/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/platform","vs/base/common/errors","vs/base/common/lifecycle","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/event","vs/base/common/assert","vs/base/common/objects","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/editor/common/diff/linesDiffComputers","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],K=function(W){for(var t=[],D=0,S=W.length;D<S;D++)t[D]=Z[W[D]];return t},Oe=this,Be=typeof global=="object"?global:{},oe;(function(W){W.global=Oe;var t=function(){function D(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(D.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),D.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=D._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof W.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")},D._isWindows=function(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1},D}();W.Environment=t})(oe||(oe={}));var oe;(function(W){var t=function(){function i(u,_,b){this.type=u,this.detail=_,this.timestamp=b}return i}();W.LoaderEvent=t;var D=function(){function i(u){this._events=[new t(1,"",u)]}return i.prototype.record=function(u,_){this._events.push(new t(u,_,W.Utilities.getHighPerformanceTimestamp()))},i.prototype.getEvents=function(){return this._events},i}();W.LoaderEventRecorder=D;var S=function(){function i(){}return i.prototype.record=function(u,_){},i.prototype.getEvents=function(){return[]},i.INSTANCE=new i,i}();W.NullLoaderEventRecorder=S})(oe||(oe={}));var oe;(function(W){var t=function(){function D(){}return D.fileUriToFilePath=function(S,i){if(i=decodeURI(i).replace(/%23/g,"#"),S){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i},D.startsWith=function(S,i){return S.length>=i.length&&S.substr(0,i.length)===i},D.endsWith=function(S,i){return S.length>=i.length&&S.substr(S.length-i.length)===i},D.containsQueryString=function(S){return/^[^\#]*\?/gi.test(S)},D.isAbsolutePath=function(S){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(S)},D.forEachProperty=function(S,i){if(S){var u=void 0;for(u in S)S.hasOwnProperty(u)&&i(u,S[u])}},D.isEmpty=function(S){var i=!0;return D.forEachProperty(S,function(){i=!1}),i},D.recursiveClone=function(S){if(!S||typeof S!="object"||S instanceof RegExp||!Array.isArray(S)&&Object.getPrototypeOf(S)!==Object.prototype)return S;var i=Array.isArray(S)?[]:{};return D.forEachProperty(S,function(u,_){_&&typeof _=="object"?i[u]=D.recursiveClone(_):i[u]=_}),i},D.generateAnonymousModule=function(){return"===anonymous"+D.NEXT_ANONYMOUS_ID+++"==="},D.isAnonymousModule=function(S){return D.startsWith(S,"===anonymous")},D.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=W.global.performance&&typeof W.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?W.global.performance.now():Date.now()},D.NEXT_ANONYMOUS_ID=1,D.PERFORMANCE_NOW_PROBED=!1,D.HAS_PERFORMANCE_NOW=!1,D}();W.Utilities=t})(oe||(oe={}));var oe;(function(W){function t(i){if(i instanceof Error)return i;var u=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(u.stack=i.stack),u}W.ensureError=t;var D=function(){function i(){}return i.validateConfigurationOptions=function(u){function _(a){if(a.phase==="loading"){console.error('Loading "'+a.moduleId+'" failed'),console.error(a),console.error("Here are the modules that depend on it:"),console.error(a.neededBy);return}if(a.phase==="factory"){console.error('The factory function of "'+a.moduleId+'" has thrown an exception'),console.error(a),console.error("Here are the modules that depend on it:"),console.error(a.neededBy);return}}if(u=u||{},typeof u.baseUrl!="string"&&(u.baseUrl=""),typeof u.isBuild!="boolean"&&(u.isBuild=!1),typeof u.paths!="object"&&(u.paths={}),typeof u.config!="object"&&(u.config={}),typeof u.catchError>"u"&&(u.catchError=!1),typeof u.recordStats>"u"&&(u.recordStats=!1),typeof u.urlArgs!="string"&&(u.urlArgs=""),typeof u.onError!="function"&&(u.onError=_),Array.isArray(u.ignoreDuplicateModules)||(u.ignoreDuplicateModules=[]),u.baseUrl.length>0&&(W.Utilities.endsWith(u.baseUrl,"/")||(u.baseUrl+="/")),typeof u.cspNonce!="string"&&(u.cspNonce=""),typeof u.preferScriptTags>"u"&&(u.preferScriptTags=!1),u.nodeCachedData&&typeof u.nodeCachedData=="object"&&(typeof u.nodeCachedData.seed!="string"&&(u.nodeCachedData.seed="seed"),(typeof u.nodeCachedData.writeDelay!="number"||u.nodeCachedData.writeDelay<0)&&(u.nodeCachedData.writeDelay=1e3*7),!u.nodeCachedData.path||typeof u.nodeCachedData.path!="string")){var b=t(new Error("INVALID cached data configuration, 'path' MUST be set"));b.phase="configuration",u.onError(b),u.nodeCachedData=void 0}return u},i.mergeConfigurationOptions=function(u,_){u===void 0&&(u=null),_===void 0&&(_=null);var b=W.Utilities.recursiveClone(_||{});return W.Utilities.forEachProperty(u,function(a,f){a==="ignoreDuplicateModules"&&typeof b.ignoreDuplicateModules<"u"?b.ignoreDuplicateModules=b.ignoreDuplicateModules.concat(f):a==="paths"&&typeof b.paths<"u"?W.Utilities.forEachProperty(f,function(A,R){return b.paths[A]=R}):a==="config"&&typeof b.config<"u"?W.Utilities.forEachProperty(f,function(A,R){return b.config[A]=R}):b[a]=W.Utilities.recursiveClone(f)}),i.validateConfigurationOptions(b)},i}();W.ConfigurationOptionsUtil=D;var S=function(){function i(u,_){if(this._env=u,this.options=D.mergeConfigurationOptions(_),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var b=this.options.nodeRequire.main.filename,a=Math.max(b.lastIndexOf("/"),b.lastIndexOf("\\"));this.options.baseUrl=b.substring(0,a+1)}}return i.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var u=0;u<this.options.ignoreDuplicateModules.length;u++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[u]]=!0},i.prototype._createSortedPathsRules=function(){var u=this;this.sortedPathsRules=[],W.Utilities.forEachProperty(this.options.paths,function(_,b){Array.isArray(b)?u.sortedPathsRules.push({from:_,to:b}):u.sortedPathsRules.push({from:_,to:[b]})}),this.sortedPathsRules.sort(function(_,b){return b.from.length-_.from.length})},i.prototype.cloneAndMerge=function(u){return new i(this._env,D.mergeConfigurationOptions(u,this.options))},i.prototype.getOptionsLiteral=function(){return this.options},i.prototype._applyPaths=function(u){for(var _,b=0,a=this.sortedPathsRules.length;b<a;b++)if(_=this.sortedPathsRules[b],W.Utilities.startsWith(u,_.from)){for(var f=[],A=0,R=_.to.length;A<R;A++)f.push(_.to[A]+u.substr(_.from.length));return f}return[u]},i.prototype._addUrlArgsToUrl=function(u){return W.Utilities.containsQueryString(u)?u+"&"+this.options.urlArgs:u+"?"+this.options.urlArgs},i.prototype._addUrlArgsIfNecessaryToUrl=function(u){return this.options.urlArgs?this._addUrlArgsToUrl(u):u},i.prototype._addUrlArgsIfNecessaryToUrls=function(u){if(this.options.urlArgs)for(var _=0,b=u.length;_<b;_++)u[_]=this._addUrlArgsToUrl(u[_]);return u},i.prototype.moduleIdToPaths=function(u){if(this._env.isNode){var _=this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(u);if(_)return this.isBuild()?["empty:"]:["node|"+u]}var b=u,a;if(!W.Utilities.endsWith(b,".js")&&!W.Utilities.isAbsolutePath(b)){a=this._applyPaths(b);for(var f=0,A=a.length;f<A;f++)this.isBuild()&&a[f]==="empty:"||(W.Utilities.isAbsolutePath(a[f])||(a[f]=this.options.baseUrl+a[f]),!W.Utilities.endsWith(a[f],".js")&&!W.Utilities.containsQueryString(a[f])&&(a[f]=a[f]+".js"))}else!W.Utilities.endsWith(b,".js")&&!W.Utilities.containsQueryString(b)&&(b=b+".js"),a=[b];return this._addUrlArgsIfNecessaryToUrls(a)},i.prototype.requireToUrl=function(u){var _=u;return W.Utilities.isAbsolutePath(_)||(_=this._applyPaths(_)[0],W.Utilities.isAbsolutePath(_)||(_=this.options.baseUrl+_)),this._addUrlArgsIfNecessaryToUrl(_)},i.prototype.isBuild=function(){return this.options.isBuild},i.prototype.shouldInvokeFactory=function(u){return!!(!this.options.isBuild||W.Utilities.isAnonymousModule(u)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[u])},i.prototype.isDuplicateMessageIgnoredFor=function(u){return this.ignoreDuplicateModulesMap.hasOwnProperty(u)},i.prototype.getConfigForModule=function(u){if(this.options.config)return this.options.config[u]},i.prototype.shouldCatchError=function(){return this.options.catchError},i.prototype.shouldRecordStats=function(){return this.options.recordStats},i.prototype.onError=function(u){this.options.onError(u)},i}();W.Configuration=S})(oe||(oe={}));var oe;(function(W){var t=function(){function a(f){this._env=f,this._scriptLoader=null,this._callbackMap={}}return a.prototype.load=function(f,A,R,N){var L=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){var e=f.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new D:this._scriptLoader=new u(this._env)}else this._env.isNode?this._scriptLoader=new u(this._env):this._scriptLoader=new D;var E={callback:R,errorback:N};if(this._callbackMap.hasOwnProperty(A)){this._callbackMap[A].push(E);return}this._callbackMap[A]=[E],this._scriptLoader.load(f,A,function(){return L.triggerCallback(A)},function(F){return L.triggerErrorback(A,F)})},a.prototype.triggerCallback=function(f){var A=this._callbackMap[f];delete this._callbackMap[f];for(var R=0;R<A.length;R++)A[R].callback()},a.prototype.triggerErrorback=function(f,A){var R=this._callbackMap[f];delete this._callbackMap[f];for(var N=0;N<R.length;N++)R[N].errorback(A)},a}(),D=function(){function a(){}return a.prototype.attachListeners=function(f,A,R){var N=function(){f.removeEventListener("load",L),f.removeEventListener("error",e)},L=function(E){N(),A()},e=function(E){N(),R(E)};f.addEventListener("load",L),f.addEventListener("error",e)},a.prototype.load=function(f,A,R,N){if(/^node\|/.test(A)){var L=f.getConfig().getOptionsLiteral(),e=_(f.getRecorder(),L.nodeRequire||W.global.nodeRequire),E=A.split("|"),F=null;try{F=e(E[1])}catch(m){N(m);return}f.enqueueDefineAnonymousModule([],function(){return F}),R()}else{var y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript"),this.attachListeners(y,R,N);var w=f.getConfig().getOptionsLiteral().trustedTypesPolicy;w&&(A=w.createScriptURL(A)),y.setAttribute("src",A);var g=f.getConfig().getOptionsLiteral().cspNonce;g&&y.setAttribute("nonce",g),document.getElementsByTagName("head")[0].appendChild(y)}},a}();function S(a){var f=a.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var A=f?self.eval(f.createScript("","true")):new Function("true");return A.call(self),!0}catch{return!1}}var i=function(){function a(){this._cachedCanUseEval=null}return a.prototype._canUseEval=function(f){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=S(f)),this._cachedCanUseEval},a.prototype.load=function(f,A,R,N){if(/^node\|/.test(A)){var L=f.getConfig().getOptionsLiteral(),e=_(f.getRecorder(),L.nodeRequire||W.global.nodeRequire),E=A.split("|"),F=null;try{F=e(E[1])}catch(g){N(g);return}f.enqueueDefineAnonymousModule([],function(){return F}),R()}else{var y=f.getConfig().getOptionsLiteral().trustedTypesPolicy,w=/^((http:)|(https:)|(file:))/.test(A)&&A.substring(0,self.origin.length)!==self.origin;if(!w&&this._canUseEval(f)){fetch(A).then(function(g){if(g.status!==200)throw new Error(g.statusText);return g.text()}).then(function(g){g=g+`
//# sourceURL=`+A;var m=y?self.eval(y.createScript("",g)):new Function(g);m.call(self),R()}).then(void 0,N);return}try{y&&(A=y.createScriptURL(A)),importScripts(A),R()}catch(g){N(g)}}},a}(),u=function(){function a(f){this._env=f,this._didInitialize=!1,this._didPatchNodeRequire=!1}return a.prototype._init=function(f){this._didInitialize||(this._didInitialize=!0,this._fs=f("fs"),this._vm=f("vm"),this._path=f("path"),this._crypto=f("crypto"))},a.prototype._initNodeRequire=function(f,A){var R=A.getConfig().getOptionsLiteral().nodeCachedData;if(!R||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var N=this,L=f("module");function e(E){var F=E.constructor,y=function(g){try{return E.require(g)}finally{}};return y.resolve=function(g,m){return F._resolveFilename(g,E,!1,m)},y.resolve.paths=function(g){return F._resolveLookupPaths(g,E)},y.main=process.mainModule,y.extensions=F._extensions,y.cache=F._cache,y}L.prototype._compile=function(E,F){var y=L.wrap(E.replace(/^#!.*/,"")),w=A.getRecorder(),g=N._getCachedDataPath(R,F),m={filename:F},l;try{var r=N._fs.readFileSync(g);l=r.slice(0,16),m.cachedData=r.slice(16),w.record(60,g)}catch{w.record(61,g)}var s=new N._vm.Script(y,m),d=s.runInThisContext(m),c=N._path.dirname(F),p=e(this),v=[this.exports,p,this,F,c,process,Be,Buffer],h=d.apply(this.exports,v);return N._handleCachedData(s,y,g,!m.cachedData,A),N._verifyCachedData(s,y,g,l,A),h}},a.prototype.load=function(f,A,R,N){var L=this,e=f.getConfig().getOptionsLiteral(),E=_(f.getRecorder(),e.nodeRequire||W.global.nodeRequire),F=e.nodeInstrumenter||function(d){return d};this._init(E),this._initNodeRequire(E,f);var y=f.getRecorder();if(/^node\|/.test(A)){var w=A.split("|"),g=null;try{g=E(w[1])}catch(d){N(d);return}f.enqueueDefineAnonymousModule([],function(){return g}),R()}else{A=W.Utilities.fileUriToFilePath(this._env.isWindows,A);var m=this._path.normalize(A),l=this._getElectronRendererScriptPathOrUri(m),r=Boolean(e.nodeCachedData),s=r?this._getCachedDataPath(e.nodeCachedData,A):void 0;this._readSourceAndCachedData(m,s,y,function(d,c,p,v){if(d){N(d);return}var h;c.charCodeAt(0)===a._BOM?h=a._PREFIX+c.substring(1)+a._SUFFIX:h=a._PREFIX+c+a._SUFFIX,h=F(h,m);var o={filename:l,cachedData:p},M=L._createAndEvalScript(f,h,o,R,N);L._handleCachedData(M,h,s,r&&!p,f),L._verifyCachedData(M,h,s,v,f)})}},a.prototype._createAndEvalScript=function(f,A,R,N,L){var e=f.getRecorder();e.record(31,R.filename);var E=new this._vm.Script(A,R),F=E.runInThisContext(R),y=f.getGlobalAMDDefineFunc(),w=!1,g=function(){return w=!0,y.apply(null,arguments)};return g.amd=y.amd,F.call(W.global,f.getGlobalAMDRequireFunc(),g,R.filename,this._path.dirname(R.filename)),e.record(32,R.filename),w?N():L(new Error("Didn't receive define call in "+R.filename+"!")),E},a.prototype._getElectronRendererScriptPathOrUri=function(f){if(!this._env.isElectronRenderer)return f;var A=f.match(/^([a-z])\:(.*)/i);return A?"file:///"+(A[1].toUpperCase()+":"+A[2]).replace(/\\/g,"/"):"file://"+f},a.prototype._getCachedDataPath=function(f,A){var R=this._crypto.createHash("md5").update(A,"utf8").update(f.seed,"utf8").update(process.arch,"").digest("hex"),N=this._path.basename(A).replace(/\.js$/,"");return this._path.join(f.path,N+"-"+R+".code")},a.prototype._handleCachedData=function(f,A,R,N,L){var e=this;f.cachedDataRejected?this._fs.unlink(R,function(E){L.getRecorder().record(62,R),e._createAndWriteCachedData(f,A,R,L),E&&L.getConfig().onError(E)}):N&&this._createAndWriteCachedData(f,A,R,L)},a.prototype._createAndWriteCachedData=function(f,A,R,N){var L=this,e=Math.ceil(N.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),E=-1,F=0,y=void 0,w=function(){setTimeout(function(){y||(y=L._crypto.createHash("md5").update(A,"utf8").digest());var g=f.createCachedData();if(!(g.length===0||g.length===E||F>=5)){if(g.length<E){w();return}E=g.length,L._fs.writeFile(R,Buffer.concat([y,g]),function(m){m&&N.getConfig().onError(m),N.getRecorder().record(63,R),w()})}},e*Math.pow(4,F++))};w()},a.prototype._readSourceAndCachedData=function(f,A,R,N){if(!A)this._fs.readFile(f,{encoding:"utf8"},N);else{var L=void 0,e=void 0,E=void 0,F=2,y=function(w){w?N(w):--F===0&&N(void 0,L,e,E)};this._fs.readFile(f,{encoding:"utf8"},function(w,g){L=g,y(w)}),this._fs.readFile(A,function(w,g){!w&&g&&g.length>0?(E=g.slice(0,16),e=g.slice(16),R.record(60,A)):R.record(61,A),y()})}},a.prototype._verifyCachedData=function(f,A,R,N,L){var e=this;!N||f.cachedDataRejected||setTimeout(function(){var E=e._crypto.createHash("md5").update(A,"utf8").digest();N.equals(E)||(L.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+R+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(R,function(F){F&&L.getConfig().onError(F)}))},Math.ceil(5e3*(1+Math.random())))},a._BOM=65279,a._PREFIX="(function (require, define, __filename, __dirname) { ",a._SUFFIX=`
});`,a}();function _(a,f){if(f.__$__isRecorded)return f;var A=function(N){a.record(33,N);try{return f(N)}finally{a.record(34,N)}};return A.__$__isRecorded=!0,A}W.ensureRecordedNodeRequire=_;function b(a){return new t(a)}W.createScriptLoader=b})(oe||(oe={}));var oe;(function(W){var t=function(){function b(a){var f=a.lastIndexOf("/");f!==-1?this.fromModulePath=a.substr(0,f+1):this.fromModulePath=""}return b._normalizeModuleId=function(a){var f=a,A;for(A=/\/\.\//;A.test(f);)f=f.replace(A,"/");for(f=f.replace(/^\.\//g,""),A=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;A.test(f);)f=f.replace(A,"/");return f=f.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),f},b.prototype.resolveModule=function(a){var f=a;return W.Utilities.isAbsolutePath(f)||(W.Utilities.startsWith(f,"./")||W.Utilities.startsWith(f,"../"))&&(f=b._normalizeModuleId(this.fromModulePath+f)),f},b.ROOT=new b(""),b}();W.ModuleIdResolver=t;var D=function(){function b(a,f,A,R,N,L){this.id=a,this.strId=f,this.dependencies=A,this._callback=R,this._errorback=N,this.moduleIdResolver=L,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return b._safeInvokeFunction=function(a,f){try{return{returnedValue:a.apply(W.global,f),producedError:null}}catch(A){return{returnedValue:null,producedError:A}}},b._invokeFactory=function(a,f,A,R){return a.shouldInvokeFactory(f)?a.shouldCatchError()?this._safeInvokeFunction(A,R):{returnedValue:A.apply(W.global,R),producedError:null}:{returnedValue:null,producedError:null}},b.prototype.complete=function(a,f,A,R){this._isComplete=!0;var N=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);var L=b._invokeFactory(f,this.strId,this._callback,A);N=L.producedError,a.record(22,this.strId),!N&&typeof L.returnedValue<"u"&&(!this.exportsPassedIn||W.Utilities.isEmpty(this.exports))&&(this.exports=L.returnedValue)}else this.exports=this._callback;if(N){var e=W.ensureError(N);e.phase="factory",e.moduleId=this.strId,e.neededBy=R(this.id),this.error=e,f.onError(e)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},b.prototype.onDependencyError=function(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1},b.prototype.isComplete=function(){return this._isComplete},b}();W.Module=D;var S=function(){function b(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return b.prototype.getMaxModuleId=function(){return this._nextId},b.prototype.getModuleId=function(a){var f=this._strModuleIdToIntModuleId.get(a);return typeof f>"u"&&(f=this._nextId++,this._strModuleIdToIntModuleId.set(a,f),this._intModuleIdToStrModuleId[f]=a),f},b.prototype.getStrModuleId=function(a){return this._intModuleIdToStrModuleId[a]},b}(),i=function(){function b(a){this.id=a}return b.EXPORTS=new b(0),b.MODULE=new b(1),b.REQUIRE=new b(2),b}();W.RegularDependency=i;var u=function(){function b(a,f,A){this.id=a,this.pluginId=f,this.pluginParam=A}return b}();W.PluginDependency=u;var _=function(){function b(a,f,A,R,N){N===void 0&&(N=0),this._env=a,this._scriptLoader=f,this._loaderAvailableTimestamp=N,this._defineFunc=A,this._requireFunc=R,this._moduleIdProvider=new S,this._config=new W.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return b.prototype.reset=function(){return new b(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},b.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},b.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},b._findRelevantLocationInStack=function(a,f){for(var A=function(m){return m.replace(/\\/g,"/")},R=A(a),N=f.split(/\n/),L=0;L<N.length;L++){var e=N[L].match(/(.*):(\d+):(\d+)\)?$/);if(e){var E=e[1],F=e[2],y=e[3],w=Math.max(E.lastIndexOf(" ")+1,E.lastIndexOf("(")+1);if(E=E.substr(w),E=A(E),E===R){var g={line:parseInt(F,10),col:parseInt(y,10)};return g.line===1&&(g.col-=53),g}}}throw new Error("Could not correlate define call site for needle "+a)},b.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var a=[],f=0,A=0,R=this._modules2.length;A<R;A++){var N=this._modules2[A];if(!!N){var L=this._buildInfoPath[N.id]||null,e=this._buildInfoDefineStack[N.id]||null,E=this._buildInfoDependencies[N.id];a[f++]={id:N.strId,path:L,defineLocation:L&&e?b._findRelevantLocationInStack(L,e):null,dependencies:E,shim:null,exports:N.exports}}}return a},b.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new W.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=W.NullLoaderEventRecorder.INSTANCE),this._recorder},b.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},b.prototype.enqueueDefineAnonymousModule=function(a,f){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var A=null;this._config.isBuild()&&(A=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:A,dependencies:a,callback:f}},b.prototype.defineModule=function(a,f,A,R,N,L){var e=this;L===void 0&&(L=new t(a));var E=this._moduleIdProvider.getModuleId(a);if(this._modules2[E]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}var F=new D(E,a,this._normalizeDependencies(f,L),A,R,L);this._modules2[E]=F,this._config.isBuild()&&(this._buildInfoDefineStack[E]=N,this._buildInfoDependencies[E]=(F.dependencies||[]).map(function(y){return e._moduleIdProvider.getStrModuleId(y.id)})),this._resolve(F)},b.prototype._normalizeDependency=function(a,f){if(a==="exports")return i.EXPORTS;if(a==="module")return i.MODULE;if(a==="require")return i.REQUIRE;var A=a.indexOf("!");if(A>=0){var R=f.resolveModule(a.substr(0,A)),N=f.resolveModule(a.substr(A+1)),L=this._moduleIdProvider.getModuleId(R+"!"+N),e=this._moduleIdProvider.getModuleId(R);return new u(L,e,N)}return new i(this._moduleIdProvider.getModuleId(f.resolveModule(a)))},b.prototype._normalizeDependencies=function(a,f){for(var A=[],R=0,N=0,L=a.length;N<L;N++)A[R++]=this._normalizeDependency(a[N],f);return A},b.prototype._relativeRequire=function(a,f,A,R){if(typeof f=="string")return this.synchronousRequire(f,a);this.defineModule(W.Utilities.generateAnonymousModule(),f,A,R,null,a)},b.prototype.synchronousRequire=function(a,f){f===void 0&&(f=new t(a));var A=this._normalizeDependency(a,f),R=this._modules2[A.id];if(!R)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!R.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(R.error)throw R.error;return R.exports},b.prototype.configure=function(a,f){var A=this._config.shouldRecordStats();f?this._config=new W.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!A&&(this._recorder=null)},b.prototype.getConfig=function(){return this._config},b.prototype._onLoad=function(a){if(this._currentAnonymousDefineCall!==null){var f=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),f.dependencies,f.callback,null,f.stack)}},b.prototype._createLoadError=function(a,f){var A=this,R=this._moduleIdProvider.getStrModuleId(a),N=(this._inverseDependencies2[a]||[]).map(function(e){return A._moduleIdProvider.getStrModuleId(e)}),L=W.ensureError(f);return L.phase="loading",L.moduleId=R,L.neededBy=N,L},b.prototype._onLoadError=function(a,f){var A=this._createLoadError(a,f);this._modules2[a]||(this._modules2[a]=new D(a,this._moduleIdProvider.getStrModuleId(a),[],function(){},null,null));for(var R=[],N=0,L=this._moduleIdProvider.getMaxModuleId();N<L;N++)R[N]=!1;var e=!1,E=[];for(E.push(a),R[a]=!0;E.length>0;){var F=E.shift(),y=this._modules2[F];y&&(e=y.onDependencyError(A)||e);var w=this._inverseDependencies2[F];if(w)for(var N=0,L=w.length;N<L;N++){var g=w[N];R[g]||(E.push(g),R[g]=!0)}}e||this._config.onError(A)},b.prototype._hasDependencyPath=function(a,f){var A=this._modules2[a];if(!A)return!1;for(var R=[],N=0,L=this._moduleIdProvider.getMaxModuleId();N<L;N++)R[N]=!1;var e=[];for(e.push(A),R[a]=!0;e.length>0;){var E=e.shift(),F=E.dependencies;if(F)for(var N=0,L=F.length;N<L;N++){var y=F[N];if(y.id===f)return!0;var w=this._modules2[y.id];w&&!R[y.id]&&(R[y.id]=!0,e.push(w))}}return!1},b.prototype._findCyclePath=function(a,f,A){if(a===f||A===50)return[a];var R=this._modules2[a];if(!R)return null;var N=R.dependencies;if(N)for(var L=0,e=N.length;L<e;L++){var E=this._findCyclePath(N[L].id,f,A+1);if(E!==null)return E.push(a),E}return null},b.prototype._createRequire=function(a){var f=this,A=function(R,N,L){return f._relativeRequire(a,R,N,L)};return A.toUrl=function(R){return f._config.requireToUrl(a.resolveModule(R))},A.getStats=function(){return f.getLoaderEvents()},A.hasDependencyCycle=function(){return f._hasDependencyCycle},A.config=function(R,N){N===void 0&&(N=!1),f.configure(R,N)},A.__$__nodeRequire=W.global.nodeRequire,A},b.prototype._loadModule=function(a){var f=this;if(!(this._modules2[a]||this._knownModules2[a])){this._knownModules2[a]=!0;var A=this._moduleIdProvider.getStrModuleId(a),R=this._config.moduleIdToPaths(A),N=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(A.indexOf("/")===-1||N.test(A))&&R.push("node|"+A);var L=-1,e=function(E){if(L++,L>=R.length)f._onLoadError(a,E);else{var F=R[L],y=f.getRecorder();if(f._config.isBuild()&&F==="empty:"){f._buildInfoPath[a]=F,f.defineModule(f._moduleIdProvider.getStrModuleId(a),[],null,null,null),f._onLoad(a);return}y.record(10,F),f._scriptLoader.load(f,F,function(){f._config.isBuild()&&(f._buildInfoPath[a]=F),y.record(11,F),f._onLoad(a)},function(w){y.record(12,F),e(w)})}};e(null)}},b.prototype._loadPluginDependency=function(a,f){var A=this;if(!(this._modules2[f.id]||this._knownModules2[f.id])){this._knownModules2[f.id]=!0;var R=function(N){A.defineModule(A._moduleIdProvider.getStrModuleId(f.id),[],N,null,null)};R.error=function(N){A._config.onError(A._createLoadError(f.id,N))},a.load(f.pluginParam,this._createRequire(t.ROOT),R,this._config.getOptionsLiteral())}},b.prototype._resolve=function(a){var f=this,A=a.dependencies;if(A)for(var R=0,N=A.length;R<N;R++){var L=A[R];if(L===i.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(L===i.MODULE){a.unresolvedDependenciesCount--;continue}if(L===i.REQUIRE){a.unresolvedDependenciesCount--;continue}var e=this._modules2[L.id];if(e&&e.isComplete()){if(e.error){a.onDependencyError(e.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(L.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(L.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");var E=this._findCyclePath(L.id,a.id,0)||[];E.reverse(),E.push(L.id),console.warn(E.map(function(w){return f._moduleIdProvider.getStrModuleId(w)}).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[L.id]=this._inverseDependencies2[L.id]||[],this._inverseDependencies2[L.id].push(a.id),L instanceof u){var F=this._modules2[L.pluginId];if(F&&F.isComplete()){this._loadPluginDependency(F.exports,L);continue}var y=this._inversePluginDependencies2.get(L.pluginId);y||(y=[],this._inversePluginDependencies2.set(L.pluginId,y)),y.push(L),this._loadModule(L.pluginId);continue}this._loadModule(L.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)},b.prototype._onModuleComplete=function(a){var f=this,A=this.getRecorder();if(!a.isComplete()){var R=a.dependencies,N=[];if(R)for(var L=0,e=R.length;L<e;L++){var E=R[L];if(E===i.EXPORTS){N[L]=a.exports;continue}if(E===i.MODULE){N[L]={id:a.strId,config:function(){return f._config.getConfigForModule(a.strId)}};continue}if(E===i.REQUIRE){N[L]=this._createRequire(a.moduleIdResolver);continue}var F=this._modules2[E.id];if(F){N[L]=F.exports;continue}N[L]=null}var y=function(r){return(f._inverseDependencies2[r]||[]).map(function(s){return f._moduleIdProvider.getStrModuleId(s)})};a.complete(A,this._config,N,y);var w=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,w)for(var L=0,e=w.length;L<e;L++){var g=w[L],m=this._modules2[g];m.unresolvedDependenciesCount--,m.unresolvedDependenciesCount===0&&this._onModuleComplete(m)}var l=this._inversePluginDependencies2.get(a.id);if(l){this._inversePluginDependencies2.delete(a.id);for(var L=0,e=l.length;L<e;L++)this._loadPluginDependency(a.exports,l[L])}}},b}();W.ModuleManager=_})(oe||(oe={}));var Q,oe;(function(W){var t=new W.Environment,D=null,S=function(b,a,f){typeof b!="string"&&(f=a,a=b,b=null),(typeof a!="object"||!Array.isArray(a))&&(f=a,a=null),a||(a=["require","exports","module"]),b?D.defineModule(b,a,f,null,null):D.enqueueDefineAnonymousModule(a,f)};S.amd={jQuery:!0};var i=function(b,a){a===void 0&&(a=!1),D.configure(b,a)},u=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return D.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){D.defineModule(W.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};u.config=i,u.getConfig=function(){return D.getConfig().getOptionsLiteral()},u.reset=function(){D=D.reset()},u.getBuildInfo=function(){return D.getBuildInfo()},u.getStats=function(){return D.getLoaderEvents()},u.define=S;function _(){if(typeof W.global.require<"u"||typeof require<"u"){var b=W.global.require||require;if(typeof b=="function"&&typeof b.resolve=="function"){var a=W.ensureRecordedNodeRequire(D.getRecorder(),b);W.global.nodeRequire=a,u.nodeRequire=a,u.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=u:(t.isElectronRenderer||(W.global.define=S),W.global.require=u)}W.init=_,(typeof W.global.define!="function"||!W.global.define.amd)&&(D=new W.ModuleManager(t,W.createScriptLoader(t),S,u,W.Utilities.getHighPerformanceTimestamp()),typeof W.global.require<"u"&&typeof W.global.require!="function"&&u.config(W.global.require),Q=function(){return S.apply(null,arguments)},Q.amd=S.amd,typeof doNotInitLoader>"u"&&_())})(oe||(oe={})),Q(Z[54],K([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function D(b,a,f,A){if(A=A||{},(A["vs/css"]||{}).disabled){f({});return}const N=a.toUrl(b+".css");S(b,N,()=>{f({})},L=>{typeof f.error=="function"&&f.error("Could not find "+N+".")})}t.load=D;function S(b,a,f,A){if(i(b,a)){f();return}u(b,a,f,A)}function i(b,a){const f=document.getElementsByTagName("link");for(let A=0,R=f.length;A<R;A++){const N=f[A].getAttribute("data-name"),L=f[A].getAttribute("href");if(N===b||L===a)return!0}return!1}function u(b,a,f,A){const R=document.createElement("link");R.setAttribute("rel","stylesheet"),R.setAttribute("type","text/css"),R.setAttribute("data-name",b),_(b,R,f,A),R.setAttribute("href",a),(document.head||document.getElementsByTagName("head")[0]).appendChild(R)}function _(b,a,f,A){const R=()=>{a.removeEventListener("load",N),a.removeEventListener("error",L)},N=e=>{R(),f()},L=e=>{R(),A(e)};a.addEventListener("load",N),a.addEventListener("error",L)}}),Q("vs/nls",["require","exports"],function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let D=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const S="i-default";function i(e,E){let F;return E.length===0?F=e:F=e.replace(/\{(\d+)\}/g,(y,w)=>{const g=w[0],m=E[g];let l=y;return typeof m=="string"?l=m:(typeof m=="number"||typeof m=="boolean"||m===void 0||m===null)&&(l=String(m)),l}),D&&(F="\uFF3B"+F.replace(/[aouei]/g,"$&$&")+"\uFF3D"),F}function u(e,E){let F=e[E];return F||(F=e["*"],F)?F:null}function _(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function b(e,E,F){const y=_(e)+_(E)+"vscode/"+_(F),w=await fetch(y);if(w.ok)return await w.json();throw new Error(`${w.status} - ${w.statusText}`)}function a(e){return function(E,F){const y=Array.prototype.slice.call(arguments,2);return i(e[E],y)}}function f(e,E,...F){return i(E,F)}t.localize=f;function A(e){}t.getConfiguredDefaultLocale=A;function R(e){D=e}t.setPseudoTranslation=R;function N(e,E){return{localize:a(E[e]),getConfiguredDefaultLocale:E.getConfiguredDefaultLocale??(F=>{})}}t.create=N;function L(e,E,F,y){const w=y["vs/nls"]??{};if(!e||e.length===0)return F({localize:f,getConfiguredDefaultLocale:()=>w.availableLanguages?.["*"]});const g=w.availableLanguages?u(w.availableLanguages,e):null,m=g===null||g===S;let l=".nls";m||(l=l+"."+g);const r=s=>{Array.isArray(s)?s.localize=a(s):s.localize=a(s[e]),s.getConfiguredDefaultLocale=()=>w.availableLanguages?.["*"],F(s)};typeof w.loadBundle=="function"?w.loadBundle(e,g,(s,d)=>{s?E([e+".nls"],r):r(d)}):w.translationServiceUrl&&!m?(async()=>{try{const s=await b(w.translationServiceUrl,g,e);return r(s)}catch(s){if(!g.includes("-"))return console.error(s),E([e+".nls"],r);try{const d=g.split("-")[0],c=await b(w.translationServiceUrl,d,e);return w.availableLanguages??={},w.availableLanguages["*"]=d,r(c)}catch(d){return console.error(d),E([e+".nls"],r)}}})():E([e+l],r,s=>{if(l===".nls"){console.error("Failed trying to load default language strings",s);return}console.error(`Failed to load message bundle for language ${g}. Falling back to the default language:`,s),E([e+".nls"],r)})}t.load=L}),function(){const W=self.MonacoEnvironment,t=W&&W.baseUrl?W.baseUrl:"../../../",D=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:f=>f,createScript:(f,...A)=>{const R=A.slice(0,-1).join(","),N=A.pop().toString();return`(function anonymous(${R}) { ${N}
})`}}):void 0;function S(){try{return(D?self.eval(D.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function i(){return new Promise((f,A)=>{if(typeof self.define=="function"&&self.define.amd)return f();const R=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(R)&&R.substring(0,self.origin.length)!==self.origin)&&S()){fetch(R).then(L=>{if(L.status!==200)throw new Error(L.statusText);return L.text()}).then(L=>{L=`${L}
//# sourceURL=${R}`,(D?self.eval(D.createScript("",L)):new Function(L)).call(self),f()}).then(void 0,A);return}D?importScripts(D.createScriptURL(R)):importScripts(R),f()})}function u(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//})}function _(f){i().then(()=>{u(),require([f],function(A){setTimeout(function(){const R=A.create((N,L)=>{self.postMessage(N,L)},null);for(self.onmessage=N=>R.onmessage(N.data,N.ports);a.length>0;)self.onmessage(a.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&u();let b=!0;const a=[];self.onmessage=f=>{if(!b){a.push(f);return}b=!1,_(f.data)}}(),Q(Z[25],K([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class D{constructor(i,u,_,b){this.originalStart=i,this.originalLength=u,this.modifiedStart=_,this.modifiedLength=b}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=D}),Q(Z[6],K([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class D{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?m.isErrorNoTelemetry(s)?new m(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(d=>{d(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}t.ErrorHandler=D,t.errorHandler=new D;function S(r){t.errorHandler.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=S;function i(r){if(!r||typeof r!="object")return!1;const s=r;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function u(r){f(r)||t.errorHandler.onUnexpectedError(r)}t.onUnexpectedError=u;function _(r){f(r)||t.errorHandler.onUnexpectedExternalError(r)}t.onUnexpectedExternalError=_;function b(r){if(r instanceof Error){const{name:s,message:d}=r,c=r.stacktrace||r.stack;return{$isError:!0,name:s,message:d,stack:c,noTelemetry:m.isErrorNoTelemetry(r)}}return r}t.transformErrorForSerialization=b;const a="Canceled";function f(r){return r instanceof A?!0:r instanceof Error&&r.name===a&&r.message===a}t.isCancellationError=f;class A extends Error{constructor(){super(a),this.name=this.message}}t.CancellationError=A;function R(){const r=new Error(a);return r.name=r.message,r}t.canceled=R;function N(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.illegalArgument=N;function L(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.illegalState=L;function e(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function E(r){const s=new Error(`${r} has been disposed`);return s.name="DISPOSED",s}t.disposed=E;function F(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.getErrorMessage=F;class y extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}t.NotImplementedError=y;class w extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}t.NotSupportedError=w;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=g;class m extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof m)return s;const d=new m;return d.message=s.message,d.stack=s.stack,d}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}t.ErrorNoTelemetry=m;class l extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype);debugger}}t.BugIndicatingError=l}),Q(Z[26],K([0,1,6]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function S(k,I=0){return k[k.length-(1+I)]}t.tail=S;function i(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}t.tail2=i;function u(k,I,U=(q,j)=>q===j){if(k===I)return!0;if(!k||!I||k.length!==I.length)return!1;for(let q=0,j=k.length;q<j;q++)if(!U(k[q],I[q]))return!1;return!0}t.equals=u;function _(k,I){const U=k.length-1;I<U&&(k[I]=k[U]),k.pop()}t.removeFastWithoutKeepingOrder=_;function b(k,I,U){return a(k.length,q=>U(k[q],I))}t.binarySearch=b;function a(k,I){let U=0,q=k-1;for(;U<=q;){const j=(U+q)/2|0,ie=I(j);if(ie<0)U=j+1;else if(ie>0)q=j-1;else return j}return-(U+1)}t.binarySearch2=a;function f(k,I){let U=0,q=k.length;if(q===0)return 0;for(;U<q;){const j=Math.floor((U+q)/2);I(k[j])?q=j:U=j+1}return U}t.findFirstInSorted=f;function A(k,I,U){if(k=k|0,k>=I.length)throw new TypeError("invalid index");const q=I[Math.floor(I.length*Math.random())],j=[],ie=[],re=[];for(const ae of I){const le=U(ae,q);le<0?j.push(ae):le>0?ie.push(ae):re.push(ae)}return k<j.length?A(k,j,U):k<j.length+re.length?re[0]:A(k-(j.length+re.length),ie,U)}t.quickSelect=A;function R(k,I){const U=[];let q;for(const j of k.slice(0).sort(I))!q||I(q[0],j)!==0?(q=[j],U.push(q)):q.push(j);return U}t.groupBy=R;function N(k,I,U){const q=[];function j(ae,le,fe){if(le===0&&fe.length===0)return;const he=q[q.length-1];he&&he.start+he.deleteCount===ae?(he.deleteCount+=le,he.toInsert.push(...fe)):q.push({start:ae,deleteCount:le,toInsert:fe})}let ie=0,re=0;for(;;){if(ie===k.length){j(ie,0,I.slice(re));break}if(re===I.length){j(ie,k.length-ie,[]);break}const ae=k[ie],le=I[re],fe=U(ae,le);fe===0?(ie+=1,re+=1):fe<0?(j(ie,1,[]),ie+=1):fe>0&&(j(ie,0,[le]),re+=1)}return q}t.sortedDiff=N;function L(k,I,U){const q=N(k,I,U),j=[],ie=[];for(const re of q)j.push(...k.slice(re.start,re.start+re.deleteCount)),ie.push(...re.toInsert);return{removed:j,added:ie}}t.delta=L;function e(k,I,U){if(U===0)return[];const q=k.slice(0,U).sort(I);return F(k,I,q,U,k.length),q}t.top=e;function E(k,I,U,q,j){return U===0?Promise.resolve([]):new Promise((ie,re)=>{(async()=>{const ae=k.length,le=k.slice(0,U).sort(I);for(let fe=U,he=Math.min(U+q,ae);fe<ae;fe=he,he=Math.min(he+q,ae)){if(fe>U&&await new Promise(ke=>setTimeout(ke)),j&&j.isCancellationRequested)throw new D.CancellationError;F(k,I,le,fe,he)}return le})().then(ie,re)})}t.topAsync=E;function F(k,I,U,q,j){for(const ie=U.length;q<j;q++){const re=k[q];if(I(re,U[ie-1])<0){U.pop();const ae=f(U,le=>I(re,le)<0);U.splice(ae,0,re)}}}function y(k){return k.filter(I=>!!I)}t.coalesce=y;function w(k){let I=0;for(let U=0;U<k.length;U++)k[U]&&(k[I]=k[U],I+=1);k.length=I}t.coalesceInPlace=w;function g(k,I,U){k.splice(U,0,k.splice(I,1)[0])}t.move=g;function m(k){return!Array.isArray(k)||k.length===0}t.isFalsyOrEmpty=m;function l(k){return Array.isArray(k)&&k.length>0}t.isNonEmptyArray=l;function r(k,I=U=>U){const U=new Set;return k.filter(q=>{const j=I(q);return U.has(j)?!1:(U.add(j),!0)})}t.distinct=r;function s(k){const I=new Set;return U=>{const q=k(U);return I.has(q)?!1:(I.add(q),!0)}}t.uniqueFilter=s;function d(k,I){const U=c(k,I);if(U!==-1)return k[U]}t.findLast=d;function c(k,I){for(let U=k.length-1;U>=0;U--){const q=k[U];if(I(q))return U}return-1}t.lastIndex=c;function p(k,I){return k.length>0?k[0]:I}t.firstOrDefault=p;function v(k,I){return k.length>0?k[k.length-1]:I}t.lastOrDefault=v;function h(k,I,U=(q,j)=>q===j){let q=0;for(let j=0,ie=Math.min(k.length,I.length);j<ie&&U(k[j],I[j]);j++)q++;return q}t.commonPrefixLength=h;function o(k){return[].concat(...k)}t.flatten=o;function M(k,I){let U=typeof I=="number"?k:0;typeof I=="number"?U=k:(U=0,I=k);const q=[];if(U<=I)for(let j=U;j<I;j++)q.push(j);else for(let j=U;j>I;j--)q.push(j);return q}t.range=M;function T(k,I,U){return k.reduce((q,j)=>(q[I(j)]=U?U(j):j,q),Object.create(null))}t.index=T;function O(k,I){return k.push(I),()=>C(k,I)}t.insert=O;function C(k,I){const U=k.indexOf(I);if(U>-1)return k.splice(U,1),I}t.remove=C;function H(k,I,U){const q=k.slice(0,I),j=k.slice(I);return q.concat(U,j)}t.arrayInsert=H;function z(k,I){let U;if(typeof I=="number"){let q=I;U=()=>{const j=Math.sin(q++)*179426549;return j-Math.floor(j)}}else U=Math.random;for(let q=k.length-1;q>0;q-=1){const j=Math.floor(U()*(q+1)),ie=k[q];k[q]=k[j],k[j]=ie}}t.shuffle=z;function ee(k,I){const U=k.indexOf(I);U>-1&&(k.splice(U,1),k.unshift(I))}t.pushToStart=ee;function ne(k,I){const U=k.indexOf(I);U>-1&&(k.splice(U,1),k.push(I))}t.pushToEnd=ne;function Y(k,I){for(const U of I)k.push(U)}t.pushMany=Y;function J(k,I){return Array.isArray(k)?k.map(I):I(k)}t.mapArrayOrNot=J;function n(k){return Array.isArray(k)?k:[k]}t.asArray=n;function Le(k){return k[Math.floor(Math.random()*k.length)]}t.getRandomElement=Le;function Ae(k,I){for(const U of k){const q=I(U);if(q!==void 0)return q}}t.mapFind=Ae;function de(k,I,U){const q=we(k,I),j=k.length,ie=U.length;k.length=j+ie;for(let re=j-1;re>=q;re--)k[re+ie]=k[re];for(let re=0;re<ie;re++)k[re+q]=U[re]}t.insertInto=de;function Ee(k,I,U,q){const j=we(k,I),ie=k.splice(j,U);return de(k,j,q),ie}t.splice=Ee;function we(k,I){return I<0?Math.max(I+k.length,0):Math.min(I,k.length)}var Ne;(function(k){function I(j){return j<0}k.isLessThan=I;function U(j){return j>0}k.isGreaterThan=U;function q(j){return j===0}k.isNeitherLessOrGreaterThan=q,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(Ne=t.CompareResult||(t.CompareResult={}));function Re(k,I){return(U,q)=>I(k(U),k(q))}t.compareBy=Re;function De(...k){return(I,U)=>{for(const q of k){const j=q(I,U);if(!Ne.isNeitherLessOrGreaterThan(j))return j}return Ne.neitherLessOrGreaterThan}}t.tieBreakComparators=De;const Fe=(k,I)=>k-I;t.numberComparator=Fe;function ye(k,I){if(k.length===0)return;let U=k[0];for(let q=1;q<k.length;q++){const j=k[q];I(j,U)>0&&(U=j)}return U}t.findMaxBy=ye;function Pe(k,I){if(k.length===0)return;let U=k[0];for(let q=1;q<k.length;q++){const j=k[q];I(j,U)>=0&&(U=j)}return U}t.findLastMaxBy=Pe;function te(k,I){return ye(k,(U,q)=>-I(U,q))}t.findMinBy=te;class G{constructor(I){this.f=I,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(I){let U=this.c;for(;U<this.f.length&&I(this.f[U]);)U++;const q=U===this.c?null:this.f.slice(this.c,U);return this.c=U,q}takeFromEndWhile(I){let U=this.d;for(;U>=0&&I(this.f[U]);)U--;const q=U===this.d?null:this.f.slice(U+1,this.d+1);return this.d=U,q}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const I=this.f[this.c];return this.c++,I}removeLast(){const I=this.f[this.d];return this.d--,I}takeCount(I){const U=this.f.slice(this.c,this.c+I);return this.c+=I,U}}t.ArrayQueue=G;class X{constructor(I){this.iterate=I}forEach(I){this.iterate(U=>(I(U),!0))}toArray(){const I=[];return this.iterate(U=>(I.push(U),!0)),I}filter(I){return new X(U=>this.iterate(q=>I(q)?U(q):!0))}map(I){return new X(U=>this.iterate(q=>U(I(q))))}some(I){let U=!1;return this.iterate(q=>(U=I(q),!U)),U}findFirst(I){let U;return this.iterate(q=>I(q)?(U=q,!1):!0),U}findLast(I){let U;return this.iterate(q=>(I(q)&&(U=q),!0)),U}findLastMaxBy(I){let U,q=!0;return this.iterate(j=>((q||Ne.isGreaterThan(I(j,U)))&&(q=!1,U=j),!0)),U}}X.empty=new X(k=>{}),t.CallbackIterable=X}),Q(Z[10],K([0,1,6]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function S(a,f){if(!a)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}t.ok=S;function i(a,f="Unreachable"){throw new Error(f)}t.assertNever=i;function u(a){if(!a)throw new D.BugIndicatingError("Assertion Failed")}t.assert=u;function _(a){if(!a()){debugger;a(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}t.assertFn=_;function b(a,f){let A=0;for(;A<a.length-1;){const R=a[A],N=a[A+1];if(!f(R,N))return!1;A++}return!0}t.checkAdjacentItems=b}),Q(Z[13],K([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function D(S){const i=this;let u=!1,_;return function(){return u||(u=!0,_=S.apply(i,arguments)),_}}t.once=D}),Q(Z[14],K([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var D;(function(S){function i(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}S.is=i;const u=Object.freeze([]);function _(){return u}S.empty=_;function*b(m){yield m}S.single=b;function a(m){return i(m)?m:b(m)}S.wrap=a;function f(m){return m||u}S.from=f;function A(m){return!m||m[Symbol.iterator]().next().done===!0}S.isEmpty=A;function R(m){return m[Symbol.iterator]().next().value}S.first=R;function N(m,l){for(const r of m)if(l(r))return!0;return!1}S.some=N;function L(m,l){for(const r of m)if(l(r))return r}S.find=L;function*e(m,l){for(const r of m)l(r)&&(yield r)}S.filter=e;function*E(m,l){let r=0;for(const s of m)yield l(s,r++)}S.map=E;function*F(...m){for(const l of m)for(const r of l)yield r}S.concat=F;function y(m,l,r){let s=r;for(const d of m)s=l(s,d);return s}S.reduce=y;function*w(m,l,r=m.length){for(l<0&&(l+=m.length),r<0?r+=m.length:r>m.length&&(r=m.length);l<r;l++)yield m[l]}S.slice=w;function g(m,l=Number.POSITIVE_INFINITY){const r=[];if(l===0)return[r,m];const s=m[Symbol.iterator]();for(let d=0;d<l;d++){const c=s.next();if(c.done)return[r,S.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return s}}]}S.consume=g})(D=t.Iterable||(t.Iterable={}))}),Q(Z[27],K([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(D=t.KeyCode||(t.KeyCode={}));var S;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(S=t.ScanCode||(t.ScanCode={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(E,F){this._keyCodeToStr[E]=F,this._strToKeyCode[F.toLowerCase()]=E}keyCodeToStr(E){return this._keyCodeToStr[E]}strToKeyCode(E){return this._strToKeyCode[E.toLowerCase()]||0}}const u=new i,_=new i,b=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const a=[],f=Object.create(null),A=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>A[e]||0,toEnum:e=>f[e]||0,toString:e=>a[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",E=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],F=[],y=[];for(const w of E){const[g,m,l,r,s,d,c,p,v,h]=w;if(y[l]||(y[l]=!0,a[l]=r,f[r]=l,A[r.toLowerCase()]=l,m&&(t.IMMUTABLE_CODE_TO_KEY_CODE[l]=s,s!==0&&s!==3&&s!==5&&s!==4&&s!==6&&s!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[s]=l))),!F[s]){if(F[s]=!0,!d)throw new Error(`String representation missing for key code ${s} around scan code ${r}`);u.define(s,d),_.define(s,v||d),b.define(s,h||v||d)}c&&(t.EVENT_KEY_CODE_MAP[c]=s),p&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[p]=s)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var R;(function(e){function E(l){return u.keyCodeToStr(l)}e.toString=E;function F(l){return u.strToKeyCode(l)}e.fromString=F;function y(l){return _.keyCodeToStr(l)}e.toUserSettingsUS=y;function w(l){return b.keyCodeToStr(l)}e.toUserSettingsGeneral=w;function g(l){return _.strToKeyCode(l)||b.strToKeyCode(l)}e.fromUserSettings=g;function m(l){if(l>=93&&l<=108)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return u.keyCodeToStr(l)}e.toElectronAccelerator=m})(R=t.KeyCodeUtils||(t.KeyCodeUtils={}));var N;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(N=t.KeyMod||(t.KeyMod={}));function L(e,E){const F=(E&65535)<<16>>>0;return(e|F)>>>0}t.KeyChord=L}),Q(Z[28],K([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class D{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.Lazy=D}),Q(Z[7],K([0,1,13,14]),function(W,t,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let u=null;function _(v){u=v}if(t.setDisposableTracker=_,i){const v="__is_disposable_tracked__";_(new class{trackDisposable(h){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{h[v]||console.log(o)},3e3)}setParent(h,o){if(h&&h!==w.None)try{h[v]=!0}catch{}}markAsDisposed(h){if(h&&h!==w.None)try{h[v]=!0}catch{}}markAsSingleton(h){}})}function b(v){return u?.trackDisposable(v),v}function a(v){u?.markAsDisposed(v)}function f(v,h){u?.setParent(v,h)}function A(v,h){if(!!u)for(const o of v)u.setParent(o,h)}function R(v){return u?.markAsSingleton(v),v}t.markAsSingleton=R;function N(v){return typeof v.dispose=="function"&&v.dispose.length===0}t.isDisposable=N;function L(v){if(S.Iterable.is(v)){const h=[];for(const o of v)if(o)try{o.dispose()}catch(M){h.push(M)}if(h.length===1)throw h[0];if(h.length>1)throw new AggregateError(h,"Encountered errors while disposing of store");return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}t.dispose=L;function e(v){for(const h of v)N(h)&&h.dispose();return[]}t.disposeIfDisposable=e;function E(...v){const h=F(()=>L(v));return A(v,h),h}t.combinedDisposable=E;function F(v){const h=b({dispose:(0,D.once)(()=>{a(h),v()})});return h}t.toDisposable=F;class y{constructor(){this.c=new Set,this.f=!1,b(this)}dispose(){this.f||(a(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{L(this.c)}finally{this.c.clear()}}add(h){if(!h)return h;if(h===this)throw new Error("Cannot register a disposable on itself!");return f(h,this),this.f?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(h),h}}y.DISABLE_DISPOSED_WARNING=!1,t.DisposableStore=y;class w{constructor(){this.q=new y,b(this),f(this.q,this)}dispose(){a(this),this.q.dispose()}B(h){if(h===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(h)}}w.None=Object.freeze({dispose(){}}),t.Disposable=w;class g{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(h){this.b||h===this.a||(this.a?.dispose(),h&&f(h,this),this.a=h)}clear(){this.value=void 0}dispose(){this.b=!0,a(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const h=this.a;return this.a=void 0,h&&f(h,null),h}}t.MutableDisposable=g;class m{constructor(h){this.b=h,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=m;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(h){let o=h;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,a(this))},this}}t.SafeDisposable=l;class r{constructor(){this.a=new Map}acquire(h,...o){let M=this.a.get(h);M||(M={counter:0,object:this.b(h,...o)},this.a.set(h,M));const{object:T}=M,O=(0,D.once)(()=>{--M.counter===0&&(this.c(h,M.object),this.a.delete(h))});return M.counter++,{object:T,dispose:O}}}t.ReferenceCollection=r;class s{constructor(h){this.a=h}async acquire(h,...o){const M=this.a.acquire(h,...o);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}t.AsyncReferenceCollection=s;class d{constructor(h){this.object=h}dispose(){}}t.ImmortalReference=d;function c(v){const h=new y;try{v(h)}finally{h.dispose()}}t.disposeOnReturn=c;class p{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){a(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{L(this.a.values())}finally{this.a.clear()}}has(h){return this.a.has(h)}get(h){return this.a.get(h)}set(h,o,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(h)?.dispose(),this.a.set(h,o)}deleteAndDispose(h){this.a.get(h)?.dispose(),this.a.delete(h)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=p}),Q(Z[15],K([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class D{constructor(u){this.element=u,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class S{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let u=this.a;for(;u!==D.Undefined;){const _=u.next;u.prev=D.Undefined,u.next=D.Undefined,u=_}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(u){return this.d(u,!1)}push(u){return this.d(u,!0)}d(u,_){const b=new D(u);if(this.a===D.Undefined)this.a=b,this.b=b;else if(_){const f=this.b;this.b=b,b.prev=f,f.next=b}else{const f=this.a;this.a=b,b.next=f,f.prev=b}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(b))}}shift(){if(this.a!==D.Undefined){const u=this.a.element;return this.e(this.a),u}}pop(){if(this.b!==D.Undefined){const u=this.b.element;return this.e(this.b),u}}e(u){if(u.prev!==D.Undefined&&u.next!==D.Undefined){const _=u.prev;_.next=u.next,u.next.prev=_}else u.prev===D.Undefined&&u.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):u.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):u.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let u=this.a;for(;u!==D.Undefined;)yield u.element,u=u.next}}t.LinkedList=S}),Q(Z[16],K([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function D(s){return typeof s=="string"}t.isString=D;function S(s){return Array.isArray(s)&&s.every(d=>D(d))}t.isStringArray=S;function i(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}t.isObject=i;function u(s){const d=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof d}t.isTypedArray=u;function _(s){return typeof s=="number"&&!isNaN(s)}t.isNumber=_;function b(s){return!!s&&typeof s[Symbol.iterator]=="function"}t.isIterable=b;function a(s){return s===!0||s===!1}t.isBoolean=a;function f(s){return typeof s>"u"}t.isUndefined=f;function A(s){return!R(s)}t.isDefined=A;function R(s){return f(s)||s===null}t.isUndefinedOrNull=R;function N(s,d){if(!s)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}t.assertType=N;function L(s){if(R(s))throw new Error("Assertion Failed: argument is undefined or null");return s}t.assertIsDefined=L;function e(...s){const d=[];for(let c=0;c<s.length;c++){const p=s[c];if(R(p))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);d.push(p)}return d}t.assertAllDefined=e;const E=Object.prototype.hasOwnProperty;function F(s){if(!i(s))return!1;for(const d in s)if(E.call(s,d))return!1;return!0}t.isEmptyObject=F;function y(s){return typeof s=="function"}t.isFunction=y;function w(...s){return s.length>0&&s.every(y)}t.areFunctions=w;function g(s,d){const c=Math.min(s.length,d.length);for(let p=0;p<c;p++)m(s[p],d[p])}t.validateConstraints=g;function m(s,d){if(D(d)){if(typeof s!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(y(d)){try{if(s instanceof d)return}catch{}if(!R(s)&&s.constructor===d||d.length===1&&d.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=m;function l(s){return s===null?void 0:s}t.withNullAsUndefined=l;function r(s){return typeof s>"u"?null:s}t.withUndefinedAsNull=r}),Q(Z[29],K([0,1,16]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const S=Object.create(null);function i(b,a){if((0,D.isString)(a)){const f=S[a];if(f===void 0)throw new Error(`${b} references an unknown codicon: ${a}`);a=f}return S[b]=a,{id:b}}function u(){return S}t.getCodiconFontCharacters=u;function _(){return Object.values(t.Codicon)}t.getAllCodicons=_,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),Q(Z[11],K([0,1,16]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function S(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const w=Array.isArray(y)?[]:{};return Object.entries(y).forEach(([g,m])=>{w[g]=m&&typeof m=="object"?S(m):m}),w}t.deepClone=S;function i(y){if(!y||typeof y!="object")return y;const w=[y];for(;w.length>0;){const g=w.shift();Object.freeze(g);for(const m in g)if(u.call(g,m)){const l=g[m];typeof l=="object"&&!Object.isFrozen(l)&&!(0,D.isTypedArray)(l)&&w.push(l)}}return y}t.deepFreeze=i;const u=Object.prototype.hasOwnProperty;function _(y,w){return b(y,w,new Set)}t.cloneAndChange=_;function b(y,w,g){if((0,D.isUndefinedOrNull)(y))return y;const m=w(y);if(typeof m<"u")return m;if(Array.isArray(y)){const l=[];for(const r of y)l.push(b(r,w,g));return l}if((0,D.isObject)(y)){if(g.has(y))throw new Error("Cannot clone recursive data-structure");g.add(y);const l={};for(const r in y)u.call(y,r)&&(l[r]=b(y[r],w,g));return g.delete(y),l}return y}function a(y,w,g=!0){return(0,D.isObject)(y)?((0,D.isObject)(w)&&Object.keys(w).forEach(m=>{m in y?g&&((0,D.isObject)(y[m])&&(0,D.isObject)(w[m])?a(y[m],w[m],g):y[m]=w[m]):y[m]=w[m]}),y):w}t.mixin=a;function f(y,w){if(y===w)return!0;if(y==null||w===null||w===void 0||typeof y!=typeof w||typeof y!="object"||Array.isArray(y)!==Array.isArray(w))return!1;let g,m;if(Array.isArray(y)){if(y.length!==w.length)return!1;for(g=0;g<y.length;g++)if(!f(y[g],w[g]))return!1}else{const l=[];for(m in y)l.push(m);l.sort();const r=[];for(m in w)r.push(m);if(r.sort(),!f(l,r))return!1;for(g=0;g<l.length;g++)if(!f(y[l[g]],w[l[g]]))return!1}return!0}t.equals=f;function A(y){const w=new Set;return JSON.stringify(y,(g,m)=>{if((0,D.isObject)(m)||Array.isArray(m)){if(w.has(m))return"[Circular]";w.add(m)}return m})}t.safeStringify=A;function R(y,w){const g=Object.create(null);return!y||!w||Object.keys(w).forEach(l=>{const r=y[l],s=w[l];f(r,s)||(g[l]=s)}),g}t.distinct=R;function N(y,w){const g=w.toLowerCase(),m=Object.keys(y).find(l=>l.toLowerCase()===g);return m?y[m]:y[w]}t.getCaseInsensitive=N;function L(y,w){const g=Object.create(null);for(const[m,l]of Object.entries(y))w(m,l)&&(g[m]=l);return g}t.filter=L;function e(y){let w=[],g=Object.getPrototypeOf(y);for(;Object.prototype!==g;)w=w.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return w}t.getAllPropertyNames=e;function E(y){const w=[];for(const g of e(y))typeof y[g]=="function"&&w.push(g);return w}t.getAllMethodNames=E;function F(y,w){const g=l=>function(){const r=Array.prototype.slice.call(arguments,0);return w(l,r)},m={};for(const l of y)m[l]=g(l);return m}t.createProxyObject=F}),Q(Z[17],K([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var D;(function(u){u[u.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",u[u.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",u[u.MAX_UINT_8=255]="MAX_UINT_8",u[u.MAX_UINT_16=65535]="MAX_UINT_16",u[u.MAX_UINT_32=4294967295]="MAX_UINT_32",u[u.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D=t.Constants||(t.Constants={}));function S(u){return u<0?0:u>255?255:u|0}t.toUint8=S;function i(u){return u<0?0:u>4294967295?4294967295:u|0}t.toUint32=i}),Q(Z[18],K([0,1,17]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class S{constructor(b){const a=(0,D.toUint8)(b);this.c=a,this.a=S.d(a),this.b=new Map}static d(b){const a=new Uint8Array(256);return a.fill(b),a}set(b,a){const f=(0,D.toUint8)(a);b>=0&&b<256?this.a[b]=f:this.b.set(b,f)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.CharacterClassifier=S;var i;(function(_){_[_.False=0]="False",_[_.True=1]="True"})(i||(i={}));class u{constructor(){this.a=new S(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}t.CharacterSet=u}),Q(Z[3],K([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class D{constructor(i,u){this.lineNumber=i,this.column=u}with(i=this.lineNumber,u=this.column){return i===this.lineNumber&&u===this.column?this:new D(i,u)}delta(i=0,u=0){return this.with(this.lineNumber+i,this.column+u)}equals(i){return D.equals(this,i)}static equals(i,u){return!i&&!u?!0:!!i&&!!u&&i.lineNumber===u.lineNumber&&i.column===u.column}isBefore(i){return D.isBefore(this,i)}static isBefore(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<u.column}isBeforeOrEqual(i){return D.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<=u.column}static compare(i,u){const _=i.lineNumber|0,b=u.lineNumber|0;if(_===b){const a=i.column|0,f=u.column|0;return a-f}return _-b}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new D(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}t.Position=D}),Q(Z[2],K([0,1,3]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class S{constructor(u,_,b,a){u>b||u===b&&_>a?(this.startLineNumber=b,this.startColumn=a,this.endLineNumber=u,this.endColumn=_):(this.startLineNumber=u,this.startColumn=_,this.endLineNumber=b,this.endColumn=a)}isEmpty(){return S.isEmpty(this)}static isEmpty(u){return u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn}containsPosition(u){return S.containsPosition(this,u)}static containsPosition(u,_){return!(_.lineNumber<u.startLineNumber||_.lineNumber>u.endLineNumber||_.lineNumber===u.startLineNumber&&_.column<u.startColumn||_.lineNumber===u.endLineNumber&&_.column>u.endColumn)}static strictContainsPosition(u,_){return!(_.lineNumber<u.startLineNumber||_.lineNumber>u.endLineNumber||_.lineNumber===u.startLineNumber&&_.column<=u.startColumn||_.lineNumber===u.endLineNumber&&_.column>=u.endColumn)}containsRange(u){return S.containsRange(this,u)}static containsRange(u,_){return!(_.startLineNumber<u.startLineNumber||_.endLineNumber<u.startLineNumber||_.startLineNumber>u.endLineNumber||_.endLineNumber>u.endLineNumber||_.startLineNumber===u.startLineNumber&&_.startColumn<u.startColumn||_.endLineNumber===u.endLineNumber&&_.endColumn>u.endColumn)}strictContainsRange(u){return S.strictContainsRange(this,u)}static strictContainsRange(u,_){return!(_.startLineNumber<u.startLineNumber||_.endLineNumber<u.startLineNumber||_.startLineNumber>u.endLineNumber||_.endLineNumber>u.endLineNumber||_.startLineNumber===u.startLineNumber&&_.startColumn<=u.startColumn||_.endLineNumber===u.endLineNumber&&_.endColumn>=u.endColumn)}plusRange(u){return S.plusRange(this,u)}static plusRange(u,_){let b,a,f,A;return _.startLineNumber<u.startLineNumber?(b=_.startLineNumber,a=_.startColumn):_.startLineNumber===u.startLineNumber?(b=_.startLineNumber,a=Math.min(_.startColumn,u.startColumn)):(b=u.startLineNumber,a=u.startColumn),_.endLineNumber>u.endLineNumber?(f=_.endLineNumber,A=_.endColumn):_.endLineNumber===u.endLineNumber?(f=_.endLineNumber,A=Math.max(_.endColumn,u.endColumn)):(f=u.endLineNumber,A=u.endColumn),new S(b,a,f,A)}intersectRanges(u){return S.intersectRanges(this,u)}static intersectRanges(u,_){let b=u.startLineNumber,a=u.startColumn,f=u.endLineNumber,A=u.endColumn;const R=_.startLineNumber,N=_.startColumn,L=_.endLineNumber,e=_.endColumn;return b<R?(b=R,a=N):b===R&&(a=Math.max(a,N)),f>L?(f=L,A=e):f===L&&(A=Math.min(A,e)),b>f||b===f&&a>A?null:new S(b,a,f,A)}equalsRange(u){return S.equalsRange(this,u)}static equalsRange(u,_){return!u&&!_?!0:!!u&&!!_&&u.startLineNumber===_.startLineNumber&&u.startColumn===_.startColumn&&u.endLineNumber===_.endLineNumber&&u.endColumn===_.endColumn}getEndPosition(){return S.getEndPosition(this)}static getEndPosition(u){return new D.Position(u.endLineNumber,u.endColumn)}getStartPosition(){return S.getStartPosition(this)}static getStartPosition(u){return new D.Position(u.startLineNumber,u.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(u,_){return new S(this.startLineNumber,this.startColumn,u,_)}setStartPosition(u,_){return new S(u,_,this.endLineNumber,this.endColumn)}collapseToStart(){return S.collapseToStart(this)}static collapseToStart(u){return new S(u.startLineNumber,u.startColumn,u.startLineNumber,u.startColumn)}collapseToEnd(){return S.collapseToEnd(this)}static collapseToEnd(u){return new S(u.endLineNumber,u.endColumn,u.endLineNumber,u.endColumn)}delta(u){return new S(this.startLineNumber+u,this.startColumn,this.endLineNumber+u,this.endColumn)}static fromPositions(u,_=u){return new S(u.lineNumber,u.column,_.lineNumber,_.column)}static lift(u){return u?new S(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):null}static isIRange(u){return u&&typeof u.startLineNumber=="number"&&typeof u.startColumn=="number"&&typeof u.endLineNumber=="number"&&typeof u.endColumn=="number"}static areIntersectingOrTouching(u,_){return!(u.endLineNumber<_.startLineNumber||u.endLineNumber===_.startLineNumber&&u.endColumn<_.startColumn||_.endLineNumber<u.startLineNumber||_.endLineNumber===u.startLineNumber&&_.endColumn<u.startColumn)}static areIntersecting(u,_){return!(u.endLineNumber<_.startLineNumber||u.endLineNumber===_.startLineNumber&&u.endColumn<=_.startColumn||_.endLineNumber<u.startLineNumber||_.endLineNumber===u.startLineNumber&&_.endColumn<=u.startColumn)}static compareRangesUsingStarts(u,_){if(u&&_){const f=u.startLineNumber|0,A=_.startLineNumber|0;if(f===A){const R=u.startColumn|0,N=_.startColumn|0;if(R===N){const L=u.endLineNumber|0,e=_.endLineNumber|0;if(L===e){const E=u.endColumn|0,F=_.endColumn|0;return E-F}return L-e}return R-N}return f-A}return(u?1:0)-(_?1:0)}static compareRangesUsingEnds(u,_){return u.endLineNumber===_.endLineNumber?u.endColumn===_.endColumn?u.startLineNumber===_.startLineNumber?u.startColumn-_.startColumn:u.startLineNumber-_.startLineNumber:u.endColumn-_.endColumn:u.endLineNumber-_.endLineNumber}static spansMultipleLines(u){return u.endLineNumber>u.startLineNumber}toJSON(){return this}}t.Range=S}),Q(Z[30],K([0,1,3,2]),function(W,t,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var i;(function(_){_[_.LTR=0]="LTR",_[_.RTL=1]="RTL"})(i=t.SelectionDirection||(t.SelectionDirection={}));class u extends S.Range{constructor(b,a,f,A){super(b,a,f,A),this.selectionStartLineNumber=b,this.selectionStartColumn=a,this.positionLineNumber=f,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return u.selectionsEqual(this,b)}static selectionsEqual(b,a){return b.selectionStartLineNumber===a.selectionStartLineNumber&&b.selectionStartColumn===a.selectionStartColumn&&b.positionLineNumber===a.positionLineNumber&&b.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,a){return this.getDirection()===0?new u(this.startLineNumber,this.startColumn,b,a):new u(b,a,this.startLineNumber,this.startColumn)}getPosition(){return new D.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,a){return this.getDirection()===0?new u(b,a,this.endLineNumber,this.endColumn):new u(this.endLineNumber,this.endColumn,b,a)}static fromPositions(b,a=b){return new u(b.lineNumber,b.column,a.lineNumber,a.column)}static fromRange(b,a){return a===0?new u(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new u(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new u(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,a){if(b&&!a||!b&&a)return!1;if(!b&&!a)return!0;if(b.length!==a.length)return!1;for(let f=0,A=b.length;f<A;f++)if(!this.selectionsEqual(b[f],a[f]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,a,f,A,R){return R===0?new u(b,a,f,A):new u(f,A,b,a)}}t.Selection=u}),Q(Z[31],K([0,1,18]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var S;(function(_){_[_.Regular=0]="Regular",_[_.Whitespace=1]="Whitespace",_[_.WordSeparator=2]="WordSeparator"})(S=t.WordCharacterClass||(t.WordCharacterClass={}));class i extends D.CharacterClassifier{constructor(b){super(0);for(let a=0,f=b.length;a<f;a++)this.set(b.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=i;function u(_){const b={};return a=>(b.hasOwnProperty(a)||(b[a]=_(a)),b[a])}t.getMapForWordSeparators=u(_=>new i(_))}),Q(Z[19],K([0,1,14,7,15]),function(W,t,D,S,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.setDefaultGetWordAtTextConfig=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function u(R=""){let N="(-?\\d*\\.\\d\\w*)|([^";for(const L of t.USUAL_WORD_SEPARATORS)R.indexOf(L)>=0||(N+="\\"+L);return N+="\\s]+)",new RegExp(N,"g")}t.DEFAULT_WORD_REGEXP=u();function _(R){let N=t.DEFAULT_WORD_REGEXP;if(R&&R instanceof RegExp)if(R.global)N=R;else{let L="g";R.ignoreCase&&(L+="i"),R.multiline&&(L+="m"),R.unicode&&(L+="u"),N=new RegExp(R.source,L)}return N.lastIndex=0,N}t.ensureValidWordDefinition=_;const b=new i.LinkedList;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(R){const N=b.unshift(R);return(0,S.toDisposable)(N)}t.setDefaultGetWordAtTextConfig=a;function f(R,N,L,e,E){if(E||(E=D.Iterable.first(b)),L.length>E.maxLen){let m=R-E.maxLen/2;return m<0?m=0:e+=m,L=L.substring(m,R+E.maxLen/2),f(R,N,L,e,E)}const F=Date.now(),y=R-1-e;let w=-1,g=null;for(let m=1;!(Date.now()-F>=E.timeBudget);m++){const l=y-E.windowSize*m;N.lastIndex=Math.max(0,l);const r=A(N,L,y,w);if(!r&&g||(g=r,l<=0))break;w=l}if(g){const m={word:g[0],startColumn:e+1+g.index,endColumn:e+1+g.index+g[0].length};return N.lastIndex=0,m}return null}t.getWordAtText=f;function A(R,N,L,e){let E;for(;E=R.exec(N);){const F=E.index||0;if(F<=L&&R.lastIndex>=L)return E;if(e>0&&F>e)return null}return null}}),Q(Z[8],K([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRange=t.SequenceDiff=void 0;class D{constructor(u,_){this.seq1Range=u,this.seq2Range=_}reverse(){return new D(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}}t.SequenceDiff=D;class S{constructor(u,_){this.start=u,this.endExclusive=_}get isEmpty(){return this.start===this.endExclusive}delta(u){return new S(this.start+u,this.endExclusive+u)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}join(u){return new S(Math.min(this.start,u.start),Math.max(this.endExclusive,u.endExclusive))}}t.OffsetRange=S}),Q(Z[32],K([0,1,8]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shiftSequenceDiffs=t.joinSequenceDiffs=t.smoothenSequenceDiffs=t.optimizeSequenceDiffs=void 0;function S(a,f,A){let R=A;return R=u(a,f,R),R=_(a,f,R),R}t.optimizeSequenceDiffs=S;function i(a,f,A){const R=[];for(const N of A){const L=R[R.length-1];if(!L){R.push(N);continue}N.seq1Range.start-L.seq1Range.endExclusive<=2||N.seq2Range.start-L.seq2Range.endExclusive<=2?R[R.length-1]=new D.SequenceDiff(L.seq1Range.join(N.seq1Range),L.seq2Range.join(N.seq2Range)):R.push(N)}return R}t.smoothenSequenceDiffs=i;function u(a,f,A){const R=[];A.length>0&&R.push(A[0]);for(let N=1;N<A.length;N++){const L=R[R.length-1],e=A[N];if(e.seq1Range.isEmpty){let E=!0;const F=e.seq1Range.start-L.seq1Range.endExclusive;for(let y=1;y<=F;y++)if(f.getElement(e.seq2Range.start-y)!==f.getElement(e.seq2Range.endExclusive-y)){E=!1;break}if(E){R[R.length-1]=new D.SequenceDiff(L.seq1Range,new D.OffsetRange(L.seq2Range.start,e.seq2Range.endExclusive-F));continue}}R.push(e)}return R}t.joinSequenceDiffs=u;function _(a,f,A){if(!a.getBoundaryScore||!f.getBoundaryScore)return A;for(let R=0;R<A.length;R++){const N=A[R];if(N.seq1Range.isEmpty){const L=R>0?A[R-1].seq2Range.endExclusive:-1,e=R+1<A.length?A[R+1].seq2Range.start:f.length;A[R]=b(N,a,f,e,L)}else if(N.seq2Range.isEmpty){const L=R>0?A[R-1].seq1Range.endExclusive:-1,e=R+1<A.length?A[R+1].seq1Range.start:a.length;A[R]=b(N.reverse(),f,a,e,L).reverse()}}return A}t.shiftSequenceDiffs=_;function b(a,f,A,R,N){let e=1;for(;a.seq2Range.start-e>N&&A.getElement(a.seq2Range.start-e)===A.getElement(a.seq2Range.endExclusive-e)&&e<20;)e++;e--;let E=0;for(;a.seq2Range.start+E<R&&A.getElement(a.seq2Range.start+E)===A.getElement(a.seq2Range.endExclusive+E)&&E<20;)E++;if(e===0&&E===0)return a;let F=0,y=-1;for(let w=-e;w<=E;w++){const g=a.seq2Range.start+w,m=a.seq2Range.endExclusive+w,l=a.seq1Range.start+w,r=f.getBoundaryScore(l)+A.getBoundaryScore(g)+A.getBoundaryScore(m);r>y&&(y=r,F=w)}return F!==0?new D.SequenceDiff(a.seq1Range.delta(F),a.seq2Range.delta(F)):a}}),Q(Z[33],K([0,1,8]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class S{compute(a,f){if(a.length===0)return[new D.SequenceDiff(new D.OffsetRange(0,0),new D.OffsetRange(0,f.length))];if(f.length===0)return[new D.SequenceDiff(new D.OffsetRange(0,a.length),new D.OffsetRange(0,0))];function A(g,m){for(;g<a.length&&m<f.length&&a.getElement(g)===f.getElement(m);)g++,m++;return g}let R=0;const N=new u;N.set(0,A(0,0));const L=new _;L.set(0,N.get(0)===0?null:new i(null,0,0,N.get(0)));let e=0;e:for(;;)for(R++,e=-R;e<=R;e+=2){const g=e===R?-1:N.get(e+1),m=e===-R?-1:N.get(e-1)+1,l=Math.min(Math.max(g,m),a.length),r=l-e,s=A(l,r);N.set(e,s);const d=l===g?L.get(e+1):L.get(e-1);if(L.set(e,s!==l?new i(d,l,r,s-l):d),N.get(e)===a.length&&N.get(e)-e===f.length)break e}let E=L.get(e);const F=[];let y=a.length,w=f.length;for(;;){const g=E?E.x+E.length:0,m=E?E.y+E.length:0;if((g!==y||m!==w)&&F.push(new D.SequenceDiff(new D.OffsetRange(g,y),new D.OffsetRange(m,w))),!E)break;y=E.x,w=E.y,E=E.prev}return F.reverse(),F}}t.MyersDiffAlgorithm=S;class i{constructor(a,f,A,R){this.prev=a,this.x=f,this.y=A,this.length=R}}class u{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(a){return a<0?(a=-a-1,this.b[a]):this.a[a]}set(a,f){if(a<0){if(a=-a-1,a>=this.b.length){const A=this.b;this.b=new Int32Array(A.length*2),this.b.set(A)}this.b[a]=f}else{if(a>=this.a.length){const A=this.a;this.a=new Int32Array(A.length*2),this.a.set(A)}this.a[a]=f}}}class _{constructor(){this.a=[],this.b=[]}get(a){return a<0?(a=-a-1,this.b[a]):this.a[a]}set(a,f){a<0?(a=-a-1,this.b[a]=f):this.a[a]=f}}}),Q(Z[34],K([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Array2D=void 0;class D{constructor(i,u){this.width=i,this.height=u,this.a=[],this.a=new Array(i*u)}get(i,u){return this.a[i+u*this.width]}set(i,u,_){this.a[i+u*this.width]=_}}t.Array2D=D}),Q(Z[35],K([0,1,8,34]),function(W,t,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class i{compute(_,b,a){const f=new S.Array2D(_.length,b.length),A=new S.Array2D(_.length,b.length),R=new S.Array2D(_.length,b.length);for(let w=0;w<_.length;w++)for(let g=0;g<b.length;g++){const m=w===0?0:f.get(w-1,g),l=g===0?0:f.get(w,g-1);let r;_.getElement(w)===b.getElement(g)?(w===0||g===0?r=0:r=f.get(w-1,g-1),w>0&&g>0&&A.get(w-1,g-1)===3&&(r+=R.get(w-1,g-1)),r+=a?a(w,g):1):r=-1;const s=Math.max(m,l,r);if(s===r){const d=w>0&&g>0?R.get(w-1,g-1):0;R.set(w,g,d+1),A.set(w,g,3)}else s===m?(R.set(w,g,0),A.set(w,g,1)):s===l&&(R.set(w,g,0),A.set(w,g,2));f.set(w,g,s)}const N=[];let L=_.length,e=b.length;function E(w,g){(w+1!==L||g+1!==e)&&N.push(new D.SequenceDiff(new D.OffsetRange(w+1,L),new D.OffsetRange(g+1,e))),L=w,e=g}let F=_.length-1,y=b.length-1;for(;F>=0&&y>=0;)A.get(F,y)===3?(E(F,y),F--,y--):A.get(F,y)===1?F--:y--;return E(-1,-1),N.reverse(),N}}t.DynamicProgrammingDiffing=i}),Q(Z[20],K([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRange=t.RangeMapping=t.LineRangeMapping=void 0;class D{constructor(_,b,a){this.originalRange=_,this.modifiedRange=b,this.innerChanges=a}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}t.LineRangeMapping=D;class S{constructor(_,b){this.originalRange=_,this.modifiedRange=b}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}t.RangeMapping=S;class i{constructor(_,b){this.startLineNumber=_,this.endLineNumberExclusive=b}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(_){return new i(this.startLineNumber+_,this.endLineNumberExclusive+_)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(_){return new i(Math.min(this.startLineNumber,_.startLineNumber),Math.max(this.endLineNumberExclusive,_.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}t.LineRange=i}),Q(Z[36],K([0,1,10,3,2,8,35,32,33,20]),function(W,t,D,S,i,u,_,b,a,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=t.lineRangeMappingFromRangeMappings=t.StandardLinesDiffComputer=void 0;class A{constructor(){this.b=new _.DynamicProgrammingDiffing,this.c=new a.MyersDiffAlgorithm}computeDiff(r,s,d){const c=new Map;function p(ne){let Y=c.get(ne);return Y===void 0&&(Y=c.size,c.set(ne,Y)),Y}const v=r.map(ne=>p(ne.trim())),h=s.map(ne=>p(ne.trim())),o=new L(v,r),M=new L(h,s);let T=(()=>o.length+M.length<1500?this.b.compute(o,M,(ne,Y)=>r[ne]===s[Y]?s[Y].length===0?.1:1+Math.log(1+s[Y].length):.99):this.c.compute(o,M))();T=(0,b.optimizeSequenceDiffs)(o,M,T);const O=[],C=ne=>{for(let Y=0;Y<ne;Y++){const J=H+Y,n=z+Y;if(r[J]!==s[n]){const Le=this.f(r,s,new u.SequenceDiff(new u.OffsetRange(J,J+1),new u.OffsetRange(n,n+1)));for(const Ae of Le)O.push(Ae)}}};let H=0,z=0;for(const ne of T){(0,D.assertFn)(()=>ne.seq1Range.start-H===ne.seq2Range.start-z);const Y=ne.seq1Range.start-H;C(Y),H=ne.seq1Range.endExclusive,z=ne.seq2Range.endExclusive;const J=this.f(r,s,ne);for(const n of J)O.push(n)}C(r.length-H);const ee=R(O);return{quitEarly:!1,changes:ee}}f(r,s,d){const c=new E(r,d.seq1Range),p=new E(s,d.seq2Range),v=c.length+p.length<500?this.b.compute(c,p):this.c.compute(c,p);let h=(0,b.optimizeSequenceDiffs)(c,p,v);return h=(0,b.smoothenSequenceDiffs)(c,p,h),h.map(M=>new f.RangeMapping(c.translateRange(M.seq1Range).delta(d.seq1Range.start),p.translateRange(M.seq2Range).delta(d.seq2Range.start)))}}t.StandardLinesDiffComputer=A;function R(l){const r=[];for(const s of N(l,(d,c)=>c.originalRange.startLineNumber-(d.originalRange.endLineNumber-(d.originalRange.endColumn>1?0:1))<=1||c.modifiedRange.startLineNumber-(d.modifiedRange.endLineNumber-(d.modifiedRange.endColumn>1?0:1))<=1)){const d=s[0],c=s[s.length-1];r.push(new f.LineRangeMapping(new f.LineRange(d.originalRange.startLineNumber,c.originalRange.endLineNumber+(c.originalRange.endColumn>1||c.modifiedRange.endColumn>1?1:0)),new f.LineRange(d.modifiedRange.startLineNumber,c.modifiedRange.endLineNumber+(c.originalRange.endColumn>1||c.modifiedRange.endColumn>1?1:0)),s))}return(0,D.assertFn)(()=>(0,D.checkAdjacentItems)(r,(s,d)=>d.originalRange.startLineNumber-s.originalRange.endLineNumberExclusive===d.modifiedRange.startLineNumber-s.modifiedRange.endLineNumberExclusive&&s.originalRange.endLineNumberExclusive<d.originalRange.startLineNumber&&s.modifiedRange.endLineNumberExclusive<d.modifiedRange.startLineNumber)),r}t.lineRangeMappingFromRangeMappings=R;function*N(l,r){let s,d;for(const c of l)d!==void 0&&r(d,c)?s.push(c):(s&&(yield s),s=[c]),d=c;s&&(yield s)}class L{constructor(r,s){this.b=r,this.c=s}getElement(r){return this.b[r]}get length(){return this.b.length}getBoundaryScore(r){const s=r===0?0:e(this.c[r-1]),d=r===this.c.length?0:e(this.c[r]);return 1e3-(s+d)}}t.LineSequence=L;function e(l){let r=0;for(;r<l.length&&(l.charCodeAt(r)===32||l.charCodeAt(r)===9);)r++;return r}class E{constructor(r,s){this.lines=r,this.lineRange=s;let d=0;this.c=new Int32Array(s.length);for(let p=s.start;p<s.endExclusive;p++)d+=r[p].length,this.c[p-s.start]=d+1,d++;this.b=new Int32Array(d);let c=0;for(let p=s.start;p<s.endExclusive;p++){const v=r[p];for(let h=0;h<v.length;h++)this.b[c+h]=v.charCodeAt(h);c+=v.length,p<r.length-1&&(this.b[c]=`
`.charCodeAt(0),c+=1)}}get text(){return[...this.b].map(r=>String.fromCharCode(r)).join("")}getElement(r){return this.b[r]}get length(){return this.b.length}getBoundaryScore(r){const s=g(r>0?this.b[r-1]:-1),d=g(r<this.b.length?this.b[r]:-1);if(s===6&&d===7)return 0;let c=0;return s!==d&&(c+=10,d===1&&(c+=1)),c+=w(s),c+=w(d),c}translateOffset(r){let s=0,d=this.c.length;for(;s<d;){const p=Math.floor((s+d)/2);this.c[p]>r?d=p:s=p+1}const c=s===0?0:this.c[s-1];return new S.Position(s+1,r-c+1)}translateRange(r){return i.Range.fromPositions(this.translateOffset(r.start),this.translateOffset(r.endExclusive))}}var F;(function(l){l[l.WordLower=0]="WordLower",l[l.WordUpper=1]="WordUpper",l[l.WordNumber=2]="WordNumber",l[l.End=3]="End",l[l.Other=4]="Other",l[l.Space=5]="Space",l[l.LineBreakCR=6]="LineBreakCR",l[l.LineBreakLF=7]="LineBreakLF"})(F||(F={}));const y={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function w(l){return y[l]}function g(l){return l===10?7:l===13?6:m(l)?5:l>=97&&l<=122?0:l>=65&&l<=90?1:l>=48&&l<=57?2:l===-1?3:4}function m(l){return l===32||l===9}}),Q(Z[37],K([0,1,18]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.State=void 0;var S;(function(L){L[L.Invalid=0]="Invalid",L[L.Start=1]="Start",L[L.H=2]="H",L[L.HT=3]="HT",L[L.HTT=4]="HTT",L[L.HTTP=5]="HTTP",L[L.F=6]="F",L[L.FI=7]="FI",L[L.FIL=8]="FIL",L[L.BeforeColon=9]="BeforeColon",L[L.AfterColon=10]="AfterColon",L[L.AlmostThere=11]="AlmostThere",L[L.End=12]="End",L[L.Accept=13]="Accept",L[L.LastKnownState=14]="LastKnownState"})(S=t.State||(t.State={}));class i{constructor(e,E,F){const y=new Uint8Array(e*E);for(let w=0,g=e*E;w<g;w++)y[w]=F;this.a=y,this.rows=e,this.cols=E}get(e,E){return this.a[e*this.cols+E]}set(e,E,F){this.a[e*this.cols+E]=F}}class u{constructor(e){let E=0,F=0;for(let w=0,g=e.length;w<g;w++){const[m,l,r]=e[w];l>E&&(E=l),m>F&&(F=m),r>F&&(F=r)}E++,F++;const y=new i(F,E,0);for(let w=0,g=e.length;w<g;w++){const[m,l,r]=e[w];y.set(m,l,r)}this.a=y,this.b=E}nextState(e,E){return E<0||E>=this.b?0:this.a.get(e,E)}}t.StateMachine=u;let _=null;function b(){return _===null&&(_=new u([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),_}var a;(function(L){L[L.None=0]="None",L[L.ForceTermination=1]="ForceTermination",L[L.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let f=null;function A(){if(f===null){f=new D.CharacterClassifier(0);const L=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<L.length;E++)f.set(L.charCodeAt(E),1);const e=".;:";for(let E=0;E<e.length;E++)f.set(e.charCodeAt(E),2)}return f}class R{static a(e,E,F,y,w){let g=w-1;do{const m=E.charCodeAt(g);if(e.get(m)!==2)break;g--}while(g>y);if(y>0){const m=E.charCodeAt(y-1),l=E.charCodeAt(g);(m===40&&l===41||m===91&&l===93||m===123&&l===125)&&g--}return{range:{startLineNumber:F,startColumn:y+1,endLineNumber:F,endColumn:g+2},url:E.substring(y,g+1)}}static computeLinks(e,E=b()){const F=A(),y=[];for(let w=1,g=e.getLineCount();w<=g;w++){const m=e.getLineContent(w),l=m.length;let r=0,s=0,d=0,c=1,p=!1,v=!1,h=!1,o=!1;for(;r<l;){let M=!1;const T=m.charCodeAt(r);if(c===13){let O;switch(T){case 40:p=!0,O=0;break;case 41:O=p?0:1;break;case 91:h=!0,v=!0,O=0;break;case 93:h=!1,O=v?0:1;break;case 123:o=!0,O=0;break;case 125:O=o?0:1;break;case 39:case 34:case 96:d===T?O=1:d===39||d===34||d===96?O=0:O=1;break;case 42:O=d===42?1:0;break;case 124:O=d===124?1:0;break;case 32:O=h?0:1;break;default:O=F.get(T)}O===1&&(y.push(R.a(F,m,w,s,r)),M=!0)}else if(c===12){let O;T===91?(v=!0,O=0):O=F.get(T),O===1?M=!0:c=13}else c=E.nextState(c,T),c===0&&(M=!0);M&&(c=1,p=!1,v=!1,o=!1,s=r+1,d=T),r++}c===13&&y.push(R.a(F,m,w,s,l))}return y}}t.LinkComputer=R;function N(L){return!L||typeof L.getLineCount!="function"||typeof L.getLineContent!="function"?[]:R.computeLinks(L)}t.computeLinks=N}),Q(Z[38],K([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class D{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,u,_,b,a){if(i&&u){const f=this.a(u,a);if(f)return{range:i,value:f}}if(_&&b){const f=this.a(b,a);if(f)return{range:_,value:f}}return null}a(i,u){const _=this.b(i,u);return _!==null?_:this.d(i,u)}b(i,u){const _=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let b=Number(i);const a=parseFloat(i);return!isNaN(b)&&!isNaN(a)&&b===a?b===0&&!u?null:(b=Math.floor(b*_),b+=u?_:-_,String(b/_)):null}d(i,u){return this.e(this.c,i,u)}e(i,u,_){let b=null;for(let a=0,f=i.length;b===null&&a<f;a++)b=this.f(i[a],u,_);return b}f(i,u,_){let b=i.indexOf(u);return b>=0?(b+=_?1:-1,b<0?b=i.length-1:b%=i.length,i[b]):null}}D.INSTANCE=new D,t.BasicInplaceReplace=D}),Q(Z[39],K([0,1,11]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.isITextSnapshot=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.OverviewRulerLane=void 0;var S;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(S=t.OverviewRulerLane||(t.OverviewRulerLane={}));var i;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(i=t.MinimapPosition||(t.MinimapPosition={}));var u;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(u=t.InjectedTextCursorStops||(t.InjectedTextCursorStops={}));var _;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(_=t.EndOfLinePreference||(t.EndOfLinePreference={}));var b;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(b=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var a;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(a=t.EndOfLineSequence||(t.EndOfLineSequence={}));class f{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),m.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,m.indentSize|0),this.a=!1),this.insertSpaces=Boolean(m.insertSpaces),this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=Boolean(m.trimAutoWhitespace),this.bracketPairColorizationOptions=m.bracketPairColorizationOptions}equals(m){return this.tabSize===m.tabSize&&this.a===m.a&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace&&(0,D.equals)(this.bracketPairColorizationOptions,m.bracketPairColorizationOptions)}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}t.TextModelResolvedOptions=f;class A{constructor(m,l){this._findMatchBrand=void 0,this.range=m,this.matches=l}}t.FindMatch=A;var R;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(R=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));function N(g){return g&&typeof g.read=="function"}t.isITextSnapshot=N;var L;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(L=t.PositionAffinity||(t.PositionAffinity={}));var e;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(e=t.ModelConstants||(t.ModelConstants={}));class E{constructor(m,l,r,s,d,c){this.identifier=m,this.range=l,this.text=r,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=d,this._isTracked=c}}t.ValidAnnotatedEditOperation=E;class F{constructor(m,l,r){this.regex=m,this.wordSeparators=l,this.simpleSearch=r}}t.SearchData=F;class y{constructor(m,l,r){this.reverseEdits=m,this.changes=l,this.trimAutoWhitespaceLineNumbers=r}}t.ApplyEditsResult=y;function w(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}t.shouldSynchronizeModel=w}),Q(Z[40],K([0,1,26,17]),function(W,t,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class i{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,f){a=(0,S.toUint32)(a);const A=this.a,R=this.b,N=f.length;return N===0?!1:(this.a=new Uint32Array(A.length+N),this.a.set(A.subarray(0,a),0),this.a.set(A.subarray(a),a+N),this.a.set(f,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(R.subarray(0,this.c[0]+1)),!0)}setValue(a,f){return a=(0,S.toUint32)(a),f=(0,S.toUint32)(f),this.a[a]===f?!1:(this.a[a]=f,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,f){a=(0,S.toUint32)(a),f=(0,S.toUint32)(f);const A=this.a,R=this.b;if(a>=A.length)return!1;const N=A.length-a;return f>=N&&(f=N),f===0?!1:(this.a=new Uint32Array(A.length-f),this.a.set(A.subarray(0,a),0),this.a.set(A.subarray(a+f),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(R.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,S.toUint32)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let f=this.c[0]+1;f===0&&(this.b[0]=this.a[0],f++),a>=this.a.length&&(a=this.a.length-1);for(let A=f;A<=a;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let f=0,A=this.a.length-1,R=0,N=0,L=0;for(;f<=A;)if(R=f+(A-f)/2|0,N=this.b[R],L=N-this.a[R],a<L)A=R-1;else if(a>=N)f=R+1;else break;return new _(R,a-L)}}t.PrefixSumComputer=i;class u{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const f=this.e[a],A=f>0?this.d[f-1]:0;return new _(f,a-A)}removeValues(a,f){this.a.splice(a,f),this.f(a)}insertValues(a,f){this.a=(0,D.arrayInsert)(this.a,a,f),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,f=this.a.length;a<f;a++){const A=this.a[a],R=a>0?this.d[a-1]:0;this.d[a]=R+A;for(let N=0;N<A;N++)this.e[R+N]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,f){this.a[a]!==f&&(this.a[a]=f,this.f(a))}}t.ConstantTimePrefixSumComputer=u;class _{constructor(a,f){this.index=a,this.remainder=f,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=f}}t.PrefixSumIndexOfResult=_}),Q(Z[41],K([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var D;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(D=t.AccessibilitySupport||(t.AccessibilitySupport={}));var S;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(S=t.CodeActionTriggerType||(t.CodeActionTriggerType={}));var i;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(i=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var u;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(u=t.CompletionItemKind||(t.CompletionItemKind={}));var _;(function(n){n[n.Deprecated=1]="Deprecated"})(_=t.CompletionItemTag||(t.CompletionItemTag={}));var b;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var a;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(a=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var f;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(f=t.CursorChangeReason||(t.CursorChangeReason={}));var A;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(A=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var R;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(R=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var N;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(N=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var L;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.autoClosingDelete=6]="autoClosingDelete",n[n.autoClosingOvertype=7]="autoClosingOvertype",n[n.autoClosingQuotes=8]="autoClosingQuotes",n[n.autoIndent=9]="autoIndent",n[n.automaticLayout=10]="automaticLayout",n[n.autoSurround=11]="autoSurround",n[n.bracketPairColorization=12]="bracketPairColorization",n[n.guides=13]="guides",n[n.codeLens=14]="codeLens",n[n.codeLensFontFamily=15]="codeLensFontFamily",n[n.codeLensFontSize=16]="codeLensFontSize",n[n.colorDecorators=17]="colorDecorators",n[n.colorDecoratorsLimit=18]="colorDecoratorsLimit",n[n.columnSelection=19]="columnSelection",n[n.comments=20]="comments",n[n.contextmenu=21]="contextmenu",n[n.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",n[n.cursorBlinking=23]="cursorBlinking",n[n.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",n[n.cursorStyle=25]="cursorStyle",n[n.cursorSurroundingLines=26]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",n[n.cursorWidth=28]="cursorWidth",n[n.disableLayerHinting=29]="disableLayerHinting",n[n.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",n[n.domReadOnly=31]="domReadOnly",n[n.dragAndDrop=32]="dragAndDrop",n[n.dropIntoEditor=33]="dropIntoEditor",n[n.emptySelectionClipboard=34]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",n[n.extraEditorClassName=36]="extraEditorClassName",n[n.fastScrollSensitivity=37]="fastScrollSensitivity",n[n.find=38]="find",n[n.fixedOverflowWidgets=39]="fixedOverflowWidgets",n[n.folding=40]="folding",n[n.foldingStrategy=41]="foldingStrategy",n[n.foldingHighlight=42]="foldingHighlight",n[n.foldingImportsByDefault=43]="foldingImportsByDefault",n[n.foldingMaximumRegions=44]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=46]="fontFamily",n[n.fontInfo=47]="fontInfo",n[n.fontLigatures=48]="fontLigatures",n[n.fontSize=49]="fontSize",n[n.fontWeight=50]="fontWeight",n[n.fontVariations=51]="fontVariations",n[n.formatOnPaste=52]="formatOnPaste",n[n.formatOnType=53]="formatOnType",n[n.glyphMargin=54]="glyphMargin",n[n.gotoLocation=55]="gotoLocation",n[n.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",n[n.hover=57]="hover",n[n.inDiffEditor=58]="inDiffEditor",n[n.inlineSuggest=59]="inlineSuggest",n[n.letterSpacing=60]="letterSpacing",n[n.lightbulb=61]="lightbulb",n[n.lineDecorationsWidth=62]="lineDecorationsWidth",n[n.lineHeight=63]="lineHeight",n[n.lineNumbers=64]="lineNumbers",n[n.lineNumbersMinChars=65]="lineNumbersMinChars",n[n.linkedEditing=66]="linkedEditing",n[n.links=67]="links",n[n.matchBrackets=68]="matchBrackets",n[n.minimap=69]="minimap",n[n.mouseStyle=70]="mouseStyle",n[n.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=72]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",n[n.multiCursorModifier=74]="multiCursorModifier",n[n.multiCursorPaste=75]="multiCursorPaste",n[n.multiCursorLimit=76]="multiCursorLimit",n[n.occurrencesHighlight=77]="occurrencesHighlight",n[n.overviewRulerBorder=78]="overviewRulerBorder",n[n.overviewRulerLanes=79]="overviewRulerLanes",n[n.padding=80]="padding",n[n.parameterHints=81]="parameterHints",n[n.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",n[n.quickSuggestions=84]="quickSuggestions",n[n.quickSuggestionsDelay=85]="quickSuggestionsDelay",n[n.readOnly=86]="readOnly",n[n.renameOnType=87]="renameOnType",n[n.renderControlCharacters=88]="renderControlCharacters",n[n.renderFinalNewline=89]="renderFinalNewline",n[n.renderLineHighlight=90]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=92]="renderValidationDecorations",n[n.renderWhitespace=93]="renderWhitespace",n[n.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",n[n.roundedSelection=95]="roundedSelection",n[n.rulers=96]="rulers",n[n.scrollbar=97]="scrollbar",n[n.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=99]="scrollBeyondLastLine",n[n.scrollPredominantAxis=100]="scrollPredominantAxis",n[n.selectionClipboard=101]="selectionClipboard",n[n.selectionHighlight=102]="selectionHighlight",n[n.selectOnLineNumbers=103]="selectOnLineNumbers",n[n.showFoldingControls=104]="showFoldingControls",n[n.showUnused=105]="showUnused",n[n.snippetSuggestions=106]="snippetSuggestions",n[n.smartSelect=107]="smartSelect",n[n.smoothScrolling=108]="smoothScrolling",n[n.stickyScroll=109]="stickyScroll",n[n.stickyTabStops=110]="stickyTabStops",n[n.stopRenderingLineAfter=111]="stopRenderingLineAfter",n[n.suggest=112]="suggest",n[n.suggestFontSize=113]="suggestFontSize",n[n.suggestLineHeight=114]="suggestLineHeight",n[n.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",n[n.suggestSelection=116]="suggestSelection",n[n.tabCompletion=117]="tabCompletion",n[n.tabIndex=118]="tabIndex",n[n.unicodeHighlighting=119]="unicodeHighlighting",n[n.unusualLineTerminators=120]="unusualLineTerminators",n[n.useShadowDOM=121]="useShadowDOM",n[n.useTabStops=122]="useTabStops",n[n.wordBreak=123]="wordBreak",n[n.wordSeparators=124]="wordSeparators",n[n.wordWrap=125]="wordWrap",n[n.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=128]="wordWrapColumn",n[n.wordWrapOverride1=129]="wordWrapOverride1",n[n.wordWrapOverride2=130]="wordWrapOverride2",n[n.wrappingIndent=131]="wrappingIndent",n[n.wrappingStrategy=132]="wrappingStrategy",n[n.showDeprecated=133]="showDeprecated",n[n.inlayHints=134]="inlayHints",n[n.editorClassName=135]="editorClassName",n[n.pixelRatio=136]="pixelRatio",n[n.tabFocusMode=137]="tabFocusMode",n[n.layoutInfo=138]="layoutInfo",n[n.wrappingInfo=139]="wrappingInfo"})(L=t.EditorOption||(t.EditorOption={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e=t.EndOfLinePreference||(t.EndOfLinePreference={}));var E;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(E=t.EndOfLineSequence||(t.EndOfLineSequence={}));var F;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(F=t.IndentAction||(t.IndentAction={}));var y;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(y=t.InjectedTextCursorStops||(t.InjectedTextCursorStops={}));var w;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(w=t.InlayHintKind||(t.InlayHintKind={}));var g;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(g=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var m;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.Semicolon=80]="Semicolon",n[n.Equal=81]="Equal",n[n.Comma=82]="Comma",n[n.Minus=83]="Minus",n[n.Period=84]="Period",n[n.Slash=85]="Slash",n[n.Backquote=86]="Backquote",n[n.BracketLeft=87]="BracketLeft",n[n.Backslash=88]="Backslash",n[n.BracketRight=89]="BracketRight",n[n.Quote=90]="Quote",n[n.OEM_8=91]="OEM_8",n[n.IntlBackslash=92]="IntlBackslash",n[n.Numpad0=93]="Numpad0",n[n.Numpad1=94]="Numpad1",n[n.Numpad2=95]="Numpad2",n[n.Numpad3=96]="Numpad3",n[n.Numpad4=97]="Numpad4",n[n.Numpad5=98]="Numpad5",n[n.Numpad6=99]="Numpad6",n[n.Numpad7=100]="Numpad7",n[n.Numpad8=101]="Numpad8",n[n.Numpad9=102]="Numpad9",n[n.NumpadMultiply=103]="NumpadMultiply",n[n.NumpadAdd=104]="NumpadAdd",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=106]="NumpadSubtract",n[n.NumpadDecimal=107]="NumpadDecimal",n[n.NumpadDivide=108]="NumpadDivide",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.AudioVolumeMute=112]="AudioVolumeMute",n[n.AudioVolumeUp=113]="AudioVolumeUp",n[n.AudioVolumeDown=114]="AudioVolumeDown",n[n.BrowserSearch=115]="BrowserSearch",n[n.BrowserHome=116]="BrowserHome",n[n.BrowserBack=117]="BrowserBack",n[n.BrowserForward=118]="BrowserForward",n[n.MediaTrackNext=119]="MediaTrackNext",n[n.MediaTrackPrevious=120]="MediaTrackPrevious",n[n.MediaStop=121]="MediaStop",n[n.MediaPlayPause=122]="MediaPlayPause",n[n.LaunchMediaPlayer=123]="LaunchMediaPlayer",n[n.LaunchMail=124]="LaunchMail",n[n.LaunchApp2=125]="LaunchApp2",n[n.Clear=126]="Clear",n[n.MAX_VALUE=127]="MAX_VALUE"})(m=t.KeyCode||(t.KeyCode={}));var l;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(l=t.MarkerSeverity||(t.MarkerSeverity={}));var r;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(r=t.MarkerTag||(t.MarkerTag={}));var s;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(s=t.MinimapPosition||(t.MinimapPosition={}));var d;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(d=t.MouseTargetType||(t.MouseTargetType={}));var c;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(c=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var p;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(p=t.OverviewRulerLane||(t.OverviewRulerLane={}));var v;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(v=t.PositionAffinity||(t.PositionAffinity={}));var h;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(h=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var o;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(o=t.RenderMinimap||(t.RenderMinimap={}));var M;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(M=t.ScrollType||(t.ScrollType={}));var T;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(T=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var O;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(O=t.SelectionDirection||(t.SelectionDirection={}));var C;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(C=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var H;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(H=t.SymbolKind||(t.SymbolKind={}));var z;(function(n){n[n.Deprecated=1]="Deprecated"})(z=t.SymbolTag||(t.SymbolTag={}));var ee;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(ee=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var ne;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(ne=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var Y;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(Y=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var J;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(J=t.WrappingIndent||(t.WrappingIndent={}))}),Q(Z[42],K([55,56]),function(W,t){return W.create("vs/base/common/platform",t)}),Q(Z[5],K([0,1,42]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let S=!1,i=!1,u=!1,_=!1,b=!1,a=!1,f=!1,A=!1,R=!1,N=!1,L,e=t.LANGUAGE_DEFAULT,E,F;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let y;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?y=t.globals.vscode.process:typeof process<"u"&&(y=process);const w=typeof y?.versions?.electron=="string",g=w&&y?.type==="renderer";if(typeof navigator=="object"&&!g)F=navigator.userAgent,S=F.indexOf("Windows")>=0,i=F.indexOf("Macintosh")>=0,A=(F.indexOf("Macintosh")>=0||F.indexOf("iPad")>=0||F.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,u=F.indexOf("Linux")>=0,N=F?.indexOf("Mobi")>=0,a=!0,L=D.getConfiguredDefaultLocale(D.localize(0,null))||t.LANGUAGE_DEFAULT,e=L;else if(typeof y=="object"){S=y.platform==="win32",i=y.platform==="darwin",u=y.platform==="linux",_=u&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,f=w,R=!!y.env.CI||!!y.env.BUILD_ARTIFACTSTAGINGDIRECTORY,L=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const h=y.env.VSCODE_NLS_CONFIG;if(h)try{const o=JSON.parse(h),M=o.availableLanguages["*"];L=o.locale,e=M||t.LANGUAGE_DEFAULT,E=o._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var m;(function(h){h[h.Web=0]="Web",h[h.Mac=1]="Mac",h[h.Linux=2]="Linux",h[h.Windows=3]="Windows"})(m=t.Platform||(t.Platform={}));function l(h){switch(h){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=l;let r=0;i?r=1:S?r=3:u&&(r=2),t.isWindows=S,t.isMacintosh=i,t.isLinux=u,t.isLinuxSnap=_,t.isNative=b,t.isElectron=f,t.isWeb=a,t.isWebWorker=a&&typeof t.globals.importScripts=="function",t.isIOS=A,t.isMobile=N,t.isCI=R,t.platform=r,t.userAgent=F,t.language=e;var s;(function(h){function o(){return t.language}h.value=o;function M(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}h.isDefaultVariant=M;function T(){return t.language==="en"}h.isDefault=T})(s=t.Language||(t.Language={})),t.locale=L,t.translationsConfigFile=E,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const h=[];t.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,O=h.length;T<O;T++){const C=h[T];if(C.id===M.data.vscodeScheduleAsyncWork){h.splice(T,1),C.callback();return}}});let o=0;return M=>{const T=++o;h.push({id:T,callback:M}),t.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return h=>setTimeout(h)})();var d;(function(h){h[h.Windows=1]="Windows",h[h.Macintosh=2]="Macintosh",h[h.Linux=3]="Linux"})(d=t.OperatingSystem||(t.OperatingSystem={})),t.OS=i||A?2:S?1:3;let c=!0,p=!1;function v(){if(!p){p=!0;const h=new Uint8Array(2);h[0]=1,h[1]=2,c=new Uint16Array(h.buffer)[0]===(2<<8)+1}return c}t.isLittleEndian=v,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),Q(Z[43],K([0,1,5]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let S;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const i=D.globals.vscode.process;S={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?S={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:S={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=S.cwd,t.env=S.env,t.platform=S.platform,t.arch=S.arch}),Q(Z[44],K([0,1,43]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const S=65,i=97,u=90,_=122,b=46,a=47,f=92,A=58,R=63;class N extends Error{constructor(s,d,c){let p;typeof d=="string"&&d.indexOf("not ")===0?(p="must not be",d=d.replace(/^not /,"")):p="must be";const v=s.indexOf(".")!==-1?"property":"argument";let h=`The "${s}" ${v} ${p} of type ${d}`;h+=`. Received type ${typeof c}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function L(r,s){if(r===null||typeof r!="object")throw new N(s,"Object",r)}function e(r,s){if(typeof r!="string")throw new N(s,"string",r)}const E=D.platform==="win32";function F(r){return r===a||r===f}function y(r){return r===a}function w(r){return r>=S&&r<=u||r>=i&&r<=_}function g(r,s,d,c){let p="",v=0,h=-1,o=0,M=0;for(let T=0;T<=r.length;++T){if(T<r.length)M=r.charCodeAt(T);else{if(c(M))break;M=a}if(c(M)){if(!(h===T-1||o===1))if(o===2){if(p.length<2||v!==2||p.charCodeAt(p.length-1)!==b||p.charCodeAt(p.length-2)!==b){if(p.length>2){const O=p.lastIndexOf(d);O===-1?(p="",v=0):(p=p.slice(0,O),v=p.length-1-p.lastIndexOf(d)),h=T,o=0;continue}else if(p.length!==0){p="",v=0,h=T,o=0;continue}}s&&(p+=p.length>0?`${d}..`:"..",v=2)}else p.length>0?p+=`${d}${r.slice(h+1,T)}`:p=r.slice(h+1,T),v=T-h-1;h=T,o=0}else M===b&&o!==-1?++o:o=-1}return p}function m(r,s){L(s,"pathObject");const d=s.dir||s.root,c=s.base||`${s.name||""}${s.ext||""}`;return d?d===s.root?`${d}${c}`:`${d}${r}${c}`:c}t.win32={resolve(...r){let s="",d="",c=!1;for(let p=r.length-1;p>=-1;p--){let v;if(p>=0){if(v=r[p],e(v,"path"),v.length===0)continue}else s.length===0?v=D.cwd():(v=D.env[`=${s}`]||D.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==s.toLowerCase()&&v.charCodeAt(2)===f)&&(v=`${s}\\`));const h=v.length;let o=0,M="",T=!1;const O=v.charCodeAt(0);if(h===1)F(O)&&(o=1,T=!0);else if(F(O))if(T=!0,F(v.charCodeAt(1))){let C=2,H=C;for(;C<h&&!F(v.charCodeAt(C));)C++;if(C<h&&C!==H){const z=v.slice(H,C);for(H=C;C<h&&F(v.charCodeAt(C));)C++;if(C<h&&C!==H){for(H=C;C<h&&!F(v.charCodeAt(C));)C++;(C===h||C!==H)&&(M=`\\\\${z}\\${v.slice(H,C)}`,o=C)}}}else o=1;else w(O)&&v.charCodeAt(1)===A&&(M=v.slice(0,2),o=2,h>2&&F(v.charCodeAt(2))&&(T=!0,o=3));if(M.length>0)if(s.length>0){if(M.toLowerCase()!==s.toLowerCase())continue}else s=M;if(c){if(s.length>0)break}else if(d=`${v.slice(o)}\\${d}`,c=T,T&&s.length>0)break}return d=g(d,!c,"\\",F),c?`${s}\\${d}`:`${s}${d}`||"."},normalize(r){e(r,"path");const s=r.length;if(s===0)return".";let d=0,c,p=!1;const v=r.charCodeAt(0);if(s===1)return y(v)?"\\":r;if(F(v))if(p=!0,F(r.charCodeAt(1))){let o=2,M=o;for(;o<s&&!F(r.charCodeAt(o));)o++;if(o<s&&o!==M){const T=r.slice(M,o);for(M=o;o<s&&F(r.charCodeAt(o));)o++;if(o<s&&o!==M){for(M=o;o<s&&!F(r.charCodeAt(o));)o++;if(o===s)return`\\\\${T}\\${r.slice(M)}\\`;o!==M&&(c=`\\\\${T}\\${r.slice(M,o)}`,d=o)}}}else d=1;else w(v)&&r.charCodeAt(1)===A&&(c=r.slice(0,2),d=2,s>2&&F(r.charCodeAt(2))&&(p=!0,d=3));let h=d<s?g(r.slice(d),!p,"\\",F):"";return h.length===0&&!p&&(h="."),h.length>0&&F(r.charCodeAt(s-1))&&(h+="\\"),c===void 0?p?`\\${h}`:h:p?`${c}\\${h}`:`${c}${h}`},isAbsolute(r){e(r,"path");const s=r.length;if(s===0)return!1;const d=r.charCodeAt(0);return F(d)||s>2&&w(d)&&r.charCodeAt(1)===A&&F(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let s,d;for(let v=0;v<r.length;++v){const h=r[v];e(h,"path"),h.length>0&&(s===void 0?s=d=h:s+=`\\${h}`)}if(s===void 0)return".";let c=!0,p=0;if(typeof d=="string"&&F(d.charCodeAt(0))){++p;const v=d.length;v>1&&F(d.charCodeAt(1))&&(++p,v>2&&(F(d.charCodeAt(2))?++p:c=!1))}if(c){for(;p<s.length&&F(s.charCodeAt(p));)p++;p>=2&&(s=`\\${s.slice(p)}`)}return t.win32.normalize(s)},relative(r,s){if(e(r,"from"),e(s,"to"),r===s)return"";const d=t.win32.resolve(r),c=t.win32.resolve(s);if(d===c||(r=d.toLowerCase(),s=c.toLowerCase(),r===s))return"";let p=0;for(;p<r.length&&r.charCodeAt(p)===f;)p++;let v=r.length;for(;v-1>p&&r.charCodeAt(v-1)===f;)v--;const h=v-p;let o=0;for(;o<s.length&&s.charCodeAt(o)===f;)o++;let M=s.length;for(;M-1>o&&s.charCodeAt(M-1)===f;)M--;const T=M-o,O=h<T?h:T;let C=-1,H=0;for(;H<O;H++){const ee=r.charCodeAt(p+H);if(ee!==s.charCodeAt(o+H))break;ee===f&&(C=H)}if(H!==O){if(C===-1)return c}else{if(T>O){if(s.charCodeAt(o+H)===f)return c.slice(o+H+1);if(H===2)return c.slice(o+H)}h>O&&(r.charCodeAt(p+H)===f?C=H:H===2&&(C=3)),C===-1&&(C=0)}let z="";for(H=p+C+1;H<=v;++H)(H===v||r.charCodeAt(H)===f)&&(z+=z.length===0?"..":"\\..");return o+=C,z.length>0?`${z}${c.slice(o,M)}`:(c.charCodeAt(o)===f&&++o,c.slice(o,M))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const s=t.win32.resolve(r);if(s.length<=2)return r;if(s.charCodeAt(0)===f){if(s.charCodeAt(1)===f){const d=s.charCodeAt(2);if(d!==R&&d!==b)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(w(s.charCodeAt(0))&&s.charCodeAt(1)===A&&s.charCodeAt(2)===f)return`\\\\?\\${s}`;return r},dirname(r){e(r,"path");const s=r.length;if(s===0)return".";let d=-1,c=0;const p=r.charCodeAt(0);if(s===1)return F(p)?r:".";if(F(p)){if(d=c=1,F(r.charCodeAt(1))){let o=2,M=o;for(;o<s&&!F(r.charCodeAt(o));)o++;if(o<s&&o!==M){for(M=o;o<s&&F(r.charCodeAt(o));)o++;if(o<s&&o!==M){for(M=o;o<s&&!F(r.charCodeAt(o));)o++;if(o===s)return r;o!==M&&(d=c=o+1)}}}}else w(p)&&r.charCodeAt(1)===A&&(d=s>2&&F(r.charCodeAt(2))?3:2,c=d);let v=-1,h=!0;for(let o=s-1;o>=c;--o)if(F(r.charCodeAt(o))){if(!h){v=o;break}}else h=!1;if(v===-1){if(d===-1)return".";v=d}return r.slice(0,v)},basename(r,s){s!==void 0&&e(s,"ext"),e(r,"path");let d=0,c=-1,p=!0,v;if(r.length>=2&&w(r.charCodeAt(0))&&r.charCodeAt(1)===A&&(d=2),s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let h=s.length-1,o=-1;for(v=r.length-1;v>=d;--v){const M=r.charCodeAt(v);if(F(M)){if(!p){d=v+1;break}}else o===-1&&(p=!1,o=v+1),h>=0&&(M===s.charCodeAt(h)?--h===-1&&(c=v):(h=-1,c=o))}return d===c?c=o:c===-1&&(c=r.length),r.slice(d,c)}for(v=r.length-1;v>=d;--v)if(F(r.charCodeAt(v))){if(!p){d=v+1;break}}else c===-1&&(p=!1,c=v+1);return c===-1?"":r.slice(d,c)},extname(r){e(r,"path");let s=0,d=-1,c=0,p=-1,v=!0,h=0;r.length>=2&&r.charCodeAt(1)===A&&w(r.charCodeAt(0))&&(s=c=2);for(let o=r.length-1;o>=s;--o){const M=r.charCodeAt(o);if(F(M)){if(!v){c=o+1;break}continue}p===-1&&(v=!1,p=o+1),M===b?d===-1?d=o:h!==1&&(h=1):d!==-1&&(h=-1)}return d===-1||p===-1||h===0||h===1&&d===p-1&&d===c+1?"":r.slice(d,p)},format:m.bind(null,"\\"),parse(r){e(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const d=r.length;let c=0,p=r.charCodeAt(0);if(d===1)return F(p)?(s.root=s.dir=r,s):(s.base=s.name=r,s);if(F(p)){if(c=1,F(r.charCodeAt(1))){let C=2,H=C;for(;C<d&&!F(r.charCodeAt(C));)C++;if(C<d&&C!==H){for(H=C;C<d&&F(r.charCodeAt(C));)C++;if(C<d&&C!==H){for(H=C;C<d&&!F(r.charCodeAt(C));)C++;C===d?c=C:C!==H&&(c=C+1)}}}}else if(w(p)&&r.charCodeAt(1)===A){if(d<=2)return s.root=s.dir=r,s;if(c=2,F(r.charCodeAt(2))){if(d===3)return s.root=s.dir=r,s;c=3}}c>0&&(s.root=r.slice(0,c));let v=-1,h=c,o=-1,M=!0,T=r.length-1,O=0;for(;T>=c;--T){if(p=r.charCodeAt(T),F(p)){if(!M){h=T+1;break}continue}o===-1&&(M=!1,o=T+1),p===b?v===-1?v=T:O!==1&&(O=1):v!==-1&&(O=-1)}return o!==-1&&(v===-1||O===0||O===1&&v===o-1&&v===h+1?s.base=s.name=r.slice(h,o):(s.name=r.slice(h,v),s.base=r.slice(h,o),s.ext=r.slice(v,o))),h>0&&h!==c?s.dir=r.slice(0,h-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(E){const r=/\\/g;return()=>{const s=D.cwd().replace(r,"/");return s.slice(s.indexOf("/"))}}return()=>D.cwd()})();t.posix={resolve(...r){let s="",d=!1;for(let c=r.length-1;c>=-1&&!d;c--){const p=c>=0?r[c]:l();e(p,"path"),p.length!==0&&(s=`${p}/${s}`,d=p.charCodeAt(0)===a)}return s=g(s,!d,"/",y),d?`/${s}`:s.length>0?s:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===a,d=r.charCodeAt(r.length-1)===a;return r=g(r,!s,"/",y),r.length===0?s?"/":d?"./":".":(d&&(r+="/"),s?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===a},join(...r){if(r.length===0)return".";let s;for(let d=0;d<r.length;++d){const c=r[d];e(c,"path"),c.length>0&&(s===void 0?s=c:s+=`/${c}`)}return s===void 0?".":t.posix.normalize(s)},relative(r,s){if(e(r,"from"),e(s,"to"),r===s||(r=t.posix.resolve(r),s=t.posix.resolve(s),r===s))return"";const d=1,c=r.length,p=c-d,v=1,h=s.length-v,o=p<h?p:h;let M=-1,T=0;for(;T<o;T++){const C=r.charCodeAt(d+T);if(C!==s.charCodeAt(v+T))break;C===a&&(M=T)}if(T===o)if(h>o){if(s.charCodeAt(v+T)===a)return s.slice(v+T+1);if(T===0)return s.slice(v+T)}else p>o&&(r.charCodeAt(d+T)===a?M=T:T===0&&(M=0));let O="";for(T=d+M+1;T<=c;++T)(T===c||r.charCodeAt(T)===a)&&(O+=O.length===0?"..":"/..");return`${O}${s.slice(v+M)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===a;let d=-1,c=!0;for(let p=r.length-1;p>=1;--p)if(r.charCodeAt(p)===a){if(!c){d=p;break}}else c=!1;return d===-1?s?"/":".":s&&d===1?"//":r.slice(0,d)},basename(r,s){s!==void 0&&e(s,"ext"),e(r,"path");let d=0,c=-1,p=!0,v;if(s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let h=s.length-1,o=-1;for(v=r.length-1;v>=0;--v){const M=r.charCodeAt(v);if(M===a){if(!p){d=v+1;break}}else o===-1&&(p=!1,o=v+1),h>=0&&(M===s.charCodeAt(h)?--h===-1&&(c=v):(h=-1,c=o))}return d===c?c=o:c===-1&&(c=r.length),r.slice(d,c)}for(v=r.length-1;v>=0;--v)if(r.charCodeAt(v)===a){if(!p){d=v+1;break}}else c===-1&&(p=!1,c=v+1);return c===-1?"":r.slice(d,c)},extname(r){e(r,"path");let s=-1,d=0,c=-1,p=!0,v=0;for(let h=r.length-1;h>=0;--h){const o=r.charCodeAt(h);if(o===a){if(!p){d=h+1;break}continue}c===-1&&(p=!1,c=h+1),o===b?s===-1?s=h:v!==1&&(v=1):s!==-1&&(v=-1)}return s===-1||c===-1||v===0||v===1&&s===c-1&&s===d+1?"":r.slice(s,c)},format:m.bind(null,"/"),parse(r){e(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const d=r.charCodeAt(0)===a;let c;d?(s.root="/",c=1):c=0;let p=-1,v=0,h=-1,o=!0,M=r.length-1,T=0;for(;M>=c;--M){const O=r.charCodeAt(M);if(O===a){if(!o){v=M+1;break}continue}h===-1&&(o=!1,h=M+1),O===b?p===-1?p=M:T!==1&&(T=1):p!==-1&&(T=-1)}if(h!==-1){const O=v===0&&d?1:v;p===-1||T===0||T===1&&p===h-1&&p===v+1?s.base=s.name=r.slice(O,h):(s.name=r.slice(O,p),s.base=r.slice(O,h),s.ext=r.slice(p,h))}return v>0?s.dir=r.slice(0,v-1):d&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=E?t.win32.normalize:t.posix.normalize,t.isAbsolute=E?t.win32.isAbsolute:t.posix.isAbsolute,t.join=E?t.win32.join:t.posix.join,t.resolve=E?t.win32.resolve:t.posix.resolve,t.relative=E?t.win32.relative:t.posix.relative,t.dirname=E?t.win32.dirname:t.posix.dirname,t.basename=E?t.win32.basename:t.posix.basename,t.extname=E?t.win32.extname:t.posix.extname,t.format=E?t.win32.format:t.posix.format,t.parse=E?t.win32.parse:t.posix.parse,t.toNamespacedPath=E?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=E?t.win32.sep:t.posix.sep,t.delimiter=E?t.win32.delimiter:t.posix.delimiter}),Q(Z[21],K([0,1,5]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const S=D.globals.performance&&typeof D.globals.performance.now=="function";class i{static create(_=!0){return new i(_)}constructor(_){this.a=S&&_,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?D.globals.performance.now():Date.now()}}t.StopWatch=i}),Q(Z[9],K([0,1,6,13,7,15,21]),function(W,t,D,S,i,u,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const b=!1,a=!1;var f;(function(v){v.None=()=>i.Disposable.None;function h(te){if(a){const{onDidAddListener:G}=te,X=e.create();let k=0;te.onDidAddListener=()=>{++k===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),X.print()),G?.()}}}function o(te,G){return Y(te,()=>{},0,void 0,!0,void 0,G)}v.defer=o;function M(te){return(G,X=null,k)=>{let I=!1,U;return U=te(q=>{if(!I)return U?U.dispose():I=!0,G.call(X,q)},null,k),I&&U.dispose(),U}}v.once=M;function T(te,G,X){return ne((k,I=null,U)=>te(q=>k.call(I,G(q)),null,U),X)}v.map=T;function O(te,G,X){return ne((k,I=null,U)=>te(q=>{G(q),k.call(I,q)},null,U),X)}v.forEach=O;function C(te,G,X){return ne((k,I=null,U)=>te(q=>G(q)&&k.call(I,q),null,U),X)}v.filter=C;function H(te){return te}v.signal=H;function z(...te){return(G,X=null,k)=>(0,i.combinedDisposable)(...te.map(I=>I(U=>G.call(X,U),null,k)))}v.any=z;function ee(te,G,X,k){let I=X;return T(te,U=>(I=G(I,U),I),k)}v.reduce=ee;function ne(te,G){let X;const k={onWillAddFirstListener(){X=te(I.fire,I)},onDidRemoveLastListener(){X?.dispose()}};G||h(k);const I=new F(k);return G?.add(I),I.event}function Y(te,G,X=100,k=!1,I=!1,U,q){let j,ie,re,ae=0,le;const fe={leakWarningThreshold:U,onWillAddFirstListener(){j=te(ke=>{ae++,ie=G(ie,ke),k&&!re&&(he.fire(ie),ie=void 0),le=()=>{const Te=ie;ie=void 0,re=void 0,(!k||ae>1)&&he.fire(Te),ae=0},typeof X=="number"?(clearTimeout(re),re=setTimeout(le,X)):re===void 0&&(re=0,queueMicrotask(le))})},onWillRemoveListener(){I&&ae>0&&le?.()},onDidRemoveLastListener(){le=void 0,j.dispose()}};q||h(fe);const he=new F(fe);return q?.add(he),he.event}v.debounce=Y;function J(te,G=0,X){return v.debounce(te,(k,I)=>k?(k.push(I),k):[I],G,void 0,!0,void 0,X)}v.accumulate=J;function n(te,G=(k,I)=>k===I,X){let k=!0,I;return C(te,U=>{const q=k||!G(U,I);return k=!1,I=U,q},X)}v.latch=n;function Le(te,G,X){return[v.filter(te,G,X),v.filter(te,k=>!G(k),X)]}v.split=Le;function Ae(te,G=!1,X=[]){let k=X.slice(),I=te(j=>{k?k.push(j):q.fire(j)});const U=()=>{k?.forEach(j=>q.fire(j)),k=null},q=new F({onWillAddFirstListener(){I||(I=te(j=>q.fire(j)))},onDidAddFirstListener(){k&&(G?setTimeout(U):U())},onDidRemoveLastListener(){I&&I.dispose(),I=null}});return q.event}v.buffer=Ae;class de{constructor(G){this.event=G,this.c=new i.DisposableStore}map(G){return new de(T(this.event,G,this.c))}forEach(G){return new de(O(this.event,G,this.c))}filter(G){return new de(C(this.event,G,this.c))}reduce(G,X){return new de(ee(this.event,G,X,this.c))}latch(){return new de(n(this.event,void 0,this.c))}debounce(G,X=100,k=!1,I=!1,U){return new de(Y(this.event,G,X,k,I,U,this.c))}on(G,X,k){return this.event(G,X,k)}once(G,X,k){return M(this.event)(G,X,k)}dispose(){this.c.dispose()}}function Ee(te){return new de(te)}v.chain=Ee;function we(te,G,X=k=>k){const k=(...j)=>q.fire(X(...j)),I=()=>te.on(G,k),U=()=>te.removeListener(G,k),q=new F({onWillAddFirstListener:I,onDidRemoveLastListener:U});return q.event}v.fromNodeEventEmitter=we;function Ne(te,G,X=k=>k){const k=(...j)=>q.fire(X(...j)),I=()=>te.addEventListener(G,k),U=()=>te.removeEventListener(G,k),q=new F({onWillAddFirstListener:I,onDidRemoveLastListener:U});return q.event}v.fromDOMEventEmitter=Ne;function Re(te){return new Promise(G=>M(te)(G))}v.toPromise=Re;function De(te,G){return G(void 0),te(X=>G(X))}v.runAndSubscribe=De;function Fe(te,G){let X=null;function k(U){X?.dispose(),X=new i.DisposableStore,G(U,X)}k(void 0);const I=te(U=>k(U));return(0,i.toDisposable)(()=>{I.dispose(),X?.dispose()})}v.runAndSubscribeWithStore=Fe;class ye{constructor(G,X){this.obs=G,this.c=0,this.d=!1;const k={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};X||h(k),this.emitter=new F(k),X&&X.add(this.emitter)}beginUpdate(G){this.c++}handleChange(G,X){this.d=!0}endUpdate(G){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function Pe(te,G){return new ye(te,G).emitter.event}v.fromObservable=Pe})(f=t.Event||(t.Event={}));class A{constructor(h){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${h}_${A.c++}`,A.all.add(this)}start(h){this.d=new _.StopWatch(!0),this.listenerCount=h}stop(){if(this.d){const h=this.d.elapsed();this.durations.push(h),this.elapsedOverall+=h,this.invocationCount+=1,this.d=void 0}}}A.all=new Set,A.c=0,t.EventProfiling=A;let R=-1;function N(v){const h=R;return R=v,{dispose(){R=h}}}t.setGlobalLeakWarningThreshold=N;class L{constructor(h,o=Math.random().toString(18).slice(2,5)){this.threshold=h,this.name=o,this.d=0}dispose(){this.c?.clear()}check(h,o){const M=this.threshold;if(M<=0||o<M)return;this.c||(this.c=new Map);const T=this.c.get(h.value)||0;if(this.c.set(h.value,T+1),this.d-=1,this.d<=0){this.d=M*.5;let O,C=0;for(const[H,z]of this.c)(!O||C<z)&&(O=H,C=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${C}):`),console.warn(O)}return()=>{const O=this.c.get(h.value)||0;this.c.set(h.value,O-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(h){this.value=h}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(h,o,M){this.callback=h,this.callbackThis=o,this.stack=M,this.subscription=new i.SafeDisposable}invoke(h){this.callback.call(this.callbackThis,h)}}class F{constructor(h){this.j=!1,this.d=h,this.f=R>0||this.d?.leakWarningThreshold?new L(this.d?.leakWarningThreshold??R):void 0,this.g=this.d?._profName?new A(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(b){const h=Array.from(this.q);queueMicrotask(()=>{for(const o of h)o.subscription.isset()&&(o.subscription.unset(),o.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(h,o,M)=>{if(this.q||(this.q=new u.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const T=this.q.isEmpty();T&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,C;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(C=e.create(),O=this.f.check(C,this.q.size+1)),b&&(C=C??e.create());const H=new E(h,o,C),z=this.q.push(H);T&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,h,o);const ee=H.subscription.set(()=>{O?.(),this.j||(this.d?.onWillRemoveListener?.(this),z(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return M instanceof i.DisposableStore?M.add(ee):Array.isArray(M)&&M.push(ee),ee}),this.l}fire(h){if(this.q){this.m||(this.m=new w);for(const o of this.q)this.m.push(this,o,h);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=F;class y{constructor(){this.c=new u.LinkedList}get size(){return this.c.size}push(h,o,M){this.c.push(new g(h,o,M))}clear(h){const o=new u.LinkedList;for(const M of this.c)M.emitter!==h&&o.push(M);this.c=o}deliver(){for(;this.c.size>0;){const h=this.c.shift();try{h.listener.invoke(h.event)}catch(o){(0,D.onUnexpectedError)(o)}}}}t.EventDeliveryQueue=y;class w extends y{clear(h){this.c.clear()}}class g{constructor(h,o,M){this.emitter=h,this.listener=o,this.event=M}}class m extends F{async fireAsync(h,o,M){if(!!this.q){this.c||(this.c=new u.LinkedList);for(const T of this.q)this.c.push([T,h]);for(;this.c.size>0&&!o.isCancellationRequested;){const[T,O]=this.c.shift(),C=[],H={...O,token:o,waitUntil:z=>{if(Object.isFrozen(C))throw new Error("waitUntil can NOT be called asynchronous");M&&(z=M(z,T.callback)),C.push(z)}};try{T.invoke(H)}catch(z){(0,D.onUnexpectedError)(z);continue}Object.freeze(C),await Promise.allSettled(C).then(z=>{for(const ee of z)ee.status==="rejected"&&(0,D.onUnexpectedError)(ee.reason)})}}}}t.AsyncEmitter=m;class l extends F{constructor(h){super(h),this.h=0,this.s=new u.LinkedList,this.t=h?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const h=Array.from(this.s);this.s.clear(),super.fire(this.t(h))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(h){this.q&&(this.h!==0?this.s.push(h):super.fire(h))}}t.PauseableEmitter=l;class r extends l{constructor(h){super(h),this.c=h.delay??100}fire(h){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(h)}}t.DebounceEmitter=r;class s extends F{constructor(h){super(h),this.c=[],this.h=h?.merge}fire(h){!this.hasListeners()||(this.c.push(h),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(o=>super.fire(o)),this.c=[]}))}}t.MicrotaskEmitter=s;class d{constructor(){this.d=!1,this.f=[],this.c=new F({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(h){const o={event:h,listener:null};this.f.push(o),this.d&&this.j(o);const M=()=>{this.d&&this.k(o);const T=this.f.indexOf(o);this.f.splice(T,1)};return(0,i.toDisposable)((0,S.once)(M))}g(){this.d=!0,this.f.forEach(h=>this.j(h))}h(){this.d=!1,this.f.forEach(h=>this.k(h))}j(h){h.listener=h.event(o=>this.c.fire(o))}k(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=d;class c{constructor(){this.c=[]}wrapEvent(h){return(o,M,T)=>h(O=>{const C=this.c[this.c.length-1];C?C.push(()=>o.call(M,O)):o.call(M,O)},void 0,T)}bufferEvents(h){const o=[];this.c.push(o);const M=h();return this.c.pop(),o.forEach(T=>T()),M}}t.EventBufferer=c;class p{constructor(){this.c=!1,this.d=f.None,this.f=i.Disposable.None,this.g=new F({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(h){this.d=h,this.c&&(this.f.dispose(),this.f=h(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=p}),Q(Z[22],K([0,1,9]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const S=Object.freeze(function(b,a){const f=setTimeout(b.bind(a),0);return{dispose(){clearTimeout(f)}}});var i;(function(b){function a(f){return f===b.None||f===b.Cancelled||f instanceof u?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}b.isCancellationToken=a,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:S})})(i=t.CancellationToken||(t.CancellationToken={}));class u{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?S:(this.b||(this.b=new D.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class _{constructor(a){this.a=void 0,this.b=void 0,this.b=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new u),this.a}cancel(){this.a?this.a instanceof u&&this.a.cancel():this.a=i.Cancelled}dispose(a=!1){a&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof u&&this.a.dispose():this.a=i.None}}t.CancellationTokenSource=_}),Q(Z[45],K([0,1,22]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class S{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new D.CancellationTokenSource,a=this.b(b.token);return this.a={promise:a,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}t.Cache=S;class i{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const a=JSON.stringify(b);return this.b!==a&&(this.b=a,this.a=this.c(b)),this.a}}t.LRUCachedFunction=i;class u{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const a=this.b(b);return this.a.set(b,a),a}}t.CachedFunction=u}),Q(Z[4],K([0,1,45,28]),function(W,t,D,S){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function u(P){return!P||typeof P!="string"?!0:P.trim().length===0}t.isFalsyOrWhitespace=u;const _=/{(\d+)}/g;function b(P,...B){return B.length===0?P:P.replace(_,function(V,$){const x=parseInt($,10);return isNaN(x)||x<0||x>=B.length?V:B[x]})}t.format=b;const a=/{([^}]+)}/g;function f(P,B){return P.replace(a,(V,$)=>B[$]??V)}t.format2=f;function A(P){return P.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.escape=A;function R(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=R;function N(P,B){let V=0;const $=B.charCodeAt(0);for(let x=P.length-1;x>=0;x--)P.charCodeAt(x)===$&&V++;return V}t.count=N;function L(P,B,V="\u2026"){return P.length<=B?P:`${P.substr(0,B)}${V}`}t.truncate=L;function e(P,B=" "){const V=E(P,B);return F(V,B)}t.trim=e;function E(P,B){if(!P||!B)return P;const V=B.length;if(V===0||P.length===0)return P;let $=0;for(;P.indexOf(B,$)===$;)$=$+V;return P.substring($)}t.ltrim=E;function F(P,B){if(!P||!B)return P;const V=B.length,$=P.length;if(V===0||$===0)return P;let x=$,se=-1;for(;se=P.lastIndexOf(B,x-1),!(se===-1||se+V!==x);){if(se===0)return"";x=se}return P.substring(0,x)}t.rtrim=F;function y(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=y;function w(P){return P.replace(/\*/g,"")}t.stripWildcards=w;function g(P,B,V={}){if(!P)throw new Error("Cannot create regex from empty string");B||(P=R(P)),V.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let $="";return V.global&&($+="g"),V.matchCase||($+="i"),V.multiline&&($+="m"),V.unicode&&($+="u"),new RegExp(P,$)}t.createRegExp=g;function m(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}t.regExpLeadsToEndlessLoop=m;function l(P){return!!P.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=l;function r(P){return(P.global?"g":"")+(P.ignoreCase?"i":"")+(P.multiline?"m":"")+(P.unicode?"u":"")}t.regExpFlags=r;function s(P){return P.split(/\r\n|\r|\n/)}t.splitLines=s;function d(P){for(let B=0,V=P.length;B<V;B++){const $=P.charCodeAt(B);if($!==32&&$!==9)return B}return-1}t.firstNonWhitespaceIndex=d;function c(P,B=0,V=P.length){for(let $=B;$<V;$++){const x=P.charCodeAt($);if(x!==32&&x!==9)return P.substring(B,$)}return P.substring(B,V)}t.getLeadingWhitespace=c;function p(P,B=P.length-1){for(let V=B;V>=0;V--){const $=P.charCodeAt(V);if($!==32&&$!==9)return V}return-1}t.lastNonWhitespaceIndex=p;function v(P,B,V){const $=[];let x=0;for(const se of P.matchAll(B)){if($.push(P.slice(x,se.index)),se.index===void 0)throw new Error("match.index should be defined");x=se.index+se[0].length,$.push(V(se[0],...se.slice(1),se.index,P,se.groups))}return $.push(P.slice(x)),Promise.all($).then(se=>se.join(""))}t.replaceAsync=v;function h(P,B){return P<B?-1:P>B?1:0}t.compare=h;function o(P,B,V=0,$=P.length,x=0,se=B.length){for(;V<$&&x<se;V++,x++){const be=P.charCodeAt(V),ue=B.charCodeAt(x);if(be<ue)return-1;if(be>ue)return 1}const ce=$-V,_e=se-x;return ce<_e?-1:ce>_e?1:0}t.compareSubstring=o;function M(P,B){return T(P,B,0,P.length,0,B.length)}t.compareIgnoreCase=M;function T(P,B,V=0,$=P.length,x=0,se=B.length){for(;V<$&&x<se;V++,x++){let be=P.charCodeAt(V),ue=B.charCodeAt(x);if(be===ue)continue;if(be>=128||ue>=128)return o(P.toLowerCase(),B.toLowerCase(),V,$,x,se);C(be)&&(be-=32),C(ue)&&(ue-=32);const ge=be-ue;if(ge!==0)return ge}const ce=$-V,_e=se-x;return ce<_e?-1:ce>_e?1:0}t.compareSubstringIgnoreCase=T;function O(P){return P>=48&&P<=57}t.isAsciiDigit=O;function C(P){return P>=97&&P<=122}t.isLowerAsciiLetter=C;function H(P){return P>=65&&P<=90}t.isUpperAsciiLetter=H;function z(P,B){return P.length===B.length&&T(P,B)===0}t.equalsIgnoreCase=z;function ee(P,B){const V=B.length;return B.length>P.length?!1:T(P,B,0,V)===0}t.startsWithIgnoreCase=ee;function ne(P,B){const V=Math.min(P.length,B.length);let $;for($=0;$<V;$++)if(P.charCodeAt($)!==B.charCodeAt($))return $;return V}t.commonPrefixLength=ne;function Y(P,B){const V=Math.min(P.length,B.length);let $;const x=P.length-1,se=B.length-1;for($=0;$<V;$++)if(P.charCodeAt(x-$)!==B.charCodeAt(se-$))return $;return V}t.commonSuffixLength=Y;function J(P){return 55296<=P&&P<=56319}t.isHighSurrogate=J;function n(P){return 56320<=P&&P<=57343}t.isLowSurrogate=n;function Le(P,B){return(P-55296<<10)+(B-56320)+65536}t.computeCodePoint=Le;function Ae(P,B,V){const $=P.charCodeAt(V);if(J($)&&V+1<B){const x=P.charCodeAt(V+1);if(n(x))return Le($,x)}return $}t.getNextCodePoint=Ae;function de(P,B){const V=P.charCodeAt(B-1);if(n(V)&&B>1){const $=P.charCodeAt(B-2);if(J($))return Le($,V)}return V}class Ee{get offset(){return this.e}constructor(B,V=0){this.c=B,this.d=B.length,this.e=V}setOffset(B){this.e=B}prevCodePoint(){const B=de(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=Ae(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.CodePointIterator=Ee;class we{get offset(){return this.c.offset}constructor(B,V=0){this.c=new Ee(B,V)}nextGraphemeLength(){const B=pe.getInstance(),V=this.c,$=V.offset;let x=B.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const se=V.offset,ce=B.getGraphemeBreakType(V.nextCodePoint());if(Ue(x,ce)){V.setOffset(se);break}x=ce}return V.offset-$}prevGraphemeLength(){const B=pe.getInstance(),V=this.c,$=V.offset;let x=B.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const se=V.offset,ce=B.getGraphemeBreakType(V.prevCodePoint());if(Ue(ce,x)){V.setOffset(se);break}x=ce}return $-V.offset}eol(){return this.c.eol()}}t.GraphemeIterator=we;function Ne(P,B){return new we(P,B).nextGraphemeLength()}t.nextCharLength=Ne;function Re(P,B){return new we(P,B).prevGraphemeLength()}t.prevCharLength=Re;function De(P,B){B>0&&n(P.charCodeAt(B))&&B--;const V=B+Ne(P,B);return[V-Re(P,V),V]}t.getCharContainingOffset=De;function Fe(P){const B=new we(P);let V=0;for(;!B.eol();)V++,B.nextGraphemeLength();return V}t.charCount=Fe;let ye;function Pe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function te(P){return ye||(ye=Pe()),ye.test(P)}t.containsRTL=te;const G=/^[\t\n\r\x20-\x7E]*$/;function X(P){return G.test(P)}t.isBasicASCII=X,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function k(P){return t.UNUSUAL_LINE_TERMINATORS.test(P)}t.containsUnusualLineTerminators=k;function I(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}t.isFullWidthCharacter=I;function U(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}t.isEmojiImprecise=U;function q(P,B){if(P.length<B)return P;const V=/\b/g;let $=0;for(;V.test(P)&&!(P.length-V.lastIndex<B);)$=V.lastIndex,V.lastIndex+=1;return P.substring($).replace(/^\s/,"")}t.lcut=q;const j=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function ie(P){return P&&(P=P.replace(j,"")),P}t.removeAnsiEscapeCodes=ie,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function re(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}t.startsWithUTF8BOM=re;function ae(P){return re(P)?P.substr(1):P}t.stripUTF8BOM=ae;function le(P,B){if(!P||!B||P.length<B.length)return!1;const V=B.length,$=P.toLowerCase();let x=0,se=-1;for(;x<V;){const ce=$.indexOf(B[x],se+1);if(ce<0)return!1;se=ce,x++}return!0}t.fuzzyContains=le;function fe(P,B=!1){return P?(B&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}t.containsUppercaseCharacter=fe;function he(P){return P.charAt(0).toUpperCase()+P.slice(1)}t.uppercaseFirstLetter=he;function ke(P,B=1){if(B===0)return"";let V=-1;do V=P.indexOf(`
`,V+1),B--;while(B>0&&V>=0);return V===-1?P:(P[V-1]==="\r"&&V--,P.substr(0,V))}t.getNLines=ke;function Te(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}t.singleLetterHash=Te;function We(P){return pe.getInstance().getGraphemeBreakType(P)}t.getGraphemeBreakType=We;function Ue(P,B){return P===0?B!==5&&B!==7:P===2&&B===3?!1:P===4||P===2||P===3||B===4||B===2||B===3?!0:!(P===8&&(B===8||B===9||B===11||B===12)||(P===11||P===9)&&(B===9||B===10)||(P===12||P===10)&&B===10||B===5||B===13||B===7||P===1||P===13&&B===14||P===6&&B===6)}var qe;(function(P){P[P.Other=0]="Other",P[P.Prepend=1]="Prepend",P[P.CR=2]="CR",P[P.LF=3]="LF",P[P.Control=4]="Control",P[P.Extend=5]="Extend",P[P.Regional_Indicator=6]="Regional_Indicator",P[P.SpacingMark=7]="SpacingMark",P[P.L=8]="L",P[P.V=9]="V",P[P.T=10]="T",P[P.LV=11]="LV",P[P.LVT=12]="LVT",P[P.ZWJ=13]="ZWJ",P[P.Extended_Pictographic=14]="Extended_Pictographic"})(qe=t.GraphemeBreakType||(t.GraphemeBreakType={}));class pe{static getInstance(){return pe.c||(pe.c=new pe),pe.c}constructor(){this.d=Ve()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const V=this.d,$=V.length/3;let x=1;for(;x<=$;)if(B<V[3*x])x=2*x;else if(B>V[3*x+1])x=2*x+1;else return V[3*x+2];return 0}}pe.c=null;function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(P,B){if(P===0)return 0;const V=je(P,B);if(V!==void 0)return V;const $=new Ee(B,P);return $.prevCodePoint(),$.offset}t.getLeftDeleteOffset=He;function je(P,B){const V=new Ee(B,P);let $=V.prevCodePoint();for(;ze($)||$===65039||$===8419;){if(V.offset===0)return;$=V.prevCodePoint()}if(!U($))return;let x=V.offset;return x>0&&V.prevCodePoint()===8205&&(x=V.offset),x}function ze(P){return 127995<=P&&P<=127999}var Ce;(function(P){P[P.zwj=8205]="zwj",P[P.emojiVariantSelector=65039]="emojiVariantSelector",P[P.enclosingKeyCap=8419]="enclosingKeyCap"})(Ce||(Ce={})),t.noBreakWhitespace="\xA0";class me{static getInstance(B){return me.d.get(Array.from(B))}static getLocales(){return me.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}i=me,me.c=new S.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),me.d=new D.LRUCachedFunction(P=>{function B(ue){const ge=new Map;for(let ve=0;ve<ue.length;ve+=2)ge.set(ue[ve],ue[ve+1]);return ge}function V(ue,ge){const ve=new Map(ue);for(const[Se,Ie]of ge)ve.set(Se,Ie);return ve}function $(ue,ge){if(!ue)return ge;const ve=new Map;for(const[Se,Ie]of ue)ge.has(Se)&&ve.set(Se,Ie);return ve}const x=i.c.value;let se=P.filter(ue=>!ue.startsWith("_")&&ue in x);se.length===0&&(se=["_default"]);let ce;for(const ue of se){const ge=B(x[ue]);ce=$(ce,ge)}const _e=B(x._common),be=V(_e,ce);return new me(be)}),me.e=new S.Lazy(()=>Object.keys(me.c.value).filter(P=>!P.startsWith("_"))),t.AmbiguousCharacters=me;class Me{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Me.c())),this.d}static isInvisibleCharacter(B){return Me.e().has(B)}static get codePoints(){return Me.e()}}Me.d=void 0,t.InvisibleCharacters=Me}),Q(Z[46],K([0,1,4]),function(W,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function S(y){return i(y,0)}t.hash=S;function i(y,w){switch(typeof y){case"object":return y===null?u(349,w):Array.isArray(y)?a(y,w):f(y,w);case"string":return b(y,w);case"boolean":return _(y,w);case"number":return u(y,w);case"undefined":return u(937,w);default:return u(617,w)}}t.doHash=i;function u(y,w){return(w<<5)-w+y|0}t.numberHash=u;function _(y,w){return u(y?433:863,w)}function b(y,w){w=u(149417,w);for(let g=0,m=y.length;g<m;g++)w=u(y.charCodeAt(g),w);return w}t.stringHash=b;function a(y,w){return w=u(104579,w),y.reduce((g,m)=>i(m,g),w)}function f(y,w){return w=u(181387,w),Object.keys(y).sort().reduce((g,m)=>(g=b(m,g),i(y[m],g)),w)}class A{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=i(w,this.g),this.g}}t.Hasher=A;var R;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function N(y,w,g=32){const m=g-w,l=~((1<<m)-1);return(y<<w|(l&y)>>>m)>>>0}function L(y,w=0,g=y.byteLength,m=0){for(let l=0;l<g;l++)y[w+l]=m}function e(y,w,g="0"){for(;y.length<w;)y=g+y;return y}function E(y,w=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(g=>g.toString(16).padStart(2,"0")).join(""):e((y>>>0).toString(16),w/4)}t.toHexString=E;class F{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const g=w.length;if(g===0)return;const m=this.p;let l=this.r,r=this.u,s,d;for(r!==0?(s=r,d=-1,r=0):(s=w.charCodeAt(0),d=0);;){let c=s;if(D.isHighSurrogate(s))if(d+1<g){const p=w.charCodeAt(d+1);D.isLowSurrogate(p)?(d++,c=D.computeCodePoint(s,p)):c=65533}else{r=s;break}else D.isLowSurrogate(s)&&(c=65533);if(l=this.w(m,l,c),d++,d<g)s=w.charCodeAt(d);else break}this.r=l,this.u=r}w(w,g,m){return m<128?w[g++]=m:m<2048?(w[g++]=192|(m&1984)>>>6,w[g++]=128|(m&63)>>>0):m<65536?(w[g++]=224|(m&61440)>>>12,w[g++]=128|(m&4032)>>>6,w[g++]=128|(m&63)>>>0):(w[g++]=240|(m&1835008)>>>18,w[g++]=128|(m&258048)>>>12,w[g++]=128|(m&4032)>>>6,w[g++]=128|(m&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,L(this.p,this.r),this.r>56&&(this.y(),L(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=F.g,g=this.q;for(let h=0;h<64;h+=4)w.setUint32(h,g.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)w.setUint32(h,N(w.getUint32(h-12,!1)^w.getUint32(h-32,!1)^w.getUint32(h-56,!1)^w.getUint32(h-64,!1),1),!1);let m=this.h,l=this.l,r=this.m,s=this.n,d=this.o,c,p,v;for(let h=0;h<80;h++)h<20?(c=l&r|~l&s,p=1518500249):h<40?(c=l^r^s,p=1859775393):h<60?(c=l&r|l&s|r&s,p=2400959708):(c=l^r^s,p=3395469782),v=N(m,5)+c+d+p+w.getUint32(h*4,!1)&4294967295,d=s,s=r,r=N(l,30),l=m,m=v;this.h=this.h+m&4294967295,this.l=this.l+l&4294967295,this.m=this.m+r&4294967295,this.n=this.n+s&4294967295,this.o=this.o+d&4294967295}}F.g=new DataView(new ArrayBuffer(320)),t.StringSHA1=F}),Q(Z[23],K([0,1,25,46]),function(W,t,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(N){this.a=N}getElements(){const N=this.a,L=new Int32Array(N.length);for(let e=0,E=N.length;e<E;e++)L[e]=N.charCodeAt(e);return L}}t.StringDiffSequence=i;function u(R,N,L){return new A(new i(R),new i(N)).ComputeDiff(L).changes}t.stringDiff=u;class _{static Assert(N,L){if(!N)throw new Error(L)}}class b{static Copy(N,L,e,E,F){for(let y=0;y<F;y++)e[E+y]=N[L+y]}static Copy2(N,L,e,E,F){for(let y=0;y<F;y++)e[E+y]=N[L+y]}}var a;(function(R){R[R.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class f{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new D.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(N,L){this.b=Math.min(this.b,N),this.c=Math.min(this.c,L),this.d++}AddModifiedElement(N,L){this.b=Math.min(this.b,N),this.c=Math.min(this.c,L),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class A{constructor(N,L,e=null){this.a=e,this.b=N,this.c=L;const[E,F,y]=A.o(N),[w,g,m]=A.o(L);this.d=y&&m,this.e=E,this.f=F,this.g=w,this.h=g,this.k=[],this.m=[]}static n(N){return N.length>0&&typeof N[0]=="string"}static o(N){const L=N.getElements();if(A.n(L)){const e=new Int32Array(L.length);for(let E=0,F=L.length;E<F;E++)e[E]=(0,S.stringHash)(L[E],0);return[L,e,!0]}return L instanceof Int32Array?[[],L,!1]:[[],new Int32Array(L),!1]}p(N,L){return this.f[N]!==this.h[L]?!1:this.d?this.e[N]===this.g[L]:!0}q(N,L){if(!this.p(N,L))return!1;const e=A.r(this.b,N),E=A.r(this.c,L);return e===E}static r(N,L){return typeof N.getStrictElement=="function"?N.getStrictElement(L):null}s(N,L){return this.f[N]!==this.f[L]?!1:this.d?this.e[N]===this.e[L]:!0}u(N,L){return this.h[N]!==this.h[L]?!1:this.d?this.g[N]===this.g[L]:!0}ComputeDiff(N){return this.v(0,this.f.length-1,0,this.h.length-1,N)}v(N,L,e,E,F){const y=[!1];let w=this.w(N,L,e,E,y);return F&&(w=this.z(w)),{quitEarly:y[0],changes:w}}w(N,L,e,E,F){for(F[0]=!1;N<=L&&e<=E&&this.p(N,e);)N++,e++;for(;L>=N&&E>=e&&this.p(L,E);)L--,E--;if(N>L||e>E){let r;return e<=E?(_.Assert(N===L+1,"originalStart should only be one more than originalEnd"),r=[new D.DiffChange(N,0,e,E-e+1)]):N<=L?(_.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),r=[new D.DiffChange(N,L-N+1,e,0)]):(_.Assert(N===L+1,"originalStart should only be one more than originalEnd"),_.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const y=[0],w=[0],g=this.y(N,L,e,E,y,w,F),m=y[0],l=w[0];if(g!==null)return g;if(!F[0]){const r=this.w(N,m,e,l,F);let s=[];return F[0]?s=[new D.DiffChange(m+1,L-(m+1)+1,l+1,E-(l+1)+1)]:s=this.w(m+1,L,l+1,E,F),this.H(r,s)}return[new D.DiffChange(N,L-N+1,e,E-e+1)]}x(N,L,e,E,F,y,w,g,m,l,r,s,d,c,p,v,h,o){let M=null,T=null,O=new f,C=L,H=e,z=d[0]-v[0]-E,ee=-1073741824,ne=this.k.length-1;do{const Y=z+N;Y===C||Y<H&&m[Y-1]<m[Y+1]?(r=m[Y+1],c=r-z-E,r<ee&&O.MarkNextChange(),ee=r,O.AddModifiedElement(r+1,c),z=Y+1-N):(r=m[Y-1]+1,c=r-z-E,r<ee&&O.MarkNextChange(),ee=r-1,O.AddOriginalElement(r,c+1),z=Y-1-N),ne>=0&&(m=this.k[ne],N=m[0],C=1,H=m.length-1)}while(--ne>=-1);if(M=O.getReverseChanges(),o[0]){let Y=d[0]+1,J=v[0]+1;if(M!==null&&M.length>0){const n=M[M.length-1];Y=Math.max(Y,n.getOriginalEnd()),J=Math.max(J,n.getModifiedEnd())}T=[new D.DiffChange(Y,s-Y+1,J,p-J+1)]}else{O=new f,C=y,H=w,z=d[0]-v[0]-g,ee=1073741824,ne=h?this.m.length-1:this.m.length-2;do{const Y=z+F;Y===C||Y<H&&l[Y-1]>=l[Y+1]?(r=l[Y+1]-1,c=r-z-g,r>ee&&O.MarkNextChange(),ee=r+1,O.AddOriginalElement(r+1,c+1),z=Y+1-F):(r=l[Y-1],c=r-z-g,r>ee&&O.MarkNextChange(),ee=r,O.AddModifiedElement(r+1,c+1),z=Y-1-F),ne>=0&&(l=this.m[ne],F=l[0],C=1,H=l.length-1)}while(--ne>=-1);T=O.getChanges()}return this.H(M,T)}y(N,L,e,E,F,y,w){let g=0,m=0,l=0,r=0,s=0,d=0;N--,e--,F[0]=0,y[0]=0,this.k=[],this.m=[];const c=L-N+(E-e),p=c+1,v=new Int32Array(p),h=new Int32Array(p),o=E-e,M=L-N,T=N-e,O=L-E,H=(M-o)%2===0;v[o]=N,h[M]=L,w[0]=!1;for(let z=1;z<=c/2+1;z++){let ee=0,ne=0;l=this.J(o-z,z,o,p),r=this.J(o+z,z,o,p);for(let J=l;J<=r;J+=2){J===l||J<r&&v[J-1]<v[J+1]?g=v[J+1]:g=v[J-1]+1,m=g-(J-o)-T;const n=g;for(;g<L&&m<E&&this.p(g+1,m+1);)g++,m++;if(v[J]=g,g+m>ee+ne&&(ee=g,ne=m),!H&&Math.abs(J-M)<=z-1&&g>=h[J])return F[0]=g,y[0]=m,n<=h[J]&&1447>0&&z<=1447+1?this.x(o,l,r,T,M,s,d,O,v,h,g,L,F,m,E,y,H,w):null}const Y=(ee-N+(ne-e)-z)/2;if(this.a!==null&&!this.a(ee,Y))return w[0]=!0,F[0]=ee,y[0]=ne,Y>0&&1447>0&&z<=1447+1?this.x(o,l,r,T,M,s,d,O,v,h,g,L,F,m,E,y,H,w):(N++,e++,[new D.DiffChange(N,L-N+1,e,E-e+1)]);s=this.J(M-z,z,M,p),d=this.J(M+z,z,M,p);for(let J=s;J<=d;J+=2){J===s||J<d&&h[J-1]>=h[J+1]?g=h[J+1]-1:g=h[J-1],m=g-(J-M)-O;const n=g;for(;g>N&&m>e&&this.p(g,m);)g--,m--;if(h[J]=g,H&&Math.abs(J-o)<=z&&g<=v[J])return F[0]=g,y[0]=m,n>=v[J]&&1447>0&&z<=1447+1?this.x(o,l,r,T,M,s,d,O,v,h,g,L,F,m,E,y,H,w):null}if(z<=1447){let J=new Int32Array(r-l+2);J[0]=o-l+1,b.Copy2(v,l,J,1,r-l+1),this.k.push(J),J=new Int32Array(d-s+2),J[0]=M-s+1,b.Copy2(h,s,J,1,d-s+1),this.m.push(J)}}return this.x(o,l,r,T,M,s,d,O,v,h,g,L,F,m,E,y,H,w)}z(N){for(let L=0;L<N.length;L++){const e=N[L],E=L<N.length-1?N[L+1].originalStart:this.f.length,F=L<N.length-1?N[L+1].modifiedStart:this.h.length,y=e.originalLength>0,w=e.modifiedLength>0;for(;e.originalStart+e.originalLength<E&&e.modifiedStart+e.modifiedLength<F&&(!y||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!w||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const m=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!m)break;e.originalStart++,e.modifiedStart++}const g=[null];if(L<N.length-1&&this.I(N[L],N[L+1],g)){N[L]=g[0],N.splice(L+1,1),L--;continue}}for(let L=N.length-1;L>=0;L--){const e=N[L];let E=0,F=0;if(L>0){const r=N[L-1];E=r.originalStart+r.originalLength,F=r.modifiedStart+r.modifiedLength}const y=e.originalLength>0,w=e.modifiedLength>0;let g=0,m=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const s=e.originalStart-r,d=e.modifiedStart-r;if(s<E||d<F||y&&!this.s(s,s+e.originalLength)||w&&!this.u(d,d+e.modifiedLength))break;const p=(s===E&&d===F?5:0)+this.G(s,e.originalLength,d,e.modifiedLength);p>m&&(m=p,g=r)}e.originalStart-=g,e.modifiedStart-=g;const l=[null];if(L>0&&this.I(N[L-1],N[L],l)){N[L-1]=l[0],N.splice(L,1),L++;continue}}if(this.d)for(let L=1,e=N.length;L<e;L++){const E=N[L-1],F=N[L],y=F.originalStart-E.originalStart-E.originalLength,w=E.originalStart,g=F.originalStart+F.originalLength,m=g-w,l=E.modifiedStart,r=F.modifiedStart+F.modifiedLength,s=r-l;if(y<5&&m<20&&s<20){const d=this.A(w,m,l,s,y);if(d){const[c,p]=d;(c!==E.originalStart+E.originalLength||p!==E.modifiedStart+E.modifiedLength)&&(E.originalLength=c-E.originalStart,E.modifiedLength=p-E.modifiedStart,F.originalStart=c+y,F.modifiedStart=p+y,F.originalLength=g-F.originalStart,F.modifiedLength=r-F.modifiedStart)}}}return N}A(N,L,e,E,F){if(L<F||E<F)return null;const y=N+L-F+1,w=e+E-F+1;let g=0,m=0,l=0;for(let r=N;r<y;r++)for(let s=e;s<w;s++){const d=this.B(r,s,F);d>0&&d>g&&(g=d,m=r,l=s)}return g>0?[m,l]:null}B(N,L,e){let E=0;for(let F=0;F<e;F++){if(!this.p(N+F,L+F))return 0;E+=this.e[N+F].length}return E}C(N){return N<=0||N>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[N])}D(N,L){if(this.C(N)||this.C(N-1))return!0;if(L>0){const e=N+L;if(this.C(e-1)||this.C(e))return!0}return!1}E(N){return N<=0||N>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[N])}F(N,L){if(this.E(N)||this.E(N-1))return!0;if(L>0){const e=N+L;if(this.E(e-1)||this.E(e))return!0}return!1}G(N,L,e,E){const F=this.D(N,L)?1:0,y=this.F(e,E)?1:0;return F+y}H(N,L){const e=[];if(N.length===0||L.length===0)return L.length>0?L:N;if(this.I(N[N.length-1],L[0],e)){const E=new Array(N.length+L.length-1);return b.Copy(N,0,E,0,N.length-1),E[N.length-1]=e[0],b.Copy(L,1,E,N.length,L.length-1),E}else{const E=new Array(N.length+L.length);return b.Copy(N,0,E,0,N.length),b.Copy(L,0,E,N.length,L.length),E}}I(N,L,e){if(_.Assert(N.originalStart<=L.originalStart,"Left change is not less than or equal to right change"),_.Assert(N.modifiedStart<=L.modifiedStart,"Left change is not less than or equal to right change"),N.originalStart+N.originalLength>=L.originalStart||N.modifiedStart+N.modifiedLength>=L.modifiedStart){const E=N.originalStart;let F=N.originalLength;const y=N.modifiedStart;let w=N.modifiedLength;return N.originalStart+N.originalLength>=L.originalStart&&(F=L.originalStart+L.originalLength-N.originalStart),N.modifiedStart+N.modifiedLength>=L.modifiedStart&&(w=L.modifiedStart+L.modifiedLength-N.modifiedStart),e[0]=new D.DiffChange(E,F,y,w),!0}else return e[0]=null,!1}J(N,L,e,E){if(N>=0&&N<E)return N;const F=e,y=E-e-1,w=L%2===0;if(N<0){const g=F%2===0;return w===g?0:1}else{const g=y%2===0;return w===g?E-1:E-2}}}t.LcsDiff=A}),Q(Z[12],K([0,1,44,5]),function(W,t,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,u=/^\//,_=/^\/\//;function b(d,c){if(!d.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!i.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!u.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(d,c){return!d&&!c?"file":d}function f(d,c){switch(d){case"https":case"http":case"file":c?c[0]!==R&&(c=R+c):c=R;break}return c}const A="",R="/",N=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class L{static isUri(c){return c instanceof L?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,p,v,h,o,M=!1){typeof c=="object"?(this.scheme=c.scheme||A,this.authority=c.authority||A,this.path=c.path||A,this.query=c.query||A,this.fragment=c.fragment||A):(this.scheme=a(c,M),this.authority=p||A,this.path=f(this.scheme,v||A),this.query=h||A,this.fragment=o||A,b(this,M))}get fsPath(){return g(this,!1)}with(c){if(!c)return this;let{scheme:p,authority:v,path:h,query:o,fragment:M}=c;return p===void 0?p=this.scheme:p===null&&(p=A),v===void 0?v=this.authority:v===null&&(v=A),h===void 0?h=this.path:h===null&&(h=A),o===void 0?o=this.query:o===null&&(o=A),M===void 0?M=this.fragment:M===null&&(M=A),p===this.scheme&&v===this.authority&&h===this.path&&o===this.query&&M===this.fragment?this:new E(p,v,h,o,M)}static parse(c,p=!1){const v=N.exec(c);return v?new E(v[2]||A,s(v[4]||A),s(v[5]||A),s(v[7]||A),s(v[9]||A),p):new E(A,A,A,A,A)}static file(c){let p=A;if(S.isWindows&&(c=c.replace(/\\/g,R)),c[0]===R&&c[1]===R){const v=c.indexOf(R,2);v===-1?(p=c.substring(2),c=R):(p=c.substring(2,v),c=c.substring(v)||R)}return new E("file",p,c,A,A)}static from(c){const p=new E(c.scheme,c.authority,c.path,c.query,c.fragment);return b(p,!0),p}static joinPath(c,...p){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return S.isWindows&&c.scheme==="file"?v=L.file(D.win32.join(g(c,!0),...p)).path:v=D.posix.join(c.path,...p),c.with({path:v})}toString(c=!1){return m(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof L)return c;{const p=new E(c);return p._formatted=c.external,p._fsPath=c._sep===e?c.fsPath:null,p}}else return c}}t.URI=L;const e=S.isWindows?1:void 0;class E extends L{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(c=!1){return c?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=e),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const F={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(d,c,p){let v,h=-1;for(let o=0;o<d.length;o++){const M=d.charCodeAt(o);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||c&&M===47||p&&M===91||p&&M===93||p&&M===58)h!==-1&&(v+=encodeURIComponent(d.substring(h,o)),h=-1),v!==void 0&&(v+=d.charAt(o));else{v===void 0&&(v=d.substr(0,o));const T=F[M];T!==void 0?(h!==-1&&(v+=encodeURIComponent(d.substring(h,o)),h=-1),v+=T):h===-1&&(h=o)}}return h!==-1&&(v+=encodeURIComponent(d.substring(h))),v!==void 0?v:d}function w(d){let c;for(let p=0;p<d.length;p++){const v=d.charCodeAt(p);v===35||v===63?(c===void 0&&(c=d.substr(0,p)),c+=F[v]):c!==void 0&&(c+=d[p])}return c!==void 0?c:d}function g(d,c){let p;return d.authority&&d.path.length>1&&d.scheme==="file"?p=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?c?p=d.path.substr(1):p=d.path[1].toLowerCase()+d.path.substr(2):p=d.path,S.isWindows&&(p=p.replace(/\//g,"\\")),p}t.uriToFsPath=g;function m(d,c){const p=c?w:y;let v="",{scheme:h,authority:o,path:M,query:T,fragment:O}=d;if(h&&(v+=h,v+=":"),(o||h==="file")&&(v+=R,v+=R),o){let C=o.indexOf("@");if(C!==-1){const H=o.substr(0,C);o=o.substr(C+1),C=H.lastIndexOf(":"),C===-1?v+=p(H,!1,!1):(v+=p(H.substr(0,C),!1,!1),v+=":",v+=p(H.substr(C+1),!1,!0)),v+="@"}o=o.toLowerCase(),C=o.lastIndexOf(":"),C===-1?v+=p(o,!1,!0):(v+=p(o.substr(0,C),!1,!0),v+=o.substr(C))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const C=M.charCodeAt(1);C>=65&&C<=90&&(M=`/${String.fromCharCode(C+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const C=M.charCodeAt(0);C>=65&&C<=90&&(M=`${String.fromCharCode(C+32)}:${M.substr(2)}`)}v+=p(M,!0,!1)}return T&&(v+="?",v+=p(T,!1,!1)),O&&(v+="#",v+=c?O:y(O,!1,!1)),v}function l(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+l(d.substr(3)):d}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(d){return d.match(r)?d.replace(r,c=>l(c)):d}}),Q(Z[57],K([0,1,6,9,7,11,5,4]),function(W,t,D,S,i,u,_,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const a="$initialize";let f=!1;function A(d){!_.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(d.message))}t.logOnceWebWorkerWarning=A;var R;(function(d){d[d.Request=0]="Request",d[d.Reply=1]="Reply",d[d.SubscribeEvent=2]="SubscribeEvent",d[d.Event=3]="Event",d[d.UnsubscribeEvent=4]="UnsubscribeEvent"})(R||(R={}));class N{constructor(c,p,v,h){this.vsWorker=c,this.req=p,this.method=v,this.args=h,this.type=0}}class L{constructor(c,p,v,h){this.vsWorker=c,this.seq=p,this.res=v,this.err=h,this.type=1}}class e{constructor(c,p,v,h){this.vsWorker=c,this.req=p,this.eventName=v,this.arg=h,this.type=2}}class E{constructor(c,p,v){this.vsWorker=c,this.req=p,this.event=v,this.type=3}}class F{constructor(c,p){this.vsWorker=c,this.req=p,this.type=4}}class y{constructor(c){this.a=-1,this.g=c,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(c){this.a=c}sendMessage(c,p){const v=String(++this.b);return new Promise((h,o)=>{this.c[v]={resolve:h,reject:o},this.o(new N(this.a,v,c,p))})}listen(c,p){let v=null;const h=new S.Emitter({onWillAddFirstListener:()=>{v=String(++this.b),this.d.set(v,h),this.o(new e(this.a,v,c,p))},onDidRemoveLastListener:()=>{this.d.delete(v),this.o(new F(this.a,v)),v=null}});return h.event}handleMessage(c){!c||!c.vsWorker||this.a!==-1&&c.vsWorker!==this.a||this.h(c)}h(c){switch(c.type){case 1:return this.j(c);case 0:return this.k(c);case 2:return this.l(c);case 3:return this.m(c);case 4:return this.n(c)}}j(c){if(!this.c[c.seq]){console.warn("Got reply to unknown seq");return}const p=this.c[c.seq];if(delete this.c[c.seq],c.err){let v=c.err;c.err.$isError&&(v=new Error,v.name=c.err.name,v.message=c.err.message,v.stack=c.err.stack),p.reject(v);return}p.resolve(c.res)}k(c){const p=c.req;this.g.handleMessage(c.method,c.args).then(h=>{this.o(new L(this.a,p,h,void 0))},h=>{h.detail instanceof Error&&(h.detail=(0,D.transformErrorForSerialization)(h.detail)),this.o(new L(this.a,p,void 0,(0,D.transformErrorForSerialization)(h)))})}l(c){const p=c.req,v=this.g.handleEvent(c.eventName,c.arg)(h=>{this.o(new E(this.a,p,h))});this.f.set(p,v)}m(c){if(!this.d.has(c.req)){console.warn("Got event for unknown req");return}this.d.get(c.req).fire(c.event)}n(c){if(!this.f.has(c.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(c.req).dispose(),this.f.delete(c.req)}o(c){const p=[];if(c.type===0)for(let v=0;v<c.args.length;v++)c.args[v]instanceof ArrayBuffer&&p.push(c.args[v]);else c.type===1&&c.res instanceof ArrayBuffer&&p.push(c.res);this.g.sendMessage(c,p)}}class w extends i.Disposable{constructor(c,p,v){super();let h=null;this.a=this.B(c.create("vs/base/common/worker/simpleWorker",C=>{this.c.handleMessage(C)},C=>{h?.(C)})),this.c=new y({sendMessage:(C,H)=>{this.a.postMessage(C,H)},handleMessage:(C,H)=>{if(typeof v[C]!="function")return Promise.reject(new Error("Missing method "+C+" on main thread host."));try{return Promise.resolve(v[C].apply(v,H))}catch(z){return Promise.reject(z)}},handleEvent:(C,H)=>{if(m(C)){const z=v[C].call(v,H);if(typeof z!="function")throw new Error(`Missing dynamic event ${C} on main thread host.`);return z}if(g(C)){const z=v[C];if(typeof z!="function")throw new Error(`Missing event ${C} on main thread host.`);return z}throw new Error(`Malformed event name ${C}`)}}),this.c.setWorkerId(this.a.getId());let o=null;typeof _.globals.require<"u"&&typeof _.globals.require.getConfig=="function"?o=_.globals.require.getConfig():typeof _.globals.requirejs<"u"&&(o=_.globals.requirejs.s.contexts._.config);const M=(0,u.getAllMethodNames)(v);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(o)),p,M]);const T=(C,H)=>this.g(C,H),O=(C,H)=>this.c.listen(C,H);this.f=new Promise((C,H)=>{h=H,this.b.then(z=>{C(l(z,T,O))},z=>{H(z),this.h("Worker failed to load "+p,z)})})}getProxyObject(){return this.f}g(c,p){return new Promise((v,h)=>{this.b.then(()=>{this.c.sendMessage(c,p).then(v,h)},h)})}h(c,p){console.error(c),console.info(p)}}t.SimpleWorkerClient=w;function g(d){return d[0]==="o"&&d[1]==="n"&&b.isUpperAsciiLetter(d.charCodeAt(2))}function m(d){return/^onDynamic/.test(d)&&b.isUpperAsciiLetter(d.charCodeAt(9))}function l(d,c,p){const v=M=>function(){const T=Array.prototype.slice.call(arguments,0);return c(M,T)},h=M=>function(T){return p(M,T)},o={};for(const M of d){if(m(M)){o[M]=h(M);continue}if(g(M)){o[M]=p(M,void 0);continue}o[M]=v(M)}return o}class r{constructor(c,p){this.a=p,this.b=null,this.c=new y({sendMessage:(v,h)=>{c(v,h)},handleMessage:(v,h)=>this.d(v,h),handleEvent:(v,h)=>this.f(v,h)})}onmessage(c){this.c.handleMessage(c)}d(c,p){if(c===a)return this.g(p[0],p[1],p[2],p[3]);if(!this.b||typeof this.b[c]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+c));try{return Promise.resolve(this.b[c].apply(this.b,p))}catch(v){return Promise.reject(v)}}f(c,p){if(!this.b)throw new Error("Missing requestHandler");if(m(c)){const v=this.b[c].call(this.b,p);if(typeof v!="function")throw new Error(`Missing dynamic event ${c} on request handler.`);return v}if(g(c)){const v=this.b[c];if(typeof v!="function")throw new Error(`Missing event ${c} on request handler.`);return v}throw new Error(`Malformed event name ${c}`)}g(c,p,v,h){this.c.setWorkerId(c);const T=l(h,(O,C)=>this.c.sendMessage(O,C),(O,C)=>this.c.listen(O,C));return this.a?(this.b=this.a(T),Promise.resolve((0,u.getAllMethodNames)(this.b))):(p&&(typeof p.baseUrl<"u"&&delete p.baseUrl,typeof p.paths<"u"&&typeof p.paths.vs<"u"&&delete p.paths.vs,typeof p.trustedTypesPolicy!==void 0&&delete p.trustedTypesPolicy,p.catchError=!0,_.globals.require.config(p)),new Promise((O,C)=>{(_.globals.require||W)([v],z=>{if(this.b=z.create(T),!this.b){C(new Error("No RequestHandler!"));return}O((0,u.getAllMethodNames)(this.b))},C)}))}}t.SimpleWorkerServer=r;function s(d){return new r(d,null)}t.create=s}),Q(Z[24],K([0,1,23,20,4,2,10]),function(W,t,D,S,i,u,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.SmartLinesDiffComputer=void 0;const b=3;class a{computeDiff(m,l,r){const d=new E(m,l,{maxComputationTime:r.maxComputationTimeMs,shouldIgnoreTrimWhitespace:r.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),c=[];let p=null;for(const v of d.changes){let h;v.originalEndLineNumber===0?h=new S.LineRange(v.originalStartLineNumber+1,v.originalStartLineNumber+1):h=new S.LineRange(v.originalStartLineNumber,v.originalEndLineNumber+1);let o;v.modifiedEndLineNumber===0?o=new S.LineRange(v.modifiedStartLineNumber+1,v.modifiedStartLineNumber+1):o=new S.LineRange(v.modifiedStartLineNumber,v.modifiedEndLineNumber+1);let M=new S.LineRangeMapping(h,o,v.charChanges?.map(T=>new S.RangeMapping(new u.Range(T.originalStartLineNumber,T.originalStartColumn,T.originalEndLineNumber,T.originalEndColumn),new u.Range(T.modifiedStartLineNumber,T.modifiedStartColumn,T.modifiedEndLineNumber,T.modifiedEndColumn))));p&&(p.modifiedRange.endLineNumberExclusive===M.modifiedRange.startLineNumber||p.originalRange.endLineNumberExclusive===M.originalRange.startLineNumber)&&(M=new S.LineRangeMapping(p.originalRange.join(M.originalRange),p.modifiedRange.join(M.modifiedRange),p.innerChanges&&M.innerChanges?p.innerChanges.concat(M.innerChanges):void 0),c.pop()),c.push(M),p=M}return(0,_.assertFn)(()=>(0,_.checkAdjacentItems)(c,(v,h)=>h.originalRange.startLineNumber-v.originalRange.endLineNumberExclusive===h.modifiedRange.startLineNumber-v.modifiedRange.endLineNumberExclusive&&v.originalRange.endLineNumberExclusive<h.originalRange.startLineNumber&&v.modifiedRange.endLineNumberExclusive<h.modifiedRange.startLineNumber)),{quitEarly:d.quitEarly,changes:c}}}t.SmartLinesDiffComputer=a;function f(g,m,l,r){return new D.LcsDiff(g,m,l).ComputeDiff(r)}class A{constructor(m){const l=[],r=[];for(let s=0,d=m.length;s<d;s++)l[s]=F(m[s],1),r[s]=y(m[s],1);this.lines=m,this.a=l,this.b=r}getElements(){const m=[];for(let l=0,r=this.lines.length;l<r;l++)m[l]=this.lines[l].substring(this.a[l]-1,this.b[l]-1);return m}getStrictElement(m){return this.lines[m]}getStartLineNumber(m){return m+1}getEndLineNumber(m){return m+1}createCharSequence(m,l,r){const s=[],d=[],c=[];let p=0;for(let v=l;v<=r;v++){const h=this.lines[v],o=m?this.a[v]:1,M=m?this.b[v]:h.length+1;for(let T=o;T<M;T++)s[p]=h.charCodeAt(T-1),d[p]=v+1,c[p]=T,p++;!m&&v<r&&(s[p]=10,d[p]=v+1,c[p]=h.length+1,p++)}return new R(s,d,c)}}class R{constructor(m,l,r){this.a=m,this.b=l,this.d=r}toString(){return"["+this.a.map((m,l)=>(m===10?"\\n":String.fromCharCode(m))+`-(${this.b[l]},${this.d[l]})`).join(", ")+"]"}e(m,l){if(m<0||m>=l.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(m){return m>0&&m===this.b.length?this.getEndLineNumber(m-1):(this.e(m,this.b),this.b[m])}getEndLineNumber(m){return m===-1?this.getStartLineNumber(m+1):(this.e(m,this.b),this.a[m]===10?this.b[m]+1:this.b[m])}getStartColumn(m){return m>0&&m===this.d.length?this.getEndColumn(m-1):(this.e(m,this.d),this.d[m])}getEndColumn(m){return m===-1?this.getStartColumn(m+1):(this.e(m,this.d),this.a[m]===10?1:this.d[m]+1)}}class N{constructor(m,l,r,s,d,c,p,v){this.originalStartLineNumber=m,this.originalStartColumn=l,this.originalEndLineNumber=r,this.originalEndColumn=s,this.modifiedStartLineNumber=d,this.modifiedStartColumn=c,this.modifiedEndLineNumber=p,this.modifiedEndColumn=v}static createFromDiffChange(m,l,r){const s=l.getStartLineNumber(m.originalStart),d=l.getStartColumn(m.originalStart),c=l.getEndLineNumber(m.originalStart+m.originalLength-1),p=l.getEndColumn(m.originalStart+m.originalLength-1),v=r.getStartLineNumber(m.modifiedStart),h=r.getStartColumn(m.modifiedStart),o=r.getEndLineNumber(m.modifiedStart+m.modifiedLength-1),M=r.getEndColumn(m.modifiedStart+m.modifiedLength-1);return new N(s,d,c,p,v,h,o,M)}}function L(g){if(g.length<=1)return g;const m=[g[0]];let l=m[0];for(let r=1,s=g.length;r<s;r++){const d=g[r],c=d.originalStart-(l.originalStart+l.originalLength),p=d.modifiedStart-(l.modifiedStart+l.modifiedLength);Math.min(c,p)<b?(l.originalLength=d.originalStart+d.originalLength-l.originalStart,l.modifiedLength=d.modifiedStart+d.modifiedLength-l.modifiedStart):(m.push(d),l=d)}return m}class e{constructor(m,l,r,s,d){this.originalStartLineNumber=m,this.originalEndLineNumber=l,this.modifiedStartLineNumber=r,this.modifiedEndLineNumber=s,this.charChanges=d}static createFromDiffResult(m,l,r,s,d,c,p){let v,h,o,M,T;if(l.originalLength===0?(v=r.getStartLineNumber(l.originalStart)-1,h=0):(v=r.getStartLineNumber(l.originalStart),h=r.getEndLineNumber(l.originalStart+l.originalLength-1)),l.modifiedLength===0?(o=s.getStartLineNumber(l.modifiedStart)-1,M=0):(o=s.getStartLineNumber(l.modifiedStart),M=s.getEndLineNumber(l.modifiedStart+l.modifiedLength-1)),c&&l.originalLength>0&&l.originalLength<20&&l.modifiedLength>0&&l.modifiedLength<20&&d()){const O=r.createCharSequence(m,l.originalStart,l.originalStart+l.originalLength-1),C=s.createCharSequence(m,l.modifiedStart,l.modifiedStart+l.modifiedLength-1);if(O.getElements().length>0&&C.getElements().length>0){let H=f(O,C,d,!0).changes;p&&(H=L(H)),T=[];for(let z=0,ee=H.length;z<ee;z++)T.push(N.createFromDiffChange(H[z],O,C))}}return new e(v,h,o,M,T)}}class E{constructor(m,l,r){this.a=r.shouldComputeCharChanges,this.b=r.shouldPostProcessCharChanges,this.d=r.shouldIgnoreTrimWhitespace,this.e=r.shouldMakePrettyDiff,this.f=m,this.g=l,this.h=new A(m),this.j=new A(l),this.k=w(r.maxComputationTime),this.l=w(r.maxComputationTime===0?0:Math.min(r.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const m=f(this.h,this.j,this.k,this.e),l=m.changes,r=m.quitEarly;if(this.d){const p=[];for(let v=0,h=l.length;v<h;v++)p.push(e.createFromDiffResult(this.d,l[v],this.h,this.j,this.l,this.a,this.b));return{quitEarly:r,changes:p}}const s=[];let d=0,c=0;for(let p=-1,v=l.length;p<v;p++){const h=p+1<v?l[p+1]:null,o=h?h.originalStart:this.f.length,M=h?h.modifiedStart:this.g.length;for(;d<o&&c<M;){const T=this.f[d],O=this.g[c];if(T!==O){{let C=F(T,1),H=F(O,1);for(;C>1&&H>1;){const z=T.charCodeAt(C-2),ee=O.charCodeAt(H-2);if(z!==ee)break;C--,H--}(C>1||H>1)&&this.m(s,d+1,1,C,c+1,1,H)}{let C=y(T,1),H=y(O,1);const z=T.length+1,ee=O.length+1;for(;C<z&&H<ee;){const ne=T.charCodeAt(C-1),Y=T.charCodeAt(H-1);if(ne!==Y)break;C++,H++}(C<z||H<ee)&&this.m(s,d+1,C,z,c+1,H,ee)}}d++,c++}h&&(s.push(e.createFromDiffResult(this.d,h,this.h,this.j,this.l,this.a,this.b)),d+=h.originalLength,c+=h.modifiedLength)}return{quitEarly:r,changes:s}}m(m,l,r,s,d,c,p){if(this.n(m,l,r,s,d,c,p))return;let v;this.a&&(v=[new N(l,r,l,s,d,c,d,p)]),m.push(new e(l,l,d,d,v))}n(m,l,r,s,d,c,p){const v=m.length;if(v===0)return!1;const h=m[v-1];return h.originalEndLineNumber===0||h.modifiedEndLineNumber===0?!1:h.originalEndLineNumber===l&&h.modifiedEndLineNumber===d?(this.a&&h.charChanges&&h.charChanges.push(new N(l,r,l,s,d,c,d,p)),!0):h.originalEndLineNumber+1===l&&h.modifiedEndLineNumber+1===d?(h.originalEndLineNumber=l,h.modifiedEndLineNumber=d,this.a&&h.charChanges&&h.charChanges.push(new N(l,r,l,s,d,c,d,p)),!0):!1}}t.DiffComputer=E;function F(g,m){const l=i.firstNonWhitespaceIndex(g);return l===-1?m:l+1}function y(g,m){const l=i.lastNonWhitespaceIndex(g);return l===-1?m:l+2}function w(g){if(g===0)return()=>!0;const m=Date.now();return()=>Date.now()-m<g}}),Q(Z[47],K([0,1,24,36]),function(W,t,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={smart:new D.SmartLinesDiffComputer,experimental:new S.StandardLinesDiffComputer}}),Q(Z[48],K([0,1,4,3,40]),function(W,t,D,S,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class u{constructor(b,a,f,A){this.c=b,this.d=a,this.f=f,this.g=A,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(b){b.eol&&b.eol!==this.f&&(this.f=b.eol,this.h=null);const a=b.changes;for(const f of a)this.n(f.range),this.o(new S.Position(f.range.startLineNumber,f.range.startColumn),f.text);this.g=b.versionId,this.j=null}k(){if(!this.h){const b=this.f.length,a=this.d.length,f=new Uint32Array(a);for(let A=0;A<a;A++)f[A]=this.d[A].length+b;this.h=new i.PrefixSumComputer(f)}}l(b,a){this.d[b]=a,this.h&&this.h.setValue(b,this.d[b].length+this.f.length)}n(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.l(b.startLineNumber-1,this.d[b.startLineNumber-1].substring(0,b.startColumn-1)+this.d[b.startLineNumber-1].substring(b.endColumn-1));return}this.l(b.startLineNumber-1,this.d[b.startLineNumber-1].substring(0,b.startColumn-1)+this.d[b.endLineNumber-1].substring(b.endColumn-1)),this.d.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.h&&this.h.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}o(b,a){if(a.length===0)return;const f=(0,D.splitLines)(a);if(f.length===1){this.l(b.lineNumber-1,this.d[b.lineNumber-1].substring(0,b.column-1)+f[0]+this.d[b.lineNumber-1].substring(b.column-1));return}f[f.length-1]+=this.d[b.lineNumber-1].substring(b.column-1),this.l(b.lineNumber-1,this.d[b.lineNumber-1].substring(0,b.column-1)+f[0]);const A=new Uint32Array(f.length-1);for(let R=1;R<f.length;R++)this.d.splice(b.lineNumber+R-1,0,f[R]),A[R-1]=f[R].length+this.f.length;this.h&&this.h.insertValues(b.lineNumber,A)}}t.MirrorTextModel=u}),Q(Z[49],K([0,1,4,31,3,2,39]),function(W,t,D,S,i,u,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const b=999;class a{constructor(w,g,m,l){this.searchString=w,this.isRegex=g,this.matchCase=m,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let w;this.isRegex?w=f(this.searchString):w=this.searchString.indexOf(`
`)>=0;let g=null;try{g=D.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:w,global:!0,unicode:!0})}catch{return null}if(!g)return null;let m=!this.isRegex&&!w;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new _.SearchData(g,this.wordSeparators?(0,S.getMapForWordSeparators)(this.wordSeparators):null,m?this.searchString:null)}}t.SearchParams=a;function f(y){if(!y||y.length===0)return!1;for(let w=0,g=y.length;w<g;w++){const m=y.charCodeAt(w);if(m===10)return!0;if(m===92){if(w++,w>=g)break;const l=y.charCodeAt(w);if(l===110||l===114||l===87)return!0}}return!1}t.isMultilineRegexSource=f;function A(y,w,g){if(!g)return new _.FindMatch(y,null);const m=[];for(let l=0,r=w.length;l<r;l++)m[l]=w[l];return new _.FindMatch(y,m)}t.createFindMatch=A;class R{constructor(w){const g=[];let m=0;for(let l=0,r=w.length;l<r;l++)w.charCodeAt(l)===10&&(g[m++]=l);this.a=g}findLineFeedCountBeforeOffset(w){const g=this.a;let m=0,l=g.length-1;if(l===-1||w<=g[0])return 0;for(;m<l;){const r=m+((l-m)/2>>0);g[r]>=w?l=r-1:g[r+1]>=w?(m=r,l=r):m=r+1}return m+1}}class N{static findMatches(w,g,m,l,r){const s=g.parseSearchRequest();return s?s.regex.multiline?this.b(w,m,new F(s.wordSeparators,s.regex),l,r):this.c(w,m,s,l,r):[]}static a(w,g,m,l,r,s){let d,c=0;l?(c=l.findLineFeedCountBeforeOffset(r),d=g+r+c):d=g+r;let p;if(l){const M=l.findLineFeedCountBeforeOffset(r+s.length)-c;p=d+s.length+M}else p=d+s.length;const v=w.getPositionAt(d),h=w.getPositionAt(p);return new u.Range(v.lineNumber,v.column,h.lineNumber,h.column)}static b(w,g,m,l,r){const s=w.getOffsetAt(g.getStartPosition()),d=w.getValueInRange(g,1),c=w.getEOL()===`\r
`?new R(d):null,p=[];let v=0,h;for(m.reset(0);h=m.next(d);)if(p[v++]=A(this.a(w,s,d,c,h.index,h[0]),h,l),v>=r)return p;return p}static c(w,g,m,l,r){const s=[];let d=0;if(g.startLineNumber===g.endLineNumber){const p=w.getLineContent(g.startLineNumber).substring(g.startColumn-1,g.endColumn-1);return d=this.d(m,p,g.startLineNumber,g.startColumn-1,d,s,l,r),s}const c=w.getLineContent(g.startLineNumber).substring(g.startColumn-1);d=this.d(m,c,g.startLineNumber,g.startColumn-1,d,s,l,r);for(let p=g.startLineNumber+1;p<g.endLineNumber&&d<r;p++)d=this.d(m,w.getLineContent(p),p,0,d,s,l,r);if(d<r){const p=w.getLineContent(g.endLineNumber).substring(0,g.endColumn-1);d=this.d(m,p,g.endLineNumber,0,d,s,l,r)}return s}static d(w,g,m,l,r,s,d,c){const p=w.wordSeparators;if(!d&&w.simpleSearch){const o=w.simpleSearch,M=o.length,T=g.length;let O=-M;for(;(O=g.indexOf(o,O+M))!==-1;)if((!p||E(p,g,T,O,M))&&(s[r++]=new _.FindMatch(new u.Range(m,O+1+l,m,O+1+M+l),null),r>=c))return r;return r}const v=new F(w.wordSeparators,w.regex);let h;v.reset(0);do if(h=v.next(g),h&&(s[r++]=A(new u.Range(m,h.index+1+l,m,h.index+1+h[0].length+l),h,d),r>=c))return r;while(h);return r}static findNextMatch(w,g,m,l){const r=g.parseSearchRequest();if(!r)return null;const s=new F(r.wordSeparators,r.regex);return r.regex.multiline?this.e(w,m,s,l):this.f(w,m,s,l)}static e(w,g,m,l){const r=new i.Position(g.lineNumber,1),s=w.getOffsetAt(r),d=w.getLineCount(),c=w.getValueInRange(new u.Range(r.lineNumber,r.column,d,w.getLineMaxColumn(d)),1),p=w.getEOL()===`\r
`?new R(c):null;m.reset(g.column-1);const v=m.next(c);return v?A(this.a(w,s,c,p,v.index,v[0]),v,l):g.lineNumber!==1||g.column!==1?this.e(w,new i.Position(1,1),m,l):null}static f(w,g,m,l){const r=w.getLineCount(),s=g.lineNumber,d=w.getLineContent(s),c=this.g(m,d,s,g.column,l);if(c)return c;for(let p=1;p<=r;p++){const v=(s+p-1)%r,h=w.getLineContent(v+1),o=this.g(m,h,v+1,1,l);if(o)return o}return null}static g(w,g,m,l,r){w.reset(l-1);const s=w.next(g);return s?A(new u.Range(m,s.index+1,m,s.index+1+s[0].length),s,r):null}static findPreviousMatch(w,g,m,l){const r=g.parseSearchRequest();if(!r)return null;const s=new F(r.wordSeparators,r.regex);return r.regex.multiline?this.h(w,m,s,l):this.j(w,m,s,l)}static h(w,g,m,l){const r=this.b(w,new u.Range(1,1,g.lineNumber,g.column),m,l,10*b);if(r.length>0)return r[r.length-1];const s=w.getLineCount();return g.lineNumber!==s||g.column!==w.getLineMaxColumn(s)?this.h(w,new i.Position(s,w.getLineMaxColumn(s)),m,l):null}static j(w,g,m,l){const r=w.getLineCount(),s=g.lineNumber,d=w.getLineContent(s).substring(0,g.column-1),c=this.k(m,d,s,l);if(c)return c;for(let p=1;p<=r;p++){const v=(r+s-p-1)%r,h=w.getLineContent(v+1),o=this.k(m,h,v+1,l);if(o)return o}return null}static k(w,g,m,l){let r=null,s;for(w.reset(0);s=w.next(g);)r=A(new u.Range(m,s.index+1,m,s.index+1+s[0].length),s,l);return r}}t.TextModelSearch=N;function L(y,w,g,m,l){if(m===0)return!0;const r=w.charCodeAt(m-1);if(y.get(r)!==0||r===13||r===10)return!0;if(l>0){const s=w.charCodeAt(m);if(y.get(s)!==0)return!0}return!1}function e(y,w,g,m,l){if(m+l===g)return!0;const r=w.charCodeAt(m+l);if(y.get(r)!==0||r===13||r===10)return!0;if(l>0){const s=w.charCodeAt(m+l-1);if(y.get(s)!==0)return!0}return!1}function E(y,w,g,m,l){return L(y,w,g,m,l)&&e(y,w,g,m,l)}t.isValidMatch=E;class F{constructor(w,g){this._wordSeparators=w,this.a=g,this.b=-1,this.c=0}reset(w){this.a.lastIndex=w,this.b=-1,this.c=0}next(w){const g=w.length;let m;do{if(this.b+this.c===g||(m=this.a.exec(w),!m))return null;const l=m.index,r=m[0].length;if(l===this.b&&r===this.c){if(r===0){D.getNextCodePoint(w,g,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=l,this.c=r,!this._wordSeparators||E(this._wordSeparators,w,g,l,r))return m}while(m);return null}}t.Searcher=F}),Q(Z[50],K([0,1,2,49,4,10,19]),function(W,t,D,S,i,u,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class b{static computeUnicodeHighlights(e,E,F){const y=F?F.startLineNumber:1,w=F?F.endLineNumber:e.getLineCount(),g=new A(E),m=g.getCandidateCodePoints();let l;m==="allNonBasicAscii"?l=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):l=new RegExp(`${a(Array.from(m))}`,"g");const r=new S.Searcher(null,l),s=[];let d=!1,c,p=0,v=0,h=0;e:for(let o=y,M=w;o<=M;o++){const T=e.getLineContent(o),O=T.length;r.reset(0);do if(c=r.next(T),c){let C=c.index,H=c.index+c[0].length;if(C>0){const Y=T.charCodeAt(C-1);i.isHighSurrogate(Y)&&C--}if(H+1<O){const Y=T.charCodeAt(H-1);i.isHighSurrogate(Y)&&H++}const z=T.substring(C,H);let ee=(0,_.getWordAtText)(C+1,_.DEFAULT_WORD_REGEXP,T,0);ee&&ee.endColumn<=C+1&&(ee=null);const ne=g.shouldHighlightNonBasicASCII(z,ee?ee.word:null);if(ne!==0){ne===3?p++:ne===2?v++:ne===1?h++:(0,u.assertNever)(ne);const Y=1e3;if(s.length>=Y){d=!0;break e}s.push(new D.Range(o,C+1,o,H+1))}}while(c)}return{ranges:s,hasMore:d,ambiguousCharacterCount:p,invisibleCharacterCount:v,nonBasicAsciiCharacterCount:h}}static computeUnicodeHighlightReason(e,E){const F=new A(E);switch(F.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const w=e.codePointAt(0),g=F.ambiguousCharacters.getPrimaryConfusable(w),m=i.AmbiguousCharacters.getLocales().filter(l=>!i.AmbiguousCharacters.getInstance(new Set([...E.allowedLocales,l])).isAmbiguous(w));return{kind:0,confusableWith:String.fromCodePoint(g),notAmbiguousInLocales:m}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=b;function a(L,e){return`[${i.escapeRegExpCharacters(L.map(F=>String.fromCodePoint(F)).join(""))}]`}var f;(function(L){L[L.Ambiguous=0]="Ambiguous",L[L.Invisible=1]="Invisible",L[L.NonBasicAscii=2]="NonBasicAscii"})(f=t.UnicodeHighlighterReasonKind||(t.UnicodeHighlighterReasonKind={}));class A{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const E of i.InvisibleCharacters.codePoints)R(String.fromCodePoint(E))||e.add(E);if(this.b.ambiguousCharacters)for(const E of this.ambiguousCharacters.getConfusableCodePoints())e.add(E);for(const E of this.a)e.delete(E);return e}shouldHighlightNonBasicASCII(e,E){const F=e.codePointAt(0);if(this.a.has(F))return 0;if(this.b.nonBasicASCII)return 1;let y=!1,w=!1;if(E)for(const g of E){const m=g.codePointAt(0),l=i.isBasicASCII(g);y=y||l,!l&&!this.ambiguousCharacters.isAmbiguous(m)&&!i.InvisibleCharacters.isInvisibleCharacter(m)&&(w=!0)}return!y&&w?0:this.b.invisibleCharacters&&!R(e)&&i.InvisibleCharacters.isInvisibleCharacter(F)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(F)?3:0}}function R(L){return L===" "||L===`
`||L==="	"}var N;(function(L){L[L.None=0]="None",L[L.NonBasicASCII=1]="NonBasicASCII",L[L.Invisible=2]="Invisible",L[L.Ambiguous=3]="Ambiguous"})(N||(N={}))}),Q(Z[51],K([0,1,9,7]),function(W,t,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class i{constructor(){this.a=new Map,this.b=new Map,this.c=new D.Emitter,this.onDidChange=this.c.event,this.d=null}fire(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,a){return this.a.set(b,a),this.fire([b]),(0,S.toDisposable)(()=>{this.a.get(b)===a&&(this.a.delete(b),this.fire([b]))})}registerFactory(b,a){this.b.get(b)?.dispose();const f=new u(this,b,a);return this.b.set(b,f),(0,S.toDisposable)(()=>{const A=this.b.get(b);!A||A!==f||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const a=this.get(b);if(a)return a;const f=this.b.get(b);return!f||f.isResolved?null:(await f.resolve(),this.get(b))}get(b){return this.a.get(b)||null}isResolved(b){if(this.get(b))return!0;const f=this.b.get(b);return!!(!f||f.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.TokenizationRegistry=i;class u extends S.Disposable{get isResolved(){return this.c}constructor(b,a,f){super(),this.f=b,this.g=a,this.h=f,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const b=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),Q(Z[52],K([0,1,29,12,2,51]),function(W,t,D,S,i,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.InlayHintKind=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.FoldingRangeKind=t.SymbolKinds=t.SymbolTag=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0;class _{constructor(M,T,O){this.offset=M,this.type=T,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=_;class b{constructor(M,T){this.tokens=M,this.endState=T,this._tokenizationResultBrand=void 0}}t.TokenizationResult=b;class a{constructor(M,T){this.tokens=M,this.endState=T,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=a;var f;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(f=t.CompletionItemKind||(t.CompletionItemKind={}));var A;(function(o){const M=new Map;M.set(0,D.Codicon.symbolMethod),M.set(1,D.Codicon.symbolFunction),M.set(2,D.Codicon.symbolConstructor),M.set(3,D.Codicon.symbolField),M.set(4,D.Codicon.symbolVariable),M.set(5,D.Codicon.symbolClass),M.set(6,D.Codicon.symbolStruct),M.set(7,D.Codicon.symbolInterface),M.set(8,D.Codicon.symbolModule),M.set(9,D.Codicon.symbolProperty),M.set(10,D.Codicon.symbolEvent),M.set(11,D.Codicon.symbolOperator),M.set(12,D.Codicon.symbolUnit),M.set(13,D.Codicon.symbolValue),M.set(15,D.Codicon.symbolEnum),M.set(14,D.Codicon.symbolConstant),M.set(15,D.Codicon.symbolEnum),M.set(16,D.Codicon.symbolEnumMember),M.set(17,D.Codicon.symbolKeyword),M.set(27,D.Codicon.symbolSnippet),M.set(18,D.Codicon.symbolText),M.set(19,D.Codicon.symbolColor),M.set(20,D.Codicon.symbolFile),M.set(21,D.Codicon.symbolReference),M.set(22,D.Codicon.symbolCustomColor),M.set(23,D.Codicon.symbolFolder),M.set(24,D.Codicon.symbolTypeParameter),M.set(25,D.Codicon.account),M.set(26,D.Codicon.issues);function T(H){let z=M.get(H);return z||(console.info("No codicon found for CompletionItemKind "+H),z=D.Codicon.symbolProperty),z}o.toIcon=T;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function C(H,z){let ee=O.get(H);return typeof ee>"u"&&!z&&(ee=9),ee}o.fromString=C})(A=t.CompletionItemKinds||(t.CompletionItemKinds={}));var R;(function(o){o[o.Deprecated=1]="Deprecated"})(R=t.CompletionItemTag||(t.CompletionItemTag={}));var N;(function(o){o[o.None=0]="None",o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(N=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var L;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var e;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(e=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var E;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(E=t.CodeActionTriggerType||(t.CodeActionTriggerType={}));var F;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(F=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var y;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(y=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));function w(o){return o&&S.URI.isUri(o.uri)&&i.Range.isIRange(o.range)&&(i.Range.isIRange(o.originSelectionRange)||i.Range.isIRange(o.targetSelectionRange))}t.isLocationLink=w;var g;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(g=t.SymbolKind||(t.SymbolKind={}));var m;(function(o){o[o.Deprecated=1]="Deprecated"})(m=t.SymbolTag||(t.SymbolTag={}));var l;(function(o){const M=new Map;M.set(0,D.Codicon.symbolFile),M.set(1,D.Codicon.symbolModule),M.set(2,D.Codicon.symbolNamespace),M.set(3,D.Codicon.symbolPackage),M.set(4,D.Codicon.symbolClass),M.set(5,D.Codicon.symbolMethod),M.set(6,D.Codicon.symbolProperty),M.set(7,D.Codicon.symbolField),M.set(8,D.Codicon.symbolConstructor),M.set(9,D.Codicon.symbolEnum),M.set(10,D.Codicon.symbolInterface),M.set(11,D.Codicon.symbolFunction),M.set(12,D.Codicon.symbolVariable),M.set(13,D.Codicon.symbolConstant),M.set(14,D.Codicon.symbolString),M.set(15,D.Codicon.symbolNumber),M.set(16,D.Codicon.symbolBoolean),M.set(17,D.Codicon.symbolArray),M.set(18,D.Codicon.symbolObject),M.set(19,D.Codicon.symbolKey),M.set(20,D.Codicon.symbolNull),M.set(21,D.Codicon.symbolEnumMember),M.set(22,D.Codicon.symbolStruct),M.set(23,D.Codicon.symbolEvent),M.set(24,D.Codicon.symbolOperator),M.set(25,D.Codicon.symbolTypeParameter);function T(O){let C=M.get(O);return C||(console.info("No codicon found for SymbolKind "+O),C=D.Codicon.symbolProperty),C}o.toIcon=T})(l=t.SymbolKinds||(t.SymbolKinds={}));class r{static fromValue(M){switch(M){case"comment":return r.Comment;case"imports":return r.Imports;case"region":return r.Region}return new r(M)}constructor(M){this.value=M}}r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region"),t.FoldingRangeKind=r;var s;(function(o){function M(T){return!T||typeof T!="object"?!1:typeof T.id=="string"&&typeof T.title=="string"}o.is=M})(s=t.Command||(t.Command={}));var d;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(d=t.CommentThreadCollapsibleState||(t.CommentThreadCollapsibleState={}));var c;(function(o){o[o.Unresolved=0]="Unresolved",o[o.Resolved=1]="Resolved"})(c=t.CommentThreadState||(t.CommentThreadState={}));var p;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(p=t.CommentMode||(t.CommentMode={}));var v;(function(o){o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(v=t.InlayHintKind||(t.InlayHintKind={})),t.TokenizationRegistry=new u.TokenizationRegistry;var h;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(h=t.ExternalUriOpenerPriority||(t.ExternalUriOpenerPriority={}))}),Q(Z[53],K([0,1,22,9,27,12,3,2,30,52,41]),function(W,t,D,S,i,u,_,b,a,f,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class R{static chord(e,E){return(0,i.KeyChord)(e,E)}}R.CtrlCmd=2048,R.Shift=1024,R.Alt=512,R.WinCtrl=256,t.KeyMod=R;function N(){return{editor:void 0,languages:void 0,CancellationTokenSource:D.CancellationTokenSource,Emitter:S.Emitter,KeyCode:A.KeyCode,KeyMod:R,Position:_.Position,Range:b.Range,Selection:a.Selection,SelectionDirection:A.SelectionDirection,MarkerSeverity:A.MarkerSeverity,MarkerTag:A.MarkerTag,Uri:u.URI,Token:f.Token}}t.createMonacoBaseAPI=N}),Q(Z[58],K([0,1,23,5,12,3,2,48,19,37,38,53,21,50,24,47,11]),function(W,t,D,S,i,u,_,b,a,f,A,R,N,L,e,E,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class y extends b.MirrorTextModel{get uri(){return this.c}get eol(){return this.f}getValue(){return this.getText()}getLinesContent(){return this.d.slice(0)}getLineCount(){return this.d.length}getLineContent(l){return this.d[l-1]}getWordAtPosition(l,r){const s=(0,a.getWordAtText)(l.column,(0,a.ensureValidWordDefinition)(r),this.d[l.lineNumber-1],0);return s?new _.Range(l.lineNumber,s.startColumn,l.lineNumber,s.endColumn):null}getWordUntilPosition(l,r){const s=this.getWordAtPosition(l,r);return s?{word:this.d[l.lineNumber-1].substring(s.startColumn-1,l.column-1),startColumn:s.startColumn,endColumn:l.column}:{word:"",startColumn:l.column,endColumn:l.column}}words(l){const r=this.d,s=this.p.bind(this);let d=0,c="",p=0,v=[];return{*[Symbol.iterator](){for(;;)if(p<v.length){const h=c.substring(v[p].start,v[p].end);p+=1,yield h}else if(d<r.length)c=r[d],v=s(c,l),p=0,d+=1;else break}}}getLineWords(l,r){const s=this.d[l-1],d=this.p(s,r),c=[];for(const p of d)c.push({word:s.substring(p.start,p.end),startColumn:p.start+1,endColumn:p.end+1});return c}p(l,r){const s=[];let d;for(r.lastIndex=0;(d=r.exec(l))&&d[0].length!==0;)s.push({start:d.index,end:d.index+d[0].length});return s}getValueInRange(l){if(l=this.q(l),l.startLineNumber===l.endLineNumber)return this.d[l.startLineNumber-1].substring(l.startColumn-1,l.endColumn-1);const r=this.f,s=l.startLineNumber-1,d=l.endLineNumber-1,c=[];c.push(this.d[s].substring(l.startColumn-1));for(let p=s+1;p<d;p++)c.push(this.d[p]);return c.push(this.d[d].substring(0,l.endColumn-1)),c.join(r)}offsetAt(l){return l=this.r(l),this.k(),this.h.getPrefixSum(l.lineNumber-2)+(l.column-1)}positionAt(l){l=Math.floor(l),l=Math.max(0,l),this.k();const r=this.h.getIndexOf(l),s=this.d[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,s)}}q(l){const r=this.r({lineNumber:l.startLineNumber,column:l.startColumn}),s=this.r({lineNumber:l.endLineNumber,column:l.endColumn});return r.lineNumber!==l.startLineNumber||r.column!==l.startColumn||s.lineNumber!==l.endLineNumber||s.column!==l.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:s.lineNumber,endColumn:s.column}:l}r(l){if(!u.Position.isIPosition(l))throw new Error("bad position");let{lineNumber:r,column:s}=l,d=!1;if(r<1)r=1,s=1,d=!0;else if(r>this.d.length)r=this.d.length,s=this.d[r-1].length+1,d=!0;else{const c=this.d[r-1].length+1;s<1?(s=1,d=!0):s>c&&(s=c,d=!0)}return d?{lineNumber:r,column:s}:l}}class w{constructor(l,r){this.c=l,this.d=Object.create(null),this.f=r,this.g=null}dispose(){this.d=Object.create(null)}h(l){return this.d[l]}j(){const l=[];return Object.keys(this.d).forEach(r=>l.push(this.d[r])),l}acceptNewModel(l){this.d[l.url]=new y(i.URI.parse(l.url),l.lines,l.EOL,l.versionId)}acceptModelChanged(l,r){if(!this.d[l])return;this.d[l].onEvents(r)}acceptRemovedModel(l){!this.d[l]||delete this.d[l]}async computeUnicodeHighlights(l,r,s){const d=this.h(l);return d?L.UnicodeTextModelHighlighter.computeUnicodeHighlights(d,r,s):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(l,r,s,d){const c=this.h(l),p=this.h(r);return!c||!p?null:w.k(c,p,s,d)}static k(l,r,s,d){const c=d==="experimental"?E.linesDiffComputers.experimental:E.linesDiffComputers.smart,p=l.getLinesContent(),v=r.getLinesContent(),h=c.computeDiff(p,v,s);return{identical:h.changes.length>0?!1:this.l(l,r),quitEarly:h.quitEarly,changes:h.changes.map(M=>[M.originalRange.startLineNumber,M.originalRange.endLineNumberExclusive,M.modifiedRange.startLineNumber,M.modifiedRange.endLineNumberExclusive,M.innerChanges?.map(T=>[T.originalRange.startLineNumber,T.originalRange.startColumn,T.originalRange.endLineNumber,T.originalRange.endColumn,T.modifiedRange.startLineNumber,T.modifiedRange.startColumn,T.modifiedRange.endLineNumber,T.modifiedRange.endColumn])])}}static l(l,r){const s=l.getLineCount(),d=r.getLineCount();if(s!==d)return!1;for(let c=1;c<=s;c++){const p=l.getLineContent(c),v=r.getLineContent(c);if(p!==v)return!1}return!0}async computeDirtyDiff(l,r,s){const d=this.h(l),c=this.h(r);if(!d||!c)return null;const p=d.getLinesContent(),v=c.getLinesContent();return new e.DiffComputer(p,v,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(l,r){const s=this.h(l);if(!s)return r;const d=[];let c;r=r.slice(0).sort((p,v)=>{if(p.range&&v.range)return _.Range.compareRangesUsingStarts(p.range,v.range);const h=p.range?0:1,o=v.range?0:1;return h-o});for(let{range:p,text:v,eol:h}of r){if(typeof h=="number"&&(c=h),_.Range.isEmpty(p)&&!v)continue;const o=s.getValueInRange(p);if(v=v.replace(/\r\n|\n|\r/g,s.eol),o===v)continue;if(Math.max(v.length,o.length)>w.n){d.push({range:p,text:v});continue}const M=(0,D.stringDiff)(o,v,!1),T=s.offsetAt(_.Range.lift(p).getStartPosition());for(const O of M){const C=s.positionAt(T+O.originalStart),H=s.positionAt(T+O.originalStart+O.originalLength),z={text:v.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:C.lineNumber,startColumn:C.column,endLineNumber:H.lineNumber,endColumn:H.column}};s.getValueInRange(z.range)!==z.text&&d.push(z)}}return typeof c=="number"&&d.push({eol:c,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),d}async computeLinks(l){const r=this.h(l);return r?(0,f.computeLinks)(r):null}async textualSuggest(l,r,s,d){const c=new N.StopWatch(!0),p=new RegExp(s,d),v=new Set;e:for(const h of l){const o=this.h(h);if(!!o){for(const M of o.words(p))if(!(M===r||!isNaN(Number(M)))&&(v.add(M),v.size>w.o))break e}}return{words:Array.from(v),duration:c.elapsed()}}async computeWordRanges(l,r,s,d){const c=this.h(l);if(!c)return Object.create(null);const p=new RegExp(s,d),v=Object.create(null);for(let h=r.startLineNumber;h<r.endLineNumber;h++){const o=c.getLineWords(h,p);for(const M of o){if(!isNaN(Number(M.word)))continue;let T=v[M.word];T||(T=[],v[M.word]=T),T.push({startLineNumber:h,startColumn:M.startColumn,endLineNumber:h,endColumn:M.endColumn})}}return v}async navigateValueSet(l,r,s,d,c){const p=this.h(l);if(!p)return null;const v=new RegExp(d,c);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});const h=p.getValueInRange(r),o=p.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},v);if(!o)return null;const M=p.getValueInRange(o);return A.BasicInplaceReplace.INSTANCE.navigateValueSet(r,h,o,M,s)}loadForeignModule(l,r,s){const d=(v,h)=>this.c.fhr(v,h),p={host:(0,F.createProxyObject)(s,d),getMirrorModels:()=>this.j()};return this.f?(this.g=this.f(p,r),Promise.resolve((0,F.getAllMethodNames)(this.g))):new Promise((v,h)=>{W([l],o=>{this.g=o.create(p,r),v((0,F.getAllMethodNames)(this.g))},h)})}fmr(l,r){if(!this.g||typeof this.g[l]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+l));try{return Promise.resolve(this.g[l].apply(this.g,r))}catch(s){return Promise.reject(s)}}}w.n=1e5,w.o=1e4,t.EditorSimpleWorker=w;function g(m){return new w(m,null)}t.create=g,typeof importScripts=="function"&&(S.globals.monaco=(0,R.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/96a795cc0b1cd62f9ff66c347637f917c6dde3da/core/vs/base/worker/workerMain.js.map
