/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/node/cli/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/base/common/network","vs/platform/environment/common/environment","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/base/common/stream","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","yauzl","yazl","zlib","vs/code/node/cli/cliProcessMain"],_=function(x){for(var e=[],O=0,R=x.length;O<R;O++)e[O]=Q[x[O]];return e};define(Q[48],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function O(D){return(S,g,c)=>{let b=null,w=null;if(typeof c.value=="function"?(b="value",w=c.value):typeof c.get=="function"&&(b="get",w=c.get),!w)throw new Error("not supported");c[b]=D(w,g)}}function R(D,S,g){let c=null,b=null;if(typeof g.value=="function"?(c="value",b=g.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(c="get",b=g.get),!b)throw new Error("not supported");const w=`$memoize$${S}`;g[c]=function(...d){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,d)}),this[w]}}e.memoize=R;function P(D,S,g){return O((c,b)=>{const w=`$debounce$${b}`,d=`$debounce$result$${b}`;return function(...m){this[d]||(this[d]=g?g():void 0),clearTimeout(this[w]),S&&(this[d]=S(this[d],...m),m=[this[d]]),this[w]=setTimeout(()=>{c.apply(this,m),this[d]=g?g():void 0},D)}})}e.debounce=P;function k(D,S,g){return O((c,b)=>{const w=`$throttle$timer$${b}`,d=`$throttle$result$${b}`,m=`$throttle$lastRun$${b}`,I=`$throttle$pending$${b}`;return function(...N){if(this[d]||(this[d]=g?g():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),S&&(this[d]=S(this[d],...N)),this[I])return;const u=this[m]+D;u<=Date.now()?(this[m]=Date.now(),c.apply(this,[this[d]]),this[d]=g?g():void 0):(this[I]=!0,this[w]=setTimeout(()=>{this[I]=!1,this[m]=Date.now(),c.apply(this,[this[d]]),this[d]=g?g():void 0},u-Date.now()))}})}e.throttle=k}),define(Q[70],_([0,1,7]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(g,c){if(!g)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=R;function P(g,c="Unreachable"){throw new Error(c)}e.assertNever=P;function k(g){if(!g)throw new O.BugIndicatingError("Assertion Failed")}e.assert=k;function D(g){if(!g()){debugger;g(),(0,O.onUnexpectedError)(new O.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function S(g,c){let b=0;for(;b<g.length-1;){const w=g[b],d=g[b+1];if(!c(w,d))return!1;b++}return!0}e.checkAdjacentItems=S}),define(Q[49],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var O;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(O=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function D(t,s=!1){let i=0;const n=t.length;let r="",a=0,o=16,l=0;function h(ne){let ae=0,fe=0;for(;ae<ne;){const oe=t.charCodeAt(i);if(oe>=48&&oe<=57)fe=fe*16+oe-48;else if(oe>=65&&oe<=70)fe=fe*16+oe-65+10;else if(oe>=97&&oe<=102)fe=fe*16+oe-97+10;else break;i++,ae++}return ae<ne&&(fe=-1),fe}function A(ne){i=ne,r="",a=0,o=16,l=0}function F(){const ne=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return l=3,t.substring(ne,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;ae=i}else l=3;return t.substring(ne,ae)}function Y(){let ne="",ae=i;for(;;){if(i>=n){ne+=t.substring(ae,i),l=2;break}const fe=t.charCodeAt(i);if(fe===34){ne+=t.substring(ae,i),i++;break}if(fe===92){if(ne+=t.substring(ae,i),i++,i>=n){l=2;break}switch(t.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const ve=h(4);ve>=0?ne+=String.fromCharCode(ve):l=4;break}default:l=5}ae=i;continue}if(fe>=0&&fe<=31)if(g(fe)){ne+=t.substring(ae,i),l=2;break}else l=6;i++}return ne}function ee(){if(r="",l=0,a=i,i>=n)return a=n,o=17;let ne=t.charCodeAt(i);if(S(ne)){do i++,r+=String.fromCharCode(ne),ne=t.charCodeAt(i);while(S(ne));return o=15}if(g(ne))return i++,r+=String.fromCharCode(ne),ne===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),o=14;switch(ne){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,r=Y(),o=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!g(t.charCodeAt(i));)i++;return r=t.substring(ae,i),o=12}if(t.charCodeAt(i+1)===42){i+=2;const fe=n-1;let oe=!1;for(;i<fe;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,oe=!0;break}i++}return oe||(i++,l=1),r=t.substring(ae,i),o=13}return r+=String.fromCharCode(ne),i++,o=16}case 45:if(r+=String.fromCharCode(ne),i++,i===n||!c(t.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=F(),o=11;default:for(;i<n&&te(ne);)i++,ne=t.charCodeAt(i);if(a!==i){switch(r=t.substring(a,i),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode(ne),i++,o=16}}function te(ne){if(S(ne)||g(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let ne;do ne=ee();while(ne>=12&&ne<=15);return ne}return{setPosition:A,getPosition:()=>i,scan:s?ie:ee,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>l}}e.createScanner=D;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function w(t,s){const i=[],n=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function l(h,A,F,Y){a.value=h,a.offset=A,a.length=F,a.type=Y,a.colonOffset=void 0,r=a}try{E(t,{onObjectBegin:(h,A)=>{if(s<=h)throw n;r=void 0,o=s>h,i.push("")},onObjectProperty:(h,A,F)=>{if(s<A||(l(h,A,F,"property"),i[i.length-1]=h,s<=A+F))throw n},onObjectEnd:(h,A)=>{if(s<=h)throw n;r=void 0,i.pop()},onArrayBegin:(h,A)=>{if(s<=h)throw n;r=void 0,i.push(0)},onArrayEnd:(h,A)=>{if(s<=h)throw n;r=void 0,i.pop()},onLiteralValue:(h,A,F)=>{if(s<A||(l(h,A,F,p(h)),s<=A+F))throw n},onSeparator:(h,A,F)=>{if(s<=A)throw n;if(h===":"&&r&&r.type==="property")r.colonOffset=A,o=!1,r=void 0;else if(h===","){const Y=i[i.length-1];typeof Y=="number"?i[i.length-1]=Y+1:(o=!0,i[i.length-1]=""),r=void 0}}})}catch(h){if(h!==n)throw h}return{path:i,previousNode:r,isAtPropertyKey:o,matches:h=>{let A=0;for(let F=0;A<h.length&&F<i.length;F++)if(h[A]===i[F]||h[A]==="*")A++;else if(h[A]!=="**")return!1;return A===h.length}}}e.getLocation=w;function d(t,s=[],i=k.DEFAULT){let n=null,r=[];const a=[];function o(h){Array.isArray(r)?r.push(h):n!==null&&(r[n]=h)}return E(t,{onObjectBegin:()=>{const h={};o(h),a.push(r),r=h,n=null},onObjectProperty:h=>{n=h},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const h=[];o(h),a.push(r),r=h,n=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:o,onError:(h,A,F)=>{s.push({error:h,offset:A,length:F})}},i),r[0]}e.parse=d;function m(t,s=[],i=k.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(h){n.type==="property"&&(n.length=h-n.offset,n=n.parent)}function a(h){return n.children.push(h),h}E(t,{onObjectBegin:h=>{n=a({type:"object",offset:h,length:-1,parent:n,children:[]})},onObjectProperty:(h,A,F)=>{n=a({type:"property",offset:A,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:h,offset:A,length:F,parent:n})},onObjectEnd:(h,A)=>{n.length=h+A-n.offset,n=n.parent,r(h+A)},onArrayBegin:(h,A)=>{n=a({type:"array",offset:h,length:-1,parent:n,children:[]})},onArrayEnd:(h,A)=>{n.length=h+A-n.offset,n=n.parent,r(h+A)},onLiteralValue:(h,A,F)=>{a({type:p(h),offset:A,length:F,parent:n,value:h}),r(A+F)},onSeparator:(h,A,F)=>{n.type==="property"&&(h===":"?n.colonOffset=A:h===","&&r(A))},onError:(h,A,F)=>{s.push({error:h,offset:A,length:F})}},i);const l=n.children[0];return l&&delete l.parent,l}e.parseTree=m;function I(t,s){if(!t)return;let i=t;for(const n of s)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===n){i=a.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=I;function N(t){if(!t.parent||!t.parent.children)return[];const s=N(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;s.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&s.push(i)}return s}e.getNodePath=N;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const s=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(s[i.children[0].value]=u(n))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=u;function f(t,s,i=!1){return s>=t.offset&&s<t.offset+t.length||i&&s===t.offset+t.length}e.contains=f;function v(t,s,i=!1){if(f(t,s,i)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=s;r++){const a=v(n[r],s,i);if(a)return a}return t}}e.findNodeAtOffset=v;function E(t,s,i=k.DEFAULT){const n=D(t,!1);function r(q){return q?()=>q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(q){return q?X=>q(X,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=r(s.onObjectBegin),l=a(s.onObjectProperty),h=r(s.onObjectEnd),A=r(s.onArrayBegin),F=r(s.onArrayEnd),Y=a(s.onLiteralValue),ee=a(s.onSeparator),te=r(s.onComment),ie=a(s.onError),ne=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function fe(){for(;;){const q=n.scan();switch(n.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:ne||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(q){case 12:case 13:ne?oe(10):te();break;case 16:oe(1);break;case 15:case 14:break;default:return q}}}function oe(q,X=[],C=[]){if(ie(q),X.length+C.length>0){let L=n.getToken();for(;L!==17;){if(X.indexOf(L)!==-1){fe();break}else if(C.indexOf(L)!==-1)break;L=fe()}}}function ve(q){const X=n.getTokenValue();return q?Y(X):l(X),fe(),!0}function V(){switch(n.getToken()){case 11:{let q=0;try{q=JSON.parse(n.getTokenValue()),typeof q!="number"&&(oe(2),q=0)}catch{oe(2)}Y(q);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return fe(),!0}function j(){return n.getToken()!==10?(oe(3,[],[2,5]),!1):(ve(!1),n.getToken()===6?(ee(":"),fe(),W()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function M(){o(),fe();let q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(q||oe(4,[],[]),ee(","),fe(),n.getToken()===2&&ae)break}else q&&oe(6,[],[]);j()||oe(4,[],[2,5]),q=!0}return h(),n.getToken()!==2?oe(7,[2],[]):fe(),!0}function $(){A(),fe();let q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(q||oe(4,[],[]),ee(","),fe(),n.getToken()===4&&ae)break}else q&&oe(6,[],[]);W()||oe(4,[],[4,5]),q=!0}return F(),n.getToken()!==4?oe(8,[4],[]):fe(),!0}function W(){switch(n.getToken()){case 3:return $();case 1:return M();case 10:return ve(!0);default:return V()}}return fe(),n.getToken()===17?i.allowEmptyContent?!0:(oe(4,[],[]),!1):W()?(n.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.visit=E;function y(t,s){const i=D(t),n=[];let r,a=0,o;do switch(o=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:a!==o&&n.push(t.substring(a,o)),s!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,s)),a=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=y;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(Q[71],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function O(S,g,c){return Math.min(Math.max(S,g),c)}e.clamp=O;function R(S,g){return(g+S%g)%g}e.rot=R;class P{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=P;class k{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=k;class D{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const c=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=D}),function(){function x(P){const k=[];typeof P=="number"&&k.push("code/timeOrigin",P);function D(g){k.push(g,Date.now())}function S(){const g=[];for(let c=0;c<k.length;c+=2)g.push({name:k[c],startTime:k[c+1]});return g}return{mark:D,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const D of performance.getEntriesByType("mark"))k.push({name:D.name,startTime:Math.round(P+D.startTime)});return k}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function O(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=O(R))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var R in O)(typeof exports=="object"?exports:x)[R]=O[R]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function O(R){if(e[R])return e[R].exports;var P=e[R]={i:R,l:!1,exports:{}};return x[R].call(P.exports,P,P.exports,O),P.l=!0,P.exports}return O.m=x,O.c=e,O.d=function(R,P,k){O.o(R,P)||Object.defineProperty(R,P,{enumerable:!0,get:k})},O.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},O.t=function(R,P){if(1&P&&(R=O(R)),8&P||4&P&&typeof R=="object"&&R&&R.__esModule)return R;var k=Object.create(null);if(O.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:R}),2&P&&typeof R!="string")for(var D in R)O.d(k,D,function(S){return R[S]}.bind(null,D));return k},O.n=function(R){var P=R&&R.__esModule?function(){return R.default}:function(){return R};return O.d(P,"a",P),P},O.o=function(R,P){return Object.prototype.hasOwnProperty.call(R,P)},O.p="",O(O.s=0)}([function(x,e,O){(function(R){var P;e=x.exports=C,P=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],g=e.src=[],c=0,b=c++;g[b]="0|[1-9]\\d*";var w=c++;g[w]="[0-9]+";var d=c++;g[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=c++;g[m]="("+g[b]+")\\.("+g[b]+")\\.("+g[b]+")";var I=c++;g[I]="("+g[w]+")\\.("+g[w]+")\\.("+g[w]+")";var N=c++;g[N]="(?:"+g[b]+"|"+g[d]+")";var u=c++;g[u]="(?:"+g[w]+"|"+g[d]+")";var f=c++;g[f]="(?:-("+g[N]+"(?:\\."+g[N]+")*))";var v=c++;g[v]="(?:-?("+g[u]+"(?:\\."+g[u]+")*))";var E=c++;g[E]="[0-9A-Za-z-]+";var y=c++;g[y]="(?:\\+("+g[E]+"(?:\\."+g[E]+")*))";var p=c++,t="v?"+g[m]+g[f]+"?"+g[y]+"?";g[p]="^"+t+"$";var s="[v=\\s]*"+g[I]+g[v]+"?"+g[y]+"?",i=c++;g[i]="^"+s+"$";var n=c++;g[n]="((?:<|>)?=?)";var r=c++;g[r]=g[w]+"|x|X|\\*";var a=c++;g[a]=g[b]+"|x|X|\\*";var o=c++;g[o]="[v=\\s]*("+g[a]+")(?:\\.("+g[a]+")(?:\\.("+g[a]+")(?:"+g[f]+")?"+g[y]+"?)?)?";var l=c++;g[l]="[v=\\s]*("+g[r]+")(?:\\.("+g[r]+")(?:\\.("+g[r]+")(?:"+g[v]+")?"+g[y]+"?)?)?";var h=c++;g[h]="^"+g[n]+"\\s*"+g[o]+"$";var A=c++;g[A]="^"+g[n]+"\\s*"+g[l]+"$";var F=c++;g[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=c++;g[Y]="(?:~>?)";var ee=c++;g[ee]="(\\s*)"+g[Y]+"\\s+",S[ee]=new RegExp(g[ee],"g");var te=c++;g[te]="^"+g[Y]+g[o]+"$";var ie=c++;g[ie]="^"+g[Y]+g[l]+"$";var ne=c++;g[ne]="(?:\\^)";var ae=c++;g[ae]="(\\s*)"+g[ne]+"\\s+",S[ae]=new RegExp(g[ae],"g");var fe=c++;g[fe]="^"+g[ne]+g[o]+"$";var oe=c++;g[oe]="^"+g[ne]+g[l]+"$";var ve=c++;g[ve]="^"+g[n]+"\\s*("+s+")$|^$";var V=c++;g[V]="^"+g[n]+"\\s*("+t+")$|^$";var j=c++;g[j]="(\\s*)"+g[n]+"\\s*("+s+"|"+g[o]+")",S[j]=new RegExp(g[j],"g");var M=c++;g[M]="^\\s*("+g[o]+")\\s+-\\s+("+g[o]+")\\s*$";var $=c++;g[$]="^\\s*("+g[l]+")\\s+-\\s+("+g[l]+")\\s*$";var W=c++;g[W]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)P(q,g[q]),S[q]||(S[q]=new RegExp(g[q]));function X(B,K){if(B instanceof C)return B;if(typeof B!="string"||B.length>k||!(K?S[i]:S[p]).test(B))return null;try{return new C(B,K)}catch{return null}}function C(B,K){if(B instanceof C){if(B.loose===K)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof C))return new C(B,K);P("SemVer",B,K),this.loose=K;var J=B.trim().match(K?S[i]:S[p]);if(!J)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var pe=+de;if(pe>=0&&pe<D)return pe}return de}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=X,e.valid=function(B,K){var J=X(B,K);return J?J.version:null},e.clean=function(B,K){var J=X(B.trim().replace(/^[=v]+/,""),K);return J?J.version:null},e.SemVer=C,C.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},C.prototype.toString=function(){return this.version},C.prototype.compare=function(B){return P("SemVer.compare",this.version,this.loose,B),B instanceof C||(B=new C(B,this.loose)),this.compareMain(B)||this.comparePre(B)},C.prototype.compareMain=function(B){return B instanceof C||(B=new C(B,this.loose)),T(this.major,B.major)||T(this.minor,B.minor)||T(this.patch,B.patch)},C.prototype.comparePre=function(B){if(B instanceof C||(B=new C(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var K=0;do{var J=this.prerelease[K],de=B.prerelease[K];if(P("prerelease compare",K,J,de),J===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(J===void 0)return-1;if(J!==de)return T(J,de)}while(++K)},C.prototype.inc=function(B,K){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,K,J,de){typeof J=="string"&&(de=J,J=void 0);try{return new C(B,J).inc(K,de).version}catch{return null}},e.diff=function(B,K){if(H(B,K))return null;var J=X(B),de=X(K);if(J.prerelease.length||de.prerelease.length){for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==de[pe])return"pre"+pe;return"prerelease"}for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==de[pe])return pe},e.compareIdentifiers=T;var L=/^[0-9]+$/;function T(B,K){var J=L.test(B),de=L.test(K);return J&&de&&(B=+B,K=+K),J&&!de?-1:de&&!J?1:B<K?-1:B>K?1:0}function U(B,K,J){return new C(B,J).compare(new C(K,J))}function z(B,K,J){return U(B,K,J)>0}function G(B,K,J){return U(B,K,J)<0}function H(B,K,J){return U(B,K,J)===0}function re(B,K,J){return U(B,K,J)!==0}function le(B,K,J){return U(B,K,J)>=0}function ye(B,K,J){return U(B,K,J)<=0}function me(B,K,J,de){var pe;switch(K){case"===":typeof B=="object"&&(B=B.version),typeof J=="object"&&(J=J.version),pe=B===J;break;case"!==":typeof B=="object"&&(B=B.version),typeof J=="object"&&(J=J.version),pe=B!==J;break;case"":case"=":case"==":pe=H(B,J,de);break;case"!=":pe=re(B,J,de);break;case">":pe=z(B,J,de);break;case">=":pe=le(B,J,de);break;case"<":pe=G(B,J,de);break;case"<=":pe=ye(B,J,de);break;default:throw new TypeError("Invalid operator: "+K)}return pe}function ce(B,K){if(B instanceof ce){if(B.loose===K)return B;B=B.value}if(!(this instanceof ce))return new ce(B,K);P("comparator",B,K),this.loose=K,this.parse(B),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(B,K){return T(K,B)},e.major=function(B,K){return new C(B,K).major},e.minor=function(B,K){return new C(B,K).minor},e.patch=function(B,K){return new C(B,K).patch},e.compare=U,e.compareLoose=function(B,K){return U(B,K,!0)},e.rcompare=function(B,K,J){return U(K,B,J)},e.sort=function(B,K){return B.sort(function(J,de){return e.compare(J,de,K)})},e.rsort=function(B,K){return B.sort(function(J,de){return e.rcompare(J,de,K)})},e.gt=z,e.lt=G,e.eq=H,e.neq=re,e.gte=le,e.lte=ye,e.cmp=me,e.Comparator=ce;var ge={};function se(B,K){if(B instanceof se)return B.loose===K?B:new se(B.raw,K);if(B instanceof ce)return new se(B.value,K);if(!(this instanceof se))return new se(B,K);if(this.loose=K,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function ue(B){return!B||B.toLowerCase()==="x"||B==="*"}function we(B,K,J,de,pe,Oe,be,Ne,Re,Le,Me,ke,Te){return((K=ue(J)?"":ue(de)?">="+J+".0.0":ue(pe)?">="+J+"."+de+".0":">="+K)+" "+(Ne=ue(Re)?"":ue(Le)?"<"+(+Re+1)+".0.0":ue(Me)?"<"+Re+"."+(+Le+1)+".0":ke?"<="+Re+"."+Le+"."+Me+"-"+ke:"<="+Ne)).trim()}function Pe(B,K){for(var J=0;J<B.length;J++)if(!B[J].test(K))return!1;if(K.prerelease.length){for(J=0;J<B.length;J++)if(P(B[J].semver),B[J].semver!==ge&&B[J].semver.prerelease.length>0){var de=B[J].semver;if(de.major===K.major&&de.minor===K.minor&&de.patch===K.patch)return!0}return!1}return!0}function je(B,K,J){try{K=new se(K,J)}catch{return!1}return K.test(B)}function Ue(B,K,J,de){var pe,Oe,be,Ne,Re;switch(B=new C(B,de),K=new se(K,de),J){case">":pe=z,Oe=ye,be=G,Ne=">",Re=">=";break;case"<":pe=G,Oe=le,be=z,Ne="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(B,K,de))return!1;for(var Le=0;Le<K.set.length;++Le){var Me=K.set[Le],ke=null,Te=null;if(Me.forEach(function(Ae){Ae.semver===ge&&(Ae=new ce(">=0.0.0")),ke=ke||Ae,Te=Te||Ae,pe(Ae.semver,ke.semver,de)?ke=Ae:be(Ae.semver,Te.semver,de)&&(Te=Ae)}),ke.operator===Ne||ke.operator===Re||(!Te.operator||Te.operator===Ne)&&Oe(B,Te.semver)||Te.operator===Re&&be(B,Te.semver))return!1}return!0}ce.prototype.parse=function(B){var K=this.loose?S[ve]:S[V],J=B.match(K);if(!J)throw new TypeError("Invalid comparator: "+B);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new C(J[2],this.loose):this.semver=ge},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(B){return P("Comparator.test",B,this.loose),this.semver===ge||(typeof B=="string"&&(B=new C(B,this.loose)),me(B,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(B,K){if(!(B instanceof ce))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new se(B.value,K),je(this.value,J,K);if(B.operator==="")return J=new se(this.value,K),je(B.semver,J,K);var de=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Oe=this.semver.version===B.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Ne=me(this.semver,"<",B.semver,K)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),Re=me(this.semver,">",B.semver,K)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return de||pe||Oe&&be||Ne||Re},e.Range=se,se.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},se.prototype.toString=function(){return this.range},se.prototype.parseRange=function(B){var K=this.loose;B=B.trim(),P("range",B,K);var J=K?S[$]:S[M];B=B.replace(J,we),P("hyphen replace",B),B=B.replace(S[j],"$1$2$3"),P("comparator trim",B,S[j]),B=(B=(B=B.replace(S[ee],"$1~")).replace(S[ae],"$1^")).split(/\s+/).join(" ");var de=K?S[ve]:S[V],pe=B.split(" ").map(function(Oe){return function(be,Ne){return P("comp",be),be=function(Re,Le){return Re.trim().split(/\s+/).map(function(Me){return function(ke,Te){P("caret",ke,Te);var Ae=Te?S[oe]:S[fe];return ke.replace(Ae,function(Fe,Ee,Se,Ie,De){var Ce;return P("caret",ke,Fe,Ee,Se,Ie,De),ue(Ee)?Ce="":ue(Se)?Ce=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ue(Ie)?Ce=Ee==="0"?">="+Ee+"."+Se+".0 <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+".0 <"+(+Ee+1)+".0.0":De?(P("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ce=Ee==="0"?Se==="0"?">="+Ee+"."+Se+"."+Ie+De+" <"+Ee+"."+Se+"."+(+Ie+1):">="+Ee+"."+Se+"."+Ie+De+" <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+"."+Ie+De+" <"+(+Ee+1)+".0.0"):(P("no pr"),Ce=Ee==="0"?Se==="0"?">="+Ee+"."+Se+"."+Ie+" <"+Ee+"."+Se+"."+(+Ie+1):">="+Ee+"."+Se+"."+Ie+" <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+"."+Ie+" <"+(+Ee+1)+".0.0"),P("caret return",Ce),Ce})}(Me,Le)}).join(" ")}(be,Ne),P("caret",be),be=function(Re,Le){return Re.trim().split(/\s+/).map(function(Me){return function(ke,Te){var Ae=Te?S[ie]:S[te];return ke.replace(Ae,function(Fe,Ee,Se,Ie,De){var Ce;return P("tilde",ke,Fe,Ee,Se,Ie,De),ue(Ee)?Ce="":ue(Se)?Ce=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ue(Ie)?Ce=">="+Ee+"."+Se+".0 <"+Ee+"."+(+Se+1)+".0":De?(P("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ce=">="+Ee+"."+Se+"."+Ie+De+" <"+Ee+"."+(+Se+1)+".0"):Ce=">="+Ee+"."+Se+"."+Ie+" <"+Ee+"."+(+Se+1)+".0",P("tilde return",Ce),Ce})}(Me,Le)}).join(" ")}(be,Ne),P("tildes",be),be=function(Re,Le){return P("replaceXRanges",Re,Le),Re.split(/\s+/).map(function(Me){return function(ke,Te){ke=ke.trim();var Ae=Te?S[A]:S[h];return ke.replace(Ae,function(Fe,Ee,Se,Ie,De,Ce){P("xRange",ke,Fe,Ee,Se,Ie,De,Ce);var xe=ue(Se),Be=xe||ue(Ie),Ve=Be||ue(De);return Ee==="="&&Ve&&(Ee=""),xe?Fe=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Ve?(Be&&(Ie=0),Ve&&(De=0),Ee===">"?(Ee=">=",Be?(Se=+Se+1,Ie=0,De=0):Ve&&(Ie=+Ie+1,De=0)):Ee==="<="&&(Ee="<",Be?Se=+Se+1:Ie=+Ie+1),Fe=Ee+Se+"."+Ie+"."+De):Be?Fe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ve&&(Fe=">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0"),P("xRange return",Fe),Fe})}(Me,Le)}).join(" ")}(be,Ne),P("xrange",be),be=function(Re,Le){return P("replaceStars",Re,Le),Re.trim().replace(S[W],"")}(be,Ne),P("stars",be),be}(Oe,K)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Oe){return!!Oe.match(de)})),pe=pe.map(function(Oe){return new ce(Oe,K)})},se.prototype.intersects=function(B,K){if(!(B instanceof se))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(de){return B.set.some(function(pe){return pe.every(function(Oe){return de.intersects(Oe,K)})})})})},e.toComparators=function(B,K){return new se(B,K).set.map(function(J){return J.map(function(de){return de.value}).join(" ").trim().split(" ")})},se.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new C(B,this.loose));for(var K=0;K<this.set.length;K++)if(Pe(this.set[K],B))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(B,K,J){var de=null,pe=null;try{var Oe=new se(K,J)}catch{return null}return B.forEach(function(be){Oe.test(be)&&(de&&pe.compare(be)!==-1||(pe=new C(de=be,J)))}),de},e.minSatisfying=function(B,K,J){var de=null,pe=null;try{var Oe=new se(K,J)}catch{return null}return B.forEach(function(be){Oe.test(be)&&(de&&pe.compare(be)!==1||(pe=new C(de=be,J)))}),de},e.validRange=function(B,K){try{return new se(B,K).range||"*"}catch{return null}},e.ltr=function(B,K,J){return Ue(B,K,"<",J)},e.gtr=function(B,K,J){return Ue(B,K,">",J)},e.outside=Ue,e.prerelease=function(B,K){var J=X(B,K);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(B,K,J){return B=new se(B,J),K=new se(K,J),B.intersects(K)},e.coerce=function(B){if(B instanceof C)return B;if(typeof B!="string")return null;var K=B.match(S[F]);return K==null?null:X((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,O(1))},function(x,e){var O,R,P=x.exports={};function k(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function S(u){if(O===setTimeout)return setTimeout(u,0);if((O===k||!O)&&setTimeout)return O=setTimeout,setTimeout(u,0);try{return O(u,0)}catch{try{return O.call(null,u,0)}catch{return O.call(this,u,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:k}catch{O=k}try{R=typeof clearTimeout=="function"?clearTimeout:D}catch{R=D}})();var g,c=[],b=!1,w=-1;function d(){b&&g&&(b=!1,g.length?c=g.concat(c):w=-1,c.length&&m())}function m(){if(!b){var u=S(d);b=!0;for(var f=c.length;f;){for(g=c,c=[];++w<f;)g&&g[w].run();w=-1,f=c.length}g=null,b=!1,function(v){if(R===clearTimeout)return clearTimeout(v);if((R===D||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(v);try{R(v)}catch{try{return R.call(null,v)}catch{return R.call(this,v)}}}(u)}}function I(u,f){this.fun=u,this.array=f}function N(){}P.nextTick=function(u){var f=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)f[v-1]=arguments[v];c.push(new I(u,f)),c.length!==1||b||S(m)},I.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=N,P.addListener=N,P.once=N,P.off=N,P.removeListener=N,P.removeAllListeners=N,P.emit=N,P.prependListener=N,P.prependOnceListener=N,P.listeners=function(u){return[]},P.binding=function(u){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(u){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Q[72],_([0,1]),function(x,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class R{constructor(S,g,c){this.level=S,this.key=g,this.value=c,this.forward=[]}}const P=void 0;class k{constructor(S,g=2**16){this.comparator=S,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new R(this.c,P,P)}get size(){return this.f}clear(){this.e=new R(this.c,P,P)}has(S){return Boolean(k.g(this,S,this.comparator))}get(S){return k.g(this,S,this.comparator)?.value}set(S,g){return k.h(this,S,g,this.comparator)&&(this.f+=1),this}delete(S){const g=k.k(this,S,this.comparator);return g&&(this.f-=1),g}forEach(S,g){let c=this.e.forward[0];for(;c;)S.call(g,c.value,c.key,this),c=c.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",g=this.e.forward[0];for(;g;)S+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return S}static g(S,g,c){let b=S.e;for(let w=S.d-1;w>=0;w--)for(;b.forward[w]&&c(b.forward[w].key,g)<0;)b=b.forward[w];if(b=b.forward[0],b&&c(b.key,g)===0)return b}static h(S,g,c,b){const w=[];let d=S.e;for(let m=S.d-1;m>=0;m--){for(;d.forward[m]&&b(d.forward[m].key,g)<0;)d=d.forward[m];w[m]=d}if(d=d.forward[0],d&&b(d.key,g)===0)return d.value=c,!1;{const m=k.j(S);if(m>S.d){for(let I=S.d;I<m;I++)w[I]=S.e;S.d=m}d=new R(m,g,c);for(let I=0;I<m;I++)d.forward[I]=w[I].forward[I],w[I].forward[I]=d;return!0}}static j(S,g=.5){let c=1;for(;Math.random()<g&&c<S.c;)c+=1;return c}static k(S,g,c){const b=[];let w=S.e;for(let d=S.d-1;d>=0;d--){for(;w.forward[d]&&c(w.forward[d].key,g)<0;)w=w.forward[d];b[d]=w}if(w=w.forward[0],!w||c(w.key,g)!==0)return!1;for(let d=0;d<S.d&&b[d].forward[d]===w;d++)b[d].forward[d]=w.forward[d];for(;S.d>0&&S.e.forward[S.d-1]===P;)S.d-=1;return!0}}e.SkipList=k}),define(Q[43],_([0,1,7,2]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function P(y){const p=y;return p?typeof p.read=="function":!1}e.isReadable=P;function k(y){const p=y;return p?[p.on,p.pause,p.resume,p.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=k;function D(y){const p=y;return p?k(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=D;function S(y,p){return new g(y,p)}e.newWriteableStream=S;class g{constructor(p,t){this.e=p,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(t=>t(p))}h(p){this.c.error.length===0?(0,O.onUnexpectedError)(p):this.c.error.slice(0).forEach(t=>t(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,t){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(p,t){if(this.a.destroyed)return;let s;switch(p){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const i=s.indexOf(t);i>=0&&s.splice(i,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(y,p){const t=[];let s;for(;(s=y.read())!==null;)t.push(s);return p(t)}e.consumeReadable=c;function b(y,p,t){const s=[];let i;for(;(i=y.read())!==null&&s.length<t;)s.push(i);return i===null&&s.length>0?p(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return y.read()}}}e.peekReadable=b;function w(y,p){return new Promise((t,s)=>{const i=[];d(y,{onData:n=>{p&&i.push(n)},onError:n=>{p?s(n):t(void 0)},onEnd:()=>{t(p?p(i):void 0)}})})}e.consumeStream=w;function d(y,p){let t=!1;return y.on("error",s=>{t||p.onError(s)}),y.on("end",()=>{t||p.onEnd()}),y.on("data",s=>{t||p.onData(s)}),(0,R.toDisposable)(()=>t=!0)}e.listenStream=d;function m(y,p){return new Promise((t,s)=>{const i=new R.DisposableStore,n=[],r=l=>{if(n.push(l),n.length>p)return i.dispose(),y.pause(),t({stream:y,buffer:n,ended:!1})},a=l=>s(l),o=()=>t({stream:y,buffer:n,ended:!0});i.add((0,R.toDisposable)(()=>y.removeListener("error",a))),y.on("error",a),i.add((0,R.toDisposable)(()=>y.removeListener("end",o))),y.on("end",o),i.add((0,R.toDisposable)(()=>y.removeListener("data",r))),y.on("data",r)})}e.peekStream=m;function I(y,p){const t=S(p);return t.end(y),t}e.toStream=I;function N(){const y=S(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=N;function u(y){let p=!1;return{read:()=>p?null:(p=!0,y)}}e.toReadable=u;function f(y,p,t){const s=S(t);return d(y,{onData:i=>s.write(p.data(i)),onError:i=>s.error(p.error?p.error(i):i),onEnd:()=>s.end()}),s}e.transform=f;function v(y,p,t){let s=!1;return{read:()=>{const i=p.read();return s?i:(s=!0,i!==null?t([y,i]):y)}}}e.prefixedReadable=v;function E(y,p,t){let s=!1;const i=S(t);return d(p,{onData:n=>s?i.write(n):(s=!0,i.write(t([y,n]))),onError:n=>i.error(n),onEnd:()=>{s||(s=!0,i.write(y)),i.end()}}),i}e.prefixedStream=E}),define(Q[14],_([0,1,43]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u";let P,k;class D{static alloc(l){return R?new D(Buffer.allocUnsafe(l)):new D(new Uint8Array(l))}static wrap(l){return R&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new D(l)}static fromString(l,h){return!(h?.dontUseNodeBuffer||!1)&&R?new D(Buffer.from(l)):(P||(P=new TextEncoder),new D(P.encode(l)))}static fromByteArray(l){const h=D.alloc(l.length);for(let A=0,F=l.length;A<F;A++)h.buffer[A]=l[A];return h}static concat(l,h){if(typeof h>"u"){h=0;for(let Y=0,ee=l.length;Y<ee;Y++)h+=l[Y].byteLength}const A=D.alloc(h);let F=0;for(let Y=0,ee=l.length;Y<ee;Y++){const te=l[Y];A.set(te,F),F+=te.byteLength}return A}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=D.alloc(this.byteLength);return l.set(this),l}toString(){return R?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(l,h){return new D(this.buffer.subarray(l,h))}set(l,h){if(l instanceof D)this.buffer.set(l.buffer,h);else if(l instanceof Uint8Array)this.buffer.set(l,h);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),h);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return c(this.buffer,l)}writeUInt32BE(l,h){b(this.buffer,l,h)}readUInt32LE(l){return w(this.buffer,l)}writeUInt32LE(l,h){d(this.buffer,l,h)}readUInt8(l){return m(this.buffer,l)}writeUInt8(l,h){I(this.buffer,l,h)}}e.VSBuffer=D;function S(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0}e.readUInt16LE=S;function g(o,l,h){o[h+0]=l&255,l=l>>>8,o[h+1]=l&255}e.writeUInt16LE=g;function c(o,l){return o[l]*2**24+o[l+1]*2**16+o[l+2]*2**8+o[l+3]}e.readUInt32BE=c;function b(o,l,h){o[h+3]=l,l=l>>>8,o[h+2]=l,l=l>>>8,o[h+1]=l,l=l>>>8,o[h]=l}e.writeUInt32BE=b;function w(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0|o[l+2]<<16>>>0|o[l+3]<<24>>>0}e.readUInt32LE=w;function d(o,l,h){o[h+0]=l&255,l=l>>>8,o[h+1]=l&255,l=l>>>8,o[h+2]=l&255,l=l>>>8,o[h+3]=l&255}e.writeUInt32LE=d;function m(o,l){return o[l]}e.readUInt8=m;function I(o,l,h){o[h]=l}e.writeUInt8=I;function N(o){return O.consumeReadable(o,l=>D.concat(l))}e.readableToBuffer=N;function u(o){return O.toReadable(o)}e.bufferToReadable=u;function f(o){return O.consumeStream(o,l=>D.concat(l))}e.streamToBuffer=f;async function v(o){return o.ended?D.concat(o.buffer):D.concat([...o.buffer,await f(o.stream)])}e.bufferedStreamToBuffer=v;function E(o){return O.toStream(o,l=>D.concat(l))}e.bufferToStream=E;function y(o){return O.transform(o,{data:l=>typeof l=="string"?D.fromString(l):D.wrap(l)},l=>D.concat(l))}e.streamToBufferReadableStream=y;function p(o){return O.newWriteableStream(l=>D.concat(l),o)}e.newWriteableBufferStream=p;function t(o,l){return O.prefixedReadable(o,l,h=>D.concat(h))}e.prefixedBufferReadable=t;function s(o,l){return O.prefixedStream(o,l,h=>D.concat(h))}e.prefixedBufferStream=s;function i(o){let l=0,h=0,A=0;const F=new Uint8Array(Math.floor(o.length/4*3)),Y=te=>{switch(h){case 3:F[A++]=l|te,h=0;break;case 2:F[A++]=l|te>>>2,l=te<<6,h=3;break;case 1:F[A++]=l|te>>>4,l=te<<4,h=2;break;default:l=te<<2,h=1}};for(let te=0;te<o.length;te++){const ie=o.charCodeAt(te);if(ie>=65&&ie<=90)Y(ie-65);else if(ie>=97&&ie<=122)Y(ie-97+26);else if(ie>=48&&ie<=57)Y(ie-48+52);else if(ie===43||ie===45)Y(62);else if(ie===47||ie===95)Y(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${o[te]}`)}}const ee=A;for(;h>0;)Y(0);return D.wrap(F).slice(0,ee)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:o},l=!0,h=!1){const A=h?r:n;let F="";const Y=o.byteLength%3;let ee=0;for(;ee<o.byteLength-Y;ee+=3){const te=o[ee+0],ie=o[ee+1],ne=o[ee+2];F+=A[te>>>2],F+=A[(te<<4|ie>>>4)&63],F+=A[(ie<<2|ne>>>6)&63],F+=A[ne&63]}if(Y===1){const te=o[ee+0];F+=A[te>>>2],F+=A[te<<4&63],l&&(F+="==")}else if(Y===2){const te=o[ee+0],ie=o[ee+1];F+=A[te>>>2],F+=A[(te<<4|ie>>>4)&63],F+=A[ie<<2&63],l&&(F+="=")}return F}e.encodeBase64=a}),define(Q[28],_([0,1,3]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const v=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([E,y])=>{v[E]=y&&typeof y=="object"?R(y):y}),v}e.deepClone=R;function P(f){if(!f||typeof f!="object")return f;const v=[f];for(;v.length>0;){const E=v.shift();Object.freeze(E);for(const y in E)if(k.call(E,y)){const p=E[y];typeof p=="object"&&!Object.isFrozen(p)&&!(0,O.isTypedArray)(p)&&v.push(p)}}return f}e.deepFreeze=P;const k=Object.prototype.hasOwnProperty;function D(f,v){return S(f,v,new Set)}e.cloneAndChange=D;function S(f,v,E){if((0,O.isUndefinedOrNull)(f))return f;const y=v(f);if(typeof y<"u")return y;if(Array.isArray(f)){const p=[];for(const t of f)p.push(S(t,v,E));return p}if((0,O.isObject)(f)){if(E.has(f))throw new Error("Cannot clone recursive data-structure");E.add(f);const p={};for(const t in f)k.call(f,t)&&(p[t]=S(f[t],v,E));return E.delete(f),p}return f}function g(f,v,E=!0){return(0,O.isObject)(f)?((0,O.isObject)(v)&&Object.keys(v).forEach(y=>{y in f?E&&((0,O.isObject)(f[y])&&(0,O.isObject)(v[y])?g(f[y],v[y],E):f[y]=v[y]):f[y]=v[y]}),f):v}e.mixin=g;function c(f,v){if(f===v)return!0;if(f==null||v===null||v===void 0||typeof f!=typeof v||typeof f!="object"||Array.isArray(f)!==Array.isArray(v))return!1;let E,y;if(Array.isArray(f)){if(f.length!==v.length)return!1;for(E=0;E<f.length;E++)if(!c(f[E],v[E]))return!1}else{const p=[];for(y in f)p.push(y);p.sort();const t=[];for(y in v)t.push(y);if(t.sort(),!c(p,t))return!1;for(E=0;E<p.length;E++)if(!c(f[p[E]],v[p[E]]))return!1}return!0}e.equals=c;function b(f){const v=new Set;return JSON.stringify(f,(E,y)=>{if((0,O.isObject)(y)||Array.isArray(y)){if(v.has(y))return"[Circular]";v.add(y)}return y})}e.safeStringify=b;function w(f,v){const E=Object.create(null);return!f||!v||Object.keys(v).forEach(p=>{const t=f[p],s=v[p];c(t,s)||(E[p]=s)}),E}e.distinct=w;function d(f,v){const E=v.toLowerCase(),y=Object.keys(f).find(p=>p.toLowerCase()===E);return y?f[y]:f[v]}e.getCaseInsensitive=d;function m(f,v){const E=Object.create(null);for(const[y,p]of Object.entries(f))v(y,p)&&(E[y]=p);return E}e.filter=m;function I(f){let v=[],E=Object.getPrototypeOf(f);for(;Object.prototype!==E;)v=v.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return v}e.getAllPropertyNames=I;function N(f){const v=[];for(const E of I(f))typeof f[E]=="function"&&v.push(E);return v}e.getAllMethodNames=N;function u(f,v){const E=p=>function(){const t=Array.prototype.slice.call(arguments,0);return v(p,t)},y={};for(const p of f)y[p]=E(p);return y}e.createProxyObject=u}),define(Q[29],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(P){return O.test(P)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(S){for(let g=0;g<S.length;g++)S[g]=Math.floor(Math.random()*256);return S};const k=new Uint8Array(16),D=[];for(let S=0;S<256;S++)D.push(S.toString(16).padStart(2,"0"));return function(){P(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let g=0,c="";return c+=D[k[g++]],c+=D[k[g++]],c+=D[k[g++]],c+=D[k[g++]],c+="-",c+=D[k[g++]],c+=D[k[g++]],c+="-",c+=D[k[g++]],c+=D[k[g++]],c+="-",c+=D[k[g++]],c+=D[k[g++]],c+="-",c+=D[k[g++]],c+=D[k[g++]],c+=D[k[g++]],c+=D[k[g++]],c+=D[k[g++]],c+=D[k[g++]],c}}()}),define(Q[73],_([0,1,33]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(D){const S=D.replace(/\-/g,":").toLowerCase();return!R.has(S)}function k(){const D=(0,O.networkInterfaces)();for(const S in D){const g=D[S];if(g){for(const{mac:c}of g)if(P(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=k}),define(Q[74],_([8,9]),function(x,e){return x.create("vs/base/common/date",e)}),define(Q[75],_([0,1,74]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,P=R*60,k=P*24,D=k*7,S=k*30,g=k*365;function c(w,d,m,I){typeof w!="number"&&(w=w.getTime());const N=Math.round((new Date().getTime()-w)/1e3);if(N<-30)return(0,O.localize)(0,null,c(new Date().getTime()+N*1e3,!1));if(!I&&N<30)return(0,O.localize)(1,null);let u;return N<R?(u=N,d?u===1?m?(0,O.localize)(2,null,u):(0,O.localize)(3,null,u):m?(0,O.localize)(4,null,u):(0,O.localize)(5,null,u):u===1?m?(0,O.localize)(6,null,u):(0,O.localize)(7,null,u):m?(0,O.localize)(8,null,u):(0,O.localize)(9,null,u)):N<P?(u=Math.floor(N/R),d?u===1?m?(0,O.localize)(10,null,u):(0,O.localize)(11,null,u):m?(0,O.localize)(12,null,u):(0,O.localize)(13,null,u):u===1?m?(0,O.localize)(14,null,u):(0,O.localize)(15,null,u):m?(0,O.localize)(16,null,u):(0,O.localize)(17,null,u)):N<k?(u=Math.floor(N/P),d?u===1?m?(0,O.localize)(18,null,u):(0,O.localize)(19,null,u):m?(0,O.localize)(20,null,u):(0,O.localize)(21,null,u):u===1?m?(0,O.localize)(22,null,u):(0,O.localize)(23,null,u):m?(0,O.localize)(24,null,u):(0,O.localize)(25,null,u)):N<D?(u=Math.floor(N/k),d?u===1?(0,O.localize)(26,null,u):(0,O.localize)(27,null,u):u===1?(0,O.localize)(28,null,u):(0,O.localize)(29,null,u)):N<S?(u=Math.floor(N/D),d?u===1?m?(0,O.localize)(30,null,u):(0,O.localize)(31,null,u):m?(0,O.localize)(32,null,u):(0,O.localize)(33,null,u):u===1?m?(0,O.localize)(34,null,u):(0,O.localize)(35,null,u):m?(0,O.localize)(36,null,u):(0,O.localize)(37,null,u)):N<g?(u=Math.floor(N/S),d?u===1?m?(0,O.localize)(38,null,u):(0,O.localize)(39,null,u):m?(0,O.localize)(40,null,u):(0,O.localize)(41,null,u):u===1?m?(0,O.localize)(42,null,u):(0,O.localize)(43,null,u):m?(0,O.localize)(44,null,u):(0,O.localize)(45,null,u)):(u=Math.floor(N/g),d?u===1?m?(0,O.localize)(46,null,u):(0,O.localize)(47,null,u):m?(0,O.localize)(48,null,u):(0,O.localize)(49,null,u):u===1?m?(0,O.localize)(50,null,u):(0,O.localize)(51,null,u):m?(0,O.localize)(52,null,u):(0,O.localize)(53,null,u))}e.fromNow=c;function b(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(Q[76],_([8,9]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(Q[34],_([0,1,19,3,76]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function k(w,d){return d&&(w.stack||w.stacktrace)?P.localize(0,null,S(w),D(w.stack)||D(w.stacktrace)):S(w)}function D(w){return Array.isArray(w)?w.join(`
`):w}function S(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?P.localize(1,null,w.message):w.message||P.localize(2,null)}function g(w=null,d=!1){if(!w)return P.localize(3,null);if(Array.isArray(w)){const m=O.coalesce(w),I=g(m[0],d);return m.length>1?P.localize(4,null,I,m.length):I}if(R.isString(w))return w;if(w.detail){const m=w.detail;if(m.error)return k(m.error,d);if(m.exception)return k(m.exception,d)}return w.stack?k(w,d):w.message?w.message:P.localize(5,null)}e.toErrorMessage=g;function c(w){const d=w;return d instanceof Error&&Array.isArray(d.actions)}e.isErrorWithActions=c;function b(w,d){let m;return typeof w=="string"?m=new Error(w):m=w,m.actions=d,m}e.createErrorWithActions=b}),define(Q[77],_([8,9]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(Q[78],_([0,1,77]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function R(P){switch(P){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}e.getParseErrorMessage=R}),define(Q[50],_([0,1,12]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var P;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(P=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(S,...g){const c=g.reduce((d,m)=>(d[m]=!0,d),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(d=>!c[d]).forEach(d=>{for(let m=0;m<b.length;m++)if(d.search(b[m])!==-1){delete S[d];break}})}e.sanitizeProcessEnvironment=k;function D(S){!S||(delete S.DEBUG,O.isMacintosh&&delete S.DYLD_LIBRARY_PATH,O.isLinux&&delete S.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(Q[51],_([0,1,30]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(f){return P(f,0)}e.hash=R;function P(f,v){switch(typeof f){case"object":return f===null?k(349,v):Array.isArray(f)?g(f,v):c(f,v);case"string":return S(f,v);case"boolean":return D(f,v);case"number":return k(f,v);case"undefined":return k(937,v);default:return k(617,v)}}e.doHash=P;function k(f,v){return(v<<5)-v+f|0}e.numberHash=k;function D(f,v){return k(f?433:863,v)}function S(f,v){v=k(149417,v);for(let E=0,y=f.length;E<y;E++)v=k(f.charCodeAt(E),v);return v}e.stringHash=S;function g(f,v){return v=k(104579,v),f.reduce((E,y)=>P(y,E),v)}function c(f,v){return v=k(181387,v),Object.keys(f).sort().reduce((E,y)=>(E=S(y,E),P(f[y],E)),v)}class b{constructor(){this.g=0}get value(){return this.g}hash(v){return this.g=P(v,this.g),this.g}}e.Hasher=b;var w;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function d(f,v,E=32){const y=E-v,p=~((1<<y)-1);return(f<<v|(p&f)>>>y)>>>0}function m(f,v=0,E=f.byteLength,y=0){for(let p=0;p<E;p++)f[v+p]=y}function I(f,v,E="0"){for(;f.length<v;)f=E+f;return f}function N(f,v=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(E=>E.toString(16).padStart(2,"0")).join(""):I((f>>>0).toString(16),v/4)}e.toHexString=N;class u{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(v){const E=v.length;if(E===0)return;const y=this.p;let p=this.r,t=this.u,s,i;for(t!==0?(s=t,i=-1,t=0):(s=v.charCodeAt(0),i=0);;){let n=s;if(O.isHighSurrogate(s))if(i+1<E){const r=v.charCodeAt(i+1);O.isLowSurrogate(r)?(i++,n=O.computeCodePoint(s,r)):n=65533}else{t=s;break}else O.isLowSurrogate(s)&&(n=65533);if(p=this.w(y,p,n),i++,i<E)s=v.charCodeAt(i);else break}this.r=p,this.u=t}w(v,E,y){return y<128?v[E++]=y:y<2048?(v[E++]=192|(y&1984)>>>6,v[E++]=128|(y&63)>>>0):y<65536?(v[E++]=224|(y&61440)>>>12,v[E++]=128|(y&4032)>>>6,v[E++]=128|(y&63)>>>0):(v[E++]=240|(y&1835008)>>>18,v[E++]=128|(y&258048)>>>12,v[E++]=128|(y&4032)>>>6,v[E++]=128|(y&63)>>>0),E>=64&&(this.y(),E-=64,this.t+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),E}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),N(this.h)+N(this.l)+N(this.m)+N(this.n)+N(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const v=8*this.t;this.q.setUint32(56,Math.floor(v/4294967296),!1),this.q.setUint32(60,v%4294967296,!1),this.y()}y(){const v=u.g,E=this.q;for(let o=0;o<64;o+=4)v.setUint32(o,E.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)v.setUint32(o,d(v.getUint32(o-12,!1)^v.getUint32(o-32,!1)^v.getUint32(o-56,!1)^v.getUint32(o-64,!1),1),!1);let y=this.h,p=this.l,t=this.m,s=this.n,i=this.o,n,r,a;for(let o=0;o<80;o++)o<20?(n=p&t|~p&s,r=1518500249):o<40?(n=p^t^s,r=1859775393):o<60?(n=p&t|p&s|t&s,r=2400959708):(n=p^t^s,r=3395469782),a=d(y,5)+n+i+r+v.getUint32(o*4,!1)&4294967295,i=s,s=t,t=d(p,30),p=y,y=a;this.h=this.h+y&4294967295,this.l=this.l+p&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+i&4294967295}}u.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=u}),define(Q[52],_([0,1,30]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(R||(R={})),function(P){const k="error",D="warning",S="warn",g="info",c="ignore";function b(d){return d?O.equalsIgnoreCase(k,d)?P.Error:O.equalsIgnoreCase(D,d)||O.equalsIgnoreCase(S,d)?P.Warning:O.equalsIgnoreCase(g,d)?P.Info:P.Ignore:P.Ignore}P.fromValue=b;function w(d){switch(d){case P.Error:return k;case P.Warning:return D;case P.Info:return g;default:return c}}P.toString=w}(R||(R={})),e.default=R}),define(Q[79],_([0,1,11]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(c){const b=c;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=R;function P(c){const b=[];let w;try{const d=JSON.parse(c.arguments),m=d[d.length-1];m&&m.__$stack&&(d.pop(),w=m.__$stack),b.push(...d)}catch{b.push("Unable to log remote console arguments",c.arguments)}return{args:b,stack:w}}e.parse=P;function k(c){if(typeof c!="string")return k(P(c).stack);const b=c;if(b){const w=D(b),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(d&&d.length===4)return{uri:O.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=k;function D(c){if(!c)return c;const b=c.indexOf(`
`);return b===-1?c:c.substring(0,b)}function S(c,b){const{args:w,stack:d}=P(c),m=typeof w[0]=="string"&&w.length===1;let I=D(d);I&&(I=`(${I.trim()})`);let N=[];if(typeof w[0]=="string"?I&&m?N=[`%c[${b}] %c${w[0]} %c${I}`,g("blue"),g(""),g("grey")]:N=[`%c[${b}] %c${w[0]}`,g("blue"),g(""),...w.slice(1)]:N=[`%c[${b}]%`,g("blue"),...w],I&&!m&&N.push(I),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,N)}e.log=S;function g(c){return`color: ${c}`}}),define(Q[53],_([0,1,14,30,11]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(c){return JSON.stringify(c,S)}e.stringify=k;function D(c){let b=JSON.parse(c);return b=g(b),b}e.parse=D;function S(c,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,R.regExpFlags)(b)}:b}function g(c,b=0){if(!c||b>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return P.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof O.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let w=0;w<c.length;++w)c[w]=g(c[w],b+1);else for(const w in c)Object.hasOwnProperty.call(c,w)&&(c[w]=g(c[w],b+1))}return c}e.revive=g}),define(Q[80],_([0,1,33,7,54,29,73]),function(x,e,O,R,P,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(b){return this.a||(this.a=P.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,w=0;const d=(0,O.networkInterfaces)();for(const m in d){const I=d[m];if(I)for(const{mac:N,internal:u}of I)u||(w+=1,this.c(N.toUpperCase())&&(b+=1))}this.b=w>0?b/w:0}return this.b}};let S;async function g(){return S||(S=(async()=>await c()||k.generateUuid())()),S}e.getMachineId=g;async function c(){try{const b=await new Promise((d,m)=>{x(["crypto"],d,m)}),w=(0,D.getMac)();return b.createHash("sha256").update(w,"utf8").digest("hex")}catch(b){R.onUnexpectedError(b);return}}}),define(Q[81],_([0,1,33,15,20]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,D=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var g;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(g||(g={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class w{constructor(p,t,s){this.exePath=p,this.displayName=t,this.a=s}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:y=!1}={}){return y?c===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:y=!1,findPreview:p=!1}={}){const t=d({useAlternateBitness:y});if(!t)return null;const s=R.join(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(s))return null;let i=-1,n=null;for(const o of await P.Promises.readdir(s)){let l=-1;if(p){const A=o.indexOf("-");if(A<0)continue;const F=o.substring(0,A);if(!k.test(F)||o.substring(A+1)!=="preview")continue;l=parseInt(F,10)}else{if(!k.test(o))continue;l=parseInt(o,10)}if(l<=i)continue;const h=R.join(s,o,"pwsh.exe");!await P.SymlinkSupport.existsFile(h)||(n=h,i=l)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",a=p?" Preview":"";return new w(n,`PowerShell${a}${r}`,!0)}async function I({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const p=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(p))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=y?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await P.Promises.readdir(p))if(t.test(i)){const n=R.join(p,i,"pwsh.exe");return new w(n,s)}return null}function N(){const y=R.join(O.homedir(),".dotnet","tools","pwsh.exe");return new w(y,".NET Core PowerShell Global Tool")}function u(){const y=R.join(process.env.windir,c===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(y,"Windows PowerShell",!0)}async function*f(){let y=await m();y&&(yield y),y=await m({useAlternateBitness:!0}),y&&(yield y),y=await I(),y&&(yield y),y=N(),y&&(yield y),y=await m({findPreview:!0}),y&&(yield y),y=await I({findPreview:!0}),y&&(yield y),y=await m({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=u(),y&&(yield y)}async function*v(){for await(const y of f())await y.exists()&&(yield y)}e.enumeratePowerShellInstallations=v;async function E(){for await(const y of v())return y;return null}e.getFirstAvailablePowerShellInstallation=E}),define(Q[55],_([0,1,15,12,35,50,3,20]),function(x,e,O,R,P,k,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function g(w=P.env){return w.comspec||"cmd.exe"}e.getWindowsShell=g;function c(w){let d=[],m=!1;const I=function(N){if(m){d.push(N);return}(!w.send(N,f=>{if(f&&console.error(f),m=!1,d.length>0){const v=d.slice(0);d=[],v.forEach(E=>I(E))}})||R.isWindows)&&(m=!0)};return{send:I}}e.createQueuedSender=c;var b;(function(w){async function d(m,I,N){if(O.isAbsolute(m))return m;if(I===void 0&&(I=P.cwd()),O.dirname(m)!=="."||(N===void 0&&D.isString(P.env.PATH)&&(N=P.env.PATH.split(O.delimiter)),N===void 0||N.length===0))return O.join(I,m);async function f(v){if(await S.Promises.exists(v)){let E;try{E=await S.Promises.stat(v)}catch(y){y.message.startsWith("EACCES")&&(E=await S.Promises.lstat(v))}return E?!E.isDirectory():!1}return!1}for(const v of N){let E;if(O.isAbsolute(v)?E=O.join(v,m):E=O.join(I,v,m),await f(E))return E;let y=E+".com";if(await f(y)||(y=E+".exe",await f(y)))return y}return O.join(I,m)}w.findExecutable=d})(b=e.win32||(e.win32={}))}),define(Q[82],_([0,1,33,12,81,55]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function D(w,d){return w===1?R.isWindows?b():k.getWindowsShell(d):g(w,d)}e.getSystemShell=D;let S=null;function g(w,d){if(R.isLinux&&w===2||R.isMacintosh&&w===3)return"/bin/bash";if(!S){let m;if(R.isWindows)m="/bin/bash";else{if(m=d.SHELL,!m)try{m=(0,O.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}S=m}return S}let c=null;async function b(){return c||(c=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),c}});var he=this&&this.__decorate||function(x,e,O,R){var P=arguments.length,k=P<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,O):R,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(x,e,O,R);else for(var S=x.length-1;S>=0;S--)(D=x[S])&&(k=(P<3?D(k):P>3?D(e,O,k):D(e,O))||k);return P>3&&k&&Object.defineProperty(e,O,k),k};define(Q[56],_([0,1,19,5,14,23,48,7,4,2,53,30,3]),function(x,e,O,R,P,k,D,S,g,c,b,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var m;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(m||(m={}));function I(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var N;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(N||(N={}));function u(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(f||(f={}));function v(j){let M=0;for(let $=0;;$+=7){const W=j.read(1);if(M|=(W.buffer[0]&127)<<$,!(W.buffer[0]&128))return M}}const E=i(0);function y(j,M){if(M===0){j.write(E);return}let $=0;for(let q=M;q!==0;q=q>>>7)$++;const W=P.VSBuffer.alloc($);for(let q=0;M!==0;q++)W.buffer[q]=M&127,M=M>>>7,M>0&&(W.buffer[q]|=128);j.write(W)}class p{constructor(M){this.b=M,this.a=0}read(M){const $=this.b.slice(this.a,this.a+M);return this.a+=$.byteLength,$}}e.BufferReader=p;class t{constructor(){this.a=[]}get buffer(){return P.VSBuffer.concat(this.a)}write(M){this.a.push(M)}}e.BufferWriter=t;var s;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(s||(s={}));function i(j){const M=P.VSBuffer.alloc(1);return M.writeUInt8(j,0),M}const n={Undefined:i(s.Undefined),String:i(s.String),Buffer:i(s.Buffer),VSBuffer:i(s.VSBuffer),Array:i(s.Array),Object:i(s.Object),Uint:i(s.Int)},r=typeof Buffer<"u";function a(j,M){if(typeof M>"u")j.write(n.Undefined);else if(typeof M=="string"){const $=P.VSBuffer.fromString(M);j.write(n.String),y(j,$.byteLength),j.write($)}else if(r&&Buffer.isBuffer(M)){const $=P.VSBuffer.wrap(M);j.write(n.Buffer),y(j,$.byteLength),j.write($)}else if(M instanceof P.VSBuffer)j.write(n.VSBuffer),y(j,M.byteLength),j.write(M);else if(Array.isArray(M)){j.write(n.Array),y(j,M.length);for(const $ of M)a(j,$)}else if(typeof M=="number"&&(M|0)===M)j.write(n.Uint),y(j,M);else{const $=P.VSBuffer.fromString(JSON.stringify(M));j.write(n.Object),y(j,$.byteLength),j.write($)}}e.serialize=a;function o(j){switch(j.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return j.read(v(j)).toString();case s.Buffer:return j.read(v(j)).buffer;case s.VSBuffer:return j.read(v(j));case s.Array:{const $=v(j),W=[];for(let q=0;q<$;q++)W.push(o(j));return W}case s.Object:return JSON.parse(j.read(v(j)).toString());case s.Int:return v(j)}}e.deserialize=o;class l{constructor(M,$,W=null,q=1e3){this.h=M,this.j=$,this.k=W,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(M,$){this.b.set(M,$),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const $=this.o([M.type]);this.k?.logOutgoing($,0,1,u(M.type));return}case 201:case 202:case 204:case 203:{const $=this.o([M.type,M.id],M.data);this.k?.logOutgoing($,M.id,1,u(M.type),M.data);return}}}o(M,$=void 0){const W=new t;return a(W,M),a(W,$),this.p(W.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const $=new p(M),W=o($),q=o($),X=W[0];switch(X){case 100:return this.k?.logIncoming(M.byteLength,W[1],1,`${I(X)}: ${W[2]}.${W[3]}`,q),this.s({type:X,id:W[1],channelName:W[2],name:W[3],arg:q});case 102:return this.k?.logIncoming(M.byteLength,W[1],1,`${I(X)}: ${W[2]}.${W[3]}`,q),this.t({type:X,id:W[1],channelName:W[2],name:W[3],arg:q});case 101:return this.k?.logIncoming(M.byteLength,W[1],1,`${I(X)}`),this.u({type:X,id:W[1]});case 103:return this.k?.logIncoming(M.byteLength,W[1],1,`${I(X)}`),this.u({type:X,id:W[1]})}}s(M){const $=this.b.get(M.channelName);if(!$){this.v(M);return}const W=new k.CancellationTokenSource;let q;try{q=$.call(this.j,M.name,M.arg,W.token)}catch(L){q=Promise.reject(L)}const X=M.id;q.then(L=>{this.m({id:X,data:L,type:201}),this.d.delete(M.id)},L=>{L instanceof Error?this.m({id:X,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.m({id:X,data:L,type:203}),this.d.delete(M.id)});const C=(0,c.toDisposable)(()=>W.cancel());this.d.set(M.id,C)}t(M){const $=this.b.get(M.channelName);if(!$){this.v(M);return}const W=M.id,X=$.listen(this.j,M.name,M.arg)(C=>this.m({id:W,data:C,type:204}));this.d.set(M.id,X)}u(M){const $=this.d.get(M.id);$&&($.dispose(),this.d.delete(M.id))}v(M){let $=this.g.get(M.channelName);$||($=[],this.g.set(M.channelName,$));const W=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);$.push({request:M,timeoutTimer:W})}w(M){const $=this.g.get(M);if($){for(const W of $)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.s(W.request);break;case 102:this.t(W.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=l;var h;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(M,$=null){this.l=M,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(W=>this.s(W)),this.j=$}getChannel(M){const $=this;return{call(W,q,X){return $.a?Promise.reject(new S.CancellationError):$.m(M,W,q,X)},listen(W,q){return $.a?g.Event.None:$.o(M,W,q)}}}m(M,$,W,q=k.CancellationToken.None){const X=this.g++,L={id:X,type:100,channelName:M,name:$,arg:W};if(q.isCancellationRequested)return Promise.reject(new S.CancellationError);let T;return new Promise((z,G)=>{if(q.isCancellationRequested)return G(new S.CancellationError);const H=()=>{const me=ce=>{switch(ce.type){case 201:this.f.delete(X),z(ce.data);break;case 202:{this.f.delete(X);const ge=new Error(ce.data.message);ge.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,ge.name=ce.data.name,G(ge);break}case 203:this.f.delete(X),G(ce.data);break}};this.f.set(X,me),this.p(L)};let re=null;this.b===f.Idle?H():(re=(0,R.createCancelablePromise)(me=>this.u()),re.then(()=>{re=null,H()}));const le=()=>{re?(re.cancel(),re=null):this.p({id:X,type:101}),G(new S.CancellationError)},ye=q.onCancellationRequested(le);T=(0,c.combinedDisposable)((0,c.toDisposable)(le),ye),this.d.add(T)}).finally(()=>{this.d.delete(T)})}o(M,$,W){const q=this.g++,C={id:q,type:102,channelName:M,name:$,arg:W};let L=null;const T=new g.Emitter({onWillAddFirstListener:()=>{L=(0,R.createCancelablePromise)(z=>this.u()),L.then(()=>{L=null,this.d.add(T),this.p(C)})},onDidRemoveLastListener:()=>{L?(L.cancel(),L=null):(this.d.delete(T),this.p({id:q,type:103}))}}),U=z=>T.fire(z.data);return this.f.set(q,U),T.event}p(M){switch(M.type){case 100:case 102:{const $=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing($,M.id,0,`${I(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const $=this.q([M.type,M.id]);this.j?.logOutgoing($,M.id,0,I(M.type));return}}}q(M,$=void 0){const W=new t;return a(W,M),a(W,$),this.r(W.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const $=new p(M),W=o($),q=o($),X=W[0];switch(X){case 200:return this.j?.logIncoming(M.byteLength,0,0,u(X)),this.t({type:W[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,W[1],0,u(X),q),this.t({type:W[0],id:W[1],data:q})}}t(M){if(M.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.dispose)(this.d.values()),this.d.clear()}}he([D.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class F{get connections(){const M=[];return this.f.forEach($=>M.push($)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new g.Emitter,this.onDidAddConnection=this.g.event,this.h=new g.Emitter,this.onDidRemoveConnection=this.h.event,M(({protocol:$,onDidClientDisconnect:W})=>{g.Event.once($.onMessage)(X=>{const C=new p(X),L=o(C),T=new l($,L),U=new A($);this.a.forEach((G,H)=>T.registerChannel(H,G));const z={channelServer:T,channelClient:U,ctx:L};this.f.add(z),this.g.fire(z),W(()=>{T.dispose(),U.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel(M,$){const W=this;return{call(q,X,C){let L;if((0,d.isFunction)($)){const U=(0,O.getRandomElement)(W.connections.filter($));L=U?Promise.resolve(U):g.Event.toPromise(g.Event.filter(W.onDidAddConnection,$))}else L=$.routeCall(W,q,X);const T=L.then(U=>U.channelClient.getChannel(M));return ee(T).call(q,X,C)},listen(q,X){if((0,d.isFunction)($))return W.j(M,$,q,X);const C=$.routeEvent(W,q,X).then(L=>L.channelClient.getChannel(M));return ee(C).listen(q,X)}}}j(M,$,W,q){const X=this;let C=new c.DisposableStore;const L=new g.Emitter({onWillAddFirstListener:()=>{C=new c.DisposableStore;const T=new g.EventMultiplexer,U=new Map,z=H=>{const le=H.channelClient.getChannel(M).listen(W,q),ye=T.add(le);U.set(H,ye)},G=H=>{const re=U.get(H);!re||(re.dispose(),U.delete(H))};X.connections.filter($).forEach(z),g.Event.filter(X.onDidAddConnection,$)(z,void 0,C),X.onDidRemoveConnection(G,void 0,C),T.event(L.fire,L,C),C.add(T)},onDidRemoveLastListener:()=>{C.dispose()}});return L.event}registerChannel(M,$){this.a.set(M,$),this.f.forEach(W=>{W.channelServer.registerChannel(M,$)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=F;class Y{constructor(M,$,W=null){const q=new t;a(q,$),M.send(q.buffer),this.a=new A(M,W),this.d=new l(M,$,W)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,$){this.d.registerChannel(M,$)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=Y;function ee(j){return{call(M,$,W){return j.then(q=>q.call(M,$,W))},listen(M,$){const W=new g.Relay;return j.then(q=>W.input=q.listen(M,$)),W.event}}}e.getDelayedChannel=ee;function te(j){let M=!1;return{call($,W,q){return M?j.call($,W,q):(0,R.timeout)(0).then(()=>M=!0).then(()=>j.call($,W,q))},listen($,W){if(M)return j.listen($,W);const q=new g.Relay;return(0,R.timeout)(0).then(()=>M=!0).then(()=>q.input=j.listen($,W)),q.event}}}e.getNextTickChannel=te;class ie{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const $ of M.connections)if(await Promise.resolve(this.a($.ctx)))return Promise.resolve($);return await g.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.StaticRouter=ie;var ne;(function(j){function M(X,C){const L=X,T=C&&C.disableMarshalling,U=new Map;for(const z in L)W(z)&&U.set(z,g.Event.buffer(L[z],!0));return new class{listen(z,G,H){const re=U.get(G);if(re)return re;if(q(G)){const le=L[G];if(typeof le=="function")return le.call(L,H)}throw new Error(`Event not found: ${G}`)}call(z,G,H){const re=L[G];if(typeof re=="function"){if(!T&&Array.isArray(H))for(let le=0;le<H.length;le++)H[le]=(0,b.revive)(H[le]);return re.apply(L,H)}throw new Error(`Method not found: ${G}`)}}}j.fromService=M;function $(X,C){const L=C&&C.disableMarshalling;return new Proxy({},{get(T,U){if(typeof U=="string")return C?.properties?.has(U)?C.properties.get(U):q(U)?function(z){return X.listen(U,z)}:W(U)?X.listen(U):async function(...z){let G;C&&!(0,d.isUndefinedOrNull)(C.context)?G=[C.context,...z]:G=z;const H=await X.call(U,G);return L?H:(0,b.revive)(H)};throw new Error(`Property not found: ${String(U)}`)}})}j.toService=$;function W(X){return X[0]==="o"&&X[1]==="n"&&w.isUpperAsciiLetter(X.charCodeAt(2))}function q(X){return/^onDynamic/.test(X)&&w.isUpperAsciiLetter(X.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const M=j.toString();if(M!=="[object Object]")return M}return j}function oe(j){return Array.isArray(j)?j.map(fe):fe(j)}function ve(j,M,$,W,q,X,C){C=oe(C);const L=ae[q],T=L[W%L.length];let U=[`%c[${j}]%c[${String(M).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${T}`];/\($/.test(X)?(U=U.concat(C),U.push(")")):U.push(C),console.log.apply(console,U)}class V{constructor(M,$){this.d=M,this.f=$,this.a=0,this.b=0}logOutgoing(M,$,W,q,X){this.b+=M,ve(this.d,this.b,M,$,W,q,X)}logIncoming(M,$,W,q,X){this.a+=M,ve(this.f,this.a,M,$,W,q,X)}}e.IPCLogger=V}),define(Q[83],_([0,1,57,5,14,23,79,7,4,2,28,55,50,56]),function(x,e,O,R,P,k,D,S,g,c,b,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class I extends m.ChannelServer{constructor(f){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",v=>P.VSBuffer.wrap(Buffer.from(v,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=I;class N{constructor(f,v){this.i=f,this.j=v,this.c=new Set,this.g=new Map,this.h=new g.Emitter,this.onDidProcessExit=this.h.event;const E=v&&v.timeout?v.timeout:6e4;this.b=new R.Delayer(E),this.d=null,this.f=null}getChannel(f){const v=this;return{call(E,y,p){return v.k(f,E,y,p)},listen(E,y){return v.l(f,E,y)}}}k(f,v,E,y=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(S.canceled());this.b.cancel();const p=this.n(f),t=(0,R.createCancelablePromise)(n=>p.call(v,E,n)),s=y.onCancellationRequested(()=>t.cancel()),i=(0,c.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{s.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,v,E){if(!this.b)return g.Event.None;this.b.cancel();let y;const p=new g.Emitter({onWillAddFirstListener:()=>{y=this.n(f).listen(v,E)(p.fire,p),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return p.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],v=Object.create(null);v.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(v.env={...v.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(v.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,d.removeDangerousEnvVariables)(v.env),this.d=(0,O.fork)(this.i,f,v);const E=new g.Emitter;g.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,D.isRemoteConsoleLog)(r)){(0,D.log)(r,`IPC Library: ${this.j.serverName}`);return}E.fire(P.VSBuffer.wrap(Buffer.from(r,"base64")))});const p=this.j.useQueue?(0,w.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&p.send(r.buffer.toString("base64")),s=E.event,i={send:t,onMessage:s};this.f=new m.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,a)=>{process.removeListener("exit",n),this.c.forEach(o=>(0,c.dispose)(o)),this.c.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:a})})}return this.f}n(f){let v=this.g.get(f);return v||(v=this.m.getChannel(f),this.g.set(f,v)),v}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=N}),define(Q[84],_([0,1,5,4,2,3]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D=e.StorageHint||(e.StorageHint={}));function S(w){const d=w;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=S;var g;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class c extends P.Disposable{constructor(d,m=Object.create(null)){super(),this.m=d,this.n=m,this.b=this.B(new R.Emitter),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=new O.ThrottledDelayer(c.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(d=>this.r(d)))}r(d){d.changed?.forEach((m,I)=>this.s(I,m)),d.deleted?.forEach(m=>this.s(m,void 0))}s(d,m){if(this.c===g.Closed)return;let I=!1;(0,k.isUndefinedOrNull)(m)?I=this.f.delete(d):this.f.get(d)!==m&&(this.f.set(d,m),I=!0),I&&this.b.fire(d)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.n.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(d,m){const I=this.f.get(d);return(0,k.isUndefinedOrNull)(I)?m:I}getBoolean(d,m){const I=this.get(d);return(0,k.isUndefinedOrNull)(I)?m:I==="true"}getNumber(d,m){const I=this.get(d);return(0,k.isUndefinedOrNull)(I)?m:parseInt(I,10)}async set(d,m){if(this.c===g.Closed)return;if((0,k.isUndefinedOrNull)(m))return this.delete(d);const I=String(m);if(this.f.get(d)!==I)return this.f.set(d,I),this.j.set(d,I),this.h.delete(d),this.b.fire(d),this.w()}async delete(d){if(!(this.c===g.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire(d),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=g.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(d).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(d){if(!!this.u)return this.w(d)}async w(d){return this.g.trigger(()=>this.v(),d)}async whenFlushed(){if(!!this.u)return new Promise(d=>this.l.push(d))}isInMemory(){return this.n.hint===D.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}c.a=100,e.Storage=c;class b{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((m,I)=>this.a.set(I,m)),d.delete?.forEach(m=>this.a.delete(m))}async close(){}}e.InMemoryStorageDatabase=b}),define(Q[85],_([8,9]),function(x,e){return x.create("vs/base/node/zip",e)}),define(Q[86],_([8,9]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[87],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Q[88],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[89],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Q[90],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Q[91],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Q[92],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Q[93],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Q[94],_([8,9]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[95],_([8,9]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(Q[96],_([8,9]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(Q[97],_([8,9]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[98],_([8,9]),function(x,e){return x.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Q[99],_([8,9]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(Q[100],_([8,9]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(Q[101],_([8,9]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[102],_([8,9]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Q[103],_([8,9]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(Q[104],_([0,1,75,48,16,15,35,18,11]),function(x,e,O,R,P,k,D,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,k.dirname)(P.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,S.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,S.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,k.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.joinPath)(g.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=D.env.VSCODE_PORTABLE;return m?g.URI.file((0,k.join)(m,"argv.json")):(0,S.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,k.resolve)(m):(0,k.normalize)((0,k.join)(P.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?g.URI.file((0,k.resolve)(m)):g.URI.file((0,k.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,k.resolve)(m);const I=D.env.VSCODE_EXTENSIONS;if(I)return I;const N=D.env.VSCODE_PORTABLE;return N?(0,k.join)(N,"extensions"):(0,S.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(I=>/^[^:/?#]+?:\/\//.test(I)?g.URI.parse(I):g.URI.file((0,k.normalize)(I)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?g.URI.parse(m):g.URI.file((0,k.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(m))}get extensionLogLevel(){const m=[];for(const I of this.args.log||[]){const N=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(I);N&&N[1]&&N[2]&&m.push([N[1],N[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,S.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=D.env.VSCODE_PORTABLE;return m?g.URI.file((0,k.join)(m,"policy.json")):(0,S.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,I,N){this.a=m,this.b=I,this.c=N,this.editSessionId=this.args.editSessionId}}he([R.memoize],c.prototype,"appRoot",null),he([R.memoize],c.prototype,"userHome",null),he([R.memoize],c.prototype,"userDataPath",null),he([R.memoize],c.prototype,"appSettingsHome",null),he([R.memoize],c.prototype,"tmpDir",null),he([R.memoize],c.prototype,"cacheHome",null),he([R.memoize],c.prototype,"stateResource",null),he([R.memoize],c.prototype,"userRoamingDataHome",null),he([R.memoize],c.prototype,"userDataSyncHome",null),he([R.memoize],c.prototype,"userDataSyncLogResource",null),he([R.memoize],c.prototype,"editSessionsLogResource",null),he([R.memoize],c.prototype,"sync",null),he([R.memoize],c.prototype,"machineSettingsResource",null),he([R.memoize],c.prototype,"workspaceStorageHome",null),he([R.memoize],c.prototype,"localHistoryHome",null),he([R.memoize],c.prototype,"keyboardLayoutResource",null),he([R.memoize],c.prototype,"argvResource",null),he([R.memoize],c.prototype,"isExtensionDevelopment",null),he([R.memoize],c.prototype,"untitledWorkspacesHome",null),he([R.memoize],c.prototype,"installSourcePath",null),he([R.memoize],c.prototype,"builtinExtensionsPath",null),he([R.memoize],c.prototype,"extensionsPath",null),he([R.memoize],c.prototype,"extensionDevelopmentLocationURI",null),he([R.memoize],c.prototype,"extensionDevelopmentKind",null),he([R.memoize],c.prototype,"extensionTestsLocationURI",null),he([R.memoize],c.prototype,"debugExtensionHost",null),he([R.memoize],c.prototype,"logLevel",null),he([R.memoize],c.prototype,"extensionLogLevel",null),he([R.memoize],c.prototype,"serviceMachineIdResource",null),he([R.memoize],c.prototype,"telemetryLogResource",null),he([R.memoize],c.prototype,"disableWorkspaceTrust",null),he([R.memoize],c.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=c;function b(d,m){return w(d["inspect-extensions"],d["inspect-brk-extensions"],5870,m,d.debugId,d.extensionEnvironment)}e.parseExtensionHostDebugPort=b;function w(d,m,I,N,u,f){const E=Number(m||d)||(N?null:I),y=E?Boolean(!!m):!1;let p;if(f)try{p=JSON.parse(f)}catch{}return{port:E,break:y,debugId:u,env:p}}e.parseDebugParams=w}),function(){"use strict";function x(e,O,R){function P(D,S){const g=k(D,S),c=[g];return e.isAbsolute(g)||c.unshift(R),e.resolve(...c)}function k(D,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,S);const b=D["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(w,"AppData","Roaming")}break;case"darwin":c=e.join(O.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,S)}return{getUserDataPath:P}}if(typeof define=="function")define(Q[105],_([157,33,35]),function(e,O,R){return x(e,O,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=x(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[106],_([0,1,33,104,105]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class k extends R.AbstractNativeEnvironmentService{constructor(c,b){super(c,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,P.getUserDataPath)(c,b.nameShort)},b)}}e.NativeEnvironmentService=k;function D(g,c){return(0,R.parseDebugParams)(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,c,g.extensionEnvironment)}e.parsePtyHostDebugPort=D;function S(g,c){return(0,R.parseDebugParams)(g["inspect-sharedprocess"],g["inspect-brk-sharedprocess"],5879,c,g.extensionEnvironment)}e.parseSharedProcessDebugPort=S}),define(Q[107],_([0,1,3,90]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function P(D,S,g){try{k(D,S,g)}catch(c){console.error(c?.message??c)}return D}e.localizeManifest=P;function k(D,S,g){const c=(b,w,d)=>{const m=b[w];if((0,O.isString)(m)){const I=m,N=I.length;if(N>1&&I[0]==="%"&&I[N-1]==="%"){const u=I.substr(1,N-2);let f=S[u];f===void 0&&g&&(f=g[u]);const v=typeof f=="string"?f:f?.message,E=g?.[u],y=typeof E=="string"?E:E?.message;if(!v){y||console.warn(`[${D.name}]: ${(0,R.localize)(0,null,u)}`);return}if(d&&(w==="title"||w==="category")&&y&&y!==v){const p={value:v,original:y};b[w]=p}else b[w]=v}}else if((0,O.isObject)(m))for(const I in m)m.hasOwnProperty(I)&&(I==="commands"?c(m,I,!0):c(m,I,d));else if(Array.isArray(m))for(let I=0;I<m.length;I++)c(m,I,d)};for(const b in D)D.hasOwnProperty(b)&&c(D,b)}}),define(Q[108],_([0,1,7]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class R{constructor(){this.a=new Map}register(k,D){this.a.set(k,D)}updateManifest(k){if(!(typeof k.main>"u"&&typeof k.browser>"u")&&(k.activationEvents===void 0&&Object.assign(k,{activationEvents:[]}),!(!Array.isArray(k.activationEvents)||!k.contributes)))for(const D in k.contributes){const S=this.a.get(D);if(!S)continue;const g=k.contributes[D],c=Array.isArray(g)?g:[g];try{S(c,k.activationEvents)}catch(b){(0,O.onUnexpectedError)(b)}}}}e.ImplicitActivationEventsImpl=R,e.ImplicitActivationEvents=new R}),define(Q[44],_([0,1,18,52,94,41]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function g(f){return f=f.trim(),f==="*"||D.test(f)}e.isValidVersionStr=g;function c(f){if(!g(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=f.match(D);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=c;function b(f){if(!f)return null;const v=f.majorBase,E=f.majorMustEqual,y=f.minorBase;let p=f.minorMustEqual;const t=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(v===0||(p=!1),s=!1);let i=0;if(f.preRelease){const n=S.exec(f.preRelease);if(n){const[,r,a,o]=n;i=Date.UTC(Number(r),Number(a)-1,Number(o))}}return{majorBase:v,majorMustEqual:E,minorBase:y,minorMustEqual:p,patchBase:t,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:i}}e.normalizeVersion=b;function w(f,v,E){let y;typeof f=="string"?y=b(c(f)):y=f;let p;v instanceof Date?p=v.getTime():typeof v=="string"&&(p=new Date(v).getTime());let t;if(typeof E=="string"?t=b(c(E)):t=E,!y||!t)return!1;const s=y.majorBase,i=y.minorBase,n=y.patchBase;let r=t.majorBase,a=t.minorBase,o=t.patchBase;const l=t.notBefore;let h=t.majorMustEqual,A=t.minorMustEqual,F=t.patchMustEqual;return t.isMinimum?s>r?!0:s<r?!1:i>a?!0:i<a||p&&p<l?!1:n>=o:(s===1&&r===0&&(!h||!A||!F)&&(r=1,a=0,o=0,h=!0,A=!1,F=!1),s<r?!1:s>r?!h:i<a?!1:i>a?!A:n<o?!1:n>o?!F:!(p&&p<l))}e.isValidVersion=w;function d(f,v,E,y,p){const t=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return t.push([R.default.Error,P.localize(0,null)]),t;if(typeof y.name!="string")return t.push([R.default.Error,P.localize(1,null,"name")]),t;if(typeof y.version!="string")return t.push([R.default.Error,P.localize(2,null,"version")]),t;if(!y.engines)return t.push([R.default.Error,P.localize(3,null,"engines")]),t;if(typeof y.engines.vscode!="string")return t.push([R.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof y.extensionDependencies<"u"&&!u(y.extensionDependencies))return t.push([R.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof y.activationEvents<"u"){if(!u(y.activationEvents))return t.push([R.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof y.main>"u"&&typeof y.browser>"u")return t.push([R.default.Error,P.localize(7,null,"activationEvents","main")]),t}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&t.push([R.default.Warning,P.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return t.push([R.default.Error,P.localize(9,null,"main")]),t;{const n=(0,O.joinPath)(E,y.main);(0,O.isEqualOrParent)(n,E)||t.push([R.default.Warning,P.localize(10,null,n.path,E.path)])}if(typeof y.activationEvents>"u")return t.push([R.default.Error,P.localize(11,null,"activationEvents","main")]),t}if(typeof y.browser<"u"){if(typeof y.browser!="string")return t.push([R.default.Error,P.localize(12,null,"browser")]),t;{const n=(0,O.joinPath)(E,y.browser);(0,O.isEqualOrParent)(n,E)||t.push([R.default.Warning,P.localize(13,null,n.path,E.path)])}if(typeof y.activationEvents>"u")return t.push([R.default.Error,P.localize(14,null,"activationEvents","browser")]),t}if(!k.valid(y.version))return t.push([R.default.Error,P.localize(15,null)]),t;const s=[];if(!m(f,v,y,p,s))for(const n of s)t.push([R.default.Error,n]);return t}e.validateExtensionManifest=d;function m(f,v,E,y,p){return y||typeof E.main>"u"&&typeof E.browser>"u"?!0:N(f,v,E.engines.vscode,p)}e.isValidExtensionVersion=m;function I(f,v,E){return f==="*"||N(v,E,f)}e.isEngineValid=I;function N(f,v,E,y=[]){const p=b(c(E));if(!p)return y.push(P.localize(16,null,E)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return y.push(P.localize(17,null,E)),!1}else if(!p.majorMustEqual)return y.push(P.localize(18,null,E)),!1;return w(f,v,p)?!0:(y.push(P.localize(19,null,f,E)),!1)}function u(f){if(!Array.isArray(f))return!1;for(let v=0,E=f.length;v<E;v++)if(typeof f[v]!="string")return!1;return!0}}),define(Q[109],_([0,1,14,29]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function P(k,D,S){let g=S&&S.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const b=(await D.readFile(k.serviceMachineIdResource)).value.toString();g=(0,R.isUUID)(b)?b:null}catch{g=null}if(!g){g=(0,R.generateUuid)();try{await D.writeFile(k.serviceMachineIdResource,O.VSBuffer.fromString(g))}catch{}}return S?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=P}),define(Q[45],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class O{constructor(P,k=[],D=!1){this.ctor=P,this.staticArguments=k,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=O}),define(Q[110],_([0,1,45]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var P;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(P=e.InstantiationType||(e.InstantiationType={}));function k(S,g,c){g instanceof O.SyncDescriptor||(g=new O.SyncDescriptor(g,[],Boolean(c))),R.push([S,g])}e.registerSingleton=k;function D(){return R}e.getSingletonServiceDescriptors=D}),define(Q[111],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class O{constructor(k,D){this.key=k,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=O;class R{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const D of this.a.values())D.outgoing.size===0&&k.push(D);return k}insertEdge(k,D){const S=this.lookupOrInsertNode(k),g=this.lookupOrInsertNode(D);S.outgoing.set(g.key,g),g.incoming.set(S.key,S)}removeNode(k){const D=this.b(k);this.a.delete(D);for(const S of this.a.values())S.outgoing.delete(D),S.incoming.delete(D)}lookupOrInsertNode(k){const D=this.b(k);let S=this.a.get(D);return S||(S=new O(D,k),this.a.set(D,S)),S}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[D,S]of this.a)k.push(`${D}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,D]of this.a){const S=new Set([k]),g=this.c(D,S);if(g)return g}}c(k,D){for(const[S,g]of k.outgoing){if(D.has(S))return[...D,S].join(" -> ");D.add(S);const c=this.c(g,D);if(c)return c;D.delete(S)}}}e.Graph=R}),define(Q[24],_([0,1,3,11,10]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function k(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof R.URI)}e.isConfigurationOverrides=k;function D(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=D;var S;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(S=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function c(u,f){const v=Object.create(null);for(const E in u)b(v,E,u[E],f);return v}e.toValuesTree=c;function b(u,f,v,E){const y=f.split("."),p=y.pop();let t=u;for(let s=0;s<y.length;s++){const i=y[s];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:E(`Ignoring ${f} as ${y.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[p]=v}catch{E(`Ignoring ${f} as ${y.join(".")} is ${JSON.stringify(t)}`)}else E(`Ignoring ${f} as ${y.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=b;function w(u,f){const v=f.split(".");d(u,v)}e.removeFromValueTree=w;function d(u,f){const v=f.shift();if(f.length===0){delete u[v];return}if(Object.keys(u).indexOf(v)!==-1){const E=u[v];typeof E=="object"&&!Array.isArray(E)&&(d(E,f),Object.keys(E).length===0&&delete u[v])}}function m(u,f,v){function E(t,s){let i=t;for(const n of s){if(typeof i!="object"||i===null)return;i=i[n]}return i}const y=f.split("."),p=E(u,y);return typeof p>"u"?v:p}e.getConfigurationValue=m;function I(u,f,v){Object.keys(f).forEach(E=>{E!=="__proto__"&&(E in u?O.isObject(u[E])&&O.isObject(f[E])?I(u[E],f[E],v):v&&(u[E]=f[E]):u[E]=f[E])})}e.merge=I;function N(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=N}),define(Q[58],_([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,O.createDecorator)("downloadService")}),define(Q[17],_([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,O.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,O.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[21],_([0,1,88,10]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function P(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function k(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function D(f,v){switch(f){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function S(f,v){return v==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=S;function g(f,v,E){return S(v,E)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===E?!0:c(E).includes(f)}e.isTargetPlatformCompatible=g;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function b(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=b;var w;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var d;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var m;(function(f){f.Install="install",f.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var I;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(I=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var N;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(N=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(v,E){super(v),this.code=E,this.name=E}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,O.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,O.localize)(1,null),original:"Preferences"}}),define(Q[59],_([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,O.createDecorator)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((k,D)=>x(["node-vsce-sign"],async S=>k(S),D))),this.a}async verify(k,D){let S;try{S=await this.b()}catch{return!1}return S.verify(k,D)}}e.ExtensionSignatureVerificationService=R}),define(Q[60],_([0,1,14,7,96,13]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(b,w,d,m,I,N){let u;try{await S(b,w,d,m,I,N)}catch(f){u=f}finally{u&&I.errorTransformer&&(u=I.errorTransformer(u)),typeof u<"u"&&d.error(u),d.end()}}e.readFileIntoStream=D;async function S(b,w,d,m,I,N){g(N);const u=await b.open(w,{create:!1});try{g(N);let f=0,v=0,E=I&&typeof I.length=="number"?I.length:void 0,y=O.VSBuffer.alloc(Math.min(I.bufferSize,typeof E=="number"?E:I.bufferSize)),p=I&&typeof I.position=="number"?I.position:0,t=0;do v=await b.read(u,p,y.buffer,t,y.byteLength-t),p+=v,t+=v,f+=v,typeof E=="number"&&(E-=v),t===y.byteLength&&(await d.write(m(y)),y=O.VSBuffer.alloc(Math.min(I.bufferSize,typeof E=="number"?E:I.bufferSize)),t=0);while(v>0&&(typeof E!="number"||E>0)&&g(N)&&c(f,I));if(t>0){let s=t;typeof E=="number"&&(s=Math.min(t,E)),d.write(m(y.slice(0,s)))}}catch(f){throw(0,k.ensureFileSystemProviderError)(f)}finally{await b.close(u)}}function g(b){if(b.isCancellationRequested)throw(0,R.canceled)();return!0}function c(b,w){if(w?.limits){if(typeof w.limits.memory=="number"&&b>w.limits.memory)throw(0,k.createFileSystemProviderError)((0,P.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&b>w.limits.size)throw(0,k.createFileSystemProviderError)((0,P.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[112],_([0,1,4,158,2,12,159]),function(x,e,O,R,P,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class S extends P.Disposable{constructor(){super(...arguments),this.a=this.B(new O.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new O.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=O.Event.None,this.c=new Map,this.f=!1}async watch(c){const b=this.i(c),w=b.filter(m=>{const I=this.c.get(m.path);return I?!(0,R.patternsEquals)(I.request.excludes,m.excludes)||!(0,R.patternsEquals)(I.request.includes,m.includes):!0}),d=Array.from(this.c.values()).filter(({request:m})=>!b.find(I=>I.path===m.path&&(0,R.patternsEquals)(I.excludes,m.excludes)&&(0,R.patternsEquals)(I.includes,m.includes))).map(({request:m})=>m.path);w.length&&this.j(`Request to start watching: ${w.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"})`).join(",")}`),d.length&&this.j(`Request to stop watching: ${d.join(",")}`);for(const m of d)this.h(m);for(const m of w)this.g(m)}g(c){const b=new D.NodeJSFileWatcherLibrary(c,d=>this.a.fire(d),d=>this.b.fire(d),this.f),w={request:c,instance:b};this.c.set(c.path,w)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const b=this.c.get(c);b&&(this.c.delete(c),b.instance.dispose())}i(c){const b=new Map;for(const w of c){const d=k.isLinux?w.path:w.path.toLowerCase();b.set(d,w)}return Array.from(b.values())}async setVerboseLogging(c){this.f=c;for(const[,b]of this.c)b.instance.setVerboseLogging(c)}j(c){this.f&&this.b.fire({type:"trace",message:this.k(c)})}k(c,b){return b?`[File Watcher (node.js)] ${c} (path: ${b.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=S}),define(Q[113],_([0,1,61,112]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class P extends O.AbstractNonRecursiveWatcherClient{constructor(D,S,g){super(D,S,g),this.m()}l(){return new R.NodeJSWatcher}}e.NodeJSWatcherClient=P}),define(Q[114],_([0,1,16,56,83,61]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends k.AbstractUniversalWatcherClient{constructor(g,c,b){super(g,c,b),this.m()}l(g){const c=g.add(new P.Client(O.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(c.onDidProcessExit(({code:b,signal:w})=>this.n(`terminated by itself with code ${b}, signal: ${w}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(Q[62],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class O{constructor(...P){this.a=new Map;for(const[k,D]of P)this.set(k,D)}set(P,k){const D=this.a.get(P);return this.a.set(P,k),D}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.ServiceCollection=O}),define(Q[115],_([0,1,5,7,2,45,111,10,62,160]),function(x,e,O,R,P,k,D,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class w extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class d{constructor(u=new g.ServiceCollection,f=!1,v,E=b){this.f=u,this.g=f,this.h=v,this.i=E,this.o=new Set,this.f.set(S.IInstantiationService,this),this._globalGraph=E?v?._globalGraph??new D.Graph(y=>y):void 0}createChild(u){return new d(u,this.g,this,this.i)}invokeFunction(u,...f){const v=I.traceInvocation(this.i,u);let E=!1;try{return u({get:p=>{if(E)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(p,v);if(!t)throw new Error(`[invokeFunction] unknown service '${p}'`);return t}},...f)}finally{E=!0,v.stop()}}createInstance(u,...f){let v,E;return u instanceof k.SyncDescriptor?(v=I.traceCreation(this.i,u.ctor),E=this.j(u.ctor,u.staticArguments.concat(f),v)):(v=I.traceCreation(this.i,u),E=this.j(u,f,v)),v.stop(),E}j(u,f=[],v){const E=S._util.getServiceDependencies(u).sort((t,s)=>t.index-s.index),y=[];for(const t of E){const s=this.m(t.id,v);s||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),y.push(s)}const p=E.length>0?E[0].index:f.length;if(f.length!==p){console.trace(`[createInstance] First service dependency of ${u.name} at position ${p+1} conflicts with ${f.length} static arguments`);const t=p-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,p)}return Reflect.construct(u,f.concat(y))}k(u,f){if(this.f.get(u)instanceof k.SyncDescriptor)this.f.set(u,f);else if(this.h)this.h.k(u,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const f=this.f.get(u);return!f&&this.h?this.h.l(u):f}m(u,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const v=this.l(u);return v instanceof k.SyncDescriptor?this.q(u,v,f.branch(u,!0)):(f.branch(u,!1),v)}q(u,f,v){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,f,v)}finally{this.o.delete(u)}}r(u,f,v){const E=new D.Graph(t=>t.id.toString());let y=0;const p=[{id:u,desc:f,_trace:v}];for(;p.length;){const t=p.pop();if(E.lookupOrInsertNode(t),y++>1e3)throw new w(E);for(const s of S._util.getServiceDependencies(t.desc.ctor)){const i=this.l(s.id);if(i||this.u(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),i instanceof k.SyncDescriptor){const n={id:s.id,desc:i,_trace:t._trace.branch(s.id,!0)};E.insertEdge(t,n),p.push(n)}}}for(;;){const t=E.roots();if(t.length===0){if(!E.isEmpty())throw new w(E);break}for(const{data:s}of t){if(this.l(s.id)instanceof k.SyncDescriptor){const n=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,n)}E.removeNode(s)}}return this.l(u)}s(u,f,v=[],E,y){if(this.f.get(u)instanceof k.SyncDescriptor)return this.t(u,f,v,E,y);if(this.h)return this.h.s(u,f,v,E,y);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(u,f,v=[],E,y){if(E){const p=new d(void 0,this.g,this,this.i);p.c=String(u);const t=new Map,s=new O.IdleValue(()=>{const i=p.j(f,v,y);for(const[n,r]of t){const a=i[n];if(typeof a=="function")for(const o of r)a.apply(i,o)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let o=t.get(n);return o||(o=new c.LinkedList,t.set(n,o)),(h,A,F)=>{const Y=o.push([h,A,F]);return(0,P.toDisposable)(Y)}}if(n in i)return i[n];const r=s.value;let a=r[n];return typeof a!="function"||(a=a.bind(r),i[n]=a),a},set(i,n,r){return s.value[n]=r,!0},getPrototypeOf(i){return f.prototype}})}else return this.j(f,v,y)}u(u,f){if(f&&console.warn(u),this.g)throw new Error(u)}}e.InstantiationService=d;var m;(function(N){N[N.None=0]="None",N[N.Creation=1]="Creation",N[N.Invocation=2]="Invocation",N[N.Branch=3]="Branch"})(m||(m={}));class I{static traceInvocation(u,f){return u?new I(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):I.c}static traceCreation(u,f){return u?new I(1,f.name):I.c}constructor(u,f){this.type=u,this.name=f,this.g=Date.now(),this.h=[]}branch(u,f){const v=new I(3,u.toString());return this.h.push([u,f,v]),v}stop(){const u=Date.now()-this.g;I.f+=u;let f=!1;function v(y,p){const t=[],s=new Array(y+1).join("	");for(const[i,n,r]of p.h)if(n&&r){f=!0,t.push(`${s}CREATES -> ${i}`);const a=v(y+1,r);a&&t.push(a)}else t.push(`${s}uses -> ${i}`);return t.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${I.f.toFixed(2)}ms)`];(u>2||f)&&I.all.add(E.join(`
`))}}I.all=new Set,I.c=new class extends I{constructor(){super(0,null)}stop(){}branch(){return this}},I.f=0,e.Trace=I});var Z=this&&this.__param||function(x,e){return function(O,R){e(O,R,x)}};define(Q[63],_([0,1,23,2,12,98,21,10]),function(x,e,O,R,P,k,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function g(b){return b.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=g,e.ILanguagePackService=(0,S.createDecorator)("languagePackService");let c=class extends R.Disposable{constructor(w){super(),this.c=w}async getAvailableLanguages(){const w=new O.CancellationTokenSource;setTimeout(()=>w.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},w.token)}catch{return[]}const I=d.firstPage.filter(N=>N.properties.localizedLanguages?.length&&N.tags.some(u=>u.startsWith("lp-"))).map(N=>{const u=N.properties.localizedLanguages?.[0],f=g(N);return{...this.f(f,u,N),extensionId:N.identifier.id,galleryExtension:N}});return I.push(this.f("en","English")),I}f(w,d,m){const I=d??w;let N;if(I!==w&&(N=`(${w})`),w.toLowerCase()===P.language.toLowerCase()&&(N??="",N+=(0,k.localize)(0,null)),m?.installCount){N??="";const u=m.installCount;let f;u>1e6?f=`${Math.floor(u/1e5)/10}M`:u>1e3?f=`${Math.floor(u/1e3)}K`:f=String(u),N+=` $(cloud-download) ${f}`}return{id:w,label:I,description:N}}};c=he([Z(0,D.IExtensionGalleryService)],c),e.LanguagePackBaseService=c}),define(Q[6],_([0,1,34,4,2,36,12,3,11,10]),function(x,e,O,R,P,k,D,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,c.createDecorator)("logService"),e.ILoggerService=(0,c.createDecorator)("loggerService");function b(){return new Date().toISOString()}function w(o){return(0,S.isNumber)(o)}e.isLogLevel=w;var d;(function(o){o[o.Off=0]="Off",o[o.Trace=1]="Trace",o[o.Debug=2]="Debug",o[o.Info=3]="Info",o[o.Warning=4]="Warning",o[o.Error=5]="Error"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function m(o,l,h){switch(l){case d.Trace:o.trace(h);break;case d.Debug:o.debug(h);break;case d.Info:o.info(h);break;case d.Warning:o.warn(h);break;case d.Error:o.error(h);break;case d.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=m;function I(o){let l="";for(let h=0;h<o.length;h++){let A=o[h];if(typeof A=="object")try{A=JSON.stringify(A)}catch{}l+=(h>0?" ":"")+A}return l}e.format=I;class N extends P.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new R.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==d.Off&&this.b<=l}}e.AbstractLogger=N;class u extends N{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...h){this.f(d.Trace)&&this.g(d.Trace,I([l,...h]))}debug(l,...h){this.f(d.Debug)&&this.g(d.Debug,I([l,...h]))}info(l,...h){this.f(d.Info)&&this.g(d.Info,I([l,...h]))}warn(l,...h){this.f(d.Warning)&&this.g(d.Warning,I([l,...h]))}error(l,...h){if(this.f(d.Error))if(l instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=l.stack,this.g(d.Error,I(A))}else this.g(d.Error,I([l,...h]))}flush(){}}e.AbstractMessageLogger=u;class f extends N{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l),this.g=!D.isWindows}trace(l,...h){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,l,...h):console.log(`[main ${b()}]`,l,...h))}debug(l,...h){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,l,...h):console.log(`[main ${b()}]`,l,...h))}info(l,...h){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,l,...h):console.log(`[main ${b()}]`,l,...h))}warn(l,...h){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,l,...h):console.warn(`[main ${b()}]`,l,...h))}error(l,...h){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,l,...h):console.error(`[main ${b()}]`,l,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class v extends N{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l)}trace(l,...h){this.f(d.Trace)&&console.log("%cTRACE","color: #888",l,...h)}debug(l,...h){this.f(d.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",l,...h)}info(l,...h){this.f(d.Info)&&console.log("%c INFO","color: #33f",l,...h)}warn(l,...h){this.f(d.Warning)&&console.log("%c WARN","color: #993",l,...h)}error(l,...h){this.f(d.Error)&&console.log("%c  ERR","color: #f33",l,...h)}dispose(){}flush(){}}e.ConsoleLogger=v;class E extends N{constructor(l,h=e.DEFAULT_LOG_LEVEL){super(),this.g=l,this.setLevel(h)}trace(l,...h){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(l),...h])}debug(l,...h){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(l),...h])}info(l,...h){this.f(d.Info)&&this.g.log(d.Info,[this.h(l),...h])}warn(l,...h){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(l),...h])}error(l,...h){this.f(d.Error)&&this.g.log(d.Error,[this.h(l),...h])}h(l){return typeof l=="string"?l:(0,O.toErrorMessage)(l,this.f(d.Trace))}dispose(){}flush(){}}e.AdapterLogger=E;class y extends N{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const h of this.g)h.setLevel(l);super.setLevel(l)}trace(l,...h){for(const A of this.g)A.trace(l,...h)}debug(l,...h){for(const A of this.g)A.debug(l,...h)}info(l,...h){for(const A of this.g)A.info(l,...h)}warn(l,...h){for(const A of this.g)A.warn(l,...h)}error(l,...h){for(const A of this.g)A.error(l,...h)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.MultiplexLogger=y;class p extends P.Disposable{constructor(l,h){if(super(),this.j=l,this.b=new k.ResourceMap,this.c=new k.ResourceMap,this.f=this.B(new R.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new R.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new R.Emitter),this.onDidChangeVisibility=this.h.event,h)for(const A of h)this.c.set(A.resource,A)}getLogger(l){return this.b.get(l)}createLogger(l,h){let A=this.b.get(l);const F=h?.logLevel==="always"?d.Trace:h?.logLevel;return A||(A=this.k(l,F??this.getLogLevel(l)??this.j,h),this.b.set(l,A)),this.registerLogger({resource:l,id:h?.id??l.toString(),logLevel:F,name:h?.name,hidden:h?.hidden,extensionId:h?.extensionId}),A}setLogLevel(l,h){if(g.URI.isUri(l)){const A=l,F=h,Y=this.c.get(A);Y&&F!==Y.logLevel&&(Y.logLevel=F===this.j?void 0:F,this.b.get(A)?.setLevel(F),this.c.set(Y.resource,Y),this.g.fire([A,F]))}else{this.j=l;for(const[A,F]of this.b.entries())this.c.get(A)?.logLevel===void 0&&F.setLevel(this.j);this.g.fire(this.j)}}setVisibility(l,h){const A=this.c.get(l);A&&h!==!A.hidden&&(A.hidden=!h,this.c.set(A.resource,A),this.h.fire([l,h]))}getLogLevel(l){let h;return l&&(h=this.c.get(l)?.logLevel),h??this.j}registerLogger(l){const h=this.c.get(l.resource);h?h.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.c.set(l.resource,l),this.f.fire({added:[l],removed:[]}))}deregisterLogger(l){const h=this.c.get(l);if(h){this.c.delete(l);const A=this.b.get(l);A&&(this.b.delete(l),A.dispose()),this.f.fire({added:[],removed:[h]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(l){return this.c.get(l)}dispose(){this.b.forEach(l=>l.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=p;class t{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(l){}getLevel(){return d.Info}trace(l,...h){}debug(l,...h){}info(l,...h){}warn(l,...h){}error(l,...h){}critical(l,...h){}dispose(){}flush(){}}e.NullLogger=t;class s extends t{}e.NullLogService=s;class i extends p{constructor(){super(d.Info)}k(l,h,A){return new t}}e.NullLoggerService=i;function n(o){if(o.verbose)return d.Trace;if(typeof o.logLevel=="string"){const l=a(o.logLevel.toLowerCase());if(l!==void 0)return l}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function r(o){switch(o){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.LogLevelToString=r;function a(o){switch(o){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.parseLogLevel=a}),define(Q[116],_([0,1,19,5,7,4,2,15,61,6]),function(x,e,O,R,P,k,D,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends D.Disposable{constructor(d,m){super(),this.a=d,this.b=m,this.c=this.B(new k.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new k.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new R.ThrottledDelayer(0)),this.s=[],this.t=this.B(new R.ThrottledDelayer(0))}watch(d,m){return m.recursive||this.b?.watcher?.forceUniversal?this.l(d,m):this.u(d,m)}l(d,m){const I={path:this.C(d),excludes:m.excludes,includes:m.includes,recursive:m.recursive},N=(0,O.insert)(this.j,I);return this.m(),(0,D.toDisposable)(()=>{N(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(d=>(0,P.onUnexpectedError)(d))}n(){this.h||(this.h=this.B(this.p(m=>this.c.fire((0,g.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const m of this.j)(0,g.isRecursiveWatchRequest)(m)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const m of this.j)(0,g.isRecursiveWatchRequest)(m)&&d.includes(m.path)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(d,m){const I={path:this.C(d),excludes:m.excludes,includes:m.includes,recursive:!1},N=(0,O.insert)(this.s,I);return this.v(),(0,D.toDisposable)(()=>{N(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(d=>(0,P.onUnexpectedError)(d))}w(){return this.r||(this.r=this.B(this.y(d=>this.c.fire((0,g.toFileChanges)(d)),d=>this.z(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.r.watch(this.s)}z(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}C(d){return(0,S.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(Q[117],_([0,1,19,5,14,23,4,51,64,2,54,16,118,18,43,95,13,60,6,7]),function(x,e,O,R,P,k,D,S,g,c,b,w,d,m,I,N,u,f,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class extends c.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new D.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new D.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new D.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new R.ResourceQueue)}registerProvider(t,s){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${t}`);const i=new c.DisposableStore;return this.h.set(t,s),this.c.fire({added:!0,scheme:t,provider:s}),i.add(s.onDidChangeFile(n=>this.R.fire(new u.FileChangesEvent(n,!this.O(s))))),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:t}))),(0,c.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:s}),this.h.delete(t),(0,c.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const s=[];this.f.fire({scheme:t,join(i){s.push(i)}}),!this.h.has(t)&&await R.Promises.settled(s)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,s){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return g.Iterable.map(this.h,([t,s])=>({scheme:t,capabilities:s.capabilities}))}async j(t){if(!(0,m.isAbsolutePath)(t))throw new u.FileOperationError((0,N.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const s=this.h.get(t.scheme);if(!s){const i=new E.ErrorNoTelemetry;throw i.message=(0,N.localize)(1,null,t.toString()),i}return s}async k(t){const s=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s)||(0,u.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const s=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,s){try{return await this.n(t,s)}catch(i){throw(0,u.toFileSystemProviderErrorCode)(i)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,N.localize)(2,null,this.nb(t)),1):(0,u.ensureFileSystemProviderError)(i)}}async n(t,s){const i=await this.j(t),n=this.O(i),r=s?.resolveTo,a=s?.resolveSingleChildDescendants,o=s?.resolveMetadata,l=await i.stat(t);let h;return this.p(i,t,l,void 0,!!o,(A,F)=>(h||(h=b.TernarySearchTree.forUris(()=>!n),h.set(t,!0),r&&h.fill(!0,r)),h.get(A.resource)||h.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&a?F===1:!1))}async p(t,s,i,n,r,a){const{providerExtUri:o}=this.N(t),l={resource:s,name:o.basename(s),isFile:(i.type&u.FileType.File)!==0,isDirectory:(i.type&u.FileType.Directory)!==0,isSymbolicLink:(i.type&u.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&u.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,u.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(l.isDirectory&&a(l,n)){try{const h=await t.readdir(s),A=await R.Promises.settled(h.map(async([F,Y])=>{try{const ee=o.joinPath(s,F),te=r?await t.stat(ee):{type:Y};return await this.p(t,ee,te,h.length,r,a)}catch(ee){return this.b.trace(ee),null}}));l.children=(0,O.coalesce)(A)}catch(h){this.b.trace(h),l.children=[]}return l}return l}async resolveAll(t){return R.Promises.settled(t.map(async s=>{try{return{stat:await this.n(s.resource,s.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const s=await this.j(t),i=await s.stat(t);return this.p(s,t,i,void 0,!0,()=>!1)}async exists(t){const s=await this.j(t);try{return!!await s.stat(t)}catch{return!1}}async canCreateFile(t,s){try{await this.r(t,s)}catch(i){return i}return!0}async r(t,s){if(!s?.overwrite&&await this.exists(t))throw new u.FileOperationError((0,N.localize)(3,null,this.nb(t)),3,s)}async createFile(t,s=P.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,s);return this.m.fire(new u.FileOperationEvent(t,0,n)),n}async writeFile(t,s,i){const n=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(n);try{await this.s(n,t,i)||await this.P(n,r.dirname(t));let o;if((0,u.hasReadWriteCapability)(n)&&!(s instanceof P.VSBuffer))if((0,I.isReadableStream)(s)){const l=await(0,I.peekStream)(s,3);l.ended?o=P.VSBuffer.concat(l.buffer):o=l}else o=(0,I.peekReadable)(s,l=>P.VSBuffer.concat(l),3);else o=s;!(0,u.hasOpenReadWriteCloseCapability)(n)||(0,u.hasReadWriteCapability)(n)&&o instanceof P.VSBuffer?await this.cb(n,t,i,o):await this.Y(n,t,i,o instanceof P.VSBuffer?(0,P.bufferToReadable)(o):o),this.m.fire(new u.FileOperationEvent(t,4))}catch(a){throw new u.FileOperationError((0,N.localize)(4,null,this.nb(t),(0,u.ensureFileSystemProviderError)(a).toString()),(0,u.toFileOperationResult)(a),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,s,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,N.localize)(5,null,this.nb(s)));let r;try{r=await t.stat(s)}catch{return}if((r.type&u.FileType.Directory)!==0)throw new u.FileOperationError((0,N.localize)(6,null,this.nb(s)),0,i);if(this.mb(s,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==u.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,u.etag)({mtime:i.mtime,size:r.size}))throw new u.FileOperationError((0,N.localize)(7,null),3,i);return r}async readFile(t,s,i){const n=await this.k(t);return s?.atomic?this.t(n,t,s,i):this.u(n,t,s,i)}async t(t,s,i,n){return new Promise((r,a)=>{this.X.queueFor(s,this.N(t).providerExtUri).queue(async()=>{try{const o=await this.u(t,s,i,n);r(o)}catch(o){a(o)}})})}async u(t,s,i,n){const r=await this.v(t,s,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,P.streamToBuffer)(r.value)}}async readFileStream(t,s,i){const n=await this.k(t);return this.v(n,t,s,i)}async v(t,s,i,n){const r=new k.CancellationTokenSource(n),a=this.F(s,i).then(l=>l,l=>{throw r.cancel(),l});let o;try{return typeof i?.etag=="string"&&i.etag!==u.ETAG_DISABLED&&await a,i?.atomic&&(0,u.hasFileAtomicReadCapability)(t)||!((0,u.hasOpenReadWriteCloseCapability)(t)||(0,u.hasFileReadStreamCapability)(t))||(0,u.hasReadWriteCapability)(t)&&i?.preferUnbuffered?o=this.D(t,s,i):(0,u.hasFileReadStreamCapability)(t)?o=this.z(t,s,r.token,i):o=this.C(t,s,r.token,i),{...await a,value:o}}catch(l){throw o&&await(0,I.consumeStream)(o),this.w(l,s,i)}}w(t,s,i){const n=(0,N.localize)(8,null,this.nb(s),(0,u.ensureFileSystemProviderError)(t).toString());return t instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof u.TooLargeFileOperationError?new u.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new u.FileOperationError(n,(0,u.toFileOperationResult)(t),i)}z(t,s,i,n=Object.create(null)){const r=t.readFileStream(s,n,i);return(0,I.transform)(r,{data:a=>a instanceof P.VSBuffer?a:P.VSBuffer.wrap(a),error:a=>this.w(a,s,n)},a=>P.VSBuffer.concat(a))}C(t,s,i,n=Object.create(null)){const r=(0,P.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,s,r,a=>a,{...n,bufferSize:this.a,errorTransformer:a=>this.w(a,s,n)},i),r}D(t,s,i){const n=(0,I.newWriteableStream)(r=>P.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,u.hasFileAtomicReadCapability)(t)?r=await t.readFile(s,{atomic:!0}):r=await t.readFile(s),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.G(s,r.byteLength,i),n.end(P.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async F(t,s){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new u.FileOperationError((0,N.localize)(9,null,this.nb(t)),0,s);if(typeof s?.etag=="string"&&s.etag!==u.ETAG_DISABLED&&s.etag===i.etag)throw new u.NotModifiedSinceFileOperationError((0,N.localize)(10,null),i,s);return this.G(t,i.size,s),i}G(t,s,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&s>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&s>i.limits.size&&(n=7),typeof n=="number")throw new u.TooLargeFileOperationError((0,N.localize)(11,null,this.nb(t)),n,s,i)}}async canMove(t,s,i){return this.H(t,s,"move",i)}async canCopy(t,s,i){return this.H(t,s,"copy",i)}async H(t,s,i,n){if(t.toString()!==s.toString())try{const r=i==="move"?this.lb(await this.l(t),t):await this.k(t),a=this.lb(await this.l(s),s);await this.M(r,t,a,s,i,n)}catch(r){return r}return!0}async move(t,s,i){const n=this.lb(await this.l(t),t),r=this.lb(await this.l(s),s),a=await this.I(n,t,r,s,"move",!!i),o=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,a==="move"?2:3,o)),o}async copy(t,s,i){const n=await this.k(t),r=this.lb(await this.l(s),s),a=await this.I(n,t,r,s,"copy",!!i),o=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,a==="copy"?3:2,o)),o}async I(t,s,i,n,r,a){if(s.toString()===n.toString())return r;const{exists:o,isSameResourceWithDifferentPathCase:l}=await this.M(t,s,i,n,r,a);if(o&&!l&&a&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),r==="copy"){if(t===i&&(0,u.hasFileFolderCopyCapability)(t))await t.copy(s,n,{overwrite:a});else{const h=await this.resolve(s);h.isDirectory?await this.L(t,h,i,n):await this.J(t,s,i,n)}return r}else return t===i?(await t.rename(s,n,{overwrite:a}),r):(await this.I(t,s,i,n,"copy",a),await this.del(s,{recursive:!0}),"copy")}async J(t,s,i,n){if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(i))return this.eb(t,s,i,n);if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasReadWriteCapability)(i))return this.kb(t,s,i,n);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(i))return this.ib(t,s,i,n);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasReadWriteCapability)(i))return this.gb(t,s,i,n)}async L(t,s,i,n){await i.mkdir(n),Array.isArray(s.children)&&await R.Promises.settled(s.children.map(async r=>{const a=this.N(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),i,a):this.J(t,r.resource,i,a)}))}async M(t,s,i,n,r,a){let o=!1;if(t===i){const{providerExtUri:h,isPathCaseSensitive:A}=this.N(t);if(A||(o=h.isEqual(s,n)),o&&r==="copy")throw new Error((0,N.localize)(12,null,this.nb(s),this.nb(n)));if(!o&&h.isEqualOrParent(n,s))throw new Error((0,N.localize)(13,null,this.nb(s),this.nb(n)))}const l=await this.exists(n);if(l&&!o){if(!a)throw new u.FileOperationError((0,N.localize)(14,null,this.nb(s),this.nb(n)),4);if(t===i){const{providerExtUri:h}=this.N(t);if(h.isEqualOrParent(s,n))throw new Error((0,N.localize)(15,null,this.nb(s),this.nb(n)))}}return{exists:l,isSameResourceWithDifferentPathCase:o}}N(t){const s=this.O(t);return{providerExtUri:s?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:s}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const s=this.lb(await this.j(t),t);await this.P(s,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,0,i)),i}async P(t,s){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(s,n.dirname(s));)try{if(((await t.stat(s)).type&u.FileType.Directory)===0)throw new Error((0,N.localize)(16,null,this.nb(s)));break}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(s)),s=n.dirname(s)}for(let r=i.length-1;r>=0;r--){s=n.joinPath(s,i[r]);try{await t.mkdir(s)}catch(a){if((0,u.toFileSystemProviderErrorCode)(a)!==u.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(t,s){try{await this.Q(t,s)}catch(i){return i}return!0}async Q(t,s){const i=this.lb(await this.j(t),t);if(!!s?.useTrash&&!(i.capabilities&4096))throw new Error((0,N.localize)(17,null,this.nb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.mb(t,r);else throw new u.FileOperationError((0,N.localize)(18,null,this.nb(t)),1);if(!!!s?.recursive){const o=await this.resolve(t);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,N.localize)(19,null,this.nb(t)))}return i}async del(t,s){const i=await this.Q(t,s),n=!!s?.useTrash,r=!!s?.recursive;await i.delete(t,{recursive:r,useTrash:n}),this.m.fire(new u.FileOperationEvent(t,1))}async cloneFile(t,s){const i=await this.j(t),n=this.lb(await this.l(s),s);if(i===n&&this.N(i).providerExtUri.isEqual(t,s))return;if(i===n&&(0,u.hasFileCloneCapability)(i))return i.cloneFile(t,s);await this.P(n,this.N(n).providerExtUri.dirname(s));const r=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,u.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,s,{overwrite:!0})):r.queue(()=>this.J(i,t,n,s))}watch(t,s={recursive:!1,excludes:[]}){const i=new c.DisposableStore;let n=!1,r=()=>{n=!0};return i.add((0,c.toDisposable)(()=>r())),(async()=>{try{const a=await this.W(t,s);n?(0,c.dispose)(a):r=()=>(0,c.dispose)(a)}catch(a){this.b.error(a)}})(),i}async W(t,s){const i=await this.j(t),n=(0,S.hash)([this.N(i).providerExtUri.getComparisonKey(t),s]);let r=this.U.get(n);return r||(r={count:0,disposable:i.watch(t,s)},this.U.set(n,r)),r.count+=1,(0,c.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,c.dispose)(r.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,c.dispose)(t.disposable);this.U.clear()}async Y(t,s,i,n){return this.X.queueFor(s,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,I.isReadableStream)(n)||(0,I.isReadableBufferedStream)(n)?await this.Z(t,r,n):await this.ab(t,r,n)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await t.close(r)}})}async Z(t,s,i){let n=0,r;if((0,I.isReadableBufferedStream)(i)){if(i.buffer.length>0){const a=P.VSBuffer.concat(i.buffer);await this.bb(t,s,a,a.byteLength,n,0),n+=a.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((a,o)=>{(0,I.listenStream)(r,{onData:async l=>{r.pause();try{await this.bb(t,s,l,l.byteLength,n,0)}catch(h){return o(h)}n+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>o(l),onEnd:()=>a()})})}async ab(t,s,i){let n=0,r;for(;(r=i.read())!==null;)await this.bb(t,s,r,r.byteLength,n,0),n+=r.byteLength}async bb(t,s,i,n,r,a){let o=0;for(;o<n;)o+=await t.write(s,r+o,i.buffer,a+o,n-o)}async cb(t,s,i,n){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.db(t,s,i,n))}async db(t,s,i,n){let r;n instanceof P.VSBuffer?r=n:(0,I.isReadableStream)(n)?r=await(0,P.streamToBuffer)(n):(0,I.isReadableBufferedStream)(n)?r=await(0,P.bufferedStreamToBuffer)(n):r=(0,P.readableToBuffer)(n),await t.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,s,i,n))}async fb(t,s,i,n){let r,a;try{r=await t.open(s,{create:!1}),a=await i.open(n,{create:!0,unlock:!1});const o=P.VSBuffer.alloc(this.a);let l=0,h=0,A=0;do A=await t.read(r,l,o.buffer,h,o.byteLength-h),await this.bb(i,a,o,A,l,h),l+=A,h+=A,h===o.byteLength&&(h=0);while(A>0)}catch(o){throw(0,u.ensureFileSystemProviderError)(o)}finally{await R.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof a=="number"?i.close(a):Promise.resolve()])}}async gb(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,s,i,n))}async hb(t,s,i,n){return i.writeFile(n,await t.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async ib(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,s,i,n))}async jb(t,s,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const a=await t.readFile(s);await this.bb(i,r,P.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await i.close(r)}}async kb(t,s,i,n){const r=await(0,P.streamToBuffer)(this.C(t,s,k.CancellationToken.None));await this.cb(i,n,void 0,r)}lb(t,s){if(t.capabilities&2048)throw new u.FileOperationError((0,N.localize)(20,null,this.nb(s)),6);return t}mb(t,s){if((s.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,N.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===w.Schemas.file?t.fsPath:t.toString(!0)}};y=he([Z(0,v.ILogService)],y),e.FileService=y}),define(Q[119],_([0,1,120,161,5,36,14,4,162,2,15,12,18,43,20,97,13,60,116,34,114,113]),function(x,e,O,R,P,k,D,S,g,c,b,w,d,m,I,N,u,f,v,E,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(O)}catch(s){console.error(`Error enabling graceful-fs: ${(0,E.toErrorMessage)(s)}`)}})();class t extends v.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=S.Event.None,this.H=new k.ResourceMap(r=>d.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,w.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:r}=await I.SymlinkSupport.stat(this.C(i));return{type:this.G(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await I.Promises.readdir(this.C(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async a=>{try{let o;a.isSymbolicLink()?o=(await this.stat((0,d.joinPath)(i,a.name))).type:o=this.G(a),r.push([a.name,o])}catch(o){this.a.trace(o)}})),r}catch(n){throw this.Y(n)}}G(i,n){let r;return n?.dangling?r=u.FileType.Unknown:i.isFile()?r=u.FileType.File:i.isDirectory()?r=u.FileType.Directory:r=u.FileType.Unknown,n&&(r|=u.FileType.SymbolicLink),r}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const a=new P.Barrier;return this.H.set(i,a),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,c.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===a&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),r=await this.I(i));const a=this.C(i);return await I.Promises.readFile(a)}catch(a){throw this.Y(a)}finally{r?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,r){const a=(0,m.newWriteableStream)(o=>D.VSBuffer.concat(o.map(l=>D.VSBuffer.wrap(l))).buffer);return(0,f.readFileIntoStream)(this,i,a,o=>o.buffer,{...n,bufferSize:256*1024},r),a}async writeFile(i,n,r){let a;try{const o=this.C(i);if(!r.create||!r.overwrite){if(await I.Promises.exists(o)){if(!r.overwrite)throw(0,u.createFileSystemProviderError)((0,N.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,u.createFileSystemProviderError)((0,N.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(o){throw await this.Z(i,o)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const r=this.C(i);let a;(0,u.isFileOpenForWriteOptions)(n)&&(a=await this.I(i));let o;try{if((0,u.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:h}=await I.SymlinkSupport.stat(r);h.mode&128||await I.Promises.chmod(r,h.mode|128)}catch(h){this.a.trace(h)}let l;if((0,u.isFileOpenForWriteOptions)(n)){if(w.isWindows)try{await I.Promises.truncate(r,0),l="r+"}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}l||(l="w")}else l="r";o=await I.Promises.open(r,l)}catch(l){throw a?.dispose(),(0,u.isFileOpenForWriteOptions)(n)?await this.Z(i,l):this.Y(l)}if(this.L.set(o,0),(0,u.isFileOpenForWriteOptions)(n)&&this.N.set(o,i),a){const l=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${r})`),this.M.set(o,a),l&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${r})`),l.dispose())}return o}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await I.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await I.Promises.close(i)}catch(r){throw this.Y(r)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,a,o){const l=this.P(i,n);let h=null;try{h=(await I.Promises.read(i,r,a,o,l)).bytesRead}catch(A){throw this.Y(A)}finally{this.Q(i,l,h)}return h}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,r){const a=this.L.get(i);typeof a=="number"&&(typeof n=="number"||(typeof r=="number"?this.L.set(i,a+r):this.L.delete(i)))}async write(i,n,r,a,o){return(0,P.retry)(()=>this.R(i,n,r,a,o),100,3)}async R(i,n,r,a,o){const l=this.P(i,n);let h=null;try{h=(await I.Promises.write(i,r,a,o,l)).bytesWritten}catch(A){throw await this.Z(this.N.get(i),A)}finally{this.Q(i,l,h)}return h}async mkdir(i){try{await I.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const r=this.C(i);n.recursive?await I.Promises.rm(r,I.RimRafMode.MOVE):await I.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(i,n,r){const a=this.C(i),o=this.C(n);if(a!==o)try{await this.S(i,n,"move",r.overwrite),await I.Promises.move(a,o)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,N.localize)(2,null,(0,b.basename)(a),(0,b.basename)((0,b.dirname)(o)),l.toString()))),this.Y(l)}}async copy(i,n,r){const a=this.C(i),o=this.C(n);if(a!==o)try{await this.S(i,n,"copy",r.overwrite),await I.Promises.copy(a,o,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,N.localize)(3,null,(0,b.basename)(a),(0,b.basename)((0,b.dirname)(o)),l.toString()))),this.Y(l)}}async S(i,n,r,a){const o=this.C(i),l=this.C(n);let h=!1;if(!!(this.capabilities&1024)||(h=(0,g.isEqual)(o,l,!0)),h&&r==="copy")throw(0,u.createFileSystemProviderError)((0,N.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!h&&await I.Promises.exists(l)){if(!a)throw(0,u.createFileSystemProviderError)((0,N.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,r){const a=this.C(i),o=this.C(n),l=!!(this.capabilities&1024);if((0,g.isEqual)(a,o,!l))return;const h=new c.DisposableStore;try{const[A,F]=await Promise.all([this.I(i),this.I(n)]);h.add(A),h.add(F),r&&await I.Promises.mkdir((0,b.dirname)(o),{recursive:!0}),await I.Promises.copyFile(a,o)}catch(A){if(A.code==="ENOENT"&&!r)return this.U(i,n,!0);throw this.Y(A)}finally{h.dispose()}}p(i,n,r){return new y.UniversalWatcherClient(a=>i(a),a=>n(a),r)}y(i,n,r){return new p.NodeJSWatcherClient(a=>i(a),a=>n(a),r)}Y(i){if(i instanceof u.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=u.FileSystemProviderErrorCode.NoPermissions;break;default:n=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(i,n)}async Z(i,n){let r=this.Y(n);if(i&&r.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await I.SymlinkSupport.stat(this.C(i));a.mode&128||(r=(0,u.createFileSystemProviderError)(n,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return r}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(Q[121],_([0,1,2,6]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class P extends O.Disposable{constructor(D,S=[]){super(),this.a=new R.MultiplexLogger([D,...S]),this.B(D.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...S){this.a.trace(D,...S)}debug(D,...S){this.a.debug(D,...S)}info(D,...S){this.a.info(D,...S)}warn(D,...S){this.a.warn(D,...S)}error(D,...S){this.a.error(D,...S)}flush(){this.a.flush()}}e.LogService=P}),define(Q[122],_([0,1,13,6]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var P;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(P||(P={}));async function k(c,b,w,d,m){try{const I=await new Promise((u,f)=>{x(["spdlog"],u,f)});I.setFlushOn(P.Trace);const N=await I.createAsyncRotatingLogger(c,b,w,d);return m?N.clearFormatters():N.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),N}catch(I){console.error(I)}return null}function D(c,b,w){switch(b){case R.LogLevel.Trace:c.trace(w);break;case R.LogLevel.Debug:c.debug(w);break;case R.LogLevel.Info:c.info(w);break;case R.LogLevel.Warning:c.warn(w);break;case R.LogLevel.Error:c.error(w);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function S(c,b){switch(b){case R.LogLevel.Trace:c.setLevel(P.Trace);break;case R.LogLevel.Debug:c.setLevel(P.Debug);break;case R.LogLevel.Info:c.setLevel(P.Info);break;case R.LogLevel.Warning:c.setLevel(P.Warning);break;case R.LogLevel.Error:c.setLevel(P.Error);break;case R.LogLevel.Off:c.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class g extends R.AbstractMessageLogger{constructor(b,w,d,m,I){super(),this.k=[],this.setLevel(I),this.l=this.n(b,w,d,m),this.B(this.onDidChangeLogLevel(N=>{this.m&&S(this.m,N)}))}async n(b,w,d,m){const I=d?6:1,N=30/I*O.ByteSize.MB,u=await k(b,w,N,I,m);if(u){this.m=u,S(this.m,this.getLevel());for(const{level:f,message:v}of this.k)D(this.m,f,v);this.k=[]}}g(b,w){this.m?D(this.m,b,w):this.getLevel()<=b&&this.k.push({level:b,message:w})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=g}),define(Q[38],_([0,1,4,64,2,10]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,k.createDecorator)("policy");class D extends P.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const b=Object.keys(this.f).length;return this.f={...c,...this.f},b!==Object.keys(this.f).length&&await this.i(c),R.Iterable.reduce(this.g.entries(),(w,[d,m])=>({...w,[d]:m}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(c,[b,w])=>({...c,[b]:{definition:w,value:this.g.get(b)}}),{})}}e.AbstractPolicyService=D;class S{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=S}),define(Q[123],_([0,1,5,4,64,3,13,6,38]),function(x,e,O,R,P,k,D,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(w,d){const m=[];for(const I of new Set(P.Iterable.concat(w.keys(),d.keys())))w.get(I)!==d.get(I)&&m.push(I);return m}let b=class extends g.AbstractPolicyService{constructor(d,m,I){super(),this.j=d,this.k=m,this.l=I,this.c=this.B(new O.ThrottledDelayer(500));const N=R.Event.filter(m.onDidFilesChange,u=>u.affects(d));this.B(m.watch(d)),this.B(N(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const d=new Map;try{const m=await this.k.readFile(this.j),I=JSON.parse(m.value.toString());if(!(0,k.isObject)(I))throw new Error("Policy file isn't a JSON object");for(const N of Object.keys(I))this.f[N]&&d.set(N,I[N])}catch(m){m.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",m)}return d}async p(){const d=await this.n(),m=c(this.g,d);this.g=d,m.length>0&&this.h.fire(m)}};b=he([Z(1,D.IFileService),Z(2,S.ILogService)],b),e.FilePolicyService=b}),define(Q[124],_([0,1,38,5,163,2,6]),function(x,e,O,R,P,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let S=class extends O.AbstractPolicyService{constructor(c,b){super(),this.j=c,this.k=b,this.a=new R.Throttler,this.b=this.B(new k.MutableDisposable)}async i(c){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((b,w)=>{try{this.b.value=(0,P.createWatcher)(this.k,c,d=>{this.m(d),b()})}catch(d){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),w(d)}}))}m(c){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const b in c){const w=c[b];w===void 0?this.g.delete(b):this.g.set(b,w)}this.h.fire(Object.keys(c))}};S=he([Z(0,D.ILogService)],S),e.NativePolicyService=S}),define(Q[31],_([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,O.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Q[37],_([0,1,70,3]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.a=new Map}add(D,S){O.ok(R.isString(D)),O.ok(R.isObject(S)),O.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,S)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.Registry=new P}),define(Q[125],_([0,1,4,37]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class k{constructor(){this.b=new O.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,c){this.a[P(g)]=c,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const D=new k;R.Registry.add(e.Extensions.JSONContribution,D)}),define(Q[42],_([0,1,19,4,3,86,24,125,37]),function(x,e,O,R,P,k,D,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(c=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=g.Registry.as(S.Extensions.JSONContribution);class d{constructor(){this.h=new Set,this.i=new R.Emitter,this.onDidSchemaChange=this.i.event,this.j=new R.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const i=new Set;this.n(t,s,i),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const s=new Set;this.o(t,s),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const i=new Set;this.o(s,i),this.n(t,!1,i),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const i=[];for(const{overrides:n,source:r}of t)for(const a in n)if(s.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const o=this.a.get(a),l=o?.valuesSources??new Map;if(r)for(const Y of Object.keys(n[a]))l.set(Y,r);const h={...o?.value||{},...n[a]};this.a.set(a,{source:r,value:h,valuesSources:l});const A=(0,D.getLanguageTagSettingPlainKey)(a),F={type:"object",default:h,description:k.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:P.isString(r)?void 0:r,defaultValueSource:r};i.push(...N(a)),this.d[a]=F,this.b.properties[a]=F}else{this.a.set(a,{value:n[a],source:r});const o=this.d[a];o&&(this.w(a,o),this.r(a,o))}this.m(i)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:i,source:n}of t)for(const r in i){const a=this.a.get(r),o=P.isString(n)?n:n?.id,l=P.isString(a?.source)?a?.source:a?.source?.id;if(o===l)if(s.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const h=this.d[r];h&&(this.w(r,h),this.r(r,h))}}this.u()}deltaConfiguration(t){let s=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,i){t.forEach(n=>{this.p(n,s,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,s){const i=n=>{if(n.properties)for(const r in n.properties){s.add(r);const a=this.d[r];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>i(r))};for(const n of t){i(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,s=!0,i,n,r=3,a){r=P.isUndefinedOrNull(t.scope)?r:t.scope;const o=t.properties;if(o)for(const h in o){const A=o[h];if(s&&E(h,A)){delete o[h];continue}if(A.source=i,A.defaultDefaultValue=o[h].default,this.w(h,A),e.OVERRIDE_PROPERTY_REGEX.test(h)?A.scope=void 0:(A.scope=P.isUndefinedOrNull(A.scope)?r:A.scope,A.restricted=P.isUndefinedOrNull(A.restricted)?!!n?.includes(h):A.restricted),o[h].hasOwnProperty("included")&&!o[h].included){this.f[h]=o[h],delete o[h];continue}else this.d[h]=o[h],o[h].policy?.name&&this.e.set(o[h].policy.name,h);!o[h].deprecationMessage&&o[h].markdownDeprecationMessage&&(o[h].deprecationMessage=o[h].markdownDeprecationMessage),a.add(h)}const l=t.allOf;if(l)for(const h of l)this.p(h,s,i,n,r,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=i=>{const n=i.properties;if(n)for(const a in n)this.r(a,n[a]);i.allOf?.forEach(s)};s(t)}r(t,s){switch(e.allSettings.properties[t]=s,s.scope){case 1:e.applicationSettings.properties[t]=s;break;case 2:e.machineSettings.properties[t]=s;break;case 6:e.machineOverridableSettings.properties[t]=s;break;case 3:e.windowSettings.properties[t]=s;break;case 4:e.resourceSettings.properties[t]=s;break;case 5:e.resourceSettings.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.allSettings.properties[t],s.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,i={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(s,i),e.allSettings.properties[s]=i,e.applicationSettings.properties[s]=i,e.machineSettings.properties[s]=i,e.machineOverridableSettings.properties[s]=i,e.windowSettings.properties[s]=i,e.resourceSettings.properties[s]=i}}v(){const t={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,s){const i=this.a.get(t);let n=i?.value,r=i?.source;P.isUndefined(n)&&(n=s.defaultDefaultValue,r=void 0),P.isUndefined(n)&&(n=f(s.type)),s.default=n,s.defaultValueSource=r}}const m="\\[([^\\]]+)\\]",I=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function N(p){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let s=I.exec(p);for(;s?.length;){const i=s[1].trim();i&&t.push(i),s=I.exec(p)}}return(0,O.distinct)(t)}e.overrideIdentifiersFromKey=N;function u(p){return p.reduce((t,s)=>`${t}[${s}]`,"")}e.keyFromOverrideIdentifiers=u;function f(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const v=new d;g.Registry.add(e.Extensions.Configuration,v);function E(p,t){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?k.localize(7,null,p):v.getConfigurationProperties()[p]!==void 0?k.localize(8,null,p):t.policy?.name&&v.getPolicyConfigurations().get(t.policy?.name)!==void 0?k.localize(9,null,p,t.policy?.name,v.getPolicyConfigurations().get(t.policy?.name)):null:k.localize(6,null)}e.validateProperty=E;function y(){const p=[],t=v.getConfigurationProperties();for(const s of Object.keys(t))p.push([s,t[s].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=y}),define(Q[65],_([0,1,19,4,49,2,36,28,3,11,24,42,37]),function(x,e,O,R,P,k,D,S,g,c,b,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function m(s){return Object.isFrozen(s)?s:S.deepFreeze(s)}class I{constructor(i={},n=[],r=[],a){this.b=i,this.c=n,this.d=r,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof I)return n;const r=new N("");return r.parseRaw(n),r.configurationModel});this.f=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,b.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const r=this.rawConfiguration.getValue(i),a=n?this.rawConfiguration.getOverrideValue(i,n):void 0,o=n?this.rawConfiguration.override(n).getValue(i):r;return{value:r,override:a,merged:o}}getOverrideValue(i,n){const r=this.i(n);return r?i?(0,b.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return O.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return O.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=S.deepClone(this.contents),r=S.deepClone(this.overrides),a=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const l of i)if(o.push(...l.raw?.length?l.raw:[l]),!l.isEmpty()){this.h(n,l.contents);for(const h of l.overrides){const[A]=r.filter(F=>O.equals(F.identifiers,h.identifiers));A?(this.h(A.contents,h.contents),A.keys.push(...h.keys),A.keys=O.distinct(A.keys)):r.push(S.deepClone(h))}for(const h of l.keys)a.indexOf(h)===-1&&a.push(h)}return new I(n,a,r,o.every(l=>l instanceof I)?void 0:o)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const a of O.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[a];const l=n[a];l&&(typeof o=="object"&&typeof l=="object"?(o=S.deepClone(o),this.h(o,l)):o=l),r[a]=o}return new I(r,this.keys,this.overrides)}h(i,n){for(const r of Object.keys(n)){if(r in i&&g.isObject(i[r])&&g.isObject(n[r])){this.h(i[r],n[r]);continue}i[r]=S.deepClone(n[r])}}i(i){let n=null,r=null;const a=o=>{o&&(r?this.h(r,o):r=S.deepClone(o))};for(const o of this.overrides)O.equals(o.identifiers,[i])?n=o.contents:o.identifiers.includes(i)&&a(o.contents);return a(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,b.removeFromValueTree)(this.contents,i),w.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>O.equals(r.identifiers,(0,w.overrideIdentifiersFromKey)(i))),1))}j(i,n,r){(0,b.addToValueTree)(this.contents,i,n,a=>console.error(a)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),w.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,b.toValuesTree)(this.contents[i],a=>console.error(a))})}}e.ConfigurationModel=I;class N{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new I}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!g.isUndefinedOrNull(i)){const r=this.g(i);this.parseRaw(r,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:r,keys:a,overrides:o,restricted:l,hasExcludedProperties:h}=this.h(i,n);this.b=new I(r,a,o,h?[i]:void 0),this.c=l||[]}g(i){let n={},r=null,a=[];const o=[],l=[];function h(F){Array.isArray(a)?a.push(F):r!==null&&(a[r]=F)}const A={onObjectBegin:()=>{const F={};h(F),o.push(a),a=F,r=null},onObjectProperty:F=>{r=F},onObjectEnd:()=>{a=o.pop()},onArrayBegin:()=>{const F=[];h(F),o.push(a),a=F,r=null},onArrayEnd:()=>{a=o.pop()},onLiteralValue:h,onError:(F,Y,ee)=>{l.push({error:F,offset:Y,length:ee})}};if(i)try{P.visit(i,A),n=a[0]||{}}catch(F){console.error(`Error while parsing settings file ${this.f}: ${F}`),this.d=[F]}return n}h(i,n){const r=d.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),a=this.i(i,r,!0,n);i=a.raw;const o=(0,b.toValuesTree)(i,A=>console.error(`Conflict in settings file ${this.f}: ${A}`)),l=Object.keys(i),h=this.j(i,A=>console.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:o,keys:l,overrides:h,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(i,n,r,a){let o=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:o};const l={},h=[];for(const A in i)if(w.OVERRIDE_PROPERTY_REGEX.test(A)&&r){const F=this.i(i[A],n,!1,a);l[A]=F.raw,o=o||F.hasExcludedProperties,h.push(...F.restricted)}else{const F=n[A],Y=F?typeof F.scope<"u"?F.scope:3:void 0;F?.restricted&&h.push(A),(Y===void 0||a.scopes===void 0||a.scopes.includes(Y))&&!(a.skipRestricted&&F?.restricted)?l[A]=i[A]:o=!0}return{raw:l,restricted:h,hasExcludedProperties:o}}j(i,n){const r=[];for(const a of Object.keys(i))if(w.OVERRIDE_PROPERTY_REGEX.test(a)){const o={};for(const l in i[a])o[l]=i[a][l];r.push({identifiers:(0,w.overrideIdentifiersFromKey)(a),keys:Object.keys(o),contents:(0,b.toValuesTree)(o,n)})}return r}}e.ConfigurationModelParser=N;class u extends k.Disposable{constructor(i,n,r,a){super(),this.f=i,this.g=n,this.h=a,this.c=this.B(new R.Emitter),this.onDidChange=this.c.event,this.a=new N(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(R.Event.any(R.Event.filter(this.h.onDidFilesChange,o=>o.contains(this.f)),R.Event.filter(this.h.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&r.isEqual(o.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new I}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=u;class f{constructor(i,n,r,a,o,l,h,A,F,Y,ee,te,ie){this.a=i,this.b=n,this.c=r,this.overrideIdentifiers=a,this.d=o,this.f=l,this.g=h,this.h=A,this.i=F,this.j=Y,this.k=ee,this.l=te,this.m=ie}get value(){return m(this.c)}n(i,n,r){const a=i.inspect(n,r);return{get value(){return m(a.value)},get override(){return m(a.override)},get merged(){return m(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class v{constructor(i,n,r,a,o=new I,l=new I,h=new D.ResourceMap,A=new I,F=new D.ResourceMap){this.c=i,this.d=n,this.f=r,this.g=a,this.h=o,this.i=l,this.j=h,this.l=A,this.m=F,this.a=null,this.b=new D.ResourceMap,this.n=null}getValue(i,n,r){return this.q(i,n,r).getValue(i)}updateValue(i,n,r={}){let a;r.resource?(a=this.m.get(r.resource),a||(a=new I,this.m.set(r.resource,a))):a=this.l,n===void 0?a.removeValue(i):a.setValue(i,n),r.resource||(this.a=null)}inspect(i,n,r){const a=this.q(i,n,r),o=this.u(n.resource,r),l=n.resource?this.m.get(n.resource)||this.l:this.l,h=new Set;for(const A of a.overrides)for(const F of A.identifiers)a.getOverrideValue(i,F)!==void 0&&h.add(F);return new f(i,n,a.getValue(i),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,o||void 0,l)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:a,updated:o,removed:l}=p(this.c,i);n=[...a,...o,...l]}for(const a of n)for(const o of(0,w.overrideIdentifiersFromKey)(a)){const l=this.c.getKeysForOverrideIdentifier(o),h=i.getKeysForOverrideIdentifier(o),A=[...h.filter(F=>l.indexOf(F)===-1),...l.filter(F=>h.indexOf(F)===-1),...l.filter(F=>!S.equals(this.c.override(o).getValue(F),i.override(o).getValue(F)))];r.push([o,A])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:a}=p(this.d,i),o=[...n,...r,...a];return o.length&&this.updatePolicyConfiguration(i),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:a,overrides:o}=p(this.applicationConfiguration,i),l=[...n,...r,...a];return l.length&&this.updateApplicationConfiguration(i),{keys:l,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:a,overrides:o}=p(this.localUserConfiguration,i),l=[...n,...r,...a];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:a,overrides:o}=p(this.remoteUserConfiguration,i),l=[...n,...r,...a];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:a,overrides:o}=p(this.workspaceConfiguration,i),l=[...n,...r,...a];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:o}}compareAndUpdateFolderConfiguration(i,n){const r=this.p.get(i),{added:a,updated:o,removed:l,overrides:h}=p(r,n),A=[...a,...o,...l];return(A.length||!r)&&this.updateFolderConfiguration(i,n),{keys:A,overrides:h}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:a,removed:o,overrides:l}=p(n,void 0);return{keys:[...r,...a,...o],overrides:l}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,r){let a=this.r(n,r);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(a=a.merge(this.d)),a}r({resource:i},n){let r=this.s();if(n&&i){const a=n.getFolder(i);a&&(r=this.t(a.uri)||r);const o=this.m.get(i);o&&(r=r.merge(o))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const r=this.s(),a=this.j.get(i);a?(n=r.merge(a),this.b.set(i,n)):n=r}return n}u(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:r,overrides:a,keys:o}=this.j.get(n);return i.push([n,{contents:r,overrides:a,keys:o}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(a=>n.add(a))),[...n.values()]}static parse(i){const n=this.x(i.defaults),r=this.x(i.policy),a=this.x(i.application),o=this.x(i.user),l=this.x(i.workspace),h=i.folders.reduce((A,F)=>(A.set(c.URI.revive(F[0]),this.x(F[1])),A),new D.ResourceMap);return new v(n,r,a,o,new I,l,h,new I,new D.ResourceMap)}static x(i){return new I(i.contents,i.keys,i.overrides)}}e.Configuration=v;function E(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,n=new Map;for(const a of s)a.keys.forEach(o=>i.add(o)),a.overrides.forEach(([o,l])=>{const h=(0,D.getOrSet)(n,o,new Set);l.forEach(A=>h.add(A))});const r=[];return n.forEach((a,o)=>r.push([o,[...a.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=E;class y{constructor(i,n,r,a){this.change=i,this.f=n,this.g=r,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of i.keys)this.affectedKeys.add(o);for(const[,o]of i.overrides)for(const l of o)this.affectedKeys.add(l);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=v.parse(this.f.data)),this.i}affectsConfiguration(i,n){const r=this.a+i,a=this.d.indexOf(r);if(a<0)return!1;const o=a+r.length;if(o>=this.d.length)return!1;const l=this.d.charCodeAt(o);if(l!==this.b&&l!==this.c)return!1;if(n){const h=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,A=this.g.getValue(i,n,this.h);return!S.equals(h,A)}return!0}}e.ConfigurationChangeEvent=y;function p(s,i){const{added:n,removed:r,updated:a}=t(i?.rawConfiguration,s?.rawConfiguration),o=[],l=s?.getAllOverrideIdentifiers()||[],h=i?.getAllOverrideIdentifiers()||[];if(i){const A=h.filter(F=>!l.includes(F));for(const F of A)o.push([F,i.getKeysForOverrideIdentifier(F)])}if(s){const A=l.filter(F=>!h.includes(F));for(const F of A)o.push([F,s.getKeysForOverrideIdentifier(F)])}if(i&&s){for(const A of l)if(h.includes(A)){const F=t({contents:s.getOverrideValue(void 0,A)||{},keys:s.getKeysForOverrideIdentifier(A)},{contents:i.getOverrideValue(void 0,A)||{},keys:i.getKeysForOverrideIdentifier(A)});o.push([A,[...F.added,...F.removed,...F.updated]])}}return{added:n,removed:r,updated:a,overrides:o}}function t(s,i){const n=s?i?s.keys.filter(o=>i.keys.indexOf(o)===-1):[...s.keys]:[],r=i?s?i.keys.filter(o=>s.keys.indexOf(o)===-1):[...i.keys]:[],a=[];if(s&&i){for(const o of i.keys)if(s.keys.indexOf(o)!==-1){const l=(0,b.getConfigurationValue)(i.contents,o),h=(0,b.getConfigurationValue)(s.contents,o);S.equals(l,h)||a.push(o)}}return{added:n,removed:r,updated:a}}}),define(Q[126],_([0,1,19,4,2,28,3,65,42,6,38,37]),function(x,e,O,R,P,k,D,S,g,c,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class d extends P.Disposable{constructor(){super(...arguments),this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new S.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(w.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:f})=>this.c(Array.from(u),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(u,f){this.h(u,w.Registry.as(g.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:u})}f(){return{}}g(){this.b=new S.ConfigurationModel;const u=w.Registry.as(g.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(u),u)}h(u,f){const v=this.f();for(const E of u){const y=v[E],p=f[E];y!==void 0?this.b.addValue(E,y):p?this.b.addValue(E,p.default):this.b.removeValue(E)}}}e.DefaultConfiguration=d;class m{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new S.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=m;let I=class extends P.Disposable{get configurationModel(){return this.b}constructor(u,f,v){super(),this.c=u,this.f=f,this.g=v,this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new S.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(u=>this.i(u))),this.B(this.c.onDidChangeConfiguration(async({properties:u})=>this.j(await this.h(u),!0))),this.b}async h(u){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",u);const f={},v=[],E=w.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const y of u){const p=E[y];if(!p){v.push(y);continue}if(p.policy){if(p.type!=="string"&&p.type!=="number"){this.g.warn(`Policy ${p.policy.name} has unsupported type ${p.type}`);continue}v.push(y),f[p.policy.name]={type:p.type}}}return(0,D.isEmptyObject)(f)||await this.f.updatePolicyDefinitions(f),v}i(u){this.g.trace("PolicyConfiguration#onDidChangePolicies",u);const f=w.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),v=(0,O.coalesce)(u.map(E=>f.get(E)));this.j(v,!0)}j(u,f){this.g.trace("PolicyConfiguration#update",u);const v=w.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),E=[],y=this.b.isEmpty();for(const p of u){const t=v[p]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(y?s!==void 0:!(0,k.equals)(this.b.getValue(p),s))&&E.push([p,s])}else this.b.getValue(p)!==void 0&&E.push([p,void 0])}if(E.length){this.g.trace("PolicyConfiguration#changed",E);const p=this.b;this.b=new S.ConfigurationModel;for(const t of p.keys)this.b.setValue(t,p.getValue(t));for(const[t,s]of E)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);f&&this.a.fire(this.b)}}};I=he([Z(1,b.IPolicyService),Z(2,c.ILogService)],I),e.PolicyConfiguration=I}),define(Q[127],_([0,1,5,4,2,18,24,65,126,38]),function(x,e,O,R,P,k,D,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends P.Disposable{constructor(d,m,I,N){super(),this.i=d,this.h=this.B(new R.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.DefaultConfiguration),this.c=I instanceof c.NullPolicyService?new g.NullPolicyConfiguration:this.B(new g.PolicyConfiguration(this.b,I,N)),this.f=this.B(new S.UserSettings(this.i,void 0,k.extUriBiasedIgnorePathCase,m)),this.a=new S.Configuration(this.b.configurationModel,this.c.configurationModel,new S.ConfigurationModel,new S.ConfigurationModel),this.g=this.B(new O.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:u,properties:f})=>this.k(u,f))),this.B(this.c.onDidChangeConfiguration(u=>this.l(u))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,m,I]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.Configuration(d,m,new S.ConfigurationModel,I)}getConfigurationData(){return this.a.toData()}getValue(d,m){const I=typeof d=="string"?d:void 0,N=(0,D.isConfigurationOverrides)(d)?d:(0,D.isConfigurationOverrides)(m)?m:{};return this.a.getValue(I,N,void 0)}updateValue(d,m,I,N){return Promise.reject(new Error("not supported"))}inspect(d){return this.a.inspect(d,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.j(d)}j(d){const m=this.a.toData(),I=this.a.compareAndUpdateLocalUserConfiguration(d);this.m(I,m,2)}k(d,m){const I=this.a.toData(),N=this.a.compareAndUpdateDefaultConfiguration(d,m);this.m(N,I,7)}l(d){const m=this.a.toData(),I=this.a.compareAndUpdatePolicyConfiguration(d);this.m(I,m,7)}m(d,m,I){const N=new S.ConfigurationChangeEvent(d,{data:m},this.a);N.source=I,N.sourceConfig=this.n(I),this.h.fire(N)}n(d){switch(d){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(Q[66],_([0,1,16]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(c){return c.scheme===O.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=R;function P(c){if(!c)return;const b=c.indexOf("+");return b<0?c:c.substr(0,b)}e.getRemoteName=P;function k(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=k;function D(c){const{host:b,port:w}=g(c);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:w}}e.parseAuthorityWithPort=D;function S(c,b){let{host:w,port:d}=g(c);return typeof d>"u"&&(d=b),{host:w,port:d}}e.parseAuthorityWithOptionalPort=S;function g(c){const b=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const w=c.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const d=c.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:c,port:void 0}}}),define(Q[32],_([0,1,30,10,66]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));var S;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class g{constructor(I){this.value=I,this.c=I.toLowerCase()}static equals(I,N){if(typeof I>"u"||I===null)return typeof N>"u"||N===null;if(typeof N>"u"||N===null)return!1;if(typeof I=="string"||typeof N=="string"){const u=typeof I=="string"?I:I.value,f=typeof N=="string"?N:N.value;return O.equalsIgnoreCase(u,f)}return I.c===N.c}static toKey(I){return typeof I=="string"?I.toLowerCase():I.c}}e.ExtensionIdentifier=g;function c(m){return b(m)}e.isApplicationScopedExtension=c;function b(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function w(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function d(m,I){if(I){const N=`onResolveRemoteAuthority:${(0,P.getRemoteName)(I)}`;return!!m.activationEvents?.includes(N)}return!1}e.isResolverExtension=d,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[128],_([0,1,2,15,20,32]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class D extends O.Disposable{constructor(g,c){super(),this.b=g,this.a=(0,R.join)(this.b.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this.B(c.onDidInstallExtensions(b=>this.c(b))),this.B(c.onDidUninstallExtension(b=>this.f(b)))}c(g){g.some(c=>!!c.local)&&this.invalidate()}f(g){g.error||this.invalidate()}invalidate(){P.Promises.rm(this.a,P.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=D}),define(Q[46],_([0,1,14,99,42,10,37]),function(x,e,O,R,P,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function S(N){return N.res.statusCode&&N.res.statusCode>=200&&N.res.statusCode<300||N.res.statusCode===1223}e.isSuccess=S;function g(N){return N.res.statusCode===204}async function c(N){return g(N)?null:(await(0,O.streamToBuffer)(N.stream)).toString()}e.asText=c;async function b(N){if(!S(N))throw new Error("Server returned "+N.res.statusCode);return c(N)}e.asTextOrError=b;async function w(N){if(!S(N))throw new Error("Server returned "+N.res.statusCode);if(g(N))return null;const f=(await(0,O.streamToBuffer)(N.stream)).toString();try{return JSON.parse(f)}catch(v){throw v.message+=`:
`+f,v}}e.asJson=w;function d(N){I(N)}e.updateProxyConfigurationsScope=d;let m;function I(N){const u=D.Registry.as(P.Extensions.Configuration),f=m;m={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:N,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},u.updateConfigurations({add:[m],remove:f?[f]:[]})}I(2)}),define(Q[129],_([0,1,23,16,13,46]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let D=class{constructor(g,c){this.a=g,this.b=c}async download(g,c,b=O.CancellationToken.None){if(g.scheme===R.Schemas.file||g.scheme===R.Schemas.vscodeRemote){await this.b.copy(g,c);return}const w={type:"GET",url:g.toString(!0)},d=await this.a.request(w,b);if(d.res.statusCode===200)await this.b.writeFile(c,d.stream);else{const m=await(0,k.asTextOrError)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${m}`)}}};D=he([Z(0,k.IRequestService),Z(1,P.IFileService)],D),e.DownloadService=D}),define(Q[130],_([0,1,131,3]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function P(D,S){return D.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:D.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function k(D,S,g={}){const c=(0,O.parse)(D),b=g.proxyUrl||P(c,S);if(!b)return null;const w=(0,O.parse)(b);if(!/^https?:$/.test(w.protocol||""))return null;const d={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:(0,R.isBoolean)(g.strictSSL)?g.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((m,I)=>{x(["http-proxy-agent"],m,I)}))(d):new(await new Promise((m,I)=>{x(["https-proxy-agent"],m,I)}))(d)}e.getProxyAgent=k}),define(Q[132],_([0,1,57,15,100,23,34,7,12,29,82,164,5,71]),function(x,e,O,R,P,k,D,S,g,c,b,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let I;async function N(f,v,E,y){return E["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(y)&&!E["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(y)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),I||(I=d.Promises.withAsyncBody(async(p,t)=>{const s=new k.CancellationTokenSource;let i=1e4;const n=f.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,m.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{s.dispose(!0),t(new Error((0,P.localize)(0,null)))},i);try{p(await u(v,s.token))}catch(a){!(0,S.isCancellationError)(a)&&!s.token.isCancellationRequested?t(new Error((0,P.localize)(1,null,(0,D.toErrorMessage)(a)))):p({})}finally{clearTimeout(r),s.dispose()}})),I)}e.getResolvedShellEnv=N;async function u(f,v){const E=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",E);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",y);const p=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(p+"({.*})"+p),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",s);const i=await(0,b.getSystemShell)(g.OS,s);return f.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(v.isCancellationRequested)return r(new S.CancellationError);const a=(0,R.basename)(i);let o,l;const h=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(o=`& '${process.execPath}' ${h} -p '''${p}'' + JSON.stringify(process.env) + ''${p}'''`,l=["-Login","-Command"]):(o=`'${process.execPath}' ${h} -p '"${p}" + JSON.stringify(process.env) + "${p}"'`,a==="tcsh"||a==="csh"?l=["-ic"]:l=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),o);const A=(0,O.spawn)(i,[...l,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});v.onCancellationRequested(()=>(A.kill(),r(new S.CancellationError))),A.on("error",ee=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(ee)),r(ee)});const F=[];A.stdout.on("data",ee=>F.push(ee));const Y=[];A.stderr.on("data",ee=>Y.push(ee)),A.on("close",(ee,te)=>{const ie=Buffer.concat(F).toString("utf8");f.trace("getUnixShellEnvironment#raw",ie);const ne=Buffer.concat(Y).toString("utf8");if(ne.trim()&&f.trace("getUnixShellEnvironment#stderr",ne),ee||te)return r(new Error((0,P.localize)(2,null,ee,te)));const ae=t.exec(ie),fe=ae?ae[1]:"{}";try{const oe=JSON.parse(fe);E?oe.ELECTRON_RUN_AS_NODE=E:delete oe.ELECTRON_RUN_AS_NODE,y?oe.ELECTRON_NO_ATTACH_CONSOLE=y:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",oe),n(oe)}catch(oe){f.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(oe)),r(oe)}})})}}),define(Q[133],_([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,O.createDecorator)("stateReadService"),e.IStateService=(0,O.createDecorator)("stateService")}),define(Q[67],_([0,1,5,14,3,17,13,6]),function(x,e,O,R,P,k,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var g;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(g=e.SaveStrategy||(e.SaveStrategy={}));class c{constructor(m,I,N,u){this.f=m,this.g=N,this.h=u,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=I===0?void 0:new O.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==1&&this.g.error(m)}}getItem(m,I){const N=this.a[m];return(0,P.isUndefinedOrNull)(N)?I:N}setItem(m,I){this.setItems([{key:m,data:I}])}setItems(m){let I=!1;for(const{key:N,data:u}of m)this.a[N]!==u&&((0,P.isUndefinedOrNull)(u)?(0,P.isUndefined)(this.a[N])||(this.a[N]=void 0,I=!0):(this.a[N]=u,I=!0));I&&this.j()}removeItem(m){(0,P.isUndefined)(this.a[m])||(this.a[m]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.h.writeFile(this.f,R.VSBuffer.fromString(m)),this.b=m}catch(I){this.g.error(I)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=c;let b=class{constructor(m,I,N,u){this.a=new c(I.stateResource,m,N,u)}async init(){await this.a.init()}getItem(m,I){return this.a.getItem(m,I)}};b=he([Z(1,k.IEnvironmentService),Z(2,S.ILogService),Z(3,D.IFileService)],b),e.StateReadonlyService=b;class w extends b{setItem(m,I){this.a.setItem(m,I)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.StateService=w}),define(Q[68],_([0,1,12,35,11,29]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(c){if(O.platform===2&&/^penguin(\.|$)/i.test(c))return"chromebook"}async function S(c,b,w,d,m,I,N,u,f,v){const E=Object.create(null);E["common.machineId"]=N,E.sessionID=(0,k.generateUuid)()+Date.now(),E.commitHash=m,E.version=I,E["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,O.PlatformToString)(O.platform),E["common.nodePlatform"]=R.platform,E["common.nodeArch"]=d,E["common.product"]=v||"desktop",u&&(E["common.msftInternal"]=u);let y=0;const p=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>y++,enumerable:!0}}),O.isLinuxSnap&&(E["common.snap"]="true");const t=D(w);t&&(E["common.platformDetail"]=t);try{const s=await c.readFile(P.URI.file(f));E["common.source"]=s.value.toString().slice(0,30)}catch{}return E}e.resolveCommonProperties=S;function g(c){const b=R.env.USERDNSDOMAIN;if(!b)return!1;const w=b.toLowerCase();return c.some(d=>w===d)}e.verifyMicrosoftInternalDomain=g}),define(Q[25],_([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,O.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,O.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var P;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(P=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Q[39],_([0,1,28,3,4,24,66,68,25]),function(x,e,O,R,P,k,D,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class c{constructor(o){this.value=o}}e.TelemetryTrustedValue=c;class b{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,l){return Promise.resolve(void 0)}publicLog2(o,l){return this.publicLog(o,l)}publicLogError(o,l){return Promise.resolve(void 0)}publicLogError2(o,l){return this.publicLogError(o,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class w{async publicLog(o,l,h){}async publicLogError(o,l,h){}}e.NullEndpointTelemetryService=w,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(a,o){return P.Event.debounce(o.onDidChangeConfiguration,(h,A)=>{const F=h?new Set([...h.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:F}},1e3,!0)(h=>{h.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(h.source),configurationKeys:y(h.affectedKeys)})})}e.configurationTelemetry=d;function m(a,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!a.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=m;function I(a,o){return!(o.isBuilt||o.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=I;function N(a){const o=a.getValue(g.TELEMETRY_SETTING_ID),l=a.getValue(g.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(g.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=N;function u(a){const o={},l={},h={};E(a,h);for(let A in h){A=A.length>150?A.substr(A.length-149):A;const F=h[A];typeof F=="number"?l[A]=F:typeof F=="boolean"?l[A]=F?1:0:typeof F=="string"?(F.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${F.length}`),o[A]=F.substring(0,8191)):typeof F<"u"&&F!==null&&(o[A]=F)}return{properties:o,measurements:l}}e.validateTelemetryData=u;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function v(a){if(!a)return"none";const o=(0,D.getRemoteName)(a);return f.has(o)?o:"other"}e.cleanRemoteAuthority=v;function E(a,o,l=0,h){if(!!a)for(const A of Object.getOwnPropertyNames(a)){const F=a[A],Y=h?h+A:A;Array.isArray(F)?o[Y]=(0,O.safeStringify)(F):F instanceof Date?o[Y]=F.toISOString():(0,R.isObject)(F)?l<2?E(F,o,l+1,Y+"."):o[Y]=(0,O.safeStringify)(F):o[Y]=F}}function y(a){if(!a)return[];const o=[];return p(o,"",a),o}function p(a,o,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(h=>p(a,o?`${o}.${h}`:h,l[h])):a.push(o)}function t(a,o){const l=a.msftInternalDomains||[],h=o.getValue("telemetry.internalTesting");return(0,S.verifyMicrosoftInternalDomain)(l)||h}e.isInternalTelemetry=t;function s(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=s;function i(a,o){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let l=a;const h=[];for(const ee of o)for(;;){const te=ee.exec(a);if(!te)break;h.push([te.index,ee.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,F=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let Y=0;for(l="";;){const ee=F.exec(a);if(!ee)break;const te=h.some(([ie,ne])=>ee.index<ne&&ie<F.lastIndex);!A.test(ee[0])&&!te&&(l+=a.substring(Y,ee.index)+"<REDACTED: user-file-path>",Y=F.lastIndex)}return Y<a.length&&(l+=a.substr(Y)),l}function n(a){if(!a)return a;const o=a.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of l)if(h.regex.test(o))return`<REDACTED: ${h.label}>`;return a}function r(a,o){return(0,O.cloneAndChange)(a,l=>{if(l instanceof c)return l.value;if(typeof l=="string"){let h=l.replaceAll("%20"," ");h=i(h,o);for(const A of o)h=h.replace(A,"");return h=n(h),h}})}e.cleanData=r}),define(Q[26],_([0,1,30,21,32,12,11,7,35,39]),function(x,e,O,R,P,k,D,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,O.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=b;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const r=n.manifest?n.manifest.version:n.version,a=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,r,a)}static parse(n){const r=w.exec(n);return r&&r[1]&&r[2]?new d({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,a="undefined"){this.version=r,this.targetPlatform=a,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?b(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=d;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(i){const n=m.exec(i);return n&&n[1]?[u(n[1]),n[2]]:[u(i),void 0]}e.getIdAndVersion=I;function N(i,n){return`${i}.${n}`}e.getExtensionId=N;function u(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=u;function f(i,n){return u(N(i,n))}e.getGalleryExtensionId=f;function v(i,n){const r=[],a=o=>{for(const l of r)if(l.some(h=>b(n(h),n(o))))return l;return null};for(const o of i){const l=a(o);l?l.push(o):r.push([o])}return r}e.groupByExtension=v;function E(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function y(i){return{id:new c.TelemetryTrustedValue(i.identifier.id),name:new c.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function p(i,n){const r=[],a=n.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const o=a.shift();if(o&&r.every(l=>!b(l.identifier,{id:o}))){const l=i.filter(h=>b(h.identifier,{id:o}));l.length===1&&(r.push(l[0]),a.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=p;async function t(i,n){if(!k.isLinux)return!1;let r;try{r=(await i.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){n.debug("Error while getting the os-release file.",(0,S.getErrorMessage)(o))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(i,n){const r=await t(i,n),a=(0,R.getTargetPlatform)(r?"alpine":k.platform,g.arch);return n.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=s}),define(Q[134],_([0,1,23,7,16,18,41,11,89,21,26,32]),function(x,e,O,R,P,k,D,S,g,c,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const d=u=>(0,g.localize)(0,null,u),m=(0,g.localize)(1,null,"ms-dotnettools.csharp");function I(u,f){return f?`${u.publisher}.${u.name}@${u.version}`:`${u.publisher}.${u.name}`}let N=class{constructor(f,v){this.a=f,this.b=v}get d(){}async listExtensions(f,v,E,y=console){let p=await this.a.getInstalled(1,E);const t=w.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(v&&v!==""){if(t.indexOf(v.toLowerCase())<0){y.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(i=>i.manifest.categories?i.manifest.categories.map(r=>r.toLowerCase()).indexOf(v.toLowerCase())>-1:!1)}else if(v===""){y.log("Possible Categories: "),t.forEach(i=>{y.log(i)});return}this.d&&y.log((0,g.localize)(2,null,this.d)),p=p.sort((i,n)=>i.identifier.id.localeCompare(n.identifier.id));let s;for(const i of p)s!==i.identifier.id&&(s=i.identifier.id,y.log(I(i.manifest,f)))}async installExtensions(f,v,E,y,p=console){const t=[],s=[];f.length&&p.log(this.d?(0,g.localize)(3,null,this.d):(0,g.localize)(4,null));const i=await this.a.getInstalled(1,E.profileLocation),n=(l,h)=>{const A=i.find(F=>(0,b.areSameExtensions)(F.identifier,{id:l}));if(A){if(!y&&(!h||h==="prerelease"&&A.preRelease))return p.log((0,g.localize)(5,null,l,A.manifest.version,l)),!1;if(h&&A.manifest.version===h)return p.log((0,g.localize)(6,null,`${l}@${h}`)),!1}return!0},r=(l,h,A)=>{o.push({id:l,version:h!=="prerelease"?h:void 0,installOptions:{...E,isBuiltin:A,installPreReleaseVersion:h==="prerelease"||E.installPreReleaseVersion}})},a=[],o=[];for(const l of f)if(l instanceof S.URI)a.push(l);else{const[h,A]=(0,b.getIdAndVersion)(l);n(h,A)&&r(h,A,!1)}for(const l of v){const[h,A]=(0,b.getIdAndVersion)(l);n(h,A)&&r(h,A,!0)}if(a.length&&await Promise.all(a.map(async l=>{try{const h=await this.f(l,{...E,isBuiltin:!1},y,p);h&&s.push(h)}catch(h){p.error(h.message||h.stack||h),t.push(l.toString())}})),o.length){const l=await this.g(o);await Promise.all(o.map(async h=>{const A=l.get(h.id.toLowerCase());if(A)try{const F=await this.h(h,A,i,y,p);F&&s.push(F)}catch(F){p.error(F.message||F.stack||F),t.push(h.id)}else p.error(`${d(h.version?`${h.id}@${h.version}`:h.id)}
${m}`),t.push(h.id)}))}if(t.length)throw new Error((0,g.localize)(7,null,t.join(", ")))}async f(f,v,E,y){const p=await this.a.getManifest(f);if(!p)throw new Error("Invalid vsix");if(await this.k(p,E,v.profileLocation,y))try{return await this.a.install(f,v),y.log((0,g.localize)(8,null,(0,k.basename)(f))),p}catch(s){if((0,R.isCancellationError)(s))return y.log((0,g.localize)(9,null,(0,k.basename)(f))),null;throw s}return null}async g(f){const v=new Map,E=f.some(p=>p.installOptions.installPreReleaseVersion),y=await this.b.getExtensions(f.map(p=>({...p,preRelease:E})),O.CancellationToken.None);for(const p of y)v.set(p.identifier.id.toLowerCase(),p);return v}async h({id:f,version:v,installOptions:E},y,p,t,s){const i=await this.b.getManifest(y,O.CancellationToken.None);if(i&&!this.j(i,s))return null;const n=p.find(r=>(0,b.areSameExtensions)(r.identifier,y.identifier));if(n){if(y.version===n.manifest.version)return s.log((0,g.localize)(10,null,v?`${f}@${v}`:f)),null;s.log((0,g.localize)(11,null,f,y.version))}try{E.isBuiltin?s.log(v?(0,g.localize)(12,null,f,v):(0,g.localize)(13,null,f)):s.log(v?(0,g.localize)(14,null,f,v):(0,g.localize)(15,null,f));const r=await this.a.installFromGallery(y,{...E,installGivenVersion:!!v});return s.log((0,g.localize)(16,null,f,r.manifest.version)),i}catch(r){if((0,R.isCancellationError)(r))return s.log((0,g.localize)(17,null,f)),null;throw r}}j(f,v){return!0}async k(f,v,E,y){const p={id:(0,b.getGalleryExtensionId)(f.publisher,f.name)},s=(await this.a.getInstalled(1,E)).find(i=>(0,b.areSameExtensions)(p,i.identifier)&&(0,D.gt)(i.manifest.version,f.version));return s&&!v?(y.log((0,g.localize)(18,null,s.identifier.id,s.manifest.version,f.version)),!1):this.j(f,y)}async uninstallExtensions(f,v,E,y=console){const p=async s=>{if(s instanceof S.URI){const i=await this.a.getManifest(s);return I(i)}return s},t=[];for(const s of f){const i=await p(s),r=(await this.a.getInstalled(void 0,E)).filter(a=>(0,b.areSameExtensions)(a.identifier,{id:i}));if(!r.length)throw new Error(`${this.l(i)}
${m}`);if(r.some(a=>a.type===0)){y.log((0,g.localize)(19,null,i));return}if(!v&&r.some(a=>a.isBuiltin)){y.log((0,g.localize)(20,null,i));return}y.log((0,g.localize)(21,null,i));for(const a of r)await this.a.uninstall(a,{profileLocation:E}),t.push(a);this.d?y.log((0,g.localize)(22,null,i,this.d)):y.log((0,g.localize)(23,null,i))}}async locateExtension(f,v=console){const E=await this.a.getInstalled();f.forEach(y=>{E.forEach(p=>{if(p.identifier.id===y&&p.location.scheme===P.Schemas.file){v.log(p.location.fsPath);return}})})}l(f){return this.d?(0,g.localize)(24,null,f,this.d):(0,g.localize)(25,null,f)}};N=he([Z(0,c.IExtensionManagementService),Z(1,c.IExtensionGalleryService)],N),e.ExtensionManagementCLI=N}),define(Q[135],_([0,1,5,7,2,16,12,18,41,3,29,20,24,17,21,26,59,13,6]),function(x,e,O,R,P,k,D,S,g,c,b,w,d,m,I,N,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let E=class We extends P.Disposable{constructor(p,t,s,i,n,r){super(),this.h=t,this.i=s,this.j=i,this.k=n,this.l=r,this.extensionsDownloadDir=p.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(p,t){await this.g;const s=(0,S.joinPath)(this.extensionsDownloadDir,this.v(p));try{await this.r(p,s,n=>this.i.download(p,n,t))}catch(n){throw new I.ExtensionManagementError(n.message,I.ExtensionManagementErrorCode.Download)}let i="Unverified";if(await this.m(p)){const n=await this.n(p);try{await this.k.verify(s.fsPath,n.fsPath)&&(i="Verified"),this.l.info(`Extension signature verification: ${p.identifier.id}. Verification status: ${i}.`)}catch(r){const a=r,o=a.code;if(o==="UnknownError")i="UnknownError",this.l.warn(`Extension signature verification: ${p.identifier.id}. Verification status: ${i}.`);else if(!a.didExecute)this.l.warn(`Extension signature verification: ${p.identifier.id}. Verification status: ${i} (${o})`);else throw await this.delete(n),await this.delete(s),new I.ExtensionManagementError(o,I.ExtensionManagementErrorCode.Signature)}}return{location:s,verificationStatus:i}}async m(p){if(!p.isSigned)return!1;const t=this.j.getValue("extensions.verifySignature");return(0,c.isBoolean)(t)?t:!0}async n(p){await this.g;const t=(0,S.joinPath)(this.extensionsDownloadDir,`${this.v(p)}${We.c}`);return await this.r(p,t,s=>this.i.downloadSignatureArchive(p,s)),t}async r(p,t,s){if(await this.h.exists(t))return;if(t.scheme!==k.Schemas.file){await s(t);return}const i=(0,S.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.h.exists(i)||await s(i);try{await this.t(i,t,Date.now()+2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",p.identifier.id,t.path);else throw this.l.info(`Rename failed because of ${(0,R.getErrorMessage)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(p){await this.g,await this.h.del(p)}async t(p,t,s){try{await w.Promises.rename(p.fsPath,t.fsPath)}catch(i){if(D.isWindows&&i&&i.code==="EPERM"&&Date.now()<s)return this.l.info(`Failed renaming ${p} to ${t} with 'EPERM' error. Trying again...`),this.t(p,t,s);throw i}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const p=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(p.children){const t=[],s=[],i=[];for(const a of p.children)if(a.name.endsWith(We.c))i.push(a.resource);else{const o=N.ExtensionKey.parse(a.name);o&&s.push([o,a])}const n=(0,N.groupByExtension)(s,([a])=>a),r=[];for(const a of n)a.sort((o,l)=>g.rcompare(o[0].version,l[0].version)),t.push(...a.slice(1).map(o=>o[1].resource)),r.push(a[0][1]);r.sort((a,o)=>a.mtime-o.mtime),t.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),t.push(...i),await O.Promises.settled(t.map(a=>(this.l.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(p){this.l.error(p)}}v(p){return this.f?N.ExtensionKey.create(p).toString().toLowerCase():(0,b.generateUuid)()}};E.c=".sigzip",E=he([Z(0,m.INativeEnvironmentService),Z(1,f.IFileService),Z(2,I.IExtensionGalleryService),Z(3,d.IConfigurationService),Z(4,u.IExtensionSignatureVerificationService),Z(5,v.ILogService)],E),e.ExtensionsDownloader=E}),define(Q[136],_([0,1,4,2,36,26,32]),function(x,e,O,R,P,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class S extends R.Disposable{constructor(c,b,w,d,m,I,N){super(),this.f=c,this.g=b,this.h=w,this.i=d,this.j=m,this.k=I,this.l=N,this.a=this.B(new O.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.DisposableMap),this.m().then(null,u=>N.error(u))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(c=>this.p(c.added,c.removed))),this.B(this.i.onAddExtensions(c=>this.r(c))),this.B(this.i.onDidAddExtensions(c=>this.s(c))),this.B(this.i.onRemoveExtensions(c=>this.t(c))),this.B(this.i.onDidRemoveExtensions(c=>this.u(c))),this.B(this.k.onDidFilesChange(c=>this.v(c)))}async p(c,b){try{await Promise.all(b.map(w=>(this.c.deleteAndDispose(w.id),this.z(w.extensionsResource)))),c.length&&await Promise.all(c.map(w=>(this.c.set(w.id,(0,R.combinedDisposable)(this.k.watch(this.j.extUri.dirname(w.extensionsResource)),this.k.watch(w.extensionsResource))),this.y(w.extensionsResource))))}catch(w){throw this.l.error(w),w}}async r(c){for(const b of c.extensions)this.D(this.G(b.identifier,b.version),c.profileLocation)}async s(c){for(const b of c.extensions){const w=this.G(b.identifier,b.version);c.error?this.F(w,c.profileLocation):this.D(w,c.profileLocation)}}async t(c){for(const b of c.extensions)this.F(this.G(b.identifier,b.version),c.profileLocation)}async u(c){const b=[],w=[];for(const d of c.extensions){const m=this.G(d.identifier,d.version);c.error?this.D(m,c.profileLocation):(this.F(m,c.profileLocation),this.b.has(m)||(this.l.debug("Extension is removed from all profiles",d.identifier.id,d.version),w.push(this.f.scanInstalledExtensionAtLocation(d.location).then(I=>{I?b.push(I):this.l.info("Extension not found at the location",d.location.toString())},I=>this.l.error(I)))))}try{await Promise.all(w),b.length&&await this.C(b)}catch(d){this.l.error(d)}}v(c){for(const b of this.h.profiles)c.contains(b.extensionsResource,0,1)&&this.w(b.extensionsResource)}async w(c){const b=[],w=[],d=await this.i.scanProfileExtensions(c),m=new Set,I=new Set;for(const[N,u]of this.b)u.has(c)&&I.add(N);for(const N of d){const u=this.G(N.identifier,N.version);m.add(u),I.has(u)||(b.push(N.identifier),this.D(u,c))}for(const N of I)if(!m.has(N)){const u=this.H(N);u&&(w.push(u.identifier),this.F(N,c))}(b.length||w.length)&&this.a.fire({added:b.length?{extensions:b,profileLocation:c}:void 0,removed:w.length?{extensions:w,profileLocation:c}:void 0})}async y(c){const b=await this.i.scanProfileExtensions(c);for(const w of b)this.D(this.G(w.identifier,w.version),c)}async z(c){for(const b of[...this.b.keys()])this.F(b,c);await this.C()}async C(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(w=>!this.b.has(this.G(w.identifier,w.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}D(c,b){let w=this.b.get(c);w||this.b.set(c,w=new P.ResourceSet(d=>this.j.extUri.getComparisonKey(d))),w.add(b)}F(c,b){const w=this.b.get(c);w&&w.delete(b),w?.size||this.b.delete(c)}G(c,b){return`${D.ExtensionIdentifier.toKey(c.id)}@${b}`}H(c){const[b,w]=(0,k.getIdAndVersion)(c);return w?{identifier:{id:b},version:w}:void 0}}e.ExtensionsWatcher=S}),define(Q[137],_([0,1,109,39]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function P(k,D,S,g,c,b,w){const d={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${D.nameShort})`};if((0,R.supportsTelemetry)(D,S)&&(0,R.getTelemetryLevel)(g)===3){const m=await(0,O.getServiceMachineId)(S,c,b),{machineId:I}=await w.getTelemetryInfo();d["X-Market-User-Id"]=m,d["VSCode-SessionId"]=I||m}return d}e.resolveMarketplaceHeaders=P}),define(Q[138],_([0,1,165,19,5,2,16,15,20,17,21,26,6,63,11]),function(x,e,O,R,P,k,D,S,g,c,b,w,d,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let N=class extends m.LanguagePackBaseService{constructor(E,y,p,t){super(p),this.h=E,this.i=t,this.g=this.B(new u(y,t)),this.h.registerParticipant({postInstall:async s=>this.j(s),postUninstall:async s=>this.k(s)})}async getBuiltInExtensionTranslationsUri(E,y){const t=(await this.g.getLanguagePacks())[y];if(!t){this.i.warn(`No language pack found for ${y}`);return}const s=t.translations[E];return s?I.URI.file(s):void 0}async getInstalledLanguages(){const E=await this.g.getLanguagePacks(),y=Object.keys(E).map(p=>{const t=E[p];return{...this.f(p,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return y.push(this.f("en","English")),y.sort((p,t)=>p.label.localeCompare(t.label)),y}async j(E){E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",E.identifier.id),await this.update())}async k(E){const y=await this.g.getLanguagePacks();Object.keys(y).some(p=>y[p]&&y[p].extensions.some(t=>(0,w.areSameExtensions)(t.extensionIdentifier,E.identifier)))&&(this.i.info("Removing language packs from the extension",E.identifier.id),await this.update())}async update(){const[E,y]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),p=await this.g.update(y);return!(0,R.equals)(Object.keys(E),Object.keys(p))}};N=he([Z(0,b.IExtensionManagementService),Z(1,c.INativeEnvironmentService),Z(2,b.IExtensionGalleryService),Z(3,d.ILogService)],N),e.NativeLanguagePackService=N;let u=class extends k.Disposable{constructor(E,y){super(),this.i=y,this.c={},this.f=(0,S.join)(E.userDataPath,"languagepacks.json"),this.g=new P.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(E){return this.m(y=>{Object.keys(y).forEach(p=>delete y[p]),this.j(y,...E)}).then(()=>this.c)}j(E,...y){for(const p of y)p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&this.k(E,p);Object.keys(E).forEach(p=>this.l(E[p]))}k(E,y){const p=y.identifier,t=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const s of t)if(y.location.scheme===D.Schemas.file&&f(s)){let i=E[s.languageId];i||(i={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},E[s.languageId]=i);const n=i.extensions.filter(r=>(0,w.areSameExtensions)(r.extensionIdentifier,p))[0];n?n.version=y.manifest.version:i.extensions.push({extensionIdentifier:p,version:y.manifest.version});for(const r of s.translations)i.translations[r.id]=(0,S.join)(y.location.fsPath,r.path)}}l(E){if(E){const y=(0,O.createHash)("md5");for(const p of E.extensions)y.update(p.extensionIdentifier.uuid||p.extensionIdentifier.id).update(p.version);E.hash=y.digest("hex")}}m(E=()=>null){return this.g.queue(()=>{let y=null;return g.Promises.readFile(this.f,"utf8").then(void 0,p=>p.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(p)).then(p=>{try{return JSON.parse(p)}catch{return{}}}).then(p=>(y=E(p),p)).then(p=>{for(const s of Object.keys(p))p[s]||delete p[s];this.c=p,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),g.Promises.writeFile(this.f,t)}).then(()=>y,p=>this.i.error(p))})}};u=he([Z(0,c.INativeEnvironmentService),Z(1,d.ILogService)],u);function f(v){if(typeof v.languageId!="string"||!Array.isArray(v.translations)||v.translations.length===0)return!1;for(const E of v.translations)if(typeof E.id!="string"||typeof E.path!="string")return!1;return!(v.languageName&&typeof v.languageName!="string"||v.localizedLanguageName&&typeof v.localizedLanguageName!="string")}}),define(Q[139],_([0,1,7,28,39]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0",D="https://mobile.events.data.microsoft.com/ping";async function S(c,b,w){const d=await new Promise((f,v)=>{x(["@microsoft/1ds-core-js"],f,v)}),m=await new Promise((f,v)=>{x(["@microsoft/1ds-post-js"],f,v)}),I=new d.AppInsightsCore,N=new m.PostChannel,u={instrumentationKey:c,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[N]]};if(w){u.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:w};u.extensionConfig[N.identifier]=f}return I.initialize(u,[]),I.addTelemetryInitializer(f=>{b&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),I}class g{constructor(b,w,d,m,I){this.e=b,this.f=w,this.g=d,this.h=I,this.c=k,this.d=D,this.g||(this.g={}),typeof m=="function"?this.a=m():this.a=m,this.b=null}i(b){if(!!this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(w=>{b(w)},w=>{(0,O.onUnexpectedError)(w),console.error(w)})}}log(b,w){if(!this.a)return;w=(0,R.mixin)(w,this.g),w=(0,P.validateTelemetryData)(w);const d=this.f+"/"+b;try{this.i(m=>{m.pluginVersionString=w?.properties.version??"Unknown",m.track({name:d,baseData:{name:d,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(Q[140],_([0,1,2,28,12,30,101,24,42,141,31,37,25,39]),function(x,e,O,R,P,k,D,S,g,c,b,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let I=class{constructor(f,v,E){this.k=v,this.l=E,this.d={},this.i=new O.DisposableStore,this.j=[],this.b=f.appenders,this.c=f.commonProperties||Promise.resolve({}),this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this.f)this.j.push(new RegExp((0,k.escapeRegExpCharacters)(y),"gi")),y.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.escapeRegExpCharacters)(y.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(y=>{(y.affectsConfiguration(d.TELEMETRY_SETTING_ID)||y.affectsConfiguration(d.TELEMETRY_OLD_SETTING_ID)||y.affectsConfiguration(d.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(f,v){this.d[f]=v}m(){let f=(0,m.getTelemetryLevel)(this.k);const v=this.l.enabledTelemetryLevels;if(v){this.h=this.sendErrorTelemetry?v.error:!1;const E=v.usage?3:v.error?2:0;f=Math.min(f,E)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const f=await this.c,v=f.sessionID,E=f["common.machineId"],y=f["common.firstSessionDate"],p=f["common.msftInternal"];return{sessionId:v,machineId:E,firstSessionDate:y,msftInternal:p}}dispose(){this.i.dispose()}n(f,v,E){return this.g<v?Promise.resolve(void 0):this.c.then(y=>{E=(0,R.mixin)(E,this.d),E=(0,m.cleanData)(E,this.j),E=(0,R.mixin)(E,y),this.b.forEach(p=>p.log(f,E))},y=>{console.error(y)})}publicLog(f,v){return this.n(f,3,v)}publicLog2(f,v){return this.publicLog(f,v)}publicLogError(f,v){return this.h?this.n(f,2,v):Promise.resolve(void 0)}publicLogError2(f,v){return this.publicLogError(f,v)}};I.IDLE_START_EVENT_NAME="UserIdleStart",I.IDLE_STOP_EVENT_NAME="UserIdleStop",I=he([Z(1,S.IConfigurationService),Z(2,b.IProductService)],I),e.TelemetryService=I;function N(){const u=(0,D.localize)(0,null,c.default.nameLong),f=c.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=P.isWeb?"":(0,D.localize)(3,null),E=(0,D.localize)(4,null),y=(0,D.localize)(5,null),p=(0,D.localize)(6,null),t=(0,D.localize)(7,null),s=`
|       | ${E} | ${y} | ${p} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,D.localize)(8,null);return`
${u} ${f} ${v}

&nbsp;

${t}
${s}

&nbsp;

${i}
`}w.Registry.as(g.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[d.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:N(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(g.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[d.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,D.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,D.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${d.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[142],_([0,1,166,139]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class P extends R.AbstractOneDataSystemAppender{constructor(D,S,g,c){const b={sendPOST:(w,d)=>{const m={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const I=O.request(w.urlString,m,N=>{N.on("data",function(u){d(N.statusCode??200,N.headers,u.toString())}),N.on("error",function(u){d(0,{})})});I.write(w.data),I.end()}catch{d(0,{})}}};super(D,S,g,c,b)}}e.OneDataSystemAppender=P}),define(Q[143],_([0,1,15,20]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function P(k,D){const S=Object.create(null),g=(b,w)=>{const d=JSON.parse(b);S[w]=d};if(D){const b=[],w=await R.Promises.readdir(D);for(const m of w)try{(await R.Promises.stat((0,O.join)(D,m))).isDirectory()&&b.push(m)}catch{}const d=[];for(const m of b)(await R.Promises.readdir((0,O.join)(D,m))).filter(N=>N==="telemetry.json").length===1&&d.push(m);for(const m of d){const I=(await R.Promises.readFile((0,O.join)(D,m,"telemetry.json"))).toString();g(I,m)}}let c=(await R.Promises.readFile((0,O.join)(k,"telemetry-core.json"))).toString();return g(c,"vscode-core"),c=(await R.Promises.readFile((0,O.join)(k,"telemetry-extensions.json"))).toString(),g(c,"vscode-extensions"),JSON.stringify(S,null,4)}e.buildTelemetryMessage=P}),define(Q[144],_([0,1,12,80,25]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function k(D){let S=D.getItem(P.machineIdKey);return(typeof S!="string"||O.isMacintosh&&S==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(S=await(0,R.getMachineId)()),S}e.resolveMachineId=k}),define(Q[27],_([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,O.createDecorator)("IUriIdentityService")}),define(Q[145],_([0,1,27,110,13,18,72,4,2]),function(x,e,O,R,P,k,D,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{constructor(d){this.uri=d,this.time=c._clock++}touch(){return this.time=c._clock++,this}}c._clock=0;let b=class{constructor(d){this.g=d,this.c=new g.DisposableStore,this.f=2**16;const m=new Map,I=N=>{let u=m.get(N.scheme);return u===void 0&&(u=d.hasProvider(N)&&!this.g.hasCapability(N,1024),m.set(N.scheme,u)),u};this.c.add(S.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(N=>{m.delete(N.scheme)})),this.extUri=new k.ExtUri(I),this.d=new D.SkipList((N,u)=>this.extUri.compare(N,u,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,k.normalizePath)(d));const m=this.d.get(d);return m?m.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new c(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((I,N)=>I[1].touch<N[1].touch?1:I[1].touch>N[1].touch?-1:0);c._clock=0,this.d.clear();const m=this.f*.5;for(let I=0;I<m;I++)this.d.set(d[I][0],d[I][1].touch())}};b=he([Z(0,P.IFileService)],b),e.UriIdentityService=b,(0,R.registerSingleton)(O.IUriIdentityService,b,1)}),define(Q[146],_([0,1,103,15,54,18,11,10,16]),function(x,e,O,R,P,k,D,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=c;function b(i){return typeof i?.id=="string"&&!c(i)&&!d(i)}e.isEmptyWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=w;function d(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=d;function m(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=m;var I;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function N(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=N;function u(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=u;class f{constructor(n,r,a,o,l){this.h=n,this.j=a,this.k=o,this.l=l,this.c=P.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=P.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class v{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,k.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=v;function E(i){return new v({uri:i,index:0,name:(0,k.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,O.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(i,n){return k.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=y;function p(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=p;function t(i,n){return!y(i,n)&&!p(i)}e.isSavedWorkspace=t;function s(i){return(typeof i=="string"?(0,R.extname)(i):(0,k.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Q[22],_([0,1,51,4,2,18,11,102,17,13,10,6,146,36,27,5,29,30,3]),function(x,e,O,R,P,k,D,S,g,c,b,w,d,m,I,N,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function E(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.isUserDataProfile=E,e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function y(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:D.URI.revive(i.location).with({scheme:n}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=y;function p(i,n,r,a){return{id:i,name:n,location:r,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,k.joinPath)(r,"globalStorage"),settingsResource:(0,k.joinPath)(r,"settings.json"),keybindingsResource:(0,k.joinPath)(r,"keybindings.json"),tasksResource:(0,k.joinPath)(r,"tasks.json"),snippetsHome:(0,k.joinPath)(r,"snippets"),extensionsResource:(0,k.joinPath)(r,"extensions.json"),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=p;let t=class extends P.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,r,a,o){super(),this.m=n,this.n=r,this.r=a,this.s=o,this.f=!0,this.g=this.B(new R.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new R.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new R.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new R.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new m.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,k.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)try{for(const l of this.I()){if(!l.name||!(0,v.isString)(l.name)||!l.location){this.s.warn("Skipping the invalid stored profile",l.location||l.name);continue}n.push(p((0,k.basename)(l.location),l.name,l.location,{shortName:l.shortName,useDefaultFlags:l.useDefaultFlags}))}}catch(l){this.s.error(l)}const r=new m.ResourceMap,a=new Map,o=this.v();if(n.unshift({...o,extensionsResource:this.N()??o.extensionsResource,isDefault:!0}),n.length)try{const l=this.L();if(l.workspaces)for(const[h,A]of Object.entries(l.workspaces)){const F=D.URI.parse(h),Y=n.find(ee=>ee.id===A);Y&&r.set(F,Y)}if(l.emptyWindows)for(const[h,A]of Object.entries(l.emptyWindows)){const F=n.find(Y=>Y.id===A);F&&a.set(h,F)}}catch(l){this.s.error(l)}this.t={profiles:n,workspaces:r,emptyWindows:a}}return this.t}v(){return p("__default__profile__",(0,S.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(n){const r="Temp",a=new RegExp(`${(0,f.escapeRegExpCharacters)(r)}\\s(\\d+)`);let o=0;for(const h of this.profiles){const A=a.exec(h.name),F=A?parseInt(A[1]):0;o=F>o?F:o}const l=`${r} ${o+1}`;return this.createProfile((0,O.hash)((0,u.generateUuid)()).toString(16),l,{transient:!0},n)}async createNamedProfile(n,r,a){return this.createProfile((0,O.hash)((0,u.generateUuid)()).toString(16),n,r,a)}async createProfile(n,r,a,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=await this.w(n,r,a);return o&&await this.setProfileForWorkspace(o,l),l}async w(n,r,a){if(!(0,v.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.k.get(r);return o||(o=(async()=>{try{const l=this.profiles.find(F=>F.name===r||F.id===n);if(l)return l;const h=p(n,r,(0,k.joinPath)(this.profilesHome,n),a);await this.n.createFolder(h.location);const A=[];return this.h.fire({profile:h,join(F){A.push(F)}}),await N.Promises.settled(A),this.C([h],[],[]),h}finally{this.k.delete(r)}})(),this.k.set(r,o)),o}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(o=>o.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);return a=p(a.id,r.name??a.name,a.location,{shortName:r.shortName??a.shortName,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags}),this.C([],[],[a]),a}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(o=>o.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const a=[];this.i.fire({profile:r,join(o){a.push(o)}});try{await Promise.allSettled(a)}catch(o){this.s.error(o)}for(const o of[...this.u.emptyWindows.keys()])r.id===this.u.emptyWindows.get(o)?.id&&this.u.emptyWindows.delete(o);for(const o of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(o)?.id&&this.u.workspaces.delete(o);this.G(),this.C([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(o){this.s.error(o)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(o=>o.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.F(n,a)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(n,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.r.extUri.isEqual(a.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(r=>!this.z(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.y(n);return D.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindows.get(r)??this.u.emptyWindows.get(r)}y(n){return(0,d.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,d.isWorkspaceIdentifier)(n)?n.configPath:n.id}z(n){return!!([...this.l.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location)))}C(n,r,a){const o=[...this.profiles,...n],l=[];this.l.profiles=[];for(let h of o)h.isDefault||r.some(A=>h.id===A.id)||(h=a.find(A=>h.id===A.id)??h,h.isTransient?this.l.profiles.push(h):l.push({location:h.location,name:h.name,shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}));this.J(l),this.t=void 0,this.D(n,r,a)}D(n,r,a){this.g.fire({added:n,removed:r,updated:a,all:this.profiles})}F(n,r,a){a=r?.isTransient?!0:a,a||this.F(n,void 0,!0);const o=this.y(n),l=a?this.l:this.u;D.URI.isUri(o)?(l.workspaces.delete(o),r&&l.workspaces.set(o,r)):(l.emptyWindows.delete(o),r&&l.emptyWindows.set(o,r)),a||this.G()}G(){const n={};for(const[a,o]of this.u.workspaces.entries())n[a.toString()]=o.id;const r={};for(const[a,o]of this.u.emptyWindows.entries())r[a.toString()]=o.id;this.M({workspaces:n,emptyWindows:r}),this.t=void 0}H(n){const r={},a=this.v();if(n.workspaces)for(const[l,h]of Object.entries(n.workspaces)){const A=D.URI.parse(h);r[l]=this.r.extUri.isEqual(A,a.location)?a.id:this.r.extUri.basename(A)}const o={};if(n.emptyWindows)for(const[l,h]of Object.entries(n.emptyWindows)){const A=D.URI.parse(h);o[l]=this.r.extUri.isEqual(A,a.location)?a.id:this.r.extUri.basename(A)}return{workspaces:r,emptyWindows:o}}I(){return[]}J(n){throw new Error("not implemented")}L(){return{}}M(n){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=he([Z(0,g.IEnvironmentService),Z(1,c.IFileService),Z(2,I.IUriIdentityService),Z(3,w.ILogService)],t),e.UserDataProfilesService=t;class s extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(n){this.a=n}L(){return this.Q}M(n){this.Q=n}}e.InMemoryUserDataProfilesService=s}),define(Q[147],_([0,1,19,5,23,7,4,2,12,11,87,21,26,32,6,31,25,22]),function(x,e,O,R,P,k,D,S,g,c,b,w,d,m,I,N,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var v;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(v=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let E=class extends S.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,r,a,o,l){super(),this.t=n,this.u=r,this.v=a,this.w=o,this.y=l,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new D.Emitter),this.m=this.B(new D.Emitter),this.n=this.B(new D.Emitter),this.p=this.B(new D.Emitter),this.s=[],this.B((0,S.toDisposable)(()=>{this.j.forEach(({task:h})=>h.cancel()),this.k.forEach(h=>h.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(a=>(0,w.isTargetPlatformCompatible)(a,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{if(!this.t.isEnabled())throw new w.ExtensionManagementError(b.localize(0,null),w.ExtensionManagementErrorCode.Internal);const a=await this.G(n,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(a.manifest,a.extension,r)}catch(a){throw t(this.u,"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(n),error:a}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(a),p(a)}}async uninstall(n,r={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,r,a){const o={...a,installOnlyNewlyAddedFromExtensionPack:c.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,m.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},l=te=>`${d.ExtensionKey.create(te).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!c.URI.isUri(r)){const te=this.j.get(l(r));if(te)return this.v.info("Extensions is already requested to install",r.identifier.id),te.task.waitUntilTaskIsFinished()}const h=[],A=[],F=[],Y=this.Q(n,r,o);c.URI.isUri(r)||this.j.set(l(r),{task:Y,waitingTasks:[]}),this.l.fire({identifier:Y.identifier,source:r,profileLocation:o.profileLocation}),this.v.info("Installing extension:",Y.identifier.id),h.push({task:Y,manifest:n});let ee=!1;try{if(o.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",Y.identifier.id);else try{const ie=await this.F(Y.identifier,n,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),ne=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:ae,manifest:fe}of(0,O.distinct)(ie,({gallery:oe})=>oe.identifier.id)){ee=ee||!!fe.extensionDependencies?.some(V=>(0,d.areSameExtensions)({id:V},Y.identifier));const oe=l(ae),ve=this.j.get(oe);if(ve){if(this.C(Y,ve.task)){const V=ve.task.identifier;this.v.info("Waiting for already requested installing extension",V.id,Y.identifier.id),ve.waitingTasks.push(Y),A.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,j=>j.some(M=>(0,d.areSameExtensions)(M.identifier,V)))).then(j=>{if(this.v.info("Finished waiting for already requested installing extension",V.id,Y.identifier.id),!j.find($=>(0,d.areSameExtensions)($.identifier,V))?.local)throw new Error(`Extension ${V.id} is not installed`)}))}}else if(!ne.some(({identifier:V})=>(0,d.areSameExtensions)(V,ae.identifier))){const V=this.Q(fe,ae,{...o,donotIncludePackAndDependencies:!0});this.j.set(oe,{task:V,waitingTasks:[Y]}),this.l.fire({identifier:V.identifier,source:ae,profileLocation:o.profileLocation}),this.v.info("Installing extension:",V.identifier.id,Y.identifier.id),h.push({task:V,manifest:fe})}}}catch(ie){if(c.URI.isUri(Y.source))(0,O.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",Y.identifier.id,ie.message),(0,O.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",Y.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",Y.identifier.id),ie}const te=h.reduce((ie,{task:ne,manifest:ae})=>(ie.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:ae}),ie),new Map);for(;te.size;){let ie;const ne=[...te.values()].filter(({manifest:ae})=>!ae.extensionDependencies?.some(fe=>te.has(fe.toLowerCase())));ne.length?ie=te.size===1?ne:ne.filter(({task:ae})=>!(ae===Y&&!ee)):(this.v.info("Found extensions with circular dependencies",ne.map(({task:ae})=>ae.identifier.id)),ie=[...te.values()]),await this.D(ie.map(async({task:ae})=>{const fe=new Date().getTime();try{const oe=await ae.run();if(await this.D(this.s.map(ve=>ve.postInstall(oe,ae.source,o,P.CancellationToken.None))),!c.URI.isUri(ae.source)){const ve=ae.operation===3,V=ve?void 0:(new Date().getTime()-ae.source.lastUpdated)/1e3;if(t(this.u,ve?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-fe,durationSinceUpdate:V}),g.isWeb&&ae.operation!==3)try{await this.t.reportStatistic(oe.manifest.publisher,oe.manifest.name,oe.manifest.version,"install")}catch{}}F.push({local:oe,identifier:ae.identifier,operation:ae.operation,source:ae.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:oe.isApplicationScoped})}catch(oe){throw c.URI.isUri(ae.source)||t(this.u,ae.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-fe,error:oe}),this.v.error("Error while installing the extension:",ae.identifier.id),oe}finally{te.delete(ae.identifier.id.toLowerCase())}}))}return A.length&&await this.D(A),F.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire(F),F.filter(({identifier:ie})=>(0,d.areSameExtensions)(ie,Y.identifier))[0].local}catch(te){if(h.forEach(({task:ie})=>ie.cancel()),F.length)try{const ie=await Promise.allSettled(F.map(({local:ne})=>this.R(ne,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let ne=0;ne<ie.length;ne++){const ae=ie[ne],{identifier:fe}=F[ne];ae.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",fe.id):this.v.warn("Rollback: Error while uninstalling extension",fe.id,(0,k.getErrorMessage)(ae.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,k.getErrorMessage)(ie),F.map(({identifier:ne})=>ne.id))}throw this.m.fire(h.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:o.context,profileLocation:o.profileLocation}))),te}finally{for(const{task:te}of h)te.source&&!c.URI.isUri(te.source)&&this.j.delete(l(te.source))}}C(n,r){for(const[,{task:a,waitingTasks:o}]of this.j.entries())if(a===n&&(o.includes(r)||o.some(l=>this.C(l,r)))||a===r&&o[0]&&!this.C(n,o[0]))return!1;return!0}async D(n){const r=[],a=[],o=await Promise.allSettled(n);for(const l of o)l.status==="fulfilled"?r.push(l.value):a.push(l.reason);if(a.length)throw y(a);return r}async F(n,r,a,o,l){if(!this.t.isEnabled())return[];const h=await this.getInstalled(void 0,l),A=[],F=[],Y=async(ee,te)=>{A.push(ee);const ie=te.extensionDependencies||[],ne=[...ie];if(te.extensionPack){const ae=a?h.find(fe=>(0,d.areSameExtensions)(fe.identifier,ee)):void 0;for(const fe of te.extensionPack)ae&&ae.manifest.extensionPack&&ae.manifest.extensionPack.some(oe=>(0,d.areSameExtensions)({id:oe},{id:fe}))||ne.every(oe=>!(0,d.areSameExtensions)({id:oe},{id:fe}))&&ne.push(fe)}if(ne.length){const ae=ne.filter(fe=>A.every(oe=>!(0,d.areSameExtensions)(oe,{id:fe})));if(ae.length){const fe=await this.t.getExtensions(ae.map(oe=>({id:oe,preRelease:o})),P.CancellationToken.None);for(const oe of fe){if(A.find(j=>(0,d.areSameExtensions)(j,oe.identifier)))continue;const ve=ie.some(j=>(0,d.areSameExtensions)({id:j},oe.identifier));let V;try{V=await this.G(oe,!1,o)}catch(j){if(j instanceof w.ExtensionManagementError&&j.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ve){this.v.info("Skipping the packed extension as it cannot be installed",oe.identifier.id);continue}else throw j}F.push({gallery:V.extension,manifest:V.manifest}),await Y(V.extension.identifier,V.manifest)}}}};return await Y(n,r),F}async G(n,r,a){if((await this.getExtensionsControlManifest()).malicious.some(A=>(0,d.areSameExtensions)(n.identifier,A)))throw new w.ExtensionManagementError(b.localize(1,null,n.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const A=await this.getTargetPlatform();throw new w.ExtensionManagementError(b.localize(2,null,n.identifier.id,this.w.nameLong,(0,w.TargetPlatformToString)(A)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.H(n,r,a);if(l){if(a&&!r&&n.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(b.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],P.CancellationToken.None))[0]?new w.ExtensionManagementError(b.localize(4,null,n.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(b.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",l.identifier.id);const h=await this.t.getManifest(l,P.CancellationToken.None);if(h===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(h.version!==l.version)throw new w.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:h}}async H(n,r,a){const o=await this.getTargetPlatform();let l=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==a&&(l=(await this.t.getExtensions([{...n.identifier,preRelease:a}],{targetPlatform:o,compatible:!0},P.CancellationToken.None))[0]||null),!l&&await this.t.isExtensionCompatible(n,a,o)&&(l=n),l||(r?l=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:o,compatible:!0},P.CancellationToken.None))[0]||null:l=await this.t.getCompatibleExtension(n,a,o)),l}async I(n,r){const a={...r,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},o=ee=>`${ee.id.toLowerCase()}${a.versionOnly?`-${n.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,l=this.k.get(o(n.identifier));if(l)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),l.waitUntilTaskIsFinished();const h=ee=>{const te=this.R(ee,a);return this.k.set(o(te.extension.identifier),te),a.profileLocation?this.v.info("Uninstalling extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,a.profileLocation.toString()):this.v.info("Uninstalling extension:",`${ee.identifier.id}@${ee.manifest.version}`),this.n.fire({identifier:ee.identifier,profileLocation:a.profileLocation,applicationScoped:ee.isApplicationScoped}),te},A=(ee,te)=>{te?a.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,a.profileLocation.toString(),te.message):this.v.error("Failed to uninstall extension:",`${ee.identifier.id}@${ee.manifest.version}`,te.message):a.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${ee.identifier.id}@${ee.manifest.version}`,a.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${ee.identifier.id}@${ee.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,d.getLocalExtensionTelemetryData)(ee),error:te}),this.p.fire({identifier:ee.identifier,error:te?.code,profileLocation:a.profileLocation,applicationScoped:ee.isApplicationScoped})},F=[],Y=[];try{F.push(h(n));const ee=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const te=this.M(n,ee);for(const ie of te)this.k.has(o(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):F.push(h(ie))}a.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(F.map(te=>te.extension),ee,n),await this.D(F.map(async te=>{try{if(await te.run(),await this.D(this.s.map(ie=>ie.postUninstall(te.extension,a,P.CancellationToken.None))),te.extension.identifier.uuid)try{await this.t.reportStatistic(te.extension.manifest.publisher,te.extension.manifest.name,te.extension.manifest.version,"uninstall")}catch{}A(te.extension)}catch(ie){const ne=ie instanceof w.ExtensionManagementError?ie:new w.ExtensionManagementError((0,k.getErrorMessage)(ie),w.ExtensionManagementErrorCode.Internal);throw A(te.extension,ne),ne}finally{Y.push(te)}}))}catch(ee){const te=ee instanceof w.ExtensionManagementError?ee:new w.ExtensionManagementError((0,k.getErrorMessage)(ee),w.ExtensionManagementErrorCode.Internal);for(const ie of F){try{ie.cancel()}catch{}Y.includes(ie)||A(ie.extension,te)}throw te}finally{for(const ee of F)this.k.delete(o(ee.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",ee.extension.identifier.id)}}J(n,r,a){for(const o of n){const l=this.N(o,r);if(l.length){const h=l.filter(A=>!n.some(F=>(0,d.areSameExtensions)(F.identifier,A.identifier)));if(h.length)throw new Error(this.L(o,h,a))}}}L(n,r,a){return a===n?r.length===1?b.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?b.localize(9,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(10,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(11,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(n,r,a=[]){if(a.indexOf(n)!==-1)return[];a.push(n);const o=n.manifest.extensionPack?n.manifest.extensionPack:[];if(o.length){const l=r.filter(A=>!A.isBuiltin&&o.some(F=>(0,d.areSameExtensions)({id:F},A.identifier))),h=[];for(const A of l)h.push(...this.M(A,r,a));return[...l,...h]}return[]}N(n,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(o=>(0,d.areSameExtensions)({id:o},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};E=he([Z(0,w.IExtensionGalleryService),Z(1,u.ITelemetryService),Z(2,I.ILogService),Z(3,N.IProductService),Z(4,f.IUserDataProfilesService)],E),e.AbstractExtensionManagementService=E;function y(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=y;function p(i){if(i instanceof w.ExtensionManagementError)return i;const n=new w.ExtensionManagementError(i.message,w.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}function t(i,n,{extensionData:r,verificationStatus:a,duration:o,error:l,durationSinceUpdate:h}){let A,F;l&&(l instanceof w.ExtensionManagementError?(A=l.code,l.code===w.ExtensionManagementErrorCode.Signature&&(F=l.message)):A=w.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:a,success:!l,duration:o,errorcode:A,errorcodeDetail:F,durationSinceUpdate:h})}class s{constructor(){this.d=new R.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.createCancelablePromise)(n=>new Promise((r,a)=>{const o=n.onCancellationRequested(()=>{o.dispose(),a(new k.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=s}),define(Q[40],_([0,1,5,14,2,4,36,11,21,26,13,10,6,22,27,3,7,25]),function(x,e,O,R,P,k,D,S,g,c,b,w,d,m,I,N,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var v;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(v=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class E extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=E,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let y=class extends P.Disposable{constructor(i,n,r,a,o,l){super(),this.i=i,this.j=n,this.k=r,this.l=a,this.m=o,this.n=l,this.b=this.B(new k.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new k.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new D.ResourceMap}scanProfileExtensions(i,n){return this.p(i,void 0,n)}async addExtensionsToProfile(i,n){const r=[],a=[];try{return await this.p(n,o=>{const l=[];for(const h of o)i.some(([A])=>(0,c.areSameExtensions)(A.identifier,h.identifier)&&A.manifest.version!==h.version)?r.push(h):l.push(h);for(const[h,A]of i)if(!l.some(F=>(0,c.areSameExtensions)(F.identifier,h.identifier)&&F.version===h.manifest.version)){const F={identifier:h.identifier,version:h.manifest.version,location:h.location,metadata:A};a.push(F),l.push(F)}return a.length&&this.b.fire({extensions:a,profileLocation:n}),r.length&&this.f.fire({extensions:r,profileLocation:n}),l}),a.length&&this.c.fire({extensions:a,profileLocation:n}),r.length&&this.g.fire({extensions:r,profileLocation:n}),a}catch(o){throw a.length&&this.c.fire({extensions:a,error:o,profileLocation:n}),r.length&&this.g.fire({extensions:r,error:o,profileLocation:n}),o}}async updateMetadata(i,n){const r=[];return await this.p(n,a=>{const o=[];for(const l of a){const h=i.find(([A])=>(0,c.areSameExtensions)(A.identifier,l.identifier)&&A.manifest.version===l.version);h&&(l.metadata={...l.metadata,...h[1]},r.push(l)),o.push(l)}return o}),r}async removeExtensionFromProfile(i,n){const r=[];this.f.fire({extensions:r,profileLocation:n});try{await this.p(n,a=>{const o=[];for(const l of a)(0,c.areSameExtensions)(l.identifier,i.identifier)?r.push(l):o.push(l);return r.length&&this.f.fire({extensions:r,profileLocation:n}),o}),r.length&&this.g.fire({extensions:r,profileLocation:n})}catch(a){throw r.length&&this.g.fire({extensions:r,error:a,profileLocation:n}),a}}async p(i,n,r){return this.w(i).queue(async()=>{let a=[],o;try{const l=await this.j.readFile(i);o=JSON.parse(l.value.toString().trim()||"[]")}catch(l){if((0,b.toFileOperationResult)(l)!==1)throw l;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(o=await this.v()),!o&&r?.bailOutWhenFileNotFound)throw new E((0,u.getErrorMessage)(l),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.r(i);let l=!1;for(const h of o){p(h)||this.r(i);let A;if((0,N.isString)(h.relativeLocation)&&h.relativeLocation)A=this.t(h.relativeLocation);else if((0,N.isString)(h.location))A=this.t(h.location),l=!0,h.relativeLocation=h.location,h.location=A.toJSON();else{A=S.URI.revive(h.location);const F=this.s(A);F&&(l=!0,h.relativeLocation=F)}a.push({identifier:h.identifier,location:A,version:h.version,metadata:h.metadata})}l&&await this.j.writeFile(i,R.VSBuffer.fromString(JSON.stringify(o)))}if(n){a=n(a);const l=a.map(h=>({identifier:h.identifier,version:h.version,location:h.location.toJSON(),relativeLocation:this.s(h.location),metadata:h.metadata}));await this.j.writeFile(i,R.VSBuffer.fromString(JSON.stringify(l)))}return a})}r(i){const n=new E(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let r;try{r=(await this.j.readFile(i)).value.toString()}catch(o){if((0,b.toFileOperationResult)(o)===1)return;throw o}this.n.info("Migrating extensions from old default profile location",i.toString());let a;try{const o=JSON.parse(r);Array.isArray(o)&&o.every(l=>p(l))?a=o:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.n.error(o)}if(a)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify(a)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(o){if((0,b.toFileOperationResult)(o)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw o}try{await this.j.del(i)}catch(o){(0,b.toFileOperationResult)(o)!==1&&this.n.error(o)}try{await this.j.del(n)}catch(o){(0,b.toFileOperationResult)(o)!==1&&this.n.error(o)}return a})()),this.u}w(i){let n=this.h.get(i);return n||(n=new O.Queue,this.h.set(i,n)),n}};y=he([Z(1,b.IFileService),Z(2,m.IUserDataProfilesService),Z(3,I.IUriIdentityService),Z(4,f.ITelemetryService),Z(5,d.ILogService)],y),e.AbstractExtensionsProfileScannerService=y;function p(s){return(0,N.isObject)(s)&&(0,g.isIExtensionIdentifier)(s.identifier)&&(t(s.location)||(0,N.isString)(s.location)&&s.location)&&((0,N.isUndefined)(s.relativeLocation)||(0,N.isString)(s.relativeLocation))&&s.version&&(0,N.isString)(s.version)}function t(s){return s?(0,N.isString)(s.path)&&(0,N.isString)(s.scheme):!1}}),define(Q[47],_([0,1,19,5,28,14,7,49,78,2,16,15,12,18,41,52,3,11,91,17,26,32,44,13,10,6,31,4,53,40,22,27,107,108]),function(x,e,O,R,P,k,D,S,g,c,b,w,d,m,I,N,u,f,v,E,y,p,t,s,i,n,r,a,o,l,h,A,F,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var ee;(function(ve){function V(j,M){if(j===M)return!0;const $=Object.keys(j),W=new Set;for(const q of Object.keys(M))W.add(q);if($.length!==W.size)return!1;for(const q of $){if(j[q]!==M[q])return!1;W.delete(q)}return W.size===0}ve.equals=V})(ee=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let te=class extends c.Disposable{constructor(V,j,M,$,W,q,X,C,L,T,U,z){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=j,this.l=M,this.m=$,this.n=W,this.p=q,this.r=X,this.s=C,this.t=L,this.u=T,this.v=U,this.w=z,this.g=this.B(new a.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,m.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(ae,(0,m.joinPath)(this.m,p.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(ae,(0,m.joinPath)(this.m,p.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(ne,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,y.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(V,j,M){const[$,W]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(j)]),q=M?await this.scanExtensionsUnderDevelopment(V,[...$,...W]):[];return this.F($,W,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const j=[];j.push(this.G(!!V.useCache,V.language)),j.push(this.H(V.language,!!V.checkControlFile));const[M,$]=await Promise.all(j);return this.D([...M,...$],0,V,!1)}async scanUserExtensions(V){const j=V.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",j);const M=this.v.extUri.isEqual(V.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,$=await this.J(j,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,M),W=V.useCache&&!$.devMode&&$.excludeObsolete?this.j:this.k;let q;try{q=await W.scanExtensions($)}catch(X){if(X instanceof l.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),q=await W.scanExtensions($);else throw X}return q=await this.D(q,1,V,!0),this.s.trace("Scanned user extensions:",q.length),q}async scanExtensionsUnderDevelopment(V,j){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const M=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter($=>$.scheme===b.Schemas.file).map(async $=>{const W=await this.J($,!1,1,!0,V.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(W)).map(X=>(X.type=j.find(C=>(0,y.areSameExtensions)(C.identifier,X.identifier))?.type??X.type,this.k.validate(X,W)))}))).flat();return this.D(M,"development",V,!0)}return[]}async scanExistingExtension(V,j,M){const $=await this.J(V,!1,j,!0,M.language,!0,void 0),W=await this.k.scanExtension($);return!W||!M.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(V,j,M){const $=await this.J(V,!1,j,!0,M.language,!0,void 0),W=await this.k.scanOneOrMultipleExtensions($);return this.D(W,j,M,!0)}async scanMetadata(V){const j=(0,m.joinPath)(V,"package.json"),M=(await this.r.readFile(j)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(V,j){const M=(0,m.joinPath)(V,"package.json"),$=(await this.r.readFile(M)).value.toString(),W=JSON.parse($);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,W.__metadata={...W.__metadata,...j},await this.r.writeFile((0,m.joinPath)(V,"package.json"),k.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof l.ExtensionsProfileScanningError&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw V}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.p.addExtensionsToProfile(V.map(j=>[j,j.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,k.VSBuffer.fromString(JSON.stringify([])))}catch(j){(0,s.toFileOperationResult)(j)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.getErrorMessage)(j))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.s.error(V)}finally{this.z=void 0}})()),this.z}async D(V,j,M,$){return M.includeAllVersions||(V=this.F(j===0?V:void 0,j===1?V:void 0,j==="development"?V:void 0,await this.getTargetPlatform(),$)),M.includeInvalid||(V=V.filter(W=>W.isValid)),V.sort((W,q)=>{const X=w.basename(W.location.fsPath),C=w.basename(q.location.fsPath);return X<C?-1:X>C?1:0})}F(V,j,M,$,W){const q=(C,L,T)=>{if(C.isValid&&!L.isValid)return!1;if(C.isValid===L.isValid){if(W&&I.gt(C.manifest.version,L.manifest.version))return this.s.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${C.location.path} with version ${C.manifest.version}`),!1;if(I.eq(C.manifest.version,L.manifest.version)){if(C.type===0)return this.s.debug(`Skipping extension ${L.location.path} in favour of system extension ${C.location.path} with same version`),!1;if(C.targetPlatform===$)return this.s.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return T?this.s.warn(`Overwriting user extension ${C.location.path} with ${L.location.path}.`):this.s.debug(`Overwriting user extension ${C.location.path} with ${L.location.path}.`),!0},X=new Map;return V?.forEach(C=>{const L=p.ExtensionIdentifier.toKey(C.identifier.id),T=X.get(L);(!T||q(T,C,!1))&&X.set(L,C)}),j?.forEach(C=>{const L=p.ExtensionIdentifier.toKey(C.identifier.id),T=X.get(L);if(!T&&V&&C.type===0){this.s.debug(`Skipping obsolete system extension ${C.location.path}.`);return}(!T||q(T,C,!1))&&X.set(L,C)}),M?.forEach(C=>{const L=p.ExtensionIdentifier.toKey(C.identifier.id),T=X.get(L);(!T||q(T,C,!0))&&X.set(L,C),X.set(L,C)}),[...X.values()]}async G(V,j){this.s.trace("Started scanning system extensions");const M=await this.J(this.systemExtensionsLocation,!1,0,!0,j,!0,void 0),W=await(V&&!M.devMode?this.i:this.k).scanExtensions(M);return this.s.trace("Scanned system extensions:",W.length),W}async H(V,j){const M=this.t.isBuilt?[]:this.u.builtInExtensions;if(!M?.length)return[];this.s.trace("Started scanning dev system extensions");const $=j?await this.I():{},W=[],q=f.URI.file(w.normalize(w.join(b.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const C of M){const L=$[C.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":W.push((0,m.joinPath)(q,C.name));break;default:W.push(f.URI.file(L));break}}const X=await Promise.all(W.map(async C=>this.k.scanExtension(await this.J(C,!1,0,!0,V,!0,void 0))));return this.s.trace("Scanned dev system extensions:",X.length),(0,O.coalesce)(X)}async I(){try{const V=await this.r.readFile(this.l);return JSON.parse(V.value.toString())}catch{return{}}}async J(V,j,M,$,W,q,X){const C=await this.f(W??d.language),L=await this.L(V),T=j&&!this.v.extUri.isEqual(V,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,U=T?await this.L(T):void 0;return new ie(V,L,T,U,j,X,M,$,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,W,C)}async L(V){try{const j=await this.r.stat(V);if(typeof j.mtime=="number")return j.mtime}catch{}}};te=he([Z(4,h.IUserDataProfilesService),Z(5,l.IExtensionsProfileScannerService),Z(6,s.IFileService),Z(7,n.ILogService),Z(8,E.IEnvironmentService),Z(9,r.IProductService),Z(10,A.IUriIdentityService),Z(11,i.IInstantiationService)],te),e.AbstractExtensionsScannerService=te;class ie{constructor(V,j,M,$,W,q,X,C,L,T,U,z,G,H,re){this.location=V,this.mtime=j,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=$,this.profile=W,this.profileScanOptions=q,this.type=X,this.excludeObsolete=C,this.validate=L,this.productVersion=T,this.productDate=U,this.productCommit=z,this.devMode=G,this.language=H,this.translations=re}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,j){return(0,m.isEqual)(V.location,j.location)&&V.mtime===j.mtime&&(0,m.isEqual)(V.applicationExtensionslocation,j.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&V.profile===j.profile&&P.equals(V.profileScanOptions,j.profileScanOptions)&&V.type===j.type&&V.excludeObsolete===j.excludeObsolete&&V.validate===j.validate&&V.productVersion===j.productVersion&&V.productDate===j.productDate&&V.productCommit===j.productCommit&&V.devMode===j.devMode&&V.language===j.language&&ee.equals(V.translations,j.translations)}}e.ExtensionScannerInput=ie;let ne=class extends c.Disposable{constructor(V,j,M,$,W){super(),this.f=V,this.g=j,this.h=M,this.i=$,this.j=W}async scanExtensions(V){const j=V.profile?await this.l(V):await this.k(V);let M={};if(V.excludeObsolete&&V.type===1)try{const $=(await this.i.readFile(this.f)).value.toString();M=JSON.parse($)}catch{}return(0,u.isEmptyObject)(M)?j:j.filter($=>!M[y.ExtensionKey.create($).toString()])}async k(V){const j=await this.i.resolve(V.location);if(!j.children?.length)return[];const M=await Promise.all(j.children.map(async $=>{if(!$.isDirectory||V.type===1&&(0,m.basename)($.resource).indexOf(".")===0)return null;const W=new ie($.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(W)}));return(0,O.coalesce)(M).sort(($,W)=>$.location.path<W.location.path?-1:1)}async l(V){let j=await this.m(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){j=j.filter($=>!$.metadata?.isApplicationScoped);const M=await this.m(V.applicationExtensionslocation,$=>!!$.metadata?.isApplicationScoped,V);j.push(...M)}return j}async m(V,j,M){const $=await this.g.scanProfileExtensions(V,M.profileScanOptions);if(!$.length)return[];const W=await Promise.all($.map(async q=>{if(j(q)){const X=new ie(q.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(X,q.metadata)}return null}));return(0,O.coalesce)(W)}async scanOneOrMultipleExtensions(V){try{if(await this.i.exists((0,m.joinPath)(V.location,"package.json"))){const j=await this.scanExtension(V);return j?[j]:[]}else return await this.scanExtensions(V)}catch(j){return this.j.error(`Error scanning extensions at ${V.location.path}:`,(0,D.getErrorMessage)(j)),[]}}async scanExtension(V,j){try{let M=await this.scanExtensionManifest(V.location);if(M){M.publisher||(M.publisher=p.UNDEFINED_PUBLISHER),j=j??M.__metadata,delete M.__metadata;const $=(0,y.getGalleryExtensionId)(M.publisher,M.name),W=j?.id?{id:$,uuid:j.id}:{id:$},q=j?.isSystem?0:V.type,X=q===0||!!j?.isBuiltin;Y.ImplicitActivationEvents.updateManifest(M),M=await this.n(V.location,M,ie.createNlsConfiguration(V));const C={type:q,identifier:W,manifest:M,location:V.location,isBuiltin:X,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return V.validate?this.validate(C,V):C}}catch(M){V.type!==0&&this.j.error(M)}return null}validate(V,j){let M=!0;const $=(0,t.validateExtensionManifest)(j.productVersion,j.productDate,j.location,V.manifest,V.isBuiltin);for(const[W,q]of $)W===N.default.Error&&(M=!1,this.j.error(this.t(j.location,q)));return V.isValid=M,V.validations=$,V}async scanExtensionManifest(V){const j=(0,m.joinPath)(V,"package.json");let M;try{M=(await this.i.readFile(j)).value.toString()}catch(W){return(0,s.toFileOperationResult)(W)!==1&&this.j.error(this.t(V,(0,v.localize)(0,null,j.path,W.message))),null}let $;try{$=JSON.parse(M)}catch{const q=[];(0,S.parse)(M,q);for(const X of q)this.j.error(this.t(V,(0,v.localize)(1,null,j.path,X.offset,X.length,(0,g.getParseErrorMessage)(X.error))));return null}return(0,S.getNodeType)($)!=="object"?(this.j.error(this.t(V,(0,v.localize)(2,null,j.path))),null):$}async n(V,j,M){const $=await this.p(V,j,M);if($)try{const W=[],q=await this.r($.default,W);if(W.length>0)return W.forEach(C=>{this.j.error(this.t(V,(0,v.localize)(3,null,$.default?.path,(0,g.getParseErrorMessage)(C.error))))}),j;if((0,S.getNodeType)($)!=="object")return this.j.error(this.t(V,(0,v.localize)(4,null,$.default?.path))),j;const X=$.values||Object.create(null);return(0,F.localizeManifest)(j,X,q)}catch{}return j}async p(V,j,M){const $=(0,m.joinPath)(V,"package.nls.json"),W=(L,T)=>{T.forEach(U=>{this.j.error(this.t(V,(0,v.localize)(5,null,L?.path,(0,g.getParseErrorMessage)(U.error))))})},q=L=>{this.j.error(this.t(V,(0,v.localize)(6,null,L?.path)))},X=`${j.publisher}.${j.name}`,C=M.translations[X];if(C)try{const L=f.URI.file(C),T=(await this.i.readFile(L)).value.toString(),U=[],z=(0,S.parse)(T,U);return U.length>0?(W(L,U),{values:void 0,default:$}):(0,S.getNodeType)(z)!=="object"?(q(L),{values:void 0,default:$}):{values:z.contents?z.contents.package:void 0,default:$}}catch{return{values:void 0,default:$}}else{if(!await this.i.exists($))return;let T;try{T=await this.s(V,M)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const U=(await this.i.readFile(T.localized)).value.toString(),z=[],G=(0,S.parse)(U,z);return z.length>0?(W(T.localized,z),{values:void 0,default:T.original}):(0,S.getNodeType)(G)!=="object"?(q(T.localized),{values:void 0,default:T.original}):{values:G,default:T.original}}catch{return{values:void 0,default:T.original}}}}async r(V,j){if(V)try{const M=(await this.i.readFile(V)).value.toString();return(0,S.parse)(M,j)}catch{}}s(V,j){return new Promise((M,$)=>{const W=q=>{const X=(0,m.joinPath)(V,`package.nls.${q}.json`);this.i.exists(X).then(C=>{C&&M({localized:X,original:(0,m.joinPath)(V,"package.nls.json")});const L=q.lastIndexOf("-");L===-1?M({localized:(0,m.joinPath)(V,"package.nls.json"),original:null}):(q=q.substring(0,L),W(q))})};if(j.devMode||j.pseudo||!j.language)return M({localized:(0,m.joinPath)(V,"package.nls.json"),original:null});W(j.language)})}t(V,j){return`[${V.path}]: ${j}`}};ne=he([Z(1,l.IExtensionsProfileScannerService),Z(2,A.IUriIdentityService),Z(3,s.IFileService),Z(4,n.ILogService)],ne);let ae=class extends ne{constructor(V,j,M,$,W,q){super(j,M,$,W,q),this.y=V,this.v=this.B(new R.ThrottledDelayer(3e3)),this.w=this.B(new a.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(V){const j=await this.z();if(this.u=V,j&&j.input&&ie.equals(j.input,this.u))return this.j.debug("Using cached extensions scan result",V.location.toString()),this.v.trigger(()=>this.D()),j.result.map($=>($.location=f.URI.revive($.location),$));const M=await super.scanExtensions(V);return await this.C({input:V,result:M}),M}async z(){try{const V=await this.i.readFile(this.y),j=JSON.parse(V.value.toString());return{result:j.result,input:(0,o.revive)(j.input)}}catch(V){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,D.getErrorMessage)(V))}return null}async C(V){try{await this.i.writeFile(this.y,k.VSBuffer.fromString(JSON.stringify(V)))}catch(j){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,D.getErrorMessage)(j))}}async D(){if(!this.u)return;const V=await this.z();if(!V)return;const j=V.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!P.equals(M,j))try{await this.i.del(this.y),this.w.fire()}catch($){this.j.error($)}}};ae=he([Z(2,l.IExtensionsProfileScannerService),Z(3,A.IUriIdentityService),Z(4,s.IFileService),Z(5,n.ILogService)],ae);function fe(ve,V){const j=(0,y.getExtensionId)(ve.manifest.publisher,ve.manifest.name);return{id:j,identifier:new p.ExtensionIdentifier(j),isBuiltin:ve.type===0,isUserBuiltin:ve.type===1&&ve.isBuiltin,isUnderDevelopment:V,extensionLocation:ve.location,uuid:ve.identifier.uuid,targetPlatform:ve.targetPlatform,...ve.manifest}}e.toExtensionDescription=fe;class oe extends te{constructor(V,j,M,$,W,q,X,C,L,T,U,z){super(V,j,(0,m.joinPath)(M,".vscode-oss-dev","extensions","control.json"),(0,m.joinPath)($,p.MANIFEST_CACHE_FOLDER),W,q,X,C,L,T,U,z),this.M=(async()=>{if(d.translationsConfigFile)try{const G=await this.r.readFile(f.URI.file(d.translationsConfigFile));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(V){return this.M}}e.NativeExtensionsScannerService=oe}),define(Q[148],_([0,1,57,5,34,4,2,16,15,20,6,22]),function(x,e,O,R,P,k,D,S,g,c,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends D.Disposable{constructor(I,N){super(),this.b=I,this.f=N,this.a=new R.Limiter(5)}async postUninstall(I){const N=this.g(I,"uninstall");N&&(this.f.info(I.identifier.id,I.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(N.script,"uninstall",N.args,!0,I),this.f.info("Finished running post uninstall script",I.identifier.id,I.manifest.version)}catch(u){this.f.error("Failed to run post uninstall script",I.identifier.id,I.manifest.version),this.f.error(u)}}));try{await c.Promises.rm(this.j(I))}catch(u){this.f.error("Error while removing extension storage path",I.identifier.id),this.f.error(u)}}g(I,N){const u=`vscode:${N}`;if(I.location.scheme===S.Schemas.file&&I.manifest&&I.manifest.scripts&&typeof I.manifest.scripts[u]=="string"){const f=I.manifest.scripts[u].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(I.identifier.id,I.manifest.version,`${u} should be a node script`),null):{script:(0,g.join)(I.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(I,N,u,f,v){return new Promise((E,y)=>{const p=this.i(I,N,u,v);let t;const s=i=>{t&&(clearTimeout(t),t=null),i?y(i):E(void 0)};p.on("error",i=>{s((0,P.toErrorMessage)(i)||"Unknown")}),p.on("exit",(i,n)=>{s(i?`post-${N} process exited with code ${i}`:void 0)}),f&&(t=setTimeout(()=>{t=null,p.kill(),y("timed out")},5e3))})}i(I,N,u,f){const v={silent:!0,execArgv:void 0},E=(0,O.fork)(I,[`--type=extension-post-${N}`,...u],v);E.stdout.setEncoding("utf8"),E.stderr.setEncoding("utf8");const y=k.Event.fromNodeEventEmitter(E.stdout,"data"),p=k.Event.fromNodeEventEmitter(E.stderr,"data");y(i=>this.f.info(f.identifier.id,f.manifest.version,`post-${N}`,i)),p(i=>this.f.error(f.identifier.id,f.manifest.version,`post-${N}`,i));const t=k.Event.any(k.Event.map(y,i=>({data:`%c${i}`,format:[""]})),k.Event.map(p,i=>({data:`%c${i}`,format:["color: red"]})));return k.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(f.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),E}j(I){return(0,g.join)(this.b.defaultProfile.globalStorageHome.fsPath,I.identifier.id.toLowerCase())}};d=he([Z(0,w.IUserDataProfilesService),Z(1,b.ILogService)],d),e.ExtensionsLifecycle=d}),define(Q[149],_([0,1,6,22,27,25,40,13,17,11]),function(x,e,O,R,P,k,D,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let b=class extends D.AbstractExtensionsProfileScannerService{constructor(d,m,I,N,u,f){super(c.URI.file(d.extensionsPath),m,I,N,u,f)}};b=he([Z(0,g.INativeEnvironmentService),Z(1,S.IFileService),Z(2,R.IUserDataProfilesService),Z(3,P.IUriIdentityService),Z(4,k.ITelemetryService),Z(5,O.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(Q[150],_([0,1,11,17,40,47,13,10,6,31,27,22]),function(x,e,O,R,P,k,D,S,g,c,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let d=class extends k.NativeExtensionsScannerService{constructor(I,N,u,f,v,E,y,p){super(O.URI.file(v.builtinExtensionsPath),O.URI.file(v.extensionsPath),v.userHome,O.URI.file(v.userDataPath),I,N,u,f,v,E,y,p)}};d=he([Z(0,w.IUserDataProfilesService),Z(1,P.IExtensionsProfileScannerService),Z(2,D.IFileService),Z(3,g.ILogService),Z(4,R.INativeEnvironmentService),Z(5,c.IProductService),Z(6,b.IUriIdentityService),Z(7,S.IInstantiationService)],d),e.ExtensionsScannerService=d}),define(Q[151],_([0,1,5,4,2,118,3,84,10,22]),function(x,e,O,R,P,k,D,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var b;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var d;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));function m(v){const E=v.get(e.TARGET_KEY);if(E)try{return JSON.parse(E)}catch{}return Object.create(null)}e.loadKeyTargets=m;class I extends P.Disposable{constructor(E={flushInterval:I.a}){super(),this.j=E,this.b=this.B(new R.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new R.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new O.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new P.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,O.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,P.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.J()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(E,y){if(y===e.TARGET_KEY){switch(E){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:E})}else this.b.fire({scope:E,key:y,target:this.F(E)[y]})}r(E){this.f.fire({reason:E})}get(E,y,p){return this.L(y)?.get(E,p)}getBoolean(E,y,p){return this.L(y)?.getBoolean(E,p)}getNumber(E,y,p){return this.L(y)?.getNumber(E,p)}store(E,y,p,t){if((0,D.isUndefinedOrNull)(y)){this.remove(E,p);return}this.t(()=>{this.u(E,p,t),this.L(p)?.set(E,y)})}remove(E,y){this.t(()=>{this.u(E,y,void 0),this.L(y)?.delete(E)})}t(E){this.b.pause(),this.c.pause();try{E()}finally{this.b.resume(),this.c.resume()}}keys(E,y){const p=[],t=this.F(E);for(const s of Object.keys(t))t[s]===y&&p.push(s);return p}u(E,y,p){const t=this.F(y);typeof p=="number"?t[E]!==p&&(t[E]=p,this.L(y)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[E]=="number"&&(delete t[E],this.L(y)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(E){switch(E){case-1:return this.D;case 0:return this.z;default:return this.w}}G(E){const y=this.L(E);return y?m(y):Object.create(null)}isNew(E){return this.getBoolean(e.IS_NEW_KEY,E)===!0}async flush(E=b.NONE){this.f.fire({reason:E});const y=this.L(-1),p=this.L(0),t=this.L(1);switch(E){case b.NONE:await O.Promises.settled([y?.whenFlushed()??Promise.resolve(),p?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await O.Promises.settled([y?.flush(0)??Promise.resolve(),p?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const E=this.L(-1)?.items??new Map,y=this.L(0)?.items??new Map,p=this.L(1)?.items??new Map;return f(E,y,p,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(E,y){return this.r(b.NONE),(0,c.isUserDataProfile)(E)?this.N(E,y):this.O(E,y)}H(E,y){return!(E.id===y.id||N(y)&&N(E))}I(E,y,p,t){this.t(()=>{if(t)for(const[s,i]of E)y.set(s,i);else{const s=new Set;for(const[i,n]of E)s.add(i),y.get(i)!==n&&this.n(p,i);for(const[i]of y.items)s.has(i)||this.n(p,i)}})}}I.a=60*1e3,e.AbstractStorageService=I;function N(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=N;class u extends I{constructor(){super(),this.p=this.B(new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(E=>this.n(1,E))),this.B(this.P.onDidChangeStorage(E=>this.n(0,E))),this.B(this.p.onDidChangeStorage(E=>this.n(-1,E)))}L(E){switch(E){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(E){switch(E){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(E){return!1}}e.InMemoryStorageService=u;async function f(v,E,y,p,t,s){const i=Y=>{try{return JSON.parse(Y)}catch{return Y}},n=new Map,r=new Map;v.forEach((Y,ee)=>{n.set(ee,Y),r.set(ee,i(Y))});const a=new Map,o=new Map;E.forEach((Y,ee)=>{a.set(ee,Y),o.set(ee,i(Y))});const l=new Map,h=new Map;y.forEach((Y,ee)=>{l.set(ee,Y),h.set(ee,i(Y))}),console.group(p!==t?`Storage: Application (path: ${p})`:`Storage: Application & Profile (path: ${p}, default profile)`);const A=[];if(n.forEach((Y,ee)=>{A.push({key:ee,value:Y})}),console.table(A),console.groupEnd(),console.log(r),p!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const Y=[];a.forEach((ee,te)=>{Y.push({key:te,value:ee})}),console.table(Y),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${s})`);const F=[];l.forEach((Y,ee)=>{F.push({key:ee,value:Y})}),console.table(F),console.groupEnd(),console.log(h)}e.logStorage=f}),define(Q[152],_([0,1,19,23,7,12,35,3,11,24,17,21,26,44,13,6,31,46,137,151,25]),function(x,e,O,R,P,k,D,S,g,c,b,w,d,m,I,N,u,f,v,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const p=k.isWeb?"web":(0,w.getTargetPlatform)(k.platform,D.arch),t="X-Market-Search-Activity-Id";var s;(function(L){L[L.None=0]="None",L[L.IncludeVersions=1]="IncludeVersions",L[L.IncludeFiles=2]="IncludeFiles",L[L.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",L[L.IncludeSharedAccounts=8]="IncludeSharedAccounts",L[L.IncludeVersionProperties=16]="IncludeVersionProperties",L[L.ExcludeNonValidated=32]="ExcludeNonValidated",L[L.IncludeInstallationTargets=64]="IncludeInstallationTargets",L[L.IncludeAssetUri=128]="IncludeAssetUri",L[L.IncludeStatistics=256]="IncludeStatistics",L[L.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",L[L.Unpublished=4096]="Unpublished",L[L.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function i(...L){return String(L.reduce((T,U)=>T|U,0))}var n;(function(L){L[L.Tag=1]="Tag",L[L.ExtensionId=4]="ExtensionId",L[L.Category=5]="Category",L[L.ExtensionName=7]="ExtensionName",L[L.Target=8]="Target",L[L.Featured=9]="Featured",L[L.SearchText=10]="SearchText",L[L.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class h{constructor(T=l){this.d=T}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(T,U=this.d.pageSize){return new h({...this.d,pageNumber:T,pageSize:U})}withFilter(T,...U){const z=[...this.d.criteria,...U.length?U.map(G=>({filterType:T,value:G})):[{filterType:T}]];return new h({...this.d,criteria:z})}withSortBy(T){return new h({...this.d,sortBy:T})}withSortOrder(T){return new h({...this.d,sortOrder:T})}withFlags(...T){return new h({...this.d,flags:T.reduce((U,z)=>U|z,0)})}withAssetTypes(...T){return new h({...this.d,assetTypes:T})}withSource(T){return new h({...this.d,source:T})}get raw(){const{criteria:T,pageNumber:U,pageSize:z,sortBy:G,sortOrder:H,flags:re,assetTypes:le}=this.d;return{filters:[{criteria:T,pageNumber:U,pageSize:z,sortBy:G,sortOrder:H}],assetTypes:le,flags:re}}get searchText(){const T=this.d.criteria.filter(U=>U.filterType===n.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(T=>String(T.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function A(L,T){const U=(L||[]).filter(z=>z.statisticName===T)[0];return U?U.value:0}function F(L){const T="Microsoft.VisualStudio.Code.Translation.";return L.files.filter(z=>z.assetType.indexOf(T)===0).reduce((z,G)=>{const H=te(L,G.assetType);return H&&z.push([G.assetType.substring(T.length),H]),z},[])}function Y(L){if(L.properties){const T=L.properties.filter(G=>G.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=T.filter(G=>U.test(G.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return te(L,r.Repository)}function ee(L){return{uri:`${L.fallbackAssetUri}/${r.VSIX}?redirect=true${L.targetPlatform?`&targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${r.VSIX}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}}function te(L,T){return L.files.filter(z=>z.assetType===T)[0]?{uri:`${L.assetUri}/${T}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${T}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}:null}function ie(L,T){const U=L.properties?L.properties.filter(G=>G.key===T):[],z=U.length>0&&U[0].value;return z?z.split(",").map(G=>(0,d.adoptToGalleryExtensionId)(G)):[]}function ne(L){const T=L.properties?L.properties.filter(U=>U.key===a.Engine):[];return T.length>0&&T[0].value||""}function ae(L){const T=L.properties?L.properties.filter(U=>U.key===a.PreRelease):[];return T.length>0&&T[0].value==="true"}function fe(L){const T=L.properties?L.properties.filter(z=>z.key===a.LocalizedLanguages):[],U=T.length>0&&T[0].value||"";return U?U.split(","):[]}function oe(L){return L.properties?.find(T=>T.key===a.SponsorLink)?.value}function ve(L){return L.indexOf("preview")!==-1}function V(L){return L.targetPlatform?(0,w.toTargetPlatform)(L.targetPlatform):"undefined"}function j(L){const T=(0,O.distinct)(L.versions.map(V)),U=!!L.tags?.includes(w.WEB_EXTENSION_TAG),z=T.indexOf("web");return U?z===-1&&T.push("web"):z!==-1&&T.splice(z,1),T}function M(L,T){const U=(0,w.getFallbackTargetPlarforms)(T);for(let z=0;z<L.length;z++){const G=L[z];if(G.version===L[z-1]?.version){let H=z;const re=V(G);if(re===T)for(;H>0&&L[H-1].version===G.version;)H--;else if(U.includes(re))for(;H>0&&L[H-1].version===G.version&&V(L[H-1])!==T;)H--;H!==z&&(L.splice(z,1),L.splice(H,0,G))}}return L}e.sortExtensionVersions=M;function $(L,T,U){L.telemetryData={index:T,querySource:U,queryActivityId:L.queryContext?.[t]}}function W(L,T,U,z){const G=L.versions[0],H={manifest:te(T,r.Manifest),readme:te(T,r.Details),changelog:te(T,r.Changelog),license:te(T,r.License),repository:Y(T),download:ee(T),icon:te(T,r.Icon),signature:te(T,r.Signature),coreTranslations:F(T)};return{identifier:{id:(0,d.getGalleryExtensionId)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},name:L.extensionName,version:T.version,displayName:L.displayName,publisherId:L.publisher.publisherId,publisher:L.publisher.publisherName,publisherDisplayName:L.publisher.displayName,publisherDomain:L.publisher.domain?{link:L.publisher.domain,verified:!!L.publisher.isDomainVerified}:void 0,publisherSponsorLink:oe(G),description:L.shortDescription||"",installCount:A(L.statistics,"install"),rating:A(L.statistics,"averagerating"),ratingCount:A(L.statistics,"ratingcount"),categories:L.categories||[],tags:L.tags||[],releaseDate:Date.parse(L.releaseDate),lastUpdated:Date.parse(L.lastUpdated),allTargetPlatforms:U,assets:H,properties:{dependencies:ie(T,a.Dependency),extensionPack:ie(T,a.ExtensionPack),engine:ne(T),localizedLanguages:fe(T),targetPlatform:V(T),isPreReleaseVersion:ae(T)},hasPreReleaseVersion:ae(G),hasReleaseVersion:!0,preview:ve(L.flags),isSigned:!!H.signature,queryContext:z}}let q=class{constructor(T,U,z,G,H,re,le,ye){this.k=U,this.l=z,this.n=G,this.o=H,this.q=re,this.u=le,this.w=ye;const me=le.extensionsGallery,ce=me?.servicePPEUrl&&ye.getValue("_extensionsGallery.enablePPE");this.d=ce?me.servicePPEUrl:me?.serviceUrl,this.g=ce?void 0:me?.searchUrl,this.h=me?.controlUrl,this.j=(0,v.resolveMarketplaceHeaders)(le.version,le,this.n,this.w,this.q,T,this.o)}x(T=""){return`${this.d}${T}`}isEnabled(){return!!this.d}async getExtensions(T,U,z){const G=R.CancellationToken.isCancellationToken(U)?{}:U,H=R.CancellationToken.isCancellationToken(U)?U:z,re=[],le=[],ye=[],me=[];let ce=!0;for(const ue of T){ue.uuid?le.push(ue.uuid):re.push(ue.id);const we=!!(ue.version||ue.preRelease);ye.push({id:ue.id,uuid:ue.uuid,includePreRelease:we}),ue.version&&me.push({id:ue.id,uuid:ue.uuid,version:ue.version}),ce=ce&&!!ue.hasPreRelease&&!we}if(!le.length&&!re.length)return[];let ge=new h().withPage(1,T.length);le.length&&(ge=ge.withFilter(n.ExtensionId,...le)),re.length&&(ge=ge.withFilter(n.ExtensionName,...re)),(G.queryAllVersions||ce)&&(ge=ge.withFlags(ge.flags,s.IncludeVersions)),G.source&&(ge=ge.withSource(G.source));const{extensions:se}=await this.z(ge,{targetPlatform:G.targetPlatform??p,includePreRelease:ye,versions:me,compatible:!!G.compatible},H);return G.source&&se.forEach((ue,we)=>$(ue,we,G.source)),se}async getCompatibleExtension(T,U,z){if((0,w.isNotWebExtensionInWebTargetPlatform)(T.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible(T,U,z))return T;const G=new h().withFlags(s.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,T.identifier.uuid),{extensions:H}=await this.z(G,{targetPlatform:z,compatible:!0,includePreRelease:U},R.CancellationToken.None);return H[0]||null}async isExtensionCompatible(T,U,z){if(!(0,w.isTargetPlatformCompatible)(T.properties.targetPlatform,T.allTargetPlatforms,z)||!U&&T.properties.isPreReleaseVersion)return!1;let G=T.properties.engine;if(!G){const H=await this.getManifest(T,R.CancellationToken.None);if(!H)throw new Error("Manifest was not found");G=H.engines.vscode}return(0,m.isEngineValid)(G,this.u.version,this.u.date)}async y(T,U,z,G,H){if(!(0,w.isTargetPlatformCompatible)(V(T),G,H)||U!=="any"&&ae(T)!==(U==="prerelease"))return!1;if(z)try{const re=await this.E(T);if(!(0,m.isEngineValid)(re,this.u.version,this.u.date))return!1}catch(re){return this.l.error(`Error while getting the engine for the version ${T.version}.`,(0,P.getErrorMessage)(re)),!1}return!0}async query(T,U){let z=T.text||"";const G=T.pageSize??50;let H=new h().withPage(1,G);z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ce,ge,se)=>(H=H.withFilter(n.Category,se||ge),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ce,ge,se)=>(H=H.withFilter(n.Tag,se||ge),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(n.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),H=H.withFilter(n.SearchText,z)),H=H.withSortBy(0)):T.ids?H=H.withFilter(n.ExtensionId,...T.ids):T.names?H=H.withFilter(n.ExtensionName,...T.names):H=H.withSortBy(4),typeof T.sortBy=="number"&&(H=H.withSortBy(T.sortBy)),typeof T.sortOrder=="number"&&(H=H.withSortOrder(T.sortOrder)),T.source&&(H=H.withSource(T.source));const re=async(ce,ge)=>{const{extensions:se,total:ue}=await this.z(ce,{targetPlatform:p,compatible:!1,includePreRelease:!!T.includePreRelease},ge);return se.forEach((we,Pe)=>$(we,(ce.pageNumber-1)*ce.pageSize+Pe,T.source)),{extensions:se,total:ue}},{extensions:le,total:ye}=await re(H,U),me=async(ce,ge)=>{if(ge.isCancellationRequested)throw new P.CancellationError;const{extensions:se}=await re(H.withPage(ce+1),ge);return se};return{firstPage:le,total:ye,pageSize:H.pageSize,getPage:me}}async z(T,U,z){const G=T.flags;!!(T.flags&s.IncludeLatestVersionOnly)&&!!(T.flags&s.IncludeVersions)&&(T=T.withFlags(T.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(T.flags&s.IncludeLatestVersionOnly)&&!(T.flags&s.IncludeVersions)&&(T=T.withFlags(T.flags,s.IncludeLatestVersionOnly)),U.versions?.length&&(T=T.withFlags(T.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),T=T.withFlags(T.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:H,total:re,context:le}=await this.B(T,z);if(!(T.flags&s.IncludeLatestVersionOnly)){const ge=[];for(const se of H){const ue=await this.A(se,U,le);ue&&ge.push(ue)}return{extensions:ge,total:re}}const me=[],ce=new Map;for(let ge=0;ge<H.length;ge++){const se=H[ge],ue={id:(0,d.getGalleryExtensionId)(se.publisher.publisherName,se.extensionName),uuid:se.extensionId},we=(0,S.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(je=>(0,d.areSameExtensions)(je,ue))?.includePreRelease;if(U.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(j(se),U.targetPlatform))continue;const Pe=await this.A(se,U,le);!Pe||Pe.properties.isPreReleaseVersion&&(!we||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==U.targetPlatform&&Pe.hasPreReleaseVersion?ce.set(se.extensionId,ge):me.push([ge,Pe])}if(ce.size){const ge=new Date().getTime(),se=new h().withFlags(G&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,ce.size).withFilter(n.ExtensionId,...ce.keys()),{extensions:ue}=await this.z(se,U,z);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:ce.size});for(const we of ue){const Pe=ce.get(we.identifier.uuid);me.push([Pe,we])}}return{extensions:me.sort((ge,se)=>ge[0]-se[0]).map(([,ge])=>ge),total:re}}async A(T,U,z){const G={id:(0,d.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},H=U.versions?.find(me=>(0,d.areSameExtensions)(me,G))?.version,re=(0,S.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(me=>(0,d.areSameExtensions)(me,G))?.includePreRelease,le=j(T),ye=M(T.versions,U.targetPlatform);if(U.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(le,U.targetPlatform))return null;for(let me=0;me<ye.length;me++){const ce=ye[me];if(!(H&&ce.version!==H)){if(await this.y(ce,re?"any":"release",U.compatible,le,U.targetPlatform))return W(T,ce,le,z);if(H&&ce.version===H)return null}}return H||U.compatible?null:W(T,T.versions[0],le)}async B(T,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,s.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(s.Unpublished));const z=await this.j,G=JSON.stringify(T.raw),H={...z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},re=new Date().getTime();let le,ye,me=0;try{if(le=await this.k.request({type:"POST",url:this.g&&T.criteria.some(ge=>ge.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:H},U),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:me};const ce=await(0,f.asJson)(le);if(ce){const ge=ce.results[0],se=ge.extensions,ue=ge.resultMetadata&&ge.resultMetadata.filter(we=>we.metadataType==="ResultCount")[0];return me=ue&&ue.metadataItems.filter(we=>we.name==="TotalCount")[0].count||0,{galleryExtensions:se,total:me,context:{[t]:le.res.headers.activityid}}}return{galleryExtensions:[],total:me}}catch(ce){throw ye=ce,ce}finally{this.o.publicLog2("galleryService:query",{...T.telemetryData,requestBodySize:String(G.length),duration:new Date().getTime()-re,success:!!le&&(0,f.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:ye?(0,P.isCancellationError)(ye)?"canceled":(0,P.getErrorMessage)(ye).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(me)})}}async reportStatistic(T,U,z,G){if(!this.isEnabled())return;const H=k.isWeb?this.x(`/itemName/${T}.${U}/version/${z}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${T}/extensions/${U}/${z}/stats?statType=${G}`),re=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ye={...await this.j,Accept:re};try{await this.k.request({type:"POST",url:H,headers:ye},R.CancellationToken.None)}catch{}}async download(T,U,z){this.l.trace("ExtensionGalleryService#download",T.identifier.id);const G=(0,d.getGalleryExtensionTelemetryData)(T),H=new Date().getTime(),re=ge=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:ge}),le=z===2?"install":z===3?"update":"",ye=le?{uri:`${T.assets.download.uri}${g.URI.parse(T.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${T.assets.download.fallbackUri}${g.URI.parse(T.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:T.assets.download,me=T.queryContext?.[t]?{[t]:T.queryContext[t]}:void 0,ce=await this.D(ye,me?{headers:me}:void 0);await this.q.writeFile(U,ce.stream),re(new Date().getTime()-H)}async downloadSignatureArchive(T,U){if(!T.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",T.identifier.id);const z=await this.D(T.assets.signature);await this.q.writeFile(U,z.stream)}async getReadme(T,U){if(T.assets.readme){const z=await this.D(T.assets.readme,{},U);return await(0,f.asTextOrError)(z)||""}return""}async getManifest(T,U){if(T.assets.manifest){const z=await this.D(T.assets.manifest,{},U),G=await(0,f.asTextOrError)(z);return G?JSON.parse(G):null}return null}async C(T,U){const z=te(T,r.Manifest);if(!z)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},H=await this.D(z,{headers:G});return await(0,f.asJson)(H)}async getCoreTranslation(T,U){const z=T.assets.coreTranslations.filter(G=>G[0]===U.toUpperCase())[0];if(z){const G=await this.D(z[1]),H=await(0,f.asTextOrError)(G);return H?JSON.parse(H):null}return null}async getChangelog(T,U){if(T.assets.changelog){const z=await this.D(T.assets.changelog,{},U);return await(0,f.asTextOrError)(z)||""}return""}async getAllCompatibleVersions(T,U,z){let G=new h().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);T.identifier.uuid?G=G.withFilter(n.ExtensionId,T.identifier.uuid):G=G.withFilter(n.ExtensionName,T.identifier.id);const{galleryExtensions:H}=await this.B(G,R.CancellationToken.None);if(!H.length)return[];const re=j(H[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(re,z))return[];const le=[];await Promise.all(H[0].versions.map(async ce=>{try{await this.y(ce,U?"any":"release",!0,re,z)&&le.push(ce)}catch{}}));const ye=[],me=new Set;for(const ce of M(le,z))me.has(ce.version)||(me.add(ce.version),ye.push({version:ce.version,date:ce.lastUpdated,isPreReleaseVersion:ae(ce)}));return ye}async D(T,U={},z=R.CancellationToken.None){const G=await this.j,H={type:"GET"},re={...G,...U.headers||{}};U={...U,...H,headers:re};const le=T.uri,ye=T.fallbackUri,me={...U,url:le};try{const ce=await this.k.request(me,z);if(ce.res.statusCode===200)return ce;const ge=await(0,f.asTextOrError)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${ge}`)}catch(ce){if((0,P.isCancellationError)(ce))throw ce;const ge=(0,P.getErrorMessage)(ce);this.o.publicLog2("galleryService:cdnFallback",{url:le,message:ge});const se={...U,url:ye};return this.k.request(se,z)}}async E(T){let U=ne(T);if(!U){const z=await this.C(T,R.CancellationToken.None);if(!z)throw new Error("Manifest was not found");U=z.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const T=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,f.asJson)(T),z=[],G={};if(U){for(const H of U.malicious)z.push({id:H});if(U.migrateToPreRelease)for(const[H,re]of Object.entries(U.migrateToPreRelease))(!re.engine||(0,m.isEngineValid)(re.engine,this.u.version,this.u.date))&&(G[H.toLowerCase()]={disallowInstall:!0,extension:{id:re.id,displayName:re.displayName,autoMigrate:{storage:!!re.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[H,re]of Object.entries(U.deprecated))re&&(G[H.toLowerCase()]=(0,S.isBoolean)(re)?{}:re)}return{malicious:z,deprecated:G}}};q=he([Z(1,f.IRequestService),Z(2,N.ILogService),Z(3,b.IEnvironmentService),Z(4,y.ITelemetryService),Z(5,I.IFileService),Z(6,u.IProductService),Z(7,c.IConfigurationService)],q);let X=class extends q{constructor(T,U,z,G,H,re,le,ye){super(T,U,z,G,H,re,le,ye)}};X=he([Z(0,E.IStorageService),Z(1,f.IRequestService),Z(2,N.ILogService),Z(3,b.IEnvironmentService),Z(4,y.ITelemetryService),Z(5,I.IFileService),Z(6,u.IProductService),Z(7,c.IConfigurationService)],X),e.ExtensionGalleryService=X;let C=class extends q{constructor(T,U,z,G,H,re,le){super(void 0,T,U,z,G,H,re,le)}};C=he([Z(0,f.IRequestService),Z(1,N.ILogService),Z(2,b.IEnvironmentService),Z(3,y.ITelemetryService),Z(4,I.IFileService),Z(5,u.IProductService),Z(6,c.IConfigurationService)],C),e.ExtensionGalleryServiceWithNoStorageService=C}),define(Q[153],_([0,1,11,17,13,6,133,27,22,3,67]),function(x,e,O,R,P,k,D,S,g,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let w=class $e extends g.UserDataProfilesService{constructor(N,u,f,v,E){super(f,v,u,E),this.O=N,this.P=f}I(){return this.O.getItem($e.b,[]).map(u=>({...u,location:(0,c.isString)(u.location)?this.r.extUri.joinPath(this.profilesHome,u.location):O.URI.revive(u.location)}))}L(){const N=this.O.getItem($e.c,{});return this.O.getItem($e.a,!1)?N:this.H(N)}N(){return this.r.extUri.joinPath(O.URI.file(this.P.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};w.a="profileAssociationsMigration",w=he([Z(0,D.IStateReadService),Z(1,S.IUriIdentityService),Z(2,R.INativeEnvironmentService),Z(3,P.IFileService),Z(4,k.ILogService)],w),e.UserDataProfilesReadonlyService=w;let d=class ze extends w{constructor(N,u,f,v,E){super(N,u,f,v,E),this.U=N}J(N){N.length?this.U.setItem(ze.b,N.map(u=>({...u,location:this.r.extUri.basename(u.location)}))):this.U.removeItem(ze.b)}I(){const N=super.I();return this.U.getItem("userDataProfilesMigration",!1)||(this.J(N),this.U.setItem("userDataProfilesMigration",!0)),N}M(N){N.emptyWindows||N.workspaces?this.U.setItem(ze.c,N):this.U.removeItem(ze.c)}L(){const N="workspaceAndProfileInfo",u=this.U.getItem(N,void 0);if(u){this.U.removeItem(N);const v=u.reduce((E,{workspace:y,profile:p})=>(E[O.URI.revive(y).toString()]=O.URI.revive(p).toString(),E),{});this.U.setItem(ze.c,{workspaces:v})}const f=super.L();return this.U.getItem(ze.a,!1)||(this.M(f),this.U.setItem(ze.a,!0)),f}};d=he([Z(0,D.IStateService),Z(1,S.IUriIdentityService),Z(2,R.INativeEnvironmentService),Z(3,P.IFileService),Z(4,k.ILogService)],d),e.UserDataProfilesService=d;let m=class extends d{constructor(N,u,f,v){super(new b.StateService(0,u,v,f),N,u,f,v)}async init(){return await this.U.init(),super.init()}};m=he([Z(0,S.IUriIdentityService),Z(1,R.INativeEnvironmentService),Z(2,P.IFileService),Z(3,k.ILogService)],m),e.ServerUserDataProfilesService=m}),define(Q[69],_([0,1,120,5,15,3,20,85,167,168]),function(x,e,O,R,P,k,D,S,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class b extends Error{constructor(t,s){let i=s.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=s}}e.ExtractError=b;function w(p){const t=p.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,i)=>s+i,t&61440)}function d(p){if(p instanceof b)return p;let t;return/end of central directory record signature not found/.test(p.message)&&(t="CorruptZip"),new b(t,p)}function m(p,t,s,i,n,r){const a=P.dirname(t),o=P.join(i,a);if(!o.startsWith(i))return Promise.reject(new Error(S.localize(0,null,t)));const l=P.join(i,t);let h;return r.onCancellationRequested(()=>{h?.destroy()}),Promise.resolve(D.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((A,F)=>{if(!r.isCancellationRequested)try{h=(0,O.createWriteStream)(l,{mode:s}),h.once("close",()=>A()),h.once("error",F),p.once("error",F),p.pipe(h)}catch(Y){F(Y)}}))}function I(p,t,s,i){let n=(0,R.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{n.cancel(),p.close()}),new Promise((a,o)=>{const l=new R.Sequencer,h=A=>{A.isCancellationRequested||(r++,p.readEntry())};p.once("error",o),p.once("close",()=>n.then(()=>{i.isCancellationRequested||p.entryCount===r?a():o(new b("Incomplete",new Error(S.localize(1,null,r,p.entryCount))))},o)),p.readEntry(),p.on("entry",A=>{if(i.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){h(i);return}const F=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(F)){const te=P.join(t,F);n=(0,R.createCancelablePromise)(ie=>D.Promises.mkdir(te,{recursive:!0}).then(()=>h(ie)).then(void 0,o));return}const Y=u(p,A),ee=w(A);n=(0,R.createCancelablePromise)(te=>l.queue(()=>Y.then(ie=>m(ie,F,ee,t,s,te).then(()=>h(te)))).then(null,o))})})}function N(p,t=!1){return new Promise((s,i)=>{(0,g.open)(p,t?{lazyEntries:!0}:void 0,(n,r)=>{n?i(d(n)):s((0,k.assertIsDefined)(r))})})}function u(p,t){return new Promise((s,i)=>{p.openReadStream(t,(n,r)=>{n?i(d(n)):s((0,k.assertIsDefined)(r))})})}function f(p,t){return new Promise((s,i)=>{const n=new c.ZipFile;t.forEach(a=>{a.contents?n.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&n.addFile(a.localPath,a.path)}),n.end();const r=(0,O.createWriteStream)(p);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>s(p))})}e.zip=f;function v(p,t,s={},i){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=N(p,!0);return s.overwrite&&(r=r.then(a=>D.Promises.rm(t).then(()=>a))),r.then(a=>I(a,t,{sourcePathRegex:n},i))}e.extract=v;function E(p,t){return N(p).then(s=>new Promise((i,n)=>{s.on("entry",r=>{r.fileName===t&&u(s,r).then(a=>i(a),a=>n(a))}),s.once("close",()=>n(new Error(S.localize(2,null,t))))}))}function y(p,t){return E(p,t).then(s=>new Promise((i,n)=>{const r=[];s.once("error",n),s.on("data",a=>r.push(a)),s.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=y}),define(Q[154],_([0,1,69,93]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function P(k){return(0,O.buffer)(k,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.getManifest=P}),define(Q[155],_([0,1,5,14,23,34,7,4,2,36,16,15,12,18,41,3,11,29,20,69,92,58,17,147,21,26,40,47,135,148,154,128,136,32,44,13,10,6,31,25,27,22]),function(x,e,O,R,P,k,D,S,g,c,b,w,d,m,I,N,u,f,v,E,y,p,t,s,i,n,r,a,o,l,h,A,F,Y,ee,te,ie,ne,ae,fe,oe,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ie.refineServiceDecorator)(i.IExtensionManagementService);let V=class extends s.AbstractExtensionManagementService{constructor(C,L,T,U,z,G,H,re,le,ye,me,ce){super(C,L,T,ye,ce),this.Z=z,this.ab=G,this.bb=H,this.cb=le,this.db=me,this.X=this.B(new S.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new c.ResourceSet;const ge=this.B(re.createInstance(l.ExtensionsLifecycle));this.S=this.B(re.createInstance(j,ue=>ge.postUninstall(ue))),this.U=this.B(new A.ExtensionsManifestCache(U,this)),this.W=this.B(re.createInstance(o.ExtensionsDownloader));const se=this.B(new F.ExtensionsWatcher(this,this.Z,ce,G,me,le,T));this.B(se.onDidChangeExtensionsByAnotherSource(ue=>this.kb(ue))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,n.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(C){this.v.trace("ExtensionManagementService#zip",C.identifier.id);const L=await this.jb(C),T=await(0,E.zip)((0,m.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,L);return u.URI.file(T)}async unzip(C){return this.v.trace("ExtensionManagementService#unzip",C.toString()),(await this.install(C)).identifier}async getManifest(C){const{location:L,cleanup:T}=await this.fb(C),U=w.resolve(L.fsPath);try{return await(0,h.getManifest)(U)}finally{await T()}}getInstalled(C,L=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(C??null,L)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(C){return this.S.scanUserExtensionAtLocation(C)}async install(C,L={}){this.v.trace("ExtensionManagementService#install",C.toString());const{location:T,cleanup:U}=await this.fb(C);try{const z=await(0,h.getManifest)(w.resolve(T.fsPath));if(z.engines&&z.engines.vscode&&!(0,ee.isEngineValid)(z.engines.vscode,this.w.version,this.w.date))throw new Error(y.localize(0,null,(0,n.getGalleryExtensionId)(z.publisher,z.name),this.w.version));return await this.z(z,T,L)}finally{await U()}}async installFromLocation(C,L){this.v.trace("ExtensionManagementService#installFromLocation",C.toString());const T=await this.S.scanUserExtensionAtLocation(C);if(!T)throw new Error(`Cannot find a valid extension from the location ${C.toString()}`);return await this.ob([[T,void 0]],L),this.v.info("Successfully installed extension",T.identifier.id,L.toString()),T}async installExtensionsFromProfile(C,L,T){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",C,L.toString(),T.toString());const U=(await this.S.scanExtensions(1,L)).filter(z=>C.some(G=>(0,n.areSameExtensions)(G,z.identifier)));if(U.length){const z=await Promise.all(U.map(G=>this.S.scanMetadata(G,L)));await this.ob(U.map((G,H)=>[G,z[H]]),T),this.v.info("Successfully installed extensions",U.map(G=>G.identifier.id),T.toString())}return U}async updateMetadata(C,L,T=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",C.identifier.id),L.isPreReleaseVersion&&(L.preRelease=!0),L.isMachineScoped=L.isMachineScoped||void 0,L.isBuiltin=L.isBuiltin||void 0,L.pinned=L.pinned||void 0,C=await this.S.updateMetadata(C,L,T),this.U.invalidate(),this.X.fire(C),C}async reinstallFromGallery(C){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",C.identifier.id),!this.t.isEnabled())throw new Error(y.localize(1,null));const L=await this.getTargetPlatform(),[T]=await this.t.getExtensions([{...C.identifier,preRelease:C.preRelease}],{targetPlatform:L,compatible:!0},P.CancellationToken.None);if(!T)throw new Error(y.localize(2,null));await this.S.setUninstalled(C);try{await this.S.removeUninstalledExtension(C)}catch(U){throw new Error(y.localize(3,null,(0,k.toErrorMessage)(U)))}return this.installFromGallery(T)}copyExtensions(C,L){return this.S.copyExtensions(C,L)}markAsUninstalled(...C){return this.S.setUninstalled(...C)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(C){this.v.error(C)}}async download(C,L){const{location:T}=await this.W.download(C,L);return T}async fb(C){if(C.scheme===b.Schemas.file)return{location:C,async cleanup(){}};this.v.trace("Downloading extension from",C.toString());const L=(0,m.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)());return await this.bb.download(C,L),this.v.info("Downloaded extension to",L.toString()),{location:L,cleanup:async()=>{try{await this.cb.del(L)}catch(U){this.v.error(U)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(C,L,T){if(u.URI.isUri(L))return new W(C,L,T,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const U=n.ExtensionKey.create(L).toString();let z=this.Y.get(U);return z||(this.Y.set(U,z=new $(C,L,T,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),z.waitUntilTaskIsFinished().then(()=>this.Y.delete(U))),z}R(C,L){return new q(C,L.profileLocation,this.ab)}async jb(C){const L=async U=>{let z=await v.Promises.readdir(U);z=z.map(re=>w.join(U,re));const G=await Promise.all(z.map(re=>v.Promises.stat(re)));let H=Promise.resolve([]);return G.forEach((re,le)=>{const ye=z[le];re.isFile()&&(H=H.then(me=>[...me,ye])),re.isDirectory()&&(H=H.then(me=>L(ye).then(ce=>[...me,...ce])))}),H};return(await L(C.location.fsPath)).map(U=>({path:`extension/${w.relative(C.location.fsPath,U)}`,localPath:U}))}async kb({added:C,removed:L}){if(L)for(const T of L.extensions)this.v.info("Extensions removed from another source",T.id,L.profileLocation.toString()),this.p.fire({identifier:T,profileLocation:L.profileLocation});if(C){const U=(await this.S.scanExtensions(1,C.profileLocation)).filter(z=>C.extensions.some(G=>(0,n.areSameExtensions)(G,z.identifier)));this.m.fire(U.map(z=>(this.v.info("Extensions added from another source",z.identifier.id,C.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:C.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(L=>this.lb.add(L)));const C=await this.cb.resolve(this.Z.userExtensionsLocation);for(const L of C.children??[])L.isDirectory&&this.lb.add(L.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(L=>this.nb(L)))}async nb(C){if(!C.affects(this.Z.userExtensionsLocation,1))return;const L=[];for(const T of C.rawAdded){if(this.lb.has(T)||!this.db.extUri.isEqual(this.db.extUri.dirname(T),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(T,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(T).startsWith(".")||!(await this.cb.stat(T)).isDirectory)continue;const U=await this.S.scanUserExtensionAtLocation(T);U&&U.installedTimestamp===void 0&&(this.lb.add(T),L.push(U))}L.length&&(await this.ob(L.map(T=>[T,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",L.map(T=>T.identifier.id)))}async ob(C,L){const T=C.map(U=>U[0]);await this.pb(T),await this.ab.addExtensionsToProfile(C,L),this.m.fire(T.map(U=>({local:U,identifier:U.identifier,operation:1,profileLocation:L})))}async pb(C){const L=await this.S.getUninstalledExtensions();for(const T of C){const U=n.ExtensionKey.create(T);!L[U.toString()]||(this.v.trace("Removing the extension from uninstalled list:",U.id),await this.S.setInstalled(U),this.v.info("Removed the extension from uninstalled list:",U.id))}}};V=he([Z(0,i.IExtensionGalleryService),Z(1,fe.ITelemetryService),Z(2,ne.ILogService),Z(3,t.INativeEnvironmentService),Z(4,a.IExtensionsScannerService),Z(5,r.IExtensionsProfileScannerService),Z(6,p.IDownloadService),Z(7,ie.IInstantiationService),Z(8,te.IFileService),Z(9,ae.IProductService),Z(10,oe.IUriIdentityService),Z(11,ve.IUserDataProfilesService)],V),e.ExtensionManagementService=V;let j=class extends g.Disposable{constructor(C,L,T,U,z,G){super(),this.k=C,this.l=L,this.m=T,this.n=U,this.p=z,this.s=G,this.h=this.B(new S.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,m.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new O.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(C,L){const T={includeInvalid:!0,profileLocation:L};let U=[];return C===null||C===0?U.push(...await this.m.scanAllExtensions({includeInvalid:!0},T,!1)):C===1&&U.push(...await this.m.scanUserExtensions(T)),U=C!==null?U.filter(z=>z.type===C):U,Promise.all(U.map(z=>this.y(z)))}async scanAllUserExtensions(C){const L=await this.m.scanUserExtensions({includeAllVersions:!C,includeInvalid:!0});return Promise.all(L.map(T=>this.y(T)))}async scanUserExtensionAtLocation(C){try{const L=await this.m.scanExistingExtension(C,1,{includeInvalid:!0});if(L)return await this.y(L)}catch(L){this.s.error(L)}return null}async extractUserExtension(C,L,T,U){await this.j.catch(()=>{});const z=C.toString(),G=w.join(this.m.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`),H=w.join(this.m.userExtensionsLocation.fsPath,z);try{await v.Promises.rm(H)}catch{throw new i.ExtensionManagementError(y.localize(4,null,H,C.id),i.ExtensionManagementErrorCode.Delete)}await this.u(C,L,G,U),await this.m.updateMetadata(u.URI.file(G),T);try{this.h.fire(u.URI.file(H)),await this.v(C,G,H,Date.now()+2*60*1e3),this.s.info("Renamed to",H)}catch(re){try{await v.Promises.rm(G)}catch{}if(re.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",C.id);else throw this.s.info(`Rename failed because of ${(0,D.getErrorMessage)(re)}. Deleted from extracted location`,G),re}return this.w(u.URI.file(H),1)}async scanMetadata(C,L){return L?(await this.n.scanProfileExtensions(L)).find(U=>(0,n.areSameExtensions)(U.identifier,C.identifier))?.metadata:this.m.scanMetadata(C.location)}async updateMetadata(C,L,T){return T?await this.n.updateMetadata([[C,L]],T):await this.m.updateMetadata(C.location,L),this.w(C.location,C.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...C){const L=C.map(T=>n.ExtensionKey.create(T));await this.t(T=>L.forEach(U=>{T[U.toString()]=!0,this.s.info("Marked extension as uninstalled",U.toString())}))}async setInstalled(C){await this.t(L=>delete L[C.toString()])}async removeExtension(C,L){this.s.trace(`Deleting ${L} extension from disk`,C.identifier.id,C.location.fsPath);const T=this.p.extUri.joinPath(this.p.extUri.dirname(C.location),`.${(0,f.generateUuid)()}`);await this.v(C.identifier,C.location.fsPath,T.fsPath,Date.now()+2*60*1e3),await this.l.del(T,{recursive:!0}),this.s.info("Deleted from disk",C.identifier.id,C.location.fsPath)}async removeUninstalledExtension(C){await this.removeExtension(C,"uninstalled"),await this.t(L=>delete L[n.ExtensionKey.create(C).toString()])}async copyExtensions(C,L){const T=await this.scanExtensions(1,C),U=await Promise.all(T.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,C)]));await this.n.addExtensionsToProfile(U,L)}async t(C){return this.g.queue(async()=>{let L;try{L=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(U){if((0,te.toFileOperationResult)(U)!==1)throw U}let T={};if(L)try{T=JSON.parse(L)}catch{}return C&&(C(T),Object.keys(T).length?await this.l.writeFile(this.c,R.VSBuffer.fromString(JSON.stringify(T))):await this.l.del(this.c)),T})}async u(C,L,T,U){this.s.trace(`Started extracting the extension from ${L} to ${T}`);try{await v.Promises.rm(T)}catch(z){throw new i.ExtensionManagementError(this.D(z).message,i.ExtensionManagementErrorCode.Delete)}try{await(0,E.extract)(L,T,{sourcePath:"extension",overwrite:!0},U),this.s.info(`Extracted extension to ${T}:`,C.id)}catch(z){try{await v.Promises.rm(T)}catch{}let G=i.ExtensionManagementErrorCode.Extract;throw z instanceof E.ExtractError&&(z.type==="CorruptZip"?G=i.ExtensionManagementErrorCode.CorruptZip:z.type==="Incomplete"&&(G=i.ExtensionManagementErrorCode.IncompleteZip)),new i.ExtensionManagementError(z.message,G)}}async v(C,L,T,U){try{await v.Promises.rename(L,T)}catch(z){if(d.isWindows&&z&&z.code==="EPERM"&&Date.now()<U)return this.s.info(`Failed renaming ${L} to ${T} with 'EPERM' error. Trying again...`,C.id),this.v(C,L,T,U);throw new i.ExtensionManagementError(z.message||y.localize(5,null,L,T),z.code||i.ExtensionManagementErrorCode.Rename)}}async w(C,L){const T=await this.m.scanExistingExtension(C,L,{includeInvalid:!0});if(T)return this.y(T);throw new Error(y.localize(6,null,C.path))}async y(C){const L=await this.l.resolve(C.location);let T,U;return L.children&&(T=L.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,U=L.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:C.identifier,type:C.type,isBuiltin:C.isBuiltin||!!C.metadata?.isBuiltin,location:C.location,manifest:C.manifest,targetPlatform:C.targetPlatform,validations:C.validations,isValid:C.isValid,readmeUrl:T,changelogUrl:U,publisherDisplayName:C.metadata?.publisherDisplayName||null,publisherId:C.metadata?.publisherId||null,isApplicationScoped:!!C.metadata?.isApplicationScoped,isMachineScoped:!!C.metadata?.isMachineScoped,isPreReleaseVersion:!!C.metadata?.isPreReleaseVersion,preRelease:!!C.metadata?.preRelease,installedTimestamp:C.metadata?.installedTimestamp,updated:!!C.metadata?.updated,pinned:!!C.metadata?.pinned}}async z(){const C=await this.getUninstalledExtensions();this.s.debug("Removing uninstalled extensions:",Object.keys(C));const L=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),T=new Set;for(const z of L)C[n.ExtensionKey.create(z).toString()]||T.add(z.identifier.id.toLowerCase());try{const z=(0,n.groupByExtension)(L,G=>G.identifier);await O.Promises.settled(z.map(async G=>{const H=G.sort((re,le)=>I.rcompare(re.manifest.version,le.manifest.version))[0];T.has(H.identifier.id.toLowerCase())||await this.k(await this.y(H))}))}catch(z){this.s.error(z)}const U=L.filter(z=>z.metadata&&C[n.ExtensionKey.create(z).toString()]);await Promise.allSettled(U.map(z=>this.removeUninstalledExtension(z)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const C=[];let L;try{L=await this.l.resolve(this.m.userExtensionsLocation)}catch(T){(0,te.toFileOperationResult)(T)!==1&&this.s.error(T)}for(const T of L?.children??[])T.isDirectory&&T.name.startsWith(".")&&(0,f.isUUID)(T.name.substring(1))&&C.push((async()=>{this.s.trace("Deleting the generated extension folder",T.resource.toString());try{await this.l.del(T.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",T.resource.toString())}catch(U){this.s.error(U)}})());await Promise.allSettled(C)}D(C){const L=Array.isArray(C)?C:[C];return L.length===1?L[0]instanceof Error?L[0]:new Error(L[0]):L.reduce((T,U)=>new Error(`${T.message}${T.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}};j=he([Z(1,te.IFileService),Z(2,a.IExtensionsScannerService),Z(3,r.IExtensionsProfileScannerService),Z(4,oe.IUriIdentityService),Z(5,ne.ILogService)],j),e.ExtensionsScanner=j;class M extends s.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,N.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(C,L,T,U,z,G,H,re,le){super(),this.identifier=C,this.source=L,this.l=T,this.m=U,this.n=z,this.o=G,this.p=H,this.q=re,this.s=le,this.j="Unverified",this.k=2}async h(C){const[L,T]=await this.x(C);return this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.l.profileLocation)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[L,T]],this.l.profileLocation),L}async u({zipPath:C,key:L,metadata:T},U){let z=await this.v(L);return z||(this.s.trace("Extracting extension...",L.id),z=await this.m.extractUserExtension(L,C,T,U),this.s.info("Extracting extension completed.",L.id)),z}async v(C){return await this.w(C)?(this.s.trace("Removing the extension from uninstalled list:",C.id),await this.m.setInstalled(C),this.s.info("Removed the extension from uninstalled list:",C.id),(await this.m.scanAllUserExtensions(!0)).find(U=>n.ExtensionKey.create(U).equals(C))):void 0}async w(C){return!!(await this.m.getUninstalledExtensions())[C.toString()]}}class $ extends M{constructor(C,L,T,U,z,G,H,re,le,ye){super(L.identifier,L,T,z,G,H,re,le,ye),this.y=C,this.z=L,this.A=U}async x(C){const T=(await this.m.scanExtensions(null,this.l.profileLocation)).find(H=>(0,n.areSameExtensions)(H.identifier,this.z.identifier));T&&(this.k=3);const U={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:(0,Y.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||T?.isMachineScoped,isBuiltin:this.l.isBuiltin||T?.isBuiltin,isSystem:T?.type===0?!0:void 0,updated:!!T,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,N.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:T?.preRelease)};if(T?.manifest.version===this.z.version)return[await this.m.updateMetadata(T,U),U];const{location:z,verificationStatus:G}=await this.A.download(this.z,this.k);try{return this.j=G,this.C(z.fsPath),[await this.u({zipPath:z.fsPath,key:n.ExtensionKey.create(this.z),metadata:U},C),U]}catch(H){try{await this.A.delete(z)}catch(re){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,D.getErrorMessage)(re))}throw H}}async C(C){try{await(0,h.getManifest)(C)}catch(L){throw new i.ExtensionManagementError((0,s.joinErrors)(L).message,i.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=$;class W extends M{constructor(C,L,T,U,z,G,H,re,le,ye){super({id:(0,n.getGalleryExtensionId)(C.publisher,C.name)},L,T,z,G,H,re,le,ye),this.y=C,this.z=L,this.A=U}async x(C){const L=new n.ExtensionKey(this.identifier,this.y.version),U=(await this.m.scanExtensions(1,this.l.profileLocation)).find(H=>(0,n.areSameExtensions)(this.identifier,H.identifier)),z=await this.C(this.identifier.id,this.y.version,C);if(z.isApplicationScoped=(0,Y.isApplicationScopedExtension)(this.y),z.isMachineScoped=this.l.isMachineScoped||U?.isMachineScoped,z.isBuiltin=this.l.isBuiltin||U?.isBuiltin,z.installedTimestamp=Date.now(),z.pinned=this.l.installGivenVersion?!0:void 0,U)if(this.k=3,L.equals(new n.ExtensionKey(U.identifier,U.manifest.version)))try{await this.m.removeExtension(U,"existing")}catch{throw new Error(y.localize(7,null,this.y.displayName||this.y.name))}else!this.l.profileLocation&&I.gt(U.manifest.version,this.y.version)&&await this.m.setUninstalled(U);else{const H=await this.v(L);if(H)try{await this.m.removeExtension(H,"existing")}catch{throw new Error(y.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:w.resolve(this.z.fsPath),key:L,metadata:z},C),z]}async C(C,L,T){try{let[U]=await this.A.getExtensions([{id:C,version:L}],T);if(U||([U]=await this.A.getExtensions([{id:C}],T)),U)return{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId,isPreReleaseVersion:U.properties.isPreReleaseVersion,preRelease:U.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class q extends s.AbstractExtensionTask{constructor(C,L,T){super(),this.extension=C,this.j=L,this.k=T}async h(C){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Q[156],_([0,1,131,5,14,7,2,3,24,17,132,6,130,169]),function(x,e,O,R,P,k,D,S,g,c,b,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let I=class extends D.Disposable{constructor(u,f,v){super(),this.h=u,this.i=f,this.j=v,this.k(),this.B(u.onDidChangeConfiguration(E=>{E.affectsConfiguration("http")&&this.k()}))}k(){const u=this.h.getValue("http");this.a=u?.proxy,this.b=!!u?.proxyStrictSSL,this.f=u?.proxyAuthorization}async request(u,f){this.j.trace("RequestService#request (node) - begin",u.url);const{a:v,b:E}=this;let y;try{y=await(0,b.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(s){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",s))}const p={...process.env,...y},t=u.agent?u.agent:await(0,d.getProxyAgent)(u.url||"",p,{proxyUrl:v,strictSSL:E});u.agent=t,u.strictSSL=E,this.f&&(u.headers={...u.headers||{},"Proxy-Authorization":this.f});try{const s=await this.m(u,f);return this.j.trace("RequestService#request (node) - success",u.url),s}catch(s){throw this.j.trace("RequestService#request (node) - error",u.url,s),s}}async l(u){return((0,O.parse)(u.url).protocol==="https:"?await new Promise((E,y)=>{x(["https"],E,y)}):await new Promise((E,y)=>{x(["http"],E,y)})).request}m(u,f){return R.Promises.withAsyncBody(async(v,E)=>{const y=(0,O.parse)(u.url),p=u.getRawRequest?u.getRawRequest(u):await this.l(u),t={hostname:y.hostname,port:y.port?parseInt(y.port):y.protocol==="https:"?443:80,protocol:y.protocol,path:y.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,S.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(t.auth=u.user+":"+u.password);const s=p(t,i=>{const n=(0,S.isNumber)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this.m({...u,url:i.headers.location,followRedirects:n-1},f).then(v,E);else{let r=i;!u.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,m.createGunzip)())),v({res:i,stream:(0,P.streamToBufferReadableStream)(r)})}});s.on("error",E),u.timeout&&s.setTimeout(u.timeout),u.isChromiumNetwork&&s.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&s.write(u.data),s.end(),f.onCancellationRequested(()=>{s.abort(),E(new k.CancellationError)})})}async resolveProxy(u){}};I=he([Z(0,g.IConfigurationService),Z(1,c.INativeEnvironmentService),Z(2,w.ILogService)],I),e.RequestService=I}),define(Q[170],_([0,1,33,5,14,34,7,2,16,15,12,35,11,20,24,127,58,129,17,106,152,21,59,134,40,47,155,150,13,117,119,45,115,62,63,138,6,122,123,38,124,141,31,46,156,67,68,25,140,39,142,143,27,145,22,153,144,149,121]),function(x,e,O,R,P,k,D,S,g,c,b,w,d,m,I,N,u,f,v,E,y,p,t,s,i,n,r,a,o,l,h,A,F,Y,ee,te,ie,ne,ae,fe,oe,ve,V,j,M,$,W,q,X,C,L,T,U,z,G,H,re,le,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class me extends S.Disposable{constructor(se){super(),this.b=se,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[se,ue]=await this.f();return se.invokeFunction(async we=>{const Pe=we.get(ie.ILogService),je=we.get(o.IFileService),Ue=we.get(v.INativeEnvironmentService),B=we.get(G.IUserDataProfilesService);Pe.info("CLI main",this.b),this.g(Pe),await this.h(Ue,je,B,se),await Promise.all(ue.map(K=>{(0,R.raceTimeout)(K.flush(),1e3)}))})}async f(){const se=new Y.ServiceCollection,ue={_serviceBrand:void 0,...ve.default};se.set(V.IProductService,ue);const we=new E.NativeEnvironmentService(this.b,ue);se.set(v.INativeEnvironmentService,we),await Promise.all([we.appSettingsHome.fsPath,we.extensionsPath].map(Me=>Me?m.Promises.mkdir(Me,{recursive:!0}):void 0));const Pe=(0,ie.getLogLevel)(we),je=new ne.SpdLogLogger("cli",(0,c.join)(we.logsPath,"cli.log"),!0,!1,Pe),Ue=[];Pe===ie.LogLevel.Trace&&Ue.push(new ie.ConsoleLogger(Pe));const B=this.B(new ye.LogService(je,Ue));se.set(ie.ILogService,B);const K=this.B(new l.FileService(B));se.set(o.IFileService,K);const J=this.B(new h.DiskFileSystemProvider(B));K.registerProvider(g.Schemas.file,J);const de=new z.UriIdentityService(K);se.set(U.IUriIdentityService,de);const pe=new $.StateReadonlyService(1,we,B,K),Oe=new H.UserDataProfilesReadonlyService(pe,de,we,K,B);se.set(G.IUserDataProfilesService,Oe);const be=b.isWindows&&ue.win32RegValueName?this.B(new oe.NativePolicyService(B,ue.win32RegValueName)):we.policyFile?this.B(new ae.FilePolicyService(we.policyFile,K,B)):new fe.NullPolicyService;se.set(fe.IPolicyService,be);const Ne=this.B(new N.ConfigurationService(Oe.defaultProfile.settingsResource,K,be,B));se.set(I.IConfigurationService,Ne),await Promise.all([pe.init(),Ne.initialize()]),Oe.init(),se.set(U.IUriIdentityService,new z.UriIdentityService(K)),se.set(j.IRequestService,new A.SyncDescriptor(M.RequestService,void 0,!0)),se.set(u.IDownloadService,new A.SyncDescriptor(f.DownloadService,void 0,!0)),se.set(i.IExtensionsProfileScannerService,new A.SyncDescriptor(le.ExtensionsProfileScannerService,void 0,!0)),se.set(n.IExtensionsScannerService,new A.SyncDescriptor(a.ExtensionsScannerService,void 0,!0)),se.set(t.IExtensionSignatureVerificationService,new A.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),se.set(r.INativeServerExtensionManagementService,new A.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),se.set(p.IExtensionGalleryService,new A.SyncDescriptor(y.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),se.set(ee.ILanguagePackService,new A.SyncDescriptor(te.NativeLanguagePackService,void 0,!1));const Re=[],Le=(0,C.isInternalTelemetry)(ue,Ne);if((0,C.supportsTelemetry)(ue,we)){ue.aiConfig&&ue.aiConfig.ariaKey&&Re.push(new L.OneDataSystemAppender(Le,"monacoworkbench",null,ue.aiConfig.ariaKey));const{installSourcePath:Me}=we,ke={appenders:Re,sendErrorTelemetry:!1,commonProperties:(async()=>{let Te;try{Te=await(0,re.resolveMachineId)(pe)}catch(Ae){Ae.code!=="ENOENT"&&B.error(Ae)}return(0,W.resolveCommonProperties)(K,(0,O.release)(),(0,O.hostname)(),process.arch,ue.commit,ue.version,Te,Le,Me)})(),piiPaths:(0,C.getPiiPathsFromEnvironment)(we)};se.set(q.ITelemetryService,new A.SyncDescriptor(X.TelemetryService,[ke],!1))}else se.set(q.ITelemetryService,C.NullTelemetryService);return[new F.InstantiationService(se),Re]}g(se){(0,D.setUnexpectedErrorHandler)(ue=>{const we=(0,k.toErrorMessage)(ue,!0);!we||se.error(`[uncaught exception in CLI]: ${we}`)}),process.on("uncaughtException",ue=>{(0,D.isSigPipeError)(ue)||(0,D.onUnexpectedError)(ue)}),process.on("unhandledRejection",ue=>(0,D.onUnexpectedError)(ue))}async h(se,ue,we,Pe){let je;if(se.args.profile&&(je=we.profiles.find(B=>B.name===se.args.profile),!je))throw new Error(`Profile '${se.args.profile}' not found.`);const Ue=(je??we.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(se,ue,this.b["install-source"]);if(this.b["list-extensions"])return Pe.createInstance(s.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,Ue);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const B={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Ue};return Pe.createInstance(s.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],B,!!this.b.force)}else{if(this.b["uninstall-extension"])return Pe.createInstance(s.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Ue);if(this.b["locate-extension"])return Pe.createInstance(s.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,T.buildTelemetryMessage)(se.appRoot,se.extensionsPath))}}i(se){return se.map(ue=>/\.vsix$/i.test(ue)?d.URI.file((0,c.isAbsolute)(ue)?ue:(0,c.join)((0,w.cwd)(),ue)):ue)}async j(se,ue,we){await ue.writeFile(d.URI.file(se.installSourcePath),P.VSBuffer.fromString(we.slice(0,30)))}}async function ce(ge){const se=new me(ge);try{await se.run()}finally{se.dispose()}}e.main=ce})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/96a795cc0b1cd62f9ff66c347637f917c6dde3da/core/vs/code/node/cli/cliProcessMain.js.map
