/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/errors","vs/nls","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/types","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/resources","vs/platform/product/common/productService","vs/base/common/strings","vs/base/node/pfs","vs/platform/userDataProfile/common/userDataProfile","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/base/common/map","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/electron-sandbox/services","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/parts/sandbox/node/electronTypes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/themables","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/ipc/node/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/node/sharedProcess/sharedProcessMain"],se=function(Z){for(var e=[],k=0,L=Z.length;k<L;k++)e[k]=ne[Z[k]];return e};define(ne[62],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function k(T){return(R,I,v)=>{let P=null,w=null;if(typeof v.value=="function"?(P="value",w=v.value):typeof v.get=="function"&&(P="get",w=v.get),!w)throw new Error("not supported");v[P]=T(w,I)}}function L(T,R,I){let v=null,P=null;if(typeof I.value=="function"?(v="value",P=I.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(v="get",P=I.get),!P)throw new Error("not supported");const w=`$memoize$${R}`;I[v]=function(...g){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,g)}),this[w]}}e.memoize=L;function l(T,R,I){return k((v,P)=>{const w=`$debounce$${P}`,g=`$debounce$result$${P}`;return function(...h){this[g]||(this[g]=I?I():void 0),clearTimeout(this[w]),R&&(this[g]=R(this[g],...h),h=[this[g]]),this[w]=setTimeout(()=>{v.apply(this,h),this[g]=I?I():void 0},T)}})}e.debounce=l;function D(T,R,I){return k((v,P)=>{const w=`$throttle$timer$${P}`,g=`$throttle$result$${P}`,h=`$throttle$lastRun$${P}`,m=`$throttle$pending$${P}`;return function(...y){if(this[g]||(this[g]=I?I():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),R&&(this[g]=R(this[g],...y)),this[m])return;const f=this[h]+T;f<=Date.now()?(this[h]=Date.now(),v.apply(this,[this[g]]),this[g]=I?I():void 0):(this[m]=!0,this[w]=setTimeout(()=>{this[m]=!1,this[h]=Date.now(),v.apply(this,[this[g]]),this[g]=I?I():void 0},f-Date.now()))}})}e.throttle=D}),define(ne[8],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?b.isErrorNoTelemetry(a)?new b(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(i=>{i(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}e.ErrorHandler=k,e.errorHandler=new k;function L(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function l(t){if(!t||typeof t!="object")return!1;const a=t;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function D(t){v(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=D;function T(t){v(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=T;function R(t){if(t instanceof Error){const{name:a,message:i}=t,n=t.stacktrace||t.stack;return{$isError:!0,name:a,message:i,stack:n,noTelemetry:b.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=R;const I="Canceled";function v(t){return t instanceof P?!0:t instanceof Error&&t.name===I&&t.message===I}e.isCancellationError=v;class P extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=P;function w(){const t=new Error(I);return t.name=t.message,t}e.canceled=w;function g(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=g;function h(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=h;function m(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function y(t){const a=new Error(`${t} has been disposed`);return a.name="DISPOSED",a}e.disposed=y;function f(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=f;class u extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.NotImplementedError=u;class d extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.NotSupportedError=d;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class b extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof b)return a;const i=new b;return i.message=a.message,i.stack=a.stack,i}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.ErrorNoTelemetry=b;class C extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,C.prototype);debugger}}e.BugIndicatingError=C}),define(ne[18],se([0,1,8]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L(H,X=0){return H[H.length-(1+X)]}e.tail=L;function l(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=l;function D(H,X,te=(le,he)=>le===he){if(H===X)return!0;if(!H||!X||H.length!==X.length)return!1;for(let le=0,he=H.length;le<he;le++)if(!te(H[le],X[le]))return!1;return!0}e.equals=D;function T(H,X){const te=H.length-1;X<te&&(H[X]=H[te]),H.pop()}e.removeFastWithoutKeepingOrder=T;function R(H,X,te){return I(H.length,le=>te(H[le],X))}e.binarySearch=R;function I(H,X){let te=0,le=H-1;for(;te<=le;){const he=(te+le)/2|0,me=X(he);if(me<0)te=he+1;else if(me>0)le=he-1;else return he}return-(te+1)}e.binarySearch2=I;function v(H,X){let te=0,le=H.length;if(le===0)return 0;for(;te<le;){const he=Math.floor((te+le)/2);X(H[he])?le=he:te=he+1}return te}e.findFirstInSorted=v;function P(H,X,te){if(H=H|0,H>=X.length)throw new TypeError("invalid index");const le=X[Math.floor(X.length*Math.random())],he=[],me=[],pe=[];for(const Se of X){const Ce=te(Se,le);Ce<0?he.push(Se):Ce>0?me.push(Se):pe.push(Se)}return H<he.length?P(H,he,te):H<he.length+pe.length?pe[0]:P(H-(he.length+pe.length),me,te)}e.quickSelect=P;function w(H,X){const te=[];let le;for(const he of H.slice(0).sort(X))!le||X(le[0],he)!==0?(le=[he],te.push(le)):le.push(he);return te}e.groupBy=w;function g(H,X,te){const le=[];function he(Se,Ce,De){if(Ce===0&&De.length===0)return;const ke=le[le.length-1];ke&&ke.start+ke.deleteCount===Se?(ke.deleteCount+=Ce,ke.toInsert.push(...De)):le.push({start:Se,deleteCount:Ce,toInsert:De})}let me=0,pe=0;for(;;){if(me===H.length){he(me,0,X.slice(pe));break}if(pe===X.length){he(me,H.length-me,[]);break}const Se=H[me],Ce=X[pe],De=te(Se,Ce);De===0?(me+=1,pe+=1):De<0?(he(me,1,[]),me+=1):De>0&&(he(me,0,[Ce]),pe+=1)}return le}e.sortedDiff=g;function h(H,X,te){const le=g(H,X,te),he=[],me=[];for(const pe of le)he.push(...H.slice(pe.start,pe.start+pe.deleteCount)),me.push(...pe.toInsert);return{removed:he,added:me}}e.delta=h;function m(H,X,te){if(te===0)return[];const le=H.slice(0,te).sort(X);return f(H,X,le,te,H.length),le}e.top=m;function y(H,X,te,le,he){return te===0?Promise.resolve([]):new Promise((me,pe)=>{(async()=>{const Se=H.length,Ce=H.slice(0,te).sort(X);for(let De=te,ke=Math.min(te+le,Se);De<Se;De=ke,ke=Math.min(ke+le,Se)){if(De>te&&await new Promise(qe=>setTimeout(qe)),he&&he.isCancellationRequested)throw new k.CancellationError;f(H,X,Ce,De,ke)}return Ce})().then(me,pe)})}e.topAsync=y;function f(H,X,te,le,he){for(const me=te.length;le<he;le++){const pe=H[le];if(X(pe,te[me-1])<0){te.pop();const Se=v(te,Ce=>X(pe,Ce)<0);te.splice(Se,0,pe)}}}function u(H){return H.filter(X=>!!X)}e.coalesce=u;function d(H){let X=0;for(let te=0;te<H.length;te++)H[te]&&(H[X]=H[te],X+=1);H.length=X}e.coalesceInPlace=d;function p(H,X,te){H.splice(te,0,H.splice(X,1)[0])}e.move=p;function b(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=b;function C(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=C;function t(H,X=te=>te){const te=new Set;return H.filter(le=>{const he=X(le);return te.has(he)?!1:(te.add(he),!0)})}e.distinct=t;function a(H){const X=new Set;return te=>{const le=H(te);return X.has(le)?!1:(X.add(le),!0)}}e.uniqueFilter=a;function i(H,X){const te=n(H,X);if(te!==-1)return H[te]}e.findLast=i;function n(H,X){for(let te=H.length-1;te>=0;te--){const le=H[te];if(X(le))return te}return-1}e.lastIndex=n;function r(H,X){return H.length>0?H[0]:X}e.firstOrDefault=r;function o(H,X){return H.length>0?H[H.length-1]:X}e.lastOrDefault=o;function s(H,X,te=(le,he)=>le===he){let le=0;for(let he=0,me=Math.min(H.length,X.length);he<me&&te(H[he],X[he]);he++)le++;return le}e.commonPrefixLength=s;function c(H){return[].concat(...H)}e.flatten=c;function S(H,X){let te=typeof X=="number"?H:0;typeof X=="number"?te=H:(te=0,X=H);const le=[];if(te<=X)for(let he=te;he<X;he++)le.push(he);else for(let he=te;he>X;he--)le.push(he);return le}e.range=S;function E(H,X,te){return H.reduce((le,he)=>(le[X(he)]=te?te(he):he,le),Object.create(null))}e.index=E;function A(H,X){return H.push(X),()=>N(H,X)}e.insert=A;function N(H,X){const te=H.indexOf(X);if(te>-1)return H.splice(te,1),X}e.remove=N;function M(H,X,te){const le=H.slice(0,X),he=H.slice(X);return le.concat(te,he)}e.arrayInsert=M;function B(H,X){let te;if(typeof X=="number"){let le=X;te=()=>{const he=Math.sin(le++)*179426549;return he-Math.floor(he)}}else te=Math.random;for(let le=H.length-1;le>0;le-=1){const he=Math.floor(te()*(le+1)),me=H[le];H[le]=H[he],H[he]=me}}e.shuffle=B;function O(H,X){const te=H.indexOf(X);te>-1&&(H.splice(te,1),H.unshift(X))}e.pushToStart=O;function j(H,X){const te=H.indexOf(X);te>-1&&(H.splice(te,1),H.push(X))}e.pushToEnd=j;function q(H,X){for(const te of X)H.push(te)}e.pushMany=q;function K(H,X){return Array.isArray(H)?H.map(X):X(H)}e.mapArrayOrNot=K;function Q(H){return Array.isArray(H)?H:[H]}e.asArray=Q;function re(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=re;function J(H,X){for(const te of H){const le=X(te);if(le!==void 0)return le}}e.mapFind=J;function W(H,X,te){const le=G(H,X),he=H.length,me=te.length;H.length=he+me;for(let pe=he-1;pe>=le;pe--)H[pe+me]=H[pe];for(let pe=0;pe<me;pe++)H[pe+le]=te[pe]}e.insertInto=W;function F(H,X,te,le){const he=G(H,X),me=H.splice(he,te);return W(H,he,le),me}e.splice=F;function G(H,X){return X<0?Math.max(X+H.length,0):Math.min(X,H.length)}var ee;(function(H){function X(he){return he<0}H.isLessThan=X;function te(he){return he>0}H.isGreaterThan=te;function le(he){return he===0}H.isNeitherLessOrGreaterThan=le,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(ee=e.CompareResult||(e.CompareResult={}));function oe(H,X){return(te,le)=>X(H(te),H(le))}e.compareBy=oe;function ae(...H){return(X,te)=>{for(const le of H){const he=le(X,te);if(!ee.isNeitherLessOrGreaterThan(he))return he}return ee.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const x=(H,X)=>H-X;e.numberComparator=x;function $(H,X){if(H.length===0)return;let te=H[0];for(let le=1;le<H.length;le++){const he=H[le];X(he,te)>0&&(te=he)}return te}e.findMaxBy=$;function U(H,X){if(H.length===0)return;let te=H[0];for(let le=1;le<H.length;le++){const he=H[le];X(he,te)>=0&&(te=he)}return te}e.findLastMaxBy=U;function z(H,X){return $(H,(te,le)=>-X(te,le))}e.findMinBy=z;class V{constructor(X){this.f=X,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(X){let te=this.c;for(;te<this.f.length&&X(this.f[te]);)te++;const le=te===this.c?null:this.f.slice(this.c,te);return this.c=te,le}takeFromEndWhile(X){let te=this.d;for(;te>=0&&X(this.f[te]);)te--;const le=te===this.d?null:this.f.slice(te+1,this.d+1);return this.d=te,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const X=this.f[this.c];return this.c++,X}removeLast(){const X=this.f[this.d];return this.d--,X}takeCount(X){const te=this.f.slice(this.c,this.c+X);return this.c+=X,te}}e.ArrayQueue=V;class _{constructor(X){this.iterate=X}forEach(X){this.iterate(te=>(X(te),!0))}toArray(){const X=[];return this.iterate(te=>(X.push(te),!0)),X}filter(X){return new _(te=>this.iterate(le=>X(le)?te(le):!0))}map(X){return new _(te=>this.iterate(le=>te(X(le))))}some(X){let te=!1;return this.iterate(le=>(te=X(le),!te)),te}findFirst(X){let te;return this.iterate(le=>X(le)?(te=le,!1):!0),te}findLast(X){let te;return this.iterate(le=>(X(le)&&(te=le),!0)),te}findLastMaxBy(X){let te,le=!0;return this.iterate(he=>((le||ee.isGreaterThan(X(he,te)))&&(le=!1,te=he),!0)),te}}_.empty=new _(H=>{}),e.CallbackIterable=_}),define(ne[129],se([0,1,8]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(I,v){if(!I)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=L;function l(I,v="Unreachable"){throw new Error(v)}e.assertNever=l;function D(I){if(!I)throw new k.BugIndicatingError("Assertion Failed")}e.assert=D;function T(I){if(!I()){debugger;I(),(0,k.onUnexpectedError)(new k.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function R(I,v){let P=0;for(;P<I.length-1;){const w=I[P],g=I[P+1];if(!v(w,g))return!1;P++}return!0}e.checkAdjacentItems=R}),define(ne[81],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(L){const l=this;let D=!1,T;return function(){return D||(D=!0,T=L.apply(l,arguments)),T}}e.once=k}),define(ne[63],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(L){function l(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}L.is=l;const D=Object.freeze([]);function T(){return D}L.empty=T;function*R(b){yield b}L.single=R;function I(b){return l(b)?b:R(b)}L.wrap=I;function v(b){return b||D}L.from=v;function P(b){return!b||b[Symbol.iterator]().next().done===!0}L.isEmpty=P;function w(b){return b[Symbol.iterator]().next().value}L.first=w;function g(b,C){for(const t of b)if(C(t))return!0;return!1}L.some=g;function h(b,C){for(const t of b)if(C(t))return t}L.find=h;function*m(b,C){for(const t of b)C(t)&&(yield t)}L.filter=m;function*y(b,C){let t=0;for(const a of b)yield C(a,t++)}L.map=y;function*f(...b){for(const C of b)for(const t of C)yield t}L.concat=f;function u(b,C,t){let a=t;for(const i of b)a=C(a,i);return a}L.reduce=u;function*d(b,C,t=b.length){for(C<0&&(C+=b.length),t<0?t+=b.length:t>b.length&&(t=b.length);C<t;C++)yield b[C]}L.slice=d;function p(b,C=Number.POSITIVE_INFINITY){const t=[];if(C===0)return[t,b];const a=b[Symbol.iterator]();for(let i=0;i<C;i++){const n=a.next();if(n.done)return[t,L.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return a}}]}L.consume=p})(k=e.Iterable||(e.Iterable={}))}),define(ne[35],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function T(t,a=!1){let i=0;const n=t.length;let r="",o=0,s=16,c=0;function S(j){let q=0,K=0;for(;q<j;){const Q=t.charCodeAt(i);if(Q>=48&&Q<=57)K=K*16+Q-48;else if(Q>=65&&Q<=70)K=K*16+Q-65+10;else if(Q>=97&&Q<=102)K=K*16+Q-97+10;else break;i++,q++}return q<j&&(K=-1),K}function E(j){i=j,r="",o=0,s=16,c=0}function A(){const j=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&v(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&v(t.charCodeAt(i)))for(i++;i<t.length&&v(t.charCodeAt(i));)i++;else return c=3,t.substring(j,i);let q=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&v(t.charCodeAt(i))){for(i++;i<t.length&&v(t.charCodeAt(i));)i++;q=i}else c=3;return t.substring(j,q)}function N(){let j="",q=i;for(;;){if(i>=n){j+=t.substring(q,i),c=2;break}const K=t.charCodeAt(i);if(K===34){j+=t.substring(q,i),i++;break}if(K===92){if(j+=t.substring(q,i),i++,i>=n){c=2;break}switch(t.charCodeAt(i++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const re=S(4);re>=0?j+=String.fromCharCode(re):c=4;break}default:c=5}q=i;continue}if(K>=0&&K<=31)if(I(K)){j+=t.substring(q,i),c=2;break}else c=6;i++}return j}function M(){if(r="",c=0,o=i,i>=n)return o=n,s=17;let j=t.charCodeAt(i);if(R(j)){do i++,r+=String.fromCharCode(j),j=t.charCodeAt(i);while(R(j));return s=15}if(I(j))return i++,r+=String.fromCharCode(j),j===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),s=14;switch(j){case 123:return i++,s=1;case 125:return i++,s=2;case 91:return i++,s=3;case 93:return i++,s=4;case 58:return i++,s=6;case 44:return i++,s=5;case 34:return i++,r=N(),s=10;case 47:{const q=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!I(t.charCodeAt(i));)i++;return r=t.substring(q,i),s=12}if(t.charCodeAt(i+1)===42){i+=2;const K=n-1;let Q=!1;for(;i<K;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,Q=!0;break}i++}return Q||(i++,c=1),r=t.substring(q,i),s=13}return r+=String.fromCharCode(j),i++,s=16}case 45:if(r+=String.fromCharCode(j),i++,i===n||!v(t.charCodeAt(i)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=A(),s=11;default:for(;i<n&&B(j);)i++,j=t.charCodeAt(i);if(o!==i){switch(r=t.substring(o,i),r){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return r+=String.fromCharCode(j),i++,s=16}}function B(j){if(R(j)||I(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let j;do j=M();while(j>=12&&j<=15);return j}return{setPosition:E,getPosition:()=>i,scan:a?O:M,getToken:()=>s,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>c}}e.createScanner=T;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function I(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function w(t,a){const i=[],n=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function c(S,E,A,N){o.value=S,o.offset=E,o.length=A,o.type=N,o.colonOffset=void 0,r=o}try{p(t,{onObjectBegin:(S,E)=>{if(a<=S)throw n;r=void 0,s=a>S,i.push("")},onObjectProperty:(S,E,A)=>{if(a<E||(c(S,E,A,"property"),i[i.length-1]=S,a<=E+A))throw n},onObjectEnd:(S,E)=>{if(a<=S)throw n;r=void 0,i.pop()},onArrayBegin:(S,E)=>{if(a<=S)throw n;r=void 0,i.push(0)},onArrayEnd:(S,E)=>{if(a<=S)throw n;r=void 0,i.pop()},onLiteralValue:(S,E,A)=>{if(a<E||(c(S,E,A,C(S)),a<=E+A))throw n},onSeparator:(S,E,A)=>{if(a<=E)throw n;if(S===":"&&r&&r.type==="property")r.colonOffset=E,s=!1,r=void 0;else if(S===","){const N=i[i.length-1];typeof N=="number"?i[i.length-1]=N+1:(s=!0,i[i.length-1]=""),r=void 0}}})}catch(S){if(S!==n)throw S}return{path:i,previousNode:r,isAtPropertyKey:s,matches:S=>{let E=0;for(let A=0;E<S.length&&A<i.length;A++)if(S[E]===i[A]||S[E]==="*")E++;else if(S[E]!=="**")return!1;return E===S.length}}}e.getLocation=w;function g(t,a=[],i=D.DEFAULT){let n=null,r=[];const o=[];function s(S){Array.isArray(r)?r.push(S):n!==null&&(r[n]=S)}return p(t,{onObjectBegin:()=>{const S={};s(S),o.push(r),r=S,n=null},onObjectProperty:S=>{n=S},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const S=[];s(S),o.push(r),r=S,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:s,onError:(S,E,A)=>{a.push({error:S,offset:E,length:A})}},i),r[0]}e.parse=g;function h(t,a=[],i=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(S){n.type==="property"&&(n.length=S-n.offset,n=n.parent)}function o(S){return n.children.push(S),S}p(t,{onObjectBegin:S=>{n=o({type:"object",offset:S,length:-1,parent:n,children:[]})},onObjectProperty:(S,E,A)=>{n=o({type:"property",offset:E,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:S,offset:E,length:A,parent:n})},onObjectEnd:(S,E)=>{n.length=S+E-n.offset,n=n.parent,r(S+E)},onArrayBegin:(S,E)=>{n=o({type:"array",offset:S,length:-1,parent:n,children:[]})},onArrayEnd:(S,E)=>{n.length=S+E-n.offset,n=n.parent,r(S+E)},onLiteralValue:(S,E,A)=>{o({type:C(S),offset:E,length:A,parent:n,value:S}),r(E+A)},onSeparator:(S,E,A)=>{n.type==="property"&&(S===":"?n.colonOffset=E:S===","&&r(E))},onError:(S,E,A)=>{a.push({error:S,offset:E,length:A})}},i);const c=n.children[0];return c&&delete c.parent,c}e.parseTree=h;function m(t,a){if(!t)return;let i=t;for(const n of a)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===n){i=o.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=m;function y(t){if(!t.parent||!t.parent.children)return[];const a=y(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.getNodePath=y;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const a=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(a[i.children[0].value]=f(n))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=f;function u(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.contains=u;function d(t,a,i=!1){if(u(t,a,i)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=a;r++){const o=d(n[r],a,i);if(o)return o}return t}}e.findNodeAtOffset=d;function p(t,a,i=D.DEFAULT){const n=T(t,!1);function r(oe){return oe?()=>oe(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(oe){return oe?ae=>oe(ae,n.getTokenOffset(),n.getTokenLength()):()=>!0}const s=r(a.onObjectBegin),c=o(a.onObjectProperty),S=r(a.onObjectEnd),E=r(a.onArrayBegin),A=r(a.onArrayEnd),N=o(a.onLiteralValue),M=o(a.onSeparator),B=r(a.onComment),O=o(a.onError),j=i&&i.disallowComments,q=i&&i.allowTrailingComma;function K(){for(;;){const oe=n.scan();switch(n.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:j||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(oe){case 12:case 13:j?Q(10):B();break;case 16:Q(1);break;case 15:case 14:break;default:return oe}}}function Q(oe,ae=[],x=[]){if(O(oe),ae.length+x.length>0){let $=n.getToken();for(;$!==17;){if(ae.indexOf($)!==-1){K();break}else if(x.indexOf($)!==-1)break;$=K()}}}function re(oe){const ae=n.getTokenValue();return oe?N(ae):c(ae),K(),!0}function J(){switch(n.getToken()){case 11:{let oe=0;try{oe=JSON.parse(n.getTokenValue()),typeof oe!="number"&&(Q(2),oe=0)}catch{Q(2)}N(oe);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return K(),!0}function W(){return n.getToken()!==10?(Q(3,[],[2,5]),!1):(re(!1),n.getToken()===6?(M(":"),K(),ee()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function F(){s(),K();let oe=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(oe||Q(4,[],[]),M(","),K(),n.getToken()===2&&q)break}else oe&&Q(6,[],[]);W()||Q(4,[],[2,5]),oe=!0}return S(),n.getToken()!==2?Q(7,[2],[]):K(),!0}function G(){E(),K();let oe=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(oe||Q(4,[],[]),M(","),K(),n.getToken()===4&&q)break}else oe&&Q(6,[],[]);ee()||Q(4,[],[4,5]),oe=!0}return A(),n.getToken()!==4?Q(8,[4],[]):K(),!0}function ee(){switch(n.getToken()){case 3:return G();case 1:return F();case 10:return re(!0);default:return J()}}return K(),n.getToken()===17?i.allowEmptyContent?!0:(Q(4,[],[]),!1):ee()?(n.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}e.visit=p;function b(t,a){const i=T(t),n=[];let r,o=0,s;do switch(s=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:o!==s&&n.push(t.substring(o,s)),a!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,a)),o=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=b;function C(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),define(ne[42],se([0,1,35]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function L(v,P,w){let g,h,m,y,f;if(P){for(y=P.offset,f=y+P.length,m=y;m>0&&!I(v,m-1);)m--;let s=f;for(;s<v.length&&!I(v,s);)s++;h=v.substring(m,s),g=T(h,w)}else h=v,g=0,m=0,y=0,f=v.length;const u=R(w,v);let d=!1,p=0,b;w.insertSpaces?b=D(" ",w.tabSize||4):b="	";const C=(0,k.createScanner)(h,!1);let t=!1;function a(){return u+D(b,g+p)}function i(){let s=C.scan();for(d=!1;s===15||s===14;)d=d||s===14,s=C.scan();return t=s===16||C.getTokenError()!==0,s}const n=[];function r(s,c,S){!t&&c<f&&S>y&&v.substring(c,S)!==s&&n.push({offset:c,length:S-c,content:s})}let o=i();if(o!==17){const s=C.getTokenOffset()+m,c=D(b,g);r(c,m,s)}for(;o!==17;){let s=C.getTokenOffset()+C.getTokenLength()+m,c=i(),S="";for(;!d&&(c===12||c===13);){const A=C.getTokenOffset()+m;r(" ",s,A),s=C.getTokenOffset()+C.getTokenLength()+m,S=c===12?a():"",c=i()}if(c===2)o!==1&&(p--,S=a());else if(c===4)o!==3&&(p--,S=a());else{switch(o){case 3:case 1:p++,S=a();break;case 5:case 12:S=a();break;case 13:d?S=a():S=" ";break;case 6:S=" ";break;case 10:if(c===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:c===12||c===13?S=" ":c!==5&&c!==17&&(t=!0);break;case 16:t=!0;break}d&&(c===12||c===13)&&(S=a())}const E=C.getTokenOffset()+m;r(S,s,E),o=c}return n}e.format=L;function l(v,P){const w=JSON.stringify(v,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?w.replace(/\r\n|\r|\n/g,P.eol):w}e.toFormattedString=l;function D(v,P){let w="";for(let g=0;g<P;g++)w+=v;return w}function T(v,P){let w=0,g=0;const h=P.tabSize||4;for(;w<v.length;){const m=v.charAt(w);if(m===" ")g++;else if(m==="	")g+=h;else break;w++}return Math.floor(g/h)}function R(v,P){for(let w=0;w<P.length;w++){const g=P.charAt(w);if(g==="\r")return w+1<P.length&&P.charAt(w+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return v&&v.eol||`
`}e.getEOL=R;function I(v,P){return`\r
`.indexOf(v.charAt(P))!==-1}e.isEOL=I}),define(ne[82],se([0,1,35,42]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function l(v,P,w){return D(v,P,void 0,w)}e.removeProperty=l;function D(v,P,w,g,h){const m=P.slice(),y=[],f=(0,k.parseTree)(v,y);let u,d;for(;m.length>0&&(d=m.pop(),u=(0,k.findNodeAtLocation)(f,m),u===void 0&&w!==void 0);)typeof d=="string"?w={[d]:w}:w=[w];if(u)if(u.type==="object"&&typeof d=="string"&&Array.isArray(u.children)){const p=(0,k.findNodeAtLocation)(u,[d]);if(p!==void 0)if(w===void 0){if(!p.parent)throw new Error("Malformed AST");const b=u.children.indexOf(p.parent);let C,t=p.parent.offset+p.parent.length;if(b>0){const a=u.children[b-1];C=a.offset+a.length}else C=u.offset+1,u.children.length>1&&(t=u.children[1].offset);return T(v,{offset:C,length:t-C,content:""},g)}else return T(v,{offset:p.offset,length:p.length,content:JSON.stringify(w)},g);else{if(w===void 0)return[];const b=`${JSON.stringify(d)}: ${JSON.stringify(w)}`,C=h?h(u.children.map(a=>a.children[0].value)):u.children.length;let t;if(C>0){const a=u.children[C-1];t={offset:a.offset+a.length,length:0,content:","+b}}else u.children.length===0?t={offset:u.offset+1,length:0,content:b}:t={offset:u.offset+1,length:0,content:b+","};return T(v,t,g)}}else if(u.type==="array"&&typeof d=="number"&&Array.isArray(u.children))if(w!==void 0){const p=`${JSON.stringify(w)}`;let b;if(u.children.length===0||d===0)b={offset:u.offset+1,length:0,content:u.children.length===0?p:p+","};else{const C=d===-1||d>u.children.length?u.children.length:d,t=u.children[C-1];b={offset:t.offset+t.length,length:0,content:","+p}}return T(v,b,g)}else{const p=d,b=u.children[p];let C;if(u.children.length===1)C={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===p){const t=u.children[p-1],a=t.offset+t.length,i=u.offset+u.length;C={offset:a,length:i-2-a,content:""}}else C={offset:b.offset,length:u.children[p+1].offset-b.offset,content:""};return T(v,C,g)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${u.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return T(v,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(w)},g)}}e.setProperty=D;function T(v,P,w){let g=R(v,P),h=P.offset,m=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;h>0&&!(0,L.isEOL)(g,h-1);)h--;for(;m<g.length&&!(0,L.isEOL)(g,m);)m++}const y=(0,L.format)(g,{offset:h,length:m-h},w);for(let u=y.length-1;u>=0;u--){const d=y[u];g=R(g,d),h=Math.min(h,d.offset),m=Math.max(m,d.offset+d.length),m+=d.content.length-d.length}const f=v.length-(g.length-m)-h;return[{offset:h,length:f,content:g.substring(h,m)}]}e.withFormatting=T;function R(v,P){return v.substring(0,P.offset)+P.content+v.substring(P.offset+P.length)}e.applyEdit=R;function I(v,P){const w=P.slice(0).sort((h,m)=>{const y=h.offset-m.offset;return y===0?h.length-m.length:y});let g=v.length;for(let h=w.length-1;h>=0;h--){const m=w[h];if(m.offset+m.length<=g)v=R(v,m);else throw new Error("Overlapping edit");g=m.offset}return v}e.applyEdits=I}),define(ne[130],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=k}),define(ne[2],se([0,1,81,63]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let D=null;function T(o){D=o}if(e.setDisposableTracker=T,l){const o="__is_disposable_tracked__";T(new class{trackDisposable(s){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[o]||console.log(c)},3e3)}setParent(s,c){if(s&&s!==d.None)try{s[o]=!0}catch{}}markAsDisposed(s){if(s&&s!==d.None)try{s[o]=!0}catch{}}markAsSingleton(s){}})}function R(o){return D?.trackDisposable(o),o}function I(o){D?.markAsDisposed(o)}function v(o,s){D?.setParent(o,s)}function P(o,s){if(!!D)for(const c of o)D.setParent(c,s)}function w(o){return D?.markAsSingleton(o),o}e.markAsSingleton=w;function g(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=g;function h(o){if(L.Iterable.is(o)){const s=[];for(const c of o)if(c)try{c.dispose()}catch(S){s.push(S)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=h;function m(o){for(const s of o)g(s)&&s.dispose();return[]}e.disposeIfDisposable=m;function y(...o){const s=f(()=>h(o));return P(o,s),s}e.combinedDisposable=y;function f(o){const s=R({dispose:(0,k.once)(()=>{I(s),o()})});return s}e.toDisposable=f;class u{constructor(){this.c=new Set,this.f=!1,R(this)}dispose(){this.f||(I(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{h(this.c)}finally{this.c.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return v(s,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(s),s}}u.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=u;class d{constructor(){this.q=new u,R(this),v(this.q,this)}dispose(){I(this),this.q.dispose()}B(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(s)}}d.None=Object.freeze({dispose(){}}),e.Disposable=d;class p{constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(s){this.b||s===this.a||(this.a?.dispose(),s&&v(s,this),this.a=s)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const s=this.a;return this.a=void 0,s&&v(s,null),s}}e.MutableDisposable=p;class b{constructor(s){this.b=s,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=b;class C{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(s){let c=s;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,I(this))},this}}e.SafeDisposable=C;class t{constructor(){this.a=new Map}acquire(s,...c){let S=this.a.get(s);S||(S={counter:0,object:this.b(s,...c)},this.a.set(s,S));const{object:E}=S,A=(0,k.once)(()=>{--S.counter===0&&(this.c(s,S.object),this.a.delete(s))});return S.counter++,{object:E,dispose:A}}}e.ReferenceCollection=t;class a{constructor(s){this.a=s}async acquire(s,...c){const S=this.a.acquire(s,...c);try{return{object:await S.object,dispose:()=>S.dispose()}}catch(E){throw S.dispose(),E}}}e.AsyncReferenceCollection=a;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function n(o){const s=new u;try{o(s)}finally{s.dispose()}}e.disposeOnReturn=n;class r{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(s){return this.a.has(s)}get(s){return this.a.get(s)}set(s,c,S=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),S||this.a.get(s)?.dispose(),this.a.set(s,c)}deleteAndDispose(s){this.a.get(s)?.dispose(),this.a.delete(s)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=r}),define(ne[83],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(D){this.element=D,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class L{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let D=this.a;for(;D!==k.Undefined;){const T=D.next;D.prev=k.Undefined,D.next=k.Undefined,D=T}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,T){const R=new k(D);if(this.a===k.Undefined)this.a=R,this.b=R;else if(T){const v=this.b;this.b=R,R.prev=v,v.next=R}else{const v=this.a;this.a=R,R.next=v,v.prev=R}this.c+=1;let I=!1;return()=>{I||(I=!0,this.e(R))}}shift(){if(this.a!==k.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==k.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==k.Undefined&&D.next!==k.Undefined){const T=D.prev;T.next=D.next,D.next.prev=T}else D.prev===k.Undefined&&D.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):D.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):D.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==k.Undefined;)yield D.element,D=D.next}}e.LinkedList=L}),define(ne[38],se([0,1]),function(Z,e){"use strict";var k,L,l;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function D(m,y,f){let u=m.get(y);return u===void 0&&(u=f,m.set(y,u)),u}e.getOrSet=D;function T(m){const y=[];return m.forEach((f,u)=>{y.push(`${u} => ${f}`)}),`Map(${m.size}) {${y.join(", ")}}`}e.mapToString=T;function R(m){const y=[];return m.forEach(f=>{y.push(f)}),`Set(${m.size}) {${y.join(", ")}}`}e.setToString=R;class I{constructor(y,f){this.uri=y,this.value=f}}class v{constructor(y,f){this[k]="ResourceMap",y instanceof v?(this.b=new Map(y.b),this.c=f??v.a):(this.b=new Map,this.c=y??v.a)}set(y,f){return this.b.set(this.c(y),new I(y,f)),this}get(y){return this.b.get(this.c(y))?.value}has(y){return this.b.has(this.c(y))}get size(){return this.b.size}clear(){this.b.clear()}delete(y){return this.b.delete(this.c(y))}forEach(y,f){typeof f<"u"&&(y=y.bind(f));for(const[u,d]of this.b)y(d.value,d.uri,this)}*values(){for(const y of this.b.values())yield y.value}*keys(){for(const y of this.b.values())yield y.uri}*entries(){for(const y of this.b.values())yield[y.uri,y.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,y]of this.b)yield[y.uri,y.value]}}v.a=m=>m.toString(),e.ResourceMap=v;class P{constructor(y,f){this[L]="ResourceSet",!y||typeof y=="function"?this.a=new v(y):(this.a=new v(f),y.forEach(this.add,this))}get size(){return this.a.size}add(y){return this.a.set(y,y),this}clear(){this.a.clear()}delete(y){return this.a.delete(y)}forEach(y,f){this.a.forEach((u,d)=>y.call(f,d,d,this))}has(y){return this.a.has(y)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=P;var w;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class g{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(y){return this.a.has(y)}get(y,f=0){const u=this.a.get(y);if(!!u)return f!==0&&this.j(u,f),u.value}set(y,f,u=0){let d=this.a.get(y);if(d)d.value=f,u!==0&&this.j(d,u);else{switch(d={key:y,value:f,next:void 0,previous:void 0},u){case 0:this.h(d);break;case 1:this.g(d);break;case 2:this.h(d);break;default:this.h(d);break}this.a.set(y,d),this.d++}return this}delete(y){return!!this.remove(y)}remove(y){const f=this.a.get(y);if(!!f)return this.a.delete(y),this.i(f),this.d--,f.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const y=this.b;return this.a.delete(y.key),this.i(y),this.d--,y.value}forEach(y,f){const u=this.e;let d=this.b;for(;d;){if(f?y.bind(f)(d.value,d.key,this):y(d.value,d.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const y=this,f=this.e;let u=this.b;const d={[Symbol.iterator](){return d},next(){if(y.e!==f)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:u.key,done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return d}values(){const y=this,f=this.e;let u=this.b;const d={[Symbol.iterator](){return d},next(){if(y.e!==f)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:u.value,done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return d}entries(){const y=this,f=this.e;let u=this.b;const d={[Symbol.iterator](){return d},next(){if(y.e!==f)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:[u.key,u.value],done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return d}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(y){if(y>=this.size)return;if(y===0){this.clear();return}let f=this.b,u=this.size;for(;f&&u>y;)this.a.delete(f.key),f=f.next,u--;this.b=f,this.d=u,f&&(f.previous=void 0),this.e++}g(y){if(!this.b&&!this.c)this.c=y;else if(this.b)y.next=this.b,this.b.previous=y;else throw new Error("Invalid list");this.b=y,this.e++}h(y){if(!this.b&&!this.c)this.b=y;else if(this.c)y.previous=this.c,this.c.next=y;else throw new Error("Invalid list");this.c=y,this.e++}i(y){if(y===this.b&&y===this.c)this.b=void 0,this.c=void 0;else if(y===this.b){if(!y.next)throw new Error("Invalid list");y.next.previous=void 0,this.b=y.next}else if(y===this.c){if(!y.previous)throw new Error("Invalid list");y.previous.next=void 0,this.c=y.previous}else{const f=y.next,u=y.previous;if(!f||!u)throw new Error("Invalid list");f.previous=u,u.next=f}y.next=void 0,y.previous=void 0,this.e++}j(y,f){if(!this.b||!this.c)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(y===this.b)return;const u=y.next,d=y.previous;y===this.c?(d.next=void 0,this.c=d):(u.previous=d,d.next=u),y.previous=void 0,y.next=this.b,this.b.previous=y,this.b=y,this.e++}else if(f===2){if(y===this.c)return;const u=y.next,d=y.previous;y===this.b?(u.previous=void 0,this.b=u):(u.previous=d,d.next=u),y.next=void 0,y.previous=this.c,this.c.next=y,this.c=y,this.e++}}}toJSON(){const y=[];return this.forEach((f,u)=>{y.push([u,f])}),y}fromJSON(y){this.clear();for(const[f,u]of y)this.set(f,u)}}e.LinkedMap=g;class h extends g{constructor(y,f=1){super(),this.k=y,this.l=Math.min(Math.max(0,f),1)}get limit(){return this.k}set limit(y){this.k=y,this.m()}get ratio(){return this.l}set ratio(y){this.l=Math.min(Math.max(0,y),1),this.m()}get(y,f=2){return super.get(y,f)}peek(y){return super.get(y,0)}set(y,f){return super.set(y,f,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=h}),define(ne[84],se([0,1,38]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new k.LRUCache(1e4);function l(v){return I(v,"NFC",L)}e.normalizeNFC=l;const D=new k.LRUCache(1e4);function T(v){return I(v,"NFD",D)}e.normalizeNFD=T;const R=/[^\u0000-\u0080]/;function I(v,P,w){if(!v)return v;const g=w.get(v);if(g)return g;let h;return R.test(v)?h=v.normalize(P):h=v,w.set(v,h),h}e.removeAccents=function(){const v=/[\u0300-\u036f]/g;return function(P){return T(P).replace(v,"")}}()}),define(ne[131],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function k(R,I,v){return Math.min(Math.max(R,I),v)}e.clamp=k;function L(R,I){return(I+R%I)%I}e.rot=L;class l{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=l;class D{constructor(){this.a=1,this.b=0}update(I){return this.b=this.b+(I-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=D;class T{constructor(I){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(I),this.c.fill(0,0,I)}update(I){const v=this.c[this.d];return this.c[this.d]=I,this.d=(this.d+1)%this.c.length,this.e-=v,this.e+=I,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=T}),function(){function Z(l){const D=[];typeof l=="number"&&D.push("code/timeOrigin",l);function T(I){D.push(I,Date.now())}function R(){const I=[];for(let v=0;v<D.length;v+=2)I.push({name:D[v],startTime:D[v+1]});return I}return{mark:T,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const T of performance.getEntriesByType("mark"))D.push({name:T.name,startTime:Math.round(l+T.startTime)});return D}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function k(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=k(L))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var L in k)(typeof exports=="object"?exports:Z)[L]=k[L]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function k(L){if(e[L])return e[L].exports;var l=e[L]={i:L,l:!1,exports:{}};return Z[L].call(l.exports,l,l.exports,k),l.l=!0,l.exports}return k.m=Z,k.c=e,k.d=function(L,l,D){k.o(L,l)||Object.defineProperty(L,l,{enumerable:!0,get:D})},k.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},k.t=function(L,l){if(1&l&&(L=k(L)),8&l||4&l&&typeof L=="object"&&L&&L.__esModule)return L;var D=Object.create(null);if(k.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:L}),2&l&&typeof L!="string")for(var T in L)k.d(D,T,function(R){return L[R]}.bind(null,T));return D},k.n=function(L){var l=L&&L.__esModule?function(){return L.default}:function(){return L};return k.d(l,"a",l),l},k.o=function(L,l){return Object.prototype.hasOwnProperty.call(L,l)},k.p="",k(k.s=0)}([function(Z,e,k){(function(L){var l;e=Z.exports=x,l=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],I=e.src=[],v=0,P=v++;I[P]="0|[1-9]\\d*";var w=v++;I[w]="[0-9]+";var g=v++;I[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=v++;I[h]="("+I[P]+")\\.("+I[P]+")\\.("+I[P]+")";var m=v++;I[m]="("+I[w]+")\\.("+I[w]+")\\.("+I[w]+")";var y=v++;I[y]="(?:"+I[P]+"|"+I[g]+")";var f=v++;I[f]="(?:"+I[w]+"|"+I[g]+")";var u=v++;I[u]="(?:-("+I[y]+"(?:\\."+I[y]+")*))";var d=v++;I[d]="(?:-?("+I[f]+"(?:\\."+I[f]+")*))";var p=v++;I[p]="[0-9A-Za-z-]+";var b=v++;I[b]="(?:\\+("+I[p]+"(?:\\."+I[p]+")*))";var C=v++,t="v?"+I[h]+I[u]+"?"+I[b]+"?";I[C]="^"+t+"$";var a="[v=\\s]*"+I[m]+I[d]+"?"+I[b]+"?",i=v++;I[i]="^"+a+"$";var n=v++;I[n]="((?:<|>)?=?)";var r=v++;I[r]=I[w]+"|x|X|\\*";var o=v++;I[o]=I[P]+"|x|X|\\*";var s=v++;I[s]="[v=\\s]*("+I[o]+")(?:\\.("+I[o]+")(?:\\.("+I[o]+")(?:"+I[u]+")?"+I[b]+"?)?)?";var c=v++;I[c]="[v=\\s]*("+I[r]+")(?:\\.("+I[r]+")(?:\\.("+I[r]+")(?:"+I[d]+")?"+I[b]+"?)?)?";var S=v++;I[S]="^"+I[n]+"\\s*"+I[s]+"$";var E=v++;I[E]="^"+I[n]+"\\s*"+I[c]+"$";var A=v++;I[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=v++;I[N]="(?:~>?)";var M=v++;I[M]="(\\s*)"+I[N]+"\\s+",R[M]=new RegExp(I[M],"g");var B=v++;I[B]="^"+I[N]+I[s]+"$";var O=v++;I[O]="^"+I[N]+I[c]+"$";var j=v++;I[j]="(?:\\^)";var q=v++;I[q]="(\\s*)"+I[j]+"\\s+",R[q]=new RegExp(I[q],"g");var K=v++;I[K]="^"+I[j]+I[s]+"$";var Q=v++;I[Q]="^"+I[j]+I[c]+"$";var re=v++;I[re]="^"+I[n]+"\\s*("+a+")$|^$";var J=v++;I[J]="^"+I[n]+"\\s*("+t+")$|^$";var W=v++;I[W]="(\\s*)"+I[n]+"\\s*("+a+"|"+I[s]+")",R[W]=new RegExp(I[W],"g");var F=v++;I[F]="^\\s*("+I[s]+")\\s+-\\s+("+I[s]+")\\s*$";var G=v++;I[G]="^\\s*("+I[c]+")\\s+-\\s+("+I[c]+")\\s*$";var ee=v++;I[ee]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)l(oe,I[oe]),R[oe]||(R[oe]=new RegExp(I[oe]));function ae(ce,fe){if(ce instanceof x)return ce;if(typeof ce!="string"||ce.length>D||!(fe?R[i]:R[C]).test(ce))return null;try{return new x(ce,fe)}catch{return null}}function x(ce,fe){if(ce instanceof x){if(ce.loose===fe)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof x))return new x(ce,fe);l("SemVer",ce,fe),this.loose=fe;var de=ce.trim().match(fe?R[i]:R[C]);if(!de)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Pe=+Ie;if(Pe>=0&&Pe<T)return Pe}return Ie}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ce,fe){var de=ae(ce,fe);return de?de.version:null},e.clean=function(ce,fe){var de=ae(ce.trim().replace(/^[=v]+/,""),fe);return de?de.version:null},e.SemVer=x,x.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},x.prototype.toString=function(){return this.version},x.prototype.compare=function(ce){return l("SemVer.compare",this.version,this.loose,ce),ce instanceof x||(ce=new x(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},x.prototype.compareMain=function(ce){return ce instanceof x||(ce=new x(ce,this.loose)),U(this.major,ce.major)||U(this.minor,ce.minor)||U(this.patch,ce.patch)},x.prototype.comparePre=function(ce){if(ce instanceof x||(ce=new x(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var fe=0;do{var de=this.prerelease[fe],Ie=ce.prerelease[fe];if(l("prerelease compare",fe,de,Ie),de===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(de===void 0)return-1;if(de!==Ie)return U(de,Ie)}while(++fe)},x.prototype.inc=function(ce,fe){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,fe,de,Ie){typeof de=="string"&&(Ie=de,de=void 0);try{return new x(ce,de).inc(fe,Ie).version}catch{return null}},e.diff=function(ce,fe){if(H(ce,fe))return null;var de=ae(ce),Ie=ae(fe);if(de.prerelease.length||Ie.prerelease.length){for(var Pe in de)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&de[Pe]!==Ie[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in de)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&de[Pe]!==Ie[Pe])return Pe},e.compareIdentifiers=U;var $=/^[0-9]+$/;function U(ce,fe){var de=$.test(ce),Ie=$.test(fe);return de&&Ie&&(ce=+ce,fe=+fe),de&&!Ie?-1:Ie&&!de?1:ce<fe?-1:ce>fe?1:0}function z(ce,fe,de){return new x(ce,de).compare(new x(fe,de))}function V(ce,fe,de){return z(ce,fe,de)>0}function _(ce,fe,de){return z(ce,fe,de)<0}function H(ce,fe,de){return z(ce,fe,de)===0}function X(ce,fe,de){return z(ce,fe,de)!==0}function te(ce,fe,de){return z(ce,fe,de)>=0}function le(ce,fe,de){return z(ce,fe,de)<=0}function he(ce,fe,de,Ie){var Pe;switch(fe){case"===":typeof ce=="object"&&(ce=ce.version),typeof de=="object"&&(de=de.version),Pe=ce===de;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof de=="object"&&(de=de.version),Pe=ce!==de;break;case"":case"=":case"==":Pe=H(ce,de,Ie);break;case"!=":Pe=X(ce,de,Ie);break;case">":Pe=V(ce,de,Ie);break;case">=":Pe=te(ce,de,Ie);break;case"<":Pe=_(ce,de,Ie);break;case"<=":Pe=le(ce,de,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return Pe}function me(ce,fe){if(ce instanceof me){if(ce.loose===fe)return ce;ce=ce.value}if(!(this instanceof me))return new me(ce,fe);l("comparator",ce,fe),this.loose=fe,this.parse(ce),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(ce,fe){return U(fe,ce)},e.major=function(ce,fe){return new x(ce,fe).major},e.minor=function(ce,fe){return new x(ce,fe).minor},e.patch=function(ce,fe){return new x(ce,fe).patch},e.compare=z,e.compareLoose=function(ce,fe){return z(ce,fe,!0)},e.rcompare=function(ce,fe,de){return z(fe,ce,de)},e.sort=function(ce,fe){return ce.sort(function(de,Ie){return e.compare(de,Ie,fe)})},e.rsort=function(ce,fe){return ce.sort(function(de,Ie){return e.rcompare(de,Ie,fe)})},e.gt=V,e.lt=_,e.eq=H,e.neq=X,e.gte=te,e.lte=le,e.cmp=he,e.Comparator=me;var pe={};function Se(ce,fe){if(ce instanceof Se)return ce.loose===fe?ce:new Se(ce.raw,fe);if(ce instanceof me)return new Se(ce.value,fe);if(!(this instanceof Se))return new Se(ce,fe);if(this.loose=fe,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ce(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function De(ce,fe,de,Ie,Pe,Fe,Ae,je,Me,Ne,Be,ie,ue){return((fe=Ce(de)?"":Ce(Ie)?">="+de+".0.0":Ce(Pe)?">="+de+"."+Ie+".0":">="+fe)+" "+(je=Ce(Me)?"":Ce(Ne)?"<"+(+Me+1)+".0.0":Ce(Be)?"<"+Me+"."+(+Ne+1)+".0":ie?"<="+Me+"."+Ne+"."+Be+"-"+ie:"<="+je)).trim()}function ke(ce,fe){for(var de=0;de<ce.length;de++)if(!ce[de].test(fe))return!1;if(fe.prerelease.length){for(de=0;de<ce.length;de++)if(l(ce[de].semver),ce[de].semver!==pe&&ce[de].semver.prerelease.length>0){var Ie=ce[de].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function qe(ce,fe,de){try{fe=new Se(fe,de)}catch{return!1}return fe.test(ce)}function Ye(ce,fe,de,Ie){var Pe,Fe,Ae,je,Me;switch(ce=new x(ce,Ie),fe=new Se(fe,Ie),de){case">":Pe=V,Fe=le,Ae=_,je=">",Me=">=";break;case"<":Pe=_,Fe=te,Ae=V,je="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(qe(ce,fe,Ie))return!1;for(var Ne=0;Ne<fe.set.length;++Ne){var Be=fe.set[Ne],ie=null,ue=null;if(Be.forEach(function(ge){ge.semver===pe&&(ge=new me(">=0.0.0")),ie=ie||ge,ue=ue||ge,Pe(ge.semver,ie.semver,Ie)?ie=ge:Ae(ge.semver,ue.semver,Ie)&&(ue=ge)}),ie.operator===je||ie.operator===Me||(!ue.operator||ue.operator===je)&&Fe(ce,ue.semver)||ue.operator===Me&&Ae(ce,ue.semver))return!1}return!0}me.prototype.parse=function(ce){var fe=this.loose?R[re]:R[J],de=ce.match(fe);if(!de)throw new TypeError("Invalid comparator: "+ce);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new x(de[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(ce){return l("Comparator.test",ce,this.loose),this.semver===pe||(typeof ce=="string"&&(ce=new x(ce,this.loose)),he(ce,this.operator,this.semver,this.loose))},me.prototype.intersects=function(ce,fe){if(!(ce instanceof me))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Se(ce.value,fe),qe(this.value,de,fe);if(ce.operator==="")return de=new Se(this.value,fe),qe(ce.semver,de,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Fe=this.semver.version===ce.semver.version,Ae=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),je=he(this.semver,"<",ce.semver,fe)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Me=he(this.semver,">",ce.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ie||Pe||Fe&&Ae||je||Me},e.Range=Se,Se.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},Se.prototype.toString=function(){return this.range},Se.prototype.parseRange=function(ce){var fe=this.loose;ce=ce.trim(),l("range",ce,fe);var de=fe?R[G]:R[F];ce=ce.replace(de,De),l("hyphen replace",ce),ce=ce.replace(R[W],"$1$2$3"),l("comparator trim",ce,R[W]),ce=(ce=(ce=ce.replace(R[M],"$1~")).replace(R[q],"$1^")).split(/\s+/).join(" ");var Ie=fe?R[re]:R[J],Pe=ce.split(" ").map(function(Fe){return function(Ae,je){return l("comp",Ae),Ae=function(Me,Ne){return Me.trim().split(/\s+/).map(function(Be){return function(ie,ue){l("caret",ie,ue);var ge=ue?R[Q]:R[K];return ie.replace(ge,function(we,ve,Ee,Re,Le){var Te;return l("caret",ie,we,ve,Ee,Re,Le),Ce(ve)?Te="":Ce(Ee)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ce(Re)?Te=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Le?(l("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Te=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Re+Le+" <"+ve+"."+Ee+"."+(+Re+1):">="+ve+"."+Ee+"."+Re+Le+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Re+Le+" <"+(+ve+1)+".0.0"):(l("no pr"),Te=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Re+" <"+ve+"."+Ee+"."+(+Re+1):">="+ve+"."+Ee+"."+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Re+" <"+(+ve+1)+".0.0"),l("caret return",Te),Te})}(Be,Ne)}).join(" ")}(Ae,je),l("caret",Ae),Ae=function(Me,Ne){return Me.trim().split(/\s+/).map(function(Be){return function(ie,ue){var ge=ue?R[O]:R[B];return ie.replace(ge,function(we,ve,Ee,Re,Le){var Te;return l("tilde",ie,we,ve,Ee,Re,Le),Ce(ve)?Te="":Ce(Ee)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ce(Re)?Te=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Le?(l("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Te=">="+ve+"."+Ee+"."+Re+Le+" <"+ve+"."+(+Ee+1)+".0"):Te=">="+ve+"."+Ee+"."+Re+" <"+ve+"."+(+Ee+1)+".0",l("tilde return",Te),Te})}(Be,Ne)}).join(" ")}(Ae,je),l("tildes",Ae),Ae=function(Me,Ne){return l("replaceXRanges",Me,Ne),Me.split(/\s+/).map(function(Be){return function(ie,ue){ie=ie.trim();var ge=ue?R[E]:R[S];return ie.replace(ge,function(we,ve,Ee,Re,Le,Te){l("xRange",ie,we,ve,Ee,Re,Le,Te);var Ue=Ce(Ee),$e=Ue||Ce(Re),ze=$e||Ce(Le);return ve==="="&&ze&&(ve=""),Ue?we=ve===">"||ve==="<"?"<0.0.0":"*":ve&&ze?($e&&(Re=0),ze&&(Le=0),ve===">"?(ve=">=",$e?(Ee=+Ee+1,Re=0,Le=0):ze&&(Re=+Re+1,Le=0)):ve==="<="&&(ve="<",$e?Ee=+Ee+1:Re=+Re+1),we=ve+Ee+"."+Re+"."+Le):$e?we=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ze&&(we=">="+Ee+"."+Re+".0 <"+Ee+"."+(+Re+1)+".0"),l("xRange return",we),we})}(Be,Ne)}).join(" ")}(Ae,je),l("xrange",Ae),Ae=function(Me,Ne){return l("replaceStars",Me,Ne),Me.trim().replace(R[ee],"")}(Ae,je),l("stars",Ae),Ae}(Fe,fe)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Fe){return!!Fe.match(Ie)})),Pe=Pe.map(function(Fe){return new me(Fe,fe)})},Se.prototype.intersects=function(ce,fe){if(!(ce instanceof Se))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Ie){return ce.set.some(function(Pe){return Pe.every(function(Fe){return Ie.intersects(Fe,fe)})})})})},e.toComparators=function(ce,fe){return new Se(ce,fe).set.map(function(de){return de.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},Se.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new x(ce,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ke(this.set[fe],ce))return!0;return!1},e.satisfies=qe,e.maxSatisfying=function(ce,fe,de){var Ie=null,Pe=null;try{var Fe=new Se(fe,de)}catch{return null}return ce.forEach(function(Ae){Fe.test(Ae)&&(Ie&&Pe.compare(Ae)!==-1||(Pe=new x(Ie=Ae,de)))}),Ie},e.minSatisfying=function(ce,fe,de){var Ie=null,Pe=null;try{var Fe=new Se(fe,de)}catch{return null}return ce.forEach(function(Ae){Fe.test(Ae)&&(Ie&&Pe.compare(Ae)!==1||(Pe=new x(Ie=Ae,de)))}),Ie},e.validRange=function(ce,fe){try{return new Se(ce,fe).range||"*"}catch{return null}},e.ltr=function(ce,fe,de){return Ye(ce,fe,"<",de)},e.gtr=function(ce,fe,de){return Ye(ce,fe,">",de)},e.outside=Ye,e.prerelease=function(ce,fe){var de=ae(ce,fe);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(ce,fe,de){return ce=new Se(ce,de),fe=new Se(fe,de),ce.intersects(fe)},e.coerce=function(ce){if(ce instanceof x)return ce;if(typeof ce!="string")return null;var fe=ce.match(R[A]);return fe==null?null:ae((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,k(1))},function(Z,e){var k,L,l=Z.exports={};function D(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function R(f){if(k===setTimeout)return setTimeout(f,0);if((k===D||!k)&&setTimeout)return k=setTimeout,setTimeout(f,0);try{return k(f,0)}catch{try{return k.call(null,f,0)}catch{return k.call(this,f,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:D}catch{k=D}try{L=typeof clearTimeout=="function"?clearTimeout:T}catch{L=T}})();var I,v=[],P=!1,w=-1;function g(){P&&I&&(P=!1,I.length?v=I.concat(v):w=-1,v.length&&h())}function h(){if(!P){var f=R(g);P=!0;for(var u=v.length;u;){for(I=v,v=[];++w<u;)I&&I[w].run();w=-1,u=v.length}I=null,P=!1,function(d){if(L===clearTimeout)return clearTimeout(d);if((L===T||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(d);try{L(d)}catch{try{return L.call(null,d)}catch{return L.call(this,d)}}}(f)}}function m(f,u){this.fun=f,this.array=u}function y(){}l.nextTick=function(f){var u=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)u[d-1]=arguments[d];v.push(new m(f,u)),v.length!==1||P||R(h)},m.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=y,l.addListener=y,l.once=y,l.off=y,l.removeListener=y,l.removeAllListeners=y,l.emit=y,l.prependListener=y,l.prependOnceListener=y,l.listeners=function(f){return[]},l.binding=function(f){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(f){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(ne[132],se([0,1]),function(Z,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(R,I,v){this.level=R,this.key=I,this.value=v,this.forward=[]}}const l=void 0;class D{constructor(R,I=2**16){this.comparator=R,this[k]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(I)|0),this.e=new L(this.c,l,l)}get size(){return this.f}clear(){this.e=new L(this.c,l,l)}has(R){return Boolean(D.g(this,R,this.comparator))}get(R){return D.g(this,R,this.comparator)?.value}set(R,I){return D.h(this,R,I,this.comparator)&&(this.f+=1),this}delete(R){const I=D.k(this,R,this.comparator);return I&&(this.f-=1),I}forEach(R,I){let v=this.e.forward[0];for(;v;)R.call(I,v.value,v.key,this),v=v.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",I=this.e.forward[0];for(;I;)R+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return R}static g(R,I,v){let P=R.e;for(let w=R.d-1;w>=0;w--)for(;P.forward[w]&&v(P.forward[w].key,I)<0;)P=P.forward[w];if(P=P.forward[0],P&&v(P.key,I)===0)return P}static h(R,I,v,P){const w=[];let g=R.e;for(let h=R.d-1;h>=0;h--){for(;g.forward[h]&&P(g.forward[h].key,I)<0;)g=g.forward[h];w[h]=g}if(g=g.forward[0],g&&P(g.key,I)===0)return g.value=v,!1;{const h=D.j(R);if(h>R.d){for(let m=R.d;m<h;m++)w[m]=R.e;R.d=h}g=new L(h,I,v);for(let m=0;m<h;m++)g.forward[m]=w[m].forward[m],w[m].forward[m]=g;return!0}}static j(R,I=.5){let v=1;for(;Math.random()<I&&v<R.c;)v+=1;return v}static k(R,I,v){const P=[];let w=R.e;for(let g=R.d-1;g>=0;g--){for(;w.forward[g]&&v(w.forward[g].key,I)<0;)w=w.forward[g];P[g]=w}if(w=w.forward[0],!w||v(w.key,I)!==0)return!1;for(let g=0;g<R.d&&P[g].forward[g]===w;g++)P[g].forward[g]=w.forward[g];for(;R.d>0&&R.e.forward[R.d-1]===l;)R.d-=1;return!0}}e.SkipList=D}),define(ne[43],se([0,1,8,2]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(b){const C=b;return C?typeof C.read=="function":!1}e.isReadable=l;function D(b){const C=b;return C?[C.on,C.pause,C.resume,C.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=D;function T(b){const C=b;return C?D(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.isReadableBufferedStream=T;function R(b,C){return new I(b,C)}e.newWriteableStream=R;class I{constructor(C,t){this.e=C,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(C){if(!this.a.destroyed){if(this.a.flowing)this.g(C);else if(this.b.data.push(C),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(C){this.a.destroyed||(this.a.flowing?this.h(C):this.b.error.push(C))}end(C){this.a.destroyed||(typeof C<"u"&&this.write(C),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(C){this.c.data.slice(0).forEach(t=>t(C))}h(C){this.c.error.length===0?(0,k.onUnexpectedError)(C):this.c.error.slice(0).forEach(t=>t(C))}i(){this.c.end.slice(0).forEach(C=>C())}on(C,t){if(!this.a.destroyed)switch(C){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(C,t){if(this.a.destroyed)return;let a;switch(C){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const C=this.e(this.b.data);this.g(C),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const C of this.b.error)this.h(C);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function v(b,C){const t=[];let a;for(;(a=b.read())!==null;)t.push(a);return C(t)}e.consumeReadable=v;function P(b,C,t){const a=[];let i;for(;(i=b.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?C(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return b.read()}}}e.peekReadable=P;function w(b,C){return new Promise((t,a)=>{const i=[];g(b,{onData:n=>{C&&i.push(n)},onError:n=>{C?a(n):t(void 0)},onEnd:()=>{t(C?C(i):void 0)}})})}e.consumeStream=w;function g(b,C){let t=!1;return b.on("error",a=>{t||C.onError(a)}),b.on("end",()=>{t||C.onEnd()}),b.on("data",a=>{t||C.onData(a)}),(0,L.toDisposable)(()=>t=!0)}e.listenStream=g;function h(b,C){return new Promise((t,a)=>{const i=new L.DisposableStore,n=[],r=c=>{if(n.push(c),n.length>C)return i.dispose(),b.pause(),t({stream:b,buffer:n,ended:!1})},o=c=>a(c),s=()=>t({stream:b,buffer:n,ended:!0});i.add((0,L.toDisposable)(()=>b.removeListener("error",o))),b.on("error",o),i.add((0,L.toDisposable)(()=>b.removeListener("end",s))),b.on("end",s),i.add((0,L.toDisposable)(()=>b.removeListener("data",r))),b.on("data",r)})}e.peekStream=h;function m(b,C){const t=R(C);return t.end(b),t}e.toStream=m;function y(){const b=R(()=>{throw new Error("not supported")});return b.end(),b}e.emptyStream=y;function f(b){let C=!1;return{read:()=>C?null:(C=!0,b)}}e.toReadable=f;function u(b,C,t){const a=R(t);return g(b,{onData:i=>a.write(C.data(i)),onError:i=>a.error(C.error?C.error(i):i),onEnd:()=>a.end()}),a}e.transform=u;function d(b,C,t){let a=!1;return{read:()=>{const i=C.read();return a?i:(a=!0,i!==null?t([b,i]):b)}}}e.prefixedReadable=d;function p(b,C,t){let a=!1;const i=R(t);return g(C,{onData:n=>a?i.write(n):(a=!0,i.write(t([b,n]))),onError:n=>i.error(n),onEnd:()=>{a||(a=!0,i.write(b)),i.end()}}),i}e.prefixedStream=p}),define(ne[17],se([0,1,43]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer<"u";let l,D;class T{static alloc(c){return L?new T(Buffer.allocUnsafe(c)):new T(new Uint8Array(c))}static wrap(c){return L&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new T(c)}static fromString(c,S){return!(S?.dontUseNodeBuffer||!1)&&L?new T(Buffer.from(c)):(l||(l=new TextEncoder),new T(l.encode(c)))}static fromByteArray(c){const S=T.alloc(c.length);for(let E=0,A=c.length;E<A;E++)S.buffer[E]=c[E];return S}static concat(c,S){if(typeof S>"u"){S=0;for(let N=0,M=c.length;N<M;N++)S+=c[N].byteLength}const E=T.alloc(S);let A=0;for(let N=0,M=c.length;N<M;N++){const B=c[N];E.set(B,A),A+=B.byteLength}return E}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=T.alloc(this.byteLength);return c.set(this),c}toString(){return L?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(c,S){return new T(this.buffer.subarray(c,S))}set(c,S){if(c instanceof T)this.buffer.set(c.buffer,S);else if(c instanceof Uint8Array)this.buffer.set(c,S);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),S);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return v(this.buffer,c)}writeUInt32BE(c,S){P(this.buffer,c,S)}readUInt32LE(c){return w(this.buffer,c)}writeUInt32LE(c,S){g(this.buffer,c,S)}readUInt8(c){return h(this.buffer,c)}writeUInt8(c,S){m(this.buffer,c,S)}}e.VSBuffer=T;function R(s,c){return s[c+0]<<0>>>0|s[c+1]<<8>>>0}e.readUInt16LE=R;function I(s,c,S){s[S+0]=c&255,c=c>>>8,s[S+1]=c&255}e.writeUInt16LE=I;function v(s,c){return s[c]*2**24+s[c+1]*2**16+s[c+2]*2**8+s[c+3]}e.readUInt32BE=v;function P(s,c,S){s[S+3]=c,c=c>>>8,s[S+2]=c,c=c>>>8,s[S+1]=c,c=c>>>8,s[S]=c}e.writeUInt32BE=P;function w(s,c){return s[c+0]<<0>>>0|s[c+1]<<8>>>0|s[c+2]<<16>>>0|s[c+3]<<24>>>0}e.readUInt32LE=w;function g(s,c,S){s[S+0]=c&255,c=c>>>8,s[S+1]=c&255,c=c>>>8,s[S+2]=c&255,c=c>>>8,s[S+3]=c&255}e.writeUInt32LE=g;function h(s,c){return s[c]}e.readUInt8=h;function m(s,c,S){s[S]=c}e.writeUInt8=m;function y(s){return k.consumeReadable(s,c=>T.concat(c))}e.readableToBuffer=y;function f(s){return k.toReadable(s)}e.bufferToReadable=f;function u(s){return k.consumeStream(s,c=>T.concat(c))}e.streamToBuffer=u;async function d(s){return s.ended?T.concat(s.buffer):T.concat([...s.buffer,await u(s.stream)])}e.bufferedStreamToBuffer=d;function p(s){return k.toStream(s,c=>T.concat(c))}e.bufferToStream=p;function b(s){return k.transform(s,{data:c=>typeof c=="string"?T.fromString(c):T.wrap(c)},c=>T.concat(c))}e.streamToBufferReadableStream=b;function C(s){return k.newWriteableStream(c=>T.concat(c),s)}e.newWriteableBufferStream=C;function t(s,c){return k.prefixedReadable(s,c,S=>T.concat(S))}e.prefixedBufferReadable=t;function a(s,c){return k.prefixedStream(s,c,S=>T.concat(S))}e.prefixedBufferStream=a;function i(s){let c=0,S=0,E=0;const A=new Uint8Array(Math.floor(s.length/4*3)),N=B=>{switch(S){case 3:A[E++]=c|B,S=0;break;case 2:A[E++]=c|B>>>2,c=B<<6,S=3;break;case 1:A[E++]=c|B>>>4,c=B<<4,S=2;break;default:c=B<<2,S=1}};for(let B=0;B<s.length;B++){const O=s.charCodeAt(B);if(O>=65&&O<=90)N(O-65);else if(O>=97&&O<=122)N(O-97+26);else if(O>=48&&O<=57)N(O-48+52);else if(O===43||O===45)N(62);else if(O===47||O===95)N(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${s[B]}`)}}const M=E;for(;S>0;)N(0);return T.wrap(A).slice(0,M)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:s},c=!0,S=!1){const E=S?r:n;let A="";const N=s.byteLength%3;let M=0;for(;M<s.byteLength-N;M+=3){const B=s[M+0],O=s[M+1],j=s[M+2];A+=E[B>>>2],A+=E[(B<<4|O>>>4)&63],A+=E[(O<<2|j>>>6)&63],A+=E[j&63]}if(N===1){const B=s[M+0];A+=E[B>>>2],A+=E[B<<4&63],c&&(A+="==")}else if(N===2){const B=s[M+0],O=s[M+1];A+=E[B>>>2],A+=E[(B<<4|O>>>4)&63],A+=E[O<<2&63],c&&(A+="=")}return A}e.encodeBase64=o}),define(ne[133],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ne[12],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function k(a){return typeof a=="string"}e.isString=k;function L(a){return Array.isArray(a)&&a.every(i=>k(i))}e.isStringArray=L;function l(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=l;function D(a){const i=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof i}e.isTypedArray=D;function T(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=T;function R(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=R;function I(a){return a===!0||a===!1}e.isBoolean=I;function v(a){return typeof a>"u"}e.isUndefined=v;function P(a){return!w(a)}e.isDefined=P;function w(a){return v(a)||a===null}e.isUndefinedOrNull=w;function g(a,i){if(!a)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=g;function h(a){if(w(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=h;function m(...a){const i=[];for(let n=0;n<a.length;n++){const r=a[n];if(w(r))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(r)}return i}e.assertAllDefined=m;const y=Object.prototype.hasOwnProperty;function f(a){if(!l(a))return!1;for(const i in a)if(y.call(a,i))return!1;return!0}e.isEmptyObject=f;function u(a){return typeof a=="function"}e.isFunction=u;function d(...a){return a.length>0&&a.every(u)}e.areFunctions=d;function p(a,i){const n=Math.min(a.length,i.length);for(let r=0;r<n;r++)b(a[r],i[r])}e.validateConstraints=p;function b(a,i){if(k(i)){if(typeof a!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(a instanceof i)return}catch{}if(!w(a)&&a.constructor===i||i.length===1&&i.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=b;function C(a){return a===null?void 0:a}e.withNullAsUndefined=C;function t(a){return typeof a>"u"?null:a}e.withUndefinedAsNull=t}),define(ne[52],se([0,1,12]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function l(R,I){if((0,k.isString)(I)){const v=L[I];if(v===void 0)throw new Error(`${R} references an unknown codicon: ${I}`);I=v}return L[R]=I,{id:R}}function D(){return L}e.getCodiconFontCharacters=D;function T(){return Object.values(e.Codicon)}e.getAllCodicons=T,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(ne[32],se([0,1,12]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const d=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([p,b])=>{d[p]=b&&typeof b=="object"?L(b):b}),d}e.deepClone=L;function l(u){if(!u||typeof u!="object")return u;const d=[u];for(;d.length>0;){const p=d.shift();Object.freeze(p);for(const b in p)if(D.call(p,b)){const C=p[b];typeof C=="object"&&!Object.isFrozen(C)&&!(0,k.isTypedArray)(C)&&d.push(C)}}return u}e.deepFreeze=l;const D=Object.prototype.hasOwnProperty;function T(u,d){return R(u,d,new Set)}e.cloneAndChange=T;function R(u,d,p){if((0,k.isUndefinedOrNull)(u))return u;const b=d(u);if(typeof b<"u")return b;if(Array.isArray(u)){const C=[];for(const t of u)C.push(R(t,d,p));return C}if((0,k.isObject)(u)){if(p.has(u))throw new Error("Cannot clone recursive data-structure");p.add(u);const C={};for(const t in u)D.call(u,t)&&(C[t]=R(u[t],d,p));return p.delete(u),C}return u}function I(u,d,p=!0){return(0,k.isObject)(u)?((0,k.isObject)(d)&&Object.keys(d).forEach(b=>{b in u?p&&((0,k.isObject)(u[b])&&(0,k.isObject)(d[b])?I(u[b],d[b],p):u[b]=d[b]):u[b]=d[b]}),u):d}e.mixin=I;function v(u,d){if(u===d)return!0;if(u==null||d===null||d===void 0||typeof u!=typeof d||typeof u!="object"||Array.isArray(u)!==Array.isArray(d))return!1;let p,b;if(Array.isArray(u)){if(u.length!==d.length)return!1;for(p=0;p<u.length;p++)if(!v(u[p],d[p]))return!1}else{const C=[];for(b in u)C.push(b);C.sort();const t=[];for(b in d)t.push(b);if(t.sort(),!v(C,t))return!1;for(p=0;p<C.length;p++)if(!v(u[C[p]],d[C[p]]))return!1}return!0}e.equals=v;function P(u){const d=new Set;return JSON.stringify(u,(p,b)=>{if((0,k.isObject)(b)||Array.isArray(b)){if(d.has(b))return"[Circular]";d.add(b)}return b})}e.safeStringify=P;function w(u,d){const p=Object.create(null);return!u||!d||Object.keys(d).forEach(C=>{const t=u[C],a=d[C];v(t,a)||(p[C]=a)}),p}e.distinct=w;function g(u,d){const p=d.toLowerCase(),b=Object.keys(u).find(C=>C.toLowerCase()===p);return b?u[b]:u[d]}e.getCaseInsensitive=g;function h(u,d){const p=Object.create(null);for(const[b,C]of Object.entries(u))d(b,C)&&(p[b]=C);return p}e.filter=h;function m(u){let d=[],p=Object.getPrototypeOf(u);for(;Object.prototype!==p;)d=d.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return d}e.getAllPropertyNames=m;function y(u){const d=[];for(const p of m(u))typeof u[p]=="function"&&d.push(p);return d}e.getAllMethodNames=y;function f(u,d){const p=C=>function(){const t=Array.prototype.slice.call(arguments,0);return d(C,t)},b={};for(const C of u)b[C]=p(C);return b}e.createProxyObject=f}),define(ne[134],se([0,1,52]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(T){function R(I){return I&&typeof I=="object"&&typeof I.id=="string"}T.isThemeColor=R})(L=e.ThemeColor||(e.ThemeColor={}));function l(T){return{id:T}}e.themeColorFromId=l;var D;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function I(d){const p=R.exec(d.id);if(!p)return I(k.Codicon.error);const[,b,C]=p,t=["codicon","codicon-"+b];return C&&t.push("codicon-modifier-"+C.substring(1)),t}T.asClassNameArray=I;function v(d){return I(d).join(" ")}T.asClassName=v;function P(d){return"."+I(d).join(".")}T.asCSSSelector=P;function w(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||L.isThemeColor(d.color))}T.isThemeIcon=w;const g=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function h(d){const p=g.exec(d);if(!p)return;const[,b]=p;return{id:b}}T.fromString=h;function m(d){return{id:d}}T.fromId=m;function y(d,p){let b=d.id;const C=b.lastIndexOf("~");return C!==-1&&(b=b.substring(0,C)),p&&(b=`${b}~${p}`),{id:b}}T.modify=y;function f(d){const p=d.id.lastIndexOf("~");if(p!==-1)return d.id.substring(p+1)}T.getModifier=f;function u(d,p){return d.id===p.id&&d.color?.id===p.color?.id}T.isEqual=u})(D=e.ThemeIcon||(e.ThemeIcon={}))}),define(ne[31],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(l){return k.test(l)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(R){for(let I=0;I<R.length;I++)R[I]=Math.floor(Math.random()*256);return R};const D=new Uint8Array(16),T=[];for(let R=0;R<256;R++)T.push(R.toString(16).padStart(2,"0"));return function(){l(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let I=0,v="";return v+=T[D[I++]],v+=T[D[I++]],v+=T[D[I++]],v+=T[D[I++]],v+="-",v+=T[D[I++]],v+=T[D[I++]],v+="-",v+=T[D[I++]],v+=T[D[I++]],v+="-",v+=T[D[I++]],v+=T[D[I++]],v+="-",v+=T[D[I++]],v+=T[D[I++]],v+=T[D[I++]],v+=T[D[I++]],v+=T[D[I++]],v+=T[D[I++]],v}}()}),define(ne[135],se([0,1,34]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function l(T){const R=T.replace(/\-/g,":").toLowerCase();return!L.has(R)}function D(){const T=(0,k.networkInterfaces)();for(const R in T){const I=T[R];if(I){for(const{mac:v}of I)if(l(v))return v}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=D}),define(ne[136],se([0,1,85]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(R,I,v,P=1){let w=!1;return new Promise(g=>{const h=setTimeout(()=>{if(!w)return w=!0,g(0)},v);l(R,I,P,m=>{if(!w)return w=!0,clearTimeout(h),g(m)})})}e.findFreePort=L;function l(R,I,v,P){if(I===0)return P(0);const w=new k.Socket;w.once("connect",()=>(T(w),l(R+v,I-1,v,P))),w.once("data",()=>{}),w.once("error",g=>(T(w),g.code!=="ECONNREFUSED"?l(R+v,I-1,v,P):P(R))),w.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(R,I,v,P="127.0.0.1"){let w=!1,g,h=1;const m=k.createServer({pauseOnConnect:!0});function y(f,u){w||(w=!0,m.removeAllListeners(),m.close(),g&&clearTimeout(g),u(f))}return new Promise(f=>{g=setTimeout(()=>{y(0,f)},v),m.on("listening",()=>{y(R,f)}),m.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&h<I?(R++,h++,m.listen(R,P)):y(0,f)}),m.on("close",()=>{y(0,f)}),m.listen(R,P)})}e.findFreePortFaster=D;function T(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(I){console.error(I)}}}),define(ne[137],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const k="Offline";function L(D){return D instanceof l?!0:D instanceof Error&&D.name===k&&D.message===k}e.isOfflineError=L;class l extends Error{constructor(){super(k),this.name=this.message}}e.OfflineError=l}),define(ne[138],se([0,1,17,8,137]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function D(I,v){I.proxyAuthorization&&(I.headers={...I.headers||{},"Proxy-Authorization":I.proxyAuthorization});const P=new XMLHttpRequest;return new Promise((w,g)=>{P.open(I.type||"GET",I.url||"",!0,I.user,I.password),T(P,I),P.responseType="arraybuffer",P.onerror=h=>g(navigator.onLine?new Error(P.statusText&&"XHR failed: "+P.statusText||"XHR failed"):new l.OfflineError),P.onload=h=>{w({res:{statusCode:P.status,headers:R(P)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(P.response)))})},P.ontimeout=h=>g(new Error(`XHR timeout: ${I.timeout}ms`)),I.timeout&&(P.timeout=I.timeout),P.send(I.data),v.onCancellationRequested(()=>{P.abort(),g((0,L.canceled)())})})}e.request=D;function T(I,v){if(v.headers){e:for(const P in v.headers){switch(P){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}I.setRequestHeader(P,v.headers[P])}}}function R(I){const v=Object.create(null);for(const P of I.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(P){const w=P.indexOf(":");v[P.substr(0,w).trim().toLowerCase()]=P.substr(w+1).trim()}return v}}),define(ne[86],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function k(L){return!!L.parentPort}e.isUtilityProcess=k}),define(ne[139],se([9,7]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(ne[64],se([0,1,139]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,l=L*60,D=l*24,T=D*7,R=D*30,I=D*365;function v(w,g,h,m){typeof w!="number"&&(w=w.getTime());const y=Math.round((new Date().getTime()-w)/1e3);if(y<-30)return(0,k.localize)(0,null,v(new Date().getTime()+y*1e3,!1));if(!m&&y<30)return(0,k.localize)(1,null);let f;return y<L?(f=y,g?f===1?h?(0,k.localize)(2,null,f):(0,k.localize)(3,null,f):h?(0,k.localize)(4,null,f):(0,k.localize)(5,null,f):f===1?h?(0,k.localize)(6,null,f):(0,k.localize)(7,null,f):h?(0,k.localize)(8,null,f):(0,k.localize)(9,null,f)):y<l?(f=Math.floor(y/L),g?f===1?h?(0,k.localize)(10,null,f):(0,k.localize)(11,null,f):h?(0,k.localize)(12,null,f):(0,k.localize)(13,null,f):f===1?h?(0,k.localize)(14,null,f):(0,k.localize)(15,null,f):h?(0,k.localize)(16,null,f):(0,k.localize)(17,null,f)):y<D?(f=Math.floor(y/l),g?f===1?h?(0,k.localize)(18,null,f):(0,k.localize)(19,null,f):h?(0,k.localize)(20,null,f):(0,k.localize)(21,null,f):f===1?h?(0,k.localize)(22,null,f):(0,k.localize)(23,null,f):h?(0,k.localize)(24,null,f):(0,k.localize)(25,null,f)):y<T?(f=Math.floor(y/D),g?f===1?(0,k.localize)(26,null,f):(0,k.localize)(27,null,f):f===1?(0,k.localize)(28,null,f):(0,k.localize)(29,null,f)):y<R?(f=Math.floor(y/T),g?f===1?h?(0,k.localize)(30,null,f):(0,k.localize)(31,null,f):h?(0,k.localize)(32,null,f):(0,k.localize)(33,null,f):f===1?h?(0,k.localize)(34,null,f):(0,k.localize)(35,null,f):h?(0,k.localize)(36,null,f):(0,k.localize)(37,null,f)):y<I?(f=Math.floor(y/R),g?f===1?h?(0,k.localize)(38,null,f):(0,k.localize)(39,null,f):h?(0,k.localize)(40,null,f):(0,k.localize)(41,null,f):f===1?h?(0,k.localize)(42,null,f):(0,k.localize)(43,null,f):h?(0,k.localize)(44,null,f):(0,k.localize)(45,null,f)):(f=Math.floor(y/I),g?f===1?h?(0,k.localize)(46,null,f):(0,k.localize)(47,null,f):h?(0,k.localize)(48,null,f):(0,k.localize)(49,null,f):f===1?h?(0,k.localize)(50,null,f):(0,k.localize)(51,null,f):h?(0,k.localize)(52,null,f):(0,k.localize)(53,null,f))}e.fromNow=v;function P(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(ne[140],se([9,7]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(ne[39],se([0,1,18,12,140]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function D(w,g){return g&&(w.stack||w.stacktrace)?l.localize(0,null,R(w),T(w.stack)||T(w.stacktrace)):R(w)}function T(w){return Array.isArray(w)?w.join(`
`):w}function R(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?l.localize(1,null,w.message):w.message||l.localize(2,null)}function I(w=null,g=!1){if(!w)return l.localize(3,null);if(Array.isArray(w)){const h=k.coalesce(w),m=I(h[0],g);return h.length>1?l.localize(4,null,m,h.length):m}if(L.isString(w))return w;if(w.detail){const h=w.detail;if(h.error)return D(h.error,g);if(h.exception)return D(h.exception,g)}return w.stack?D(w,g):w.message?w.message:l.localize(5,null)}e.toErrorMessage=I;function v(w){const g=w;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=v;function P(w,g){let h;return typeof w=="string"?h=new Error(w):h=w,h.actions=g,h}e.createErrorWithActions=P}),define(ne[141],se([9,7]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(ne[142],se([0,1,141]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(l){switch(l){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(ne[143],se([9,7]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(ne[4],se([0,1,143]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,l=!1,D=!1,T=!1,R=!1,I=!1,v=!1,P=!1,w=!1,g=!1,h,m=e.LANGUAGE_DEFAULT,y,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const d=typeof u?.versions?.electron=="string",p=d&&u?.type==="renderer";if(typeof navigator=="object"&&!p)f=navigator.userAgent,L=f.indexOf("Windows")>=0,l=f.indexOf("Macintosh")>=0,P=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=f.indexOf("Linux")>=0,g=f?.indexOf("Mobi")>=0,I=!0,h=k.getConfiguredDefaultLocale(k.localize(0,null))||e.LANGUAGE_DEFAULT,m=h;else if(typeof u=="object"){L=u.platform==="win32",l=u.platform==="darwin",D=u.platform==="linux",T=D&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,v=d,w=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.LANGUAGE_DEFAULT,m=e.LANGUAGE_DEFAULT;const s=u.env.VSCODE_NLS_CONFIG;if(s)try{const c=JSON.parse(s),S=c.availableLanguages["*"];h=c.locale,m=S||e.LANGUAGE_DEFAULT,y=c._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var b;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function C(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=C;let t=0;l?t=1:L?t=3:D&&(t=2),e.isWindows=L,e.isMacintosh=l,e.isLinux=D,e.isLinuxSnap=T,e.isNative=R,e.isElectron=v,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isMobile=g,e.isCI=w,e.platform=t,e.userAgent=f,e.language=m;var a;(function(s){function c(){return e.language}s.value=c;function S(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=S;function E(){return e.language==="en"}s.isDefault=E})(a=e.Language||(e.Language={})),e.locale=h,e.translationsConfigFile=y,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let E=0,A=s.length;E<A;E++){const N=s[E];if(N.id===S.data.vscodeScheduleAsyncWork){s.splice(E,1),N.callback();return}}});let c=0;return S=>{const E=++c;s.push({id:E,callback:S}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return s=>setTimeout(s)})();var i;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=l||P?2:L?1:3;let n=!0,r=!1;function o(){if(!r){r=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,n=new Uint16Array(s.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[36],se([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.process<"u"){const l=k.globals.vscode.process;L={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(ne[13],se([0,1,36]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,l=97,D=90,T=122,R=46,I=47,v=92,P=58,w=63;class g extends Error{constructor(a,i,n){let r;typeof i=="string"&&i.indexOf("not ")===0?(r="must not be",i=i.replace(/^not /,"")):r="must be";const o=a.indexOf(".")!==-1?"property":"argument";let s=`The "${a}" ${o} ${r} of type ${i}`;s+=`. Received type ${typeof n}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,a){if(t===null||typeof t!="object")throw new g(a,"Object",t)}function m(t,a){if(typeof t!="string")throw new g(a,"string",t)}const y=k.platform==="win32";function f(t){return t===I||t===v}function u(t){return t===I}function d(t){return t>=L&&t<=D||t>=l&&t<=T}function p(t,a,i,n){let r="",o=0,s=-1,c=0,S=0;for(let E=0;E<=t.length;++E){if(E<t.length)S=t.charCodeAt(E);else{if(n(S))break;S=I}if(n(S)){if(!(s===E-1||c===1))if(c===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==R||r.charCodeAt(r.length-2)!==R){if(r.length>2){const A=r.lastIndexOf(i);A===-1?(r="",o=0):(r=r.slice(0,A),o=r.length-1-r.lastIndexOf(i)),s=E,c=0;continue}else if(r.length!==0){r="",o=0,s=E,c=0;continue}}a&&(r+=r.length>0?`${i}..`:"..",o=2)}else r.length>0?r+=`${i}${t.slice(s+1,E)}`:r=t.slice(s+1,E),o=E-s-1;s=E,c=0}else S===R&&c!==-1?++c:c=-1}return r}function b(t,a){h(a,"pathObject");const i=a.dir||a.root,n=a.base||`${a.name||""}${a.ext||""}`;return i?i===a.root?`${i}${n}`:`${i}${t}${n}`:n}e.win32={resolve(...t){let a="",i="",n=!1;for(let r=t.length-1;r>=-1;r--){let o;if(r>=0){if(o=t[r],m(o,"path"),o.length===0)continue}else a.length===0?o=k.cwd():(o=k.env[`=${a}`]||k.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==a.toLowerCase()&&o.charCodeAt(2)===v)&&(o=`${a}\\`));const s=o.length;let c=0,S="",E=!1;const A=o.charCodeAt(0);if(s===1)f(A)&&(c=1,E=!0);else if(f(A))if(E=!0,f(o.charCodeAt(1))){let N=2,M=N;for(;N<s&&!f(o.charCodeAt(N));)N++;if(N<s&&N!==M){const B=o.slice(M,N);for(M=N;N<s&&f(o.charCodeAt(N));)N++;if(N<s&&N!==M){for(M=N;N<s&&!f(o.charCodeAt(N));)N++;(N===s||N!==M)&&(S=`\\\\${B}\\${o.slice(M,N)}`,c=N)}}}else c=1;else d(A)&&o.charCodeAt(1)===P&&(S=o.slice(0,2),c=2,s>2&&f(o.charCodeAt(2))&&(E=!0,c=3));if(S.length>0)if(a.length>0){if(S.toLowerCase()!==a.toLowerCase())continue}else a=S;if(n){if(a.length>0)break}else if(i=`${o.slice(c)}\\${i}`,n=E,E&&a.length>0)break}return i=p(i,!n,"\\",f),n?`${a}\\${i}`:`${a}${i}`||"."},normalize(t){m(t,"path");const a=t.length;if(a===0)return".";let i=0,n,r=!1;const o=t.charCodeAt(0);if(a===1)return u(o)?"\\":t;if(f(o))if(r=!0,f(t.charCodeAt(1))){let c=2,S=c;for(;c<a&&!f(t.charCodeAt(c));)c++;if(c<a&&c!==S){const E=t.slice(S,c);for(S=c;c<a&&f(t.charCodeAt(c));)c++;if(c<a&&c!==S){for(S=c;c<a&&!f(t.charCodeAt(c));)c++;if(c===a)return`\\\\${E}\\${t.slice(S)}\\`;c!==S&&(n=`\\\\${E}\\${t.slice(S,c)}`,i=c)}}}else i=1;else d(o)&&t.charCodeAt(1)===P&&(n=t.slice(0,2),i=2,a>2&&f(t.charCodeAt(2))&&(r=!0,i=3));let s=i<a?p(t.slice(i),!r,"\\",f):"";return s.length===0&&!r&&(s="."),s.length>0&&f(t.charCodeAt(a-1))&&(s+="\\"),n===void 0?r?`\\${s}`:s:r?`${n}\\${s}`:`${n}${s}`},isAbsolute(t){m(t,"path");const a=t.length;if(a===0)return!1;const i=t.charCodeAt(0);return f(i)||a>2&&d(i)&&t.charCodeAt(1)===P&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,i;for(let o=0;o<t.length;++o){const s=t[o];m(s,"path"),s.length>0&&(a===void 0?a=i=s:a+=`\\${s}`)}if(a===void 0)return".";let n=!0,r=0;if(typeof i=="string"&&f(i.charCodeAt(0))){++r;const o=i.length;o>1&&f(i.charCodeAt(1))&&(++r,o>2&&(f(i.charCodeAt(2))?++r:n=!1))}if(n){for(;r<a.length&&f(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(t,a){if(m(t,"from"),m(a,"to"),t===a)return"";const i=e.win32.resolve(t),n=e.win32.resolve(a);if(i===n||(t=i.toLowerCase(),a=n.toLowerCase(),t===a))return"";let r=0;for(;r<t.length&&t.charCodeAt(r)===v;)r++;let o=t.length;for(;o-1>r&&t.charCodeAt(o-1)===v;)o--;const s=o-r;let c=0;for(;c<a.length&&a.charCodeAt(c)===v;)c++;let S=a.length;for(;S-1>c&&a.charCodeAt(S-1)===v;)S--;const E=S-c,A=s<E?s:E;let N=-1,M=0;for(;M<A;M++){const O=t.charCodeAt(r+M);if(O!==a.charCodeAt(c+M))break;O===v&&(N=M)}if(M!==A){if(N===-1)return n}else{if(E>A){if(a.charCodeAt(c+M)===v)return n.slice(c+M+1);if(M===2)return n.slice(c+M)}s>A&&(t.charCodeAt(r+M)===v?N=M:M===2&&(N=3)),N===-1&&(N=0)}let B="";for(M=r+N+1;M<=o;++M)(M===o||t.charCodeAt(M)===v)&&(B+=B.length===0?"..":"\\..");return c+=N,B.length>0?`${B}${n.slice(c,S)}`:(n.charCodeAt(c)===v&&++c,n.slice(c,S))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.win32.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===v){if(a.charCodeAt(1)===v){const i=a.charCodeAt(2);if(i!==w&&i!==R)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(d(a.charCodeAt(0))&&a.charCodeAt(1)===P&&a.charCodeAt(2)===v)return`\\\\?\\${a}`;return t},dirname(t){m(t,"path");const a=t.length;if(a===0)return".";let i=-1,n=0;const r=t.charCodeAt(0);if(a===1)return f(r)?t:".";if(f(r)){if(i=n=1,f(t.charCodeAt(1))){let c=2,S=c;for(;c<a&&!f(t.charCodeAt(c));)c++;if(c<a&&c!==S){for(S=c;c<a&&f(t.charCodeAt(c));)c++;if(c<a&&c!==S){for(S=c;c<a&&!f(t.charCodeAt(c));)c++;if(c===a)return t;c!==S&&(i=n=c+1)}}}}else d(r)&&t.charCodeAt(1)===P&&(i=a>2&&f(t.charCodeAt(2))?3:2,n=i);let o=-1,s=!0;for(let c=a-1;c>=n;--c)if(f(t.charCodeAt(c))){if(!s){o=c;break}}else s=!1;if(o===-1){if(i===-1)return".";o=i}return t.slice(0,o)},basename(t,a){a!==void 0&&m(a,"ext"),m(t,"path");let i=0,n=-1,r=!0,o;if(t.length>=2&&d(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(i=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let s=a.length-1,c=-1;for(o=t.length-1;o>=i;--o){const S=t.charCodeAt(o);if(f(S)){if(!r){i=o+1;break}}else c===-1&&(r=!1,c=o+1),s>=0&&(S===a.charCodeAt(s)?--s===-1&&(n=o):(s=-1,n=c))}return i===n?n=c:n===-1&&(n=t.length),t.slice(i,n)}for(o=t.length-1;o>=i;--o)if(f(t.charCodeAt(o))){if(!r){i=o+1;break}}else n===-1&&(r=!1,n=o+1);return n===-1?"":t.slice(i,n)},extname(t){m(t,"path");let a=0,i=-1,n=0,r=-1,o=!0,s=0;t.length>=2&&t.charCodeAt(1)===P&&d(t.charCodeAt(0))&&(a=n=2);for(let c=t.length-1;c>=a;--c){const S=t.charCodeAt(c);if(f(S)){if(!o){n=c+1;break}continue}r===-1&&(o=!1,r=c+1),S===R?i===-1?i=c:s!==1&&(s=1):i!==-1&&(s=-1)}return i===-1||r===-1||s===0||s===1&&i===r-1&&i===n+1?"":t.slice(i,r)},format:b.bind(null,"\\"),parse(t){m(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.length;let n=0,r=t.charCodeAt(0);if(i===1)return f(r)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(f(r)){if(n=1,f(t.charCodeAt(1))){let N=2,M=N;for(;N<i&&!f(t.charCodeAt(N));)N++;if(N<i&&N!==M){for(M=N;N<i&&f(t.charCodeAt(N));)N++;if(N<i&&N!==M){for(M=N;N<i&&!f(t.charCodeAt(N));)N++;N===i?n=N:N!==M&&(n=N+1)}}}}else if(d(r)&&t.charCodeAt(1)===P){if(i<=2)return a.root=a.dir=t,a;if(n=2,f(t.charCodeAt(2))){if(i===3)return a.root=a.dir=t,a;n=3}}n>0&&(a.root=t.slice(0,n));let o=-1,s=n,c=-1,S=!0,E=t.length-1,A=0;for(;E>=n;--E){if(r=t.charCodeAt(E),f(r)){if(!S){s=E+1;break}continue}c===-1&&(S=!1,c=E+1),r===R?o===-1?o=E:A!==1&&(A=1):o!==-1&&(A=-1)}return c!==-1&&(o===-1||A===0||A===1&&o===c-1&&o===s+1?a.base=a.name=t.slice(s,c):(a.name=t.slice(s,o),a.base=t.slice(s,c),a.ext=t.slice(o,c))),s>0&&s!==n?a.dir=t.slice(0,s-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(y){const t=/\\/g;return()=>{const a=k.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>k.cwd()})();e.posix={resolve(...t){let a="",i=!1;for(let n=t.length-1;n>=-1&&!i;n--){const r=n>=0?t[n]:C();m(r,"path"),r.length!==0&&(a=`${r}/${a}`,i=r.charCodeAt(0)===I)}return a=p(a,!i,"/",u),i?`/${a}`:a.length>0?a:"."},normalize(t){if(m(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===I,i=t.charCodeAt(t.length-1)===I;return t=p(t,!a,"/",u),t.length===0?a?"/":i?"./":".":(i&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return m(t,"path"),t.length>0&&t.charCodeAt(0)===I},join(...t){if(t.length===0)return".";let a;for(let i=0;i<t.length;++i){const n=t[i];m(n,"path"),n.length>0&&(a===void 0?a=n:a+=`/${n}`)}return a===void 0?".":e.posix.normalize(a)},relative(t,a){if(m(t,"from"),m(a,"to"),t===a||(t=e.posix.resolve(t),a=e.posix.resolve(a),t===a))return"";const i=1,n=t.length,r=n-i,o=1,s=a.length-o,c=r<s?r:s;let S=-1,E=0;for(;E<c;E++){const N=t.charCodeAt(i+E);if(N!==a.charCodeAt(o+E))break;N===I&&(S=E)}if(E===c)if(s>c){if(a.charCodeAt(o+E)===I)return a.slice(o+E+1);if(E===0)return a.slice(o+E)}else r>c&&(t.charCodeAt(i+E)===I?S=E:E===0&&(S=0));let A="";for(E=i+S+1;E<=n;++E)(E===n||t.charCodeAt(E)===I)&&(A+=A.length===0?"..":"/..");return`${A}${a.slice(o+S)}`},toNamespacedPath(t){return t},dirname(t){if(m(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===I;let i=-1,n=!0;for(let r=t.length-1;r>=1;--r)if(t.charCodeAt(r)===I){if(!n){i=r;break}}else n=!1;return i===-1?a?"/":".":a&&i===1?"//":t.slice(0,i)},basename(t,a){a!==void 0&&m(a,"ext"),m(t,"path");let i=0,n=-1,r=!0,o;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let s=a.length-1,c=-1;for(o=t.length-1;o>=0;--o){const S=t.charCodeAt(o);if(S===I){if(!r){i=o+1;break}}else c===-1&&(r=!1,c=o+1),s>=0&&(S===a.charCodeAt(s)?--s===-1&&(n=o):(s=-1,n=c))}return i===n?n=c:n===-1&&(n=t.length),t.slice(i,n)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===I){if(!r){i=o+1;break}}else n===-1&&(r=!1,n=o+1);return n===-1?"":t.slice(i,n)},extname(t){m(t,"path");let a=-1,i=0,n=-1,r=!0,o=0;for(let s=t.length-1;s>=0;--s){const c=t.charCodeAt(s);if(c===I){if(!r){i=s+1;break}continue}n===-1&&(r=!1,n=s+1),c===R?a===-1?a=s:o!==1&&(o=1):a!==-1&&(o=-1)}return a===-1||n===-1||o===0||o===1&&a===n-1&&a===i+1?"":t.slice(a,n)},format:b.bind(null,"/"),parse(t){m(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.charCodeAt(0)===I;let n;i?(a.root="/",n=1):n=0;let r=-1,o=0,s=-1,c=!0,S=t.length-1,E=0;for(;S>=n;--S){const A=t.charCodeAt(S);if(A===I){if(!c){o=S+1;break}continue}s===-1&&(c=!1,s=S+1),A===R?r===-1?r=S:E!==1&&(E=1):r!==-1&&(E=-1)}if(s!==-1){const A=o===0&&i?1:o;r===-1||E===0||E===1&&r===s-1&&r===o+1?a.base=a.name=t.slice(A,s):(a.name=t.slice(A,r),a.base=t.slice(A,s),a.ext=t.slice(r,s))}return o>0?a.dir=t.slice(0,o-1):i&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y?e.win32.normalize:e.posix.normalize,e.isAbsolute=y?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y?e.win32.join:e.posix.join,e.resolve=y?e.win32.resolve:e.posix.resolve,e.relative=y?e.win32.relative:e.posix.relative,e.dirname=y?e.win32.dirname:e.posix.dirname,e.basename=y?e.win32.basename:e.posix.basename,e.extname=y?e.win32.extname:e.posix.extname,e.format=y?e.win32.format:e.posix.format,e.parse=y?e.win32.parse:e.posix.parse,e.toNamespacedPath=y?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y?e.win32.sep:e.posix.sep,e.delimiter=y?e.win32.delimiter:e.posix.delimiter}),define(ne[144],se([0,1,13]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(P){const w=(0,k.extname)(P),g=L[w.toLowerCase()];return g!==void 0?g:T(P)}e.getMediaOrTextMime=D;function T(P){const w=(0,k.extname)(P);return l[w.toLowerCase()]}e.getMediaMime=T;function R(P){for(const w in l)if(l[w]===P)return w}e.getExtensionForMimeType=R;const I=/^(.+)\/(.+?)(;.+)?$/;function v(P,w){const g=I.exec(P);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:w?void 0:P}e.normalizeMimeType=v}),define(ne[87],se([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(L=e.Source||(e.Source={}));var l;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(R,...I){const v=I.reduce((g,h)=>(g[h]=!0,g),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(g=>!v[g]).forEach(g=>{for(let h=0;h<P.length;h++)if(g.search(P[h])!==-1){delete R[g];break}})}e.sanitizeProcessEnvironment=D;function T(R){!R||(delete R.DEBUG,k.isMacintosh&&delete R.DYLD_LIBRARY_PATH,k.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(ne[88],se([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=k.globals.performance&&typeof k.globals.performance.now=="function";class l{static create(T=!0){return new l(T)}constructor(T){this.a=L&&T,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?k.globals.performance.now():Date.now()}}e.StopWatch=l}),define(ne[3],se([0,1,8,81,2,83,88]),function(Z,e,k,L,l,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,I=!1;var v;(function(o){o.None=()=>l.Disposable.None;function s(z){if(I){const{onDidAddListener:V}=z,_=m.create();let H=0;z.onDidAddListener=()=>{++H===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),_.print()),V?.()}}}function c(z,V){return q(z,()=>{},0,void 0,!0,void 0,V)}o.defer=c;function S(z){return(V,_=null,H)=>{let X=!1,te;return te=z(le=>{if(!X)return te?te.dispose():X=!0,V.call(_,le)},null,H),X&&te.dispose(),te}}o.once=S;function E(z,V,_){return j((H,X=null,te)=>z(le=>H.call(X,V(le)),null,te),_)}o.map=E;function A(z,V,_){return j((H,X=null,te)=>z(le=>{V(le),H.call(X,le)},null,te),_)}o.forEach=A;function N(z,V,_){return j((H,X=null,te)=>z(le=>V(le)&&H.call(X,le),null,te),_)}o.filter=N;function M(z){return z}o.signal=M;function B(...z){return(V,_=null,H)=>(0,l.combinedDisposable)(...z.map(X=>X(te=>V.call(_,te),null,H)))}o.any=B;function O(z,V,_,H){let X=_;return E(z,te=>(X=V(X,te),X),H)}o.reduce=O;function j(z,V){let _;const H={onWillAddFirstListener(){_=z(X.fire,X)},onDidRemoveLastListener(){_?.dispose()}};V||s(H);const X=new f(H);return V?.add(X),X.event}function q(z,V,_=100,H=!1,X=!1,te,le){let he,me,pe,Se=0,Ce;const De={leakWarningThreshold:te,onWillAddFirstListener(){he=z(qe=>{Se++,me=V(me,qe),H&&!pe&&(ke.fire(me),me=void 0),Ce=()=>{const Ye=me;me=void 0,pe=void 0,(!H||Se>1)&&ke.fire(Ye),Se=0},typeof _=="number"?(clearTimeout(pe),pe=setTimeout(Ce,_)):pe===void 0&&(pe=0,queueMicrotask(Ce))})},onWillRemoveListener(){X&&Se>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,he.dispose()}};le||s(De);const ke=new f(De);return le?.add(ke),ke.event}o.debounce=q;function K(z,V=0,_){return o.debounce(z,(H,X)=>H?(H.push(X),H):[X],V,void 0,!0,void 0,_)}o.accumulate=K;function Q(z,V=(H,X)=>H===X,_){let H=!0,X;return N(z,te=>{const le=H||!V(te,X);return H=!1,X=te,le},_)}o.latch=Q;function re(z,V,_){return[o.filter(z,V,_),o.filter(z,H=>!V(H),_)]}o.split=re;function J(z,V=!1,_=[]){let H=_.slice(),X=z(he=>{H?H.push(he):le.fire(he)});const te=()=>{H?.forEach(he=>le.fire(he)),H=null},le=new f({onWillAddFirstListener(){X||(X=z(he=>le.fire(he)))},onDidAddFirstListener(){H&&(V?setTimeout(te):te())},onDidRemoveLastListener(){X&&X.dispose(),X=null}});return le.event}o.buffer=J;class W{constructor(V){this.event=V,this.c=new l.DisposableStore}map(V){return new W(E(this.event,V,this.c))}forEach(V){return new W(A(this.event,V,this.c))}filter(V){return new W(N(this.event,V,this.c))}reduce(V,_){return new W(O(this.event,V,_,this.c))}latch(){return new W(Q(this.event,void 0,this.c))}debounce(V,_=100,H=!1,X=!1,te){return new W(q(this.event,V,_,H,X,te,this.c))}on(V,_,H){return this.event(V,_,H)}once(V,_,H){return S(this.event)(V,_,H)}dispose(){this.c.dispose()}}function F(z){return new W(z)}o.chain=F;function G(z,V,_=H=>H){const H=(...he)=>le.fire(_(...he)),X=()=>z.on(V,H),te=()=>z.removeListener(V,H),le=new f({onWillAddFirstListener:X,onDidRemoveLastListener:te});return le.event}o.fromNodeEventEmitter=G;function ee(z,V,_=H=>H){const H=(...he)=>le.fire(_(...he)),X=()=>z.addEventListener(V,H),te=()=>z.removeEventListener(V,H),le=new f({onWillAddFirstListener:X,onDidRemoveLastListener:te});return le.event}o.fromDOMEventEmitter=ee;function oe(z){return new Promise(V=>S(z)(V))}o.toPromise=oe;function ae(z,V){return V(void 0),z(_=>V(_))}o.runAndSubscribe=ae;function x(z,V){let _=null;function H(te){_?.dispose(),_=new l.DisposableStore,V(te,_)}H(void 0);const X=z(te=>H(te));return(0,l.toDisposable)(()=>{X.dispose(),_?.dispose()})}o.runAndSubscribeWithStore=x;class ${constructor(V,_){this.obs=V,this.c=0,this.d=!1;const H={onWillAddFirstListener:()=>{V.addObserver(this)},onDidRemoveLastListener:()=>{V.removeObserver(this)}};_||s(H),this.emitter=new f(H),_&&_.add(this.emitter)}beginUpdate(V){this.c++}handleChange(V,_){this.d=!0}endUpdate(V){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function U(z,V){return new $(z,V).emitter.event}o.fromObservable=U})(v=e.Event||(e.Event={}));class P{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${P.c++}`,P.all.add(this)}start(s){this.d=new T.StopWatch(!0),this.listenerCount=s}stop(){if(this.d){const s=this.d.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this.d=void 0}}}P.all=new Set,P.c=0,e.EventProfiling=P;let w=-1;function g(o){const s=w;return w=o,{dispose(){w=s}}}e.setGlobalLeakWarningThreshold=g;class h{constructor(s,c=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=c,this.d=0}dispose(){this.c?.clear()}check(s,c){const S=this.threshold;if(S<=0||c<S)return;this.c||(this.c=new Map);const E=this.c.get(s.value)||0;if(this.c.set(s.value,E+1),this.d-=1,this.d<=0){this.d=S*.5;let A,N=0;for(const[M,B]of this.c)(!A||N<B)&&(A=M,N=B);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${N}):`),console.warn(A)}return()=>{const A=this.c.get(s.value)||0;this.c.set(s.value,A-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y{constructor(s,c,S){this.callback=s,this.callbackThis=c,this.stack=S,this.subscription=new l.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class f{constructor(s){this.j=!1,this.d=s,this.f=w>0||this.d?.leakWarningThreshold?new h(this.d?.leakWarningThreshold??w):void 0,this.g=this.d?._profName?new P(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(R){const s=Array.from(this.q);queueMicrotask(()=>{for(const c of s)c.subscription.isset()&&(c.subscription.unset(),c.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(s,c,S)=>{if(this.q||(this.q=new D.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const E=this.q.isEmpty();E&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let A,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=m.create(),A=this.f.check(N,this.q.size+1)),R&&(N=N??m.create());const M=new y(s,c,N),B=this.q.push(M);E&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,s,c);const O=M.subscription.set(()=>{A?.(),this.j||(this.d?.onWillRemoveListener?.(this),B(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return S instanceof l.DisposableStore?S.add(O):Array.isArray(S)&&S.push(O),O}),this.l}fire(s){if(this.q){this.m||(this.m=new d);for(const c of this.q)this.m.push(this,c,s);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=f;class u{constructor(){this.c=new D.LinkedList}get size(){return this.c.size}push(s,c,S){this.c.push(new p(s,c,S))}clear(s){const c=new D.LinkedList;for(const S of this.c)S.emitter!==s&&c.push(S);this.c=c}deliver(){for(;this.c.size>0;){const s=this.c.shift();try{s.listener.invoke(s.event)}catch(c){(0,k.onUnexpectedError)(c)}}}}e.EventDeliveryQueue=u;class d extends u{clear(s){this.c.clear()}}class p{constructor(s,c,S){this.emitter=s,this.listener=c,this.event=S}}class b extends f{async fireAsync(s,c,S){if(!!this.q){this.c||(this.c=new D.LinkedList);for(const E of this.q)this.c.push([E,s]);for(;this.c.size>0&&!c.isCancellationRequested;){const[E,A]=this.c.shift(),N=[],M={...A,token:c,waitUntil:B=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");S&&(B=S(B,E.callback)),N.push(B)}};try{E.invoke(M)}catch(B){(0,k.onUnexpectedError)(B);continue}Object.freeze(N),await Promise.allSettled(N).then(B=>{for(const O of B)O.status==="rejected"&&(0,k.onUnexpectedError)(O.reason)})}}}}e.AsyncEmitter=b;class C extends f{constructor(s){super(s),this.h=0,this.s=new D.LinkedList,this.t=s?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const s=Array.from(this.s);this.s.clear(),super.fire(this.t(s))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(s){this.q&&(this.h!==0?this.s.push(s):super.fire(s))}}e.PauseableEmitter=C;class t extends C{constructor(s){super(s),this.c=s.delay??100}fire(s){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(s)}}e.DebounceEmitter=t;class a extends f{constructor(s){super(s),this.c=[],this.h=s?.merge}fire(s){!this.hasListeners()||(this.c.push(s),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(c=>super.fire(c)),this.c=[]}))}}e.MicrotaskEmitter=a;class i{constructor(){this.d=!1,this.f=[],this.c=new f({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(s){const c={event:s,listener:null};this.f.push(c),this.d&&this.j(c);const S=()=>{this.d&&this.k(c);const E=this.f.indexOf(c);this.f.splice(E,1)};return(0,l.toDisposable)((0,L.once)(S))}g(){this.d=!0,this.f.forEach(s=>this.j(s))}h(){this.d=!1,this.f.forEach(s=>this.k(s))}j(s){s.listener=s.event(c=>this.c.fire(c))}k(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.c=[]}wrapEvent(s){return(c,S,E)=>s(A=>{const N=this.c[this.c.length-1];N?N.push(()=>c.call(S,A)):c.call(S,A)},void 0,E)}bufferEvents(s){const c=[];this.c.push(c);const S=s();return this.c.pop(),c.forEach(E=>E()),S}}e.EventBufferer=n;class r{constructor(){this.c=!1,this.d=v.None,this.f=l.Disposable.None,this.g=new f({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(s){this.d=s,this.c&&(this.f.dispose(),this.f=s(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=r}),define(ne[23],se([0,1,3]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(R,I){const v=setTimeout(R.bind(I),0);return{dispose(){clearTimeout(v)}}});var l;(function(R){function I(v){return v===R.None||v===R.Cancelled||v instanceof D?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}R.isCancellationToken=I,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(l=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new k.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(I){this.a=void 0,this.b=void 0,this.b=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new D),this.a}cancel(){this.a?this.a instanceof D&&this.a.cancel():this.a=l.Cancelled}dispose(I=!1){I&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof D&&this.a.dispose():this.a=l.None}}e.CancellationTokenSource=T}),define(ne[145],se([0,1,23]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new k.CancellationTokenSource,I=this.b(R.token);return this.a={promise:I,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.Cache=L;class l{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const I=JSON.stringify(R);return this.b!==I&&(this.b=I,this.a=this.c(R)),this.a}}e.LRUCachedFunction=l;class D{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const I=this.b(R);return this.a.set(R,I),I}}e.CachedFunction=D}),define(ne[26],se([0,1,145,130]),function(Z,e,k,L){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=D;const T=/{(\d+)}/g;function R(ie,...ue){return ue.length===0?ie:ie.replace(T,function(ge,we){const ve=parseInt(we,10);return isNaN(ve)||ve<0||ve>=ue.length?ge:ue[ve]})}e.format=R;const I=/{([^}]+)}/g;function v(ie,ue){return ie.replace(I,(ge,we)=>ue[we]??ge)}e.format2=v;function P(ie){return ie.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=P;function w(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function g(ie,ue){let ge=0;const we=ue.charCodeAt(0);for(let ve=ie.length-1;ve>=0;ve--)ie.charCodeAt(ve)===we&&ge++;return ge}e.count=g;function h(ie,ue,ge="\u2026"){return ie.length<=ue?ie:`${ie.substr(0,ue)}${ge}`}e.truncate=h;function m(ie,ue=" "){const ge=y(ie,ue);return f(ge,ue)}e.trim=m;function y(ie,ue){if(!ie||!ue)return ie;const ge=ue.length;if(ge===0||ie.length===0)return ie;let we=0;for(;ie.indexOf(ue,we)===we;)we=we+ge;return ie.substring(we)}e.ltrim=y;function f(ie,ue){if(!ie||!ue)return ie;const ge=ue.length,we=ie.length;if(ge===0||we===0)return ie;let ve=we,Ee=-1;for(;Ee=ie.lastIndexOf(ue,ve-1),!(Ee===-1||Ee+ge!==ve);){if(Ee===0)return"";ve=Ee}return ie.substring(0,ve)}e.rtrim=f;function u(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function d(ie){return ie.replace(/\*/g,"")}e.stripWildcards=d;function p(ie,ue,ge={}){if(!ie)throw new Error("Cannot create regex from empty string");ue||(ie=w(ie)),ge.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let we="";return ge.global&&(we+="g"),ge.matchCase||(we+="i"),ge.multiline&&(we+="m"),ge.unicode&&(we+="u"),new RegExp(ie,we)}e.createRegExp=p;function b(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function C(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=C;function t(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.regExpFlags=t;function a(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=a;function i(ie){for(let ue=0,ge=ie.length;ue<ge;ue++){const we=ie.charCodeAt(ue);if(we!==32&&we!==9)return ue}return-1}e.firstNonWhitespaceIndex=i;function n(ie,ue=0,ge=ie.length){for(let we=ue;we<ge;we++){const ve=ie.charCodeAt(we);if(ve!==32&&ve!==9)return ie.substring(ue,we)}return ie.substring(ue,ge)}e.getLeadingWhitespace=n;function r(ie,ue=ie.length-1){for(let ge=ue;ge>=0;ge--){const we=ie.charCodeAt(ge);if(we!==32&&we!==9)return ge}return-1}e.lastNonWhitespaceIndex=r;function o(ie,ue,ge){const we=[];let ve=0;for(const Ee of ie.matchAll(ue)){if(we.push(ie.slice(ve,Ee.index)),Ee.index===void 0)throw new Error("match.index should be defined");ve=Ee.index+Ee[0].length,we.push(ge(Ee[0],...Ee.slice(1),Ee.index,ie,Ee.groups))}return we.push(ie.slice(ve)),Promise.all(we).then(Ee=>Ee.join(""))}e.replaceAsync=o;function s(ie,ue){return ie<ue?-1:ie>ue?1:0}e.compare=s;function c(ie,ue,ge=0,we=ie.length,ve=0,Ee=ue.length){for(;ge<we&&ve<Ee;ge++,ve++){const Te=ie.charCodeAt(ge),Ue=ue.charCodeAt(ve);if(Te<Ue)return-1;if(Te>Ue)return 1}const Re=we-ge,Le=Ee-ve;return Re<Le?-1:Re>Le?1:0}e.compareSubstring=c;function S(ie,ue){return E(ie,ue,0,ie.length,0,ue.length)}e.compareIgnoreCase=S;function E(ie,ue,ge=0,we=ie.length,ve=0,Ee=ue.length){for(;ge<we&&ve<Ee;ge++,ve++){let Te=ie.charCodeAt(ge),Ue=ue.charCodeAt(ve);if(Te===Ue)continue;if(Te>=128||Ue>=128)return c(ie.toLowerCase(),ue.toLowerCase(),ge,we,ve,Ee);N(Te)&&(Te-=32),N(Ue)&&(Ue-=32);const $e=Te-Ue;if($e!==0)return $e}const Re=we-ge,Le=Ee-ve;return Re<Le?-1:Re>Le?1:0}e.compareSubstringIgnoreCase=E;function A(ie){return ie>=48&&ie<=57}e.isAsciiDigit=A;function N(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=N;function M(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=M;function B(ie,ue){return ie.length===ue.length&&E(ie,ue)===0}e.equalsIgnoreCase=B;function O(ie,ue){const ge=ue.length;return ue.length>ie.length?!1:E(ie,ue,0,ge)===0}e.startsWithIgnoreCase=O;function j(ie,ue){const ge=Math.min(ie.length,ue.length);let we;for(we=0;we<ge;we++)if(ie.charCodeAt(we)!==ue.charCodeAt(we))return we;return ge}e.commonPrefixLength=j;function q(ie,ue){const ge=Math.min(ie.length,ue.length);let we;const ve=ie.length-1,Ee=ue.length-1;for(we=0;we<ge;we++)if(ie.charCodeAt(ve-we)!==ue.charCodeAt(Ee-we))return we;return ge}e.commonSuffixLength=q;function K(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=K;function Q(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=Q;function re(ie,ue){return(ie-55296<<10)+(ue-56320)+65536}e.computeCodePoint=re;function J(ie,ue,ge){const we=ie.charCodeAt(ge);if(K(we)&&ge+1<ue){const ve=ie.charCodeAt(ge+1);if(Q(ve))return re(we,ve)}return we}e.getNextCodePoint=J;function W(ie,ue){const ge=ie.charCodeAt(ue-1);if(Q(ge)&&ue>1){const we=ie.charCodeAt(ue-2);if(K(we))return re(we,ge)}return ge}class F{get offset(){return this.e}constructor(ue,ge=0){this.c=ue,this.d=ue.length,this.e=ge}setOffset(ue){this.e=ue}prevCodePoint(){const ue=W(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=J(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.CodePointIterator=F;class G{get offset(){return this.c.offset}constructor(ue,ge=0){this.c=new F(ue,ge)}nextGraphemeLength(){const ue=Ie.getInstance(),ge=this.c,we=ge.offset;let ve=ue.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Ee=ge.offset,Re=ue.getGraphemeBreakType(ge.nextCodePoint());if(fe(ve,Re)){ge.setOffset(Ee);break}ve=Re}return ge.offset-we}prevGraphemeLength(){const ue=Ie.getInstance(),ge=this.c,we=ge.offset;let ve=ue.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Ee=ge.offset,Re=ue.getGraphemeBreakType(ge.prevCodePoint());if(fe(Re,ve)){ge.setOffset(Ee);break}ve=Re}return we-ge.offset}eol(){return this.c.eol()}}e.GraphemeIterator=G;function ee(ie,ue){return new G(ie,ue).nextGraphemeLength()}e.nextCharLength=ee;function oe(ie,ue){return new G(ie,ue).prevGraphemeLength()}e.prevCharLength=oe;function ae(ie,ue){ue>0&&Q(ie.charCodeAt(ue))&&ue--;const ge=ue+ee(ie,ue);return[ge-oe(ie,ge),ge]}e.getCharContainingOffset=ae;function x(ie){const ue=new G(ie);let ge=0;for(;!ue.eol();)ge++,ue.nextGraphemeLength();return ge}e.charCount=x;let $;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function z(ie){return $||($=U()),$.test(ie)}e.containsRTL=z;const V=/^[\t\n\r\x20-\x7E]*$/;function _(ie){return V.test(ie)}e.isBasicASCII=_,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=H;function X(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=X;function te(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=te;function le(ie,ue){if(ie.length<ue)return ie;const ge=/\b/g;let we=0;for(;ge.test(ie)&&!(ie.length-ge.lastIndex<ue);)we=ge.lastIndex,ge.lastIndex+=1;return ie.substring(we).replace(/^\s/,"")}e.lcut=le;const he=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function me(ie){return ie&&(ie=ie.replace(he,"")),ie}e.removeAnsiEscapeCodes=me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function pe(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=pe;function Se(ie){return pe(ie)?ie.substr(1):ie}e.stripUTF8BOM=Se;function Ce(ie,ue){if(!ie||!ue||ie.length<ue.length)return!1;const ge=ue.length,we=ie.toLowerCase();let ve=0,Ee=-1;for(;ve<ge;){const Re=we.indexOf(ue[ve],Ee+1);if(Re<0)return!1;Ee=Re,ve++}return!0}e.fuzzyContains=Ce;function De(ie,ue=!1){return ie?(ue&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=De;function ke(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=ke;function qe(ie,ue=1){if(ue===0)return"";let ge=-1;do ge=ie.indexOf(`
`,ge+1),ue--;while(ue>0&&ge>=0);return ge===-1?ie:(ie[ge-1]==="\r"&&ge--,ie.substr(0,ge))}e.getNLines=qe;function Ye(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.singleLetterHash=Ye;function ce(ie){return Ie.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=ce;function fe(ie,ue){return ie===0?ue!==5&&ue!==7:ie===2&&ue===3?!1:ie===4||ie===2||ie===3||ue===4||ue===2||ue===3?!0:!(ie===8&&(ue===8||ue===9||ue===11||ue===12)||(ie===11||ie===9)&&(ue===9||ue===10)||(ie===12||ie===10)&&ue===10||ue===5||ue===13||ue===7||ie===1||ie===13&&ue===14||ie===6&&ue===6)}var de;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(de=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Pe()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const ge=this.d,we=ge.length/3;let ve=1;for(;ve<=we;)if(ue<ge[3*ve])ve=2*ve;else if(ue>ge[3*ve+1])ve=2*ve+1;else return ge[3*ve+2];return 0}}Ie.c=null;function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(ie,ue){if(ie===0)return 0;const ge=Ae(ie,ue);if(ge!==void 0)return ge;const we=new F(ue,ie);return we.prevCodePoint(),we.offset}e.getLeftDeleteOffset=Fe;function Ae(ie,ue){const ge=new F(ue,ie);let we=ge.prevCodePoint();for(;je(we)||we===65039||we===8419;){if(ge.offset===0)return;we=ge.prevCodePoint()}if(!te(we))return;let ve=ge.offset;return ve>0&&ge.prevCodePoint()===8205&&(ve=ge.offset),ve}function je(ie){return 127995<=ie&&ie<=127999}var Me;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class Ne{static getInstance(ue){return Ne.d.get(Array.from(ue))}static getLocales(){return Ne.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}l=Ne,Ne.c=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ne.d=new k.LRUCachedFunction(ie=>{function ue(Ue){const $e=new Map;for(let ze=0;ze<Ue.length;ze+=2)$e.set(Ue[ze],Ue[ze+1]);return $e}function ge(Ue,$e){const ze=new Map(Ue);for(const[et,st]of $e)ze.set(et,st);return ze}function we(Ue,$e){if(!Ue)return $e;const ze=new Map;for(const[et,st]of Ue)$e.has(et)&&ze.set(et,st);return ze}const ve=l.c.value;let Ee=ie.filter(Ue=>!Ue.startsWith("_")&&Ue in ve);Ee.length===0&&(Ee=["_default"]);let Re;for(const Ue of Ee){const $e=ue(ve[Ue]);Re=we(Re,$e)}const Le=ue(ve._common),Te=ge(Le,Re);return new Ne(Te)}),Ne.e=new L.Lazy(()=>Object.keys(Ne.c.value).filter(ie=>!ie.startsWith("_"))),e.AmbiguousCharacters=Ne;class Be{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Be.c())),this.d}static isInvisibleCharacter(ue){return Be.e().has(ue)}static get codePoints(){return Be.e()}}Be.d=void 0,e.InvisibleCharacters=Be}),define(ne[48],se([0,1,13,4,26,12]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(r){return r===47||r===92}e.isPathSeparator=T;function R(r){return r.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=R;function I(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=I;function v(r,o=k.posix.sep){if(!r)return"";const s=r.length,c=r.charCodeAt(0);if(T(c)){if(T(r.charCodeAt(1))&&!T(r.charCodeAt(2))){let E=3;const A=E;for(;E<s&&!T(r.charCodeAt(E));E++);if(A!==E&&!T(r.charCodeAt(E+1))){for(E+=1;E<s;E++)if(T(r.charCodeAt(E)))return r.slice(0,E+1).replace(/[\\/]/g,o)}}return o}else if(u(c)&&r.charCodeAt(1)===58)return T(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let S=r.indexOf("://");if(S!==-1){for(S+=3;S<s;S++)if(T(r.charCodeAt(S)))return r.slice(0,S+1)}return""}e.getRoot=v;function P(r){if(!L.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let s=2;const c=s;for(;s<r.length&&(o=r.charCodeAt(s),o!==92);s++);return!(c===s||(o=r.charCodeAt(s+1),isNaN(o)||o===92))}e.isUNC=P;const w=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(r,o=L.isWindows){const s=o?w:g;return!(!r||r.length===0||/^\s+$/.test(r)||(s.lastIndex=0,s.test(r))||o&&h.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=m;function y(r,o,s){const c=r===o;return!s||c?c:!r||!o?!1:(0,l.equalsIgnoreCase)(r,o)}e.isEqual=y;function f(r,o,s,c=k.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(s){if(!(0,l.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let E=o.length;return o.charAt(o.length-1)===c&&E--,r.charAt(E)===c}return o.charAt(o.length-1)!==c&&(o+=c),r.indexOf(o)===0}e.isEqualOrParent=f;function u(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=u;function d(r,o){return L.isWindows&&r.endsWith(":")&&(r+=k.sep),(0,k.isAbsolute)(r)||(r=(0,k.join)(o,r)),r=(0,k.normalize)(r),L.isWindows?(r=(0,l.rtrim)(r,k.sep),r.endsWith(":")&&(r+=k.sep)):(r=(0,l.rtrim)(r,k.sep),r||(r=k.sep)),r}e.sanitizeFilePath=d;function p(r){const o=(0,k.normalize)(r);return L.isWindows?r.length>3?!1:b(o)&&(r.length===2||o.charCodeAt(2)===92):o===k.posix.sep}e.isRootOrDriveLetter=p;function b(r,o=L.isWindows){return o?u(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=b;function C(r){return b(r)?r[0]:void 0}e.getDriveLetter=C;function t(r,o,s){return o.length>r.length?-1:r===o?0:(s&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=t;function a(r){const o=r.split(":");let s,c,S;for(const E of o){const A=Number(E);(0,D.isNumber)(A)?c===void 0?c=A:S===void 0&&(S=A):s=s?[s,E].join(":"):E}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:c!==void 0?c:void 0,column:S!==void 0?S:c!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(r,o,s=8){let c="";for(let E=0;E<s;E++)c+=i.charAt(Math.floor(Math.random()*i.length));let S;return o?S=`${o}-${c}`:S=c,r?(0,k.join)(r,S):S}e.randomPath=n}),define(ne[65],se([0,1,26]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(u){return l(u,0)}e.hash=L;function l(u,d){switch(typeof u){case"object":return u===null?D(349,d):Array.isArray(u)?I(u,d):v(u,d);case"string":return R(u,d);case"boolean":return T(u,d);case"number":return D(u,d);case"undefined":return D(937,d);default:return D(617,d)}}e.doHash=l;function D(u,d){return(d<<5)-d+u|0}e.numberHash=D;function T(u,d){return D(u?433:863,d)}function R(u,d){d=D(149417,d);for(let p=0,b=u.length;p<b;p++)d=D(u.charCodeAt(p),d);return d}e.stringHash=R;function I(u,d){return d=D(104579,d),u.reduce((p,b)=>l(b,p),d)}function v(u,d){return d=D(181387,d),Object.keys(u).sort().reduce((p,b)=>(p=R(b,p),l(u[b],p)),d)}class P{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=l(d,this.g),this.g}}e.Hasher=P;var w;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function g(u,d,p=32){const b=p-d,C=~((1<<b)-1);return(u<<d|(C&u)>>>b)>>>0}function h(u,d=0,p=u.byteLength,b=0){for(let C=0;C<p;C++)u[d+C]=b}function m(u,d,p="0"){for(;u.length<d;)u=p+u;return u}function y(u,d=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(p=>p.toString(16).padStart(2,"0")).join(""):m((u>>>0).toString(16),d/4)}e.toHexString=y;class f{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const p=d.length;if(p===0)return;const b=this.p;let C=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=d.charCodeAt(0),i=0);;){let n=a;if(k.isHighSurrogate(a))if(i+1<p){const r=d.charCodeAt(i+1);k.isLowSurrogate(r)?(i++,n=k.computeCodePoint(a,r)):n=65533}else{t=a;break}else k.isLowSurrogate(a)&&(n=65533);if(C=this.w(b,C,n),i++,i<p)a=d.charCodeAt(i);else break}this.r=C,this.u=t}w(d,p,b){return b<128?d[p++]=b:b<2048?(d[p++]=192|(b&1984)>>>6,d[p++]=128|(b&63)>>>0):b<65536?(d[p++]=224|(b&61440)>>>12,d[p++]=128|(b&4032)>>>6,d[p++]=128|(b&63)>>>0):(d[p++]=240|(b&1835008)>>>18,d[p++]=128|(b&258048)>>>12,d[p++]=128|(b&4032)>>>6,d[p++]=128|(b&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=f.g,p=this.q;for(let s=0;s<64;s+=4)d.setUint32(s,p.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)d.setUint32(s,g(d.getUint32(s-12,!1)^d.getUint32(s-32,!1)^d.getUint32(s-56,!1)^d.getUint32(s-64,!1),1),!1);let b=this.h,C=this.l,t=this.m,a=this.n,i=this.o,n,r,o;for(let s=0;s<80;s++)s<20?(n=C&t|~C&a,r=1518500249):s<40?(n=C^t^a,r=1859775393):s<60?(n=C&t|C&a|t&a,r=2400959708):(n=C^t^a,r=3395469782),o=g(b,5)+n+i+r+d.getUint32(s*4,!1)&4294967295,i=a,a=t,t=g(C,30),C=b,b=o;this.h=this.h+b&4294967295,this.l=this.l+C&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}f.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=f}),define(ne[89],se([0,1,26]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(L||(L={})),function(l){const D="error",T="warning",R="warn",I="info",v="ignore";function P(g){return g?k.equalsIgnoreCase(D,g)?l.Error:k.equalsIgnoreCase(T,g)||k.equalsIgnoreCase(R,g)?l.Warning:k.equalsIgnoreCase(I,g)?l.Info:l.Ignore:l.Ignore}l.fromValue=P;function w(g){switch(g){case l.Error:return D;case l.Warning:return T;case l.Info:return I;default:return v}}l.toString=w}(L||(L={})),e.default=L}),define(ne[49],se([0,1,18,26]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const m=h.charCodeAt(0),y=this.b.charCodeAt(this.c);return m-y}value(){return this.b[this.c]}}e.StringIterator=l;class D{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,L.compareSubstring)(h,this.b,0,h.length,this.c,this.d):(0,L.compareSubstringIgnoreCase)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=D;class T{constructor(h=!0,m=!0){this.f=h,this.g=m}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let m=h.length-1;m>=0;m--,this.c--){const y=this.b.charCodeAt(m);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,L.compareSubstring)(h,this.b,0,h.length,this.d,this.e):(0,L.compareSubstringIgnoreCase)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=T;var R;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(R||(R={}));class I{constructor(h,m){this.f=h,this.g=m,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new T(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,L.compareIgnoreCase)(h,this.c.scheme);if(this.d[this.e]===2)return(0,L.compareIgnoreCase)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,L.compare)(h,this.c.query);if(this.d[this.e]===5)return(0,L.compare)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=I;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(P||(P={}));class w{static forUris(h=()=>!1,m=()=>!1){return new w(new I(h,m))}static forPaths(h=!1){return new w(new T(void 0,!h))}static forStrings(){return new w(new l)}static forConfigKeys(){return new w(new D)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,m){if(m){const y=m.slice(0);(0,k.shuffle)(y);for(const f of y)this.set(f,h)}else{const y=h.slice(0);(0,k.shuffle)(y);for(const f of y)this.set(f[0],f[1])}}set(h,m){const y=this.b.reset(h);let f;this.c||(this.c=new v,this.c.segment=y.value());const u=[];for(f=this.c;;){const p=y.cmp(f.segment);if(p>0)f.left||(f.left=new v,f.left.segment=y.value()),u.push([-1,f]),f=f.left;else if(p<0)f.right||(f.right=new v,f.right.segment=y.value()),u.push([1,f]),f=f.right;else if(y.hasNext())y.next(),f.mid||(f.mid=new v,f.mid.segment=y.value()),u.push([0,f]),f=f.mid;else break}const d=f.value;f.value=m,f.key=h;for(let p=u.length-1;p>=0;p--){const b=u[p][1];b.updateHeight();const C=b.balanceFactor();if(C<-1||C>1){const t=u[p][0],a=u[p+1][0];if(t===1&&a===1)u[p][1]=b.rotateLeft();else if(t===-1&&a===-1)u[p][1]=b.rotateRight();else if(t===1&&a===-1)b.right=u[p+1][1]=u[p+1][1].rotateRight(),u[p][1]=b.rotateLeft();else if(t===-1&&a===1)b.left=u[p+1][1]=u[p+1][1].rotateLeft(),u[p][1]=b.rotateRight();else throw new Error;if(p>0)switch(u[p-1][0]){case-1:u[p-1][1].left=u[p][1];break;case 1:u[p-1][1].right=u[p][1];break;case 0:u[p-1][1].mid=u[p][1];break}else this.c=u[0][1]}}return d}get(h){return this.d(h)?.value}d(h){const m=this.b.reset(h);let y=this.c;for(;y;){const f=m.cmp(y.segment);if(f>0)y=y.left;else if(f<0)y=y.right;else if(m.hasNext())m.next(),y=y.mid;else break}return y}has(h){const m=this.d(h);return!(m?.value===void 0&&m?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,m){const y=this.b.reset(h),f=[];let u=this.c;for(;u;){const d=y.cmp(u.segment);if(d>0)f.push([-1,u]),u=u.left;else if(d<0)f.push([1,u]),u=u.right;else if(y.hasNext())y.next(),f.push([0,u]),u=u.mid;else break}if(!!u){if(m?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const d=this.f(u.right);if(d.key){const{key:p,value:b,segment:C}=d;this.e(d.key,!1),u.key=p,u.value=b,u.segment=C}}else{const d=u.left??u.right;if(f.length>0){const[p,b]=f[f.length-1];switch(p){case-1:b.left=d;break;case 0:b.mid=d;break;case 1:b.right=d;break}}else this.c=d}for(let d=f.length-1;d>=0;d--){const p=f[d][1];p.updateHeight();const b=p.balanceFactor();if(b>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),f[d][1]=p.rotateLeft()):b<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),f[d][1]=p.rotateRight()),d>0)switch(f[d-1][0]){case-1:f[d-1][1].left=f[d][1];break;case 1:f[d-1][1].right=f[d][1];break;case 0:f[d-1][1].mid=f[d][1];break}else this.c=f[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const m=this.b.reset(h);let y=this.c,f;for(;y;){const u=m.cmp(y.segment);if(u>0)y=y.left;else if(u<0)y=y.right;else if(m.hasNext())m.next(),f=y.value||f,y=y.mid;else break}return y&&y.value||f}findSuperstr(h){return this.g(h,!1)}g(h,m){const y=this.b.reset(h);let f=this.c;for(;f;){const u=y.cmp(f.segment);if(u>0)f=f.left;else if(u<0)f=f.right;else if(y.hasNext())y.next(),f=f.mid;else return f.mid?this.h(f.mid):m?f.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[m,y]of this)h(y,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const m=[];return this.j(h,m),m[Symbol.iterator]()}j(h,m){!h||(h.left&&this.j(h.left,m),h.value&&m.push([h.key,h.value]),h.mid&&this.j(h.mid,m),h.right&&this.j(h.right,m))}_isBalanced(){const h=m=>{if(!m)return!0;const y=m.balanceFactor();return y<-1||y>1?!1:h(m.left)&&h(m.right)};return h(this.c)}}e.TernarySearchTree=w}),define(ne[10],se([0,1,13,4]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,D=/^\//,T=/^\/\//;function R(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!l.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!D.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(i,n){return!i&&!n?"file":i}function v(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==w&&(n=w+n):n=w;break}return n}const P="",w="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(n){return n instanceof h?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,r,o,s,c,S=!1){typeof n=="object"?(this.scheme=n.scheme||P,this.authority=n.authority||P,this.path=n.path||P,this.query=n.query||P,this.fragment=n.fragment||P):(this.scheme=I(n,S),this.authority=r||P,this.path=v(this.scheme,o||P),this.query=s||P,this.fragment=c||P,R(this,S))}get fsPath(){return p(this,!1)}with(n){if(!n)return this;let{scheme:r,authority:o,path:s,query:c,fragment:S}=n;return r===void 0?r=this.scheme:r===null&&(r=P),o===void 0?o=this.authority:o===null&&(o=P),s===void 0?s=this.path:s===null&&(s=P),c===void 0?c=this.query:c===null&&(c=P),S===void 0?S=this.fragment:S===null&&(S=P),r===this.scheme&&o===this.authority&&s===this.path&&c===this.query&&S===this.fragment?this:new y(r,o,s,c,S)}static parse(n,r=!1){const o=g.exec(n);return o?new y(o[2]||P,a(o[4]||P),a(o[5]||P),a(o[7]||P),a(o[9]||P),r):new y(P,P,P,P,P)}static file(n){let r=P;if(L.isWindows&&(n=n.replace(/\\/g,w)),n[0]===w&&n[1]===w){const o=n.indexOf(w,2);o===-1?(r=n.substring(2),n=w):(r=n.substring(2,o),n=n.substring(o)||w)}return new y("file",r,n,P,P)}static from(n){const r=new y(n.scheme,n.authority,n.path,n.query,n.fragment);return R(r,!0),r}static joinPath(n,...r){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return L.isWindows&&n.scheme==="file"?o=h.file(k.win32.join(p(n,!0),...r)).path:o=k.posix.join(n.path,...r),n.with({path:o})}toString(n=!1){return b(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof h)return n;{const r=new y(n);return r._formatted=n.external,r._fsPath=n._sep===m?n.fsPath:null,r}}else return n}}e.URI=h;const m=L.isWindows?1:void 0;class y extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(n=!1){return n?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=m),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,n,r){let o,s=-1;for(let c=0;c<i.length;c++){const S=i.charCodeAt(c);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||n&&S===47||r&&S===91||r&&S===93||r&&S===58)s!==-1&&(o+=encodeURIComponent(i.substring(s,c)),s=-1),o!==void 0&&(o+=i.charAt(c));else{o===void 0&&(o=i.substr(0,c));const E=f[S];E!==void 0?(s!==-1&&(o+=encodeURIComponent(i.substring(s,c)),s=-1),o+=E):s===-1&&(s=c)}}return s!==-1&&(o+=encodeURIComponent(i.substring(s))),o!==void 0?o:i}function d(i){let n;for(let r=0;r<i.length;r++){const o=i.charCodeAt(r);o===35||o===63?(n===void 0&&(n=i.substr(0,r)),n+=f[o]):n!==void 0&&(n+=i[r])}return n!==void 0?n:i}function p(i,n){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,L.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=p;function b(i,n){const r=n?d:u;let o="",{scheme:s,authority:c,path:S,query:E,fragment:A}=i;if(s&&(o+=s,o+=":"),(c||s==="file")&&(o+=w,o+=w),c){let N=c.indexOf("@");if(N!==-1){const M=c.substr(0,N);c=c.substr(N+1),N=M.lastIndexOf(":"),N===-1?o+=r(M,!1,!1):(o+=r(M.substr(0,N),!1,!1),o+=":",o+=r(M.substr(N+1),!1,!0)),o+="@"}c=c.toLowerCase(),N=c.lastIndexOf(":"),N===-1?o+=r(c,!1,!0):(o+=r(c.substr(0,N),!1,!0),o+=c.substr(N))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const N=S.charCodeAt(1);N>=65&&N<=90&&(S=`/${String.fromCharCode(N+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const N=S.charCodeAt(0);N>=65&&N<=90&&(S=`${String.fromCharCode(N+32)}:${S.substr(2)}`)}o+=r(S,!0,!1)}return E&&(o+="?",o+=r(E,!1,!1)),A&&(o+="#",o+=n?A:u(A,!1,!1)),o}function C(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+C(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(t)?i.replace(t,n=>C(n)):i}}),define(ne[146],se([0,1,10]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(v){const P=v;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=L;function l(v){const P=[];let w;try{const g=JSON.parse(v.arguments),h=g[g.length-1];h&&h.__$stack&&(g.pop(),w=h.__$stack),P.push(...g)}catch{P.push("Unable to log remote console arguments",v.arguments)}return{args:P,stack:w}}e.parse=l;function D(v){if(typeof v!="string")return D(l(v).stack);const P=v;if(P){const w=T(P),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(g&&g.length===4)return{uri:k.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=D;function T(v){if(!v)return v;const P=v.indexOf(`
`);return P===-1?v:v.substring(0,P)}function R(v,P){const{args:w,stack:g}=l(v),h=typeof w[0]=="string"&&w.length===1;let m=T(g);m&&(m=`(${m.trim()})`);let y=[];if(typeof w[0]=="string"?m&&h?y=[`%c[${P}] %c${w[0]} %c${m}`,I("blue"),I(""),I("grey")]:y=[`%c[${P}] %c${w[0]}`,I("blue"),I(""),...w.slice(1)]:y=[`%c[${P}]%`,I("blue"),...w],m&&!h&&y.push(m),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,y)}e.log=R;function I(v){return`color: ${v}`}}),define(ne[90],se([0,1,17,26,10]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(v){return JSON.stringify(v,R)}e.stringify=D;function T(v){let P=JSON.parse(v);return P=I(P),P}e.parse=T;function R(v,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,L.regExpFlags)(P)}:P}function I(v,P=0){if(!v||P>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return l.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 16:return new Date(v.source)}if(v instanceof k.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let w=0;w<v.length;++w)v[w]=I(v[w],P+1);else for(const w in v)Object.hasOwnProperty.call(v,w)&&(v[w]=I(v[w],P+1))}return v}e.revive=I}),define(ne[21],se([0,1,8,4,10]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractive="vscode-interactive",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${D.vscodeRemoteResource}`}set(P,w,g){this.a[P]=w,this.b[P]=g}setConnectionToken(P,w){this.c[P]=w}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(f){return k.onUnexpectedError(f),P}const w=P.authority;let g=this.a[w];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const h=this.b[w],m=this.c[w];let y=`path=${encodeURIComponent(P.path)}`;return typeof m=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),l.URI.from({scheme:L.isWeb?this.d:D.vscodeRemoteResource,authority:`${g}:${h}`,path:this.f,query:y})}}e.RemoteAuthorities=new T,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(P){const w=this.b(P,Z);return this.uriToBrowserUri(w)}uriToBrowserUri(P){return P.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===D.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${D.vscodeFileResource}://${R.a}`)?P.with({scheme:D.vscodeFileResource,authority:P.authority||R.a,query:null,fragment:null}):P}asFileUri(P){const w=this.b(P,Z);return this.uriToFileUri(w)}uriToFileUri(P){return P.scheme===D.vscodeFileResource?P.with({scheme:D.file,authority:P.authority!==R.a?P.authority:null,query:null,fragment:null}):P}b(P,w){return l.URI.isUri(P)?P:l.URI.parse(w.toUrl(P))}}R.a="vscode-app",e.FileAccess=new R;var I;(function(v){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(P.get("3"));const w="vscode-coi";function g(m){let y;typeof m=="string"?y=new URL(m).searchParams:m instanceof URL?y=m.searchParams:l.URI.isUri(m)&&(y=new URL(m.toString(!0)).searchParams);const f=y?.get(w);if(!!f)return P.get(f)}v.getHeadersFromQuery=g;function h(m,y,f){if(!globalThis.crossOriginIsolated)return;const u=y&&f?"3":f?"2":"1";m instanceof URLSearchParams?m.set(w,u):m[w]=u}v.addSearchParam=h})(I=e.COI||(e.COI={}))}),define(ne[24],se([0,1,48,21,13,4,26,10]),function(Z,e,k,L,l,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(h){return(0,R.uriToFsPath)(h,!0)}e.originalFSPath=I;class v{constructor(m){this.a=m}compare(m,y,f=!1){return m===y?0:(0,T.compare)(this.getComparisonKey(m,f),this.getComparisonKey(y,f))}isEqual(m,y,f=!1){return m===y?!0:!m||!y?!1:this.getComparisonKey(m,f)===this.getComparisonKey(y,f)}getComparisonKey(m,y=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,y,f=!1){if(m.scheme===y.scheme){if(m.scheme===L.Schemas.file)return k.isEqualOrParent(I(m),I(y),this.a(m))&&m.query===y.query&&(f||m.fragment===y.fragment);if((0,e.isEqualAuthority)(m.authority,y.authority))return k.isEqualOrParent(m.path,y.path,this.a(m),"/")&&m.query===y.query&&(f||m.fragment===y.fragment)}return!1}joinPath(m,...y){return R.URI.joinPath(m,...y)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return l.posix.basename(m.path)}extname(m){return l.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let y;return m.scheme===L.Schemas.file?y=R.URI.file(l.dirname(I(m))).path:(y=l.posix.dirname(m.path),m.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),y="/")),m.with({path:y})}normalizePath(m){if(!m.path.length)return m;let y;return m.scheme===L.Schemas.file?y=R.URI.file(l.normalize(I(m))).path:y=l.posix.normalize(m.path),m.with({path:y})}relativePath(m,y){if(m.scheme!==y.scheme||!(0,e.isEqualAuthority)(m.authority,y.authority))return;if(m.scheme===L.Schemas.file){const d=l.relative(I(m),I(y));return D.isWindows?k.toSlashes(d):d}let f=m.path||"/";const u=y.path||"/";if(this.a(m)){let d=0;for(const p=Math.min(f.length,u.length);d<p&&!(f.charCodeAt(d)!==u.charCodeAt(d)&&f.charAt(d).toLowerCase()!==u.charAt(d).toLowerCase());d++);f=u.substr(0,d)+f.substr(d)}return l.posix.relative(f,u)}resolvePath(m,y){if(m.scheme===L.Schemas.file){const f=R.URI.file(l.resolve(I(m),y));return m.with({authority:f.authority,path:f.path})}return y=k.toPosixPath(y),m.with({path:l.posix.resolve(m.path,y)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,y){return m===y||m!==void 0&&y!==void 0&&(0,T.equalsIgnoreCase)(m,y)}hasTrailingPathSeparator(m,y=l.sep){if(m.scheme===L.Schemas.file){const f=I(m);return f.length>k.getRoot(f).length&&f[f.length-1]===y}else{const f=m.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,y=l.sep){return(0,e.hasTrailingPathSeparator)(m,y)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,y=l.sep){let f=!1;if(m.scheme===L.Schemas.file){const u=I(m);f=u!==void 0&&u.length===k.getRoot(u).length&&u[u.length-1]===y}else{y="/";const u=m.path;f=u.length===1&&u.charCodeAt(u.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(m,y)?m.with({path:m.path+"/"}):m}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(h=>h.scheme===L.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new v(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(h,m){const y=[];for(let f=0;f<h.length;f++){const u=m(h[f]);h.some((d,p)=>p===f?!1:(0,e.isEqualOrParent)(u,m(d)))||y.push(h[f])}return y}e.distinctParents=P;var w;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function m(y){const f=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(p=>{const[b,C]=p.split(":");b&&C&&f.set(b,C)});const d=y.path.substring(0,y.path.indexOf(";"));return d&&f.set(h.META_DATA_MIME,d),f}h.parseMetaData=m})(w=e.DataUri||(e.DataUri={}));function g(h,m,y){if(m){let f=h.path;return f&&f[0]!==l.posix.sep&&(f=l.posix.sep+f),h.with({scheme:y,authority:m,path:f})}return h.with({scheme:y})}e.toLocalResource=g}),define(ne[6],se([0,1,23,8,3,2,24,4,133]),function(Z,e,k,L,l,D,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(x){return!!x&&typeof x.then=="function"}e.isThenable=v;function P(x){const $=new k.CancellationTokenSource,U=x($.token),z=new Promise((V,_)=>{const H=$.token.onCancellationRequested(()=>{H.dispose(),$.dispose(),_(new L.CancellationError)});Promise.resolve(U).then(X=>{H.dispose(),$.dispose(),V(X)},X=>{H.dispose(),$.dispose(),_(X)})});return new class{cancel(){$.cancel()}then(V,_){return z.then(V,_)}catch(V){return this.then(void 0,V)}finally(V){return z.finally(V)}}}e.createCancelablePromise=P;function w(x,$,U){return new Promise((z,V)=>{const _=$.onCancellationRequested(()=>{_.dispose(),z(U)});x.then(z,V).finally(()=>_.dispose())})}e.raceCancellation=w;function g(x,$){return new Promise((U,z)=>{const V=$.onCancellationRequested(()=>{V.dispose(),z(new L.CancellationError)});x.then(U,z).finally(()=>V.dispose())})}e.raceCancellationError=g;async function h(x){let $=-1;const U=x.map((V,_)=>V.then(H=>($=_,H))),z=await Promise.race(U);return x.forEach((V,_)=>{_!==$&&V.cancel()}),z}e.raceCancellablePromises=h;function m(x,$,U){let z;const V=setTimeout(()=>{z?.(void 0),U?.()},$);return Promise.race([x.finally(()=>clearTimeout(V)),new Promise(_=>z=_)])}e.raceTimeout=m;function y(x){return new Promise(($,U)=>{const z=x();v(z)?z.then($,U):$(z)})}e.asPromise=y;class f{constructor(){this.a=null,this.b=null,this.d=null}queue($){if(this.a){if(this.d=$,!this.b){const U=()=>{this.b=null;const z=this.queue(this.d);return this.d=null,z};this.b=new Promise(z=>{this.a.then(U,U).then(z)})}return new Promise((U,z)=>{this.b.then(U,z)})}return this.a=$(),new Promise((U,z)=>{this.a.then(V=>{this.a=null,U(V)},V=>{this.a=null,z(V)})})}}e.Throttler=f;class u{constructor(){this.a=Promise.resolve(null)}queue($){return this.a=this.a.then(()=>$(),()=>$())}}e.Sequencer=u;class d{constructor(){this.a=new Map}queue($,U){const V=(this.a.get($)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get($)===V&&this.a.delete($)});return this.a.set($,V),V}}e.SequencerByKey=d;const p=(x,$)=>{let U=!0;const z=setTimeout(()=>{U=!1,$()},x);return{isTriggered:()=>U,dispose:()=>{clearTimeout(z),U=!1}}},b=x=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,x())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};class C{constructor($){this.defaultDelay=$,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger($,U=this.defaultDelay){this.g=$,this.h(),this.b||(this.b=new Promise((V,_)=>{this.d=V,this.f=_}).then(()=>{if(this.b=null,this.d=null,this.g){const V=this.g;return this.g=null,V()}}));const z=()=>{this.a=null,this.d?.(null)};return this.a=U===I.MicrotaskDelay?b(z):p(U,z),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=C;class t{constructor($){this.a=new C($),this.b=new f}trigger($,U){return this.a.trigger(()=>this.b.queue($),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class a{constructor(){this.a=!1,this.b=new Promise(($,U)=>{this.d=$})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=a;class i extends a{constructor($){super(),this.f=setTimeout(()=>this.open(),$)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function n(x,$){return $?new Promise((U,z)=>{const V=setTimeout(()=>{_.dispose(),U()},x),_=$.onCancellationRequested(()=>{clearTimeout(V),_.dispose(),z(new L.CancellationError)})}):P(U=>n(x,U))}e.timeout=n;function r(x,$=0){const U=setTimeout(x,$);return(0,D.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=r;function o(x){const $=[];let U=0;const z=x.length;function V(){return U<z?x[U++]():null}function _(H){H!=null&&$.push(H);const X=V();return X?X.then(_):Promise.resolve($)}return Promise.resolve(null).then(_)}e.sequence=o;function s(x,$=z=>!!z,U=null){let z=0;const V=x.length,_=()=>{if(z>=V)return Promise.resolve(U);const H=x[z++];return Promise.resolve(H()).then(te=>$(te)?Promise.resolve(te):_())};return _()}e.first=s;function c(x,$=z=>!!z,U=null){if(x.length===0)return Promise.resolve(U);let z=x.length;const V=()=>{z=-1;for(const _ of x)_.cancel?.()};return new Promise((_,H)=>{for(const X of x)X.then(te=>{--z>=0&&$(te)?(V(),_(te)):z===0&&_(U)}).catch(te=>{--z>=0&&(V(),H(te))})})}e.firstParallel=c;class S{constructor($){this.a=0,this.d=$,this.f=[],this.b=0,this.g=new l.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue($){return this.a++,new Promise((U,z)=>{this.f.push({factory:$,c:U,e:z}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const $=this.f.shift();this.b++;const U=$.factory();U.then($.c,$.e),U.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=S;class E extends S{constructor(){super(1)}}e.Queue=E;class A{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const $=new W;return this.b.add($),$.p}d(){for(const[,$]of this.a)if($.size>0)return!1;return!0}queueFor($,U=T.extUri){const z=U.getComparisonKey($);let V=this.a.get(z);return V||(V=new E,l.Event.once(V.onDrained)(()=>{V?.dispose(),this.a.delete(z),this.f()}),this.a.set(z,V)),V}f(){!this.d()||this.g()}g(){for(const $ of this.b)$.complete();this.b.clear()}dispose(){for(const[,$]of this.a)$.dispose();this.a.clear(),this.g()}}e.ResourceQueue=A;class N{constructor($,U){this.a=-1,typeof $=="function"&&typeof U=="number"&&this.setIfNotSet($,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet($,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,$()},U)}setIfNotSet($,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,$()},U))}}e.TimeoutTimer=N;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet($,U){this.cancel(),this.a=setInterval(()=>{$()},U)}}e.IntervalTimer=M;class B{constructor($,U){this.b=-1,this.a=$,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule($=this.d){this.cancel(),this.b=setTimeout(this.f,$)}get delay(){return this.d}set delay($){this.d=$}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=B;class O{constructor($,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=$,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule($=this.b){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil($/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=O;class j extends B{constructor($,U){super($,U),this.j=[]}work($){this.j.push($),this.isScheduled()||this.schedule()}h(){const $=this.j;this.j=[],this.a?.($)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=j;class q extends D.Disposable{constructor($,U){super(),this.g=$,this.h=U,this.a=[],this.b=this.B(new D.MutableDisposable),this.f=!1}get pending(){return this.a.length}work($){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+$.length>this.g.maxBufferedWork)return!1}else if(this.pending+$.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const U of $)this.a.push(U);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new B(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,R.setTimeout0)(()=>{if($)return;const U=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let $=!1;return{dispose(){$||($=!0)}}}:e.runWhenIdle=(x,$)=>{const U=requestIdleCallback(x,typeof $=="number"?{timeout:$}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(U))}}}}();class K{constructor($){this.d=!1,this.a=()=>{try{this.f=$()}catch(U){this.g=U}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=K;async function Q(x,$,U){let z;for(let V=0;V<U;V++)try{return await x()}catch(_){z=_,await n($)}throw z}e.retry=Q;class re{hasPending($){return this.a?typeof $=="number"?this.a.taskId===$:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending($,U,z){return this.a={taskId:$,cancel:()=>z?.(),promise:U},U.then(()=>this.d($),()=>this.d($)),U}d($){this.a&&$===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const $=this.b;this.b=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this.b)this.b.run=$;else{let U,z;const V=new Promise((_,H)=>{U=_,z=H});this.b={run:$,promise:V,promiseResolve:U,promiseReject:z}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=re;class J{constructor($,U=()=>Date.now()){this.d=$,this.f=U,this.a=0,this.b=0}increment(){const $=this.f();return $-this.a>this.d&&(this.a=$,this.b=0),this.b++,this.b}}e.IntervalCounter=J;class W{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise(($,U)=>{this.a=$,this.b=U})}complete($){return new Promise(U=>{this.a($),this.f=!0,U()})}error($){return new Promise(U=>{this.b($),this.d=!0,U()})}cancel(){new Promise($=>{this.b(new L.CancellationError),this.d=!0,$()})}}e.DeferredPromise=W;var F;(function(x){async function $(z){let V;const _=await Promise.all(z.map(H=>H.then(X=>X,X=>{V||(V=X)})));if(typeof V<"u")throw V;return _}x.settled=$;function U(z){return new Promise(async(V,_)=>{try{await z(V,_)}catch(H){_(H)}})}x.withAsyncBody=U})(F=e.Promises||(e.Promises={}));var G;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(G||(G={}));class ee{static fromArray($){return new ee(U=>{U.emitMany($)})}static fromPromise($){return new ee(async U=>{U.emitMany(await $)})}static fromPromises($){return new ee(async U=>{await Promise.all($.map(async z=>U.emitOne(await z)))})}static merge($){return new ee(async U=>{await Promise.all($.map(async z=>{for await(const V of z)U.emitOne(V)}))})}constructor($){this.a=0,this.b=[],this.d=null,this.f=new l.Emitter,queueMicrotask(async()=>{const U={emitOne:z=>this.g(z),emitMany:z=>this.h(z),reject:z=>this.k(z)};try{await Promise.resolve($(U)),this.j()}catch(z){this.k(z)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this.a===2)throw this.d;if($<this.b.length)return{done:!1,value:this.b[$++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map($,U){return new ee(async z=>{for await(const V of $)z.emitOne(U(V))})}map($){return ee.map(this,$)}static filter($,U){return new ee(async z=>{for await(const V of $)U(V)&&z.emitOne(V)})}filter($){return ee.filter(this,$)}static coalesce($){return ee.filter($,U=>!!U)}coalesce(){return ee.coalesce(this)}static async toPromise($){const U=[];for await(const z of $)U.push(z);return U}toPromise(){return ee.toPromise(this)}g($){this.a===0&&(this.b.push($),this.f.fire())}h($){this.a===0&&(this.b=this.b.concat($),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k($){this.a===0&&(this.a=2,this.d=$,this.f.fire())}}ee.EMPTY=ee.fromArray([]),e.AsyncIterableObject=ee;class oe extends ee{constructor($,U){super(U),this.l=$}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=oe;function ae(x){const $=new k.CancellationTokenSource,U=x($.token);return new oe($,async z=>{const V=$.token.onCancellationRequested(()=>{V.dispose(),$.dispose(),z.reject(new L.CancellationError)});try{for await(const _ of U){if($.token.isCancellationRequested)return;z.emitOne(_)}V.dispose(),$.dispose()}catch(_){V.dispose(),$.dispose(),z.reject(_)}})}e.createCancelableAsyncIterable=ae}),define(ne[91],se([0,1,18,6,48,38,13,4,26]),function(Z,e,k,L,l,D,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function v(){return Object.create(null)}e.getEmptyExpression=v,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",w="[^/\\\\]",g=/\//g;function h(J,W){switch(J){case 0:return"";case 1:return`${w}*?`;default:return`(?:${P}|${w}+${P}${W?`|${P}${w}+`:""})*?`}}function m(J,W){if(!J)return[];const F=[];let G=!1,ee=!1,oe="";for(const ae of J){switch(ae){case W:if(!G&&!ee){F.push(oe),oe="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}oe+=ae}return oe&&F.push(oe),F}e.splitGlobAware=m;function y(J){if(!J)return"";let W="";const F=m(J,e.GLOB_SPLIT);if(F.every(G=>G===e.GLOBSTAR))W=".*";else{let G=!1;F.forEach((ee,oe)=>{if(ee===e.GLOBSTAR){if(G)return;W+=h(2,oe===F.length-1)}else{let ae=!1,x="",$=!1,U="";for(const z of ee){if(z!=="}"&&ae){x+=z;continue}if($&&(z!=="]"||!U)){let V;z==="-"?V=z:(z==="^"||z==="!")&&!U?V="^":z===e.GLOB_SPLIT?V="":V=(0,I.escapeRegExpCharacters)(z),U+=V;continue}switch(z){case"{":ae=!0;continue;case"[":$=!0;continue;case"}":{W+=`(?:${m(x,",").map(H=>y(H)).join("|")})`,ae=!1,x="";break}case"]":{W+="["+U+"]",$=!1,U="";break}case"?":W+=w;continue;case"*":W+=h(1);continue;default:W+=(0,I.escapeRegExpCharacters)(z)}}oe<F.length-1&&(F[oe+1]!==e.GLOBSTAR||oe+2<F.length)&&(W+=P)}G=ee===e.GLOBSTAR})}return W}const f=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.LRUCache(1e4),a=function(){return!1},i=function(){return null};function n(J,W){if(!J)return i;let F;typeof J!="string"?F=J.pattern:F=J,F=F.trim();const G=`${F}_${!!W.trimForExclusions}`;let ee=t.get(G);if(ee)return r(ee,J);let oe;return f.test(F)?ee=s(F.substr(4),F):(oe=u.exec(o(F,W)))?ee=c(oe[1],F):(W.trimForExclusions?p:d).test(F)?ee=S(F,W):(oe=b.exec(o(F,W)))?ee=E(oe[1].substr(1),F,!0):(oe=C.exec(o(F,W)))?ee=E(oe[1],F,!1):ee=A(F),t.set(G,ee),r(ee,J)}function r(J,W){if(typeof W=="string")return J;const F=function(G,ee){return(0,l.isEqualOrParent)(G,W.base,!R.isLinux)?J((0,I.ltrim)(G.substr(W.base.length),T.sep),ee):null};return F.allBasenames=J.allBasenames,F.allPaths=J.allPaths,F.basenames=J.basenames,F.patterns=J.patterns,F}function o(J,W){return W.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function s(J,W){return function(F,G){return typeof F=="string"&&F.endsWith(J)?W:null}}function c(J,W){const F=`/${J}`,G=`\\${J}`,ee=function(ae,x){return typeof ae!="string"?null:x?x===J?W:null:ae===J||ae.endsWith(F)||ae.endsWith(G)?W:null},oe=[J];return ee.basenames=oe,ee.patterns=[W],ee.allBasenames=oe,ee}function S(J,W){const F=Q(J.slice(1,-1).split(",").map(x=>n(x,W)).filter(x=>x!==i),J),G=F.length;if(!G)return i;if(G===1)return F[0];const ee=function(x,$){for(let U=0,z=F.length;U<z;U++)if(F[U](x,$))return J;return null},oe=F.find(x=>!!x.allBasenames);oe&&(ee.allBasenames=oe.allBasenames);const ae=F.reduce((x,$)=>$.allPaths?x.concat($.allPaths):x,[]);return ae.length&&(ee.allPaths=ae),ee}function E(J,W,F){const G=T.sep===T.posix.sep,ee=G?J:J.replace(g,T.sep),oe=T.sep+ee,ae=T.posix.sep+J;let x;return F?x=function($,U){return typeof $=="string"&&($===ee||$.endsWith(oe)||!G&&($===J||$.endsWith(ae)))?W:null}:x=function($,U){return typeof $=="string"&&($===ee||!G&&$===J)?W:null},x.allPaths=[(F?"*/":"./")+J],x}function A(J){try{const W=new RegExp(`^${y(J)}$`);return function(F){return W.lastIndex=0,typeof F=="string"&&W.test(F)?J:null}}catch{return i}}function N(J,W,F){return!J||typeof W!="string"?!1:M(J)(W,void 0,F)}e.match=N;function M(J,W={}){if(!J)return a;if(typeof J=="string"||B(J)){const F=n(J,W);if(F===i)return a;const G=function(ee,oe){return!!F(ee,oe)};return F.allBasenames&&(G.allBasenames=F.allBasenames),F.allPaths&&(G.allPaths=F.allPaths),G}return q(J,W)}e.parse=M;function B(J){const W=J;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}e.isRelativePattern=B;function O(J){return J.allBasenames||[]}e.getBasenameTerms=O;function j(J){return J.allPaths||[]}e.getPathTerms=j;function q(J,W){const F=Q(Object.getOwnPropertyNames(J).map(x=>K(x,J[x],W)).filter(x=>x!==i)),G=F.length;if(!G)return i;if(!F.some(x=>!!x.requiresSiblings)){if(G===1)return F[0];const x=function(z,V){let _;for(let H=0,X=F.length;H<X;H++){const te=F[H](z,V);if(typeof te=="string")return te;(0,L.isThenable)(te)&&(_||(_=[]),_.push(te))}return _?(async()=>{for(const H of _){const X=await H;if(typeof X=="string")return X}return null})():null},$=F.find(z=>!!z.allBasenames);$&&(x.allBasenames=$.allBasenames);const U=F.reduce((z,V)=>V.allPaths?z.concat(V.allPaths):z,[]);return U.length&&(x.allPaths=U),x}const ee=function(x,$,U){let z,V;for(let _=0,H=F.length;_<H;_++){const X=F[_];X.requiresSiblings&&U&&($||($=(0,T.basename)(x)),z||(z=$.substr(0,$.length-(0,T.extname)(x).length)));const te=X(x,$,z,U);if(typeof te=="string")return te;(0,L.isThenable)(te)&&(V||(V=[]),V.push(te))}return V?(async()=>{for(const _ of V){const H=await _;if(typeof H=="string")return H}return null})():null},oe=F.find(x=>!!x.allBasenames);oe&&(ee.allBasenames=oe.allBasenames);const ae=F.reduce((x,$)=>$.allPaths?x.concat($.allPaths):x,[]);return ae.length&&(ee.allPaths=ae),ee}function K(J,W,F){if(W===!1)return i;const G=n(J,F);if(G===i)return i;if(typeof W=="boolean")return G;if(W){const ee=W.when;if(typeof ee=="string"){const oe=(ae,x,$,U)=>{if(!U||!G(ae,x))return null;const z=ee.replace("$(basename)",()=>$),V=U(z);return(0,L.isThenable)(V)?V.then(_=>_?J:null):V?J:null};return oe.requiresSiblings=!0,oe}}return G}function Q(J,W){const F=J.filter(x=>!!x.basenames);if(F.length<2)return J;const G=F.reduce((x,$)=>{const U=$.basenames;return U?x.concat(U):x},[]);let ee;if(W){ee=[];for(let x=0,$=G.length;x<$;x++)ee.push(W)}else ee=F.reduce((x,$)=>{const U=$.patterns;return U?x.concat(U):x},[]);const oe=function(x,$){if(typeof x!="string")return null;if(!$){let z;for(z=x.length;z>0;z--){const V=x.charCodeAt(z-1);if(V===47||V===92)break}$=x.substr(z)}const U=G.indexOf($);return U!==-1?ee[U]:null};oe.basenames=G,oe.patterns=ee,oe.allBasenames=G;const ae=J.filter(x=>!x.basenames);return ae.push(oe),ae}function re(J,W){return(0,k.equals)(J,W,(F,G)=>typeof F=="string"&&typeof G=="string"?F===G:typeof F!="string"&&typeof G!="string"?F.base===G.base&&F.pattern===G.pattern:!1)}e.patternsEquals=re}),define(ne[92],se([0,1,17,10]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(w){return w.toJSON()}class D{constructor(g){this.a=g}transformIncoming(g){const h=this.a.transformIncoming(g);return h===g?g:l(L.URI.from(h))}transformOutgoing(g){const h=this.a.transformOutgoing(g);return h===g?g:l(L.URI.from(h))}transformOutgoingURI(g){const h=this.a.transformOutgoing(g);return h===g?g:L.URI.from(h)}transformOutgoingScheme(g){return this.a.transformOutgoingScheme(g)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function T(w,g,h){if(!w||h>200)return null;if(typeof w=="object"){if(w instanceof L.URI)return g.transformOutgoing(w);for(const m in w)if(Object.hasOwnProperty.call(w,m)){const y=T(w[m],g,h+1);y!==null&&(w[m]=y)}}return null}function R(w,g){const h=T(w,g,0);return h===null?w:h}e.transformOutgoingURIs=R;function I(w,g,h,m){if(!w||m>200)return null;if(typeof w=="object"){if(w.$mid===1)return h?L.URI.revive(g.transformIncoming(w)):g.transformIncoming(w);if(w instanceof k.VSBuffer)return null;for(const y in w)if(Object.hasOwnProperty.call(w,y)){const f=I(w[y],g,h,m+1);f!==null&&(w[y]=f)}}return null}function v(w,g){const h=I(w,g,!1,0);return h===null?w:h}e.transformIncomingURIs=v;function P(w,g){const h=I(w,g,!0,0);return h===null?w:h}e.transformAndReviveIncomingURIs=P}),define(ne[147],se([0,1,34,8,49,31,135]),function(Z,e,k,L,l,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(P){return this.a||(this.a=l.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(P)}value(){if(this.b===void 0){let P=0,w=0;const g=(0,k.networkInterfaces)();for(const h in g){const m=g[h];if(m)for(const{mac:y,internal:f}of m)f||(w+=1,this.c(y.toUpperCase())&&(P+=1))}this.b=w>0?P/w:0}return this.b}};let R;async function I(){return R||(R=(async()=>await v()||D.generateUuid())()),R}e.getMachineId=I;async function v(){try{const P=await new Promise((g,h)=>{Z(["crypto"],g,h)}),w=(0,T.getMac)();return P.createHash("sha256").update(w,"utf8").digest("hex")}catch(P){L.onUnexpectedError(P);return}}}),define(ne[27],se([0,1,53,34,294,6,48,84,13,4,24,10]),function(Z,e,k,L,l,D,T,R,I,v,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(q){q[q.UNLINK=0]="UNLINK",q[q.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function h(q,K=g.UNLINK){if((0,T.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");return K===g.UNLINK?y(q):m(q)}async function m(q){try{const K=(0,T.randomPath)((0,L.tmpdir)());try{await k.promises.rename(q,K)}catch(Q){return Q.code==="ENOENT"?void 0:y(q)}y(K).catch(Q=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function y(q){return(0,l.promisify)(k.rm)(q,{recursive:!0,force:!0,maxRetries:3})}function f(q){if((0,T.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function u(q,K){return b(await(K?d(q):(0,l.promisify)(k.readdir)(q)))}async function d(q){try{return await(0,l.promisify)(k.readdir)(q,{withFileTypes:!0})}catch(re){console.warn("[node.js fs] readdir with filetypes failed with error: ",re)}const K=[],Q=await u(q);for(const re of Q){let J=!1,W=!1,F=!1;try{const G=await e.Promises.lstat((0,I.join)(q,re));J=G.isFile(),W=G.isDirectory(),F=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}K.push({name:re,isFile:()=>J,isDirectory:()=>W,isSymbolicLink:()=>F})}return K}function p(q){return b(k.readdirSync(q))}e.readdirSync=p;function b(q){return q.map(K=>typeof K=="string"?v.isMacintosh?(0,R.normalizeNFC)(K):K:(K.name=v.isMacintosh?(0,R.normalizeNFC)(K.name):K.name,K))}async function C(q){const K=await u(q),Q=[];for(const re of K)await a.existsDirectory((0,I.join)(q,re))&&Q.push(re);return Q}function t(q,K=1e3){return new Promise(Q=>{let re=!1;const J=setInterval(()=>{re||(re=!0,k.access(q,W=>{re=!1,W&&(clearInterval(J),Q(void 0))}))},K)})}e.whenDeleted=t;var a;(function(q){async function K(J){let W;try{if(W=await e.Promises.lstat(J),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(v.isWindows&&F.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw G}throw F}}q.stat=K;async function Q(J){try{const{stat:W,symbolicLink:F}=await q.stat(J);return W.isFile()&&F?.dangling!==!0}catch{}return!1}q.existsFile=Q;async function re(J){try{const{stat:W,symbolicLink:F}=await q.stat(J);return W.isDirectory()&&F?.dangling!==!0}catch{}return!1}q.existsDirectory=re})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new D.ResourceQueue;function n(q,K,Q){return i.queueFor(w.URI.file(q),P.extUriBiasedIgnorePathCase).queue(()=>{const re=S(Q);return new Promise((J,W)=>s(q,K,re,F=>F?W(F):J()))})}let r=!0;function o(q){r=q}e.configureFlushOnWrite=o;function s(q,K,Q,re){if(!r)return k.writeFile(q,K,{mode:Q.mode,flag:Q.flag},re);k.open(q,Q.flag,Q.mode,(J,W)=>{if(J)return re(J);k.writeFile(W,K,F=>{if(F)return k.close(W,()=>re(F));k.fdatasync(W,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),o(!1)),k.close(W,ee=>re(ee))))})})}function c(q,K,Q){const re=S(Q);if(!r)return k.writeFileSync(q,K,{mode:re.mode,flag:re.flag});const J=k.openSync(q,re.flag,re.mode);try{k.writeFileSync(J,K);try{k.fdatasyncSync(J)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),o(!1)}}finally{k.closeSync(J)}}e.writeFileSync=c;function S(q){return q?{mode:typeof q.mode=="number"?q.mode:438,flag:typeof q.flag=="string"?q.flag:"w"}:{mode:438,flag:"w"}}async function E(q,K){if(q!==K)try{await e.Promises.rename(q,K)}catch(Q){if(q.toLowerCase()!==K.toLowerCase()&&Q.code==="EXDEV"||q.endsWith("."))await A(q,K,{preserveSymlinks:!1}),await h(q,g.MOVE);else throw Q}}async function A(q,K,Q){return M(q,K,{root:{source:q,target:K},options:Q,handledSourcePaths:new Set})}const N=511;async function M(q,K,Q){if(Q.handledSourcePaths.has(q))return;Q.handledSourcePaths.add(q);const{stat:re,symbolicLink:J}=await a.stat(q);if(J){if(Q.options.preserveSymlinks)try{return await j(q,K,Q)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(J.dangling)return}return re.isDirectory()?B(q,K,re.mode&N,Q):O(q,K,re.mode&N)}async function B(q,K,Q,re){await e.Promises.mkdir(K,{recursive:!0,mode:Q});const J=await u(q);for(const W of J)await M((0,I.join)(q,W),(0,I.join)(K,W),re)}async function O(q,K,Q){await e.Promises.copyFile(q,K),await e.Promises.chmod(K,Q)}async function j(q,K,Q){let re=await e.Promises.readlink(q);(0,T.isEqualOrParent)(re,Q.root.source,!v.isLinux)&&(re=(0,I.join)(Q.root.target,re.substr(Q.root.source.length+1))),await e.Promises.symlink(re,K)}e.Promises=new class{get access(){return(0,l.promisify)(k.access)}get stat(){return(0,l.promisify)(k.stat)}get lstat(){return(0,l.promisify)(k.lstat)}get utimes(){return(0,l.promisify)(k.utimes)}get read(){return(q,K,Q,re,J)=>new Promise((W,F)=>{k.read(q,K,Q,re,J,(G,ee,oe)=>G?F(G):W({bytesRead:ee,buffer:oe}))})}get readFile(){return(0,l.promisify)(k.readFile)}get write(){return(q,K,Q,re,J)=>new Promise((W,F)=>{k.write(q,K,Q,re,J,(G,ee,oe)=>G?F(G):W({bytesWritten:ee,buffer:oe}))})}get appendFile(){return(0,l.promisify)(k.appendFile)}get fdatasync(){return(0,l.promisify)(k.fdatasync)}get truncate(){return(0,l.promisify)(k.truncate)}get rename(){return(0,l.promisify)(k.rename)}get copyFile(){return(0,l.promisify)(k.copyFile)}get open(){return(0,l.promisify)(k.open)}get close(){return(0,l.promisify)(k.close)}get symlink(){return(0,l.promisify)(k.symlink)}get readlink(){return(0,l.promisify)(k.readlink)}get chmod(){return(0,l.promisify)(k.chmod)}get mkdir(){return(0,l.promisify)(k.mkdir)}get unlink(){return(0,l.promisify)(k.unlink)}get rmdir(){return(0,l.promisify)(k.rmdir)}get realpath(){return(0,l.promisify)(k.realpath)}async exists(q){try{return await e.Promises.access(q),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return C}get writeFile(){return n}get rm(){return h}get move(){return E}get copy(){return A}}}),define(ne[148],se([0,1,53,13,4,26,27]),function(Z,e,k,L,l,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(g){if(l.isLinux)return g;const h=(0,L.dirname)(g);if(g===h)return g;const m=((0,L.basename)(g)||g).toLowerCase();try{const f=(0,T.readdirSync)(h).filter(u=>u.toLowerCase()===m);if(f.length===1){const u=R(h);if(u)return(0,L.join)(u,f[0])}else if(f.length>1){const u=f.indexOf(m);if(u>=0){const d=R(h);if(d)return(0,L.join)(d,f[u])}}}catch{}return null}e.realcaseSync=R;async function I(g){if(l.isLinux)return g;const h=(0,L.dirname)(g);if(g===h)return g;const m=((0,L.basename)(g)||g).toLowerCase();try{const f=(await T.Promises.readdir(h)).filter(u=>u.toLowerCase()===m);if(f.length===1){const u=await I(h);if(u)return(0,L.join)(u,f[0])}else if(f.length>1){const u=f.indexOf(m);if(u>=0){const d=await I(h);if(d)return(0,L.join)(d,f[u])}}}catch{}return null}e.realcase=I;async function v(g){try{return await T.Promises.realpath(g)}catch{const m=w(g);return await T.Promises.access(m,k.constants.R_OK),m}}e.realpath=v;function P(g){try{return k.realpathSync(g)}catch{const m=w(g);return k.accessSync(m,k.constants.R_OK),m}}e.realpathSync=P;function w(g){return(0,D.rtrim)((0,L.normalize)(g),L.sep)}}),define(ne[93],se([0,1,34,13,27]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,T=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var I;(function(b){b[b.x64=0]="x64",b[b.x86=1]="x86",b[b.ARM=2]="ARM"})(I||(I={}));let v;switch(process.arch){case"ia32":case"x32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class w{constructor(C,t,a){this.exePath=C,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await l.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:b=!1}={}){return b?v===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:b=!1,findPreview:C=!1}={}){const t=g({useAlternateBitness:b});if(!t)return null;const a=L.join(t,"PowerShell");if(!await l.SymlinkSupport.existsDirectory(a))return null;let i=-1,n=null;for(const s of await l.Promises.readdir(a)){let c=-1;if(C){const E=s.indexOf("-");if(E<0)continue;const A=s.substring(0,E);if(!D.test(A)||s.substring(E+1)!=="preview")continue;c=parseInt(A,10)}else{if(!D.test(s))continue;c=parseInt(s,10)}if(c<=i)continue;const S=L.join(a,s,"pwsh.exe");!await l.SymlinkSupport.existsFile(S)||(n=S,i=c)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",o=C?" Preview":"";return new w(n,`PowerShell${o}${r}`,!0)}async function m({findPreview:b}={}){if(!process.env.LOCALAPPDATA)return null;const C=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await l.SymlinkSupport.existsDirectory(C))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=b?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const i of await l.Promises.readdir(C))if(t.test(i)){const n=L.join(C,i,"pwsh.exe");return new w(n,a)}return null}function y(){const b=L.join(k.homedir(),".dotnet","tools","pwsh.exe");return new w(b,".NET Core PowerShell Global Tool")}function f(){const b=L.join(process.env.windir,v===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(b,"Windows PowerShell",!0)}async function*u(){let b=await h();b&&(yield b),b=await h({useAlternateBitness:!0}),b&&(yield b),b=await m(),b&&(yield b),b=y(),b&&(yield b),b=await h({findPreview:!0}),b&&(yield b),b=await m({findPreview:!0}),b&&(yield b),b=await h({useAlternateBitness:!0,findPreview:!0}),b&&(yield b),b=f(),b&&(yield b)}async function*d(){for await(const b of u())await b.exists()&&(yield b)}e.enumeratePowerShellInstallations=d;async function p(){for await(const b of d())return b;return null}e.getFirstAvailablePowerShellInstallation=p}),define(ne[94],se([0,1,13,4,36,87,12,27]),function(Z,e,k,L,l,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function I(w=l.env){return w.comspec||"cmd.exe"}e.getWindowsShell=I;function v(w){let g=[],h=!1;const m=function(y){if(h){g.push(y);return}(!w.send(y,u=>{if(u&&console.error(u),h=!1,g.length>0){const d=g.slice(0);g=[],d.forEach(p=>m(p))}})||L.isWindows)&&(h=!0)};return{send:m}}e.createQueuedSender=v;var P;(function(w){async function g(h,m,y){if(k.isAbsolute(h))return h;if(m===void 0&&(m=l.cwd()),k.dirname(h)!=="."||(y===void 0&&T.isString(l.env.PATH)&&(y=l.env.PATH.split(k.delimiter)),y===void 0||y.length===0))return k.join(m,h);async function u(d){if(await R.Promises.exists(d)){let p;try{p=await R.Promises.stat(d)}catch(b){b.message.startsWith("EACCES")&&(p=await R.Promises.lstat(d))}return p?!p.isDirectory():!1}return!1}for(const d of y){let p;if(k.isAbsolute(d)?p=k.join(d,h):p=k.join(m,d,h),await u(p))return p;let b=p+".com";if(await u(b)||(b=p+".exe",await u(b)))return b}return k.join(m,h)}w.findExecutable=g})(P=e.win32||(e.win32={}))}),define(ne[149],se([0,1,50,21]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function l(T){return new Promise((R,I)=>{let v;const P=new Map;function w(h,m,y,f,u){const d=P.get(m);if(h===T||d){const p={name:g(y),cmd:y,pid:h,ppid:m,load:f,mem:u};P.set(h,p),h===T&&(v=p),d&&(d.children||(d.children=[]),d.children.push(p),d.children.length>1&&(d.children=d.children.sort((b,C)=>b.pid-C.pid)))}}function g(h){const m=/--vscode-window-kind=shared-process/i,y=/--vscode-window-kind=issue-reporter/i,f=/--vscode-window-kind=process-explorer/i,u=/--utility-sub-type=network/i,d=/--vscode-utility-kind=extensionHost/i,p=/--vscode-utility-kind=fileWatcher/i,b=/--vscode-utility-kind=shared-process/i,C=/--crashes-directory/i,t=/\\pipe\\winpty-control/i,a=/conhost\.exe/i,i=/--type=([a-zA-Z-]+)/;if(C.exec(h))return"electron-crash-reporter";if(t.exec(h))return"winpty-process";if(a.exec(h))return"console-window-host (Windows internal process)";let n=i.exec(h);if(n&&n.length===2){if(n[1]==="renderer")return m.exec(h)?"shared-process":y.exec(h)?"issue-reporter":f.exec(h)?"process-explorer":"window";if(n[1]==="utility"){if(u.exec(h))return"utility-network-service";if(d.exec(h))return"extension-host";if(p.exec(h))return"file-watcher";if(b.exec(h))return"shared-process"}else if(n[1]==="extensionHost")return"extension-host";return n[1]}const r=/[a-zA-Z-]+\.js/g;let o="";do n=r.exec(h),n&&(o+=n+" ");while(n);return o&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron_node ${o}`:h}if(process.platform==="win32"){const h=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,y)=>{Z(["windows-process-tree"],m,y)}).then(m=>{m.getProcessList(T,y=>{if(!y){I(new Error(`Root process ${T} not found`));return}m.getProcessCpuUsage(y,f=>{const u=new Map;f.forEach(d=>{const p=h(d.commandLine||"");u.set(d.pid,{name:g(p),cmd:p,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),v=u.get(T),v?(u.forEach(d=>{const p=u.get(d.ppid);p&&(p.children||(p.children=[]),p.children.push(d))}),u.forEach(d=>{d.children&&(d.children=d.children.sort((p,b)=>p.pid-b.pid))}),R(v)):I(new Error(`Root process ${T} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let h=function(){let m=[v];const y=[];for(;m.length;){const u=m.shift();u&&(y.push(u.pid),u.children&&(m=m.concat(u.children)))}let f=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+y.join(" "),(0,k.exec)(f,{},(u,d,p)=>{if(u||p)I(u||new Error(p.toString()));else{const b=d.toString().split(`
`);for(let C=0;C<y.length;C++){const t=P.get(y[C]);t.load=parseFloat(b[C])}if(!v){I(new Error(`Root process ${T} not found`));return}R(v)}})};(0,k.exec)("which ps",{},(m,y,f)=>{if(m||f)if(process.platform!=="linux")I(m||new Error(f.toString()));else{const u=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,k.exec)(u,{},(d,p,b)=>{d||b?I(d||new Error(b.toString())):(D(p,w),h())})}else{const u=y.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${u} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,b,C)=>{p||C&&!C.includes("screen size is bogus")?I(p||new Error(C.toString())):(D(b,w),process.platform==="linux"?h():v?R(v):I(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=l;function D(T,R){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=T.toString().split(`
`);for(const P of v){const w=I.exec(P.trim());w&&w.length===6&&R(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(ne[150],se([0,1,34,4,93,94]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function T(w,g){return w===1?L.isWindows?P():D.getWindowsShell(g):I(w,g)}e.getSystemShell=T;let R=null;function I(w,g){if(L.isLinux&&w===2||L.isMacintosh&&w===3)return"/bin/bash";if(!R){let h;if(L.isWindows)h="/bin/bash";else{if(h=g.SHELL,!h)try{h=(0,k.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}R=h}return R}let v=null;async function P(){return v||(v=(await(0,l.getFirstAvailablePowerShellInstallation)()).exePath),v}});var ye=this&&this.__decorate||function(Z,e,k,L){var l=arguments.length,D=l<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,k):L,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(Z,e,k,L);else for(var R=Z.length-1;R>=0;R--)(T=Z[R])&&(D=(l<3?T(D):l>3?T(e,k,D):T(e,k))||D);return l>3&&D&&Object.defineProperty(e,k,D),D};define(ne[37],se([0,1,18,6,17,23,62,8,3,2,90,26,12]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var h;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(h||(h={}));function m(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(y||(y={}));function f(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(u||(u={}));function d(W){let F=0;for(let G=0;;G+=7){const ee=W.read(1);if(F|=(ee.buffer[0]&127)<<G,!(ee.buffer[0]&128))return F}}const p=i(0);function b(W,F){if(F===0){W.write(p);return}let G=0;for(let oe=F;oe!==0;oe=oe>>>7)G++;const ee=l.VSBuffer.alloc(G);for(let oe=0;F!==0;oe++)ee.buffer[oe]=F&127,F=F>>>7,F>0&&(ee.buffer[oe]|=128);W.write(ee)}class C{constructor(F){this.b=F,this.a=0}read(F){const G=this.b.slice(this.a,this.a+F);return this.a+=G.byteLength,G}}e.BufferReader=C;class t{constructor(){this.a=[]}get buffer(){return l.VSBuffer.concat(this.a)}write(F){this.a.push(F)}}e.BufferWriter=t;var a;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(a||(a={}));function i(W){const F=l.VSBuffer.alloc(1);return F.writeUInt8(W,0),F}const n={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},r=typeof Buffer<"u";function o(W,F){if(typeof F>"u")W.write(n.Undefined);else if(typeof F=="string"){const G=l.VSBuffer.fromString(F);W.write(n.String),b(W,G.byteLength),W.write(G)}else if(r&&Buffer.isBuffer(F)){const G=l.VSBuffer.wrap(F);W.write(n.Buffer),b(W,G.byteLength),W.write(G)}else if(F instanceof l.VSBuffer)W.write(n.VSBuffer),b(W,F.byteLength),W.write(F);else if(Array.isArray(F)){W.write(n.Array),b(W,F.length);for(const G of F)o(W,G)}else if(typeof F=="number"&&(F|0)===F)W.write(n.Uint),b(W,F);else{const G=l.VSBuffer.fromString(JSON.stringify(F));W.write(n.Object),b(W,G.byteLength),W.write(G)}}e.serialize=o;function s(W){switch(W.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return W.read(d(W)).toString();case a.Buffer:return W.read(d(W)).buffer;case a.VSBuffer:return W.read(d(W));case a.Array:{const G=d(W),ee=[];for(let oe=0;oe<G;oe++)ee.push(s(W));return ee}case a.Object:return JSON.parse(W.read(d(W)).toString());case a.Int:return d(W)}}e.deserialize=s;class c{constructor(F,G,ee=null,oe=1e3){this.h=F,this.j=G,this.k=ee,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(F,G){this.b.set(F,G),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const G=this.o([F.type]);this.k?.logOutgoing(G,0,1,f(F.type));return}case 201:case 202:case 204:case 203:{const G=this.o([F.type,F.id],F.data);this.k?.logOutgoing(G,F.id,1,f(F.type),F.data);return}}}o(F,G=void 0){const ee=new t;return o(ee,F),o(ee,G),this.p(ee.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const G=new C(F),ee=s(G),oe=s(G),ae=ee[0];switch(ae){case 100:return this.k?.logIncoming(F.byteLength,ee[1],1,`${m(ae)}: ${ee[2]}.${ee[3]}`,oe),this.s({type:ae,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 102:return this.k?.logIncoming(F.byteLength,ee[1],1,`${m(ae)}: ${ee[2]}.${ee[3]}`,oe),this.t({type:ae,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 101:return this.k?.logIncoming(F.byteLength,ee[1],1,`${m(ae)}`),this.u({type:ae,id:ee[1]});case 103:return this.k?.logIncoming(F.byteLength,ee[1],1,`${m(ae)}`),this.u({type:ae,id:ee[1]})}}s(F){const G=this.b.get(F.channelName);if(!G){this.v(F);return}const ee=new D.CancellationTokenSource;let oe;try{oe=G.call(this.j,F.name,F.arg,ee.token)}catch($){oe=Promise.reject($)}const ae=F.id;oe.then($=>{this.m({id:ae,data:$,type:201}),this.d.delete(F.id)},$=>{$ instanceof Error?this.m({id:ae,data:{message:$.message,name:$.name,stack:$.stack?$.stack.split?$.stack.split(`
`):$.stack:void 0},type:202}):this.m({id:ae,data:$,type:203}),this.d.delete(F.id)});const x=(0,v.toDisposable)(()=>ee.cancel());this.d.set(F.id,x)}t(F){const G=this.b.get(F.channelName);if(!G){this.v(F);return}const ee=F.id,ae=G.listen(this.j,F.name,F.arg)(x=>this.m({id:ee,data:x,type:204}));this.d.set(F.id,ae)}u(F){const G=this.d.get(F.id);G&&(G.dispose(),this.d.delete(F.id))}v(F){let G=this.g.get(F.channelName);G||(G=[],this.g.set(F.channelName,G));const ee=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);G.push({request:F,timeoutTimer:ee})}w(F){const G=this.g.get(F);if(G){for(const ee of G)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,v.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=c;var S;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(F,G=null){this.l=F,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new I.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=G}getChannel(F){const G=this;return{call(ee,oe,ae){return G.a?Promise.reject(new R.CancellationError):G.m(F,ee,oe,ae)},listen(ee,oe){return G.a?I.Event.None:G.o(F,ee,oe)}}}m(F,G,ee,oe=D.CancellationToken.None){const ae=this.g++,$={id:ae,type:100,channelName:F,name:G,arg:ee};if(oe.isCancellationRequested)return Promise.reject(new R.CancellationError);let U;return new Promise((V,_)=>{if(oe.isCancellationRequested)return _(new R.CancellationError);const H=()=>{const he=me=>{switch(me.type){case 201:this.f.delete(ae),V(me.data);break;case 202:{this.f.delete(ae);const pe=new Error(me.data.message);pe.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,pe.name=me.data.name,_(pe);break}case 203:this.f.delete(ae),_(me.data);break}};this.f.set(ae,he),this.p($)};let X=null;this.b===u.Idle?H():(X=(0,L.createCancelablePromise)(he=>this.u()),X.then(()=>{X=null,H()}));const te=()=>{X?(X.cancel(),X=null):this.p({id:ae,type:101}),_(new R.CancellationError)},le=oe.onCancellationRequested(te);U=(0,v.combinedDisposable)((0,v.toDisposable)(te),le),this.d.add(U)}).finally(()=>{this.d.delete(U)})}o(F,G,ee){const oe=this.g++,x={id:oe,type:102,channelName:F,name:G,arg:ee};let $=null;const U=new I.Emitter({onWillAddFirstListener:()=>{$=(0,L.createCancelablePromise)(V=>this.u()),$.then(()=>{$=null,this.d.add(U),this.p(x)})},onDidRemoveLastListener:()=>{$?($.cancel(),$=null):(this.d.delete(U),this.p({id:oe,type:103}))}}),z=V=>U.fire(V.data);return this.f.set(oe,z),U.event}p(F){switch(F.type){case 100:case 102:{const G=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(G,F.id,0,`${m(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const G=this.q([F.type,F.id]);this.j?.logOutgoing(G,F.id,0,m(F.type));return}}}q(F,G=void 0){const ee=new t;return o(ee,F),o(ee,G),this.r(ee.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const G=new C(F),ee=s(G),oe=s(G),ae=ee[0];switch(ae){case 200:return this.j?.logIncoming(F.byteLength,0,0,f(ae)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,ee[1],0,f(ae),oe),this.t({type:ee[0],id:ee[1],data:oe})}}t(F){if(F.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,v.dispose)(this.d.values()),this.d.clear()}}ye([T.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class A{get connections(){const F=[];return this.f.forEach(G=>F.push(G)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new I.Emitter,this.onDidAddConnection=this.g.event,this.h=new I.Emitter,this.onDidRemoveConnection=this.h.event,F(({protocol:G,onDidClientDisconnect:ee})=>{I.Event.once(G.onMessage)(ae=>{const x=new C(ae),$=s(x),U=new c(G,$),z=new E(G);this.a.forEach((_,H)=>U.registerChannel(H,_));const V={channelServer:U,channelClient:z,ctx:$};this.f.add(V),this.g.fire(V),ee(()=>{U.dispose(),z.dispose(),this.f.delete(V),this.h.fire(V)})})})}getChannel(F,G){const ee=this;return{call(oe,ae,x){let $;if((0,g.isFunction)(G)){const z=(0,k.getRandomElement)(ee.connections.filter(G));$=z?Promise.resolve(z):I.Event.toPromise(I.Event.filter(ee.onDidAddConnection,G))}else $=G.routeCall(ee,oe,ae);const U=$.then(z=>z.channelClient.getChannel(F));return M(U).call(oe,ae,x)},listen(oe,ae){if((0,g.isFunction)(G))return ee.j(F,G,oe,ae);const x=G.routeEvent(ee,oe,ae).then($=>$.channelClient.getChannel(F));return M(x).listen(oe,ae)}}}j(F,G,ee,oe){const ae=this;let x=new v.DisposableStore;const $=new I.Emitter({onWillAddFirstListener:()=>{x=new v.DisposableStore;const U=new I.EventMultiplexer,z=new Map,V=H=>{const te=H.channelClient.getChannel(F).listen(ee,oe),le=U.add(te);z.set(H,le)},_=H=>{const X=z.get(H);!X||(X.dispose(),z.delete(H))};ae.connections.filter(G).forEach(V),I.Event.filter(ae.onDidAddConnection,G)(V,void 0,x),ae.onDidRemoveConnection(_,void 0,x),U.event($.fire,$,x),x.add(U)},onDidRemoveLastListener:()=>{x.dispose()}});return $.event}registerChannel(F,G){this.a.set(F,G),this.f.forEach(ee=>{ee.channelServer.registerChannel(F,G)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=A;class N{constructor(F,G,ee=null){const oe=new t;o(oe,G),F.send(oe.buffer),this.a=new E(F,ee),this.d=new c(F,G,ee)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,G){this.d.registerChannel(F,G)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function M(W){return{call(F,G,ee){return W.then(oe=>oe.call(F,G,ee))},listen(F,G){const ee=new I.Relay;return W.then(oe=>ee.input=oe.listen(F,G)),ee.event}}}e.getDelayedChannel=M;function B(W){let F=!1;return{call(G,ee,oe){return F?W.call(G,ee,oe):(0,L.timeout)(0).then(()=>F=!0).then(()=>W.call(G,ee,oe))},listen(G,ee){if(F)return W.listen(G,ee);const oe=new I.Relay;return(0,L.timeout)(0).then(()=>F=!0).then(()=>oe.input=W.listen(G,ee)),oe.event}}}e.getNextTickChannel=B;class O{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const G of F.connections)if(await Promise.resolve(this.a(G.ctx)))return Promise.resolve(G);return await I.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.StaticRouter=O;var j;(function(W){function F(ae,x){const $=ae,U=x&&x.disableMarshalling,z=new Map;for(const V in $)ee(V)&&z.set(V,I.Event.buffer($[V],!0));return new class{listen(V,_,H){const X=z.get(_);if(X)return X;if(oe(_)){const te=$[_];if(typeof te=="function")return te.call($,H)}throw new Error(`Event not found: ${_}`)}call(V,_,H){const X=$[_];if(typeof X=="function"){if(!U&&Array.isArray(H))for(let te=0;te<H.length;te++)H[te]=(0,P.revive)(H[te]);return X.apply($,H)}throw new Error(`Method not found: ${_}`)}}}W.fromService=F;function G(ae,x){const $=x&&x.disableMarshalling;return new Proxy({},{get(U,z){if(typeof z=="string")return x?.properties?.has(z)?x.properties.get(z):oe(z)?function(V){return ae.listen(z,V)}:ee(z)?ae.listen(z):async function(...V){let _;x&&!(0,g.isUndefinedOrNull)(x.context)?_=[x.context,...V]:_=V;const H=await ae.call(z,_);return $?H:(0,P.revive)(H)};throw new Error(`Property not found: ${String(z)}`)}})}W.toService=G;function ee(ae){return ae[0]==="o"&&ae[1]==="n"&&w.isUpperAsciiLetter(ae.charCodeAt(2))}function oe(ae){return/^onDynamic/.test(ae)&&w.isUpperAsciiLetter(ae.charCodeAt(9))}})(j=e.ProxyChannel||(e.ProxyChannel={}));const q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const F=W.toString();if(F!=="[object Object]")return F}return W}function Q(W){return Array.isArray(W)?W.map(K):K(W)}function re(W,F,G,ee,oe,ae,x){x=Q(x);const $=q[oe],U=$[ee%$.length];let z=[`%c[${W}]%c[${String(F).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ae)?(z=z.concat(x),z.push(")")):z.push(x),console.log.apply(console,z)}class J{constructor(F,G){this.d=F,this.f=G,this.a=0,this.b=0}logOutgoing(F,G,ee,oe,ae){this.b+=F,re(this.d,this.b,F,G,ee,oe,ae)}logIncoming(F,G,ee,oe,ae){this.a+=F,re(this.f,this.a,F,G,ee,oe,ae)}}e.IPCLogger=J}),define(ne[151],se([0,1,17,3,37]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class D{constructor(I){this.a=I,this.onMessage=L.Event.fromDOMEventEmitter(this.a,"message",v=>k.VSBuffer.wrap(v.data)),I.start()}send(I){this.a.postMessage(I.buffer)}disconnect(){this.a.close()}}e.Protocol=D;class T extends l.IPCClient{constructor(I,v){const P=new D(I);super(P,v),this.b=P}dispose(){this.b.disconnect()}}e.Client=T}),define(ne[95],se([0,1,6,17,3,2,37]),function(Z,e,k,L,l,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(R=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(E){E.enableDiagnostics=!1,E.records=[];const A=new WeakMap;let N=0;function M(O,j){if(!A.has(O)){const q=String(++N);A.set(O,q)}return A.get(O)}function B(O,j,q,K){if(!E.enableDiagnostics)return;const Q=M(O,j);if(K instanceof L.VSBuffer||K instanceof Uint8Array||K instanceof ArrayBuffer||ArrayBuffer.isView(K)){const re=L.VSBuffer.alloc(K.byteLength);re.set(K),E.records.push({timestamp:Date.now(),id:Q,label:j,type:q,buff:re})}else E.records.push({timestamp:Date.now(),id:Q,label:j,type:q,data:K})}E.traceSocketEvent=B})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var v;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function w(){return P||(P=L.VSBuffer.alloc(0)),P}class g{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(A){this.a.push(A),this.b+=A.byteLength}read(A){return this.c(A,!0)}peek(A){return this.c(A,!1)}c(A,N){if(A===0)return w();if(A>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===A){const j=this.a[0];return N&&(this.a.shift(),this.b-=A),j}if(this.a[0].byteLength>A){const j=this.a[0].slice(0,A);return N&&(this.a[0]=this.a[0].slice(A),this.b-=A),j}const M=L.VSBuffer.alloc(A);let B=0,O=0;for(;A>0;){const j=this.a[O];if(j.byteLength>A){const q=j.slice(0,A);M.set(q,B),B+=A,N&&(this.a[O]=j.slice(A),this.b-=A),A-=A}else M.set(j,B),B+=j.byteLength,N?(this.a.shift(),this.b-=j.byteLength):O++,A-=j.byteLength}return M}}e.ChunkStream=g;var h;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(h||(h={}));function m(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var y;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(y=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(A,N,M,B){this.type=A,this.id=N,this.ack=M,this.data=B,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends D.Disposable{constructor(A){super(),this.f=this.B(new l.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=A,this.b=!1,this.c=new g,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(A){if(!(!A||A.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(A);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:m(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const M=this.g.messageType,B=this.g.id,O=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new f(M,B,O,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(A){this.k=null,this.a=!1,this.b=!1,this.c=A,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(A){if(this.a)return;A.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=L.VSBuffer.alloc(13);N.writeUInt8(A.type,0),N.writeUInt32BE(A.id,1),N.writeUInt32BE(A.ack,5),N.writeUInt32BE(A.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:m(A.type),id:A.id,ack:A.ack,messageSize:A.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",A.data),this.j(N,A.data)}g(A,N){const M=this.f===0;return this.d.push(A,N),this.f+=A.byteLength+N.byteLength,M}h(){const A=L.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,A}j(A,N){this.g(A,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const A=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:A.byteLength}),this.c.write(A)}}class p extends D.Disposable{constructor(A){super(),this.f=new l.Emitter,this.onMessage=this.f.event,this.g=new l.Emitter,this.onDidDispose=this.g.event,this.a=A,this.b=this.B(new d(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(A){this.b.write(new f(1,0,0,A))}}e.Protocol=p;class b extends T.IPCClient{static fromSocket(A,N){return new b(new p(A),N)}get onDidDispose(){return this.b.onDidDispose}constructor(A,N,M=null){super(A,N,M),this.b=A}dispose(){super.dispose();const A=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),A.end()}}e.Client=b;class C{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new l.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(A){this.b?this.d.length>0?this.d.push(A):this.a.fire(A):this.d.push(A)}flushBuffer(){this.d=[]}}e.BufferedEmitter=C;class t{constructor(A){this.data=A,this.next=null}}class a{constructor(){this.a=null,this.b=null}length(){let A=0,N=this.a;for(;N;)N=N.next,A++;return A}peek(){return this.a?this.a.data:null}toArray(){const A=[];let N=0,M=this.a;for(;M;)A[N++]=M.data,M=M.next;return A}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(A){const N=new t(A);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const A=Date.now();for(let N=0;N<i.a;N++)this.c[N]=A-1e3*N;setInterval(()=>{for(let N=i.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const A=Date.now(),N=(1+i.a)*1e3;let M=0;for(let B=0;B<i.a;B++)A-this.c[B]<=N&&M++;return 1-M/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var n;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(n=e.ConnectionHealth||(e.ConnectionHealth={}));function r(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=r;class o{constructor(A){this.connectionHealth=A}}e.ConnectionHealthChangedEvent=o;class s{constructor(A,N){this.roundTripTime=A,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=s;class c{get unacknowledgedCount(){return this.c-this.d}constructor(A){this.x=new C,this.onControlMessage=this.x.event,this.y=new C,this.onMessage=this.y.event,this.z=new C,this.onDidDispose=this.z.event,this.A=new C,this.onSocketClose=this.A.event,this.B=new C,this.onSocketTimeout=this.B.event,this.C=new C,this.onHighRoundTripTime=this.C.event,this.D=new C,this.onDidChangeConnectionHealth=this.D.event,this.u=A.loadEstimator??i.getInstance(),this.v=A.measureRoundTripTime??!1,this.w=A.sendKeepAlive??!0,this.a=!1,this.b=new a,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new D.DisposableStore,this.o=A.socket,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new S),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),A.initialChunk&&this.q.acceptChunk(A.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const A=new f(5,0,0,w());this.p.write(A),this.p.flush()}sendPause(){const A=new f(7,0,0,w());this.p.write(A)}sendResume(){const A=new f(8,0,0,w());this.p.write(A)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(A,N){this.a=!0,this.t.dispose(),this.t=new D.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=A,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(M=>this.E(M))),this.t.add(this.o.onClose(M=>this.A.fire(M))),this.r=this.t.add(new S),this.t.add(this.r.onSendLatencyRequest(M=>this.J(M))),this.t.add(this.r.onHighRoundTripTime(M=>this.C.fire(M))),this.t.add(this.r.onDidChangeConnectionHealth(M=>this.D.fire(M))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const A=new f(3,0,this.h,w());this.p.write(A);const N=this.b.toArray();for(let M=0,B=N.length;M<B;M++)this.p.write(N[M]);this.G()}acceptDisconnect(){this.z.fire()}E(A){if(A.ack>this.d){this.d=A.ack;do{const N=this.b.peek();if(N&&N.id<=A.ack)this.b.pop();else break}while(!0)}switch(A.type){case 0:break;case 1:{if(A.id>this.g)if(A.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new f(6,0,0,w())))}else this.g=A.id,this.j=Date.now(),this.F(),this.y.fire(A.data);break}case 2:{this.x.fire(A.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let M=0,B=N.length;M<B;M++)this.p.write(N[M]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(A.data);break}case 11:{this.r.handleResponse(A.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(A){const N=++this.c;this.h=this.g;const M=new f(1,N,this.h,A);this.b.push(M),this.a||(this.p.write(M),this.G())}sendControl(A){const N=new f(2,0,0,A);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const A=Date.now()-this.j;if(A>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-A+5)}G(){if(this.c<=this.d||this.f||this.a)return;const A=this.b.peek(),N=Date.now()-A.writtenTime,M=Date.now()-this.q.lastReadTime,B=Date.now()-this.n;if(N>=2e4&&M>=2e4&&B>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:M});return}const O=Math.max(2e4-N,2e4-M,2e4-B,500);this.f=setTimeout(()=>{this.f=null,this.G()},O)}H(){if(this.g<=this.h)return;this.h=this.g;const A=new f(3,0,this.h,w());this.p.write(A)}I(){this.h=this.g;const A=new f(9,0,this.h,w());this.p.write(A)}J(A){this.h=this.g;const N=new f(10,0,this.h,A);this.p.write(N)}K(A){this.h=this.g;const N=new f(11,0,this.h,A);this.p.write(N)}}e.PersistentProtocol=c;class S extends D.Disposable{constructor(){super(),this.a=this.B(new l.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new l.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new l.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new k.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},A=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const A=++this.h,N=L.VSBuffer.alloc(4);N.writeUInt32BE(A,0),this.a.fire(N)},6e4)}handleResponse(A){if(A.byteLength!==4)return;const N=A.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const M=Date.now()-this.g,B=this.k++;this.j[B%this.j.length]=M;const O=this.l,j=this.j.filter(q=>q>=1e3).length;this.l=j>=3?1:0,M>1e3&&this.b.fire(new s(M,j)),O!==this.l&&this.c.fire(this.l)}}}),define(ne[152],se([0,1,153,3,37,151]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends l.IPCServer{static b(){const I=L.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(v,P)=>P);return L.Event.map(I,v=>{const{port1:P,port2:w}=new MessageChannel,h={protocol:new D.Protocol(P),onDidClientDisconnect:L.Event.fromDOMEventEmitter(P,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",v,[w]),h})}constructor(){super(T.b())}}e.Server=T}),define(ne[66],se([0,1,50,6,17,23,146,8,3,2,32,94,87,37]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends h.ChannelServer{constructor(u){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",d=>l.VSBuffer.wrap(Buffer.from(d,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=m;class y{constructor(u,d){this.i=u,this.j=d,this.c=new Set,this.g=new Map,this.h=new I.Emitter,this.onDidProcessExit=this.h.event;const p=d&&d.timeout?d.timeout:6e4;this.b=new L.Delayer(p),this.d=null,this.f=null}getChannel(u){const d=this;return{call(p,b,C){return d.k(u,p,b,C)},listen(p,b){return d.l(u,p,b)}}}k(u,d,p,b=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(R.canceled());this.b.cancel();const C=this.n(u),t=(0,L.createCancelablePromise)(n=>C.call(d,p,n)),a=b.onCancellationRequested(()=>t.cancel()),i=(0,v.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,d,p){if(!this.b)return I.Event.None;this.b.cancel();let b;const C=new I.Emitter({onWillAddFirstListener:()=>{b=this.n(u).listen(d,p)(C.fire,C),this.c.add(b)},onDidRemoveLastListener:()=>{this.c.delete(b),b.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return C.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,g.removeDangerousEnvVariables)(d.env),this.d=(0,k.fork)(this.i,u,d);const p=new I.Emitter;I.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,T.isRemoteConsoleLog)(r)){(0,T.log)(r,`IPC Library: ${this.j.serverName}`);return}p.fire(l.VSBuffer.wrap(Buffer.from(r,"base64")))});const C=this.j.useQueue?(0,w.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&C.send(r.buffer.toString("base64")),a=p.event,i={send:t,onMessage:a};this.f=new h.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",n),this.c.forEach(s=>(0,v.dispose)(s)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(u){let d=this.g.get(u);return d||(d=this.m.getChannel(u),this.g.set(u,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=y}),define(ne[154],se([0,1,86,17,37,3,12,18]),function(Z,e,k,L,l,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class I{constructor(g){this.a=g,this.onMessage=D.Event.fromNodeEventEmitter(this.a,"message",h=>L.VSBuffer.wrap(h.data)),g.start()}send(g){this.a.postMessage(g.buffer)}disconnect(){this.a.close()}}class v extends l.IPCServer{static b(){(0,T.assertType)((0,k.isUtilityProcess)(process),"Electron Utility Process");const g=new D.Emitter;return process.parentPort.on("message",h=>{const m=(0,R.firstOrDefault)(h.ports);m&&g.fire(m)}),D.Event.map(g.event,h=>({protocol:new I(h),onDidClientDisconnect:D.Event.fromNodeEventEmitter(h,"close")}))}constructor(){super(v.b())}}e.Server=v;function P(w,g,h){const m=y=>{y.data===g&&(w.removeListener("message",m),h())};w.on("message",m)}e.once=P}),define(ne[155],se([0,1,17,8,3,2,13,4,31,37,95]),function(Z,e,k,L,l,D,T,R,I,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function w(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class g{traceSocketEvent(s,c){P.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,c)}constructor(s,c=""){this.f=!0,this.debugLabel=c,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=S=>{if(this.traceSocketEvent("error",{code:S?.code,message:S?.message}),S){if(S.code==="EPIPE")return;(0,L.onUnexpectedError)(S)}},this.socket.on("error",this.a),this.b=S=>{this.traceSocketEvent("close",{hadError:S}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const c=S=>{this.traceSocketEvent("read",S),s(k.VSBuffer.wrap(S))};return this.socket.on("data",c),{dispose:()=>this.socket.off("data",c)}}onClose(s){const c=S=>{s({type:0,hadError:S,error:void 0})};return this.socket.on("close",c),{dispose:()=>this.socket.off("close",c)}}onEnd(s){const c=()=>{s()};return this.socket.on("end",c),{dispose:()=>this.socket.off("end",c)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,c=>{if(c){if(c.code==="EPIPE")return;(0,L.onUnexpectedError)(c)}})}catch(c){if(c.code==="EPIPE")return;(0,L.onUnexpectedError)(c)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,c)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const S=()=>{this.socket.off("close",S),this.socket.off("end",S),this.socket.off("error",S),this.socket.off("timeout",S),this.socket.off("drain",S),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",S),this.socket.on("end",S),this.socket.on("error",S),this.socket.on("timeout",S),this.socket.on("drain",S)})}}e.NodeSocket=g;var h;(function(o){o[o.MinHeaderByteSize=2]="MinHeaderByteSize"})(h||(h={}));var m;(function(o){o[o.PeekHeader=1]="PeekHeader",o[o.ReadHeader=2]="ReadHeader",o[o.ReadBody=3]="ReadBody",o[o.Fin=4]="Fin"})(m||(m={}));class y extends D.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,c){this.socket.traceSocketEvent(s,c)}constructor(s,c,S,E){super(),this.f=this.B(new l.Emitter),this.g=this.B(new l.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:c,inflateBytesLength:S?.byteLength||0,recordInflateBytes:E}),this.a=this.B(new f(this,c,S,E,this.f,(A,N)=>this.k(A,N))),this.B(this.a.onError(A=>{console.error(A),(0,L.onUnexpectedError)(A),this.g.fire({type:0,hadError:!0,error:A})})),this.b=new P.ChunkStream,this.B(this.socket.onData(A=>this.l(A))),this.B(this.socket.onClose(A=>this.g.fire(A)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this.a.writeMessage(s)}k(s,c){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let S=2;s.byteLength<126?S+=0:s.byteLength<2**16?S+=2:S+=8;const E=k.VSBuffer.alloc(S);if(c?E.writeUInt8(194,0):E.writeUInt8(130,0),s.byteLength<126)E.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){E.writeUInt8(126,1);let A=1;E.writeUInt8(s.byteLength>>>8&255,++A),E.writeUInt8(s.byteLength>>>0&255,++A)}else{E.writeUInt8(127,1);let A=1;E.writeUInt8(0,++A),E.writeUInt8(0,++A),E.writeUInt8(0,++A),E.writeUInt8(0,++A),E.writeUInt8(s.byteLength>>>24&255,++A),E.writeUInt8(s.byteLength>>>16&255,++A),E.writeUInt8(s.byteLength>>>8&255,++A),E.writeUInt8(s.byteLength>>>0&255,++A)}this.socket.write(k.VSBuffer.concat([E,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const c=this.b.peek(this.j.readLen),S=c.readUInt8(0),E=(S&128)>>>7,A=(S&64)>>>6,N=c.readUInt8(1),M=(N&128)>>>7,B=N&127;this.j.state=2,this.j.readLen=2+(M?4:0)+(B===126?2:0)+(B===127?8:0),this.j.fin=E,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(A)),this.j.firstFrameOfMessage=Boolean(E),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const c=this.b.read(this.j.readLen),S=c.readUInt8(1),E=(S&128)>>>7;let A=S&127,N=1;A===126?A=c.readUInt8(++N)*2**8+c.readUInt8(++N):A===127&&(A=c.readUInt8(++N)*0+c.readUInt8(++N)*0+c.readUInt8(++N)*0+c.readUInt8(++N)*0+c.readUInt8(++N)*2**24+c.readUInt8(++N)*2**16+c.readUInt8(++N)*2**8+c.readUInt8(++N));let M=0;E&&(M=c.readUInt8(++N)*2**24+c.readUInt8(++N)*2**16+c.readUInt8(++N)*2**8+c.readUInt8(++N)),this.j.state=3,this.j.readLen=A,this.j.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const c=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",c),p(c,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",c),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(c,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class f extends D.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:k.VSBuffer.alloc(0)}constructor(s,c,S,E,A,N){super(),this.k=s,this.l=A,this.m=N,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new l.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,c?(this.b=this.B(new u(this.k,E,S,{windowBits:15})),this.f=this.B(new d(this.k,{windowBits:15})),this.B(this.b.onError(M=>this.a.fire(M))),this.B(this.f.onError(M=>this.a.fire(M)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const c=await this.r(this.f,s);this.m(c,!0)}else this.m(s,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(s,c){return new Promise((S,E)=>{s.write(c),s.flush(A=>S(A))})}acceptFrame(s,c,S){this.h.push({data:s,isCompressed:c,isLastFrameOfMessage:S}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const c=await this.u(this.b,s.data,s.isLastFrameOfMessage);this.l.fire(c)}else this.l.fire(s.data)}this.s=!1}}u(s,c,S){return new Promise((E,A)=>{s.write(c),S&&s.write(k.VSBuffer.fromByteArray([0,0,255,255])),s.flush(N=>E(N))})}}class u extends D.Disposable{get recordedInflateBytes(){return this.j?k.VSBuffer.concat(this.f):k.VSBuffer.alloc(0)}constructor(s,c,S,E){super(),this.h=s,this.j=c,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=w().zlib.createInflateRaw(E),this.b.on("error",A=>{this.h.traceSocketEvent("zlibInflateError",{message:A?.message,code:A?.code}),this.a.fire(A)}),this.b.on("data",A=>{this.h.traceSocketEvent("zlibInflateData",A),this.g.push(k.VSBuffer.wrap(A))}),S&&(this.h.traceSocketEvent("zlibInflateInitialWrite",S.buffer),this.b.write(S.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const c=k.VSBuffer.concat(this.g);this.g.length=0,s(c)})}}class d extends D.Disposable{constructor(s,c){super(),this.g=s,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.b=w().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",S=>{this.g.traceSocketEvent("zlibDeflateError",{message:S?.message,code:S?.code}),this.a.fire(S)}),this.b.on("data",S=>{this.g.traceSocketEvent("zlibDeflateData",S),this.f.push(k.VSBuffer.wrap(S))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let c=k.VSBuffer.concat(this.f);this.f.length=0,c=c.slice(0,c.byteLength-4),s(c)})}}function p(o,s){if(s===0)return;const c=o.byteLength>>>2;for(let B=0;B<c;B++){const O=o.readUInt32BE(B*4);o.writeUInt32BE(O^s,B*4)}const S=c*4,E=o.byteLength-S,A=s>>>24&255,N=s>>>16&255,M=s>>>8&255;E>=1&&o.writeUInt8(o.readUInt8(S)^A,S),E>=2&&o.writeUInt8(o.readUInt8(S+1)^N,S+1),E>=3&&o.writeUInt8(o.readUInt8(S+2)^M,S+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const b={[2]:107,[1]:103};function C(){const o=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${o}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${o}.sock`):s=(0,T.join)(w().os.tmpdir(),`vscode-ipc-${o}.sock`),a(s),s}e.createRandomIPCHandle=C;function t(o,s,c){const S=w().crypto.createHash("md5").update(o).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${S}-${c}-${s}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${S.substr(0,8)}-${c}-${s}.sock`):E=(0,T.join)(o,`${c}-${s}.sock`),a(E),E}e.createStaticIPCHandle=t;function a(o){const s=b[R.platform];typeof s=="number"&&o.length>=s&&console.warn(`WARNING: IPC handle "${o}" is longer than ${s} chars, try a shorter --user-data-dir`)}class i extends v.IPCServer{static b(s){const c=l.Event.fromNodeEventEmitter(s,"connection");return l.Event.map(c,S=>({protocol:new P.Protocol(new g(S,"ipc-server-connection")),onDidClientDisconnect:l.Event.once(l.Event.fromNodeEventEmitter(S,"close"))}))}constructor(s){super(i.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function n(o){return new Promise((s,c)=>{const S=w().net.createServer();S.on("error",c),S.listen(o,()=>{S.removeListener("error",c),s(new i(S))})})}e.serve=n;function r(o,s){return new Promise((c,S)=>{const E=w().net.createConnection(o,()=>{E.removeListener("error",S),c(P.Client.fromSocket(new g(E,`ipc-client${s}`),s))});E.once("error",S)})}e.connect=r}),define(ne[67],se([0,1,6,3,2,12]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T=e.StorageHint||(e.StorageHint={}));function R(w){const g=w;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var I;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class v extends l.Disposable{constructor(g,h=Object.create(null)){super(),this.m=g,this.n=h,this.b=this.B(new L.Emitter),this.onDidChangeStorage=this.b.event,this.c=I.None,this.f=new Map,this.g=new k.ThrottledDelayer(v.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(g=>this.r(g)))}r(g){g.changed?.forEach((h,m)=>this.s(m,h)),g.deleted?.forEach(h=>this.s(h,void 0))}s(g,h){if(this.c===I.Closed)return;let m=!1;(0,D.isUndefinedOrNull)(h)?m=this.f.delete(g):this.f.get(g)!==h&&(this.f.set(g,h),m=!0),m&&this.b.fire(g)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===I.None&&(this.c=I.Initialized,this.n.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(g,h){const m=this.f.get(g);return(0,D.isUndefinedOrNull)(m)?h:m}getBoolean(g,h){const m=this.get(g);return(0,D.isUndefinedOrNull)(m)?h:m==="true"}getNumber(g,h){const m=this.get(g);return(0,D.isUndefinedOrNull)(m)?h:parseInt(m,10)}async set(g,h){if(this.c===I.Closed)return;if((0,D.isUndefinedOrNull)(h))return this.delete(g);const m=String(h);if(this.f.get(g)!==m)return this.f.set(g,m),this.j.set(g,m),this.h.delete(g),this.b.fire(g),this.w()}async delete(g){if(!(this.c===I.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire(g),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=I.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(g).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(g){if(!!this.u)return this.w(g)}async w(g){return this.g.trigger(()=>this.v(),g)}async whenFlushed(){if(!!this.u)return new Promise(g=>this.l.push(g))}isInMemory(){return this.n.hint===T.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}v.a=100,e.Storage=v;class P{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((h,m)=>this.a.set(m,h)),g.delete?.forEach(h=>this.a.delete(h))}async close(){}}e.InMemoryStorageDatabase=P}),define(ne[156],se([9,7]),function(Z,e){return Z.create("vs/base/node/zip",e)}),define(ne[157],se([9,7]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[158],se([9,7]),function(Z,e){return Z.create("vs/platform/environment/node/argv",e)}),define(ne[159],se([9,7]),function(Z,e){return Z.create("vs/platform/environment/node/argvHelper",e)}),define(ne[160],se([9,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[161],se([9,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[162],se([9,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[163],se([9,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[164],se([9,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[165],se([9,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[166],se([9,7]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[167],se([9,7]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[168],se([9,7]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(ne[169],se([9,7]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(ne[170],se([9,7]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(ne[171],se([9,7]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[172],se([9,7]),function(Z,e){return Z.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[173],se([9,7]),function(Z,e){return Z.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ne[174],se([9,7]),function(Z,e){return Z.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(ne[175],se([9,7]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(ne[176],se([9,7]),function(Z,e){return Z.create("vs/platform/shell/node/shellEnv",e)}),define(ne[177],se([9,7]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ne[178],se([9,7]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[179],se([9,7]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[180],se([9,7]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[181],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[182],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[183],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[184],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[185],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[186],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[187],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ne[188],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[189],se([9,7]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ne[190],se([9,7]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(ne[191],se([0,1,64,62,21,13,36,24,10]),function(Z,e,k,L,l,D,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class v{get appRoot(){return(0,D.dirname)(l.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return I.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.b.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return I.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return I.URI.file((0,D.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(I.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=T.env.VSCODE_PORTABLE;return h?I.URI.file((0,D.join)(h,"argv.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,D.resolve)(h):(0,D.normalize)((0,D.join)(l.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?I.URI.file((0,D.resolve)(h)):I.URI.file((0,D.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,D.resolve)(h);const m=T.env.VSCODE_EXTENSIONS;if(m)return m;const y=T.env.VSCODE_PORTABLE;return y?(0,D.join)(y,"extensions"):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(m=>/^[^:/?#]+?:\/\//.test(m)?I.URI.parse(m):I.URI.file((0,D.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?I.URI.parse(h):I.URI.file((0,D.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const m of this.args.log||[]){const y=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(m);y&&y[1]&&y[2]&&h.push([y[1],y[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return I.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=T.env.VSCODE_PORTABLE;return h?I.URI.file((0,D.join)(h,"policy.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,m,y){this.a=h,this.b=m,this.c=y,this.editSessionId=this.args.editSessionId}}ye([L.memoize],v.prototype,"appRoot",null),ye([L.memoize],v.prototype,"userHome",null),ye([L.memoize],v.prototype,"userDataPath",null),ye([L.memoize],v.prototype,"appSettingsHome",null),ye([L.memoize],v.prototype,"tmpDir",null),ye([L.memoize],v.prototype,"cacheHome",null),ye([L.memoize],v.prototype,"stateResource",null),ye([L.memoize],v.prototype,"userRoamingDataHome",null),ye([L.memoize],v.prototype,"userDataSyncHome",null),ye([L.memoize],v.prototype,"userDataSyncLogResource",null),ye([L.memoize],v.prototype,"editSessionsLogResource",null),ye([L.memoize],v.prototype,"sync",null),ye([L.memoize],v.prototype,"machineSettingsResource",null),ye([L.memoize],v.prototype,"workspaceStorageHome",null),ye([L.memoize],v.prototype,"localHistoryHome",null),ye([L.memoize],v.prototype,"keyboardLayoutResource",null),ye([L.memoize],v.prototype,"argvResource",null),ye([L.memoize],v.prototype,"isExtensionDevelopment",null),ye([L.memoize],v.prototype,"untitledWorkspacesHome",null),ye([L.memoize],v.prototype,"installSourcePath",null),ye([L.memoize],v.prototype,"builtinExtensionsPath",null),ye([L.memoize],v.prototype,"extensionsPath",null),ye([L.memoize],v.prototype,"extensionDevelopmentLocationURI",null),ye([L.memoize],v.prototype,"extensionDevelopmentKind",null),ye([L.memoize],v.prototype,"extensionTestsLocationURI",null),ye([L.memoize],v.prototype,"debugExtensionHost",null),ye([L.memoize],v.prototype,"logLevel",null),ye([L.memoize],v.prototype,"extensionLogLevel",null),ye([L.memoize],v.prototype,"serviceMachineIdResource",null),ye([L.memoize],v.prototype,"telemetryLogResource",null),ye([L.memoize],v.prototype,"disableWorkspaceTrust",null),ye([L.memoize],v.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=v;function P(g,h){return w(g["inspect-extensions"],g["inspect-brk-extensions"],5870,h,g.debugId,g.extensionEnvironment)}e.parseExtensionHostDebugPort=P;function w(g,h,m,y,f,u){const p=Number(h||g)||(y?null:m),b=p?Boolean(!!h):!1;let C;if(u)try{C=JSON.parse(u)}catch{}return{port:p,break:b,debugId:f,env:C}}e.parseDebugParams=w}),define(ne[192],se([0,1,295,4,158]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const D={o:(0,l.localize)(0,null),e:(0,l.localize)(1,null),t:(0,l.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,l.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,l.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,l.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,l.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,l.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,l.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,l.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,l.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,l.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,l.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,l.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,l.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,l.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,l.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,l.localize)(17,null)},category:{type:"string",cat:"e",description:(0,l.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,l.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,l.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,l.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,l.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,l.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,l.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,l.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,l.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,l.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,l.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,l.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,l.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,l.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,l.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,l.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,l.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,l.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(y,f,u=T){const d=y.find(o=>o.length>0&&o[0]!=="-"),p={},b=["_"],C=[],t={};let a;for(const o in f){const s=f[o];s.type==="subcommand"?o===d&&(a=s):(s.alias&&(p[o]=s.alias),s.type==="string"||s.type==="string[]"?(b.push(o),s.deprecates&&b.push(...s.deprecates)):s.type==="boolean"&&(C.push(o),s.deprecates&&C.push(...s.deprecates)),s.global&&(t[o]=s))}if(a&&d){const o=t;for(const E in a.options)o[E]=a.options[E];const s=y.filter(E=>E!==d),c=u.getSubcommandReporter?u.getSubcommandReporter(d):void 0,S=R(s,o,c);return{[d]:S,_:[]}}const i=k(y,{string:b,boolean:C,alias:p}),n={},r=i;n._=i._.map(o=>String(o)).filter(o=>o.length>0),delete r._;for(const o in f){const s=f[o];if(s.type==="subcommand")continue;s.alias&&delete r[s.alias];let c=r[o];if(s.deprecates)for(const S of s.deprecates)r.hasOwnProperty(S)&&(c||(c=r[S],c&&u.onDeprecatedOption(S,s.deprecationMessage||(0,l.localize)(36,null,o))),delete r[S]);if(typeof c<"u"){if(s.type==="string[]"){if(Array.isArray(c)||(c=[c]),!s.allowEmptyValue){const S=c.filter(E=>E.length>0);S.length!==c.length&&(u.onEmptyValue(o),c=S.length>0?S:void 0)}}else s.type==="string"&&(Array.isArray(c)?(c=c.pop(),u.onMultipleValues(o,c)):!c&&!s.allowEmptyValue&&(u.onEmptyValue(o),c=void 0));n[o]=c,s.deprecationMessage&&u.onDeprecatedOption(o,s.deprecationMessage)}delete r[o]}for(const o in r)u.onUnknownOption(o);return n}e.parseArgs=R;function I(y,f){let u="";return f.args&&(Array.isArray(f.args)?u=` <${f.args.join("> <")}>`:u=` <${f.args}>`),f.alias?`-${f.alias} --${y}${u}`:`--${y}${u}`}function v(y,f){const u=[];for(const d in y){const p=y[d],b=I(d,p);u.push([b,p.description])}return P(u,f)}e.formatOptions=v;function P(y,f){const d=y.reduce((C,t)=>Math.max(C,t[0].length),12)+2+1;if(f-d<25)return y.reduce((C,t)=>C.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const p=f-d-1,b=[];for(const C of y){const t=C[0],a=g(C[1],p),i=w(d-t.length-2);b.push("  "+t+i+a[0]);for(let n=1;n<a.length;n++)b.push(w(d)+a[n])}return b}function w(y){return" ".repeat(y)}function g(y,f){const u=[];for(;y.length;){const d=y.length<f?y.length:y.lastIndexOf(" ",f),p=y.slice(0,d).trim();y=y.slice(d),u.push(p)}return u}function h(y,f,u,d,p){const b=process.stdout.isTTY&&process.stdout.columns||80,C=p?.noInputFiles!==!0?`[${(0,l.localize)(37,null)}...]`:"",t=[`${y} ${u}`];t.push(""),t.push(`${(0,l.localize)(38,null)}: ${f} [${(0,l.localize)(39,null)}]${C}`),t.push(""),p?.noPipe!==!0&&(L.isWindows?t.push((0,l.localize)(40,null,f)):t.push((0,l.localize)(41,null,f)),t.push(""));const a={},i=[];for(const n in d){const r=d[n];if(r.type==="subcommand")r.description&&i.push({command:n,description:r.description});else if(r.description&&r.cat){let o=a[r.cat];o||(a[r.cat]=o={}),o[n]=r}}for(const n in a){const r=n,o=a[r];o&&(t.push(D[r]),t.push(...v(o,b)),t.push(""))}return i.length&&(t.push((0,l.localize)(42,null)),t.push(...P(i.map(n=>[n.command,n.description]),b)),t.push("")),t.join(`
`)}e.buildHelpMessage=h;function m(y,f){return`${y||(0,l.localize)(43,null)}
${f||(0,l.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=m}),define(ne[193],se([0,1,296,159,192]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const D=2048;function T(g,h){const m=(b,C)=>{console.warn((0,L.localize)(0,null,b,C))},y=b=>{console.warn((0,L.localize)(1,null,b))},f=(b,C)=>{console.warn((0,L.localize)(2,null,b,C))},u=b=>({onUnknownOption:C=>{b!=="tunnel"&&console.warn((0,L.localize)(3,null,C,b))},onMultipleValues:m,onEmptyValue:y,onDeprecatedOption:f,getSubcommandReporter:b!=="tunnel"?u:void 0}),d={onUnknownOption:b=>{console.warn((0,L.localize)(4,null,b))},onMultipleValues:m,onEmptyValue:y,onDeprecatedOption:f,getSubcommandReporter:u},p=(0,l.parseArgs)(g,l.OPTIONS,h?d:void 0);return p.goto&&p._.forEach(b=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,L.localize)(5,null))),p["max-memory"]&&k(parseInt(p["max-memory"])>=D,`The max-memory argument cannot be specified lower than ${D} MB.`),p}function R(g){const h=g.findIndex(m=>!/^-/.test(m));if(h>-1)return[...g.slice(0,h),...g.slice(h+1)]}function I(g){let[,...h]=g;process.env.VSCODE_DEV&&(h=R(h)||[]);const m=!w(process.env);return T(h,m)}e.parseMainProcessArgv=I;function v(g){let[,,...h]=g;return process.env.VSCODE_DEV&&(h=R(h)||[]),T(h,!0)}e.parseCLIProcessArgv=v;function P(g,...h){const m=g.indexOf("--");return m===-1?g.push(...h):g.splice(m,0,...h),g}e.addArg=P;function w(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),function(){"use strict";function Z(e,k,L){function l(T,R){const I=D(T,R),v=[I];return e.isAbsolute(I)||v.unshift(L),e.resolve(...v)}function D(T,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return e.join(v,R);const P=T["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=e.join(w,"AppData","Roaming")}break;case"darwin":v=e.join(k.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(v,R)}return{getUserDataPath:l}}if(typeof define=="function")define(ne[194],se([297,34,36]),function(e,k,L){return Z(e,k,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=Z(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[96],se([0,1,34,191,194]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class D extends L.AbstractNativeEnvironmentService{constructor(v,P){super(v,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,l.getUserDataPath)(v,P.nameShort)},P)}}e.NativeEnvironmentService=D;function T(I,v){return(0,L.parseDebugParams)(I["inspect-ptyhost"],I["inspect-brk-ptyhost"],5877,v,I.extensionEnvironment)}e.parsePtyHostDebugPort=T;function R(I,v){return(0,L.parseDebugParams)(I["inspect-sharedprocess"],I["inspect-brk-sharedprocess"],5879,v,I.extensionEnvironment)}e.parseSharedProcessDebugPort=R}),define(ne[195],se([0,1,10]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,l=/^([^@:]+@)?([^:]+):(.+)$/,D=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function v(f){const u=f.match(T);return u?u[1]:null}function P(f){if(f.indexOf("://")===-1){const u=f.match(L);return u?v(u[2]):null}try{const u=k.URI.parse(f);if(u.authority)return v(u.authority)}catch{}return null}function w(f,u){const d=new Set;let p;for(;p=R.exec(f);){const C=P(p[1]);C&&d.add(C)}const b=new Set(u);return Array.from(d).map(C=>b.has(C)?C:C.replace(I,"a"))}e.getDomainsOfRemotes=w;function g(f){const u=f.match(D);return u?u[2]:null}function h(f,u,d){return f&&u?(d&&u.endsWith(".git")&&(u=u.substr(0,u.length-4)),u.indexOf("/")===0?`${f}${u}`:`${f}/${u}`):null}function m(f,u){if(f.indexOf("://")===-1){const d=f.match(l);if(d)return h(d[2],d[3],u)}try{const d=k.URI.parse(f);if(d.authority)return h(g(d.authority),d.path,u)}catch{}return null}function y(f,u=!1){const d=[];let p;for(;p=R.exec(f);){const b=m(p[1],u);b&&d.push(b)}return d}e.getRemotes=y}),define(ne[196],se([0,1,12,162]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function l(T,R,I){try{D(T,R,I)}catch(v){console.error(v?.message??v)}return T}e.localizeManifest=l;function D(T,R,I){const v=(P,w,g)=>{const h=P[w];if((0,k.isString)(h)){const m=h,y=m.length;if(y>1&&m[0]==="%"&&m[y-1]==="%"){const f=m.substr(1,y-2);let u=R[f];u===void 0&&I&&(u=I[f]);const d=typeof u=="string"?u:u?.message,p=I?.[f],b=typeof p=="string"?p:p?.message;if(!d){b||console.warn(`[${T.name}]: ${(0,L.localize)(0,null,f)}`);return}if(g&&(w==="title"||w==="category")&&b&&b!==d){const C={value:d,original:b};P[w]=C}else P[w]=d}}else if((0,k.isObject)(h))for(const m in h)h.hasOwnProperty(m)&&(m==="commands"?v(h,m,!0):v(h,m,g));else if(Array.isArray(h))for(let m=0;m<h.length;m++)v(h,m,g)};for(const P in T)T.hasOwnProperty(P)&&v(T,P)}}),define(ne[197],se([0,1,8]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class L{constructor(){this.a=new Map}register(D,T){this.a.set(D,T)}updateManifest(D){if(!(typeof D.main>"u"&&typeof D.browser>"u")&&(D.activationEvents===void 0&&Object.assign(D,{activationEvents:[]}),!(!Array.isArray(D.activationEvents)||!D.contributes)))for(const T in D.contributes){const R=this.a.get(T);if(!R)continue;const I=D.contributes[T],v=Array.isArray(I)?I:[I];try{R(v,D.activationEvents)}catch(P){(0,k.onUnexpectedError)(P)}}}}e.ImplicitActivationEventsImpl=L,e.ImplicitActivationEvents=new L}),define(ne[198],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(D){this.a=D}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(D,T,R,I){return this.a.call("promptImportantExtensionsInstallNotification",[D,T,R,I])}promptWorkspaceRecommendations(D){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class L{constructor(D){this.a=D}listen(D,T){throw new Error(`Event not found: ${T}`)}call(D,T,R){switch(T){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(ne[68],se([0,1,24,89,167,54]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function I(u){return u=u.trim(),u==="*"||T.test(u)}e.isValidVersionStr=I;function v(u){if(!I(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=u.match(T);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=v;function P(u){if(!u)return null;const d=u.majorBase,p=u.majorMustEqual,b=u.minorBase;let C=u.minorMustEqual;const t=u.patchBase;let a=u.patchMustEqual;u.hasCaret&&(d===0||(C=!1),a=!1);let i=0;if(u.preRelease){const n=R.exec(u.preRelease);if(n){const[,r,o,s]=n;i=Date.UTC(Number(r),Number(o)-1,Number(s))}}return{majorBase:d,majorMustEqual:p,minorBase:b,minorMustEqual:C,patchBase:t,patchMustEqual:a,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=P;function w(u,d,p){let b;typeof u=="string"?b=P(v(u)):b=u;let C;d instanceof Date?C=d.getTime():typeof d=="string"&&(C=new Date(d).getTime());let t;if(typeof p=="string"?t=P(v(p)):t=p,!b||!t)return!1;const a=b.majorBase,i=b.minorBase,n=b.patchBase;let r=t.majorBase,o=t.minorBase,s=t.patchBase;const c=t.notBefore;let S=t.majorMustEqual,E=t.minorMustEqual,A=t.patchMustEqual;return t.isMinimum?a>r?!0:a<r?!1:i>o?!0:i<o||C&&C<c?!1:n>=s:(a===1&&r===0&&(!S||!E||!A)&&(r=1,o=0,s=0,S=!0,E=!1,A=!1),a<r?!1:a>r?!S:i<o?!1:i>o?!E:n<s?!1:n>s?!A:!(C&&C<c))}e.isValidVersion=w;function g(u,d,p,b,C){const t=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return t.push([L.default.Error,l.localize(0,null)]),t;if(typeof b.name!="string")return t.push([L.default.Error,l.localize(1,null,"name")]),t;if(typeof b.version!="string")return t.push([L.default.Error,l.localize(2,null,"version")]),t;if(!b.engines)return t.push([L.default.Error,l.localize(3,null,"engines")]),t;if(typeof b.engines.vscode!="string")return t.push([L.default.Error,l.localize(4,null,"engines.vscode")]),t;if(typeof b.extensionDependencies<"u"&&!f(b.extensionDependencies))return t.push([L.default.Error,l.localize(5,null,"extensionDependencies")]),t;if(typeof b.activationEvents<"u"){if(!f(b.activationEvents))return t.push([L.default.Error,l.localize(6,null,"activationEvents")]),t;if(typeof b.main>"u"&&typeof b.browser>"u")return t.push([L.default.Error,l.localize(7,null,"activationEvents","main")]),t}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&t.push([L.default.Warning,l.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return t.push([L.default.Error,l.localize(9,null,"main")]),t;{const n=(0,k.joinPath)(p,b.main);(0,k.isEqualOrParent)(n,p)||t.push([L.default.Warning,l.localize(10,null,n.path,p.path)])}if(typeof b.activationEvents>"u")return t.push([L.default.Error,l.localize(11,null,"activationEvents","main")]),t}if(typeof b.browser<"u"){if(typeof b.browser!="string")return t.push([L.default.Error,l.localize(12,null,"browser")]),t;{const n=(0,k.joinPath)(p,b.browser);(0,k.isEqualOrParent)(n,p)||t.push([L.default.Warning,l.localize(13,null,n.path,p.path)])}if(typeof b.activationEvents>"u")return t.push([L.default.Error,l.localize(14,null,"activationEvents","browser")]),t}if(!D.valid(b.version))return t.push([L.default.Error,l.localize(15,null)]),t;const a=[];if(!h(u,d,b,C,a))for(const n of a)t.push([L.default.Error,n]);return t}e.validateExtensionManifest=g;function h(u,d,p,b,C){return b||typeof p.main>"u"&&typeof p.browser>"u"?!0:y(u,d,p.engines.vscode,C)}e.isValidExtensionVersion=h;function m(u,d,p){return u==="*"||y(d,p,u)}e.isEngineValid=m;function y(u,d,p,b=[]){const C=P(v(p));if(!C)return b.push(l.localize(16,null,p)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return b.push(l.localize(17,null,p)),!1}else if(!C.majorMustEqual)return b.push(l.localize(18,null,p)),!1;return w(u,d,C)?!0:(b.push(l.localize(19,null,u,p)),!1)}function f(u){if(!Array.isArray(u))return!1;for(let d=0,p=u.length;d<p;d++)if(typeof u[d]!="string")return!1;return!0}}),define(ne[44],se([0,1,17,31]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function l(D,T,R){let I=R&&R.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const P=(await T.readFile(D.serviceMachineIdResource)).value.toString();I=(0,L.isUUID)(P)?P:null}catch{I=null}if(!I){I=(0,L.generateUuid)();try{await T.writeFile(D.serviceMachineIdResource,k.VSBuffer.fromString(I))}catch{}}return R?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=l}),define(ne[55],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(l,D=[],T=!1){this.ctor=l,this.staticArguments=D,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=k}),define(ne[69],se([0,1,55]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var l;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function D(R,I,v){I instanceof k.SyncDescriptor||(I=new k.SyncDescriptor(I,[],Boolean(v))),L.push([R,I])}e.registerSingleton=D;function T(){return L}e.getSingletonServiceDescriptors=T}),define(ne[199],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(D,T){this.key=D,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=k;class L{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const T of this.a.values())T.outgoing.size===0&&D.push(T);return D}insertEdge(D,T){const R=this.lookupOrInsertNode(D),I=this.lookupOrInsertNode(T);R.outgoing.set(I.key,I),I.incoming.set(R.key,R)}removeNode(D){const T=this.b(D);this.a.delete(T);for(const R of this.a.values())R.outgoing.delete(T),R.incoming.delete(T)}lookupOrInsertNode(D){const T=this.b(D);let R=this.a.get(T);return R||(R=new k(T,D),this.a.set(T,R)),R}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[T,R]of this.a)D.push(`${T}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,T]of this.a){const R=new Set([D]),I=this.c(T,R);if(I)return I}}c(D,T){for(const[R,I]of D.outgoing){if(T.has(R))return[...T,R].join(" -> ");T.add(R);const v=this.c(I,T);if(v)return v;T.delete(R)}}}e.Graph=L}),define(ne[5],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function R(I){return I[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=R})(k=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function L(T,R,I){R[k.DI_TARGET]===R?R[k.DI_DEPENDENCIES].push({id:T,index:I}):(R[k.DI_DEPENDENCIES]=[{id:T,index:I}],R[k.DI_TARGET]=R)}function l(T){if(k.serviceIds.has(T))return k.serviceIds.get(T);const R=function(I,v,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(R,I,P)};return R.toString=()=>T,k.serviceIds.set(T,R),R}e.createDecorator=l;function D(T){return T}e.refineServiceDecorator=D}),define(ne[200],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(ne[16],se([0,1,12,10,5]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function D(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof L.URI)}e.isConfigurationOverrides=D;function T(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=T;var R;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function v(f,u){const d=Object.create(null);for(const p in f)P(d,p,f[p],u);return d}e.toValuesTree=v;function P(f,u,d,p){const b=u.split("."),C=b.pop();let t=f;for(let a=0;a<b.length;a++){const i=b[a];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:p(`Ignoring ${u} as ${b.slice(0,a+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[C]=d}catch{p(`Ignoring ${u} as ${b.join(".")} is ${JSON.stringify(t)}`)}else p(`Ignoring ${u} as ${b.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=P;function w(f,u){const d=u.split(".");g(f,d)}e.removeFromValueTree=w;function g(f,u){const d=u.shift();if(u.length===0){delete f[d];return}if(Object.keys(f).indexOf(d)!==-1){const p=f[d];typeof p=="object"&&!Array.isArray(p)&&(g(p,u),Object.keys(p).length===0&&delete f[d])}}function h(f,u,d){function p(t,a){let i=t;for(const n of a){if(typeof i!="object"||i===null)return;i=i[n]}return i}const b=u.split("."),C=p(f,b);return typeof C>"u"?d:C}e.getConfigurationValue=h;function m(f,u,d){Object.keys(u).forEach(p=>{p!=="__proto__"&&(p in f?k.isObject(f[p])&&k.isObject(u[p])?m(f[p],u[p],d):d&&(f[p]=u[p]):f[p]=u[p])})}e.merge=m;function y(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(ne[201],se([0,1,4,26,5]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",k.isMacintosh),D.set("isLinux",k.isLinux),D.set("isWindows",k.isWindows),D.set("isWeb",k.isWeb),D.set("isMacNative",k.isMacintosh&&!k.isWeb),D.set("isEdge",k.isEdge),D.set("isFirefox",k.isFirefox),D.set("isChrome",k.isChrome),D.set("isSafari",k.isSafari);const T=Object.prototype.hasOwnProperty;var R;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return w.INSTANCE}static true(){return g.INSTANCE}static has(O){return h.create(O)}static equals(O,j){return m.create(O,j)}static notEquals(O,j){return u.create(O,j)}static regex(O,j){return i.create(O,j)}static in(O,j){return y.create(O,j)}static notIn(O,j){return f.create(O,j)}static not(O){return d.create(O)}static and(...O){return o.create(O,null,!0)}static or(...O){return s.create(O,null,!0)}static greater(O,j){return b.create(O,j)}static greaterEquals(O,j){return C.create(O,j)}static smaller(O,j){return t.create(O,j)}static smallerEquals(O,j){return a.create(O,j)}static deserialize(O){if(!!O)return this.c(O)}static c(O){const j=O.split("||");return s.create(j.map(q=>this.d(q)),null,!0)}static d(O){const j=O.split("&&");return o.create(j.map(q=>this.f(q)),null,!0)}static f(O){if(O=O.trim(),O.indexOf("!=")>=0){const j=O.split("!=");return u.create(j[0].trim(),this.g(j[1]))}if(O.indexOf("==")>=0){const j=O.split("==");return m.create(j[0].trim(),this.g(j[1]))}if(O.indexOf("=~")>=0){const j=O.split("=~");return i.create(j[0].trim(),this.h(j[1]))}if(O.indexOf(" not in ")>=0){const j=O.split(" not in ");return f.create(j[0].trim(),this.g(j[1]))}if(O.indexOf(" in ")>=0){const j=O.split(" in ");return y.create(j[0].trim(),this.g(j[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(O)){const j=O.split(">=");return C.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(O)){const j=O.split(">");return b.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(O)){const j=O.split("<=");return a.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(O)){const j=O.split("<");return t.create(j[0].trim(),j[1].trim())}return/^\!\s*/.test(O)?d.create(O.substr(1).trim()):h.create(O)}static g(O){if(O=O.trim(),O==="true")return!0;if(O==="false")return!1;const j=/^'([^']*)'$/.exec(O);return j?j[1].trim():O}static h(O){if((0,L.isFalsyOrWhitespace)(O))return console.warn("missing regexp-value for =~-expression"),null;const j=O.indexOf("/"),q=O.lastIndexOf("/");if(j===q||j<0)return console.warn(`bad regexp-value '${O}', missing /-enclosure`),null;const K=O.slice(j+1,q),Q=O[q+1]==="i"?"i":"";try{return new RegExp(K,Q)}catch(re){return console.warn(`bad regexp-value '${O}', parse error: ${re}`),null}}}e.ContextKeyExpr=I;function v(B,O){const j=B?B.substituteConstants():void 0,q=O?O.substituteConstants():void 0;return!j&&!q?!0:!j||!q?!1:j.equals(q)}e.expressionsAreEqualWithConstantSubstitution=v;function P(B,O){return B.cmp(O)}class w{constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return g.INSTANCE}}w.INSTANCE=new w,e.ContextKeyFalseExpr=w;class g{constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return w.INSTANCE}}g.INSTANCE=new g,e.ContextKeyTrueExpr=g;class h{static create(O,j=null){const q=D.get(O);return typeof q=="boolean"?q?g.INSTANCE:w.INSTANCE:new h(O,j)}constructor(O,j){this.key=O,this.c=j,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:S(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=D.get(this.key);return typeof O=="boolean"?O?g.INSTANCE:w.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=d.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=h;class m{static create(O,j,q=null){if(typeof j=="boolean")return j?h.create(O,q):d.create(O,q);const K=D.get(O);return typeof K=="boolean"?j===(K?"true":"false")?g.INSTANCE:w.INSTANCE:new m(O,j,q)}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:E(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=D.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?g.INSTANCE:w.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=m;class y{static create(O,j){return new y(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:E(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.f),q=O.getValue(this.d);return Array.isArray(j)?j.includes(q):typeof q=="string"&&typeof j=="object"&&j!==null?T.call(j,q):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=y;class f{static create(O,j){return new f(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=11,this.c=y.create(O,j)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=f;class u{static create(O,j,q=null){if(typeof j=="boolean")return j?d.create(O,q):h.create(O,q);const K=D.get(O);return typeof K=="boolean"?j===(K?"true":"false")?w.INSTANCE:g.INSTANCE:new u(O,j,q)}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:E(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=D.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?w.INSTANCE:g.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=u;class d{static create(O,j=null){const q=D.get(O);return typeof q=="boolean"?q?w.INSTANCE:g.INSTANCE:new d(O,j)}constructor(O,j){this.c=O,this.d=j,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:S(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=D.get(this.c);return typeof O=="boolean"?O?w.INSTANCE:g.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=h.create(this.c,this)),this.d}}e.ContextKeyNotExpr=d;function p(B,O){if(typeof B=="string"){const j=parseFloat(B);isNaN(j)||(B=j)}return typeof B=="string"||typeof B=="number"?O(B):w.INSTANCE}class b{static create(O,j,q=null){return p(j,K=>new b(O,K,q))}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:E(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=a.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=b;class C{static create(O,j,q=null){return p(j,K=>new C(O,K,q))}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:E(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=t.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=C;class t{static create(O,j,q=null){return p(j,K=>new t(O,K,q))}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:E(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=t;class a{static create(O,j,q=null){return p(j,K=>new a(O,K,q))}constructor(O,j,q){this.c=O,this.d=j,this.f=q,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:E(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=a;class i{static create(O,j){return new i(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const j=this.f?this.f.source:"",q=O.f?O.f.source:"";return j<q?-1:j>q?1:0}equals(O){if(O.type===this.type){const j=this.f?this.f.source:"",q=O.f?O.f.source:"";return this.d===O.d&&j===q}return!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=n.create(this)),this.c}}e.ContextKeyRegexExpr=i;class n{static create(O){return new n(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(O){return new n(this.c.map(O))}negate(){return this.c}}e.ContextKeyNotRegexExpr=n;function r(B){let O=null;for(let j=0,q=B.length;j<q;j++){const K=B[j].substituteConstants();if(B[j]!==K&&O===null){O=[];for(let Q=0;Q<j;Q++)O[Q]=B[Q]}O!==null&&(O[j]=K)}return O===null?B:O}class o{static create(O,j,q){return o.d(O,j,q)}constructor(O,j){this.expr=O,this.c=j,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,q=this.expr.length;j<q;j++){const K=P(this.expr[j],O.expr[j]);if(K!==0)return K}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,q=this.expr.length;j<q;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=r(this.expr);return O===this.expr?this:o.create(O,this.c,!1)}evaluate(O){for(let j=0,q=this.expr.length;j<q;j++)if(!this.expr[j].evaluate(O))return!1;return!0}static d(O,j,q){const K=[];let Q=!1;for(const re of O)if(!!re){if(re.type===1){Q=!0;continue}if(re.type===0)return w.INSTANCE;if(re.type===6){K.push(...re.expr);continue}K.push(re)}if(K.length===0&&Q)return g.INSTANCE;if(K.length!==0){if(K.length===1)return K[0];K.sort(P);for(let re=1;re<K.length;re++)K[re-1].equals(K[re])&&(K.splice(re,1),re--);if(K.length===1)return K[0];for(;K.length>1;){const re=K[K.length-1];if(re.type!==9)break;K.pop();const J=K.pop(),W=K.length===0,F=s.create(re.expr.map(G=>o.create([G,J],null,q)),null,W);F&&(K.push(F),K.sort(P))}if(K.length===1)return K[0];if(q){for(let re=0;re<K.length;re++)for(let J=re+1;J<K.length;J++)if(K[re].negate().equals(K[J]))return w.INSTANCE;if(K.length===1)return K[0]}return new o(K,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new o(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());this.c=s.create(O,this,!0)}return this.c}}class s{static create(O,j,q){return s.d(O,j,q)}constructor(O,j){this.expr=O,this.c=j,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,q=this.expr.length;j<q;j++){const K=P(this.expr[j],O.expr[j]);if(K!==0)return K}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,q=this.expr.length;j<q;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=r(this.expr);return O===this.expr?this:s.create(O,this.c,!1)}evaluate(O){for(let j=0,q=this.expr.length;j<q;j++)if(this.expr[j].evaluate(O))return!0;return!1}static d(O,j,q){let K=[],Q=!1;if(O){for(let re=0,J=O.length;re<J;re++){const W=O[re];if(!!W){if(W.type===0){Q=!0;continue}if(W.type===1)return g.INSTANCE;if(W.type===9){K=K.concat(W.expr);continue}K.push(W)}}if(K.length===0&&Q)return w.INSTANCE;K.sort(P)}if(K.length!==0){if(K.length===1)return K[0];for(let re=1;re<K.length;re++)K[re-1].equals(K[re])&&(K.splice(re,1),re--);if(K.length===1)return K[0];if(q){for(let re=0;re<K.length;re++)for(let J=re+1;J<K.length;J++)if(K[re].negate().equals(K[J]))return g.INSTANCE;if(K.length===1)return K[0]}return new s(K,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new s(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());for(;O.length>1;){const j=O.shift(),q=O.shift(),K=[];for(const Q of M(j))for(const re of M(q))K.push(o.create([Q,re],null,!1));O.unshift(s.create(K,null,!1))}this.c=s.create(O,this,!0)}return this.c}}class c extends h{static all(){return c.d.values()}constructor(O,j,q){super(O,null),this.f=j,typeof q=="object"?c.d.push({...q,key:O}):q!==!0&&c.d.push({key:O,description:q,type:j!=null?typeof j:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return m.create(this.key,O)}notEqualsTo(O){return u.create(this.key,O)}}c.d=[],e.RawContextKey=c,e.IContextKeyService=(0,l.createDecorator)("contextKeyService");function S(B,O){return B<O?-1:B>O?1:0}function E(B,O,j,q){return B<j?-1:B>j?1:O<q?-1:O>q?1:0}function A(B,O){if(B.type===0||O.type===1)return!0;if(B.type===9)return O.type===9?N(B.expr,O.expr):!1;if(O.type===9){for(const j of O.expr)if(A(B,j))return!0;return!1}if(B.type===6){if(O.type===6)return N(O.expr,B.expr);for(const j of B.expr)if(A(j,O))return!0;return!1}return B.equals(O)}e.implies=A;function N(B,O){let j=0,q=0;for(;j<B.length&&q<O.length;){const K=B[j].cmp(O[q]);if(K<0)return!1;K===0&&j++,q++}return j===B.length}function M(B){return B.type===9?B.expr:[B]}}),define(ne[97],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function L(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=L;class l{async getPerformanceInfo(T,R){return{}}async getSystemInfo(T,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,R){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=l}),define(ne[98],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(ne[15],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[29],se([0,1,161,5]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function D(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function T(u,d){switch(u){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function R(u,d){return d==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function I(u,d,p){return R(d,p)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===p?!0:v(p).includes(u)}e.isTargetPlatformCompatible=I;function v(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=v;function P(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=P;var w;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var g;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(g=e.SortOrder||(e.SortOrder={}));var h;(function(u){u.Install="install",u.Uninstall="uninstall"})(h=e.StatisticType||(e.StatisticType={}));var m;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var y;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(d,p){super(d),this.code=p,this.name=p}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,k.localize)(1,null),original:"Preferences"}}),define(ne[202],se([0,1,3,2,32,10,92,29]),function(Z,e,k,L,l,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function I(f,u){return f?D.URI.revive(u?u.transformIncoming(f):f):void 0}function v(f,u){return u?u.transformOutgoingURI(f):f}function P(f,u){u=u||T.DefaultURITransformer;const d=f.manifest;return{...(0,T.transformAndReviveIncomingURIs)({...f,manifest:void 0},u),manifest:d}}function w(f,u){return f?.profileLocation?(0,T.transformAndReviveIncomingURIs)(f,u??T.DefaultURITransformer):f}function g(f,u){return u?(0,l.cloneAndChange)(f,d=>d instanceof D.URI?u.transformOutgoingURI(d):void 0):f}class h{constructor(u,d){this.a=u,this.b=d,this.onInstallExtension=k.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=k.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,d){const p=this.b(u);switch(d){case"onInstallExtension":return k.Event.map(this.onInstallExtension,b=>({...b,profileLocation:b.profileLocation?v(b.profileLocation,p):b.profileLocation}));case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,b=>b.map(C=>({...C,local:C.local?g(C.local,p):C.local,profileLocation:C.profileLocation?v(C.profileLocation,p):C.profileLocation})));case"onUninstallExtension":return k.Event.map(this.onUninstallExtension,b=>({...b,profileLocation:b.profileLocation?v(b.profileLocation,p):b.profileLocation}));case"onDidUninstallExtension":return k.Event.map(this.onDidUninstallExtension,b=>({...b,profileLocation:b.profileLocation?v(b.profileLocation,p):b.profileLocation}));case"onDidUpdateExtensionMetadata":return k.Event.map(this.onDidUpdateExtensionMetadata,b=>g(b,p))}throw new Error("Invalid listen")}async call(u,d,p){const b=this.b(u);switch(d){case"zip":{const C=P(p[0],b),t=await this.a.zip(C);return v(t,b)}case"unzip":return this.a.unzip(I(p[0],b));case"install":return this.a.install(I(p[0],b),w(p[1],b));case"installFromLocation":return this.a.installFromLocation(I(p[0],b),I(p[1],b));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(p[0],I(p[1],b),I(p[2],b));case"getManifest":return this.a.getManifest(I(p[0],b));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(p[0]);case"installFromGallery":return this.a.installFromGallery(p[0],w(p[1],b));case"uninstall":return this.a.uninstall(P(p[0],b),w(p[1],b));case"reinstallFromGallery":return this.a.reinstallFromGallery(P(p[0],b));case"getInstalled":return(await this.a.getInstalled(p[0],I(p[1],b))).map(t=>g(t,b));case"copyExtensions":return this.a.copyExtensions(I(p[0],b),I(p[1],b));case"updateMetadata":{const C=await this.a.updateMetadata(P(p[0],b),p[1],I(p[2],b));return g(C,b)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(p[0],p[1]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=h;class m extends L.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.k=u,this.c=this.B(new k.Emitter),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=this.B(new k.Emitter),this.j=this.B(new k.Emitter),this.B(this.k.listen("onInstallExtension")(d=>this.l(this.c,{...d,source:this.m(d.source)?D.URI.revive(d.source):d.source,profileLocation:D.URI.revive(d.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(d=>this.l(this.f,d.map(p=>({...p,local:p.local?P(p.local,null):p.local,source:this.m(p.source)?D.URI.revive(p.source):p.source,profileLocation:D.URI.revive(p.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(d=>this.l(this.g,{...d,profileLocation:D.URI.revive(d.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(d=>this.l(this.h,{...d,profileLocation:D.URI.revive(d.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(d=>this.j.fire(P(d,null))))}l(u,d){u.fire(d)}m(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(u){const d=await this.getTargetPlatform();return u.allTargetPlatforms.some(p=>(0,R.isTargetPlatformCompatible)(p,u.allTargetPlatforms,d))}zip(u){return Promise.resolve(this.k.call("zip",[u]).then(d=>D.URI.revive(d)))}unzip(u){return Promise.resolve(this.k.call("unzip",[u]))}install(u,d){return Promise.resolve(this.k.call("install",[u,d])).then(p=>P(p,null))}installFromLocation(u,d){return Promise.resolve(this.k.call("installFromLocation",[u,d])).then(p=>P(p,null))}async installExtensionsFromProfile(u,d,p){return(await this.k.call("installExtensionsFromProfile",[u,d,p])).map(C=>P(C,null))}getManifest(u){return Promise.resolve(this.k.call("getManifest",[u]))}installFromGallery(u,d){return Promise.resolve(this.k.call("installFromGallery",[u,d])).then(p=>P(p,null))}uninstall(u,d){return Promise.resolve(this.k.call("uninstall",[u,d]))}reinstallFromGallery(u){return Promise.resolve(this.k.call("reinstallFromGallery",[u])).then(d=>P(d,null))}getInstalled(u=null,d){return Promise.resolve(this.k.call("getInstalled",[u,d])).then(p=>p.map(b=>P(b,null)))}updateMetadata(u,d,p){return Promise.resolve(this.k.call("updateMetadata",[u,d,p])).then(b=>P(b,null))}copyExtensions(u,d){return this.k.call("copyExtensions",[u,d])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(u,d){const p=await this.k.call("download",[u,d]);return D.URI.revive(p)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=m;class y{constructor(u){this.a=u}listen(u,d){throw new Error("Invalid listen")}call(u,d,p){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(D.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=y}),define(ne[99],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,k.createDecorator)("IExtensionSignatureVerificationService");class L{b(){return this.a||(this.a=new Promise((D,T)=>Z(["node-vsce-sign"],async R=>D(R),T))),this.a}async verify(D,T){let R;try{R=await this.b()}catch{return!1}return R.verify(D,T)}}e.ExtensionSignatureVerificationService=L}),define(ne[100],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function l(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=l;var D;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(D=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[14],se([0,1,49,13,26,12,10,169,5,4,21]),function(Z,e,k,L,l,D,T,R,I,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function w(F){return F.create===!0}e.isFileOpenForWriteOptions=w;var g;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(g=e.FileType||(e.FileType={}));var h;(function(F){F[F.Readonly=1]="Readonly"})(h=e.FilePermission||(e.FilePermission={}));var m;(function(F){F[F.None=0]="None",F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock",F[F.FileAtomicRead=16384]="FileAtomicRead",F[F.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=y;function f(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=f;function u(F){return!!(F.capabilities&32768)}e.hasFileCloneCapability=u;function d(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function p(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=p;function b(F){return y(F)?!!(F.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var C;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(G,ee){const oe=new t(G.toString(),ee);return n(oe,ee),oe}constructor(G,ee){super(G),this.code=ee}}e.FileSystemProviderError=t;function a(F,G){return t.create(F,G)}e.createFileSystemProviderError=a;function i(F){return F||a((0,R.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=i;function n(F,G){return F.name=G?`${G} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=n;function r(F){if(!F)return C.Unknown;if(F instanceof t)return F.code;const G=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!G)return C.Unknown;switch(G[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=r;function o(F){if(F instanceof N)return F.fileOperationResult;switch(r(F)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var s;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY",F[F.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class c{constructor(G,ee,oe){this.resource=G,this.operation=ee,this.target=oe}isOperation(G){return this.operation===G}}e.FileOperationEvent=c;var S;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(S=e.FileChangeType||(e.FileChangeType={}));class E{constructor(G,ee){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const oe=new Map;for(const ae of G){const x=oe.get(ae.type);switch(x?x.push([ae.resource,ae]):oe.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,x]of oe)switch(ae){case 1:this.a=k.TernarySearchTree.forUris(()=>ee),this.a.fill(x);break;case 0:this.b=k.TernarySearchTree.forUris(()=>ee),this.b.fill(x);break;case 2:this.c=k.TernarySearchTree.forUris(()=>ee),this.c.fill(x);break}}contains(G,...ee){return this.d(G,{includeChildren:!1},...ee)}affects(G,...ee){return this.d(G,{includeChildren:!0},...ee)}d(G,ee,...oe){if(!G)return!1;const ae=oe.length>0;return!!((!ae||oe.includes(1))&&(this.a?.get(G)||ee.includeChildren&&this.a?.findSuperstr(G))||(!ae||oe.includes(0))&&(this.b?.get(G)||ee.includeChildren&&this.b?.findSuperstr(G))||(!ae||oe.includes(2))&&(this.c?.findSubstr(G)||ee.includeChildren&&this.c?.findSuperstr(G)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=E;function A(F,G,ee){return!F||!G||F===G||G.length>F.length?!1:(G.charAt(G.length-1)!==L.sep&&(G+=L.sep),ee?(0,l.startsWithIgnoreCase)(F,G):F.indexOf(G)===0)}e.isParent=A;class N extends Error{constructor(G,ee,oe){super(G),this.fileOperationResult=ee,this.options=oe}}e.FileOperationError=N;class M extends N{constructor(G,ee,oe,ae){super(G,ee,ae),this.fileOperationResult=ee,this.size=oe}}e.TooLargeFileOperationError=M;class B extends N{constructor(G,ee,oe){super(G,2,oe),this.stat=ee}}e.NotModifiedSinceFileOperationError=B;var O;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var j;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(j=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function q(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=q;async function K(F,G){if(!G.hasProvider(T.URI.from({scheme:F.scheme})))return new Promise(ee=>{const oe=G.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===F.scheme&&ae.added&&(oe.dispose(),ee())})})}e.whenProviderRegistered=K,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Q{static formatSize(G){return(0,D.isNumber)(G)||(G=0),G<Q.KB?(0,R.localize)(1,null,G.toFixed(0)):G<Q.MB?(0,R.localize)(2,null,(G/Q.KB).toFixed(2)):G<Q.GB?(0,R.localize)(3,null,(G/Q.MB).toFixed(2)):G<Q.TB?(0,R.localize)(4,null,(G/Q.GB).toFixed(2)):(0,R.localize)(5,null,(G/Q.TB).toFixed(2))}}Q.KB=1024,Q.MB=Q.KB*Q.KB,Q.GB=Q.MB*Q.KB,Q.TB=Q.GB*Q.KB,e.ByteSize=Q;var re;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(re=e.Arch||(e.Arch={}));function J(F){return{maxFileSize:F===0?300*Q.MB:16*Q.GB,maxHeapSize:F===0?700*Q.MB:2*700*Q.MB}}e.getPlatformFileLimits=J;function W(F){const G=typeof F=="string"||F?.scheme===P.Schemas.vscodeRemote;return typeof F!="string"&&F?.scheme===P.Schemas.file?1024*Q.MB:G?10*Q.MB:v.isWeb?50*Q.MB:1024*Q.MB}e.getLargeFileConfirmationLimit=W});var Y=this&&this.__param||function(Z,e){return function(k,L){e(k,L,Z)}};define(ne[203],se([0,1,101,43,14]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let D=class{constructor(R){this.a=R}async checksum(R){const I=(await this.a.readFileStream(R)).value;return new Promise((v,P)=>{const w=(0,k.createHash)("md5");(0,L.listenStream)(I,{onData:g=>w.update(g.buffer),onError:g=>P(g),onEnd:()=>v(w.digest("base64").replace(/=+$/,""))})})}};D=ye([Y(0,l.IFileService)],D),e.ChecksumService=D}),define(ne[204],se([0,1,17,39,8,3,2,43,10,31,14]),function(Z,e,k,L,l,D,T,R,I,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends T.Disposable{constructor(h,m){super(),this.a=h,this.b=m,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.h=(0,v.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,m){const{buffer:y}=await this.a.call("readFile",[h,m]);return y}readFileStream(h,m,y){const f=(0,R.newWriteableStream)(d=>k.VSBuffer.concat(d.map(p=>k.VSBuffer.wrap(p))).buffer),u=this.a.listen("readFileStream",[h,m])(d=>{if(d instanceof k.VSBuffer)f.write(d.buffer);else{if(d==="end")f.end();else{let p;if(d instanceof Error)p=d;else{const b=d;p=(0,P.createFileSystemProviderError)(b.message??(0,L.toErrorMessage)(b),b.code??P.FileSystemProviderErrorCode.Unknown)}f.error(p),f.end()}u.dispose()}});return y.onCancellationRequested(()=>{f.error((0,l.canceled)()),f.end(),u.dispose()}),f}writeFile(h,m,y){return this.a.call("writeFile",[h,k.VSBuffer.wrap(m),y])}open(h,m){return this.a.call("open",[h,m])}close(h){return this.a.call("close",[h])}async read(h,m,y,f,u){const[d,p]=await this.a.call("read",[h,m,u]);return y.set(d.buffer.slice(0,p),f),p}write(h,m,y,f,u){return this.a.call("write",[h,m,k.VSBuffer.wrap(y),f,u])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,m){return this.a.call("delete",[h,m])}rename(h,m,y){return this.a.call("rename",[h,m,y])}copy(h,m,y){return this.a.call("copy",[h,m,y])}cloneFile(h,m){return this.a.call("cloneFile",[h,m])}i(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const m=h;this.f.fire(m.map(y=>({resource:I.URI.revive(y.resource),type:y.type})))}else{const m=h;this.g.fire(m)}}))}watch(h,m){const y=(0,v.generateUuid)();return this.a.call("watch",[this.h,y,h,m]),(0,T.toDisposable)(()=>this.a.call("unwatch",[this.h,y]))}}e.DiskFileSystemProviderClient=w}),define(ne[102],se([0,1,17,8,170,14]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(P,w,g,h,m,y){let f;try{await R(P,w,g,h,m,y)}catch(u){f=u}finally{f&&m.errorTransformer&&(f=m.errorTransformer(f)),typeof f<"u"&&g.error(f),g.end()}}e.readFileIntoStream=T;async function R(P,w,g,h,m,y){I(y);const f=await P.open(w,{create:!1});try{I(y);let u=0,d=0,p=m&&typeof m.length=="number"?m.length:void 0,b=k.VSBuffer.alloc(Math.min(m.bufferSize,typeof p=="number"?p:m.bufferSize)),C=m&&typeof m.position=="number"?m.position:0,t=0;do d=await P.read(f,C,b.buffer,t,b.byteLength-t),C+=d,t+=d,u+=d,typeof p=="number"&&(p-=d),t===b.byteLength&&(await g.write(h(b)),b=k.VSBuffer.alloc(Math.min(m.bufferSize,typeof p=="number"?p:m.bufferSize)),t=0);while(d>0&&(typeof p!="number"||p>0)&&I(y)&&v(u,m));if(t>0){let a=t;typeof p=="number"&&(a=Math.min(t,p)),g.write(h(b.slice(0,a)))}}catch(u){throw(0,D.ensureFileSystemProviderError)(u)}finally{await P.close(f)}}function I(P){if(P.isCancellationRequested)throw(0,L.canceled)();return!0}function v(P,w){if(w?.limits){if(typeof w.limits.memory=="number"&&P>w.limits.memory)throw(0,D.createFileSystemProviderError)((0,l.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&P>w.limits.size)throw(0,D.createFileSystemProviderError)((0,l.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[56],se([0,1,91,2,13,4,10,14]),function(Z,e,k,L,l,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(u){return u.recursive===!0}e.isRecursiveWatchRequest=I;class v extends L.Disposable{constructor(d,p,b,C){super(),this.h=d,this.i=p,this.j=b,this.k=C,this.c=this.B(new L.MutableDisposable),this.f=void 0,this.g=0}m(){const d=new L.DisposableStore;this.c.value=d,this.b=this.l(d),this.b.setVerboseLogging(this.j),d.add(this.b.onDidChangeFile(p=>this.h(p))),d.add(this.b.onDidLogMessage(p=>this.i(p))),d.add(this.b.onDidError(p=>this.n(p)))}n(d){this.k.restartOnError?this.g<v.a&&this.f?(this.r(`restarting watcher after error: ${d}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${d}`):this.r(d)}p(d){this.g++,this.m(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.j=d,await this.b?.setVerboseLogging(d)}r(d){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${d}`})}s(d){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}v.a=5,e.AbstractWatcherClient=v;class P extends v{constructor(d,p,b){super(d,p,b,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=P;class w extends v{constructor(d,p,b){super(d,p,b,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function g(u){return u.map(d=>({type:d.type,resource:T.URI.file(d.path)}))}e.toFileChanges=g;function h(u){const d=new f;for(const p of u)d.processEvent(p);return d.coalesce()}e.coalesceEvents=h;function m(u,d){return typeof d=="string"&&!d.startsWith(k.GLOBSTAR)&&!(0,l.isAbsolute)(d)?{base:u,pattern:d}:d}e.normalizeWatcherPattern=m;function y(u,d){const p=[];for(const b of d)p.push((0,k.parse)(m(u,b)));return p}e.parseWatcherPatterns=y;class f{constructor(){this.a=new Set,this.b=new Map}c(d){return D.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const p=this.b.get(this.c(d));let b=!1;if(p){const C=p.type,t=d.type;p.path!==d.path&&(d.type===2||d.type===1)?b=!0:C===1&&t===2?(this.b.delete(this.c(d)),this.a.delete(p)):C===2&&t===1?p.type=0:C===1&&t===0||(p.type=t)}else b=!0;b&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],p=[];return Array.from(this.a).filter(b=>b.type!==2?(d.push(b),!1):!0).sort((b,C)=>b.path.length-C.path.length).filter(b=>p.some(C=>(0,R.isParent)(b.path,C,!D.isLinux))?!1:(p.push(b.path),!0)).concat(d)}}}),define(ne[205],se([0,1,53,6,23,48,2,84,13,4,148,27,56]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends T.Disposable{constructor(f,u,d,p){super(),this.j=f,this.k=u,this.l=d,this.m=p,this.c=this.B(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},b=>this.k(b))),this.f=this.B(new L.RunOnceWorker(b=>this.u(b),h.b)),this.g=(0,g.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,g.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new l.CancellationTokenSource,this.ready=this.n()}async n(){try{const f=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const u=await w.Promises.stat(f);this.B(await this.s(f,u.isDirectory()))}catch(f){f.code!=="ENOENT"?this.w(f):this.z(f)}}async r(f){let u=f.path;try{u=await w.Promises.realpath(f.path),f.path===u&&(u=await(0,P.realcase)(f.path)??f.path),f.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${u})`)}catch{}return u}async s(f,u){if(v.isMacintosh&&(0,D.isEqualOrParent)(f,"/Volumes/",!0))return this.w(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const d=new l.CancellationTokenSource(this.i.token),p=new T.DisposableStore;try{const b=(0,I.basename)(f),C=(0,k.watch)(f);p.add((0,T.toDisposable)(()=>{C.removeAllListeners(),C.close()})),this.z(`Started watching: '${f}'`);const t=new Set;if(u)try{for(const i of await w.Promises.readdir(f))t.add(i)}catch(i){this.w(i)}const a=new Map;p.add((0,T.toDisposable)(()=>{for(const[,i]of a)i.dispose();a.clear()})),C.on("error",(i,n)=>{this.w(`Failed to watch ${f} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),C.on("change",(i,n)=>{if(d.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${n}`);let r="";if(n&&(r=n.toString(),v.isMacintosh&&(r=(0,R.normalizeNFC)(r))),!(!r||i!=="change"&&i!=="rename"))if(u)if(i==="rename"){a.get(r)?.dispose();const o=setTimeout(async()=>{if(a.delete(r),r===b&&!await w.Promises.exists(f)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.v((0,I.join)(f,r));if(d.token.isCancellationRequested)return;let c;s?t.has(r)?c=0:(c=1,t.add(r)):(t.delete(r),c=2),this.t({path:(0,I.join)(this.j.path,r),type:c})},h.a);a.set(r,(0,T.toDisposable)(()=>clearTimeout(o)))}else{let o;t.has(r)?o=0:(o=1,t.add(r)),this.t({path:(0,I.join)(this.j.path,r),type:o})}else if(i==="rename"||r!==b){const o=setTimeout(async()=>{const s=await w.Promises.exists(f);d.token.isCancellationRequested||(s?(this.t({path:this.j.path,type:0},!0),p.add(await this.s(f,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},h.a);p.clear(),p.add((0,T.toDisposable)(()=>clearTimeout(o)))}else this.t({path:this.j.path,type:0},!0)})}catch(b){await w.Promises.exists(f)&&!d.token.isCancellationRequested&&this.w(`Failed to watch ${f} for changes using fs.watch() (${b.toString()})`)}return(0,T.toDisposable)(()=>{d.dispose(!0),p.dispose()})}t(f,u=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),!u&&this.g.some(d=>d(f.path))?this.m&&this.z(` >> ignored (excluded) ${f.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(d=>d(f.path))?this.m&&this.z(` >> ignored (not included) ${f.path}`):this.f.work(f))}u(f){const u=(0,g.coalesceEvents)(f);if(u.length>0){if(this.m)for(const p of u)this.z(`>> normalized ${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(f){if(v.isLinux)return w.Promises.exists(f);try{const u=(0,I.basename)(f);return(await w.Promises.readdir((0,I.dirname)(f))).some(p=>p===u)}catch(u){return this.z(u),!1}}setVerboseLogging(f){this.m=f}w(f){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}y(f){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}z(f){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}h.a=100,h.b=75,e.NodeJSFileWatcherLibrary=h;async function m(y,f,u,d,p=512){const b=await w.Promises.open(y,"r"),C=Buffer.allocUnsafe(p),t=new l.CancellationTokenSource(d);let a,i=!1;const n={path:y,excludes:[],recursive:!1},r=new h(n,o=>{(async()=>{for(const{type:s}of o)if(s===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:c}=await w.Promises.read(b,C,0,p,null);if(!c||t.token.isCancellationRequested)break;f(C.slice(0,c))}}catch(c){a=new Error(c),t.dispose(!0)}finally{i=!1}}})()});return await r.ready,u(),new Promise((o,s)=>{t.token.onCancellationRequested(async()=>{r.dispose();try{await w.Promises.close(b)}catch(c){a=new Error(c)}a?s(a):o()})})}e.watchFileContents=m}),define(ne[206],se([0,1,3,91,2,4,205]),function(Z,e,k,L,l,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends l.Disposable{constructor(){super(...arguments),this.a=this.B(new k.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new k.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=k.Event.None,this.c=new Map,this.f=!1}async watch(v){const P=this.i(v),w=P.filter(h=>{const m=this.c.get(h.path);return m?!(0,L.patternsEquals)(m.request.excludes,h.excludes)||!(0,L.patternsEquals)(m.request.includes,h.includes):!0}),g=Array.from(this.c.values()).filter(({request:h})=>!P.find(m=>m.path===h.path&&(0,L.patternsEquals)(m.excludes,h.excludes)&&(0,L.patternsEquals)(m.includes,h.includes))).map(({request:h})=>h.path);w.length&&this.j(`Request to start watching: ${w.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),g.length&&this.j(`Request to stop watching: ${g.join(",")}`);for(const h of g)this.h(h);for(const h of w)this.g(h)}g(v){const P=new T.NodeJSFileWatcherLibrary(v,g=>this.a.fire(g),g=>this.b.fire(g),this.f),w={request:v,instance:P};this.c.set(v.path,w)}async stop(){for(const[v]of this.c)this.h(v);this.c.clear()}h(v){const P=this.c.get(v);P&&(this.c.delete(v),P.instance.dispose())}i(v){const P=new Map;for(const w of v){const g=D.isLinux?w.path:w.path.toLowerCase();P.set(g,w)}return Array.from(P.values())}async setVerboseLogging(v){this.f=v;for(const[,P]of this.c)P.instance.setVerboseLogging(v)}j(v){this.f&&this.b.fire({type:"trace",message:this.k(v)})}k(v,P){return P?`[File Watcher (node.js)] ${v} (path: ${P.request.path})`:`[File Watcher (node.js)] ${v}`}}e.NodeJSWatcher=R}),define(ne[207],se([0,1,56,206]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class l extends k.AbstractNonRecursiveWatcherClient{constructor(T,R,I){super(T,R,I),this.m()}l(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=l}),define(ne[208],se([0,1,21,37,66,56]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends D.AbstractUniversalWatcherClient{constructor(I,v,P){super(I,v,P),this.m()}l(I){const v=I.add(new l.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(v.onDidProcessExit(({code:P,signal:w})=>this.n(`terminated by itself with code ${P}, signal: ${w}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(v.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(ne[70],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...l){this.a=new Map;for(const[D,T]of l)this.set(D,T)}set(l,D){const T=this.a.get(l);return this.a.set(l,D),T}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.ServiceCollection=k}),define(ne[209],se([0,1,6,8,2,55,199,5,70,83]),function(Z,e,k,L,l,D,T,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class w extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class g{constructor(f=new I.ServiceCollection,u=!1,d,p=P){this.f=f,this.g=u,this.h=d,this.i=p,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=p?d?._globalGraph??new T.Graph(b=>b):void 0}createChild(f){return new g(f,this.g,this,this.i)}invokeFunction(f,...u){const d=m.traceInvocation(this.i,f);let p=!1;try{return f({get:C=>{if(p)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(C,d);if(!t)throw new Error(`[invokeFunction] unknown service '${C}'`);return t}},...u)}finally{p=!0,d.stop()}}createInstance(f,...u){let d,p;return f instanceof D.SyncDescriptor?(d=m.traceCreation(this.i,f.ctor),p=this.j(f.ctor,f.staticArguments.concat(u),d)):(d=m.traceCreation(this.i,f),p=this.j(f,u,d)),d.stop(),p}j(f,u=[],d){const p=R._util.getServiceDependencies(f).sort((t,a)=>t.index-a.index),b=[];for(const t of p){const a=this.m(t.id,d);a||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),b.push(a)}const C=p.length>0?p[0].index:u.length;if(u.length!==C){console.trace(`[createInstance] First service dependency of ${f.name} at position ${C+1} conflicts with ${u.length} static arguments`);const t=C-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,C)}return Reflect.construct(f,u.concat(b))}k(f,u){if(this.f.get(f)instanceof D.SyncDescriptor)this.f.set(f,u);else if(this.h)this.h.k(f,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const u=this.f.get(f);return!u&&this.h?this.h.l(f):u}m(f,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const d=this.l(f);return d instanceof D.SyncDescriptor?this.q(f,d,u.branch(f,!0)):(u.branch(f,!1),d)}q(f,u,d){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,u,d)}finally{this.o.delete(f)}}r(f,u,d){const p=new T.Graph(t=>t.id.toString());let b=0;const C=[{id:f,desc:u,_trace:d}];for(;C.length;){const t=C.pop();if(p.lookupOrInsertNode(t),b++>1e3)throw new w(p);for(const a of R._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${f} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof D.SyncDescriptor){const n={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};p.insertEdge(t,n),C.push(n)}}}for(;;){const t=p.roots();if(t.length===0){if(!p.isEmpty())throw new w(p);break}for(const{data:a}of t){if(this.l(a.id)instanceof D.SyncDescriptor){const n=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,n)}p.removeNode(a)}}return this.l(f)}s(f,u,d=[],p,b){if(this.f.get(f)instanceof D.SyncDescriptor)return this.t(f,u,d,p,b);if(this.h)return this.h.s(f,u,d,p,b);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(f,u,d=[],p,b){if(p){const C=new g(void 0,this.g,this,this.i);C.c=String(f);const t=new Map,a=new k.IdleValue(()=>{const i=C.j(u,d,b);for(const[n,r]of t){const o=i[n];if(typeof o=="function")for(const s of r)o.apply(i,s)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let s=t.get(n);return s||(s=new v.LinkedList,t.set(n,s)),(S,E,A)=>{const N=s.push([S,E,A]);return(0,l.toDisposable)(N)}}if(n in i)return i[n];const r=a.value;let o=r[n];return typeof o!="function"||(o=o.bind(r),i[n]=o),o},set(i,n,r){return a.value[n]=r,!0},getPrototypeOf(i){return u.prototype}})}else return this.j(u,d,b)}u(f,u){if(u&&console.warn(f),this.g)throw new Error(f)}}e.InstantiationService=g;var h;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(h||(h={}));class m{static traceInvocation(f,u){return f?new m(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(f,u){return f?new m(1,u.name):m.c}constructor(f,u){this.type=f,this.name=u,this.g=Date.now(),this.h=[]}branch(f,u){const d=new m(3,f.toString());return this.h.push([f,u,d]),d}stop(){const f=Date.now()-this.g;m.f+=f;let u=!1;function d(b,C){const t=[],a=new Array(b+1).join("	");for(const[i,n,r]of C.h)if(n&&r){u=!0,t.push(`${a}CREATES -> ${i}`);const o=d(b+1,r);o&&t.push(o)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(f>2||u)&&m.all.add(p.join(`
`))}}m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0,e.Trace=m}),define(ne[210],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(l,D){this.a=l,this.b=D}getChannel(l){return this.a.getChannel(l,this.b)}registerChannel(l,D){this.a.registerChannel(l,D)}}e.MessagePortMainProcessService=k}),define(ne[71],se([0,1,37,55,69,5]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(h,m,y,f){const u=y.getChannel(h);return R(m)?f.createInstance(new L.SyncDescriptor(m.channelClientCtor,[u])):k.ProxyChannel.toService(u,m?.proxyOptions)}}function R(g){return!!g?.channelClientCtor}e.IMainProcessService=(0,D.createDecorator)("mainProcessService");let I=class extends T{constructor(h,m,y,f){super(h,m,y,f)}};I=ye([Y(2,e.IMainProcessService),Y(3,D.IInstantiationService)],I);function v(g,h,m){(0,l.registerSingleton)(g,new L.SyncDescriptor(I,[h,m],!0))}e.registerMainProcessRemoteService=v,e.ISharedProcessService=(0,D.createDecorator)("sharedProcessService");let P=class extends T{constructor(h,m,y,f){super(h,m,y,f)}};P=ye([Y(2,e.ISharedProcessService),Y(3,D.IInstantiationService)],P);function w(g,h,m){(0,l.registerSingleton)(g,new L.SyncDescriptor(P,[h,m],!0))}e.registerSharedProcessRemoteService=w}),define(ne[72],se([0,1,23,2,4,172,29,5]),function(Z,e,k,L,l,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(P){return P.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let v=class extends L.Disposable{constructor(w){super(),this.c=w}async getAvailableLanguages(){const w=new k.CancellationTokenSource;setTimeout(()=>w.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},w.token)}catch{return[]}const m=g.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(f=>f.startsWith("lp-"))).map(y=>{const f=y.properties.localizedLanguages?.[0],u=I(y);return{...this.f(u,f,y),extensionId:y.identifier.id,galleryExtension:y}});return m.push(this.f("en","English")),m}f(w,g,h){const m=g??w;let y;if(m!==w&&(y=`(${w})`),w.toLowerCase()===l.language.toLowerCase()&&(y??="",y+=(0,D.localize)(0,null)),h?.installCount){y??="";const f=h.installCount;let u;f>1e6?u=`${Math.floor(f/1e5)/10}M`:f>1e3?u=`${Math.floor(f/1e3)}K`:u=String(f),y+=` $(cloud-download) ${u}`}return{id:w,label:m,description:y}}};v=ye([Y(0,T.IExtensionGalleryService)],v),e.LanguagePackBaseService=v}),define(ne[211],se([0,1,2,72]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let l=class extends k.Disposable{constructor(T){super(),this.a=T,this.b()}b(){this.a.update()}};l=ye([Y(0,L.ILanguagePackService)],l),e.LocalizationsUpdater=l}),define(ne[11],se([0,1,39,3,2,38,4,12,10,5]),function(Z,e,k,L,l,D,T,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function P(){return new Date().toISOString()}function w(s){return(0,R.isNumber)(s)}e.isLogLevel=w;var g;(function(s){s[s.Off=0]="Off",s[s.Trace=1]="Trace",s[s.Debug=2]="Debug",s[s.Info=3]="Info",s[s.Warning=4]="Warning",s[s.Error=5]="Error"})(g=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=g.Info;function h(s,c,S){switch(c){case g.Trace:s.trace(S);break;case g.Debug:s.debug(S);break;case g.Info:s.info(S);break;case g.Warning:s.warn(S);break;case g.Error:s.error(S);break;case g.Off:break;default:throw new Error(`Invalid log level ${c}`)}}e.log=h;function m(s){let c="";for(let S=0;S<s.length;S++){let E=s[S];if(typeof E=="object")try{E=JSON.stringify(E)}catch{}c+=(S>0?" ":"")+E}return c}e.format=m;class y extends l.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new L.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(c){this.b!==c&&(this.b=c,this.c.fire(this.b))}getLevel(){return this.b}f(c){return this.b!==g.Off&&this.b<=c}}e.AbstractLogger=y;class f extends y{constructor(c){super(),this.h=c}f(c){return this.h||super.f(c)}trace(c,...S){this.f(g.Trace)&&this.g(g.Trace,m([c,...S]))}debug(c,...S){this.f(g.Debug)&&this.g(g.Debug,m([c,...S]))}info(c,...S){this.f(g.Info)&&this.g(g.Info,m([c,...S]))}warn(c,...S){this.f(g.Warning)&&this.g(g.Warning,m([c,...S]))}error(c,...S){if(this.f(g.Error))if(c instanceof Error){const E=Array.prototype.slice.call(arguments);E[0]=c.stack,this.g(g.Error,m(E))}else this.g(g.Error,m([c,...S]))}flush(){}}e.AbstractMessageLogger=f;class u extends y{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c),this.g=!T.isWindows}trace(c,...S){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,c,...S):console.log(`[main ${P()}]`,c,...S))}debug(c,...S){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,c,...S):console.log(`[main ${P()}]`,c,...S))}info(c,...S){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,c,...S):console.log(`[main ${P()}]`,c,...S))}warn(c,...S){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${P()}]\x1B[0m`,c,...S):console.warn(`[main ${P()}]`,c,...S))}error(c,...S){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${P()}]\x1B[0m`,c,...S):console.error(`[main ${P()}]`,c,...S))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class d extends y{constructor(c=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(c)}trace(c,...S){this.f(g.Trace)&&console.log("%cTRACE","color: #888",c,...S)}debug(c,...S){this.f(g.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",c,...S)}info(c,...S){this.f(g.Info)&&console.log("%c INFO","color: #33f",c,...S)}warn(c,...S){this.f(g.Warning)&&console.log("%c WARN","color: #993",c,...S)}error(c,...S){this.f(g.Error)&&console.log("%c  ERR","color: #f33",c,...S)}dispose(){}flush(){}}e.ConsoleLogger=d;class p extends y{constructor(c,S=e.DEFAULT_LOG_LEVEL){super(),this.g=c,this.setLevel(S)}trace(c,...S){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(c),...S])}debug(c,...S){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(c),...S])}info(c,...S){this.f(g.Info)&&this.g.log(g.Info,[this.h(c),...S])}warn(c,...S){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(c),...S])}error(c,...S){this.f(g.Error)&&this.g.log(g.Error,[this.h(c),...S])}h(c){return typeof c=="string"?c:(0,k.toErrorMessage)(c,this.f(g.Trace))}dispose(){}flush(){}}e.AdapterLogger=p;class b extends y{constructor(c){super(),this.g=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const S of this.g)S.setLevel(c);super.setLevel(c)}trace(c,...S){for(const E of this.g)E.trace(c,...S)}debug(c,...S){for(const E of this.g)E.debug(c,...S)}info(c,...S){for(const E of this.g)E.info(c,...S)}warn(c,...S){for(const E of this.g)E.warn(c,...S)}error(c,...S){for(const E of this.g)E.error(c,...S)}flush(){for(const c of this.g)c.flush()}dispose(){for(const c of this.g)c.dispose()}}e.MultiplexLogger=b;class C extends l.Disposable{constructor(c,S){if(super(),this.j=c,this.b=new D.ResourceMap,this.c=new D.ResourceMap,this.f=this.B(new L.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new L.Emitter),this.onDidChangeVisibility=this.h.event,S)for(const E of S)this.c.set(E.resource,E)}getLogger(c){return this.b.get(c)}createLogger(c,S){let E=this.b.get(c);const A=S?.logLevel==="always"?g.Trace:S?.logLevel;return E||(E=this.k(c,A??this.getLogLevel(c)??this.j,S),this.b.set(c,E)),this.registerLogger({resource:c,id:S?.id??c.toString(),logLevel:A,name:S?.name,hidden:S?.hidden,extensionId:S?.extensionId}),E}setLogLevel(c,S){if(I.URI.isUri(c)){const E=c,A=S,N=this.c.get(E);N&&A!==N.logLevel&&(N.logLevel=A===this.j?void 0:A,this.b.get(E)?.setLevel(A),this.c.set(N.resource,N),this.g.fire([E,A]))}else{this.j=c;for(const[E,A]of this.b.entries())this.c.get(E)?.logLevel===void 0&&A.setLevel(this.j);this.g.fire(this.j)}}setVisibility(c,S){const E=this.c.get(c);E&&S!==!E.hidden&&(E.hidden=!S,this.c.set(E.resource,E),this.h.fire([c,S]))}getLogLevel(c){let S;return c&&(S=this.c.get(c)?.logLevel),S??this.j}registerLogger(c){const S=this.c.get(c.resource);S?S.hidden!==c.hidden&&this.setVisibility(c.resource,!c.hidden):(this.c.set(c.resource,c),this.f.fire({added:[c],removed:[]}))}deregisterLogger(c){const S=this.c.get(c);if(S){this.c.delete(c);const E=this.b.get(c);E&&(this.b.delete(c),E.dispose()),this.f.fire({added:[],removed:[S]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(c){return this.c.get(c)}dispose(){this.b.forEach(c=>c.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=C;class t{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(c){}getLevel(){return g.Info}trace(c,...S){}debug(c,...S){}info(c,...S){}warn(c,...S){}error(c,...S){}critical(c,...S){}dispose(){}flush(){}}e.NullLogger=t;class a extends t{}e.NullLogService=a;class i extends C{constructor(){super(g.Info)}k(c,S,E){return new t}}e.NullLoggerService=i;function n(s){if(s.verbose)return g.Trace;if(typeof s.logLevel=="string"){const c=o(s.logLevel.toLowerCase());if(c!==void 0)return c}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function r(s){switch(s){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}e.LogLevelToString=r;function o(s){switch(s){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.parseLogLevel=o}),define(ne[212],se([0,1,6,8,2,13,27,15,11]),function(Z,e,k,L,l,D,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let v=class extends l.Disposable{constructor(w,g){super(),this.a=w,this.b=g,this.B(new k.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,D.basename)(this.a.logsPath),g=(0,D.dirname)(this.a.logsPath),y=(await T.Promises.readdir(g)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==w),f=y.slice(0,Math.max(0,y.length-9));f.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(u=>T.Promises.rm((0,D.join)(g,u)))))}catch(w){(0,L.onUnexpectedError)(w)}}};v=ye([Y(0,R.IEnvironmentService),Y(1,I.ILogService)],v),e.LogsDataCleaner=v}),define(ne[213],se([0,1,18,6,8,3,2,13,56,11]),function(Z,e,k,L,l,D,T,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends T.Disposable{constructor(g,h){super(),this.a=g,this.b=h,this.c=this.B(new D.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new L.ThrottledDelayer(0)),this.s=[],this.t=this.B(new L.ThrottledDelayer(0))}watch(g,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(g,h):this.u(g,h)}l(g,h){const m={path:this.C(g),excludes:h.excludes,includes:h.includes,recursive:h.recursive},y=(0,k.insert)(this.j,m);return this.m(),(0,T.toDisposable)(()=>{y(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(g=>(0,l.onUnexpectedError)(g))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,I.toFileChanges)(h)),h=>this.z(h),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const h of this.j)(0,I.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const h of this.j)(0,I.isRecursiveWatchRequest)(h)&&g.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(g,h){const m={path:this.C(g),excludes:h.excludes,includes:h.includes,recursive:!1},y=(0,k.insert)(this.s,m);return this.v(),(0,T.toDisposable)(()=>{y(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(g=>(0,l.onUnexpectedError)(g))}w(){return this.r||(this.r=this.B(this.y(g=>this.c.fire((0,I.toFileChanges)(g)),g=>this.z(g),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)}))),this.r.watch(this.s)}z(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}C(g){return(0,R.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(ne[214],se([0,1,18,6,17,23,3,65,63,2,49,21,103,24,43,168,14,102,11,8]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let b=class extends v.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new T.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new T.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new T.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new L.ResourceQueue)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${t}`);const i=new v.DisposableStore;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(n=>this.R.fire(new f.FileChangesEvent(n,!this.O(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,v.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,v.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await L.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return I.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,h.isAbsolutePath)(t))throw new f.FileOperationError((0,y.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new p.ErrorNoTelemetry;throw i.message=(0,y.localize)(1,null,t.toString()),i}return a}async k(t){const a=await this.j(t);if((0,f.hasOpenReadWriteCloseCapability)(a)||(0,f.hasReadWriteCapability)(a)||(0,f.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,f.hasOpenReadWriteCloseCapability)(a)||(0,f.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(i){throw(0,f.toFileSystemProviderErrorCode)(i)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,y.localize)(2,null,this.nb(t)),1):(0,f.ensureFileSystemProviderError)(i)}}async n(t,a){const i=await this.j(t),n=this.O(i),r=a?.resolveTo,o=a?.resolveSingleChildDescendants,s=a?.resolveMetadata,c=await i.stat(t);let S;return this.p(i,t,c,void 0,!!s,(E,A)=>(S||(S=P.TernarySearchTree.forUris(()=>!n),S.set(t,!0),r&&S.fill(!0,r)),S.get(E.resource)||S.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&o?A===1:!1))}async p(t,a,i,n,r,o){const{providerExtUri:s}=this.N(t),c={resource:a,name:s.basename(a),isFile:(i.type&f.FileType.File)!==0,isDirectory:(i.type&f.FileType.Directory)!==0,isSymbolicLink:(i.type&f.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&f.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,f.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(c.isDirectory&&o(c,n)){try{const S=await t.readdir(a),E=await L.Promises.settled(S.map(async([A,N])=>{try{const M=s.joinPath(a,A),B=r?await t.stat(M):{type:N};return await this.p(t,M,B,S.length,r,o)}catch(M){return this.b.trace(M),null}}));c.children=(0,k.coalesce)(E)}catch(S){this.b.trace(S),c.children=[]}return c}return c}async resolveAll(t){return L.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.p(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.r(t,a)}catch(i){return i}return!0}async r(t,a){if(!a?.overwrite&&await this.exists(t))throw new f.FileOperationError((0,y.localize)(3,null,this.nb(t)),3,a)}async createFile(t,a=l.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,a);return this.m.fire(new f.FileOperationEvent(t,0,n)),n}async writeFile(t,a,i){const n=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(n);try{await this.s(n,t,i)||await this.P(n,r.dirname(t));let s;if((0,f.hasReadWriteCapability)(n)&&!(a instanceof l.VSBuffer))if((0,m.isReadableStream)(a)){const c=await(0,m.peekStream)(a,3);c.ended?s=l.VSBuffer.concat(c.buffer):s=c}else s=(0,m.peekReadable)(a,c=>l.VSBuffer.concat(c),3);else s=a;!(0,f.hasOpenReadWriteCloseCapability)(n)||(0,f.hasReadWriteCapability)(n)&&s instanceof l.VSBuffer?await this.cb(n,t,i,s):await this.Y(n,t,i,s instanceof l.VSBuffer?(0,l.bufferToReadable)(s):s),this.m.fire(new f.FileOperationEvent(t,4))}catch(o){throw new f.FileOperationError((0,y.localize)(4,null,this.nb(t),(0,f.ensureFileSystemProviderError)(o).toString()),(0,f.toFileOperationResult)(o),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,a,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,y.localize)(5,null,this.nb(a)));let r;try{r=await t.stat(a)}catch{return}if((r.type&f.FileType.Directory)!==0)throw new f.FileOperationError((0,y.localize)(6,null,this.nb(a)),0,i);if(this.mb(a,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==f.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,f.etag)({mtime:i.mtime,size:r.size}))throw new f.FileOperationError((0,y.localize)(7,null),3,i);return r}async readFile(t,a,i){const n=await this.k(t);return a?.atomic?this.t(n,t,a,i):this.u(n,t,a,i)}async t(t,a,i,n){return new Promise((r,o)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const s=await this.u(t,a,i,n);r(s)}catch(s){o(s)}})})}async u(t,a,i,n){const r=await this.v(t,a,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,l.streamToBuffer)(r.value)}}async readFileStream(t,a,i){const n=await this.k(t);return this.v(n,t,a,i)}async v(t,a,i,n){const r=new D.CancellationTokenSource(n),o=this.F(a,i).then(c=>c,c=>{throw r.cancel(),c});let s;try{return typeof i?.etag=="string"&&i.etag!==f.ETAG_DISABLED&&await o,i?.atomic&&(0,f.hasFileAtomicReadCapability)(t)||!((0,f.hasOpenReadWriteCloseCapability)(t)||(0,f.hasFileReadStreamCapability)(t))||(0,f.hasReadWriteCapability)(t)&&i?.preferUnbuffered?s=this.D(t,a,i):(0,f.hasFileReadStreamCapability)(t)?s=this.z(t,a,r.token,i):s=this.C(t,a,r.token,i),{...await o,value:s}}catch(c){throw s&&await(0,m.consumeStream)(s),this.w(c,a,i)}}w(t,a,i){const n=(0,y.localize)(8,null,this.nb(a),(0,f.ensureFileSystemProviderError)(t).toString());return t instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof f.TooLargeFileOperationError?new f.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new f.FileOperationError(n,(0,f.toFileOperationResult)(t),i)}z(t,a,i,n=Object.create(null)){const r=t.readFileStream(a,n,i);return(0,m.transform)(r,{data:o=>o instanceof l.VSBuffer?o:l.VSBuffer.wrap(o),error:o=>this.w(o,a,n)},o=>l.VSBuffer.concat(o))}C(t,a,i,n=Object.create(null)){const r=(0,l.newWriteableBufferStream)();return(0,u.readFileIntoStream)(t,a,r,o=>o,{...n,bufferSize:this.a,errorTransformer:o=>this.w(o,a,n)},i),r}D(t,a,i){const n=(0,m.newWriteableStream)(r=>l.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,f.hasFileAtomicReadCapability)(t)?r=await t.readFile(a,{atomic:!0}):r=await t.readFile(a),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.G(a,r.byteLength,i),n.end(l.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async F(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new f.FileOperationError((0,y.localize)(9,null,this.nb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==f.ETAG_DISABLED&&a.etag===i.etag)throw new f.NotModifiedSinceFileOperationError((0,y.localize)(10,null),i,a);return this.G(t,i.size,a),i}G(t,a,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&a>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&a>i.limits.size&&(n=7),typeof n=="number")throw new f.TooLargeFileOperationError((0,y.localize)(11,null,this.nb(t)),n,a,i)}}async canMove(t,a,i){return this.H(t,a,"move",i)}async canCopy(t,a,i){return this.H(t,a,"copy",i)}async H(t,a,i,n){if(t.toString()!==a.toString())try{const r=i==="move"?this.lb(await this.l(t),t):await this.k(t),o=this.lb(await this.l(a),a);await this.M(r,t,o,a,i,n)}catch(r){return r}return!0}async move(t,a,i){const n=this.lb(await this.l(t),t),r=this.lb(await this.l(a),a),o=await this.I(n,t,r,a,"move",!!i),s=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(t,o==="move"?2:3,s)),s}async copy(t,a,i){const n=await this.k(t),r=this.lb(await this.l(a),a),o=await this.I(n,t,r,a,"copy",!!i),s=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(t,o==="copy"?3:2,s)),s}async I(t,a,i,n,r,o){if(a.toString()===n.toString())return r;const{exists:s,isSameResourceWithDifferentPathCase:c}=await this.M(t,a,i,n,r,o);if(s&&!c&&o&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),r==="copy"){if(t===i&&(0,f.hasFileFolderCopyCapability)(t))await t.copy(a,n,{overwrite:o});else{const S=await this.resolve(a);S.isDirectory?await this.L(t,S,i,n):await this.J(t,a,i,n)}return r}else return t===i?(await t.rename(a,n,{overwrite:o}),r):(await this.I(t,a,i,n,"copy",o),await this.del(a,{recursive:!0}),"copy")}async J(t,a,i,n){if((0,f.hasOpenReadWriteCloseCapability)(t)&&(0,f.hasOpenReadWriteCloseCapability)(i))return this.eb(t,a,i,n);if((0,f.hasOpenReadWriteCloseCapability)(t)&&(0,f.hasReadWriteCapability)(i))return this.kb(t,a,i,n);if((0,f.hasReadWriteCapability)(t)&&(0,f.hasOpenReadWriteCloseCapability)(i))return this.ib(t,a,i,n);if((0,f.hasReadWriteCapability)(t)&&(0,f.hasReadWriteCapability)(i))return this.gb(t,a,i,n)}async L(t,a,i,n){await i.mkdir(n),Array.isArray(a.children)&&await L.Promises.settled(a.children.map(async r=>{const o=this.N(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),i,o):this.J(t,r.resource,i,o)}))}async M(t,a,i,n,r,o){let s=!1;if(t===i){const{providerExtUri:S,isPathCaseSensitive:E}=this.N(t);if(E||(s=S.isEqual(a,n)),s&&r==="copy")throw new Error((0,y.localize)(12,null,this.nb(a),this.nb(n)));if(!s&&S.isEqualOrParent(n,a))throw new Error((0,y.localize)(13,null,this.nb(a),this.nb(n)))}const c=await this.exists(n);if(c&&!s){if(!o)throw new f.FileOperationError((0,y.localize)(14,null,this.nb(a),this.nb(n)),4);if(t===i){const{providerExtUri:S}=this.N(t);if(S.isEqualOrParent(a,n))throw new Error((0,y.localize)(15,null,this.nb(a),this.nb(n)))}}return{exists:c,isSameResourceWithDifferentPathCase:s}}N(t){const a=this.O(t);return{providerExtUri:a?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.lb(await this.j(t),t);await this.P(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(t,0,i)),i}async P(t,a){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(a,n.dirname(a));)try{if(((await t.stat(a)).type&f.FileType.Directory)===0)throw new Error((0,y.localize)(16,null,this.nb(a)));break}catch(r){if((0,f.toFileSystemProviderErrorCode)(r)!==f.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(a)),a=n.dirname(a)}for(let r=i.length-1;r>=0;r--){a=n.joinPath(a,i[r]);try{await t.mkdir(a)}catch(o){if((0,f.toFileSystemProviderErrorCode)(o)!==f.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,a){try{await this.Q(t,a)}catch(i){return i}return!0}async Q(t,a){const i=this.lb(await this.j(t),t);if(!!a?.useTrash&&!(i.capabilities&4096))throw new Error((0,y.localize)(17,null,this.nb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.mb(t,r);else throw new f.FileOperationError((0,y.localize)(18,null,this.nb(t)),1);if(!!!a?.recursive){const s=await this.resolve(t);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,y.localize)(19,null,this.nb(t)))}return i}async del(t,a){const i=await this.Q(t,a),n=!!a?.useTrash,r=!!a?.recursive;await i.delete(t,{recursive:r,useTrash:n}),this.m.fire(new f.FileOperationEvent(t,1))}async cloneFile(t,a){const i=await this.j(t),n=this.lb(await this.l(a),a);if(i===n&&this.N(i).providerExtUri.isEqual(t,a))return;if(i===n&&(0,f.hasFileCloneCapability)(i))return i.cloneFile(t,a);await this.P(n,this.N(n).providerExtUri.dirname(a));const r=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,f.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,a,{overwrite:!0})):r.queue(()=>this.J(i,t,n,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new v.DisposableStore;let n=!1,r=()=>{n=!0};return i.add((0,v.toDisposable)(()=>r())),(async()=>{try{const o=await this.W(t,a);n?(0,v.dispose)(o):r=()=>(0,v.dispose)(o)}catch(o){this.b.error(o)}})(),i}async W(t,a){const i=await this.j(t),n=(0,R.hash)([this.N(i).providerExtUri.getComparisonKey(t),a]);let r=this.U.get(n);return r||(r={count:0,disposable:i.watch(t,a)},this.U.set(n,r)),r.count+=1,(0,v.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,v.dispose)(r.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,v.dispose)(t.disposable);this.U.clear()}async Y(t,a,i,n){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,m.isReadableStream)(n)||(0,m.isReadableBufferedStream)(n)?await this.Z(t,r,n):await this.ab(t,r,n)}catch(o){throw(0,f.ensureFileSystemProviderError)(o)}finally{await t.close(r)}})}async Z(t,a,i){let n=0,r;if((0,m.isReadableBufferedStream)(i)){if(i.buffer.length>0){const o=l.VSBuffer.concat(i.buffer);await this.bb(t,a,o,o.byteLength,n,0),n+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((o,s)=>{(0,m.listenStream)(r,{onData:async c=>{r.pause();try{await this.bb(t,a,c,c.byteLength,n,0)}catch(S){return s(S)}n+=c.byteLength,setTimeout(()=>r.resume())},onError:c=>s(c),onEnd:()=>o()})})}async ab(t,a,i){let n=0,r;for(;(r=i.read())!==null;)await this.bb(t,a,r,r.byteLength,n,0),n+=r.byteLength}async bb(t,a,i,n,r,o){let s=0;for(;s<n;)s+=await t.write(a,r+s,i.buffer,o+s,n-s)}async cb(t,a,i,n){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.db(t,a,i,n))}async db(t,a,i,n){let r;n instanceof l.VSBuffer?r=n:(0,m.isReadableStream)(n)?r=await(0,l.streamToBuffer)(n):(0,m.isReadableBufferedStream)(n)?r=await(0,l.bufferedStreamToBuffer)(n):r=(0,l.readableToBuffer)(n),await t.writeFile(a,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,a,i,n))}async fb(t,a,i,n){let r,o;try{r=await t.open(a,{create:!1}),o=await i.open(n,{create:!0,unlock:!1});const s=l.VSBuffer.alloc(this.a);let c=0,S=0,E=0;do E=await t.read(r,c,s.buffer,S,s.byteLength-S),await this.bb(i,o,s,E,c,S),c+=E,S+=E,S===s.byteLength&&(S=0);while(E>0)}catch(s){throw(0,f.ensureFileSystemProviderError)(s)}finally{await L.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async gb(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,a,i,n))}async hb(t,a,i,n){return i.writeFile(n,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async ib(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,a,i,n))}async jb(t,a,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const o=await t.readFile(a);await this.bb(i,r,l.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,f.ensureFileSystemProviderError)(o)}finally{await i.close(r)}}async kb(t,a,i,n){const r=await(0,l.streamToBuffer)(this.C(t,a,D.CancellationToken.None));await this.cb(i,n,void 0,r)}lb(t,a){if(t.capabilities&2048)throw new f.FileOperationError((0,y.localize)(20,null,this.nb(a)),6);return t}mb(t,a){if((a.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,y.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===w.Schemas.file?t.fsPath:t.toString(!0)}};b=ye([Y(0,d.ILogService)],b),e.FileService=b}),define(ne[215],se([0,1,53,298,6,38,17,3,48,2,13,4,24,43,27,171,14,102,213,39,208,207]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u,d,p,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(k)}catch(a){console.error(`Error enabling graceful-fs: ${(0,p.toErrorMessage)(a)}`)}})();class t extends d.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=R.Event.None,this.H=new D.ResourceMap(r=>g.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,w.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:r}=await m.SymlinkSupport.stat(this.C(i));return{type:this.G(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await m.Promises.readdir(this.C(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async o=>{try{let s;o.isSymbolicLink()?s=(await this.stat((0,g.joinPath)(i,o.name))).type:s=this.G(o),r.push([o.name,s])}catch(s){this.a.trace(s)}})),r}catch(n){throw this.Y(n)}}G(i,n){let r;return n?.dangling?r=f.FileType.Unknown:i.isFile()?r=f.FileType.File:i.isDirectory()?r=f.FileType.Directory:r=f.FileType.Unknown,n&&(r|=f.FileType.SymbolicLink),r}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const o=new l.Barrier;return this.H.set(i,o),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,v.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===o&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),r=await this.I(i));const o=this.C(i);return await m.Promises.readFile(o)}catch(o){throw this.Y(o)}finally{r?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,r){const o=(0,h.newWriteableStream)(s=>T.VSBuffer.concat(s.map(c=>T.VSBuffer.wrap(c))).buffer);return(0,u.readFileIntoStream)(this,i,o,s=>s.buffer,{...n,bufferSize:256*1024},r),o}async writeFile(i,n,r){let o;try{const s=this.C(i);if(!r.create||!r.overwrite){if(await m.Promises.exists(s)){if(!r.overwrite)throw(0,f.createFileSystemProviderError)((0,y.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,f.createFileSystemProviderError)((0,y.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(o,0,n,0,n.byteLength)}catch(s){throw await this.Z(i,s)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const r=this.C(i);let o;(0,f.isFileOpenForWriteOptions)(n)&&(o=await this.I(i));let s;try{if((0,f.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:S}=await m.SymlinkSupport.stat(r);S.mode&128||await m.Promises.chmod(r,S.mode|128)}catch(S){this.a.trace(S)}let c;if((0,f.isFileOpenForWriteOptions)(n)){if(w.isWindows)try{await m.Promises.truncate(r,0),c="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}c||(c="w")}else c="r";s=await m.Promises.open(r,c)}catch(c){throw o?.dispose(),(0,f.isFileOpenForWriteOptions)(n)?await this.Z(i,c):this.Y(c)}if(this.L.set(s,0),(0,f.isFileOpenForWriteOptions)(n)&&this.N.set(s,i),o){const c=this.M.get(s);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${r})`),this.M.set(s,o),c&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${r})`),c.dispose())}return s}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await m.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await m.Promises.close(i)}catch(r){throw this.Y(r)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,o,s){const c=this.P(i,n);let S=null;try{S=(await m.Promises.read(i,r,o,s,c)).bytesRead}catch(E){throw this.Y(E)}finally{this.Q(i,c,S)}return S}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,r){const o=this.L.get(i);typeof o=="number"&&(typeof n=="number"||(typeof r=="number"?this.L.set(i,o+r):this.L.delete(i)))}async write(i,n,r,o,s){return(0,l.retry)(()=>this.R(i,n,r,o,s),100,3)}async R(i,n,r,o,s){const c=this.P(i,n);let S=null;try{S=(await m.Promises.write(i,r,o,s,c)).bytesWritten}catch(E){throw await this.Z(this.N.get(i),E)}finally{this.Q(i,c,S)}return S}async mkdir(i){try{await m.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const r=this.C(i);n.recursive?await m.Promises.rm(r,m.RimRafMode.MOVE):await m.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(i,n,r){const o=this.C(i),s=this.C(n);if(o!==s)try{await this.S(i,n,"move",r.overwrite),await m.Promises.move(o,s)}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,y.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(s)),c.toString()))),this.Y(c)}}async copy(i,n,r){const o=this.C(i),s=this.C(n);if(o!==s)try{await this.S(i,n,"copy",r.overwrite),await m.Promises.copy(o,s,{preserveSymlinks:!0})}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,y.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(s)),c.toString()))),this.Y(c)}}async S(i,n,r,o){const s=this.C(i),c=this.C(n);let S=!1;if(!!(this.capabilities&1024)||(S=(0,I.isEqual)(s,c,!0)),S&&r==="copy")throw(0,f.createFileSystemProviderError)((0,y.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!S&&await m.Promises.exists(c)){if(!o)throw(0,f.createFileSystemProviderError)((0,y.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,r){const o=this.C(i),s=this.C(n),c=!!(this.capabilities&1024);if((0,I.isEqual)(o,s,!c))return;const S=new v.DisposableStore;try{const[E,A]=await Promise.all([this.I(i),this.I(n)]);S.add(E),S.add(A),r&&await m.Promises.mkdir((0,P.dirname)(s),{recursive:!0}),await m.Promises.copyFile(o,s)}catch(E){if(E.code==="ENOENT"&&!r)return this.U(i,n,!0);throw this.Y(E)}finally{S.dispose()}}p(i,n,r){return new b.UniversalWatcherClient(o=>i(o),o=>n(o),r)}y(i,n,r){return new C.NodeJSWatcherClient(o=>i(o),o=>n(o),r)}Y(i){if(i instanceof f.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=f.FileSystemProviderErrorCode.NoPermissions;break;default:n=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(i,n)}async Z(i,n){let r=this.Y(n);if(i&&r.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await m.SymlinkSupport.stat(this.C(i));o.mode&128||(r=(0,f.createFileSystemProviderError)(n,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return r}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(ne[104],se([0,1,3,2,5,11]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,l.createDecorator)("sharedProcessLifecycleService");let T=class extends L.Disposable{constructor(I){super(),this.b=I,this.a=this.B(new k.Emitter),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};T=ye([Y(0,D.ILogService)],T),e.SharedProcessLifecycleService=T}),define(ne[105],se([0,1,10,3,11,2]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class T extends l.AbstractLoggerService{constructor(w,g,h,m){super(g,h),this.l=w,this.m=m,this.B(m.listen("onDidChangeLogLevel",w)(y=>{(0,l.isLogLevel)(y)?super.setLogLevel(y):super.setLogLevel(k.URI.revive(y[0]),y[1])})),this.B(m.listen("onDidChangeVisibility",w)(([y,f])=>super.setVisibility(k.URI.revive(y),f))),this.B(m.listen("onDidChangeLoggers",w)(({added:y,removed:f})=>{for(const u of y)super.registerLogger({...u,resource:k.URI.revive(u.resource)});for(const u of f)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new l.AdapterLogger({log:(w,g)=>{this.m.call("consoleLog",[w,g])}})}registerLogger(w){super.registerLogger(w),this.m.call("registerLogger",[w,this.l])}deregisterLogger(w){super.deregisterLogger(w),this.m.call("deregisterLogger",[w,this.l])}setLogLevel(w,g){super.setLogLevel(w,g),this.m.call("setLogLevel",[w,g])}setVisibility(w,g){super.setVisibility(w,g),this.m.call("setVisibility",[w,g])}k(w,g,h){return new R(this.m,w,g,h,this.l)}static setLogLevel(w,g,h){return w.call("setLogLevel",[g,h])}}e.LoggerChannelClient=T;class R extends l.AbstractMessageLogger{constructor(w,g,h,m,y){super(m?.logLevel==="always"),this.m=w,this.n=g,this.k=!1,this.l=[],this.setLevel(h),this.m.call("createLogger",[g,m,y]).then(()=>{this.r(this.l),this.k=!0})}g(w,g){const h=[[w,g]];this.k?this.r(h):this.l.push(...h)}r(w){this.m.call("log",[this.n,w])}}class I{constructor(w,g){this.a=w,this.b=g}listen(w,g){const h=this.b(w);switch(g){case"onDidChangeLoggers":return L.Event.map(this.a.onDidChangeLoggers,m=>({added:[...m.added].map(y=>this.c(y,h)),removed:[...m.removed].map(y=>this.c(y,h))}));case"onDidChangeVisibility":return L.Event.map(this.a.onDidChangeVisibility,m=>[h.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return L.Event.map(this.a.onDidChangeLogLevel,m=>(0,l.isLogLevel)(m)?m:[h.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${g}`)}async call(w,g,h){const m=this.b(w);switch(g){case"setLogLevel":return(0,l.isLogLevel)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(k.URI.revive(m.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,m)))}throw new Error(`Call not found: ${g}`)}c(w,g){return{...w,resource:g.transformOutgoingURI(w.resource)}}}e.LoggerChannel=I;class v extends D.Disposable{constructor(w,g){super(),g.call("setLogLevel",[w.getLogLevel()]),this.B(w.onDidChangeLogLevel(h=>g.call("setLogLevel",[h]))),g.call("getRegisteredLoggers").then(h=>{for(const m of h)w.registerLogger({...m,resource:k.URI.revive(m.resource)})}),this.B(g.listen("onDidChangeVisibility")(([h,m])=>w.setVisibility(k.URI.revive(h),m))),this.B(g.listen("onDidChangeLoggers")(({added:h,removed:m})=>{for(const y of h)w.registerLogger({...y,resource:k.URI.revive(y.resource)});for(const y of m)w.deregisterLogger(y.resource)}))}}e.RemoteLoggerChannelClient=v}),define(ne[216],se([0,1,2,11]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends k.Disposable{constructor(T,R=[]){super(),this.a=new L.MultiplexLogger([T,...R]),this.B(T.onDidChangeLogLevel(I=>this.setLevel(I)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...R){this.a.trace(T,...R)}debug(T,...R){this.a.debug(T,...R)}info(T,...R){this.a.info(T,...R)}warn(T,...R){this.a.warn(T,...R)}error(T,...R){this.a.error(T,...R)}flush(){this.a.flush()}}e.LogService=l}),define(ne[57],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(ne[58],se([0,1,3,63,2,5]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,D.createDecorator)("policy");class T extends l.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new k.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(v){const P=Object.keys(this.f).length;return this.f={...v,...this.f},P!==Object.keys(this.f).length&&await this.i(v),L.Iterable.reduce(this.g.entries(),(w,[g,h])=>({...w,[g]:h}),{})}getPolicyValue(v){return this.g.get(v)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(v,[P,w])=>({...v,[P]:{definition:w,value:this.g.get(P)}}),{})}}e.AbstractPolicyService=T;class R{constructor(){this.onDidChange=k.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(ne[217],se([0,1,3,2,58]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class D{constructor(I){this.b=I,this.a=new L.DisposableStore}listen(I,v){switch(v){case"onDidChange":return k.Event.map(this.b.onDidChange,P=>P.reduce((w,g)=>({...w,[g]:this.b.getPolicyValue(g)??null}),{}),this.a)}throw new Error(`Event not found: ${v}`)}call(I,v,P){switch(v){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${v}`)}dispose(){this.a.dispose()}}e.PolicyChannel=D;class T extends l.AbstractPolicyService{constructor(I,v){super(),this.a=v;for(const P in I){const{definition:w,value:g}=I[P];this.f[P]=w,g!==void 0&&this.g.set(P,g)}this.a.listen("onDidChange")(P=>{for(const w in P){const g=P[w];g===null?this.g.delete(w):this.g.set(w,g)}this.h.fire(Object.keys(P))})}async i(I){const v=await this.a.call("updatePolicyDefinitions",I);for(const P in v)this.g.set(P,v[P])}}e.PolicyChannelClient=T}),define(ne[106],se([0,1,4,36]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.context<"u"){const D=k.globals.vscode.context.configuration();if(D)l=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,L.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:D.version})}}else l={},Object.keys(l).length===0&&Object.assign(l,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(ne[25],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[218],se([0,1,6,8,2,13,27,11,25]),function(Z,e,k,L,l,D,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let v=class extends l.Disposable{constructor(w,g,h){super(),this.b=g,this.c=h,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this.B(new k.RunOnceScheduler(()=>{this.f(w)},3e4)).schedule()}async f(w){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),h=(0,D.dirname)(w),m=(0,D.basename)(w),y=await T.Promises.readdir(h);await Promise.all(y.map(async f=>{if(f===m)return;const u=(0,D.join)(h,f),d=await T.Promises.stat(u);if(d.isDirectory()&&g-d.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),T.Promises.rm(u)}))}catch(g){(0,L.onUnexpectedError)(g)}}};v=ye([Y(1,I.IProductService),Y(2,R.ILogService)],v),e.CodeCacheCleaner=v}),define(ne[219],se([0,1,6,8,2,13,27,15,11,25]),function(Z,e,k,L,l,D,T,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends l.Disposable{constructor(g,h,m){super(),this.b=g,this.c=h,this.f=m,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new k.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),h=JSON.parse(await T.Promises.readFile((0,D.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(h)){const p=h[d];g[`${p.hash}.${d}`]=!0}const m=(0,D.join)(this.b.userDataPath,"clp");if(!await T.Promises.exists(m))return;const f=await T.Promises.readdir(m);for(const d of f){if(g[d]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await T.Promises.rm((0,D.join)(m,d))}const u=Date.now();for(const d of Object.keys(g)){const p=(0,D.join)(m,d),b=await T.Promises.readdir(p);for(const C of b){if(C==="tcf.json")continue;const t=(0,D.join)(p,C),a=await T.Promises.stat(t);a.isDirectory()&&u-a.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,D.join)(d,C)}`),await T.Promises.rm(t))}}}catch(g){(0,L.onUnexpectedError)(g)}}};P=ye([Y(0,R.INativeEnvironmentService),Y(1,I.ILogService),Y(2,v.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(ne[220],se([0,1,18,2,24,195,14,25]),function(Z,e,k,L,l,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let I=class extends L.Disposable{constructor(P,w){super(),this.b=P,this.c=w,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,g])=>this.a.set(g.configPath,g))}getConfigBasedTips(P){return this.f(P)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(P){const w=[];for(const[g,h]of this.a)if(!(h.configScheme&&h.configScheme!==P.scheme))try{const m=await this.b.readFile((0,l.joinPath)(P,g)),y=new Map;Object.entries(h.recommendations).forEach(([u,d])=>{if((0,k.isNonEmptyArray)(d.remotes))for(const p of d.remotes)y.set(p,{extensionId:u,extensionName:d.name,configName:h.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled});else w.push({extensionId:u,extensionName:d.name,configName:h.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled})});const f=(0,D.getDomainsOfRemotes)(m.value.toString(),[...y.keys()]);for(const u of f){const d=y.get(u);d&&w.push(d)}}catch{}return w}};I=ye([Y(0,T.IFileService),Y(1,R.IProductService)],I),e.ExtensionTipsService=I}),define(ne[221],se([0,1,13,5]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,L.createDecorator)("IV8InspectProfilingService");var l;(function(D){function T(I){return Boolean(I.samples&&I.timeDeltas)}D.isValidProfile=T;function R(I,v="noAbsolutePaths"){for(const P of I.nodes)P.callFrame&&P.callFrame.url&&((0,k.isAbsolute)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,k.join)(v,(0,k.basename)(P.callFrame.url)));return I}D.rewriteAbsolutePaths=R})(l=e.Utils||(e.Utils={}))}),define(ne[222],se([0,1,31]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class L{constructor(){this.a=new Map}async startProfiling(D){const R=await(await new Promise((v,P)=>{Z(["v8-inspect-profiler"],v,P)})).startProfiling({port:D.port,checkForPaused:!0}),I=(0,k.generateUuid)();return this.a.set(I,R),I}async stopProfiling(D){const T=this.a.get(D);if(!T)throw new Error(`UNKNOWN session '${D}'`);const R=await T.stop();return this.a.delete(D),R.profile}}e.InspectProfilingService=L}),define(ne[40],se([0,1,129,12]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.a=new Map}add(T,R){k.ok(L.isString(T)),k.ok(L.isObject(R)),k.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,R)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.Registry=new l}),define(ne[107],se([0,1,3,40]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class D{constructor(){this.b=new k.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(I,v){this.a[l(I)]=v,this.b.fire(I)}notifySchemaChanged(I){this.b.fire(I)}getSchemaContributions(){return{schemas:this.a}}}const T=new D;L.Registry.add(e.Extensions.JSONContribution,T)}),define(ne[45],se([0,1,18,3,12,157,16,107,40]),function(Z,e,k,L,l,D,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var v;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(v=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=I.Registry.as(R.Extensions.JSONContribution);class g{constructor(){this.h=new Set,this.i=new L.Emitter,this.onDidSchemaChange=this.i.event,this.j=new L.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:n,source:r}of t)for(const o in n)if(a.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const s=this.a.get(o),c=s?.valuesSources??new Map;if(r)for(const N of Object.keys(n[o]))c.set(N,r);const S={...s?.value||{},...n[o]};this.a.set(o,{source:r,value:S,valuesSources:c});const E=(0,T.getLanguageTagSettingPlainKey)(o),A={type:"object",default:S,description:D.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:l.isString(r)?void 0:r,defaultValueSource:r};i.push(...y(o)),this.d[o]=A,this.b.properties[o]=A}else{this.a.set(o,{value:n[o],source:r});const s=this.d[o];s&&(this.w(o,s),this.r(o,s))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:n}of t)for(const r in i){const o=this.a.get(r),s=l.isString(n)?n:n?.id,c=l.isString(o?.source)?o?.source:o?.source?.id;if(s===c)if(a.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const S=this.d[r];S&&(this.w(r,S),this.r(r,S))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(n=>{this.p(n,a,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,a){const i=n=>{if(n.properties)for(const r in n.properties){a.add(r);const o=this.d[r];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>i(r))};for(const n of t){i(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,a=!0,i,n,r=3,o){r=l.isUndefinedOrNull(t.scope)?r:t.scope;const s=t.properties;if(s)for(const S in s){const E=s[S];if(a&&p(S,E)){delete s[S];continue}if(E.source=i,E.defaultDefaultValue=s[S].default,this.w(S,E),e.OVERRIDE_PROPERTY_REGEX.test(S)?E.scope=void 0:(E.scope=l.isUndefinedOrNull(E.scope)?r:E.scope,E.restricted=l.isUndefinedOrNull(E.restricted)?!!n?.includes(S):E.restricted),s[S].hasOwnProperty("included")&&!s[S].included){this.f[S]=s[S],delete s[S];continue}else this.d[S]=s[S],s[S].policy?.name&&this.e.set(s[S].policy.name,S);!s[S].deprecationMessage&&s[S].markdownDeprecationMessage&&(s[S].deprecationMessage=s[S].markdownDeprecationMessage),o.add(S)}const c=t.allOf;if(c)for(const S of c)this.p(S,a,i,n,r,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const n=i.properties;if(n)for(const o in n)this.r(o,n[o]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(a,i),e.allSettings.properties[a]=i,e.applicationSettings.properties[a]=i,e.machineSettings.properties[a]=i,e.machineOverridableSettings.properties[a]=i,e.windowSettings.properties[a]=i,e.resourceSettings.properties[a]=i}}v(){const t={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let n=i?.value,r=i?.source;l.isUndefined(n)&&(n=a.defaultDefaultValue,r=void 0),l.isUndefined(n)&&(n=u(a.type)),a.default=n,a.defaultValueSource=r}}const h="\\[([^\\]]+)\\]",m=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(C){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(C)){let a=m.exec(C);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=m.exec(C)}}return(0,k.distinct)(t)}e.overrideIdentifiersFromKey=y;function f(C){return C.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=f;function u(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const d=new g;I.Registry.add(e.Extensions.Configuration,d);function p(C,t){return C.trim()?e.OVERRIDE_PROPERTY_REGEX.test(C)?D.localize(7,null,C):d.getConfigurationProperties()[C]!==void 0?D.localize(8,null,C):t.policy?.name&&d.getPolicyConfigurations().get(t.policy?.name)!==void 0?D.localize(9,null,C,t.policy?.name,d.getPolicyConfigurations().get(t.policy?.name)):null:D.localize(6,null)}e.validateProperty=p;function b(){const C=[],t=d.getConfigurationProperties();for(const a of Object.keys(t))C.push([a,t[a].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.getScopes=b}),define(ne[73],se([0,1,18,3,35,2,38,32,12,10,16,45,40]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function h(a){return Object.isFrozen(a)?a:R.deepFreeze(a)}class m{constructor(i={},n=[],r=[],o){this.b=i,this.c=n,this.d=r,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof m)return n;const r=new y("");return r.parseRaw(n),r.configurationModel});this.f=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const r=this.rawConfiguration.getValue(i),o=n?this.rawConfiguration.getOverrideValue(i,n):void 0,s=n?this.rawConfiguration.override(n).getValue(i):r;return{value:r,override:o,merged:s}}getOverrideValue(i,n){const r=this.i(n);return r?i?(0,P.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return k.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return k.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=R.deepClone(this.contents),r=R.deepClone(this.overrides),o=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const c of i)if(s.push(...c.raw?.length?c.raw:[c]),!c.isEmpty()){this.h(n,c.contents);for(const S of c.overrides){const[E]=r.filter(A=>k.equals(A.identifiers,S.identifiers));E?(this.h(E.contents,S.contents),E.keys.push(...S.keys),E.keys=k.distinct(E.keys)):r.push(R.deepClone(S))}for(const S of c.keys)o.indexOf(S)===-1&&o.push(S)}return new m(n,o,r,s.every(c=>c instanceof m)?void 0:s)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const o of k.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[o];const c=n[o];c&&(typeof s=="object"&&typeof c=="object"?(s=R.deepClone(s),this.h(s,c)):s=c),r[o]=s}return new m(r,this.keys,this.overrides)}h(i,n){for(const r of Object.keys(n)){if(r in i&&I.isObject(i[r])&&I.isObject(n[r])){this.h(i[r],n[r]);continue}i[r]=R.deepClone(n[r])}}i(i){let n=null,r=null;const o=s=>{s&&(r?this.h(r,s):r=R.deepClone(s))};for(const s of this.overrides)k.equals(s.identifiers,[i])?n=s.contents:s.identifiers.includes(i)&&o(s.contents);return o(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,P.removeFromValueTree)(this.contents,i),w.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>k.equals(r.identifiers,(0,w.overrideIdentifiersFromKey)(i))),1))}j(i,n,r){(0,P.addToValueTree)(this.contents,i,n,o=>console.error(o)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),w.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,P.toValuesTree)(this.contents[i],o=>console.error(o))})}}e.ConfigurationModel=m;class y{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!I.isUndefinedOrNull(i)){const r=this.g(i);this.parseRaw(r,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:r,keys:o,overrides:s,restricted:c,hasExcludedProperties:S}=this.h(i,n);this.b=new m(r,o,s,S?[i]:void 0),this.c=c||[]}g(i){let n={},r=null,o=[];const s=[],c=[];function S(A){Array.isArray(o)?o.push(A):r!==null&&(o[r]=A)}const E={onObjectBegin:()=>{const A={};S(A),s.push(o),o=A,r=null},onObjectProperty:A=>{r=A},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{const A=[];S(A),s.push(o),o=A,r=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:S,onError:(A,N,M)=>{c.push({error:A,offset:N,length:M})}};if(i)try{l.visit(i,E),n=o[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return n}h(i,n){const r=g.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),o=this.i(i,r,!0,n);i=o.raw;const s=(0,P.toValuesTree)(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),c=Object.keys(i),S=this.j(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:s,keys:c,overrides:S,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(i,n,r,o){let s=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:s};const c={},S=[];for(const E in i)if(w.OVERRIDE_PROPERTY_REGEX.test(E)&&r){const A=this.i(i[E],n,!1,o);c[E]=A.raw,s=s||A.hasExcludedProperties,S.push(...A.restricted)}else{const A=n[E],N=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&S.push(E),(N===void 0||o.scopes===void 0||o.scopes.includes(N))&&!(o.skipRestricted&&A?.restricted)?c[E]=i[E]:s=!0}return{raw:c,restricted:S,hasExcludedProperties:s}}j(i,n){const r=[];for(const o of Object.keys(i))if(w.OVERRIDE_PROPERTY_REGEX.test(o)){const s={};for(const c in i[o])s[c]=i[o][c];r.push({identifiers:(0,w.overrideIdentifiersFromKey)(o),keys:Object.keys(s),contents:(0,P.toValuesTree)(s,n)})}return r}}e.ConfigurationModelParser=y;class f extends D.Disposable{constructor(i,n,r,o){super(),this.f=i,this.g=n,this.h=o,this.c=this.B(new L.Emitter),this.onDidChange=this.c.event,this.a=new y(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(L.Event.any(L.Event.filter(this.h.onDidFilesChange,s=>s.contains(this.f)),L.Event.filter(this.h.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&r.isEqual(s.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new m}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=f;class u{constructor(i,n,r,o,s,c,S,E,A,N,M,B,O){this.a=i,this.b=n,this.c=r,this.overrideIdentifiers=o,this.d=s,this.f=c,this.g=S,this.h=E,this.i=A,this.j=N,this.k=M,this.l=B,this.m=O}get value(){return h(this.c)}n(i,n,r){const o=i.inspect(n,r);return{get value(){return h(o.value)},get override(){return h(o.override)},get merged(){return h(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class d{constructor(i,n,r,o,s=new m,c=new m,S=new T.ResourceMap,E=new m,A=new T.ResourceMap){this.c=i,this.d=n,this.f=r,this.g=o,this.h=s,this.i=c,this.j=S,this.l=E,this.m=A,this.a=null,this.b=new T.ResourceMap,this.n=null}getValue(i,n,r){return this.q(i,n,r).getValue(i)}updateValue(i,n,r={}){let o;r.resource?(o=this.m.get(r.resource),o||(o=new m,this.m.set(r.resource,o))):o=this.l,n===void 0?o.removeValue(i):o.setValue(i,n),r.resource||(this.a=null)}inspect(i,n,r){const o=this.q(i,n,r),s=this.u(n.resource,r),c=n.resource?this.m.get(n.resource)||this.l:this.l,S=new Set;for(const E of o.overrides)for(const A of E.identifiers)o.getOverrideValue(i,A)!==void 0&&S.add(A);return new u(i,n,o.getValue(i),S.size?[...S]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,s||void 0,c)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:o,updated:s,removed:c}=C(this.c,i);n=[...o,...s,...c]}for(const o of n)for(const s of(0,w.overrideIdentifiersFromKey)(o)){const c=this.c.getKeysForOverrideIdentifier(s),S=i.getKeysForOverrideIdentifier(s),E=[...S.filter(A=>c.indexOf(A)===-1),...c.filter(A=>S.indexOf(A)===-1),...c.filter(A=>!R.equals(this.c.override(s).getValue(A),i.override(s).getValue(A)))];r.push([s,E])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:o}=C(this.d,i),s=[...n,...r,...o];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:o,overrides:s}=C(this.applicationConfiguration,i),c=[...n,...r,...o];return c.length&&this.updateApplicationConfiguration(i),{keys:c,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:s}=C(this.localUserConfiguration,i),c=[...n,...r,...o];return c.length&&this.updateLocalUserConfiguration(i),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:s}=C(this.remoteUserConfiguration,i),c=[...n,...r,...o];return c.length&&this.updateRemoteUserConfiguration(i),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:o,overrides:s}=C(this.workspaceConfiguration,i),c=[...n,...r,...o];return c.length&&this.updateWorkspaceConfiguration(i),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(i,n){const r=this.p.get(i),{added:o,updated:s,removed:c,overrides:S}=C(r,n),E=[...o,...s,...c];return(E.length||!r)&&this.updateFolderConfiguration(i,n),{keys:E,overrides:S}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:o,removed:s,overrides:c}=C(n,void 0);return{keys:[...r,...o,...s],overrides:c}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,r){let o=this.r(n,r);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(o=o.merge(this.d)),o}r({resource:i},n){let r=this.s();if(n&&i){const o=n.getFolder(i);o&&(r=this.t(o.uri)||r);const s=this.m.get(i);s&&(r=r.merge(s))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const r=this.s(),o=this.j.get(i);o?(n=r.merge(o),this.b.set(i,n)):n=r}return n}u(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:r,overrides:o,keys:s}=this.j.get(n);return i.push([n,{contents:r,overrides:o,keys:s}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o))),[...n.values()]}static parse(i){const n=this.x(i.defaults),r=this.x(i.policy),o=this.x(i.application),s=this.x(i.user),c=this.x(i.workspace),S=i.folders.reduce((E,A)=>(E.set(v.URI.revive(A[0]),this.x(A[1])),E),new T.ResourceMap);return new d(n,r,o,s,new m,c,S,new m,new T.ResourceMap)}static x(i){return new m(i.contents,i.keys,i.overrides)}}e.Configuration=d;function p(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,n=new Map;for(const o of a)o.keys.forEach(s=>i.add(s)),o.overrides.forEach(([s,c])=>{const S=(0,T.getOrSet)(n,s,new Set);c.forEach(E=>S.add(E))});const r=[];return n.forEach((o,s)=>r.push([s,[...o.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=p;class b{constructor(i,n,r,o){this.change=i,this.f=n,this.g=r,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const s of i.keys)this.affectedKeys.add(s);for(const[,s]of i.overrides)for(const c of s)this.affectedKeys.add(c);this.d=this.a;for(const s of this.affectedKeys)this.d+=s+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(i,n){const r=this.a+i,o=this.d.indexOf(r);if(o<0)return!1;const s=o+r.length;if(s>=this.d.length)return!1;const c=this.d.charCodeAt(s);if(c!==this.b&&c!==this.c)return!1;if(n){const S=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,E=this.g.getValue(i,n,this.h);return!R.equals(S,E)}return!0}}e.ConfigurationChangeEvent=b;function C(a,i){const{added:n,removed:r,updated:o}=t(i?.rawConfiguration,a?.rawConfiguration),s=[],c=a?.getAllOverrideIdentifiers()||[],S=i?.getAllOverrideIdentifiers()||[];if(i){const E=S.filter(A=>!c.includes(A));for(const A of E)s.push([A,i.getKeysForOverrideIdentifier(A)])}if(a){const E=c.filter(A=>!S.includes(A));for(const A of E)s.push([A,a.getKeysForOverrideIdentifier(A)])}if(i&&a){for(const E of c)if(S.includes(E)){const A=t({contents:a.getOverrideValue(void 0,E)||{},keys:a.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});s.push([E,[...A.added,...A.removed,...A.updated]])}}return{added:n,removed:r,updated:o,overrides:s}}function t(a,i){const n=a?i?a.keys.filter(s=>i.keys.indexOf(s)===-1):[...a.keys]:[],r=i?a?i.keys.filter(s=>a.keys.indexOf(s)===-1):[...i.keys]:[],o=[];if(a&&i){for(const s of i.keys)if(a.keys.indexOf(s)!==-1){const c=(0,P.getConfigurationValue)(i.contents,s),S=(0,P.getConfigurationValue)(a.contents,s);R.equals(c,S)||o.push(s)}}return{added:n,removed:r,updated:o}}}),define(ne[223],se([0,1,18,3,2,32,12,73,45,11,58,40]),function(Z,e,k,L,l,D,T,R,I,v,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class g extends l.Disposable{constructor(){super(...arguments),this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new R.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(w.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:u})=>this.c(Array.from(f),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(f,u){this.h(f,w.Registry.as(I.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:f})}f(){return{}}g(){this.b=new R.ConfigurationModel;const f=w.Registry.as(I.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(f),f)}h(f,u){const d=this.f();for(const p of f){const b=d[p],C=u[p];b!==void 0?this.b.addValue(p,b):C?this.b.addValue(p,C.default):this.b.removeValue(p)}}}e.DefaultConfiguration=g;class h{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new R.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=h;let m=class extends l.Disposable{get configurationModel(){return this.b}constructor(f,u,d){super(),this.c=f,this.f=u,this.g=d,this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new R.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(f=>this.i(f))),this.B(this.c.onDidChangeConfiguration(async({properties:f})=>this.j(await this.h(f),!0))),this.b}async h(f){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",f);const u={},d=[],p=w.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const b of f){const C=p[b];if(!C){d.push(b);continue}if(C.policy){if(C.type!=="string"&&C.type!=="number"){this.g.warn(`Policy ${C.policy.name} has unsupported type ${C.type}`);continue}d.push(b),u[C.policy.name]={type:C.type}}}return(0,T.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),d}i(f){this.g.trace("PolicyConfiguration#onDidChangePolicies",f);const u=w.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),d=(0,k.coalesce)(f.map(p=>u.get(p)));this.j(d,!0)}j(f,u){this.g.trace("PolicyConfiguration#update",f);const d=w.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),p=[],b=this.b.isEmpty();for(const C of f){const t=d[C]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(b?a!==void 0:!(0,D.equals)(this.b.getValue(C),a))&&p.push([C,a])}else this.b.getValue(C)!==void 0&&p.push([C,void 0])}if(p.length){this.g.trace("PolicyConfiguration#changed",p);const C=this.b;this.b=new R.ConfigurationModel;for(const t of C.keys)this.b.setValue(t,C.getValue(t));for(const[t,a]of p)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);u&&this.a.fire(this.b)}}};m=ye([Y(1,P.IPolicyService),Y(2,v.ILogService)],m),e.PolicyConfiguration=m}),define(ne[224],se([0,1,6,3,2,24,16,73,223,58]),function(Z,e,k,L,l,D,T,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends l.Disposable{constructor(g,h,m,y){super(),this.i=g,this.h=this.B(new L.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new I.DefaultConfiguration),this.c=m instanceof v.NullPolicyService?new I.NullPolicyConfiguration:this.B(new I.PolicyConfiguration(this.b,m,y)),this.f=this.B(new R.UserSettings(this.i,void 0,D.extUriBiasedIgnorePathCase,h)),this.a=new R.Configuration(this.b.configurationModel,this.c.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.g=this.B(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:f,properties:u})=>this.k(f,u))),this.B(this.c.onDidChangeConfiguration(f=>this.l(f))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,h,m]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.Configuration(g,h,new R.ConfigurationModel,m)}getConfigurationData(){return this.a.toData()}getValue(g,h){const m=typeof g=="string"?g:void 0,y=(0,T.isConfigurationOverrides)(g)?g:(0,T.isConfigurationOverrides)(h)?h:{};return this.a.getValue(m,y,void 0)}updateValue(g,h,m,y){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.j(g)}j(g){const h=this.a.toData(),m=this.a.compareAndUpdateLocalUserConfiguration(g);this.m(m,h,2)}k(g,h){const m=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(g,h);this.m(y,m,7)}l(g){const h=this.a.toData(),m=this.a.compareAndUpdatePolicyConfiguration(g);this.m(m,h,7)}m(g,h,m){const y=new R.ConfigurationChangeEvent(g,{data:h},this.a);y.source=m,y.sourceConfig=this.n(m),this.h.fire(y)}n(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(ne[225],se([0,1,8,5]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var l;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends k.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof D&&I._code===l.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof D&&I._code===l.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof D&&I._code===l.NoResolverFound}static isHandled(I){return I instanceof D&&I.isHandled}constructor(I,v=l.Unknown,P){super(I),this._message=I,this._code=v,this._detail=P,this.isHandled=v===l.NotAvailable&&P===!0,Object.setPrototypeOf(this,D.prototype)}}e.RemoteAuthorityResolverError=D;function T(R){const I=R.indexOf("+");return I===-1?R:R.substring(0,I)}e.getRemoteAuthorityPrefix=T}),define(ne[74],se([0,1,21]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(v){return v.scheme===k.Schemas.vscodeRemote?v.authority:void 0}e.getRemoteAuthority=L;function l(v){if(!v)return;const P=v.indexOf("+");return P<0?v:v.substr(0,P)}e.getRemoteName=l;function D(v){return`/${v.quality??"oss"}-${v.commit??"dev"}`}e.getRemoteServerRootPath=D;function T(v){const{host:P,port:w}=I(v);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:w}}e.parseAuthorityWithPort=T;function R(v,P){let{host:w,port:g}=I(v);return typeof g>"u"&&(g=P),{host:w,port:g}}e.parseAuthorityWithOptionalPort=R;function I(v){const P=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const w=v.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const g=v.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:v,port:void 0}}}),define(ne[46],se([0,1,26,5,74]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));var R;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(R=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(m){this.value=m,this.c=m.toLowerCase()}static equals(m,y){if(typeof m>"u"||m===null)return typeof y>"u"||y===null;if(typeof y>"u"||y===null)return!1;if(typeof m=="string"||typeof y=="string"){const f=typeof m=="string"?m:m.value,u=typeof y=="string"?y:y.value;return k.equalsIgnoreCase(f,u)}return m.c===y.c}static toKey(m){return typeof m=="string"?m.toLowerCase():m.c}}e.ExtensionIdentifier=I;function v(h){return P(h)}e.isApplicationScopedExtension=v;function P(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function w(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function g(h,m){if(m){const y=`onResolveRemoteAuthority:${(0,l.getRemoteName)(m)}`;return!!h.activationEvents?.includes(y)}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[226],se([0,1,2,13,27,46]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends k.Disposable{constructor(I,v){super(),this.b=I,this.a=(0,L.join)(this.b.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this.B(v.onDidInstallExtensions(P=>this.c(P))),this.B(v.onDidUninstallExtension(P=>this.f(P)))}c(I){I.some(v=>!!v.local)&&this.invalidate()}f(I){I.error||this.invalidate()}invalidate(){l.Promises.rm(this.a,l.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(ne[227],se([0,1,6,17,23,8,3,2,103,88,31,95,225,74]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const m=30*1e3;var y;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(y=e.ConnectionType||(e.ConnectionType={}));function f(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(U){const z=new l.CancellationTokenSource;return setTimeout(()=>z.cancel(),U),z.token}function d(U,z){if(U.isCancellationRequested||z.isCancellationRequested)return l.CancellationToken.Cancelled;const V=new l.CancellationTokenSource;return U.onCancellationRequested(()=>V.cancel()),z.onCancellationRequested(()=>V.cancel()),V.token}class p{get didTimeout(){return this.c==="timedout"}constructor(z){this.c="pending",this.d=new R.DisposableStore,this.promise=new Promise((V,_)=>{this.f=V,this.g=_}),z.isCancellationRequested?this.h():this.d.add(z.onCancellationRequested(()=>this.h()))}registerDisposable(z){this.c==="pending"?this.d.add(z):z.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const z=new Error("Time limit reached");return z.code="ETIMEDOUT",z.syscall="connect",z}resolve(z){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(z))}reject(z){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(z))}}function b(U,z){const V=new p(z);return V.registerDisposable(U.onControlMessage(_=>{const H=JSON.parse(_.toString()),X=G(H);X?V.reject(X):V.resolve(H)})),V.promise}function C(U,z,V,_,H,X,te,le,he){const me=new p(he),pe=v.StopWatch.create(!1);return U.info(`Creating a socket (${le})...`),I.mark(`code/willCreateSocket/${te}`),z.connect(V,_,H,X,le,(Se,Ce)=>{me.didTimeout?(I.mark(`code/didCreateSocketError/${te}`),U.info(`Creating a socket (${le}) finished after ${pe.elapsed()} ms, but this is too late and has timed out already.`),Se&&U.error(Se),Ce?.dispose()):Se||!Ce?(I.mark(`code/didCreateSocketError/${te}`),U.info(`Creating a socket (${le}) returned an error after ${pe.elapsed()} ms.`),me.reject(Se)):(I.mark(`code/didCreateSocketOK/${te}`),U.info(`Creating a socket (${le}) was successful after ${pe.elapsed()} ms.`),me.resolve(Ce))}),me.promise}function t(U,z){const V=new p(z);return U.then(_=>{V.didTimeout||V.resolve(_)},_=>{V.didTimeout||V.reject(_)}),V.promise}async function a(U,z,V,_){const H=x(U,z);U.logService.trace(`${H} 1/6. invoking socketFactory.connect().`);let X;try{X=await C(U.logService,U.socketFactory,U.host,U.port,(0,h.getRemoteServerRootPath)(U),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,f(z),`renderer-${f(z)}-${U.reconnectionToken}`,_)}catch(pe){throw U.logService.error(`${H} socketFactory.connect() failed or timed out. Error:`),U.logService.error(pe),pe}U.logService.trace(`${H} 2/6. socketFactory.connect() was successful.`);let te,le;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(X,null),te=U.reconnectionProtocol,le=!1):(te=new w.PersistentProtocol({socket:X,measureRoundTripTime:!0}),le=!0),U.logService.trace(`${H} 3/6. sending AuthRequest control message.`);const he=await t(U.signService.createNewMessage((0,P.generateUuid)()),_),me={type:"auth",auth:U.connectionToken||"00000000000000000000",data:he.data};te.sendControl(L.VSBuffer.fromString(JSON.stringify(me)));try{const pe=await b(te,d(_,u(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(U.logService.trace(`${H} 4/6. received SignRequest control message.`),!await t(U.signService.validate(he,pe.signedData),_)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Ce=await t(U.signService.sign(pe.data),_),De={type:"connectionType",commit:U.commit,signedData:Ce,desiredConnectionType:z};return V&&(De.args=V),U.logService.trace(`${H} 5/6. sending ConnectionTypeRequest control message.`),te.sendControl(L.VSBuffer.fromString(JSON.stringify(De))),{protocol:te,ownsProtocol:le}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&(U.logService.error(`${H} the handshake timed out. Error:`),U.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${H} received error control message when negotiating connection. Error:`),U.logService.error(pe)),le&&F(te),pe}}async function i(U,z,V,_){const H=Date.now(),X=x(U,z),{protocol:te,ownsProtocol:le}=await a(U,z,V,_),he=new p(_);return he.registerDisposable(te.onControlMessage(me=>{const pe=JSON.parse(me.toString()),Se=G(pe);Se?(U.logService.error(`${X} received error control message when negotiating connection. Error:`),U.logService.error(Se),le&&F(te),he.reject(Se)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${$(H)}!`),he.resolve({protocol:te,firstMessage:pe}))})),he.promise}async function n(U,z){const{protocol:V}=await i(U,1,void 0,z);return{protocol:V}}async function r(U,z,V){const{protocol:_,firstMessage:H}=await i(U,2,z,V),X=H&&H.debugPort;return{protocol:_,debugPort:X}}async function o(U,z,V){const _=Date.now(),H=x(U,3),{protocol:X}=await a(U,3,z,V);return U.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${$(_)}!`),X}async function s(U,z,V){const{host:_,port:H,connectionToken:X}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,host:_,port:H,connectionToken:X,reconnectionToken:z,reconnectionProtocol:V,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function c(U,z,V){return E(U,async _=>{const{protocol:H}=await n(_,l.CancellationToken.None);return new J(U,z,V,_.reconnectionToken,H)})}e.connectRemoteAgentManagement=c;async function S(U,z){return E(U,async V=>{const{protocol:_,debugPort:H}=await r(V,z,l.CancellationToken.None);return new W(U,z,V.reconnectionToken,_,H)})}e.connectRemoteAgentExtensionHost=S;async function E(U,z){for(let _=1;;_++)try{const H=(0,P.generateUuid)(),X=await s(U,H,null);return await z(X)}catch(H){if(_<5)U.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(H);else throw U.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(H),re.triggerPermanentFailure(0,0,g.RemoteAuthorityResolverError.isHandled(H)),H}}async function A(U,z,V){const _=await s(U,(0,P.generateUuid)(),null);return await o(_,{host:z,port:V},l.CancellationToken.None)}e.connectRemoteAgentTunnel=A;function N(U){return(0,k.createCancelablePromise)(z=>new Promise((V,_)=>{const H=setTimeout(V,U*1e3);z.onCancellationRequested(()=>{clearTimeout(H),V()})}))}var M;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain",U[U.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(M=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class B{constructor(z,V){this.reconnectionToken=z,this.millisSinceLastIncomingData=V,this.type=0}}e.ConnectionLostEvent=B;class O{constructor(z,V,_,H){this.reconnectionToken=z,this.millisSinceLastIncomingData=V,this.durationSeconds=_,this.c=H,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=O;class j{constructor(z,V,_){this.reconnectionToken=z,this.millisSinceLastIncomingData=V,this.attempt=_,this.type=2}}e.ReconnectionRunningEvent=j;class q{constructor(z,V,_){this.reconnectionToken=z,this.millisSinceLastIncomingData=V,this.attempt=_,this.type=4}}e.ConnectionGainEvent=q;class K{constructor(z,V){this.reconnectionToken=z,this.connectionHealth=V,this.type=5}}e.ConnectionHealthChangedEvent=K;class Q{constructor(z,V,_,H){this.reconnectionToken=z,this.millisSinceLastIncomingData=V,this.attempt=_,this.handled=H,this.type=3}}e.ReconnectionPermanentFailureEvent=Q;class re extends R.Disposable{static triggerPermanentFailure(z,V,_){this._permanentFailure=!0,this.f=z,this.g=V,this.h=_,this.i.forEach(H=>H.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(z=>z.s())}static debugPauseSocketWriting(){this.i.forEach(z=>z.w())}get k(){return this.c||re._permanentFailure}constructor(z,V,_,H,X){super(),this.n=z,this.p=V,this.reconnectionToken=_,this.protocol=H,this.r=X,this.j=this.B(new T.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new q(this.reconnectionToken,0,0)),this.B(H.onSocketClose(te=>{const le=ae(this.n,this.reconnectionToken,!0);te?te.type===0?(this.p.logService.info(`${le} received socket close event (hadError: ${te.hadError}).`),te.error&&this.p.logService.error(te.error)):(this.p.logService.info(`${le} received socket close event (wasClean: ${te.wasClean}, code: ${te.code}, reason: ${te.reason}).`),te.event&&this.p.logService.error(te.event)):this.p.logService.info(`${le} received socket close event.`),this.s()})),this.B(H.onSocketTimeout(te=>{const le=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${te.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${te.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${te.timeSinceLastReceivedSomeData}).`),this.s()})),this.B(H.onHighRoundTripTime(te=>{const le=oe(this.n,this.reconnectionToken);this.p.logService.info(`${le} high roundtrip time: ${te.roundTripTime}ms (${te.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(H.onDidChangeConnectionHealth(te=>{this.j.fire(new K(this.reconnectionToken,te))})),re.i.push(this),this.B((0,R.toDisposable)(()=>{const te=re.i.indexOf(this);te>=0&&re.i.splice(te,1)})),this.k&&this.v(re.f,re.g,re.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const z=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${z} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const V=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const H=_<V.length?V[_]:V[V.length-1];try{if(H>0){const te=N(H);this.j.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H,te)),this.p.logService.info(`${z} waiting for ${H} seconds before reconnecting...`);try{await te}catch{}}if(this.k){this.p.logService.error(`${z} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.p.logService.info(`${z} resolving connection...`);const X=await s(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${z} connecting to ${X.host}:${X.port}...`),await this.y(X,u(m)),this.p.logService.info(`${z} reconnected!`),this.j.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(X),this.u(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.p.logService.error(`${z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(X),this.u(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(g.RemoteAuthorityResolverError.isTemporarilyNotAvailable(X)){this.p.logService.info(`${z} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this.p.logService.info(`${z} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(X);continue}if((0,D.isCancellationError)(X)){this.p.logService.info(`${z} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(X);continue}if(X instanceof g.RemoteAuthorityResolverError){this.p.logService.error(`${z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(X),this.u(this.protocol.getMillisSinceLastIncomingData(),_+1,g.RemoteAuthorityResolverError.isHandled(X));break}this.p.logService.error(`${z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(X),this.u(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.k&&!this.m)}u(z,V,_){this.r?re.triggerPermanentFailure(z,V,_):this.v(z,V,_)}v(z,V,_){this.j.fire(new Q(this.reconnectionToken,z,V,_)),F(this.protocol)}w(){this.protocol.pauseSocketWriting()}}re._permanentFailure=!1,re.f=0,re.g=0,re.h=!1,re.i=[],e.PersistentConnection=re;class J extends re{constructor(z,V,_,H,X){super(1,z,H,X,!0),this.client=this.B(new w.Client(X,{remoteAuthority:V,clientId:_},z.ipcLogger))}async y(z,V){await n(z,V)}}e.ManagementPersistentConnection=J;class W extends re{constructor(z,V,_,H,X){super(2,z,_,H,!1),this.z=V,this.debugPort=X}async y(z,V){await r(z,this.z,V)}}e.ExtensionHostPersistentConnection=W;function F(U){try{U.acceptDisconnect();const z=U.getSocket();U.dispose(),z.dispose()}catch(z){(0,D.onUnexpectedError)(z)}}function G(U){if(U&&U.type==="error"){const z=new Error(`Connection error: ${U.reason}`);return z.code="VSCODE_CONNECTION_ERROR",z}return null}function ee(U,z){for(;U.length<z;)U+=" ";return U}function oe(U,z){return`[remote-connection][${ee(f(U),13)}][${z.substr(0,5)}\u2026]`}function ae(U,z,V){return`${oe(U,z)}[${V?"reconnect":"initial"}]`}function x(U,z){return`${ae(z,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function $(U){return`${Date.now()-U} ms`}}),define(ne[228],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[229],se([0,1,85,155]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(l,D,T,R,I,v){const P=g=>v(g,void 0),w=k.createConnection({host:l,port:D},()=>{w.removeListener("error",P);const g=Buffer.alloc(16);for(let f=0;f<16;f++)g[f]=Math.round(Math.random()*256);const h=g.toString("base64"),m=[`GET ws://${/:/.test(l)?`[${l}]`:l}:${D}${T}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`];w.write(m.join(`\r
`)+`\r
\r
`);const y=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",y),v(void 0,new L.NodeSocket(w,I)))};w.on("data",y)});w.setNoDelay(!0),w.once("error",P)}}}),define(ne[108],se([0,1,5,173]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,k.createDecorator)("IRemoteTunnelService");var l;(function(D){D.disconnected={type:"disconnected"},D.uninitialized={type:"uninitialized"},D.connected=T=>({type:"connected",info:T}),D.connecting=T=>({type:"connecting",progress:T})})(l=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME=(0,L.localize)(0,null),e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(ne[230],se([0,1,138,16,11]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let D=class{constructor(R,I){this.a=R,this.b=I}async request(R,I){this.b.trace("RequestService#request (browser) - begin",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.a.getValue("http.proxyAuthorization"));try{const v=await(0,k.request)(R,I);return this.b.trace("RequestService#request (browser) - success",R.url),v}catch(v){throw this.b.error("RequestService#request (browser) - error",R.url,v),v}}async resolveProxy(R){}};D=ye([Y(0,L.IConfigurationService),Y(1,l.ILogService)],D),e.RequestService=D}),define(ne[59],se([0,1,17,175,45,5,40]),function(Z,e,k,L,l,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function R(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=R;function I(y){return y.res.statusCode===204}async function v(y){return I(y)?null:(await(0,k.streamToBuffer)(y.stream)).toString()}e.asText=v;async function P(y){if(!R(y))throw new Error("Server returned "+y.res.statusCode);return v(y)}e.asTextOrError=P;async function w(y){if(!R(y))throw new Error("Server returned "+y.res.statusCode);if(I(y))return null;const u=(await(0,k.streamToBuffer)(y.stream)).toString();try{return JSON.parse(u)}catch(d){throw d.message+=`:
`+u,d}}e.asJson=w;function g(y){m(y)}e.updateProxyConfigurationsScope=g;let h;function m(y){const f=T.Registry.as(l.Extensions.Configuration),u=h;h={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[h],remove:u?[u]:[]})}m(2)}),define(ne[231],se([0,1,23,21,14,59]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(I,v){this.a=I,this.b=v}async download(I,v,P=k.CancellationToken.None){if(I.scheme===L.Schemas.file||I.scheme===L.Schemas.vscodeRemote){await this.b.copy(I,v);return}const w={type:"GET",url:I.toString(!0)},g=await this.a.request(w,P);if(g.res.statusCode===200)await this.b.writeFile(v,g.stream);else{const h=await(0,D.asTextOrError)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${h}`)}}};T=ye([Y(0,D.IRequestService),Y(1,l.IFileService)],T),e.DownloadService=T}),define(ne[232],se([0,1,17,23]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class l{constructor(R){this.a=R}listen(R,I){throw new Error("Invalid listen")}call(R,I,v,P=L.CancellationToken.None){switch(I){case"request":return this.a.request(v[0],P).then(async({res:w,stream:g})=>{const h=await(0,k.streamToBuffer)(g);return[{statusCode:w.statusCode,headers:w.headers},h]});case"resolveProxy":return this.a.resolveProxy(v[0])}throw new Error("Invalid call")}}e.RequestChannel=l;class D{constructor(R){this.a=R}async request(R,I){const[v,P]=await this.a.call("request",[R],I);return{res:v,stream:(0,k.bufferToStream)(P)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.RequestChannelClient=D}),define(ne[233],se([0,1,12,230,232]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class D{constructor(R,I,v){this.c=I,this.d=v,this.a=new L.RequestService(I,v),this.b=new l.RequestChannelClient(R.getChannel("request"))}request(R,I){return this.e().request(R,I)}async resolveProxy(R){return this.e().resolveProxy(R)}e(){return this.f()?(this.d.trace("Using main request service"),this.b):(this.d.trace("Using browser request service"),this.a)}f(){const R=this.c.getValue("developer.sharedProcess.redirectRequestsToMain");return(0,k.isBoolean)(R)?R:!0}}e.SharedProcessRequestService=D}),define(ne[109],se([0,1,65,5]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISharedProcessWorkerService=e.hash=void 0;function l(D){return(0,k.hash)({moduleId:D.process.moduleId,windowId:D.reply.windowId})}e.hash=l,e.ISharedProcessWorkerService=(0,L.createDecorator)("sharedProcessWorkerService")}),define(ne[234],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(L){L.Spawn="vscode:shared-process->shared-process-worker=spawn",L.Terminate="vscode:shared-process->shared-process-worker=terminate",L.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",L.Ready="vscode:shared-process-worker->shared-process=ready",L.Ack="vscode:shared-process-worker->shared-process=ack",L.Trace="vscode:shared-process-worker->shared-process=trace",L.Info="vscode:shared-process-worker->shared-process=info",L.Warn="vscode:shared-process-worker->shared-process=warn",L.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[235],se([0,1,153,6,23,3,2,21,31,11,109,234]),function(Z,e,k,L,l,D,T,R,I,v,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let g=class{constructor(y){this.d=y,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(y){const f=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${f})`);const u=(0,P.hash)(y);this.b.has(u)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${f})`),this.f(y));const d=new l.CancellationTokenSource;let p,b,C;this.b.set(u,n=>{d.dispose(!0),p?.terminate(y,l.CancellationToken.None),b?.close(),C?.close(),this.b.delete(u);const r=this.c.get(u);r&&(this.c.delete(u),r({reason:n}))}),p=await this.e(y);const t=new Promise(n=>{this.c.set(u,n)});if(d.token.isCancellationRequested)return t;const{port1:a,port2:i}=new MessageChannel;return b=a,C=i,await p.spawn(y,C,d.token),d.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${f})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",y,[b])),t}e(y){let f=this.a.get(y.process.moduleId);if(!f){this.d.trace(`SharedProcess: creating new web worker (${y.process.moduleId})`);const u=new h(y.process.type,this.d);f=u.init(),u.onDidProcessSelfTerminate(({configuration:d,reason:p})=>{this.f(d,p)}),this.a.set(y.process.moduleId,f)}return f}async disposeWorker(y){return this.f(y)}f(y,f){const u=this.b.get((0,P.hash)(y));u&&(this.d.trace(`SharedProcess: disposeWorker (window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),u(f))}};g=ye([Y(0,v.ILogService)],g),e.SharedProcessWorkerService=g;class h extends T.Disposable{constructor(y,f){super(),this.f=y,this.g=f,this.a=this.B(new D.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const y=new L.DeferredPromise,f=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return f.onerror=u=>{this.g.error(`SharedProcess: worker error (${this.f})`,u.message)},f.onmessageerror=u=>{this.g.error(`SharedProcess: worker message error (${this.f})`,u)},f.onmessage=u=>{const{id:d,message:p,configuration:b,nonce:C}=u.data;switch(d){case w.SharedProcessWorkerMessages.Ready:y.complete(f);break;case w.SharedProcessWorkerMessages.Ack:if(C){const t=this.c.get(C);t&&(this.c.delete(C),t())}break;case w.SharedProcessWorkerMessages.SelfTerminated:b&&p&&this.a.fire({configuration:b,reason:JSON.parse(p)});break;case w.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,p);break;case w.SharedProcessWorkerMessages.Info:p&&this.g.info(p);break;case w.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,p);break;case w.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,p);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,u)}},f.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),y.p}async i(y,f,u){const d=await this.b;if(!f.isCancellationRequested)return new Promise(p=>{const b=(0,I.generateUuid)();this.c.set(b,p);const C={...y,nonce:b};u?d.postMessage(C,[u]):d.postMessage(C),f.onCancellationRequested(()=>{this.c.delete(b)&&p()})})}spawn(y,f,u){const d={id:w.SharedProcessWorkerMessages.Spawn,configuration:y,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(d,u,f)}terminate(y,f){const u={id:w.SharedProcessWorkerMessages.Terminate,configuration:y};return this.i(u,f)}}}),define(ne[236],se([0,1,62,21,96]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class D extends l.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}}ye([k.memoize],D.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=D}),define(ne[237],se([0,1,50,13,176,23,39,8,4,31,150,193,6,131]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let m;async function y(u,d,p,b){return p["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(b)&&!p["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(b)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=g.Promises.withAsyncBody(async(C,t)=>{const a=new D.CancellationTokenSource;let i=1e4;const n=u.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,h.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{a.dispose(!0),t(new Error((0,l.localize)(0,null)))},i);try{C(await f(d,a.token))}catch(o){!(0,R.isCancellationError)(o)&&!a.token.isCancellationRequested?t(new Error((0,l.localize)(1,null,(0,T.toErrorMessage)(o)))):C({})}finally{clearTimeout(r),a.dispose()}})),m)}e.getResolvedShellEnv=y;async function f(u,d){const p=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",p);const b=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",b);const C=(0,v.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(C+"({.*})"+C),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",a);const i=await(0,P.getSystemShell)(I.OS,a);return u.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(d.isCancellationRequested)return r(new R.CancellationError);const o=(0,L.basename)(i);let s,c;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(s=`& '${process.execPath}' ${S} -p '''${C}'' + JSON.stringify(process.env) + ''${C}'''`,c=["-Login","-Command"]):(s=`'${process.execPath}' ${S} -p '"${C}" + JSON.stringify(process.env) + "${C}"'`,o==="tcsh"||o==="csh"?c=["-ic"]:c=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(c),s);const E=(0,k.spawn)(i,[...c,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});d.onCancellationRequested(()=>(E.kill(),r(new R.CancellationError))),E.on("error",M=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(M)),r(M)});const A=[];E.stdout.on("data",M=>A.push(M));const N=[];E.stderr.on("data",M=>N.push(M)),E.on("close",(M,B)=>{const O=Buffer.concat(A).toString("utf8");u.trace("getUnixShellEnvironment#raw",O);const j=Buffer.concat(N).toString("utf8");if(j.trim()&&u.trace("getUnixShellEnvironment#stderr",j),M||B)return r(new Error((0,l.localize)(2,null,M,B)));const q=t.exec(O),K=q?q[1]:"{}";try{const Q=JSON.parse(K);p?Q.ELECTRON_RUN_AS_NODE=p:delete Q.ELECTRON_RUN_AS_NODE,b?Q.ELECTRON_NO_ATTACH_CONSOLE=b:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.VSCODE_RESOLVING_ENVIRONMENT,delete Q.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",Q),n(Q)}catch(Q){u.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(Q)),r(Q)}})})}}),define(ne[110],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[238],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.b=new Map}c(){return new Promise((l,D)=>Z(["vsda"],l,D))}async createNewMessage(l){try{const D=await this.c(),T=new D.validator;if(T){const R=String(k.a++);return this.b.set(R,T),{id:R,data:T.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,D){if(!l.id)return!0;const T=this.b.get(l.id);if(!T)return!1;this.b.delete(l.id);try{return T.validate(D)==="ok"}catch{return!1}}async sign(l){try{const D=await this.c(),T=new D.signer;if(T)return T.sign(l)}catch{}return l}}k.a=1,e.SignService=k}),define(ne[75],se([0,1,3,2]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class l extends L.Disposable{constructor(w,g,h){super(),this.a=w,this.b=g,this.c=h}async getItems(){const w={profile:this.b,workspace:this.c},g=await this.a.call("getItems",w);return new Map(g)}updateItems(w){const g={profile:this.b,workspace:this.c};return w.insert&&(g.insert=Array.from(w.insert.entries())),w.delete&&(g.delete=Array.from(w.delete.values())),this.a.call("updateItems",g)}}class D extends l{constructor(w,g){super(w,g,void 0),this.f=this.B(new k.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(w=>this.h(w)))}h(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this.f.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}}class T extends D{constructor(w){super(w,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class R extends D{constructor(w,g){super(w,g)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class I extends l{constructor(w,g){super(w,void 0,g),this.onDidChangeItemsExternal=k.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class v{constructor(w){this.a=w}isUsed(w){const g={payload:w,profile:void 0,workspace:void 0};return this.a.call("isUsed",g)}}e.StorageClient=v}),define(ne[111],se([0,1,4,36,10,31]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(v){if(k.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function R(v,P,w,g,h,m,y,f,u,d){const p=Object.create(null);p["common.machineId"]=y,p.sessionID=(0,D.generateUuid)()+Date.now(),p.commitHash=h,p.version=m,p["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,k.PlatformToString)(k.platform),p["common.nodePlatform"]=L.platform,p["common.nodeArch"]=g,p["common.product"]=d||"desktop",f&&(p["common.msftInternal"]=f);let b=0;const C=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-C,enumerable:!0},"common.sequence":{get:()=>b++,enumerable:!0}}),k.isLinuxSnap&&(p["common.snap"]="true");const t=T(w);t&&(p["common.platformDetail"]=t);try{const a=await v.readFile(l.URI.file(u));p["common.source"]=a.value.toString().slice(0,30)}catch{}return p}e.resolveCommonProperties=R;function I(v){const P=L.env.USERDNSDOMAIN;if(!P)return!1;const w=P.toLowerCase();return v.some(g=>w===g)}e.verifyMicrosoftInternalDomain=I}),define(ne[19],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[239],se([0,1,34,6,35,21,13,4,10,147,27,149,97,14,25,19]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const f=new Map;async function u(t,a){const i=`${t}::${a.join(":")}`,n=f.get(i);if(n)return n;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,s=new Map,c=2e4;function S(A,N,M,B){const O=N.substring(A.length+1);return L.Promises.withAsyncBody(async j=>{let q;try{q=await P.Promises.readdir(N,{withFileTypes:!0})}catch{j();return}if(B.count>=c){B.count+=q.length,B.maxReached=!0,j();return}let K=q.length;if(K===0){j();return}let Q=q;B.count+q.length>c&&(B.maxReached=!0,K=c-B.count,Q=q.slice(0,K)),B.count+=q.length;for(const re of Q)if(re.isDirectory()){if(M.includes(re.name)||await S(A,(0,T.join)(N,re.name),M,B),--K===0){j();return}}else{const J=re.name.lastIndexOf(".");if(J>=0){const W=re.name.substring(J+1);W&&o.set(W,(o.get(W)??0)+1)}for(const W of r)W.relativePathPattern?.test(O)!==!1&&W.filePattern.test(re.name)&&s.set(W.tag,(s.get(W.tag)??0)+1);if(--K===0){j();return}}})}const E=L.Promises.withAsyncBody(async A=>{const N={count:0,maxReached:!1};await S(t,t,a,N);const M=await b(t);A({configFiles:d(s),fileTypes:d(o),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:M})});return f.set(i,E),E}e.collectWorkspaceStats=u;function d(t){return Array.from(t.entries(),([a,i])=>({name:a,count:i})).sort((a,i)=>i.count-a.count)}function p(){const t={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(v.virtualMachineHint.value()*100)}%`},a=k.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}e.getMachineInfo=p;async function b(t){try{const a=new Map,i=(0,T.join)(t,".vscode","launch.json"),n=await P.Promises.readFile(i),r=[],o=(0,l.parse)(n.toString(),r);if(r.length)return console.log(`Unable to parse ${i}`),[];if((0,l.getNodeType)(o)==="object"&&o.configurations)for(const s of o.configurations){const c=s.type;c&&(a.has(c)?a.set(c,a.get(c)+1):a.set(c,1))}return d(a)}catch{return[]}}e.collectLaunchConfigs=b;let C=class{constructor(a,i){this.c=a,this.d=i}f(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}g(a){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const n=k.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(k.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||i.push(`Load (avg):       ${k.loadavg().map(r=>Math.round(r)).join(", ")}`),i.push(`VM:               ${Math.round(v.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,w.listProcesses)(a.mainPID),this.k(a)]).then(async n=>{let[r,o]=n,s=this.m(a,r);return i.forEach(c=>{if((0,g.isRemoteDiagnosticError)(c))s+=`
${c.errorMessage}`,o+=`
${c.errorMessage}`;else if(s+=`

Remote: ${c.hostName}`,c.processes&&(s+=`
${this.m(a,c.processes)}`),c.workspaceMetadata){o+=`
|  Remote: ${c.hostName}`;for(const S of Object.keys(c.workspaceMetadata)){const E=c.workspaceMetadata[S];let A=`${E.fileCount} files`;E.maxFilesReached&&(A=`more than ${A}`),o+=`|    Folder (${S}): ${A}`,o+=this.h(E)}}}),{processInfo:s,workspaceInfo:o}})}async getSystemInfo(a,i){const{memory:n,vmHint:r,os:o,cpus:s}=p(),c={os:o,memory:n,cpus:s,vmHint:r,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return R.isWindows||(c.load=`${k.loadavg().map(S=>Math.round(S)).join(", ")}`),R.isLinux&&(c.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(c)}async getDiagnostics(a,i){const n=[];return(0,w.listProcesses)(a.mainPID).then(async r=>(n.push(""),n.push(this.g(a)),n.push(""),n.push(this.m(a,r)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(a))),i.forEach(o=>{if((0,g.isRemoteDiagnosticError)(o))n.push(`
${o.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${o.hostName}`),n.push(this.f(o.machineInfo)),o.processes&&n.push(this.m(a,o.processes)),o.workspaceMetadata)for(const s of Object.keys(o.workspaceMetadata)){const c=o.workspaceMetadata[s];let S=`${c.fileCount} files`;c.maxFilesReached&&(S=`more than ${S}`),n.push(`Folder (${s}): ${S}`),n.push(this.h(c))}}),n.push(""),n.push(""),n.join(`
`)))}h(a){const i=[];let r=0;const o=(E,A)=>{const N=` ${E}(${A})`;r+N.length>60?(i.push(s),s="|                 ",r=s.length):r+=N.length,s+=N};let s="|      File types:";const c=10,S=a.fileTypes.length>c?c:a.fileTypes.length;for(let E=0;E<S;E++){const A=a.fileTypes[E];o(A.name,A.count)}if(i.push(s),a.configFiles.length>=0&&(s="|      Conf files:",r=0,a.configFiles.forEach(E=>{o(E.name,E.count)}),i.push(s)),a.launchConfigFiles.length>0){let E="|      Launch Configs:";a.launchConfigFiles.forEach(A=>{E+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),i.push(E)}return i.join(`
`)}j(a){const i=Math.max(...Object.keys(a).map(n=>n.length));return Object.keys(a).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${a[n]}`).join(`
                  `)}k(a){const i=[],n=[];return a.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(i.push(`|  Window (${r.title})`),r.folderURIs.forEach(o=>{const s=I.URI.revive(o);if(s.scheme===D.Schemas.file){const c=s.fsPath;n.push(u(c,["node_modules",".git"]).then(S=>{let E=`${S.fileCount} files`;S.maxFilesReached&&(E=`more than ${E}`),i.push(`|    Folder (${(0,T.basename)(c)}): ${E}`),i.push(this.h(S))}).catch(S=>{i.push(`|      Error: Unable to collect workspace stats for folder ${c} (${S.toString()})`)}))}else i.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(r=>i.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}m(a,i){const n=new Map;a.windows.forEach(o=>n.set(o.pid,o.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),i&&this.n(a.mainPID,n,r,i,0),r.join(`
`)}n(a,i,n,r,o){const s=o===0;let c;s?c=r.pid===a?`${this.d.applicationName} main`:"remote agent":(c=`${"  ".repeat(o)} ${r.name}`,r.name==="window"&&(c=`${c} (${i.get(r.pid)})`));const S=process.platform==="win32"?r.mem:k.totalmem()*(r.mem/100);n.push(`${r.load.toFixed(0).padStart(5," ")}	${(S/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${c}`),Array.isArray(r.children)&&r.children.forEach(E=>this.n(a,i,n,E,o+1))}async getWorkspaceFileExtensions(a){const i=new Set;for(const{uri:n}of a.folders){const r=I.URI.revive(n);if(r.scheme!==D.Schemas.file)continue;const o=r.fsPath;try{(await u(o,["node_modules",".git"])).fileTypes.forEach(c=>i.add(c.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const n=I.URI.revive(i);if(n.scheme!==D.Schemas.file)continue;const r=n.fsPath;try{const o=await u(r,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(s=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:s.name,count:s.count})}),o.launchConfigFiles.forEach(s=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:s.name,count:s.count})}),o.configFiles.forEach(s=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};C=ye([Y(0,y.ITelemetryService),Y(1,m.IProductService)],C),e.DiagnosticsService=C}),define(ne[240],se([0,1,108,3,19,15,2,11,13,50,25,4,6,104,16,174,34,10]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const d=[k.CONFIGURATION_KEY_HOST_NAME,k.CONFIGURATION_KEY_PREVENT_SLEEP];let p=class extends T.Disposable{constructor(C,t,a,i,n,r){super(),this.r=C,this.s=t,this.t=a,this.u=r,this.b=new L.Emitter,this.onDidTokenFailed=this.b.event,this.f=new L.Emitter,this.onDidChangeTunnelStatus=this.f.event,this.g=new L.Emitter,this.onDidChangeAccount=this.g.event,this.k=k.TunnelStates.disconnected;const o=u.URI.file((0,I.join)(a.logsPath,k.LOG_FILE_NAME));this.h=this.B(i.createLogger(o,{name:k.LOGGER_NAME,id:k.LOG_CHANNEL_ID})),this.n=new g.Delayer(100),this.B(this.h.onDidChangeLogLevel(s=>this.h.info("Log level changed to "+(0,R.LogLevelToString)(s)))),this.B(n.onWillShutdown(()=>{this.j?.cancel(),this.j=void 0,this.dispose()})),this.B(r.onDidChangeConfiguration(s=>{d.some(c=>s.affectsConfiguration(c))&&this.n.trigger(()=>this.w())}))}async getAccount(){return this.i}async updateAccount(C){if(C&&this.i?C.token!==this.i.token||C.providerId!==this.i.providerId:C!==this.i){this.i=C,this.g.fire(C),C?this.h.info(`Account updated: ${C.accountLabel} (${C.providerId})`):this.h.info("Account reset"),this.r.publicLog2("remoteTunnel.enablement",{enabled:!!C});try{await this.n.trigger(()=>this.w())}catch(t){this.h.error(t)}}return this.k}v(){if(!this.p){let C;w.isMacintosh?C=this.t.appRoot:C=(0,I.dirname)((0,I.dirname)(this.t.appRoot)),this.p=(0,I.join)(C,"bin",`${this.s.tunnelApplicationName}${w.isWindows?".exe":""}`)}return this.p}async w(){if(this.j&&(this.j.cancel(),this.j=void 0),!this.i){this.y(k.TunnelStates.disconnected);return}const{token:C,providerId:t,accountLabel:a}=this.i;this.y(k.TunnelStates.connecting((0,y.localize)(0,null,a,t)));const i=(c,S)=>{c=c.replaceAll(C,"*".repeat(4)),S?this.h.error(c):this.h.info(c),!this.t.isBuilt&&c.startsWith("   Compiling")&&this.y(k.TunnelStates.connecting((0,y.localize)(1,null)))},n=this.z("login",["user","login","--provider",t,"--access-token",C,"--log",(0,R.LogLevelToString)(this.h.getLevel())],i);this.j=n;try{if(await n,this.j!==n)return}catch(c){this.h.error(c),this.j=void 0,this.b.fire(!0),this.y(k.TunnelStates.disconnected);return}const r=this.D();r?this.y(k.TunnelStates.connecting((0,y.localize)(2,null,r))):this.y(k.TunnelStates.connecting((0,y.localize)(3,null)));const o=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,R.LogLevelToString)(this.h.getLevel())];r?o.push("--name",r):o.push("--random-name"),this.C()&&o.push("--no-sleep");const s=this.z("tunnel",o,(c,S)=>{S?this.h.error(c):this.h.info(c);const E=c.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(E){const A={link:E[1],domain:E[2],hostName:E[4]};this.y(k.TunnelStates.connected(A))}else c.match(/error refreshing token/)&&(s.cancel(),this.b.fire(!0),this.y(k.TunnelStates.disconnected))});this.j=s,s.finally(()=>{s===this.j&&(this.h.info("tunnel process terminated"),this.j=void 0,this.i=void 0,this.y(k.TunnelStates.disconnected))})}async getTunnelStatus(){return this.k}y(C){this.k=C,this.f.fire(C)}z(C,t,a=()=>{}){return(0,g.createCancelablePromise)(i=>new Promise((n,r)=>{i.isCancellationRequested&&n();let o;if(i.onCancellationRequested(()=>{o&&(this.h.info(`${C} terminating(${o.pid})`),o.kill())}),!this.t.isBuilt)a("Building tunnel CLI from sources and run",!1),a(`${C} Spawning: cargo run -- tunnel ${t.join(" ")}`,!1),o=(0,v.spawn)("cargo",["run","--","tunnel",...t],{cwd:(0,I.join)(this.t.appRoot,"cli")});else{a("Running tunnel CLI",!1);const s=this.v();a(`${C} Spawning: ${s} tunnel ${t.join(" ")}`,!1),o=(0,v.spawn)(s,["tunnel",...t],{cwd:(0,f.homedir)()})}o.stdout.on("data",s=>{if(o){const c=s.toString();a(c,!1)}}),o.stderr.on("data",s=>{if(o){const c=s.toString();a(c,!0)}}),o.on("exit",s=>{o&&(a(`${C} exit(${o.pid}): + ${s} `,!1),o=void 0,s===0?n():r())}),o.on("error",s=>{o&&(a(`${C} error(${o.pid}): + ${s} `,!0),o=void 0,r())})}))}async getHostName(){return this.D()}C(){return!!this.u.getValue(k.CONFIGURATION_KEY_PREVENT_SLEEP)}D(){let C=this.u.getValue(k.CONFIGURATION_KEY_HOST_NAME)||(0,f.hostname)();return C=C.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),C||void 0}};p=ye([Y(0,l.ITelemetryService),Y(1,P.IProductService),Y(2,D.INativeEnvironmentService),Y(3,R.ILoggerService),Y(4,h.ISharedProcessLifecycleService),Y(5,m.IConfigurationService)],p),e.RemoteTunnelService=p}),define(ne[112],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(D){this.b=D}listen(D,T){throw new Error(`Event not found: ${T}`)}call(D,T,{eventName:R,data:I}){return this.b.forEach(v=>v.log(R,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class L{constructor(D){this.b=D}log(D,T){return this.b.call("log",{eventName:D,data:T}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(ne[47],se([0,1,32,12,3,16,74,111,19]),function(Z,e,k,L,l,D,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class v{constructor(s){this.value=s}}e.TelemetryTrustedValue=v;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(s,c){return Promise.resolve(void 0)}publicLog2(s,c){return this.publicLog(s,c)}publicLogError(s,c){return Promise.resolve(void 0)}publicLogError2(s,c){return this.publicLogError(s,c)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class w{async publicLog(s,c,S){}async publicLogError(s,c,S){}}e.NullEndpointTelemetryService=w,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(o,s){return l.Event.debounce(s.onDidChangeConfiguration,(S,E)=>{const A=S?new Set([...S.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:A}},1e3,!0)(S=>{S.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(S.source),configurationKeys:b(S.affectedKeys)})})}e.configurationTelemetry=g;function h(o,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!o.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=h;function m(o,s){return!(s.isBuilt||s.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=m;function y(o){const s=o.getValue(I.TELEMETRY_SETTING_ID),c=o.getValue(I.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function f(o){const s={},c={},S={};p(o,S);for(let E in S){E=E.length>150?E.substr(E.length-149):E;const A=S[E];typeof A=="number"?c[E]=A:typeof A=="boolean"?c[E]=A?1:0:typeof A=="string"?(A.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${A.length}`),s[E]=A.substring(0,8191)):typeof A<"u"&&A!==null&&(s[E]=A)}return{properties:s,measurements:c}}e.validateTelemetryData=f;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function d(o){if(!o)return"none";const s=(0,T.getRemoteName)(o);return u.has(s)?s:"other"}e.cleanRemoteAuthority=d;function p(o,s,c=0,S){if(!!o)for(const E of Object.getOwnPropertyNames(o)){const A=o[E],N=S?S+E:E;Array.isArray(A)?s[N]=(0,k.safeStringify)(A):A instanceof Date?s[N]=A.toISOString():(0,L.isObject)(A)?c<2?p(A,s,c+1,N+"."):s[N]=(0,k.safeStringify)(A):s[N]=A}}function b(o){if(!o)return[];const s=[];return C(s,"",o),s}function C(o,s,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(S=>C(o,s?`${s}.${S}`:S,c[S])):o.push(s)}function t(o,s){const c=o.msftInternalDomains||[],S=s.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(c)||S}e.isInternalTelemetry=t;function a(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=a;function i(o,s){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let c=o;const S=[];for(const M of s)for(;;){const B=M.exec(o);if(!B)break;S.push([B.index,M.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,A=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(c="";;){const M=A.exec(o);if(!M)break;const B=S.some(([O,j])=>M.index<j&&O<A.lastIndex);!E.test(M[0])&&!B&&(c+=o.substring(N,M.index)+"<REDACTED: user-file-path>",N=A.lastIndex)}return N<o.length&&(c+=o.substr(N)),c}function n(o){if(!o)return o;const s=o.toLowerCase(),c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const S of c)if(S.regex.test(s))return`<REDACTED: ${S.label}>`;return o}function r(o,s){return(0,k.cloneAndChange)(o,c=>{if(c instanceof v)return c.value;if(typeof c=="string"){let S=c.replaceAll("%20"," ");S=i(S,s);for(const E of s)S=S.replace(E,"");return S=n(S),S}})}e.cleanData=r}),define(ne[33],se([0,1,26,29,46,4,10,8,36,47]),function(Z,e,k,L,l,D,T,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,k.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=P;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(n){const r=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new g(n.identifier,r,o)}static parse(n){const r=w.exec(n);return r&&r[1]&&r[2]?new g({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof g?P(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=g;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(i){const n=h.exec(i);return n&&n[1]?[f(n[1]),n[2]]:[f(i),void 0]}e.getIdAndVersion=m;function y(i,n){return`${i}.${n}`}e.getExtensionId=y;function f(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=f;function u(i,n){return f(y(i,n))}e.getGalleryExtensionId=u;function d(i,n){const r=[],o=s=>{for(const c of r)if(c.some(S=>P(n(S),n(s))))return c;return null};for(const s of i){const c=o(s);c?c.push(s):r.push([s])}return r}e.groupByExtension=d;function p(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function b(i){return{id:new v.TelemetryTrustedValue(i.identifier.id),name:new v.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function C(i,n){const r=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const s=o.shift();if(s&&r.every(c=>!P(c.identifier,{id:s}))){const c=i.filter(S=>P(S.identifier,{id:s}));c.length===1&&(r.push(c[0]),o.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=C;async function t(i,n){if(!D.isLinux)return!1;let r;try{r=(await i.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){n.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(s))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,n){const r=await t(i,n),o=(0,L.getTargetPlatform)(r?"alpine":D.platform,I.arch);return n.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=a}),define(ne[241],se([0,1,23,33]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function l(D,T,R,I,v){try{const P=await D.getExtensionsControlManifest();if(!P.deprecated)return;const w=await D.getInstalled(1);for(const[g,h]of Object.entries(P.deprecated)){if(!h?.extension)continue;const{id:m,autoMigrate:y,preRelease:f}=h.extension;if(!y)continue;const u=w.find(p=>(0,L.areSameExtensions)(p.identifier,{id:g}));if(!u)continue;const d=(await T.getExtensions([{id:m,preRelease:f}],{targetPlatform:await D.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!d){v.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${m}' extension is not found`);continue}try{v.info(`Migrating '${u.identifier.id}' extension to '${m}' extension...`);const p=!I.getDisabledExtensions().some(C=>(0,L.areSameExtensions)(C,u.identifier));await D.uninstall(u),v.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let b=w.find(C=>(0,L.areSameExtensions)(C.identifier,{id:m}));(!b||!b.isPreReleaseVersion&&p)&&(b=await D.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),v.info(`Installed the pre-release extension '${b.identifier.id}'`),p||(await I.disableExtension(b.identifier),v.info(`Disabled the pre-release extension '${b.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),y.storage&&(R.addToMigrationList((0,L.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,L.getExtensionId)(b.manifest.publisher,b.manifest.name)),v.info("Added pre-release extension to the storage migration list"))),v.info(`Migrated '${u.identifier.id}' extension to '${m}' extension.`)}catch(p){v.error(p)}}}catch(P){v.error(P)}}e.migrateUnsupportedExtensions=l}),define(ne[242],se([0,1,6,8,2,21,4,24,54,12,31,27,16,15,29,33,99,14,11]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let p=class yt extends l.Disposable{constructor(C,t,a,i,n,r){super(),this.h=t,this.i=a,this.j=i,this.k=n,this.l=r,this.extensionsDownloadDir=C.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(C,t){await this.g;const a=(0,R.joinPath)(this.extensionsDownloadDir,this.v(C));try{await this.r(C,a,n=>this.i.download(C,n,t))}catch(n){throw new m.ExtensionManagementError(n.message,m.ExtensionManagementErrorCode.Download)}let i="Unverified";if(await this.m(C)){const n=await this.n(C);try{await this.k.verify(a.fsPath,n.fsPath)&&(i="Verified"),this.l.info(`Extension signature verification: ${C.identifier.id}. Verification status: ${i}.`)}catch(r){const o=r,s=o.code;if(s==="UnknownError")i="UnknownError",this.l.warn(`Extension signature verification: ${C.identifier.id}. Verification status: ${i}.`);else if(!o.didExecute)this.l.warn(`Extension signature verification: ${C.identifier.id}. Verification status: ${i} (${s})`);else throw await this.delete(n),await this.delete(a),new m.ExtensionManagementError(s,m.ExtensionManagementErrorCode.Signature)}}return{location:a,verificationStatus:i}}async m(C){if(!C.isSigned)return!1;const t=this.j.getValue("extensions.verifySignature");return(0,v.isBoolean)(t)?t:!0}async n(C){await this.g;const t=(0,R.joinPath)(this.extensionsDownloadDir,`${this.v(C)}${yt.c}`);return await this.r(C,t,a=>this.i.downloadSignatureArchive(C,a)),t}async r(C,t,a){if(await this.h.exists(t))return;if(t.scheme!==D.Schemas.file){await a(t);return}const i=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,P.generateUuid)()}`);await this.h.exists(i)||await a(i);try{await this.t(i,t,Date.now()+2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",C.identifier.id,t.path);else throw this.l.info(`Rename failed because of ${(0,L.getErrorMessage)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(C){await this.g,await this.h.del(C)}async t(C,t,a){try{await w.Promises.rename(C.fsPath,t.fsPath)}catch(i){if(T.isWindows&&i&&i.code==="EPERM"&&Date.now()<a)return this.l.info(`Failed renaming ${C} to ${t} with 'EPERM' error. Trying again...`),this.t(C,t,a);throw i}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const C=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(C.children){const t=[],a=[],i=[];for(const o of C.children)if(o.name.endsWith(yt.c))i.push(o.resource);else{const s=y.ExtensionKey.parse(o.name);s&&a.push([s,o])}const n=(0,y.groupByExtension)(a,([o])=>o),r=[];for(const o of n)o.sort((s,c)=>I.rcompare(s[0].version,c[0].version)),t.push(...o.slice(1).map(s=>s[1].resource)),r.push(o[0][1]);r.sort((o,s)=>o.mtime-s.mtime),t.push(...r.slice(0,Math.max(0,r.length-this.f)).map(o=>o.resource)),t.push(...i),await k.Promises.settled(t.map(o=>(this.l.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(C){this.l.error(C)}}v(C){return this.f?y.ExtensionKey.create(C).toString().toLowerCase():(0,P.generateUuid)()}};p.c=".sigzip",p=ye([Y(0,h.INativeEnvironmentService),Y(1,u.IFileService),Y(2,m.IExtensionGalleryService),Y(3,g.IConfigurationService),Y(4,f.IExtensionSignatureVerificationService),Y(5,d.ILogService)],p),e.ExtensionsDownloader=p}),define(ne[243],se([0,1,3,2,38,33,46]),function(Z,e,k,L,l,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends L.Disposable{constructor(v,P,w,g,h,m,y){super(),this.f=v,this.g=P,this.h=w,this.i=g,this.j=h,this.k=m,this.l=y,this.a=this.B(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new L.DisposableMap),this.m().then(null,f=>y.error(f))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(v=>this.p(v.added,v.removed))),this.B(this.i.onAddExtensions(v=>this.r(v))),this.B(this.i.onDidAddExtensions(v=>this.s(v))),this.B(this.i.onRemoveExtensions(v=>this.t(v))),this.B(this.i.onDidRemoveExtensions(v=>this.u(v))),this.B(this.k.onDidFilesChange(v=>this.v(v)))}async p(v,P){try{await Promise.all(P.map(w=>(this.c.deleteAndDispose(w.id),this.z(w.extensionsResource)))),v.length&&await Promise.all(v.map(w=>(this.c.set(w.id,(0,L.combinedDisposable)(this.k.watch(this.j.extUri.dirname(w.extensionsResource)),this.k.watch(w.extensionsResource))),this.y(w.extensionsResource))))}catch(w){throw this.l.error(w),w}}async r(v){for(const P of v.extensions)this.D(this.G(P.identifier,P.version),v.profileLocation)}async s(v){for(const P of v.extensions){const w=this.G(P.identifier,P.version);v.error?this.F(w,v.profileLocation):this.D(w,v.profileLocation)}}async t(v){for(const P of v.extensions)this.F(this.G(P.identifier,P.version),v.profileLocation)}async u(v){const P=[],w=[];for(const g of v.extensions){const h=this.G(g.identifier,g.version);v.error?this.D(h,v.profileLocation):(this.F(h,v.profileLocation),this.b.has(h)||(this.l.debug("Extension is removed from all profiles",g.identifier.id,g.version),w.push(this.f.scanInstalledExtensionAtLocation(g.location).then(m=>{m?P.push(m):this.l.info("Extension not found at the location",g.location.toString())},m=>this.l.error(m)))))}try{await Promise.all(w),P.length&&await this.C(P)}catch(g){this.l.error(g)}}v(v){for(const P of this.h.profiles)v.contains(P.extensionsResource,0,1)&&this.w(P.extensionsResource)}async w(v){const P=[],w=[],g=await this.i.scanProfileExtensions(v),h=new Set,m=new Set;for(const[y,f]of this.b)f.has(v)&&m.add(y);for(const y of g){const f=this.G(y.identifier,y.version);h.add(f),m.has(f)||(P.push(y.identifier),this.D(f,v))}for(const y of m)if(!h.has(y)){const f=this.H(y);f&&(w.push(f.identifier),this.F(y,v))}(P.length||w.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:v}:void 0,removed:w.length?{extensions:w,profileLocation:v}:void 0})}async y(v){const P=await this.i.scanProfileExtensions(v);for(const w of P)this.D(this.G(w.identifier,w.version),v)}async z(v){for(const P of[...this.b.keys()])this.F(P,v);await this.C()}async C(v){v||(v=(await this.f.scanAllUserInstalledExtensions()).filter(w=>!this.b.has(this.G(w.identifier,w.manifest.version)))),v.length&&await this.f.markAsUninstalled(...v)}D(v,P){let w=this.b.get(v);w||this.b.set(v,w=new l.ResourceSet(g=>this.j.extUri.getComparisonKey(g))),w.add(P)}F(v,P){const w=this.b.get(v);w&&w.delete(P),w?.size||this.b.delete(v)}G(v,P){return`${T.ExtensionIdentifier.toKey(v.id)}@${P}`}H(v){const[P,w]=(0,D.getIdAndVersion)(v);return w?{identifier:{id:P},version:w}:void 0}}e.ExtensionsWatcher=R}),define(ne[244],se([0,1,44,47]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function l(D,T,R,I,v,P,w){const g={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${T.nameShort})`};if((0,L.supportsTelemetry)(T,R)&&(0,L.getTelemetryLevel)(I)===3){const h=await(0,k.getServiceMachineId)(R,v,P),{machineId:m}=await w.getTelemetryInfo();g["X-Market-User-Id"]=h,g["VSCode-SessionId"]=m||h}return g}e.resolveMarketplaceHeaders=l}),define(ne[245],se([0,1,101,18,6,2,21,13,27,15,29,33,11,72,10]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let y=class extends h.LanguagePackBaseService{constructor(p,b,C,t){super(C),this.h=p,this.i=t,this.g=this.B(new f(b,t)),this.h.registerParticipant({postInstall:async a=>this.j(a),postUninstall:async a=>this.k(a)})}async getBuiltInExtensionTranslationsUri(p,b){const t=(await this.g.getLanguagePacks())[b];if(!t){this.i.warn(`No language pack found for ${b}`);return}const a=t.translations[p];return a?m.URI.file(a):void 0}async getInstalledLanguages(){const p=await this.g.getLanguagePacks(),b=Object.keys(p).map(C=>{const t=p[C];return{...this.f(C,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return b.push(this.f("en","English")),b.sort((C,t)=>C.label.localeCompare(t.label)),b}async j(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",p.identifier.id),await this.update())}async k(p){const b=await this.g.getLanguagePacks();Object.keys(b).some(C=>b[C]&&b[C].extensions.some(t=>(0,w.areSameExtensions)(t.extensionIdentifier,p.identifier)))&&(this.i.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,b]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),C=await this.g.update(b);return!(0,L.equals)(Object.keys(p),Object.keys(C))}};y=ye([Y(0,P.IExtensionManagementService),Y(1,v.INativeEnvironmentService),Y(2,P.IExtensionGalleryService),Y(3,g.ILogService)],y),e.NativeLanguagePackService=y;let f=class extends D.Disposable{constructor(p,b){super(),this.i=b,this.c={},this.f=(0,R.join)(p.userDataPath,"languagepacks.json"),this.g=new l.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(p){return this.m(b=>{Object.keys(b).forEach(C=>delete b[C]),this.j(b,...p)}).then(()=>this.c)}j(p,...b){for(const C of b)C&&C.manifest&&C.manifest.contributes&&C.manifest.contributes.localizations&&C.manifest.contributes.localizations.length&&this.k(p,C);Object.keys(p).forEach(C=>this.l(p[C]))}k(p,b){const C=b.identifier,t=b.manifest.contributes&&b.manifest.contributes.localizations?b.manifest.contributes.localizations:[];for(const a of t)if(b.location.scheme===T.Schemas.file&&u(a)){let i=p[a.languageId];i||(i={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},p[a.languageId]=i);const n=i.extensions.filter(r=>(0,w.areSameExtensions)(r.extensionIdentifier,C))[0];n?n.version=b.manifest.version:i.extensions.push({extensionIdentifier:C,version:b.manifest.version});for(const r of a.translations)i.translations[r.id]=(0,R.join)(b.location.fsPath,r.path)}}l(p){if(p){const b=(0,k.createHash)("md5");for(const C of p.extensions)b.update(C.extensionIdentifier.uuid||C.extensionIdentifier.id).update(C.version);p.hash=b.digest("hex")}}m(p=()=>null){return this.g.queue(()=>{let b=null;return I.Promises.readFile(this.f,"utf8").then(void 0,C=>C.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(C)).then(C=>{try{return JSON.parse(C)}catch{return{}}}).then(C=>(b=p(C),C)).then(C=>{for(const a of Object.keys(C))C[a]||delete C[a];this.c=C,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),I.Promises.writeFile(this.f,t)}).then(()=>b,C=>this.i.error(C))})}};f=ye([Y(0,v.INativeEnvironmentService),Y(1,g.ILogService)],f);function u(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const p of d.translations)if(typeof p.id!="string"||typeof p.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(ne[246],se([0,1,8,32,47]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",T="https://mobile.events.data.microsoft.com/ping";async function R(v,P,w){const g=await new Promise((u,d)=>{Z(["@microsoft/1ds-core-js"],u,d)}),h=await new Promise((u,d)=>{Z(["@microsoft/1ds-post-js"],u,d)}),m=new g.AppInsightsCore,y=new h.PostChannel,f={instrumentationKey:v,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(w){f.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:w};f.extensionConfig[y.identifier]=u}return m.initialize(f,[]),m.addTelemetryInitializer(u=>{P&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),m}class I{constructor(P,w,g,h,m){this.e=P,this.f=w,this.g=g,this.h=m,this.c=D,this.d=T,this.g||(this.g={}),typeof h=="function"?this.a=h():this.a=h,this.b=null}i(P){if(!!this.a){if(typeof this.a!="string"){P(this.a);return}this.b||(this.b=R(this.a,this.e,this.h)),this.b.then(w=>{P(w)},w=>{(0,k.onUnexpectedError)(w),console.error(w)})}}log(P,w){if(!this.a)return;w=(0,L.mixin)(w,this.g),w=(0,l.validateTelemetryData)(w);const g=this.f+"/"+P;try{this.i(h=>{h.pluginVersionString=w?.properties.version??"Unknown",h.track({name:g,baseData:{name:g,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(P=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(ne[113],se([0,1,2,177,15,11,25,47]),function(Z,e,k,L,l,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let I=class extends k.Disposable{constructor(P,w,g,h,m=""){super(),this.b=m;const y=w.getLogger(g.telemetryLogResource);if(y)this.a=this.B(y);else{const u=(0,R.isLoggingOnly)(h,g)?" (Not Sent)":"",d=g.telemetryLogResource,p=()=>(0,R.supportsTelemetry)(h,g)&&P.getLevel()===D.LogLevel.Trace;this.a=this.B(w.createLogger(d,{id:R.telemetryLogChannelId,name:(0,L.localize)(0,null,u),hidden:!p()})),this.B(P.onDidChangeLogLevel(()=>w.setVisibility(d,p()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,w){this.a.trace(`${this.b}telemetry/${P}`,(0,R.validateTelemetryData)(w))}};I=ye([Y(0,D.ILogService),Y(1,D.ILoggerService),Y(2,l.IEnvironmentService),Y(3,T.IProductService)],I),e.TelemetryLogAppender=I}),define(ne[114],se([0,1,2,32,4,26,178,16,45,106,25,40,19,47]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(u,d,p){this.k=d,this.l=p,this.d={},this.i=new k.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const b of this.f)this.j.push(new RegExp((0,D.escapeRegExpCharacters)(b),"gi")),b.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.escapeRegExpCharacters)(b.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(b=>{(b.affectsConfiguration(g.TELEMETRY_SETTING_ID)||b.affectsConfiguration(g.TELEMETRY_OLD_SETTING_ID)||b.affectsConfiguration(g.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,d){this.d[u]=d}m(){let u=(0,h.getTelemetryLevel)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const p=d.usage?3:d.error?2:0;u=Math.min(u,p)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,d=u.sessionID,p=u["common.machineId"],b=u["common.firstSessionDate"],C=u["common.msftInternal"];return{sessionId:d,machineId:p,firstSessionDate:b,msftInternal:C}}dispose(){this.i.dispose()}n(u,d,p){return this.g<d?Promise.resolve(void 0):this.c.then(b=>{p=(0,L.mixin)(p,this.d),p=(0,h.cleanData)(p,this.j),p=(0,L.mixin)(p,b),this.b.forEach(C=>C.log(u,p))},b=>{console.error(b)})}publicLog(u,d){return this.n(u,3,d)}publicLog2(u,d){return this.publicLog(u,d)}publicLogError(u,d){return this.h?this.n(u,2,d):Promise.resolve(void 0)}publicLogError2(u,d){return this.publicLogError(u,d)}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=ye([Y(1,R.IConfigurationService),Y(2,P.IProductService)],m),e.TelemetryService=m;function y(){const f=(0,T.localize)(0,null,v.default.nameLong),u=v.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",v.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=l.isWeb?"":(0,T.localize)(3,null),p=(0,T.localize)(4,null),b=(0,T.localize)(5,null),C=(0,T.localize)(6,null),t=(0,T.localize)(7,null),a=`
|       | ${p} | ${b} | ${C} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,T.localize)(8,null);return`
${f} ${u} ${d}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}w.Registry.as(I.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,T.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(I.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,T.localize)(16,null,v.default.nameLong,v.default.privacyStatementUrl):(0,T.localize)(15,null,v.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[247],se([0,1,299,246]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class l extends L.AbstractOneDataSystemAppender{constructor(T,R,I,v){const P={sendPOST:(w,g)=>{const h={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const m=k.request(w.urlString,h,y=>{y.on("data",function(f){g(y.statusCode??200,y.headers,f.toString())}),y.on("error",function(f){g(0,{})})});m.write(w.data),m.end()}catch{g(0,{})}}};super(T,R,I,v,P)}}e.OneDataSystemAppender=l}),define(ne[248],se([0,1,21,66,16,15,11,25,19,112,113,114]),function(Z,e,k,L,l,D,T,R,I,v,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let g=class{constructor(m,y,f,u,d,p){this.b=m,this.c=y,this.d=f,this.e=u,this.f=d,this.g=p,this.a=new Map}async h(m){if(!this.a.has(m.id)){const{machineId:y,sessionId:f}=await this.c.getTelemetryInfo(),u=Object.create(null);u["common.vscodemachineid"]=y,u["common.vscodesessionid"]=f;const d=[m.id,JSON.stringify(u),m.aiKey],b=new L.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:d,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),C=[new v.TelemetryAppenderClient(b),new P.TelemetryLogAppender(this.d,this.e,this.f,this.g,`[${m.id}] `)];this.a.set(m.id,new w.TelemetryService({appenders:C,sendErrorTelemetry:m.sendErrorTelemetry},this.b,this.g))}return this.a.get(m.id)}async publicLog(m,y,f){await(await this.h(m)).publicLog(y,f)}async publicLogError(m,y,f){await(await this.h(m)).publicLogError(y,f)}};g=ye([Y(0,l.IConfigurationService),Y(1,I.ITelemetryService),Y(2,T.ILogService),Y(3,T.ILoggerService),Y(4,D.IEnvironmentService),Y(5,R.IProductService)],g),e.CustomEndpointTelemetryService=g}),define(ne[115],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var k;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(k=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(ne[249],se([0,1,4,115]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class l{constructor(I){this.collections=I,this.map=new Map,I.forEach((v,P)=>{const w=v.map.entries();let g=w.next();for(;!g.done;){const h=g.value[0];let m=this.map.get(h);if(m||(m=[],this.map.set(h,m)),m.length>0&&m[0].type===L.EnvironmentVariableMutatorType.Replace){g=w.next();continue}const y=g.value[1];m.unshift({extensionIdentifier:P,value:y.value,type:y.type}),g=w.next()}})}async applyToProcessEnvironment(I,v){let P;k.isWindows&&(P={},Object.keys(I).forEach(w=>P[w.toLowerCase()]=w));for(const[w,g]of this.map){const h=k.isWindows&&P[w.toLowerCase()]||w;for(const m of g){const y=v?await v(m.value):m.value;switch(m.type){case L.EnvironmentVariableMutatorType.Append:I[h]=(I[h]||"")+y;break;case L.EnvironmentVariableMutatorType.Prepend:I[h]=y+(I[h]||"");break;case L.EnvironmentVariableMutatorType.Replace:I[h]=y;break}}}}diff(I){const v=new Map,P=new Map,w=new Map;if(I.map.forEach((g,h)=>{const m=this.map.get(h),y=D(g,m);y&&v.set(h,y)}),this.map.forEach((g,h)=>{const m=I.map.get(h),y=D(g,m);y&&w.set(h,y)}),this.map.forEach((g,h)=>{const m=I.map.get(h),y=T(g,m);y&&P.set(h,y)}),!(v.size===0&&P.size===0&&w.size===0))return{added:v,changed:P,removed:w}}}e.MergedEnvironmentVariableCollection=l;function D(R,I){if(!I)return R;const v=new Set;I.forEach(w=>v.add(w.extensionIdentifier));const P=[];return R.forEach(w=>{v.has(w.extensionIdentifier)||P.push(w)}),P.length===0?void 0:P}function T(R,I){if(!I)return;const v=new Map;I.forEach(w=>v.set(w.extensionIdentifier,w));const P=[];return R.forEach(w=>{const g=v.get(w.extensionIdentifier);g&&(w.type!==g.type||w.value!==g.value)&&P.push(g)}),P.length===0?void 0:P}}),define(ne[250],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function k(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=k;function L(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=L;function l(T){return Array.from(T.entries()).map(R=>[R[0],k(R[1].map)])}e.serializeEnvironmentVariableCollections=l;function D(T){return new Map(T.map(R=>[R[0],{map:L(R[1])}]))}e.deserializeEnvironmentVariableCollections=D}),define(ne[251],se([0,1,6,23,3,2,11]),function(Z,e,k,L,l,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends D.Disposable{constructor(v,P){super(),this.h=P,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new l.Emitter),this.onCreateRequest=this.g.event,this.b=v===void 0?15e3:v}createRequest(v){return new Promise((P,w)=>{const g=++this.a;this.c.set(g,P),this.g.fire({requestId:g,...v});const h=new L.CancellationTokenSource;(0,k.timeout)(this.b,h.token).then(()=>w(`Request ${g} timed out (${this.b}ms)`)),this.f.set(g,[(0,D.toDisposable)(()=>h.cancel())])})}acceptReply(v,P){const w=this.c.get(v);w?(this.c.delete(v),(0,D.dispose)(this.f.get(v)||[]),this.f.delete(v),w(P)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${v}`)}};R=ye([Y(1,T.ILogService)],R),e.RequestStore=R}),define(ne[116],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(p){p.Shell="terminal.integrated.shell.",p.ShellArgs="terminal.integrated.shellArgs.",p.DefaultProfile="terminal.integrated.defaultProfile.",p.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var l;(function(p){p.ShellLinux="terminal.integrated.shell.linux",p.ShellMacOs="terminal.integrated.shell.osx",p.ShellWindows="terminal.integrated.shell.windows",p.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",p.AutomationShellLinux="terminal.integrated.automationShell.linux",p.AutomationShellMacOs="terminal.integrated.automationShell.osx",p.AutomationShellWindows="terminal.integrated.automationShell.windows",p.AutomationProfileLinux="terminal.integrated.automationProfile.linux",p.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",p.AutomationProfileWindows="terminal.integrated.automationProfile.windows",p.ShellArgsLinux="terminal.integrated.shellArgs.linux",p.ShellArgsMacOs="terminal.integrated.shellArgs.osx",p.ShellArgsWindows="terminal.integrated.shellArgs.windows",p.ProfilesWindows="terminal.integrated.profiles.windows",p.ProfilesMacOs="terminal.integrated.profiles.osx",p.ProfilesLinux="terminal.integrated.profiles.linux",p.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",p.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",p.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",p.UseWslProfiles="terminal.integrated.useWslProfiles",p.TabsDefaultColor="terminal.integrated.tabs.defaultColor",p.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",p.TabsEnabled="terminal.integrated.tabs.enabled",p.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",p.TabsHideCondition="terminal.integrated.tabs.hideCondition",p.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",p.TabsShowActions="terminal.integrated.tabs.showActions",p.TabsLocation="terminal.integrated.tabs.location",p.TabsFocusMode="terminal.integrated.tabs.focusMode",p.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",p.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",p.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",p.CopyOnSelection="terminal.integrated.copyOnSelection",p.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",p.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",p.FontFamily="terminal.integrated.fontFamily",p.FontSize="terminal.integrated.fontSize",p.LetterSpacing="terminal.integrated.letterSpacing",p.LineHeight="terminal.integrated.lineHeight",p.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",p.TabStopWidth="terminal.integrated.tabStopWidth",p.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",p.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",p.BellDuration="terminal.integrated.bellDuration",p.FontWeight="terminal.integrated.fontWeight",p.FontWeightBold="terminal.integrated.fontWeightBold",p.CursorBlinking="terminal.integrated.cursorBlinking",p.CursorStyle="terminal.integrated.cursorStyle",p.CursorWidth="terminal.integrated.cursorWidth",p.Scrollback="terminal.integrated.scrollback",p.DetectLocale="terminal.integrated.detectLocale",p.DefaultLocation="terminal.integrated.defaultLocation",p.GpuAcceleration="terminal.integrated.gpuAcceleration",p.TerminalTitleSeparator="terminal.integrated.tabs.separator",p.TerminalTitle="terminal.integrated.tabs.title",p.TerminalDescription="terminal.integrated.tabs.description",p.RightClickBehavior="terminal.integrated.rightClickBehavior",p.Cwd="terminal.integrated.cwd",p.ConfirmOnExit="terminal.integrated.confirmOnExit",p.ConfirmOnKill="terminal.integrated.confirmOnKill",p.EnableBell="terminal.integrated.enableBell",p.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",p.AllowChords="terminal.integrated.allowChords",p.AllowMnemonics="terminal.integrated.allowMnemonics",p.TabFocusMode="terminal.integrated.tabFocusMode",p.EnvMacOs="terminal.integrated.env.osx",p.EnvLinux="terminal.integrated.env.linux",p.EnvWindows="terminal.integrated.env.windows",p.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",p.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",p.ShowExitAlert="terminal.integrated.showExitAlert",p.SplitCwd="terminal.integrated.splitCwd",p.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",p.WordSeparators="terminal.integrated.wordSeparators",p.EnableFileLinks="terminal.integrated.enableFileLinks",p.UnicodeVersion="terminal.integrated.unicodeVersion",p.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",p.LocalEchoEnabled="terminal.integrated.localEchoEnabled",p.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",p.LocalEchoStyle="terminal.integrated.localEchoStyle",p.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",p.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",p.CustomGlyphs="terminal.integrated.customGlyphs",p.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",p.InheritEnv="terminal.integrated.inheritEnv",p.ShowLinkHover="terminal.integrated.showLinkHover",p.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",p.AutoReplies="terminal.integrated.autoReplies",p.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",p.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",p.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",p.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",p.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",p.SmoothScrolling="terminal.integrated.smoothScrolling"})(l=e.TerminalSettingId||(e.TerminalSettingId={}));var D;(function(p){p.FileName="ptyhost"})(D=e.TerminalLogConstants||(e.TerminalLogConstants={}));var T;(function(p){p.PowerShell="pwsh",p.Bash="bash",p.Fish="fish",p.Sh="sh",p.Csh="csh",p.Ksh="ksh",p.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var R;(function(p){p.CommandPrompt="cmd",p.PowerShell="pwsh",p.Wsl="wsl",p.GitBash="gitbash"})(R=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(p){p[p.Api=0]="Api",p[p.Process=1]="Process",p[p.Sequence=2]="Sequence",p[p.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var v;(function(p){p.LocalPty="localPty",p.PtyHost="ptyHost",p.Logger="logger",p.Heartbeat="heartbeat"})(v=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var P;(function(p){p.Cwd="cwd",p.InitialCwd="initialCwd",p.FixedDimensions="fixedDimensions",p.Title="title",p.ShellType="shellType",p.HasChildProcesses="hasChildProcesses",p.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",p.OverrideDimensions="overrideDimensions",p.FailedShellIntegrationActivation="failedShellIntegrationActivation",p.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(P=e.ProcessPropertyType||(e.ProcessPropertyType={}));var w;(function(p){p[p.BeatInterval=5e3]="BeatInterval",p[p.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",p[p.SecondWaitMultiplier=1]="SecondWaitMultiplier",p[p.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w=e.HeartbeatConstants||(e.HeartbeatConstants={}));var g;(function(p){p[p.Panel=1]="Panel",p[p.Editor=2]="Editor"})(g=e.TerminalLocation||(e.TerminalLocation={}));var h;(function(p){p.TerminalView="view",p.Editor="editor"})(h=e.TerminalLocationString||(e.TerminalLocationString={}));var m;(function(p){p[p.GraceTime=6e4]="GraceTime",p[p.ShortGraceTime=6e3]="ShortGraceTime"})(m=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(p){p[p.HighWatermarkChars=1e5]="HighWatermarkChars",p[p.LowWatermarkChars=5e3]="LowWatermarkChars",p[p.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var f;(function(p){p.GitBash="Git Bash",p.Pwsh="PowerShell"})(f=e.ProfileSource||(e.ProfileSource={}));var u;(function(p){p[p.Off=0]="Off",p[p.FinalTerm=1]="FinalTerm",p[p.VSCode=2]="VSCode"})(u=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var d;(function(p){p[p.Unknown=0]="Unknown",p[p.Shutdown=1]="Shutdown",p[p.Process=2]="Process",p[p.User=3]="User",p[p.Extension=4]="Extension"})(d=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ne[252],se([0,1,52,10,180,134]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(g,h){const m=[{name:null,description:(0,l.localize)(0,null)}];return m.push(...g.map(y=>({name:y.profileName,description:R(y)}))),h&&m.push(...h.map(y=>({name:y.title,description:I(y)}))),{values:m.map(y=>y.name),markdownDescriptions:m.map(y=>y.description)}}e.createProfileSchemaEnums=T;function R(g){let h=`$(${D.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:k.Codicon.terminal.id}) ${g.profileName}
- path: ${g.path}`;return g.args&&(typeof g.args=="string"?h+=`
- args: "${g.args}"`:h+=`
- args: [${g.args.length===0?"":`'${g.args.join("','")}'`}]`),g.overrideName!==void 0&&(h+=`
- overrideName: ${g.overrideName}`),g.color&&(h+=`
- color: ${g.color}`),g.env&&(h+=`
- env: ${JSON.stringify(g.env)}`),h}function I(g){return`$(${D.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:k.Codicon.terminal.id}) ${g.title}
- extensionIdentifier: ${g.extensionIdentifier}`}function v(g,h){if(!g&&!h)return!0;if(typeof g=="string"&&typeof h=="string")return g===h;if(Array.isArray(g)&&Array.isArray(h)){if(g.length!==h.length)return!1;for(let m=0;m<g.length;m++)if(g[m]!==h[m])return!1;return!0}return!1}e.terminalProfileArgsMatch=v;function P(g,h){if(!g&&!h)return!0;if(!g||!h)return!1;if(D.ThemeIcon.isThemeIcon(g)&&D.ThemeIcon.isThemeIcon(h))return g.id===h.id&&g.color===h.color;if(typeof g=="object"&&"light"in g&&"dark"in g&&typeof h=="object"&&"light"in h&&"dark"in h){const m=g,y=h;if((L.URI.isUri(m.light)||w(m.light))&&(L.URI.isUri(m.dark)||w(m.dark))&&(L.URI.isUri(y.light)||w(y.light))&&(L.URI.isUri(y.dark)||w(y.dark)))return m.light.path===y.light.path&&m.dark.path===y.dark.path}if(L.URI.isUri(g)&&L.URI.isUri(h)||w(g)||w(h)){const m=g,y=h;return m.path===y.path&&m.scheme===y.scheme}return!1}e.terminalIconsEqual=P;function w(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}e.isUriComponents=w}),define(ne[253],se([0,1,52,179,45,40,252]),function(Z,e,k,L,l,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,k.getAllCodicons)(),b=>b.id),markdownEnumDescriptions:Array.from((0,k.getAllCodicons)(),b=>`$(${b.id})`)};const R={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),...e.terminalIconSchema},color:{description:(0,L.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},v={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(6,null),type:["string"],items:{type:"string"}},...R}},P=(0,L.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),w=(0,L.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),g=(0,L.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),h=(0,L.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),m=(0,L.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),y=(0,L.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),f={id:"terminal",order:100,title:(0,L.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(26,null)}},{type:"string",markdownDescription:(0,L.localize)(27,null)}],default:[],markdownDeprecationMessage:g},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(30,null),type:"string"},id:{description:(0,L.localize)(31,null),type:"string"},title:{description:(0,L.localize)(32,null),type:"string"},...R}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(34,null),type:"string"},id:{description:(0,L.localize)(35,null),type:"string"},title:{description:(0,L.localize)(36,null),type:"string"},...R}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(38,null),type:"string"},id:{description:(0,L.localize)(39,null),type:"string"},title:{description:(0,L.localize)(40,null),type:"string"},...R}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,L.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){D.Registry.as(l.Extensions.Configuration).registerConfiguration(f),p()}e.registerTerminalPlatformConfiguration=u;let d;function p(b,C){const t=D.Registry.as(l.Extensions.Configuration);let a;b&&(a=(0,T.createProfileSchemaEnums)(b?.profiles,C));const i=d;d={id:"terminal",order:100,title:(0,L.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:b?.os===3?a?.values:void 0,markdownEnumDescriptions:b?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:b?.os===2?a?.values:void 0,markdownEnumDescriptions:b?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:b?.os===1?a?.values:void 0,markdownEnumDescriptions:b?.os===1?a?.markdownDescriptions:void 0}}},t.updateConfigurations({add:[d],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=p}),define(ne[254],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(ne[255],se([0,1,34,21,32,13,4,36,26,12,27,115,250,249]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function m(){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let r=0;return n&&n.length===4&&(r=parseInt(n[3])),r}e.getWindowsBuildNumber=m;async function y(n,r,o,s=R.env,c=P.Promises.exists){if(D.isAbsolute(n))return await c(n)?n:void 0;if(r===void 0&&(r=R.cwd()),D.dirname(n)!=="."){const N=D.join(r,n);return await c(N)?N:void 0}const E=(0,l.getCaseInsensitive)(s,"PATH");if(o===void 0&&(0,v.isString)(E)&&(o=E.split(D.delimiter)),o===void 0||o.length===0){const N=D.join(r,n);return await c(N)?N:void 0}for(const N of o){let M;if(D.isAbsolute(N)?M=D.join(N,n):M=D.join(r,N,n),await c(M))return M;if(T.isWindows){let B=M+".com";if(await c(B)||(B=M+".exe",await c(B)))return B}}const A=D.join(r,n);return await c(A)?A:void 0}e.findExecutable=y;function f(n,r,o,s,c){const S=T.isWindows&&(!r.windowsEnableConpty||m()<18309);if(!r.shellIntegration.enabled||!n.executable||n.isFeatureTerminal||n.hideFromUser||n.ignoreShellIntegration||S)return;const E=n.args,A=R.platform==="win32"?D.basename(n.executable).toLowerCase():D.basename(n.executable),N=D.dirname(L.FileAccess.asFileUri("").fsPath);let M;const B={VSCODE_INJECTION:"1"};if(T.isWindows){if(A==="pwsh.exe"||A==="powershell.exe")return!E||a(E)?M=p.get(d.WindowsPwsh):t(E)&&(M=p.get(d.WindowsPwshLogin)),M?(M=[...M],M[M.length-1]=(0,I.format)(M[M.length-1],N,""),r.shellIntegration.suggestEnabled&&(B.VSCODE_SUGGEST="1"),{newArgs:M,envMixin:B}):void 0;s.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args);return}switch(A){case"bash":return!E||E.length===0?M=p.get(d.Bash):i(E)&&(B.VSCODE_SHELL_LOGIN="1",u(r,B),M=p.get(d.Bash)),M?(M=[...M],M[M.length-1]=(0,I.format)(M[M.length-1],N),{newArgs:M,envMixin:B}):void 0;case"fish":{const O=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",j=D.join(N,"out/vs/workbench/contrib/xdg_data");return B.XDG_DATA_DIRS=`${O}:${j}`,u(r,B),{newArgs:void 0,envMixin:B}}case"pwsh":return!E||a(E)?M=p.get(d.Pwsh):t(E)&&(M=p.get(d.PwshLogin)),M?(r.shellIntegration.suggestEnabled&&(B.VSCODE_SUGGEST="1"),M=[...M],M[M.length-1]=(0,I.format)(M[M.length-1],N,""),{newArgs:M,envMixin:B}):void 0;case"zsh":{if(!E||E.length===0?M=p.get(d.Zsh):i(E)?(M=p.get(d.ZshLogin),u(r,B)):(E===p.get(d.Zsh)||E===p.get(d.ZshLogin))&&(M=E),!M)return;M=[...M],M[M.length-1]=(0,I.format)(M[M.length-1],N);let O;try{O=k.userInfo().username}catch{O="unknown"}const j=D.join(k.tmpdir(),`${O}-${c.applicationName}-zsh`);B.ZDOTDIR=j;const q=o?.ZDOTDIR??k.homedir()??"~";B.USER_ZDOTDIR=q;const K=[];return K.push({source:D.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.join(j,".zshrc")}),K.push({source:D.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.join(j,".zprofile")}),K.push({source:D.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.join(j,".zshenv")}),K.push({source:D.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.join(j,".zlogin")}),{newArgs:M,envMixin:B,filesToCopy:K}}}s.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args)}e.getShellIntegrationInjection=f;function u(n,r){if(T.isMacintosh&&n.environmentVariableCollections){const o=(0,g.deserializeEnvironmentVariableCollections)(n.environmentVariableCollections),c=new h.MergedEnvironmentVariableCollection(o).map.get("PATH"),S=[];if(c)for(const E of c)E.type===w.EnvironmentVariableMutatorType.Prepend&&S.push(E.value);S.length>0&&(r.VSCODE_PATH_PREFIX=S.join(""))}}var d;(function(n){n.WindowsPwsh="windows-pwsh",n.WindowsPwshLogin="windows-pwsh-login",n.Pwsh="pwsh",n.PwshLogin="pwsh-login",n.Zsh="zsh",n.ZshLogin="zsh-login",n.Bash="bash"})(d||(d={}));const p=new Map;p.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),p.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),p.set(d.Zsh,["-i"]),p.set(d.ZshLogin,["-il"]),p.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const b=["-login","-l"],C=["-nol","-nologo"];function t(n){return typeof n=="string"?b.includes(n.toLowerCase()):n.length===1&&b.includes(n[0].toLowerCase())||n.length===2&&(b.includes(n[0].toLowerCase())||b.includes(n[1].toLowerCase()))&&(C.includes(n[0].toLowerCase())||C.includes(n[1].toLowerCase()))}function a(n){return typeof n=="string"?C.includes(n.toLowerCase()):n.length===0||n?.length===1&&C.includes(n[0].toLowerCase())}function i(n){return n==="string"&&b.includes(n.toLowerCase())||typeof n!="string"&&n.length===1&&b.includes(n[0].toLowerCase())}}),define(ne[256],se([0,1,50,52,13,4,12,27,93,255]),function(Z,e,k,L,l,D,T,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,w=!0;function g(a,i,n,r,o=process.env,s,c,S,E){return s=s||{existsFile:R.SymlinkSupport.existsFile,readFile:R.Promises.readFile},D.isWindows?h(n,s,o,c,r.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:r.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:r.getValue("terminal.integrated.defaultProfile.windows"),E,S):b(s,c,n,a&&typeof a=="object"?{...a}:r.getValue(D.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:r.getValue(D.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),E,S,o)}e.detectAvailableProfiles=g;async function h(a,i,n,r,o,s,c,S,E){const A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),N=`${process.env.windir}\\${A?"Sysnative":"System32"}`;let M=!1;(0,v.getWindowsBuildNumber)()>=16299&&(M=!0),await f(S);const B=new Map;if(a){B.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),B.set("Windows PowerShell",{path:`${N}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),B.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),B.set("Command Prompt",{path:`${N}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0}),B.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),B.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:L.Codicon.terminalBash,isAutoDetected:!0});const j=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;B.set("Cmder",{path:`${N}\\cmd.exe`,args:["/K",j],requiresPath:process.env.CMDER_ROOT?j:{path:j,isUnsafe:!0},isAutoDetected:!0})}C(s,B);const O=await m(B.entries(),c,i,n,r,E);if(a||o)try{const j=await d(`${N}\\${M?"wsl":"bash"}.exe`,c);for(const q of j)(!s||!(q.profileName in s))&&O.push(q)}catch{w&&(r?.info("WSL is not installed, so could not detect WSL profiles"),w=!1)}return O}async function m(a,i,n,r=process.env,o,s){const c=[];for(const[S,E]of a){if(E===null)continue;let A,N,M;if("source"in E){const q=P?.get(E.source);if(!q)continue;A=q.paths,N=E.args||q.args,E.icon?M=y(E.icon):q.icon&&(M=q.icon)}else A=Array.isArray(E.path)?E.path:[E.path],N=D.isWindows||Array.isArray(E.args)?E.args:void 0,M=y(E.icon);let B;if(s){const q=A.map(Q=>typeof Q=="string"?Q:Q.path),K=await s(q);B=new Array(A.length);for(let Q=0;Q<A.length;Q++)typeof A[Q]=="string"?B[Q]=K[Q]:B[Q]={path:K[Q],isUnsafe:!0}}else B=A.slice();let O;if(E.requiresPath){let q;if((0,T.isString)(E.requiresPath)?q=E.requiresPath:(q=E.requiresPath.path,E.requiresPath.isUnsafe&&(O=q)),!await n.existsFile(q))continue}const j=await t(S,i,B,n,r,N,E.env,E.overrideName,E.isAutoDetected,O);j?(j.isAutoDetected=E.isAutoDetected,j.icon=M,j.color=E.color,c.push(j)):o?.debug("Terminal profile not validated",S,A)}return o?.debug("Validated terminal profiles",c),c}function y(a){return typeof a=="string"?{id:a}:a}async function f(a){P&&!a||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),P.set("PowerShell",{profileName:"PowerShell",paths:a||await u(),icon:L.Codicon.terminalPowershell}))}async function u(){const a=[];for await(const i of(0,I.enumeratePowerShellInstallations)())a.push(i.exePath);return a}async function d(a,i){const n=[],r=await new Promise((c,S)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(E,A)=>{if(E)return S("Problem occurred when getting wsl distros");c(A)})});if(!r)return[];const o=new RegExp(/[\r?\n]/),s=r.split(o).filter(c=>c.trim().length>0&&c!=="");for(const c of s){if(c===""||c.startsWith("docker-desktop"))continue;const S=`${c} (WSL)`,E={profileName:S,path:a,args:["-d",`${c}`],isDefault:S===i,icon:p(c),isAutoDetected:!1};n.push(E)}return n}function p(a){return a.includes("Ubuntu")?L.Codicon.terminalUbuntu:a.includes("Debian")?L.Codicon.terminalDebian:L.Codicon.terminalLinux}async function b(a,i,n,r,o,s,c,S){const E=new Map;if(n){const A=(await a.readFile("/etc/shells")).toString(),N=s||A.split(`
`).filter(B=>B.trim().includes("#")&&B.trim().length>0),M=new Map;for(const B of N){let O=(0,l.basename)(B),j=M.get(O)||0;j++,j>1&&(O=`${O} (${j})`),M.set(O,j),E.set(O,{path:B,isAutoDetected:!0})}}return C(r,E),await m(E.entries(),o,a,S,i,c)}function C(a,i){if(!!a)for(const[n,r]of Object.entries(a))r===null||typeof r!="object"||!("path"in r)&&!("source"in r)?i.delete(n):(r.icon=r.icon||i.get(n)?.icon,i.set(n,r))}async function t(a,i,n,r,o,s,c,S,E,A){if(n.length===0)return Promise.resolve(void 0);const N=n.shift();if(N==="")return t(a,i,n,r,o,s,c,S,E);const M=typeof N!="string"&&N.isUnsafe,B=typeof N=="string"?N:N.path,O={profileName:a,path:B,args:s,env:c,overrideName:S,isAutoDetected:E,isDefault:a===i,isUnsafePath:M,requiresUnsafePath:A};if((0,l.basename)(B)===B){const q=o.PATH?o.PATH.split(l.delimiter):void 0,K=await(0,v.findExecutable)(B,void 0,q,void 0,r.existsFile);return K?(O.path=K,O.isFromPath=!0,O):t(a,i,n,r,o,s)}return await r.existsFile((0,l.normalize)(B))?O:t(a,i,n,r,o,s,c,S,E)}}),define(ne[257],se([0,1,3,2,21,4,37,66,16,15,96,237,11,251,116,253,256,105]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var d;(function(C){C[C.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let p=0,b=class extends L.Disposable{constructor(t,a,i,n,r,o){super(),this.C=t,this.D=a,this.F=i,this.G=n,this.H=r,this.I=o,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new k.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new k.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new k.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new k.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new k.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new k.Emitter),this.onProcessData=this.s.event,this.t=this.B(new k.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new k.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new k.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new k.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new k.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new k.Emitter),this.onProcessExit=this.z.event,(0,y.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,L.toDisposable)(()=>this.O())),this.f=this.B(new h.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.F.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(D.isWindows)return process.env;try{return await(0,w.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(t){return this.H.error("ptyHost was unable to resolve shell environment",t),{}}}N(){const t={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsPath],env:{VSCODE_LAST_PTY_ID:p,VSCODE_PTY_LOG_NAME:this.D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},a=(0,P.parsePtyHostDebugPort)(this.G.args,this.G.isBuilt);a&&(a.break&&a.port?t.debugBrk=a.port:!a.break&&a.port&&(t.debug=a.port));const i=new R.Client(l.FileAccess.asFileUri("bootstrap-fork").fsPath,t);this.m.fire(),T.ProxyChannel.toService(i.getChannel(m.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(i.onDidProcessExit(o=>{this.l.fire(o.code),this.i||(this.g<=d.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))})),this.B(new u.RemoteLoggerChannelClient(this.I,i.getChannel(m.TerminalIpcChannels.Logger)));const r=T.ProxyChannel.toService(i.getChannel(m.TerminalIpcChannels.PtyHost));return this.B(r.onProcessData(o=>this.s.fire(o))),this.B(r.onProcessReady(o=>this.t.fire(o))),this.B(r.onProcessExit(o=>this.z.fire(o))),this.B(r.onDidChangeProperty(o=>this.y.fire(o))),this.B(r.onProcessReplay(o=>this.u.fire(o))),this.B(r.onProcessOrphanQuestion(o=>this.v.fire(o))),this.B(r.onDidRequestDetach(o=>this.w.fire(o))),[i,r]}dispose(){this.i=!0,super.dispose()}async createProcess(t,a,i,n,r,o,s,c,S,E,A){const N=setTimeout(()=>this.S(),m.HeartbeatConstants.CreateProcessTimeout),M=await this.b.createProcess(t,a,i,n,r,o,s,c,S,E,A);return clearTimeout(N),p=Math.max(p,M),M}updateTitle(t,a,i){return this.b.updateTitle(t,a,i)}updateIcon(t,a,i,n){return this.b.updateIcon(t,a,i,n)}attachToProcess(t){return this.b.attachToProcess(t)}detachFromProcess(t,a){return this.b.detachFromProcess(t,a)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(t){return this.b.start(t)}shutdown(t,a){return this.b.shutdown(t,a)}input(t,a){return this.b.input(t,a)}processBinary(t,a){return this.b.processBinary(t,a)}resize(t,a,i){return this.b.resize(t,a,i)}acknowledgeDataEvent(t,a){return this.b.acknowledgeDataEvent(t,a)}setUnicodeVersion(t,a){return this.b.setUnicodeVersion(t,a)}getInitialCwd(t){return this.b.getInitialCwd(t)}getCwd(t){return this.b.getCwd(t)}getLatency(t){return this.b.getLatency(t)}orphanQuestionReply(t){return this.b.orphanQuestionReply(t)}installAutoReply(t,a){return this.b.installAutoReply(t,a)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(t){return this.b.uninstallAutoReply(t)}getDefaultSystemShell(t){return this.b.getDefaultSystemShell(t)}async getProfiles(t,a,i,n=!1){const r=await this.c;return(0,f.detectAvailableProfiles)(a,i,n,this.F,r,void 0,this.H,this.W.bind(this,t))}getEnvironment(){return this.b.getEnvironment()}getWslPath(t,a){return this.b.getWslPath(t,a)}getRevivedPtyNewId(t){return this.b.getRevivedPtyNewId(t)}setTerminalLayoutInfo(t){return this.b.setTerminalLayoutInfo(t)}async getTerminalLayoutInfo(t){return await this.b.getTerminalLayoutInfo(t)}async requestDetachInstance(t,a){return this.b.requestDetachInstance(t,a)}async acceptDetachInstanceReply(t,a){return this.b.acceptDetachInstanceReply(t,a)}async freePortKillProcess(t){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(t)}async serializeTerminalState(t){return this.b.serializeTerminalState(t)}async reviveTerminalProcesses(t,a){return this.b.reviveTerminalProcesses(t,a)}async refreshProperty(t,a){return this.b.refreshProperty(t,a)}async updateProperty(t,a,i){return this.b.updateProperty(t,a,i)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier+m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${m.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(t,a){return this.f.createRequest({workspaceId:t,originalText:a})}async acceptPtyHostResolvedVariables(t,a){this.f.acceptReply(t,a)}};b=ye([Y(2,I.IConfigurationService),Y(3,v.IEnvironmentService),Y(4,g.ILogService),Y(5,g.ILoggerService)],b),e.PtyHostService=b}),define(ne[76],se([0,1,3,16,5,11]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var T;(function(y){y.Http="http",y.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function v(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!f)return{address:f[1],port:+f[2]}}e.extractLocalHostUriMetaDataForPortMapping=v,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=w;function g(y,f,u,d){if(u===1)return!1;if(u===2&&w(f)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(p?.length===4&&parseInt(p[1])>=18)return!1}return y<1024}e.isPortPrivileged=g;class h{constructor(f,u,d){this.remoteAddress=f,this.localAddress=u,this.b=d,this.a=new k.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=h;let m=class{constructor(f,u){this.i=f,this.j=u,this.a=new k.Emitter,this.onTunnelOpened=this.a.event,this.b=new k.Emitter,this.onTunnelClosed=this.b.event,this.c=new k.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const f=this.j.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(f){return this.e=f,f?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(f){this.f=f.elevation,this.g=f.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const f=[],u=Array.from(this.d.values());for(const d of u){const p=Array.from(d.values());for(const b of p){const C=await b.value;C&&f.push(C)}}return f}async dispose(){for(const f of this.d.values()){for(const{value:u}of f.values())await u.then(d=>d?.dispose());f.clear()}this.d.clear()}setEnvironmentTunnel(f,u,d,p,b){this.o(f,u,Promise.resolve({tunnelRemoteHost:f,tunnelRemotePort:u,localAddress:d,privacy:p,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(f,u){(w(f)||P(f))&&(f=e.LOCALHOST_ADDRESSES[0]);const d=this.q(f,u);if(d)return++d.refcount,d.value}openTunnel(f,u,d,p,b,C=!1,t,a){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${d} on local port ${b}.`),!f)return;if(u||(u="localhost"),p||(p=this.k),this.e&&this.h.has(d)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(f,u,d,p,b,C,t,a);return i?i.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,d);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.m(n);return(n.tunnelRemoteHost!==u||n.tunnelRemotePort!==d)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(r),r}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,privacy:f.privacy,protocol:f.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${f.tunnelRemoteHost}:${f.tunnelRemotePort} `);const u=this.d.get(f.tunnelRemoteHost);if(u){const d=u.get(f.tunnelRemotePort);d&&(d.refcount--,await this.n(f.tunnelRemoteHost,f.tunnelRemotePort,d))}}}}async n(f,u,d){if(d.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${f}:${u}.`);const p=d.value.then(async b=>{b&&(await b.dispose(!0),this.b.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this.d.has(f)&&this.d.get(f).delete(u),p}}async closeTunnel(f,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${f}:${u} `);const d=this.d.get(f);if(d&&d.has(u)){const p=d.get(u);p.refcount=0,await this.n(f,u,p)}}o(f,u,d){this.d.has(f)||this.d.set(f,new Map),this.d.get(f).set(u,{refcount:1,value:d})}async p(f,u){const d=this.d.get(f);d&&(await d.get(u)||d.delete(u),d.size===0&&this.d.delete(f))}q(f,u){const d=[f];P(f)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):w(f)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const p=d.map(b=>this.d.get(b));for(const b of p){const C=b?.get(u);if(C)return C}}canTunnel(f){return!!v(f)}s(f,u,d,p,b,C,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${d} on local port ${p}.`);const a=d;this.h.add(a);const i=p===void 0?d:p,n={elevationRequired:b?this.isPortPrivileged(i):!1},r={remoteAddress:{host:u,port:d},localAddressPort:p,privacy:C,public:C?C!==R.Private:void 0,protocol:t},o=f.forwardPort(r,n);return o?(this.o(u,d,o),o.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(a)})):this.h.delete(a),o}};m=ye([Y(0,D.ILogService),Y(1,L.IConfigurationService)],m),e.AbstractTunnelService=m}),define(ne[258],se([0,1,11,76,2,8,6]),function(Z,e,k,L,l,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends l.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new T.DeferredPromise),this.b.p)}setAddress(P){this.a=P,this.b&&(this.b.complete(P),this.b=null)}setTunnel(P){this.B(P)}}let I=class Rt extends l.Disposable{constructor(P,w){super(),this.f=P,this.g=w,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Rt.a)}}async startTunnel(P,w,g,h,m,y,f){const u=new R,d=await Promise.resolve(this.f.openTunnel(P,u,g,h,m,y,f));if(!d)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${g}:${h} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(w))throw this.c.delete(w),u.dispose(),await d.dispose(),(0,D.canceled)();return u.setTunnel(d),this.b.set(w,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${d.localAddress} (local) to ${g}:${h} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(P,w){const g=this.b.get(P);!g||g.setAddress(w)}async destroyTunnel(P){const w=this.b.get(P);if(w){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this.b.delete(P),await w.dispose();return}this.c.add(P)}};I.a=0,I=ye([Y(0,L.ISharedTunnelsService),Y(1,k.ILogService)],I),e.SharedProcessTunnelService=I}),define(ne[259],se([0,1,85,34,136,229,6,2,16,11,25,227,76,110,4]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(b,C,t,a,i){let n;for(let r=3;r&&(n?.dispose(),n=await new f(b,C,t,a,i).waitForReady(),!(i&&l.BROWSER_RESTRICTED_PORTS[i]||!l.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));r--);return n}class f extends R.Disposable{constructor(C,t,a,i,n){super(),this.j=t,this.k=n,this.privacy=g.TunnelPrivacyId.Private,this.i=new Map,this.a=C,this.b=k.createServer(),this.c=new T.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=r=>this.l(r),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const C=this.k??this.tunnelRemotePort,t=(0,g.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let a=await(0,l.findFreePortFaster)(C,2,1e3,t),i=null;return this.b.listen(a,this.j),await this.c.wait(),i=this.b.address(),i||(a=0,this.b.listen(a,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(C){C.pause();const t=(0,g.isLocalhost)(this.tunnelRemoteHost)||(0,g.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,w.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),i=a.getSocket().socket,n=a.readEntireBuffer();a.dispose(),n.byteLength>0&&C.write(n.buffer),C.on("end",()=>{C.localAddress&&this.i.delete(C.localAddress),i.end()}),C.on("close",()=>i.end()),C.on("error",()=>{C.localAddress&&this.i.delete(C.localAddress),i.destroy()}),i.on("end",()=>C.end()),i.on("close",()=>C.end()),i.on("error",()=>{C.destroy()}),C.pipe(i),i.pipe(C),C.localAddress&&this.i.set(C.localAddress,()=>{C.end(),i.end()})}}let u=class extends g.AbstractTunnelService{constructor(C,t,a,i,n){super(t,n),this.t=C,this.u=a,this.v=i}isPortPrivileged(C){return(0,g.isPortPrivileged)(C,this.k,m.OS,L.release())}r(C,t,a,i,n,r,o,s){const c=this.q(t,a);if(c)return++c.refcount,c.value;if(this.e)return this.s(this.e,t,a,n,r,o,s);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${a} on local port ${n}.`);const S={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:C,signService:this.u,logService:this.i,ipcLogger:null},E=y(S,i,t,a,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,a,E),E}}};u=ye([Y(1,v.ILogService),Y(2,h.ISignService),Y(3,P.IProductService),Y(4,I.IConfigurationService)],u),e.BaseTunnelService=u;let d=class extends u{constructor(C,t,a,i){super(D.nodeSocketFactory,C,t,a,i)}};d=ye([Y(0,v.ILogService),Y(1,h.ISignService),Y(2,P.IProductService),Y(3,I.IConfigurationService)],d),e.TunnelService=d;let p=class extends R.Disposable{constructor(C,t,a,i){super(),this.b=C,this.c=t,this.f=a,this.g=i,this.a=new Map}async openTunnel(C,t,a,i,n,r,o,s,c){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${i} on local port ${r}.`),!this.a.has(C)){const S=new d(this.b,this.f,this.c,this.g);this.B(S),this.a.set(C,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(C))})}return this.a.get(C).openTunnel(t,a,i,n,r,o,s,c)}};p=ye([Y(0,v.ILogService),Y(1,P.IProductService),Y(2,h.ISignService),Y(3,I.IConfigurationService)],p),e.SharedTunnelsService=p}),define(ne[30],se([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(ne[260],se([0,1,30,69,14,24,132,3,2]),function(Z,e,k,L,l,D,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class v{constructor(g){this.uri=g,this.time=v._clock++}touch(){return this.time=v._clock++,this}}v._clock=0;let P=class{constructor(g){this.g=g,this.c=new I.DisposableStore,this.f=2**16;const h=new Map,m=y=>{let f=h.get(y.scheme);return f===void 0&&(f=g.hasProvider(y)&&!this.g.hasCapability(y,1024),h.set(y.scheme,f)),f};this.c.add(R.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(y=>{h.delete(y.scheme)})),this.extUri=new D.ExtUri(m),this.d=new T.SkipList((y,f)=>this.extUri.compare(y,f,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,D.normalizePath)(g));const h=this.d.get(g);return h?h.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new v(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((m,y)=>m[1].touch<y[1].touch?1:m[1].touch>y[1].touch?-1:0);v._clock=0,this.d.clear();const h=this.f*.5;for(let m=0;m<h;m++)this.d.set(g[m][0],g[m][1].touch())}};P=ye([Y(0,l.IFileService)],P),e.UriIdentityService=P,(0,L.registerSingleton)(k.IUriIdentityService,P,1)}),define(ne[261],se([0,1,3,2,14,43,49,17]),function(Z,e,k,L,l,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends L.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(P,w,g,h){super(),this.c=P,this.f=w,this.g=g,this.h=h,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new k.Emitter),this.onDidChangeFile=this.a.event,this.b=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(m=>this.i(m)))}watch(P,w){this.b.set(P,P);const g=this.f.watch(this.j(P),w);return(0,L.toDisposable)(()=>{this.b.delete(P),g.dispose()})}stat(P){return this.f.stat(this.j(P))}mkdir(P){return this.f.mkdir(this.j(P))}rename(P,w,g){return this.f.rename(this.j(P),this.j(w),g)}readFile(P){return this.f.readFile(this.j(P),{atomic:!0})}readFileStream(P,w,g){const h=(0,D.newWriteableStream)(m=>R.VSBuffer.concat(m.map(y=>R.VSBuffer.wrap(y))).buffer);return(async()=>{try{const m=await this.readFile(P);h.end(m)}catch(m){h.error(m),h.end()}})(),h}readdir(P){return this.f.readdir(this.j(P))}writeFile(P,w,g){return this.f.writeFile(this.j(P),w,g)}delete(P,w){return this.f.delete(this.j(P),w)}copy(P,w,g){if((0,l.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(P),this.j(w),g);throw new Error("copy not supported")}i(P){const w=[];for(const g of P){if(g.resource.scheme!==this.c)continue;const h=this.k(g.resource);this.b.findSubstr(h)&&w.push({resource:h,type:g.type})}w.length&&(this.h.debug("User data changed"),this.a.fire(w))}j(P){return P.with({scheme:this.c})}k(P){return P.with({scheme:this.g})}}e.FileUserDataProvider=I}),define(ne[60],se([0,1,82]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(T,R,I,v){const P=(0,k.setProperty)(T,R,I,v)[0];return P&&(T=T.substring(0,P.offset)+P.content+T.substring(P.offset+P.length)),T}e.edit=L;function l(T,R,I){let v=I;for(;v>=0;){if(T.charAt(v)===R.charAt(R.length-1)&&R.length===1)return v+1;if(v--,R.length===2&&v>=0&&T.charAt(v)===R.charAt(0))return v+2}return 0}e.getLineStartOffset=l;function D(T,R,I){let v=I;for(;v>=0;)if(T.charAt(v)===R.charAt(R.length-1)&&R.length===1||(v++,R.length===2&&v>=0&&T.charAt(v)===R.charAt(1)))return v;return T.length-1}e.getLineEndOffset=D}),define(ne[262],se([0,1,32,54,12]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(h,m,y,f,u,d){const p=[],b=[],C=[];if(!m){const j=h.filter(({identifier:q})=>u.every(K=>K.toLowerCase()!==q.id.toLowerCase()));return{local:{added:p,removed:b,updated:C},remote:j.length>0?{added:j,updated:[],removed:[],all:j}:null}}h=h.map(w),m=m.map(w),y=y?y.map(w):null;const t=new Map,a=j=>{j.uuid&&t.set(j.id.toLowerCase(),j.uuid)};h.forEach(({identifier:j})=>a(j)),m.forEach(({identifier:j})=>a(j)),y?.forEach(({identifier:j})=>a(j));const i=j=>{const q=j.identifier.uuid||t.get(j.identifier.id.toLowerCase());return q?`uuid:${q}`:`id:${j.identifier.id.toLowerCase()}`},n=(j,q)=>(j.set(i(q),q),j),r=h.reduce(n,new Map),o=m.reduce(n,new Map),s=m.reduce((j,q)=>n(j,(0,k.deepClone)(q)),new Map),c=y?y.reduce(n,new Map):null,S=f.reduce(n,new Map),E=u.reduce((j,q)=>{const K=t.get(q.toLowerCase());return j.add(K?`uuid:${K}`:`id:${q.toLowerCase()}`)},new Set),A=d?d.reduce((j,{id:q,uuid:K})=>(K=K??t.get(q.toLowerCase()),j.add(K?`uuid:${K}`:`id:${q.toLowerCase()}`)),new Set):null,N=T(r,o,E,!1);if(N.added.size>0||N.removed.size>0||N.updated.size>0){const j=T(c,r,E,!1),q=T(c,o,E,!0),K=(Q,re,J,W)=>{let F,G,ee;return re.installed?(F=W.pinned,ee=W.preRelease,F&&(G=W.version)):(F=J.pinned,ee=J.preRelease,F&&(G=J.version)),F===void 0&&(F=re.pinned,F&&(G=re.version)),ee===void 0&&(ee=re.preRelease),{...W,installed:re.installed||J.installed,pinned:F,preRelease:ee,version:G??(J.version&&(!re.installed||L.gt(J.version,re.version))?J.version:re.version),state:I(re,J,c?.get(Q))}};for(const Q of q.removed.values()){const re=r.get(Q);if(!re)continue;const J=(0,l.assertIsDefined)(c?.get(Q)),W=A&&!A.has(Q)&&J.installed;re.installed&&W?b.push(re.identifier):s.set(Q,re)}for(const Q of q.added.values()){const re=(0,l.assertIsDefined)(o.get(Q)),J=r.get(Q);if(J){if(N.updated.has(Q)){const W=K(Q,J,re,re);R(J,re,!1,!1)||C.push(g(W,Q)),s.set(Q,W)}}else re.installed&&p.push(g(re,Q))}for(const Q of q.updated.values()){const re=(0,l.assertIsDefined)(o.get(Q)),J=(0,l.assertIsDefined)(c?.get(Q)),W=r.get(Q);if(W)if(A&&!A.has(Q)&&J.installed&&W.installed&&!re.installed)b.push(W.identifier);else{const G=K(Q,W,re,re);C.push(g(G,Q)),s.set(Q,G)}else re.installed&&p.push(g(re,Q))}for(const Q of j.added.values())q.added.has(Q)||s.set(Q,(0,l.assertIsDefined)(r.get(Q)));for(const Q of j.updated.values()){if(q.removed.has(Q)||q.updated.has(Q))continue;const re=(0,l.assertIsDefined)(r.get(Q)),J=(0,l.assertIsDefined)(o.get(Q));s.set(Q,K(Q,re,J,re))}for(const Q of j.removed.values())q.updated.has(Q)||q.removed.has(Q)||S.has(Q)||!(0,l.assertIsDefined)(o.get(Q)).installed||!A||A.has(Q)||!(0,l.assertIsDefined)(c?.get(Q)).installed||s.delete(Q)}const M=[],B=T(o,s,new Set,!0),O=B.added.size>0||B.updated.size>0||B.removed.size>0;return O&&s.forEach((j,q)=>M.push(g(j,q))),{local:{added:p,removed:b,updated:C},remote:O?{added:[...B.added].map(j=>s.get(j)),updated:[...B.updated].map(j=>s.get(j)),removed:[...B.removed].map(j=>o.get(j)),all:M}:null}}e.merge=D;function T(h,m,y,f){const u=h?[...h.keys()].filter(t=>!y.has(t)):[],d=[...m.keys()].filter(t=>!y.has(t)),p=d.filter(t=>u.indexOf(t)===-1).reduce((t,a)=>(t.add(a),t),new Set),b=u.filter(t=>d.indexOf(t)===-1).reduce((t,a)=>(t.add(a),t),new Set),C=new Set;for(const t of u){if(b.has(t))continue;const a=h.get(t),i=m.get(t);(!i||!R(a,i,f,!0))&&C.add(t)}return{added:p,removed:b,updated:C}}function R(h,m,y,f){return!(h.disabled!==m.disabled||f&&h.installed!==m.installed||h.installed&&m.installed&&(h.preRelease!==m.preRelease||h.pinned!==m.pinned||m.pinned&&h.version!==m.version)||!P(h.state,m.state)||y&&h.version!==m.version)}function I(h,m,y){const f=h.state,u=m.state,d=y?.state;if(!m.version||f&&L.gt(h.version,m.version))return f;if(u&&L.gt(m.version,h.version)||!f)return u;if(!u)return f;const p=(0,k.deepClone)(f),b=d?v(d,u):{added:Object.keys(u).reduce((t,a)=>(t.add(a),t),new Set),removed:new Set,updated:new Set},C=d?v(d,f):{added:Object.keys(f).reduce((t,a)=>(t.add(a),t),new Set),removed:new Set,updated:new Set};for(const t of[...b.added.values(),...b.updated.values()])p[t]=u[t];for(const t of b.removed.values())C.updated.has(t)||delete p[t];return p}function v(h,m){const y=Object.keys(h),f=Object.keys(m),u=f.filter(b=>y.indexOf(b)===-1).reduce((b,C)=>(b.add(C),b),new Set),d=y.filter(b=>f.indexOf(b)===-1).reduce((b,C)=>(b.add(C),b),new Set),p=new Set;for(const b of y){if(d.has(b))continue;const C=h[b],t=m[b];(0,k.equals)(C,t)||p.add(b)}return{added:u,removed:d,updated:p}}function P(h={},m={}){const{added:y,removed:f,updated:u}=v(h,m);return y.size===0&&f.size===0&&u.size===0}function w(h){return{...h,disabled:!!h.disabled,installed:!!h.installed}}function g(h,m){const y={identifier:{id:h.identifier.id,uuid:m.startsWith("uuid:")?m.substring(5):void 0},version:h.version,preRelease:!!h.preRelease,pinned:!!h.pinned};return h.disabled&&(y.disabled=!0),h.installed&&(y.installed=!0),h.state&&(y.state=h.state),y}}),define(ne[117],se([0,1,18,16,5]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,l.createDecorator)("IIgnoredExtensionsManagementService");let D=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,I){let v=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return v=v.filter(P=>P!==R&&P!==`-${R}`),I&&v.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,2)}updateSynchronizedExtensions(R,I){let v=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return v=v.filter(P=>P!==R&&P!==`-${R}`),I&&v.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,2)}getIgnoredExtensions(R){const I=R.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),v=this.b().map(g=>g.toLowerCase()),P=[],w=[];if(Array.isArray(v))for(const g of v)g.startsWith("-")?w.push(g.substring(1)):P.push(g);return(0,k.distinct)([...I,...P].filter(g=>w.indexOf(g)===-1))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};D=ye([Y(0,L.IConfigurationService)],D),e.IgnoredExtensionsManagementService=D}),define(ne[263],se([0,1,18,35,32,201,60]),function(Z,e,k,L,l,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(b){return(0,L.parse)(b)||[]}async function I(b,C,t,a,i){const n=R(b),r=R(C),o=t?R(t):null,s=[...n,...r,...o||[]].map(K=>K.key),c=await i.resolveUserBindings(s),S=P(n,r,o,c);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:b,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:C,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:b,hasChanges:!0,hasConflicts:!1};const E=g(n),A=g(r),N=o?g(o):null,M=m(E,A,c),B=N?m(N,E,c):{added:[...E.keys()].reduce((K,Q)=>(K.add(Q),K),new Set),removed:new Set,updated:new Set},O=N?m(N,A,c):{added:[...A.keys()].reduce((K,Q)=>(K.add(Q),K),new Set),removed:new Set,updated:new Set},j=v(M,B,O);let q=b;for(const K of j.removed.values())j.conflicts.has(K)||(q=d(q,K,a));for(const K of j.added.values()){if(j.conflicts.has(K))continue;const Q=A.get(K);if(Q.some(re=>re.command!==`-${K}`&&S.conflicts.has(c[re.key]))){j.conflicts.add(K);continue}q=u(q,Q,a)}for(const K of j.updated.values()){if(j.conflicts.has(K))continue;const Q=A.get(K);if(Q.some(re=>re.command!==`-${K}`&&S.conflicts.has(c[re.key]))){j.conflicts.add(K);continue}q=p(q,K,Q,a)}return{mergeContent:q,hasChanges:!0,hasConflicts:j.conflicts.size>0}}e.merge=I;function v(b,C,t){const a=new Set,i=new Set,n=new Set,r=new Set;for(const o of C.removed.values())t.updated.has(o)&&r.add(o);for(const o of t.removed.values())r.has(o)||(C.updated.has(o)?r.add(o):i.add(o));for(const o of C.added.values())r.has(o)||t.added.has(o)&&b.updated.has(o)&&r.add(o);for(const o of t.added.values())r.has(o)||(C.added.has(o)?b.updated.has(o)&&r.add(o):a.add(o));for(const o of C.updated.values())r.has(o)||t.updated.has(o)&&b.updated.has(o)&&r.add(o);for(const o of t.updated.values())r.has(o)||(C.updated.has(o)?b.updated.has(o)&&r.add(o):n.add(o));return{added:a,removed:i,updated:n,conflicts:r}}function P(b,C,t,a){const i=new Set,n=w(b,a),r=w(C,a),o=t?w(t,a):null,s=h(n,r);if(s.added.size===0&&s.removed.size===0&&s.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const c=o?h(o,n):{added:[...n.keys()].reduce((B,O)=>(B.add(O),B),new Set),removed:new Set,updated:new Set};if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const S=o?h(o,r):{added:[...r.keys()].reduce((B,O)=>(B.add(O),B),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:E,removed:A,updated:N,conflicts:M}=v(s,c,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:E,removed:A,updated:N,conflicts:M}}function w(b,C){const t=new Map;for(const a of b){const i=C[a.key];let n=t.get(i);n||(n=[],t.set(i,n)),n.push(a)}return t}function g(b){const C=new Map;for(const t of b){const a=t.command[0]==="-"?t.command.substring(1):t.command;let i=C.get(a);i||(i=[],C.set(a,i)),i.push(t)}return C}function h(b,C){const t=[...b.keys()],a=[...C.keys()],i=a.filter(o=>t.indexOf(o)===-1).reduce((o,s)=>(o.add(s),o),new Set),n=t.filter(o=>a.indexOf(o)===-1).reduce((o,s)=>(o.add(s),o),new Set),r=new Set;for(const o of t){if(n.has(o))continue;const s=b.get(o).map(S=>({...S,key:o})),c=C.get(o).map(S=>({...S,key:o}));(0,k.equals)(s,c,(S,E)=>f(S,E))||r.add(o)}return{added:i,removed:n,updated:r}}function m(b,C,t){const a=[...b.keys()],i=[...C.keys()],n=i.filter(s=>a.indexOf(s)===-1).reduce((s,c)=>(s.add(c),s),new Set),r=a.filter(s=>i.indexOf(s)===-1).reduce((s,c)=>(s.add(c),s),new Set),o=new Set;for(const s of a){if(r.has(s))continue;const c=b.get(s).map(E=>({...E,key:t[E.key]})),S=C.get(s).map(E=>({...E,key:t[E.key]}));y(c,S)||o.add(s)}return{added:n,removed:r,updated:o}}function y(b,C){return!(!(0,k.equals)(b.filter(({command:t})=>t[0]!=="-"),C.filter(({command:t})=>t[0]!=="-"),(t,a)=>f(t,a))||!(0,k.equals)(b.filter(({command:t})=>t[0]==="-"),C.filter(({command:t})=>t[0]==="-"),(t,a)=>f(t,a)))}function f(b,C){if(b.command!==C.command||b.key!==C.key)return!1;const t=D.ContextKeyExpr.deserialize(b.when),a=D.ContextKeyExpr.deserialize(C.when);return!(t&&!a||!t&&a||t&&a&&!t.equals(a)||!l.equals(b.args,C.args))}function u(b,C,t){for(const a of C)b=T.edit(b,[-1],a,t);return b}function d(b,C,t){const a=R(b);for(let i=a.length-1;i>=0;i--)(a[i].command===C||a[i].command===`-${C}`)&&(b=T.edit(b,[i],void 0,t));return b}function p(b,C,t,a){const i=R(b),n=i.findIndex(r=>r.command===C||r.command===`-${C}`);for(let r=i.length-1;r>=0;r--)(i[r].command===C||i[r].command===`-${C}`)&&(b=T.edit(b,[r],void 0,a));for(let r=t.length-1;r>=0;r--)b=T.edit(b,[n],t[r],a);return b}}),define(ne[264],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(D,T,R){const I={},v={},P=new Set;if(!T)return{local:{added:I,updated:v,removed:[...P.values()]},remote:{added:D,updated:{},removed:[]},conflicts:[]};const w=L(D,T);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:I,updated:v,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=L(R,D),h=L(R,T),m={},y={},f=new Set,u=new Set;for(const d of g.removed.values())h.updated.has(d)?I[d]=T[d]:f.add(d);for(const d of h.removed.values())u.has(d)||(g.updated.has(d)?u.add(d):P.add(d));for(const d of g.updated.values())u.has(d)||(h.updated.has(d)?w.updated.has(d)&&u.add(d):y[d]=D[d]);for(const d of h.updated.values())u.has(d)||(g.updated.has(d)?w.updated.has(d)&&u.add(d):D[d]!==void 0&&(v[d]=T[d]));for(const d of g.added.values())u.has(d)||(h.added.has(d)?w.updated.has(d)&&u.add(d):m[d]=D[d]);for(const d of h.added.values())u.has(d)||(g.added.has(d)?w.updated.has(d)&&u.add(d):I[d]=T[d]);return{local:{added:I,removed:[...P.values()],updated:v},remote:{added:m,removed:[...f.values()],updated:y},conflicts:[...u.values()]}}e.merge=k;function L(D,T){const R=D?Object.keys(D):[],I=T?Object.keys(T):[],v=I.filter(g=>R.indexOf(g)===-1).reduce((g,h)=>(g.add(h),g),new Set),P=R.filter(g=>I.indexOf(g)===-1).reduce((g,h)=>(g.add(h),g),new Set),w=new Set;for(const g of R){if(P.has(g))continue;const h=D[g],m=T[g];h!==m&&w.add(g)}return{added:v,removed:P,updated:w}}function l(D,T){const{added:R,removed:I,updated:v}=L(D,T);return R.size===0&&I.size===0&&v.size===0}e.areSame=l}),define(ne[265],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(l,D,T,R){const I={added:[],removed:[],updated:[]};let v={added:[],removed:[],updated:[]};if(!D){const w=l.filter(({id:g})=>!R.includes(g));return w.length?v.added=w:v=null,{local:I,remote:v}}const P=L(l,D,R);if(P.added.length>0||P.removed.length>0||P.updated.length>0){const w=L(T,l,R),g=L(T,D,R);for(const h of g.removed){const m=l.find(y=>y.id===h);m&&I.removed.push(m)}for(const h of g.added){const m=D.find(y=>y.id===h);w.added.includes(h)?P.updated.includes(h)&&I.updated.push(m):I.added.push(m)}for(const h of g.updated)I.updated.push(D.find(m=>m.id===h));for(const h of w.added)g.added.includes(h)||v.added.push(l.find(m=>m.id===h));for(const h of w.updated)g.removed.includes(h)||g.updated.includes(h)||v.updated.push(l.find(m=>m.id===h));for(const h of w.removed){const m=D.find(y=>y.id===h);m&&v.removed.push(m)}}return v.added.length===0&&v.removed.length===0&&v.updated.length===0&&(v=null),{local:I,remote:v}}e.merge=k;function L(l,D,T){l=l?l.filter(({id:g})=>!T.includes(g)):[],D=D.filter(({id:g})=>!T.includes(g));const R=l.map(({id:g})=>g),I=D.map(({id:g})=>g),v=I.filter(g=>R.indexOf(g)===-1),P=R.filter(g=>I.indexOf(g)===-1),w=[];for(const{id:g,name:h,shortName:m}of l){if(P.includes(g))continue;const y=D.find(f=>f.id===g);(!y||y.name!==h||y.shortName!==m)&&w.push(g)}return{added:v,removed:P,updated:w}}}),define(ne[22],se([0,1,18,12,186,45,29,5,107,40]),function(Z,e,k,L,l,D,T,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function P(){const r=v.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(r).filter(o=>!!r[o].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=P;function w(){const r=v.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(r).filter(S=>!!r[S].ignoreSync),s=Object.keys(r).filter(S=>r[S].scope===2||r[S].scope===6),c=P();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...o,...s,...c])}e.getDefaultIgnoredSettings=w,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function g(){const r="vscode://schemas/ignoredSettings",o=v.Registry.as(D.Extensions.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,l.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,l.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,l.localize)(2,null),items:[{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,l.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,l.localize)(4,null),default:[],scope:1,$ref:r,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const s=v.Registry.as(I.Extensions.JSONContribution),c=()=>{const S=P(),E=w().filter(B=>B!==e.CONFIGURATION_SYNC_STORE_KEY),A=Object.keys(D.allSettings.properties).filter(B=>E.indexOf(B)===-1),N=E.filter(B=>S.indexOf(B)===-1),M={items:{type:"string",enum:[...A,...N.map(B=>`-${B}`)]}};s.registerSchema(r,M)};return o.onDidUpdateConfiguration(()=>c())}e.registerConfiguration=g;function h(r){return r&&(0,L.isObject)(r)&&(0,L.isString)(r.id)&&Array.isArray(r.scopes)}e.isAuthenticationProvider=h;var m;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState",r.Profiles="profiles"})(m=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(r,...o){return r?[r,...o]:o}e.getPathSegments=y;function f(r,o,s,c){return c.joinPath(s.userDataSyncHome,...y(r,o,`lastSync${o}.json`))}e.getLastSyncResourceUri=f,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,R.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(r){const o={};return o[e.HEADER_EXECUTION_ID]=r,o}e.createSyncHeaders=u;var d;(function(r){r.Unauthorized="Unauthorized",r.NotFound="NotFound",r.MethodNotFound="MethodNotFound",r.Conflict="Conflict",r.Gone="Gone",r.PreconditionFailed="PreconditionFailed",r.TooLarge="TooLarge",r.UpgradeRequired="UpgradeRequired",r.PreconditionRequired="PreconditionRequired",r.TooManyRequests="RemoteTooManyRequests",r.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",r.RequestFailed="RequestFailed",r.RequestCanceled="RequestCanceled",r.RequestTimeout="RequestTimeout",r.RequestProtocolNotSupported="RequestProtocolNotSupported",r.RequestPathNotEscaped="RequestPathNotEscaped",r.RequestHeadersNotObject="RequestHeadersNotObject",r.NoCollection="NoCollection",r.NoRef="NoRef",r.EmptyResponse="EmptyResponse",r.TurnedOff="TurnedOff",r.SessionExpired="SessionExpired",r.ServiceChanged="ServiceChanged",r.DefaultServiceChanged="DefaultServiceChanged",r.LocalTooManyProfiles="LocalTooManyProfiles",r.LocalTooManyRequests="LocalTooManyRequests",r.LocalPreconditionFailed="LocalPreconditionFailed",r.LocalInvalidContent="LocalInvalidContent",r.LocalError="LocalError",r.IncompatibleLocalContent="IncompatibleLocalContent",r.IncompatibleRemoteContent="IncompatibleRemoteContent",r.Unknown="Unknown"})(d=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class p extends Error{constructor(o,s,c,S){super(o),this.code=s,this.resource=c,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=p;class b extends p{constructor(o,s,c,S,E){super(o,c,void 0,E),this.url=s,this.serverCode=S}}e.UserDataSyncStoreError=b;class C extends p{constructor(o,s){super(o,s)}}e.UserDataAutoSyncError=C,function(r){function o(s){if(s instanceof r)return s;const c=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(s.name);if(c&&c[1]){const S=c[2]==="unknown"?void 0:c[2],E=c[3]==="unknown"?void 0:c[3];return new r(s.message,c[1],S,E)}return new r(s.message,"Unknown")}r.toUserDataSyncError=o}(p=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(r){r.Uninitialized="uninitialized",r.Idle="idle",r.Syncing="syncing",r.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var a;(function(r){r[r.None=0]="None",r[r.Added=1]="Added",r[r.Modified=2]="Modified",r[r.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var i;(function(r){r.Preview="preview",r.Conflict="conflict",r.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(r){return`sync.enable.${r}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSyncLog",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(ne[266],se([0,1,32,22]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function l(T,R,I,v,P){if(!R)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const w=D(T,R);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const g=I?D(I,R):{added:Object.keys(R).reduce((d,p)=>(d.add(p),d),new Set),removed:new Set,updated:new Set},h=I?D(I,T):{added:Object.keys(T).reduce((d,p)=>(d.add(p),d),new Set),removed:new Set,updated:new Set},m={added:{},removed:[],updated:{}},y=k.deepClone(R),f=!I;for(const d of h.added.values())d!==L.SYNC_SERVICE_URL_TYPE&&f&&g.added.has(d)||(y[d]=T[d]);for(const d of h.updated.values())y[d]=T[d];for(const d of h.removed.values())v.unregistered.includes(d)||delete y[d];for(const d of g.added.values()){const p=R[d];if(v.machine.includes(d)){P.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(I&&h.added.has(d))continue;const b=T[d];b&&b.value===p.value||d===L.SYNC_SERVICE_URL_TYPE&&f&&h.added.has(d)||(b?m.updated[d]=p:m.added[d]=p)}for(const d of g.updated.values()){const p=R[d];if(v.machine.includes(d)){P.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(d)||h.removed.has(d))continue;const b=T[d];b&&b.value===p.value||(m.updated[d]=p)}for(const d of g.removed.values()){if(v.machine.includes(d)){P.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}h.updated.has(d)||h.removed.has(d)||m.removed.push(d)}const u=D(R,y);return{local:m,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:y}}}e.merge=l;function D(T,R){const I=Object.keys(T),v=Object.keys(R),P=v.filter(h=>I.indexOf(h)===-1).reduce((h,m)=>(h.add(m),h),new Set),w=I.filter(h=>v.indexOf(h)===-1).reduce((h,m)=>(h.add(m),h),new Set),g=new Set;for(const h of I){if(w.has(h))continue;const m=T[h],y=R[h];k.equals(m,y)||g.add(h)}return{added:P,removed:w,updated:g}}}),define(ne[267],se([0,1,18,35,82,42,32,60,22]),function(Z,e,k,L,l,D,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function v(s,c,S){let E=[];S?E=w(S):E=P(c);const A=[],N=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(E))for(const M of E)M.startsWith("-")?N.push(M.substring(1)):A.push(M);return(0,k.distinct)([...s,...A].filter(M=>N.indexOf(M)===-1))}e.getIgnoredSettings=v;function P(s){let c=s.inspect("settingsSync.ignoredSettings").userValue;return c!==void 0||(c=s.inspect("sync.ignoredSettings").userValue,c!==void 0)?c:s.getValue("settingsSync.ignoredSettings")||[]}function w(s){const c=(0,L.parse)(s);return c?c["settingsSync.ignoredSettings"]||c["sync.ignoredSettings"]||[]:[]}function g(s,c){const S=(0,L.parse)(s)||{};let E="{}";for(const A of Object.keys(S)){const N=(0,l.setProperty)(E,[A],S[A],c);E=(0,l.applyEdits)(E,N)}return E}e.removeComments=g;function h(s,c,S,E){if(S.length){const A=o(c),N=(0,L.parse)(c)||{},M=(0,L.parse)(s);if(!M)return s;const B=[];for(const O of S){const j=N[O],q=M[O];j===void 0?s=R.edit(s,[O],void 0,E):q!==void 0?s=R.edit(s,[O],j,E):B.push(t(O,A))}B.sort((O,j)=>O.startOffset-j.startOffset),B.forEach(O=>s=d(O.setting.key,c,s,E))}return s}e.updateIgnoredSettings=h;function m(s,c,S,E,A,N){const M=h(s,c,E,N),B=S!==M,O=S!==c;if(!B&&!O)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(B&&!O)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(O&&!B)return{conflictsSettings:[],localContent:h(c,s,E,N),remoteContent:null,hasConflicts:!1};if(S===null&&f(s)){const z=y(s,c,E)?null:h(c,s,E,N);return{conflictsSettings:[],localContent:z,remoteContent:null,hasConflicts:!1}}let j=s,q=c;const K=(0,L.parse)(s),Q=(0,L.parse)(c),re=S?(0,L.parse)(S):null,J=E.reduce((z,V)=>(z.add(V),z),new Set),W=u(K,Q,J),F=u(re,K,J),G=u(re,Q,J),ee=new Map,oe=new Set,ae=z=>{oe.add(z);const V=A.filter(({key:_})=>_===z)[0];V?(j=R.edit(j,[z],V.value,N),q=R.edit(q,[z],V.value,N)):ee.set(z,{key:z,localValue:K[z],remoteValue:Q[z]})};for(const z of F.removed.values())G.updated.has(z)?ae(z):q=R.edit(q,[z],void 0,N);for(const z of G.removed.values())oe.has(z)||(F.updated.has(z)?ae(z):j=R.edit(j,[z],void 0,N));for(const z of F.updated.values())oe.has(z)||(G.updated.has(z)?W.updated.has(z)&&ae(z):q=R.edit(q,[z],K[z],N));for(const z of G.updated.values())oe.has(z)||(F.updated.has(z)?W.updated.has(z)&&ae(z):j=R.edit(j,[z],Q[z],N));for(const z of F.added.values())oe.has(z)||(G.added.has(z)?W.updated.has(z)&&ae(z):q=d(z,j,q,N));for(const z of G.added.values())oe.has(z)||(F.added.has(z)?W.updated.has(z)&&ae(z):j=d(z,q,j,N));const x=ee.size>0||!y(j,q,E),$=x||!y(j,s,[]),U=x||!y(q,c,[]);return{localContent:$?j:null,remoteContent:U?q:null,conflictsSettings:[...ee.values()],hasConflicts:x}}e.merge=m;function y(s,c,S){if(s===c)return!0;const E=(0,L.parse)(s),A=(0,L.parse)(c),N=S.reduce((O,j)=>(O.add(j),O),new Set),M=o(s).filter(O=>!(O.setting&&N.has(O.setting.key))),B=o(c).filter(O=>!(O.setting&&N.has(O.setting.key)));if(M.length!==B.length)return!1;for(let O=0;O<M.length;O++){const j=M[O],q=B[O];if(j.setting&&q.setting){if(j.setting.key!==q.setting.key||!T.equals(E[j.setting.key],A[j.setting.key]))return!1}else if(!j.setting&&!q.setting){if(j.value!==q.value)return!1}else return!1}return!0}function f(s){return s?o(s).length===0:!0}e.isEmpty=f;function u(s,c,S){const E=s?Object.keys(s).filter(O=>!S.has(O)):[],A=Object.keys(c).filter(O=>!S.has(O)),N=A.filter(O=>E.indexOf(O)===-1).reduce((O,j)=>(O.add(j),O),new Set),M=E.filter(O=>A.indexOf(O)===-1).reduce((O,j)=>(O.add(j),O),new Set),B=new Set;if(s)for(const O of E){if(M.has(O))continue;const j=s[O],q=c[O];T.equals(j,q)||B.add(O)}return{added:N,removed:M,updated:B}}function d(s,c,S,E){const A=(0,L.parse)(c),N=o(c),M=o(S),B=p(s,N,M);return b(S,s,A[s],B,M,E)}e.addSetting=d;function p(s,c,S){const E=c.findIndex(N=>N.setting?.key===s),A=c[E-1];if(A){if(A.setting){const M=t(A.setting.key,S);if(M)return{index:S.indexOf(M),insertAfter:!0}}else{const M=a(E,c);if(M){const B=t(M.setting.key,S);if(B){const O=i(S.indexOf(B),S),j=n(c,M,c[E]);if(O){const q=n(S,B,O),K=r(j,q);return K?{index:S.indexOf(K),insertAfter:!0}:{index:S.indexOf(O),insertAfter:!1}}else{const q=n(S,B,S[S.length-1]),K=r(j,q);return K?{index:S.indexOf(K),insertAfter:!0}:{index:S.length-1,insertAfter:!0}}}}}const N=c[E+1];if(N)if(N.setting){const M=t(N.setting.key,S);if(M)return{index:S.indexOf(M),insertAfter:!1}}else{const M=i(E,c);if(M){const B=t(M.setting.key,S);if(B){const O=a(S.indexOf(B),S),j=n(c,c[E],M);if(O){const q=n(S,O,B),K=r(j.reverse(),q.reverse());return K?{index:S.indexOf(K),insertAfter:!1}:{index:S.indexOf(O),insertAfter:!0}}else{const q=n(S,S[0],B),K=r(j.reverse(),q.reverse());return K?{index:S.indexOf(K),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:S.length-1,insertAfter:!0}}function b(s,c,S,E,A,N){let M;return E.index===-1?M=(0,l.setProperty)(s,[c],S,N):M=C(s,c,S,E,A,N).map(B=>(0,l.withFormatting)(s,B,N)[0]),(0,l.applyEdits)(s,M)}function C(s,c,S,E,A,N){const M=`${JSON.stringify(c)}: ${JSON.stringify(S)}`,B=(0,D.getEOL)(N,s),O=A[E.index];if(E.insertAfter){const j=[];if(O.setting)j.push({offset:O.endOffset,length:0,content:","+M});else{const q=i(E.index,A),K=a(E.index,A),Q=K?.setting?.commaOffset;K&&Q===void 0&&j.push({offset:K.endOffset,length:0,content:","});const re=Q!==void 0&&Q>O.endOffset;j.push({offset:re?Q+1:O.endOffset,length:0,content:q?B+M+",":B+M})}return j}else{if(O.setting)return[{offset:O.startOffset,length:0,content:M+","}];const j=(A[E.index-1]&&!A[E.index-1].setting?B:"")+M+(i(E.index,A)?",":"")+B;return[{offset:O.startOffset,length:0,content:j}]}}function t(s,c){return c.filter(S=>S.setting?.key===s)[0]}function a(s,c){for(let S=s-1;S>=0;S--)if(c[S].setting)return c[S]}function i(s,c){for(let S=s+1;S<c.length;S++)if(c[S].setting)return c[S]}function n(s,c,S){const E=s.indexOf(c),A=s.indexOf(S);return s.filter((N,M)=>E<M&&M<A)}function r(s,c){if(s.length&&c.length){let S=0;for(;S<c.length&&S<s.length;S++)if(s[S].value!==c[S].value)return c[S-1];return c[S-1]}}function o(s){const c=[];let S=-1,E,A;const N={onObjectBegin:M=>{S++},onObjectProperty:(M,B,O)=>{S===0&&(E=B,A=M)},onObjectEnd:(M,B)=>{S--,S===0&&c.push({startOffset:E,endOffset:M+B,value:s.substring(E,M+B),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(M,B)=>{S++},onArrayEnd:(M,B)=>{S--,S===0&&c.push({startOffset:E,endOffset:M+B,value:s.substring(E,M+B),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(M,B,O)=>{S===0&&c.push({startOffset:E,endOffset:B+O,value:s.substring(E,B+O),setting:{key:A,commaOffset:void 0}})},onSeparator:(M,B,O)=>{if(S===0&&M===","){let j=c.length-1;for(;j>=0&&!c[j].setting;j--);const q=c[j];q&&c.splice(j,1,{startOffset:q.startOffset,endOffset:q.endOffset,value:q.value,setting:{key:q.setting.key,commaOffset:B}})}},onComment:(M,B)=>{S===0&&c.push({startOffset:M,endOffset:M+B,value:s.substring(M,M+B)})}};return(0,L.visit)(s,N),c}}),define(ne[77],se([0,1,3,2,5,22]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,l.createDecorator)("IUserDataSyncAccountService");let T=class extends L.Disposable{get account(){return this.a}constructor(I,v){super(),this.g=I,this.h=v,this.b=this.B(new k.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new k.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(I.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(I.onTokenSucceed(()=>this.f=!1))}async updateAccount(I){(I&&this.a?I.token!==this.a.token||I.authenticationProviderId!==this.a.authenticationProviderId:I!==this.a)&&(this.a=I,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(I))}};T=ye([Y(0,D.IUserDataSyncStoreService),Y(1,D.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(ne[268],se([0,1,2,10]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class l{constructor(g){this.a=g}listen(g,h){switch(h){case"onError":return this.a.onError}throw new Error(`Event not found: ${h}`)}call(g,h,m){switch(h){case"triggerSync":return this.a.triggerSync(m[0],m[1],m[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(m[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=l;class D{constructor(g){this.a=g}listen(g,h){throw new Error(`Event not found: ${h}`)}call(g,h,m){switch(h){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(m[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(L.URI.revive(m[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=D;class T{constructor(g){this.a=g}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.a.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.a.call("resolveFormattingOptions",[g])}}e.UserDataSyncUtilServiceClient=T;class R{constructor(g){this.a=g}listen(g,h){switch(h){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${h}`)}async call(g,h,m){switch(h){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(m[0],m[1]);case"setEnablements":return this.a.setEnablements(m)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class I{constructor(g){this.a=g}listen(g,h){switch(h){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${h}`)}call(g,h,m){switch(h){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(m)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class v{constructor(g){this.a=g}listen(g,h){switch(h){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${h}`)}call(g,h,m){switch(h){case"switch":return this.a.switch(m[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=v;class P extends k.Disposable{constructor(g){super(),this.a=g,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.a.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.a.call("getPreviousUserDataSyncStore");return this.b(g)}b(g){return{url:L.URI.revive(g.url),type:g.type,defaultUrl:L.URI.revive(g.defaultUrl),insidersUrl:L.URI.revive(g.insidersUrl),stableUrl:L.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(ne[269],se([0,1,187,15,11,22]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let T=class extends l.AbstractLogger{constructor(I,v){super(),this.g=this.B(I.createLogger(v.userDataSyncLogResource,{id:D.USER_DATA_SYNC_LOG_ID,name:(0,k.localize)(0,null)}))}trace(I,...v){this.g.trace(I,...v)}debug(I,...v){this.g.debug(I,...v)}info(I,...v){this.g.info(I,...v)}warn(I,...v){this.g.warn(I,...v)}error(I,...v){this.g.error(I,...v)}flush(){this.g.flush()}};T=ye([Y(0,l.ILoggerService),Y(1,L.IEnvironmentService)],T),e.UserDataSyncLogService=T}),define(ne[270],se([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(ne[271],se([0,1,6,3,2]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class D extends l.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:I,getActiveWindowId:v}){super(),this.a=this.B(new l.DisposableStore),L.Event.latch(L.Event.any(R,I))(this.f,this,this.a),this.b=(0,k.createCancelablePromise)(()=>v()),(async()=>{try{const w=await this.b;this.c=typeof this.c=="number"?this.c:w}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=D}),define(ne[118],se([0,1,190,13,49,24,10,5,21]),function(Z,e,k,L,l,D,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function v(i){const n=i;return typeof n?.id=="string"&&T.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=v;function P(i){return typeof i?.id=="string"&&!v(i)&&!g(i)}e.isEmptyWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=w;function g(i){const n=i;return typeof n?.id=="string"&&T.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=g;function h(i){const n=i;if(n?.uri)return{id:n.id,uri:T.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:T.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=h;var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function y(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=y;function f(i){const n=i;return!!(n&&typeof n=="object"&&T.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=f;class u{constructor(n,r,o,s,c){this.h=n,this.j=o,this.k=s,this.l=c,this.c=l.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=l.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class d{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,D.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function p(i){return new d({uri:i,index:0,name:(0,D.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(i,n){return D.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=b;function C(i){let n;return T.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=C;function t(i,n){return!b(i,n)&&!C(i)}e.isSavedWorkspace=t;function a(i){return(typeof i=="string"?(0,L.extname)(i):(0,D.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=a}),define(ne[28],se([0,1,65,3,2,24,10,181,15,14,5,11,118,38,30,6,31,26,12]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function p(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&T.URI.isUri(n.location)&&T.URI.isUri(n.globalStorageHome)&&T.URI.isUri(n.settingsResource)&&T.URI.isUri(n.keybindingsResource)&&T.URI.isUri(n.tasksResource)&&T.URI.isUri(n.snippetsHome)&&T.URI.isUri(n.extensionsResource))}e.isUserDataProfile=p,e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function b(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:T.URI.revive(i.location).with({scheme:n}),globalStorageHome:T.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:T.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:T.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:T.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:T.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:T.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=b;function C(i,n,r,o){return{id:i,name:n,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,D.joinPath)(r,"globalStorage"),settingsResource:(0,D.joinPath)(r,"settings.json"),keybindingsResource:(0,D.joinPath)(r,"keybindings.json"),tasksResource:(0,D.joinPath)(r,"tasks.json"),snippetsHome:(0,D.joinPath)(r,"snippets"),extensionsResource:(0,D.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=C;let t=class extends l.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,r,o,s){super(),this.m=n,this.n=r,this.r=o,this.s=s,this.f=!0,this.g=this.B(new L.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new L.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new L.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new L.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new h.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,D.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)try{for(const c of this.I()){if(!c.name||!(0,d.isString)(c.name)||!c.location){this.s.warn("Skipping the invalid stored profile",c.location||c.name);continue}n.push(C((0,D.basename)(c.location),c.name,c.location,{shortName:c.shortName,useDefaultFlags:c.useDefaultFlags}))}}catch(c){this.s.error(c)}const r=new h.ResourceMap,o=new Map,s=this.v();if(n.unshift({...s,extensionsResource:this.N()??s.extensionsResource,isDefault:!0}),n.length)try{const c=this.L();if(c.workspaces)for(const[S,E]of Object.entries(c.workspaces)){const A=T.URI.parse(S),N=n.find(M=>M.id===E);N&&r.set(A,N)}if(c.emptyWindows)for(const[S,E]of Object.entries(c.emptyWindows)){const A=n.find(N=>N.id===E);A&&o.set(S,A)}}catch(c){this.s.error(c)}this.t={profiles:n,workspaces:r,emptyWindows:o}}return this.t}v(){return C("__default__profile__",(0,R.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(n){const r="Temp",o=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let s=0;for(const S of this.profiles){const E=o.exec(S.name),A=E?parseInt(E[1]):0;s=A>s?A:s}const c=`${r} ${s+1}`;return this.createProfile((0,k.hash)((0,f.generateUuid)()).toString(16),c,{transient:!0},n)}async createNamedProfile(n,r,o){return this.createProfile((0,k.hash)((0,f.generateUuid)()).toString(16),n,r,o)}async createProfile(n,r,o,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=await this.w(n,r,o);return s&&await this.setProfileForWorkspace(s,c),c}async w(n,r,o){if(!(0,d.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.k.get(r);return s||(s=(async()=>{try{const c=this.profiles.find(A=>A.name===r||A.id===n);if(c)return c;const S=C(n,r,(0,D.joinPath)(this.profilesHome,n),o);await this.n.createFolder(S.location);const E=[];return this.h.fire({profile:S,join(A){E.push(A)}}),await y.Promises.settled(E),this.C([S],[],[]),S}finally{this.k.delete(r)}})(),this.k.set(r,s)),s}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(s=>s.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);return o=C(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.C([],[],[o]),o}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(s=>s.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const o=[];this.i.fire({profile:r,join(s){o.push(s)}});try{await Promise.allSettled(o)}catch(s){this.s.error(s)}for(const s of[...this.u.emptyWindows.keys()])r.id===this.u.emptyWindows.get(s)?.id&&this.u.emptyWindows.delete(s);for(const s of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(s)?.id&&this.u.workspaces.delete(s);this.G(),this.C([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(s){this.s.error(s)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(s=>s.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.F(n,o)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(n,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.r.extUri.isEqual(o.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(r=>!this.z(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.y(n);return T.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindows.get(r)??this.u.emptyWindows.get(r)}y(n){return(0,g.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,g.isWorkspaceIdentifier)(n)?n.configPath:n.id}z(n){return!!([...this.l.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location)))}C(n,r,o){const s=[...this.profiles,...n],c=[];this.l.profiles=[];for(let S of s)S.isDefault||r.some(E=>S.id===E.id)||(S=o.find(E=>S.id===E.id)??S,S.isTransient?this.l.profiles.push(S):c.push({location:S.location,name:S.name,shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}));this.J(c),this.t=void 0,this.D(n,r,o)}D(n,r,o){this.g.fire({added:n,removed:r,updated:o,all:this.profiles})}F(n,r,o){o=r?.isTransient?!0:o,o||this.F(n,void 0,!0);const s=this.y(n),c=o?this.l:this.u;T.URI.isUri(s)?(c.workspaces.delete(s),r&&c.workspaces.set(s,r)):(c.emptyWindows.delete(s),r&&c.emptyWindows.set(s,r)),o||this.G()}G(){const n={};for(const[o,s]of this.u.workspaces.entries())n[o.toString()]=s.id;const r={};for(const[o,s]of this.u.emptyWindows.entries())r[o.toString()]=s.id;this.M({workspaces:n,emptyWindows:r}),this.t=void 0}H(n){const r={},o=this.v();if(n.workspaces)for(const[c,S]of Object.entries(n.workspaces)){const E=T.URI.parse(S);r[c]=this.r.extUri.isEqual(E,o.location)?o.id:this.r.extUri.basename(E)}const s={};if(n.emptyWindows)for(const[c,S]of Object.entries(n.emptyWindows)){const E=T.URI.parse(S);s[c]=this.r.extUri.isEqual(E,o.location)?o.id:this.r.extUri.basename(E)}return{workspaces:r,emptyWindows:s}}I(){return[]}J(n){throw new Error("not implemented")}L(){return{}}M(n){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=ye([Y(0,I.IEnvironmentService),Y(1,v.IFileService),Y(2,m.IUriIdentityService),Y(3,w.ILogService)],t),e.UserDataProfilesService=t;class a extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(n){this.a=n}L(){return this.Q}M(n){this.Q=n}}e.InMemoryUserDataProfilesService=a}),define(ne[272],se([0,1,6,2,28]),function(Z,e,k,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let D=class extends L.Disposable{constructor(R){super(),this.B(new k.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};D=ye([Y(0,l.IUserDataProfilesService)],D),e.UserDataProfilesCleaner=D}),define(ne[273],se([0,1,18,6,23,8,3,2,4,10,160,29,33,46,11,25,19,28]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var d;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(d=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let p=class extends R.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,r,o,s,c){super(),this.t=n,this.u=r,this.v=o,this.w=s,this.y=c,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new T.Emitter),this.m=this.B(new T.Emitter),this.n=this.B(new T.Emitter),this.p=this.B(new T.Emitter),this.s=[],this.B((0,R.toDisposable)(()=>{this.j.forEach(({task:S})=>S.cancel()),this.k.forEach(S=>S.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(o=>(0,w.isTargetPlatformCompatible)(o,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{if(!this.t.isEnabled())throw new w.ExtensionManagementError(P.localize(0,null),w.ExtensionManagementErrorCode.Internal);const o=await this.G(n,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(o.manifest,o.extension,r)}catch(o){throw t(this.u,"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(n),error:o}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(o),C(o)}}async uninstall(n,r={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,r,o){const s={...o,installOnlyNewlyAddedFromExtensionPack:v.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,h.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},c=B=>`${g.ExtensionKey.create(B).toString()}${s.profileLocation?`-${s.profileLocation.toString()}`:""}`;if(!v.URI.isUri(r)){const B=this.j.get(c(r));if(B)return this.v.info("Extensions is already requested to install",r.identifier.id),B.task.waitUntilTaskIsFinished()}const S=[],E=[],A=[],N=this.Q(n,r,s);v.URI.isUri(r)||this.j.set(c(r),{task:N,waitingTasks:[]}),this.l.fire({identifier:N.identifier,source:r,profileLocation:s.profileLocation}),this.v.info("Installing extension:",N.identifier.id),S.push({task:N,manifest:n});let M=!1;try{if(s.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",N.identifier.id);else try{const O=await this.F(N.identifier,n,!!s.installOnlyNewlyAddedFromExtensionPack,!!s.installPreReleaseVersion,s.profileLocation),j=await this.getInstalled(void 0,s.profileLocation);for(const{gallery:q,manifest:K}of(0,k.distinct)(O,({gallery:Q})=>Q.identifier.id)){M=M||!!K.extensionDependencies?.some(J=>(0,g.areSameExtensions)({id:J},N.identifier));const Q=c(q),re=this.j.get(Q);if(re){if(this.C(N,re.task)){const J=re.task.identifier;this.v.info("Waiting for already requested installing extension",J.id,N.identifier.id),re.waitingTasks.push(N),E.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,W=>W.some(F=>(0,g.areSameExtensions)(F.identifier,J)))).then(W=>{if(this.v.info("Finished waiting for already requested installing extension",J.id,N.identifier.id),!W.find(G=>(0,g.areSameExtensions)(G.identifier,J))?.local)throw new Error(`Extension ${J.id} is not installed`)}))}}else if(!j.some(({identifier:J})=>(0,g.areSameExtensions)(J,q.identifier))){const J=this.Q(K,q,{...s,donotIncludePackAndDependencies:!0});this.j.set(Q,{task:J,waitingTasks:[N]}),this.l.fire({identifier:J.identifier,source:q,profileLocation:s.profileLocation}),this.v.info("Installing extension:",J.identifier.id,N.identifier.id),S.push({task:J,manifest:K})}}}catch(O){if(v.URI.isUri(N.source))(0,k.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",N.identifier.id,O.message),(0,k.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",N.identifier.id,O.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",N.identifier.id),O}const B=S.reduce((O,{task:j,manifest:q})=>(O.set(j.identifier.id.toLowerCase(),{task:j,manifest:q}),O),new Map);for(;B.size;){let O;const j=[...B.values()].filter(({manifest:q})=>!q.extensionDependencies?.some(K=>B.has(K.toLowerCase())));j.length?O=B.size===1?j:j.filter(({task:q})=>!(q===N&&!M)):(this.v.info("Found extensions with circular dependencies",j.map(({task:q})=>q.identifier.id)),O=[...B.values()]),await this.D(O.map(async({task:q})=>{const K=new Date().getTime();try{const Q=await q.run();if(await this.D(this.s.map(re=>re.postInstall(Q,q.source,s,l.CancellationToken.None))),!v.URI.isUri(q.source)){const re=q.operation===3,J=re?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(t(this.u,re?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-K,durationSinceUpdate:J}),I.isWeb&&q.operation!==3)try{await this.t.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,"install")}catch{}}A.push({local:Q,identifier:q.identifier,operation:q.operation,source:q.source,context:s.context,profileLocation:s.profileLocation,applicationScoped:Q.isApplicationScoped})}catch(Q){throw v.URI.isUri(q.source)||t(this.u,q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-K,error:Q}),this.v.error("Error while installing the extension:",q.identifier.id),Q}finally{B.delete(q.identifier.id.toLowerCase())}}))}return E.length&&await this.D(E),A.forEach(({identifier:O})=>this.v.info("Extension installed successfully:",O.id)),this.m.fire(A),A.filter(({identifier:O})=>(0,g.areSameExtensions)(O,N.identifier))[0].local}catch(B){if(S.forEach(({task:O})=>O.cancel()),A.length)try{const O=await Promise.allSettled(A.map(({local:j})=>this.R(j,{versionOnly:!0,profileLocation:s.profileLocation}).run()));for(let j=0;j<O.length;j++){const q=O[j],{identifier:K}=A[j];q.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",K.id):this.v.warn("Rollback: Error while uninstalling extension",K.id,(0,D.getErrorMessage)(q.reason))}}catch(O){this.v.warn("Error while rolling back extensions",(0,D.getErrorMessage)(O),A.map(({identifier:j})=>j.id))}throw this.m.fire(S.map(({task:O})=>({identifier:O.identifier,operation:2,source:O.source,context:s.context,profileLocation:s.profileLocation}))),B}finally{for(const{task:B}of S)B.source&&!v.URI.isUri(B.source)&&this.j.delete(c(B.source))}}C(n,r){for(const[,{task:o,waitingTasks:s}]of this.j.entries())if(o===n&&(s.includes(r)||s.some(c=>this.C(c,r)))||o===r&&s[0]&&!this.C(n,s[0]))return!1;return!0}async D(n){const r=[],o=[],s=await Promise.allSettled(n);for(const c of s)c.status==="fulfilled"?r.push(c.value):o.push(c.reason);if(o.length)throw b(o);return r}async F(n,r,o,s,c){if(!this.t.isEnabled())return[];const S=await this.getInstalled(void 0,c),E=[],A=[],N=async(M,B)=>{E.push(M);const O=B.extensionDependencies||[],j=[...O];if(B.extensionPack){const q=o?S.find(K=>(0,g.areSameExtensions)(K.identifier,M)):void 0;for(const K of B.extensionPack)q&&q.manifest.extensionPack&&q.manifest.extensionPack.some(Q=>(0,g.areSameExtensions)({id:Q},{id:K}))||j.every(Q=>!(0,g.areSameExtensions)({id:Q},{id:K}))&&j.push(K)}if(j.length){const q=j.filter(K=>E.every(Q=>!(0,g.areSameExtensions)(Q,{id:K})));if(q.length){const K=await this.t.getExtensions(q.map(Q=>({id:Q,preRelease:s})),l.CancellationToken.None);for(const Q of K){if(E.find(W=>(0,g.areSameExtensions)(W,Q.identifier)))continue;const re=O.some(W=>(0,g.areSameExtensions)({id:W},Q.identifier));let J;try{J=await this.G(Q,!1,s)}catch(W){if(W instanceof w.ExtensionManagementError&&W.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!re){this.v.info("Skipping the packed extension as it cannot be installed",Q.identifier.id);continue}else throw W}A.push({gallery:J.extension,manifest:J.manifest}),await N(J.extension.identifier,J.manifest)}}}};return await N(n,r),A}async G(n,r,o){if((await this.getExtensionsControlManifest()).malicious.some(E=>(0,g.areSameExtensions)(n.identifier,E)))throw new w.ExtensionManagementError(P.localize(1,null,n.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const E=await this.getTargetPlatform();throw new w.ExtensionManagementError(P.localize(2,null,n.identifier.id,this.w.nameLong,(0,w.TargetPlatformToString)(E)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const c=await this.H(n,r,o);if(c){if(o&&!r&&n.hasPreReleaseVersion&&!c.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(P.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],l.CancellationToken.None))[0]?new w.ExtensionManagementError(P.localize(4,null,n.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(P.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",c.identifier.id);const S=await this.t.getManifest(c,l.CancellationToken.None);if(S===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(S.version!==c.version)throw new w.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:c,manifest:S}}async H(n,r,o){const s=await this.getTargetPlatform();let c=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==o&&(c=(await this.t.getExtensions([{...n.identifier,preRelease:o}],{targetPlatform:s,compatible:!0},l.CancellationToken.None))[0]||null),!c&&await this.t.isExtensionCompatible(n,o,s)&&(c=n),c||(r?c=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:s,compatible:!0},l.CancellationToken.None))[0]||null:c=await this.t.getCompatibleExtension(n,o,s)),c}async I(n,r){const o={...r,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},s=M=>`${M.id.toLowerCase()}${o.versionOnly?`-${n.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,c=this.k.get(s(n.identifier));if(c)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),c.waitUntilTaskIsFinished();const S=M=>{const B=this.R(M,o);return this.k.set(s(B.extension.identifier),B),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.n.fire({identifier:M.identifier,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped}),B},E=(M,B)=>{B?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString(),B.message):this.v.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,B.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,g.getLocalExtensionTelemetryData)(M),error:B}),this.p.fire({identifier:M.identifier,error:B?.code,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped})},A=[],N=[];try{A.push(S(n));const M=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const B=this.M(n,M);for(const O of B)this.k.has(s(O.identifier))?this.v.info("Extensions is already requested to uninstall",O.identifier.id):A.push(S(O))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(A.map(B=>B.extension),M,n),await this.D(A.map(async B=>{try{if(await B.run(),await this.D(this.s.map(O=>O.postUninstall(B.extension,o,l.CancellationToken.None))),B.extension.identifier.uuid)try{await this.t.reportStatistic(B.extension.manifest.publisher,B.extension.manifest.name,B.extension.manifest.version,"uninstall")}catch{}E(B.extension)}catch(O){const j=O instanceof w.ExtensionManagementError?O:new w.ExtensionManagementError((0,D.getErrorMessage)(O),w.ExtensionManagementErrorCode.Internal);throw E(B.extension,j),j}finally{N.push(B)}}))}catch(M){const B=M instanceof w.ExtensionManagementError?M:new w.ExtensionManagementError((0,D.getErrorMessage)(M),w.ExtensionManagementErrorCode.Internal);for(const O of A){try{O.cancel()}catch{}N.includes(O)||E(O.extension,B)}throw B}finally{for(const M of A)this.k.delete(s(M.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}J(n,r,o){for(const s of n){const c=this.N(s,r);if(c.length){const S=c.filter(E=>!n.some(A=>(0,g.areSameExtensions)(A.identifier,E.identifier)));if(S.length)throw new Error(this.L(s,S,o))}}}L(n,r,o){return o===n?r.length===1?P.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?P.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):P.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?P.localize(9,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?P.localize(10,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):P.localize(11,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(n,r,o=[]){if(o.indexOf(n)!==-1)return[];o.push(n);const s=n.manifest.extensionPack?n.manifest.extensionPack:[];if(s.length){const c=r.filter(E=>!E.isBuiltin&&s.some(A=>(0,g.areSameExtensions)({id:A},E.identifier))),S=[];for(const E of c)S.push(...this.M(E,r,o));return[...c,...S]}return[]}N(n,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(s=>(0,g.areSameExtensions)({id:s},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};p=ye([Y(0,w.IExtensionGalleryService),Y(1,f.ITelemetryService),Y(2,m.ILogService),Y(3,y.IProductService),Y(4,u.IUserDataProfilesService)],p),e.AbstractExtensionManagementService=p;function b(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=b;function C(i){if(i instanceof w.ExtensionManagementError)return i;const n=new w.ExtensionManagementError(i.message,w.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}function t(i,n,{extensionData:r,verificationStatus:o,duration:s,error:c,durationSinceUpdate:S}){let E,A;c&&(c instanceof w.ExtensionManagementError?(E=c.code,c.code===w.ExtensionManagementErrorCode.Signature&&(A=c.message)):E=w.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:o,success:!c,duration:s,errorcode:E,errorcodeDetail:A,durationSinceUpdate:S})}class a{constructor(){this.d=new L.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,L.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,L.createCancelablePromise)(n=>new Promise((r,o)=>{const s=n.onCancellationRequested(()=>{s.dispose(),o(new D.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=a}),define(ne[51],se([0,1,6,17,2,3,38,10,29,33,14,5,11,28,30,12,8,19]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class p extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=p,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let b=class extends l.Disposable{constructor(i,n,r,o,s,c){super(),this.i=i,this.j=n,this.k=r,this.l=o,this.m=s,this.n=c,this.b=this.B(new D.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new D.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new T.ResourceMap}scanProfileExtensions(i,n){return this.p(i,void 0,n)}async addExtensionsToProfile(i,n){const r=[],o=[];try{return await this.p(n,s=>{const c=[];for(const S of s)i.some(([E])=>(0,v.areSameExtensions)(E.identifier,S.identifier)&&E.manifest.version!==S.version)?r.push(S):c.push(S);for(const[S,E]of i)if(!c.some(A=>(0,v.areSameExtensions)(A.identifier,S.identifier)&&A.version===S.manifest.version)){const A={identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:E};o.push(A),c.push(A)}return o.length&&this.b.fire({extensions:o,profileLocation:n}),r.length&&this.f.fire({extensions:r,profileLocation:n}),c}),o.length&&this.c.fire({extensions:o,profileLocation:n}),r.length&&this.g.fire({extensions:r,profileLocation:n}),o}catch(s){throw o.length&&this.c.fire({extensions:o,error:s,profileLocation:n}),r.length&&this.g.fire({extensions:r,error:s,profileLocation:n}),s}}async updateMetadata(i,n){const r=[];return await this.p(n,o=>{const s=[];for(const c of o){const S=i.find(([E])=>(0,v.areSameExtensions)(E.identifier,c.identifier)&&E.manifest.version===c.version);S&&(c.metadata={...c.metadata,...S[1]},r.push(c)),s.push(c)}return s}),r}async removeExtensionFromProfile(i,n){const r=[];this.f.fire({extensions:r,profileLocation:n});try{await this.p(n,o=>{const s=[];for(const c of o)(0,v.areSameExtensions)(c.identifier,i.identifier)?r.push(c):s.push(c);return r.length&&this.f.fire({extensions:r,profileLocation:n}),s}),r.length&&this.g.fire({extensions:r,profileLocation:n})}catch(o){throw r.length&&this.g.fire({extensions:r,error:o,profileLocation:n}),o}}async p(i,n,r){return this.w(i).queue(async()=>{let o=[],s;try{const c=await this.j.readFile(i);s=JSON.parse(c.value.toString().trim()||"[]")}catch(c){if((0,P.toFileOperationResult)(c)!==1)throw c;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(s=await this.v()),!s&&r?.bailOutWhenFileNotFound)throw new p((0,f.getErrorMessage)(c),"ERROR_PROFILE_NOT_FOUND")}if(s){Array.isArray(s)||this.r(i);let c=!1;for(const S of s){C(S)||this.r(i);let E;if((0,y.isString)(S.relativeLocation)&&S.relativeLocation)E=this.t(S.relativeLocation);else if((0,y.isString)(S.location))E=this.t(S.location),c=!0,S.relativeLocation=S.location,S.location=E.toJSON();else{E=R.URI.revive(S.location);const A=this.s(E);A&&(c=!0,S.relativeLocation=A)}o.push({identifier:S.identifier,location:E,version:S.version,metadata:S.metadata})}c&&await this.j.writeFile(i,L.VSBuffer.fromString(JSON.stringify(s)))}if(n){o=n(o);const c=o.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),relativeLocation:this.s(S.location),metadata:S.metadata}));await this.j.writeFile(i,L.VSBuffer.fromString(JSON.stringify(c)))}return o})}r(i){const n=new p(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let r;try{r=(await this.j.readFile(i)).value.toString()}catch(s){if((0,P.toFileOperationResult)(s)===1)return;throw s}this.n.info("Migrating extensions from old default profile location",i.toString());let o;try{const s=JSON.parse(r);Array.isArray(s)&&s.every(c=>C(c))?o=s:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",s)}catch(s){this.n.error(s)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(s){if((0,P.toFileOperationResult)(s)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw s}try{await this.j.del(i)}catch(s){(0,P.toFileOperationResult)(s)!==1&&this.n.error(s)}try{await this.j.del(n)}catch(s){(0,P.toFileOperationResult)(s)!==1&&this.n.error(s)}return o})()),this.u}w(i){let n=this.h.get(i);return n||(n=new k.Queue,this.h.set(i,n)),n}};b=ye([Y(1,P.IFileService),Y(2,h.IUserDataProfilesService),Y(3,m.IUriIdentityService),Y(4,u.ITelemetryService),Y(5,g.ILogService)],b),e.AbstractExtensionsProfileScannerService=b;function C(a){return(0,y.isObject)(a)&&(0,I.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,y.isString)(a.location)&&a.location)&&((0,y.isUndefined)(a.relativeLocation)||(0,y.isString)(a.relativeLocation))&&a.version&&(0,y.isString)(a.version)}function t(a){return a?(0,y.isString)(a.path)&&(0,y.isString)(a.scheme):!1}}),define(ne[78],se([0,1,18,6,32,17,8,35,142,2,21,13,4,24,54,89,12,10,163,15,33,46,68,14,5,11,25,3,90,51,28,30,196,197]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u,d,p,b,C,t,a,i,n,r,o,s,c,S,E,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var M;(function(re){function J(W,F){if(W===F)return!0;const G=Object.keys(W),ee=new Set;for(const oe of Object.keys(F))ee.add(oe);if(G.length!==ee.size)return!1;for(const oe of G){if(W[oe]!==F[oe])return!1;ee.delete(oe)}return ee.size===0}re.equals=J})(M=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let B=class extends v.Disposable{constructor(J,W,F,G,ee,oe,ae,x,$,U,z,V){super(),this.systemExtensionsLocation=J,this.userExtensionsLocation=W,this.l=F,this.m=G,this.n=ee,this.p=oe,this.r=ae,this.s=x,this.t=$,this.u=U,this.v=z,this.w=V,this.g=this.B(new o.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(q,(0,h.joinPath)(this.m,C.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(q,(0,h.joinPath)(this.m,C.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(j,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,b.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(J,W,F){const[G,ee]=await Promise.all([this.scanSystemExtensions(J),this.scanUserExtensions(W)]),oe=F?await this.scanExtensionsUnderDevelopment(J,[...G,...ee]):[];return this.F(G,ee,oe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(J){const W=[];W.push(this.G(!!J.useCache,J.language)),W.push(this.H(J.language,!!J.checkControlFile));const[F,G]=await Promise.all(W);return this.D([...F,...G],0,J,!1)}async scanUserExtensions(J){const W=J.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",W);const F=this.v.extUri.isEqual(J.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,G=await this.J(W,!!J.profileLocation,1,!J.includeUninstalled,J.language,!0,F),ee=J.useCache&&!G.devMode&&G.excludeObsolete?this.j:this.k;let oe;try{oe=await ee.scanExtensions(G)}catch(ae){if(ae instanceof c.ExtensionsProfileScanningError&&ae.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),oe=await ee.scanExtensions(G);else throw ae}return oe=await this.D(oe,1,J,!0),this.s.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment(J,W){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const F=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(G=>G.scheme===P.Schemas.file).map(async G=>{const ee=await this.J(G,!1,1,!0,J.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(ee)).map(ae=>(ae.type=W.find(x=>(0,b.areSameExtensions)(x.identifier,ae.identifier))?.type??ae.type,this.k.validate(ae,ee)))}))).flat();return this.D(F,"development",J,!0)}return[]}async scanExistingExtension(J,W,F){const G=await this.J(J,!1,W,!0,F.language,!0,void 0),ee=await this.k.scanExtension(G);return!ee||!F.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(J,W,F){const G=await this.J(J,!1,W,!0,F.language,!0,void 0),ee=await this.k.scanOneOrMultipleExtensions(G);return this.D(ee,W,F,!0)}async scanMetadata(J){const W=(0,h.joinPath)(J,"package.json"),F=(await this.r.readFile(W)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(J,W){const F=(0,h.joinPath)(J,"package.json"),G=(await this.r.readFile(F)).value.toString(),ee=JSON.parse(G);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,ee.__metadata={...ee.__metadata,...W},await this.r.writeFile((0,h.joinPath)(J,"package.json"),D.VSBuffer.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(J){if(J instanceof c.ExtensionsProfileScanningError&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw J}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const J=await this.scanUserExtensions({includeInvalid:!0});if(J.length)await this.p.addExtensionsToProfile(J.map(W=>[W,W.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify([])))}catch(W){(0,a.toFileOperationResult)(W)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.getErrorMessage)(W))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(J){this.s.error(J)}finally{this.z=void 0}})()),this.z}async D(J,W,F,G){return F.includeAllVersions||(J=this.F(W===0?J:void 0,W===1?J:void 0,W==="development"?J:void 0,await this.getTargetPlatform(),G)),F.includeInvalid||(J=J.filter(ee=>ee.isValid)),J.sort((ee,oe)=>{const ae=w.basename(ee.location.fsPath),x=w.basename(oe.location.fsPath);return ae<x?-1:ae>x?1:0})}F(J,W,F,G,ee){const oe=(x,$,U)=>{if(x.isValid&&!$.isValid)return!1;if(x.isValid===$.isValid){if(ee&&m.gt(x.manifest.version,$.manifest.version))return this.s.debug(`Skipping extension ${$.location.path} with lower version ${$.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(m.eq(x.manifest.version,$.manifest.version)){if(x.type===0)return this.s.debug(`Skipping extension ${$.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===G)return this.s.debug(`Skipping extension ${$.location.path} from different target platform ${$.targetPlatform}`),!1}}return U?this.s.warn(`Overwriting user extension ${x.location.path} with ${$.location.path}.`):this.s.debug(`Overwriting user extension ${x.location.path} with ${$.location.path}.`),!0},ae=new Map;return J?.forEach(x=>{const $=C.ExtensionIdentifier.toKey(x.identifier.id),U=ae.get($);(!U||oe(U,x,!1))&&ae.set($,x)}),W?.forEach(x=>{const $=C.ExtensionIdentifier.toKey(x.identifier.id),U=ae.get($);if(!U&&J&&x.type===0){this.s.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!U||oe(U,x,!1))&&ae.set($,x)}),F?.forEach(x=>{const $=C.ExtensionIdentifier.toKey(x.identifier.id),U=ae.get($);(!U||oe(U,x,!0))&&ae.set($,x),ae.set($,x)}),[...ae.values()]}async G(J,W){this.s.trace("Started scanning system extensions");const F=await this.J(this.systemExtensionsLocation,!1,0,!0,W,!0,void 0),ee=await(J&&!F.devMode?this.i:this.k).scanExtensions(F);return this.s.trace("Scanned system extensions:",ee.length),ee}async H(J,W){const F=this.t.isBuilt?[]:this.u.builtInExtensions;if(!F?.length)return[];this.s.trace("Started scanning dev system extensions");const G=W?await this.I():{},ee=[],oe=u.URI.file(w.normalize(w.join(P.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const x of F){const $=G[x.name]||"marketplace";switch($){case"disabled":break;case"marketplace":ee.push((0,h.joinPath)(oe,x.name));break;default:ee.push(u.URI.file($));break}}const ae=await Promise.all(ee.map(async x=>this.k.scanExtension(await this.J(x,!1,0,!0,J,!0,void 0))));return this.s.trace("Scanned dev system extensions:",ae.length),(0,k.coalesce)(ae)}async I(){try{const J=await this.r.readFile(this.l);return JSON.parse(J.value.toString())}catch{return{}}}async J(J,W,F,G,ee,oe,ae){const x=await this.f(ee??g.language),$=await this.L(J),U=W&&!this.v.extUri.isEqual(J,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,z=U?await this.L(U):void 0;return new O(J,$,U,z,W,ae,F,G,oe,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,ee,x)}async L(J){try{const W=await this.r.stat(J);if(typeof W.mtime=="number")return W.mtime}catch{}}};B=ye([Y(4,S.IUserDataProfilesService),Y(5,c.IExtensionsProfileScannerService),Y(6,a.IFileService),Y(7,n.ILogService),Y(8,p.IEnvironmentService),Y(9,r.IProductService),Y(10,E.IUriIdentityService),Y(11,i.IInstantiationService)],B),e.AbstractExtensionsScannerService=B;class O{constructor(J,W,F,G,ee,oe,ae,x,$,U,z,V,_,H,X){this.location=J,this.mtime=W,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=G,this.profile=ee,this.profileScanOptions=oe,this.type=ae,this.excludeObsolete=x,this.validate=$,this.productVersion=U,this.productDate=z,this.productCommit=V,this.devMode=_,this.language=H,this.translations=X}static createNlsConfiguration(J){return{language:J.language,pseudo:J.language==="pseudo",devMode:J.devMode,translations:J.translations}}static equals(J,W){return(0,h.isEqual)(J.location,W.location)&&J.mtime===W.mtime&&(0,h.isEqual)(J.applicationExtensionslocation,W.applicationExtensionslocation)&&J.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&J.profile===W.profile&&l.equals(J.profileScanOptions,W.profileScanOptions)&&J.type===W.type&&J.excludeObsolete===W.excludeObsolete&&J.validate===W.validate&&J.productVersion===W.productVersion&&J.productDate===W.productDate&&J.productCommit===W.productCommit&&J.devMode===W.devMode&&J.language===W.language&&M.equals(J.translations,W.translations)}}e.ExtensionScannerInput=O;let j=class extends v.Disposable{constructor(J,W,F,G,ee){super(),this.f=J,this.g=W,this.h=F,this.i=G,this.j=ee}async scanExtensions(J){const W=J.profile?await this.l(J):await this.k(J);let F={};if(J.excludeObsolete&&J.type===1)try{const G=(await this.i.readFile(this.f)).value.toString();F=JSON.parse(G)}catch{}return(0,f.isEmptyObject)(F)?W:W.filter(G=>!F[b.ExtensionKey.create(G).toString()])}async k(J){const W=await this.i.resolve(J.location);if(!W.children?.length)return[];const F=await Promise.all(W.children.map(async G=>{if(!G.isDirectory||J.type===1&&(0,h.basename)(G.resource).indexOf(".")===0)return null;const ee=new O(G.resource,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(ee)}));return(0,k.coalesce)(F).sort((G,ee)=>G.location.path<ee.location.path?-1:1)}async l(J){let W=await this.m(J.location,()=>!0,J);if(J.applicationExtensionslocation&&!this.h.extUri.isEqual(J.location,J.applicationExtensionslocation)){W=W.filter(G=>!G.metadata?.isApplicationScoped);const F=await this.m(J.applicationExtensionslocation,G=>!!G.metadata?.isApplicationScoped,J);W.push(...F)}return W}async m(J,W,F){const G=await this.g.scanProfileExtensions(J,F.profileScanOptions);if(!G.length)return[];const ee=await Promise.all(G.map(async oe=>{if(W(oe)){const ae=new O(oe.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.profileScanOptions,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(ae,oe.metadata)}return null}));return(0,k.coalesce)(ee)}async scanOneOrMultipleExtensions(J){try{if(await this.i.exists((0,h.joinPath)(J.location,"package.json"))){const W=await this.scanExtension(J);return W?[W]:[]}else return await this.scanExtensions(J)}catch(W){return this.j.error(`Error scanning extensions at ${J.location.path}:`,(0,T.getErrorMessage)(W)),[]}}async scanExtension(J,W){try{let F=await this.scanExtensionManifest(J.location);if(F){F.publisher||(F.publisher=C.UNDEFINED_PUBLISHER),W=W??F.__metadata,delete F.__metadata;const G=(0,b.getGalleryExtensionId)(F.publisher,F.name),ee=W?.id?{id:G,uuid:W.id}:{id:G},oe=W?.isSystem?0:J.type,ae=oe===0||!!W?.isBuiltin;N.ImplicitActivationEvents.updateManifest(F),F=await this.n(J.location,F,O.createNlsConfiguration(J));const x={type:oe,identifier:ee,manifest:F,location:J.location,isBuiltin:ae,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return J.validate?this.validate(x,J):x}}catch(F){J.type!==0&&this.j.error(F)}return null}validate(J,W){let F=!0;const G=(0,t.validateExtensionManifest)(W.productVersion,W.productDate,W.location,J.manifest,J.isBuiltin);for(const[ee,oe]of G)ee===y.default.Error&&(F=!1,this.j.error(this.t(W.location,oe)));return J.isValid=F,J.validations=G,J}async scanExtensionManifest(J){const W=(0,h.joinPath)(J,"package.json");let F;try{F=(await this.i.readFile(W)).value.toString()}catch(ee){return(0,a.toFileOperationResult)(ee)!==1&&this.j.error(this.t(J,(0,d.localize)(0,null,W.path,ee.message))),null}let G;try{G=JSON.parse(F)}catch{const oe=[];(0,R.parse)(F,oe);for(const ae of oe)this.j.error(this.t(J,(0,d.localize)(1,null,W.path,ae.offset,ae.length,(0,I.getParseErrorMessage)(ae.error))));return null}return(0,R.getNodeType)(G)!=="object"?(this.j.error(this.t(J,(0,d.localize)(2,null,W.path))),null):G}async n(J,W,F){const G=await this.p(J,W,F);if(G)try{const ee=[],oe=await this.r(G.default,ee);if(ee.length>0)return ee.forEach(x=>{this.j.error(this.t(J,(0,d.localize)(3,null,G.default?.path,(0,I.getParseErrorMessage)(x.error))))}),W;if((0,R.getNodeType)(G)!=="object")return this.j.error(this.t(J,(0,d.localize)(4,null,G.default?.path))),W;const ae=G.values||Object.create(null);return(0,A.localizeManifest)(W,ae,oe)}catch{}return W}async p(J,W,F){const G=(0,h.joinPath)(J,"package.nls.json"),ee=($,U)=>{U.forEach(z=>{this.j.error(this.t(J,(0,d.localize)(5,null,$?.path,(0,I.getParseErrorMessage)(z.error))))})},oe=$=>{this.j.error(this.t(J,(0,d.localize)(6,null,$?.path)))},ae=`${W.publisher}.${W.name}`,x=F.translations[ae];if(x)try{const $=u.URI.file(x),U=(await this.i.readFile($)).value.toString(),z=[],V=(0,R.parse)(U,z);return z.length>0?(ee($,z),{values:void 0,default:G}):(0,R.getNodeType)(V)!=="object"?(oe($),{values:void 0,default:G}):{values:V.contents?V.contents.package:void 0,default:G}}catch{return{values:void 0,default:G}}else{if(!await this.i.exists(G))return;let U;try{U=await this.s(J,F)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const z=(await this.i.readFile(U.localized)).value.toString(),V=[],_=(0,R.parse)(z,V);return V.length>0?(ee(U.localized,V),{values:void 0,default:U.original}):(0,R.getNodeType)(_)!=="object"?(oe(U.localized),{values:void 0,default:U.original}):{values:_,default:U.original}}catch{return{values:void 0,default:U.original}}}}async r(J,W){if(J)try{const F=(await this.i.readFile(J)).value.toString();return(0,R.parse)(F,W)}catch{}}s(J,W){return new Promise((F,G)=>{const ee=oe=>{const ae=(0,h.joinPath)(J,`package.nls.${oe}.json`);this.i.exists(ae).then(x=>{x&&F({localized:ae,original:(0,h.joinPath)(J,"package.nls.json")});const $=oe.lastIndexOf("-");$===-1?F({localized:(0,h.joinPath)(J,"package.nls.json"),original:null}):(oe=oe.substring(0,$),ee(oe))})};if(W.devMode||W.pseudo||!W.language)return F({localized:(0,h.joinPath)(J,"package.nls.json"),original:null});ee(W.language)})}t(J,W){return`[${J.path}]: ${W}`}};j=ye([Y(1,c.IExtensionsProfileScannerService),Y(2,E.IUriIdentityService),Y(3,a.IFileService),Y(4,n.ILogService)],j);let q=class extends j{constructor(J,W,F,G,ee,oe){super(W,F,G,ee,oe),this.y=J,this.v=this.B(new L.ThrottledDelayer(3e3)),this.w=this.B(new o.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(J){const W=await this.z();if(this.u=J,W&&W.input&&O.equals(W.input,this.u))return this.j.debug("Using cached extensions scan result",J.location.toString()),this.v.trigger(()=>this.D()),W.result.map(G=>(G.location=u.URI.revive(G.location),G));const F=await super.scanExtensions(J);return await this.C({input:J,result:F}),F}async z(){try{const J=await this.i.readFile(this.y),W=JSON.parse(J.value.toString());return{result:W.result,input:(0,s.revive)(W.input)}}catch(J){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,T.getErrorMessage)(J))}return null}async C(J){try{await this.i.writeFile(this.y,D.VSBuffer.fromString(JSON.stringify(J)))}catch(W){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,T.getErrorMessage)(W))}}async D(){if(!this.u)return;const J=await this.z();if(!J)return;const W=J.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!l.equals(F,W))try{await this.i.del(this.y),this.w.fire()}catch(G){this.j.error(G)}}};q=ye([Y(2,c.IExtensionsProfileScannerService),Y(3,E.IUriIdentityService),Y(4,a.IFileService),Y(5,n.ILogService)],q);function K(re,J){const W=(0,b.getExtensionId)(re.manifest.publisher,re.manifest.name);return{id:W,identifier:new C.ExtensionIdentifier(W),isBuiltin:re.type===0,isUserBuiltin:re.type===1&&re.isBuiltin,isUnderDevelopment:J,extensionLocation:re.location,uuid:re.identifier.uuid,targetPlatform:re.targetPlatform,...re.manifest}}e.toExtensionDescription=K;class Q extends B{constructor(J,W,F,G,ee,oe,ae,x,$,U,z,V){super(J,W,(0,h.joinPath)(F,".vscode-oss-dev","extensions","control.json"),(0,h.joinPath)(G,C.MANIFEST_CACHE_FOLDER),ee,oe,ae,x,$,U,z,V),this.M=(async()=>{if(g.translationsConfigFile)try{const _=await this.r.readFile(u.URI.file(g.translationsConfigFile));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(J){return this.M}}e.NativeExtensionsScannerService=Q}),define(ne[274],se([0,1,11,28,30,19,51,14,15,10]),function(Z,e,k,L,l,D,T,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let P=class extends T.AbstractExtensionsProfileScannerService{constructor(g,h,m,y,f,u){super(v.URI.file(g.extensionsPath),h,m,y,f,u)}};P=ye([Y(0,I.INativeEnvironmentService),Y(1,R.IFileService),Y(2,L.IUserDataProfilesService),Y(3,l.IUriIdentityService),Y(4,D.ITelemetryService),Y(5,k.ILogService)],P),e.ExtensionsProfileScannerService=P}),define(ne[275],se([0,1,50,6,39,3,2,21,13,27,11,28]),function(Z,e,k,L,l,D,T,R,I,v,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends T.Disposable{constructor(m,y){super(),this.b=m,this.f=y,this.a=new L.Limiter(5)}async postUninstall(m){const y=this.g(m,"uninstall");y&&(this.f.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,m),this.f.info("Finished running post uninstall script",m.identifier.id,m.manifest.version)}catch(f){this.f.error("Failed to run post uninstall script",m.identifier.id,m.manifest.version),this.f.error(f)}}));try{await v.Promises.rm(this.j(m))}catch(f){this.f.error("Error while removing extension storage path",m.identifier.id),this.f.error(f)}}g(m,y){const f=`vscode:${y}`;if(m.location.scheme===R.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[f]=="string"){const u=m.manifest.scripts[f].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(m.identifier.id,m.manifest.version,`${f} should be a node script`),null):{script:(0,I.join)(m.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(m,y,f,u,d){return new Promise((p,b)=>{const C=this.i(m,y,f,d);let t;const a=i=>{t&&(clearTimeout(t),t=null),i?b(i):p(void 0)};C.on("error",i=>{a((0,l.toErrorMessage)(i)||"Unknown")}),C.on("exit",(i,n)=>{a(i?`post-${y} process exited with code ${i}`:void 0)}),u&&(t=setTimeout(()=>{t=null,C.kill(),b("timed out")},5e3))})}i(m,y,f,u){const d={silent:!0,execArgv:void 0},p=(0,k.fork)(m,[`--type=extension-post-${y}`,...f],d);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const b=D.Event.fromNodeEventEmitter(p.stdout,"data"),C=D.Event.fromNodeEventEmitter(p.stderr,"data");b(i=>this.f.info(u.identifier.id,u.manifest.version,`post-${y}`,i)),C(i=>this.f.error(u.identifier.id,u.manifest.version,`post-${y}`,i));const t=D.Event.any(D.Event.map(b,i=>({data:`%c${i}`,format:[""]})),D.Event.map(C,i=>({data:`%c${i}`,format:["color: red"]})));return D.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(u.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),p}j(m){return(0,I.join)(this.b.defaultProfile.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};g=ye([Y(0,w.IUserDataProfilesService),Y(1,P.ILogService)],g),e.ExtensionsLifecycle=g}),define(ne[276],se([0,1,10,15,51,78,14,5,11,25,30,28]),function(Z,e,k,L,l,D,T,R,I,v,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=class extends D.NativeExtensionsScannerService{constructor(m,y,f,u,d,p,b,C){super(k.URI.file(d.builtinExtensionsPath),k.URI.file(d.extensionsPath),d.userHome,k.URI.file(d.userDataPath),m,y,f,u,d,p,b,C)}};g=ye([Y(0,w.IUserDataProfilesService),Y(1,l.IExtensionsProfileScannerService),Y(2,T.IFileService),Y(3,I.ILogService),Y(4,L.INativeEnvironmentService),Y(5,v.IProductService),Y(6,P.IUriIdentityService),Y(7,R.IInstantiationService)],g),e.ExtensionsScannerService=g}),define(ne[20],se([0,1,6,3,2,103,12,67,5,28]),function(Z,e,k,L,l,D,T,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var P;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var g;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));function h(d){const p=d.get(e.TARGET_KEY);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}e.loadKeyTargets=h;class m extends l.Disposable{constructor(p={flushInterval:m.a}){super(),this.j=p,this.b=this.B(new L.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new L.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new k.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new l.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,k.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,l.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.J()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(p,b){if(b===e.TARGET_KEY){switch(p){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:p})}else this.b.fire({scope:p,key:b,target:this.F(p)[b]})}r(p){this.f.fire({reason:p})}get(p,b,C){return this.L(b)?.get(p,C)}getBoolean(p,b,C){return this.L(b)?.getBoolean(p,C)}getNumber(p,b,C){return this.L(b)?.getNumber(p,C)}store(p,b,C,t){if((0,T.isUndefinedOrNull)(b)){this.remove(p,C);return}this.t(()=>{this.u(p,C,t),this.L(C)?.set(p,b)})}remove(p,b){this.t(()=>{this.u(p,b,void 0),this.L(b)?.delete(p)})}t(p){this.b.pause(),this.c.pause();try{p()}finally{this.b.resume(),this.c.resume()}}keys(p,b){const C=[],t=this.F(p);for(const a of Object.keys(t))t[a]===b&&C.push(a);return C}u(p,b,C){const t=this.F(b);typeof C=="number"?t[p]!==C&&(t[p]=C,this.L(b)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[p]=="number"&&(delete t[p],this.L(b)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(p){switch(p){case-1:return this.D;case 0:return this.z;default:return this.w}}G(p){const b=this.L(p);return b?h(b):Object.create(null)}isNew(p){return this.getBoolean(e.IS_NEW_KEY,p)===!0}async flush(p=P.NONE){this.f.fire({reason:p});const b=this.L(-1),C=this.L(0),t=this.L(1);switch(p){case P.NONE:await k.Promises.settled([b?.whenFlushed()??Promise.resolve(),C?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await k.Promises.settled([b?.flush(0)??Promise.resolve(),C?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const p=this.L(-1)?.items??new Map,b=this.L(0)?.items??new Map,C=this.L(1)?.items??new Map;return u(p,b,C,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(p,b){return this.r(P.NONE),(0,v.isUserDataProfile)(p)?this.N(p,b):this.O(p,b)}H(p,b){return!(p.id===b.id||y(b)&&y(p))}I(p,b,C,t){this.t(()=>{if(t)for(const[a,i]of p)b.set(a,i);else{const a=new Set;for(const[i,n]of p)a.add(i),b.get(i)!==n&&this.n(C,i);for(const[i]of b.items)a.has(i)||this.n(C,i)}})}}m.a=60*1e3,e.AbstractStorageService=m;function y(d){return d.isDefault||!!d.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=y;class f extends m{constructor(){super(),this.p=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(p=>this.n(1,p))),this.B(this.P.onDidChangeStorage(p=>this.n(0,p))),this.B(this.p.onDidChangeStorage(p=>this.n(-1,p)))}L(p){switch(p){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(p){switch(p){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(p){return!1}}e.InMemoryStorageService=f;async function u(d,p,b,C,t,a){const i=N=>{try{return JSON.parse(N)}catch{return N}},n=new Map,r=new Map;d.forEach((N,M)=>{n.set(M,N),r.set(M,i(N))});const o=new Map,s=new Map;p.forEach((N,M)=>{o.set(M,N),s.set(M,i(N))});const c=new Map,S=new Map;b.forEach((N,M)=>{c.set(M,N),S.set(M,i(N))}),console.group(C!==t?`Storage: Application (path: ${C})`:`Storage: Application & Profile (path: ${C}, default profile)`);const E=[];if(n.forEach((N,M)=>{E.push({key:M,value:N})}),console.table(E),console.groupEnd(),console.log(r),C!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const N=[];o.forEach((M,B)=>{N.push({key:B,value:M})}),console.table(N),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${a})`);const A=[];c.forEach((N,M)=>{A.push({key:M,value:N})}),console.table(A),console.groupEnd(),console.log(S)}e.logStorage=u}),define(ne[119],se([0,1,3,2,12,29,33,20]),function(Z,e,k,L,l,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends L.Disposable{constructor(w,g){super(),this.a=new k.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new v(w)),this.B(this.b.onDidChange(h=>this.a.fire({extensions:h,source:"storage"}))),this.B(g.onDidInstallExtensions(h=>h.forEach(({local:m,operation:y})=>{m&&y===4&&this.f(m.identifier)})))}async enableExtension(w,g){return this.f(w)?(this.a.fire({extensions:[w],source:g}),!0):!1}async disableExtension(w,g){return this.c(w)?(this.a.fire({extensions:[w],source:g}),!0):!1}getDisabledExtensions(){return this.h(D.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(w){const g=this.getDisabledExtensions();return g.every(h=>!(0,T.areSameExtensions)(h,w))?(g.push(w),this.g(g),!0):!1}f(w){const g=this.getDisabledExtensions();for(let h=0;h<g.length;h++){const m=g[h];if((0,T.areSameExtensions)(m,w))return g.splice(h,1),this.g(g),!0}return!1}g(w){this.i(D.DISABLED_EXTENSIONS_STORAGE_PATH,w)}h(w){return this.b.get(w,0)}i(w,g){this.b.set(w,g,0)}};I=ye([Y(0,R.IStorageService),Y(1,D.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class v extends L.Disposable{constructor(w){super(),this.c=w,this.a=Object.create(null),this.b=this.B(new k.Emitter),this.onDidChange=this.b.event,this.B(w.onDidChangeValue(g=>this.f(g)))}get(w,g){let h;return g===0?((0,l.isUndefinedOrNull)(this.a[w])&&(this.a[w]=this.g(w,g)),h=this.a[w]):h=this.g(w,g),JSON.parse(h)}set(w,g,h){const m=JSON.stringify(g.map(({id:f,uuid:u})=>({id:f,uuid:u})));this.g(w,h)!==m&&(h===0&&(g.length?this.a[w]=m:delete this.a[w]),this.h(w,g.length?m:void 0,h))}f(w){if(w.scope===0&&!(0,l.isUndefinedOrNull)(this.a[w.key])&&this.g(w.key,w.scope)!==this.a[w.key]){const h=this.get(w.key,w.scope);delete this.a[w.key];const m=this.get(w.key,w.scope),y=h.filter(u=>!m.some(d=>(0,T.areSameExtensions)(u,d))),f=m.filter(u=>!h.some(d=>(0,T.areSameExtensions)(d,u)));(y.length||f.length)&&this.b.fire([...y,...f])}}g(w,g){return this.c.get(w,g,"[]")}h(w,g,h){g?this.c.store(w,g,h,1):this.c.remove(w,h)}}e.StorageManager=v}),define(ne[277],se([0,1,18,23,8,4,36,12,10,16,15,29,33,68,14,11,25,59,244,20,19]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u,d,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const C=D.isWeb?"web":(0,w.getTargetPlatform)(D.platform,T.arch),t="X-Market-Search-Activity-Id";var a;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished",$[$.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(a||(a={}));function i(...$){return String($.reduce((U,z)=>U|z,0))}var n;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},c={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class S{constructor(U=c){this.d=U}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(U,z=this.d.pageSize){return new S({...this.d,pageNumber:U,pageSize:z})}withFilter(U,...z){const V=[...this.d.criteria,...z.length?z.map(_=>({filterType:U,value:_})):[{filterType:U}]];return new S({...this.d,criteria:V})}withSortBy(U){return new S({...this.d,sortBy:U})}withSortOrder(U){return new S({...this.d,sortOrder:U})}withFlags(...U){return new S({...this.d,flags:U.reduce((z,V)=>z|V,0)})}withAssetTypes(...U){return new S({...this.d,assetTypes:U})}withSource(U){return new S({...this.d,source:U})}get raw(){const{criteria:U,pageNumber:z,pageSize:V,sortBy:_,sortOrder:H,flags:X,assetTypes:te}=this.d;return{filters:[{criteria:U,pageNumber:z,pageSize:V,sortBy:_,sortOrder:H}],assetTypes:te,flags:X}}get searchText(){const U=this.d.criteria.filter(z=>z.filterType===n.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(U=>String(U.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function E($,U){const z=($||[]).filter(V=>V.statisticName===U)[0];return z?z.value:0}function A($){const U="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(V=>V.assetType.indexOf(U)===0).reduce((V,_)=>{const H=B($,_.assetType);return H&&V.push([_.assetType.substring(U.length),H]),V},[])}function N($){if($.properties){const U=$.properties.filter(_=>_.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=U.filter(_=>z.test(_.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return B($,r.Repository)}function M($){return{uri:`${$.fallbackAssetUri}/${r.VSIX}?redirect=true${$.targetPlatform?`&targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${r.VSIX}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}}function B($,U){return $.files.filter(V=>V.assetType===U)[0]?{uri:`${$.assetUri}/${U}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${U}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}:null}function O($,U){const z=$.properties?$.properties.filter(_=>_.key===U):[],V=z.length>0&&z[0].value;return V?V.split(",").map(_=>(0,g.adoptToGalleryExtensionId)(_)):[]}function j($){const U=$.properties?$.properties.filter(z=>z.key===o.Engine):[];return U.length>0&&U[0].value||""}function q($){const U=$.properties?$.properties.filter(z=>z.key===o.PreRelease):[];return U.length>0&&U[0].value==="true"}function K($){const U=$.properties?$.properties.filter(V=>V.key===o.LocalizedLanguages):[],z=U.length>0&&U[0].value||"";return z?z.split(","):[]}function Q($){return $.properties?.find(U=>U.key===o.SponsorLink)?.value}function re($){return $.indexOf("preview")!==-1}function J($){return $.targetPlatform?(0,w.toTargetPlatform)($.targetPlatform):"undefined"}function W($){const U=(0,k.distinct)($.versions.map(J)),z=!!$.tags?.includes(w.WEB_EXTENSION_TAG),V=U.indexOf("web");return z?V===-1&&U.push("web"):V!==-1&&U.splice(V,1),U}function F($,U){const z=(0,w.getFallbackTargetPlarforms)(U);for(let V=0;V<$.length;V++){const _=$[V];if(_.version===$[V-1]?.version){let H=V;const X=J(_);if(X===U)for(;H>0&&$[H-1].version===_.version;)H--;else if(z.includes(X))for(;H>0&&$[H-1].version===_.version&&J($[H-1])!==U;)H--;H!==V&&($.splice(V,1),$.splice(H,0,_))}}return $}e.sortExtensionVersions=F;function G($,U,z){$.telemetryData={index:U,querySource:z,queryActivityId:$.queryContext?.[t]}}function ee($,U,z,V){const _=$.versions[0],H={manifest:B(U,r.Manifest),readme:B(U,r.Details),changelog:B(U,r.Changelog),license:B(U,r.License),repository:N(U),download:M(U),icon:B(U,r.Icon),signature:B(U,r.Signature),coreTranslations:A(U)};return{identifier:{id:(0,g.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:U.version,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,publisherDomain:$.publisher.domain?{link:$.publisher.domain,verified:!!$.publisher.isDomainVerified}:void 0,publisherSponsorLink:Q(_),description:$.shortDescription||"",installCount:E($.statistics,"install"),rating:E($.statistics,"averagerating"),ratingCount:E($.statistics,"ratingcount"),categories:$.categories||[],tags:$.tags||[],releaseDate:Date.parse($.releaseDate),lastUpdated:Date.parse($.lastUpdated),allTargetPlatforms:z,assets:H,properties:{dependencies:O(U,o.Dependency),extensionPack:O(U,o.ExtensionPack),engine:j(U),localizedLanguages:K(U),targetPlatform:J(U),isPreReleaseVersion:q(U)},hasPreReleaseVersion:q(_),hasReleaseVersion:!0,preview:re($.flags),isSigned:!!H.signature,queryContext:V}}let oe=class{constructor(U,z,V,_,H,X,te,le){this.k=z,this.l=V,this.n=_,this.o=H,this.q=X,this.u=te,this.w=le;const he=te.extensionsGallery,me=he?.servicePPEUrl&&le.getValue("_extensionsGallery.enablePPE");this.d=me?he.servicePPEUrl:he?.serviceUrl,this.g=me?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,d.resolveMarketplaceHeaders)(te.version,te,this.n,this.w,this.q,U,this.o)}x(U=""){return`${this.d}${U}`}isEnabled(){return!!this.d}async getExtensions(U,z,V){const _=L.CancellationToken.isCancellationToken(z)?{}:z,H=L.CancellationToken.isCancellationToken(z)?z:V,X=[],te=[],le=[],he=[];let me=!0;for(const Ce of U){Ce.uuid?te.push(Ce.uuid):X.push(Ce.id);const De=!!(Ce.version||Ce.preRelease);le.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:De}),Ce.version&&he.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),me=me&&!!Ce.hasPreRelease&&!De}if(!te.length&&!X.length)return[];let pe=new S().withPage(1,U.length);te.length&&(pe=pe.withFilter(n.ExtensionId,...te)),X.length&&(pe=pe.withFilter(n.ExtensionName,...X)),(_.queryAllVersions||me)&&(pe=pe.withFlags(pe.flags,a.IncludeVersions)),_.source&&(pe=pe.withSource(_.source));const{extensions:Se}=await this.z(pe,{targetPlatform:_.targetPlatform??C,includePreRelease:le,versions:he,compatible:!!_.compatible},H);return _.source&&Se.forEach((Ce,De)=>G(Ce,De,_.source)),Se}async getCompatibleExtension(U,z,V){if((0,w.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,V))return null;if(await this.isExtensionCompatible(U,z,V))return U;const _=new S().withFlags(a.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,U.identifier.uuid),{extensions:H}=await this.z(_,{targetPlatform:V,compatible:!0,includePreRelease:z},L.CancellationToken.None);return H[0]||null}async isExtensionCompatible(U,z,V){if(!(0,w.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,V)||!z&&U.properties.isPreReleaseVersion)return!1;let _=U.properties.engine;if(!_){const H=await this.getManifest(U,L.CancellationToken.None);if(!H)throw new Error("Manifest was not found");_=H.engines.vscode}return(0,h.isEngineValid)(_,this.u.version,this.u.date)}async y(U,z,V,_,H){if(!(0,w.isTargetPlatformCompatible)(J(U),_,H)||z!=="any"&&q(U)!==(z==="prerelease"))return!1;if(V)try{const X=await this.E(U);if(!(0,h.isEngineValid)(X,this.u.version,this.u.date))return!1}catch(X){return this.l.error(`Error while getting the engine for the version ${U.version}.`,(0,l.getErrorMessage)(X)),!1}return!0}async query(U,z){let V=U.text||"";const _=U.pageSize??50;let H=new S().withPage(1,_);V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,pe,Se)=>(H=H.withFilter(n.Category,Se||pe),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,pe,Se)=>(H=H.withFilter(n.Tag,Se||pe),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(n.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),H=H.withFilter(n.SearchText,V)),H=H.withSortBy(0)):U.ids?H=H.withFilter(n.ExtensionId,...U.ids):U.names?H=H.withFilter(n.ExtensionName,...U.names):H=H.withSortBy(4),typeof U.sortBy=="number"&&(H=H.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(H=H.withSortOrder(U.sortOrder)),U.source&&(H=H.withSource(U.source));const X=async(me,pe)=>{const{extensions:Se,total:Ce}=await this.z(me,{targetPlatform:C,compatible:!1,includePreRelease:!!U.includePreRelease},pe);return Se.forEach((De,ke)=>G(De,(me.pageNumber-1)*me.pageSize+ke,U.source)),{extensions:Se,total:Ce}},{extensions:te,total:le}=await X(H,z),he=async(me,pe)=>{if(pe.isCancellationRequested)throw new l.CancellationError;const{extensions:Se}=await X(H.withPage(me+1),pe);return Se};return{firstPage:te,total:le,pageSize:H.pageSize,getPage:he}}async z(U,z,V){const _=U.flags;!!(U.flags&a.IncludeLatestVersionOnly)&&!!(U.flags&a.IncludeVersions)&&(U=U.withFlags(U.flags&~a.IncludeVersions,a.IncludeLatestVersionOnly)),!(U.flags&a.IncludeLatestVersionOnly)&&!(U.flags&a.IncludeVersions)&&(U=U.withFlags(U.flags,a.IncludeLatestVersionOnly)),z.versions?.length&&(U=U.withFlags(U.flags&~a.IncludeLatestVersionOnly,a.IncludeVersions)),U=U.withFlags(U.flags,a.IncludeAssetUri,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeStatistics,a.IncludeVersionProperties);const{galleryExtensions:H,total:X,context:te}=await this.B(U,V);if(!(U.flags&a.IncludeLatestVersionOnly)){const pe=[];for(const Se of H){const Ce=await this.A(Se,z,te);Ce&&pe.push(Ce)}return{extensions:pe,total:X}}const he=[],me=new Map;for(let pe=0;pe<H.length;pe++){const Se=H[pe],Ce={id:(0,g.getGalleryExtensionId)(Se.publisher.publisherName,Se.extensionName),uuid:Se.extensionId},De=(0,R.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(qe=>(0,g.areSameExtensions)(qe,Ce))?.includePreRelease;if(z.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(W(Se),z.targetPlatform))continue;const ke=await this.A(Se,z,te);!ke||ke.properties.isPreReleaseVersion&&(!De||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==z.targetPlatform&&ke.hasPreReleaseVersion?me.set(Se.extensionId,pe):he.push([pe,ke])}if(me.size){const pe=new Date().getTime(),Se=new S().withFlags(_&~a.IncludeLatestVersionOnly,a.IncludeVersions).withPage(1,me.size).withFilter(n.ExtensionId,...me.keys()),{extensions:Ce}=await this.z(Se,z,V);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-pe,count:me.size});for(const De of Ce){const ke=me.get(De.identifier.uuid);he.push([ke,De])}}return{extensions:he.sort((pe,Se)=>pe[0]-Se[0]).map(([,pe])=>pe),total:X}}async A(U,z,V){const _={id:(0,g.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},H=z.versions?.find(he=>(0,g.areSameExtensions)(he,_))?.version,X=(0,R.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(he=>(0,g.areSameExtensions)(he,_))?.includePreRelease,te=W(U),le=F(U.versions,z.targetPlatform);if(z.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(te,z.targetPlatform))return null;for(let he=0;he<le.length;he++){const me=le[he];if(!(H&&me.version!==H)){if(await this.y(me,X?"any":"release",z.compatible,te,z.targetPlatform))return ee(U,me,te,V);if(H&&me.version===H)return null}}return H||z.compatible?null:ee(U,U.versions[0],te)}async B(U,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,a.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(a.Unpublished));const V=await this.j,_=JSON.stringify(U.raw),H={...V,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(_.length)},X=new Date().getTime();let te,le,he=0;try{if(te=await this.k.request({type:"POST",url:this.g&&U.criteria.some(pe=>pe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:_,headers:H},z),te.res.statusCode&&te.res.statusCode>=400&&te.res.statusCode<500)return{galleryExtensions:[],total:he};const me=await(0,u.asJson)(te);if(me){const pe=me.results[0],Se=pe.extensions,Ce=pe.resultMetadata&&pe.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return he=Ce&&Ce.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:he,context:{[t]:te.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(me){throw le=me,me}finally{this.o.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(_.length),duration:new Date().getTime()-X,success:!!te&&(0,u.isSuccess)(te),responseBodySize:te?.res.headers["Content-Length"],statusCode:te?String(te.res.statusCode):void 0,errorCode:le?(0,l.isCancellationError)(le)?"canceled":(0,l.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(U,z,V,_){if(!this.isEnabled())return;const H=D.isWeb?this.x(`/itemName/${U}.${z}/version/${V}/statType/${_==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${U}/extensions/${z}/${V}/stats?statType=${_}`),X=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",le={...await this.j,Accept:X};try{await this.k.request({type:"POST",url:H,headers:le},L.CancellationToken.None)}catch{}}async download(U,z,V){this.l.trace("ExtensionGalleryService#download",U.identifier.id);const _=(0,g.getGalleryExtensionTelemetryData)(U),H=new Date().getTime(),X=pe=>this.o.publicLog("galleryService:downloadVSIX",{..._,duration:pe}),te=V===2?"install":V===3?"update":"",le=te?{uri:`${U.assets.download.uri}${I.URI.parse(U.assets.download.uri).query?"&":"?"}${te}=true`,fallbackUri:`${U.assets.download.fallbackUri}${I.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${te}=true`}:U.assets.download,he=U.queryContext?.[t]?{[t]:U.queryContext[t]}:void 0,me=await this.D(le,he?{headers:he}:void 0);await this.q.writeFile(z,me.stream),X(new Date().getTime()-H)}async downloadSignatureArchive(U,z){if(!U.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const V=await this.D(U.assets.signature);await this.q.writeFile(z,V.stream)}async getReadme(U,z){if(U.assets.readme){const V=await this.D(U.assets.readme,{},z);return await(0,u.asTextOrError)(V)||""}return""}async getManifest(U,z){if(U.assets.manifest){const V=await this.D(U.assets.manifest,{},z),_=await(0,u.asTextOrError)(V);return _?JSON.parse(_):null}return null}async C(U,z){const V=B(U,r.Manifest);if(!V)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},H=await this.D(V,{headers:_});return await(0,u.asJson)(H)}async getCoreTranslation(U,z){const V=U.assets.coreTranslations.filter(_=>_[0]===z.toUpperCase())[0];if(V){const _=await this.D(V[1]),H=await(0,u.asTextOrError)(_);return H?JSON.parse(H):null}return null}async getChangelog(U,z){if(U.assets.changelog){const V=await this.D(U.assets.changelog,{},z);return await(0,u.asTextOrError)(V)||""}return""}async getAllCompatibleVersions(U,z,V){let _=new S().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?_=_.withFilter(n.ExtensionId,U.identifier.uuid):_=_.withFilter(n.ExtensionName,U.identifier.id);const{galleryExtensions:H}=await this.B(_,L.CancellationToken.None);if(!H.length)return[];const X=W(H[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(X,V))return[];const te=[];await Promise.all(H[0].versions.map(async me=>{try{await this.y(me,z?"any":"release",!0,X,V)&&te.push(me)}catch{}}));const le=[],he=new Set;for(const me of F(te,V))he.has(me.version)||(he.add(me.version),le.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:q(me)}));return le}async D(U,z={},V=L.CancellationToken.None){const _=await this.j,H={type:"GET"},X={..._,...z.headers||{}};z={...z,...H,headers:X};const te=U.uri,le=U.fallbackUri,he={...z,url:te};try{const me=await this.k.request(he,V);if(me.res.statusCode===200)return me;const pe=await(0,u.asTextOrError)(me);throw new Error(`Expected 200, got back ${me.res.statusCode} instead.

${pe}`)}catch(me){if((0,l.isCancellationError)(me))throw me;const pe=(0,l.getErrorMessage)(me);this.o.publicLog2("galleryService:cdnFallback",{url:te,message:pe});const Se={...z,url:le};return this.k.request(Se,V)}}async E(U){let z=j(U);if(!z){const V=await this.C(U,L.CancellationToken.None);if(!V)throw new Error("Manifest was not found");z=V.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const U=await this.k.request({type:"GET",url:this.h},L.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,u.asJson)(U),V=[],_={};if(z){for(const H of z.malicious)V.push({id:H});if(z.migrateToPreRelease)for(const[H,X]of Object.entries(z.migrateToPreRelease))(!X.engine||(0,h.isEngineValid)(X.engine,this.u.version,this.u.date))&&(_[H.toLowerCase()]={disallowInstall:!0,extension:{id:X.id,displayName:X.displayName,autoMigrate:{storage:!!X.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[H,X]of Object.entries(z.deprecated))X&&(_[H.toLowerCase()]=(0,R.isBoolean)(X)?{}:X)}return{malicious:V,deprecated:_}}};oe=ye([Y(1,u.IRequestService),Y(2,y.ILogService),Y(3,P.IEnvironmentService),Y(4,b.ITelemetryService),Y(5,m.IFileService),Y(6,f.IProductService),Y(7,v.IConfigurationService)],oe);let ae=class extends oe{constructor(U,z,V,_,H,X,te,le){super(U,z,V,_,H,X,te,le)}};ae=ye([Y(0,p.IStorageService),Y(1,u.IRequestService),Y(2,y.ILogService),Y(3,P.IEnvironmentService),Y(4,b.ITelemetryService),Y(5,m.IFileService),Y(6,f.IProductService),Y(7,v.IConfigurationService)],ae),e.ExtensionGalleryService=ae;let x=class extends oe{constructor(U,z,V,_,H,X,te){super(void 0,U,z,V,_,H,X,te)}};x=ye([Y(0,u.IRequestService),Y(1,y.ILogService),Y(2,P.IEnvironmentService),Y(3,b.ITelemetryService),Y(4,m.IFileService),Y(5,f.IProductService),Y(6,v.IConfigurationService)],x),e.ExtensionGalleryServiceWithNoStorageService=x}),define(ne[79],se([0,1,5,3,2,20,33,25,18,11,12]),function(Z,e,k,L,l,D,T,R,I,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let g=class Xe extends l.Disposable{static b(m){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(m.id)}@${m.version}`}static c(m){const y=w.exec(m);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(m,y){const f=await m.getInstalled(),u=[];for(const[d,p]of Xe.f(y)){const b=f.find(C=>(0,T.areSameExtensions)(C.identifier,{id:d}))?.manifest.version;for(const C of p)b!==C&&u.push(Xe.b({id:d,version:C}))}for(const d of u)y.remove(d,0)}static f(m){const y=new Map,f=m.keys(0,1);for(const u of f){const d=Xe.c(u);if(d){let p=y.get(d.id.toLowerCase());p||y.set(d.id.toLowerCase(),p=[]),p.push(d.version)}}return y}constructor(m,y,f){super(),this.i=m,this.j=y,this.k=f,this.g=this.B(new L.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Xe.f(m),this.B(this.i.onDidChangeValue(u=>this.l(u)))}l(m){if(m.scope!==0)return;if(this.h.has(m.key.toLowerCase())){this.g.fire();return}const y=Xe.c(m.key);if(y){if(this.i.get(m.key,0)===void 0)this.h.delete(y.id.toLowerCase());else{let f=this.h.get(y.id.toLowerCase());f||this.h.set(y.id.toLowerCase(),f=[]),f.push(y.version),this.g.fire()}return}}m(m){if((0,P.isString)(m))return m;const y=m.manifest?m.manifest.publisher:m.publisher,f=m.manifest?m.manifest.name:m.name;return(0,T.getExtensionId)(y,f)}getExtensionState(m,y){const f=this.m(m),u=this.getExtensionStateRaw(m,y);if(u)try{return JSON.parse(u)}catch(d){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${y}): ${d}`)}}getExtensionStateRaw(m,y){const f=this.m(m),u=this.i.get(f,y?0:1);return u&&u?.length>Xe.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${y}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(m,y,f){const u=this.m(m);y===void 0?this.i.remove(u,f?0:1):this.i.store(u,JSON.stringify(y),f?0:1,1)}setKeysForSync(m,y){this.i.store(Xe.b(m),JSON.stringify(y),0,1)}getKeysForSync(m){const y=this.j.extensionSyncedKeys?.[m.id.toLowerCase()],f=this.i.get(Xe.b(m),0),u=f?JSON.parse(f):void 0;return u&&y?(0,I.distinct)([...u,...y]):u||y}addToMigrationList(m,y){if(m!==y){const f=this.n.filter(u=>!u.includes(m)&&!u.includes(y));f.push([m,y]),this.n=f}}getSourceExtensionToMigrate(m){const y=this.n.find(([,f])=>m===f);return y?y[0]:void 0}get n(){const m=this.i.get("extensionStorage.migrationList",-1,"[]");try{const y=JSON.parse(m);if(Array.isArray(y))return y}catch{}return[]}set n(m){m.length?this.i.store("extensionStorage.migrationList",JSON.stringify(m),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};g.a=512*1024,g=ye([Y(0,D.IStorageService),Y(1,R.IProductService),Y(2,v.ILogService)],g),e.ExtensionStorageService=g}),define(ne[278],se([0,1,18,6,3,13,4,36,10,164,15,29,33,220,100,14,57,25,20,19]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const b="extensionTips/promptedExecutableTips",C="extensionTips/lastPromptedMediumImpExeTime";let t=class extends h.ExtensionTipsService{constructor(i,n,r,o,s,c,S,E){super(S,E),this.m=i,this.n=n,this.p=r,this.r=o,this.s=s,this.t=c,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,E.exeBasedExtensionTips&&Object.entries(E.exeBasedExtensionTips).forEach(([A,N])=>{const M=[],B=[],O=[];Object.entries(N.recommendations).forEach(([j,q])=>{q.important?N.important?M.push({extensionId:j,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):B.push({extensionId:j,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):O.push({extensionId:j,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),M.length&&this.g.set(A,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:M}),B.length&&this.h.set(A,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:B}),O.length&&this.j.set(A,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:O})}),(0,L.timeout)(3e3).then(async()=>{await this.u(),this.w(),this.y()})}async getImportantExecutableBasedTips(){const i=await this.I(this.g),n=await this.I(this.h);return[...i,...n]}getOtherExecutableBasedTips(){return this.I(this.j)}async u(){const i=await this.I(this.g),n=await this.I(this.h),r=await this.p.getInstalled();this.k=this.v(i,r),this.l=this.v(n,r)}v(i,n){const r=new Map;i.forEach(E=>r.set(E.extensionId.toLowerCase(),E));const{installed:o,uninstalled:s}=this.H([...r.keys()],n);for(const E of o){const A=r.get(E);A&&this.n.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:E,exeName:A.exeName})}for(const E of s){const A=r.get(E);A&&this.n.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:E,exeName:A.exeName})}const c=this.F(),S=new Map;for(const E of s){const A=r.get(E);if(A&&(!c[A.exeName]||!c[A.exeName].includes(A.extensionId))){let N=S.get(A.exeName);N||(N=[],S.set(A.exeName,N)),N.push(A)}}return S}w(){if(this.k.size===0)return;const[i,n]=[...this.k.entries()][0];this.z(n).then(r=>{switch(r){case"reacted":this.G(n[0].exeName,n);break;case"ignored":this.k.delete(i);break;case"incompatibleWindow":{const o=l.Event.once(l.Event.latch(l.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(o(()=>this.w()));break}case"toomany":{const o=this.B((0,L.disposableTimeout)(()=>{o.dispose(),this.w()},36e5));break}}})}y(){if(this.l.size===0)return;const i=this.C(),n=Date.now()-i,r=7*24*60*60*1e3;if(n<r){const c=this.B((0,L.disposableTimeout)(()=>{c.dispose(),this.y()},r-n));return}const[o,s]=[...this.l.entries()][0];this.z(s).then(c=>{switch(c){case"reacted":{this.D(Date.now()),this.l.delete(o),this.G(s[0].exeName,s);const S=this.B((0,L.disposableTimeout)(()=>{S.dispose(),this.y()},r));break}case"ignored":this.l.delete(o),this.y();break;case"incompatibleWindow":{const S=l.Event.once(l.Event.latch(l.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(S(()=>this.y()));break}case"toomany":{const S=this.B((0,L.disposableTimeout)(()=>{S.dispose(),this.y()},36e5));break}}})}async z(i){const n=await this.p.getInstalled(1),r=i.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(c=>n.every(S=>!(0,g.areSameExtensions)(S.identifier,{id:c})))).map(({extensionId:s})=>s.toLowerCase()),o=(0,v.localize)(0,null,i[0].exeFriendlyName);return this.t.promptImportantExtensionsInstallNotification(r,o,`@exe:"${i[0].exeName}"`,3)}C(){let i=this.r.getNumber(C,-1);return i||(i=Date.now(),this.D(i)),i}D(i){this.r.store(C,i,-1,1)}F(){return JSON.parse(this.r.get(b,-1,"{}"))}G(i,n){const r=this.F();r[i]=n.map(({extensionId:o})=>o.toLowerCase()),this.r.store(b,JSON.stringify(r),-1,0)}H(i,n){const r=[],o=[],s=n.reduce((c,S)=>(c.add(S.identifier.id.toLowerCase()),c),new Set);return i.forEach(c=>{s.has(c.toLowerCase())?r.push(c):o.push(c)}),{installed:r,uninstalled:o}}async I(i){const n=[],r=new Map;for(const o of i.keys()){const s=i.get(o);if(!s||!(0,k.isNonEmptyArray)(s.recommendations))continue;const c=[];T.isWindows?s.windowsPath&&c.push(s.windowsPath.replace("%USERPROFILE%",()=>R.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>R.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>R.env.ProgramFiles).replace("%APPDATA%",()=>R.env.APPDATA).replace("%WINDIR%",()=>R.env.WINDIR)):(c.push((0,D.join)("/usr/local/bin",o)),c.push((0,D.join)("/usr/bin",o)),c.push((0,D.join)(this.m.userHome.fsPath,o)));for(const S of c){let E=r.get(S);if(E===void 0&&(E=await this.b.exists(I.URI.file(S)),r.set(S,E)),E)for(const{extensionId:A,extensionName:N,isExtensionPack:M,whenNotInstalled:B}of s.recommendations)n.push({extensionId:A,extensionName:N,isExtensionPack:M,exeName:o,exeFriendlyName:s.exeFriendlyName,windowsPath:s.windowsPath,whenNotInstalled:B})}}return n}};t=ye([Y(0,P.INativeEnvironmentService),Y(1,p.ITelemetryService),Y(2,w.IExtensionManagementService),Y(3,d.IStorageService),Y(4,f.INativeHostService),Y(5,m.IExtensionRecommendationNotificationService),Y(6,y.IFileService),Y(7,u.IProductService)],t),e.ExtensionTipsService=t}),define(ne[279],se([0,1,6,2,24,67,20,75,28]),function(Z,e,k,L,l,D,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class v extends T.AbstractStorageService{constructor(w,g,h,m){super(),this.X=w,this.Y=g,this.Z=h,this.ab=m,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new L.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new L.DisposableStore),this.W=this.db(this.X)}bb(){const w=this.B(new R.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),g=this.B(new D.Storage(w));return this.B(g.onDidChangeStorage(h=>this.n(-1,h))),g}cb(w){this.Q.clear(),this.P=w;let g;if((0,T.isProfileUsingDefaultStorage)(w))g=this.s;else{const h=this.Q.add(new R.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),w));g=this.Q.add(new D.Storage(h))}return this.Q.add(g.onDidChangeStorage(h=>this.n(0,h))),g}db(w){this.U.clear(),this.S=w?.id;let g;if(w){const h=this.U.add(new R.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),w));g=this.U.add(new D.Storage(h)),this.U.add(g.onDidChangeStorage(m=>this.n(1,m)))}return g}async J(){await k.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(w){switch(w){case-1:return this.s;case 0:return this.R;default:return this.W}}M(w){switch(w){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,l.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(T.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(w,g){if(!this.H(this.P,w))return;const h=this.R,m=h.items;h!==this.s&&await h.close(),this.R=this.cb(w),await this.R.init(),this.I(m,this.R,0,g)}async O(w,g){const h=this.W,m=h?.items??new Map;await h?.close(),this.W=this.db(w),await this.W.init(),this.I(m,this.W,1,g)}hasScope(w){return(0,I.isUserDataProfile)(w)?this.P.id===w.id:this.S===w.id}}e.NativeStorageService=v}),define(ne[280],se([0,1,3,2,28,92]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class T{constructor(v,P){this.a=v,this.b=P}listen(v,P){const w=this.b(v);switch(P){case"onDidChangeProfiles":return k.Event.map(this.a.onDidChangeProfiles,g=>({all:g.all.map(h=>(0,D.transformOutgoingURIs)({...h},w)),added:g.added.map(h=>(0,D.transformOutgoingURIs)({...h},w)),removed:g.removed.map(h=>(0,D.transformOutgoingURIs)({...h},w)),updated:g.updated.map(h=>(0,D.transformOutgoingURIs)({...h},w))}))}throw new Error(`Invalid listen ${P}`)}async call(v,P,w){const g=this.b(v);switch(P){case"createProfile":{const h=await this.a.createProfile(w[0],w[1],w[2]);return(0,D.transformOutgoingURIs)({...h},g)}case"updateProfile":{let h=(0,l.reviveProfile)((0,D.transformIncomingURIs)(w[0],g),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,w[1]),(0,D.transformOutgoingURIs)({...h},g)}case"removeProfile":{const h=(0,l.reviveProfile)((0,D.transformIncomingURIs)(w[0],g),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${P}`)}}e.RemoteUserDataProfilesServiceChannel=T;class R extends L.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(v,P,w){super(),this.profilesHome=P,this.f=w,this.a=[],this.b=this.B(new k.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=v.map(g=>(0,l.reviveProfile)(g,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(g=>{const h=g.added.map(f=>(0,l.reviveProfile)(f,this.profilesHome.scheme)),m=g.removed.map(f=>(0,l.reviveProfile)(f,this.profilesHome.scheme)),y=g.updated.map(f=>(0,l.reviveProfile)(f,this.profilesHome.scheme));this.a=g.all.map(f=>(0,l.reviveProfile)(f,this.profilesHome.scheme)),this.b.fire({added:h,removed:m,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(v){this.c=v}isEnabled(){return this.c}async createNamedProfile(v,P,w){const g=await this.f.call("createNamedProfile",[v,P,w]);return(0,l.reviveProfile)(g,this.profilesHome.scheme)}async createProfile(v,P,w,g){const h=await this.f.call("createProfile",[v,P,w,g]);return(0,l.reviveProfile)(h,this.profilesHome.scheme)}async createTransientProfile(v){const P=await this.f.call("createTransientProfile",[v]);return(0,l.reviveProfile)(P,this.profilesHome.scheme)}async setProfileForWorkspace(v,P){await this.f.call("setProfileForWorkspace",[v,P])}removeProfile(v){return this.f.call("removeProfile",[v])}async updateProfile(v,P){const w=await this.f.call("updateProfile",[v,P]);return(0,l.reviveProfile)(w,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=R}),define(ne[61],se([0,1,2,67,5,20]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,l.createDecorator)("IUserDataProfileStorageService");let T=class extends k.Disposable{constructor(v){super(),this.a=v}async readStorageData(v){return this.withProfileScopedStorageService(v,async P=>this.b(P))}async updateStorageData(v,P,w){return this.withProfileScopedStorageService(v,async g=>this.c(g,P,w))}async withProfileScopedStorageService(v,P){if(this.a.hasScope(v))return P(this.a);const w=await this.g(v),g=new R(w);try{await g.initialize();const h=await P(g);return await g.flush(),h}finally{g.dispose(),await this.f(w)}}b(v){const P=new Map,w=g=>{for(const h of v.keys(0,g))P.set(h,{value:v.get(h,0),target:g})};return w(0),w(1),P}c(v,P,w){for(const[g,h]of P)v.store(g,h,0,w)}async f(v){try{await v.close()}finally{(0,k.isDisposable)(v)&&v.dispose()}}};T=ye([Y(0,D.IStorageService)],T),e.AbstractUserDataProfileStorageService=T;class R extends D.AbstractStorageService{constructor(v){super({flushInterval:100}),this.p=this.B(new L.Storage(v))}J(){return this.p.init()}L(v){return v===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(ne[281],se([0,1,3,2,71,11,61,20,75,28,69]),function(Z,e,k,L,l,D,T,R,I,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let w=class extends T.AbstractUserDataProfileStorageService{constructor(h,m,y,f){super(y),this.i=h;const u=h.getChannel("profileStorageListener"),d=this.B(new L.MutableDisposable);this.h=this.B(new k.Emitter({onWillAddFirstListener:()=>{d.value=u.listen("onDidChange")(p=>{f.trace("profile storage changes",p),this.h.fire({targetChanges:p.targetChanges.map(b=>(0,v.reviveProfile)(b,m.profilesHome.scheme)),valueChanges:p.valueChanges.map(b=>({...b,profile:(0,v.reviveProfile)(b.profile,m.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this.h.event}async g(h){const m=this.i.getChannel("storage");return(0,R.isProfileUsingDefaultStorage)(h)?new I.ApplicationStorageDatabaseClient(m):new I.ProfileStorageDatabaseClient(m,h)}};w=ye([Y(0,l.IMainProcessService),Y(1,v.IUserDataProfilesService),Y(2,R.IStorageService),Y(3,D.ILogService)],w),e.UserDataProfileStorageService=w,(0,P.registerSingleton)(T.IUserDataProfileStorageService,w,1)}),define(ne[41],se([0,1,18,6,17,23,3,35,2,26,12,182,16,15,14,44,20,19,30,22]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function b(r){return!!(r&&r.ref!==void 0&&typeof r.ref=="string"&&r.ref!==""&&r.syncData!==void 0&&(r.syncData===null||C(r.syncData)))}e.isRemoteUserData=b;function C(r){return!!(r&&r.version!==void 0&&typeof r.version=="number"&&r.content!==void 0&&typeof r.content=="string"&&(Object.keys(r).length===2||Object.keys(r).length===3&&r.machineId!==void 0&&typeof r.machineId=="string"))}e.isSyncData=C;function t(r,o){return`${(0,v.uppercaseFirstLetter)(r)}${o.isDefault?"":` (${o.name})`}`}e.getSyncResourceLogLabel=t;let a=class extends I.Disposable{get status(){return this.j}get conflicts(){return{...this.syncResource,conflicts:this.l}}constructor(o,s,c,S,E,A,N,M,B,O,j,q){super(),this.syncResource=o,this.collection=s,this.z=c,this.C=S,this.D=E,this.F=A,this.G=N,this.H=M,this.I=B,this.J=O,this.L=j,this.c=null,this.j="idle",this.k=this.B(new T.Emitter),this.onDidChangeStatus=this.k.event,this.l=[],this.m=this.B(new T.Emitter),this.onDidChangeConflicts=this.m.event,this.n=new L.ThrottledDelayer(50),this.s=this.B(new T.Emitter),this.onDidChangeLocal=this.s.event,this.u=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.v=!1,this.y={},this.resource=this.syncResource.syncResource,this.w=t(o.syncResource,o.profile),this.h=q.extUri,this.f=this.h.joinPath(S.userDataSyncHome,...(0,p.getPathSegments)(o.profile.isDefault?void 0:o.profile.id,o.syncResource)),this.g=this.h.joinPath(this.f,p.PREVIEW_DIR_NAME),this.t=(0,p.getLastSyncResourceUri)(o.profile.isDefault?void 0:o.profile.id,o.syncResource,S,this.h),this.i=(0,y.getServiceMachineId)(S,c,E)}M(){this.n.trigger(()=>this.N())}async N(){if(this.status==="hasConflicts"){this.J.info(`${this.w}: In conflicts state and local change detected. Syncing again...`);const o=await this.c;this.c=null;const s=await this.S(o.remoteUserData,o.lastSyncUserData,!0,this.lb());this.O(s)}else{this.J.trace(`${this.w}: Checking for local changes...`);const o=await this.getLastSyncUserData();(o?await this.rb(o):!0)&&this.s.fire()}}O(o){this.j!==o&&(this.j=o,this.k.fire(o))}async sync(o,s={}){await this.P(o,!0,this.lb(),s)}async preview(o,s,c={}){return this.P(o,!1,s,c)}async apply(o,s={}){try{this.y={...s};const c=await this.X(o);return this.O(c),this.c}finally{this.y={}}}async P(o,s,c,S){try{if(this.y={...S},this.status==="hasConflicts")return this.J.info(`${this.w}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.J.info(`${this.w}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.J.trace(`${this.w}: Started synchronizing ${this.resource.toLowerCase()}...`),this.O("syncing");let E="idle";try{const A=await this.getLastSyncUserData(),N=await this.R(o,A);return E=await this.S(N,A,s,c),E==="hasConflicts"?this.J.info(`${this.w}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):E==="idle"&&this.J.trace(`${this.w}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.O(E)}}finally{this.y={}}}async replace(o){const s=this.hb(o);if(!s)return!1;await this.stop();try{this.J.trace(`${this.w}: Started resetting ${this.resource.toLowerCase()}...`),this.O("syncing");const c=await this.getLastSyncUserData(),S=await this.R(null,c),E=await this.Q(S),A=await this.nb({ref:S.ref,syncData:s},c,E,this.lb(),D.CancellationToken.None),N=[];for(const M of A){const B=await this.pb(M,M.remoteResource,void 0,D.CancellationToken.None),{remoteChange:O}=await this.pb(M,M.previewResource,M.remoteContent,D.CancellationToken.None);N.push([M,{...B,remoteChange:O!==0?O:2}])}await this.qb(S,c,N,!1),this.J.info(`${this.w}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.O("idle")}return!0}async Q(o){const s=await this.i;return!!o.syncData?.machineId&&o.syncData.machineId===s}async R(o,s){if(s){const c=o?o[this.resource]:void 0;if(s.ref===c||c===void 0&&s.syncData===null)return s}return this.getRemoteUserData(s)}async S(o,s,c,S){if(o.syncData&&o.syncData.version>this.mb)throw this.I.publicLog2("sync/incompatible",{source:this.resource}),new p.UserDataSyncError((0,w.localize)(0,null,this.resource,this.mb,o.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.U(o,s,c,S)}catch(E){if(E instanceof p.UserDataSyncError)switch(E.code){case"LocalPreconditionFailed":return this.J.info(`${this.w}: Failed to synchronize ${this.w} as there is a new local version available. Synchronizing again...`),this.S(o,s,c,S);case"Conflict":case"PreconditionFailed":return this.J.info(`${this.w}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),o=await this.getRemoteUserData(null),s=await this.getLastSyncUserData(),this.S(o,s,c,S)}throw E}}async U(o,s,c,S){try{const E=await this.Q(o),A=!E&&s===null&&this.db()!==void 0,N=c&&!A;this.c||(this.c=(0,L.createCancelablePromise)(B=>this.bb(o,s,E,N,S,B)));let M=await this.c;if(c&&A){this.J.info(`${this.w}: Accepting remote because it was synced before and the last sync data is not available.`);for(const B of M.resourcePreviews)M=await this.accept(B.remoteResource)||M}return this.Z(M.resourcePreviews),M.resourcePreviews.some(({mergeState:B})=>B==="conflict")?"hasConflicts":c?await this.X(!1):"syncing"}catch(E){throw this.c=null,E}}async merge(o){return await this.W(o,async s=>{const c=await this.ob(s,D.CancellationToken.None);await this.z.writeFile(s.previewResource,l.VSBuffer.fromString(c?.content||""));const S=c&&!c.hasConflicts?await this.pb(s,s.previewResource,void 0,D.CancellationToken.None):void 0;return s.acceptResult=S,s.mergeState=c.hasConflicts?"conflict":S?"accepted":"preview",s.localChange=S?S.localChange:c.localChange,s.remoteChange=S?S.remoteChange:c.remoteChange,s}),this.c}async accept(o,s){return await this.W(o,async c=>{const S=await this.pb(c,o,s,D.CancellationToken.None);return c.acceptResult=S,c.mergeState="accepted",c.localChange=S.localChange,c.remoteChange=S.remoteChange,c}),this.c}async discard(o){return await this.W(o,async s=>{const c=await this.ob(s,D.CancellationToken.None);return await this.z.writeFile(s.previewResource,l.VSBuffer.fromString(c.content||"")),s.acceptResult=void 0,s.mergeState="preview",s.localChange=c.localChange,s.remoteChange=c.remoteChange,s}),this.c}async W(o,s){if(!this.c)return;let c=await this.c;const S=c.resourcePreviews.findIndex(({localResource:E,remoteResource:A,previewResource:N})=>this.h.isEqual(E,o)||this.h.isEqual(A,o)||this.h.isEqual(N,o));S!==-1&&(this.c=(0,L.createCancelablePromise)(async E=>{const A=[...c.resourcePreviews];return A[S]=await s(A[S]),{...c,resourcePreviews:A}}),c=await this.c,this.Z(c.resourcePreviews),c.resourcePreviews.some(({mergeState:E})=>E==="conflict")?this.O("hasConflicts"):this.O("syncing"))}async X(o){if(!this.c)return"idle";const s=await this.c;return s.resourcePreviews.some(({mergeState:c})=>c==="conflict")?"hasConflicts":s.resourcePreviews.some(({mergeState:c})=>c!=="accepted")?"syncing":(await this.qb(s.remoteUserData,s.lastSyncUserData,s.resourcePreviews.map(c=>[c,c.acceptResult]),o),this.c=null,await this.Y(),"idle")}async Y(){try{await this.z.del(this.g,{recursive:!0})}catch{}}Z(o){const s=o.filter(({mergeState:c})=>c==="conflict");(0,k.equals)(this.l,s,(c,S)=>this.h.isEqual(c.previewResource,S.previewResource))||(this.l=s,this.m.fire(this.conflicts))}async hasPreviouslySynced(){const o=await this.getLastSyncUserData();return!!o&&o.syncData!==null}async ab(o){const s=this.c?await this.c:null;if(s)for(const c of s.resourcePreviews){if(this.h.isEqual(c.acceptedResource,o))return c.acceptResult?c.acceptResult.content:null;if(this.h.isEqual(c.remoteResource,o))return c.remoteContent;if(this.h.isEqual(c.localResource,o))return c.localContent;if(this.h.isEqual(c.baseResource,o))return c.baseContent}return null}async resetLocal(){this.D.remove(this.u,-1);try{await this.z.del(this.t)}catch(o){(0,m.toFileOperationResult)(o)!==1&&this.J.error(o)}}async bb(o,s,c,S,E,A){const N=await this.nb(o,s,c,E,A),M=[];for(const B of N){const O=B.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(B.localChange===0&&B.remoteChange===0)M.push({...B,acceptedResource:O,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const j=S?await this.ob(B,A):void 0;if(A.isCancellationRequested)break;await this.z.writeFile(B.previewResource,l.VSBuffer.fromString(j?.content||""));const q=j&&!j.hasConflicts?await this.pb(B,B.previewResource,void 0,A):void 0;M.push({...B,acceptResult:q,mergeState:j?.hasConflicts?"conflict":q?"accepted":"preview",localChange:q?q.localChange:j?j.localChange:B.localChange,remoteChange:q?q.remoteChange:j?j.remoteChange:B.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:o,lastSyncUserData:s,resourcePreviews:M,isLastSyncFromCurrentMachine:c}}async getLastSyncUserData(){let o=this.db();if(o||(o=await this.gb()),!o)return this.J.info(`${this.w}: Last sync data state does not exist.`),null;const s=JSON.parse(o),c=this.H.getResourceSyncStateVersion(this.resource);if(this.v=!!s.version&&!!c&&s.version!==c,this.v)return this.J.info(`${this.w}: Reset last sync state because last sync state version ${s.version} is not compatible with current sync state version ${c}.`),await this.resetLocal(),null;let S,E=1;for(;S===void 0&&E++<6;)try{const A=await this.eb();A&&(A.ref===s.ref?S=A.syncData:this.J.info(`${this.w}: Last sync data stored locally is not same as the last sync state.`));break}catch(A){if(A instanceof m.FileOperationError&&A.fileOperationResult===1){this.J.info(`${this.w}: Last sync resource does not exist locally.`);break}else{if(A instanceof p.UserDataSyncError)throw A;this.J.error(A,E)}}if(S===void 0)try{const A=await this.F.resolveResourceContent(this.resource,s.ref,this.collection,this.y);S=A===null?null:this.hb(A),await this.fb({ref:s.ref,syncData:S})}catch(A){if(A instanceof p.UserDataSyncError&&A.code==="NotFound")this.J.info(`${this.w}: Last sync resource does not exist remotely.`);else throw A}return S===void 0?null:{...s,syncData:S}}async cb(o,s={}){if(s.ref||s.version)throw new Error("Cannot have core properties as additional");const c=this.H.getResourceSyncStateVersion(this.resource),S={ref:o.ref,version:c,...s};this.D.store(this.u,JSON.stringify(S),-1,1),await this.fb(o)}db(){return this.D.get(this.u,-1)}async eb(){const o=(await this.z.readFile(this.t)).value.toString();try{const s=o?JSON.parse(o):void 0;if(b(s))return s}catch(s){this.J.error(s)}}async fb(o){await this.z.writeFile(this.t,l.VSBuffer.fromString(JSON.stringify(o)))}async gb(){try{const o=await this.z.readFile(this.t),s=JSON.parse(o.value.toString());await this.z.del(this.t),s.ref&&s.content!==void 0?(this.D.store(this.u,JSON.stringify({...s,content:void 0}),-1,1),await this.fb({ref:s.ref,syncData:s.content===null?null:JSON.parse(s.content)})):this.J.info(`${this.w}: Migrating last sync user data. Invalid data.`,s)}catch(o){o instanceof m.FileOperationError&&o.fileOperationResult===1?this.J.info(`${this.w}: Migrating last sync user data. Resource does not exist.`):this.J.error(o)}return this.D.get(this.u,-1)}async getRemoteUserData(o){const{ref:s,content:c}=await this.ib(o);let S=null;return c!==null&&(S=this.hb(c)),{ref:s,syncData:S}}hb(o){try{const s=JSON.parse(o);if(C(s))return s}catch(s){this.J.error(s)}throw new p.UserDataSyncError((0,w.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(o){const s=o?{ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null}:null;return this.F.readResource(this.resource,s,this.collection,this.y)}async jb(o,s){const c=await this.i,S={version:this.mb,machineId:c,content:o};try{return s=await this.F.writeResource(this.resource,JSON.stringify(S),s,this.collection,this.y),{ref:s,syncData:S}}catch(E){throw E instanceof p.UserDataSyncError&&E.code==="TooLarge"&&(E=new p.UserDataSyncError(E.message,E.code,this.resource)),E}}async kb(o){const s={version:this.mb,content:o};return this.G.backup(this.syncResource.profile,this.resource,JSON.stringify(s))}async stop(){this.status!=="idle"&&(this.J.trace(`${this.w}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.Z([]),await this.Y(),this.O("idle"),this.J.info(`${this.w}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.L.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=ye([Y(2,m.IFileService),Y(3,h.IEnvironmentService),Y(4,f.IStorageService),Y(5,p.IUserDataSyncStoreService),Y(6,p.IUserDataSyncBackupStoreService),Y(7,p.IUserDataSyncEnablementService),Y(8,u.ITelemetryService),Y(9,p.IUserDataSyncLogService),Y(10,g.IConfigurationService),Y(11,d.IUriIdentityService)],a),e.AbstractSynchroniser=a;let i=class extends a{constructor(o,s,c,S,E,A,N,M,B,O,j,q,K){super(s,c,S,E,A,N,M,B,O,j,q,K),this.p=o,this.B(this.z.watch(this.h.dirname(o))),this.B(this.z.onDidFilesChange(Q=>this.ub(Q)))}async r(){try{return await this.z.readFile(this.p)}catch{return null}}async sb(o,s,c){try{s?await this.z.writeFile(this.p,l.VSBuffer.fromString(o),c?void 0:s):await this.z.createFile(this.p,l.VSBuffer.fromString(o),{overwrite:c})}catch(S){throw S instanceof m.FileOperationError&&S.fileOperationResult===1||S instanceof m.FileOperationError&&S.fileOperationResult===3?new p.UserDataSyncError(S.message,"LocalPreconditionFailed"):S}}async tb(){try{await this.z.del(this.p)}catch(o){if(!(o instanceof m.FileOperationError&&o.fileOperationResult===1))throw o}}ub(o){!o.contains(this.p)||this.M()}};i=ye([Y(3,m.IFileService),Y(4,h.IEnvironmentService),Y(5,f.IStorageService),Y(6,p.IUserDataSyncStoreService),Y(7,p.IUserDataSyncBackupStoreService),Y(8,p.IUserDataSyncEnablementService),Y(9,u.ITelemetryService),Y(10,p.IUserDataSyncLogService),Y(11,g.IConfigurationService),Y(12,d.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let n=class extends i{constructor(o,s,c,S,E,A,N,M,B,O,j,q,K,Q){super(o,s,c,S,E,A,N,M,B,O,j,K,Q),this.vb=q,this.xb=void 0}wb(o,s){const c=[],S=(0,R.parse)(o,c,{allowEmptyContent:!0,allowTrailingComma:!0});return c.length>0||!(0,P.isUndefined)(S)&&s!==Array.isArray(S)}yb(){return this.xb||(this.xb=this.vb.resolveFormattingOptions(this.p)),this.xb}};n=ye([Y(3,m.IFileService),Y(4,h.IEnvironmentService),Y(5,f.IStorageService),Y(6,p.IUserDataSyncStoreService),Y(7,p.IUserDataSyncBackupStoreService),Y(8,p.IUserDataSyncEnablementService),Y(9,u.ITelemetryService),Y(10,p.IUserDataSyncLogService),Y(11,p.IUserDataSyncUtilService),Y(12,g.IConfigurationService),Y(13,d.IUriIdentityService)],n),e.AbstractJsonFileSynchroniser=n}),define(ne[120],se([0,1,6,23,8,3,42,2,26,16,15,119,29,33,79,14,5,70,20,19,30,41,262,117,22,61]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u,d,p,b,C,t,a,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function r(E,A){const N=JSON.parse(E.content);if(E.version===1||E.version===2){const M=(await A.getInstalled(0)).filter(B=>B.isBuiltin);for(const B of N)E.version===1&&(B.enabled===!1&&(B.disabled=!0),delete B.enabled),E.version===2&&M.every(O=>!(0,h.areSameExtensions)(O.identifier,B.identifier))&&(B.installed=!0)}return N}function o(E){return JSON.parse(E.content)}e.parseExtensions=o;function s(E,A){return E.sort((N,M)=>!N.identifier.uuid&&M.identifier.uuid?-1:N.identifier.uuid&&!M.identifier.uuid?1:(0,I.compare)(N.identifier.id,M.identifier.id)),A?(0,T.toFormattedString)(E,{}):JSON.stringify(E)}e.stringify=s;let c=class extends C.AbstractSynchroniser{constructor(A,N,M,B,O,j,q,K,Q,re,J,W,F,G,ee,oe,ae){super({syncResource:"extensions",profile:A},N,B,M,O,j,q,W,F,re,J,ee),this.yb=K,this.zb=Q,this.Ab=ae,this.mb=5,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"base"}),this.ub=this.sb.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),this.vb=this.sb.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.wb=this.sb.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.xb=this.Ab.createInstance(S),this.B(D.Event.any(D.Event.filter(this.yb.onDidInstallExtensions,x=>x.some(({local:$})=>!!$)),D.Event.filter(this.yb.onDidUninstallExtension,x=>!x.error),D.Event.filter(oe.onDidChange,x=>x.valueChanges.some(({profile:$,changes:U})=>this.syncResource.profile.id===$.id&&U.some(z=>z.key===g.DISABLED_EXTENSIONS_STORAGE_PATH))),G.onDidChangeExtensionStorageToSync)(()=>this.M()))}async nb(A,N){const M=A.syncData?await r(A.syncData,this.yb):null,B=N?.skippedExtensions??[],O=N?.builtinExtensions??null,j=N?.syncData?await r(N.syncData,this.yb):null,{localExtensions:q,ignoredExtensions:K}=await this.xb.getLocalExtensions(this.syncResource.profile);M?this.J.trace(`${this.w}: Merging remote extensions with local extensions...`):this.J.trace(`${this.w}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:Q,remote:re}=(0,t.merge)(q,M,j,B,K,O),J={local:Q,remote:re,content:this.Db(q,Q.added,Q.updated,Q.removed),localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:re!==null?2:0},W=this.Kb(q,!1);return[{skippedExtensions:B,builtinExtensions:O,baseResource:this.tb,baseContent:j?this.Kb(j,!1):W,localResource:this.ub,localContent:W,localExtensions:q,remoteResource:this.vb,remoteExtensions:M,remoteContent:M?this.Kb(M,!1):null,previewResource:this.sb,previewResult:J,localChange:J.localChange,remoteChange:J.remoteChange,acceptedResource:this.wb}]}async rb(A){const N=A.syncData?await r(A.syncData,this.yb):null,{localExtensions:M,ignoredExtensions:B}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:O}=(0,t.merge)(M,N,N,A.skippedExtensions||[],B,A.builtinExtensions||[]);return O!==null}Db(A,N,M,B){const O=[...N,...M],j=new Set,q=K=>{j.add(K.id.toLowerCase()),K.uuid&&j.add(K.uuid)};O.forEach(({identifier:K})=>q(K)),B.forEach(q);for(const K of A)j.has(K.identifier.id.toLowerCase())||K.identifier.uuid&&j.has(K.identifier.uuid)||O.push(K);return this.Kb(O,!1)}async ob(A,N){return{...A.previewResult,hasConflicts:!1}}async pb(A,N,M,B){if(this.h.isEqual(N,this.ub))return this.Gb(A);if(this.h.isEqual(N,this.vb))return this.Hb(A);if(this.h.isEqual(N,this.sb))return A.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async Gb(A){const N=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),M=this.zb.getIgnoredExtensions(N),B=(0,t.merge)(A.localExtensions,null,null,A.skippedExtensions,M,A.builtinExtensions),{local:O,remote:j}=B;return{content:A.localContent,local:O,remote:j,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:j!==null?2:0}}async Hb(A){const N=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),M=this.zb.getIgnoredExtensions(N),B=A.remoteContent?JSON.parse(A.remoteContent):null;if(B!==null){const O=(0,t.merge)(A.localExtensions,B,A.localExtensions,[],M,A.builtinExtensions),{local:j,remote:q}=O;return{content:A.remoteContent,local:j,remote:q,localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?2:0,remoteChange:q!==null?2:0}}else return{content:A.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(A,N,M,B){let{skippedExtensions:O,builtinExtensions:j,localExtensions:q}=M[0][0];const{local:K,remote:Q,localChange:re,remoteChange:J}=M[0][1];if(re===0&&J===0&&this.J.info(`${this.w}: No changes found during synchronizing extensions.`),re!==0&&(await this.kb(JSON.stringify(q)),O=await this.xb.updateLocalExtensions(K.added,K.removed,K.updated,O,this.syncResource.profile)),Q){this.J.trace(`${this.w}: Updating remote extensions...`);const W=JSON.stringify(Q.all);A=await this.jb(W,B?null:A.ref),this.J.info(`${this.w}: Updated remote extensions.${Q.added.length?` Added: ${JSON.stringify(Q.added.map(F=>F.identifier.id))}.`:""}${Q.updated.length?` Updated: ${JSON.stringify(Q.updated.map(F=>F.identifier.id))}.`:""}${Q.removed.length?` Removed: ${JSON.stringify(Q.removed.map(F=>F.identifier.id))}.`:""}`)}N?.ref!==A.ref&&(this.J.trace(`${this.w}: Updating last synchronized extensions...`),j=this.Jb(q,j),await this.cb(A,{skippedExtensions:O,builtinExtensions:j}),this.J.info(`${this.w}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(W=>W.identifier.id))}.`:""}`))}Jb(A,N){const M=new Set,B=[];for(const O of A)M.add(O.identifier.id.toLowerCase()),O.installed||B.push(O.identifier);if(N)for(const O of N)M.has(O.id.toLowerCase())||B.push(O);return B}async resolveContent(A){if(this.h.isEqual(this.vb,A)||this.h.isEqual(this.tb,A)||this.h.isEqual(this.ub,A)||this.h.isEqual(this.wb,A)){const N=await this.ab(A);return N&&this.Kb(JSON.parse(N),!0)}return null}Kb(A,N){return s(A,N)}async hasLocalData(){try{const{localExtensions:A}=await this.xb.getLocalExtensions(this.syncResource.profile);if(A.some(N=>N.installed||N.disabled))return!0}catch{}return!1}};c=ye([Y(2,P.IEnvironmentService),Y(3,y.IFileService),Y(4,d.IStorageService),Y(5,i.IUserDataSyncStoreService),Y(6,i.IUserDataSyncBackupStoreService),Y(7,g.IExtensionManagementService),Y(8,a.IIgnoredExtensionsManagementService),Y(9,i.IUserDataSyncLogService),Y(10,v.IConfigurationService),Y(11,i.IUserDataSyncEnablementService),Y(12,p.ITelemetryService),Y(13,m.IExtensionStorageService),Y(14,b.IUriIdentityService),Y(15,n.IUserDataProfileStorageService),Y(16,f.IInstantiationService)],c),e.ExtensionsSynchroniser=c;let S=class{constructor(A,N,M,B,O,j){this.a=A,this.b=N,this.c=M,this.d=B,this.f=O,this.g=j}async getLocalExtensions(A){const N=await this.a.getInstalled(void 0,A.extensionsResource),M=this.d.getIgnoredExtensions(N);return{localExtensions:await this.i(A,async(O,j)=>{const q=O.getDisabledExtensions();return N.map(K=>{const{identifier:Q,isBuiltin:re,manifest:J,preRelease:W,pinned:F}=K,G={identifier:Q,preRelease:W,version:J.version,pinned:!!F};q.some(ee=>(0,h.areSameExtensions)(ee,Q))&&(G.disabled=!0),re||(G.installed=!0);try{const ee=j.getKeysForSync({id:Q.id,version:J.version});if(ee){const oe=j.getExtensionState(K,!0)||{};G.state=Object.keys(oe).reduce((ae,x)=>(ee.includes(x)&&(ae[x]=oe[x]),ae),{})}}catch(ee){this.g.info(`${(0,C.getSyncResourceLogLabel)("extensions",A)}: Error while parsing extension state`,(0,l.getErrorMessage)(ee))}return G})}),ignoredExtensions:M}}async updateLocalExtensions(A,N,M,B,O){const j=(0,C.getSyncResourceLogLabel)("extensions",O),q=[],K=[],Q=[],re=await this.a.getInstalled(void 0,O.extensionsResource);if((A.length||M.length)&&await this.i(O,async(W,F)=>{await k.Promises.settled([...A,...M].map(async G=>{const ee=re.find(x=>(0,h.areSameExtensions)(x.identifier,G.identifier));if(ee&&ee.isBuiltin){G.state&&ee.manifest.version===G.version&&this.h(G.state,ee,ee.manifest.version,F),W.getDisabledExtensions().some($=>(0,h.areSameExtensions)($,G.identifier))!==!!G.disabled&&(G.disabled?(this.g.trace(`${j}: Disabling extension...`,G.identifier.id),await W.disableExtension(G.identifier),this.g.info(`${j}: Disabled extension`,G.identifier.id)):(this.g.trace(`${j}: Enabling extension...`,G.identifier.id),await W.enableExtension(G.identifier),this.g.info(`${j}: Enabled extension`,G.identifier.id))),K.push(G.identifier);return}const oe=G.pinned?G.version:void 0,ae=(await this.c.getExtensions([{...G.identifier,version:oe,preRelease:oe?void 0:G.preRelease}],L.CancellationToken.None))[0];if(G.state&&(ee?ee.manifest.version===G.version:!!ae)&&this.h(G.state,ee||ae,ee?.manifest.version,F),ae)try{W.getDisabledExtensions().some($=>(0,h.areSameExtensions)($,G.identifier))!==!!G.disabled&&(G.disabled?(this.g.trace(`${j}: Disabling extension...`,G.identifier.id,ae.version),await W.disableExtension(ae.identifier),this.g.info(`${j}: Disabled extension`,G.identifier.id,ae.version)):(this.g.trace(`${j}: Enabling extension...`,G.identifier.id,ae.version),await W.enableExtension(ae.identifier),this.g.info(`${j}: Enabled extension`,G.identifier.id,ae.version))),(!ee||ee.preRelease!==G.preRelease||ee.pinned!==G.pinned||oe&&ee.manifest.version!==oe)&&(await this.a.canInstall(ae)?q.push([G,ae]):(this.g.info(`${j}: Skipped synchronizing extension because it cannot be installed.`,ae.displayName||ae.identifier.id),Q.push(G)))}catch(x){Q.push(G),this.g.error(x),this.g.info(`${j}: Skipped synchronizing extension`,ae.displayName||ae.identifier.id)}else Q.push(G),this.g.info(`${j}: Skipped synchronizing extension because the extension is not found.`,G.identifier.id)}))}),N.length){const W=re.filter(({identifier:F,isBuiltin:G})=>!G&&N.some(ee=>(0,h.areSameExtensions)(F,ee)));await k.Promises.settled(W.map(async F=>{this.g.trace(`${j}: Uninstalling local extension...`,F.identifier.id),await this.a.uninstall(F,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:O.extensionsResource}),this.g.info(`${j}: Uninstalled local extension.`,F.identifier.id),K.push(F.identifier)}))}for(const[W,F]of q)try{this.g.trace(`${j}: Installing extension...`,F.identifier.id,F.version),await this.a.installFromGallery(F,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:W.pinned&&!!W.version,installPreReleaseVersion:W.preRelease,profileLocation:O.extensionsResource,context:{[g.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[g.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}),this.g.info(`${j}: Installed extension.`,F.identifier.id,F.version),K.push(F.identifier)}catch(G){Q.push(W),G instanceof g.ExtensionManagementError&&[g.ExtensionManagementErrorCode.Incompatible,g.ExtensionManagementErrorCode.IncompatiblePreRelease,g.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(G.code)?this.g.info(`${j}: Skipped synchronizing extension because the compatible extension is not found.`,F.displayName||F.identifier.id):(this.g.error(G),this.g.info(`${j}: Skipped synchronizing extension`,F.displayName||F.identifier.id))}const J=[];for(const W of B)K.some(F=>(0,h.areSameExtensions)(F,W.identifier))||J.push(W);for(const W of Q)J.some(F=>(0,h.areSameExtensions)(F.identifier,W.identifier))||J.push(W);return J}h(A,N,M,B){const O=B.getExtensionState(N,!0)||{},j=M?B.getKeysForSync({id:N.identifier.id,version:M}):void 0;j?j.forEach(q=>{O[q]=A[q]}):Object.keys(A).forEach(q=>O[q]=A[q]),B.setExtensionState(N,O,!0)}async i(A,N){return this.b.withProfileScopedStorageService(A,async M=>{const B=new R.DisposableStore,O=this.f.createChild(new u.ServiceCollection([d.IStorageService,M])),j=B.add(O.createInstance(w.GlobalExtensionEnablementService)),q=B.add(O.createInstance(m.ExtensionStorageService));try{return await N(j,q)}finally{B.dispose()}})}};S=ye([Y(0,g.IExtensionManagementService),Y(1,n.IUserDataProfileStorageService),Y(2,g.IExtensionGalleryService),Y(3,a.IIgnoredExtensionsManagementService),Y(4,f.IInstantiationService),Y(5,i.IUserDataSyncLogService)],S),e.LocalExtensionsProvider=S}),define(ne[121],se([0,1,17,8,3,35,42,4,31,16,15,14,11,44,20,19,30,41,60,266,22,61,5]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u,d,p,b,C,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const a="globalState.argv.",i=["locale"];function n(S,E){const A=S.storage?Object.keys(S.storage).sort():[],N={};return A.forEach(M=>N[M]=S.storage[M]),S.storage=N,E?(0,T.toFormattedString)(S,{}):JSON.stringify(S)}e.stringify=n;const r=1;let o=class extends u.AbstractSynchroniser{constructor(E,A,N,M,B,O,j,q,K,Q,re,J,W,F){super({syncResource:"globalState",profile:E},A,M,q,J,B,O,K,Q,j,re,W),this.xb=N,this.mb=r,this.r=this.h.joinPath(this.g,"globalState.json"),this.sb=this.r.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.tb=this.r.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.ub=this.r.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.vb=this.r.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.wb=F.createInstance(s),this.B(M.watch(this.h.dirname(this.C.argvResource))),this.B(l.Event.any(l.Event.filter(M.onDidFilesChange,G=>G.contains(this.C.argvResource)),l.Event.filter(N.onDidChange,G=>!!(G.targetChanges.some(ee=>this.syncResource.profile.id===ee.id)||G.valueChanges.some(({profile:ee,changes:oe})=>this.syncResource.profile.id===ee.id&&oe.some(ae=>ae.target===0)))))(()=>this.M()))}async nb(E,A,N){const M=E.syncData?JSON.parse(E.syncData.content):null;A=A===null&&N?E:A;const B=A&&A.syncData?JSON.parse(A.syncData.content):null,O=await this.wb.getLocalGlobalState(this.syncResource.profile);M?this.J.trace(`${this.w}: Merging remote ui state with local ui state...`):this.J.trace(`${this.w}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const j=await this.Fb(B),{local:q,remote:K}=(0,p.merge)(O.storage,M?M.storage:null,B?B.storage:null,j,this.J),Q={content:null,local:q,remote:K,localChange:Object.keys(q.added).length>0||Object.keys(q.updated).length>0||q.removed.length>0?2:0,remoteChange:K.all!==null?2:0},re=n(O,!1);return[{baseResource:this.sb,baseContent:B?n(B,!1):re,localResource:this.tb,localContent:re,localUserData:O,remoteResource:this.ub,remoteContent:M?n(M,!1):null,previewResource:this.r,previewResult:Q,localChange:Q.localChange,remoteChange:Q.remoteChange,acceptedResource:this.vb,storageKeys:j}]}async rb(E){const A=E.syncData?JSON.parse(E.syncData.content):null;if(A===null)return!0;const N=await this.wb.getLocalGlobalState(this.syncResource.profile),M=await this.Fb(A),{remote:B}=(0,p.merge)(N.storage,A.storage,A.storage,M,this.J);return B.all!==null}async ob(E,A){return{...E.previewResult,hasConflicts:!1}}async pb(E,A,N,M){if(this.h.isEqual(A,this.tb))return this.Cb(E);if(this.h.isEqual(A,this.ub))return this.Db(E);if(this.h.isEqual(A,this.r))return E.previewResult;throw new Error(`Invalid Resource: ${A.toString()}`)}async Cb(E){return{content:E.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(E.localUserData.storage),removed:[],updated:[],all:E.localUserData.storage},localChange:0,remoteChange:2}}async Db(E){if(E.remoteContent!==null){const A=JSON.parse(E.remoteContent),{local:N,remote:M}=(0,p.merge)(E.localUserData.storage,A.storage,null,E.storageKeys,this.J);return{content:E.remoteContent,local:N,remote:M,localChange:Object.keys(N.added).length>0||Object.keys(N.updated).length>0||N.removed.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:E.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(E,A,N,M){const{localUserData:B}=N[0][0],{local:O,remote:j,localChange:q,remoteChange:K}=N[0][1];if(q===0&&K===0&&this.J.info(`${this.w}: No changes found during synchronizing ui state.`),q!==0&&(this.J.trace(`${this.w}: Updating local ui state...`),await this.kb(JSON.stringify(B)),await this.wb.writeLocalGlobalState(O,this.syncResource.profile),this.J.info(`${this.w}: Updated local ui state`)),K!==0){this.J.trace(`${this.w}: Updating remote ui state...`);const Q=JSON.stringify({storage:j.all});E=await this.jb(Q,M?null:E.ref),this.J.info(`${this.w}: Updated remote ui state.${j.added.length?` Added: ${j.added}.`:""}${j.updated.length?` Updated: ${j.updated}.`:""}${j.removed.length?` Removed: ${j.removed}.`:""}`)}A?.ref!==E.ref&&(this.J.trace(`${this.w}: Updating last synchronized ui state...`),await this.cb(E),this.J.info(`${this.w}: Updated last synchronized ui state`))}async resolveContent(E){if(this.h.isEqual(this.ub,E)||this.h.isEqual(this.sb,E)||this.h.isEqual(this.tb,E)||this.h.isEqual(this.vb,E)){const A=await this.ab(E);return A&&n(JSON.parse(A),!0)}return null}async hasLocalData(){try{const{storage:E}=await this.wb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(E).length>1||E[`${a}.locale`]?.value!=="en")return!0}catch{}return!1}async Fb(E){const A=await this.xb.readStorageData(this.syncResource.profile),N=[],M=[];for(const[j,q]of A)q.target===0?N.push(j):q.target===1&&M.push(j);const B=[...N,...M],O=E?.storage?Object.keys(E.storage).filter(j=>!j.startsWith(a)&&!B.includes(j)&&A.get(j)!==void 0):[];if(!R.isWeb){const j=[...b.ALL_SYNC_RESOURCES.map(q=>(0,b.getEnablementKey)(q)),b.SYNC_SERVICE_URL_TYPE];O.push(...j),M.push(...j)}return{user:N,machine:M,unregistered:O}}};o=ye([Y(2,C.IUserDataProfileStorageService),Y(3,w.IFileService),Y(4,b.IUserDataSyncStoreService),Y(5,b.IUserDataSyncBackupStoreService),Y(6,b.IUserDataSyncLogService),Y(7,P.IEnvironmentService),Y(8,b.IUserDataSyncEnablementService),Y(9,y.ITelemetryService),Y(10,v.IConfigurationService),Y(11,m.IStorageService),Y(12,f.IUriIdentityService),Y(13,t.IInstantiationService)],o),e.GlobalStateSynchroniser=o;let s=class{constructor(E,A,N,M){this.a=E,this.b=A,this.c=N,this.d=M}async getLocalGlobalState(E){const A={};if(E.isDefault){const M=await this.f(),B=(0,D.parse)(M);for(const O of i)B[O]!==void 0&&(A[`${a}${O}`]={version:1,value:B[O]})}const N=await this.c.readStorageData(E);for(const[M,B]of N)B.value&&B.target===0&&(A[M]={version:1,value:B.value});return{storage:A}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const E=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),E.value.toString()}catch(E){this.d.debug((0,L.getErrorMessage)(E))}return"{}"}async writeLocalGlobalState({added:E,removed:A,updated:N},M){const B=(0,u.getSyncResourceLogLabel)("globalState",M),O={},j=new Map,q=await this.c.readStorageData(M),K=(Q,re)=>{for(const J of Q){if(J.startsWith(a)){O[J.substring(a.length)]=re?re[J].value:void 0;continue}if(re){const W=re[J];W.value!==q.get(J)?.value&&j.set(J,W.value)}else q.get(J)!==void 0&&j.set(J,void 0)}};if(K(Object.keys(E),E),K(Object.keys(N),N),K(A),Object.keys(O).length){this.d.trace(`${B}: Updating locale...`);const Q=await this.f();let re=Q;for(const J of Object.keys(O))re=(0,d.edit)(re,[J],O[J],{});Q!==re&&(this.d.trace(`${B}: Updating locale...`),await this.a.writeFile(this.b.argvResource,k.VSBuffer.fromString(re)),this.d.info(`${B}: Updated locale.`)),this.d.info(`${B}: Updated locale`)}j.size&&(this.d.trace(`${B}: Updating global state...`),await this.c.updateStorageData(M,j,0),this.d.info(`${B}: Updated global state`,[...j.keys()]))}};s=ye([Y(0,w.IFileService),Y(1,P.IEnvironmentService),Y(2,C.IUserDataProfileStorageService),Y(3,b.IUserDataSyncLogService)],s),e.LocalGlobalStateProvider=s;let c=class{constructor(E,A,N,M,B){this.a=E,this.b=A,this.c=N,this.d=M,this.f=B}getSyncStoreType(E){return this.h(E)?.storage[b.SYNC_SERVICE_URL_TYPE]?.value}async sync(E){const A=(0,b.createSyncHeaders)((0,I.generateUuid)());try{return await this.g(E,A)}catch(N){if(N instanceof b.UserDataSyncError)switch(N.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(E,A)}throw N}}async g(E,A){const N=await this.a.readResource("globalState",null,void 0,A),M=this.h(N)||{storage:{}};M.storage[b.SYNC_SERVICE_URL_TYPE]={value:E,version:r};const B=await(0,h.getServiceMachineId)(this.c,this.d,this.b),O={version:r,machineId:B,content:n(M,!1)};await this.a.writeResource("globalState",JSON.stringify(O),N.ref,void 0,A)}h({content:E}){if(!E)return null;const A=JSON.parse(E);if((0,u.isSyncData)(A))return A?JSON.parse(A.content):null;throw new Error("Invalid remote data")}};c=ye([Y(1,m.IStorageService),Y(2,P.IEnvironmentService),Y(3,w.IFileService),Y(4,g.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(ne[122],se([0,1,18,3,35,4,12,183,16,15,14,20,19,30,41,263,22]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function u(p,b,C){try{const t=JSON.parse(p);if(!b)return(0,T.isUndefined)(t.all)?null:t.all;switch(D.OS){case 2:return(0,T.isUndefined)(t.mac)?null:t.mac;case 3:return(0,T.isUndefined)(t.linux)?null:t.linux;case 1:return(0,T.isUndefined)(t.windows)?null:t.windows}}catch(t){return C.error(t),null}}e.getKeybindingsContentFromSyncContent=u;let d=class extends m.AbstractJsonFileSynchroniser{constructor(b,C,t,a,i,n,r,o,s,c,S,E,A){super(b.keybindingsResource,{syncResource:"keybindings",profile:b},C,o,s,c,t,a,r,E,i,S,n,A),this.mb=2,this.Ab=this.h.joinPath(this.g,"keybindings.json"),this.Bb=this.Ab.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Cb=this.Ab.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Db=this.Ab.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Eb=this.Ab.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(L.Event.filter(n.onDidChangeConfiguration,N=>N.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.M()))}async nb(b,C,t,a){const i=b.syncData?u(b.syncData.content,a.keybindingsPerPlatform??this.Mb(),this.J):null;C=C===null&&t?b:C;const n=C?this.Kb(C):null,r=await this.r(),o=await this.yb();let s=null,c=!1,S=!1,E=!1;if(i){let M=r?r.value.toString():"[]";if(M=M||"[]",this.wb(M,!0))throw new f.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource);if(!n||n!==M||n!==i){this.J.trace(`${this.w}: Merging remote keybindings with local keybindings...`);const B=await(0,y.merge)(M,i,n,o,this.vb);B.hasChanges&&(s=B.mergeContent,E=B.hasConflicts,c=E||B.mergeContent!==M,S=E||B.mergeContent!==i)}}else r&&(this.J.trace(`${this.w}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),s=r.value.toString(),S=!0);const A={content:E?n:s,localChange:c?r?2:1:0,remoteChange:S?2:0,hasConflicts:E},N=r?r.value.toString():null;return[{fileContent:r,baseResource:this.Bb,baseContent:n,localResource:this.Cb,localContent:N,localChange:A.localChange,remoteResource:this.Db,remoteContent:i,remoteChange:A.remoteChange,previewResource:this.Ab,previewResult:A,acceptedResource:this.Eb}]}async rb(b){const C=this.Kb(b);if(C===null)return!0;const t=await this.r(),a=t?t.value.toString():"",i=await this.yb(),n=await(0,y.merge)(a||"[]",C,C,i,this.vb);return n.hasConflicts||n.mergeContent!==C}async ob(b,C){return b.previewResult}async pb(b,C,t,a){if(this.h.isEqual(C,this.Cb))return{content:b.fileContent?b.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(C,this.Db))return{content:b.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(C,this.Ab))return t===void 0?{content:b.previewResult.content,localChange:b.previewResult.localChange,remoteChange:b.previewResult.remoteChange}:{content:t,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${C.toString()}`)}async qb(b,C,t,a){const{fileContent:i}=t[0][0];let{content:n,localChange:r,remoteChange:o}=t[0][1];if(r===0&&o===0&&this.J.info(`${this.w}: No changes found during synchronizing keybindings.`),n!==null&&(n=n.trim(),n=n||"[]",this.wb(n,!0)))throw new f.UserDataSyncError((0,R.localize)(1,null),"LocalInvalidContent",this.resource);if(r!==0&&(this.J.trace(`${this.w}: Updating local keybindings...`),i&&await this.kb(this.Lb(i.value.toString())),await this.sb(n||"[]",i,a),this.J.info(`${this.w}: Updated local keybindings`)),o!==0){this.J.trace(`${this.w}: Updating remote keybindings...`);const s=this.Lb(n||"[]",b.syncData?.content);b=await this.jb(s,a?null:b.ref),this.J.info(`${this.w}: Updated remote keybindings`)}try{await this.z.del(this.Ab)}catch{}C?.ref!==b.ref&&(this.J.trace(`${this.w}: Updating last synchronized keybindings...`),await this.cb(b,{platformSpecific:this.Mb()}),this.J.info(`${this.w}: Updated last synchronized keybindings`))}async hasLocalData(){try{const b=await this.r();if(b){const C=(0,l.parse)(b.value.toString());if((0,k.isNonEmptyArray)(C))return!0}}catch(b){if(b.fileOperationResult!==1)return!0}return!1}async resolveContent(b){return this.h.isEqual(this.Db,b)||this.h.isEqual(this.Bb,b)||this.h.isEqual(this.Cb,b)||this.h.isEqual(this.Eb,b)?this.ab(b):null}Kb(b){return!b.syncData||b.platformSpecific!==void 0&&b.platformSpecific!==this.Mb()?null:u(b.syncData.content,this.Mb(),this.J)}Lb(b,C){let t={};try{t=JSON.parse(C||"{}")}catch(a){this.J.error(a)}switch(this.Mb()?delete t.all:t.all=b,D.OS){case 2:t.mac=b;break;case 3:t.linux=b;break;case 1:t.windows=b;break}return JSON.stringify(t)}Mb(){return!!this.L.getValue(f.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};d=ye([Y(2,f.IUserDataSyncStoreService),Y(3,f.IUserDataSyncBackupStoreService),Y(4,f.IUserDataSyncLogService),Y(5,I.IConfigurationService),Y(6,f.IUserDataSyncEnablementService),Y(7,P.IFileService),Y(8,v.IEnvironmentService),Y(9,w.IStorageService),Y(10,f.IUserDataSyncUtilService),Y(11,g.ITelemetryService),Y(12,h.IUriIdentityService)],d),e.KeybindingsSynchroniser=d}),define(ne[123],se([0,1,3,184,16,73,15,29,14,20,19,30,41,60,267,22]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function f(p){return p&&p.settings&&typeof p.settings=="string"&&Object.keys(p).length===1}function u(p){const b=JSON.parse(p);return f(b)?b:{settings:p}}e.parseSettingsSyncContent=u;let d=class extends g.AbstractJsonFileSynchroniser{constructor(b,C,t,a,i,n,r,o,s,c,S,E,A,N){super(b.settingsResource,{syncResource:"settings",profile:b},C,t,a,i,n,r,S,E,o,s,c,N),this.Ab=A,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Kb=void 0}async getRemoteUserDataSyncConfiguration(b){const C=await this.getLastSyncUserData(),t=await this.R(b,C),a=this.Hb(t),i=new D.ConfigurationModelParser(y.USER_DATA_SYNC_CONFIGURATION_SCOPE);return a?.settings&&i.parse(a.settings),i.configurationModel.getValue(y.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async nb(b,C,t){const a=await this.r(),i=await this.yb(),n=this.Hb(b);C=C===null&&t?b:C;const r=C?this.Hb(C):null,o=await this.Lb();let s=null,c=!1,S=!1,E=!1;if(n){let B=a?a.value.toString().trim():"{}";B=B||"{}",this.Mb(B),this.J.trace(`${this.w}: Merging remote settings with local settings...`);const O=(0,m.merge)(B,n.settings,r?r.settings:null,o,[],i);s=O.localContent||O.remoteContent,c=O.localContent!==null,S=O.remoteContent!==null,E=O.hasConflicts}else a&&(this.J.trace(`${this.w}: Remote settings does not exist. Synchronizing settings for the first time.`),s=a.value.toString().trim()||"{}",this.Mb(s),S=!0);const A=a?a.value.toString():null,N=r?.settings??null,M={content:E?N:s,localChange:c?2:0,remoteChange:S?2:0,hasConflicts:E};return[{fileContent:a,baseResource:this.baseResource,baseContent:N,localResource:this.localResource,localContent:A,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:n?n.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async rb(b){const C=this.Hb(b);if(C===null)return!0;const t=await this.r(),a=t?t.value.toString().trim():"",i=await this.Lb(),n=await this.yb();return(0,m.merge)(a||"{}",C.settings,C.settings,i,[],n).remoteContent!==null}async ob(b,C){const t=await this.yb(),a=await this.Lb();return{...b.previewResult,content:b.previewResult.content?(0,m.updateIgnoredSettings)(b.previewResult.content,"{}",a,t):null}}async pb(b,C,t,a){const i=await this.yb(),n=await this.Lb();if(this.h.isEqual(C,this.localResource))return{content:b.fileContent?(0,m.updateIgnoredSettings)(b.fileContent.value.toString(),"{}",n,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(C,this.remoteResource))return{content:b.remoteContent!==null?(0,m.updateIgnoredSettings)(b.remoteContent,b.fileContent?b.fileContent.value.toString():"{}",n,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(C,this.previewResource))return t===void 0?{content:b.previewResult.content,localChange:b.previewResult.localChange,remoteChange:b.previewResult.remoteChange}:{content:t!==null?(0,m.updateIgnoredSettings)(t,b.fileContent?b.fileContent.value.toString():"{}",n,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${C.toString()}`)}async qb(b,C,t,a){const{fileContent:i}=t[0][0];let{content:n,localChange:r,remoteChange:o}=t[0][1];if(r===0&&o===0&&this.J.info(`${this.w}: No changes found during synchronizing settings.`),n=n?n.trim():"{}",n=n||"{}",this.Mb(n),r!==0&&(this.J.trace(`${this.w}: Updating local settings...`),i&&await this.kb(JSON.stringify(this.Jb(i.value.toString()))),await this.sb(n,i,a),await this.L.reloadConfiguration(3),this.J.info(`${this.w}: Updated local settings`)),o!==0){const s=await this.yb(),c=this.Hb(b),S=await this.Lb(n);n=(0,m.updateIgnoredSettings)(n,c?c.settings:"{}",S,s),this.J.trace(`${this.w}: Updating remote settings...`),b=await this.jb(JSON.stringify(this.Jb(n)),a?null:b.ref),this.J.info(`${this.w}: Updated remote settings`)}try{await this.z.del(this.previewResource)}catch{}C?.ref!==b.ref&&(this.J.trace(`${this.w}: Updating last synchronized settings...`),await this.cb(b),this.J.info(`${this.w}: Updated last synchronized settings`))}async hasLocalData(){try{const b=await this.r();if(b){const C=await this.yb(),t=(0,h.edit)(b.value.toString(),[y.CONFIGURATION_SYNC_STORE_KEY],void 0,C);return!(0,m.isEmpty)(t)}}catch(b){if(b.fileOperationResult!==1)return!0}return!1}async resolveContent(b){return this.h.isEqual(this.remoteResource,b)||this.h.isEqual(this.localResource,b)||this.h.isEqual(this.acceptedResource,b)||this.h.isEqual(this.baseResource,b)?this.ab(b):null}async ab(b){let C=await super.ab(b);if(C){const t=await this.yb(),a=await this.Lb();C=(0,m.updateIgnoredSettings)(C,"{}",a,t)}return C}Hb(b){return b.syncData?this.Ib(b.syncData.content):null}Ib(b){try{return u(b)}catch(C){this.J.error(C)}return null}Jb(b){return{settings:b}}async Lb(b){if(!this.Kb){this.Kb=this.vb.resolveDefaultIgnoredSettings();const t=k.Event.any(k.Event.filter(this.Ab.onDidInstallExtensions,a=>a.some(({local:i})=>!!i)),k.Event.filter(this.Ab.onDidUninstallExtension,a=>!a.error))(()=>{t.dispose(),this.Kb=void 0})}const C=await this.Kb;return(0,m.getIgnoredSettings)(C,this.L,b)}Mb(b){if(this.wb(b,!1))throw new y.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};d=ye([Y(2,I.IFileService),Y(3,T.IEnvironmentService),Y(4,v.IStorageService),Y(5,y.IUserDataSyncStoreService),Y(6,y.IUserDataSyncBackupStoreService),Y(7,y.IUserDataSyncLogService),Y(8,y.IUserDataSyncUtilService),Y(9,l.IConfigurationService),Y(10,y.IUserDataSyncEnablementService),Y(11,P.ITelemetryService),Y(12,R.IExtensionManagementService),Y(13,w.IUriIdentityService)],d),e.SettingsSynchroniser=d}),define(ne[124],se([0,1,17,3,32,16,15,14,20,19,30,41,264,22]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsSynchroniser=e.parseSnippets=void 0;function m(f){return JSON.parse(f.content)}e.parseSnippets=m;let y=class extends w.AbstractSynchroniser{constructor(u,d,p,b,C,t,a,i,n,r,o,s){super({syncResource:"snippets",profile:u},d,b,p,C,t,a,r,o,i,n,s),this.mb=1,this.r=u.snippetsHome,this.B(this.z.watch(p.userRoamingDataHome)),this.B(this.z.watch(this.r)),this.B(L.Event.filter(this.z.onDidFilesChange,c=>c.affects(this.r))(()=>this.M()))}async nb(u,d,p){const b=await this.Db(),C=this.Cb(b),t=u.syncData?this.Bb(u.syncData):null;d=d===null&&p?u:d;const a=d&&d.syncData?this.Bb(d.syncData):null;t?this.J.trace(`${this.w}: Merging remote snippets with local snippets...`):this.J.trace(`${this.w}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,g.merge)(C,t,a);return this.xb(i,b,t||{},a||{})}async rb(u){const d=u.syncData?this.Bb(u.syncData):null;if(d===null)return!0;const p=await this.Db(),b=this.Cb(p),C=(0,g.merge)(b,d,d);return Object.keys(C.remote.added).length>0||Object.keys(C.remote.updated).length>0||C.remote.removed.length>0||C.conflicts.length>0}async ob(u,d){return u.previewResult}async pb(u,d,p,b){if(this.h.isEqualOrParent(d,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:u.fileContent?u.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(d,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:u.remoteContent,localChange:u.remoteContent!==null?u.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(d,this.g))return p===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:p,localChange:p===null?u.fileContent!==null?3:0:2,remoteChange:p===null?u.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async qb(u,d,p,b){const C=p.map(([t,a])=>({...t,acceptResult:a}));C.every(({localChange:t,remoteChange:a})=>t===0&&a===0)&&this.J.info(`${this.w}: No changes found during synchronizing snippets.`),C.some(({localChange:t})=>t!==0)&&(await this.yb(C),await this.zb(C,b)),C.some(({remoteChange:t})=>t!==0)&&(u=await this.Ab(C,u,b)),d?.ref!==u.ref&&(this.J.trace(`${this.w}: Updating last synchronized snippets...`),await this.cb(u),this.J.info(`${this.w}: Updated last synchronized snippets`));for(const{previewResource:t}of C)try{await this.z.del(t)}catch{}}xb(u,d,p,b){const C=new Map;for(const t of Object.keys(u.local.added)){const a={content:u.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};C.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(u.local.updated)){const a={content:u.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},i=d[t]?d[t].value.toString():null;C.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t],localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of u.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=d[t]?d[t].value.toString():null;C.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t],localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(u.remote.added)){const a={content:u.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},i=d[t]?d[t].value.toString():null;C.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t],localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(u.remote.updated)){const a={content:u.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},i=d[t]?d[t].value.toString():null;C.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t],localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of u.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};C.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of u.conflicts){const a={content:b[t]??null,hasConflicts:!0,localChange:d[t]?2:1,remoteChange:p[t]?2:1},i=d[t]?d[t].value.toString():null;C.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t]||null,localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(d))if(!C.has(t)){const a={content:d[t]?d[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=d[t]?d[t].value.toString():null;C.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:b[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t]||null,localContent:i,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:p[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...C.values()]}async resolveContent(u){return this.h.isEqualOrParent(u,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(u,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(u,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(u,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.ab(u):null}async hasLocalData(){try{const u=await this.Db();if(Object.keys(u).length)return!0}catch{}return!1}async yb(u){const d={};for(const p of u)p.fileContent&&(d[this.h.basename(p.localResource)]=p.fileContent);await this.kb(JSON.stringify(this.Cb(d)))}async zb(u,d){for(const{fileContent:p,acceptResult:b,localResource:C,remoteResource:t,localChange:a}of u)if(a!==0){const i=t?this.h.basename(t):this.h.basename(C),n=this.h.joinPath(this.r,i);a===3?(this.J.trace(`${this.w}: Deleting snippet...`,this.h.basename(n)),await this.z.del(n),this.J.info(`${this.w}: Deleted snippet`,this.h.basename(n))):a===1?(this.J.trace(`${this.w}: Creating snippet...`,this.h.basename(n)),await this.z.createFile(n,k.VSBuffer.fromString(b.content),{overwrite:d}),this.J.info(`${this.w}: Created snippet`,this.h.basename(n))):(this.J.trace(`${this.w}: Updating snippet...`,this.h.basename(n)),await this.z.writeFile(n,k.VSBuffer.fromString(b.content),d?void 0:p),this.J.info(`${this.w}: Updated snippet`,this.h.basename(n)))}}async Ab(u,d,p){const b=d.syncData?this.Bb(d.syncData):{},C=(0,l.deepClone)(b);for(const{acceptResult:t,localResource:a,remoteResource:i,remoteChange:n}of u)if(n!==0){const r=a?this.h.basename(a):this.h.basename(i);n===3?delete C[r]:C[r]=t.content}return(0,g.areSame)(b,C)||(this.J.trace(`${this.w}: Updating remote snippets...`),d=await this.jb(JSON.stringify(C),p?null:d.ref),this.J.info(`${this.w}: Updated remote snippets`)),d}Bb(u){return m(u)}Cb(u){const d={};for(const p of Object.keys(u))d[p]=u[p].value.toString();return d}async Db(){const u={};let d;try{d=await this.z.resolve(this.r)}catch(p){if(p instanceof R.FileOperationError&&p.fileOperationResult===1)return u;throw p}for(const p of d.children||[]){const b=p.resource,C=this.h.extname(b);if(C===".json"||C===".code-snippets"){const t=this.h.relativePath(this.r,b),a=await this.z.readFile(b);u[t]=a}}return u}};y=ye([Y(2,T.IEnvironmentService),Y(3,R.IFileService),Y(4,I.IStorageService),Y(5,h.IUserDataSyncStoreService),Y(6,h.IUserDataSyncBackupStoreService),Y(7,h.IUserDataSyncLogService),Y(8,D.IConfigurationService),Y(9,h.IUserDataSyncEnablementService),Y(10,v.ITelemetryService),Y(11,P.IUriIdentityService)],y),e.SnippetsSynchroniser=y}),define(ne[125],se([0,1,16,15,14,20,19,30,41,22]),function(Z,e,k,L,l,D,T,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function P(h,m){try{return JSON.parse(h).tasks??null}catch(y){return m.error(y),null}}e.getTasksContentFromSyncContent=P;let w=class extends I.AbstractFileSynchroniser{constructor(m,y,f,u,d,p,b,C,t,a,i,n){super(m.tasksResource,{syncResource:"tasks",profile:m},y,C,t,a,f,u,b,i,d,p,n),this.mb=1,this.wb=this.h.joinPath(this.g,"tasks.json"),this.xb=this.wb.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.yb=this.wb.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.zb=this.wb.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Ab=this.wb.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async nb(m,y,f,u){const d=m.syncData?P(m.syncData.content,this.J):null;y=y===null&&f?m:y;const p=y?.syncData?P(y.syncData.content,this.J):null,b=await this.r();let C=null,t=!1,a=!1,i=!1;if(m.syncData){const o=b?b.value.toString():null;if(!p||p!==o||p!==d){this.J.trace(`${this.w}: Merging remote tasks with local tasks...`);const s=g(o,d,p);C=s.content,i=s.hasConflicts,t=s.hasLocalChanged,a=s.hasRemoteChanged}}else b&&(this.J.trace(`${this.w}: Remote tasks does not exist. Synchronizing tasks for the first time.`),C=b.value.toString(),a=!0);const n={content:i?p:C,localChange:t?b?2:1:0,remoteChange:a?2:0,hasConflicts:i},r=b?b.value.toString():null;return[{fileContent:b,baseResource:this.xb,baseContent:p,localResource:this.yb,localContent:r,localChange:n.localChange,remoteResource:this.zb,remoteContent:d,remoteChange:n.remoteChange,previewResource:this.wb,previewResult:n,acceptedResource:this.Ab}]}async rb(m){const y=m?.syncData?P(m.syncData.content,this.J):null;if(y===null)return!0;const f=await this.r(),u=f?f.value.toString():null,d=g(u,y,y);return d.hasLocalChanged||d.hasRemoteChanged}async ob(m,y){return m.previewResult}async pb(m,y,f,u){if(this.h.isEqual(y,this.yb))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(y,this.zb))return{content:m.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(y,this.wb))return f===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:f,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${y.toString()}`)}async qb(m,y,f,u){const{fileContent:d}=f[0][0],{content:p,localChange:b,remoteChange:C}=f[0][1];if(b===0&&C===0&&this.J.info(`${this.w}: No changes found during synchronizing tasks.`),b!==0&&(this.J.trace(`${this.w}: Updating local tasks...`),d&&await this.kb(JSON.stringify(this.Gb(d.value.toString()))),p?await this.sb(p,d,u):await this.tb(),this.J.info(`${this.w}: Updated local tasks`)),C!==0){this.J.trace(`${this.w}: Updating remote tasks...`);const t=JSON.stringify(this.Gb(p));m=await this.jb(t,u?null:m.ref),this.J.info(`${this.w}: Updated remote tasks`)}try{await this.z.del(this.wb)}catch{}y?.ref!==m.ref&&(this.J.trace(`${this.w}: Updating last synchronized tasks...`),await this.cb(m),this.J.info(`${this.w}: Updated last synchronized tasks`))}async hasLocalData(){return this.z.exists(this.p)}async resolveContent(m){return this.h.isEqual(this.zb,m)||this.h.isEqual(this.xb,m)||this.h.isEqual(this.yb,m)||this.h.isEqual(this.Ab,m)?this.ab(m):null}Gb(m){return m?{tasks:m}:{}}};w=ye([Y(2,v.IUserDataSyncStoreService),Y(3,v.IUserDataSyncBackupStoreService),Y(4,v.IUserDataSyncLogService),Y(5,k.IConfigurationService),Y(6,v.IUserDataSyncEnablementService),Y(7,l.IFileService),Y(8,L.IEnvironmentService),Y(9,D.IStorageService),Y(10,T.ITelemetryService),Y(11,R.IUriIdentityService)],w),e.TasksSynchroniser=w;function g(h,m,y){if(h===null&&m===null&&y===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(h===m)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const f=y!==h,u=y!==m;return!f&&!u?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:f&&!u?{content:h,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:u&&!f?{content:m,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:h,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[126],se([0,1,42,16,15,14,20,19,30,28,41,265,22]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let h=class extends P.AbstractSynchroniser{constructor(u,d,p,b,C,t,a,i,n,r,o,s,c){super({syncResource:"profiles",profile:u},d,b,C,t,a,i,o,s,n,r,c),this.sb=p,this.mb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?y(u.syncData):null}async getRemoteSyncedProfiles(u){const d=await this.getLastSyncUserData(),p=await this.R(u,d);return p?.syncData?y(p.syncData):null}async nb(u,d,p){if(!this.sb.isEnabled())throw new g.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const b=u.syncData?y(u.syncData):null,C=d?.syncData?y(d.syncData):null,t=this.Ab(),{local:a,remote:i}=(0,w.merge)(t,b,C,[]),n={local:a,remote:i,content:C?this.Bb(C):null,localChange:a.added.length>0||a.removed.length>0||a.updated.length>0?2:0,remoteChange:i!==null?2:0},r=m(t,!1);return[{baseResource:this.baseResource,baseContent:C?this.Bb(C):null,localResource:this.localResource,localContent:r,remoteResource:this.remoteResource,remoteContent:b?this.Bb(b):null,remoteProfiles:b,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async rb(u){const d=u?.syncData?y(u.syncData):null,p=this.Ab(),{remote:b}=(0,w.merge)(p,d,d,[]);return!!b?.added.length||!!b?.removed.length||!!b?.updated.length}async ob(u,d){return{...u.previewResult,hasConflicts:!1}}async pb(u,d,p,b){if(this.h.isEqual(d,this.localResource))return this.xb(u);if(this.h.isEqual(d,this.remoteResource))return this.yb(u);if(this.h.isEqual(d,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async xb(u){const d=this.Ab(),p=(0,w.merge)(d,null,null,[]),{local:b,remote:C}=p;return{content:u.localContent,local:b,remote:C,localChange:b.added.length>0||b.removed.length>0||b.updated.length>0?2:0,remoteChange:C!==null?2:0}}async yb(u){const d=u.remoteContent?JSON.parse(u.remoteContent):null,p=[],b=[];for(const C of this.Ab()){const t=d?.find(a=>a.id===C.id);t&&(p.push({id:C.id,name:C.name,collection:t.collection}),b.push(C))}if(d!==null){const C=(0,w.merge)(b,d,p,[]),{local:t,remote:a}=C;return{content:u.remoteContent,local:t,remote:a,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:a!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(u,d,p,b){const{local:C,remote:t,localChange:a,remoteChange:i}=p[0][1];a===0&&i===0&&this.J.info(`${this.w}: No changes found during synchronizing profiles.`);const n=p[0][0].remoteProfiles||[];if(n.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new g.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(a!==0){await this.kb(m(this.Ab(),!1));const r=[];for(const o of C.added)r.push((async()=>{this.J.trace(`${this.w}: Creating '${o.name}' profile...`),await this.sb.createProfile(o.id,o.name,{shortName:o.shortName}),this.J.info(`${this.w}: Created profile '${o.name}'.`)})());for(const o of C.removed)r.push((async()=>{this.J.trace(`${this.w}: Removing '${o.name}' profile...`),await this.sb.removeProfile(o),this.J.info(`${this.w}: Removed profile '${o.name}'.`)})());for(const o of C.updated){const s=this.sb.profiles.find(c=>c.id===o.id);s?r.push((async()=>{this.J.trace(`${this.w}: Updating '${o.name}' profile...`),await this.sb.updateProfile(s,{name:o.name,shortName:o.shortName}),this.J.info(`${this.w}: Updated profile '${o.name}'.`)})()):this.J.info(`${this.w}: Could not find profile with id '${o.id}' to update.`)}await Promise.all(r)}if(i!==0){this.J.trace(`${this.w}: Updating remote profiles...`);const r=[],o=n.length+(t?.added.length??0)<=20;if(o)for(const s of t?.added||[]){const c=await this.F.createCollection(this.y);r.push(c),n.push({id:s.id,name:s.name,collection:c,shortName:s.shortName})}else this.J.info(`${this.w}: Could not create remote profiles as there are too many profiles.`);for(const s of t?.removed||[])n.splice(n.findIndex(({id:c})=>s.id===c),1);for(const s of t?.updated||[]){const c=n.find(({id:S})=>s.id===S);c&&n.splice(n.indexOf(c),1,{id:s.id,name:s.name,collection:c.collection,shortName:s.shortName})}try{u=await this.updateRemoteProfiles(n,b?null:u.ref),this.J.info(`${this.w}: Updated remote profiles.${o&&t?.added.length?` Added: ${JSON.stringify(t.added.map(s=>s.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(s=>s.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(s=>s.name))}.`:""}`)}catch(s){if(r.length){this.J.info(`${this.w}: Failed to update remote profiles. Cleaning up added collections...`);for(const c of r)await this.F.deleteCollection(c,this.y)}throw s}for(const s of t?.removed||[])await this.F.deleteCollection(s.collection,this.y)}d?.ref!==u.ref&&(this.J.trace(`${this.w}: Updating last synchronized profiles...`),await this.cb(u),this.J.info(`${this.w}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,d){return this.jb(this.Bb(u),d)}async hasLocalData(){return this.Ab().length>0}async resolveContent(u){if(this.h.isEqual(this.remoteResource,u)||this.h.isEqual(this.baseResource,u)||this.h.isEqual(this.localResource,u)||this.h.isEqual(this.acceptedResource,u)){const d=await this.ab(u);return d&&(0,k.toFormattedString)(JSON.parse(d),{})}return null}Ab(){return this.sb.profiles.filter(u=>!u.isDefault&&!u.isTransient)}Bb(u){return JSON.stringify([...u].sort((d,p)=>d.name.localeCompare(p.name)))}};h=ye([Y(2,v.IUserDataProfilesService),Y(3,D.IFileService),Y(4,l.IEnvironmentService),Y(5,T.IStorageService),Y(6,g.IUserDataSyncStoreService),Y(7,g.IUserDataSyncBackupStoreService),Y(8,g.IUserDataSyncLogService),Y(9,L.IConfigurationService),Y(10,g.IUserDataSyncEnablementService),Y(11,R.ITelemetryService),Y(12,I.IUriIdentityService)],h),e.UserDataProfilesManifestSynchroniser=h;function m(f,u){const d=[...f].sort((p,b)=>p.name.localeCompare(b.name)).map(p=>({id:p.id,name:p.name}));return u?(0,k.toFormattedString)(d,{}):JSON.stringify(d)}e.stringifyLocalProfiles=m;function y(f){return JSON.parse(f.content)}e.parseUserDataProfilesManifest=y}),define(ne[282],se([0,1,6,17,64,2,24,16,15,14,28,22]),function(Z,e,k,L,l,D,T,R,I,v,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let g=class extends D.Disposable{constructor(m,y,f,u,d){super(),this.a=m,this.b=y,this.c=f,this.f=u,this.g=d,this.h()}async h(){for(const y of this.g.profiles)for(const f of w.ALL_SYNC_RESOURCES)try{await this.j(this.i(y,f))}catch(u){this.f.error(u)}let m;try{m=await this.b.resolve(this.a.userDataSyncHome)}catch(y){(0,v.toFileOperationResult)(y)!==1&&this.f.error(y);return}if(m.children){for(const y of m.children)if(y.isDirectory&&!this.g.profiles.some(f=>f.id===y.name))try{this.f.info("Deleting non existing profile from backup",y.resource.path),await this.b.del(y.resource,{recursive:!0})}catch(f){this.f.error(f)}}}async getAllRefs(m,y){const f=this.i(m,y);try{const u=await this.b.resolve(f);if(u.children)return u.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.k(p)}))}catch(u){if((0,v.toFileOperationResult)(u)!==1)throw u}return[]}async resolveContent(m,y,f){const u=this.i(m,y),d=(0,T.joinPath)(u,f);try{return(await this.b.readFile(d)).value.toString()}catch(p){return this.f.error(p),null}}async backup(m,y,f){const u=this.i(m,y),d=(0,T.joinPath)(u,`${(0,l.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,L.VSBuffer.fromString(f))}catch(p){this.f.error(p)}try{this.j(u)}catch{}}i(m,y){return(0,T.joinPath)(this.a.userDataSyncHome,...m.isDefault?[y]:[m.id,y])}async j(m){try{try{if(!await this.b.exists(m))return}catch{return}const y=await this.b.resolve(m);if(y.children){const f=y.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort(),u=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let d=f.filter(b=>Date.now()-this.k(b)>u);const p=f.length-d.length;p<10&&(d=d.slice(10-p)),await k.Promises.settled(d.map(async b=>{this.f.info("Deleting from backup",b.resource.path),await this.b.del(b.resource)}))}}catch(y){this.f.error(y)}}k(m){return m.ctime||new Date(parseInt(m.name.substring(0,4)),parseInt(m.name.substring(4,6))-1,parseInt(m.name.substring(6,8)),parseInt(m.name.substring(9,11)),parseInt(m.name.substring(11,13)),parseInt(m.name.substring(13,15))).getTime()}};g=ye([Y(0,I.IEnvironmentService),Y(1,v.IFileService),Y(2,R.IConfigurationService),Y(3,w.IUserDataSyncLogService),Y(4,P.IUserDataProfilesService)],g),e.UserDataSyncBackupStoreService=g}),define(ne[283],se([0,1,3,2,4,15,20,19,22]),function(Z,e,k,L,l,D,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const v="sync.enable";let P=class extends L.Disposable{constructor(g,h,m,y){super(),this.c=g,this.f=h,this.g=m,this.h=y,this.a=new k.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new k.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(g.onDidChangeValue(f=>this.j(f)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(v,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(g){g&&!this.canToggleEnablement()||(this.f.publicLog2(v,{enabled:g}),this.c.store(v,g,-1,1))}isResourceEnabled(g){return this.c.getBoolean((0,I.getEnablementKey)(g),-1,!0)}setResourceEnablement(g,h){if(this.isResourceEnabled(g)!==h){const m=(0,I.getEnablementKey)(g);this.i(m,h)}}getResourceSyncStateVersion(g){}i(g,h){this.c.store(g,h,-1,l.isWeb?0:1)}j(g){if(g.scope!==-1)return;if(v===g.key){this.a.fire(this.isEnabled());return}const h=I.ALL_SYNC_RESOURCES.filter(m=>(0,I.getEnablementKey)(m)===g.key)[0];if(h){this.b.fire([h,this.isResourceEnabled(h)]);return}}};P=ye([Y(0,T.IStorageService),Y(1,R.ITelemetryService),Y(2,D.IEnvironmentService),Y(3,I.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(ne[80],se([0,1,3,2,4,26,188,15,14,5,25,44,20,22]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,v.createDecorator)("IUserDataSyncMachinesService");const m="sync.currentMachineName",y="Safari",f="Chrome",u="Edge",d="Firefox",p="Android";function b(a){switch(a){case y:case f:case u:case d:case p:case(0,l.PlatformToString)(0):return!0}return!1}e.isWebPlatform=b;function C(){return l.isSafari?y:l.isChrome?f:l.isEdge?u:l.isFirefox?d:l.isAndroid?p:(0,l.PlatformToString)(l.isWeb?0:l.platform)}let t=class nt extends L.Disposable{constructor(i,n,r,o,s,c){super(),this.h=r,this.i=o,this.j=s,this.k=c,this.c=this.B(new k.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,w.getServiceMachineId)(i,n,r)}async getMachines(i){const n=await this.f;return(await this.m(i)).machines.map(o=>({...o,isCurrent:o.id===n}))}async addCurrentMachine(i){const n=await this.f,r=await this.m(i);r.machines.some(({id:o})=>o===n)||(r.machines.push({id:n,name:this.l(r.machines),platform:C()}),await this.n(r))}async removeCurrentMachine(i){const n=await this.f,r=await this.m(i),o=r.machines.filter(({id:s})=>s!==n);o.length!==r.machines.length&&(r.machines=o,await this.n(r))}async renameMachine(i,n,r){const o=await this.m(r),s=o.machines.find(({id:c})=>c===i);if(s){s.name=n,await this.n(o);const c=await this.f;i===c&&this.h.store(m,n,-1,1)}}async setEnablements(i){const n=await this.m();for(const[r,o]of i){const s=n.machines.find(c=>c.id===r);s&&(s.disabled=o?void 0:!0)}await this.n(n)}l(i){const n=this.h.get(m,-1);if(n)return n;const r=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${C()} (${this.k.nameShort})`,o=new RegExp(`${(0,D.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let s=0;for(const c of i){const S=o.exec(c.name),E=S?parseInt(S[1]):0;s=E>s?E:s}return`${r} #${s+1}`}async m(i){this.g=await this.p(i);const n=this.r(this.g);if(n.version!==nt.a)throw new Error((0,T.localize)(0,null,this.k.nameLong));return n}async n(i){const n=JSON.stringify(i),r=await this.i.writeResource(nt.b,n,this.g?.ref||null);this.g={ref:r,content:n},this.c.fire()}async p(i){if(this.g){const n=i&&i.latest?i.latest[nt.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.i.readResource(nt.b,this.g)}r(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(n){this.j.error(n)}return{version:nt.a,machines:[]}}};t.a=1,t.b="machines",t=ye([Y(0,R.IEnvironmentService),Y(1,I.IFileService),Y(2,g.IStorageService),Y(3,h.IUserDataSyncStoreService),Y(4,h.IUserDataSyncLogService),Y(5,P.IProductService)],t),e.UserDataSyncMachinesService=t}),define(ne[284],se([0,1,6,64,39,8,3,2,4,24,10,185,25,20,19,22,77,80]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const d="sync.disableMachineEventually",p="sync.sessionId",b="sync.storeUrl",C="sync.productQuality";let t=class extends R.Disposable{get j(){const n=this.z.get(b,-1);return n?P.URI.parse(n):void 0}set j(n){n?this.z.store(b,n.toString(),-1,1):this.z.remove(b,-1)}get l(){return this.z.get(C,-1)}set l(n){n?this.z.store(C,n,-1,1):this.z.remove(C,-1)}constructor(n,r,o,s,c,S,E,A,N,M){super(),this.n=r,this.p=o,this.r=s,this.s=c,this.u=S,this.v=E,this.w=A,this.y=N,this.z=M,this.a=this.B(new R.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new T.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new k.ThrottledDelayer(this.O())),this.i=this.j,this.j=r.userDataSyncStore?.url,this.k=this.l,this.l=n.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(r.onDidChangeUserDataSyncStore(()=>{(0,v.isEqual)(this.j,r.userDataSyncStore?.url)||(this.i=this.j,this.j=r.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(E.onDidChangeAccount(()=>this.C())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(c.onDidChangeLocal(B=>this.triggerSync([B],!1,!1))),this.B(T.Event.filter(this.r.onDidChangeResourceEnablement,([,B])=>B)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:n,message:r}=this.F();n?this.a.value===void 0&&(this.a.value=new a(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.I(o))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(r&&this.u.info(r),this.a.clear()):r&&this.r.isEnabled()&&this.u.info(r))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(n,r,o){try{this.v.account&&!o&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(p,-1),n?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(s){if(this.u.error(s),r)this.G(!1);else throw s}}G(n){this.r.isEnabled()!==n&&(this.r.setEnablement(n),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(n){if(!n){this.b=0;return}const r=y.UserDataSyncError.toUserDataSyncError(n);r instanceof y.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:r.code,service:this.n.userDataSyncStore.url.toString()}),r.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):r.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):r.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):r.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):r.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):r.code==="UpgradeRequired"||r.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):r.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${r.resource} content with newer version than of client. Requires client upgrade.`)):r.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${r.resource} content with older version than of client. Requires server reset.`)):r.code==="ServiceChanged"||r.code==="DefaultServiceChanged"?I.isWeb&&r.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(r),this.b++),this.h.fire(r)}async J(){this.z.store(d,!0,-1,1),await(0,k.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(d,-1,!1)}M(){this.z.remove(d,-1)}async triggerSync(n,r,o){if(this.a.value===void 0)return this.f.cancel();if(r&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...n),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const s=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:s}),this.N=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};t=ye([Y(0,g.IProductService),Y(1,y.IUserDataSyncStoreManagementService),Y(2,y.IUserDataSyncStoreService),Y(3,y.IUserDataSyncEnablementService),Y(4,y.IUserDataSyncService),Y(5,y.IUserDataSyncLogService),Y(6,f.IUserDataSyncAccountService),Y(7,m.ITelemetryService),Y(8,u.IUserDataSyncMachinesService),Y(9,h.IStorageService)],t),e.UserDataAutoSyncService=t;class a extends R.Disposable{constructor(n,r,o,s,c,S,E,A){super(),this.j=n,this.k=r,this.l=o,this.m=s,this.n=c,this.p=S,this.r=E,this.s=A,this.b=this.B(new R.MutableDisposable),this.c=this.B(new T.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new T.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,R.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(a.a,!1)}u(){this.b.value=(0,k.disposableTimeout)(()=>this.sync(a.a,!1),this.k)}sync(n,r){const o=(0,k.createCancelablePromise)(async s=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(c){if((0,D.isCancellationError)(c))return}return this.y(n,r,s)});return this.i=o,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,v.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const n=await this.l.getPreviousUserDataSyncStore(),r=this.l.userDataSyncStore;return!!r&&!!n&&(!(0,v.isEqual)(r.defaultUrl,n.defaultUrl)||!(0,v.isEqual)(r.insidersUrl,n.insidersUrl)||!(0,v.isEqual)(r.stableUrl,n.stableUrl))}async y(n,r,o){this.r.info(`Auto Sync: Triggered by ${n}`),this.c.fire();let s;try{await this.z(r,o)}catch(c){if(this.r.error(c),s=c,y.UserDataSyncError.toUserDataSyncError(c).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.z(r,o),s=void 0}catch(S){this.r.error(S),s=S}}this.f.fire(s)}async z(n,r){if(this.h=await this.n.createSyncTask(this.g,n),r.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new y.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const o=this.s.get(p,-1);if(o&&this.g&&o!==this.g.session)throw this.v()?await this.w()?new y.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const s=await this.p.getMachines(this.g||void 0);if(r.isCancellationRequested)return;const c=s.find(S=>S.isCurrent);if(c?.disabled)throw new y.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(S){throw new y.UserDataAutoSyncError((0,l.toErrorMessage)(S),S instanceof y.UserDataSyncError?S.code:"Unknown")}this.g&&this.g.session!==o&&this.s.store(p,this.g.session,-1,1),!r.isCancellationRequested&&(c||await this.p.addCurrentMachine(this.g||void 0))}register(n){return super.B(n)}}a.a="Interval"}),define(ne[285],se([0,1,10,189,15,14,44,20,30,22,28,41,124,123,122,16,125,120,121,5,126,42]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u,d,p,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let t=class He{constructor(i,n,r,o,s,c,S,E,A,N){this.e=i,this.f=n,this.g=r,this.h=s,this.i=c,this.j=S,this.k=E,this.l=A,this.m=N,this.d=o.extUri}async getRemoteSyncedProfiles(){const i=await this.e.readResource("profiles",null,void 0);if(i.content){const n=this.K(i.content,"profiles");return(0,b.parseUserDataProfilesManifest)(n)}return[]}async getRemoteSyncResourceHandles(i,n){return(await this.e.getAllResourceRefs(i,n?.collection)).map(({created:o,ref:s})=>({created:o,uri:this.I({remote:!0,syncResource:i,profile:n?.id??this.k.defaultProfile.id,collection:n?.collection,ref:s,node:void 0})}))}async getLocalSyncResourceHandles(i,n){return(await this.f.getAllRefs(n,i)).map(({created:o,ref:s})=>({created:o,uri:this.I({remote:!1,syncResource:i,profile:n.id,collection:void 0,ref:s,node:void 0})}))}resolveUserDataSyncResource({uri:i}){const n=this.J(i),r=n?this.k.profiles.find(o=>o.id===n.profile):void 0;return n&&r?{profile:r,syncResource:n?.syncResource}:void 0}async getAssociatedResources({uri:i}){const n=this.J(i);if(!n)return[];const r=this.k.profiles.find(o=>o.id===n.profile);switch(n.syncResource){case"settings":return this.r(i,r);case"keybindings":return this.t(i,r);case"tasks":return this.v(i,r);case"snippets":return this.x(i,r);case"globalState":return this.C(i,r);case"extensions":return this.z(i,r);case"profiles":return this.F(i,r)}}async getMachineId({uri:i}){const n=this.J(i);if(!!n){if(n.remote){if(n.ref){const{content:r}=await this.L(n.syncResource,n.ref,n.collection);if(r)return this.K(r,n.syncResource)?.machineId}return}return(0,T.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(i){const n=this.J(i);if(!n||n.node===He.a)return null;if(n.ref){const r=await this.n(n.remote,n.syncResource,n.profile,n.collection,n.ref);return n.node&&r?this.o(n.syncResource,r,n.node):r}return!n.remote&&!n.node?this.q(n.syncResource,n.profile):null}async n(i,n,r,o,s){if(i){const{content:S}=await this.L(n,s,o);return S}const c=this.k.profiles.find(S=>S.id===r);return c?this.f.resolveContent(c,n,s):null}o(i,n,r){const o=this.K(n,i);switch(i){case"settings":return this.s(o,r);case"keybindings":return this.u(o,r);case"tasks":return this.w(o,r);case"snippets":return this.y(o,r);case"globalState":return this.D(o,r);case"extensions":return this.A(o,r);case"profiles":return this.G(o,r)}}async q(i,n){const r=this.k.profiles.find(o=>o.id===n);if(!r)return null;switch(i){case"globalState":return this.E(r);case"extensions":return this.B(r);case"profiles":return this.H(r);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(i,n){const r=this.d.joinPath(i,"settings.json"),o=n?n.settingsResource:this.d.joinPath(i,He.a);return[{resource:r,comparableResource:o}]}s(i,n){switch(n){case"settings.json":return(0,h.parseSettingsSyncContent)(i.content).settings}return null}t(i,n){const r=this.d.joinPath(i,"keybindings.json"),o=n?n.keybindingsResource:this.d.joinPath(i,He.a);return[{resource:r,comparableResource:o}]}u(i,n){switch(n){case"keybindings.json":return(0,m.getKeybindingsContentFromSyncContent)(i.content,!!this.l.getValue(v.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(i,n){const r=this.d.joinPath(i,"tasks.json"),o=n?n.tasksResource:this.d.joinPath(i,He.a);return[{resource:r,comparableResource:o}]}w(i,n){switch(n){case"tasks.json":return(0,f.getTasksContentFromSyncContent)(i.content,this.g)}return null}async x(i,n){const r=await this.resolveContent(i);if(r){const o=this.K(r,"snippets");if(o){const s=(0,g.parseSnippets)(o),c=[];for(const S of Object.keys(s)){const E=this.d.joinPath(i,S),A=n?this.d.joinPath(n.snippetsHome,S):this.d.joinPath(i,He.a);c.push({resource:E,comparableResource:A})}return c}}return[]}y(i,n){return(0,g.parseSnippets)(i)[n]||null}z(i,n){const r=this.d.joinPath(i,"extensions.json"),o=n?this.I({remote:!1,syncResource:"extensions",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,He.a);return[{resource:r,comparableResource:o}]}A(i,n){switch(n){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(i),!0)}return null}async B(i){const{localExtensions:n}=await this.m.createInstance(u.LocalExtensionsProvider).getLocalExtensions(i);return(0,u.stringify)(n,!0)}C(i,n){const r=this.d.joinPath(i,"globalState.json"),o=n?this.I({remote:!1,syncResource:"globalState",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,He.a);return[{resource:r,comparableResource:o}]}D(i,n){switch(n){case"globalState.json":return(0,d.stringify)(JSON.parse(i.content),!0)}return null}async E(i){const n=await this.m.createInstance(d.LocalGlobalStateProvider).getLocalGlobalState(i);return(0,d.stringify)(n,!0)}F(i,n){const r=this.d.joinPath(i,"profiles.json"),o=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:r,comparableResource:o}]}G(i,n){switch(n){case"profiles.json":return(0,C.toFormattedString)(JSON.parse(i.content),{})}return null}async H(i){return(0,b.stringifyLocalProfiles)(this.k.profiles.filter(n=>!n.isDefault&&!n.isTransient),!0)}I(i){const n=i.remote?He.b:He.c,r=[i.syncResource,i.profile];return i.collection&&r.push(`collection:${i.collection}`),i.ref&&r.push(`ref:${i.ref}`),i.node&&r.push(i.node),this.d.joinPath(k.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:n,path:"/"}),...r)}J(i){if(i.scheme!==v.USER_DATA_SYNC_SCHEME||i.authority!==He.c&&i.authority!==He.b)return;const n=[];for(;i.path!=="/";)n.unshift(this.d.basename(i)),i=this.d.dirname(i);if(n.length<2)return;const r=i.authority===He.b,o=n.shift(),s=n.shift();let c,S,E;for(;n.length;){const A=n.shift();A.startsWith("collection:")?c=A.substring(11):A.startsWith("ref:")?S=A.substring(4):E=A}return{remote:r,syncResource:o,profile:s,collection:c,ref:S,node:E}}K(i,n){try{const r=JSON.parse(i);if((0,w.isSyncData)(r))return r}catch(r){this.g.error(r)}throw new v.UserDataSyncError((0,L.localize)(0,null),"IncompatibleRemoteContent",n)}async L(i,n,r){const o=await this.e.resolveResourceContent(i,n,r);return{ref:n,content:o}}};t.a="not-existing-resource",t.b="remote-backup",t.c="local-backup",t=ye([Y(0,v.IUserDataSyncStoreService),Y(1,v.IUserDataSyncBackupStoreService),Y(2,v.IUserDataSyncLogService),Y(3,I.IUriIdentityService),Y(4,l.IEnvironmentService),Y(5,R.IStorageService),Y(6,D.IFileService),Y(7,P.IUserDataProfilesService),Y(8,y.IConfigurationService),Y(9,p.IInstantiationService)],t),e.UserDataSyncResourceProviderService=t}),define(ne[286],se([0,1,18,6,23,39,3,2,24,12,31,16,29,5,20,19,28,120,121,122,123,124,125,126,22]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u,d,p,b,C,t,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const n="sync.lastSyncTime";let r=class extends R.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(E,A,N,M,B,O,j,q,K){super(),this.v=E,this.w=A,this.y=N,this.z=M,this.C=B,this.D=O,this.F=j,this.G=q,this.H=K,this.f="uninitialized",this.g=this.B(new T.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new T.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new T.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new T.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new T.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new T.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new T.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=A.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(n,-1,void 0),this.B((0,R.toDisposable)(()=>this.W()))}async createSyncTask(E,A){this.X(),this.z.info("Sync started.");const N=new Date().getTime(),M=(0,P.generateUuid)();try{const q=(0,i.createSyncHeaders)(M);A&&(q["Cache-Control"]="no-cache"),E=await this.v.manifest(E,q)}catch(q){const K=i.UserDataSyncError.toUserDataSyncError(q);throw c(K,M,this.w,this.C),K}const B=!1,O=this;let j;return{manifest:E,async run(){if(B)throw new Error("Can run a task only once");j=(0,L.createCancelablePromise)(q=>O.I(E,!1,M,q)),await j.finally(()=>j=void 0),O.z.info(`Sync done. Took ${new Date().getTime()-N}ms`),O.S()},stop(){return j?.cancel(),O.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new i.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const E=new Date().getTime(),A=(0,P.generateUuid)(),N=(0,i.createSyncHeaders)(A);let M;try{M=await this.v.manifest(null,N)}catch(j){const q=i.UserDataSyncError.toUserDataSyncError(j);throw c(q,A,this.w,this.C),q}await this.resetLocal();const B=this,O=new l.CancellationTokenSource;return{id:A,async merge(){return B.I(M,!0,A,O.token)},async apply(){try{try{await B.L(M,A,O.token)}catch(j){if(i.UserDataSyncError.toUserDataSyncError(j).code==="MethodNotFound")B.z.info("Client is making invalid requests. Cleaning up data..."),await B.cleanUpRemoteData(),B.z.info("Applying manual sync again..."),await B.L(M,A,O.token);else throw j}}catch(j){throw B.z.error(j),j}B.z.info(`Sync done. Took ${new Date().getTime()-E}ms`),B.S()},async stop(){O.cancel(),await B.N(),await B.resetLocal()}}}async I(E,A,N,M){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const B=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(B,E,A,N,M));const O=B.enabled.find(j=>j.resource==="profiles");if(O){const j=await O.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.J(j,E,A,N,M)}}finally{this.l.fire(this.k)}}async J(E,A,N,M,B){for(const O of E){if(B.isCancellationRequested)return;const j=this.G.profiles.find(K=>K.id===O.id);if(!j){this.z.error(`Profile with id:${O.id} and name: ${O.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",O.name);const q=this.getOrCreateActiveProfileSynchronizer(j,O);this.k.push(...await this.M(q,A,N,M,B))}for(const[O,j]of this.u.entries())this.G.profiles.some(q=>q.id===j[0].profile.id)||(j[1].dispose(),this.u.delete(O))}async L(E,A,N){const M=this.U();for(const K of M){if(N.isCancellationRequested)return;await K.apply(A,N)}const B=M.find(K=>K.profile.isDefault);if(!B)return;const O=B.enabled.find(K=>K.resource==="profiles");if(!O)return;const q=(await O.getRemoteSyncedProfiles(E?.latest??null)||[]).filter(K=>M.every(Q=>Q.profile.id!==K.id));q.length&&await this.J(q,E,!1,A,N)}async M(E,A,N,M,B){return(await E.sync(A,N,M,B)).map(([j,q])=>({profile:E.profile,syncResource:j,error:q}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(E=>E.stop()))}async resolveContent(E){const A=await this.H.resolveContent(E);if(A)return A;for(const N of this.U())for(const M of N.enabled){const B=await M.resolveContent(E);if(B)return B}return null}async replace(E){this.X();const A=this.H.resolveUserDataSyncResource(E);if(!A)return;const N=await this.resolveContent(E.uri);!N||await this.O(A.profile,async M=>{if(A.syncResource===M.resource)return await M.replace(N),!0})}async accept(E,A,N,M){this.X(),await this.O(E.profile,async B=>{if(E.syncResource===B.resource)return await B.accept(A,N),M&&await B.apply((0,v.isBoolean)(M)?!1:M.force,(0,i.createSyncHeaders)((0,P.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(E,A){return this.H.getRemoteSyncResourceHandles(E,A)}async getLocalSyncResourceHandles(E,A){return this.H.getLocalSyncResourceHandles(E,A??this.G.defaultProfile)}async getAssociatedResources(E){return this.H.getAssociatedResources(E)}async getMachineId(E){return this.H.getMachineId(E)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async A=>{if(A.resource!=="globalState"&&await A.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async A=>{if(await A.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(E){this.z.error(E)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(n,-1);for(const[E]of this.u.values())try{await E.resetLocal()}catch(A){this.z.error(A)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const E=await this.H.getRemoteSyncedProfiles(),A=E.map(O=>O.collection),N=await this.v.getAllCollections(),M=N.filter(O=>!A.includes(O));M.length&&(this.z.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(O=>this.v.deleteCollection(O))),this.z.info("Deleted redundant collections on server"));const B=E.filter(O=>N.includes(O.collection));if(B.length!==E.length){this.z.info("Updating remote profiles with invalid collections on server");const O=this.y.createInstance(a.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await O.updateRemoteProfiles(B,null),this.z.info("Updated remote profiles on server")}finally{O.dispose()}}}async O(E,A){const N=new R.DisposableStore;try{const M=this.u.get(E.id);if(M){const K=await this.P(M[0],A,N);return(0,v.isUndefined)(K)?null:K}if(E.isDefault){const K=N.add(this.y.createInstance(o,E,void 0)),Q=await this.P(K,A,N);return(0,v.isUndefined)(Q)?null:Q}if(this.G.isEnabled())return null;const B=N.add(this.y.createInstance(a.UserDataProfilesManifestSynchroniser,E,void 0)),O=await this.v.manifest(null),q=(await B.getRemoteSyncedProfiles(O?.latest??null)||[]).find(K=>K.id===E.id);if(q){const K=N.add(this.y.createInstance(o,E,q.collection)),Q=await this.P(K,A,N);return(0,v.isUndefined)(Q)?null:Q}return null}finally{N.dispose()}}async P(E,A,N){const M=[...E.enabled,...E.disabled.map(B=>N.add(E.createSynchronizer(B)))];for(const B of M){const O=await A(B);if(!(0,v.isUndefined)(O))return O}}Q(E){const A=this.f;this.f!==E&&(this.f=E,this.g.fire(E),A==="hasConflicts"&&this.S())}R(){const E=this.U().map(A=>A.conflicts).flat();(0,k.equals)(this.i,E,(A,N)=>A.profile.id===N.profile.id&&A.syncResource===N.syncResource&&(0,k.equals)(A.conflicts,N.conflicts,(M,B)=>(0,I.isEqual)(M.previewResource,B.previewResource)))||(this.i=E,this.j.fire(E))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(n,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(E,A){let N=this.u.get(E.id);if(N&&N[0].collection!==A?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.u.delete(E.id)),!N){const M=new R.DisposableStore,B=M.add(this.y.createInstance(o,E,A?.collection));M.add(B.onDidChangeStatus(O=>this.Q(O))),M.add(B.onDidChangeConflicts(O=>this.R())),M.add(B.onDidChangeLocal(O=>this.h.fire(O))),this.u.set(E.id,N=[B,M])}return N[0]}U(){const E=[];for(const[A]of this.u.values())E.push(A);return E}W(){this.u.forEach(([,E])=>E.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};r=ye([Y(0,i.IUserDataSyncStoreService),Y(1,i.IUserDataSyncStoreManagementService),Y(2,h.IInstantiationService),Y(3,i.IUserDataSyncLogService),Y(4,y.ITelemetryService),Y(5,m.IStorageService),Y(6,i.IUserDataSyncEnablementService),Y(7,f.IUserDataProfilesService),Y(8,i.IUserDataSyncResourceProviderService)],r),e.UserDataSyncService=r;let o=class extends R.Disposable{get enabled(){return this.f.sort((E,A)=>E[1]-A[1]).map(([E])=>E)}get disabled(){return i.ALL_SYNC_RESOURCES.filter(E=>!this.l.isResourceEnabled(E))}get status(){return this.g}get conflicts(){return this.j}constructor(E,A,N,M,B,O,j,q,K,Q){super(),this.profile=E,this.collection=A,this.l=N,this.m=M,this.n=B,this.r=O,this.t=j,this.u=q,this.v=K,this.w=Q,this.f=[],this.g="idle",this.h=this.B(new T.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new T.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new T.Emitter),this.onDidChangeConflicts=this.k.event,this.B(N.onDidChangeResourceEnablement(([re,J])=>this.y(re,J))),this.B((0,R.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,re])=>re.dispose())));for(const re of i.ALL_SYNC_RESOURCES)N.isResourceEnabled(re)&&this.z(re)}y(E,A){A?this.z(E):this.C(E)}z(E){if(this.f.some(([B])=>B.resource===E))return;if(E==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(E==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled()))return;const A=new R.DisposableStore,N=A.add(this.createSynchronizer(E));A.add(N.onDidChangeStatus(()=>this.G())),A.add(N.onDidChangeConflicts(()=>this.H())),A.add(N.onDidChangeLocal(()=>this.i.fire(E)));const M=this.I(E);this.f.push([N,M,A])}C(E){const A=this.f.findIndex(([N])=>N.resource===E);if(A!==-1){const[[N,,M]]=this.f.splice(A,1);M.dispose(),this.G(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,B=>this.u.error(B))}}createSynchronizer(E){switch(E){case"settings":return this.m.createInstance(b.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(p.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(C.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(t.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(d.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(u.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(a.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(E,A,N,M){if(M.isCancellationRequested)return[];const B=this.enabled;if(!B.length)return[];try{const O=[],j=(0,i.createSyncHeaders)(N),q=(this.collection?E?.collections?.[this.collection]?.latest:E?.latest)??null,K=A?await this.D(q):{};for(const Q of B){if(M.isCancellationRequested)return[];if(!this.l.isResourceEnabled(Q.resource))return[];try{if(A){const re=await Q.preview(q,K,j);if(re)for(const J of re.resourcePreviews)(J.localChange!==0||J.remoteChange!==0)&&J.mergeState==="preview"&&await Q.merge(J.previewResource)}else await Q.sync(q,j)}catch(re){const J=i.UserDataSyncError.toUserDataSyncError(re);if(c(J,N,this.r,this.t),s(re))throw J;this.u.error(re),this.u.error(`${Q.resource}: ${(0,D.toErrorMessage)(re)}`),O.push([Q.resource,J])}}return O}finally{this.G()}}async apply(E,A){const N=(0,i.createSyncHeaders)(E);for(const M of this.enabled){if(A.isCancellationRequested)return;try{await M.apply(!1,N)}catch(B){const O=i.UserDataSyncError.toUserDataSyncError(B);if(c(O,E,this.r,this.t),s(B))throw O;this.u.error(B),this.u.error(`${M.resource}: ${(0,D.toErrorMessage)(B)}`)}}}async stop(){for(const E of this.enabled)try{E.status!=="idle"&&await E.stop()}catch(A){this.u.error(A)}}async resetLocal(){for(const E of this.enabled)try{await E.resetLocal()}catch(A){this.u.error(`${E.resource}: ${(0,D.toErrorMessage)(A)}`),this.u.error(A)}}async D(E){if(!this.profile.isDefault)return{};const A=this.w.getValue(i.USER_DATA_SYNC_CONFIGURATION_SCOPE),N=this.enabled.find(M=>M instanceof b.SettingsSynchroniser);if(N){const M=await N.getRemoteUserDataSyncConfiguration(E);return{...A,...M}}return A}F(E){this.g!==E&&(this.g=E,this.h.fire(E))}G(){return this.H(),this.enabled.some(E=>E.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(E=>E.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const E=this.enabled.filter(A=>A.status==="hasConflicts").filter(A=>A.conflicts.conflicts.length>0).map(A=>A.conflicts);(0,k.equals)(this.j,E,(A,N)=>A.syncResource===N.syncResource&&(0,k.equals)(A.conflicts,N.conflicts,(M,B)=>(0,I.isEqual)(M.previewResource,B.previewResource)))||(this.j=E,this.k.fire(E))}I(E){switch(E){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};o=ye([Y(2,i.IUserDataSyncEnablementService),Y(3,h.IInstantiationService),Y(4,g.IExtensionGalleryService),Y(5,i.IUserDataSyncStoreManagementService),Y(6,y.ITelemetryService),Y(7,i.IUserDataSyncLogService),Y(8,f.IUserDataProfilesService),Y(9,w.IConfigurationService)],o);function s(S){if(S instanceof i.UserDataSyncError)switch(S.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function c(S,E,A,N){N.publicLog2("sync/error",{code:S.code,serverCode:S instanceof i.UserDataSyncStoreError?String(S.serverCode):void 0,url:S instanceof i.UserDataSyncStoreError?S.url:void 0,resource:S.resource,executionId:E,service:A.userDataSyncStore.url.toString()})}}),define(ne[287],se([0,1,3,2,10,28,22]),function(Z,e,k,L,l,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function R(g,h){return{...g,profile:(0,D.reviveProfile)(g.profile,h.profilesHome.scheme)}}function I(g){return{created:g.created,uri:l.URI.revive(g.uri)}}class v{constructor(h,m,y){this.c=h,this.d=m,this.f=y,this.a=new Map,this.b=new k.Emitter}listen(h,m){switch(m){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${m}`)}async call(h,m,y){try{return await this.g(h,m,y)}catch(f){throw this.f.error(f),f}}async g(h,m,y){switch(m){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(l.URI.revive(y[0]));case"accept":return this.c.accept(R(y[0],this.d),l.URI.revive(y[1]),y[2],y[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(y[0],y[1]?(0,D.reviveProfile)(y[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(y[0],y[1]);case"replace":return this.c.replace(I(y[0]));case"getAssociatedResources":return this.c.getAssociatedResources(I(y[0]));case"getMachineId":return this.c.getMachineId(I(y[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(m.startsWith("manualSync/")){const f=m.substring(11),u=y[0],d=this.h(u);switch(y=y.slice(1),f){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.a.delete(this.j(d.id)));case"stop":return d.stop().finally(()=>this.a.delete(this.j(d.id)))}}throw new Error("Invalid call")}h(h){const m=this.a.get(this.j(h));if(!m)throw new Error(`Manual sync taks not found: ${h}`);return m}async i(){const h=await this.c.createManualSyncTask();return this.a.set(this.j(h.id),h),h.id}j(h){return`manualSyncTask-${h}`}}e.UserDataSyncChannel=v;let P=class extends L.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(h,m){super(),this.k=m,this.b="uninitialized",this.c=this.B(new k.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new k.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new k.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new k.Emitter),this.onSyncErrors=this.j.event,this.a={call(y,f,u){return h.call(y,f,u).then(null,d=>{throw T.UserDataSyncError.toUserDataSyncError(d)})},listen(y,f){return h.listen(y,f)}},this.a.call("_getInitialData").then(([y,f,u])=>{this.l(y),this.m(f),u&&this.n(u),this.B(this.a.listen("onDidChangeStatus")(d=>this.l(d))),this.B(this.a.listen("onDidChangeLastSyncTime")(d=>this.n(d)))}),this.B(this.a.listen("onDidChangeConflicts")(y=>this.m(y))),this.B(this.a.listen("onSyncErrors")(y=>this.j.fire(y.map(f=>({...f,error:T.UserDataSyncError.toUserDataSyncError(f.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const h=await this.a.call("createManualSyncTask"),m=this;return new w(h,{async call(f,u,d){return m.a.call(`manualSync/${f}`,[h,...Array.isArray(u)?u:[u]],d)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(h,m,y,f){return this.a.call("accept",[h,m,y,f])}resolveContent(h){return this.a.call("resolveContent",[h])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(h,m){return(await this.a.call("getLocalSyncResourceHandles",[h,m])).map(({created:f,uri:u})=>({created:f,uri:l.URI.revive(u)}))}async getRemoteSyncResourceHandles(h,m){return(await this.a.call("getRemoteSyncResourceHandles",[h,m])).map(({created:f,uri:u})=>({created:f,uri:l.URI.revive(u)}))}async getAssociatedResources(h){return(await this.a.call("getAssociatedResources",[h])).map(({resource:y,comparableResource:f})=>({resource:l.URI.revive(y),comparableResource:l.URI.revive(f)}))}getMachineId(h){return this.a.call("getMachineId",[h])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(h){return this.a.call("replace",[h])}async l(h){this.b=h,this.c.fire(h)}async m(h){this.f=h.map(m=>({syncResource:m.syncResource,profile:(0,D.reviveProfile)(m.profile,this.k.profilesHome.scheme),conflicts:m.conflicts.map(y=>({...y,baseResource:l.URI.revive(y.baseResource),localResource:l.URI.revive(y.localResource),remoteResource:l.URI.revive(y.remoteResource),previewResource:l.URI.revive(y.previewResource)}))})),this.g.fire(this.f)}n(h){this.h!==h&&(this.h=h,this.i.fire(h))}};P=ye([Y(1,D.IUserDataProfilesService)],P),e.UserDataSyncChannelClient=P;class w extends L.Disposable{constructor(h,m){super(),this.id=h,this.a=m}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(ne[288],se([0,1,6,23,8,3,2,144,4,24,12,10,31,16,15,14,25,59,44,20,22]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u,d,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const C="sync.previous.store",t="sync.donot-make-requests-until",a="sync.user-session-id",i="sync.machine-session-id",n=100,r=1e3*60*5;let o=class extends T.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(b.SYNC_SERVICE_URL_TYPE,-1)}set c(N){this.h.store(b.SYNC_SERVICE_URL_TYPE,N,-1,I.isWeb?0:1)}constructor(N,M,B){super(),this.f=N,this.g=M,this.h=B,this.a=this.B(new D.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(D.Event.filter(B.onDidChangeValue,O=>O.key===b.SYNC_SERVICE_URL_TYPE&&O.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[b.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(b.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(N,M){N=I.isWeb&&N?.web?{...N,...N.web}:N;const B={...N||{},...M||{}};if(B&&(0,P.isString)(B.url)&&(0,P.isObject)(B.authenticationProviders)&&Object.keys(B.authenticationProviders).every(O=>Array.isArray(B.authenticationProviders[O].scopes))){const O=B,j=!!O.canSwitch&&!M?.url,q=O.url===O.insidersUrl?"insiders":"stable",K=(j?this.c:void 0)||q,Q=M?.url||(K==="insiders"?O.insidersUrl:K==="stable"?O.stableUrl:O.url);return{url:w.URI.parse(Q),type:K,defaultType:q,defaultUrl:w.URI.parse(O.url),stableUrl:w.URI.parse(O.stableUrl),insidersUrl:w.URI.parse(O.insidersUrl),canSwitch:j,authenticationProviders:Object.keys(O.authenticationProviders).reduce((re,J)=>(re.push({id:J,scopes:O.authenticationProviders[J].scopes}),re),[])}}}};o=ye([Y(0,f.IProductService),Y(1,h.IConfigurationService),Y(2,p.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let s=class extends o{constructor(N,M,B){super(N,M,B);const O=this.h.get(C,-1);O&&(this.k=JSON.parse(O));const j=this.f[b.CONFIGURATION_SYNC_STORE_KEY];j?this.h.store(C,JSON.stringify(j),-1,1):this.h.remove(C,-1)}async switch(N){N!==this.c&&(this.c=N,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};s=ye([Y(0,f.IProductService),Y(1,h.IConfigurationService),Y(2,p.IStorageService)],s),e.UserDataSyncStoreManagementService=s;let c=class extends T.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(N,M,B,O,j,q,K){super(),this.k=B,this.l=O,this.n=K,this.g=this.B(new D.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new D.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new D.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(N),this.c=(0,d.getServiceMachineId)(j,q,K).then(Q=>{const re={"X-Client-Name":`${M.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(re["X-Client-Commit"]=M.commit),re}),this.f=new E(n,r,this.k,this.l),this.r(),this.B((0,T.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(N,M){this.b={token:N,type:M}}p(N){this.a=N?(0,v.joinPath)(N,"v1"):void 0}r(){const N=this.n.getNumber(t,-1);N&&Date.now()<N&&this.t(new Date(N))}t(N){this.i?.getTime()!==N?.getTime()&&(this.i=N,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(t,this.i.getTime(),-1,1),this.s=(0,k.createCancelablePromise)(M=>(0,k.timeout)(this.i.getTime()-Date.now(),M).then(()=>this.t(void 0))),this.s.then(null,M=>null)):this.n.remove(t,-1),this.j.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,v.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const B=await this.w(M,{type:"GET",headers:N},[],L.CancellationToken.None);return(await(0,u.asJson)(B))?.map(({id:O})=>O)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,v.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]=R.Mimes.text;const B=await this.w(M,{type:"POST",headers:N},[],L.CancellationToken.None),O=await(0,u.asTextOrError)(B);if(!O)throw new b.UserDataSyncStoreError("Server did not return the collection id",M,"NoCollection",B.res.statusCode,B.res.headers[b.HEADER_OPERATION_ID]);return O}async deleteCollection(N,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const B=N?(0,v.joinPath)(this.a,"collection",N).toString():(0,v.joinPath)(this.a,"collection").toString();M={...M},await this.w(B,{type:"DELETE",headers:M},[],L.CancellationToken.None)}async getAllResourceRefs(N,M){if(!this.a)throw new Error("No settings sync store url configured.");const B=this.u(this.a,M,N),O={},j=await this.w(B.toString(),{type:"GET",headers:O},[],L.CancellationToken.None);return(await(0,u.asJson)(j)||[]).map(({url:K,created:Q})=>({ref:(0,v.relativePath)(B,B.with({path:K})),created:Q*1e3}))}async resolveResourceContent(N,M,B,O={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,v.joinPath)(this.u(this.a,B,N),M).toString();O={...O},O["Cache-Control"]="no-cache";const q=await this.w(j,{type:"GET",headers:O},[],L.CancellationToken.None);return await(0,u.asTextOrError)(q)}async deleteResource(N,M,B){if(!this.a)throw new Error("No settings sync store url configured.");const O=M!==null?(0,v.joinPath)(this.u(this.a,B,N),M).toString():this.u(this.a,B,N).toString(),j={};await this.w(O,{type:"DELETE",headers:j},[],L.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,v.joinPath)(this.a,"resource").toString(),M={"Content-Type":R.Mimes.text};await this.w(N,{type:"DELETE",headers:M},[],L.CancellationToken.None)}async readResource(N,M,B,O={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,v.joinPath)(this.u(this.a,B,N),"latest").toString();O={...O},O["Cache-Control"]="no-cache",M&&(O["If-None-Match"]=M.ref);const q=await this.w(j,{type:"GET",headers:O},[304],L.CancellationToken.None);let K=null;if(q.res.statusCode===304&&(K=M),K===null){const Q=q.res.headers.etag;if(!Q)throw new b.UserDataSyncStoreError("Server did not return the ref",j,"NoRef",q.res.statusCode,q.res.headers[b.HEADER_OPERATION_ID]);const re=await(0,u.asTextOrError)(q);if(!re&&q.res.statusCode===304)throw new b.UserDataSyncStoreError("Empty response",j,"EmptyResponse",q.res.statusCode,q.res.headers[b.HEADER_OPERATION_ID]);K={ref:Q,content:re}}return K}async writeResource(N,M,B,O,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const q=this.u(this.a,O,N).toString();j={...j},j["Content-Type"]=R.Mimes.text,B&&(j["If-Match"]=B);const K=await this.w(q,{type:"POST",data:M,headers:j},[],L.CancellationToken.None),Q=K.res.headers.etag;if(!Q)throw new b.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",K.res.statusCode,K.res.headers[b.HEADER_OPERATION_ID]);return Q}async manifest(N,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const B=(0,v.joinPath)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",N&&(M["If-None-Match"]=N.ref);const O=await this.w(B,{type:"GET",headers:M},[304],L.CancellationToken.None);let j=null;if(O.res.statusCode===304&&(j=N),!j){const K=O.res.headers.etag;if(!K)throw new b.UserDataSyncStoreError("Server did not return the ref",B,"NoRef",O.res.statusCode,O.res.headers[b.HEADER_OPERATION_ID]);const Q=await(0,u.asTextOrError)(O);if(!Q&&O.res.statusCode===304)throw new b.UserDataSyncStoreError("Empty response",B,"EmptyResponse",O.res.statusCode,O.res.headers[b.HEADER_OPERATION_ID]);Q&&(j={...JSON.parse(Q),ref:K})}const q=this.n.get(a,-1);return q&&j&&q!==j.session&&this.v(),j===null&&q&&this.v(),j&&this.n.store(a,j.session,-1,1),j}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.v()}u(N,M,B){return M?(0,v.joinPath)(N,"collection",M,"resource",B):(0,v.joinPath)(N,"resource",B)}v(){this.n.remove(a,-1),this.n.remove(i,-1)}async w(N,M,B,O){if(!this.b)throw new b.UserDataSyncStoreError("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const j=await this.c;M.headers={...M.headers||{},...j,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y(M.headers),this.l.trace("Sending request to server",{url:N,type:M.type,headers:{...M.headers,authorization:void 0}});let q;try{q=await this.f.request(N,M,O)}catch(W){if(!(W instanceof b.UserDataSyncStoreError)){let F="RequestFailed";const G=(0,l.getErrorMessage)(W).toLowerCase();G.includes("xhr timeout")?F="RequestTimeout":G.includes("protocol")&&G.includes("not supported")?F="RequestProtocolNotSupported":G.includes("request path contains unescaped characters")?F="RequestPathNotEscaped":G.includes("headers must be an object")?F="RequestHeadersNotObject":(0,l.isCancellationError)(W)&&(F="RequestCanceled"),W=new b.UserDataSyncStoreError(`Connection refused for the request '${N}'.`,N,F,void 0,void 0)}throw this.l.info("Request failed",N),W}const K=q.res.headers[b.HEADER_OPERATION_ID],Q={url:N,status:q.res.statusCode,"execution-id":M.headers[b.HEADER_EXECUTION_ID],"operation-id":K},re=(0,u.isSuccess)(q)||q.res.statusCode&&B.indexOf(q.res.statusCode)!==-1;let J="";if(re?this.l.trace("Request succeeded",Q):(this.l.info("Request failed",Q),J=await(0,u.asText)(q)||""),q.res.statusCode===401)throw this.b=void 0,this.g.fire(),new b.UserDataSyncStoreError(`Request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",q.res.statusCode,K);if(this.h.fire(),q.res.statusCode===404)throw new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",q.res.statusCode,K);if(q.res.statusCode===405)throw new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because the requested endpoint is not found (405). ${J}`,N,"MethodNotFound",q.res.statusCode,K);if(q.res.statusCode===409)throw new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",q.res.statusCode,K);if(q.res.statusCode===410)throw new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",q.res.statusCode,K);if(q.res.statusCode===412)throw new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",q.res.statusCode,K);if(q.res.statusCode===413)throw new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",q.res.statusCode,K);if(q.res.statusCode===426)throw new b.UserDataSyncStoreError(`${M.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",q.res.statusCode,K);if(q.res.statusCode===429){const W=q.res.headers["retry-after"];throw W?(this.t(new Date(Date.now()+parseInt(W)*1e3)),new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",q.res.statusCode,K)):new b.UserDataSyncStoreError(`${M.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",q.res.statusCode,K)}if(!re)throw new b.UserDataSyncStoreError("Server returned "+q.res.statusCode,N,"Unknown",q.res.statusCode,K);return q}y(N){let M=this.n.get(i,-1);M===void 0&&(M=(0,g.generateUuid)(),this.n.store(i,M,-1,1)),N["X-Machine-Session-Id"]=M;const B=this.n.get(a,-1);B!==void 0&&(N["X-User-Session-Id"]=B)}};c=ye([Y(1,f.IProductService),Y(2,u.IRequestService),Y(3,b.IUserDataSyncLogService),Y(4,m.IEnvironmentService),Y(5,y.IFileService),Y(6,p.IStorageService)],c),e.UserDataSyncStoreClient=c;let S=class extends c{constructor(N,M,B,O,j,q,K){super(N.userDataSyncStore?.url,M,B,O,j,q,K),this.B(N.onDidChangeUserDataSyncStore(()=>this.p(N.userDataSyncStore?.url)))}};S=ye([Y(0,b.IUserDataSyncStoreManagementService),Y(1,f.IProductService),Y(2,u.IRequestService),Y(3,b.IUserDataSyncLogService),Y(4,m.IEnvironmentService),Y(5,y.IFileService),Y(6,p.IStorageService)],S),e.UserDataSyncStoreService=S;class E{constructor(N,M,B,O){this.c=N,this.d=M,this.f=B,this.g=O,this.a=[],this.b=void 0}request(N,M,B){if(this.h()&&this.i(),M.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new b.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(M,B)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=E}),define(ne[289],se([0,1,3,57,25,20,19,284,22,77,80]),function(Z,e,k,L,l,D,T,R,I,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends R.UserDataAutoSyncService{constructor(h,m,y,f,u,d,p,b,C,t,a){super(h,m,y,f,u,p,b,C,t,a),this.B(k.Event.debounce(k.Event.any(k.Event.map(d.onDidFocusWindow,()=>"windowFocus"),k.Event.map(d.onDidOpenWindow,()=>"windowOpen")),(i,n)=>i?[...i,n]:[n],1e3)(i=>this.triggerSync(i,!0,!1)))}};w=ye([Y(0,l.IProductService),Y(1,I.IUserDataSyncStoreManagementService),Y(2,I.IUserDataSyncStoreService),Y(3,I.IUserDataSyncEnablementService),Y(4,I.IUserDataSyncService),Y(5,L.INativeHostService),Y(6,I.IUserDataSyncLogService),Y(7,v.IUserDataSyncAccountService),Y(8,T.ITelemetryService),Y(9,P.IUserDataSyncMachinesService),Y(10,D.IStorageService)],w),e.UserDataAutoSyncService=w}),define(ne[290],se([0,1,101,21,4,24]),function(Z,e,k,L,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(v){function P(){let w=v.scheme===L.Schemas.file?(0,D.originalFSPath)(v):v.toString();return l.isLinux||(w=w.toLowerCase()),(0,k.createHash)("md5").update(w).digest("hex")}return{id:P(),configPath:v}}e.getWorkspaceIdentifier=T;function R(v,P){function w(){if(v.scheme!==L.Schemas.file)return(0,k.createHash)("md5").update(v.toString()).digest("hex");if(!P)return;let h;return l.isLinux?h=P.ino:l.isMacintosh?h=P.birthtime.getTime():l.isWindows&&(typeof P.birthtimeMs=="number"?h=Math.floor(P.birthtimeMs):h=P.birthtime.getTime()),(0,k.createHash)("md5").update(v.fsPath).update(h?String(h):"").digest("hex")}const g=w();if(typeof g=="string")return{id:g,uri:v}}e.getSingleFolderWorkspaceIdentifier=R;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(ne[291],se([0,1,6,8,2,13,27,15,11,75,118,290,71,57]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let m=class extends l.Disposable{constructor(f,u,d,p){super(),this.a=f,this.b=u,this.c=d,this.f=p,this.B(new k.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=await T.Promises.readdir(this.a.workspaceStorageHome.fsPath),u=new v.StorageClient(this.f.getChannel("storage"));await Promise.all(f.map(async d=>{const p=(0,D.join)(this.a.workspaceStorageHome.fsPath,d);d.length===w.NON_EMPTY_WORKSPACE_ID_LENGTH||d===P.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(t=>t.workspace?.id===d)||await u.isUsed(p)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await T.Promises.rm(p))}))}catch(f){(0,L.onUnexpectedError)(f)}}};m=ye([Y(0,R.INativeEnvironmentService),Y(1,I.ILogService),Y(2,h.INativeHostService),Y(3,g.IMainProcessService)],m),e.UnusedWorkspaceStorageDataCleaner=m}),define(ne[127],se([0,1,53,6,13,12,27,156,300,301]),function(Z,e,k,L,l,D,T,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(t,a){let i=a.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=a}}e.ExtractError=P;function w(C){const t=C.externalFileAttributes>>16||33188;return[448,56,7].map(a=>t&a).reduce((a,i)=>a+i,t&61440)}function g(C){if(C instanceof P)return C;let t;return/end of central directory record signature not found/.test(C.message)&&(t="CorruptZip"),new P(t,C)}function h(C,t,a,i,n,r){const o=l.dirname(t),s=l.join(i,o);if(!s.startsWith(i))return Promise.reject(new Error(R.localize(0,null,t)));const c=l.join(i,t);let S;return r.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(T.Promises.mkdir(s,{recursive:!0})).then(()=>new Promise((E,A)=>{if(!r.isCancellationRequested)try{S=(0,k.createWriteStream)(c,{mode:a}),S.once("close",()=>E()),S.once("error",A),C.once("error",A),C.pipe(S)}catch(N){A(N)}}))}function m(C,t,a,i){let n=(0,L.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{n.cancel(),C.close()}),new Promise((o,s)=>{const c=new L.Sequencer,S=E=>{E.isCancellationRequested||(r++,C.readEntry())};C.once("error",s),C.once("close",()=>n.then(()=>{i.isCancellationRequested||C.entryCount===r?o():s(new P("Incomplete",new Error(R.localize(1,null,r,C.entryCount))))},s)),C.readEntry(),C.on("entry",E=>{if(i.isCancellationRequested)return;if(!a.sourcePathRegex.test(E.fileName)){S(i);return}const A=E.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(A)){const B=l.join(t,A);n=(0,L.createCancelablePromise)(O=>T.Promises.mkdir(B,{recursive:!0}).then(()=>S(O)).then(void 0,s));return}const N=f(C,E),M=w(E);n=(0,L.createCancelablePromise)(B=>c.queue(()=>N.then(O=>h(O,A,M,t,a,B).then(()=>S(B)))).then(null,s))})})}function y(C,t=!1){return new Promise((a,i)=>{(0,I.open)(C,t?{lazyEntries:!0}:void 0,(n,r)=>{n?i(g(n)):a((0,D.assertIsDefined)(r))})})}function f(C,t){return new Promise((a,i)=>{C.openReadStream(t,(n,r)=>{n?i(g(n)):a((0,D.assertIsDefined)(r))})})}function u(C,t){return new Promise((a,i)=>{const n=new v.ZipFile;t.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const r=(0,k.createWriteStream)(C);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>a(C))})}e.zip=u;function d(C,t,a={},i){const n=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let r=y(C,!0);return a.overwrite&&(r=r.then(o=>T.Promises.rm(t).then(()=>o))),r.then(o=>m(o,t,{sourcePathRegex:n},i))}e.extract=d;function p(C,t){return y(C).then(a=>new Promise((i,n)=>{a.on("entry",r=>{r.fileName===t&&f(a,r).then(o=>i(o),o=>n(o))}),a.once("close",()=>n(new Error(R.localize(2,null,t))))}))}function b(C,t){return p(C,t).then(a=>new Promise((i,n)=>{const r=[];a.once("error",n),a.on("data",o=>r.push(o)),a.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=b}),define(ne[292],se([0,1,127,166]),function(Z,e,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function l(D){return(0,k.buffer)(D,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,L.localize)(0,null))}})}e.getManifest=l}),define(ne[128],se([0,1,6,17,23,39,8,3,2,38,21,13,4,24,54,12,10,31,27,127,165,98,15,273,29,33,51,78,242,275,292,226,243,46,68,14,5,11,25,19,30,28]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u,d,p,b,C,t,a,i,n,r,o,s,c,S,E,A,N,M,B,O,j,q,K,Q,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,O.refineServiceDecorator)(i.IExtensionManagementService);let J=class extends a.AbstractExtensionManagementService{constructor(x,$,U,z,V,_,H,X,te,le,he,me){super(x,$,U,le,me),this.Z=V,this.ab=_,this.bb=H,this.cb=te,this.db=he,this.X=this.B(new R.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new v.ResourceSet;const pe=this.B(X.createInstance(c.ExtensionsLifecycle));this.S=this.B(X.createInstance(W,Ce=>pe.postUninstall(Ce))),this.U=this.B(new E.ExtensionsManifestCache(z,this)),this.W=this.B(X.createInstance(s.ExtensionsDownloader));const Se=this.B(new A.ExtensionsWatcher(this,this.Z,me,_,he,te,U));this.B(Se.onDidChangeExtensionsByAnotherSource(Ce=>this.kb(Ce))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,n.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(x){this.v.trace("ExtensionManagementService#zip",x.identifier.id);const $=await this.jb(x),U=await(0,p.zip)((0,h.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,$);return f.URI.file(U)}async unzip(x){return this.v.trace("ExtensionManagementService#unzip",x.toString()),(await this.install(x)).identifier}async getManifest(x){const{location:$,cleanup:U}=await this.fb(x),z=w.resolve($.fsPath);try{return await(0,S.getManifest)(z)}finally{await U()}}getInstalled(x,$=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(x??null,$)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(x){return this.S.scanUserExtensionAtLocation(x)}async install(x,$={}){this.v.trace("ExtensionManagementService#install",x.toString());const{location:U,cleanup:z}=await this.fb(x);try{const V=await(0,S.getManifest)(w.resolve(U.fsPath));if(V.engines&&V.engines.vscode&&!(0,M.isEngineValid)(V.engines.vscode,this.w.version,this.w.date))throw new Error(b.localize(0,null,(0,n.getGalleryExtensionId)(V.publisher,V.name),this.w.version));return await this.z(V,U,$)}finally{await z()}}async installFromLocation(x,$){this.v.trace("ExtensionManagementService#installFromLocation",x.toString());const U=await this.S.scanUserExtensionAtLocation(x);if(!U)throw new Error(`Cannot find a valid extension from the location ${x.toString()}`);return await this.ob([[U,void 0]],$),this.v.info("Successfully installed extension",U.identifier.id,$.toString()),U}async installExtensionsFromProfile(x,$,U){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",x,$.toString(),U.toString());const z=(await this.S.scanExtensions(1,$)).filter(V=>x.some(_=>(0,n.areSameExtensions)(_,V.identifier)));if(z.length){const V=await Promise.all(z.map(_=>this.S.scanMetadata(_,$)));await this.ob(z.map((_,H)=>[_,V[H]]),U),this.v.info("Successfully installed extensions",z.map(_=>_.identifier.id),U.toString())}return z}async updateMetadata(x,$,U=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",x.identifier.id),$.isPreReleaseVersion&&($.preRelease=!0),$.isMachineScoped=$.isMachineScoped||void 0,$.isBuiltin=$.isBuiltin||void 0,$.pinned=$.pinned||void 0,x=await this.S.updateMetadata(x,$,U),this.U.invalidate(),this.X.fire(x),x}async reinstallFromGallery(x){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",x.identifier.id),!this.t.isEnabled())throw new Error(b.localize(1,null));const $=await this.getTargetPlatform(),[U]=await this.t.getExtensions([{...x.identifier,preRelease:x.preRelease}],{targetPlatform:$,compatible:!0},l.CancellationToken.None);if(!U)throw new Error(b.localize(2,null));await this.S.setUninstalled(x);try{await this.S.removeUninstalledExtension(x)}catch(z){throw new Error(b.localize(3,null,(0,D.toErrorMessage)(z)))}return this.installFromGallery(U)}copyExtensions(x,$){return this.S.copyExtensions(x,$)}markAsUninstalled(...x){return this.S.setUninstalled(...x)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(x){this.v.error(x)}}async download(x,$){const{location:U}=await this.W.download(x,$);return U}async fb(x){if(x.scheme===P.Schemas.file)return{location:x,async cleanup(){}};this.v.trace("Downloading extension from",x.toString());const $=(0,h.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)());return await this.bb.download(x,$),this.v.info("Downloaded extension to",$.toString()),{location:$,cleanup:async()=>{try{await this.cb.del($)}catch(z){this.v.error(z)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(x,$,U){if(f.URI.isUri($))return new ee(x,$,U,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const z=n.ExtensionKey.create($).toString();let V=this.Y.get(z);return V||(this.Y.set(z,V=new G(x,$,U,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),V.waitUntilTaskIsFinished().then(()=>this.Y.delete(z))),V}R(x,$){return new oe(x,$.profileLocation,this.ab)}async jb(x){const $=async z=>{let V=await d.Promises.readdir(z);V=V.map(X=>w.join(z,X));const _=await Promise.all(V.map(X=>d.Promises.stat(X)));let H=Promise.resolve([]);return _.forEach((X,te)=>{const le=V[te];X.isFile()&&(H=H.then(he=>[...he,le])),X.isDirectory()&&(H=H.then(he=>$(le).then(me=>[...he,...me])))}),H};return(await $(x.location.fsPath)).map(z=>({path:`extension/${w.relative(x.location.fsPath,z)}`,localPath:z}))}async kb({added:x,removed:$}){if($)for(const U of $.extensions)this.v.info("Extensions removed from another source",U.id,$.profileLocation.toString()),this.p.fire({identifier:U,profileLocation:$.profileLocation});if(x){const z=(await this.S.scanExtensions(1,x.profileLocation)).filter(V=>x.extensions.some(_=>(0,n.areSameExtensions)(_,V.identifier)));this.m.fire(z.map(V=>(this.v.info("Extensions added from another source",V.identifier.id,x.profileLocation.toString()),{identifier:V.identifier,local:V,profileLocation:x.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract($=>this.lb.add($)));const x=await this.cb.resolve(this.Z.userExtensionsLocation);for(const $ of x.children??[])$.isDirectory&&this.lb.add($.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange($=>this.nb($)))}async nb(x){if(!x.affects(this.Z.userExtensionsLocation,1))return;const $=[];for(const U of x.rawAdded){if(this.lb.has(U)||!this.db.extUri.isEqual(this.db.extUri.dirname(U),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(U,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(U).startsWith(".")||!(await this.cb.stat(U)).isDirectory)continue;const z=await this.S.scanUserExtensionAtLocation(U);z&&z.installedTimestamp===void 0&&(this.lb.add(U),$.push(z))}$.length&&(await this.ob($.map(U=>[U,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",$.map(U=>U.identifier.id)))}async ob(x,$){const U=x.map(z=>z[0]);await this.pb(U),await this.ab.addExtensionsToProfile(x,$),this.m.fire(U.map(z=>({local:z,identifier:z.identifier,operation:1,profileLocation:$})))}async pb(x){const $=await this.S.getUninstalledExtensions();for(const U of x){const z=n.ExtensionKey.create(U);!$[z.toString()]||(this.v.trace("Removing the extension from uninstalled list:",z.id),await this.S.setInstalled(z),this.v.info("Removed the extension from uninstalled list:",z.id))}}};J=ye([Y(0,i.IExtensionGalleryService),Y(1,K.ITelemetryService),Y(2,j.ILogService),Y(3,t.INativeEnvironmentService),Y(4,o.IExtensionsScannerService),Y(5,r.IExtensionsProfileScannerService),Y(6,C.IDownloadService),Y(7,O.IInstantiationService),Y(8,B.IFileService),Y(9,q.IProductService),Y(10,Q.IUriIdentityService),Y(11,re.IUserDataProfilesService)],J),e.ExtensionManagementService=J;let W=class extends I.Disposable{constructor(x,$,U,z,V,_){super(),this.k=x,this.l=$,this.m=U,this.n=z,this.p=V,this.s=_,this.h=this.B(new R.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,h.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new k.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(x,$){const U={includeInvalid:!0,profileLocation:$};let z=[];return x===null||x===0?z.push(...await this.m.scanAllExtensions({includeInvalid:!0},U,!1)):x===1&&z.push(...await this.m.scanUserExtensions(U)),z=x!==null?z.filter(V=>V.type===x):z,Promise.all(z.map(V=>this.y(V)))}async scanAllUserExtensions(x){const $=await this.m.scanUserExtensions({includeAllVersions:!x,includeInvalid:!0});return Promise.all($.map(U=>this.y(U)))}async scanUserExtensionAtLocation(x){try{const $=await this.m.scanExistingExtension(x,1,{includeInvalid:!0});if($)return await this.y($)}catch($){this.s.error($)}return null}async extractUserExtension(x,$,U,z){await this.j.catch(()=>{});const V=x.toString(),_=w.join(this.m.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),H=w.join(this.m.userExtensionsLocation.fsPath,V);try{await d.Promises.rm(H)}catch{throw new i.ExtensionManagementError(b.localize(4,null,H,x.id),i.ExtensionManagementErrorCode.Delete)}await this.u(x,$,_,z),await this.m.updateMetadata(f.URI.file(_),U);try{this.h.fire(f.URI.file(H)),await this.v(x,_,H,Date.now()+2*60*1e3),this.s.info("Renamed to",H)}catch(X){try{await d.Promises.rm(_)}catch{}if(X.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",x.id);else throw this.s.info(`Rename failed because of ${(0,T.getErrorMessage)(X)}. Deleted from extracted location`,_),X}return this.w(f.URI.file(H),1)}async scanMetadata(x,$){return $?(await this.n.scanProfileExtensions($)).find(z=>(0,n.areSameExtensions)(z.identifier,x.identifier))?.metadata:this.m.scanMetadata(x.location)}async updateMetadata(x,$,U){return U?await this.n.updateMetadata([[x,$]],U):await this.m.updateMetadata(x.location,$),this.w(x.location,x.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...x){const $=x.map(U=>n.ExtensionKey.create(U));await this.t(U=>$.forEach(z=>{U[z.toString()]=!0,this.s.info("Marked extension as uninstalled",z.toString())}))}async setInstalled(x){await this.t($=>delete $[x.toString()])}async removeExtension(x,$){this.s.trace(`Deleting ${$} extension from disk`,x.identifier.id,x.location.fsPath);const U=this.p.extUri.joinPath(this.p.extUri.dirname(x.location),`.${(0,u.generateUuid)()}`);await this.v(x.identifier,x.location.fsPath,U.fsPath,Date.now()+2*60*1e3),await this.l.del(U,{recursive:!0}),this.s.info("Deleted from disk",x.identifier.id,x.location.fsPath)}async removeUninstalledExtension(x){await this.removeExtension(x,"uninstalled"),await this.t($=>delete $[n.ExtensionKey.create(x).toString()])}async copyExtensions(x,$){const U=await this.scanExtensions(1,x),z=await Promise.all(U.filter(V=>!V.isApplicationScoped).map(async V=>[V,await this.scanMetadata(V,x)]));await this.n.addExtensionsToProfile(z,$)}async t(x){return this.g.queue(async()=>{let $;try{$=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(z){if((0,B.toFileOperationResult)(z)!==1)throw z}let U={};if($)try{U=JSON.parse($)}catch{}return x&&(x(U),Object.keys(U).length?await this.l.writeFile(this.c,L.VSBuffer.fromString(JSON.stringify(U))):await this.l.del(this.c)),U})}async u(x,$,U,z){this.s.trace(`Started extracting the extension from ${$} to ${U}`);try{await d.Promises.rm(U)}catch(V){throw new i.ExtensionManagementError(this.D(V).message,i.ExtensionManagementErrorCode.Delete)}try{await(0,p.extract)($,U,{sourcePath:"extension",overwrite:!0},z),this.s.info(`Extracted extension to ${U}:`,x.id)}catch(V){try{await d.Promises.rm(U)}catch{}let _=i.ExtensionManagementErrorCode.Extract;throw V instanceof p.ExtractError&&(V.type==="CorruptZip"?_=i.ExtensionManagementErrorCode.CorruptZip:V.type==="Incomplete"&&(_=i.ExtensionManagementErrorCode.IncompleteZip)),new i.ExtensionManagementError(V.message,_)}}async v(x,$,U,z){try{await d.Promises.rename($,U)}catch(V){if(g.isWindows&&V&&V.code==="EPERM"&&Date.now()<z)return this.s.info(`Failed renaming ${$} to ${U} with 'EPERM' error. Trying again...`,x.id),this.v(x,$,U,z);throw new i.ExtensionManagementError(V.message||b.localize(5,null,$,U),V.code||i.ExtensionManagementErrorCode.Rename)}}async w(x,$){const U=await this.m.scanExistingExtension(x,$,{includeInvalid:!0});if(U)return this.y(U);throw new Error(b.localize(6,null,x.path))}async y(x){const $=await this.l.resolve(x.location);let U,z;return $.children&&(U=$.children.find(({name:V})=>/^readme(\.txt|\.md|)$/i.test(V))?.resource,z=$.children.find(({name:V})=>/^changelog(\.txt|\.md|)$/i.test(V))?.resource),{identifier:x.identifier,type:x.type,isBuiltin:x.isBuiltin||!!x.metadata?.isBuiltin,location:x.location,manifest:x.manifest,targetPlatform:x.targetPlatform,validations:x.validations,isValid:x.isValid,readmeUrl:U,changelogUrl:z,publisherDisplayName:x.metadata?.publisherDisplayName||null,publisherId:x.metadata?.publisherId||null,isApplicationScoped:!!x.metadata?.isApplicationScoped,isMachineScoped:!!x.metadata?.isMachineScoped,isPreReleaseVersion:!!x.metadata?.isPreReleaseVersion,preRelease:!!x.metadata?.preRelease,installedTimestamp:x.metadata?.installedTimestamp,updated:!!x.metadata?.updated,pinned:!!x.metadata?.pinned}}async z(){const x=await this.getUninstalledExtensions();this.s.debug("Removing uninstalled extensions:",Object.keys(x));const $=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),U=new Set;for(const V of $)x[n.ExtensionKey.create(V).toString()]||U.add(V.identifier.id.toLowerCase());try{const V=(0,n.groupByExtension)($,_=>_.identifier);await k.Promises.settled(V.map(async _=>{const H=_.sort((X,te)=>m.rcompare(X.manifest.version,te.manifest.version))[0];U.has(H.identifier.id.toLowerCase())||await this.k(await this.y(H))}))}catch(V){this.s.error(V)}const z=$.filter(V=>V.metadata&&x[n.ExtensionKey.create(V).toString()]);await Promise.allSettled(z.map(V=>this.removeUninstalledExtension(V)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const x=[];let $;try{$=await this.l.resolve(this.m.userExtensionsLocation)}catch(U){(0,B.toFileOperationResult)(U)!==1&&this.s.error(U)}for(const U of $?.children??[])U.isDirectory&&U.name.startsWith(".")&&(0,u.isUUID)(U.name.substring(1))&&x.push((async()=>{this.s.trace("Deleting the generated extension folder",U.resource.toString());try{await this.l.del(U.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",U.resource.toString())}catch(z){this.s.error(z)}})());await Promise.allSettled(x)}D(x){const $=Array.isArray(x)?x:[x];return $.length===1?$[0]instanceof Error?$[0]:new Error($[0]):$.reduce((U,z)=>new Error(`${U.message}${U.message?",":""}${z instanceof Error?z.message:z}`),new Error(""))}};W=ye([Y(1,B.IFileService),Y(2,o.IExtensionsScannerService),Y(3,r.IExtensionsProfileScannerService),Y(4,Q.IUriIdentityService),Y(5,j.ILogService)],W),e.ExtensionsScanner=W;class F extends a.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,y.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(x,$,U,z,V,_,H,X,te){super(),this.identifier=x,this.source=$,this.l=U,this.m=z,this.n=V,this.o=_,this.p=H,this.q=X,this.s=te,this.j="Unverified",this.k=2}async h(x){const[$,U]=await this.x(x);return this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.l.profileLocation)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[$,U]],this.l.profileLocation),$}async u({zipPath:x,key:$,metadata:U},z){let V=await this.v($);return V||(this.s.trace("Extracting extension...",$.id),V=await this.m.extractUserExtension($,x,U,z),this.s.info("Extracting extension completed.",$.id)),V}async v(x){return await this.w(x)?(this.s.trace("Removing the extension from uninstalled list:",x.id),await this.m.setInstalled(x),this.s.info("Removed the extension from uninstalled list:",x.id),(await this.m.scanAllUserExtensions(!0)).find(z=>n.ExtensionKey.create(z).equals(x))):void 0}async w(x){return!!(await this.m.getUninstalledExtensions())[x.toString()]}}class G extends F{constructor(x,$,U,z,V,_,H,X,te,le){super($.identifier,$,U,V,_,H,X,te,le),this.y=x,this.z=$,this.A=z}async x(x){const U=(await this.m.scanExtensions(null,this.l.profileLocation)).find(H=>(0,n.areSameExtensions)(H.identifier,this.z.identifier));U&&(this.k=3);const z={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:(0,N.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||U?.isMachineScoped,isBuiltin:this.l.isBuiltin||U?.isBuiltin,isSystem:U?.type===0?!0:void 0,updated:!!U,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,y.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:U?.preRelease)};if(U?.manifest.version===this.z.version)return[await this.m.updateMetadata(U,z),z];const{location:V,verificationStatus:_}=await this.A.download(this.z,this.k);try{return this.j=_,this.C(V.fsPath),[await this.u({zipPath:V.fsPath,key:n.ExtensionKey.create(this.z),metadata:z},x),z]}catch(H){try{await this.A.delete(V)}catch(X){this.s.warn("Error while deleting the downloaded file",V.toString(),(0,T.getErrorMessage)(X))}throw H}}async C(x){try{await(0,S.getManifest)(x)}catch($){throw new i.ExtensionManagementError((0,a.joinErrors)($).message,i.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=G;class ee extends F{constructor(x,$,U,z,V,_,H,X,te,le){super({id:(0,n.getGalleryExtensionId)(x.publisher,x.name)},$,U,V,_,H,X,te,le),this.y=x,this.z=$,this.A=z}async x(x){const $=new n.ExtensionKey(this.identifier,this.y.version),z=(await this.m.scanExtensions(1,this.l.profileLocation)).find(H=>(0,n.areSameExtensions)(this.identifier,H.identifier)),V=await this.C(this.identifier.id,this.y.version,x);if(V.isApplicationScoped=(0,N.isApplicationScopedExtension)(this.y),V.isMachineScoped=this.l.isMachineScoped||z?.isMachineScoped,V.isBuiltin=this.l.isBuiltin||z?.isBuiltin,V.installedTimestamp=Date.now(),V.pinned=this.l.installGivenVersion?!0:void 0,z)if(this.k=3,$.equals(new n.ExtensionKey(z.identifier,z.manifest.version)))try{await this.m.removeExtension(z,"existing")}catch{throw new Error(b.localize(7,null,this.y.displayName||this.y.name))}else!this.l.profileLocation&&m.gt(z.manifest.version,this.y.version)&&await this.m.setUninstalled(z);else{const H=await this.v($);if(H)try{await this.m.removeExtension(H,"existing")}catch{throw new Error(b.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:w.resolve(this.z.fsPath),key:$,metadata:V},x),V]}async C(x,$,U){try{let[z]=await this.A.getExtensions([{id:x,version:$}],U);if(z||([z]=await this.A.getExtensions([{id:x}],U)),z)return{id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId,isPreReleaseVersion:z.properties.isPreReleaseVersion,preRelease:z.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class oe extends a.AbstractExtensionTask{constructor(x,$,U){super(),this.extension=x,this.j=$,this.k=U}async h(x){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[293],se([0,1,2,29,79,241,128,11,20]),function(Z,e,k,L,l,D,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let v=class extends k.Disposable{constructor(w,g,h,m,y,f){super(),w.cleanUp(),(0,D.migrateUnsupportedExtensions)(w,g,h,m,f),l.ExtensionStorageService.removeOutdatedExtensionVersions(w,y)}};v=ye([Y(0,T.INativeServerExtensionManagementService),Y(1,L.IExtensionGalleryService),Y(2,l.IExtensionStorageService),Y(3,L.IGlobalExtensionEnablementService),Y(4,I.IStorageService),Y(5,R.ILogService)],v),e.ExtensionsContributions=v}),define(ne[302],se([0,1,34,39,8,2,21,24,10,37,154,218,219,211,212,291,200,203,16,224,97,239,98,231,15,236,119,277,29,99,202,128,100,14,214,215,55,5,209,70,72,245,11,105,106,25,59,20,111,19,112,113,114,47,248,116,257,79,117,22,77,282,268,269,80,283,286,287,288,61,271,110,238,76,259,228,258,109,30,260,4,261,204,222,221,78,276,28,51,217,58,280,247,272,108,285,293,7,216,270,86,152,278,198,210,71,57,279,254,289,281,235,233,240,104,274]),function(Z,e,k,L,l,D,T,R,I,v,P,w,g,h,m,y,f,u,d,p,b,C,t,a,i,n,r,o,s,c,S,E,A,N,M,B,O,j,q,K,Q,re,J,W,F,G,ee,oe,ae,x,$,U,z,V,_,H,X,te,le,he,me,pe,Se,Ce,De,ke,qe,Ye,ce,fe,de,Ie,Pe,Fe,Ae,je,Me,Ne,Be,ie,ue,ge,we,ve,Ee,Re,Le,Te,Ue,$e,ze,et,st,Dt,vt,kt,At,wt,Lt,Ot,Qe,Tt,Nt,Ut,Mt,Ft,jt,$t,St,Bt,zt,qt,Wt,Vt,bt,xt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ht extends D.Disposable{constructor(be,Oe){super(),this.f=be,this.g=Oe,this.b=void 0,this.c=void 0,(0,Qe.isUtilityProcess)(process)?this.a=this.B(new P.Server):this.a=this.B(new Tt.Server),this.h()}h(){const be=async()=>{this.c?.fireOnWillShutdown(),this.dispose()};if(process.once("exit",be),(0,Qe.isUtilityProcess)(process)?(0,P.once)(process.parentPort,"vscode:electron-main->shared-process=exit",be):this.g.once("vscode:electron-main->shared-process=exit",be),!(0,Qe.isUtilityProcess)(process)){const Oe="vscode:electron-main->shared-process=disposeWorker",We=(Ve,tt)=>{this.i(tt)};this.g.on(Oe,We),this.B((0,D.toDisposable)(()=>this.g.removeListener(Oe,We)))}}i(be){this.b?.disposeWorker(be)}async init(){const be=await this.j();(0,he.registerConfiguration)(),be.invokeFunction(Oe=>{const We=Oe.get(J.ILogService);We.trace("sharedProcess configuration",JSON.stringify(this.f)),this.k(Oe),this.l(We)}),this.B((0,D.combinedDisposable)(be.createInstance(w.CodeCacheCleaner,this.f.codeCachePath),be.createInstance(g.LanguagePackCachedDataCleaner),be.createInstance(y.UnusedWorkspaceStorageDataCleaner),be.createInstance(m.LogsDataCleaner),be.createInstance(h.LocalizationsUpdater),be.createInstance(At.ExtensionsContributions),be.createInstance(Dt.UserDataProfilesCleaner)))}async j(){const be=new K.ServiceCollection,Oe={_serviceBrand:void 0,...F.default};be.set(G.IProductService,Oe);const We=new v.StaticRouter(Ge=>Ge==="main"),Ve=new Mt.MessagePortMainProcessService(this.a,We);be.set(Ft.IMainProcessService,Ve);const tt=this.f.policiesData?new $e.PolicyChannelClient(this.f.policiesData,Ve.getChannel("policy")):new ze.NullPolicyService;be.set(ze.IPolicyService,tt);const Je=new n.SharedProcessEnvironmentService(this.f.args,Oe);be.set(i.INativeEnvironmentService,Je);const _e=new W.LoggerChannelClient(void 0,this.f.logLevel,this.f.loggers.map(Ge=>({...Ge,resource:I.URI.revive(Ge.resource)})),Ve.getChannel("logger"));be.set(J.ILoggerService,_e);const ct=this.B(_e.createLogger((0,R.joinPath)(I.URI.file(Je.logsPath),"sharedprocess.log"),{id:"sharedLog",name:(0,wt.localize)(0,null)})),ht=this.B(new J.ConsoleLogger(ct.getLevel())),xe=this.B(new Lt.LogService(ct,[ht]));be.set(J.ILogService,xe),this.c=this.B(new bt.SharedProcessLifecycleService(xe)),be.set(bt.ISharedProcessLifecycleService,this.c),this.b=new qt.SharedProcessWorkerService(xe),be.set(Ne.ISharedProcessWorkerService,this.b);const Ze=this.B(new M.FileService(xe));be.set(N.IFileService,Ze);const ft=this.B(new B.DiskFileSystemProvider(xe));Ze.registerProvider(T.Schemas.file,ft);const dt=this.B(new ge.FileUserDataProvider(T.Schemas.file,this.B(new we.DiskFileSystemProviderClient(Ve.getChannel(we.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:ue.isLinux})),T.Schemas.vscodeUserData,xe));Ze.registerProvider(T.Schemas.vscodeUserData,dt);const it=this.B(new et.UserDataProfilesService(this.f.profiles.all,I.URI.revive(this.f.profiles.home),Ve.getChannel("userDataProfiles")));be.set(Te.IUserDataProfilesService,it);const Ke=this.B(new p.ConfigurationService(it.defaultProfile.settingsResource,Ze,tt,xe));be.set(d.IConfigurationService,Ke);const rt=new $t.NativeStorageService(void 0,{defaultProfile:it.defaultProfile,currentProfile:it.defaultProfile},Ve,Je);be.set(oe.IStorageService,rt),this.B((0,D.toDisposable)(()=>rt.flush())),await Promise.all([Ke.initialize(),rt.initialize()]);const gt=new ie.UriIdentityService(Ze);be.set(Be.IUriIdentityService,gt),be.set(ee.IRequestService,new Wt.SharedProcessRequestService(Ve,Ke,xe)),be.set(f.IChecksumService,new O.SyncDescriptor(u.ChecksumService,void 0,!1)),be.set(Ee.IV8InspectProfilingService,new O.SyncDescriptor(ve.InspectProfilingService,void 0,!1));const lt=v.ProxyChannel.toService(Ve.getChannel("nativeHost"),{context:this.f.windowId});be.set(jt.INativeHostService,lt),be.set(t.IDownloadService,new O.SyncDescriptor(a.DownloadService,void 0,!0));const mt=this.B(new de.ActiveWindowManager(lt)),Gt=new v.StaticRouter(Ge=>mt.getActiveClientId().then(pt=>Ge===pt));be.set(A.IExtensionRecommendationNotificationService,new Ut.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",Gt)));let ut;const ot=[],Ct=(0,V.isInternalTelemetry)(Oe,Ke);if((0,V.supportsTelemetry)(Oe,Je)){const Ge=new U.TelemetryLogAppender(xe,_e,Je,Oe);ot.push(Ge);const{installSourcePath:pt}=Je;if(Oe.aiConfig?.ariaKey){const Pt=new st.OneDataSystemAppender(Ct,"monacoworkbench",null,Oe.aiConfig.ariaKey);this.B((0,D.toDisposable)(()=>Pt.flush())),ot.push(Pt)}ut=new z.TelemetryService({appenders:ot,commonProperties:(0,ae.resolveCommonProperties)(Ze,(0,k.release)(),(0,k.hostname)(),process.arch,Oe.commit,Oe.version,this.f.machineId,Ct,pt),sendErrorTelemetry:!0,piiPaths:(0,V.getPiiPathsFromEnvironment)(Je)},Ke,Oe)}else{ut=V.NullTelemetryService;const Ge=V.NullAppender;ot.push(Ge)}this.a.registerChannel("telemetryAppender",new $.TelemetryAppenderChannel(ot)),be.set(x.ITelemetryService,ut);const Jt=new _.CustomEndpointTelemetryService(Ke,ut,xe,_e,Je,Oe);be.set(x.ICustomEndpointTelemetryService,Jt),be.set(Ue.IExtensionsProfileScannerService,new O.SyncDescriptor(xt.ExtensionsProfileScannerService,void 0,!0)),be.set(Re.IExtensionsScannerService,new O.SyncDescriptor(Le.ExtensionsScannerService,void 0,!0)),be.set(c.IExtensionSignatureVerificationService,new O.SyncDescriptor(c.ExtensionSignatureVerificationService,void 0,!0)),be.set(E.INativeServerExtensionManagementService,new O.SyncDescriptor(E.ExtensionManagementService,void 0,!0)),be.set(s.IExtensionGalleryService,new O.SyncDescriptor(o.ExtensionGalleryService,void 0,!0)),be.set(s.IExtensionTipsService,new O.SyncDescriptor(Nt.ExtensionTipsService,void 0,!1)),be.set(Q.ILanguagePackService,new O.SyncDescriptor(re.NativeLanguagePackService,void 0,!1)),be.set(b.IDiagnosticsService,new O.SyncDescriptor(C.DiagnosticsService,void 0,!1)),be.set(me.IUserDataSyncAccountService,new O.SyncDescriptor(me.UserDataSyncAccountService,void 0,!0)),be.set(he.IUserDataSyncLogService,new O.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),be.set(he.IUserDataSyncUtilService,new Se.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),be.set(s.IGlobalExtensionEnablementService,new O.SyncDescriptor(r.GlobalExtensionEnablementService,void 0,!1)),be.set(le.IIgnoredExtensionsManagementService,new O.SyncDescriptor(le.IgnoredExtensionsManagementService,void 0,!0)),be.set(te.IExtensionStorageService,new O.SyncDescriptor(te.ExtensionStorageService)),be.set(he.IUserDataSyncStoreManagementService,new O.SyncDescriptor(ce.UserDataSyncStoreManagementService,void 0,!0)),be.set(he.IUserDataSyncStoreService,new O.SyncDescriptor(ce.UserDataSyncStoreService,void 0,!0)),be.set(De.IUserDataSyncMachinesService,new O.SyncDescriptor(De.UserDataSyncMachinesService,void 0,!0)),be.set(he.IUserDataSyncBackupStoreService,new O.SyncDescriptor(pe.UserDataSyncBackupStoreService,void 0,!1)),be.set(he.IUserDataSyncEnablementService,new O.SyncDescriptor(ke.UserDataSyncEnablementService,void 0,!0)),be.set(he.IUserDataSyncService,new O.SyncDescriptor(qe.UserDataSyncService,void 0,!1)),be.set(fe.IUserDataProfileStorageService,new O.SyncDescriptor(zt.UserDataProfileStorageService,void 0,!0)),be.set(he.IUserDataSyncResourceProviderService,new O.SyncDescriptor(kt.UserDataSyncResourceProviderService,void 0,!0));const It=new X.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ke.getValue("terminal.integrated.persistentSessionScrollback")??100},(0,wt.localize)(1,null),Ke,Je,xe,_e);return It.initialize(),be.set(St.ILocalPtyService,this.B(It)),be.set(Ie.ISignService,new O.SyncDescriptor(Pe.SignService,void 0,!1)),be.set(Fe.ISharedTunnelsService,new O.SyncDescriptor(Ae.SharedTunnelsService)),be.set(je.ISharedProcessTunnelService,new O.SyncDescriptor(Me.SharedProcessTunnelService)),be.set(vt.IRemoteTunnelService,new O.SyncDescriptor(Vt.RemoteTunnelService)),new q.InstantiationService(be)}k(be){const Oe=new S.ExtensionManagementChannel(be.get(s.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",Oe);const We=v.ProxyChannel.fromService(be.get(Q.ILanguagePackService));this.a.registerChannel("languagePacks",We);const Ve=v.ProxyChannel.fromService(be.get(b.IDiagnosticsService));this.a.registerChannel("diagnostics",Ve);const tt=new S.ExtensionTipsChannel(be.get(s.IExtensionTipsService));this.a.registerChannel("extensionTipsService",tt);const Je=v.ProxyChannel.fromService(be.get(f.IChecksumService));this.a.registerChannel("checksum",Je);const _e=v.ProxyChannel.fromService(be.get(Ee.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",_e);const ct=new Se.UserDataSyncMachinesServiceChannel(be.get(De.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ct);const ht=v.ProxyChannel.fromService(be.get(x.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",ht);const xe=new Se.UserDataSyncAccountServiceChannel(be.get(me.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",xe);const Ze=new Se.UserDataSyncStoreManagementServiceChannel(be.get(he.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",Ze);const ft=new Ye.UserDataSyncChannel(be.get(he.IUserDataSyncService),be.get(Te.IUserDataProfilesService),be.get(J.ILogService));this.a.registerChannel("userDataSync",ft);const dt=this.B(be.get(j.IInstantiationService).createInstance(Bt.UserDataAutoSyncService)),it=new Se.UserDataAutoSyncChannel(dt);this.a.registerChannel("userDataAutoSync",it);const Ke=be.get(St.ILocalPtyService),rt=v.ProxyChannel.fromService(Ke);this.a.registerChannel(H.TerminalIpcChannels.LocalPty,rt);const gt=v.ProxyChannel.fromService(be.get(je.ISharedProcessTunnelService));this.a.registerChannel(je.ipcSharedProcessTunnelChannelName,gt);const lt=v.ProxyChannel.fromService(be.get(Ne.ISharedProcessWorkerService));this.a.registerChannel(Ot.ipcUtilityProcessWorkerChannelName,lt);const mt=v.ProxyChannel.fromService(be.get(vt.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",mt)}l(be){(0,Qe.isUtilityProcess)(process)?(process.on("uncaughtException",Oe=>(0,l.onUnexpectedError)(Oe)),process.on("unhandledRejection",Oe=>(0,l.onUnexpectedError)(Oe))):globalThis.addEventListener("unhandledrejection",Oe=>{(0,l.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,l.setUnexpectedErrorHandler)(Oe=>{const We=(0,L.toErrorMessage)(Oe,!0);!We||be.error(`[uncaught exception in sharedProcess]: ${We}`)})}}async function Et(at){let be;(0,Qe.isUtilityProcess)(process)||(be=(await new Promise((We,Ve)=>{Z(["electron"],We,Ve)})).ipcRenderer);const Oe=new Ht(at,be);(0,Qe.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"):be.send("vscode:shared-process->electron-main=ipc-ready"),await Oe.init(),(0,Qe.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=init-done"):be.send("vscode:shared-process->electron-main=init-done")}e.main=Et,(0,Qe.isUtilityProcess)(process)&&process.parentPort.once("message",at=>{Et(at.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/96a795cc0b1cd62f9ff66c347637f917c6dde3da/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
