/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/types","vs/base/common/platform","vs/base/common/path","vs/base/common/errors","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/network","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(ne){for(var e=[],o=0,A=ne.length;o<A;o++)e[o]=ye[ne[o]];return e};define(ye[61],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function o(I,P){const S=Object.create(null);for(const k of I){const O=P(k);let T=S[O];T||(T=S[O]=[]),T.push(k)}return S}e.groupBy=o;function A(I,P){const S=[],k=[];for(const O of I)P.has(O)||S.push(O);for(const O of P)I.has(O)||k.push(O);return{removed:S,added:k}}e.diffSets=A;function a(I,P){const S=[],k=[];for(const[O,T]of I)P.has(O)||S.push(T);for(const[O,T]of P)I.has(O)||k.push(T);return{removed:S,added:k}}e.diffMaps=a;class R{constructor(){this.a=new Map}add(P,S){let k=this.a.get(P);k||(k=new Set,this.a.set(P,k)),k.add(S)}delete(P,S){const k=this.a.get(P);!k||(k.delete(S),k.size===0&&this.a.delete(P))}forEach(P,S){const k=this.a.get(P);!k||k.forEach(S)}}e.SetMap=R}),define(ye[62],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function o(I){return(P,S,k)=>{let O=null,T=null;if(typeof k.value=="function"?(O="value",T=k.value):typeof k.get=="function"&&(O="get",T=k.get),!T)throw new Error("not supported");k[O]=I(T,S)}}function A(I,P,S){let k=null,O=null;if(typeof S.value=="function"?(k="value",O=S.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(k="get",O=S.get),!O)throw new Error("not supported");const T=`$memoize$${P}`;S[k]=function(...v){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,v)}),this[T]}}e.memoize=A;function a(I,P,S){return o((k,O)=>{const T=`$debounce$${O}`,v=`$debounce$result$${O}`;return function(...C){this[v]||(this[v]=S?S():void 0),clearTimeout(this[T]),P&&(this[v]=P(this[v],...C),C=[this[v]]),this[T]=setTimeout(()=>{k.apply(this,C),this[v]=S?S():void 0},I)}})}e.debounce=a;function R(I,P,S){return o((k,O)=>{const T=`$throttle$timer$${O}`,v=`$throttle$result$${O}`,C=`$throttle$lastRun$${O}`,y=`$throttle$pending$${O}`;return function(...f){if(this[v]||(this[v]=S?S():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...f)),this[y])return;const h=this[C]+I;h<=Date.now()?(this[C]=Date.now(),k.apply(this,[this[v]]),this[v]=S?S():void 0):(this[y]=!0,this[T]=setTimeout(()=>{this[y]=!1,this[C]=Date.now(),k.apply(this,[this[v]]),this[v]=S?S():void 0},h-Date.now()))}})}e.throttle=R}),define(ye[12],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class o{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?D.isErrorNoTelemetry(s)?new D(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(r=>{r(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.ErrorHandler=o,e.errorHandler=new o;function A(n){e.errorHandler.setUnexpectedErrorHandler(n)}e.setUnexpectedErrorHandler=A;function a(n){if(!n||typeof n!="object")return!1;const s=n;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=a;function R(n){k(n)||e.errorHandler.onUnexpectedError(n)}e.onUnexpectedError=R;function I(n){k(n)||e.errorHandler.onUnexpectedExternalError(n)}e.onUnexpectedExternalError=I;function P(n){if(n instanceof Error){const{name:s,message:r}=n,c=n.stacktrace||n.stack;return{$isError:!0,name:s,message:r,stack:c,noTelemetry:D.isErrorNoTelemetry(n)}}return n}e.transformErrorForSerialization=P;const S="Canceled";function k(n){return n instanceof O?!0:n instanceof Error&&n.name===S&&n.message===S}e.isCancellationError=k;class O extends Error{constructor(){super(S),this.name=this.message}}e.CancellationError=O;function T(){const n=new Error(S);return n.name=n.message,n}e.canceled=T;function v(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}e.illegalArgument=v;function C(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}e.illegalState=C;function y(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function f(n){const s=new Error(`${n} has been disposed`);return s.name="DISPOSED",s}e.disposed=f;function h(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}e.getErrorMessage=h;class u extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=u;class g extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=g;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class D extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof D)return s;const r=new D;return r.message=s.message,r.stack=s.stack,r}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=D;class p extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype);debugger}}e.BugIndicatingError=p}),define(ye[15],De([1,0,12]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(oe,le=0){return oe[oe.length-(1+le)]}e.tail=A;function a(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=a;function R(oe,le,ue=(te,ce)=>te===ce){if(oe===le)return!0;if(!oe||!le||oe.length!==le.length)return!1;for(let te=0,ce=oe.length;te<ce;te++)if(!ue(oe[te],le[te]))return!1;return!0}e.equals=R;function I(oe,le){const ue=oe.length-1;le<ue&&(oe[le]=oe[ue]),oe.pop()}e.removeFastWithoutKeepingOrder=I;function P(oe,le,ue){return S(oe.length,te=>ue(oe[te],le))}e.binarySearch=P;function S(oe,le){let ue=0,te=oe-1;for(;ue<=te;){const ce=(ue+te)/2|0,se=le(ce);if(se<0)ue=ce+1;else if(se>0)te=ce-1;else return ce}return-(ue+1)}e.binarySearch2=S;function k(oe,le){let ue=0,te=oe.length;if(te===0)return 0;for(;ue<te;){const ce=Math.floor((ue+te)/2);le(oe[ce])?te=ce:ue=ce+1}return ue}e.findFirstInSorted=k;function O(oe,le,ue){if(oe=oe|0,oe>=le.length)throw new TypeError("invalid index");const te=le[Math.floor(le.length*Math.random())],ce=[],se=[],F=[];for(const H of le){const K=ue(H,te);K<0?ce.push(H):K>0?se.push(H):F.push(H)}return oe<ce.length?O(oe,ce,ue):oe<ce.length+F.length?F[0]:O(oe-(ce.length+F.length),se,ue)}e.quickSelect=O;function T(oe,le){const ue=[];let te;for(const ce of oe.slice(0).sort(le))!te||le(te[0],ce)!==0?(te=[ce],ue.push(te)):te.push(ce);return ue}e.groupBy=T;function v(oe,le,ue){const te=[];function ce(H,K,_){if(K===0&&_.length===0)return;const de=te[te.length-1];de&&de.start+de.deleteCount===H?(de.deleteCount+=K,de.toInsert.push(..._)):te.push({start:H,deleteCount:K,toInsert:_})}let se=0,F=0;for(;;){if(se===oe.length){ce(se,0,le.slice(F));break}if(F===le.length){ce(se,oe.length-se,[]);break}const H=oe[se],K=le[F],_=ue(H,K);_===0?(se+=1,F+=1):_<0?(ce(se,1,[]),se+=1):_>0&&(ce(se,0,[K]),F+=1)}return te}e.sortedDiff=v;function C(oe,le,ue){const te=v(oe,le,ue),ce=[],se=[];for(const F of te)ce.push(...oe.slice(F.start,F.start+F.deleteCount)),se.push(...F.toInsert);return{removed:ce,added:se}}e.delta=C;function y(oe,le,ue){if(ue===0)return[];const te=oe.slice(0,ue).sort(le);return h(oe,le,te,ue,oe.length),te}e.top=y;function f(oe,le,ue,te,ce){return ue===0?Promise.resolve([]):new Promise((se,F)=>{(async()=>{const H=oe.length,K=oe.slice(0,ue).sort(le);for(let _=ue,de=Math.min(ue+te,H);_<H;_=de,de=Math.min(de+te,H)){if(_>ue&&await new Promise(we=>setTimeout(we)),ce&&ce.isCancellationRequested)throw new o.CancellationError;h(oe,le,K,_,de)}return K})().then(se,F)})}e.topAsync=f;function h(oe,le,ue,te,ce){for(const se=ue.length;te<ce;te++){const F=oe[te];if(le(F,ue[se-1])<0){ue.pop();const H=k(ue,K=>le(F,K)<0);ue.splice(H,0,F)}}}function u(oe){return oe.filter(le=>!!le)}e.coalesce=u;function g(oe){let le=0;for(let ue=0;ue<oe.length;ue++)oe[ue]&&(oe[le]=oe[ue],le+=1);oe.length=le}e.coalesceInPlace=g;function b(oe,le,ue){oe.splice(ue,0,oe.splice(le,1)[0])}e.move=b;function D(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=D;function p(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=p;function n(oe,le=ue=>ue){const ue=new Set;return oe.filter(te=>{const ce=le(te);return ue.has(ce)?!1:(ue.add(ce),!0)})}e.distinct=n;function s(oe){const le=new Set;return ue=>{const te=oe(ue);return le.has(te)?!1:(le.add(te),!0)}}e.uniqueFilter=s;function r(oe,le){const ue=c(oe,le);if(ue!==-1)return oe[ue]}e.findLast=r;function c(oe,le){for(let ue=oe.length-1;ue>=0;ue--){const te=oe[ue];if(le(te))return ue}return-1}e.lastIndex=c;function l(oe,le){return oe.length>0?oe[0]:le}e.firstOrDefault=l;function m(oe,le){return oe.length>0?oe[oe.length-1]:le}e.lastOrDefault=m;function i(oe,le,ue=(te,ce)=>te===ce){let te=0;for(let ce=0,se=Math.min(oe.length,le.length);ce<se&&ue(oe[ce],le[ce]);ce++)te++;return te}e.commonPrefixLength=i;function t(oe){return[].concat(...oe)}e.flatten=t;function d(oe,le){let ue=typeof le=="number"?oe:0;typeof le=="number"?ue=oe:(ue=0,le=oe);const te=[];if(ue<=le)for(let ce=ue;ce<le;ce++)te.push(ce);else for(let ce=ue;ce>le;ce--)te.push(ce);return te}e.range=d;function E(oe,le,ue){return oe.reduce((te,ce)=>(te[le(ce)]=ue?ue(ce):ce,te),Object.create(null))}e.index=E;function w(oe,le){return oe.push(le),()=>L(oe,le)}e.insert=w;function L(oe,le){const ue=oe.indexOf(le);if(ue>-1)return oe.splice(ue,1),le}e.remove=L;function q(oe,le,ue){const te=oe.slice(0,le),ce=oe.slice(le);return te.concat(ue,ce)}e.arrayInsert=q;function V(oe,le){let ue;if(typeof le=="number"){let te=le;ue=()=>{const ce=Math.sin(te++)*179426549;return ce-Math.floor(ce)}}else ue=Math.random;for(let te=oe.length-1;te>0;te-=1){const ce=Math.floor(ue()*(te+1)),se=oe[te];oe[te]=oe[ce],oe[ce]=se}}e.shuffle=V;function M(oe,le){const ue=oe.indexOf(le);ue>-1&&(oe.splice(ue,1),oe.unshift(le))}e.pushToStart=M;function B(oe,le){const ue=oe.indexOf(le);ue>-1&&(oe.splice(ue,1),oe.push(le))}e.pushToEnd=B;function N(oe,le){for(const ue of le)oe.push(ue)}e.pushMany=N;function U(oe,le){return Array.isArray(oe)?oe.map(le):le(oe)}e.mapArrayOrNot=U;function $(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=$;function z(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=z;function ae(oe,le){for(const ue of oe){const te=le(ue);if(te!==void 0)return te}}e.mapFind=ae;function ee(oe,le,ue){const te=J(oe,le),ce=oe.length,se=ue.length;oe.length=ce+se;for(let F=ce-1;F>=te;F--)oe[F+se]=oe[F];for(let F=0;F<se;F++)oe[F+te]=ue[F]}e.insertInto=ee;function x(oe,le,ue,te){const ce=J(oe,le),se=oe.splice(ce,ue);return ee(oe,ce,te),se}e.splice=x;function J(oe,le){return le<0?Math.max(le+oe.length,0):Math.min(le,oe.length)}var ie;(function(oe){function le(ce){return ce<0}oe.isLessThan=le;function ue(ce){return ce>0}oe.isGreaterThan=ue;function te(ce){return ce===0}oe.isNeitherLessOrGreaterThan=te,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(ie=e.CompareResult||(e.CompareResult={}));function pe(oe,le){return(ue,te)=>le(oe(ue),oe(te))}e.compareBy=pe;function Q(...oe){return(le,ue)=>{for(const te of oe){const ce=te(le,ue);if(!ie.isNeitherLessOrGreaterThan(ce))return ce}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=Q;const Y=(oe,le)=>oe-le;e.numberComparator=Y;function Z(oe,le){if(oe.length===0)return;let ue=oe[0];for(let te=1;te<oe.length;te++){const ce=oe[te];le(ce,ue)>0&&(ue=ce)}return ue}e.findMaxBy=Z;function me(oe,le){if(oe.length===0)return;let ue=oe[0];for(let te=1;te<oe.length;te++){const ce=oe[te];le(ce,ue)>=0&&(ue=ce)}return ue}e.findLastMaxBy=me;function ve(oe,le){return Z(oe,(ue,te)=>-le(ue,te))}e.findMinBy=ve;class Ie{constructor(le){this.f=le,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(le){let ue=this.c;for(;ue<this.f.length&&le(this.f[ue]);)ue++;const te=ue===this.c?null:this.f.slice(this.c,ue);return this.c=ue,te}takeFromEndWhile(le){let ue=this.d;for(;ue>=0&&le(this.f[ue]);)ue--;const te=ue===this.d?null:this.f.slice(ue+1,this.d+1);return this.d=ue,te}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const le=this.f[this.c];return this.c++,le}removeLast(){const le=this.f[this.d];return this.d--,le}takeCount(le){const ue=this.f.slice(this.c,this.c+le);return this.c+=le,ue}}e.ArrayQueue=Ie;class Re{constructor(le){this.iterate=le}forEach(le){this.iterate(ue=>(le(ue),!0))}toArray(){const le=[];return this.iterate(ue=>(le.push(ue),!0)),le}filter(le){return new Re(ue=>this.iterate(te=>le(te)?ue(te):!0))}map(le){return new Re(ue=>this.iterate(te=>ue(le(te))))}some(le){let ue=!1;return this.iterate(te=>(ue=le(te),!ue)),ue}findFirst(le){let ue;return this.iterate(te=>le(te)?(ue=te,!1):!0),ue}findLast(le){let ue;return this.iterate(te=>(le(te)&&(ue=te),!0)),ue}findLastMaxBy(le){let ue,te=!0;return this.iterate(ce=>((te||ie.isGreaterThan(le(ce,ue)))&&(te=!1,ue=ce),!0)),ue}}Re.empty=new Re(oe=>{}),e.CallbackIterable=Re}),define(ye[50],De([1,0,12]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(S,k){if(!S)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=A;function a(S,k="Unreachable"){throw new Error(k)}e.assertNever=a;function R(S){if(!S)throw new o.BugIndicatingError("Assertion Failed")}e.assert=R;function I(S){if(!S()){debugger;S(),(0,o.onUnexpectedError)(new o.BugIndicatingError("Assertion Failed"))}}e.assertFn=I;function P(S,k){let O=0;for(;O<S.length-1;){const T=S[O],v=S[O+1];if(!k(T,v))return!1;O++}return!0}e.checkAdjacentItems=P}),define(ye[63],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function o(A){const a=this;let R=!1,I;return function(){return R||(R=!0,I=A.apply(a,arguments)),I}}e.once=o}),define(ye[101],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class o{constructor(a){this.a=a,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=o,e.defaultGenerator=new o("id#")}),define(ye[64],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var o;(function(A){function a(D){return D&&typeof D=="object"&&typeof D[Symbol.iterator]=="function"}A.is=a;const R=Object.freeze([]);function I(){return R}A.empty=I;function*P(D){yield D}A.single=P;function S(D){return a(D)?D:P(D)}A.wrap=S;function k(D){return D||R}A.from=k;function O(D){return!D||D[Symbol.iterator]().next().done===!0}A.isEmpty=O;function T(D){return D[Symbol.iterator]().next().value}A.first=T;function v(D,p){for(const n of D)if(p(n))return!0;return!1}A.some=v;function C(D,p){for(const n of D)if(p(n))return n}A.find=C;function*y(D,p){for(const n of D)p(n)&&(yield n)}A.filter=y;function*f(D,p){let n=0;for(const s of D)yield p(s,n++)}A.map=f;function*h(...D){for(const p of D)for(const n of p)yield n}A.concat=h;function u(D,p,n){let s=n;for(const r of D)s=p(s,r);return s}A.reduce=u;function*g(D,p,n=D.length){for(p<0&&(p+=D.length),n<0?n+=D.length:n>D.length&&(n=D.length);p<n;p++)yield D[p]}A.slice=g;function b(D,p=Number.POSITIVE_INFINITY){const n=[];if(p===0)return[n,D];const s=D[Symbol.iterator]();for(let r=0;r<p;r++){const c=s.next();if(c.done)return[n,A.empty()];n.push(c.value)}return[n,{[Symbol.iterator](){return s}}]}A.consume=b})(o=e.Iterable||(e.Iterable={}))}),define(ye[146],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var o;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(o=e.ScanError||(e.ScanError={}));var A;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var a;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(a=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(n){n.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function I(n,s=!1){let r=0;const c=n.length;let l="",m=0,i=16,t=0;function d(B){let N=0,U=0;for(;N<B;){const $=n.charCodeAt(r);if($>=48&&$<=57)U=U*16+$-48;else if($>=65&&$<=70)U=U*16+$-65+10;else if($>=97&&$<=102)U=U*16+$-97+10;else break;r++,N++}return N<B&&(U=-1),U}function E(B){r=B,l="",m=0,i=16,t=0}function w(){const B=r;if(n.charCodeAt(r)===48)r++;else for(r++;r<n.length&&k(n.charCodeAt(r));)r++;if(r<n.length&&n.charCodeAt(r)===46)if(r++,r<n.length&&k(n.charCodeAt(r)))for(r++;r<n.length&&k(n.charCodeAt(r));)r++;else return t=3,n.substring(B,r);let N=r;if(r<n.length&&(n.charCodeAt(r)===69||n.charCodeAt(r)===101))if(r++,(r<n.length&&n.charCodeAt(r)===43||n.charCodeAt(r)===45)&&r++,r<n.length&&k(n.charCodeAt(r))){for(r++;r<n.length&&k(n.charCodeAt(r));)r++;N=r}else t=3;return n.substring(B,N)}function L(){let B="",N=r;for(;;){if(r>=c){B+=n.substring(N,r),t=2;break}const U=n.charCodeAt(r);if(U===34){B+=n.substring(N,r),r++;break}if(U===92){if(B+=n.substring(N,r),r++,r>=c){t=2;break}switch(n.charCodeAt(r++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const z=d(4);z>=0?B+=String.fromCharCode(z):t=4;break}default:t=5}N=r;continue}if(U>=0&&U<=31)if(S(U)){B+=n.substring(N,r),t=2;break}else t=6;r++}return B}function q(){if(l="",t=0,m=r,r>=c)return m=c,i=17;let B=n.charCodeAt(r);if(P(B)){do r++,l+=String.fromCharCode(B),B=n.charCodeAt(r);while(P(B));return i=15}if(S(B))return r++,l+=String.fromCharCode(B),B===13&&n.charCodeAt(r)===10&&(r++,l+=`
`),i=14;switch(B){case 123:return r++,i=1;case 125:return r++,i=2;case 91:return r++,i=3;case 93:return r++,i=4;case 58:return r++,i=6;case 44:return r++,i=5;case 34:return r++,l=L(),i=10;case 47:{const N=r-1;if(n.charCodeAt(r+1)===47){for(r+=2;r<c&&!S(n.charCodeAt(r));)r++;return l=n.substring(N,r),i=12}if(n.charCodeAt(r+1)===42){r+=2;const U=c-1;let $=!1;for(;r<U;){if(n.charCodeAt(r)===42&&n.charCodeAt(r+1)===47){r+=2,$=!0;break}r++}return $||(r++,t=1),l=n.substring(N,r),i=13}return l+=String.fromCharCode(B),r++,i=16}case 45:if(l+=String.fromCharCode(B),r++,r===c||!k(n.charCodeAt(r)))return i=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=w(),i=11;default:for(;r<c&&V(B);)r++,B=n.charCodeAt(r);if(m!==r){switch(l=n.substring(m,r),l){case"true":return i=8;case"false":return i=9;case"null":return i=7}return i=16}return l+=String.fromCharCode(B),r++,i=16}}function V(B){if(P(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let B;do B=q();while(B>=12&&B<=15);return B}return{setPosition:E,getPosition:()=>r,scan:s?M:q,getToken:()=>i,getTokenValue:()=>l,getTokenOffset:()=>m,getTokenLength:()=>r-m,getTokenError:()=>t}}e.createScanner=I;function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function S(n){return n===10||n===13||n===8232||n===8233}function k(n){return n>=48&&n<=57}var O;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(O||(O={}));function T(n,s){const r=[],c=new Object;let l;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let i=!1;function t(d,E,w,L){m.value=d,m.offset=E,m.length=w,m.type=L,m.colonOffset=void 0,l=m}try{b(n,{onObjectBegin:(d,E)=>{if(s<=d)throw c;l=void 0,i=s>d,r.push("")},onObjectProperty:(d,E,w)=>{if(s<E||(t(d,E,w,"property"),r[r.length-1]=d,s<=E+w))throw c},onObjectEnd:(d,E)=>{if(s<=d)throw c;l=void 0,r.pop()},onArrayBegin:(d,E)=>{if(s<=d)throw c;l=void 0,r.push(0)},onArrayEnd:(d,E)=>{if(s<=d)throw c;l=void 0,r.pop()},onLiteralValue:(d,E,w)=>{if(s<E||(t(d,E,w,p(d)),s<=E+w))throw c},onSeparator:(d,E,w)=>{if(s<=E)throw c;if(d===":"&&l&&l.type==="property")l.colonOffset=E,i=!1,l=void 0;else if(d===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(i=!0,r[r.length-1]=""),l=void 0}}})}catch(d){if(d!==c)throw d}return{path:r,previousNode:l,isAtPropertyKey:i,matches:d=>{let E=0;for(let w=0;E<d.length&&w<r.length;w++)if(d[E]===r[w]||d[E]==="*")E++;else if(d[E]!=="**")return!1;return E===d.length}}}e.getLocation=T;function v(n,s=[],r=R.DEFAULT){let c=null,l=[];const m=[];function i(d){Array.isArray(l)?l.push(d):c!==null&&(l[c]=d)}return b(n,{onObjectBegin:()=>{const d={};i(d),m.push(l),l=d,c=null},onObjectProperty:d=>{c=d},onObjectEnd:()=>{l=m.pop()},onArrayBegin:()=>{const d=[];i(d),m.push(l),l=d,c=null},onArrayEnd:()=>{l=m.pop()},onLiteralValue:i,onError:(d,E,w)=>{s.push({error:d,offset:E,length:w})}},r),l[0]}e.parse=v;function C(n,s=[],r=R.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(d){c.type==="property"&&(c.length=d-c.offset,c=c.parent)}function m(d){return c.children.push(d),d}b(n,{onObjectBegin:d=>{c=m({type:"object",offset:d,length:-1,parent:c,children:[]})},onObjectProperty:(d,E,w)=>{c=m({type:"property",offset:E,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:d,offset:E,length:w,parent:c})},onObjectEnd:(d,E)=>{c.length=d+E-c.offset,c=c.parent,l(d+E)},onArrayBegin:(d,E)=>{c=m({type:"array",offset:d,length:-1,parent:c,children:[]})},onArrayEnd:(d,E)=>{c.length=d+E-c.offset,c=c.parent,l(d+E)},onLiteralValue:(d,E,w)=>{m({type:p(d),offset:E,length:w,parent:c,value:d}),l(E+w)},onSeparator:(d,E,w)=>{c.type==="property"&&(d===":"?c.colonOffset=E:d===","&&l(E))},onError:(d,E,w)=>{s.push({error:d,offset:E,length:w})}},r);const t=c.children[0];return t&&delete t.parent,t}e.parseTree=C;function y(n,s){if(!n)return;let r=n;for(const c of s)if(typeof c=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const m of r.children)if(Array.isArray(m.children)&&m.children[0].value===c){r=m.children[1],l=!0;break}if(!l)return}else{const l=c;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=y;function f(n){if(!n.parent||!n.parent.children)return[];const s=f(n.parent);if(n.parent.type==="property"){const r=n.parent.children[0].value;s.push(r)}else if(n.parent.type==="array"){const r=n.parent.children.indexOf(n);r!==-1&&s.push(r)}return s}e.getNodePath=f;function h(n){switch(n.type){case"array":return n.children.map(h);case"object":{const s=Object.create(null);for(const r of n.children){const c=r.children[1];c&&(s[r.children[0].value]=h(c))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=h;function u(n,s,r=!1){return s>=n.offset&&s<n.offset+n.length||r&&s===n.offset+n.length}e.contains=u;function g(n,s,r=!1){if(u(n,s,r)){const c=n.children;if(Array.isArray(c))for(let l=0;l<c.length&&c[l].offset<=s;l++){const m=g(c[l],s,r);if(m)return m}return n}}e.findNodeAtOffset=g;function b(n,s,r=R.DEFAULT){const c=I(n,!1);function l(pe){return pe?()=>pe(c.getTokenOffset(),c.getTokenLength()):()=>!0}function m(pe){return pe?Q=>pe(Q,c.getTokenOffset(),c.getTokenLength()):()=>!0}const i=l(s.onObjectBegin),t=m(s.onObjectProperty),d=l(s.onObjectEnd),E=l(s.onArrayBegin),w=l(s.onArrayEnd),L=m(s.onLiteralValue),q=m(s.onSeparator),V=l(s.onComment),M=m(s.onError),B=r&&r.disallowComments,N=r&&r.allowTrailingComma;function U(){for(;;){const pe=c.scan();switch(c.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:B||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(pe){case 12:case 13:B?$(10):V();break;case 16:$(1);break;case 15:case 14:break;default:return pe}}}function $(pe,Q=[],Y=[]){if(M(pe),Q.length+Y.length>0){let Z=c.getToken();for(;Z!==17;){if(Q.indexOf(Z)!==-1){U();break}else if(Y.indexOf(Z)!==-1)break;Z=U()}}}function z(pe){const Q=c.getTokenValue();return pe?L(Q):t(Q),U(),!0}function ae(){switch(c.getToken()){case 11:{let pe=0;try{pe=JSON.parse(c.getTokenValue()),typeof pe!="number"&&($(2),pe=0)}catch{$(2)}L(pe);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return U(),!0}function ee(){return c.getToken()!==10?($(3,[],[2,5]),!1):(z(!1),c.getToken()===6?(q(":"),U(),ie()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function x(){i(),U();let pe=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(pe||$(4,[],[]),q(","),U(),c.getToken()===2&&N)break}else pe&&$(6,[],[]);ee()||$(4,[],[2,5]),pe=!0}return d(),c.getToken()!==2?$(7,[2],[]):U(),!0}function J(){E(),U();let pe=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(pe||$(4,[],[]),q(","),U(),c.getToken()===4&&N)break}else pe&&$(6,[],[]);ie()||$(4,[],[4,5]),pe=!0}return w(),c.getToken()!==4?$(8,[4],[]):U(),!0}function ie(){switch(c.getToken()){case 3:return J();case 1:return x();case 10:return z(!0);default:return ae()}}return U(),c.getToken()===17?r.allowEmptyContent?!0:($(4,[],[]),!1):ie()?(c.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=b;function D(n,s){const r=I(n),c=[];let l,m=0,i;do switch(i=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:m!==i&&c.push(n.substring(m,i)),s!==void 0&&c.push(r.getTokenValue().replace(/[^\r\n]/g,s)),m=r.getPosition();break}while(l!==17);return c.join("")}e.stripComments=D;function p(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(ye[65],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class o{constructor(a){this.d=a,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(a){this.c=a}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=o}),define(ye[6],De([1,0,63,64]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const a=!1;let R=null;function I(m){R=m}if(e.setDisposableTracker=I,a){const m="__is_disposable_tracked__";I(new class{trackDisposable(i){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[m]||console.log(t)},3e3)}setParent(i,t){if(i&&i!==g.None)try{i[m]=!0}catch{}}markAsDisposed(i){if(i&&i!==g.None)try{i[m]=!0}catch{}}markAsSingleton(i){}})}function P(m){return R?.trackDisposable(m),m}function S(m){R?.markAsDisposed(m)}function k(m,i){R?.setParent(m,i)}function O(m,i){if(!!R)for(const t of m)R.setParent(t,i)}function T(m){return R?.markAsSingleton(m),m}e.markAsSingleton=T;function v(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=v;function C(m){if(A.Iterable.is(m)){const i=[];for(const t of m)if(t)try{t.dispose()}catch(d){i.push(d)}if(i.length===1)throw i[0];if(i.length>1)throw new AggregateError(i,"Encountered errors while disposing of store");return Array.isArray(m)?[]:m}else if(m)return m.dispose(),m}e.dispose=C;function y(m){for(const i of m)v(i)&&i.dispose();return[]}e.disposeIfDisposable=y;function f(...m){const i=h(()=>C(m));return O(m,i),i}e.combinedDisposable=f;function h(m){const i=P({dispose:(0,o.once)(()=>{S(i),m()})});return i}e.toDisposable=h;class u{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(S(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{C(this.c)}finally{this.c.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return k(i,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(i),i}}u.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=u;class g{constructor(){this.q=new u,P(this),k(this.q,this)}dispose(){S(this),this.q.dispose()}B(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(i)}}g.None=Object.freeze({dispose(){}}),e.Disposable=g;class b{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(i){this.b||i===this.a||(this.a?.dispose(),i&&k(i,this),this.a=i)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const i=this.a;return this.a=void 0,i&&k(i,null),i}}e.MutableDisposable=b;class D{constructor(i){this.b=i,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=D;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(i){let t=i;return this.unset=()=>t=void 0,this.isset=()=>t!==void 0,this.dispose=()=>{t&&(t(),t=void 0,S(this))},this}}e.SafeDisposable=p;class n{constructor(){this.a=new Map}acquire(i,...t){let d=this.a.get(i);d||(d={counter:0,object:this.b(i,...t)},this.a.set(i,d));const{object:E}=d,w=(0,o.once)(()=>{--d.counter===0&&(this.c(i,d.object),this.a.delete(i))});return d.counter++,{object:E,dispose:w}}}e.ReferenceCollection=n;class s{constructor(i){this.a=i}async acquire(i,...t){const d=this.a.acquire(i,...t);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(E){throw d.dispose(),E}}}e.AsyncReferenceCollection=s;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r;function c(m){const i=new u;try{m(i)}finally{i.dispose()}}e.disposeOnReturn=c;class l{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{C(this.a.values())}finally{this.a.clear()}}has(i){return this.a.has(i)}get(i){return this.a.get(i)}set(i,t,d=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),d||this.a.get(i)?.dispose(),this.a.set(i,t)}deleteAndDispose(i){this.a.get(i)?.dispose(),this.a.delete(i)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=l}),define(ye[66],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class o{constructor(R){this.element=R,this.next=o.Undefined,this.prev=o.Undefined}}o.Undefined=new o(void 0);class A{constructor(){this.a=o.Undefined,this.b=o.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===o.Undefined}clear(){let R=this.a;for(;R!==o.Undefined;){const I=R.next;R.prev=o.Undefined,R.next=o.Undefined,R=I}this.a=o.Undefined,this.b=o.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,I){const P=new o(R);if(this.a===o.Undefined)this.a=P,this.b=P;else if(I){const k=this.b;this.b=P,P.prev=k,k.next=P}else{const k=this.a;this.a=P,P.next=k,k.prev=P}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(P))}}shift(){if(this.a!==o.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==o.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==o.Undefined&&R.next!==o.Undefined){const I=R.prev;I.next=R.next,R.next.prev=I}else R.prev===o.Undefined&&R.next===o.Undefined?(this.a=o.Undefined,this.b=o.Undefined):R.next===o.Undefined?(this.b=this.b.prev,this.b.next=o.Undefined):R.prev===o.Undefined&&(this.a=this.a.next,this.a.prev=o.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==o.Undefined;)yield R.element,R=R.next}}e.LinkedList=A}),define(ye[28],De([1,0]),function(ne,e){"use strict";var o,A,a;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(y,f,h){let u=y.get(f);return u===void 0&&(u=h,y.set(f,u)),u}e.getOrSet=R;function I(y){const f=[];return y.forEach((h,u)=>{f.push(`${u} => ${h}`)}),`Map(${y.size}) {${f.join(", ")}}`}e.mapToString=I;function P(y){const f=[];return y.forEach(h=>{f.push(h)}),`Set(${y.size}) {${f.join(", ")}}`}e.setToString=P;class S{constructor(f,h){this.uri=f,this.value=h}}class k{constructor(f,h){this[o]="ResourceMap",f instanceof k?(this.b=new Map(f.b),this.c=h??k.a):(this.b=new Map,this.c=f??k.a)}set(f,h){return this.b.set(this.c(f),new S(f,h)),this}get(f){return this.b.get(this.c(f))?.value}has(f){return this.b.has(this.c(f))}get size(){return this.b.size}clear(){this.b.clear()}delete(f){return this.b.delete(this.c(f))}forEach(f,h){typeof h<"u"&&(f=f.bind(h));for(const[u,g]of this.b)f(g.value,g.uri,this)}*values(){for(const f of this.b.values())yield f.value}*keys(){for(const f of this.b.values())yield f.uri}*entries(){for(const f of this.b.values())yield[f.uri,f.value]}*[(o=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.b)yield[f.uri,f.value]}}k.a=y=>y.toString(),e.ResourceMap=k;class O{constructor(f,h){this[A]="ResourceSet",!f||typeof f=="function"?this.a=new k(f):(this.a=new k(h),f.forEach(this.add,this))}get size(){return this.a.size}add(f){return this.a.set(f,f),this}clear(){this.a.clear()}delete(f){return this.a.delete(f)}forEach(f,h){this.a.forEach((u,g)=>f.call(h,g,g,this))}has(f){return this.a.has(f)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var T;(function(y){y[y.None=0]="None",y[y.AsOld=1]="AsOld",y[y.AsNew=2]="AsNew"})(T=e.Touch||(e.Touch={}));class v{constructor(){this[a]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(f){return this.a.has(f)}get(f,h=0){const u=this.a.get(f);if(!!u)return h!==0&&this.j(u,h),u.value}set(f,h,u=0){let g=this.a.get(f);if(g)g.value=h,u!==0&&this.j(g,u);else{switch(g={key:f,value:h,next:void 0,previous:void 0},u){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(f,g),this.d++}return this}delete(f){return!!this.remove(f)}remove(f){const h=this.a.get(f);if(!!h)return this.a.delete(f),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const f=this.b;return this.a.delete(f.key),this.i(f),this.d--,f.value}forEach(f,h){const u=this.e;let g=this.b;for(;g;){if(h?f.bind(h)(g.value,g.key,this):f(g.value,g.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const f=this,h=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(f.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:u.key,done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return g}values(){const f=this,h=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(f.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:u.value,done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return g}entries(){const f=this,h=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(f.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:[u.key,u.value],done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return g}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(f){if(f>=this.size)return;if(f===0){this.clear();return}let h=this.b,u=this.size;for(;h&&u>f;)this.a.delete(h.key),h=h.next,u--;this.b=h,this.d=u,h&&(h.previous=void 0),this.e++}g(f){if(!this.b&&!this.c)this.c=f;else if(this.b)f.next=this.b,this.b.previous=f;else throw new Error("Invalid list");this.b=f,this.e++}h(f){if(!this.b&&!this.c)this.b=f;else if(this.c)f.previous=this.c,this.c.next=f;else throw new Error("Invalid list");this.c=f,this.e++}i(f){if(f===this.b&&f===this.c)this.b=void 0,this.c=void 0;else if(f===this.b){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this.b=f.next}else if(f===this.c){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this.c=f.previous}else{const h=f.next,u=f.previous;if(!h||!u)throw new Error("Invalid list");h.previous=u,u.next=h}f.next=void 0,f.previous=void 0,this.e++}j(f,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(f===this.b)return;const u=f.next,g=f.previous;f===this.c?(g.next=void 0,this.c=g):(u.previous=g,g.next=u),f.previous=void 0,f.next=this.b,this.b.previous=f,this.b=f,this.e++}else if(h===2){if(f===this.c)return;const u=f.next,g=f.previous;f===this.b?(u.previous=void 0,this.b=u):(u.previous=g,g.next=u),f.next=void 0,f.previous=this.c,this.c.next=f,this.c=f,this.e++}}}toJSON(){const f=[];return this.forEach((h,u)=>{f.push([u,h])}),f}fromJSON(f){this.clear();for(const[h,u]of f)this.set(h,u)}}e.LinkedMap=v;class C extends v{constructor(f,h=1){super(),this.k=f,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(f){this.k=f,this.m()}get ratio(){return this.l}set ratio(f){this.l=Math.min(Math.max(0,f),1),this.m()}get(f,h=2){return super.get(f,h)}peek(f){return super.get(f,0)}set(f,h){return super.set(f,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=C}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ye[147],De([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(oe,le){for(var ue=0;ue<le.length;ue++){var te=le[ue];te.enumerable=te.enumerable||!1,te.configurable=!0,"value"in te&&(te.writable=!0),Object.defineProperty(oe,te.key,te)}}function o(oe,le,ue){return le&&e(oe.prototype,le),ue&&e(oe,ue),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function A(oe,le){if(!!oe){if(typeof oe=="string")return a(oe,le);var ue=Object.prototype.toString.call(oe).slice(8,-1);if(ue==="Object"&&oe.constructor&&(ue=oe.constructor.name),ue==="Map"||ue==="Set")return Array.from(oe);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return a(oe,le)}}function a(oe,le){(le==null||le>oe.length)&&(le=oe.length);for(var ue=0,te=new Array(le);ue<le;ue++)te[ue]=oe[ue];return te}function R(oe,le){var ue=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(ue)return(ue=ue.call(oe)).next.bind(ue);if(Array.isArray(oe)||(ue=A(oe))||le&&oe&&typeof oe.length=="number"){ue&&(oe=ue);var te=0;return function(){return te>=oe.length?{done:!0}:{done:!1,value:oe[te++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=I();function P(oe){ne.defaults=oe}var S=/[&<>"']/,k=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(le){return v[le]};function y(oe,le){if(le){if(S.test(oe))return oe.replace(k,C)}else if(O.test(oe))return oe.replace(T,C);return oe}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(oe){return oe.replace(f,function(le,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var u=/(^|[^\[])\^/g;function g(oe,le){oe=typeof oe=="string"?oe:oe.source,le=le||"";var ue={replace:function(ce,se){return se=se.source||se,se=se.replace(u,"$1"),oe=oe.replace(ce,se),ue},getRegex:function(){return new RegExp(oe,le)}};return ue}var b=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(oe,le,ue){if(oe){var te;try{te=decodeURIComponent(h(ue)).replace(b,"").toLowerCase()}catch{return null}if(te.indexOf("javascript:")===0||te.indexOf("vbscript:")===0||te.indexOf("data:")===0)return null}le&&!D.test(ue)&&(ue=l(le,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var n={},s=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(oe,le){n[" "+oe]||(s.test(oe)?n[" "+oe]=oe+"/":n[" "+oe]=d(oe,"/",!0)),oe=n[" "+oe];var ue=oe.indexOf(":")===-1;return le.substring(0,2)==="//"?ue?le:oe.replace(r,"$1")+le:le.charAt(0)==="/"?ue?le:oe.replace(c,"$1")+le:oe+le}var m={exec:function(){}};function i(oe){for(var le=1,ue,te;le<arguments.length;le++){ue=arguments[le];for(te in ue)Object.prototype.hasOwnProperty.call(ue,te)&&(oe[te]=ue[te])}return oe}function t(oe,le){var ue=oe.replace(/\|/g,function(se,F,H){for(var K=!1,_=F;--_>=0&&H[_]==="\\";)K=!K;return K?"|":" |"}),te=ue.split(/ \|/),ce=0;if(te[0].trim()||te.shift(),te.length>0&&!te[te.length-1].trim()&&te.pop(),te.length>le)te.splice(le);else for(;te.length<le;)te.push("");for(;ce<te.length;ce++)te[ce]=te[ce].trim().replace(/\\\|/g,"|");return te}function d(oe,le,ue){var te=oe.length;if(te===0)return"";for(var ce=0;ce<te;){var se=oe.charAt(te-ce-1);if(se===le&&!ue)ce++;else if(se!==le&&ue)ce++;else break}return oe.slice(0,te-ce)}function E(oe,le){if(oe.indexOf(le[1])===-1)return-1;for(var ue=oe.length,te=0,ce=0;ce<ue;ce++)if(oe[ce]==="\\")ce++;else if(oe[ce]===le[0])te++;else if(oe[ce]===le[1]&&(te--,te<0))return ce;return-1}function w(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(oe,le){if(le<1)return"";for(var ue="";le>1;)le&1&&(ue+=oe),le>>=1,oe+=oe;return ue+oe}function q(oe,le,ue,te){var ce=le.href,se=le.title?y(le.title):null,F=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){te.state.inLink=!0;var H={type:"link",raw:ue,href:ce,title:se,text:F,tokens:te.inlineTokens(F)};return te.state.inLink=!1,H}return{type:"image",raw:ue,href:ce,title:se,text:y(F)}}function V(oe,le){var ue=oe.match(/^(\s+)(?:```)/);if(ue===null)return le;var te=ue[1];return le.split(`
`).map(function(ce){var se=ce.match(/^\s+/);if(se===null)return ce;var F=se[0];return F.length>=te.length?ce.slice(te.length):ce}).join(`
`)}var M=function(){function oe(ue){this.options=ue||ne.defaults}var le=oe.prototype;return le.space=function(te){var ce=this.rules.block.newline.exec(te);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},le.code=function(te){var ce=this.rules.block.code.exec(te);if(ce){var se=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?se:d(se,`
`)}}},le.fences=function(te){var ce=this.rules.block.fences.exec(te);if(ce){var se=ce[0],F=V(se,ce[3]||"");return{type:"code",raw:se,lang:ce[2]?ce[2].trim():ce[2],text:F}}},le.heading=function(te){var ce=this.rules.block.heading.exec(te);if(ce){var se=ce[2].trim();if(/#$/.test(se)){var F=d(se,"#");(this.options.pedantic||!F||/ $/.test(F))&&(se=F.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:se,tokens:this.lexer.inline(se)}}},le.hr=function(te){var ce=this.rules.block.hr.exec(te);if(ce)return{type:"hr",raw:ce[0]}},le.blockquote=function(te){var ce=this.rules.block.blockquote.exec(te);if(ce){var se=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},le.list=function(te){var ce=this.rules.block.list.exec(te);if(ce){var se,F,H,K,_,de,we,Pe,be,Ce,ke,He,Ge=ce[1].trim(),nt=Ge.length>1,Qe={type:"list",raw:"",ordered:nt,start:nt?+Ge.slice(0,-1):"",loose:!1,items:[]};Ge=nt?"\\d{1,9}\\"+Ge.slice(-1):"\\"+Ge,this.options.pedantic&&(Ge=nt?Ge:"[*+-]");for(var tt=new RegExp("^( {0,3}"+Ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");te&&(He=!1,!(!(ce=tt.exec(te))||this.rules.block.hr.test(te)));){if(se=ce[0],te=te.substring(se.length),Pe=ce[2].split(`
`,1)[0],be=te.split(`
`,1)[0],this.options.pedantic?(K=2,ke=Pe.trimLeft()):(K=ce[2].search(/[^ ]/),K=K>4?1:K,ke=Pe.slice(K),K+=ce[1].length),de=!1,!Pe&&/^ *$/.test(be)&&(se+=be+`
`,te=te.substring(be.length+1),He=!0),!He)for(var rt=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Be=new RegExp("^ {0,"+Math.min(3,K-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:```|~~~)"),W=new RegExp("^ {0,"+Math.min(3,K-1)+"}#");te&&(Ce=te.split(`
`,1)[0],Pe=Ce,this.options.pedantic&&(Pe=Pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Pe)||W.test(Pe)||rt.test(Pe)||Be.test(te)));){if(Pe.search(/[^ ]/)>=K||!Pe.trim())ke+=`
`+Pe.slice(K);else if(!de)ke+=`
`+Pe;else break;!de&&!Pe.trim()&&(de=!0),se+=Ce+`
`,te=te.substring(Ce.length+1)}Qe.loose||(we?Qe.loose=!0:/\n *\n *$/.test(se)&&(we=!0)),this.options.gfm&&(F=/^\[[ xX]\] /.exec(ke),F&&(H=F[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:se,task:!!F,checked:H,loose:!1,text:ke}),Qe.raw+=se}Qe.items[Qe.items.length-1].raw=se.trimRight(),Qe.items[Qe.items.length-1].text=ke.trimRight(),Qe.raw=Qe.raw.trimRight();var X=Qe.items.length;for(_=0;_<X;_++){this.lexer.state.top=!1,Qe.items[_].tokens=this.lexer.blockTokens(Qe.items[_].text,[]);var he=Qe.items[_].tokens.filter(function(Ne){return Ne.type==="space"}),Le=he.every(function(Ne){for(var qe=Ne.raw.split(""),je=0,Ze=R(qe),st;!(st=Ze()).done;){var at=st.value;if(at===`
`&&(je+=1),je>1)return!0}return!1});!Qe.loose&&he.length&&Le&&(Qe.loose=!0,Qe.items[_].loose=!0)}return Qe}},le.html=function(te){var ce=this.rules.block.html.exec(te);if(ce){var se={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var F=this.options.sanitizer?this.options.sanitizer(ce[0]):y(ce[0]);se.type="paragraph",se.text=F,se.tokens=this.lexer.inline(F)}return se}},le.def=function(te){var ce=this.rules.block.def.exec(te);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var se=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:ce[0],href:ce[2],title:ce[3]}}},le.table=function(te){var ce=this.rules.block.table.exec(te);if(ce){var se={type:"table",header:t(ce[1]).map(function(we){return{text:we}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=ce[0];var F=se.align.length,H,K,_,de;for(H=0;H<F;H++)/^ *-+: *$/.test(se.align[H])?se.align[H]="right":/^ *:-+: *$/.test(se.align[H])?se.align[H]="center":/^ *:-+ *$/.test(se.align[H])?se.align[H]="left":se.align[H]=null;for(F=se.rows.length,H=0;H<F;H++)se.rows[H]=t(se.rows[H],se.header.length).map(function(we){return{text:we}});for(F=se.header.length,K=0;K<F;K++)se.header[K].tokens=this.lexer.inline(se.header[K].text);for(F=se.rows.length,K=0;K<F;K++)for(de=se.rows[K],_=0;_<de.length;_++)de[_].tokens=this.lexer.inline(de[_].text);return se}}},le.lheading=function(te){var ce=this.rules.block.lheading.exec(te);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},le.paragraph=function(te){var ce=this.rules.block.paragraph.exec(te);if(ce){var se=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:se,tokens:this.lexer.inline(se)}}},le.text=function(te){var ce=this.rules.block.text.exec(te);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},le.escape=function(te){var ce=this.rules.inline.escape.exec(te);if(ce)return{type:"escape",raw:ce[0],text:y(ce[1])}},le.tag=function(te){var ce=this.rules.inline.tag.exec(te);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):y(ce[0]):ce[0]}},le.link=function(te){var ce=this.rules.inline.link.exec(te);if(ce){var se=ce[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var F=d(se.slice(0,-1),"\\");if((se.length-F.length)%2===0)return}else{var H=E(ce[2],"()");if(H>-1){var K=ce[0].indexOf("!")===0?5:4,_=K+ce[1].length+H;ce[2]=ce[2].substring(0,H),ce[0]=ce[0].substring(0,_).trim(),ce[3]=""}}var de=ce[2],we="";if(this.options.pedantic){var Pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);Pe&&(de=Pe[1],we=Pe[3])}else we=ce[3]?ce[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(se)?de=de.slice(1):de=de.slice(1,-1)),q(ce,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},le.reflink=function(te,ce){var se;if((se=this.rules.inline.reflink.exec(te))||(se=this.rules.inline.nolink.exec(te))){var F=(se[2]||se[1]).replace(/\s+/g," ");if(F=ce[F.toLowerCase()],!F||!F.href){var H=se[0].charAt(0);return{type:"text",raw:H,text:H}}return q(se,F,se[0],this.lexer)}},le.emStrong=function(te,ce,se){se===void 0&&(se="");var F=this.rules.inline.emStrong.lDelim.exec(te);if(!!F&&!(F[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var H=F[1]||F[2]||"";if(!H||H&&(se===""||this.rules.inline.punctuation.exec(se))){var K=F[0].length-1,_,de,we=K,Pe=0,be=F[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(be.lastIndex=0,ce=ce.slice(-1*te.length+K);(F=be.exec(ce))!=null;)if(_=F[1]||F[2]||F[3]||F[4]||F[5]||F[6],!!_){if(de=_.length,F[3]||F[4]){we+=de;continue}else if((F[5]||F[6])&&K%3&&!((K+de)%3)){Pe+=de;continue}if(we-=de,!(we>0)){if(de=Math.min(de,de+we+Pe),Math.min(K,de)%2){var Ce=te.slice(1,K+F.index+de);return{type:"em",raw:te.slice(0,K+F.index+de+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var ke=te.slice(2,K+F.index+de-1);return{type:"strong",raw:te.slice(0,K+F.index+de+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},le.codespan=function(te){var ce=this.rules.inline.code.exec(te);if(ce){var se=ce[2].replace(/\n/g," "),F=/[^ ]/.test(se),H=/^ /.test(se)&&/ $/.test(se);return F&&H&&(se=se.substring(1,se.length-1)),se=y(se,!0),{type:"codespan",raw:ce[0],text:se}}},le.br=function(te){var ce=this.rules.inline.br.exec(te);if(ce)return{type:"br",raw:ce[0]}},le.del=function(te){var ce=this.rules.inline.del.exec(te);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},le.autolink=function(te,ce){var se=this.rules.inline.autolink.exec(te);if(se){var F,H;return se[2]==="@"?(F=y(this.options.mangle?ce(se[1]):se[1]),H="mailto:"+F):(F=y(se[1]),H=F),{type:"link",raw:se[0],text:F,href:H,tokens:[{type:"text",raw:F,text:F}]}}},le.url=function(te,ce){var se;if(se=this.rules.inline.url.exec(te)){var F,H;if(se[2]==="@")F=y(this.options.mangle?ce(se[0]):se[0]),H="mailto:"+F;else{var K;do K=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(K!==se[0]);F=y(se[0]),se[1]==="www."?H="http://"+F:H=F}return{type:"link",raw:se[0],text:F,href:H,tokens:[{type:"text",raw:F,text:F}]}}},le.inlineText=function(te,ce){var se=this.rules.inline.text.exec(te);if(se){var F;return this.lexer.state.inRawBlock?F=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):y(se[0]):se[0]:F=y(this.options.smartypants?ce(se[0]):se[0]),{type:"text",raw:se[0],text:F}}},oe}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=g(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=g(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=g(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=g(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=g(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=i({},B),B.gfm=i({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=g(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=i({},B.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:g(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=g(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=g(B._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=g(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=g(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=g(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=g(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=g(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=g(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=g(N.reflink).replace("label",N._label).replace("ref",B._label).getRegex(),N.nolink=g(N.nolink).replace("ref",B._label).getRegex(),N.reflinkSearch=g(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=i({},N),N.pedantic=i({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=i({},N.normal,{escape:g(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=g(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=i({},N.gfm,{br:g(N.br).replace("{2,}","*").getRegex(),text:g(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(oe){var le="",ue,te,ce=oe.length;for(ue=0;ue<ce;ue++)te=oe.charCodeAt(ue),Math.random()>.5&&(te="x"+te.toString(16)),le+="&#"+te+";";return le}var z=function(){function oe(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||ne.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var te={block:B.normal,inline:N.normal};this.options.pedantic?(te.block=B.pedantic,te.inline=N.pedantic):this.options.gfm&&(te.block=B.gfm,this.options.breaks?te.inline=N.breaks:te.inline=N.gfm),this.tokenizer.rules=te}oe.lex=function(te,ce){var se=new oe(ce);return se.lex(te)},oe.lexInline=function(te,ce){var se=new oe(ce);return se.inlineTokens(te)};var le=oe.prototype;return le.lex=function(te){te=te.replace(/\r\n|\r/g,`
`),this.blockTokens(te,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},le.blockTokens=function(te,ce){var se=this;ce===void 0&&(ce=[]),this.options.pedantic?te=te.replace(/\t/g,"    ").replace(/^ +$/gm,""):te=te.replace(/^( *)(\t+)/gm,function(we,Pe,be){return Pe+"    ".repeat(be.length)});for(var F,H,K,_;te;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(F=we.call({lexer:se},te,ce))?(te=te.substring(F.raw.length),ce.push(F),!0):!1}))){if(F=this.tokenizer.space(te)){te=te.substring(F.raw.length),F.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(F);continue}if(F=this.tokenizer.code(te)){te=te.substring(F.raw.length),H=ce[ce.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+F.raw,H.text+=`
`+F.text,this.inlineQueue[this.inlineQueue.length-1].src=H.text):ce.push(F);continue}if(F=this.tokenizer.fences(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.heading(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.hr(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.blockquote(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.list(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.html(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.def(te)){te=te.substring(F.raw.length),H=ce[ce.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+F.raw,H.text+=`
`+F.raw,this.inlineQueue[this.inlineQueue.length-1].src=H.text):this.tokens.links[F.tag]||(this.tokens.links[F.tag]={href:F.href,title:F.title});continue}if(F=this.tokenizer.table(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.lheading(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(K=te,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,Pe=te.slice(1),be=void 0;se.options.extensions.startBlock.forEach(function(Ce){be=Ce.call({lexer:this},Pe),typeof be=="number"&&be>=0&&(we=Math.min(we,be))}),we<1/0&&we>=0&&(K=te.substring(0,we+1))}(),this.state.top&&(F=this.tokenizer.paragraph(K))){H=ce[ce.length-1],_&&H.type==="paragraph"?(H.raw+=`
`+F.raw,H.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):ce.push(F),_=K.length!==te.length,te=te.substring(F.raw.length);continue}if(F=this.tokenizer.text(te)){te=te.substring(F.raw.length),H=ce[ce.length-1],H&&H.type==="text"?(H.raw+=`
`+F.raw,H.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):ce.push(F);continue}if(te){var de="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,ce},le.inline=function(te,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:te,tokens:ce}),ce},le.inlineTokens=function(te,ce){var se=this;ce===void 0&&(ce=[]);var F,H,K,_=te,de,we,Pe;if(this.tokens.links){var be=Object.keys(this.tokens.links);if(be.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(_))!=null;)be.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(_=_.slice(0,de.index)+"["+L("a",de[0].length-2)+"]"+_.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(_))!=null;)_=_.slice(0,de.index)+"["+L("a",de[0].length-2)+"]"+_.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(_))!=null;)_=_.slice(0,de.index)+"++"+_.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;te;)if(we||(Pe=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(F=ke.call({lexer:se},te,ce))?(te=te.substring(F.raw.length),ce.push(F),!0):!1}))){if(F=this.tokenizer.escape(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.tag(te)){te=te.substring(F.raw.length),H=ce[ce.length-1],H&&F.type==="text"&&H.type==="text"?(H.raw+=F.raw,H.text+=F.text):ce.push(F);continue}if(F=this.tokenizer.link(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.reflink(te,this.tokens.links)){te=te.substring(F.raw.length),H=ce[ce.length-1],H&&F.type==="text"&&H.type==="text"?(H.raw+=F.raw,H.text+=F.text):ce.push(F);continue}if(F=this.tokenizer.emStrong(te,_,Pe)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.codespan(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.br(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.del(te)){te=te.substring(F.raw.length),ce.push(F);continue}if(F=this.tokenizer.autolink(te,$)){te=te.substring(F.raw.length),ce.push(F);continue}if(!this.state.inLink&&(F=this.tokenizer.url(te,$))){te=te.substring(F.raw.length),ce.push(F);continue}if(K=te,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,He=te.slice(1),Ge=void 0;se.options.extensions.startInline.forEach(function(nt){Ge=nt.call({lexer:this},He),typeof Ge=="number"&&Ge>=0&&(ke=Math.min(ke,Ge))}),ke<1/0&&ke>=0&&(K=te.substring(0,ke+1))}(),F=this.tokenizer.inlineText(K,U)){te=te.substring(F.raw.length),F.raw.slice(-1)!=="_"&&(Pe=F.raw.slice(-1)),we=!0,H=ce[ce.length-1],H&&H.type==="text"?(H.raw+=F.raw,H.text+=F.text):ce.push(F);continue}if(te){var Ce="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return ce},o(oe,null,[{key:"rules",get:function(){return{block:B,inline:N}}}]),oe}(),ae=function(){function oe(ue){this.options=ue||ne.defaults}var le=oe.prototype;return le.code=function(te,ce,se){var F=(ce||"").match(/\S*/)[0];if(this.options.highlight){var H=this.options.highlight(te,F);H!=null&&H!==te&&(se=!0,te=H)}return te=te.replace(/\n$/,"")+`
`,F?'<pre><code class="'+this.options.langPrefix+y(F,!0)+'">'+(se?te:y(te,!0))+`</code></pre>
`:"<pre><code>"+(se?te:y(te,!0))+`</code></pre>
`},le.blockquote=function(te){return`<blockquote>
`+te+`</blockquote>
`},le.html=function(te){return te},le.heading=function(te,ce,se,F){if(this.options.headerIds){var H=this.options.headerPrefix+F.slug(se);return"<h"+ce+' id="'+H+'">'+te+"</h"+ce+`>
`}return"<h"+ce+">"+te+"</h"+ce+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(te,ce,se){var F=ce?"ol":"ul",H=ce&&se!==1?' start="'+se+'"':"";return"<"+F+H+`>
`+te+"</"+F+`>
`},le.listitem=function(te){return"<li>"+te+`</li>
`},le.checkbox=function(te){return"<input "+(te?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(te){return"<p>"+te+`</p>
`},le.table=function(te,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+te+`</thead>
`+ce+`</table>
`},le.tablerow=function(te){return`<tr>
`+te+`</tr>
`},le.tablecell=function(te,ce){var se=ce.header?"th":"td",F=ce.align?"<"+se+' align="'+ce.align+'">':"<"+se+">";return F+te+("</"+se+`>
`)},le.strong=function(te){return"<strong>"+te+"</strong>"},le.em=function(te){return"<em>"+te+"</em>"},le.codespan=function(te){return"<code>"+te+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(te){return"<del>"+te+"</del>"},le.link=function(te,ce,se){if(te=p(this.options.sanitize,this.options.baseUrl,te),te===null)return se;var F='<a href="'+y(te)+'"';return ce&&(F+=' title="'+ce+'"'),F+=">"+se+"</a>",F},le.image=function(te,ce,se){if(te=p(this.options.sanitize,this.options.baseUrl,te),te===null)return se;var F='<img src="'+te+'" alt="'+se+'"';return ce&&(F+=' title="'+ce+'"'),F+=this.options.xhtml?"/>":">",F},le.text=function(te){return te},oe}(),ee=function(){function oe(){}var le=oe.prototype;return le.strong=function(te){return te},le.em=function(te){return te},le.codespan=function(te){return te},le.del=function(te){return te},le.html=function(te){return te},le.text=function(te){return te},le.link=function(te,ce,se){return""+se},le.image=function(te,ce,se){return""+se},le.br=function(){return""},oe}(),x=function(){function oe(){this.seen={}}var le=oe.prototype;return le.serialize=function(te){return te.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(te,ce){var se=te,F=0;if(this.seen.hasOwnProperty(se)){F=this.seen[te];do F++,se=te+"-"+F;while(this.seen.hasOwnProperty(se))}return ce||(this.seen[te]=F,this.seen[se]=0),se},le.slug=function(te,ce){ce===void 0&&(ce={});var se=this.serialize(te);return this.getNextSafeSlug(se,ce.dryrun)},oe}(),J=function(){function oe(ue){this.options=ue||ne.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ee,this.slugger=new x}oe.parse=function(te,ce){var se=new oe(ce);return se.parse(te)},oe.parseInline=function(te,ce){var se=new oe(ce);return se.parseInline(te)};var le=oe.prototype;return le.parse=function(te,ce){ce===void 0&&(ce=!0);var se="",F,H,K,_,de,we,Pe,be,Ce,ke,He,Ge,nt,Qe,tt,rt,Be,it,W,X=te.length;for(F=0;F<X;F++){if(ke=te[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(W=this.options.extensions.renderers[ke.type].call({parser:this},ke),W!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){se+=W||"";continue}switch(ke.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,h(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(be="",Pe="",_=ke.header.length,H=0;H<_;H++)Pe+=this.renderer.tablecell(this.parseInline(ke.header[H].tokens),{header:!0,align:ke.align[H]});for(be+=this.renderer.tablerow(Pe),Ce="",_=ke.rows.length,H=0;H<_;H++){for(we=ke.rows[H],Pe="",de=we.length,K=0;K<de;K++)Pe+=this.renderer.tablecell(this.parseInline(we[K].tokens),{header:!1,align:ke.align[K]});Ce+=this.renderer.tablerow(Pe)}se+=this.renderer.table(be,Ce);continue}case"blockquote":{Ce=this.parse(ke.tokens),se+=this.renderer.blockquote(Ce);continue}case"list":{for(He=ke.ordered,Ge=ke.start,nt=ke.loose,_=ke.items.length,Ce="",H=0;H<_;H++)tt=ke.items[H],rt=tt.checked,Be=tt.task,Qe="",tt.task&&(it=this.renderer.checkbox(rt),nt?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=it+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=it+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:it}):Qe+=it),Qe+=this.parse(tt.tokens,nt),Ce+=this.renderer.listitem(Qe,Be,rt);se+=this.renderer.list(Ce,He,Ge);continue}case"html":{se+=this.renderer.html(ke.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(Ce=ke.tokens?this.parseInline(ke.tokens):ke.text;F+1<X&&te[F+1].type==="text";)ke=te[++F],Ce+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);se+=ce?this.renderer.paragraph(Ce):Ce;continue}default:{var he='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return se},le.parseInline=function(te,ce){ce=ce||this.renderer;var se="",F,H,K,_=te.length;for(F=0;F<_;F++){if(H=te[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(K=this.options.extensions.renderers[H.type].call({parser:this},H),K!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(H.type))){se+=K||"";continue}switch(H.type){case"escape":{se+=ce.text(H.text);break}case"html":{se+=ce.html(H.text);break}case"link":{se+=ce.link(H.href,H.title,this.parseInline(H.tokens,ce));break}case"image":{se+=ce.image(H.href,H.title,H.text);break}case"strong":{se+=ce.strong(this.parseInline(H.tokens,ce));break}case"em":{se+=ce.em(this.parseInline(H.tokens,ce));break}case"codespan":{se+=ce.codespan(H.text);break}case"br":{se+=ce.br();break}case"del":{se+=ce.del(this.parseInline(H.tokens,ce));break}case"text":{se+=ce.text(H.text);break}default:{var de='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return se},oe}();function ie(oe,le,ue){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof le=="function"&&(ue=le,le=null),le=i({},ie.defaults,le||{}),w(le),ue){var te=le.highlight,ce;try{ce=z.lex(oe,le)}catch(_){return ue(_)}var se=function(de){var we;if(!de)try{le.walkTokens&&ie.walkTokens(ce,le.walkTokens),we=J.parse(ce,le)}catch(Pe){de=Pe}return le.highlight=te,de?ue(de):ue(null,we)};if(!te||te.length<3||(delete le.highlight,!ce.length))return se();var F=0;ie.walkTokens(ce,function(_){_.type==="code"&&(F++,setTimeout(function(){te(_.text,_.lang,function(de,we){if(de)return se(de);we!=null&&we!==_.text&&(_.text=we,_.escaped=!0),F--,F===0&&se()})},0))}),F===0&&se();return}function H(_){if(_.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+y(_.message+"",!0)+"</pre>";throw _}try{var K=z.lex(oe,le);if(le.walkTokens){if(le.async)return Promise.all(ie.walkTokens(K,le.walkTokens)).then(function(){return J.parse(K,le)}).catch(H);ie.walkTokens(K,le.walkTokens)}return J.parse(K,le)}catch(_){H(_)}}ie.options=ie.setOptions=function(oe){return i(ie.defaults,oe),P(ie.defaults),ie},ie.getDefaults=I,ie.defaults=ne.defaults,ie.use=function(){for(var oe=arguments.length,le=new Array(oe),ue=0;ue<oe;ue++)le[ue]=arguments[ue];var te=i.apply(void 0,[{}].concat(le)),ce=ie.defaults.extensions||{renderers:{},childTokens:{}},se;le.forEach(function(F){if(F.extensions&&(se=!0,F.extensions.forEach(function(K){if(!K.name)throw new Error("extension name required");if(K.renderer){var _=ce.renderers?ce.renderers[K.name]:null;_?ce.renderers[K.name]=function(){for(var de=arguments.length,we=new Array(de),Pe=0;Pe<de;Pe++)we[Pe]=arguments[Pe];var be=K.renderer.apply(this,we);return be===!1&&(be=_.apply(this,we)),be}:ce.renderers[K.name]=K.renderer}if(K.tokenizer){if(!K.level||K.level!=="block"&&K.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[K.level]?ce[K.level].unshift(K.tokenizer):ce[K.level]=[K.tokenizer],K.start&&(K.level==="block"?ce.startBlock?ce.startBlock.push(K.start):ce.startBlock=[K.start]:K.level==="inline"&&(ce.startInline?ce.startInline.push(K.start):ce.startInline=[K.start]))}K.childTokens&&(ce.childTokens[K.name]=K.childTokens)})),F.renderer&&function(){var K=ie.defaults.renderer||new ae,_=function(Pe){var be=K[Pe];K[Pe]=function(){for(var Ce=arguments.length,ke=new Array(Ce),He=0;He<Ce;He++)ke[He]=arguments[He];var Ge=F.renderer[Pe].apply(K,ke);return Ge===!1&&(Ge=be.apply(K,ke)),Ge}};for(var de in F.renderer)_(de);te.renderer=K}(),F.tokenizer&&function(){var K=ie.defaults.tokenizer||new M,_=function(Pe){var be=K[Pe];K[Pe]=function(){for(var Ce=arguments.length,ke=new Array(Ce),He=0;He<Ce;He++)ke[He]=arguments[He];var Ge=F.tokenizer[Pe].apply(K,ke);return Ge===!1&&(Ge=be.apply(K,ke)),Ge}};for(var de in F.tokenizer)_(de);te.tokenizer=K}(),F.walkTokens){var H=ie.defaults.walkTokens;te.walkTokens=function(K){var _=[];return _.push(F.walkTokens.call(this,K)),H&&(_=_.concat(H.call(this,K))),_}}se&&(te.extensions=ce),ie.setOptions(te)})},ie.walkTokens=function(oe,le){for(var ue=[],te=function(){var H=se.value;switch(ue=ue.concat(le.call(ie,H)),H.type){case"table":{for(var K=R(H.header),_;!(_=K()).done;){var de=_.value;ue=ue.concat(ie.walkTokens(de.tokens,le))}for(var we=R(H.rows),Pe;!(Pe=we()).done;)for(var be=Pe.value,Ce=R(be),ke;!(ke=Ce()).done;){var He=ke.value;ue=ue.concat(ie.walkTokens(He.tokens,le))}break}case"list":{ue=ue.concat(ie.walkTokens(H.items,le));break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[H.type]?ie.defaults.extensions.childTokens[H.type].forEach(function(Ge){ue=ue.concat(ie.walkTokens(H[Ge],le))}):H.tokens&&(ue=ue.concat(ie.walkTokens(H.tokens,le)))}},ce=R(oe),se;!(se=ce()).done;)te();return ue},ie.parseInline=function(oe,le){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");le=i({},ie.defaults,le||{}),w(le);try{var ue=z.lexInline(oe,le);return le.walkTokens&&ie.walkTokens(ue,le.walkTokens),J.parseInline(ue,le)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+y(te.message+"",!0)+"</pre>";throw te}},ie.Parser=J,ie.parser=J.parse,ie.Renderer=ae,ie.TextRenderer=ee,ie.Lexer=z,ie.lexer=z.lex,ie.Tokenizer=M,ie.Slugger=x,ie.parse=ie;var pe=ie.options,Q=ie.setOptions,Y=ie.use,Z=ie.walkTokens,me=ie.parseInline,ve=ie,Ie=J.parse,Re=z.lex;ne.Lexer=z,ne.Parser=J,ne.Renderer=ae,ne.Slugger=x,ne.TextRenderer=ee,ne.Tokenizer=M,ne.getDefaults=I,ne.lexer=Re,ne.marked=ie,ne.options=pe,ne.parse=ve,ne.parseInline=me,ne.parser=Ie,ne.setOptions=Q,ne.use=Y,ne.walkTokens=Z,Object.defineProperty(ne,"__esModule",{value:!0})}),define(ye[86],De([1,0,28]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new o.LRUCache(1e4);function a(k){return S(k,"NFC",A)}e.normalizeNFC=a;const R=new o.LRUCache(1e4);function I(k){return S(k,"NFD",R)}e.normalizeNFD=I;const P=/[^\u0000-\u0080]/;function S(k,O,T){if(!k)return k;const v=T.get(k);if(v)return v;let C;return P.test(k)?C=k.normalize(O):C=k,T.set(k,C),C}e.removeAccents=function(){const k=/[\u0300-\u036f]/g;return function(O){return I(O).replace(k,"")}}()}),define(ye[102],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function o(P,S,k){return Math.min(Math.max(P,S),k)}e.clamp=o;function A(P,S){return(S+P%S)%S}e.rot=A;class a{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=a;class R{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class I{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const k=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=I}),function(){function ne(a){const R=[];typeof a=="number"&&R.push("code/timeOrigin",a);function I(S){R.push(S,Date.now())}function P(){const S=[];for(let k=0;k<R.length;k+=2)S.push({name:R[k],startTime:R[k+1]});return S}return{mark:I,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(a){performance.mark(a)},getMarks(){let a=performance.timeOrigin;typeof a!="number"&&(a=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(a)}];for(const I of performance.getEntriesByType("mark"))R.push({name:I.name,startTime:Math.round(a+I.startTime)});return R}};if(typeof process=="object"){const a=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(a)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function o(a){return a.MonacoPerformanceMarks||(a.MonacoPerformanceMarks=e()),a.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=o(A))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var o=e();for(var A in o)(typeof exports=="object"?exports:ne)[A]=o[A]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function o(A){if(e[A])return e[A].exports;var a=e[A]={i:A,l:!1,exports:{}};return ne[A].call(a.exports,a,a.exports,o),a.l=!0,a.exports}return o.m=ne,o.c=e,o.d=function(A,a,R){o.o(A,a)||Object.defineProperty(A,a,{enumerable:!0,get:R})},o.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},o.t=function(A,a){if(1&a&&(A=o(A)),8&a||4&a&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(o.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&a&&typeof A!="string")for(var I in A)o.d(R,I,function(P){return A[P]}.bind(null,I));return R},o.n=function(A){var a=A&&A.__esModule?function(){return A.default}:function(){return A};return o.d(a,"a",a),a},o.o=function(A,a){return Object.prototype.hasOwnProperty.call(A,a)},o.p="",o(o.s=0)}([function(ne,e,o){(function(A){var a;e=ne.exports=Y,a=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var be=Array.prototype.slice.call(arguments,0);be.unshift("SEMVER"),console.log.apply(console,be)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],S=e.src=[],k=0,O=k++;S[O]="0|[1-9]\\d*";var T=k++;S[T]="[0-9]+";var v=k++;S[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=k++;S[C]="("+S[O]+")\\.("+S[O]+")\\.("+S[O]+")";var y=k++;S[y]="("+S[T]+")\\.("+S[T]+")\\.("+S[T]+")";var f=k++;S[f]="(?:"+S[O]+"|"+S[v]+")";var h=k++;S[h]="(?:"+S[T]+"|"+S[v]+")";var u=k++;S[u]="(?:-("+S[f]+"(?:\\."+S[f]+")*))";var g=k++;S[g]="(?:-?("+S[h]+"(?:\\."+S[h]+")*))";var b=k++;S[b]="[0-9A-Za-z-]+";var D=k++;S[D]="(?:\\+("+S[b]+"(?:\\."+S[b]+")*))";var p=k++,n="v?"+S[C]+S[u]+"?"+S[D]+"?";S[p]="^"+n+"$";var s="[v=\\s]*"+S[y]+S[g]+"?"+S[D]+"?",r=k++;S[r]="^"+s+"$";var c=k++;S[c]="((?:<|>)?=?)";var l=k++;S[l]=S[T]+"|x|X|\\*";var m=k++;S[m]=S[O]+"|x|X|\\*";var i=k++;S[i]="[v=\\s]*("+S[m]+")(?:\\.("+S[m]+")(?:\\.("+S[m]+")(?:"+S[u]+")?"+S[D]+"?)?)?";var t=k++;S[t]="[v=\\s]*("+S[l]+")(?:\\.("+S[l]+")(?:\\.("+S[l]+")(?:"+S[g]+")?"+S[D]+"?)?)?";var d=k++;S[d]="^"+S[c]+"\\s*"+S[i]+"$";var E=k++;S[E]="^"+S[c]+"\\s*"+S[t]+"$";var w=k++;S[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=k++;S[L]="(?:~>?)";var q=k++;S[q]="(\\s*)"+S[L]+"\\s+",P[q]=new RegExp(S[q],"g");var V=k++;S[V]="^"+S[L]+S[i]+"$";var M=k++;S[M]="^"+S[L]+S[t]+"$";var B=k++;S[B]="(?:\\^)";var N=k++;S[N]="(\\s*)"+S[B]+"\\s+",P[N]=new RegExp(S[N],"g");var U=k++;S[U]="^"+S[B]+S[i]+"$";var $=k++;S[$]="^"+S[B]+S[t]+"$";var z=k++;S[z]="^"+S[c]+"\\s*("+s+")$|^$";var ae=k++;S[ae]="^"+S[c]+"\\s*("+n+")$|^$";var ee=k++;S[ee]="(\\s*)"+S[c]+"\\s*("+s+"|"+S[i]+")",P[ee]=new RegExp(S[ee],"g");var x=k++;S[x]="^\\s*("+S[i]+")\\s+-\\s+("+S[i]+")\\s*$";var J=k++;S[J]="^\\s*("+S[t]+")\\s+-\\s+("+S[t]+")\\s*$";var ie=k++;S[ie]="(<|>)?=?\\s*\\*";for(var pe=0;pe<35;pe++)a(pe,S[pe]),P[pe]||(P[pe]=new RegExp(S[pe]));function Q(be,Ce){if(be instanceof Y)return be;if(typeof be!="string"||be.length>R||!(Ce?P[r]:P[p]).test(be))return null;try{return new Y(be,Ce)}catch{return null}}function Y(be,Ce){if(be instanceof Y){if(be.loose===Ce)return be;be=be.version}else if(typeof be!="string")throw new TypeError("Invalid Version: "+be);if(be.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Y))return new Y(be,Ce);a("SemVer",be,Ce),this.loose=Ce;var ke=be.trim().match(Ce?P[r]:P[p]);if(!ke)throw new TypeError("Invalid Version: "+be);if(this.raw=be,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(He){if(/^[0-9]+$/.test(He)){var Ge=+He;if(Ge>=0&&Ge<I)return Ge}return He}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=Q,e.valid=function(be,Ce){var ke=Q(be,Ce);return ke?ke.version:null},e.clean=function(be,Ce){var ke=Q(be.trim().replace(/^[=v]+/,""),Ce);return ke?ke.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(be){return a("SemVer.compare",this.version,this.loose,be),be instanceof Y||(be=new Y(be,this.loose)),this.compareMain(be)||this.comparePre(be)},Y.prototype.compareMain=function(be){return be instanceof Y||(be=new Y(be,this.loose)),me(this.major,be.major)||me(this.minor,be.minor)||me(this.patch,be.patch)},Y.prototype.comparePre=function(be){if(be instanceof Y||(be=new Y(be,this.loose)),this.prerelease.length&&!be.prerelease.length)return-1;if(!this.prerelease.length&&be.prerelease.length)return 1;if(!this.prerelease.length&&!be.prerelease.length)return 0;var Ce=0;do{var ke=this.prerelease[Ce],He=be.prerelease[Ce];if(a("prerelease compare",Ce,ke,He),ke===void 0&&He===void 0)return 0;if(He===void 0)return 1;if(ke===void 0)return-1;if(ke!==He)return me(ke,He)}while(++Ce)},Y.prototype.inc=function(be,Ce){switch(be){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+be)}return this.format(),this.raw=this.version,this},e.inc=function(be,Ce,ke,He){typeof ke=="string"&&(He=ke,ke=void 0);try{return new Y(be,ke).inc(Ce,He).version}catch{return null}},e.diff=function(be,Ce){if(oe(be,Ce))return null;var ke=Q(be),He=Q(Ce);if(ke.prerelease.length||He.prerelease.length){for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==He[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==He[Ge])return Ge},e.compareIdentifiers=me;var Z=/^[0-9]+$/;function me(be,Ce){var ke=Z.test(be),He=Z.test(Ce);return ke&&He&&(be=+be,Ce=+Ce),ke&&!He?-1:He&&!ke?1:be<Ce?-1:be>Ce?1:0}function ve(be,Ce,ke){return new Y(be,ke).compare(new Y(Ce,ke))}function Ie(be,Ce,ke){return ve(be,Ce,ke)>0}function Re(be,Ce,ke){return ve(be,Ce,ke)<0}function oe(be,Ce,ke){return ve(be,Ce,ke)===0}function le(be,Ce,ke){return ve(be,Ce,ke)!==0}function ue(be,Ce,ke){return ve(be,Ce,ke)>=0}function te(be,Ce,ke){return ve(be,Ce,ke)<=0}function ce(be,Ce,ke,He){var Ge;switch(Ce){case"===":typeof be=="object"&&(be=be.version),typeof ke=="object"&&(ke=ke.version),Ge=be===ke;break;case"!==":typeof be=="object"&&(be=be.version),typeof ke=="object"&&(ke=ke.version),Ge=be!==ke;break;case"":case"=":case"==":Ge=oe(be,ke,He);break;case"!=":Ge=le(be,ke,He);break;case">":Ge=Ie(be,ke,He);break;case">=":Ge=ue(be,ke,He);break;case"<":Ge=Re(be,ke,He);break;case"<=":Ge=te(be,ke,He);break;default:throw new TypeError("Invalid operator: "+Ce)}return Ge}function se(be,Ce){if(be instanceof se){if(be.loose===Ce)return be;be=be.value}if(!(this instanceof se))return new se(be,Ce);a("comparator",be,Ce),this.loose=Ce,this.parse(be),this.semver===F?this.value="":this.value=this.operator+this.semver.version,a("comp",this)}e.rcompareIdentifiers=function(be,Ce){return me(Ce,be)},e.major=function(be,Ce){return new Y(be,Ce).major},e.minor=function(be,Ce){return new Y(be,Ce).minor},e.patch=function(be,Ce){return new Y(be,Ce).patch},e.compare=ve,e.compareLoose=function(be,Ce){return ve(be,Ce,!0)},e.rcompare=function(be,Ce,ke){return ve(Ce,be,ke)},e.sort=function(be,Ce){return be.sort(function(ke,He){return e.compare(ke,He,Ce)})},e.rsort=function(be,Ce){return be.sort(function(ke,He){return e.rcompare(ke,He,Ce)})},e.gt=Ie,e.lt=Re,e.eq=oe,e.neq=le,e.gte=ue,e.lte=te,e.cmp=ce,e.Comparator=se;var F={};function H(be,Ce){if(be instanceof H)return be.loose===Ce?be:new H(be.raw,Ce);if(be instanceof se)return new H(be.value,Ce);if(!(this instanceof H))return new H(be,Ce);if(this.loose=Ce,this.raw=be,this.set=be.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+be);this.format()}function K(be){return!be||be.toLowerCase()==="x"||be==="*"}function _(be,Ce,ke,He,Ge,nt,Qe,tt,rt,Be,it,W,X){return((Ce=K(ke)?"":K(He)?">="+ke+".0.0":K(Ge)?">="+ke+"."+He+".0":">="+Ce)+" "+(tt=K(rt)?"":K(Be)?"<"+(+rt+1)+".0.0":K(it)?"<"+rt+"."+(+Be+1)+".0":W?"<="+rt+"."+Be+"."+it+"-"+W:"<="+tt)).trim()}function de(be,Ce){for(var ke=0;ke<be.length;ke++)if(!be[ke].test(Ce))return!1;if(Ce.prerelease.length){for(ke=0;ke<be.length;ke++)if(a(be[ke].semver),be[ke].semver!==F&&be[ke].semver.prerelease.length>0){var He=be[ke].semver;if(He.major===Ce.major&&He.minor===Ce.minor&&He.patch===Ce.patch)return!0}return!1}return!0}function we(be,Ce,ke){try{Ce=new H(Ce,ke)}catch{return!1}return Ce.test(be)}function Pe(be,Ce,ke,He){var Ge,nt,Qe,tt,rt;switch(be=new Y(be,He),Ce=new H(Ce,He),ke){case">":Ge=Ie,nt=te,Qe=Re,tt=">",rt=">=";break;case"<":Ge=Re,nt=ue,Qe=Ie,tt="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(be,Ce,He))return!1;for(var Be=0;Be<Ce.set.length;++Be){var it=Ce.set[Be],W=null,X=null;if(it.forEach(function(he){he.semver===F&&(he=new se(">=0.0.0")),W=W||he,X=X||he,Ge(he.semver,W.semver,He)?W=he:Qe(he.semver,X.semver,He)&&(X=he)}),W.operator===tt||W.operator===rt||(!X.operator||X.operator===tt)&&nt(be,X.semver)||X.operator===rt&&Qe(be,X.semver))return!1}return!0}se.prototype.parse=function(be){var Ce=this.loose?P[z]:P[ae],ke=be.match(Ce);if(!ke)throw new TypeError("Invalid comparator: "+be);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new Y(ke[2],this.loose):this.semver=F},se.prototype.toString=function(){return this.value},se.prototype.test=function(be){return a("Comparator.test",be,this.loose),this.semver===F||(typeof be=="string"&&(be=new Y(be,this.loose)),ce(be,this.operator,this.semver,this.loose))},se.prototype.intersects=function(be,Ce){if(!(be instanceof se))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new H(be.value,Ce),we(this.value,ke,Ce);if(be.operator==="")return ke=new H(this.value,Ce),we(be.semver,ke,Ce);var He=!(this.operator!==">="&&this.operator!==">"||be.operator!==">="&&be.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||be.operator!=="<="&&be.operator!=="<"),nt=this.semver.version===be.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||be.operator!==">="&&be.operator!=="<="),tt=ce(this.semver,"<",be.semver,Ce)&&(this.operator===">="||this.operator===">")&&(be.operator==="<="||be.operator==="<"),rt=ce(this.semver,">",be.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(be.operator===">="||be.operator===">");return He||Ge||nt&&Qe||tt||rt},e.Range=H,H.prototype.format=function(){return this.range=this.set.map(function(be){return be.join(" ").trim()}).join("||").trim(),this.range},H.prototype.toString=function(){return this.range},H.prototype.parseRange=function(be){var Ce=this.loose;be=be.trim(),a("range",be,Ce);var ke=Ce?P[J]:P[x];be=be.replace(ke,_),a("hyphen replace",be),be=be.replace(P[ee],"$1$2$3"),a("comparator trim",be,P[ee]),be=(be=(be=be.replace(P[q],"$1~")).replace(P[N],"$1^")).split(/\s+/).join(" ");var He=Ce?P[z]:P[ae],Ge=be.split(" ").map(function(nt){return function(Qe,tt){return a("comp",Qe),Qe=function(rt,Be){return rt.trim().split(/\s+/).map(function(it){return function(W,X){a("caret",W,X);var he=X?P[$]:P[U];return W.replace(he,function(Le,Ne,qe,je,Ze){var st;return a("caret",W,Le,Ne,qe,je,Ze),K(Ne)?st="":K(qe)?st=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":K(je)?st=Ne==="0"?">="+Ne+"."+qe+".0 <"+Ne+"."+(+qe+1)+".0":">="+Ne+"."+qe+".0 <"+(+Ne+1)+".0.0":Ze?(a("replaceCaret pr",Ze),Ze.charAt(0)!=="-"&&(Ze="-"+Ze),st=Ne==="0"?qe==="0"?">="+Ne+"."+qe+"."+je+Ze+" <"+Ne+"."+qe+"."+(+je+1):">="+Ne+"."+qe+"."+je+Ze+" <"+Ne+"."+(+qe+1)+".0":">="+Ne+"."+qe+"."+je+Ze+" <"+(+Ne+1)+".0.0"):(a("no pr"),st=Ne==="0"?qe==="0"?">="+Ne+"."+qe+"."+je+" <"+Ne+"."+qe+"."+(+je+1):">="+Ne+"."+qe+"."+je+" <"+Ne+"."+(+qe+1)+".0":">="+Ne+"."+qe+"."+je+" <"+(+Ne+1)+".0.0"),a("caret return",st),st})}(it,Be)}).join(" ")}(Qe,tt),a("caret",Qe),Qe=function(rt,Be){return rt.trim().split(/\s+/).map(function(it){return function(W,X){var he=X?P[M]:P[V];return W.replace(he,function(Le,Ne,qe,je,Ze){var st;return a("tilde",W,Le,Ne,qe,je,Ze),K(Ne)?st="":K(qe)?st=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":K(je)?st=">="+Ne+"."+qe+".0 <"+Ne+"."+(+qe+1)+".0":Ze?(a("replaceTilde pr",Ze),Ze.charAt(0)!=="-"&&(Ze="-"+Ze),st=">="+Ne+"."+qe+"."+je+Ze+" <"+Ne+"."+(+qe+1)+".0"):st=">="+Ne+"."+qe+"."+je+" <"+Ne+"."+(+qe+1)+".0",a("tilde return",st),st})}(it,Be)}).join(" ")}(Qe,tt),a("tildes",Qe),Qe=function(rt,Be){return a("replaceXRanges",rt,Be),rt.split(/\s+/).map(function(it){return function(W,X){W=W.trim();var he=X?P[E]:P[d];return W.replace(he,function(Le,Ne,qe,je,Ze,st){a("xRange",W,Le,Ne,qe,je,Ze,st);var at=K(qe),mt=at||K(je),gt=mt||K(Ze);return Ne==="="&&gt&&(Ne=""),at?Le=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&gt?(mt&&(je=0),gt&&(Ze=0),Ne===">"?(Ne=">=",mt?(qe=+qe+1,je=0,Ze=0):gt&&(je=+je+1,Ze=0)):Ne==="<="&&(Ne="<",mt?qe=+qe+1:je=+je+1),Le=Ne+qe+"."+je+"."+Ze):mt?Le=">="+qe+".0.0 <"+(+qe+1)+".0.0":gt&&(Le=">="+qe+"."+je+".0 <"+qe+"."+(+je+1)+".0"),a("xRange return",Le),Le})}(it,Be)}).join(" ")}(Qe,tt),a("xrange",Qe),Qe=function(rt,Be){return a("replaceStars",rt,Be),rt.trim().replace(P[ie],"")}(Qe,tt),a("stars",Qe),Qe}(nt,Ce)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(nt){return!!nt.match(He)})),Ge=Ge.map(function(nt){return new se(nt,Ce)})},H.prototype.intersects=function(be,Ce){if(!(be instanceof H))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(He){return be.set.some(function(Ge){return Ge.every(function(nt){return He.intersects(nt,Ce)})})})})},e.toComparators=function(be,Ce){return new H(be,Ce).set.map(function(ke){return ke.map(function(He){return He.value}).join(" ").trim().split(" ")})},H.prototype.test=function(be){if(!be)return!1;typeof be=="string"&&(be=new Y(be,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(de(this.set[Ce],be))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(be,Ce,ke){var He=null,Ge=null;try{var nt=new H(Ce,ke)}catch{return null}return be.forEach(function(Qe){nt.test(Qe)&&(He&&Ge.compare(Qe)!==-1||(Ge=new Y(He=Qe,ke)))}),He},e.minSatisfying=function(be,Ce,ke){var He=null,Ge=null;try{var nt=new H(Ce,ke)}catch{return null}return be.forEach(function(Qe){nt.test(Qe)&&(He&&Ge.compare(Qe)!==1||(Ge=new Y(He=Qe,ke)))}),He},e.validRange=function(be,Ce){try{return new H(be,Ce).range||"*"}catch{return null}},e.ltr=function(be,Ce,ke){return Pe(be,Ce,"<",ke)},e.gtr=function(be,Ce,ke){return Pe(be,Ce,">",ke)},e.outside=Pe,e.prerelease=function(be,Ce){var ke=Q(be,Ce);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(be,Ce,ke){return be=new H(be,ke),Ce=new H(Ce,ke),be.intersects(Ce)},e.coerce=function(be){if(be instanceof Y)return be;if(typeof be!="string")return null;var Ce=be.match(P[w]);return Ce==null?null:Q((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,o(1))},function(ne,e){var o,A,a=ne.exports={};function R(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function P(h){if(o===setTimeout)return setTimeout(h,0);if((o===R||!o)&&setTimeout)return o=setTimeout,setTimeout(h,0);try{return o(h,0)}catch{try{return o.call(null,h,0)}catch{return o.call(this,h,0)}}}(function(){try{o=typeof setTimeout=="function"?setTimeout:R}catch{o=R}try{A=typeof clearTimeout=="function"?clearTimeout:I}catch{A=I}})();var S,k=[],O=!1,T=-1;function v(){O&&S&&(O=!1,S.length?k=S.concat(k):T=-1,k.length&&C())}function C(){if(!O){var h=P(v);O=!0;for(var u=k.length;u;){for(S=k,k=[];++T<u;)S&&S[T].run();T=-1,u=k.length}S=null,O=!1,function(g){if(A===clearTimeout)return clearTimeout(g);if((A===I||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(g);try{A(g)}catch{try{return A.call(null,g)}catch{return A.call(this,g)}}}(h)}}function y(h,u){this.fun=h,this.array=u}function f(){}a.nextTick=function(h){var u=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)u[g-1]=arguments[g];k.push(new y(h,u)),k.length!==1||O||P(C)},y.prototype.run=function(){this.fun.apply(null,this.array)},a.title="browser",a.browser=!0,a.env={},a.argv=[],a.version="",a.versions={},a.on=f,a.addListener=f,a.once=f,a.off=f,a.removeListener=f,a.removeAllListeners=f,a.emit=f,a.prependListener=f,a.prependOnceListener=f,a.listeners=function(h){return[]},a.binding=function(h){throw new Error("process.binding is not supported")},a.cwd=function(){return"/"},a.chdir=function(h){throw new Error("process.chdir is not supported")},a.umask=function(){return 0}}])}),define(ye[103],De([1,0,12,6]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function a(D){const p=D;return p?typeof p.read=="function":!1}e.isReadable=a;function R(D){const p=D;return p?[p.on,p.pause,p.resume,p.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=R;function I(D){const p=D;return p?R(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=I;function P(D,p){return new S(D,p)}e.newWriteableStream=P;class S{constructor(p,n){this.e=p,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(n=>n(p))}h(p){this.c.error.length===0?(0,o.onUnexpectedError)(p):this.c.error.slice(0).forEach(n=>n(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,n){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(p,n){if(this.a.destroyed)return;let s;switch(p){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const r=s.indexOf(n);r>=0&&s.splice(r,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(D,p){const n=[];let s;for(;(s=D.read())!==null;)n.push(s);return p(n)}e.consumeReadable=k;function O(D,p,n){const s=[];let r;for(;(r=D.read())!==null&&s.length<n;)s.push(r);return r===null&&s.length>0?p(s):{read:()=>{if(s.length>0)return s.shift();if(typeof r<"u"){const c=r;return r=void 0,c}return D.read()}}}e.peekReadable=O;function T(D,p){return new Promise((n,s)=>{const r=[];v(D,{onData:c=>{p&&r.push(c)},onError:c=>{p?s(c):n(void 0)},onEnd:()=>{n(p?p(r):void 0)}})})}e.consumeStream=T;function v(D,p){let n=!1;return D.on("error",s=>{n||p.onError(s)}),D.on("end",()=>{n||p.onEnd()}),D.on("data",s=>{n||p.onData(s)}),(0,A.toDisposable)(()=>n=!0)}e.listenStream=v;function C(D,p){return new Promise((n,s)=>{const r=new A.DisposableStore,c=[],l=t=>{if(c.push(t),c.length>p)return r.dispose(),D.pause(),n({stream:D,buffer:c,ended:!1})},m=t=>s(t),i=()=>n({stream:D,buffer:c,ended:!0});r.add((0,A.toDisposable)(()=>D.removeListener("error",m))),D.on("error",m),r.add((0,A.toDisposable)(()=>D.removeListener("end",i))),D.on("end",i),r.add((0,A.toDisposable)(()=>D.removeListener("data",l))),D.on("data",l)})}e.peekStream=C;function y(D,p){const n=P(p);return n.end(D),n}e.toStream=y;function f(){const D=P(()=>{throw new Error("not supported")});return D.end(),D}e.emptyStream=f;function h(D){let p=!1;return{read:()=>p?null:(p=!0,D)}}e.toReadable=h;function u(D,p,n){const s=P(n);return v(D,{onData:r=>s.write(p.data(r)),onError:r=>s.error(p.error?p.error(r):r),onEnd:()=>s.end()}),s}e.transform=u;function g(D,p,n){let s=!1;return{read:()=>{const r=p.read();return s?r:(s=!0,r!==null?n([D,r]):D)}}}e.prefixedReadable=g;function b(D,p,n){let s=!1;const r=P(n);return v(p,{onData:c=>s?r.write(c):(s=!0,r.write(n([D,c]))),onError:c=>r.error(c),onEnd:()=>{s||(s=!0,r.write(D)),r.end()}}),r}e.prefixedStream=b}),define(ye[22],De([1,0,103]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let a,R;class I{static alloc(t){return A?new I(Buffer.allocUnsafe(t)):new I(new Uint8Array(t))}static wrap(t){return A&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new I(t)}static fromString(t,d){return!(d?.dontUseNodeBuffer||!1)&&A?new I(Buffer.from(t)):(a||(a=new TextEncoder),new I(a.encode(t)))}static fromByteArray(t){const d=I.alloc(t.length);for(let E=0,w=t.length;E<w;E++)d.buffer[E]=t[E];return d}static concat(t,d){if(typeof d>"u"){d=0;for(let L=0,q=t.length;L<q;L++)d+=t[L].byteLength}const E=I.alloc(d);let w=0;for(let L=0,q=t.length;L<q;L++){const V=t[L];E.set(V,w),w+=V.byteLength}return E}constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}clone(){const t=I.alloc(this.byteLength);return t.set(this),t}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(t,d){return new I(this.buffer.subarray(t,d))}set(t,d){if(t instanceof I)this.buffer.set(t.buffer,d);else if(t instanceof Uint8Array)this.buffer.set(t,d);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),d);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(t){return k(this.buffer,t)}writeUInt32BE(t,d){O(this.buffer,t,d)}readUInt32LE(t){return T(this.buffer,t)}writeUInt32LE(t,d){v(this.buffer,t,d)}readUInt8(t){return C(this.buffer,t)}writeUInt8(t,d){y(this.buffer,t,d)}}e.VSBuffer=I;function P(i,t){return i[t+0]<<0>>>0|i[t+1]<<8>>>0}e.readUInt16LE=P;function S(i,t,d){i[d+0]=t&255,t=t>>>8,i[d+1]=t&255}e.writeUInt16LE=S;function k(i,t){return i[t]*2**24+i[t+1]*2**16+i[t+2]*2**8+i[t+3]}e.readUInt32BE=k;function O(i,t,d){i[d+3]=t,t=t>>>8,i[d+2]=t,t=t>>>8,i[d+1]=t,t=t>>>8,i[d]=t}e.writeUInt32BE=O;function T(i,t){return i[t+0]<<0>>>0|i[t+1]<<8>>>0|i[t+2]<<16>>>0|i[t+3]<<24>>>0}e.readUInt32LE=T;function v(i,t,d){i[d+0]=t&255,t=t>>>8,i[d+1]=t&255,t=t>>>8,i[d+2]=t&255,t=t>>>8,i[d+3]=t&255}e.writeUInt32LE=v;function C(i,t){return i[t]}e.readUInt8=C;function y(i,t,d){i[d]=t}e.writeUInt8=y;function f(i){return o.consumeReadable(i,t=>I.concat(t))}e.readableToBuffer=f;function h(i){return o.toReadable(i)}e.bufferToReadable=h;function u(i){return o.consumeStream(i,t=>I.concat(t))}e.streamToBuffer=u;async function g(i){return i.ended?I.concat(i.buffer):I.concat([...i.buffer,await u(i.stream)])}e.bufferedStreamToBuffer=g;function b(i){return o.toStream(i,t=>I.concat(t))}e.bufferToStream=b;function D(i){return o.transform(i,{data:t=>typeof t=="string"?I.fromString(t):I.wrap(t)},t=>I.concat(t))}e.streamToBufferReadableStream=D;function p(i){return o.newWriteableStream(t=>I.concat(t),i)}e.newWriteableBufferStream=p;function n(i,t){return o.prefixedReadable(i,t,d=>I.concat(d))}e.prefixedBufferReadable=n;function s(i,t){return o.prefixedStream(i,t,d=>I.concat(d))}e.prefixedBufferStream=s;function r(i){let t=0,d=0,E=0;const w=new Uint8Array(Math.floor(i.length/4*3)),L=V=>{switch(d){case 3:w[E++]=t|V,d=0;break;case 2:w[E++]=t|V>>>2,t=V<<6,d=3;break;case 1:w[E++]=t|V>>>4,t=V<<4,d=2;break;default:t=V<<2,d=1}};for(let V=0;V<i.length;V++){const M=i.charCodeAt(V);if(M>=65&&M<=90)L(M-65);else if(M>=97&&M<=122)L(M-97+26);else if(M>=48&&M<=57)L(M-48+52);else if(M===43||M===45)L(62);else if(M===47||M===95)L(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${i[V]}`)}}const q=E;for(;d>0;)L(0);return I.wrap(w).slice(0,q)}e.decodeBase64=r;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:i},t=!0,d=!1){const E=d?l:c;let w="";const L=i.byteLength%3;let q=0;for(;q<i.byteLength-L;q+=3){const V=i[q+0],M=i[q+1],B=i[q+2];w+=E[V>>>2],w+=E[(V<<4|M>>>4)&63],w+=E[(M<<2|B>>>6)&63],w+=E[B&63]}if(L===1){const V=i[q+0];w+=E[V>>>2],w+=E[V<<4&63],t&&(w+="==")}else if(L===2){const V=i[q+0],M=i[q+1];w+=E[V>>>2],w+=E[(V<<4|M>>>4)&63],w+=E[M<<2&63],t&&(w+="=")}return w}e.encodeBase64=m}),define(ye[148],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ye[9],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function o(s){return typeof s=="string"}e.isString=o;function A(s){return Array.isArray(s)&&s.every(r=>o(r))}e.isStringArray=A;function a(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=a;function R(s){const r=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof r}e.isTypedArray=R;function I(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=I;function P(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=P;function S(s){return s===!0||s===!1}e.isBoolean=S;function k(s){return typeof s>"u"}e.isUndefined=k;function O(s){return!T(s)}e.isDefined=O;function T(s){return k(s)||s===null}e.isUndefinedOrNull=T;function v(s,r){if(!s)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=v;function C(s){if(T(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=C;function y(...s){const r=[];for(let c=0;c<s.length;c++){const l=s[c];if(T(l))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);r.push(l)}return r}e.assertAllDefined=y;const f=Object.prototype.hasOwnProperty;function h(s){if(!a(s))return!1;for(const r in s)if(f.call(s,r))return!1;return!0}e.isEmptyObject=h;function u(s){return typeof s=="function"}e.isFunction=u;function g(...s){return s.length>0&&s.every(u)}e.areFunctions=g;function b(s,r){const c=Math.min(s.length,r.length);for(let l=0;l<c;l++)D(s[l],r[l])}e.validateConstraints=b;function D(s,r){if(o(r)){if(typeof s!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(u(r)){try{if(s instanceof r)return}catch{}if(!T(s)&&s.constructor===r||r.length===1&&r.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=D;function p(s){return s===null?void 0:s}e.withNullAsUndefined=p;function n(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=n}),define(ye[67],De([1,0,9]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function a(P,S){if((0,o.isString)(S)){const k=A[S];if(k===void 0)throw new Error(`${P} references an unknown codicon: ${S}`);S=k}return A[P]=S,{id:P}}function R(){return A}e.getCodiconFontCharacters=R;function I(){return Object.values(e.Codicon)}e.getAllCodicons=I,e.Codicon={add:a("add",6e4),plus:a("plus",6e4),gistNew:a("gist-new",6e4),repoCreate:a("repo-create",6e4),lightbulb:a("lightbulb",60001),lightBulb:a("light-bulb",60001),repo:a("repo",60002),repoDelete:a("repo-delete",60002),gistFork:a("gist-fork",60003),repoForked:a("repo-forked",60003),gitPullRequest:a("git-pull-request",60004),gitPullRequestAbandoned:a("git-pull-request-abandoned",60004),recordKeys:a("record-keys",60005),keyboard:a("keyboard",60005),tag:a("tag",60006),tagAdd:a("tag-add",60006),tagRemove:a("tag-remove",60006),person:a("person",60007),personFollow:a("person-follow",60007),personOutline:a("person-outline",60007),personFilled:a("person-filled",60007),gitBranch:a("git-branch",60008),gitBranchCreate:a("git-branch-create",60008),gitBranchDelete:a("git-branch-delete",60008),sourceControl:a("source-control",60008),mirror:a("mirror",60009),mirrorPublic:a("mirror-public",60009),star:a("star",60010),starAdd:a("star-add",60010),starDelete:a("star-delete",60010),starEmpty:a("star-empty",60010),comment:a("comment",60011),commentAdd:a("comment-add",60011),alert:a("alert",60012),warning:a("warning",60012),search:a("search",60013),searchSave:a("search-save",60013),logOut:a("log-out",60014),signOut:a("sign-out",60014),logIn:a("log-in",60015),signIn:a("sign-in",60015),eye:a("eye",60016),eyeUnwatch:a("eye-unwatch",60016),eyeWatch:a("eye-watch",60016),circleFilled:a("circle-filled",60017),primitiveDot:a("primitive-dot",60017),closeDirty:a("close-dirty",60017),debugBreakpoint:a("debug-breakpoint",60017),debugBreakpointDisabled:a("debug-breakpoint-disabled",60017),debugHint:a("debug-hint",60017),primitiveSquare:a("primitive-square",60018),edit:a("edit",60019),pencil:a("pencil",60019),info:a("info",60020),issueOpened:a("issue-opened",60020),gistPrivate:a("gist-private",60021),gitForkPrivate:a("git-fork-private",60021),lock:a("lock",60021),mirrorPrivate:a("mirror-private",60021),close:a("close",60022),removeClose:a("remove-close",60022),x:a("x",60022),repoSync:a("repo-sync",60023),sync:a("sync",60023),clone:a("clone",60024),desktopDownload:a("desktop-download",60024),beaker:a("beaker",60025),microscope:a("microscope",60025),vm:a("vm",60026),deviceDesktop:a("device-desktop",60026),file:a("file",60027),fileText:a("file-text",60027),more:a("more",60028),ellipsis:a("ellipsis",60028),kebabHorizontal:a("kebab-horizontal",60028),mailReply:a("mail-reply",60029),reply:a("reply",60029),organization:a("organization",60030),organizationFilled:a("organization-filled",60030),organizationOutline:a("organization-outline",60030),newFile:a("new-file",60031),fileAdd:a("file-add",60031),newFolder:a("new-folder",60032),fileDirectoryCreate:a("file-directory-create",60032),trash:a("trash",60033),trashcan:a("trashcan",60033),history:a("history",60034),clock:a("clock",60034),folder:a("folder",60035),fileDirectory:a("file-directory",60035),symbolFolder:a("symbol-folder",60035),logoGithub:a("logo-github",60036),markGithub:a("mark-github",60036),github:a("github",60036),terminal:a("terminal",60037),console:a("console",60037),repl:a("repl",60037),zap:a("zap",60038),symbolEvent:a("symbol-event",60038),error:a("error",60039),stop:a("stop",60039),variable:a("variable",60040),symbolVariable:a("symbol-variable",60040),array:a("array",60042),symbolArray:a("symbol-array",60042),symbolModule:a("symbol-module",60043),symbolPackage:a("symbol-package",60043),symbolNamespace:a("symbol-namespace",60043),symbolObject:a("symbol-object",60043),symbolMethod:a("symbol-method",60044),symbolFunction:a("symbol-function",60044),symbolConstructor:a("symbol-constructor",60044),symbolBoolean:a("symbol-boolean",60047),symbolNull:a("symbol-null",60047),symbolNumeric:a("symbol-numeric",60048),symbolNumber:a("symbol-number",60048),symbolStructure:a("symbol-structure",60049),symbolStruct:a("symbol-struct",60049),symbolParameter:a("symbol-parameter",60050),symbolTypeParameter:a("symbol-type-parameter",60050),symbolKey:a("symbol-key",60051),symbolText:a("symbol-text",60051),symbolReference:a("symbol-reference",60052),goToFile:a("go-to-file",60052),symbolEnum:a("symbol-enum",60053),symbolValue:a("symbol-value",60053),symbolRuler:a("symbol-ruler",60054),symbolUnit:a("symbol-unit",60054),activateBreakpoints:a("activate-breakpoints",60055),archive:a("archive",60056),arrowBoth:a("arrow-both",60057),arrowDown:a("arrow-down",60058),arrowLeft:a("arrow-left",60059),arrowRight:a("arrow-right",60060),arrowSmallDown:a("arrow-small-down",60061),arrowSmallLeft:a("arrow-small-left",60062),arrowSmallRight:a("arrow-small-right",60063),arrowSmallUp:a("arrow-small-up",60064),arrowUp:a("arrow-up",60065),bell:a("bell",60066),bold:a("bold",60067),book:a("book",60068),bookmark:a("bookmark",60069),debugBreakpointConditionalUnverified:a("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:a("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:a("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:a("debug-breakpoint-data-unverified",60072),debugBreakpointData:a("debug-breakpoint-data",60073),debugBreakpointDataDisabled:a("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:a("debug-breakpoint-log-unverified",60074),debugBreakpointLog:a("debug-breakpoint-log",60075),debugBreakpointLogDisabled:a("debug-breakpoint-log-disabled",60075),briefcase:a("briefcase",60076),broadcast:a("broadcast",60077),browser:a("browser",60078),bug:a("bug",60079),calendar:a("calendar",60080),caseSensitive:a("case-sensitive",60081),check:a("check",60082),checklist:a("checklist",60083),chevronDown:a("chevron-down",60084),dropDownButton:a("drop-down-button",60084),chevronLeft:a("chevron-left",60085),chevronRight:a("chevron-right",60086),chevronUp:a("chevron-up",60087),chromeClose:a("chrome-close",60088),chromeMaximize:a("chrome-maximize",60089),chromeMinimize:a("chrome-minimize",60090),chromeRestore:a("chrome-restore",60091),circle:a("circle",60092),circleOutline:a("circle-outline",60092),debugBreakpointUnverified:a("debug-breakpoint-unverified",60092),circleSlash:a("circle-slash",60093),circuitBoard:a("circuit-board",60094),clearAll:a("clear-all",60095),clippy:a("clippy",60096),closeAll:a("close-all",60097),cloudDownload:a("cloud-download",60098),cloudUpload:a("cloud-upload",60099),code:a("code",60100),collapseAll:a("collapse-all",60101),colorMode:a("color-mode",60102),commentDiscussion:a("comment-discussion",60103),compareChanges:a("compare-changes",60157),creditCard:a("credit-card",60105),dash:a("dash",60108),dashboard:a("dashboard",60109),database:a("database",60110),debugContinue:a("debug-continue",60111),debugDisconnect:a("debug-disconnect",60112),debugPause:a("debug-pause",60113),debugRestart:a("debug-restart",60114),debugStart:a("debug-start",60115),debugStepInto:a("debug-step-into",60116),debugStepOut:a("debug-step-out",60117),debugStepOver:a("debug-step-over",60118),debugStop:a("debug-stop",60119),debug:a("debug",60120),deviceCameraVideo:a("device-camera-video",60121),deviceCamera:a("device-camera",60122),deviceMobile:a("device-mobile",60123),diffAdded:a("diff-added",60124),diffIgnored:a("diff-ignored",60125),diffModified:a("diff-modified",60126),diffRemoved:a("diff-removed",60127),diffRenamed:a("diff-renamed",60128),diff:a("diff",60129),discard:a("discard",60130),editorLayout:a("editor-layout",60131),emptyWindow:a("empty-window",60132),exclude:a("exclude",60133),extensions:a("extensions",60134),eyeClosed:a("eye-closed",60135),fileBinary:a("file-binary",60136),fileCode:a("file-code",60137),fileMedia:a("file-media",60138),filePdf:a("file-pdf",60139),fileSubmodule:a("file-submodule",60140),fileSymlinkDirectory:a("file-symlink-directory",60141),fileSymlinkFile:a("file-symlink-file",60142),fileZip:a("file-zip",60143),files:a("files",60144),filter:a("filter",60145),flame:a("flame",60146),foldDown:a("fold-down",60147),foldUp:a("fold-up",60148),fold:a("fold",60149),folderActive:a("folder-active",60150),folderOpened:a("folder-opened",60151),gear:a("gear",60152),gift:a("gift",60153),gistSecret:a("gist-secret",60154),gist:a("gist",60155),gitCommit:a("git-commit",60156),gitCompare:a("git-compare",60157),gitMerge:a("git-merge",60158),githubAction:a("github-action",60159),githubAlt:a("github-alt",60160),globe:a("globe",60161),grabber:a("grabber",60162),graph:a("graph",60163),gripper:a("gripper",60164),heart:a("heart",60165),home:a("home",60166),horizontalRule:a("horizontal-rule",60167),hubot:a("hubot",60168),inbox:a("inbox",60169),issueClosed:a("issue-closed",60324),issueReopened:a("issue-reopened",60171),issues:a("issues",60172),italic:a("italic",60173),jersey:a("jersey",60174),json:a("json",60175),bracket:a("bracket",60175),kebabVertical:a("kebab-vertical",60176),key:a("key",60177),law:a("law",60178),lightbulbAutofix:a("lightbulb-autofix",60179),linkExternal:a("link-external",60180),link:a("link",60181),listOrdered:a("list-ordered",60182),listUnordered:a("list-unordered",60183),liveShare:a("live-share",60184),loading:a("loading",60185),location:a("location",60186),mailRead:a("mail-read",60187),mail:a("mail",60188),markdown:a("markdown",60189),megaphone:a("megaphone",60190),mention:a("mention",60191),milestone:a("milestone",60192),mortarBoard:a("mortar-board",60193),move:a("move",60194),multipleWindows:a("multiple-windows",60195),mute:a("mute",60196),noNewline:a("no-newline",60197),note:a("note",60198),octoface:a("octoface",60199),openPreview:a("open-preview",60200),package_:a("package",60201),paintcan:a("paintcan",60202),pin:a("pin",60203),play:a("play",60204),run:a("run",60204),plug:a("plug",60205),preserveCase:a("preserve-case",60206),preview:a("preview",60207),project:a("project",60208),pulse:a("pulse",60209),question:a("question",60210),quote:a("quote",60211),radioTower:a("radio-tower",60212),reactions:a("reactions",60213),references:a("references",60214),refresh:a("refresh",60215),regex:a("regex",60216),remoteExplorer:a("remote-explorer",60217),remote:a("remote",60218),remove:a("remove",60219),replaceAll:a("replace-all",60220),replace:a("replace",60221),repoClone:a("repo-clone",60222),repoForcePush:a("repo-force-push",60223),repoPull:a("repo-pull",60224),repoPush:a("repo-push",60225),report:a("report",60226),requestChanges:a("request-changes",60227),rocket:a("rocket",60228),rootFolderOpened:a("root-folder-opened",60229),rootFolder:a("root-folder",60230),rss:a("rss",60231),ruby:a("ruby",60232),saveAll:a("save-all",60233),saveAs:a("save-as",60234),save:a("save",60235),screenFull:a("screen-full",60236),screenNormal:a("screen-normal",60237),searchStop:a("search-stop",60238),server:a("server",60240),settingsGear:a("settings-gear",60241),settings:a("settings",60242),shield:a("shield",60243),smiley:a("smiley",60244),sortPrecedence:a("sort-precedence",60245),splitHorizontal:a("split-horizontal",60246),splitVertical:a("split-vertical",60247),squirrel:a("squirrel",60248),starFull:a("star-full",60249),starHalf:a("star-half",60250),symbolClass:a("symbol-class",60251),symbolColor:a("symbol-color",60252),symbolCustomColor:a("symbol-customcolor",60252),symbolConstant:a("symbol-constant",60253),symbolEnumMember:a("symbol-enum-member",60254),symbolField:a("symbol-field",60255),symbolFile:a("symbol-file",60256),symbolInterface:a("symbol-interface",60257),symbolKeyword:a("symbol-keyword",60258),symbolMisc:a("symbol-misc",60259),symbolOperator:a("symbol-operator",60260),symbolProperty:a("symbol-property",60261),wrench:a("wrench",60261),wrenchSubaction:a("wrench-subaction",60261),symbolSnippet:a("symbol-snippet",60262),tasklist:a("tasklist",60263),telescope:a("telescope",60264),textSize:a("text-size",60265),threeBars:a("three-bars",60266),thumbsdown:a("thumbsdown",60267),thumbsup:a("thumbsup",60268),tools:a("tools",60269),triangleDown:a("triangle-down",60270),triangleLeft:a("triangle-left",60271),triangleRight:a("triangle-right",60272),triangleUp:a("triangle-up",60273),twitter:a("twitter",60274),unfold:a("unfold",60275),unlock:a("unlock",60276),unmute:a("unmute",60277),unverified:a("unverified",60278),verified:a("verified",60279),versions:a("versions",60280),vmActive:a("vm-active",60281),vmOutline:a("vm-outline",60282),vmRunning:a("vm-running",60283),watch:a("watch",60284),whitespace:a("whitespace",60285),wholeWord:a("whole-word",60286),window:a("window",60287),wordWrap:a("word-wrap",60288),zoomIn:a("zoom-in",60289),zoomOut:a("zoom-out",60290),listFilter:a("list-filter",60291),listFlat:a("list-flat",60292),listSelection:a("list-selection",60293),selection:a("selection",60293),listTree:a("list-tree",60294),debugBreakpointFunctionUnverified:a("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:a("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:a("debug-breakpoint-function-disabled",60296),debugStackframeActive:a("debug-stackframe-active",60297),circleSmallFilled:a("circle-small-filled",60298),debugStackframeDot:a("debug-stackframe-dot",60298),debugStackframe:a("debug-stackframe",60299),debugStackframeFocused:a("debug-stackframe-focused",60299),debugBreakpointUnsupported:a("debug-breakpoint-unsupported",60300),symbolString:a("symbol-string",60301),debugReverseContinue:a("debug-reverse-continue",60302),debugStepBack:a("debug-step-back",60303),debugRestartFrame:a("debug-restart-frame",60304),callIncoming:a("call-incoming",60306),callOutgoing:a("call-outgoing",60307),menu:a("menu",60308),expandAll:a("expand-all",60309),feedback:a("feedback",60310),groupByRefType:a("group-by-ref-type",60311),ungroupByRefType:a("ungroup-by-ref-type",60312),account:a("account",60313),bellDot:a("bell-dot",60314),debugConsole:a("debug-console",60315),library:a("library",60316),output:a("output",60317),runAll:a("run-all",60318),syncIgnored:a("sync-ignored",60319),pinned:a("pinned",60320),githubInverted:a("github-inverted",60321),debugAlt:a("debug-alt",60305),serverProcess:a("server-process",60322),serverEnvironment:a("server-environment",60323),pass:a("pass",60324),stopCircle:a("stop-circle",60325),playCircle:a("play-circle",60326),record:a("record",60327),debugAltSmall:a("debug-alt-small",60328),vmConnect:a("vm-connect",60329),cloud:a("cloud",60330),merge:a("merge",60331),exportIcon:a("export",60332),graphLeft:a("graph-left",60333),magnet:a("magnet",60334),notebook:a("notebook",60335),redo:a("redo",60336),checkAll:a("check-all",60337),pinnedDirty:a("pinned-dirty",60338),passFilled:a("pass-filled",60339),circleLargeFilled:a("circle-large-filled",60340),circleLarge:a("circle-large",60341),circleLargeOutline:a("circle-large-outline",60341),combine:a("combine",60342),gather:a("gather",60342),table:a("table",60343),variableGroup:a("variable-group",60344),typeHierarchy:a("type-hierarchy",60345),typeHierarchySub:a("type-hierarchy-sub",60346),typeHierarchySuper:a("type-hierarchy-super",60347),gitPullRequestCreate:a("git-pull-request-create",60348),runAbove:a("run-above",60349),runBelow:a("run-below",60350),notebookTemplate:a("notebook-template",60351),debugRerun:a("debug-rerun",60352),workspaceTrusted:a("workspace-trusted",60353),workspaceUntrusted:a("workspace-untrusted",60354),workspaceUnspecified:a("workspace-unspecified",60355),terminalCmd:a("terminal-cmd",60356),terminalDebian:a("terminal-debian",60357),terminalLinux:a("terminal-linux",60358),terminalPowershell:a("terminal-powershell",60359),terminalTmux:a("terminal-tmux",60360),terminalUbuntu:a("terminal-ubuntu",60361),terminalBash:a("terminal-bash",60362),arrowSwap:a("arrow-swap",60363),copy:a("copy",60364),personAdd:a("person-add",60365),filterFilled:a("filter-filled",60366),wand:a("wand",60367),debugLineByLine:a("debug-line-by-line",60368),inspect:a("inspect",60369),layers:a("layers",60370),layersDot:a("layers-dot",60371),layersActive:a("layers-active",60372),compass:a("compass",60373),compassDot:a("compass-dot",60374),compassActive:a("compass-active",60375),azure:a("azure",60376),issueDraft:a("issue-draft",60377),gitPullRequestClosed:a("git-pull-request-closed",60378),gitPullRequestDraft:a("git-pull-request-draft",60379),debugAll:a("debug-all",60380),debugCoverage:a("debug-coverage",60381),runErrors:a("run-errors",60382),folderLibrary:a("folder-library",60383),debugContinueSmall:a("debug-continue-small",60384),beakerStop:a("beaker-stop",60385),graphLine:a("graph-line",60386),graphScatter:a("graph-scatter",60387),pieChart:a("pie-chart",60388),bracketDot:a("bracket-dot",60389),bracketError:a("bracket-error",60390),lockSmall:a("lock-small",60391),azureDevops:a("azure-devops",60392),verifiedFilled:a("verified-filled",60393),newLine:a("newline",60394),layout:a("layout",60395),layoutActivitybarLeft:a("layout-activitybar-left",60396),layoutActivitybarRight:a("layout-activitybar-right",60397),layoutPanelLeft:a("layout-panel-left",60398),layoutPanelCenter:a("layout-panel-center",60399),layoutPanelJustify:a("layout-panel-justify",60400),layoutPanelRight:a("layout-panel-right",60401),layoutPanel:a("layout-panel",60402),layoutSidebarLeft:a("layout-sidebar-left",60403),layoutSidebarRight:a("layout-sidebar-right",60404),layoutStatusbar:a("layout-statusbar",60405),layoutMenubar:a("layout-menubar",60406),layoutCentered:a("layout-centered",60407),layoutSidebarRightOff:a("layout-sidebar-right-off",60416),layoutPanelOff:a("layout-panel-off",60417),layoutSidebarLeftOff:a("layout-sidebar-left-off",60418),target:a("target",60408),indent:a("indent",60409),recordSmall:a("record-small",60410),errorSmall:a("error-small",60411),arrowCircleDown:a("arrow-circle-down",60412),arrowCircleLeft:a("arrow-circle-left",60413),arrowCircleRight:a("arrow-circle-right",60414),arrowCircleUp:a("arrow-circle-up",60415),heartFilled:a("heart-filled",60420),map:a("map",60421),mapFilled:a("map-filled",60422),circleSmall:a("circle-small",60423),bellSlash:a("bell-slash",60424),bellSlashDot:a("bell-slash-dot",60425),commentUnresolved:a("comment-unresolved",60426),gitPullRequestGoToChanges:a("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:a("git-pull-request-new-changes",60428),searchFuzzy:a("search-fuzzy",60429),commentDraft:a("comment-draft",60430),dialogError:a("dialog-error","error"),dialogWarning:a("dialog-warning","warning"),dialogInfo:a("dialog-info","info"),dialogClose:a("dialog-close","close"),treeItemExpanded:a("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:a("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:a("tree-filter-on-type-off","list-selection"),treeFilterClear:a("tree-filter-clear","close"),treeItemLoading:a("tree-item-loading","loading"),menuSelection:a("menu-selection","check"),menuSubmenu:a("menu-submenu","chevron-right"),menuBarMore:a("menubar-more","more"),scrollbarButtonLeft:a("scrollbar-button-left","triangle-left"),scrollbarButtonRight:a("scrollbar-button-right","triangle-right"),scrollbarButtonUp:a("scrollbar-button-up","triangle-up"),scrollbarButtonDown:a("scrollbar-button-down","triangle-down"),toolBarMore:a("toolbar-more","more"),quickInputBack:a("quick-input-back","arrow-left")}}),define(ye[23],De([1,0,9]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const g=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([b,D])=>{g[b]=D&&typeof D=="object"?A(D):D}),g}e.deepClone=A;function a(u){if(!u||typeof u!="object")return u;const g=[u];for(;g.length>0;){const b=g.shift();Object.freeze(b);for(const D in b)if(R.call(b,D)){const p=b[D];typeof p=="object"&&!Object.isFrozen(p)&&!(0,o.isTypedArray)(p)&&g.push(p)}}return u}e.deepFreeze=a;const R=Object.prototype.hasOwnProperty;function I(u,g){return P(u,g,new Set)}e.cloneAndChange=I;function P(u,g,b){if((0,o.isUndefinedOrNull)(u))return u;const D=g(u);if(typeof D<"u")return D;if(Array.isArray(u)){const p=[];for(const n of u)p.push(P(n,g,b));return p}if((0,o.isObject)(u)){if(b.has(u))throw new Error("Cannot clone recursive data-structure");b.add(u);const p={};for(const n in u)R.call(u,n)&&(p[n]=P(u[n],g,b));return b.delete(u),p}return u}function S(u,g,b=!0){return(0,o.isObject)(u)?((0,o.isObject)(g)&&Object.keys(g).forEach(D=>{D in u?b&&((0,o.isObject)(u[D])&&(0,o.isObject)(g[D])?S(u[D],g[D],b):u[D]=g[D]):u[D]=g[D]}),u):g}e.mixin=S;function k(u,g){if(u===g)return!0;if(u==null||g===null||g===void 0||typeof u!=typeof g||typeof u!="object"||Array.isArray(u)!==Array.isArray(g))return!1;let b,D;if(Array.isArray(u)){if(u.length!==g.length)return!1;for(b=0;b<u.length;b++)if(!k(u[b],g[b]))return!1}else{const p=[];for(D in u)p.push(D);p.sort();const n=[];for(D in g)n.push(D);if(n.sort(),!k(p,n))return!1;for(b=0;b<p.length;b++)if(!k(u[p[b]],g[p[b]]))return!1}return!0}e.equals=k;function O(u){const g=new Set;return JSON.stringify(u,(b,D)=>{if((0,o.isObject)(D)||Array.isArray(D)){if(g.has(D))return"[Circular]";g.add(D)}return D})}e.safeStringify=O;function T(u,g){const b=Object.create(null);return!u||!g||Object.keys(g).forEach(p=>{const n=u[p],s=g[p];k(n,s)||(b[p]=s)}),b}e.distinct=T;function v(u,g){const b=g.toLowerCase(),D=Object.keys(u).find(p=>p.toLowerCase()===b);return D?u[D]:u[g]}e.getCaseInsensitive=v;function C(u,g){const b=Object.create(null);for(const[D,p]of Object.entries(u))g(D,p)&&(b[D]=p);return b}e.filter=C;function y(u){let g=[],b=Object.getPrototypeOf(u);for(;Object.prototype!==b;)g=g.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return g}e.getAllPropertyNames=y;function f(u){const g=[];for(const b of y(u))typeof u[b]=="function"&&g.push(b);return g}e.getAllMethodNames=f;function h(u,g){const b=p=>function(){const n=Array.prototype.slice.call(arguments,0);return g(p,n)},D={};for(const p of u)D[p]=b(p);return D}e.createProxyObject=h}),define(ye[51],De([1,0,67]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(I){function P(S){return S&&typeof S=="object"&&typeof S.id=="string"}I.isThemeColor=P})(A=e.ThemeColor||(e.ThemeColor={}));function a(I){return{id:I}}e.themeColorFromId=a;var R;(function(I){I.iconNameSegment="[A-Za-z0-9]+",I.iconNameExpression="[A-Za-z0-9-]+",I.iconModifierExpression="~[A-Za-z]+",I.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${I.iconNameExpression})(${I.iconModifierExpression})?$`);function S(g){const b=P.exec(g.id);if(!b)return S(o.Codicon.error);const[,D,p]=b,n=["codicon","codicon-"+D];return p&&n.push("codicon-modifier-"+p.substring(1)),n}I.asClassNameArray=S;function k(g){return S(g).join(" ")}I.asClassName=k;function O(g){return"."+S(g).join(".")}I.asCSSSelector=O;function T(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||A.isThemeColor(g.color))}I.isThemeIcon=T;const v=new RegExp(`^\\$\\((${I.iconNameExpression}(?:${I.iconModifierExpression})?)\\)$`);function C(g){const b=v.exec(g);if(!b)return;const[,D]=b;return{id:D}}I.fromString=C;function y(g){return{id:g}}I.fromId=y;function f(g,b){let D=g.id;const p=D.lastIndexOf("~");return p!==-1&&(D=D.substring(0,p)),b&&(D=`${D}~${b}`),{id:D}}I.modify=f;function h(g){const b=g.id.lastIndexOf("~");if(b!==-1)return g.id.substring(b+1)}I.getModifier=h;function u(g,b){return g.id===b.id&&g.color?.id===b.color?.id}I.isEqual=u})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(ye[104],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var o;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(o=e.Constants||(e.Constants={}));function A(R){return R<0?0:R>255?255:R|0}e.toUint8=A;function a(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=a}),define(ye[30],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(a){return o.test(a)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let a;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?a=crypto.getRandomValues.bind(crypto):a=function(P){for(let S=0;S<P.length;S++)P[S]=Math.floor(Math.random()*256);return P};const R=new Uint8Array(16),I=[];for(let P=0;P<256;P++)I.push(P.toString(16).padStart(2,"0"));return function(){a(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let S=0,k="";return k+=I[R[S++]],k+=I[R[S++]],k+=I[R[S++]],k+=I[R[S++]],k+="-",k+=I[R[S++]],k+=I[R[S++]],k+="-",k+=I[R[S++]],k+=I[R[S++]],k+="-",k+=I[R[S++]],k+=I[R[S++]],k+="-",k+=I[R[S++]],k+=I[R[S++]],k+=I[R[S++]],k+=I[R[S++]],k+=I[R[S++]],k+=I[R[S++]],k}}()}),define(ye[149],De([1,0,15,30]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function a(P){return{id:(0,A.generateUuid)(),asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.createStringDataTransferItem=a;function R(P,S,k){return{id:(0,A.generateUuid)(),asString:async()=>"",asFile:()=>({name:P,uri:S,data:k}),value:void 0}}e.createFileDataTransferItem=R;class I{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,k){const O=this.a.get(S);O?O.push(k):this.a.set(this.b(S),[k])}replace(S,k){this.a.set(this.b(S),[k])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,k]of this.a.entries())for(const O of k)yield[S,O]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[k,O]of this.entries())S(O,k)}b(S){return S.toLowerCase()}}e.VSDataTransfer=I,e.UriList=Object.freeze({create:P=>(0,o.distinct)(P.map(S=>S.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.UriList.split(P).filter(S=>!S.startsWith("#"))})}),define(ye[105],De([1,0,104]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class A{constructor(P){const S=(0,o.toUint8)(P);this.c=S,this.a=A.d(S),this.b=new Map}static d(P){const S=new Uint8Array(256);return S.fill(P),S}set(P,S){const k=(0,o.toUint8)(S);P>=0&&P<256?this.a[P]=k:this.b.set(P,k)}get(P){return P>=0&&P<256?this.a[P]:this.b.get(P)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=A;var a;(function(I){I[I.False=0]="False",I[I.True=1]="True"})(a||(a={}));class R{constructor(){this.a=new A(0)}add(P){this.a.set(P,1)}has(P){return this.a.get(P)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(ye[52],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class o{constructor(a,R){this.lineNumber=a,this.column=R}with(a=this.lineNumber,R=this.column){return a===this.lineNumber&&R===this.column?this:new o(a,R)}delta(a=0,R=0){return this.with(this.lineNumber+a,this.column+R)}equals(a){return o.equals(this,a)}static equals(a,R){return!a&&!R?!0:!!a&&!!R&&a.lineNumber===R.lineNumber&&a.column===R.column}isBefore(a){return o.isBefore(this,a)}static isBefore(a,R){return a.lineNumber<R.lineNumber?!0:R.lineNumber<a.lineNumber?!1:a.column<R.column}isBeforeOrEqual(a){return o.isBeforeOrEqual(this,a)}static isBeforeOrEqual(a,R){return a.lineNumber<R.lineNumber?!0:R.lineNumber<a.lineNumber?!1:a.column<=R.column}static compare(a,R){const I=a.lineNumber|0,P=R.lineNumber|0;if(I===P){const S=a.column|0,k=R.column|0;return S-k}return I-P}clone(){return new o(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(a){return new o(a.lineNumber,a.column)}static isIPosition(a){return a&&typeof a.lineNumber=="number"&&typeof a.column=="number"}}e.Position=o}),define(ye[32],De([1,0,52]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class A{constructor(R,I,P,S){R>P||R===P&&I>S?(this.startLineNumber=P,this.startColumn=S,this.endLineNumber=R,this.endColumn=I):(this.startLineNumber=R,this.startColumn=I,this.endLineNumber=P,this.endColumn=S)}isEmpty(){return A.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return A.containsPosition(this,R)}static containsPosition(R,I){return!(I.lineNumber<R.startLineNumber||I.lineNumber>R.endLineNumber||I.lineNumber===R.startLineNumber&&I.column<R.startColumn||I.lineNumber===R.endLineNumber&&I.column>R.endColumn)}static strictContainsPosition(R,I){return!(I.lineNumber<R.startLineNumber||I.lineNumber>R.endLineNumber||I.lineNumber===R.startLineNumber&&I.column<=R.startColumn||I.lineNumber===R.endLineNumber&&I.column>=R.endColumn)}containsRange(R){return A.containsRange(this,R)}static containsRange(R,I){return!(I.startLineNumber<R.startLineNumber||I.endLineNumber<R.startLineNumber||I.startLineNumber>R.endLineNumber||I.endLineNumber>R.endLineNumber||I.startLineNumber===R.startLineNumber&&I.startColumn<R.startColumn||I.endLineNumber===R.endLineNumber&&I.endColumn>R.endColumn)}strictContainsRange(R){return A.strictContainsRange(this,R)}static strictContainsRange(R,I){return!(I.startLineNumber<R.startLineNumber||I.endLineNumber<R.startLineNumber||I.startLineNumber>R.endLineNumber||I.endLineNumber>R.endLineNumber||I.startLineNumber===R.startLineNumber&&I.startColumn<=R.startColumn||I.endLineNumber===R.endLineNumber&&I.endColumn>=R.endColumn)}plusRange(R){return A.plusRange(this,R)}static plusRange(R,I){let P,S,k,O;return I.startLineNumber<R.startLineNumber?(P=I.startLineNumber,S=I.startColumn):I.startLineNumber===R.startLineNumber?(P=I.startLineNumber,S=Math.min(I.startColumn,R.startColumn)):(P=R.startLineNumber,S=R.startColumn),I.endLineNumber>R.endLineNumber?(k=I.endLineNumber,O=I.endColumn):I.endLineNumber===R.endLineNumber?(k=I.endLineNumber,O=Math.max(I.endColumn,R.endColumn)):(k=R.endLineNumber,O=R.endColumn),new A(P,S,k,O)}intersectRanges(R){return A.intersectRanges(this,R)}static intersectRanges(R,I){let P=R.startLineNumber,S=R.startColumn,k=R.endLineNumber,O=R.endColumn;const T=I.startLineNumber,v=I.startColumn,C=I.endLineNumber,y=I.endColumn;return P<T?(P=T,S=v):P===T&&(S=Math.max(S,v)),k>C?(k=C,O=y):k===C&&(O=Math.min(O,y)),P>k||P===k&&S>O?null:new A(P,S,k,O)}equalsRange(R){return A.equalsRange(this,R)}static equalsRange(R,I){return!R&&!I?!0:!!R&&!!I&&R.startLineNumber===I.startLineNumber&&R.startColumn===I.startColumn&&R.endLineNumber===I.endLineNumber&&R.endColumn===I.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(R){return new o.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(R){return new o.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,I){return new A(this.startLineNumber,this.startColumn,R,I)}setStartPosition(R,I){return new A(R,I,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(R){return new A(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(R){return new A(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new A(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,I=R){return new A(R.lineNumber,R.column,I.lineNumber,I.column)}static lift(R){return R?new A(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,I){return!(R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<I.startColumn||I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<R.startColumn)}static areIntersecting(R,I){return!(R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<=I.startColumn||I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,I){if(R&&I){const k=R.startLineNumber|0,O=I.startLineNumber|0;if(k===O){const T=R.startColumn|0,v=I.startColumn|0;if(T===v){const C=R.endLineNumber|0,y=I.endLineNumber|0;if(C===y){const f=R.endColumn|0,h=I.endColumn|0;return f-h}return C-y}return T-v}return k-O}return(R?1:0)-(I?1:0)}static compareRangesUsingEnds(R,I){return R.endLineNumber===I.endLineNumber?R.endColumn===I.endColumn?R.startLineNumber===I.startLineNumber?R.startColumn-I.startColumn:R.startLineNumber-I.startLineNumber:R.endColumn-I.endColumn:R.endLineNumber-I.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=A}),define(ye[150],De([1,0,52,32]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var a;(function(I){I[I.LTR=0]="LTR",I[I.RTL=1]="RTL"})(a=e.SelectionDirection||(e.SelectionDirection={}));class R extends A.Range{constructor(P,S,k,O){super(P,S,k,O),this.selectionStartLineNumber=P,this.selectionStartColumn=S,this.positionLineNumber=k,this.positionColumn=O}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return R.selectionsEqual(this,P)}static selectionsEqual(P,S){return P.selectionStartLineNumber===S.selectionStartLineNumber&&P.selectionStartColumn===S.selectionStartColumn&&P.positionLineNumber===S.positionLineNumber&&P.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,S){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,P,S):new R(P,S,this.startLineNumber,this.startColumn)}getPosition(){return new o.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new o.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(P,S){return this.getDirection()===0?new R(P,S,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,P,S)}static fromPositions(P,S=P){return new R(P.lineNumber,P.column,S.lineNumber,S.column)}static fromRange(P,S){return S===0?new R(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):new R(P.endLineNumber,P.endColumn,P.startLineNumber,P.startColumn)}static liftSelection(P){return new R(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,S){if(P&&!S||!P&&S)return!1;if(!P&&!S)return!0;if(P.length!==S.length)return!1;for(let k=0,O=P.length;k<O;k++)if(!this.selectionsEqual(P[k],S[k]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,S,k,O,T){return T===0?new R(P,S,k,O):new R(k,O,P,S)}}e.Selection=R}),define(ye[151],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[152],De([1,0,105]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var A;(function(I){I[I.Regular=0]="Regular",I[I.Whitespace=1]="Whitespace",I[I.WordSeparator=2]="WordSeparator"})(A=e.WordCharacterClass||(e.WordCharacterClass={}));class a extends o.CharacterClassifier{constructor(P){super(0);for(let S=0,k=P.length;S<k;S++)this.set(P.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=a;function R(I){const P={};return S=>(P.hasOwnProperty(S)||(P[S]=I(S)),P[S])}e.getMapForWordSeparators=R(I=>new a(I))}),define(ye[106],De([1,0,64,6,66]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(T=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)T.indexOf(C)>=0||(v+="\\"+C);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=R();function I(T){let v=e.DEFAULT_WORD_REGEXP;if(T&&T instanceof RegExp)if(T.global)v=T;else{let C="g";T.ignoreCase&&(C+="i"),T.multiline&&(C+="m"),T.unicode&&(C+="u"),v=new RegExp(T.source,C)}return v.lastIndex=0,v}e.ensureValidWordDefinition=I;const P=new a.LinkedList;P.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(T){const v=P.unshift(T);return(0,A.toDisposable)(v)}e.setDefaultGetWordAtTextConfig=S;function k(T,v,C,y,f){if(f||(f=o.Iterable.first(P)),C.length>f.maxLen){let D=T-f.maxLen/2;return D<0?D=0:y+=D,C=C.substring(D,T+f.maxLen/2),k(T,v,C,y,f)}const h=Date.now(),u=T-1-y;let g=-1,b=null;for(let D=1;!(Date.now()-h>=f.timeBudget);D++){const p=u-f.windowSize*D;v.lastIndex=Math.max(0,p);const n=O(v,C,u,g);if(!n&&b||(b=n,p<=0))break;g=p}if(b){const D={word:b[0],startColumn:y+1+b.index,endColumn:y+1+b.index+b[0].length};return v.lastIndex=0,D}return null}e.getWordAtText=k;function O(T,v,C,y){let f;for(;f=T.exec(v);){const h=f.index||0;if(h<=C&&T.lastIndex>=C)return f;if(y>0&&h>y)return null}return null}}),define(ye[153],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var o;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(o=e.IndentAction||(e.IndentAction={}));class A{constructor(P){if(this.e=null,this.f=!1,this.open=P.open,this.close=P.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(P.notIn))for(let S=0,k=P.notIn.length;S<k;S++)switch(P.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(P,S){if(P.getTokenCount()===0)return!0;const k=P.findTokenIndexAtOffset(S-2),O=P.getStandardTokenType(k);return this.isOK(O)}g(P,S){for(let k=P;k<=S;k++){const O=String.fromCharCode(k);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=A;class a{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of P)R(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),R(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),R(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),R(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&R(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=a;function R(I,P,S){I.has(P)?I.get(P).push(S):I.set(P,[S])}}),define(ye[154],De([1,0,105]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var A;(function(C){C[C.Invalid=0]="Invalid",C[C.Start=1]="Start",C[C.H=2]="H",C[C.HT=3]="HT",C[C.HTT=4]="HTT",C[C.HTTP=5]="HTTP",C[C.F=6]="F",C[C.FI=7]="FI",C[C.FIL=8]="FIL",C[C.BeforeColon=9]="BeforeColon",C[C.AfterColon=10]="AfterColon",C[C.AlmostThere=11]="AlmostThere",C[C.End=12]="End",C[C.Accept=13]="Accept",C[C.LastKnownState=14]="LastKnownState"})(A=e.State||(e.State={}));class a{constructor(y,f,h){const u=new Uint8Array(y*f);for(let g=0,b=y*f;g<b;g++)u[g]=h;this.a=u,this.rows=y,this.cols=f}get(y,f){return this.a[y*this.cols+f]}set(y,f,h){this.a[y*this.cols+f]=h}}class R{constructor(y){let f=0,h=0;for(let g=0,b=y.length;g<b;g++){const[D,p,n]=y[g];p>f&&(f=p),D>h&&(h=D),n>h&&(h=n)}f++,h++;const u=new a(h,f,0);for(let g=0,b=y.length;g<b;g++){const[D,p,n]=y[g];u.set(D,p,n)}this.a=u,this.b=f}nextState(y,f){return f<0||f>=this.b?0:this.a.get(y,f)}}e.StateMachine=R;let I=null;function P(){return I===null&&(I=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),I}var S;(function(C){C[C.None=0]="None",C[C.ForceTermination=1]="ForceTermination",C[C.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let k=null;function O(){if(k===null){k=new o.CharacterClassifier(0);const C=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<C.length;f++)k.set(C.charCodeAt(f),1);const y=".;:";for(let f=0;f<y.length;f++)k.set(y.charCodeAt(f),2)}return k}class T{static a(y,f,h,u,g){let b=g-1;do{const D=f.charCodeAt(b);if(y.get(D)!==2)break;b--}while(b>u);if(u>0){const D=f.charCodeAt(u-1),p=f.charCodeAt(b);(D===40&&p===41||D===91&&p===93||D===123&&p===125)&&b--}return{range:{startLineNumber:h,startColumn:u+1,endLineNumber:h,endColumn:b+2},url:f.substring(u,b+1)}}static computeLinks(y,f=P()){const h=O(),u=[];for(let g=1,b=y.getLineCount();g<=b;g++){const D=y.getLineContent(g),p=D.length;let n=0,s=0,r=0,c=1,l=!1,m=!1,i=!1,t=!1;for(;n<p;){let d=!1;const E=D.charCodeAt(n);if(c===13){let w;switch(E){case 40:l=!0,w=0;break;case 41:w=l?0:1;break;case 91:i=!0,m=!0,w=0;break;case 93:i=!1,w=m?0:1;break;case 123:t=!0,w=0;break;case 125:w=t?0:1;break;case 39:case 34:case 96:r===E?w=1:r===39||r===34||r===96?w=0:w=1;break;case 42:w=r===42?1:0;break;case 124:w=r===124?1:0;break;case 32:w=i?0:1;break;default:w=h.get(E)}w===1&&(u.push(T.a(h,D,g,s,n)),d=!0)}else if(c===12){let w;E===91?(m=!0,w=0):w=h.get(E),w===1?d=!0:c=13}else c=f.nextState(c,E),c===0&&(d=!0);d&&(c=1,l=!1,m=!1,t=!1,s=n+1,r=E),n++}c===13&&u.push(T.a(h,D,g,s,p))}return u}}e.LinkComputer=T;function v(C){return!C||typeof C.getLineCount!="function"||typeof C.getLineContent!="function"?[]:T.computeLinks(C)}e.computeLinks=v}),define(ye[107],De([1,0,23]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var A;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(A=e.OverviewRulerLane||(e.OverviewRulerLane={}));var a;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(a=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var I;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(I=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(D){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,D.tabSize|0),D.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,D.indentSize|0),this.a=!1),this.insertSpaces=Boolean(D.insertSpaces),this.defaultEOL=D.defaultEOL|0,this.trimAutoWhitespace=Boolean(D.trimAutoWhitespace),this.bracketPairColorizationOptions=D.bracketPairColorizationOptions}equals(D){return this.tabSize===D.tabSize&&this.a===D.a&&this.indentSize===D.indentSize&&this.insertSpaces===D.insertSpaces&&this.defaultEOL===D.defaultEOL&&this.trimAutoWhitespace===D.trimAutoWhitespace&&(0,o.equals)(this.bracketPairColorizationOptions,D.bracketPairColorizationOptions)}createChangeEvent(D){return{tabSize:this.tabSize!==D.tabSize,indentSize:this.indentSize!==D.indentSize,insertSpaces:this.insertSpaces!==D.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==D.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class O{constructor(D,p){this._findMatchBrand=void 0,this.range=D,this.matches=p}}e.FindMatch=O;var T;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function v(b){return b&&typeof b.read=="function"}e.isITextSnapshot=v;var C;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(C=e.PositionAffinity||(e.PositionAffinity={}));var y;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(y=e.ModelConstants||(e.ModelConstants={}));class f{constructor(D,p,n,s,r,c){this.identifier=D,this.range=p,this.text=n,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=r,this._isTracked=c}}e.ValidAnnotatedEditOperation=f;class h{constructor(D,p,n){this.regex=D,this.wordSeparators=p,this.simpleSearch=n}}e.SearchData=h;class u{constructor(D,p,n){this.reverseEdits=D,this.changes=p,this.trimAutoWhitespaceLineNumbers=n}}e.ApplyEditsResult=u;function g(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=g}),define(ye[155],De([1,0,15,104]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class a{constructor(S){this.a=S,this.b=new Uint32Array(S.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(S,k){S=(0,A.toUint32)(S);const O=this.a,T=this.b,v=k.length;return v===0?!1:(this.a=new Uint32Array(O.length+v),this.a.set(O.subarray(0,S),0),this.a.set(O.subarray(S),S+v),this.a.set(k,S),S-1<this.c[0]&&(this.c[0]=S-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(T.subarray(0,this.c[0]+1)),!0)}setValue(S,k){return S=(0,A.toUint32)(S),k=(0,A.toUint32)(k),this.a[S]===k?!1:(this.a[S]=k,S-1<this.c[0]&&(this.c[0]=S-1),!0)}removeValues(S,k){S=(0,A.toUint32)(S),k=(0,A.toUint32)(k);const O=this.a,T=this.b;if(S>=O.length)return!1;const v=O.length-S;return k>=v&&(k=v),k===0?!1:(this.a=new Uint32Array(O.length-k),this.a.set(O.subarray(0,S),0),this.a.set(O.subarray(S+k),S),this.b=new Uint32Array(this.a.length),S-1<this.c[0]&&(this.c[0]=S-1),this.c[0]>=0&&this.b.set(T.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(S){return S<0?0:(S=(0,A.toUint32)(S),this.d(S))}d(S){if(S<=this.c[0])return this.b[S];let k=this.c[0]+1;k===0&&(this.b[0]=this.a[0],k++),S>=this.a.length&&(S=this.a.length-1);for(let O=k;O<=S;O++)this.b[O]=this.b[O-1]+this.a[O];return this.c[0]=Math.max(this.c[0],S),this.b[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let k=0,O=this.a.length-1,T=0,v=0,C=0;for(;k<=O;)if(T=k+(O-k)/2|0,v=this.b[T],C=v-this.a[T],S<C)O=T-1;else if(S>=v)k=T+1;else break;return new I(T,S-C)}}e.PrefixSumComputer=a;class R{constructor(S){this.a=S,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(S){return this.g(),S===0?0:this.d[S-1]}getIndexOf(S){this.g();const k=this.e[S],O=k>0?this.d[k-1]:0;return new I(k,S-O)}removeValues(S,k){this.a.splice(S,k),this.f(S)}insertValues(S,k){this.a=(0,o.arrayInsert)(this.a,S,k),this.f(S)}f(S){this.b=!1,this.c=Math.min(this.c,S-1)}g(){if(!this.b){for(let S=this.c+1,k=this.a.length;S<k;S++){const O=this.a[S],T=S>0?this.d[S-1]:0;this.d[S]=T+O;for(let v=0;v<O;v++)this.e[T+v]=S}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(S,k){this.a[S]!==k&&(this.a[S]=k,this.f(S))}}e.ConstantTimePrefixSumComputer=R;class I{constructor(S,k){this.index=S,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=k}}e.PrefixSumIndexOfResult=I}),define(ye[156],De([17,18]),function(ne,e){return ne.create("vs/base/common/actions",e)}),define(ye[157],De([17,18]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ye[158],De([1,0,157]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,a=A*60,R=a*24,I=R*7,P=R*30,S=R*365;function k(T,v,C,y){typeof T!="number"&&(T=T.getTime());const f=Math.round((new Date().getTime()-T)/1e3);if(f<-30)return(0,o.localize)(0,null,k(new Date().getTime()+f*1e3,!1));if(!y&&f<30)return(0,o.localize)(1,null);let h;return f<A?(h=f,v?h===1?C?(0,o.localize)(2,null,h):(0,o.localize)(3,null,h):C?(0,o.localize)(4,null,h):(0,o.localize)(5,null,h):h===1?C?(0,o.localize)(6,null,h):(0,o.localize)(7,null,h):C?(0,o.localize)(8,null,h):(0,o.localize)(9,null,h)):f<a?(h=Math.floor(f/A),v?h===1?C?(0,o.localize)(10,null,h):(0,o.localize)(11,null,h):C?(0,o.localize)(12,null,h):(0,o.localize)(13,null,h):h===1?C?(0,o.localize)(14,null,h):(0,o.localize)(15,null,h):C?(0,o.localize)(16,null,h):(0,o.localize)(17,null,h)):f<R?(h=Math.floor(f/a),v?h===1?C?(0,o.localize)(18,null,h):(0,o.localize)(19,null,h):C?(0,o.localize)(20,null,h):(0,o.localize)(21,null,h):h===1?C?(0,o.localize)(22,null,h):(0,o.localize)(23,null,h):C?(0,o.localize)(24,null,h):(0,o.localize)(25,null,h)):f<I?(h=Math.floor(f/R),v?h===1?(0,o.localize)(26,null,h):(0,o.localize)(27,null,h):h===1?(0,o.localize)(28,null,h):(0,o.localize)(29,null,h)):f<P?(h=Math.floor(f/I),v?h===1?C?(0,o.localize)(30,null,h):(0,o.localize)(31,null,h):C?(0,o.localize)(32,null,h):(0,o.localize)(33,null,h):h===1?C?(0,o.localize)(34,null,h):(0,o.localize)(35,null,h):C?(0,o.localize)(36,null,h):(0,o.localize)(37,null,h)):f<S?(h=Math.floor(f/P),v?h===1?C?(0,o.localize)(38,null,h):(0,o.localize)(39,null,h):C?(0,o.localize)(40,null,h):(0,o.localize)(41,null,h):h===1?C?(0,o.localize)(42,null,h):(0,o.localize)(43,null,h):C?(0,o.localize)(44,null,h):(0,o.localize)(45,null,h)):(h=Math.floor(f/S),v?h===1?C?(0,o.localize)(46,null,h):(0,o.localize)(47,null,h):C?(0,o.localize)(48,null,h):(0,o.localize)(49,null,h):h===1?C?(0,o.localize)(50,null,h):(0,o.localize)(51,null,h):C?(0,o.localize)(52,null,h):(0,o.localize)(53,null,h))}e.fromNow=k;function O(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(ye[159],De([17,18]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ye[45],De([1,0,15,9,159]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(T,v){return v&&(T.stack||T.stacktrace)?a.localize(0,null,P(T),I(T.stack)||I(T.stacktrace)):P(T)}function I(T){return Array.isArray(T)?T.join(`
`):T}function P(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?a.localize(1,null,T.message):T.message||a.localize(2,null)}function S(T=null,v=!1){if(!T)return a.localize(3,null);if(Array.isArray(T)){const C=o.coalesce(T),y=S(C[0],v);return C.length>1?a.localize(4,null,y,C.length):y}if(A.isString(T))return T;if(T.detail){const C=T.detail;if(C.error)return R(C.error,v);if(C.exception)return R(C.exception,v)}return T.stack?R(T,v):T.message?T.message:a.localize(5,null)}e.toErrorMessage=S;function k(T){const v=T;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=k;function O(T,v){let C;return typeof T=="string"?C=new Error(T):C=T,C.actions=v,C}e.createErrorWithActions=O}),define(ye[160],De([17,18]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ye[10],De([1,0,160]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let A=!1,a=!1,R=!1,I=!1,P=!1,S=!1,k=!1,O=!1,T=!1,v=!1,C,y=e.LANGUAGE_DEFAULT,f,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const g=typeof u?.versions?.electron=="string",b=g&&u?.type==="renderer";if(typeof navigator=="object"&&!b)h=navigator.userAgent,A=h.indexOf("Windows")>=0,a=h.indexOf("Macintosh")>=0,O=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=h.indexOf("Linux")>=0,v=h?.indexOf("Mobi")>=0,S=!0,C=o.getConfiguredDefaultLocale(o.localize(0,null))||e.LANGUAGE_DEFAULT,y=C;else if(typeof u=="object"){A=u.platform==="win32",a=u.platform==="darwin",R=u.platform==="linux",I=R&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,k=g,T=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT;const i=u.env.VSCODE_NLS_CONFIG;if(i)try{const t=JSON.parse(i),d=t.availableLanguages["*"];C=t.locale,y=d||e.LANGUAGE_DEFAULT,f=t._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var D;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function p(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let n=0;a?n=1:A?n=3:R&&(n=2),e.isWindows=A,e.isMacintosh=a,e.isLinux=R,e.isLinuxSnap=I,e.isNative=P,e.isElectron=k,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=O,e.isMobile=v,e.isCI=T,e.platform=n,e.userAgent=h,e.language=y;var s;(function(i){function t(){return e.language}i.value=t;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=d;function E(){return e.language==="en"}i.isDefault=E})(s=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=f,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const i=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let E=0,w=i.length;E<w;E++){const L=i[E];if(L.id===d.data.vscodeScheduleAsyncWork){i.splice(E,1),L.callback();return}}});let t=0;return d=>{const E=++t;i.push({id:E,callback:d}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return i=>setTimeout(i)})();var r;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=a||O?2:A?1:3;let c=!0,l=!1;function m(){if(!l){l=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,c=new Uint16Array(i.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=m,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ye[36],De([1,0,10]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof o.globals.vscode<"u"&&typeof o.globals.vscode.process<"u"){const a=o.globals.vscode.process;A={get platform(){return a.platform},get arch(){return a.arch},get env(){return a.env},cwd(){return a.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return o.isWindows?"win32":o.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(ye[11],De([1,0,36]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,a=97,R=90,I=122,P=46,S=47,k=92,O=58,T=63;class v extends Error{constructor(s,r,c){let l;typeof r=="string"&&r.indexOf("not ")===0?(l="must not be",r=r.replace(/^not /,"")):l="must be";const m=s.indexOf(".")!==-1?"property":"argument";let i=`The "${s}" ${m} ${l} of type ${r}`;i+=`. Received type ${typeof c}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function C(n,s){if(n===null||typeof n!="object")throw new v(s,"Object",n)}function y(n,s){if(typeof n!="string")throw new v(s,"string",n)}const f=o.platform==="win32";function h(n){return n===S||n===k}function u(n){return n===S}function g(n){return n>=A&&n<=R||n>=a&&n<=I}function b(n,s,r,c){let l="",m=0,i=-1,t=0,d=0;for(let E=0;E<=n.length;++E){if(E<n.length)d=n.charCodeAt(E);else{if(c(d))break;d=S}if(c(d)){if(!(i===E-1||t===1))if(t===2){if(l.length<2||m!==2||l.charCodeAt(l.length-1)!==P||l.charCodeAt(l.length-2)!==P){if(l.length>2){const w=l.lastIndexOf(r);w===-1?(l="",m=0):(l=l.slice(0,w),m=l.length-1-l.lastIndexOf(r)),i=E,t=0;continue}else if(l.length!==0){l="",m=0,i=E,t=0;continue}}s&&(l+=l.length>0?`${r}..`:"..",m=2)}else l.length>0?l+=`${r}${n.slice(i+1,E)}`:l=n.slice(i+1,E),m=E-i-1;i=E,t=0}else d===P&&t!==-1?++t:t=-1}return l}function D(n,s){C(s,"pathObject");const r=s.dir||s.root,c=s.base||`${s.name||""}${s.ext||""}`;return r?r===s.root?`${r}${c}`:`${r}${n}${c}`:c}e.win32={resolve(...n){let s="",r="",c=!1;for(let l=n.length-1;l>=-1;l--){let m;if(l>=0){if(m=n[l],y(m,"path"),m.length===0)continue}else s.length===0?m=o.cwd():(m=o.env[`=${s}`]||o.cwd(),(m===void 0||m.slice(0,2).toLowerCase()!==s.toLowerCase()&&m.charCodeAt(2)===k)&&(m=`${s}\\`));const i=m.length;let t=0,d="",E=!1;const w=m.charCodeAt(0);if(i===1)h(w)&&(t=1,E=!0);else if(h(w))if(E=!0,h(m.charCodeAt(1))){let L=2,q=L;for(;L<i&&!h(m.charCodeAt(L));)L++;if(L<i&&L!==q){const V=m.slice(q,L);for(q=L;L<i&&h(m.charCodeAt(L));)L++;if(L<i&&L!==q){for(q=L;L<i&&!h(m.charCodeAt(L));)L++;(L===i||L!==q)&&(d=`\\\\${V}\\${m.slice(q,L)}`,t=L)}}}else t=1;else g(w)&&m.charCodeAt(1)===O&&(d=m.slice(0,2),t=2,i>2&&h(m.charCodeAt(2))&&(E=!0,t=3));if(d.length>0)if(s.length>0){if(d.toLowerCase()!==s.toLowerCase())continue}else s=d;if(c){if(s.length>0)break}else if(r=`${m.slice(t)}\\${r}`,c=E,E&&s.length>0)break}return r=b(r,!c,"\\",h),c?`${s}\\${r}`:`${s}${r}`||"."},normalize(n){y(n,"path");const s=n.length;if(s===0)return".";let r=0,c,l=!1;const m=n.charCodeAt(0);if(s===1)return u(m)?"\\":n;if(h(m))if(l=!0,h(n.charCodeAt(1))){let t=2,d=t;for(;t<s&&!h(n.charCodeAt(t));)t++;if(t<s&&t!==d){const E=n.slice(d,t);for(d=t;t<s&&h(n.charCodeAt(t));)t++;if(t<s&&t!==d){for(d=t;t<s&&!h(n.charCodeAt(t));)t++;if(t===s)return`\\\\${E}\\${n.slice(d)}\\`;t!==d&&(c=`\\\\${E}\\${n.slice(d,t)}`,r=t)}}}else r=1;else g(m)&&n.charCodeAt(1)===O&&(c=n.slice(0,2),r=2,s>2&&h(n.charCodeAt(2))&&(l=!0,r=3));let i=r<s?b(n.slice(r),!l,"\\",h):"";return i.length===0&&!l&&(i="."),i.length>0&&h(n.charCodeAt(s-1))&&(i+="\\"),c===void 0?l?`\\${i}`:i:l?`${c}\\${i}`:`${c}${i}`},isAbsolute(n){y(n,"path");const s=n.length;if(s===0)return!1;const r=n.charCodeAt(0);return h(r)||s>2&&g(r)&&n.charCodeAt(1)===O&&h(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,r;for(let m=0;m<n.length;++m){const i=n[m];y(i,"path"),i.length>0&&(s===void 0?s=r=i:s+=`\\${i}`)}if(s===void 0)return".";let c=!0,l=0;if(typeof r=="string"&&h(r.charCodeAt(0))){++l;const m=r.length;m>1&&h(r.charCodeAt(1))&&(++l,m>2&&(h(r.charCodeAt(2))?++l:c=!1))}if(c){for(;l<s.length&&h(s.charCodeAt(l));)l++;l>=2&&(s=`\\${s.slice(l)}`)}return e.win32.normalize(s)},relative(n,s){if(y(n,"from"),y(s,"to"),n===s)return"";const r=e.win32.resolve(n),c=e.win32.resolve(s);if(r===c||(n=r.toLowerCase(),s=c.toLowerCase(),n===s))return"";let l=0;for(;l<n.length&&n.charCodeAt(l)===k;)l++;let m=n.length;for(;m-1>l&&n.charCodeAt(m-1)===k;)m--;const i=m-l;let t=0;for(;t<s.length&&s.charCodeAt(t)===k;)t++;let d=s.length;for(;d-1>t&&s.charCodeAt(d-1)===k;)d--;const E=d-t,w=i<E?i:E;let L=-1,q=0;for(;q<w;q++){const M=n.charCodeAt(l+q);if(M!==s.charCodeAt(t+q))break;M===k&&(L=q)}if(q!==w){if(L===-1)return c}else{if(E>w){if(s.charCodeAt(t+q)===k)return c.slice(t+q+1);if(q===2)return c.slice(t+q)}i>w&&(n.charCodeAt(l+q)===k?L=q:q===2&&(L=3)),L===-1&&(L=0)}let V="";for(q=l+L+1;q<=m;++q)(q===m||n.charCodeAt(q)===k)&&(V+=V.length===0?"..":"\\..");return t+=L,V.length>0?`${V}${c.slice(t,d)}`:(c.charCodeAt(t)===k&&++t,c.slice(t,d))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=e.win32.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===k){if(s.charCodeAt(1)===k){const r=s.charCodeAt(2);if(r!==T&&r!==P)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(g(s.charCodeAt(0))&&s.charCodeAt(1)===O&&s.charCodeAt(2)===k)return`\\\\?\\${s}`;return n},dirname(n){y(n,"path");const s=n.length;if(s===0)return".";let r=-1,c=0;const l=n.charCodeAt(0);if(s===1)return h(l)?n:".";if(h(l)){if(r=c=1,h(n.charCodeAt(1))){let t=2,d=t;for(;t<s&&!h(n.charCodeAt(t));)t++;if(t<s&&t!==d){for(d=t;t<s&&h(n.charCodeAt(t));)t++;if(t<s&&t!==d){for(d=t;t<s&&!h(n.charCodeAt(t));)t++;if(t===s)return n;t!==d&&(r=c=t+1)}}}}else g(l)&&n.charCodeAt(1)===O&&(r=s>2&&h(n.charCodeAt(2))?3:2,c=r);let m=-1,i=!0;for(let t=s-1;t>=c;--t)if(h(n.charCodeAt(t))){if(!i){m=t;break}}else i=!1;if(m===-1){if(r===-1)return".";m=r}return n.slice(0,m)},basename(n,s){s!==void 0&&y(s,"ext"),y(n,"path");let r=0,c=-1,l=!0,m;if(n.length>=2&&g(n.charCodeAt(0))&&n.charCodeAt(1)===O&&(r=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let i=s.length-1,t=-1;for(m=n.length-1;m>=r;--m){const d=n.charCodeAt(m);if(h(d)){if(!l){r=m+1;break}}else t===-1&&(l=!1,t=m+1),i>=0&&(d===s.charCodeAt(i)?--i===-1&&(c=m):(i=-1,c=t))}return r===c?c=t:c===-1&&(c=n.length),n.slice(r,c)}for(m=n.length-1;m>=r;--m)if(h(n.charCodeAt(m))){if(!l){r=m+1;break}}else c===-1&&(l=!1,c=m+1);return c===-1?"":n.slice(r,c)},extname(n){y(n,"path");let s=0,r=-1,c=0,l=-1,m=!0,i=0;n.length>=2&&n.charCodeAt(1)===O&&g(n.charCodeAt(0))&&(s=c=2);for(let t=n.length-1;t>=s;--t){const d=n.charCodeAt(t);if(h(d)){if(!m){c=t+1;break}continue}l===-1&&(m=!1,l=t+1),d===P?r===-1?r=t:i!==1&&(i=1):r!==-1&&(i=-1)}return r===-1||l===-1||i===0||i===1&&r===l-1&&r===c+1?"":n.slice(r,l)},format:D.bind(null,"\\"),parse(n){y(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const r=n.length;let c=0,l=n.charCodeAt(0);if(r===1)return h(l)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(h(l)){if(c=1,h(n.charCodeAt(1))){let L=2,q=L;for(;L<r&&!h(n.charCodeAt(L));)L++;if(L<r&&L!==q){for(q=L;L<r&&h(n.charCodeAt(L));)L++;if(L<r&&L!==q){for(q=L;L<r&&!h(n.charCodeAt(L));)L++;L===r?c=L:L!==q&&(c=L+1)}}}}else if(g(l)&&n.charCodeAt(1)===O){if(r<=2)return s.root=s.dir=n,s;if(c=2,h(n.charCodeAt(2))){if(r===3)return s.root=s.dir=n,s;c=3}}c>0&&(s.root=n.slice(0,c));let m=-1,i=c,t=-1,d=!0,E=n.length-1,w=0;for(;E>=c;--E){if(l=n.charCodeAt(E),h(l)){if(!d){i=E+1;break}continue}t===-1&&(d=!1,t=E+1),l===P?m===-1?m=E:w!==1&&(w=1):m!==-1&&(w=-1)}return t!==-1&&(m===-1||w===0||w===1&&m===t-1&&m===i+1?s.base=s.name=n.slice(i,t):(s.name=n.slice(i,m),s.base=n.slice(i,t),s.ext=n.slice(m,t))),i>0&&i!==c?s.dir=n.slice(0,i-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(f){const n=/\\/g;return()=>{const s=o.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>o.cwd()})();e.posix={resolve(...n){let s="",r=!1;for(let c=n.length-1;c>=-1&&!r;c--){const l=c>=0?n[c]:p();y(l,"path"),l.length!==0&&(s=`${l}/${s}`,r=l.charCodeAt(0)===S)}return s=b(s,!r,"/",u),r?`/${s}`:s.length>0?s:"."},normalize(n){if(y(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===S,r=n.charCodeAt(n.length-1)===S;return n=b(n,!s,"/",u),n.length===0?s?"/":r?"./":".":(r&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return y(n,"path"),n.length>0&&n.charCodeAt(0)===S},join(...n){if(n.length===0)return".";let s;for(let r=0;r<n.length;++r){const c=n[r];y(c,"path"),c.length>0&&(s===void 0?s=c:s+=`/${c}`)}return s===void 0?".":e.posix.normalize(s)},relative(n,s){if(y(n,"from"),y(s,"to"),n===s||(n=e.posix.resolve(n),s=e.posix.resolve(s),n===s))return"";const r=1,c=n.length,l=c-r,m=1,i=s.length-m,t=l<i?l:i;let d=-1,E=0;for(;E<t;E++){const L=n.charCodeAt(r+E);if(L!==s.charCodeAt(m+E))break;L===S&&(d=E)}if(E===t)if(i>t){if(s.charCodeAt(m+E)===S)return s.slice(m+E+1);if(E===0)return s.slice(m+E)}else l>t&&(n.charCodeAt(r+E)===S?d=E:E===0&&(d=0));let w="";for(E=r+d+1;E<=c;++E)(E===c||n.charCodeAt(E)===S)&&(w+=w.length===0?"..":"/..");return`${w}${s.slice(m+d)}`},toNamespacedPath(n){return n},dirname(n){if(y(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===S;let r=-1,c=!0;for(let l=n.length-1;l>=1;--l)if(n.charCodeAt(l)===S){if(!c){r=l;break}}else c=!1;return r===-1?s?"/":".":s&&r===1?"//":n.slice(0,r)},basename(n,s){s!==void 0&&y(s,"ext"),y(n,"path");let r=0,c=-1,l=!0,m;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let i=s.length-1,t=-1;for(m=n.length-1;m>=0;--m){const d=n.charCodeAt(m);if(d===S){if(!l){r=m+1;break}}else t===-1&&(l=!1,t=m+1),i>=0&&(d===s.charCodeAt(i)?--i===-1&&(c=m):(i=-1,c=t))}return r===c?c=t:c===-1&&(c=n.length),n.slice(r,c)}for(m=n.length-1;m>=0;--m)if(n.charCodeAt(m)===S){if(!l){r=m+1;break}}else c===-1&&(l=!1,c=m+1);return c===-1?"":n.slice(r,c)},extname(n){y(n,"path");let s=-1,r=0,c=-1,l=!0,m=0;for(let i=n.length-1;i>=0;--i){const t=n.charCodeAt(i);if(t===S){if(!l){r=i+1;break}continue}c===-1&&(l=!1,c=i+1),t===P?s===-1?s=i:m!==1&&(m=1):s!==-1&&(m=-1)}return s===-1||c===-1||m===0||m===1&&s===c-1&&s===r+1?"":n.slice(s,c)},format:D.bind(null,"/"),parse(n){y(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const r=n.charCodeAt(0)===S;let c;r?(s.root="/",c=1):c=0;let l=-1,m=0,i=-1,t=!0,d=n.length-1,E=0;for(;d>=c;--d){const w=n.charCodeAt(d);if(w===S){if(!t){m=d+1;break}continue}i===-1&&(t=!1,i=d+1),w===P?l===-1?l=d:E!==1&&(E=1):l!==-1&&(E=-1)}if(i!==-1){const w=m===0&&r?1:m;l===-1||E===0||E===1&&l===i-1&&l===m+1?s.base=s.name=n.slice(w,i):(s.name=n.slice(w,l),s.base=n.slice(w,i),s.ext=n.slice(l,i))}return m>0?s.dir=n.slice(0,m-1):r&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f?e.win32.normalize:e.posix.normalize,e.isAbsolute=f?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f?e.win32.join:e.posix.join,e.resolve=f?e.win32.resolve:e.posix.resolve,e.relative=f?e.win32.relative:e.posix.relative,e.dirname=f?e.win32.dirname:e.posix.dirname,e.basename=f?e.win32.basename:e.posix.basename,e.extname=f?e.win32.extname:e.posix.extname,e.format=f?e.win32.format:e.posix.format,e.parse=f?e.win32.parse:e.posix.parse,e.toNamespacedPath=f?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f?e.win32.sep:e.posix.sep,e.delimiter=f?e.win32.delimiter:e.posix.delimiter}),define(ye[108],De([1,0,65,11]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const a=new o.Lazy(()=>{const t=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:t,collatorIsNumeric:t.resolvedOptions().numeric}}),R=new o.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new o.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(t,d,E=!1){const w=t||"",L=d||"",q=a.value.collator.compare(w,L);return a.value.collatorIsNumeric&&q===0&&w!==L?w<L?-1:1:q}e.compareFileNames=P;function S(t,d){const E=R.value.collator;return t=t||"",d=d||"",D(E,t,d)}e.compareFileNamesDefault=S;function k(t,d){const E=R.value.collator;return t=t||"",d=d||"",r(t,d)||D(E,t,d)}e.compareFileNamesUpper=k;function O(t,d){const E=R.value.collator;return t=t||"",d=d||"",s(t,d)||D(E,t,d)}e.compareFileNamesLower=O;function T(t,d){return t=t||"",d=d||"",t===d?0:t<d?-1:1}e.compareFileNamesUnicode=T;function v(t,d){const[E,w]=g(t),[L,q]=g(d);let V=a.value.collator.compare(w,q);if(V===0){if(a.value.collatorIsNumeric&&w!==q)return w<q?-1:1;if(V=a.value.collator.compare(E,L),a.value.collatorIsNumeric&&V===0&&E!==L)return E<L?-1:1}return V}e.compareFileExtensions=v;function C(t,d){t=t||"",d=d||"";const E=b(t),w=b(d),L=R.value.collator,q=I.value.collator;return D(q,E,w)||D(L,t,d)}e.compareFileExtensionsDefault=C;function y(t,d){t=t||"",d=d||"";const E=b(t),w=b(d),L=R.value.collator,q=I.value.collator;return D(q,E,w)||r(t,d)||D(L,t,d)}e.compareFileExtensionsUpper=y;function f(t,d){t=t||"",d=d||"";const E=b(t),w=b(d),L=R.value.collator,q=I.value.collator;return D(q,E,w)||s(t,d)||D(L,t,d)}e.compareFileExtensionsLower=f;function h(t,d){t=t||"",d=d||"";const E=b(t).toLowerCase(),w=b(d).toLowerCase();return E!==w?E<w?-1:1:t!==d?t<d?-1:1:0}e.compareFileExtensionsUnicode=h;const u=/^(.*?)(\.([^.]*))?$/;function g(t,d=!1){const E=t?u.exec(t):[];let w=[E&&E[1]||"",E&&E[3]||""];return d&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function b(t){const d=t?u.exec(t):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function D(t,d,E){const w=t.compare(d,E);return w!==0?w:d.length!==E.length?d.length<E.length?-1:1:0}function p(t){const d=t.charAt(0);return d.toLocaleUpperCase()!==d}function n(t){const d=t.charAt(0);return d.toLocaleLowerCase()!==d}function s(t,d){return p(t)&&n(d)?-1:n(t)&&p(d)?1:0}function r(t,d){return n(t)&&p(d)?-1:p(t)&&n(d)?1:0}function c(t,d,E=!1){return E||(t=t&&t.toLowerCase(),d=d&&d.toLowerCase()),t===d?0:t<d?-1:1}function l(t,d,E=!1){const w=t.split(A.sep),L=d.split(A.sep),q=w.length-1,V=L.length-1;let M,B;for(let N=0;;N++){if(M=q===N,B=V===N,M&&B)return P(w[N],L[N],E);if(M)return-1;if(B)return 1;const U=c(w[N],L[N],E);if(U!==0)return U}}e.comparePaths=l;function m(t,d,E){const w=t.toLowerCase(),L=d.toLowerCase(),q=i(t,d,E);if(q)return q;const V=w.endsWith(E),M=L.endsWith(E);if(V!==M)return V?-1:1;const B=P(w,L);return B!==0?B:w.localeCompare(L)}e.compareAnything=m;function i(t,d,E){const w=t.toLowerCase(),L=d.toLowerCase(),q=w.startsWith(E),V=L.startsWith(E);if(q!==V)return q?-1:1;if(q&&V){if(w.length<L.length)return-1;if(w.length>L.length)return 1}return 0}e.compareByPrefix=i}),define(ye[87],De([1,0,11]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},a={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(O){const T=(0,o.extname)(O),v=A[T.toLowerCase()];return v!==void 0?v:I(O)}e.getMediaOrTextMime=R;function I(O){const T=(0,o.extname)(O);return a[T.toLowerCase()]}e.getMediaMime=I;function P(O){for(const T in a)if(a[T]===O)return T}e.getExtensionForMimeType=P;const S=/^(.+)\/(.+?)(;.+)?$/;function k(O,T){const v=S.exec(O);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:T?void 0:O}e.normalizeMimeType=k}),define(ye[109],De([1,0,10]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var a;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(a=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(P,...S){const k=S.reduce((v,C)=>(v[C]=!0,v),{}),O=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(v=>!k[v]).forEach(v=>{for(let C=0;C<O.length;C++)if(v.search(O[C])!==-1){delete P[v];break}})}e.sanitizeProcessEnvironment=R;function I(P){!P||(delete P.DEBUG,o.isMacintosh&&delete P.DYLD_LIBRARY_PATH,o.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=I}),define(ye[43],De([1,0,10]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=o.globals.performance&&typeof o.globals.performance.now=="function";class a{static create(I=!0){return new a(I)}constructor(I){this.a=A&&I,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?o.globals.performance.now():Date.now()}}e.StopWatch=a}),define(ye[3],De([1,0,12,63,6,66,43]),function(ne,e,o,A,a,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,S=!1;var k;(function(m){m.None=()=>a.Disposable.None;function i(ve){if(S){const{onDidAddListener:Ie}=ve,Re=y.create();let oe=0;ve.onDidAddListener=()=>{++oe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Re.print()),Ie?.()}}}function t(ve,Ie){return N(ve,()=>{},0,void 0,!0,void 0,Ie)}m.defer=t;function d(ve){return(Ie,Re=null,oe)=>{let le=!1,ue;return ue=ve(te=>{if(!le)return ue?ue.dispose():le=!0,Ie.call(Re,te)},null,oe),le&&ue.dispose(),ue}}m.once=d;function E(ve,Ie,Re){return B((oe,le=null,ue)=>ve(te=>oe.call(le,Ie(te)),null,ue),Re)}m.map=E;function w(ve,Ie,Re){return B((oe,le=null,ue)=>ve(te=>{Ie(te),oe.call(le,te)},null,ue),Re)}m.forEach=w;function L(ve,Ie,Re){return B((oe,le=null,ue)=>ve(te=>Ie(te)&&oe.call(le,te),null,ue),Re)}m.filter=L;function q(ve){return ve}m.signal=q;function V(...ve){return(Ie,Re=null,oe)=>(0,a.combinedDisposable)(...ve.map(le=>le(ue=>Ie.call(Re,ue),null,oe)))}m.any=V;function M(ve,Ie,Re,oe){let le=Re;return E(ve,ue=>(le=Ie(le,ue),le),oe)}m.reduce=M;function B(ve,Ie){let Re;const oe={onWillAddFirstListener(){Re=ve(le.fire,le)},onDidRemoveLastListener(){Re?.dispose()}};Ie||i(oe);const le=new h(oe);return Ie?.add(le),le.event}function N(ve,Ie,Re=100,oe=!1,le=!1,ue,te){let ce,se,F,H=0,K;const _={leakWarningThreshold:ue,onWillAddFirstListener(){ce=ve(we=>{H++,se=Ie(se,we),oe&&!F&&(de.fire(se),se=void 0),K=()=>{const Pe=se;se=void 0,F=void 0,(!oe||H>1)&&de.fire(Pe),H=0},typeof Re=="number"?(clearTimeout(F),F=setTimeout(K,Re)):F===void 0&&(F=0,queueMicrotask(K))})},onWillRemoveListener(){le&&H>0&&K?.()},onDidRemoveLastListener(){K=void 0,ce.dispose()}};te||i(_);const de=new h(_);return te?.add(de),de.event}m.debounce=N;function U(ve,Ie=0,Re){return m.debounce(ve,(oe,le)=>oe?(oe.push(le),oe):[le],Ie,void 0,!0,void 0,Re)}m.accumulate=U;function $(ve,Ie=(oe,le)=>oe===le,Re){let oe=!0,le;return L(ve,ue=>{const te=oe||!Ie(ue,le);return oe=!1,le=ue,te},Re)}m.latch=$;function z(ve,Ie,Re){return[m.filter(ve,Ie,Re),m.filter(ve,oe=>!Ie(oe),Re)]}m.split=z;function ae(ve,Ie=!1,Re=[]){let oe=Re.slice(),le=ve(ce=>{oe?oe.push(ce):te.fire(ce)});const ue=()=>{oe?.forEach(ce=>te.fire(ce)),oe=null},te=new h({onWillAddFirstListener(){le||(le=ve(ce=>te.fire(ce)))},onDidAddFirstListener(){oe&&(Ie?setTimeout(ue):ue())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return te.event}m.buffer=ae;class ee{constructor(Ie){this.event=Ie,this.c=new a.DisposableStore}map(Ie){return new ee(E(this.event,Ie,this.c))}forEach(Ie){return new ee(w(this.event,Ie,this.c))}filter(Ie){return new ee(L(this.event,Ie,this.c))}reduce(Ie,Re){return new ee(M(this.event,Ie,Re,this.c))}latch(){return new ee($(this.event,void 0,this.c))}debounce(Ie,Re=100,oe=!1,le=!1,ue){return new ee(N(this.event,Ie,Re,oe,le,ue,this.c))}on(Ie,Re,oe){return this.event(Ie,Re,oe)}once(Ie,Re,oe){return d(this.event)(Ie,Re,oe)}dispose(){this.c.dispose()}}function x(ve){return new ee(ve)}m.chain=x;function J(ve,Ie,Re=oe=>oe){const oe=(...ce)=>te.fire(Re(...ce)),le=()=>ve.on(Ie,oe),ue=()=>ve.removeListener(Ie,oe),te=new h({onWillAddFirstListener:le,onDidRemoveLastListener:ue});return te.event}m.fromNodeEventEmitter=J;function ie(ve,Ie,Re=oe=>oe){const oe=(...ce)=>te.fire(Re(...ce)),le=()=>ve.addEventListener(Ie,oe),ue=()=>ve.removeEventListener(Ie,oe),te=new h({onWillAddFirstListener:le,onDidRemoveLastListener:ue});return te.event}m.fromDOMEventEmitter=ie;function pe(ve){return new Promise(Ie=>d(ve)(Ie))}m.toPromise=pe;function Q(ve,Ie){return Ie(void 0),ve(Re=>Ie(Re))}m.runAndSubscribe=Q;function Y(ve,Ie){let Re=null;function oe(ue){Re?.dispose(),Re=new a.DisposableStore,Ie(ue,Re)}oe(void 0);const le=ve(ue=>oe(ue));return(0,a.toDisposable)(()=>{le.dispose(),Re?.dispose()})}m.runAndSubscribeWithStore=Y;class Z{constructor(Ie,Re){this.obs=Ie,this.c=0,this.d=!1;const oe={onWillAddFirstListener:()=>{Ie.addObserver(this)},onDidRemoveLastListener:()=>{Ie.removeObserver(this)}};Re||i(oe),this.emitter=new h(oe),Re&&Re.add(this.emitter)}beginUpdate(Ie){this.c++}handleChange(Ie,Re){this.d=!0}endUpdate(Ie){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function me(ve,Ie){return new Z(ve,Ie).emitter.event}m.fromObservable=me})(k=e.Event||(e.Event={}));class O{constructor(i){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${i}_${O.c++}`,O.all.add(this)}start(i){this.d=new I.StopWatch(!0),this.listenerCount=i}stop(){if(this.d){const i=this.d.elapsed();this.durations.push(i),this.elapsedOverall+=i,this.invocationCount+=1,this.d=void 0}}}O.all=new Set,O.c=0,e.EventProfiling=O;let T=-1;function v(m){const i=T;return T=m,{dispose(){T=i}}}e.setGlobalLeakWarningThreshold=v;class C{constructor(i,t=Math.random().toString(18).slice(2,5)){this.threshold=i,this.name=t,this.d=0}dispose(){this.c?.clear()}check(i,t){const d=this.threshold;if(d<=0||t<d)return;this.c||(this.c=new Map);const E=this.c.get(i.value)||0;if(this.c.set(i.value,E+1),this.d-=1,this.d<=0){this.d=d*.5;let w,L=0;for(const[q,V]of this.c)(!w||L<V)&&(w=q,L=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${t} listeners already. MOST frequent listener (${L}):`),console.warn(w)}return()=>{const w=this.c.get(i.value)||0;this.c.set(i.value,w-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(i){this.value=i}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f{constructor(i,t,d){this.callback=i,this.callbackThis=t,this.stack=d,this.subscription=new a.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class h{constructor(i){this.j=!1,this.d=i,this.f=T>0||this.d?.leakWarningThreshold?new C(this.d?.leakWarningThreshold??T):void 0,this.g=this.d?._profName?new O(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const i=Array.from(this.q);queueMicrotask(()=>{for(const t of i)t.subscription.isset()&&(t.subscription.unset(),t.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(i,t,d)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),a.Disposable.None;const E=this.q.isEmpty();E&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let w,L;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(L=y.create(),w=this.f.check(L,this.q.size+1)),P&&(L=L??y.create());const q=new f(i,t,L),V=this.q.push(q);E&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,i,t);const M=q.subscription.set(()=>{w?.(),this.j||(this.d?.onWillRemoveListener?.(this),V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return d instanceof a.DisposableStore?d.add(M):Array.isArray(d)&&d.push(M),M}),this.l}fire(i){if(this.q){this.m||(this.m=new g);for(const t of this.q)this.m.push(this,t,i);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=h;class u{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(i,t,d){this.c.push(new b(i,t,d))}clear(i){const t=new R.LinkedList;for(const d of this.c)d.emitter!==i&&t.push(d);this.c=t}deliver(){for(;this.c.size>0;){const i=this.c.shift();try{i.listener.invoke(i.event)}catch(t){(0,o.onUnexpectedError)(t)}}}}e.EventDeliveryQueue=u;class g extends u{clear(i){this.c.clear()}}class b{constructor(i,t,d){this.emitter=i,this.listener=t,this.event=d}}class D extends h{async fireAsync(i,t,d){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const E of this.q)this.c.push([E,i]);for(;this.c.size>0&&!t.isCancellationRequested;){const[E,w]=this.c.shift(),L=[],q={...w,token:t,waitUntil:V=>{if(Object.isFrozen(L))throw new Error("waitUntil can NOT be called asynchronous");d&&(V=d(V,E.callback)),L.push(V)}};try{E.invoke(q)}catch(V){(0,o.onUnexpectedError)(V);continue}Object.freeze(L),await Promise.allSettled(L).then(V=>{for(const M of V)M.status==="rejected"&&(0,o.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=D;class p extends h{constructor(i){super(i),this.h=0,this.s=new R.LinkedList,this.t=i?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const i=Array.from(this.s);this.s.clear(),super.fire(this.t(i))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(i){this.q&&(this.h!==0?this.s.push(i):super.fire(i))}}e.PauseableEmitter=p;class n extends p{constructor(i){super(i),this.c=i.delay??100}fire(i){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(i)}}e.DebounceEmitter=n;class s extends h{constructor(i){super(i),this.c=[],this.h=i?.merge}fire(i){!this.hasListeners()||(this.c.push(i),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(t=>super.fire(t)),this.c=[]}))}}e.MicrotaskEmitter=s;class r{constructor(){this.d=!1,this.f=[],this.c=new h({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(i){const t={event:i,listener:null};this.f.push(t),this.d&&this.j(t);const d=()=>{this.d&&this.k(t);const E=this.f.indexOf(t);this.f.splice(E,1)};return(0,a.toDisposable)((0,A.once)(d))}g(){this.d=!0,this.f.forEach(i=>this.j(i))}h(){this.d=!1,this.f.forEach(i=>this.k(i))}j(i){i.listener=i.event(t=>this.c.fire(t))}k(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=r;class c{constructor(){this.c=[]}wrapEvent(i){return(t,d,E)=>i(w=>{const L=this.c[this.c.length-1];L?L.push(()=>t.call(d,w)):t.call(d,w)},void 0,E)}bufferEvents(i){const t=[];this.c.push(t);const d=i();return this.c.pop(),t.forEach(E=>E()),d}}e.EventBufferer=c;class l{constructor(){this.c=!1,this.d=k.None,this.f=a.Disposable.None,this.g=new h({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(i){this.d=i,this.c&&(this.f.dispose(),this.f=i(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=l}),define(ye[161],De([1,0,3,6,156]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends A.Disposable{constructor(v,C="",y="",f=!0,h){super(),this.h=this.B(new o.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=C,this.u=y,this.w=f,this.C=h}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,C){this.C&&await this.C(v)}}e.Action=R;class I extends A.Disposable{constructor(){super(...arguments),this.f=this.B(new o.Emitter),this.onWillRun=this.f.event,this.h=this.B(new o.Emitter),this.onDidRun=this.h.event}async run(v,C){if(!v.enabled)return;this.f.fire({action:v});let y;try{await this.runAction(v,C)}catch(f){y=f}this.h.fire({action:v,error:y})}async runAction(v,C){await v.run(C)}}e.ActionRunner=I;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let C=[];for(const y of v)y.length&&(C.length?C=[...C,new P,...y]:C=y);return C}async run(){}}P.ID="vs.actions.separator",e.Separator=P;class S{get actions(){return this.a}constructor(v,C,y,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=C,this.class=f,this.a=y}async run(){}}e.SubmenuAction=S;class k extends R{constructor(){super(k.ID,a.localize(0,null),void 0,!1)}}k.ID="vs.actions.empty",e.EmptySubmenuAction=k;function O(T){return{id:T.id,label:T.label,class:void 0,enabled:T.enabled??!0,checked:T.checked??!1,run:async()=>T.run(),tooltip:T.label}}e.toAction=O}),define(ye[21],De([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(P,S){const k=setTimeout(P.bind(S),0);return{dispose(){clearTimeout(k)}}});var a;(function(P){function S(k){return k===P.None||k===P.Cancelled||k instanceof R?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}P.isCancellationToken=S,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:o.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(a=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new o.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(S){this.a=void 0,this.b=void 0,this.b=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=a.Cancelled}dispose(S=!1){S&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=a.None}}e.CancellationTokenSource=I}),define(ye[162],De([1,0,21]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new o.CancellationTokenSource,S=this.b(P.token);return this.a={promise:S,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=A;class a{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const S=JSON.stringify(P);return this.b!==S&&(this.b=S,this.a=this.c(P)),this.a}}e.LRUCachedFunction=a;class R{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const S=this.b(P);return this.a.set(P,S),S}}e.CachedFunction=R}),define(ye[8],De([1,0,162,65]),function(ne,e,o,A){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=R;const I=/{(\d+)}/g;function P(W,...X){return X.length===0?W:W.replace(I,function(he,Le){const Ne=parseInt(Le,10);return isNaN(Ne)||Ne<0||Ne>=X.length?he:X[Ne]})}e.format=P;const S=/{([^}]+)}/g;function k(W,X){return W.replace(S,(he,Le)=>X[Le]??he)}e.format2=k;function O(W){return W.replace(/[<>&]/g,function(X){switch(X){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return X}})}e.escape=O;function T(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=T;function v(W,X){let he=0;const Le=X.charCodeAt(0);for(let Ne=W.length-1;Ne>=0;Ne--)W.charCodeAt(Ne)===Le&&he++;return he}e.count=v;function C(W,X,he="\u2026"){return W.length<=X?W:`${W.substr(0,X)}${he}`}e.truncate=C;function y(W,X=" "){const he=f(W,X);return h(he,X)}e.trim=y;function f(W,X){if(!W||!X)return W;const he=X.length;if(he===0||W.length===0)return W;let Le=0;for(;W.indexOf(X,Le)===Le;)Le=Le+he;return W.substring(Le)}e.ltrim=f;function h(W,X){if(!W||!X)return W;const he=X.length,Le=W.length;if(he===0||Le===0)return W;let Ne=Le,qe=-1;for(;qe=W.lastIndexOf(X,Ne-1),!(qe===-1||qe+he!==Ne);){if(qe===0)return"";Ne=qe}return W.substring(0,Ne)}e.rtrim=h;function u(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function g(W){return W.replace(/\*/g,"")}e.stripWildcards=g;function b(W,X,he={}){if(!W)throw new Error("Cannot create regex from empty string");X||(W=T(W)),he.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let Le="";return he.global&&(Le+="g"),he.matchCase||(Le+="i"),he.multiline&&(Le+="m"),he.unicode&&(Le+="u"),new RegExp(W,Le)}e.createRegExp=b;function D(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=D;function p(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function n(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=n;function s(W){return W.split(/\r\n|\r|\n/)}e.splitLines=s;function r(W){for(let X=0,he=W.length;X<he;X++){const Le=W.charCodeAt(X);if(Le!==32&&Le!==9)return X}return-1}e.firstNonWhitespaceIndex=r;function c(W,X=0,he=W.length){for(let Le=X;Le<he;Le++){const Ne=W.charCodeAt(Le);if(Ne!==32&&Ne!==9)return W.substring(X,Le)}return W.substring(X,he)}e.getLeadingWhitespace=c;function l(W,X=W.length-1){for(let he=X;he>=0;he--){const Le=W.charCodeAt(he);if(Le!==32&&Le!==9)return he}return-1}e.lastNonWhitespaceIndex=l;function m(W,X,he){const Le=[];let Ne=0;for(const qe of W.matchAll(X)){if(Le.push(W.slice(Ne,qe.index)),qe.index===void 0)throw new Error("match.index should be defined");Ne=qe.index+qe[0].length,Le.push(he(qe[0],...qe.slice(1),qe.index,W,qe.groups))}return Le.push(W.slice(Ne)),Promise.all(Le).then(qe=>qe.join(""))}e.replaceAsync=m;function i(W,X){return W<X?-1:W>X?1:0}e.compare=i;function t(W,X,he=0,Le=W.length,Ne=0,qe=X.length){for(;he<Le&&Ne<qe;he++,Ne++){const st=W.charCodeAt(he),at=X.charCodeAt(Ne);if(st<at)return-1;if(st>at)return 1}const je=Le-he,Ze=qe-Ne;return je<Ze?-1:je>Ze?1:0}e.compareSubstring=t;function d(W,X){return E(W,X,0,W.length,0,X.length)}e.compareIgnoreCase=d;function E(W,X,he=0,Le=W.length,Ne=0,qe=X.length){for(;he<Le&&Ne<qe;he++,Ne++){let st=W.charCodeAt(he),at=X.charCodeAt(Ne);if(st===at)continue;if(st>=128||at>=128)return t(W.toLowerCase(),X.toLowerCase(),he,Le,Ne,qe);L(st)&&(st-=32),L(at)&&(at-=32);const mt=st-at;if(mt!==0)return mt}const je=Le-he,Ze=qe-Ne;return je<Ze?-1:je>Ze?1:0}e.compareSubstringIgnoreCase=E;function w(W){return W>=48&&W<=57}e.isAsciiDigit=w;function L(W){return W>=97&&W<=122}e.isLowerAsciiLetter=L;function q(W){return W>=65&&W<=90}e.isUpperAsciiLetter=q;function V(W,X){return W.length===X.length&&E(W,X)===0}e.equalsIgnoreCase=V;function M(W,X){const he=X.length;return X.length>W.length?!1:E(W,X,0,he)===0}e.startsWithIgnoreCase=M;function B(W,X){const he=Math.min(W.length,X.length);let Le;for(Le=0;Le<he;Le++)if(W.charCodeAt(Le)!==X.charCodeAt(Le))return Le;return he}e.commonPrefixLength=B;function N(W,X){const he=Math.min(W.length,X.length);let Le;const Ne=W.length-1,qe=X.length-1;for(Le=0;Le<he;Le++)if(W.charCodeAt(Ne-Le)!==X.charCodeAt(qe-Le))return Le;return he}e.commonSuffixLength=N;function U(W){return 55296<=W&&W<=56319}e.isHighSurrogate=U;function $(W){return 56320<=W&&W<=57343}e.isLowSurrogate=$;function z(W,X){return(W-55296<<10)+(X-56320)+65536}e.computeCodePoint=z;function ae(W,X,he){const Le=W.charCodeAt(he);if(U(Le)&&he+1<X){const Ne=W.charCodeAt(he+1);if($(Ne))return z(Le,Ne)}return Le}e.getNextCodePoint=ae;function ee(W,X){const he=W.charCodeAt(X-1);if($(he)&&X>1){const Le=W.charCodeAt(X-2);if(U(Le))return z(Le,he)}return he}class x{get offset(){return this.e}constructor(X,he=0){this.c=X,this.d=X.length,this.e=he}setOffset(X){this.e=X}prevCodePoint(){const X=ee(this.c,this.e);return this.e-=X>=65536?2:1,X}nextCodePoint(){const X=ae(this.c,this.d,this.e);return this.e+=X>=65536?2:1,X}eol(){return this.e>=this.d}}e.CodePointIterator=x;class J{get offset(){return this.c.offset}constructor(X,he=0){this.c=new x(X,he)}nextGraphemeLength(){const X=He.getInstance(),he=this.c,Le=he.offset;let Ne=X.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const qe=he.offset,je=X.getGraphemeBreakType(he.nextCodePoint());if(Ce(Ne,je)){he.setOffset(qe);break}Ne=je}return he.offset-Le}prevGraphemeLength(){const X=He.getInstance(),he=this.c,Le=he.offset;let Ne=X.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const qe=he.offset,je=X.getGraphemeBreakType(he.prevCodePoint());if(Ce(je,Ne)){he.setOffset(qe);break}Ne=je}return Le-he.offset}eol(){return this.c.eol()}}e.GraphemeIterator=J;function ie(W,X){return new J(W,X).nextGraphemeLength()}e.nextCharLength=ie;function pe(W,X){return new J(W,X).prevGraphemeLength()}e.prevCharLength=pe;function Q(W,X){X>0&&$(W.charCodeAt(X))&&X--;const he=X+ie(W,X);return[he-pe(W,he),he]}e.getCharContainingOffset=Q;function Y(W){const X=new J(W);let he=0;for(;!X.eol();)he++,X.nextGraphemeLength();return he}e.charCount=Y;let Z;function me(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve(W){return Z||(Z=me()),Z.test(W)}e.containsRTL=ve;const Ie=/^[\t\n\r\x20-\x7E]*$/;function Re(W){return Ie.test(W)}e.isBasicASCII=Re,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=oe;function le(W){return W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=le;function ue(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129008||W>=129280&&W<=129535||W>=129648&&W<=129782}e.isEmojiImprecise=ue;function te(W,X){if(W.length<X)return W;const he=/\b/g;let Le=0;for(;he.test(W)&&!(W.length-he.lastIndex<X);)Le=he.lastIndex,he.lastIndex+=1;return W.substring(Le).replace(/^\s/,"")}e.lcut=te;const ce=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function se(W){return W&&(W=W.replace(ce,"")),W}e.removeAnsiEscapeCodes=se,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function F(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=F;function H(W){return F(W)?W.substr(1):W}e.stripUTF8BOM=H;function K(W,X){if(!W||!X||W.length<X.length)return!1;const he=X.length,Le=W.toLowerCase();let Ne=0,qe=-1;for(;Ne<he;){const je=Le.indexOf(X[Ne],qe+1);if(je<0)return!1;qe=je,Ne++}return!0}e.fuzzyContains=K;function _(W,X=!1){return W?(X&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=_;function de(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=de;function we(W,X=1){if(X===0)return"";let he=-1;do he=W.indexOf(`
`,he+1),X--;while(X>0&&he>=0);return he===-1?W:(W[he-1]==="\r"&&he--,W.substr(0,he))}e.getNLines=we;function Pe(W){return W=W%(2*26),W<26?String.fromCharCode(97+W):String.fromCharCode(65+W-26)}e.singleLetterHash=Pe;function be(W){return He.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=be;function Ce(W,X){return W===0?X!==5&&X!==7:W===2&&X===3?!1:W===4||W===2||W===3||X===4||X===2||X===3?!0:!(W===8&&(X===8||X===9||X===11||X===12)||(W===11||W===9)&&(X===9||X===10)||(W===12||W===10)&&X===10||X===5||X===13||X===7||W===1||W===13&&X===14||W===6&&X===6)}var ke;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(ke=e.GraphemeBreakType||(e.GraphemeBreakType={}));class He{static getInstance(){return He.c||(He.c=new He),He.c}constructor(){this.d=Ge()}getGraphemeBreakType(X){if(X<32)return X===10?3:X===13?2:4;if(X<127)return 0;const he=this.d,Le=he.length/3;let Ne=1;for(;Ne<=Le;)if(X<he[3*Ne])Ne=2*Ne;else if(X>he[3*Ne+1])Ne=2*Ne+1;else return he[3*Ne+2];return 0}}He.c=null;function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt(W,X){if(W===0)return 0;const he=Qe(W,X);if(he!==void 0)return he;const Le=new x(X,W);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function Qe(W,X){const he=new x(X,W);let Le=he.prevCodePoint();for(;tt(Le)||Le===65039||Le===8419;){if(he.offset===0)return;Le=he.prevCodePoint()}if(!ue(Le))return;let Ne=he.offset;return Ne>0&&he.prevCodePoint()===8205&&(Ne=he.offset),Ne}function tt(W){return 127995<=W&&W<=127999}var rt;(function(W){W[W.zwj=8205]="zwj",W[W.emojiVariantSelector=65039]="emojiVariantSelector",W[W.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.noBreakWhitespace="\xA0";class Be{static getInstance(X){return Be.d.get(Array.from(X))}static getLocales(){return Be.e.value}constructor(X){this.f=X}isAmbiguous(X){return this.f.has(X)}getPrimaryConfusable(X){return this.f.get(X)}getConfusableCodePoints(){return new Set(this.f.keys())}}a=Be,Be.c=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.d=new o.LRUCachedFunction(W=>{function X(at){const mt=new Map;for(let gt=0;gt<at.length;gt+=2)mt.set(at[gt],at[gt+1]);return mt}function he(at,mt){const gt=new Map(at);for(const[Et,lt]of mt)gt.set(Et,lt);return gt}function Le(at,mt){if(!at)return mt;const gt=new Map;for(const[Et,lt]of at)mt.has(Et)&&gt.set(Et,lt);return gt}const Ne=a.c.value;let qe=W.filter(at=>!at.startsWith("_")&&at in Ne);qe.length===0&&(qe=["_default"]);let je;for(const at of qe){const mt=X(Ne[at]);je=Le(je,mt)}const Ze=X(Ne._common),st=he(Ze,je);return new Be(st)}),Be.e=new A.Lazy(()=>Object.keys(Be.c.value).filter(W=>!W.startsWith("_"))),e.AmbiguousCharacters=Be;class it{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(it.c())),this.d}static isInvisibleCharacter(X){return it.e().has(X)}static get codePoints(){return it.e()}}it.d=void 0,e.InvisibleCharacters=it}),define(ye[33],De([1,0,11,10,8,9]),function(ne,e,o,A,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(l){return l===47||l===92}e.isPathSeparator=I;function P(l){return l.replace(/[\\/]/g,o.posix.sep)}e.toSlashes=P;function S(l){return l.indexOf("/")===-1&&(l=P(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=S;function k(l,m=o.posix.sep){if(!l)return"";const i=l.length,t=l.charCodeAt(0);if(I(t)){if(I(l.charCodeAt(1))&&!I(l.charCodeAt(2))){let E=3;const w=E;for(;E<i&&!I(l.charCodeAt(E));E++);if(w!==E&&!I(l.charCodeAt(E+1))){for(E+=1;E<i;E++)if(I(l.charCodeAt(E)))return l.slice(0,E+1).replace(/[\\/]/g,m)}}return m}else if(u(t)&&l.charCodeAt(1)===58)return I(l.charCodeAt(2))?l.slice(0,2)+m:l.slice(0,2);let d=l.indexOf("://");if(d!==-1){for(d+=3;d<i;d++)if(I(l.charCodeAt(d)))return l.slice(0,d+1)}return""}e.getRoot=k;function O(l){if(!A.isWindows||!l||l.length<5)return!1;let m=l.charCodeAt(0);if(m!==92||(m=l.charCodeAt(1),m!==92))return!1;let i=2;const t=i;for(;i<l.length&&(m=l.charCodeAt(i),m!==92);i++);return!(t===i||(m=l.charCodeAt(i+1),isNaN(m)||m===92))}e.isUNC=O;const T=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(l,m=A.isWindows){const i=m?T:v;return!(!l||l.length===0||/^\s+$/.test(l)||(i.lastIndex=0,i.test(l))||m&&C.test(l)||l==="."||l===".."||m&&l[l.length-1]==="."||m&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=y;function f(l,m,i){const t=l===m;return!i||t?t:!l||!m?!1:(0,a.equalsIgnoreCase)(l,m)}e.isEqual=f;function h(l,m,i,t=o.sep){if(l===m)return!0;if(!l||!m||m.length>l.length)return!1;if(i){if(!(0,a.startsWithIgnoreCase)(l,m))return!1;if(m.length===l.length)return!0;let E=m.length;return m.charAt(m.length-1)===t&&E--,l.charAt(E)===t}return m.charAt(m.length-1)!==t&&(m+=t),l.indexOf(m)===0}e.isEqualOrParent=h;function u(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=u;function g(l,m){return A.isWindows&&l.endsWith(":")&&(l+=o.sep),(0,o.isAbsolute)(l)||(l=(0,o.join)(m,l)),l=(0,o.normalize)(l),A.isWindows?(l=(0,a.rtrim)(l,o.sep),l.endsWith(":")&&(l+=o.sep)):(l=(0,a.rtrim)(l,o.sep),l||(l=o.sep)),l}e.sanitizeFilePath=g;function b(l){const m=(0,o.normalize)(l);return A.isWindows?l.length>3?!1:D(m)&&(l.length===2||m.charCodeAt(2)===92):m===o.posix.sep}e.isRootOrDriveLetter=b;function D(l,m=A.isWindows){return m?u(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=D;function p(l){return D(l)?l[0]:void 0}e.getDriveLetter=p;function n(l,m,i){return m.length>l.length?-1:l===m?0:(i&&(l=l.toLowerCase(),m=m.toLowerCase()),l.indexOf(m))}e.indexOfPath=n;function s(l){const m=l.split(":");let i,t,d;for(const E of m){const w=Number(E);(0,R.isNumber)(w)?t===void 0?t=w:d===void 0&&(d=w):i=i?[i,E].join(":"):E}if(!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:t!==void 0?t:void 0,column:d!==void 0?d:t!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function c(l,m,i=8){let t="";for(let E=0;E<i;E++)t+=r.charAt(Math.floor(Math.random()*r.length));let d;return m?d=`${m}-${t}`:d=t,l?(0,o.join)(l,d):d}e.randomPath=c}),define(ye[110],De([1,0,28,8]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function a(...se){return function(F,H){for(let K=0,_=se.length;K<_;K++){const de=se[K](F,H);if(de)return de}return null}}e.or=a,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(se,F,H){if(!H||H.length<F.length)return null;let K;return se?K=A.startsWithIgnoreCase(H,F):K=H.indexOf(F)===0,K?F.length>0?[{start:0,end:F.length}]:[]:null}function I(se,F){const H=F.toLowerCase().indexOf(se.toLowerCase());return H===-1?null:[{start:H,end:H+se.length}]}e.matchesContiguousSubString=I;function P(se,F){return S(se.toLowerCase(),F.toLowerCase(),0,0)}e.matchesSubString=P;function S(se,F,H,K){if(H===se.length)return[];if(K===F.length)return null;if(se[H]===F[K]){let _=null;return(_=S(se,F,H+1,K+1))?u({start:K,end:K+1},_):null}return S(se,F,H,K+1)}function k(se){return 97<=se&&se<=122}function O(se){return 65<=se&&se<=90}e.isUpper=O;function T(se){return 48<=se&&se<=57}function v(se){return se===32||se===9||se===10||se===13}const C=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>C.add(se.charCodeAt(0)));function y(se){return v(se)||C.has(se)}function f(se,F){return se===F||y(se)&&y(F)}function h(se){return k(se)||O(se)||T(se)}function u(se,F){return F.length===0?F=[se]:se.end===F[0].start?F[0].start=se.start:F.unshift(se),F}function g(se,F){for(let H=F;H<se.length;H++){const K=se.charCodeAt(H);if(O(K)||T(K)||H>0&&!h(se.charCodeAt(H-1)))return H}return se.length}function b(se,F,H,K){if(H===se.length)return[];if(K===F.length)return null;if(se[H]!==F[K].toLowerCase())return null;{let _=null,de=K+1;for(_=b(se,F,H+1,K+1);!_&&(de=g(F,de))<F.length;)_=b(se,F,H+1,de),de++;return _===null?null:u({start:K,end:K+1},_)}}function D(se){let F=0,H=0,K=0,_=0,de=0;for(let ke=0;ke<se.length;ke++)de=se.charCodeAt(ke),O(de)&&F++,k(de)&&H++,h(de)&&K++,T(de)&&_++;const we=F/se.length,Pe=H/se.length,be=K/se.length,Ce=_/se.length;return{upperPercent:we,lowerPercent:Pe,alphaPercent:be,numericPercent:Ce}}function p(se){const{upperPercent:F,lowerPercent:H}=se;return H===0&&F>.6}function n(se){const{upperPercent:F,lowerPercent:H,alphaPercent:K,numericPercent:_}=se;return H>.2&&F<.8&&K>.6&&_<.2}function s(se){let F=0,H=0,K=0,_=0;for(let de=0;de<se.length;de++)K=se.charCodeAt(de),O(K)&&F++,k(K)&&H++,v(K)&&_++;return(F===0||H===0)&&_===0?se.length<=30:F<=5}function r(se,F){if(!F||(F=F.trim(),F.length===0)||!s(se)||F.length>60)return null;const H=D(F);if(!n(H)){if(!p(H))return null;F=F.toLowerCase()}let K=null,_=0;for(se=se.toLowerCase();_<F.length&&(K=b(se,F,0,_))===null;)_=g(F,_+1);return K}e.matchesCamelCase=r;function c(se,F,H=!1){if(!F||F.length===0)return null;let K=null,_=0;for(se=se.toLowerCase(),F=F.toLowerCase();_<F.length&&(K=l(se,F,0,_,H))===null;)_=m(F,_+1);return K}e.matchesWords=c;function l(se,F,H,K,_){if(H===se.length)return[];if(K===F.length)return null;if(f(se.charCodeAt(H),F.charCodeAt(K))){let de=null,we=K+1;if(de=l(se,F,H+1,K+1,_),!_)for(;!de&&(we=m(F,we))<F.length;)de=l(se,F,H+1,we,_),we++;return de?se.charCodeAt(H)!==F.charCodeAt(K)?de:u({start:K,end:K+1},de):null}else return null}function m(se,F){for(let H=F;H<se.length;H++)if(y(se.charCodeAt(H))||H>0&&y(se.charCodeAt(H-1)))return H;return se.length}const i=a(e.matchesPrefix,r,I),t=a(e.matchesPrefix,r,P),d=new o.LRUCache(1e4);function E(se,F,H=!1){if(typeof se!="string"||typeof F!="string")return null;let K=d.get(se);K||(K=new RegExp(A.convertSimple2RegExpPattern(se),"i"),d.set(se,K));const _=K.exec(F);return _?[{start:_.index,end:_.index+_[0].length}]:H?t(se,F):i(se,F)}e.matchesFuzzy=E;function w(se,F){const H=Ie(se,se.toLowerCase(),0,F,F.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?q(H):null}e.matchesFuzzy2=w;function L(se,F,H,K,_,de){const we=Math.min(13,se.length);for(;H<we;H++){const Pe=Ie(se,F,H,K,_,de,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Pe)return Pe}return[0,de]}e.anyScore=L;function q(se){if(typeof se>"u")return[];const F=[],H=se[1];for(let K=se.length-1;K>1;K--){const _=se[K]+H,de=F[F.length-1];de&&de.end===_?de.end=_+1:F.push({start:_,end:_+1})}return F}e.createMatches=q;const V=128;function M(){const se=[],F=[];for(let H=0;H<=V;H++)F[H]=0;for(let H=0;H<=V;H++)se.push(F.slice(0));return se}function B(se){const F=[];for(let H=0;H<=se;H++)F[H]=0;return F}const N=B(2*V),U=B(2*V),$=M(),z=M(),ae=M(),ee=!1;function x(se,F,H,K,_){function de(Pe,be,Ce=" "){for(;Pe.length<be;)Pe=Ce+Pe;return Pe}let we=` |   |${K.split("").map(Pe=>de(Pe,3)).join("|")}
`;for(let Pe=0;Pe<=H;Pe++)Pe===0?we+=" |":we+=`${F[Pe-1]}|`,we+=se[Pe].slice(0,_+1).map(be=>de(be.toString(),3)).join("|")+`
`;return we}function J(se,F,H,K){se=se.substr(F),H=H.substr(K),console.log(x(z,se,se.length,H,H.length)),console.log(x(ae,se,se.length,H,H.length)),console.log(x($,se,se.length,H,H.length))}function ie(se,F){if(F<0||F>=se.length)return!1;const H=se.codePointAt(F);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(H)}}function pe(se,F){if(F<0||F>=se.length)return!1;switch(se.charCodeAt(F)){case 32:case 9:return!0;default:return!1}}function Q(se,F,H){return F[se]!==H[se]}function Y(se,F,H,K,_,de,we=!1){for(;F<H&&_<de;)se[F]===K[_]&&(we&&(N[F]=_),F+=1),_+=1;return F===H}e.isPatternInWord=Y;var Z;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(Z||(Z={}));var me;(function(se){se.Default=[-100,0];function F(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}se.isDefault=F})(me=e.FuzzyScore||(e.FuzzyScore={}));class ve{constructor(F,H){this.firstMatchCanBeWeak=F,this.boostFullMatch=H}}ve.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=ve;function Ie(se,F,H,K,_,de,we=ve.default){const Pe=se.length>V?V:se.length,be=K.length>V?V:K.length;if(H>=Pe||de>=be||Pe-H>be-de||!Y(F,H,Pe,_,de,be,!0))return;Re(Pe,be,H,de,F,_);let Ce=1,ke=1,He=H,Ge=de;const nt=[!1];for(Ce=1,He=H;He<Pe;Ce++,He++){const it=N[He],W=U[He],X=He+1<Pe?U[He+1]:be;for(ke=it-de+1,Ge=it;Ge<X;ke++,Ge++){let he=Number.MIN_SAFE_INTEGER,Le=!1;Ge<=W&&(he=oe(se,F,He,H,K,_,Ge,be,de,$[Ce-1][ke-1]===0,nt));let Ne=0;he!==Number.MAX_SAFE_INTEGER&&(Le=!0,Ne=he+z[Ce-1][ke-1]);const qe=Ge>it,je=qe?z[Ce][ke-1]+($[Ce][ke-1]>0?-5:0):0,Ze=Ge>it+1&&$[Ce][ke-1]>0,st=Ze?z[Ce][ke-2]+($[Ce][ke-2]>0?-5:0):0;if(Ze&&(!qe||st>=je)&&(!Le||st>=Ne))z[Ce][ke]=st,ae[Ce][ke]=3,$[Ce][ke]=0;else if(qe&&(!Le||je>=Ne))z[Ce][ke]=je,ae[Ce][ke]=2,$[Ce][ke]=0;else if(Le)z[Ce][ke]=Ne,ae[Ce][ke]=1,$[Ce][ke]=$[Ce-1][ke-1]+1;else throw new Error("not possible")}}if(ee&&J(se,H,K,de),!nt[0]&&!we.firstMatchCanBeWeak)return;Ce--,ke--;const Qe=[z[Ce][ke],de];let tt=0,rt=0;for(;Ce>=1;){let it=ke;do{const W=ae[Ce][it];if(W===3)it=it-2;else if(W===2)it=it-1;else break}while(it>=1);tt>1&&F[H+Ce-1]===_[de+ke-1]&&!Q(it+de-1,K,_)&&tt+1>$[Ce][it]&&(it=ke),it===ke?tt++:tt=1,rt||(rt=it),Ce--,ke=it-1,Qe.push(ke)}be===Pe&&we.boostFullMatch&&(Qe[0]+=2);const Be=rt-Pe;return Qe[0]-=Be,Qe}e.fuzzyScore=Ie;function Re(se,F,H,K,_,de){let we=se-1,Pe=F-1;for(;we>=H&&Pe>=K;)_[we]===de[Pe]&&(U[we]=Pe,we--),Pe--}function oe(se,F,H,K,_,de,we,Pe,be,Ce,ke){if(F[H]!==de[we])return Number.MIN_SAFE_INTEGER;let He=1,Ge=!1;return we===H-K?He=se[H]===_[we]?7:5:Q(we,_,de)&&(we===0||!Q(we-1,_,de))?(He=se[H]===_[we]?7:5,Ge=!0):ie(de,we)&&(we===0||!ie(de,we-1))?He=5:(ie(de,we-1)||pe(de,we-1))&&(He=5,Ge=!0),He>1&&H===K&&(ke[0]=!0),Ge||(Ge=Q(we,_,de)||ie(de,we-1)||pe(de,we-1)),H===K?we>be&&(He-=Ge?3:5):Ce?He+=Ge?2:0:He+=Ge?0:1,we+1===Pe&&(He-=Ge?3:5),He}function le(se,F,H,K,_,de,we){return te(se,F,H,K,_,de,!0,we)}e.fuzzyScoreGracefulAggressive=le;function ue(se,F,H,K,_,de,we){return te(se,F,H,K,_,de,!1,we)}e.fuzzyScoreGraceful=ue;function te(se,F,H,K,_,de,we,Pe){let be=Ie(se,F,H,K,_,de,Pe);if(be&&!we)return be;if(se.length>=3){const Ce=Math.min(7,se.length-1);for(let ke=H+1;ke<Ce;ke++){const He=ce(se,ke);if(He){const Ge=Ie(He,He.toLowerCase(),H,K,_,de,Pe);Ge&&(Ge[0]-=3,(!be||Ge[0]>be[0])&&(be=Ge))}}}return be}function ce(se,F){if(F+1>=se.length)return;const H=se[F],K=se[F+1];if(H!==K)return se.slice(0,F)+K+H+se.slice(F+2)}}),define(ye[88],De([1,0,8]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(u){return a(u,0)}e.hash=A;function a(u,g){switch(typeof u){case"object":return u===null?R(349,g):Array.isArray(u)?S(u,g):k(u,g);case"string":return P(u,g);case"boolean":return I(u,g);case"number":return R(u,g);case"undefined":return R(937,g);default:return R(617,g)}}e.doHash=a;function R(u,g){return(g<<5)-g+u|0}e.numberHash=R;function I(u,g){return R(u?433:863,g)}function P(u,g){g=R(149417,g);for(let b=0,D=u.length;b<D;b++)g=R(u.charCodeAt(b),g);return g}e.stringHash=P;function S(u,g){return g=R(104579,g),u.reduce((b,D)=>a(D,b),g)}function k(u,g){return g=R(181387,g),Object.keys(u).sort().reduce((b,D)=>(b=P(D,b),a(u[D],b)),g)}class O{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=a(g,this.g),this.g}}e.Hasher=O;var T;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function v(u,g,b=32){const D=b-g,p=~((1<<D)-1);return(u<<g|(p&u)>>>D)>>>0}function C(u,g=0,b=u.byteLength,D=0){for(let p=0;p<b;p++)u[g+p]=D}function y(u,g,b="0"){for(;u.length<g;)u=b+u;return u}function f(u,g=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(b=>b.toString(16).padStart(2,"0")).join(""):y((u>>>0).toString(16),g/4)}e.toHexString=f;class h{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const b=g.length;if(b===0)return;const D=this.p;let p=this.r,n=this.u,s,r;for(n!==0?(s=n,r=-1,n=0):(s=g.charCodeAt(0),r=0);;){let c=s;if(o.isHighSurrogate(s))if(r+1<b){const l=g.charCodeAt(r+1);o.isLowSurrogate(l)?(r++,c=o.computeCodePoint(s,l)):c=65533}else{n=s;break}else o.isLowSurrogate(s)&&(c=65533);if(p=this.w(D,p,c),r++,r<b)s=g.charCodeAt(r);else break}this.r=p,this.u=n}w(g,b,D){return D<128?g[b++]=D:D<2048?(g[b++]=192|(D&1984)>>>6,g[b++]=128|(D&63)>>>0):D<65536?(g[b++]=224|(D&61440)>>>12,g[b++]=128|(D&4032)>>>6,g[b++]=128|(D&63)>>>0):(g[b++]=240|(D&1835008)>>>18,g[b++]=128|(D&258048)>>>12,g[b++]=128|(D&4032)>>>6,g[b++]=128|(D&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,C(this.p,this.r),this.r>56&&(this.y(),C(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=h.g,b=this.q;for(let i=0;i<64;i+=4)g.setUint32(i,b.getUint32(i,!1),!1);for(let i=64;i<320;i+=4)g.setUint32(i,v(g.getUint32(i-12,!1)^g.getUint32(i-32,!1)^g.getUint32(i-56,!1)^g.getUint32(i-64,!1),1),!1);let D=this.h,p=this.l,n=this.m,s=this.n,r=this.o,c,l,m;for(let i=0;i<80;i++)i<20?(c=p&n|~p&s,l=1518500249):i<40?(c=p^n^s,l=1859775393):i<60?(c=p&n|p&s|n&s,l=2400959708):(c=p^n^s,l=3395469782),m=v(D,5)+c+r+l+g.getUint32(i*4,!1)&4294967295,r=s,s=n,n=v(p,30),p=D,D=m;this.h=this.h+D&4294967295,this.l=this.l+p&4294967295,this.m=this.m+n&4294967295,this.n=this.n+s&4294967295,this.o=this.o+r&4294967295}}h.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=h}),define(ye[111],De([1,0,108,110,88,11,10,8]),function(ne,e,o,A,a,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,k=[S,[]];function O($,z,ae,ee){if(!$||!z)return k;const x=$.length,J=z.length;if(x<J)return k;const ie=$.toLowerCase();return T(z,ae,J,$,ie,x,ee)}e.scoreFuzzy=O;function T($,z,ae,ee,x,J,ie){const pe=[],Q=[];for(let ve=0;ve<ae;ve++){const Ie=ve*J,Re=Ie-J,oe=ve>0,le=$[ve],ue=z[ve];for(let te=0;te<J;te++){const ce=te>0,se=Ie+te,F=se-1,H=Re+te-1,K=ce?pe[F]:0,_=oe&&ce?pe[H]:0,de=oe&&ce?Q[H]:0;let we;!_&&oe?we=0:we=v(le,ue,ee,x,te,de),we&&_+we>=K&&(ie||oe||x.startsWith(z,te))?(Q[se]=de+1,pe[se]=_+we):(Q[se]=S,pe[se]=K)}}const Y=[];let Z=ae-1,me=J-1;for(;Z>=0&&me>=0;){const ve=Z*J+me;Q[ve]===S||(Y.push(me),Z--),me--}return[pe[ae*J-1],Y.reverse()]}function v($,z,ae,ee,x,J){let ie=0;if(!C(z,ee[x]))return ie;if(ie+=1,J>0&&(ie+=J*5),$===ae[x]&&(ie+=1),x===0)ie+=8;else{const pe=y(ae.charCodeAt(x-1));pe?ie+=pe:(0,A.isUpper)(ae.charCodeAt(x))&&J===0&&(ie+=2)}return ie}function C($,z){return $===z?!0:$==="/"||$==="\\"?z==="/"||z==="\\":!1}function y($){switch($){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const f=[void 0,[]];function h($,z,ae=0,ee=0){const x=z;return x.values&&x.values.length>1?u($,x.values,ae,ee):g($,z,ae,ee)}e.scoreFuzzy2=h;function u($,z,ae,ee){let x=0;const J=[];for(const ie of z){const[pe,Q]=g($,ie,ae,ee);if(typeof pe!="number")return f;x+=pe,J.push(...Q)}return[x,t(J)]}function g($,z,ae,ee){const x=(0,A.fuzzyScore)(z.original,z.originalLowercase,ae,$,$.toLowerCase(),ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return x?[x[0],(0,A.createMatches)(x)]:f}const b=Object.freeze({score:0}),D=1<<18,p=1<<17,n=1<<16;function s($,z,ae,ee){const x=ee.values?ee.values:[ee];return(0,a.hash)({[ee.normalized]:{values:x.map(ie=>({value:ie.normalized,expectContiguousMatch:ie.expectContiguousMatch})),label:$,description:z,allowNonContiguousMatches:ae}})}function r($,z,ae,ee,x){if(!$||!z.normalized)return b;const J=ee.getItemLabel($);if(!J)return b;const ie=ee.getItemDescription($),pe=s(J,ie,ae,z),Q=x[pe];if(Q)return Q;const Y=c(J,ie,ee.getItemPath($),z,ae);return x[pe]=Y,Y}e.scoreItemFuzzy=r;function c($,z,ae,ee,x){const J=!ae||!ee.containsPathSeparator;return ae&&(I.isLinux?ee.pathNormalized===ae:(0,P.equalsIgnoreCase)(ee.pathNormalized,ae))?{score:D,labelMatch:[{start:0,end:$.length}],descriptionMatch:z?[{start:0,end:z.length}]:void 0}:ee.values&&ee.values.length>1?l($,z,ae,ee.values,J,x):m($,z,ae,ee,J,x)}function l($,z,ae,ee,x,J){let ie=0;const pe=[],Q=[];for(const Y of ee){const{score:Z,labelMatch:me,descriptionMatch:ve}=m($,z,ae,Y,x,J);if(Z===S)return b;ie+=Z,me&&pe.push(...me),ve&&Q.push(...ve)}return{score:ie,labelMatch:t(pe),descriptionMatch:t(Q)}}function m($,z,ae,ee,x,J){if(x||!z){const[ie,pe]=O($,ee.normalized,ee.normalizedLowercase,J&&!ee.expectContiguousMatch);if(ie){const Q=(0,A.matchesPrefix)(ee.normalized,$);let Y;return Q?(Y=p,Y+=Math.round(ee.normalized.length/$.length*100)):Y=n,{score:Y+ie,labelMatch:Q||i(pe)}}}if(z){let ie=z;ae&&(ie=`${z}${R.sep}`);const pe=ie.length,Q=`${ie}${$}`,[Y,Z]=O(Q,ee.normalized,ee.normalizedLowercase,J&&!ee.expectContiguousMatch);if(Y){const me=i(Z),ve=[],Ie=[];return me.forEach(Re=>{Re.start<pe&&Re.end>pe?(ve.push({start:0,end:Re.end-pe}),Ie.push({start:Re.start,end:pe})):Re.start>=pe?ve.push({start:Re.start-pe,end:Re.end-pe}):Ie.push(Re)}),{score:Y,labelMatch:ve,descriptionMatch:Ie}}}return b}function i($){const z=[];if(!$)return z;let ae;for(const ee of $)ae&&ae.end===ee?ae.end+=1:(ae={start:ee,end:ee+1},z.push(ae));return z}function t($){const z=$.sort((x,J)=>x.start-J.start),ae=[];let ee;for(const x of z)!ee||!d(ee,x)?(ee=x,ae.push(x)):(ee.start=Math.min(ee.start,x.start),ee.end=Math.max(ee.end,x.end));return ae}function d($,z){return!($.end<z.start||z.end<$.start)}function E($,z,ae,ee,x,J){const ie=r($,ae,ee,x,J),pe=r(z,ae,ee,x,J),Q=ie.score,Y=pe.score;if((Q===D||Y===D)&&Q!==Y)return Q===D?-1:1;if(Q>n||Y>n){if(Q!==Y)return Q>Y?-1:1;if(Q<p&&Y<p){const le=L(ie.labelMatch,pe.labelMatch);if(le!==0)return le}const Re=x.getItemLabel($)||"",oe=x.getItemLabel(z)||"";if(Re.length!==oe.length)return Re.length-oe.length}if(Q!==Y)return Q>Y?-1:1;const Z=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0,me=Array.isArray(pe.labelMatch)&&pe.labelMatch.length>0;if(Z&&!me)return-1;if(me&&!Z)return 1;const ve=w($,ie,x),Ie=w(z,pe,x);return ve&&Ie&&ve!==Ie?Ie>ve?-1:1:q($,z,ae,x)}e.compareItemsByFuzzyScore=E;function w($,z,ae){let ee=-1,x=-1;if(z.descriptionMatch&&z.descriptionMatch.length?ee=z.descriptionMatch[0].start:z.labelMatch&&z.labelMatch.length&&(ee=z.labelMatch[0].start),z.labelMatch&&z.labelMatch.length){if(x=z.labelMatch[z.labelMatch.length-1].end,z.descriptionMatch&&z.descriptionMatch.length){const J=ae.getItemDescription($);J&&(x+=J.length)}}else z.descriptionMatch&&z.descriptionMatch.length&&(x=z.descriptionMatch[z.descriptionMatch.length-1].end);return x-ee}function L($,z){if(!$&&!z||(!$||!$.length)&&(!z||!z.length))return 0;if(!z||!z.length)return-1;if(!$||!$.length)return 1;const ae=$[0].start,x=$[$.length-1].end-ae,J=z[0].start,pe=z[z.length-1].end-J;return x===pe?0:pe<x?1:-1}function q($,z,ae,ee){const x=ee.getItemLabel($)||"",J=ee.getItemLabel(z)||"",ie=ee.getItemDescription($),pe=ee.getItemDescription(z),Q=x.length+(ie?ie.length:0),Y=J.length+(pe?pe.length:0);if(Q!==Y)return Q-Y;const Z=ee.getItemPath($),me=ee.getItemPath(z);return Z&&me&&Z.length!==me.length?Z.length-me.length:x!==J?(0,o.compareAnything)(x,J,ae.normalized):ie&&pe&&ie!==pe?(0,o.compareAnything)(ie,pe,ae.normalized):Z&&me&&Z!==me?(0,o.compareAnything)(Z,me,ae.normalized):0}function V($){return $.startsWith('"')&&$.endsWith('"')}const M=" ";function B($){typeof $!="string"&&($="");const z=$.toLowerCase(),{pathNormalized:ae,normalized:ee,normalizedLowercase:x}=N($),J=ae.indexOf(R.sep)>=0,ie=V($);let pe;const Q=$.split(M);if(Q.length>1)for(const Y of Q){const Z=V(Y),{pathNormalized:me,normalized:ve,normalizedLowercase:Ie}=N(Y);ve&&(pe||(pe=[]),pe.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:me,normalized:ve,normalizedLowercase:Ie,expectContiguousMatch:Z}))}return{original:$,originalLowercase:z,pathNormalized:ae,normalized:ee,normalizedLowercase:x,values:pe,containsPathSeparator:J,expectContiguousMatch:ie}}e.prepareQuery=B;function N($){let z;I.isWindows?z=$.replace(/\//g,R.sep):z=$.replace(/\\/g,R.sep);const ae=(0,P.stripWildcards)(z).replace(/\s|"/g,"");return{pathNormalized:z,normalized:ae,normalizedLowercase:ae.toLowerCase()}}function U($){return Array.isArray($)?B($.map(z=>z.original).join(M)):B($.original)}e.pieceToQuery=U}),define(ye[163],De([1,0,110,8,51]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",I=new RegExp(`\\$\\(${a.ThemeIcon.iconNameExpression}(?:${a.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${I.source}`,"g");function S(u){return u.replace(P,(g,b)=>b?g:`\\${g}`)}e.escapeIcons=S;const k=new RegExp(`\\\\${I.source}`,"g");function O(u){return u.replace(k,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=O;const T=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function v(u){return u.indexOf(R)===-1?u:u.replace(T,(g,b,D,p)=>D?g:b||p||"")}e.stripIcons=v;function C(u){return u?u.replace(/\$\((.*?)\)/g,(g,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=C;const y=new RegExp(`\\$\\(${a.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(u){y.lastIndex=0;let g="";const b=[];let D=0;for(;;){const p=y.lastIndex,n=y.exec(u),s=u.substring(p,n?.index);if(s.length>0){g+=s;for(let r=0;r<s.length;r++)b.push(D)}if(!n)break;D+=n[0].length}return{text:g,iconOffsets:b}}e.parseLabelWithIcons=f;function h(u,g,b=!1){const{text:D,iconOffsets:p}=g;if(!p||p.length===0)return(0,o.matchesFuzzy)(u,D,b);const n=(0,A.ltrim)(D," "),s=D.length-n.length,r=(0,o.matchesFuzzy)(u,n,b);if(r)for(const c of r){const l=p[c.start+s]+s;c.start+=l,c.end+=l}return r}e.matchesFuzzyIconAware=h}),define(ye[37],De([1,0,8]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(a){a[a.Ignore=0]="Ignore",a[a.Info=1]="Info",a[a.Warning=2]="Warning",a[a.Error=3]="Error"})(A||(A={})),function(a){const R="error",I="warning",P="warn",S="info",k="ignore";function O(v){return v?o.equalsIgnoreCase(R,v)?a.Error:o.equalsIgnoreCase(I,v)||o.equalsIgnoreCase(P,v)?a.Warning:o.equalsIgnoreCase(S,v)?a.Info:a.Ignore:a.Ignore}a.fromValue=O;function T(v){switch(v){case a.Error:return R;case a.Warning:return I;case a.Info:return S;default:return k}}a.toString=T}(A||(A={})),e.default=A}),define(ye[68],De([1,0,15,8]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class a{constructor(){this.b="",this.c=0}reset(C){return this.b=C,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(C){const y=C.charCodeAt(0),f=this.b.charCodeAt(this.c);return y-f}value(){return this.b[this.c]}}e.StringIterator=a;class R{constructor(C=!0){this.e=C}reset(C){return this.b=C,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let C=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(C)this.c++;else break;else C=!1;return this}cmp(C){return this.e?(0,A.compareSubstring)(C,this.b,0,C.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(C,this.b,0,C.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class I{constructor(C=!0,y=!0){this.f=C,this.g=y}reset(C){this.d=0,this.e=0,this.b=C,this.c=C.length;for(let y=C.length-1;y>=0;y--,this.c--){const f=this.b.charCodeAt(y);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let C=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(C)this.d++;else break;else C=!1}return this}cmp(C){return this.g?(0,A.compareSubstring)(C,this.b,0,C.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(C,this.b,0,C.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=I;var P;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(P||(P={}));class S{constructor(C,y){this.f=C,this.g=y,this.d=[],this.e=0}reset(C){return this.c=C,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(C)),this.b.reset(C.path),this.b.value()&&this.d.push(3)),this.g(C)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(C){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(C,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(C,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(C);if(this.d[this.e]===4)return(0,A.compare)(C,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(C,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const C=this.right;return this.right=C.left,C.left=this,this.updateHeight(),C.updateHeight(),C}rotateRight(){const C=this.left;return this.left=C.right,C.right=this,this.updateHeight(),C.updateHeight(),C}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(O||(O={}));class T{static forUris(C=()=>!1,y=()=>!1){return new T(new S(C,y))}static forPaths(C=!1){return new T(new I(void 0,!C))}static forStrings(){return new T(new a)}static forConfigKeys(){return new T(new R)}constructor(C){this.b=C}clear(){this.c=void 0}fill(C,y){if(y){const f=y.slice(0);(0,o.shuffle)(f);for(const h of f)this.set(h,C)}else{const f=C.slice(0);(0,o.shuffle)(f);for(const h of f)this.set(h[0],h[1])}}set(C,y){const f=this.b.reset(C);let h;this.c||(this.c=new k,this.c.segment=f.value());const u=[];for(h=this.c;;){const b=f.cmp(h.segment);if(b>0)h.left||(h.left=new k,h.left.segment=f.value()),u.push([-1,h]),h=h.left;else if(b<0)h.right||(h.right=new k,h.right.segment=f.value()),u.push([1,h]),h=h.right;else if(f.hasNext())f.next(),h.mid||(h.mid=new k,h.mid.segment=f.value()),u.push([0,h]),h=h.mid;else break}const g=h.value;h.value=y,h.key=C;for(let b=u.length-1;b>=0;b--){const D=u[b][1];D.updateHeight();const p=D.balanceFactor();if(p<-1||p>1){const n=u[b][0],s=u[b+1][0];if(n===1&&s===1)u[b][1]=D.rotateLeft();else if(n===-1&&s===-1)u[b][1]=D.rotateRight();else if(n===1&&s===-1)D.right=u[b+1][1]=u[b+1][1].rotateRight(),u[b][1]=D.rotateLeft();else if(n===-1&&s===1)D.left=u[b+1][1]=u[b+1][1].rotateLeft(),u[b][1]=D.rotateRight();else throw new Error;if(b>0)switch(u[b-1][0]){case-1:u[b-1][1].left=u[b][1];break;case 1:u[b-1][1].right=u[b][1];break;case 0:u[b-1][1].mid=u[b][1];break}else this.c=u[0][1]}}return g}get(C){return this.d(C)?.value}d(C){const y=this.b.reset(C);let f=this.c;for(;f;){const h=y.cmp(f.segment);if(h>0)f=f.left;else if(h<0)f=f.right;else if(y.hasNext())y.next(),f=f.mid;else break}return f}has(C){const y=this.d(C);return!(y?.value===void 0&&y?.mid===void 0)}delete(C){return this.e(C,!1)}deleteSuperstr(C){return this.e(C,!0)}e(C,y){const f=this.b.reset(C),h=[];let u=this.c;for(;u;){const g=f.cmp(u.segment);if(g>0)h.push([-1,u]),u=u.left;else if(g<0)h.push([1,u]),u=u.right;else if(f.hasNext())f.next(),h.push([0,u]),u=u.mid;else break}if(!!u){if(y?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this.f(u.right);if(g.key){const{key:b,value:D,segment:p}=g;this.e(g.key,!1),u.key=b,u.value=D,u.segment=p}}else{const g=u.left??u.right;if(h.length>0){const[b,D]=h[h.length-1];switch(b){case-1:D.left=g;break;case 0:D.mid=g;break;case 1:D.right=g;break}}else this.c=g}for(let g=h.length-1;g>=0;g--){const b=h[g][1];b.updateHeight();const D=b.balanceFactor();if(D>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),h[g][1]=b.rotateLeft()):D<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),h[g][1]=b.rotateRight()),g>0)switch(h[g-1][0]){case-1:h[g-1][1].left=h[g][1];break;case 1:h[g-1][1].right=h[g][1];break;case 0:h[g-1][1].mid=h[g][1];break}else this.c=h[0][1]}}}f(C){for(;C.left;)C=C.left;return C}findSubstr(C){const y=this.b.reset(C);let f=this.c,h;for(;f;){const u=y.cmp(f.segment);if(u>0)f=f.left;else if(u<0)f=f.right;else if(y.hasNext())y.next(),h=f.value||h,f=f.mid;else break}return f&&f.value||h}findSuperstr(C){return this.g(C,!1)}g(C,y){const f=this.b.reset(C);let h=this.c;for(;h;){const u=f.cmp(h.segment);if(u>0)h=h.left;else if(u<0)h=h.right;else if(f.hasNext())f.next(),h=h.mid;else return h.mid?this.h(h.mid):y?h.value:void 0}}hasElementOrSubtree(C){return this.g(C,!0)!==void 0}forEach(C){for(const[y,f]of this)C(f,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(C){const y=[];return this.j(C,y),y[Symbol.iterator]()}j(C,y){!C||(C.left&&this.j(C.left,y),C.value&&y.push([C.key,C.value]),C.mid&&this.j(C.mid,y),C.right&&this.j(C.right,y))}_isBalanced(){const C=y=>{if(!y)return!0;const f=y.balanceFactor();return f<-1||f>1?!1:C(y.left)&&C(y.right)};return C(this.c)}}e.TernarySearchTree=T}),define(ye[2],De([1,0,11,10]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const a=/^\w[\w\d+.-]*$/,R=/^\//,I=/^\/\//;function P(r,c){if(!r.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!a.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(r,c){return!r&&!c?"file":r}function k(r,c){switch(r){case"https":case"http":case"file":c?c[0]!==T&&(c=T+c):c=T;break}return c}const O="",T="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{static isUri(c){return c instanceof C?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,l,m,i,t,d=!1){typeof c=="object"?(this.scheme=c.scheme||O,this.authority=c.authority||O,this.path=c.path||O,this.query=c.query||O,this.fragment=c.fragment||O):(this.scheme=S(c,d),this.authority=l||O,this.path=k(this.scheme,m||O),this.query=i||O,this.fragment=t||O,P(this,d))}get fsPath(){return b(this,!1)}with(c){if(!c)return this;let{scheme:l,authority:m,path:i,query:t,fragment:d}=c;return l===void 0?l=this.scheme:l===null&&(l=O),m===void 0?m=this.authority:m===null&&(m=O),i===void 0?i=this.path:i===null&&(i=O),t===void 0?t=this.query:t===null&&(t=O),d===void 0?d=this.fragment:d===null&&(d=O),l===this.scheme&&m===this.authority&&i===this.path&&t===this.query&&d===this.fragment?this:new f(l,m,i,t,d)}static parse(c,l=!1){const m=v.exec(c);return m?new f(m[2]||O,s(m[4]||O),s(m[5]||O),s(m[7]||O),s(m[9]||O),l):new f(O,O,O,O,O)}static file(c){let l=O;if(A.isWindows&&(c=c.replace(/\\/g,T)),c[0]===T&&c[1]===T){const m=c.indexOf(T,2);m===-1?(l=c.substring(2),c=T):(l=c.substring(2,m),c=c.substring(m)||T)}return new f("file",l,c,O,O)}static from(c){const l=new f(c.scheme,c.authority,c.path,c.query,c.fragment);return P(l,!0),l}static joinPath(c,...l){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return A.isWindows&&c.scheme==="file"?m=C.file(o.win32.join(b(c,!0),...l)).path:m=o.posix.join(c.path,...l),c.with({path:m})}toString(c=!1){return D(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof C)return c;{const l=new f(c);return l._formatted=c.external,l._fsPath=c._sep===y?c.fsPath:null,l}}else return c}}e.URI=C;const y=A.isWindows?1:void 0;class f extends C{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(c=!1){return c?D(this,!0):(this._formatted||(this._formatted=D(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=y),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(r,c,l){let m,i=-1;for(let t=0;t<r.length;t++){const d=r.charCodeAt(t);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||c&&d===47||l&&d===91||l&&d===93||l&&d===58)i!==-1&&(m+=encodeURIComponent(r.substring(i,t)),i=-1),m!==void 0&&(m+=r.charAt(t));else{m===void 0&&(m=r.substr(0,t));const E=h[d];E!==void 0?(i!==-1&&(m+=encodeURIComponent(r.substring(i,t)),i=-1),m+=E):i===-1&&(i=t)}}return i!==-1&&(m+=encodeURIComponent(r.substring(i))),m!==void 0?m:r}function g(r){let c;for(let l=0;l<r.length;l++){const m=r.charCodeAt(l);m===35||m===63?(c===void 0&&(c=r.substr(0,l)),c+=h[m]):c!==void 0&&(c+=r[l])}return c!==void 0?c:r}function b(r,c){let l;return r.authority&&r.path.length>1&&r.scheme==="file"?l=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?c?l=r.path.substr(1):l=r.path[1].toLowerCase()+r.path.substr(2):l=r.path,A.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=b;function D(r,c){const l=c?g:u;let m="",{scheme:i,authority:t,path:d,query:E,fragment:w}=r;if(i&&(m+=i,m+=":"),(t||i==="file")&&(m+=T,m+=T),t){let L=t.indexOf("@");if(L!==-1){const q=t.substr(0,L);t=t.substr(L+1),L=q.lastIndexOf(":"),L===-1?m+=l(q,!1,!1):(m+=l(q.substr(0,L),!1,!1),m+=":",m+=l(q.substr(L+1),!1,!0)),m+="@"}t=t.toLowerCase(),L=t.lastIndexOf(":"),L===-1?m+=l(t,!1,!0):(m+=l(t.substr(0,L),!1,!0),m+=t.substr(L))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const L=d.charCodeAt(1);L>=65&&L<=90&&(d=`/${String.fromCharCode(L+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const L=d.charCodeAt(0);L>=65&&L<=90&&(d=`${String.fromCharCode(L+32)}:${d.substr(2)}`)}m+=l(d,!0,!1)}return E&&(m+="?",m+=l(E,!1,!1)),w&&(m+="#",m+=c?w:u(w,!1,!1)),m}function p(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+p(r.substr(3)):r}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(n)?r.replace(n,c=>p(c)):r}}),define(ye[69],De([1,0,22,8,2]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(k){return JSON.stringify(k,P)}e.stringify=R;function I(k){let O=JSON.parse(k);return O=S(O),O}e.parse=I;function P(k,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,A.regExpFlags)(O)}:O}function S(k,O=0){if(!k||O>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return a.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof o.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let T=0;T<k.length;++T)k[T]=S(k[T],O+1);else for(const T in k)Object.hasOwnProperty.call(k,T)&&(k[T]=S(k[T],O+1))}return k}e.revive=S}),define(ye[16],De([1,0,12,10,2]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.vscodeUserData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls",k.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(O){this.d=O}setDelegate(O){this.e=O}setServerRootPath(O){this.f=`${O}/${R.vscodeRemoteResource}`}set(O,T,v){this.a[O]=T,this.b[O]=v}setConnectionToken(O,T){this.c[O]=T}getPreferredWebSchema(){return this.d}rewrite(O){if(this.e)try{return this.e(O)}catch(h){return o.onUnexpectedError(h),O}const T=O.authority;let v=this.a[T];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const C=this.b[T],y=this.c[T];let f=`path=${encodeURIComponent(O.path)}`;return typeof y=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),a.URI.from({scheme:A.isWeb?this.d:R.vscodeRemoteResource,authority:`${v}:${C}`,path:this.f,query:f})}}e.RemoteAuthorities=new I,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(O){const T=this.b(O,ne);return this.uriToBrowserUri(T)}uriToBrowserUri(O){return O.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===R.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${R.vscodeFileResource}://${P.a}`)?O.with({scheme:R.vscodeFileResource,authority:O.authority||P.a,query:null,fragment:null}):O}asFileUri(O){const T=this.b(O,ne);return this.uriToFileUri(T)}uriToFileUri(O){return O.scheme===R.vscodeFileResource?O.with({scheme:R.file,authority:O.authority!==P.a?O.authority:null,query:null,fragment:null}):O}b(O,T){return a.URI.isUri(O)?O:a.URI.parse(T.toUrl(O))}}P.a="vscode-app",e.FileAccess=new P;var S;(function(k){const O=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);k.CoopAndCoep=Object.freeze(O.get("3"));const T="vscode-coi";function v(y){let f;typeof y=="string"?f=new URL(y).searchParams:y instanceof URL?f=y.searchParams:a.URI.isUri(y)&&(f=new URL(y.toString(!0)).searchParams);const h=f?.get(T);if(!!h)return O.get(h)}k.getHeadersFromQuery=v;function C(y,f,h){if(!globalThis.crossOriginIsolated)return;const u=f&&h?"3":h?"2":"1";y instanceof URLSearchParams?y.set(T,u):y[T]=u}k.addSearchParam=C})(S=e.COI||(e.COI={}))}),define(ye[24],De([1,0,33,16,11,10,8,2]),function(ne,e,o,A,a,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(C){return(0,P.uriToFsPath)(C,!0)}e.originalFSPath=S;class k{constructor(y){this.a=y}compare(y,f,h=!1){return y===f?0:(0,I.compare)(this.getComparisonKey(y,h),this.getComparisonKey(f,h))}isEqual(y,f,h=!1){return y===f?!0:!y||!f?!1:this.getComparisonKey(y,h)===this.getComparisonKey(f,h)}getComparisonKey(y,f=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,f,h=!1){if(y.scheme===f.scheme){if(y.scheme===A.Schemas.file)return o.isEqualOrParent(S(y),S(f),this.a(y))&&y.query===f.query&&(h||y.fragment===f.fragment);if((0,e.isEqualAuthority)(y.authority,f.authority))return o.isEqualOrParent(y.path,f.path,this.a(y),"/")&&y.query===f.query&&(h||y.fragment===f.fragment)}return!1}joinPath(y,...f){return P.URI.joinPath(y,...f)}basenameOrAuthority(y){return(0,e.basename)(y)||y.authority}basename(y){return a.posix.basename(y.path)}extname(y){return a.posix.extname(y.path)}dirname(y){if(y.path.length===0)return y;let f;return y.scheme===A.Schemas.file?f=P.URI.file(a.dirname(S(y))).path:(f=a.posix.dirname(y.path),y.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),f="/")),y.with({path:f})}normalizePath(y){if(!y.path.length)return y;let f;return y.scheme===A.Schemas.file?f=P.URI.file(a.normalize(S(y))).path:f=a.posix.normalize(y.path),y.with({path:f})}relativePath(y,f){if(y.scheme!==f.scheme||!(0,e.isEqualAuthority)(y.authority,f.authority))return;if(y.scheme===A.Schemas.file){const g=a.relative(S(y),S(f));return R.isWindows?o.toSlashes(g):g}let h=y.path||"/";const u=f.path||"/";if(this.a(y)){let g=0;for(const b=Math.min(h.length,u.length);g<b&&!(h.charCodeAt(g)!==u.charCodeAt(g)&&h.charAt(g).toLowerCase()!==u.charAt(g).toLowerCase());g++);h=u.substr(0,g)+h.substr(g)}return a.posix.relative(h,u)}resolvePath(y,f){if(y.scheme===A.Schemas.file){const h=P.URI.file(a.resolve(S(y),f));return y.with({authority:h.authority,path:h.path})}return f=o.toPosixPath(f),y.with({path:a.posix.resolve(y.path,f)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,f){return y===f||y!==void 0&&f!==void 0&&(0,I.equalsIgnoreCase)(y,f)}hasTrailingPathSeparator(y,f=a.sep){if(y.scheme===A.Schemas.file){const h=S(y);return h.length>o.getRoot(h).length&&h[h.length-1]===f}else{const h=y.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,f=a.sep){return(0,e.hasTrailingPathSeparator)(y,f)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,f=a.sep){let h=!1;if(y.scheme===A.Schemas.file){const u=S(y);h=u!==void 0&&u.length===o.getRoot(u).length&&u[u.length-1]===f}else{f="/";const u=y.path;h=u.length===1&&u.charCodeAt(u.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(y,f)?y.with({path:y.path+"/"}):y}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(C=>C.scheme===A.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new k(C=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(C,y){const f=[];for(let h=0;h<C.length;h++){const u=y(C[h]);C.some((g,b)=>b===h?!1:(0,e.isEqualOrParent)(u,y(g)))||f.push(C[h])}return f}e.distinctParents=O;var T;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function y(f){const h=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(b=>{const[D,p]=b.split(":");D&&p&&h.set(D,p)});const g=f.path.substring(0,f.path.indexOf(";"));return g&&h.set(C.META_DATA_MIME,g),h}C.parseMetaData=y})(T=e.DataUri||(e.DataUri={}));function v(C,y,f){if(y){let h=C.path;return h&&h[0]!==a.posix.sep&&(h=a.posix.sep+h),C.with({scheme:f,authority:y,path:h})}return C.with({scheme:f})}e.toLocalResource=v}),define(ye[19],De([1,0,21,12,3,6,24,10,148]),function(ne,e,o,A,a,R,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k(Y){return!!Y&&typeof Y.then=="function"}e.isThenable=k;function O(Y){const Z=new o.CancellationTokenSource,me=Y(Z.token),ve=new Promise((Ie,Re)=>{const oe=Z.token.onCancellationRequested(()=>{oe.dispose(),Z.dispose(),Re(new A.CancellationError)});Promise.resolve(me).then(le=>{oe.dispose(),Z.dispose(),Ie(le)},le=>{oe.dispose(),Z.dispose(),Re(le)})});return new class{cancel(){Z.cancel()}then(Ie,Re){return ve.then(Ie,Re)}catch(Ie){return this.then(void 0,Ie)}finally(Ie){return ve.finally(Ie)}}}e.createCancelablePromise=O;function T(Y,Z,me){return new Promise((ve,Ie)=>{const Re=Z.onCancellationRequested(()=>{Re.dispose(),ve(me)});Y.then(ve,Ie).finally(()=>Re.dispose())})}e.raceCancellation=T;function v(Y,Z){return new Promise((me,ve)=>{const Ie=Z.onCancellationRequested(()=>{Ie.dispose(),ve(new A.CancellationError)});Y.then(me,ve).finally(()=>Ie.dispose())})}e.raceCancellationError=v;async function C(Y){let Z=-1;const me=Y.map((Ie,Re)=>Ie.then(oe=>(Z=Re,oe))),ve=await Promise.race(me);return Y.forEach((Ie,Re)=>{Re!==Z&&Ie.cancel()}),ve}e.raceCancellablePromises=C;function y(Y,Z,me){let ve;const Ie=setTimeout(()=>{ve?.(void 0),me?.()},Z);return Promise.race([Y.finally(()=>clearTimeout(Ie)),new Promise(Re=>ve=Re)])}e.raceTimeout=y;function f(Y){return new Promise((Z,me)=>{const ve=Y();k(ve)?ve.then(Z,me):Z(ve)})}e.asPromise=f;class h{constructor(){this.a=null,this.b=null,this.d=null}queue(Z){if(this.a){if(this.d=Z,!this.b){const me=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(me,me).then(ve)})}return new Promise((me,ve)=>{this.b.then(me,ve)})}return this.a=Z(),new Promise((me,ve)=>{this.a.then(Ie=>{this.a=null,me(Ie)},Ie=>{this.a=null,ve(Ie)})})}}e.Throttler=h;class u{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.Sequencer=u;class g{constructor(){this.a=new Map}queue(Z,me){const Ie=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.a.get(Z)===Ie&&this.a.delete(Z)});return this.a.set(Z,Ie),Ie}}e.SequencerByKey=g;const b=(Y,Z)=>{let me=!0;const ve=setTimeout(()=>{me=!1,Z()},Y);return{isTriggered:()=>me,dispose:()=>{clearTimeout(ve),me=!1}}},D=Y=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,Y())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class p{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,me=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((Ie,Re)=>{this.d=Ie,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const Ie=this.g;return this.g=null,Ie()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=me===S.MicrotaskDelay?D(ve):b(me,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=p;class n{constructor(Z){this.a=new p(Z),this.b=new h}trigger(Z,me){return this.a.trigger(()=>this.b.queue(Z),me)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=n;class s{constructor(){this.a=!1,this.b=new Promise((Z,me)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=s;class r extends s{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function c(Y,Z){return Z?new Promise((me,ve)=>{const Ie=setTimeout(()=>{Re.dispose(),me()},Y),Re=Z.onCancellationRequested(()=>{clearTimeout(Ie),Re.dispose(),ve(new A.CancellationError)})}):O(me=>c(Y,me))}e.timeout=c;function l(Y,Z=0){const me=setTimeout(Y,Z);return(0,R.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=l;function m(Y){const Z=[];let me=0;const ve=Y.length;function Ie(){return me<ve?Y[me++]():null}function Re(oe){oe!=null&&Z.push(oe);const le=Ie();return le?le.then(Re):Promise.resolve(Z)}return Promise.resolve(null).then(Re)}e.sequence=m;function i(Y,Z=ve=>!!ve,me=null){let ve=0;const Ie=Y.length,Re=()=>{if(ve>=Ie)return Promise.resolve(me);const oe=Y[ve++];return Promise.resolve(oe()).then(ue=>Z(ue)?Promise.resolve(ue):Re())};return Re()}e.first=i;function t(Y,Z=ve=>!!ve,me=null){if(Y.length===0)return Promise.resolve(me);let ve=Y.length;const Ie=()=>{ve=-1;for(const Re of Y)Re.cancel?.()};return new Promise((Re,oe)=>{for(const le of Y)le.then(ue=>{--ve>=0&&Z(ue)?(Ie(),Re(ue)):ve===0&&Re(me)}).catch(ue=>{--ve>=0&&(Ie(),oe(ue))})})}e.firstParallel=t;class d{constructor(Z){this.a=0,this.d=Z,this.f=[],this.b=0,this.g=new a.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(Z){return this.a++,new Promise((me,ve)=>{this.f.push({factory:Z,c:me,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const Z=this.f.shift();this.b++;const me=Z.factory();me.then(Z.c,Z.e),me.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=d;class E extends d{constructor(){super(1)}}e.Queue=E;class w{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const Z=new ee;return this.b.add(Z),Z.p}d(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueFor(Z,me=I.extUri){const ve=me.getComparisonKey(Z);let Ie=this.a.get(ve);return Ie||(Ie=new E,a.Event.once(Ie.onDrained)(()=>{Ie?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,Ie)),Ie}f(){!this.d()||this.g()}g(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.g()}}e.ResourceQueue=w;class L{constructor(Z,me){this.a=-1,typeof Z=="function"&&typeof me=="number"&&this.setIfNotSet(Z,me)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,me){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},me)}setIfNotSet(Z,me){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},me))}}e.TimeoutTimer=L;class q{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(Z,me){this.cancel(),this.a=setInterval(()=>{Z()},me)}}e.IntervalTimer=q;class V{constructor(Z,me){this.b=-1,this.a=Z,this.d=me,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=V;class M{constructor(Z,me){me%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.a=Z,this.b=me,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=M;class B extends V{constructor(Z,me){super(Z,me),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=B;class N extends R.Disposable{constructor(Z,me){super(),this.g=Z,this.h=me,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const me of Z)this.a.push(me);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Y=>{(0,P.setTimeout0)(()=>{if(Z)return;const me=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.runWhenIdle=(Y,Z)=>{const me=requestIdleCallback(Y,typeof Z=="number"?{timeout:Z}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(me))}}}}();class U{constructor(Z){this.d=!1,this.a=()=>{try{this.f=Z()}catch(me){this.g=me}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=U;async function $(Y,Z,me){let ve;for(let Ie=0;Ie<me;Ie++)try{return await Y()}catch(Re){ve=Re,await c(Z)}throw ve}e.retry=$;class z{hasPending(Z){return this.a?typeof Z=="number"?this.a.taskId===Z:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(Z,me,ve){return this.a={taskId:Z,cancel:()=>ve?.(),promise:me},me.then(()=>this.d(Z),()=>this.d(Z)),me}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}setNext(Z){if(this.b)this.b.run=Z;else{let me,ve;const Ie=new Promise((Re,oe)=>{me=Re,ve=oe});this.b={run:Z,promise:Ie,promiseResolve:me,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=z;class ae{constructor(Z,me=()=>Date.now()){this.d=Z,this.f=me,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.IntervalCounter=ae;class ee{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((Z,me)=>{this.a=Z,this.b=me})}complete(Z){return new Promise(me=>{this.a(Z),this.f=!0,me()})}error(Z){return new Promise(me=>{this.b(Z),this.d=!0,me()})}cancel(){new Promise(Z=>{this.b(new A.CancellationError),this.d=!0,Z()})}}e.DeferredPromise=ee;var x;(function(Y){async function Z(ve){let Ie;const Re=await Promise.all(ve.map(oe=>oe.then(le=>le,le=>{Ie||(Ie=le)})));if(typeof Ie<"u")throw Ie;return Re}Y.settled=Z;function me(ve){return new Promise(async(Ie,Re)=>{try{await ve(Ie,Re)}catch(oe){Re(oe)}})}Y.withAsyncBody=me})(x=e.Promises||(e.Promises={}));var J;(function(Y){Y[Y.Initial=0]="Initial",Y[Y.DoneOK=1]="DoneOK",Y[Y.DoneError=2]="DoneError"})(J||(J={}));class ie{static fromArray(Z){return new ie(me=>{me.emitMany(Z)})}static fromPromise(Z){return new ie(async me=>{me.emitMany(await Z)})}static fromPromises(Z){return new ie(async me=>{await Promise.all(Z.map(async ve=>me.emitOne(await ve)))})}static merge(Z){return new ie(async me=>{await Promise.all(Z.map(async ve=>{for await(const Ie of ve)me.emitOne(Ie)}))})}constructor(Z){this.a=0,this.b=[],this.d=null,this.f=new a.Emitter,queueMicrotask(async()=>{const me={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(Z(me)),this.j()}catch(ve){this.k(ve)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===1)return{done:!0,value:void 0};await a.Event.toPromise(this.f.event)}while(!0)}}}static map(Z,me){return new ie(async ve=>{for await(const Ie of Z)ve.emitOne(me(Ie))})}map(Z){return ie.map(this,Z)}static filter(Z,me){return new ie(async ve=>{for await(const Ie of Z)me(Ie)&&ve.emitOne(Ie)})}filter(Z){return ie.filter(this,Z)}static coalesce(Z){return ie.filter(Z,me=>!!me)}coalesce(){return ie.coalesce(this)}static async toPromise(Z){const me=[];for await(const ve of Z)me.push(ve);return me}toPromise(){return ie.toPromise(this)}g(Z){this.a===0&&(this.b.push(Z),this.f.fire())}h(Z){this.a===0&&(this.b=this.b.concat(Z),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Z){this.a===0&&(this.a=2,this.d=Z,this.f.fire())}}ie.EMPTY=ie.fromArray([]),e.AsyncIterableObject=ie;class pe extends ie{constructor(Z,me){super(me),this.l=Z}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=pe;function Q(Y){const Z=new o.CancellationTokenSource,me=Y(Z.token);return new pe(Z,async ve=>{const Ie=Z.token.onCancellationRequested(()=>{Ie.dispose(),Z.dispose(),ve.reject(new A.CancellationError)});try{for await(const Re of me){if(Z.token.isCancellationRequested)return;ve.emitOne(Re)}Ie.dispose(),Z.dispose()}catch(Re){Ie.dispose(),Z.dispose(),ve.reject(Re)}})}e.createCancelableAsyncIterable=Q}),define(ye[38],De([1,0,15,19,33,28,11,10,8]),function(ne,e,o,A,a,R,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",T="[^/\\\\]",v=/\//g;function C(ae,ee){switch(ae){case 0:return"";case 1:return`${T}*?`;default:return`(?:${O}|${T}+${O}${ee?`|${O}${T}+`:""})*?`}}function y(ae,ee){if(!ae)return[];const x=[];let J=!1,ie=!1,pe="";for(const Q of ae){switch(Q){case ee:if(!J&&!ie){x.push(pe),pe="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}pe+=Q}return pe&&x.push(pe),x}e.splitGlobAware=y;function f(ae){if(!ae)return"";let ee="";const x=y(ae,e.GLOB_SPLIT);if(x.every(J=>J===e.GLOBSTAR))ee=".*";else{let J=!1;x.forEach((ie,pe)=>{if(ie===e.GLOBSTAR){if(J)return;ee+=C(2,pe===x.length-1)}else{let Q=!1,Y="",Z=!1,me="";for(const ve of ie){if(ve!=="}"&&Q){Y+=ve;continue}if(Z&&(ve!=="]"||!me)){let Ie;ve==="-"?Ie=ve:(ve==="^"||ve==="!")&&!me?Ie="^":ve===e.GLOB_SPLIT?Ie="":Ie=(0,S.escapeRegExpCharacters)(ve),me+=Ie;continue}switch(ve){case"{":Q=!0;continue;case"[":Z=!0;continue;case"}":{ee+=`(?:${y(Y,",").map(oe=>f(oe)).join("|")})`,Q=!1,Y="";break}case"]":{ee+="["+me+"]",Z=!1,me="";break}case"?":ee+=T;continue;case"*":ee+=C(1);continue;default:ee+=(0,S.escapeRegExpCharacters)(ve)}}pe<x.length-1&&(x[pe+1]!==e.GLOBSTAR||pe+2<x.length)&&(ee+=O)}J=ie===e.GLOBSTAR})}return ee}const h=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new R.LRUCache(1e4),s=function(){return!1},r=function(){return null};function c(ae,ee){if(!ae)return r;let x;typeof ae!="string"?x=ae.pattern:x=ae,x=x.trim();const J=`${x}_${!!ee.trimForExclusions}`;let ie=n.get(J);if(ie)return l(ie,ae);let pe;return h.test(x)?ie=i(x.substr(4),x):(pe=u.exec(m(x,ee)))?ie=t(pe[1],x):(ee.trimForExclusions?b:g).test(x)?ie=d(x,ee):(pe=D.exec(m(x,ee)))?ie=E(pe[1].substr(1),x,!0):(pe=p.exec(m(x,ee)))?ie=E(pe[1],x,!1):ie=w(x),n.set(J,ie),l(ie,ae)}function l(ae,ee){if(typeof ee=="string")return ae;const x=function(J,ie){return(0,a.isEqualOrParent)(J,ee.base,!P.isLinux)?ae((0,S.ltrim)(J.substr(ee.base.length),I.sep),ie):null};return x.allBasenames=ae.allBasenames,x.allPaths=ae.allPaths,x.basenames=ae.basenames,x.patterns=ae.patterns,x}function m(ae,ee){return ee.trimForExclusions&&ae.endsWith("/**")?ae.substr(0,ae.length-2):ae}function i(ae,ee){return function(x,J){return typeof x=="string"&&x.endsWith(ae)?ee:null}}function t(ae,ee){const x=`/${ae}`,J=`\\${ae}`,ie=function(Q,Y){return typeof Q!="string"?null:Y?Y===ae?ee:null:Q===ae||Q.endsWith(x)||Q.endsWith(J)?ee:null},pe=[ae];return ie.basenames=pe,ie.patterns=[ee],ie.allBasenames=pe,ie}function d(ae,ee){const x=$(ae.slice(1,-1).split(",").map(Y=>c(Y,ee)).filter(Y=>Y!==r),ae),J=x.length;if(!J)return r;if(J===1)return x[0];const ie=function(Y,Z){for(let me=0,ve=x.length;me<ve;me++)if(x[me](Y,Z))return ae;return null},pe=x.find(Y=>!!Y.allBasenames);pe&&(ie.allBasenames=pe.allBasenames);const Q=x.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return Q.length&&(ie.allPaths=Q),ie}function E(ae,ee,x){const J=I.sep===I.posix.sep,ie=J?ae:ae.replace(v,I.sep),pe=I.sep+ie,Q=I.posix.sep+ae;let Y;return x?Y=function(Z,me){return typeof Z=="string"&&(Z===ie||Z.endsWith(pe)||!J&&(Z===ae||Z.endsWith(Q)))?ee:null}:Y=function(Z,me){return typeof Z=="string"&&(Z===ie||!J&&Z===ae)?ee:null},Y.allPaths=[(x?"*/":"./")+ae],Y}function w(ae){try{const ee=new RegExp(`^${f(ae)}$`);return function(x){return ee.lastIndex=0,typeof x=="string"&&ee.test(x)?ae:null}}catch{return r}}function L(ae,ee,x){return!ae||typeof ee!="string"?!1:q(ae)(ee,void 0,x)}e.match=L;function q(ae,ee={}){if(!ae)return s;if(typeof ae=="string"||V(ae)){const x=c(ae,ee);if(x===r)return s;const J=function(ie,pe){return!!x(ie,pe)};return x.allBasenames&&(J.allBasenames=x.allBasenames),x.allPaths&&(J.allPaths=x.allPaths),J}return N(ae,ee)}e.parse=q;function V(ae){const ee=ae;return ee?typeof ee.base=="string"&&typeof ee.pattern=="string":!1}e.isRelativePattern=V;function M(ae){return ae.allBasenames||[]}e.getBasenameTerms=M;function B(ae){return ae.allPaths||[]}e.getPathTerms=B;function N(ae,ee){const x=$(Object.getOwnPropertyNames(ae).map(Y=>U(Y,ae[Y],ee)).filter(Y=>Y!==r)),J=x.length;if(!J)return r;if(!x.some(Y=>!!Y.requiresSiblings)){if(J===1)return x[0];const Y=function(ve,Ie){let Re;for(let oe=0,le=x.length;oe<le;oe++){const ue=x[oe](ve,Ie);if(typeof ue=="string")return ue;(0,A.isThenable)(ue)&&(Re||(Re=[]),Re.push(ue))}return Re?(async()=>{for(const oe of Re){const le=await oe;if(typeof le=="string")return le}return null})():null},Z=x.find(ve=>!!ve.allBasenames);Z&&(Y.allBasenames=Z.allBasenames);const me=x.reduce((ve,Ie)=>Ie.allPaths?ve.concat(Ie.allPaths):ve,[]);return me.length&&(Y.allPaths=me),Y}const ie=function(Y,Z,me){let ve,Ie;for(let Re=0,oe=x.length;Re<oe;Re++){const le=x[Re];le.requiresSiblings&&me&&(Z||(Z=(0,I.basename)(Y)),ve||(ve=Z.substr(0,Z.length-(0,I.extname)(Y).length)));const ue=le(Y,Z,ve,me);if(typeof ue=="string")return ue;(0,A.isThenable)(ue)&&(Ie||(Ie=[]),Ie.push(ue))}return Ie?(async()=>{for(const Re of Ie){const oe=await Re;if(typeof oe=="string")return oe}return null})():null},pe=x.find(Y=>!!Y.allBasenames);pe&&(ie.allBasenames=pe.allBasenames);const Q=x.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return Q.length&&(ie.allPaths=Q),ie}function U(ae,ee,x){if(ee===!1)return r;const J=c(ae,x);if(J===r)return r;if(typeof ee=="boolean")return J;if(ee){const ie=ee.when;if(typeof ie=="string"){const pe=(Q,Y,Z,me)=>{if(!me||!J(Q,Y))return null;const ve=ie.replace("$(basename)",()=>Z),Ie=me(ve);return(0,A.isThenable)(Ie)?Ie.then(Re=>Re?ae:null):Ie?ae:null};return pe.requiresSiblings=!0,pe}}return J}function $(ae,ee){const x=ae.filter(Y=>!!Y.basenames);if(x.length<2)return ae;const J=x.reduce((Y,Z)=>{const me=Z.basenames;return me?Y.concat(me):Y},[]);let ie;if(ee){ie=[];for(let Y=0,Z=J.length;Y<Z;Y++)ie.push(ee)}else ie=x.reduce((Y,Z)=>{const me=Z.patterns;return me?Y.concat(me):Y},[]);const pe=function(Y,Z){if(typeof Y!="string")return null;if(!Z){let ve;for(ve=Y.length;ve>0;ve--){const Ie=Y.charCodeAt(ve-1);if(Ie===47||Ie===92)break}Z=Y.substr(ve)}const me=J.indexOf(Z);return me!==-1?ie[me]:null};pe.basenames=J,pe.patterns=ie,pe.allBasenames=J;const Q=ae.filter(Y=>!Y.basenames);return Q.push(pe),Q}function z(ae,ee){return(0,o.equals)(ae,ee,(x,J)=>typeof x=="string"&&typeof J=="string"?x===J:typeof x!="string"&&typeof J!="string"?x.base===J.base&&x.pattern===J.pattern:!1)}e.patternsEquals=z}),define(ye[112],De([1,0,12,163,24,8,2]),function(ne,e,o,A,a,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(u="",g=!1){if(this.value=u,typeof this.value!="string")throw(0,o.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(u,g=0){return this.value+=v(this.supportThemeIcons?(0,A.escapeIcons)(u):u).replace(/([ \t]+)/g,(b,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,g){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(u,g,b){return this.value+="[",this.value+=this.c(g,"]"),this.value+="](",this.value+=this.c(String(u),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(u,g){const b=new RegExp((0,R.escapeRegExpCharacters)(g),"g");return u.replace(b,(D,p)=>u.charAt(p-1)!=="\\"?`\\${D}`:D)}}e.MarkdownString=S;function k(h){return O(h)?!h.value:Array.isArray(h)?h.every(k):!0}e.isEmptyMarkdownString=k;function O(h){return h instanceof S?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function T(h,u){return h===u?!0:!h||!u?!1:h.value===u.value&&h.isTrusted===u.isTrusted&&h.supportThemeIcons===u.supportThemeIcons&&h.supportHtml===u.supportHtml&&(h.baseUri===u.baseUri||!!h.baseUri&&!!u.baseUri&&(0,a.isEqual)(I.URI.from(h.baseUri),I.URI.from(u.baseUri)))}e.markdownStringEqual=T;function v(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function C(h){return h.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=C;function y(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=y;function f(h){const u=[],g=h.split("|").map(D=>D.trim());h=g[0];const b=g[1];if(b){const D=/height=(\d+)/.exec(b),p=/width=(\d+)/.exec(b),n=D?D[1]:"",s=p?p[1]:"",r=isFinite(parseInt(s)),c=isFinite(parseInt(n));r&&u.push(`width="${s}"`),c&&u.push(`height="${n}"`)}return{href:h,dimensions:u}}e.parseHrefAndDimensions=f}),define(ye[113],De([1,0,15,33,11,10,24,8]),function(ne,e,o,A,a,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(r,c){const{os:l,tildify:m,relative:i}=c;if(i){const E=k(r,i,l);if(typeof E=="string")return E}let t=r.fsPath;if(l===1&&!R.isWindows?t=t.replace(/\//g,"\\"):l!==1&&R.isWindows&&(t=t.replace(/\\/g,"/")),l!==1&&m?.userHome){const E=m.userHome.fsPath;let w;r.scheme!==m.userHome.scheme&&r.path.startsWith(a.posix.sep)?w=m.userHome.with({path:r.path}).fsPath:w=r.fsPath,t=v(w,E,l)}return(l===1?a.win32:a.posix).normalize(O(t,l===1))}e.getPathLabel=S;function k(r,c,l){const m=l===1?a.win32:a.posix,i=l===3?I.extUri:I.extUriIgnorePathCase,t=c.getWorkspace(),d=(0,o.firstOrDefault)(t.folders);if(!d)return;r.scheme!==d.uri.scheme&&r.path.startsWith(a.posix.sep)&&(r=d.uri.with({path:r.path}));const E=c.getWorkspaceFolder(r);if(!E)return;let w;if(i.isEqual(E.uri,r)?w="":w=i.relativePath(E.uri,r)??"",w&&(w=m.normalize(w)),t.folders.length>1&&!c.noPrefix){const L=E.name?E.name:i.basenameOrAuthority(E.uri);w=w?`${L} \u2022 ${w}`:L}return w}function O(r,c=R.isWindows){return(0,A.hasDriveLetter)(r,c)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=O;let T=Object.create(null);function v(r,c,l=R.OS){if(l===1||!r||!c)return r;let m=T.original===c?T.normalized:void 0;m||(m=c,R.isWindows&&(m=(0,A.toSlashes)(m)),m=`${(0,P.rtrim)(m,a.posix.sep)}${a.posix.sep}`,T={original:c,normalized:m});let i=r;return R.isWindows&&(i=(0,A.toSlashes)(i)),(l===3?i.startsWith(m):(0,P.startsWithIgnoreCase)(i,m))?`~/${i.substr(m.length)}`:r}e.tildify=v;function C(r,c){return r.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=C;const y="\u2026",f="\\\\",h="~";function u(r,c=a.sep){const l=new Array(r.length);let m=!1;for(let i=0;i<r.length;i++){const t=r[i];if(t===""){l[i]=`.${c}`;continue}if(!t){l[i]=t;continue}m=!0;let d="",E=t;E.indexOf(f)===0?(d=E.substr(0,E.indexOf(f)+f.length),E=E.substr(E.indexOf(f)+f.length)):E.indexOf(c)===0?(d=E.substr(0,E.indexOf(c)+c.length),E=E.substr(E.indexOf(c)+c.length)):E.indexOf(h)===0&&(d=E.substr(0,E.indexOf(h)+h.length),E=E.substr(E.indexOf(h)+h.length));const w=E.split(c);for(let L=1;m&&L<=w.length;L++)for(let q=w.length-L;m&&q>=0;q--){m=!1;let V=w.slice(q,q+L).join(c);for(let M=0;!m&&M<r.length;M++)if(M!==i&&r[M]&&r[M].indexOf(V)>-1){const B=q+L===w.length,N=q>0&&r[M].indexOf(c)>-1?c+V:V,U=r[M].endsWith(N);m=!B||U}if(!m){let M="";(w[0].endsWith(":")||d!=="")&&(q===1&&(q=0,L++,V=w[0]+c+V),q>0&&(M=w[0]+c),M=d+M),q>0&&(M=M+y+c),M=M+V,q+L<w.length&&(M=M+c+y),l[i]=M}}m&&(l[i]=t)}return l}e.shorten=u;var g;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function b(r,c=Object.create(null)){const l=[];let m=!1,i="";for(const t of r)if(t==="$"||m&&t==="{")i&&l.push({value:i,type:g.TEXT}),i="",m=!0;else if(t==="}"&&m){const d=c[i];if(typeof d=="string")d.length&&l.push({value:d,type:g.VARIABLE});else if(d){const E=l[l.length-1];(!E||E.type!==g.SEPARATOR)&&l.push({value:d.label,type:g.SEPARATOR})}i="",m=!1}else i+=t;return i&&!m&&l.push({value:i,type:g.TEXT}),l.filter((t,d)=>{if(t.type===g.SEPARATOR){const E=l[d-1],w=l[d+1];return[E,w].every(L=>L&&(L.type===g.VARIABLE||L.type===g.TEXT)&&L.value.length>0)}return!0}).map(t=>t.value).join("")}e.template=b;function D(r,c){return R.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):r.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function p(r,c){return R.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,""):R.isWindows?r.replace(/&&|&/g,l=>l==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(r){const c=r.indexOf("/")!==-1?a.posix:a.win32,l=c.basename(r),m=c.dirname(r);return l.length?{name:l,parentPath:m}:{name:m,parentPath:""}}e.splitName=s}),define(ye[114],De([1,0,22,2]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function a(T){return T.toJSON()}class R{constructor(v){this.a=v}transformIncoming(v){const C=this.a.transformIncoming(v);return C===v?v:a(A.URI.from(C))}transformOutgoing(v){const C=this.a.transformOutgoing(v);return C===v?v:a(A.URI.from(C))}transformOutgoingURI(v){const C=this.a.transformOutgoing(v);return C===v?v:A.URI.from(C)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function I(T,v,C){if(!T||C>200)return null;if(typeof T=="object"){if(T instanceof A.URI)return v.transformOutgoing(T);for(const y in T)if(Object.hasOwnProperty.call(T,y)){const f=I(T[y],v,C+1);f!==null&&(T[y]=f)}}return null}function P(T,v){const C=I(T,v,0);return C===null?T:C}e.transformOutgoingURIs=P;function S(T,v,C,y){if(!T||y>200)return null;if(typeof T=="object"){if(T.$mid===1)return C?A.URI.revive(v.transformIncoming(T)):v.transformIncoming(T);if(T instanceof o.VSBuffer)return null;for(const f in T)if(Object.hasOwnProperty.call(T,f)){const h=S(T[f],v,C,y+1);h!==null&&(T[f]=h)}}return null}function k(T,v){const C=S(T,v,!1,0);return C===null?T:C}e.transformIncomingURIs=k;function O(T,v){const C=S(T,v,!0,0);return C===null?T:C}e.transformAndReviveIncomingURIs=O}),define(ye[29],De([1,0,70,89,318,19,33,86,11,10,24,2]),function(ne,e,o,A,a,R,I,P,S,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function C(N,U=v.UNLINK){if((0,I.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return U===v.UNLINK?f(N):y(N)}async function y(N){try{const U=(0,I.randomPath)((0,A.tmpdir)());try{await o.promises.rename(N,U)}catch($){return $.code==="ENOENT"?void 0:f(N)}f(U).catch($=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function f(N){return(0,a.promisify)(o.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function h(N){if((0,I.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");o.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=h;async function u(N,U){return D(await(U?g(N):(0,a.promisify)(o.readdir)(N)))}async function g(N){try{return await(0,a.promisify)(o.readdir)(N,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const U=[],$=await u(N);for(const z of $){let ae=!1,ee=!1,x=!1;try{const J=await e.Promises.lstat((0,S.join)(N,z));ae=J.isFile(),ee=J.isDirectory(),x=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}U.push({name:z,isFile:()=>ae,isDirectory:()=>ee,isSymbolicLink:()=>x})}return U}function b(N){return D(o.readdirSync(N))}e.readdirSync=b;function D(N){return N.map(U=>typeof U=="string"?k.isMacintosh?(0,P.normalizeNFC)(U):U:(U.name=k.isMacintosh?(0,P.normalizeNFC)(U.name):U.name,U))}async function p(N){const U=await u(N),$=[];for(const z of U)await s.existsDirectory((0,S.join)(N,z))&&$.push(z);return $}function n(N,U=1e3){return new Promise($=>{let z=!1;const ae=setInterval(()=>{z||(z=!0,o.access(N,ee=>{z=!1,ee&&(clearInterval(ae),$(void 0))}))},U)})}e.whenDeleted=n;var s;(function(N){async function U(ae){let ee;try{if(ee=await e.Promises.lstat(ae),!ee.isSymbolicLink())return{stat:ee}}catch{}try{return{stat:await e.Promises.stat(ae),symbolicLink:ee?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&ee)return{stat:ee,symbolicLink:{dangling:!0}};if(k.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ae)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&ee)return{stat:ee,symbolicLink:{dangling:!0}};throw J}throw x}}N.stat=U;async function $(ae){try{const{stat:ee,symbolicLink:x}=await N.stat(ae);return ee.isFile()&&x?.dangling!==!0}catch{}return!1}N.existsFile=$;async function z(ae){try{const{stat:ee,symbolicLink:x}=await N.stat(ae);return ee.isDirectory()&&x?.dangling!==!0}catch{}return!1}N.existsDirectory=z})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new R.ResourceQueue;function c(N,U,$){return r.queueFor(T.URI.file(N),O.extUriBiasedIgnorePathCase).queue(()=>{const z=d($);return new Promise((ae,ee)=>i(N,U,z,x=>x?ee(x):ae()))})}let l=!0;function m(N){l=N}e.configureFlushOnWrite=m;function i(N,U,$,z){if(!l)return o.writeFile(N,U,{mode:$.mode,flag:$.flag},z);o.open(N,$.flag,$.mode,(ae,ee)=>{if(ae)return z(ae);o.writeFile(ee,U,x=>{if(x)return o.close(ee,()=>z(x));o.fdatasync(ee,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),m(!1)),o.close(ee,ie=>z(ie))))})})}function t(N,U,$){const z=d($);if(!l)return o.writeFileSync(N,U,{mode:z.mode,flag:z.flag});const ae=o.openSync(N,z.flag,z.mode);try{o.writeFileSync(ae,U);try{o.fdatasyncSync(ae)}catch(ee){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",ee),m(!1)}}finally{o.closeSync(ae)}}e.writeFileSync=t;function d(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function E(N,U){if(N!==U)try{await e.Promises.rename(N,U)}catch($){if(N.toLowerCase()!==U.toLowerCase()&&$.code==="EXDEV"||N.endsWith("."))await w(N,U,{preserveSymlinks:!1}),await C(N,v.MOVE);else throw $}}async function w(N,U,$){return q(N,U,{root:{source:N,target:U},options:$,handledSourcePaths:new Set})}const L=511;async function q(N,U,$){if($.handledSourcePaths.has(N))return;$.handledSourcePaths.add(N);const{stat:z,symbolicLink:ae}=await s.stat(N);if(ae){if($.options.preserveSymlinks)try{return await B(N,U,$)}catch(ee){console.warn("[node.js fs] copy of symlink failed: ",ee)}if(ae.dangling)return}return z.isDirectory()?V(N,U,z.mode&L,$):M(N,U,z.mode&L)}async function V(N,U,$,z){await e.Promises.mkdir(U,{recursive:!0,mode:$});const ae=await u(N);for(const ee of ae)await q((0,S.join)(N,ee),(0,S.join)(U,ee),z)}async function M(N,U,$){await e.Promises.copyFile(N,U),await e.Promises.chmod(U,$)}async function B(N,U,$){let z=await e.Promises.readlink(N);(0,I.isEqualOrParent)(z,$.root.source,!k.isLinux)&&(z=(0,S.join)($.root.target,z.substr($.root.source.length+1))),await e.Promises.symlink(z,U)}e.Promises=new class{get access(){return(0,a.promisify)(o.access)}get stat(){return(0,a.promisify)(o.stat)}get lstat(){return(0,a.promisify)(o.lstat)}get utimes(){return(0,a.promisify)(o.utimes)}get read(){return(N,U,$,z,ae)=>new Promise((ee,x)=>{o.read(N,U,$,z,ae,(J,ie,pe)=>J?x(J):ee({bytesRead:ie,buffer:pe}))})}get readFile(){return(0,a.promisify)(o.readFile)}get write(){return(N,U,$,z,ae)=>new Promise((ee,x)=>{o.write(N,U,$,z,ae,(J,ie,pe)=>J?x(J):ee({bytesWritten:ie,buffer:pe}))})}get appendFile(){return(0,a.promisify)(o.appendFile)}get fdatasync(){return(0,a.promisify)(o.fdatasync)}get truncate(){return(0,a.promisify)(o.truncate)}get rename(){return(0,a.promisify)(o.rename)}get copyFile(){return(0,a.promisify)(o.copyFile)}get open(){return(0,a.promisify)(o.open)}get close(){return(0,a.promisify)(o.close)}get symlink(){return(0,a.promisify)(o.symlink)}get readlink(){return(0,a.promisify)(o.readlink)}get chmod(){return(0,a.promisify)(o.chmod)}get mkdir(){return(0,a.promisify)(o.mkdir)}get unlink(){return(0,a.promisify)(o.unlink)}get rmdir(){return(0,a.promisify)(o.rmdir)}get realpath(){return(0,a.promisify)(o.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return p}get writeFile(){return c}get rm(){return C}get move(){return E}get copy(){return w}}}),define(ye[115],De([1,0,70,11,10,8,29]),function(ne,e,o,A,a,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(v){if(a.isLinux)return v;const C=(0,A.dirname)(v);if(v===C)return v;const y=((0,A.basename)(v)||v).toLowerCase();try{const h=(0,I.readdirSync)(C).filter(u=>u.toLowerCase()===y);if(h.length===1){const u=P(C);if(u)return(0,A.join)(u,h[0])}else if(h.length>1){const u=h.indexOf(y);if(u>=0){const g=P(C);if(g)return(0,A.join)(g,h[u])}}}catch{}return null}e.realcaseSync=P;async function S(v){if(a.isLinux)return v;const C=(0,A.dirname)(v);if(v===C)return v;const y=((0,A.basename)(v)||v).toLowerCase();try{const h=(await I.Promises.readdir(C)).filter(u=>u.toLowerCase()===y);if(h.length===1){const u=await S(C);if(u)return(0,A.join)(u,h[0])}else if(h.length>1){const u=h.indexOf(y);if(u>=0){const g=await S(C);if(g)return(0,A.join)(g,h[u])}}}catch{}return null}e.realcase=S;async function k(v){try{return await I.Promises.realpath(v)}catch{const y=T(v);return await I.Promises.access(y,o.constants.R_OK),y}}e.realpath=k;function O(v){try{return o.realpathSync(v)}catch{const y=T(v);return o.accessSync(y,o.constants.R_OK),y}}e.realpathSync=O;function T(v){return(0,R.rtrim)((0,A.normalize)(v),A.sep)}}),define(ye[116],De([1,0,11,10,36,109,9,29]),function(ne,e,o,A,a,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function S(T=a.env){return T.comspec||"cmd.exe"}e.getWindowsShell=S;function k(T){let v=[],C=!1;const y=function(f){if(C){v.push(f);return}(!T.send(f,u=>{if(u&&console.error(u),C=!1,v.length>0){const g=v.slice(0);v=[],g.forEach(b=>y(b))}})||A.isWindows)&&(C=!0)};return{send:y}}e.createQueuedSender=k;var O;(function(T){async function v(C,y,f){if(o.isAbsolute(C))return C;if(y===void 0&&(y=a.cwd()),o.dirname(C)!=="."||(f===void 0&&I.isString(a.env.PATH)&&(f=a.env.PATH.split(o.delimiter)),f===void 0||f.length===0))return o.join(y,C);async function u(g){if(await P.Promises.exists(g)){let b;try{b=await P.Promises.stat(g)}catch(D){D.message.startsWith("EACCES")&&(b=await P.Promises.lstat(g))}return b?!b.isDirectory():!1}return!1}for(const g of f){let b;if(o.isAbsolute(g)?b=o.join(g,C):b=o.join(y,g,C),await u(b))return b;let D=b+".com";if(await u(D)||(D=b+".exe",await u(D)))return D}return o.join(y,C)}T.findExecutable=v})(O=e.win32||(e.win32={}))});var xe=this&&this.__decorate||function(ne,e,o,A){var a=arguments.length,R=a<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,o):A,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ne,e,o,A);else for(var P=ne.length-1;P>=0;P--)(I=ne[P])&&(R=(a<3?I(R):a>3?I(e,o,R):I(e,o))||R);return a>3&&R&&Object.defineProperty(e,o,R),R};define(ye[117],De([1,0,15,19,22,21,62,12,3,6,69,8,9]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var C;(function(ee){ee[ee.Promise=100]="Promise",ee[ee.PromiseCancel=101]="PromiseCancel",ee[ee.EventListen=102]="EventListen",ee[ee.EventDispose=103]="EventDispose"})(C||(C={}));function y(ee){switch(ee){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(ee){ee[ee.Initialize=200]="Initialize",ee[ee.PromiseSuccess=201]="PromiseSuccess",ee[ee.PromiseError=202]="PromiseError",ee[ee.PromiseErrorObj=203]="PromiseErrorObj",ee[ee.EventFire=204]="EventFire"})(f||(f={}));function h(ee){switch(ee){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(ee){ee[ee.Uninitialized=0]="Uninitialized",ee[ee.Idle=1]="Idle"})(u||(u={}));function g(ee){let x=0;for(let J=0;;J+=7){const ie=ee.read(1);if(x|=(ie.buffer[0]&127)<<J,!(ie.buffer[0]&128))return x}}const b=r(0);function D(ee,x){if(x===0){ee.write(b);return}let J=0;for(let pe=x;pe!==0;pe=pe>>>7)J++;const ie=a.VSBuffer.alloc(J);for(let pe=0;x!==0;pe++)ie.buffer[pe]=x&127,x=x>>>7,x>0&&(ie.buffer[pe]|=128);ee.write(ie)}class p{constructor(x){this.b=x,this.a=0}read(x){const J=this.b.slice(this.a,this.a+x);return this.a+=J.byteLength,J}}e.BufferReader=p;class n{constructor(){this.a=[]}get buffer(){return a.VSBuffer.concat(this.a)}write(x){this.a.push(x)}}e.BufferWriter=n;var s;(function(ee){ee[ee.Undefined=0]="Undefined",ee[ee.String=1]="String",ee[ee.Buffer=2]="Buffer",ee[ee.VSBuffer=3]="VSBuffer",ee[ee.Array=4]="Array",ee[ee.Object=5]="Object",ee[ee.Int=6]="Int"})(s||(s={}));function r(ee){const x=a.VSBuffer.alloc(1);return x.writeUInt8(ee,0),x}const c={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object),Uint:r(s.Int)},l=typeof Buffer<"u";function m(ee,x){if(typeof x>"u")ee.write(c.Undefined);else if(typeof x=="string"){const J=a.VSBuffer.fromString(x);ee.write(c.String),D(ee,J.byteLength),ee.write(J)}else if(l&&Buffer.isBuffer(x)){const J=a.VSBuffer.wrap(x);ee.write(c.Buffer),D(ee,J.byteLength),ee.write(J)}else if(x instanceof a.VSBuffer)ee.write(c.VSBuffer),D(ee,x.byteLength),ee.write(x);else if(Array.isArray(x)){ee.write(c.Array),D(ee,x.length);for(const J of x)m(ee,J)}else if(typeof x=="number"&&(x|0)===x)ee.write(c.Uint),D(ee,x);else{const J=a.VSBuffer.fromString(JSON.stringify(x));ee.write(c.Object),D(ee,J.byteLength),ee.write(J)}}e.serialize=m;function i(ee){switch(ee.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return ee.read(g(ee)).toString();case s.Buffer:return ee.read(g(ee)).buffer;case s.VSBuffer:return ee.read(g(ee));case s.Array:{const J=g(ee),ie=[];for(let pe=0;pe<J;pe++)ie.push(i(ee));return ie}case s.Object:return JSON.parse(ee.read(g(ee)).toString());case s.Int:return g(ee)}}e.deserialize=i;class t{constructor(x,J,ie=null,pe=1e3){this.h=x,this.j=J,this.k=ie,this.l=pe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Q=>this.q(Q)),this.m({type:200})}registerChannel(x,J){this.b.set(x,J),setTimeout(()=>this.w(x),0)}m(x){switch(x.type){case 200:{const J=this.o([x.type]);this.k?.logOutgoing(J,0,1,h(x.type));return}case 201:case 202:case 204:case 203:{const J=this.o([x.type,x.id],x.data);this.k?.logOutgoing(J,x.id,1,h(x.type),x.data);return}}}o(x,J=void 0){const ie=new n;return m(ie,x),m(ie,J),this.p(ie.buffer)}p(x){try{return this.h.send(x),x.byteLength}catch{return 0}}q(x){const J=new p(x),ie=i(J),pe=i(J),Q=ie[0];switch(Q){case 100:return this.k?.logIncoming(x.byteLength,ie[1],1,`${y(Q)}: ${ie[2]}.${ie[3]}`,pe),this.s({type:Q,id:ie[1],channelName:ie[2],name:ie[3],arg:pe});case 102:return this.k?.logIncoming(x.byteLength,ie[1],1,`${y(Q)}: ${ie[2]}.${ie[3]}`,pe),this.t({type:Q,id:ie[1],channelName:ie[2],name:ie[3],arg:pe});case 101:return this.k?.logIncoming(x.byteLength,ie[1],1,`${y(Q)}`),this.u({type:Q,id:ie[1]});case 103:return this.k?.logIncoming(x.byteLength,ie[1],1,`${y(Q)}`),this.u({type:Q,id:ie[1]})}}s(x){const J=this.b.get(x.channelName);if(!J){this.v(x);return}const ie=new R.CancellationTokenSource;let pe;try{pe=J.call(this.j,x.name,x.arg,ie.token)}catch(Z){pe=Promise.reject(Z)}const Q=x.id;pe.then(Z=>{this.m({id:Q,data:Z,type:201}),this.d.delete(x.id)},Z=>{Z instanceof Error?this.m({id:Q,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.m({id:Q,data:Z,type:203}),this.d.delete(x.id)});const Y=(0,k.toDisposable)(()=>ie.cancel());this.d.set(x.id,Y)}t(x){const J=this.b.get(x.channelName);if(!J){this.v(x);return}const ie=x.id,Q=J.listen(this.j,x.name,x.arg)(Y=>this.m({id:ie,data:Y,type:204}));this.d.set(x.id,Q)}u(x){const J=this.d.get(x.id);J&&(J.dispose(),this.d.delete(x.id))}v(x){let J=this.g.get(x.channelName);J||(J=[],this.g.set(x.channelName,J));const ie=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.m({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:x,timeoutTimer:ie})}w(x){const J=this.g.get(x);if(J){for(const ie of J)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(x)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,k.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=t;var d;(function(ee){ee[ee.LocalSide=0]="LocalSide",ee[ee.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(x,J=null){this.l=x,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=J}getChannel(x){const J=this;return{call(ie,pe,Q){return J.a?Promise.reject(new P.CancellationError):J.m(x,ie,pe,Q)},listen(ie,pe){return J.a?S.Event.None:J.o(x,ie,pe)}}}m(x,J,ie,pe=R.CancellationToken.None){const Q=this.g++,Z={id:Q,type:100,channelName:x,name:J,arg:ie};if(pe.isCancellationRequested)return Promise.reject(new P.CancellationError);let me;return new Promise((Ie,Re)=>{if(pe.isCancellationRequested)return Re(new P.CancellationError);const oe=()=>{const ce=se=>{switch(se.type){case 201:this.f.delete(Q),Ie(se.data);break;case 202:{this.f.delete(Q);const F=new Error(se.data.message);F.stack=Array.isArray(se.data.stack)?se.data.stack.join(`
`):se.data.stack,F.name=se.data.name,Re(F);break}case 203:this.f.delete(Q),Re(se.data);break}};this.f.set(Q,ce),this.p(Z)};let le=null;this.b===u.Idle?oe():(le=(0,A.createCancelablePromise)(ce=>this.u()),le.then(()=>{le=null,oe()}));const ue=()=>{le?(le.cancel(),le=null):this.p({id:Q,type:101}),Re(new P.CancellationError)},te=pe.onCancellationRequested(ue);me=(0,k.combinedDisposable)((0,k.toDisposable)(ue),te),this.d.add(me)}).finally(()=>{this.d.delete(me)})}o(x,J,ie){const pe=this.g++,Y={id:pe,type:102,channelName:x,name:J,arg:ie};let Z=null;const me=new S.Emitter({onWillAddFirstListener:()=>{Z=(0,A.createCancelablePromise)(Ie=>this.u()),Z.then(()=>{Z=null,this.d.add(me),this.p(Y)})},onDidRemoveLastListener:()=>{Z?(Z.cancel(),Z=null):(this.d.delete(me),this.p({id:pe,type:103}))}}),ve=Ie=>me.fire(Ie.data);return this.f.set(pe,ve),me.event}p(x){switch(x.type){case 100:case 102:{const J=this.q([x.type,x.id,x.channelName,x.name],x.arg);this.j?.logOutgoing(J,x.id,0,`${y(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const J=this.q([x.type,x.id]);this.j?.logOutgoing(J,x.id,0,y(x.type));return}}}q(x,J=void 0){const ie=new n;return m(ie,x),m(ie,J),this.r(ie.buffer)}r(x){try{return this.l.send(x),x.byteLength}catch{return 0}}s(x){const J=new p(x),ie=i(J),pe=i(J),Q=ie[0];switch(Q){case 200:return this.j?.logIncoming(x.byteLength,0,0,h(Q)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(x.byteLength,ie[1],0,h(Q),pe),this.t({type:ie[0],id:ie[1],data:pe})}}t(x){if(x.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(x.id)?.(x)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,k.dispose)(this.d.values()),this.d.clear()}}xe([I.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class w{get connections(){const x=[];return this.f.forEach(J=>x.push(J)),x}constructor(x){this.a=new Map,this.f=new Set,this.g=new S.Emitter,this.onDidAddConnection=this.g.event,this.h=new S.Emitter,this.onDidRemoveConnection=this.h.event,x(({protocol:J,onDidClientDisconnect:ie})=>{S.Event.once(J.onMessage)(Q=>{const Y=new p(Q),Z=i(Y),me=new t(J,Z),ve=new E(J);this.a.forEach((Re,oe)=>me.registerChannel(oe,Re));const Ie={channelServer:me,channelClient:ve,ctx:Z};this.f.add(Ie),this.g.fire(Ie),ie(()=>{me.dispose(),ve.dispose(),this.f.delete(Ie),this.h.fire(Ie)})})})}getChannel(x,J){const ie=this;return{call(pe,Q,Y){let Z;if((0,v.isFunction)(J)){const ve=(0,o.getRandomElement)(ie.connections.filter(J));Z=ve?Promise.resolve(ve):S.Event.toPromise(S.Event.filter(ie.onDidAddConnection,J))}else Z=J.routeCall(ie,pe,Q);const me=Z.then(ve=>ve.channelClient.getChannel(x));return q(me).call(pe,Q,Y)},listen(pe,Q){if((0,v.isFunction)(J))return ie.j(x,J,pe,Q);const Y=J.routeEvent(ie,pe,Q).then(Z=>Z.channelClient.getChannel(x));return q(Y).listen(pe,Q)}}}j(x,J,ie,pe){const Q=this;let Y=new k.DisposableStore;const Z=new S.Emitter({onWillAddFirstListener:()=>{Y=new k.DisposableStore;const me=new S.EventMultiplexer,ve=new Map,Ie=oe=>{const ue=oe.channelClient.getChannel(x).listen(ie,pe),te=me.add(ue);ve.set(oe,te)},Re=oe=>{const le=ve.get(oe);!le||(le.dispose(),ve.delete(oe))};Q.connections.filter(J).forEach(Ie),S.Event.filter(Q.onDidAddConnection,J)(Ie,void 0,Y),Q.onDidRemoveConnection(Re,void 0,Y),me.event(Z.fire,Z,Y),Y.add(me)},onDidRemoveLastListener:()=>{Y.dispose()}});return Z.event}registerChannel(x,J){this.a.set(x,J),this.f.forEach(ie=>{ie.channelServer.registerChannel(x,J)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=w;class L{constructor(x,J,ie=null){const pe=new n;m(pe,J),x.send(pe.buffer),this.a=new E(x,ie),this.d=new t(x,J,ie)}getChannel(x){return this.a.getChannel(x)}registerChannel(x,J){this.d.registerChannel(x,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=L;function q(ee){return{call(x,J,ie){return ee.then(pe=>pe.call(x,J,ie))},listen(x,J){const ie=new S.Relay;return ee.then(pe=>ie.input=pe.listen(x,J)),ie.event}}}e.getDelayedChannel=q;function V(ee){let x=!1;return{call(J,ie,pe){return x?ee.call(J,ie,pe):(0,A.timeout)(0).then(()=>x=!0).then(()=>ee.call(J,ie,pe))},listen(J,ie){if(x)return ee.listen(J,ie);const pe=new S.Relay;return(0,A.timeout)(0).then(()=>x=!0).then(()=>pe.input=ee.listen(J,ie)),pe.event}}}e.getNextTickChannel=V;class M{constructor(x){this.a=x}routeCall(x){return this.b(x)}routeEvent(x){return this.b(x)}async b(x){for(const J of x.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await S.Event.toPromise(x.onDidAddConnection),await this.b(x)}}e.StaticRouter=M;var B;(function(ee){function x(Q,Y){const Z=Q,me=Y&&Y.disableMarshalling,ve=new Map;for(const Ie in Z)ie(Ie)&&ve.set(Ie,S.Event.buffer(Z[Ie],!0));return new class{listen(Ie,Re,oe){const le=ve.get(Re);if(le)return le;if(pe(Re)){const ue=Z[Re];if(typeof ue=="function")return ue.call(Z,oe)}throw new Error(`Event not found: ${Re}`)}call(Ie,Re,oe){const le=Z[Re];if(typeof le=="function"){if(!me&&Array.isArray(oe))for(let ue=0;ue<oe.length;ue++)oe[ue]=(0,O.revive)(oe[ue]);return le.apply(Z,oe)}throw new Error(`Method not found: ${Re}`)}}}ee.fromService=x;function J(Q,Y){const Z=Y&&Y.disableMarshalling;return new Proxy({},{get(me,ve){if(typeof ve=="string")return Y?.properties?.has(ve)?Y.properties.get(ve):pe(ve)?function(Ie){return Q.listen(ve,Ie)}:ie(ve)?Q.listen(ve):async function(...Ie){let Re;Y&&!(0,v.isUndefinedOrNull)(Y.context)?Re=[Y.context,...Ie]:Re=Ie;const oe=await Q.call(ve,Re);return Z?oe:(0,O.revive)(oe)};throw new Error(`Property not found: ${String(ve)}`)}})}ee.toService=J;function ie(Q){return Q[0]==="o"&&Q[1]==="n"&&T.isUpperAsciiLetter(Q.charCodeAt(2))}function pe(Q){return/^onDynamic/.test(Q)&&T.isUpperAsciiLetter(Q.charCodeAt(9))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(ee){if(Array.isArray(ee))return ee;if(ee&&typeof ee=="object"&&typeof ee.toString=="function"){const x=ee.toString();if(x!=="[object Object]")return x}return ee}function $(ee){return Array.isArray(ee)?ee.map(U):U(ee)}function z(ee,x,J,ie,pe,Q,Y){Y=$(Y);const Z=N[pe],me=Z[ie%Z.length];let ve=[`%c[${ee}]%c[${String(x).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${me}`];/\($/.test(Q)?(ve=ve.concat(Y),ve.push(")")):ve.push(Y),console.log.apply(console,ve)}class ae{constructor(x,J){this.d=x,this.f=J,this.a=0,this.b=0}logOutgoing(x,J,ie,pe,Q){this.b+=x,z(this.d,this.b,x,J,ie,pe,Q)}logIncoming(x,J,ie,pe,Q){this.a+=x,z(this.f,this.a,x,J,ie,pe,Q)}}e.IPCLogger=ae}),define(ye[118],De([1,0,19,22,3,6,117]),function(ne,e,o,A,a,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var S;(function(E){E.enableDiagnostics=!1,E.records=[];const w=new WeakMap;let L=0;function q(M,B){if(!w.has(M)){const N=String(++L);w.set(M,N)}return w.get(M)}function V(M,B,N,U){if(!E.enableDiagnostics)return;const $=q(M,B);if(U instanceof A.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const z=A.VSBuffer.alloc(U.byteLength);z.set(U),E.records.push({timestamp:Date.now(),id:$,label:B,type:N,buff:z})}else E.records.push({timestamp:Date.now(),id:$,label:B,type:N,data:U})}E.traceSocketEvent=V})(S=e.SocketDiagnostics||(e.SocketDiagnostics={}));var k;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k=e.SocketCloseEventType||(e.SocketCloseEventType={}));let O=null;function T(){return O||(O=A.VSBuffer.alloc(0)),O}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(w){this.a.push(w),this.b+=w.byteLength}read(w){return this.c(w,!0)}peek(w){return this.c(w,!1)}c(w,L){if(w===0)return T();if(w>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===w){const B=this.a[0];return L&&(this.a.shift(),this.b-=w),B}if(this.a[0].byteLength>w){const B=this.a[0].slice(0,w);return L&&(this.a[0]=this.a[0].slice(w),this.b-=w),B}const q=A.VSBuffer.alloc(w);let V=0,M=0;for(;w>0;){const B=this.a[M];if(B.byteLength>w){const N=B.slice(0,w);q.set(N,V),V+=w,L&&(this.a[M]=B.slice(w),this.b-=w),w-=w}else q.set(B,V),V+=B.byteLength,L?(this.a.shift(),this.b-=B.byteLength):M++,w-=B.byteLength}return q}}e.ChunkStream=v;var C;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(C||(C={}));function y(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var f;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(w,L,q,V){this.type=w,this.id=L,this.ack=q,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends R.Disposable{constructor(w){super(),this.f=this.B(new a.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=w,this.b=!1,this.c=new v,this.B(this.a.onData(L=>this.acceptChunk(L))),this.lastReadTime=Date.now()}acceptChunk(w){if(!(!w||w.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(w);this.c.byteLength>=this.g.readLen;){const L=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=L.readUInt32BE(9),this.g.messageType=L.readUInt8(0),this.g.id=L.readUInt32BE(1),this.g.ack=L.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const q=this.g.messageType,V=this.g.id,M=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",L),this.f.fire(new h(q,V,M,L)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(w){this.k=null,this.a=!1,this.b=!1,this.c=w,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(w){if(this.a)return;w.writtenTime=Date.now(),this.lastWriteTime=Date.now();const L=A.VSBuffer.alloc(13);L.writeUInt8(w.type,0),L.writeUInt32BE(w.id,1),L.writeUInt32BE(w.ack,5),L.writeUInt32BE(w.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(w.type),id:w.id,ack:w.ack,messageSize:w.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",w.data),this.j(L,w.data)}g(w,L){const q=this.f===0;return this.d.push(w,L),this.f+=w.byteLength+L.byteLength,q}h(){const w=A.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,w}j(w,L){this.g(w,L)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const w=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:w.byteLength}),this.c.write(w)}}class b extends R.Disposable{constructor(w){super(),this.f=new a.Emitter,this.onMessage=this.f.event,this.g=new a.Emitter,this.onDidDispose=this.g.event,this.a=w,this.b=this.B(new g(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(L=>{L.type===1&&this.f.fire(L.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(w){this.b.write(new h(1,0,0,w))}}e.Protocol=b;class D extends I.IPCClient{static fromSocket(w,L){return new D(new b(w),L)}get onDidDispose(){return this.b.onDidDispose}constructor(w,L,q=null){super(w,L,q),this.b=w}dispose(){super.dispose();const w=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),w.end()}}e.Client=D;class p{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new a.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(w){this.b?this.d.length>0?this.d.push(w):this.a.fire(w):this.d.push(w)}flushBuffer(){this.d=[]}}e.BufferedEmitter=p;class n{constructor(w){this.data=w,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let w=0,L=this.a;for(;L;)L=L.next,w++;return w}peek(){return this.a?this.a.data:null}toArray(){const w=[];let L=0,q=this.a;for(;q;)w[L++]=q.data,q=q.next;return w}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(w){const L=new n(w);if(!this.a){this.a=L,this.b=L;return}this.b.next=L,this.b=L}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const w=Date.now();for(let L=0;L<r.a;L++)this.c[L]=w-1e3*L;setInterval(()=>{for(let L=r.a;L>=1;L--)this.c[L]=this.c[L-1];this.c[0]=Date.now()},1e3)}d(){const w=Date.now(),L=(1+r.a)*1e3;let q=0;for(let V=0;V<r.a;V++)w-this.c[V]<=L&&q++;return 1-q/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;var c;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(c=e.ConnectionHealth||(e.ConnectionHealth={}));function l(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=l;class m{constructor(w){this.connectionHealth=w}}e.ConnectionHealthChangedEvent=m;class i{constructor(w,L){this.roundTripTime=w,this.recentHighRoundTripCount=L}}e.HighRoundTripTimeEvent=i;class t{get unacknowledgedCount(){return this.c-this.d}constructor(w){this.x=new p,this.onControlMessage=this.x.event,this.y=new p,this.onMessage=this.y.event,this.z=new p,this.onDidDispose=this.z.event,this.A=new p,this.onSocketClose=this.A.event,this.B=new p,this.onSocketTimeout=this.B.event,this.C=new p,this.onHighRoundTripTime=this.C.event,this.D=new p,this.onDidChangeConnectionHealth=this.D.event,this.u=w.loadEstimator??r.getInstance(),this.v=w.measureRoundTripTime??!1,this.w=w.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=w.socket,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(L=>this.E(L))),this.t.add(this.o.onClose(L=>this.A.fire(L))),this.r=this.t.add(new d),this.t.add(this.r.onSendLatencyRequest(L=>this.J(L))),this.t.add(this.r.onHighRoundTripTime(L=>this.C.fire(L))),this.t.add(this.r.onDidChangeConnectionHealth(L=>this.D.fire(L))),this.v&&this.r.start(),w.initialChunk&&this.q.acceptChunk(w.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const w=new h(5,0,0,T());this.p.write(w),this.p.flush()}sendPause(){const w=new h(7,0,0,T());this.p.write(w)}sendResume(){const w=new h(8,0,0,T());this.p.write(w)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(w,L){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=w,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(q=>this.E(q))),this.t.add(this.o.onClose(q=>this.A.fire(q))),this.r=this.t.add(new d),this.t.add(this.r.onSendLatencyRequest(q=>this.J(q))),this.t.add(this.r.onHighRoundTripTime(q=>this.C.fire(q))),this.t.add(this.r.onDidChangeConnectionHealth(q=>this.D.fire(q))),this.q.acceptChunk(L)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const w=new h(3,0,this.h,T());this.p.write(w);const L=this.b.toArray();for(let q=0,V=L.length;q<V;q++)this.p.write(L[q]);this.G()}acceptDisconnect(){this.z.fire()}E(w){if(w.ack>this.d){this.d=w.ack;do{const L=this.b.peek();if(L&&L.id<=w.ack)this.b.pop();else break}while(!0)}switch(w.type){case 0:break;case 1:{if(w.id>this.g)if(w.id!==this.g+1){const L=Date.now();L-this.m>1e4&&(this.m=L,this.p.write(new h(6,0,0,T())))}else this.g=w.id,this.j=Date.now(),this.F(),this.y.fire(w.data);break}case 2:{this.x.fire(w.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const L=this.b.toArray();for(let q=0,V=L.length;q<V;q++)this.p.write(L[q]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(w.data);break}case 11:{this.r.handleResponse(w.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(w){const L=++this.c;this.h=this.g;const q=new h(1,L,this.h,w);this.b.push(q),this.a||(this.p.write(q),this.G())}sendControl(w){const L=new h(2,0,0,w);this.p.write(L)}F(){if(this.g<=this.h||this.k)return;const w=Date.now()-this.j;if(w>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-w+5)}G(){if(this.c<=this.d||this.f||this.a)return;const w=this.b.peek(),L=Date.now()-w.writtenTime,q=Date.now()-this.q.lastReadTime,V=Date.now()-this.n;if(L>=2e4&&q>=2e4&&V>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:L,timeSinceLastReceivedSomeData:q});return}const M=Math.max(2e4-L,2e4-q,2e4-V,500);this.f=setTimeout(()=>{this.f=null,this.G()},M)}H(){if(this.g<=this.h)return;this.h=this.g;const w=new h(3,0,this.h,T());this.p.write(w)}I(){this.h=this.g;const w=new h(9,0,this.h,T());this.p.write(w)}J(w){this.h=this.g;const L=new h(10,0,this.h,w);this.p.write(L)}K(w){this.h=this.g;const L=new h(11,0,this.h,w);this.p.write(L)}}e.PersistentProtocol=t;class d extends R.Disposable{constructor(){super(),this.a=this.B(new a.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new a.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new a.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new o.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},w=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const w=++this.h,L=A.VSBuffer.alloc(4);L.writeUInt32BE(w,0),this.a.fire(L)},6e4)}handleResponse(w){if(w.byteLength!==4)return;const L=w.readUInt32BE(0);if(this.g<=0||L!==this.h)return;const q=Date.now()-this.g,V=this.k++;this.j[V%this.j.length]=q;const M=this.l,B=this.j.filter(N=>N>=1e3).length;this.l=B>=3?1:0,q>1e3&&this.b.fire(new i(q,B)),M!==this.l&&this.c.fire(this.l)}}}),define(ye[119],De([1,0,22,12,3,6,11,10,30,117,118]),function(ne,e,o,A,a,R,I,P,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function T(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class v{traceSocketEvent(i,t){O.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,i,t)}constructor(i,t=""){this.f=!0,this.debugLabel=t,this.socket=i,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=d=>{if(this.traceSocketEvent("error",{code:d?.code,message:d?.message}),d){if(d.code==="EPIPE")return;(0,A.onUnexpectedError)(d)}},this.socket.on("error",this.a),this.b=d=>{this.traceSocketEvent("close",{hadError:d}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(i){const t=d=>{this.traceSocketEvent("read",d),i(o.VSBuffer.wrap(d))};return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(i){const t=d=>{i({type:0,hadError:d,error:void 0})};return this.socket.on("close",t),{dispose:()=>this.socket.off("close",t)}}onEnd(i){const t=()=>{i()};return this.socket.on("end",t),{dispose:()=>this.socket.off("end",t)}}write(i){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",i),this.socket.write(i.buffer,t=>{if(t){if(t.code==="EPIPE")return;(0,A.onUnexpectedError)(t)}})}catch(t){if(t.code==="EPIPE")return;(0,A.onUnexpectedError)(t)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((i,t)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),i();return}const d=()=>{this.socket.off("close",d),this.socket.off("end",d),this.socket.off("error",d),this.socket.off("timeout",d),this.socket.off("drain",d),this.traceSocketEvent("nodeDrainEnd"),i()};this.socket.on("close",d),this.socket.on("end",d),this.socket.on("error",d),this.socket.on("timeout",d),this.socket.on("drain",d)})}}e.NodeSocket=v;var C;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(C||(C={}));var y;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(y||(y={}));class f extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(i,t){this.socket.traceSocketEvent(i,t)}constructor(i,t,d,E){super(),this.f=this.B(new a.Emitter),this.g=this.B(new a.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=i,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:t,inflateBytesLength:d?.byteLength||0,recordInflateBytes:E}),this.a=this.B(new h(this,t,d,E,this.f,(w,L)=>this.k(w,L))),this.B(this.a.onError(w=>{console.error(w),(0,A.onUnexpectedError)(w),this.g.fire({type:0,hadError:!0,error:w})})),this.b=new O.ChunkStream,this.B(this.socket.onData(w=>this.l(w))),this.B(this.socket.onClose(w=>this.g.fire(w)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(i){return this.f.event(i)}onClose(i){return this.g.event(i)}onEnd(i){return this.socket.onEnd(i)}write(i){this.a.writeMessage(i)}k(i,t){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",i);let d=2;i.byteLength<126?d+=0:i.byteLength<2**16?d+=2:d+=8;const E=o.VSBuffer.alloc(d);if(t?E.writeUInt8(194,0):E.writeUInt8(130,0),i.byteLength<126)E.writeUInt8(i.byteLength,1);else if(i.byteLength<2**16){E.writeUInt8(126,1);let w=1;E.writeUInt8(i.byteLength>>>8&255,++w),E.writeUInt8(i.byteLength>>>0&255,++w)}else{E.writeUInt8(127,1);let w=1;E.writeUInt8(0,++w),E.writeUInt8(0,++w),E.writeUInt8(0,++w),E.writeUInt8(0,++w),E.writeUInt8(i.byteLength>>>24&255,++w),E.writeUInt8(i.byteLength>>>16&255,++w),E.writeUInt8(i.byteLength>>>8&255,++w),E.writeUInt8(i.byteLength>>>0&255,++w)}this.socket.write(o.VSBuffer.concat([E,i]))}end(){this.h=!0,this.socket.end()}l(i){if(i.byteLength!==0){for(this.b.acceptChunk(i);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const t=this.b.peek(this.j.readLen),d=t.readUInt8(0),E=(d&128)>>>7,w=(d&64)>>>6,L=t.readUInt8(1),q=(L&128)>>>7,V=L&127;this.j.state=2,this.j.readLen=2+(q?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=E,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(w)),this.j.firstFrameOfMessage=Boolean(E),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const t=this.b.read(this.j.readLen),d=t.readUInt8(1),E=(d&128)>>>7;let w=d&127,L=1;w===126?w=t.readUInt8(++L)*2**8+t.readUInt8(++L):w===127&&(w=t.readUInt8(++L)*0+t.readUInt8(++L)*0+t.readUInt8(++L)*0+t.readUInt8(++L)*0+t.readUInt8(++L)*2**24+t.readUInt8(++L)*2**16+t.readUInt8(++L)*2**8+t.readUInt8(++L));let q=0;E&&(q=t.readUInt8(++L)*2**24+t.readUInt8(++L)*2**16+t.readUInt8(++L)*2**8+t.readUInt8(++L)),this.j.state=3,this.j.readLen=w,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const t=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",t),b(t,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",t),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(t,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await a.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=f;class h extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:o.VSBuffer.alloc(0)}constructor(i,t,d,E,w,L){super(),this.k=i,this.l=w,this.m=L,this.a=this.B(new a.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new a.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,t?(this.b=this.B(new u(this.k,E,d,{windowBits:15})),this.f=this.B(new g(this.k,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(i){this.g.push(i),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const i=this.g.shift();if(this.f){const t=await this.r(this.f,i);this.m(t,!0)}else this.m(i,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(i,t){return new Promise((d,E)=>{i.write(t),i.flush(w=>d(w))})}acceptFrame(i,t,d){this.h.push({data:i,isCompressed:t,isLastFrameOfMessage:d}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const i=this.h.shift();if(this.b&&i.isCompressed){const t=await this.u(this.b,i.data,i.isLastFrameOfMessage);this.l.fire(t)}else this.l.fire(i.data)}this.s=!1}}u(i,t,d){return new Promise((E,w)=>{i.write(t),d&&i.write(o.VSBuffer.fromByteArray([0,0,255,255])),i.flush(L=>E(L))})}}class u extends R.Disposable{get recordedInflateBytes(){return this.j?o.VSBuffer.concat(this.f):o.VSBuffer.alloc(0)}constructor(i,t,d,E){super(),this.h=i,this.j=t,this.a=this.B(new a.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=T().zlib.createInflateRaw(E),this.b.on("error",w=>{this.h.traceSocketEvent("zlibInflateError",{message:w?.message,code:w?.code}),this.a.fire(w)}),this.b.on("data",w=>{this.h.traceSocketEvent("zlibInflateData",w),this.g.push(o.VSBuffer.wrap(w))}),d&&(this.h.traceSocketEvent("zlibInflateInitialWrite",d.buffer),this.b.write(d.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(i){this.j&&this.f.push(i.clone()),this.h.traceSocketEvent("zlibInflateWrite",i),this.b.write(i.buffer)}flush(i){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const t=o.VSBuffer.concat(this.g);this.g.length=0,i(t)})}}class g extends R.Disposable{constructor(i,t){super(),this.g=i,this.a=this.B(new a.Emitter),this.onError=this.a.event,this.f=[],this.b=T().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",d=>{this.g.traceSocketEvent("zlibDeflateError",{message:d?.message,code:d?.code}),this.a.fire(d)}),this.b.on("data",d=>{this.g.traceSocketEvent("zlibDeflateData",d),this.f.push(o.VSBuffer.wrap(d))})}write(i){this.g.traceSocketEvent("zlibDeflateWrite",i.buffer),this.b.write(i.buffer)}flush(i){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let t=o.VSBuffer.concat(this.f);this.f.length=0,t=t.slice(0,t.byteLength-4),i(t)})}}function b(m,i){if(i===0)return;const t=m.byteLength>>>2;for(let V=0;V<t;V++){const M=m.readUInt32BE(V*4);m.writeUInt32BE(M^i,V*4)}const d=t*4,E=m.byteLength-d,w=i>>>24&255,L=i>>>16&255,q=i>>>8&255;E>=1&&m.writeUInt8(m.readUInt8(d)^w,d),E>=2&&m.writeUInt8(m.readUInt8(d+1)^L,d+1),E>=3&&m.writeUInt8(m.readUInt8(d+2)^q,d+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const D={[2]:107,[1]:103};function p(){const m=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let i;return e.XDG_RUNTIME_DIR?i=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):i=(0,I.join)(T().os.tmpdir(),`vscode-ipc-${m}.sock`),s(i),i}e.createRandomIPCHandle=p;function n(m,i,t){const d=T().crypto.createHash("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${d}-${t}-${i}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${d.substr(0,8)}-${t}-${i}.sock`):E=(0,I.join)(m,`${t}-${i}.sock`),s(E),E}e.createStaticIPCHandle=n;function s(m){const i=D[P.platform];typeof i=="number"&&m.length>=i&&console.warn(`WARNING: IPC handle "${m}" is longer than ${i} chars, try a shorter --user-data-dir`)}class r extends k.IPCServer{static b(i){const t=a.Event.fromNodeEventEmitter(i,"connection");return a.Event.map(t,d=>({protocol:new O.Protocol(new v(d,"ipc-server-connection")),onDidClientDisconnect:a.Event.once(a.Event.fromNodeEventEmitter(d,"close"))}))}constructor(i){super(r.b(i)),this.d=i}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=r;function c(m){return new Promise((i,t)=>{const d=T().net.createServer();d.on("error",t),d.listen(m,()=>{d.removeListener("error",t),i(new r(d))})})}e.serve=c;function l(m,i){return new Promise((t,d)=>{const E=T().net.createConnection(m,()=>{E.removeListener("error",d),t(O.Client.fromSocket(new v(E,`ipc-client${i}`),i))});E.once("error",d)})}e.connect=l}),define(ye[164],De([1,0,38,11]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function a(R,I,P,S,k,O){if(Array.isArray(R)){let T=0;for(const v of R){const C=a(v,I,P,S,k,O);if(C===10)return C;C>T&&(T=C)}return T}else{if(typeof R=="string")return S?R==="*"?5:R===P?10:0:0;if(R){const{language:T,pattern:v,scheme:C,hasAccessToAllModels:y,notebookType:f}=R;if(!S&&!y)return 0;f&&k&&(I=k);let h=0;if(C)if(C===I.scheme)h=10;else if(C==="*")h=5;else return 0;if(T)if(T===P)h=10;else if(T==="*")h=Math.max(h,5);else return 0;if(f)if(f===O)h=10;else if(f==="*"&&O!==void 0)h=Math.max(h,5);else return 0;if(v){let u;if(typeof v=="string"?u=v:u={...v,base:(0,A.normalize)(v.base)},u===I.fsPath||(0,o.match)(u,I.fsPath))h=10;else return 0}return h}else return 0}}e.score=a}),define(ye[165],De([1,0,8,52,155]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(P,S,k,O){this.c=P,this.d=S,this.f=k,this.g=O,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(P){P.eol&&P.eol!==this.f&&(this.f=P.eol,this.h=null);const S=P.changes;for(const k of S)this.n(k.range),this.o(new A.Position(k.range.startLineNumber,k.range.startColumn),k.text);this.g=P.versionId,this.j=null}k(){if(!this.h){const P=this.f.length,S=this.d.length,k=new Uint32Array(S);for(let O=0;O<S;O++)k[O]=this.d[O].length+P;this.h=new a.PrefixSumComputer(k)}}l(P,S){this.d[P]=S,this.h&&this.h.setValue(P,this.d[P].length+this.f.length)}n(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this.l(P.startLineNumber-1,this.d[P.startLineNumber-1].substring(0,P.startColumn-1)+this.d[P.startLineNumber-1].substring(P.endColumn-1));return}this.l(P.startLineNumber-1,this.d[P.startLineNumber-1].substring(0,P.startColumn-1)+this.d[P.endLineNumber-1].substring(P.endColumn-1)),this.d.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this.h&&this.h.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}o(P,S){if(S.length===0)return;const k=(0,o.splitLines)(S);if(k.length===1){this.l(P.lineNumber-1,this.d[P.lineNumber-1].substring(0,P.column-1)+k[0]+this.d[P.lineNumber-1].substring(P.column-1));return}k[k.length-1]+=this.d[P.lineNumber-1].substring(P.column-1),this.l(P.lineNumber-1,this.d[P.lineNumber-1].substring(0,P.column-1)+k[0]);const O=new Uint32Array(k.length-1);for(let T=1;T<k.length;T++)this.d.splice(P.lineNumber+T-1,0,k[T]),O[T-1]=k[T].length+this.f.length;this.h&&this.h.insertValues(P.lineNumber,O)}}e.MirrorTextModel=R}),define(ye[166],De([1,0,8,152,52,32,107]),function(ne,e,o,A,a,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class S{constructor(g,b,D,p){this.searchString=g,this.isRegex=b,this.matchCase=D,this.wordSeparators=p}parseSearchRequest(){if(this.searchString==="")return null;let g;this.isRegex?g=k(this.searchString):g=this.searchString.indexOf(`
`)>=0;let b=null;try{b=o.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:g,global:!0,unicode:!0})}catch{return null}if(!b)return null;let D=!this.isRegex&&!g;return D&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(D=this.matchCase),new I.SearchData(b,this.wordSeparators?(0,A.getMapForWordSeparators)(this.wordSeparators):null,D?this.searchString:null)}}e.SearchParams=S;function k(u){if(!u||u.length===0)return!1;for(let g=0,b=u.length;g<b;g++){const D=u.charCodeAt(g);if(D===10)return!0;if(D===92){if(g++,g>=b)break;const p=u.charCodeAt(g);if(p===110||p===114||p===87)return!0}}return!1}e.isMultilineRegexSource=k;function O(u,g,b){if(!b)return new I.FindMatch(u,null);const D=[];for(let p=0,n=g.length;p<n;p++)D[p]=g[p];return new I.FindMatch(u,D)}e.createFindMatch=O;class T{constructor(g){const b=[];let D=0;for(let p=0,n=g.length;p<n;p++)g.charCodeAt(p)===10&&(b[D++]=p);this.a=b}findLineFeedCountBeforeOffset(g){const b=this.a;let D=0,p=b.length-1;if(p===-1||g<=b[0])return 0;for(;D<p;){const n=D+((p-D)/2>>0);b[n]>=g?p=n-1:b[n+1]>=g?(D=n,p=n):D=n+1}return D+1}}class v{static findMatches(g,b,D,p,n){const s=b.parseSearchRequest();return s?s.regex.multiline?this.b(g,D,new h(s.wordSeparators,s.regex),p,n):this.c(g,D,s,p,n):[]}static a(g,b,D,p,n,s){let r,c=0;p?(c=p.findLineFeedCountBeforeOffset(n),r=b+n+c):r=b+n;let l;if(p){const d=p.findLineFeedCountBeforeOffset(n+s.length)-c;l=r+s.length+d}else l=r+s.length;const m=g.getPositionAt(r),i=g.getPositionAt(l);return new R.Range(m.lineNumber,m.column,i.lineNumber,i.column)}static b(g,b,D,p,n){const s=g.getOffsetAt(b.getStartPosition()),r=g.getValueInRange(b,1),c=g.getEOL()===`\r
`?new T(r):null,l=[];let m=0,i;for(D.reset(0);i=D.next(r);)if(l[m++]=O(this.a(g,s,r,c,i.index,i[0]),i,p),m>=n)return l;return l}static c(g,b,D,p,n){const s=[];let r=0;if(b.startLineNumber===b.endLineNumber){const l=g.getLineContent(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);return r=this.d(D,l,b.startLineNumber,b.startColumn-1,r,s,p,n),s}const c=g.getLineContent(b.startLineNumber).substring(b.startColumn-1);r=this.d(D,c,b.startLineNumber,b.startColumn-1,r,s,p,n);for(let l=b.startLineNumber+1;l<b.endLineNumber&&r<n;l++)r=this.d(D,g.getLineContent(l),l,0,r,s,p,n);if(r<n){const l=g.getLineContent(b.endLineNumber).substring(0,b.endColumn-1);r=this.d(D,l,b.endLineNumber,0,r,s,p,n)}return s}static d(g,b,D,p,n,s,r,c){const l=g.wordSeparators;if(!r&&g.simpleSearch){const t=g.simpleSearch,d=t.length,E=b.length;let w=-d;for(;(w=b.indexOf(t,w+d))!==-1;)if((!l||f(l,b,E,w,d))&&(s[n++]=new I.FindMatch(new R.Range(D,w+1+p,D,w+1+d+p),null),n>=c))return n;return n}const m=new h(g.wordSeparators,g.regex);let i;m.reset(0);do if(i=m.next(b),i&&(s[n++]=O(new R.Range(D,i.index+1+p,D,i.index+1+i[0].length+p),i,r),n>=c))return n;while(i);return n}static findNextMatch(g,b,D,p){const n=b.parseSearchRequest();if(!n)return null;const s=new h(n.wordSeparators,n.regex);return n.regex.multiline?this.e(g,D,s,p):this.f(g,D,s,p)}static e(g,b,D,p){const n=new a.Position(b.lineNumber,1),s=g.getOffsetAt(n),r=g.getLineCount(),c=g.getValueInRange(new R.Range(n.lineNumber,n.column,r,g.getLineMaxColumn(r)),1),l=g.getEOL()===`\r
`?new T(c):null;D.reset(b.column-1);const m=D.next(c);return m?O(this.a(g,s,c,l,m.index,m[0]),m,p):b.lineNumber!==1||b.column!==1?this.e(g,new a.Position(1,1),D,p):null}static f(g,b,D,p){const n=g.getLineCount(),s=b.lineNumber,r=g.getLineContent(s),c=this.g(D,r,s,b.column,p);if(c)return c;for(let l=1;l<=n;l++){const m=(s+l-1)%n,i=g.getLineContent(m+1),t=this.g(D,i,m+1,1,p);if(t)return t}return null}static g(g,b,D,p,n){g.reset(p-1);const s=g.next(b);return s?O(new R.Range(D,s.index+1,D,s.index+1+s[0].length),s,n):null}static findPreviousMatch(g,b,D,p){const n=b.parseSearchRequest();if(!n)return null;const s=new h(n.wordSeparators,n.regex);return n.regex.multiline?this.h(g,D,s,p):this.j(g,D,s,p)}static h(g,b,D,p){const n=this.b(g,new R.Range(1,1,b.lineNumber,b.column),D,p,10*P);if(n.length>0)return n[n.length-1];const s=g.getLineCount();return b.lineNumber!==s||b.column!==g.getLineMaxColumn(s)?this.h(g,new a.Position(s,g.getLineMaxColumn(s)),D,p):null}static j(g,b,D,p){const n=g.getLineCount(),s=b.lineNumber,r=g.getLineContent(s).substring(0,b.column-1),c=this.k(D,r,s,p);if(c)return c;for(let l=1;l<=n;l++){const m=(n+s-l-1)%n,i=g.getLineContent(m+1),t=this.k(D,i,m+1,p);if(t)return t}return null}static k(g,b,D,p){let n=null,s;for(g.reset(0);s=g.next(b);)n=O(new R.Range(D,s.index+1,D,s.index+1+s[0].length),s,p);return n}}e.TextModelSearch=v;function C(u,g,b,D,p){if(D===0)return!0;const n=g.charCodeAt(D-1);if(u.get(n)!==0||n===13||n===10)return!0;if(p>0){const s=g.charCodeAt(D);if(u.get(s)!==0)return!0}return!1}function y(u,g,b,D,p){if(D+p===b)return!0;const n=g.charCodeAt(D+p);if(u.get(n)!==0||n===13||n===10)return!0;if(p>0){const s=g.charCodeAt(D+p-1);if(u.get(s)!==0)return!0}return!1}function f(u,g,b,D,p){return C(u,g,b,D,p)&&y(u,g,b,D,p)}e.isValidMatch=f;class h{constructor(g,b){this._wordSeparators=g,this.a=b,this.b=-1,this.c=0}reset(g){this.a.lastIndex=g,this.b=-1,this.c=0}next(g){const b=g.length;let D;do{if(this.b+this.c===b||(D=this.a.exec(g),!D))return null;const p=D.index,n=D[0].length;if(p===this.b&&n===this.c){if(n===0){o.getNextCodePoint(g,b,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=p,this.c=n,!this._wordSeparators||f(this._wordSeparators,g,b,p,n))return D}while(D);return null}}e.Searcher=h}),define(ye[120],De([1,0,22,10]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var a;(function(T){T[T.Full=1]="Full",T[T.Delta=2]="Delta"})(a||(a={}));function R(T){for(let v=0,C=T.length;v<C;v+=4){const y=T[v+0],f=T[v+1],h=T[v+2],u=T[v+3];T[v+0]=u,T[v+1]=h,T[v+2]=f,T[v+3]=y}}function I(T){const v=new Uint8Array(T.buffer,T.byteOffset,T.length*4);return A.isLittleEndian()||R(v),o.VSBuffer.wrap(v)}function P(T){const v=T.buffer;if(A.isLittleEndian()||R(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const C=new Uint8Array(v.byteLength);return C.set(v),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function S(T){const v=new Uint32Array(k(T));let C=0;if(v[C++]=T.id,T.type==="full")v[C++]=1,v[C++]=T.data.length,v.set(T.data,C),C+=T.data.length;else{v[C++]=2,v[C++]=T.deltas.length;for(const y of T.deltas)v[C++]=y.start,v[C++]=y.deleteCount,y.data?(v[C++]=y.data.length,v.set(y.data,C),C+=y.data.length):v[C++]=0}return I(v)}e.encodeSemanticTokensDto=S;function k(T){let v=0;if(v+=1+1,T.type==="full")v+=1+T.data.length;else{v+=1,v+=(1+1+1)*T.deltas.length;for(const C of T.deltas)C.data&&(v+=C.data.length)}return v}function O(T){const v=P(T);let C=0;const y=v[C++];if(v[C++]===1){const g=v[C++],b=v.subarray(C,C+g);return C+=g,{id:y,type:"full",data:b}}const h=v[C++],u=[];for(let g=0;g<h;g++){const b=v[C++],D=v[C++],p=v[C++];let n;p>0&&(n=v.subarray(C,C+p),C+=p),u[g]={start:b,deleteCount:D,data:n}}return{id:y,type:"delta",deltas:u}}e.decodeSemanticTokensDto=O}),define(ye[167],De([1,0,3,6]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class a{constructor(){this.a=new Map,this.b=new Map,this.c=new o.Emitter,this.onDidChange=this.c.event,this.d=null}fire(P){this.c.fire({changedLanguages:P,changedColorMap:!1})}register(P,S){return this.a.set(P,S),this.fire([P]),(0,A.toDisposable)(()=>{this.a.get(P)===S&&(this.a.delete(P),this.fire([P]))})}registerFactory(P,S){this.b.get(P)?.dispose();const k=new R(this,P,S);return this.b.set(P,k),(0,A.toDisposable)(()=>{const O=this.b.get(P);!O||O!==k||(this.b.delete(P),O.dispose())})}async getOrCreate(P){const S=this.get(P);if(S)return S;const k=this.b.get(P);return!k||k.isResolved?null:(await k.resolve(),this.get(P))}get(P){return this.a.get(P)||null}isResolved(P){if(this.get(P))return!0;const k=this.b.get(P);return!!(!k||k.isResolved)}setColorMap(P){this.d=P,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=a;class R extends A.Disposable{get isResolved(){return this.c}constructor(P,S,k){super(),this.f=P,this.g=S,this.h=k,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const P=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,P&&!this.a&&this.B(this.f.register(this.g,P))}}}),define(ye[71],De([1,0,67,2,32,167]),function(ne,e,o,A,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class I{constructor(d,E,w){this.offset=d,this.type=E,this.language=w,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=I;class P{constructor(d,E){this.tokens=d,this.endState=E,this._tokenizationResultBrand=void 0}}e.TokenizationResult=P;class S{constructor(d,E){this.tokens=d,this.endState=E,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=S;var k;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(k=e.CompletionItemKind||(e.CompletionItemKind={}));var O;(function(t){const d=new Map;d.set(0,o.Codicon.symbolMethod),d.set(1,o.Codicon.symbolFunction),d.set(2,o.Codicon.symbolConstructor),d.set(3,o.Codicon.symbolField),d.set(4,o.Codicon.symbolVariable),d.set(5,o.Codicon.symbolClass),d.set(6,o.Codicon.symbolStruct),d.set(7,o.Codicon.symbolInterface),d.set(8,o.Codicon.symbolModule),d.set(9,o.Codicon.symbolProperty),d.set(10,o.Codicon.symbolEvent),d.set(11,o.Codicon.symbolOperator),d.set(12,o.Codicon.symbolUnit),d.set(13,o.Codicon.symbolValue),d.set(15,o.Codicon.symbolEnum),d.set(14,o.Codicon.symbolConstant),d.set(15,o.Codicon.symbolEnum),d.set(16,o.Codicon.symbolEnumMember),d.set(17,o.Codicon.symbolKeyword),d.set(27,o.Codicon.symbolSnippet),d.set(18,o.Codicon.symbolText),d.set(19,o.Codicon.symbolColor),d.set(20,o.Codicon.symbolFile),d.set(21,o.Codicon.symbolReference),d.set(22,o.Codicon.symbolCustomColor),d.set(23,o.Codicon.symbolFolder),d.set(24,o.Codicon.symbolTypeParameter),d.set(25,o.Codicon.account),d.set(26,o.Codicon.issues);function E(q){let V=d.get(q);return V||(console.info("No codicon found for CompletionItemKind "+q),V=o.Codicon.symbolProperty),V}t.toIcon=E;const w=new Map;w.set("method",0),w.set("function",1),w.set("constructor",2),w.set("field",3),w.set("variable",4),w.set("class",5),w.set("struct",6),w.set("interface",7),w.set("module",8),w.set("property",9),w.set("event",10),w.set("operator",11),w.set("unit",12),w.set("value",13),w.set("constant",14),w.set("enum",15),w.set("enum-member",16),w.set("enumMember",16),w.set("keyword",17),w.set("snippet",27),w.set("text",18),w.set("color",19),w.set("file",20),w.set("reference",21),w.set("customcolor",22),w.set("folder",23),w.set("type-parameter",24),w.set("typeParameter",24),w.set("account",25),w.set("issue",26);function L(q,V){let M=w.get(q);return typeof M>"u"&&!V&&(M=9),M}t.fromString=L})(O=e.CompletionItemKinds||(e.CompletionItemKinds={}));var T;(function(t){t[t.Deprecated=1]="Deprecated"})(T=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var C;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(C=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var y;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(y=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(t){return t&&A.URI.isUri(t.uri)&&a.Range.isIRange(t.range)&&(a.Range.isIRange(t.originSelectionRange)||a.Range.isIRange(t.targetSelectionRange))}e.isLocationLink=g;var b;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(b=e.SymbolKind||(e.SymbolKind={}));var D;(function(t){t[t.Deprecated=1]="Deprecated"})(D=e.SymbolTag||(e.SymbolTag={}));var p;(function(t){const d=new Map;d.set(0,o.Codicon.symbolFile),d.set(1,o.Codicon.symbolModule),d.set(2,o.Codicon.symbolNamespace),d.set(3,o.Codicon.symbolPackage),d.set(4,o.Codicon.symbolClass),d.set(5,o.Codicon.symbolMethod),d.set(6,o.Codicon.symbolProperty),d.set(7,o.Codicon.symbolField),d.set(8,o.Codicon.symbolConstructor),d.set(9,o.Codicon.symbolEnum),d.set(10,o.Codicon.symbolInterface),d.set(11,o.Codicon.symbolFunction),d.set(12,o.Codicon.symbolVariable),d.set(13,o.Codicon.symbolConstant),d.set(14,o.Codicon.symbolString),d.set(15,o.Codicon.symbolNumber),d.set(16,o.Codicon.symbolBoolean),d.set(17,o.Codicon.symbolArray),d.set(18,o.Codicon.symbolObject),d.set(19,o.Codicon.symbolKey),d.set(20,o.Codicon.symbolNull),d.set(21,o.Codicon.symbolEnumMember),d.set(22,o.Codicon.symbolStruct),d.set(23,o.Codicon.symbolEvent),d.set(24,o.Codicon.symbolOperator),d.set(25,o.Codicon.symbolTypeParameter);function E(w){let L=d.get(w);return L||(console.info("No codicon found for SymbolKind "+w),L=o.Codicon.symbolProperty),L}t.toIcon=E})(p=e.SymbolKinds||(e.SymbolKinds={}));class n{static fromValue(d){switch(d){case"comment":return n.Comment;case"imports":return n.Imports;case"region":return n.Region}return new n(d)}constructor(d){this.value=d}}n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region"),e.FoldingRangeKind=n;var s;(function(t){function d(E){return!E||typeof E!="object"?!1:typeof E.id=="string"&&typeof E.title=="string"}t.is=d})(s=e.Command||(e.Command={}));var r;(function(t){t[t.Collapsed=0]="Collapsed",t[t.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(t){t[t.Unresolved=0]="Unresolved",t[t.Resolved=1]="Resolved"})(c=e.CommentThreadState||(e.CommentThreadState={}));var l;(function(t){t[t.Editing=0]="Editing",t[t.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var m;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(m=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new R.TokenizationRegistry;var i;(function(t){t[t.None=0]="None",t[t.Option=1]="Option",t[t.Default=2]="Default",t[t.Preferred=3]="Preferred"})(i=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[168],De([17,18]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(ye[121],De([1,0,168,10,106,15,23,151]),function(ne,e,o,A,a,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(W){W[W.None=0]="None",W[W.Keep=1]="Keep",W[W.Brackets=2]="Brackets",W[W.Advanced=3]="Advanced",W[W.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=k;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class T{constructor(X,he,Le,Ne){this.id=X,this.name=he,this.defaultValue=Le,this.schema=Ne}applyUpdate(X,he){return C(X,he)}compute(X,he,Le){return Le}}class v{constructor(X,he){this.newValue=X,this.didChange=he}}e.ApplyUpdateResult=v;function C(W,X){if(typeof W!="object"||typeof X!="object"||!W||!X)return new v(X,W!==X);if(Array.isArray(W)||Array.isArray(X)){const Le=Array.isArray(W)&&Array.isArray(X)&&R.equals(W,X);return new v(X,!Le)}let he=!1;for(const Le in X)if(X.hasOwnProperty(Le)){const Ne=C(W[Le],X[Le]);Ne.didChange&&(W[Le]=Ne.newValue,he=!0)}return new v(W,he)}class y{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,he){return C(X,he)}validate(X){return this.defaultValue}}class f{constructor(X,he,Le,Ne){this.id=X,this.name=he,this.defaultValue=Le,this.schema=Ne}applyUpdate(X,he){return C(X,he)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,he,Le){return Le}}function h(W,X){return typeof W>"u"?X:W==="false"?!1:Boolean(W)}e.boolean=h;class u extends f{constructor(X,he,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Le),super(X,he,Le,Ne)}validate(X){return h(X,this.defaultValue)}}function g(W,X,he,Le){if(typeof W>"u")return X;let Ne=parseInt(W,10);return isNaN(Ne)?X:(Ne=Math.max(he,Ne),Ne=Math.min(Le,Ne),Ne|0)}e.clampedInt=g;class b extends f{static clampedInt(X,he,Le,Ne){return g(X,he,Le,Ne)}constructor(X,he,Le,Ne,qe,je=void 0){typeof je<"u"&&(je.type="integer",je.default=Le,je.minimum=Ne,je.maximum=qe),super(X,he,Le,je),this.minimum=Ne,this.maximum=qe}validate(X){return b.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class D extends f{static clamp(X,he,Le){return X<he?he:X>Le?Le:X}static float(X,he){if(typeof X=="number")return X;if(typeof X>"u")return he;const Le=parseFloat(X);return isNaN(Le)?he:Le}constructor(X,he,Le,Ne,qe){typeof qe<"u"&&(qe.type="number",qe.default=Le),super(X,he,Le,qe),this.validationFn=Ne}validate(X){return this.validationFn(D.float(X,this.defaultValue))}}class p extends f{static string(X,he){return typeof X!="string"?he:X}constructor(X,he,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Le),super(X,he,Le,Ne)}validate(X){return p.string(X,this.defaultValue)}}function n(W,X,he){return typeof W!="string"||he.indexOf(W)===-1?X:W}e.stringSet=n;class s extends f{constructor(X,he,Le,Ne,qe=void 0){typeof qe<"u"&&(qe.type="string",qe.enum=Ne,qe.default=Le),super(X,he,Le,qe),this.c=Ne}validate(X){return n(X,this.defaultValue,this.c)}}class r extends T{constructor(X,he,Le,Ne,qe,je,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=qe,Ze.default=Ne),super(X,he,Le,Ze),this.c=qe,this.d=je}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function c(W){switch(W){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",tags:["accessibility"],description:o.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,he,Le){return Le===0?X.accessibilitySupport:Le}}class m extends T{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:o.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{insertSpace:h(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(W){W[W.Hidden=0]="Hidden",W[W.Blink=1]="Blink",W[W.Smooth=2]="Smooth",W[W.Phase=3]="Phase",W[W.Expand=4]="Expand",W[W.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(W){switch(W){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(W){W[W.Line=1]="Line",W[W.Block=2]="Block",W[W.Underline=3]="Underline",W[W.LineThin=4]="LineThin",W[W.BlockOutline=5]="BlockOutline",W[W.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function E(W){switch(W){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function w(W){switch(W){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class L extends y{constructor(){super(135)}compute(X,he,Le){const Ne=["monaco-editor"];return he.get(36)&&Ne.push(he.get(36)),X.extraEditorClassName&&Ne.push(X.extraEditorClassName),he.get(70)==="default"?Ne.push("mouse-default"):he.get(70)==="copy"&&Ne.push("mouse-copy"),he.get(105)&&Ne.push("showUnused"),he.get(133)&&Ne.push("showDeprecated"),Ne.join(" ")}}class q extends u{constructor(){super(34,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute(X,he,Le){return Le&&X.emptySelectionClipboard}}class V extends T{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:o.localize(16,null),included:A.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:o.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{cursorMoveOnType:h(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":n(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":n(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(he.loop,this.defaultValue.loop)}}}class M extends T{constructor(){super(48,"fontLigatures",M.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?M.OFF:X==="true"?M.ON:X:Boolean(X)?M.ON:M.OFF}}M.OFF='"liga" off, "calt" off',M.ON='"liga" on, "calt" on',e.EditorFontLigatures=M;class B extends T{constructor(){super(51,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:o.localize(22,null)},{type:"string",description:o.localize(23,null)}],description:o.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?B.OFF:X==="true"?B.TRANSLATE:X:Boolean(X)?B.TRANSLATE:B.OFF}compute(X,he,Le){return X.fontInfo.fontVariationSettings}}B.OFF="normal",B.TRANSLATE="translate",e.EditorFontVariations=B;class N extends y{constructor(){super(47)}compute(X,he,Le){return X.fontInfo}}class U extends f{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(25,null)})}validate(X){const he=D.float(X,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:D.clamp(he,6,100)}compute(X,he,Le){return X.fontInfo.fontSize}}class $ extends T{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.d,maximum:$.e,errorMessage:o.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(b.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,$.d,$.e))}}$.c=["normal","bold","100","200","300","400","500","600","700","800","900"],$.d=1,$.e=1e3;class z extends T{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[o.localize(28,null),o.localize(29,null),o.localize(30,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(32,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(33,null),...he},"editor.gotoLocation.multipleDeclarations":{description:o.localize(34,null),...he},"editor.gotoLocation.multipleImplementations":{description:o.localize(35,null),...he},"editor.gotoLocation.multipleReferences":{description:o.localize(36,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Le,description:o.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Le,description:o.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Le,description:o.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Le,description:o.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Le,description:o.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{multiple:n(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??n(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??n(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??n(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??n(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??n(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ae extends T{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:o.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:o.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:o.localize(44,null)},"editor.hover.above":{type:"boolean",default:X.above,description:o.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),delay:b.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:h(he.sticky,this.defaultValue.sticky),above:h(he.above,this.defaultValue.above)}}}var ee;(function(W){W[W.None=0]="None",W[W.Text=1]="Text",W[W.Blocks=2]="Blocks"})(ee=e.RenderMinimap||(e.RenderMinimap={}));class x extends y{constructor(){super(138)}compute(X,he,Le){return x.computeLayout(he,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const he=X.height/X.lineHeight,Le=Math.floor(X.paddingTop/X.lineHeight);let Ne=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Ne=Math.max(Ne,he-1));const qe=(Le+X.viewLineCount+Ne)/(X.pixelRatio*X.height),je=Math.floor(X.viewLineCount/qe);return{typicalViewportLineCount:he,extraLinesBeforeFirstLine:Le,extraLinesBeyondLastLine:Ne,desiredRatio:qe,minimapLineCount:je}}static c(X,he){const Le=X.outerWidth,Ne=X.outerHeight,qe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(qe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const je=he.stableMinimapLayoutInput,Ze=je&&X.outerHeight===je.outerHeight&&X.lineHeight===je.lineHeight&&X.typicalHalfwidthCharacterWidth===je.typicalHalfwidthCharacterWidth&&X.pixelRatio===je.pixelRatio&&X.scrollBeyondLastLine===je.scrollBeyondLastLine&&X.paddingTop===je.paddingTop&&X.paddingBottom===je.paddingBottom&&X.minimap.enabled===je.minimap.enabled&&X.minimap.side===je.minimap.side&&X.minimap.size===je.minimap.size&&X.minimap.showSlider===je.minimap.showSlider&&X.minimap.renderCharacters===je.minimap.renderCharacters&&X.minimap.maxColumn===je.minimap.maxColumn&&X.minimap.scale===je.minimap.scale&&X.verticalScrollbarWidth===je.verticalScrollbarWidth&&X.isViewportWrapping===je.isViewportWrapping,st=X.lineHeight,at=X.typicalHalfwidthCharacterWidth,mt=X.scrollBeyondLastLine,gt=X.minimap.renderCharacters;let Et=qe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const lt=X.minimap.maxColumn,pt=X.minimap.size,xt=X.minimap.side,jt=X.verticalScrollbarWidth,kt=X.viewLineCount,ft=X.remainingWidth,Tt=X.isViewportWrapping,Bt=gt?2:3;let At=Math.floor(qe*Ne);const Xe=At/qe;let Nt=!1,Gt=!1,Ft=Bt*Et,bt=Et/qe,Ae=1;if(pt==="fill"||pt==="fit"){const{typicalViewportLineCount:Ve,extraLinesBeforeFirstLine:et,extraLinesBeyondLastLine:ut,desiredRatio:Pt,minimapLineCount:St}=x.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:mt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Ne,lineHeight:st,pixelRatio:qe});if(kt/St>1)Nt=!0,Gt=!0,Et=1,Ft=1,bt=Et/qe;else{let wt=!1,Rt=Et+1;if(pt==="fit"){const yt=Math.ceil((et+kt+ut)*Ft);Tt&&Ze&&ft<=he.stableFitRemainingWidth?(wt=!0,Rt=he.stableFitMaxMinimapScale):wt=yt>At}if(pt==="fill"||wt){Nt=!0;const yt=Et;Ft=Math.min(st*qe,Math.max(1,Math.floor(1/Pt))),Tt&&Ze&&ft<=he.stableFitRemainingWidth&&(Rt=he.stableFitMaxMinimapScale),Et=Math.min(Rt,Math.max(1,Math.floor(Ft/Bt))),Et>yt&&(Ae=Math.min(2,Et/yt)),bt=Et/qe/Ae,At=Math.ceil(Math.max(Ve,et+kt+ut)*Ft),Tt?(he.stableMinimapLayoutInput=X,he.stableFitRemainingWidth=ft,he.stableFitMaxMinimapScale=Et):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const Oe=Math.floor(lt*bt),Se=Math.min(Oe,Math.max(0,Math.floor((ft-jt-2)*bt/(at+bt)))+e.MINIMAP_GUTTER_WIDTH);let re=Math.floor(qe*Se);const Fe=re/qe;re=Math.floor(re*Ae);const We=gt?1:2,Ye=xt==="left"?0:Le-Se-jt;return{renderMinimap:We,minimapLeft:Ye,minimapWidth:Se,minimapHeightIsEditorHeight:Nt,minimapIsSampling:Gt,minimapScale:Et,minimapLineHeight:Ft,minimapCanvasInnerWidth:re,minimapCanvasInnerHeight:At,minimapCanvasOuterWidth:Fe,minimapCanvasOuterHeight:Xe}}static computeLayout(X,he){const Le=he.outerWidth|0,Ne=he.outerHeight|0,qe=he.lineHeight|0,je=he.lineNumbersDigitCount|0,Ze=he.typicalHalfwidthCharacterWidth,st=he.maxDigitWidth,at=he.pixelRatio,mt=he.viewLineCount,gt=X.get(130),Et=gt==="inherit"?X.get(129):gt,lt=Et==="inherit"?X.get(125):Et,pt=X.get(128),xt=he.isDominatedByLongLines,jt=X.get(54),kt=X.get(64).renderType!==0,ft=X.get(65),Tt=X.get(99),Bt=X.get(80),At=X.get(69),Xe=X.get(97),Nt=Xe.verticalScrollbarSize,Gt=Xe.verticalHasArrows,Ft=Xe.arrowSize,bt=Xe.horizontalScrollbarSize,Ae=X.get(40),Oe=X.get(104)!=="never";let Se=X.get(62);Ae&&Oe&&(Se+=16);let re=0;if(kt){const ei=Math.max(je,ft);re=Math.round(ei*st)}let Fe=0;jt&&(Fe=qe);let We=0,Ye=We+Fe,Ve=Ye+re,et=Ve+Se;const ut=Le-Fe-re-Se;let Pt=!1,St=!1,Dt=-1;Et==="inherit"&&xt?(Pt=!0,St=!0):lt==="on"||lt==="bounded"?St=!0:lt==="wordWrapColumn"&&(Dt=pt);const wt=x.c({outerWidth:Le,outerHeight:Ne,lineHeight:qe,typicalHalfwidthCharacterWidth:Ze,pixelRatio:at,scrollBeyondLastLine:Tt,paddingTop:Bt.top,paddingBottom:Bt.bottom,minimap:At,verticalScrollbarWidth:Nt,viewLineCount:mt,remainingWidth:ut,isViewportWrapping:St},he.memory||new O);wt.renderMinimap!==0&&wt.minimapLeft===0&&(We+=wt.minimapWidth,Ye+=wt.minimapWidth,Ve+=wt.minimapWidth,et+=wt.minimapWidth);const Rt=ut-wt.minimapWidth,yt=Math.max(1,Math.floor((Rt-Nt-2)/Ze)),ri=Gt?Ft:0;return St&&(Dt=Math.max(1,yt),lt==="bounded"&&(Dt=Math.min(Dt,pt))),{width:Le,height:Ne,glyphMarginLeft:We,glyphMarginWidth:Fe,lineNumbersLeft:Ye,lineNumbersWidth:re,decorationsLeft:Ve,decorationsWidth:Se,contentLeft:et,contentWidth:Rt,minimap:wt,viewportColumn:yt,isWordWrapMinified:Pt,isViewportWrapping:St,wrappingColumn:Dt,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:bt,overviewRuler:{top:ri,width:Nt,height:Ne-2*ri,right:0}}}}e.EditorLayoutInfoComputer=x;class J extends T{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[o.localize(46,null),o.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:o.localize(48,null)}})}validate(X){return n(X,"simple",["simple","advanced"])}compute(X,he,Le){return he.get(2)===2?"advanced":Le}}class ie extends T{constructor(){const X={enabled:!0};super(61,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:o.localize(49,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:h(X.enabled,this.defaultValue.enabled)}}}class pe extends T{constructor(){const X={enabled:!1,maxLineCount:5};super(109,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:o.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:o.localize(51,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(he.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class Q extends T{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:o.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(53,null),o.localize(54,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(55,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:o.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:o.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:o.localize(59,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return typeof he.enabled=="boolean"&&(he.enabled=he.enabled?"on":"off"),{enabled:n(he.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(he.fontFamily,this.defaultValue.fontFamily),padding:h(he.padding,this.defaultValue.padding)}}}class Y extends T{constructor(){super(62,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):b.clampedInt(X,this.defaultValue,0,1e3)}compute(X,he,Le){return Le<0?b.clampedInt(-Le*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Le}}class Z extends D{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>D.clamp(X,0,150),{markdownDescription:o.localize(60,null)})}compute(X,he,Le){return X.fontInfo.lineHeight}}class me extends T{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:o.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:o.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(63,null),o.localize(64,null),o.localize(65,null)],default:X.size,description:o.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:o.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:o.localize(68,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:o.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:o.localize(71,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),autohide:h(he.autohide,this.defaultValue.autohide),size:n(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(he.side,this.defaultValue.side,["right","left"]),showSlider:n(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(he.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(he.scale,1,1,3),maxColumn:b.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ve(W){return W==="ctrlCmd"?A.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ie extends T{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(73,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{top:b.clampedInt(he.top,0,0,1e3),bottom:b.clampedInt(he.bottom,0,0,1e3)}}}class Re extends T{constructor(){const X={enabled:!0,cycle:!0};super(81,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:o.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:o.localize(75,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),cycle:h(he.cycle,this.defaultValue.cycle)}}}class oe extends y{constructor(){super(136)}compute(X,he,Le){return X.pixelRatio}}class le extends T{constructor(){const X={other:"on",comments:"off",strings:"off"},he=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(76,null),o.localize(77,null),o.localize(78,null)]}];super(84,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:he,default:X.strings,description:o.localize(79,null)},comments:{anyOf:he,default:X.comments,description:o.localize(80,null)},other:{anyOf:he,default:X.other,description:o.localize(81,null)}},default:X,markdownDescription:o.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const at=X?"on":"off";return{comments:at,strings:at,other:at}}if(!X||typeof X!="object")return this.defaultValue;const{other:he,comments:Le,strings:Ne}=X,qe=["on","inline","off"];let je,Ze,st;return typeof he=="boolean"?je=he?"on":"off":je=n(he,this.defaultValue.other,qe),typeof Le=="boolean"?Ze=Le?"on":"off":Ze=n(Le,this.defaultValue.comments,qe),typeof Ne=="boolean"?st=Ne?"on":"off":st=n(Ne,this.defaultValue.strings,qe),{other:je,comments:Ze,strings:st}}}var ue;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative",W[W.Interval=3]="Interval",W[W.Custom=4]="Custom"})(ue=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class te extends T{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(83,null),o.localize(84,null),o.localize(85,null),o.localize(86,null)],default:"on",description:o.localize(87,null)})}validate(X){let he=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(he=4,Le=X):X==="interval"?he=3:X==="relative"?he=2:X==="on"?he=1:he=0),{renderType:he,renderFn:Le}}}function ce(W){const X=W.get(92);return X==="editable"?W.get(86):X!=="on"}e.filterValidationDecorations=ce;class se extends T{constructor(){const X=[],he={type:"number",description:o.localize(88,null)};super(96,"rulers",X,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:o.localize(89,null),format:"color-hex"}}}]},default:X,description:o.localize(90,null)})}validate(X){if(Array.isArray(X)){const he=[];for(const Le of X)if(typeof Le=="number")he.push({column:b.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const Ne=Le;he.push({column:b.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return he.sort((Le,Ne)=>Le.column-Ne.column),he}return this.defaultValue}}function F(W,X){if(typeof W!="string")return X;switch(W){case"hidden":return 2;case"visible":return 3;default:return 1}}class H extends T{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(91,null),o.localize(92,null),o.localize(93,null)],default:"auto",description:o.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(95,null),o.localize(96,null),o.localize(97,null)],default:"auto",description:o.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:o.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:o.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:o.localize(101,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X,Le=b.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=b.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:F(he.vertical,this.defaultValue.vertical),horizontal:F(he.horizontal,this.defaultValue.horizontal),useShadows:h(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:b.clampedInt(he.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:b.clampedInt(he.verticalSliderSize,Ne,0,1e3),scrollByPage:h(he.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends T{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:o.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:o.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:o.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:o.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:o.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:o.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:o.localize(108,null)}})}applyUpdate(X,he){let Le=!1;he.allowedCharacters&&X&&(I.equals(X.allowedCharacters,he.allowedCharacters)||(X={...X,allowedCharacters:he.allowedCharacters},Le=!0)),he.allowedLocales&&X&&(I.equals(X.allowedLocales,he.allowedLocales)||(X={...X,allowedLocales:he.allowedLocales},Le=!0));const Ne=super.applyUpdate(X,he);return Le?new v(Ne.newValue,!0):Ne}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{nonBasicASCII:Pe(he.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:h(he.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:h(he.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Pe(he.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Pe(he.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,he){if(typeof X!="object"||!X)return he;const Le={};for(const[Ne,qe]of Object.entries(X))qe===!0&&(Le[Ne]=!0);return Le}}class _ extends T{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:o.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[o.localize(110,null),o.localize(111,null)],description:o.localize(112,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),mode:n(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:n(he.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class de extends T{constructor(){const X={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:o.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:o.localize(114,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:h(he.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class we extends T{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(115,null),o.localize(116,null),o.localize(117,null)],default:X.bracketPairs,description:o.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(119,null),o.localize(120,null),o.localize(121,null)],default:X.bracketPairsHorizontal,description:o.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:o.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:o.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(125,null),o.localize(126,null),o.localize(127,null)],default:X.highlightActiveIndentation,description:o.localize(128,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{bracketPairs:Pe(he.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Pe(he.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:h(he.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:h(he.indentation,this.defaultValue.indentation),highlightActiveIndentation:Pe(he.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Pe(W,X,he){const Le=he.indexOf(W);return Le===-1?X:he[Le]}class be extends T{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(129,null),o.localize(130,null)],default:X.insertMode,description:o.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:o.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:o.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:o.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[o.localize(135,null),o.localize(136,null),o.localize(137,null),o.localize(138,null)],default:X.selectionMode,markdownDescription:o.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:o.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:o.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:o.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:o.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:o.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(176,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{insertMode:n(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:n(he.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:h(he.showIcons,this.defaultValue.showIcons),showStatusBar:h(he.showStatusBar,this.defaultValue.showStatusBar),preview:h(he.preview,this.defaultValue.preview),previewMode:n(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(he.showMethods,this.defaultValue.showMethods),showFunctions:h(he.showFunctions,this.defaultValue.showFunctions),showConstructors:h(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(he.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:h(he.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:h(he.showFields,this.defaultValue.showFields),showVariables:h(he.showVariables,this.defaultValue.showVariables),showClasses:h(he.showClasses,this.defaultValue.showClasses),showStructs:h(he.showStructs,this.defaultValue.showStructs),showInterfaces:h(he.showInterfaces,this.defaultValue.showInterfaces),showModules:h(he.showModules,this.defaultValue.showModules),showProperties:h(he.showProperties,this.defaultValue.showProperties),showEvents:h(he.showEvents,this.defaultValue.showEvents),showOperators:h(he.showOperators,this.defaultValue.showOperators),showUnits:h(he.showUnits,this.defaultValue.showUnits),showValues:h(he.showValues,this.defaultValue.showValues),showConstants:h(he.showConstants,this.defaultValue.showConstants),showEnums:h(he.showEnums,this.defaultValue.showEnums),showEnumMembers:h(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(he.showKeywords,this.defaultValue.showKeywords),showWords:h(he.showWords,this.defaultValue.showWords),showColors:h(he.showColors,this.defaultValue.showColors),showFiles:h(he.showFiles,this.defaultValue.showFiles),showReferences:h(he.showReferences,this.defaultValue.showReferences),showFolders:h(he.showFolders,this.defaultValue.showFolders),showTypeParameters:h(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(he.showSnippets,this.defaultValue.showSnippets),showUsers:h(he.showUsers,this.defaultValue.showUsers),showIssues:h(he.showIssues,this.defaultValue.showIssues)}}}class Ce extends T{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(177,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var ke;(function(W){W[W.None=0]="None",W[W.Same=1]="Same",W[W.Indent=2]="Indent",W[W.DeepIndent=3]="DeepIndent"})(ke=e.WrappingIndent||(e.WrappingIndent={}));class He extends T{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[o.localize(178,null),o.localize(179,null),o.localize(180,null),o.localize(181,null)],description:o.localize(182,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,he,Le){return he.get(2)===2?0:Le}}class Ge extends y{constructor(){super(139)}compute(X,he,Le){const Ne=he.get(138);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class nt extends T{constructor(){const X={enabled:!0};super(33,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:o.localize(183,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:h(X.enabled,this.defaultValue.enabled)}}}const Qe="Consolas, 'Courier New', monospace",tt="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.isMacintosh?tt:A.isLinux?rt:Qe,fontWeight:"normal",fontSize:A.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(W){return e.editorOptionsRegistry[W.id]=W,W}var it;(function(W){W[W.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",W[W.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",W[W.accessibilitySupport=2]="accessibilitySupport",W[W.accessibilityPageSize=3]="accessibilityPageSize",W[W.ariaLabel=4]="ariaLabel",W[W.autoClosingBrackets=5]="autoClosingBrackets",W[W.autoClosingDelete=6]="autoClosingDelete",W[W.autoClosingOvertype=7]="autoClosingOvertype",W[W.autoClosingQuotes=8]="autoClosingQuotes",W[W.autoIndent=9]="autoIndent",W[W.automaticLayout=10]="automaticLayout",W[W.autoSurround=11]="autoSurround",W[W.bracketPairColorization=12]="bracketPairColorization",W[W.guides=13]="guides",W[W.codeLens=14]="codeLens",W[W.codeLensFontFamily=15]="codeLensFontFamily",W[W.codeLensFontSize=16]="codeLensFontSize",W[W.colorDecorators=17]="colorDecorators",W[W.colorDecoratorsLimit=18]="colorDecoratorsLimit",W[W.columnSelection=19]="columnSelection",W[W.comments=20]="comments",W[W.contextmenu=21]="contextmenu",W[W.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",W[W.cursorBlinking=23]="cursorBlinking",W[W.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",W[W.cursorStyle=25]="cursorStyle",W[W.cursorSurroundingLines=26]="cursorSurroundingLines",W[W.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",W[W.cursorWidth=28]="cursorWidth",W[W.disableLayerHinting=29]="disableLayerHinting",W[W.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",W[W.domReadOnly=31]="domReadOnly",W[W.dragAndDrop=32]="dragAndDrop",W[W.dropIntoEditor=33]="dropIntoEditor",W[W.emptySelectionClipboard=34]="emptySelectionClipboard",W[W.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",W[W.extraEditorClassName=36]="extraEditorClassName",W[W.fastScrollSensitivity=37]="fastScrollSensitivity",W[W.find=38]="find",W[W.fixedOverflowWidgets=39]="fixedOverflowWidgets",W[W.folding=40]="folding",W[W.foldingStrategy=41]="foldingStrategy",W[W.foldingHighlight=42]="foldingHighlight",W[W.foldingImportsByDefault=43]="foldingImportsByDefault",W[W.foldingMaximumRegions=44]="foldingMaximumRegions",W[W.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",W[W.fontFamily=46]="fontFamily",W[W.fontInfo=47]="fontInfo",W[W.fontLigatures=48]="fontLigatures",W[W.fontSize=49]="fontSize",W[W.fontWeight=50]="fontWeight",W[W.fontVariations=51]="fontVariations",W[W.formatOnPaste=52]="formatOnPaste",W[W.formatOnType=53]="formatOnType",W[W.glyphMargin=54]="glyphMargin",W[W.gotoLocation=55]="gotoLocation",W[W.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",W[W.hover=57]="hover",W[W.inDiffEditor=58]="inDiffEditor",W[W.inlineSuggest=59]="inlineSuggest",W[W.letterSpacing=60]="letterSpacing",W[W.lightbulb=61]="lightbulb",W[W.lineDecorationsWidth=62]="lineDecorationsWidth",W[W.lineHeight=63]="lineHeight",W[W.lineNumbers=64]="lineNumbers",W[W.lineNumbersMinChars=65]="lineNumbersMinChars",W[W.linkedEditing=66]="linkedEditing",W[W.links=67]="links",W[W.matchBrackets=68]="matchBrackets",W[W.minimap=69]="minimap",W[W.mouseStyle=70]="mouseStyle",W[W.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",W[W.mouseWheelZoom=72]="mouseWheelZoom",W[W.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",W[W.multiCursorModifier=74]="multiCursorModifier",W[W.multiCursorPaste=75]="multiCursorPaste",W[W.multiCursorLimit=76]="multiCursorLimit",W[W.occurrencesHighlight=77]="occurrencesHighlight",W[W.overviewRulerBorder=78]="overviewRulerBorder",W[W.overviewRulerLanes=79]="overviewRulerLanes",W[W.padding=80]="padding",W[W.parameterHints=81]="parameterHints",W[W.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",W[W.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",W[W.quickSuggestions=84]="quickSuggestions",W[W.quickSuggestionsDelay=85]="quickSuggestionsDelay",W[W.readOnly=86]="readOnly",W[W.renameOnType=87]="renameOnType",W[W.renderControlCharacters=88]="renderControlCharacters",W[W.renderFinalNewline=89]="renderFinalNewline",W[W.renderLineHighlight=90]="renderLineHighlight",W[W.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",W[W.renderValidationDecorations=92]="renderValidationDecorations",W[W.renderWhitespace=93]="renderWhitespace",W[W.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",W[W.roundedSelection=95]="roundedSelection",W[W.rulers=96]="rulers",W[W.scrollbar=97]="scrollbar",W[W.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",W[W.scrollBeyondLastLine=99]="scrollBeyondLastLine",W[W.scrollPredominantAxis=100]="scrollPredominantAxis",W[W.selectionClipboard=101]="selectionClipboard",W[W.selectionHighlight=102]="selectionHighlight",W[W.selectOnLineNumbers=103]="selectOnLineNumbers",W[W.showFoldingControls=104]="showFoldingControls",W[W.showUnused=105]="showUnused",W[W.snippetSuggestions=106]="snippetSuggestions",W[W.smartSelect=107]="smartSelect",W[W.smoothScrolling=108]="smoothScrolling",W[W.stickyScroll=109]="stickyScroll",W[W.stickyTabStops=110]="stickyTabStops",W[W.stopRenderingLineAfter=111]="stopRenderingLineAfter",W[W.suggest=112]="suggest",W[W.suggestFontSize=113]="suggestFontSize",W[W.suggestLineHeight=114]="suggestLineHeight",W[W.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",W[W.suggestSelection=116]="suggestSelection",W[W.tabCompletion=117]="tabCompletion",W[W.tabIndex=118]="tabIndex",W[W.unicodeHighlighting=119]="unicodeHighlighting",W[W.unusualLineTerminators=120]="unusualLineTerminators",W[W.useShadowDOM=121]="useShadowDOM",W[W.useTabStops=122]="useTabStops",W[W.wordBreak=123]="wordBreak",W[W.wordSeparators=124]="wordSeparators",W[W.wordWrap=125]="wordWrap",W[W.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",W[W.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",W[W.wordWrapColumn=128]="wordWrapColumn",W[W.wordWrapOverride1=129]="wordWrapOverride1",W[W.wordWrapOverride2=130]="wordWrapOverride2",W[W.wrappingIndent=131]="wrappingIndent",W[W.wrappingStrategy=132]="wrappingStrategy",W[W.showDeprecated=133]="showDeprecated",W[W.inlayHints=134]="inlayHints",W[W.editorClassName=135]="editorClassName",W[W.pixelRatio=136]="pixelRatio",W[W.tabFocusMode=137]="tabFocusMode",W[W.layoutInfo=138]="layoutInfo",W[W.wrappingInfo=139]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(184,null)})),acceptSuggestionOnEnter:Be(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(185,null),""],markdownDescription:o.localize(186,null)})),accessibilitySupport:Be(new l),accessibilityPageSize:Be(new b(3,"accessibilityPageSize",10,1,1073741824,{description:o.localize(187,null),tags:["accessibility"]})),ariaLabel:Be(new p(4,"ariaLabel",o.localize(188,null))),autoClosingBrackets:Be(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(189,null),o.localize(190,null),""],description:o.localize(191,null)})),autoClosingDelete:Be(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(192,null),""],description:o.localize(193,null)})),autoClosingOvertype:Be(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(194,null),""],description:o.localize(195,null)})),autoClosingQuotes:Be(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(196,null),o.localize(197,null),""],description:o.localize(198,null)})),autoIndent:Be(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[o.localize(199,null),o.localize(200,null),o.localize(201,null),o.localize(202,null),o.localize(203,null)],description:o.localize(204,null)})),automaticLayout:Be(new u(10,"automaticLayout",!1)),autoSurround:Be(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(205,null),o.localize(206,null),o.localize(207,null),""],description:o.localize(208,null)})),bracketPairColorization:Be(new de),bracketPairGuides:Be(new we),stickyTabStops:Be(new u(110,"stickyTabStops",!1,{description:o.localize(209,null)})),codeLens:Be(new u(14,"codeLens",!0,{description:o.localize(210,null)})),codeLensFontFamily:Be(new p(15,"codeLensFontFamily","",{description:o.localize(211,null)})),codeLensFontSize:Be(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(212,null)})),colorDecorators:Be(new u(17,"colorDecorators",!0,{description:o.localize(213,null)})),colorDecoratorsLimit:Be(new b(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:o.localize(214,null)})),columnSelection:Be(new u(19,"columnSelection",!1,{description:o.localize(215,null)})),comments:Be(new m),contextmenu:Be(new u(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new u(22,"copyWithSyntaxHighlighting",!0,{description:o.localize(216,null)})),cursorBlinking:Be(new r(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:o.localize(217,null)})),cursorSmoothCaretAnimation:Be(new s(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[o.localize(218,null),o.localize(219,null),o.localize(220,null)],description:o.localize(221,null)})),cursorStyle:Be(new r(25,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],w,{description:o.localize(222,null)})),cursorSurroundingLines:Be(new b(26,"cursorSurroundingLines",0,0,1073741824,{description:o.localize(223,null)})),cursorSurroundingLinesStyle:Be(new s(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(224,null),o.localize(225,null)],description:o.localize(226,null)})),cursorWidth:Be(new b(28,"cursorWidth",0,0,1073741824,{markdownDescription:o.localize(227,null)})),disableLayerHinting:Be(new u(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new u(30,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new u(31,"domReadOnly",!1)),dragAndDrop:Be(new u(32,"dragAndDrop",!0,{description:o.localize(228,null)})),emptySelectionClipboard:Be(new q),dropIntoEditor:Be(new nt),stickyScroll:Be(new pe),experimentalWhitespaceRendering:Be(new s(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[o.localize(229,null),o.localize(230,null),o.localize(231,null)],description:o.localize(232,null)})),extraEditorClassName:Be(new p(36,"extraEditorClassName","")),fastScrollSensitivity:Be(new D(37,"fastScrollSensitivity",5,W=>W<=0?5:W,{markdownDescription:o.localize(233,null)})),find:Be(new V),fixedOverflowWidgets:Be(new u(39,"fixedOverflowWidgets",!1)),folding:Be(new u(40,"folding",!0,{description:o.localize(234,null)})),foldingStrategy:Be(new s(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(235,null),o.localize(236,null)],description:o.localize(237,null)})),foldingHighlight:Be(new u(42,"foldingHighlight",!0,{description:o.localize(238,null)})),foldingImportsByDefault:Be(new u(43,"foldingImportsByDefault",!1,{description:o.localize(239,null)})),foldingMaximumRegions:Be(new b(44,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(240,null)})),unfoldOnClickAfterEndOfLine:Be(new u(45,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(241,null)})),fontFamily:Be(new p(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(242,null)})),fontInfo:Be(new N),fontLigatures2:Be(new M),fontSize:Be(new U),fontWeight:Be(new $),fontVariations:Be(new B),formatOnPaste:Be(new u(52,"formatOnPaste",!1,{description:o.localize(243,null)})),formatOnType:Be(new u(53,"formatOnType",!1,{description:o.localize(244,null)})),glyphMargin:Be(new u(54,"glyphMargin",!0,{description:o.localize(245,null)})),gotoLocation:Be(new z),hideCursorInOverviewRuler:Be(new u(56,"hideCursorInOverviewRuler",!1,{description:o.localize(246,null)})),hover:Be(new ae),inDiffEditor:Be(new u(58,"inDiffEditor",!1)),letterSpacing:Be(new D(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,W=>D.clamp(W,-5,20),{description:o.localize(247,null)})),lightbulb:Be(new ie),lineDecorationsWidth:Be(new Y),lineHeight:Be(new Z),lineNumbers:Be(new te),lineNumbersMinChars:Be(new b(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new u(66,"linkedEditing",!1,{description:o.localize(248,null)})),links:Be(new u(67,"links",!0,{description:o.localize(249,null)})),matchBrackets:Be(new s(68,"matchBrackets","always",["always","near","never"],{description:o.localize(250,null)})),minimap:Be(new me),mouseStyle:Be(new s(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new D(71,"mouseWheelScrollSensitivity",1,W=>W===0?1:W,{markdownDescription:o.localize(251,null)})),mouseWheelZoom:Be(new u(72,"mouseWheelZoom",!1,{markdownDescription:o.localize(252,null)})),multiCursorMergeOverlapping:Be(new u(73,"multiCursorMergeOverlapping",!0,{description:o.localize(253,null)})),multiCursorModifier:Be(new r(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ve,{markdownEnumDescriptions:[o.localize(254,null),o.localize(255,null)],markdownDescription:o.localize(256,null)})),multiCursorPaste:Be(new s(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(257,null),o.localize(258,null)],markdownDescription:o.localize(259,null)})),multiCursorLimit:Be(new b(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:o.localize(260,null)})),occurrencesHighlight:Be(new u(77,"occurrencesHighlight",!0,{description:o.localize(261,null)})),overviewRulerBorder:Be(new u(78,"overviewRulerBorder",!0,{description:o.localize(262,null)})),overviewRulerLanes:Be(new b(79,"overviewRulerLanes",3,0,3)),padding:Be(new Ie),parameterHints:Be(new Re),peekWidgetDefaultFocus:Be(new s(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(263,null),o.localize(264,null)],description:o.localize(265,null)})),definitionLinkOpensInPeek:Be(new u(83,"definitionLinkOpensInPeek",!1,{description:o.localize(266,null)})),quickSuggestions:Be(new le),quickSuggestionsDelay:Be(new b(85,"quickSuggestionsDelay",10,0,1073741824,{description:o.localize(267,null)})),readOnly:Be(new u(86,"readOnly",!1)),renameOnType:Be(new u(87,"renameOnType",!1,{description:o.localize(268,null),markdownDeprecationMessage:o.localize(269,null)})),renderControlCharacters:Be(new u(88,"renderControlCharacters",!0,{description:o.localize(270,null),restricted:!0})),renderFinalNewline:Be(new s(89,"renderFinalNewline",A.isLinux?"dimmed":"on",["off","on","dimmed"],{description:o.localize(271,null)})),renderLineHighlight:Be(new s(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(272,null)],description:o.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Be(new u(91,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(274,null)})),renderValidationDecorations:Be(new s(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new s(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(275,null),o.localize(276,null),o.localize(277,null),""],description:o.localize(278,null)})),revealHorizontalRightPadding:Be(new b(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new u(95,"roundedSelection",!0,{description:o.localize(279,null)})),rulers:Be(new se),scrollbar:Be(new H),scrollBeyondLastColumn:Be(new b(98,"scrollBeyondLastColumn",4,0,1073741824,{description:o.localize(280,null)})),scrollBeyondLastLine:Be(new u(99,"scrollBeyondLastLine",!0,{description:o.localize(281,null)})),scrollPredominantAxis:Be(new u(100,"scrollPredominantAxis",!0,{description:o.localize(282,null)})),selectionClipboard:Be(new u(101,"selectionClipboard",!0,{description:o.localize(283,null),included:A.isLinux})),selectionHighlight:Be(new u(102,"selectionHighlight",!0,{description:o.localize(284,null)})),selectOnLineNumbers:Be(new u(103,"selectOnLineNumbers",!0)),showFoldingControls:Be(new s(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(285,null),o.localize(286,null),o.localize(287,null)],description:o.localize(288,null)})),showUnused:Be(new u(105,"showUnused",!0,{description:o.localize(289,null)})),showDeprecated:Be(new u(133,"showDeprecated",!0,{description:o.localize(290,null)})),inlayHints:Be(new Q),snippetSuggestions:Be(new s(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(291,null),o.localize(292,null),o.localize(293,null),o.localize(294,null)],description:o.localize(295,null)})),smartSelect:Be(new Ce),smoothScrolling:Be(new u(108,"smoothScrolling",!1,{description:o.localize(296,null)})),stopRenderingLineAfter:Be(new b(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new be),inlineSuggest:Be(new _),suggestFontSize:Be(new b(113,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new b(114,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new u(115,"suggestOnTriggerCharacters",!0,{description:o.localize(299,null)})),suggestSelection:Be(new s(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(300,null),o.localize(301,null),o.localize(302,null)],description:o.localize(303,null)})),tabCompletion:Be(new s(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(304,null),o.localize(305,null),o.localize(306,null)],description:o.localize(307,null)})),tabIndex:Be(new b(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new K),unusualLineTerminators:Be(new s(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(308,null),o.localize(309,null),o.localize(310,null)],description:o.localize(311,null)})),useShadowDOM:Be(new u(121,"useShadowDOM",!0)),useTabStops:Be(new u(122,"useTabStops",!0,{description:o.localize(312,null)})),wordBreak:Be(new s(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[o.localize(313,null),o.localize(314,null)],description:o.localize(315,null)})),wordSeparators:Be(new p(124,"wordSeparators",a.USUAL_WORD_SEPARATORS,{description:o.localize(316,null)})),wordWrap:Be(new s(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(317,null),o.localize(318,null),o.localize(319,null),o.localize(320,null)],description:o.localize(321,null)})),wordWrapBreakAfterCharacters:Be(new p(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new p(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new b(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:o.localize(322,null)})),wordWrapOverride1:Be(new s(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new s(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new L),pixelRatio:Be(new oe),tabFocusMode:Be(new u(137,"tabFocusMode",!1,{markdownDescription:o.localize(323,null)})),layoutInfo:Be(new x),wrappingInfo:Be(new Ge),wrappingIndent:Be(new He),wrappingStrategy:Be(new J)}}),define(ye[169],De([17,18]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[170],De([17,18]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[171],De([17,18]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[172],De([17,18]),function(ne,e){return ne.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[173],De([17,18]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ye[174],De([17,18]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(ye[175],De([17,18]),function(ne,e){return ne.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[176],De([17,18]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ye[177],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[178],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[179],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[180],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[181],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[182],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[183],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[184],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[185],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[186],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ye[187],De([17,18]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(ye[188],De([17,18]),function(ne,e){return ne.create("vs/workbench/common/views",e)}),define(ye[189],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[190],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[191],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[192],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[193],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[194],De([17,18]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[195],De([17,18]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[196],De([17,18]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[197],De([1,0,12]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class A{constructor(){this.a=new Map}register(R,I){this.a.set(R,I)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const I in R.contributes){const P=this.a.get(I);if(!P)continue;const S=R.contributes[I],k=Array.isArray(S)?S:[S];try{P(k,R.activationEvents)}catch(O){(0,o.onUnexpectedError)(O)}}}}e.ImplicitActivationEventsImpl=A,e.ImplicitActivationEvents=new A}),define(ye[198],De([1,0,24,37,171,319]),function(ne,e,o,A,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function S(u){return u=u.trim(),u==="*"||I.test(u)}e.isValidVersionStr=S;function k(u){if(!S(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=u.match(I);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=k;function O(u){if(!u)return null;const g=u.majorBase,b=u.majorMustEqual,D=u.minorBase;let p=u.minorMustEqual;const n=u.patchBase;let s=u.patchMustEqual;u.hasCaret&&(g===0||(p=!1),s=!1);let r=0;if(u.preRelease){const c=P.exec(u.preRelease);if(c){const[,l,m,i]=c;r=Date.UTC(Number(l),Number(m)-1,Number(i))}}return{majorBase:g,majorMustEqual:b,minorBase:D,minorMustEqual:p,patchBase:n,patchMustEqual:s,isMinimum:u.hasGreaterEquals,notBefore:r}}e.normalizeVersion=O;function T(u,g,b){let D;typeof u=="string"?D=O(k(u)):D=u;let p;g instanceof Date?p=g.getTime():typeof g=="string"&&(p=new Date(g).getTime());let n;if(typeof b=="string"?n=O(k(b)):n=b,!D||!n)return!1;const s=D.majorBase,r=D.minorBase,c=D.patchBase;let l=n.majorBase,m=n.minorBase,i=n.patchBase;const t=n.notBefore;let d=n.majorMustEqual,E=n.minorMustEqual,w=n.patchMustEqual;return n.isMinimum?s>l?!0:s<l?!1:r>m?!0:r<m||p&&p<t?!1:c>=i:(s===1&&l===0&&(!d||!E||!w)&&(l=1,m=0,i=0,d=!0,E=!1,w=!1),s<l?!1:s>l?!d:r<m?!1:r>m?!E:c<i?!1:c>i?!w:!(p&&p<t))}e.isValidVersion=T;function v(u,g,b,D,p){const n=[];if(typeof D.publisher<"u"&&typeof D.publisher!="string")return n.push([A.default.Error,a.localize(0,null)]),n;if(typeof D.name!="string")return n.push([A.default.Error,a.localize(1,null,"name")]),n;if(typeof D.version!="string")return n.push([A.default.Error,a.localize(2,null,"version")]),n;if(!D.engines)return n.push([A.default.Error,a.localize(3,null,"engines")]),n;if(typeof D.engines.vscode!="string")return n.push([A.default.Error,a.localize(4,null,"engines.vscode")]),n;if(typeof D.extensionDependencies<"u"&&!h(D.extensionDependencies))return n.push([A.default.Error,a.localize(5,null,"extensionDependencies")]),n;if(typeof D.activationEvents<"u"){if(!h(D.activationEvents))return n.push([A.default.Error,a.localize(6,null,"activationEvents")]),n;if(typeof D.main>"u"&&typeof D.browser>"u")return n.push([A.default.Error,a.localize(7,null,"activationEvents","main")]),n}if(typeof D.extensionKind<"u"&&typeof D.main>"u"&&n.push([A.default.Warning,a.localize(8,null,"extensionKind")]),typeof D.main<"u"){if(typeof D.main!="string")return n.push([A.default.Error,a.localize(9,null,"main")]),n;{const c=(0,o.joinPath)(b,D.main);(0,o.isEqualOrParent)(c,b)||n.push([A.default.Warning,a.localize(10,null,c.path,b.path)])}if(typeof D.activationEvents>"u")return n.push([A.default.Error,a.localize(11,null,"activationEvents","main")]),n}if(typeof D.browser<"u"){if(typeof D.browser!="string")return n.push([A.default.Error,a.localize(12,null,"browser")]),n;{const c=(0,o.joinPath)(b,D.browser);(0,o.isEqualOrParent)(c,b)||n.push([A.default.Warning,a.localize(13,null,c.path,b.path)])}if(typeof D.activationEvents>"u")return n.push([A.default.Error,a.localize(14,null,"activationEvents","browser")]),n}if(!R.valid(D.version))return n.push([A.default.Error,a.localize(15,null)]),n;const s=[];if(!C(u,g,D,p,s))for(const c of s)n.push([A.default.Error,c]);return n}e.validateExtensionManifest=v;function C(u,g,b,D,p){return D||typeof b.main>"u"&&typeof b.browser>"u"?!0:f(u,g,b.engines.vscode,p)}e.isValidExtensionVersion=C;function y(u,g,b){return u==="*"||f(g,b,u)}e.isEngineValid=y;function f(u,g,b,D=[]){const p=O(k(b));if(!p)return D.push(a.localize(16,null,b)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return D.push(a.localize(17,null,b)),!1}else if(!p.majorMustEqual)return D.push(a.localize(18,null,b)),!1;return T(u,g,p)?!0:(D.push(a.localize(19,null,u,b)),!1)}function h(u){if(!Array.isArray(u))return!1;for(let g=0,b=u.length;g<b;g++)if(typeof u[g]!="string")return!1;return!0}}),define(ye[122],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class o{constructor(a,R=[],I=!1){this.ctor=a,this.staticArguments=R,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=o}),define(ye[90],De([1,0,122]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var a;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(a=e.InstantiationType||(e.InstantiationType={}));function R(P,S,k){S instanceof o.SyncDescriptor||(S=new o.SyncDescriptor(S,[],Boolean(k))),A.push([P,S])}e.registerSingleton=R;function I(){return A}e.getSingletonServiceDescriptors=I}),define(ye[199],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class o{constructor(R,I){this.key=R,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.Node=o;class A{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const I of this.a.values())I.outgoing.size===0&&R.push(I);return R}insertEdge(R,I){const P=this.lookupOrInsertNode(R),S=this.lookupOrInsertNode(I);P.outgoing.set(S.key,S),S.incoming.set(P.key,P)}removeNode(R){const I=this.b(R);this.a.delete(I);for(const P of this.a.values())P.outgoing.delete(I),P.incoming.delete(I)}lookupOrInsertNode(R){const I=this.b(R);let P=this.a.get(I);return P||(P=new o(I,R),this.a.set(I,P)),P}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[I,P]of this.a)R.push(`${I}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,I]of this.a){const P=new Set([R]),S=this.c(I,P);if(S)return S}}c(R,I){for(const[P,S]of R.outgoing){if(I.has(P))return[...I,P].join(" -> ");I.add(P);const k=this.c(S,I);if(k)return k;I.delete(P)}}}e.Graph=A}),define(ye[4],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var o;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function P(S){return S[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=P})(o=e._util||(e._util={})),e.IInstantiationService=a("instantiationService");function A(I,P,S){P[o.DI_TARGET]===P?P[o.DI_DEPENDENCIES].push({id:I,index:S}):(P[o.DI_DEPENDENCIES]=[{id:I,index:S}],P[o.DI_TARGET]=P)}function a(I){if(o.serviceIds.has(I))return o.serviceIds.get(I);const P=function(S,k,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,S,O)};return P.toString=()=>I,o.serviceIds.set(I,P),P}e.createDecorator=a;function R(I){return I}e.refineServiceDecorator=R}),define(ye[53],De([1,0,9,2,4]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,a.createDecorator)("configurationService");function R(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof A.URI)}e.isConfigurationOverrides=R;function I(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=I;var P;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function k(h,u){const g=Object.create(null);for(const b in h)O(g,b,h[b],u);return g}e.toValuesTree=k;function O(h,u,g,b){const D=u.split("."),p=D.pop();let n=h;for(let s=0;s<D.length;s++){const r=D[s];let c=n[r];switch(typeof c){case"undefined":c=n[r]=Object.create(null);break;case"object":break;default:b(`Ignoring ${u} as ${D.slice(0,s+1).join(".")} is ${JSON.stringify(c)}`);return}n=c}if(typeof n=="object"&&n!==null)try{n[p]=g}catch{b(`Ignoring ${u} as ${D.join(".")} is ${JSON.stringify(n)}`)}else b(`Ignoring ${u} as ${D.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=O;function T(h,u){const g=u.split(".");v(h,g)}e.removeFromValueTree=T;function v(h,u){const g=u.shift();if(u.length===0){delete h[g];return}if(Object.keys(h).indexOf(g)!==-1){const b=h[g];typeof b=="object"&&!Array.isArray(b)&&(v(b,u),Object.keys(b).length===0&&delete h[g])}}function C(h,u,g){function b(n,s){let r=n;for(const c of s){if(typeof r!="object"||r===null)return;r=r[c]}return r}const D=u.split("."),p=b(h,D);return typeof p>"u"?g:p}e.getConfigurationValue=C;function y(h,u,g){Object.keys(u).forEach(b=>{b!=="__proto__"&&(b in h?o.isObject(h[b])&&o.isObject(u[b])?y(h[b],u[b],g):g&&(h[b]=u[b]):h[b]=u[b])})}e.merge=y;function f(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(ye[54],De([1,0,10,8,4]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",o.isMacintosh),R.set("isLinux",o.isLinux),R.set("isWindows",o.isWindows),R.set("isWeb",o.isWeb),R.set("isMacNative",o.isMacintosh&&!o.isWeb),R.set("isEdge",o.isEdge),R.set("isFirefox",o.isFirefox),R.set("isChrome",o.isChrome),R.set("isSafari",o.isSafari);const I=Object.prototype.hasOwnProperty;var P;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return T.INSTANCE}static true(){return v.INSTANCE}static has(M){return C.create(M)}static equals(M,B){return y.create(M,B)}static notEquals(M,B){return u.create(M,B)}static regex(M,B){return r.create(M,B)}static in(M,B){return f.create(M,B)}static notIn(M,B){return h.create(M,B)}static not(M){return g.create(M)}static and(...M){return m.create(M,null,!0)}static or(...M){return i.create(M,null,!0)}static greater(M,B){return D.create(M,B)}static greaterEquals(M,B){return p.create(M,B)}static smaller(M,B){return n.create(M,B)}static smallerEquals(M,B){return s.create(M,B)}static deserialize(M){if(!!M)return this.c(M)}static c(M){const B=M.split("||");return i.create(B.map(N=>this.d(N)),null,!0)}static d(M){const B=M.split("&&");return m.create(B.map(N=>this.f(N)),null,!0)}static f(M){if(M=M.trim(),M.indexOf("!=")>=0){const B=M.split("!=");return u.create(B[0].trim(),this.g(B[1]))}if(M.indexOf("==")>=0){const B=M.split("==");return y.create(B[0].trim(),this.g(B[1]))}if(M.indexOf("=~")>=0){const B=M.split("=~");return r.create(B[0].trim(),this.h(B[1]))}if(M.indexOf(" not in ")>=0){const B=M.split(" not in ");return h.create(B[0].trim(),this.g(B[1]))}if(M.indexOf(" in ")>=0){const B=M.split(" in ");return f.create(B[0].trim(),this.g(B[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(M)){const B=M.split(">=");return p.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(M)){const B=M.split(">");return D.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(M)){const B=M.split("<=");return s.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(M)){const B=M.split("<");return n.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(M)?g.create(M.substr(1).trim()):C.create(M)}static g(M){if(M=M.trim(),M==="true")return!0;if(M==="false")return!1;const B=/^'([^']*)'$/.exec(M);return B?B[1].trim():M}static h(M){if((0,A.isFalsyOrWhitespace)(M))return console.warn("missing regexp-value for =~-expression"),null;const B=M.indexOf("/"),N=M.lastIndexOf("/");if(B===N||B<0)return console.warn(`bad regexp-value '${M}', missing /-enclosure`),null;const U=M.slice(B+1,N),$=M[N+1]==="i"?"i":"";try{return new RegExp(U,$)}catch(z){return console.warn(`bad regexp-value '${M}', parse error: ${z}`),null}}}e.ContextKeyExpr=S;function k(V,M){const B=V?V.substituteConstants():void 0,N=M?M.substituteConstants():void 0;return!B&&!N?!0:!B||!N?!1:B.equals(N)}e.expressionsAreEqualWithConstantSubstitution=k;function O(V,M){return V.cmp(M)}class T{constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return v.INSTANCE}}T.INSTANCE=new T,e.ContextKeyFalseExpr=T;class v{constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return T.INSTANCE}}v.INSTANCE=new v,e.ContextKeyTrueExpr=v;class C{static create(M,B=null){const N=R.get(M);return typeof N=="boolean"?N?v.INSTANCE:T.INSTANCE:new C(M,B)}constructor(M,B){this.key=M,this.c=B,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:d(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=R.get(this.key);return typeof M=="boolean"?M?v.INSTANCE:T.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=g.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=C;class y{static create(M,B,N=null){if(typeof B=="boolean")return B?C.create(M,N):g.create(M,N);const U=R.get(M);return typeof U=="boolean"?B===(U?"true":"false")?v.INSTANCE:T.INSTANCE:new y(M,B,N)}constructor(M,B,N){this.c=M,this.d=B,this.f=N,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:E(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=R.get(this.c);if(typeof M=="boolean"){const B=M?"true":"false";return this.d===B?v.INSTANCE:T.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=y;class f{static create(M,B){return new f(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=10,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:E(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const B=M.getValue(this.f),N=M.getValue(this.d);return Array.isArray(B)?B.includes(N):typeof N=="string"&&typeof B=="object"&&B!==null?I.call(B,N):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=h.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=f;class h{static create(M,B){return new h(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=11,this.c=f.create(M,B)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=h;class u{static create(M,B,N=null){if(typeof B=="boolean")return B?g.create(M,N):C.create(M,N);const U=R.get(M);return typeof U=="boolean"?B===(U?"true":"false")?T.INSTANCE:v.INSTANCE:new u(M,B,N)}constructor(M,B,N){this.c=M,this.d=B,this.f=N,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:E(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=R.get(this.c);if(typeof M=="boolean"){const B=M?"true":"false";return this.d===B?T.INSTANCE:v.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=u;class g{static create(M,B=null){const N=R.get(M);return typeof N=="boolean"?N?T.INSTANCE:v.INSTANCE:new g(M,B)}constructor(M,B){this.c=M,this.d=B,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:d(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=R.get(this.c);return typeof M=="boolean"?M?T.INSTANCE:v.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=C.create(this.c,this)),this.d}}e.ContextKeyNotExpr=g;function b(V,M){if(typeof V=="string"){const B=parseFloat(V);isNaN(B)||(V=B)}return typeof V=="string"||typeof V=="number"?M(V):T.INSTANCE}class D{static create(M,B,N=null){return b(B,U=>new D(M,U,N))}constructor(M,B,N){this.c=M,this.d=B,this.f=N,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:E(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=D;class p{static create(M,B,N=null){return b(B,U=>new p(M,U,N))}constructor(M,B,N){this.c=M,this.d=B,this.f=N,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:E(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=p;class n{static create(M,B,N=null){return b(B,U=>new n(M,U,N))}constructor(M,B,N){this.c=M,this.d=B,this.f=N,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:E(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=n;class s{static create(M,B,N=null){return b(B,U=>new s(M,U,N))}constructor(M,B,N){this.c=M,this.d=B,this.f=N,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:E(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=s;class r{static create(M,B){return new r(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=7,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const B=this.f?this.f.source:"",N=M.f?M.f.source:"";return B<N?-1:B>N?1:0}equals(M){if(M.type===this.type){const B=this.f?this.f.source:"",N=M.f?M.f.source:"";return this.d===M.d&&B===N}return!1}substituteConstants(){return this}evaluate(M){const B=M.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=c.create(this)),this.c}}e.ContextKeyRegexExpr=r;class c{static create(M){return new c(M)}constructor(M){this.c=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(M){return new c(this.c.map(M))}negate(){return this.c}}e.ContextKeyNotRegexExpr=c;function l(V){let M=null;for(let B=0,N=V.length;B<N;B++){const U=V[B].substituteConstants();if(V[B]!==U&&M===null){M=[];for(let $=0;$<B;$++)M[$]=V[$]}M!==null&&(M[B]=U)}return M===null?V:M}class m{static create(M,B,N){return m.d(M,B,N)}constructor(M,B){this.expr=M,this.c=B,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let B=0,N=this.expr.length;B<N;B++){const U=O(this.expr[B],M.expr[B]);if(U!==0)return U}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let B=0,N=this.expr.length;B<N;B++)if(!this.expr[B].equals(M.expr[B]))return!1;return!0}return!1}substituteConstants(){const M=l(this.expr);return M===this.expr?this:m.create(M,this.c,!1)}evaluate(M){for(let B=0,N=this.expr.length;B<N;B++)if(!this.expr[B].evaluate(M))return!1;return!0}static d(M,B,N){const U=[];let $=!1;for(const z of M)if(!!z){if(z.type===1){$=!0;continue}if(z.type===0)return T.INSTANCE;if(z.type===6){U.push(...z.expr);continue}U.push(z)}if(U.length===0&&$)return v.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(O);for(let z=1;z<U.length;z++)U[z-1].equals(U[z])&&(U.splice(z,1),z--);if(U.length===1)return U[0];for(;U.length>1;){const z=U[U.length-1];if(z.type!==9)break;U.pop();const ae=U.pop(),ee=U.length===0,x=i.create(z.expr.map(J=>m.create([J,ae],null,N)),null,ee);x&&(U.push(x),U.sort(O))}if(U.length===1)return U[0];if(N){for(let z=0;z<U.length;z++)for(let ae=z+1;ae<U.length;ae++)if(U[z].negate().equals(U[ae]))return T.INSTANCE;if(U.length===1)return U[0]}return new m(U,B)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const B of this.expr)M.push(...B.keys());return M}map(M){return new m(this.expr.map(B=>B.map(M)),null)}negate(){if(!this.c){const M=[];for(const B of this.expr)M.push(B.negate());this.c=i.create(M,this,!0)}return this.c}}class i{static create(M,B,N){return i.d(M,B,N)}constructor(M,B){this.expr=M,this.c=B,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let B=0,N=this.expr.length;B<N;B++){const U=O(this.expr[B],M.expr[B]);if(U!==0)return U}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let B=0,N=this.expr.length;B<N;B++)if(!this.expr[B].equals(M.expr[B]))return!1;return!0}return!1}substituteConstants(){const M=l(this.expr);return M===this.expr?this:i.create(M,this.c,!1)}evaluate(M){for(let B=0,N=this.expr.length;B<N;B++)if(this.expr[B].evaluate(M))return!0;return!1}static d(M,B,N){let U=[],$=!1;if(M){for(let z=0,ae=M.length;z<ae;z++){const ee=M[z];if(!!ee){if(ee.type===0){$=!0;continue}if(ee.type===1)return v.INSTANCE;if(ee.type===9){U=U.concat(ee.expr);continue}U.push(ee)}}if(U.length===0&&$)return T.INSTANCE;U.sort(O)}if(U.length!==0){if(U.length===1)return U[0];for(let z=1;z<U.length;z++)U[z-1].equals(U[z])&&(U.splice(z,1),z--);if(U.length===1)return U[0];if(N){for(let z=0;z<U.length;z++)for(let ae=z+1;ae<U.length;ae++)if(U[z].negate().equals(U[ae]))return v.INSTANCE;if(U.length===1)return U[0]}return new i(U,B)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const B of this.expr)M.push(...B.keys());return M}map(M){return new i(this.expr.map(B=>B.map(M)),null)}negate(){if(!this.c){const M=[];for(const B of this.expr)M.push(B.negate());for(;M.length>1;){const B=M.shift(),N=M.shift(),U=[];for(const $ of q(B))for(const z of q(N))U.push(m.create([$,z],null,!1));M.unshift(i.create(U,null,!1))}this.c=i.create(M,this,!0)}return this.c}}class t extends C{static all(){return t.d.values()}constructor(M,B,N){super(M,null),this.f=B,typeof N=="object"?t.d.push({...N,key:M}):N!==!0&&t.d.push({key:M,description:N,type:B!=null?typeof B:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return y.create(this.key,M)}notEqualsTo(M){return u.create(this.key,M)}}t.d=[],e.RawContextKey=t,e.IContextKeyService=(0,a.createDecorator)("contextKeyService");function d(V,M){return V<M?-1:V>M?1:0}function E(V,M,B,N){return V<B?-1:V>B?1:M<N?-1:M>N?1:0}function w(V,M){if(V.type===0||M.type===1)return!0;if(V.type===9)return M.type===9?L(V.expr,M.expr):!1;if(M.type===9){for(const B of M.expr)if(w(V,B))return!0;return!1}if(V.type===6){if(M.type===6)return L(M.expr,V.expr);for(const B of V.expr)if(w(B,M))return!0;return!1}return V.equals(M)}e.implies=w;function L(V,M){let B=0,N=0;for(;B<V.length&&N<M.length;){const U=V[B].cmp(M[N]);if(U<0)return!1;U===0&&B++,N++}return B===V.length}function q(V){return V.type===9?V.expr:[V]}}),define(ye[200],De([1,0,4]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,o.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,o.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[123],De([1,0,170,4]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function a(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=a;function R(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function I(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function P(u,g){return g==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function S(u,g,b){return P(g,b)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===b?!0:k(b).includes(u)}e.isTargetPlatformCompatible=S;function k(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function O(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=O;var T;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var v;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var C;(function(u){u.Install="install",u.Uninstall="uninstall"})(C=e.StatisticType||(e.StatisticType={}));var y;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var f;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(f=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(g,b){super(g),this.code=b,this.name=b}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,o.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,o.localize)(1,null),original:"Preferences"}}),define(ye[201],De([1,0,4]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,o.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,o.createDecorator)("externalTerminal")}),define(ye[202],De([1,0,46,16,11,10,109,29,116,172,201]),function(ne,e,o,A,a,R,I,P,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const T=k.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:C.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class C extends v{openTerminal(D,p){return this.spawnTerminal(o,D,S.getWindowsShell(),p)}spawnTerminal(D,p,n,s){const r=p.windowsExec||C.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const c=a.basename(r,".exe").toLowerCase();if(c==="cmder")return D.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return r.indexOf(" ")>=0&&l.push('""'),l.push(r),c==="wt"&&l.push("-d ."),new Promise((m,i)=>{const t=h(process),d=D.spawn(n,l,{cwd:s,env:t});d.on("error",i),d.on("exit",()=>m())})}runInTerminal(D,p,n,s,r){const c="windowsExec"in r&&r.windowsExec?r.windowsExec:C.getDefaultTerminalWindows();return new Promise((l,m)=>{const i=`"${p} - ${T}"`,t=`""${n.join('" "')}" & pause"`,d=Object.assign({},h(process),s);Object.keys(d).filter(V=>d[V]===null).forEach(V=>delete d[V]);const E={cwd:p,env:d,windowsVerbatimArguments:!0};let w,L;a.basename(c,".exe")==="wt"?(w=c,L=["-d",".",C.b,"/c",t]):(w=C.b,L=["/c","start",i,"/wait",c,"/c",t]),o.spawn(w,L,E).on("error",V=>{m(u(V))}),l(void 0)})}static getDefaultTerminalWindows(){if(!C.d){const D=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");C.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${D?"Sysnative":"System32"}\\cmd.exe`}return C.d}}C.b="cmd.exe",e.WindowsExternalTerminalService=C;class y extends v{openTerminal(D,p){return this.spawnTerminal(o,D,p)}runInTerminal(D,p,n,s,r){const c=r.osxExec||O.DEFAULT_TERMINAL_OSX;return new Promise((l,m)=>{if(c===O.DEFAULT_TERMINAL_OSX||c==="iTerm.app"){const i=c===O.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",d=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${i}.scpt`).fsPath,"-t",D||T,"-w",p];for(const L of n)d.push("-a"),d.push(L);if(s){const L=Object.assign({},h(process),s);for(const q in L){const V=L[q];V===null?(d.push("-u"),d.push(q)):(d.push("-e"),d.push(`${q}=${V}`))}}let E="";const w=o.spawn(y.b,d);w.on("error",L=>{m(u(L))}),w.stderr.on("data",L=>{E+=L.toString()}),w.on("exit",L=>{if(L===0)l(void 0);else if(E){const q=E.split(`
`,1);m(new Error(q[0]))}else m(new Error(k.localize(1,null,i,L)))})}else m(new Error(k.localize(2,null,c)))})}spawnTerminal(D,p,n){const s=p.osxExec||O.DEFAULT_TERMINAL_OSX;return new Promise((r,c)=>{const l=["-a",s];n&&l.push(n);const m=h(process),i=D.spawn("/usr/bin/open",l,{cwd:n,env:m});i.on("error",c),i.on("exit",()=>r())})}}y.b="/usr/bin/osascript",e.MacExternalTerminalService=y;class f extends v{openTerminal(D,p){return this.spawnTerminal(o,D,p)}runInTerminal(D,p,n,s,r){const c=r.linuxExec?Promise.resolve(r.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((l,m)=>{const i=[];c.then(t=>{t.indexOf("gnome-terminal")>=0?i.push("-x"):i.push("-e"),i.push("bash"),i.push("-c");const d=`${g(n)}; echo; read -p "${f.b}" -n1;`;i.push(`''${d}''`);const E=Object.assign({},h(process),s);Object.keys(E).filter(V=>E[V]===null).forEach(V=>delete E[V]);const w={cwd:p,env:E};let L="";const q=o.spawn(t,i,w);q.on("error",V=>{m(u(V))}),q.stderr.on("data",V=>{L+=V.toString()}),q.on("exit",V=>{if(V===0)l(void 0);else if(L){const M=L.split(`
`,1);m(new Error(M[0]))}else m(new Error(k.localize(4,null,t,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!R.isLinux)f.d=Promise.resolve("xterm");else{const D=await P.Promises.exists("/etc/debian_version");f.d=new Promise(p=>{D?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return f.d}spawnTerminal(D,p,n){const s=p.linuxExec?Promise.resolve(p.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((r,c)=>{s.then(l=>{const m=h(process),i=D.spawn(l,[],{cwd:n,env:m});i.on("error",c),i.on("exit",()=>r())})})}}f.b=k.localize(3,null),e.LinuxExternalTerminalService=f;function h(b){const D={...b.env};return(0,I.sanitizeProcessEnvironment)(D),D}function u(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(k.localize(5,null,b.path)):b}function g(b){let D="";for(const p of b)p.indexOf(" ")>=0?D+='"'+p+'"':D+=p,D+=" ";return D}}),define(ye[44],De([1,0,68,11,8,9,2,173,4,10,16]),function(ne,e,o,A,a,R,I,P,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function T(x){return x.create===!0}e.isFileOpenForWriteOptions=T;var v;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var C;(function(x){x[x.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var y;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=f;function h(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=h;function u(x){return!!(x.capabilities&32768)}e.hasFileCloneCapability=u;function g(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function b(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=b;function D(x){return f(x)?!!(x.capabilities&16384):!1}e.hasFileAtomicReadCapability=D;var p;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class n extends Error{static create(J,ie){const pe=new n(J.toString(),ie);return c(pe,ie),pe}constructor(J,ie){super(J),this.code=ie}}e.FileSystemProviderError=n;function s(x,J){return n.create(x,J)}e.createFileSystemProviderError=s;function r(x){return x||s((0,P.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=r;function c(x,J){return x.name=J?`${J} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=c;function l(x){if(!x)return p.Unknown;if(x instanceof n)return x.code;const J=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!J)return p.Unknown;switch(J[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=l;function m(x){if(x instanceof L)return x.fileOperationResult;switch(l(x)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=m;var i;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class t{constructor(J,ie,pe){this.resource=J,this.operation=ie,this.target=pe}isOperation(J){return this.operation===J}}e.FileOperationEvent=t;var d;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(d=e.FileChangeType||(e.FileChangeType={}));class E{constructor(J,ie){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const pe=new Map;for(const Q of J){const Y=pe.get(Q.type);switch(Y?Y.push([Q.resource,Q]):pe.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,Y]of pe)switch(Q){case 1:this.a=o.TernarySearchTree.forUris(()=>ie),this.a.fill(Y);break;case 0:this.b=o.TernarySearchTree.forUris(()=>ie),this.b.fill(Y);break;case 2:this.c=o.TernarySearchTree.forUris(()=>ie),this.c.fill(Y);break}}contains(J,...ie){return this.d(J,{includeChildren:!1},...ie)}affects(J,...ie){return this.d(J,{includeChildren:!0},...ie)}d(J,ie,...pe){if(!J)return!1;const Q=pe.length>0;return!!((!Q||pe.includes(1))&&(this.a?.get(J)||ie.includeChildren&&this.a?.findSuperstr(J))||(!Q||pe.includes(0))&&(this.b?.get(J)||ie.includeChildren&&this.b?.findSuperstr(J))||(!Q||pe.includes(2))&&(this.c?.findSubstr(J)||ie.includeChildren&&this.c?.findSuperstr(J)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=E;function w(x,J,ie){return!x||!J||x===J||J.length>x.length?!1:(J.charAt(J.length-1)!==A.sep&&(J+=A.sep),ie?(0,a.startsWithIgnoreCase)(x,J):x.indexOf(J)===0)}e.isParent=w;class L extends Error{constructor(J,ie,pe){super(J),this.fileOperationResult=ie,this.options=pe}}e.FileOperationError=L;class q extends L{constructor(J,ie,pe,Q){super(J,ie,Q),this.fileOperationResult=ie,this.size=pe}}e.TooLargeFileOperationError=q;class V extends L{constructor(J,ie,pe){super(J,2,pe),this.stat=ie}}e.NotModifiedSinceFileOperationError=V;var M;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var B;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(B=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=N;async function U(x,J){if(!J.hasProvider(I.URI.from({scheme:x.scheme})))return new Promise(ie=>{const pe=J.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===x.scheme&&Q.added&&(pe.dispose(),ie())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(J){return(0,R.isNumber)(J)||(J=0),J<$.KB?(0,P.localize)(1,null,J.toFixed(0)):J<$.MB?(0,P.localize)(2,null,(J/$.KB).toFixed(2)):J<$.GB?(0,P.localize)(3,null,(J/$.MB).toFixed(2)):J<$.TB?(0,P.localize)(4,null,(J/$.GB).toFixed(2)):(0,P.localize)(5,null,(J/$.TB).toFixed(2))}}$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB,e.ByteSize=$;var z;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function ae(x){return{maxFileSize:x===0?300*$.MB:16*$.GB,maxHeapSize:x===0?700*$.MB:2*700*$.MB}}e.getPlatformFileLimits=ae;function ee(x){const J=typeof x=="string"||x?.scheme===O.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===O.Schemas.file?1024*$.MB:J?10*$.MB:k.isWeb?50*$.MB:1024*$.MB}e.getLargeFileConfirmationLimit=ee}),define(ye[91],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class o{constructor(...a){this.a=new Map;for(const[R,I]of a)this.set(R,I)}set(a,R){const I=this.a.get(a);return this.a.set(a,R),I}has(a){return this.a.has(a)}get(a){return this.a.get(a)}}e.ServiceCollection=o}),define(ye[203],De([1,0,19,12,6,122,199,4,91,66]),function(ne,e,o,A,a,R,I,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class T extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class v{constructor(h=new S.ServiceCollection,u=!1,g,b=O){this.f=h,this.g=u,this.h=g,this.i=b,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=b?g?._globalGraph??new I.Graph(D=>D):void 0}createChild(h){return new v(h,this.g,this,this.i)}invokeFunction(h,...u){const g=y.traceInvocation(this.i,h);let b=!1;try{return h({get:p=>{if(b)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(p,g);if(!n)throw new Error(`[invokeFunction] unknown service '${p}'`);return n}},...u)}finally{b=!0,g.stop()}}createInstance(h,...u){let g,b;return h instanceof R.SyncDescriptor?(g=y.traceCreation(this.i,h.ctor),b=this.j(h.ctor,h.staticArguments.concat(u),g)):(g=y.traceCreation(this.i,h),b=this.j(h,u,g)),g.stop(),b}j(h,u=[],g){const b=P._util.getServiceDependencies(h).sort((n,s)=>n.index-s.index),D=[];for(const n of b){const s=this.m(n.id,g);s||this.u(`[createInstance] ${h.name} depends on UNKNOWN service ${n.id}.`,!1),D.push(s)}const p=b.length>0?b[0].index:u.length;if(u.length!==p){console.trace(`[createInstance] First service dependency of ${h.name} at position ${p+1} conflicts with ${u.length} static arguments`);const n=p-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,p)}return Reflect.construct(h,u.concat(D))}k(h,u){if(this.f.get(h)instanceof R.SyncDescriptor)this.f.set(h,u);else if(this.h)this.h.k(h,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(h){const u=this.f.get(h);return!u&&this.h?this.h.l(h):u}m(h,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(h));const g=this.l(h);return g instanceof R.SyncDescriptor?this.q(h,g,u.branch(h,!0)):(u.branch(h,!1),g)}q(h,u,g){if(this.o.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this.o.add(h);try{return this.r(h,u,g)}finally{this.o.delete(h)}}r(h,u,g){const b=new I.Graph(n=>n.id.toString());let D=0;const p=[{id:h,desc:u,_trace:g}];for(;p.length;){const n=p.pop();if(b.lookupOrInsertNode(n),D++>1e3)throw new T(b);for(const s of P._util.getServiceDependencies(n.desc.ctor)){const r=this.l(s.id);if(r||this.u(`[createInstance] ${h} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),r instanceof R.SyncDescriptor){const c={id:s.id,desc:r,_trace:n._trace.branch(s.id,!0)};b.insertEdge(n,c),p.push(c)}}}for(;;){const n=b.roots();if(n.length===0){if(!b.isEmpty())throw new T(b);break}for(const{data:s}of n){if(this.l(s.id)instanceof R.SyncDescriptor){const c=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,c)}b.removeNode(s)}}return this.l(h)}s(h,u,g=[],b,D){if(this.f.get(h)instanceof R.SyncDescriptor)return this.t(h,u,g,b,D);if(this.h)return this.h.s(h,u,g,b,D);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(h,u,g=[],b,D){if(b){const p=new v(void 0,this.g,this,this.i);p.c=String(h);const n=new Map,s=new o.IdleValue(()=>{const r=p.j(u,g,D);for(const[c,l]of n){const m=r[c];if(typeof m=="function")for(const i of l)m.apply(r,i)}return n.clear(),r});return new Proxy(Object.create(null),{get(r,c){if(!s.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let i=n.get(c);return i||(i=new k.LinkedList,n.set(c,i)),(d,E,w)=>{const L=i.push([d,E,w]);return(0,a.toDisposable)(L)}}if(c in r)return r[c];const l=s.value;let m=l[c];return typeof m!="function"||(m=m.bind(l),r[c]=m),m},set(r,c,l){return s.value[c]=l,!0},getPrototypeOf(r){return u.prototype}})}else return this.j(u,g,D)}u(h,u){if(u&&console.warn(h),this.g)throw new Error(h)}}e.InstantiationService=v;var C;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(C||(C={}));class y{static traceInvocation(h,u){return h?new y(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(h,u){return h?new y(1,u.name):y.c}constructor(h,u){this.type=h,this.name=u,this.g=Date.now(),this.h=[]}branch(h,u){const g=new y(3,h.toString());return this.h.push([h,u,g]),g}stop(){const h=Date.now()-this.g;y.f+=h;let u=!1;function g(D,p){const n=[],s=new Array(D+1).join("	");for(const[r,c,l]of p.h)if(c&&l){u=!0,n.push(`${s}CREATES -> ${r}`);const m=g(D+1,l);m&&n.push(m)}else n.push(`${s}uses -> ${r}`);return n.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(h>2||u)&&y.all.add(b.join(`
`))}}y.all=new Set,y.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}},y.f=0,e.Trace=y}),define(ye[13],De([1,0,45,3,6,28,10,9,2,4]),function(ne,e,o,A,a,R,I,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function O(){return new Date().toISOString()}function T(i){return(0,P.isNumber)(i)}e.isLogLevel=T;var v;(function(i){i[i.Off=0]="Off",i[i.Trace=1]="Trace",i[i.Debug=2]="Debug",i[i.Info=3]="Info",i[i.Warning=4]="Warning",i[i.Error=5]="Error"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function C(i,t,d){switch(t){case v.Trace:i.trace(d);break;case v.Debug:i.debug(d);break;case v.Info:i.info(d);break;case v.Warning:i.warn(d);break;case v.Error:i.error(d);break;case v.Off:break;default:throw new Error(`Invalid log level ${t}`)}}e.log=C;function y(i){let t="";for(let d=0;d<i.length;d++){let E=i[d];if(typeof E=="object")try{E=JSON.stringify(E)}catch{}t+=(d>0?" ":"")+E}return t}e.format=y;class f extends a.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(t){this.b!==t&&(this.b=t,this.c.fire(this.b))}getLevel(){return this.b}f(t){return this.b!==v.Off&&this.b<=t}}e.AbstractLogger=f;class h extends f{constructor(t){super(),this.h=t}f(t){return this.h||super.f(t)}trace(t,...d){this.f(v.Trace)&&this.g(v.Trace,y([t,...d]))}debug(t,...d){this.f(v.Debug)&&this.g(v.Debug,y([t,...d]))}info(t,...d){this.f(v.Info)&&this.g(v.Info,y([t,...d]))}warn(t,...d){this.f(v.Warning)&&this.g(v.Warning,y([t,...d]))}error(t,...d){if(this.f(v.Error))if(t instanceof Error){const E=Array.prototype.slice.call(arguments);E[0]=t.stack,this.g(v.Error,y(E))}else this.g(v.Error,y([t,...d]))}flush(){}}e.AbstractMessageLogger=h;class u extends f{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.g=!I.isWindows}trace(t,...d){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${O()}]\x1B[0m`,t,...d):console.log(`[main ${O()}]`,t,...d))}debug(t,...d){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${O()}]\x1B[0m`,t,...d):console.log(`[main ${O()}]`,t,...d))}info(t,...d){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${O()}]\x1B[0m`,t,...d):console.log(`[main ${O()}]`,t,...d))}warn(t,...d){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${O()}]\x1B[0m`,t,...d):console.warn(`[main ${O()}]`,t,...d))}error(t,...d){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${O()}]\x1B[0m`,t,...d):console.error(`[main ${O()}]`,t,...d))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class g extends f{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...d){this.f(v.Trace)&&console.log("%cTRACE","color: #888",t,...d)}debug(t,...d){this.f(v.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",t,...d)}info(t,...d){this.f(v.Info)&&console.log("%c INFO","color: #33f",t,...d)}warn(t,...d){this.f(v.Warning)&&console.log("%c WARN","color: #993",t,...d)}error(t,...d){this.f(v.Error)&&console.log("%c  ERR","color: #f33",t,...d)}dispose(){}flush(){}}e.ConsoleLogger=g;class b extends f{constructor(t,d=e.DEFAULT_LOG_LEVEL){super(),this.g=t,this.setLevel(d)}trace(t,...d){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(t),...d])}debug(t,...d){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(t),...d])}info(t,...d){this.f(v.Info)&&this.g.log(v.Info,[this.h(t),...d])}warn(t,...d){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(t),...d])}error(t,...d){this.f(v.Error)&&this.g.log(v.Error,[this.h(t),...d])}h(t){return typeof t=="string"?t:(0,o.toErrorMessage)(t,this.f(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=b;class D extends f{constructor(t){super(),this.g=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const d of this.g)d.setLevel(t);super.setLevel(t)}trace(t,...d){for(const E of this.g)E.trace(t,...d)}debug(t,...d){for(const E of this.g)E.debug(t,...d)}info(t,...d){for(const E of this.g)E.info(t,...d)}warn(t,...d){for(const E of this.g)E.warn(t,...d)}error(t,...d){for(const E of this.g)E.error(t,...d)}flush(){for(const t of this.g)t.flush()}dispose(){for(const t of this.g)t.dispose()}}e.MultiplexLogger=D;class p extends a.Disposable{constructor(t,d){if(super(),this.j=t,this.b=new R.ResourceMap,this.c=new R.ResourceMap,this.f=this.B(new A.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new A.Emitter),this.onDidChangeVisibility=this.h.event,d)for(const E of d)this.c.set(E.resource,E)}getLogger(t){return this.b.get(t)}createLogger(t,d){let E=this.b.get(t);const w=d?.logLevel==="always"?v.Trace:d?.logLevel;return E||(E=this.k(t,w??this.getLogLevel(t)??this.j,d),this.b.set(t,E)),this.registerLogger({resource:t,id:d?.id??t.toString(),logLevel:w,name:d?.name,hidden:d?.hidden,extensionId:d?.extensionId}),E}setLogLevel(t,d){if(S.URI.isUri(t)){const E=t,w=d,L=this.c.get(E);L&&w!==L.logLevel&&(L.logLevel=w===this.j?void 0:w,this.b.get(E)?.setLevel(w),this.c.set(L.resource,L),this.g.fire([E,w]))}else{this.j=t;for(const[E,w]of this.b.entries())this.c.get(E)?.logLevel===void 0&&w.setLevel(this.j);this.g.fire(this.j)}}setVisibility(t,d){const E=this.c.get(t);E&&d!==!E.hidden&&(E.hidden=!d,this.c.set(E.resource,E),this.h.fire([t,d]))}getLogLevel(t){let d;return t&&(d=this.c.get(t)?.logLevel),d??this.j}registerLogger(t){const d=this.c.get(t.resource);d?d.hidden!==t.hidden&&this.setVisibility(t.resource,!t.hidden):(this.c.set(t.resource,t),this.f.fire({added:[t],removed:[]}))}deregisterLogger(t){const d=this.c.get(t);if(d){this.c.delete(t);const E=this.b.get(t);E&&(this.b.delete(t),E.dispose()),this.f.fire({added:[],removed:[d]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(t){return this.c.get(t)}dispose(){this.b.forEach(t=>t.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=p;class n{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return v.Info}trace(t,...d){}debug(t,...d){}info(t,...d){}warn(t,...d){}error(t,...d){}critical(t,...d){}dispose(){}flush(){}}e.NullLogger=n;class s extends n{}e.NullLogService=s;class r extends p{constructor(){super(v.Info)}k(t,d,E){return new n}}e.NullLoggerService=r;function c(i){if(i.verbose)return v.Trace;if(typeof i.logLevel=="string"){const t=m(i.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function l(i){switch(i){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=l;function m(i){switch(i){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=m}),define(ye[204],De([1,0,6,13]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class a extends o.Disposable{constructor(I,P=[]){super(),this.a=new A.MultiplexLogger([I,...P]),this.B(I.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...P){this.a.trace(I,...P)}debug(I,...P){this.a.debug(I,...P)}info(I,...P){this.a.info(I,...P)}warn(I,...P){this.a.warn(I,...P)}error(I,...P){this.a.error(I,...P)}flush(){this.a.flush()}}e.LogService=a}),define(ye[205],De([1,0,44,13]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var a;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(a||(a={}));async function R(k,O,T,v,C){try{const y=await new Promise((h,u)=>{ne(["spdlog"],h,u)});y.setFlushOn(a.Trace);const f=await y.createAsyncRotatingLogger(k,O,T,v);return C?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(y){console.error(y)}return null}function I(k,O,T){switch(O){case A.LogLevel.Trace:k.trace(T);break;case A.LogLevel.Debug:k.debug(T);break;case A.LogLevel.Info:k.info(T);break;case A.LogLevel.Warning:k.warn(T);break;case A.LogLevel.Error:k.error(T);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${O}`)}}function P(k,O){switch(O){case A.LogLevel.Trace:k.setLevel(a.Trace);break;case A.LogLevel.Debug:k.setLevel(a.Debug);break;case A.LogLevel.Info:k.setLevel(a.Info);break;case A.LogLevel.Warning:k.setLevel(a.Warning);break;case A.LogLevel.Error:k.setLevel(a.Error);break;case A.LogLevel.Off:k.setLevel(a.Off);break;default:throw new Error(`Invalid log level ${O}`)}}class S extends A.AbstractMessageLogger{constructor(O,T,v,C,y){super(),this.k=[],this.setLevel(y),this.l=this.n(O,T,v,C),this.B(this.onDidChangeLogLevel(f=>{this.m&&P(this.m,f)}))}async n(O,T,v,C){const y=v?6:1,f=30/y*o.ByteSize.MB,h=await R(O,T,f,y,C);if(h){this.m=h,P(this.m,this.getLevel());for(const{level:u,message:g}of this.k)I(this.m,u,g);this.k=[]}}g(O,T){this.m?I(this.m,O,T):this.getLevel()<=O&&this.k.push({level:O,message:T})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=S}),define(ye[124],De([1,0,37,174,4]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var I;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function k(y,f){return f-y}S.compare=k;const O=Object.create(null);O[S.Error]=(0,A.localize)(0,null),O[S.Warning]=(0,A.localize)(1,null),O[S.Info]=(0,A.localize)(2,null);function T(y){return O[y]||""}S.toString=T;function v(y){switch(y){case o.default.Error:return S.Error;case o.default.Warning:return S.Warning;case o.default.Info:return S.Info;case o.default.Ignore:return S.Hint}}S.fromSeverity=v;function C(y){switch(y){case S.Error:return o.default.Error;case S.Warning:return o.default.Warning;case S.Info:return o.default.Info;case S.Hint:return o.default.Ignore}}S.toSeverity=C}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(S){const k="";function O(v){return T(v,!0)}S.makeKey=O;function T(v,C){const y=[k];return v.source?y.push(v.source.replace("\xA6","\\\xA6")):y.push(k),v.code?typeof v.code=="string"?y.push(v.code.replace("\xA6","\\\xA6")):y.push(v.code.value.replace("\xA6","\\\xA6")):y.push(k),v.severity!==void 0&&v.severity!==null?y.push(I.toString(v.severity)):y.push(k),v.message&&C?y.push(v.message.replace("\xA6","\\\xA6")):y.push(k),v.startLineNumber!==void 0&&v.startLineNumber!==null?y.push(v.startLineNumber.toString()):y.push(k),v.startColumn!==void 0&&v.startColumn!==null?y.push(v.startColumn.toString()):y.push(k),v.endLineNumber!==void 0&&v.endLineNumber!==null?y.push(v.endLineNumber.toString()):y.push(k),v.endColumn!==void 0&&v.endColumn!==null?y.push(v.endColumn.toString()):y.push(k),y.push(k),y.join("\xA6")}S.makeKeyOptionalMessage=T})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,a.createDecorator)("markerService")}),define(ye[206],De([1,0,3,37,4]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=A.default,e.INotificationService=(0,a.createDecorator)("notificationService");var R;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new S,this.onDidClose=o.Event.None,this.onDidChangeVisibility=o.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=P;class S{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=S}),define(ye[125],De([1,0,8,2,4]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,a.createDecorator)("openerService");function R(k,O){return A.URI.isUri(k)?(0,o.equalsIgnoreCase)(k.scheme,O):(0,o.startsWithIgnoreCase)(k,O+":")}e.matchesScheme=R;function I(k,...O){return O.some(T=>R(k,T))}e.matchesSomeScheme=I;function P(k,O){return k.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=P;function S(k){let O;const T=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return T&&(O={startLineNumber:parseInt(T[1]),startColumn:T[2]?parseInt(T[2]):1,endLineNumber:T[4]?parseInt(T[4]):void 0,endColumn:T[4]?T[5]?parseInt(T[5]):1:void 0},k=k.with({fragment:""})),{selection:O,uri:k}}e.extractSelection=S}),define(ye[207],De([1,0,10,36]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;if(typeof o.globals.vscode<"u"&&typeof o.globals.vscode.context<"u"){const R=o.globals.vscode.context.configuration();if(R)a=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(a=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:R.version})}}else a={},Object.keys(a).length===0&&Object.assign(a,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(ye[208],De([1,0,4]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,o.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__param||function(ne,e){return function(o,A){e(o,A,ne)}};define(ye[126],De([1,0,19,21,6,4]),function(ne,e,o,A,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var I;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{get value(){return this.a}constructor(T){this.b=T}report(T){this.a=T,this.b(this.a)}}P.None=Object.freeze({report(){}}),e.Progress=P;let S=class extends a.Disposable{constructor(T,v){super(),this.a=new o.DeferredPromise,v.withProgress(T,C=>(this.b=C,this.c&&C.report(this.c),this.a.p)),this.B((0,a.toDisposable)(()=>this.a.complete()))}report(T){this.b?this.b.report(T):this.c=T}};S=xe([ze(1,e.IProgressService)],S),e.UnmanagedProgress=S;class k extends a.Disposable{constructor(T){super(),this.g=T,this.a=0,this.b=this.B(new a.DisposableStore)}start(T){this.stop();const v=++this.a,C=new A.CancellationTokenSource;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},T),this.b.add((0,a.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,a.toDisposable)(()=>C.cancel())),this.b.add((0,a.toDisposable)(()=>this.c?this.c.done():void 0)),{id:v,token:C.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(T){this.a===T&&this.b.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(ye[39],De([1,0,50,9]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class a{constructor(){this.a=new Map}add(I,P){o.ok(A.isString(I)),o.ok(A.isObject(P)),o.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,P)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.Registry=new a}),define(ye[92],De([1,0,3,39]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function a(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this.b=new o.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,k){this.a[a(S)]=k,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const I=new R;A.Registry.add(e.Extensions.JSONContribution,I)}),define(ye[127],De([1,0,15,3,9,169,53,92,39]),function(ne,e,o,A,a,R,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const T=S.Registry.as(P.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const r=new Set;this.n(n,s,r),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(n){const s=new Set;this.o(n,s),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:n,remove:s}){const r=new Set;this.o(s,r),this.n(n,!1,r),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(n){const s=new Set;this.k(n,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(n,s){const r=[];for(const{overrides:c,source:l}of n)for(const m in c)if(s.add(m),e.OVERRIDE_PROPERTY_REGEX.test(m)){const i=this.a.get(m),t=i?.valuesSources??new Map;if(l)for(const L of Object.keys(c[m]))t.set(L,l);const d={...i?.value||{},...c[m]};this.a.set(m,{source:l,value:d,valuesSources:t});const E=(0,I.getLanguageTagSettingPlainKey)(m),w={type:"object",default:d,description:R.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:d,source:a.isString(l)?void 0:l,defaultValueSource:l};r.push(...f(m)),this.d[m]=w,this.b.properties[m]=w}else{this.a.set(m,{value:c[m],source:l});const i=this.d[m];i&&(this.w(m,i),this.r(m,i))}this.m(r)}deregisterDefaultConfigurations(n){const s=new Set;this.l(n,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(n,s){for(const{overrides:r,source:c}of n)for(const l in r){const m=this.a.get(l),i=a.isString(c)?c:c?.id,t=a.isString(m?.source)?m?.source:m?.source?.id;if(i===t)if(s.add(l),this.a.delete(l),e.OVERRIDE_PROPERTY_REGEX.test(l))delete this.d[l],delete this.b.properties[l];else{const d=this.d[l];d&&(this.w(l,d),this.r(l,d))}}this.u()}deltaConfiguration(n){let s=!1;const r=new Set;n.removedDefaults&&(this.l(n.removedDefaults,r),s=!0),n.addedDefaults&&(this.k(n.addedDefaults,r),s=!0),n.removedConfigurations&&this.o(n.removedConfigurations,r),n.addedConfigurations&&this.n(n.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const s of n)this.h.add(s);this.u()}n(n,s,r){n.forEach(c=>{this.p(c,s,c.extensionInfo,c.restrictedProperties,void 0,r),this.c.push(c),this.q(c)})}o(n,s){const r=c=>{if(c.properties)for(const l in c.properties){s.add(l);const m=this.d[l];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[l],this.s(l,c.properties[l])}c.allOf?.forEach(l=>r(l))};for(const c of n){r(c);const l=this.c.indexOf(c);l!==-1&&this.c.splice(l,1)}}p(n,s=!0,r,c,l=3,m){l=a.isUndefinedOrNull(n.scope)?l:n.scope;const i=n.properties;if(i)for(const d in i){const E=i[d];if(s&&b(d,E)){delete i[d];continue}if(E.source=r,E.defaultDefaultValue=i[d].default,this.w(d,E),e.OVERRIDE_PROPERTY_REGEX.test(d)?E.scope=void 0:(E.scope=a.isUndefinedOrNull(E.scope)?l:E.scope,E.restricted=a.isUndefinedOrNull(E.restricted)?!!c?.includes(d):E.restricted),i[d].hasOwnProperty("included")&&!i[d].included){this.f[d]=i[d],delete i[d];continue}else this.d[d]=i[d],i[d].policy?.name&&this.e.set(i[d].policy.name,d);!i[d].deprecationMessage&&i[d].markdownDeprecationMessage&&(i[d].deprecationMessage=i[d].markdownDeprecationMessage),m.add(d)}const t=n.allOf;if(t)for(const d of t)this.p(d,s,r,c,l,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const s=r=>{const c=r.properties;if(c)for(const m in c)this.r(m,c[m]);r.allOf?.forEach(s)};s(n)}r(n,s){switch(e.allSettings.properties[n]=s,s.scope){case 1:e.applicationSettings.properties[n]=s;break;case 2:e.machineSettings.properties[n]=s;break;case 6:e.machineOverridableSettings.properties[n]=s;break;case 3:e.windowSettings.properties[n]=s;break;case 4:e.resourceSettings.properties[n]=s;break;case 5:e.resourceSettings.properties[n]=s,this.g.properties[n]=s;break}}s(n,s){switch(delete e.allSettings.properties[n],s.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const s=`[${n}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(s,r),e.allSettings.properties[s]=r,e.applicationSettings.properties[s]=r,e.machineSettings.properties[s]=r,e.machineOverridableSettings.properties[s]=r,e.windowSettings.properties[s]=r,e.resourceSettings.properties[s]=r}}v(){const n={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}w(n,s){const r=this.a.get(n);let c=r?.value,l=r?.source;a.isUndefined(c)&&(c=s.defaultDefaultValue,l=void 0),a.isUndefined(c)&&(c=u(s.type)),s.default=c,s.defaultValueSource=l}}const C="\\[([^\\]]+)\\]",y=new RegExp(C,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${C})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(p){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let s=y.exec(p);for(;s?.length;){const r=s[1].trim();r&&n.push(r),s=y.exec(p)}}return(0,o.distinct)(n)}e.overrideIdentifiersFromKey=f;function h(p){return p.reduce((n,s)=>`${n}[${s}]`,"")}e.keyFromOverrideIdentifiers=h;function u(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const g=new v;S.Registry.add(e.Extensions.Configuration,g);function b(p,n){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?R.localize(7,null,p):g.getConfigurationProperties()[p]!==void 0?R.localize(8,null,p):n.policy?.name&&g.getPolicyConfigurations().get(n.policy?.name)!==void 0?R.localize(9,null,p,n.policy?.name,g.getPolicyConfigurations().get(n.policy?.name)):null:R.localize(6,null)}e.validateProperty=b;function D(){const p=[],n=g.getConfigurationProperties();for(const s of Object.keys(n))p.push([s,n[s].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=D}),define(ye[209],De([1,0,15,3,146,6,28,23,9,2,53,127,39]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function C(s){return Object.isFrozen(s)?s:P.deepFreeze(s)}class y{constructor(r={},c=[],l=[],m){this.b=r,this.c=c,this.d=l,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(c=>{if(c instanceof y)return c;const l=new f("");return l.parseRaw(c),l.configurationModel});this.f=r.reduce((c,l)=>l===c?l:c.merge(l),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,O.getConfigurationValue)(this.contents,r):this.contents}inspect(r,c){const l=this.rawConfiguration.getValue(r),m=c?this.rawConfiguration.getOverrideValue(r,c):void 0,i=c?this.rawConfiguration.override(c).getValue(r):l;return{value:l,override:m,merged:i}}getOverrideValue(r,c){const l=this.i(c);return l?r?(0,O.getConfigurationValue)(l,r):l:void 0}getKeysForOverrideIdentifier(r){const c=[];for(const l of this.overrides)l.identifiers.includes(r)&&c.push(...l.keys);return o.distinct(c)}getAllOverrideIdentifiers(){const r=[];for(const c of this.overrides)r.push(...c.identifiers);return o.distinct(r)}override(r){let c=this.a.get(r);return c||(c=this.g(r),this.a.set(r,c)),c}merge(...r){const c=P.deepClone(this.contents),l=P.deepClone(this.overrides),m=[...this.keys],i=this.raw?.length?[...this.raw]:[this];for(const t of r)if(i.push(...t.raw?.length?t.raw:[t]),!t.isEmpty()){this.h(c,t.contents);for(const d of t.overrides){const[E]=l.filter(w=>o.equals(w.identifiers,d.identifiers));E?(this.h(E.contents,d.contents),E.keys.push(...d.keys),E.keys=o.distinct(E.keys)):l.push(P.deepClone(d))}for(const d of t.keys)m.indexOf(d)===-1&&m.push(d)}return new y(c,m,l,i.every(t=>t instanceof y)?void 0:i)}g(r){const c=this.i(r);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const l={};for(const m of o.distinct([...Object.keys(this.contents),...Object.keys(c)])){let i=this.contents[m];const t=c[m];t&&(typeof i=="object"&&typeof t=="object"?(i=P.deepClone(i),this.h(i,t)):i=t),l[m]=i}return new y(l,this.keys,this.overrides)}h(r,c){for(const l of Object.keys(c)){if(l in r&&S.isObject(r[l])&&S.isObject(c[l])){this.h(r[l],c[l]);continue}r[l]=P.deepClone(c[l])}}i(r){let c=null,l=null;const m=i=>{i&&(l?this.h(l,i):l=P.deepClone(i))};for(const i of this.overrides)o.equals(i.identifiers,[r])?c=i.contents:i.identifiers.includes(r)&&m(i.contents);return m(c),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,c){this.j(r,c,!0)}setValue(r,c){this.j(r,c,!1)}removeValue(r){const c=this.keys.indexOf(r);c!==-1&&(this.keys.splice(c,1),(0,O.removeFromValueTree)(this.contents,r),T.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(l=>o.equals(l.identifiers,(0,T.overrideIdentifiersFromKey)(r))),1))}j(r,c,l){(0,O.addToValueTree)(this.contents,r,c,m=>console.error(m)),l=l||this.keys.indexOf(r)===-1,l&&this.keys.push(r),T.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,T.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,O.toValuesTree)(this.contents[r],m=>console.error(m))})}}e.ConfigurationModel=y;class f{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,c){if(!S.isUndefinedOrNull(r)){const l=this.g(r);this.parseRaw(l,c)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,c){this.a=r;const{contents:l,keys:m,overrides:i,restricted:t,hasExcludedProperties:d}=this.h(r,c);this.b=new y(l,m,i,d?[r]:void 0),this.c=t||[]}g(r){let c={},l=null,m=[];const i=[],t=[];function d(w){Array.isArray(m)?m.push(w):l!==null&&(m[l]=w)}const E={onObjectBegin:()=>{const w={};d(w),i.push(m),m=w,l=null},onObjectProperty:w=>{l=w},onObjectEnd:()=>{m=i.pop()},onArrayBegin:()=>{const w=[];d(w),i.push(m),m=w,l=null},onArrayEnd:()=>{m=i.pop()},onLiteralValue:d,onError:(w,L,q)=>{t.push({error:w,offset:L,length:q})}};if(r)try{a.visit(r,E),c=m[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return c}h(r,c){const l=v.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),m=this.i(r,l,!0,c);r=m.raw;const i=(0,O.toValuesTree)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),t=Object.keys(r),d=this.j(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:i,keys:t,overrides:d,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(r,c,l,m){let i=!1;if(!m?.scopes&&!m?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:i};const t={},d=[];for(const E in r)if(T.OVERRIDE_PROPERTY_REGEX.test(E)&&l){const w=this.i(r[E],c,!1,m);t[E]=w.raw,i=i||w.hasExcludedProperties,d.push(...w.restricted)}else{const w=c[E],L=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&d.push(E),(L===void 0||m.scopes===void 0||m.scopes.includes(L))&&!(m.skipRestricted&&w?.restricted)?t[E]=r[E]:i=!0}return{raw:t,restricted:d,hasExcludedProperties:i}}j(r,c){const l=[];for(const m of Object.keys(r))if(T.OVERRIDE_PROPERTY_REGEX.test(m)){const i={};for(const t in r[m])i[t]=r[m][t];l.push({identifiers:(0,T.overrideIdentifiersFromKey)(m),keys:Object.keys(i),contents:(0,O.toValuesTree)(i,c)})}return l}}e.ConfigurationModelParser=f;class h extends R.Disposable{constructor(r,c,l,m){super(),this.f=r,this.g=c,this.h=m,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.a=new f(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(l.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(A.Event.any(A.Event.filter(this.h.onDidFilesChange,i=>i.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,i=>(i.isOperation(0)||i.isOperation(3)||i.isOperation(1)||i.isOperation(4))&&l.isEqual(i.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new y}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=h;class u{constructor(r,c,l,m,i,t,d,E,w,L,q,V,M){this.a=r,this.b=c,this.c=l,this.overrideIdentifiers=m,this.d=i,this.f=t,this.g=d,this.h=E,this.i=w,this.j=L,this.k=q,this.l=V,this.m=M}get value(){return C(this.c)}n(r,c,l){const m=r.inspect(c,l);return{get value(){return C(m.value)},get override(){return C(m.override)},get merged(){return C(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(r,c,l,m,i=new y,t=new y,d=new I.ResourceMap,E=new y,w=new I.ResourceMap){this.c=r,this.d=c,this.f=l,this.g=m,this.h=i,this.i=t,this.j=d,this.l=E,this.m=w,this.a=null,this.b=new I.ResourceMap,this.n=null}getValue(r,c,l){return this.q(r,c,l).getValue(r)}updateValue(r,c,l={}){let m;l.resource?(m=this.m.get(l.resource),m||(m=new y,this.m.set(l.resource,m))):m=this.l,c===void 0?m.removeValue(r):m.setValue(r,c),l.resource||(this.a=null)}inspect(r,c,l){const m=this.q(r,c,l),i=this.u(c.resource,l),t=c.resource?this.m.get(c.resource)||this.l:this.l,d=new Set;for(const E of m.overrides)for(const w of E.identifiers)m.getOverrideValue(r,w)!==void 0&&d.add(w);return new u(r,c,m.getValue(r),d.size?[...d]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.i:void 0,i||void 0,t)}keys(r){const c=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,c){this.j.set(r,c),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,c){const l=[];if(!c){const{added:m,updated:i,removed:t}=p(this.c,r);c=[...m,...i,...t]}for(const m of c)for(const i of(0,T.overrideIdentifiersFromKey)(m)){const t=this.c.getKeysForOverrideIdentifier(i),d=r.getKeysForOverrideIdentifier(i),E=[...d.filter(w=>t.indexOf(w)===-1),...t.filter(w=>d.indexOf(w)===-1),...t.filter(w=>!P.equals(this.c.override(i).getValue(w),r.override(i).getValue(w)))];l.push([i,E])}return this.updateDefaultConfiguration(r),{keys:c,overrides:l}}compareAndUpdatePolicyConfiguration(r){const{added:c,updated:l,removed:m}=p(this.d,r),i=[...c,...l,...m];return i.length&&this.updatePolicyConfiguration(r),{keys:i,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:c,updated:l,removed:m,overrides:i}=p(this.applicationConfiguration,r),t=[...c,...l,...m];return t.length&&this.updateApplicationConfiguration(r),{keys:t,overrides:i}}compareAndUpdateLocalUserConfiguration(r){const{added:c,updated:l,removed:m,overrides:i}=p(this.localUserConfiguration,r),t=[...c,...l,...m];return t.length&&this.updateLocalUserConfiguration(r),{keys:t,overrides:i}}compareAndUpdateRemoteUserConfiguration(r){const{added:c,updated:l,removed:m,overrides:i}=p(this.remoteUserConfiguration,r),t=[...c,...l,...m];return t.length&&this.updateRemoteUserConfiguration(r),{keys:t,overrides:i}}compareAndUpdateWorkspaceConfiguration(r){const{added:c,updated:l,removed:m,overrides:i}=p(this.workspaceConfiguration,r),t=[...c,...l,...m];return t.length&&this.updateWorkspaceConfiguration(r),{keys:t,overrides:i}}compareAndUpdateFolderConfiguration(r,c){const l=this.p.get(r),{added:m,updated:i,removed:t,overrides:d}=p(l,c),E=[...m,...i,...t];return(E.length||!l)&&this.updateFolderConfiguration(r,c),{keys:E,overrides:d}}compareAndDeleteFolderConfiguration(r){const c=this.p.get(r);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:l,updated:m,removed:i,overrides:t}=p(c,void 0);return{keys:[...l,...m,...i],overrides:t}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,c,l){let m=this.r(c,l);return c.overrideIdentifier&&(m=m.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(m=m.merge(this.d)),m}r({resource:r},c){let l=this.s();if(c&&r){const m=c.getFolder(r);m&&(l=this.t(m.uri)||l);const i=this.m.get(r);i&&(l=l.merge(i))}return l}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let c=this.b.get(r);if(!c){const l=this.s(),m=this.j.get(r);m?(c=l.merge(m),this.b.set(r,c)):c=l}return c}u(r,c){if(c&&r){const l=c.getFolder(r);if(l)return this.j.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,c)=>{const{contents:l,overrides:m,keys:i}=this.j.get(c);return r.push([c,{contents:l,overrides:m,keys:i}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(c=>r.add(c)),this.userConfiguration.keys.forEach(c=>r.add(c)),this.i.keys.forEach(c=>r.add(c)),this.j.forEach(c=>c.keys.forEach(l=>r.add(l))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.i.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.j.forEach(c=>c.getAllOverrideIdentifiers().forEach(l=>r.add(l))),[...r.values()]}w(r){const c=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(l=>c.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(l=>c.add(l)),this.i.getKeysForOverrideIdentifier(r).forEach(l=>c.add(l)),this.j.forEach(l=>l.getKeysForOverrideIdentifier(r).forEach(m=>c.add(m))),[...c.values()]}static parse(r){const c=this.x(r.defaults),l=this.x(r.policy),m=this.x(r.application),i=this.x(r.user),t=this.x(r.workspace),d=r.folders.reduce((E,w)=>(E.set(k.URI.revive(w[0]),this.x(w[1])),E),new I.ResourceMap);return new g(c,l,m,i,new y,t,d,new y,new I.ResourceMap)}static x(r){return new y(r.contents,r.keys,r.overrides)}}e.Configuration=g;function b(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,c=new Map;for(const m of s)m.keys.forEach(i=>r.add(i)),m.overrides.forEach(([i,t])=>{const d=(0,I.getOrSet)(c,i,new Set);t.forEach(E=>d.add(E))});const l=[];return c.forEach((m,i)=>l.push([i,[...m.values()]])),{keys:[...r.values()],overrides:l}}e.mergeChanges=b;class D{constructor(r,c,l,m){this.change=r,this.f=c,this.g=l,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const i of r.keys)this.affectedKeys.add(i);for(const[,i]of r.overrides)for(const t of i)this.affectedKeys.add(t);this.d=this.a;for(const i of this.affectedKeys)this.d+=i+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(r,c){const l=this.a+r,m=this.d.indexOf(l);if(m<0)return!1;const i=m+l.length;if(i>=this.d.length)return!1;const t=this.d.charCodeAt(i);if(t!==this.b&&t!==this.c)return!1;if(c){const d=this.previousConfiguration?this.previousConfiguration.getValue(r,c,this.f?.workspace):void 0,E=this.g.getValue(r,c,this.h);return!P.equals(d,E)}return!0}}e.ConfigurationChangeEvent=D;function p(s,r){const{added:c,removed:l,updated:m}=n(r?.rawConfiguration,s?.rawConfiguration),i=[],t=s?.getAllOverrideIdentifiers()||[],d=r?.getAllOverrideIdentifiers()||[];if(r){const E=d.filter(w=>!t.includes(w));for(const w of E)i.push([w,r.getKeysForOverrideIdentifier(w)])}if(s){const E=t.filter(w=>!d.includes(w));for(const w of E)i.push([w,s.getKeysForOverrideIdentifier(w)])}if(r&&s){for(const E of t)if(d.includes(E)){const w=n({contents:s.getOverrideValue(void 0,E)||{},keys:s.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});i.push([E,[...w.added,...w.removed,...w.updated]])}}return{added:c,removed:l,updated:m,overrides:i}}function n(s,r){const c=s?r?s.keys.filter(i=>r.keys.indexOf(i)===-1):[...s.keys]:[],l=r?s?r.keys.filter(i=>s.keys.indexOf(i)===-1):[...r.keys]:[],m=[];if(s&&r){for(const i of r.keys)if(s.keys.indexOf(i)!==-1){const t=(0,O.getConfigurationValue)(r.contents,i),d=(0,O.getConfigurationValue)(s.contents,i);P.equals(t,d)||m.push(i)}}return{added:c,removed:l,updated:m}}}),define(ye[128],De([1,0,12,4]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var a;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(a=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends o.ErrorNoTelemetry{static isNotAvailable(S){return S instanceof R&&S._code===a.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof R&&S._code===a.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof R&&S._code===a.NoResolverFound}static isHandled(S){return S instanceof R&&S.isHandled}constructor(S,k=a.Unknown,O){super(S),this._message=S,this._code=k,this._detail=O,this.isHandled=k===a.NotAvailable&&O===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function I(P){const S=P.indexOf("+");return S===-1?P:P.substring(0,S)}e.getRemoteAuthorityPrefix=I}),define(ye[72],De([1,0,16]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(k){return k.scheme===o.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=A;function a(k){if(!k)return;const O=k.indexOf("+");return O<0?k:k.substr(0,O)}e.getRemoteName=a;function R(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=R;function I(k){const{host:O,port:T}=S(k);if(typeof T>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:T}}e.parseAuthorityWithPort=I;function P(k,O){let{host:T,port:v}=S(k);return typeof v>"u"&&(v=O),{host:T,port:v}}e.parseAuthorityWithOptionalPort=P;function S(k){const O=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const T=k.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const v=k.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:k,port:void 0}}}),define(ye[27],De([1,0,8,4,72]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(C){if(typeof C=="object"&&C!==null&&C.supported!==!0)return C.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(C){C[C.System=0]="System",C[C.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var P;(function(C){C.WIN32_X64="win32-x64",C.WIN32_IA32="win32-ia32",C.WIN32_ARM64="win32-arm64",C.LINUX_X64="linux-x64",C.LINUX_ARM64="linux-arm64",C.LINUX_ARMHF="linux-armhf",C.ALPINE_X64="alpine-x64",C.ALPINE_ARM64="alpine-arm64",C.DARWIN_X64="darwin-x64",C.DARWIN_ARM64="darwin-arm64",C.WEB="web",C.UNIVERSAL="universal",C.UNKNOWN="unknown",C.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(y){this.value=y,this.c=y.toLowerCase()}static equals(y,f){if(typeof y>"u"||y===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof y=="string"||typeof f=="string"){const h=typeof y=="string"?y:y.value,u=typeof f=="string"?f:f.value;return o.equalsIgnoreCase(h,u)}return y.c===f.c}static toKey(y){return typeof y=="string"?y.toLowerCase():y.c}}e.ExtensionIdentifier=S;function k(C){return O(C)}e.isApplicationScopedExtension=k;function O(C){return C.contributes&&C.contributes.localizations?C.contributes.localizations.length>0:!1}e.isLanguagePackExtension=O;function T(C){return C.contributes&&C.contributes.authentication?C.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=T;function v(C,y){if(y){const f=`onResolveRemoteAuthority:${(0,a.getRemoteName)(y)}`;return!!C.activationEvents?.includes(f)}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[210],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class o{constructor(){this.b=new Map}c(){return new Promise((a,R)=>ne(["vsda"],a,R))}async createNewMessage(a){try{const R=await this.c(),I=new R.validator;if(I){const P=String(o.a++);return this.b.set(P,I),{id:P,data:I.createNewMessage(a)}}}catch{}return{id:"",data:a}}async validate(a,R){if(!a.id)return!0;const I=this.b.get(a.id);if(!I)return!1;this.b.delete(a.id);try{return I.validate(R)==="ok"}catch{return!1}}async sign(a){try{const R=await this.c(),I=new R.signer;if(I)return I.sign(a)}catch{}return a}}o.a=1,e.SignService=o}),define(ye[211],De([1,0,10,36,2,30]),function(ne,e,o,A,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(k){if(o.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function P(k,O,T,v,C,y,f,h,u,g){const b=Object.create(null);b["common.machineId"]=f,b.sessionID=(0,R.generateUuid)()+Date.now(),b.commitHash=C,b.version=y,b["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,o.PlatformToString)(o.platform),b["common.nodePlatform"]=A.platform,b["common.nodeArch"]=v,b["common.product"]=g||"desktop",h&&(b["common.msftInternal"]=h);let D=0;const p=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>D++,enumerable:!0}}),o.isLinuxSnap&&(b["common.snap"]="true");const n=I(T);n&&(b["common.platformDetail"]=n);try{const s=await k.readFile(a.URI.file(u));b["common.source"]=s.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=P;function S(k){const O=A.env.USERDNSDOMAIN;if(!O)return!1;const T=O.toLowerCase();return k.some(v=>T===v)}e.verifyMicrosoftInternalDomain=S}),define(ye[212],De([1,0,4]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,o.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,o.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var a;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(a=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ye[73],De([1,0,23,9,3,53,72,211,212]),function(ne,e,o,A,a,R,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class k{constructor(i){this.value=i}}e.TelemetryTrustedValue=k;class O{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(i,t){return Promise.resolve(void 0)}publicLog2(i,t){return this.publicLog(i,t)}publicLogError(i,t){return Promise.resolve(void 0)}publicLogError2(i,t){return this.publicLogError(i,t)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=O,e.NullTelemetryService=new O;class T{async publicLog(i,t,d){}async publicLogError(i,t,d){}}e.NullEndpointTelemetryService=T,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(m,i){return a.Event.debounce(i.onDidChangeConfiguration,(d,E)=>{const w=d?new Set([...d.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:w}},1e3,!0)(d=>{d.source!==7&&m.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(d.source),configurationKeys:D(d.affectedKeys)})})}e.configurationTelemetry=v;function C(m,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!m.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=C;function y(m,i){return!(i.isBuilt||i.disableTelemetry||m.enableTelemetry&&m.aiConfig?.ariaKey)}e.isLoggingOnly=y;function f(m){const i=m.getValue(S.TELEMETRY_SETTING_ID),t=m.getValue(S.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(m.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||t===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function h(m){const i={},t={},d={};b(m,d);for(let E in d){E=E.length>150?E.substr(E.length-149):E;const w=d[E];typeof w=="number"?t[E]=w:typeof w=="boolean"?t[E]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${w.length}`),i[E]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(i[E]=w)}return{properties:i,measurements:t}}e.validateTelemetryData=h;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function g(m){if(!m)return"none";const i=(0,I.getRemoteName)(m);return u.has(i)?i:"other"}e.cleanRemoteAuthority=g;function b(m,i,t=0,d){if(!!m)for(const E of Object.getOwnPropertyNames(m)){const w=m[E],L=d?d+E:E;Array.isArray(w)?i[L]=(0,o.safeStringify)(w):w instanceof Date?i[L]=w.toISOString():(0,A.isObject)(w)?t<2?b(w,i,t+1,L+"."):i[L]=(0,o.safeStringify)(w):i[L]=w}}function D(m){if(!m)return[];const i=[];return p(i,"",m),i}function p(m,i,t){t&&typeof t=="object"&&!Array.isArray(t)?Object.keys(t).forEach(d=>p(m,i?`${i}.${d}`:d,t[d])):m.push(i)}function n(m,i){const t=m.msftInternalDomains||[],d=i.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(t)||d}e.isInternalTelemetry=n;function s(m){return[m.appRoot,m.extensionsPath,m.userHome.fsPath,m.tmpDir.fsPath,m.userDataPath]}e.getPiiPathsFromEnvironment=s;function r(m,i){if(!m||!m.includes("/")&&!m.includes("\\"))return m;let t=m;const d=[];for(const q of i)for(;;){const V=q.exec(m);if(!V)break;d.push([V.index,q.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let L=0;for(t="";;){const q=w.exec(m);if(!q)break;const V=d.some(([M,B])=>q.index<B&&M<w.lastIndex);!E.test(q[0])&&!V&&(t+=m.substring(L,q.index)+"<REDACTED: user-file-path>",L=w.lastIndex)}return L<m.length&&(t+=m.substr(L)),t}function c(m){if(!m)return m;const i=m.toLowerCase(),t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of t)if(d.regex.test(i))return`<REDACTED: ${d.label}>`;return m}function l(m,i){return(0,o.cloneAndChange)(m,t=>{if(t instanceof k)return t.value;if(typeof t=="string"){let d=t.replaceAll("%20"," ");d=r(d,i);for(const E of i)d=d.replace(E,"");return d=c(d),d}})}e.cleanData=l}),define(ye[213],De([1,0,8,123,27,10,2,12,36,73]),function(ne,e,o,A,a,R,I,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function O(r,c){return r.uuid&&c.uuid?r.uuid===c.uuid:r.id===c.id?!0:(0,o.compareIgnoreCase)(r.id,c.id)===0}e.areSameExtensions=O;const T=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(c){const l=c.manifest?c.manifest.version:c.version,m=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new v(c.identifier,l,m)}static parse(c){const l=T.exec(c);return l&&l[1]&&l[2]?new v({id:l[1]},l[2],l[4]||void 0):null}constructor(c,l,m="undefined"){this.version=l,this.targetPlatform=m,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof v?O(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=v;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const c=C.exec(r);return c&&c[1]?[h(c[1]),c[2]]:[h(r),void 0]}e.getIdAndVersion=y;function f(r,c){return`${r}.${c}`}e.getExtensionId=f;function h(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function u(r,c){return h(f(r,c))}e.getGalleryExtensionId=u;function g(r,c){const l=[],m=i=>{for(const t of l)if(t.some(d=>O(c(d),c(i))))return t;return null};for(const i of r){const t=m(i);t?t.push(i):l.push([i])}return l}e.groupByExtension=g;function b(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function D(r){return{id:new k.TelemetryTrustedValue(r.identifier.id),name:new k.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=D,e.BetterMergeId=new a.ExtensionIdentifier("pprice.better-merge");function p(r,c){const l=[],m=c.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const i=m.shift();if(i&&l.every(t=>!O(t.identifier,{id:i}))){const t=r.filter(d=>O(d.identifier,{id:i}));t.length===1&&(l.push(t[0]),m.push(...t[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=p;async function n(r,c){if(!R.isLinux)return!1;let l;try{l=(await r.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await r.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(i){c.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(i))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(r,c){const l=await n(r,c),m=(0,A.getTargetPlatform)(l?"alpine":R.platform,S.arch);return c.debug("ComputeTargetPlatform:",m),m}e.computeTargetPlatform=s}),define(ye[214],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function o(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=o;function A(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=A;function a(I){return Array.from(I.entries()).map(P=>[P[0],o(P[1].map)])}e.serializeEnvironmentVariableCollections=a;function R(I){return new Map(I.map(P=>[P[0],{map:A(P[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(ye[215],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class o{constructor(a){this.b=a,this.a=new Map}dispose(){for(const a of this.a.values())a.dispose()}startBuffering(a,R,I=5){const P=R(S=>{const k=typeof S=="string"?S:S.data;let O=this.a.get(a);if(O){O.data.push(k);return}const T=setTimeout(()=>this.flushBuffer(a),I);O={data:[k],timeoutId:T,dispose:()=>{clearTimeout(T),this.flushBuffer(a),P.dispose()}},this.a.set(a,O)});return P}stopBuffering(a){this.a.get(a)?.dispose()}flushBuffer(a){const R=this.a.get(a);R&&(this.a.delete(a),this.b(a,R.data.join("")))}}e.TerminalDataBufferer=o}),define(ye[216],De([1,0,19,67,51,3,9,2,175,92,39]),function(ne,e,o,A,a,R,I,P,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var T;(function(D){function p(n,s){let r=n.defaults;for(;a.ThemeIcon.isThemeIcon(r);){const c=y.getIcon(r.id);if(!c)return;r=c.defaults}return r}D.getDefinition=p})(T=e.IconContribution||(e.IconContribution={}));var v;(function(D){function p(s){return{weight:s.weight,style:s.style,src:s.src.map(r=>({format:r.format,location:r.location.toString()}))}}D.toJSONObject=p;function n(s){const r=c=>(0,I.isString)(c)?c:void 0;if(s&&Array.isArray(s.src)&&s.src.every(c=>(0,I.isString)(c.format)&&(0,I.isString)(c.location)))return{weight:r(s.weight),style:r(s.style),src:s.src.map(c=>({format:c.format,location:P.URI.parse(c.location)}))}}D.fromJSONObject=n})(v=e.IconFontDefinition||(e.IconFontDefinition={}));class C{constructor(){this.a=new R.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${a.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,n,s,r){const c=this.b[p];if(c){if(s&&!c.description){c.description=s,this.d.properties[p].markdownDescription=`${s} $(${p})`;const i=this.e.enum.indexOf(p);i!==-1&&(this.e.enumDescriptions[i]=s),this.a.fire()}return c}const l={id:p,description:s,defaults:n,deprecationMessage:r};this.b[p]=l;const m={$ref:"#/definitions/icons"};return r&&(m.deprecationMessage=r),s&&(m.markdownDescription=`${s}: $(${p})`),this.d.properties[p]=m,this.e.enum.push(p),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const n=this.e.enum.indexOf(p);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,n){const s=this.f[p];return s||(this.f[p]=n,this.a.fire(),n)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(c,l)=>c.id.localeCompare(l.id),n=c=>{for(;a.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(c=>this.b[c]);for(const c of r.filter(l=>!!l.description).sort(p))s.push(`|<i class="${n(c)}"></i>|${c.id}|${a.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const c of r.filter(l=>!a.ThemeIcon.isThemeIcon(l.defaults)).sort(p))s.push(`|<i class="${n(c)}"></i>|${c.id}|`);return s.join(`
`)}}const y=new C;O.Registry.add(e.Extensions.IconContribution,y);function f(D,p,n,s){return y.registerIcon(D,p,n,s)}e.registerIcon=f;function h(){return y}e.getIconRegistry=h;function u(){const D=(0,A.getCodiconFontCharacters)();for(const p in D){const n="\\"+D[p].toString(16);y.registerIcon(p,{fontCharacter:n})}}u(),e.iconsSchemaId="vscode://schemas/icons";const g=O.Registry.as(k.Extensions.JSONContribution);g.registerSchema(e.iconsSchemaId,y.getIconSchema());const b=new o.RunOnceScheduler(()=>g.notifySchemaChanged(e.iconsSchemaId),200);y.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.widgetClose=f("widget-close",A.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=f("goto-previous-location",A.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=f("goto-next-location",A.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=a.ThemeIcon.modify(A.Codicon.sync,"spin"),e.spinningLoading=a.ThemeIcon.modify(A.Codicon.loading,"spin")}),define(ye[129],De([1,0,3,53,4,13]),function(ne,e,o,A,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,a.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,a.createDecorator)("sharedTunnelsService");var I;(function(f){f.Http="http",f.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function T(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=T;function v(f,h,u,g){if(u===1)return!1;if(u===2&&T(h)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(b?.length===4&&parseInt(b[1])>=18)return!1}return f<1024}e.isPortPrivileged=v;class C{constructor(h,u,g){this.remoteAddress=h,this.localAddress=u,this.b=g,this.a=new o.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=C;let y=class{constructor(h,u){this.i=h,this.j=u,this.a=new o.Emitter,this.onTunnelOpened=this.a.event,this.b=new o.Emitter,this.onTunnelClosed=this.b.event,this.c=new o.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const h=this.j.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.e=h,h?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.f=h.elevation,this.g=h.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const h=[],u=Array.from(this.d.values());for(const g of u){const b=Array.from(g.values());for(const D of b){const p=await D.value;p&&h.push(p)}}return h}async dispose(){for(const h of this.d.values()){for(const{value:u}of h.values())await u.then(g=>g?.dispose());h.clear()}this.d.clear()}setEnvironmentTunnel(h,u,g,b,D){this.o(h,u,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:u,localAddress:g,privacy:b,protocol:D,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,u){(T(h)||O(h))&&(h=e.LOCALHOST_ADDRESSES[0]);const g=this.q(h,u);if(g)return++g.refcount,g.value}openTunnel(h,u,g,b,D,p=!1,n,s){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${g} on local port ${D}.`),!h)return;if(u||(u="localhost"),b||(b=this.k),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(h,u,g,b,D,p,n,s);return r?r.then(c=>{if(!c){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.m(c);return(c.tunnelRemoteHost!==u||c.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(l),l}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const u=this.d.get(h.tunnelRemoteHost);if(u){const g=u.get(h.tunnelRemotePort);g&&(g.refcount--,await this.n(h.tunnelRemoteHost,h.tunnelRemotePort,g))}}}}async n(h,u,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${u}.`);const b=g.value.then(async D=>{D&&(await D.dispose(!0),this.b.fire({host:D.tunnelRemoteHost,port:D.tunnelRemotePort}))});return this.d.has(h)&&this.d.get(h).delete(u),b}}async closeTunnel(h,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${u} `);const g=this.d.get(h);if(g&&g.has(u)){const b=g.get(u);b.refcount=0,await this.n(h,u,b)}}o(h,u,g){this.d.has(h)||this.d.set(h,new Map),this.d.get(h).set(u,{refcount:1,value:g})}async p(h,u){const g=this.d.get(h);g&&(await g.get(u)||g.delete(u),g.size===0&&this.d.delete(h))}q(h,u){const g=[h];O(h)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):T(h)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const b=g.map(D=>this.d.get(D));for(const D of b){const p=D?.get(u);if(p)return p}}canTunnel(h){return!!k(h)}s(h,u,g,b,D,p,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${g} on local port ${b}.`);const s=g;this.h.add(s);const r=b===void 0?g:b,c={elevationRequired:D?this.isPortPrivileged(r):!1},l={remoteAddress:{host:u,port:g},localAddressPort:b,privacy:p,public:p?p!==P.Private:void 0,protocol:n},m=h.forwardPort(l,c);return m?(this.o(u,g,m),m.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),m}};y=xe([ze(0,R.ILogService),ze(1,A.IConfigurationService)],y),e.AbstractTunnelService=y}),define(ye[217],De([1,0,4]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,o.createDecorator)("editSessionIdentityService");var A;(function(a){a[a.Complete=100]="Complete",a[a.Partial=50]="Partial",a[a.None=0]="None"})(A=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ye[218],De([1,0,16]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function A(S){return S.scheme!==o.Schemas.file&&S.scheme!==o.Schemas.vscodeRemote}e.isVirtualResource=A;function a(S){if(S.folders.length)return S.folders.every(k=>A(k.uri))?S.folders[0].uri:void 0;if(S.configuration&&A(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=a;function R(S){return a(S)?.scheme}e.getVirtualWorkspaceScheme=R;function I(S){return a(S)?.authority}e.getVirtualWorkspaceAuthority=I;function P(S){return a(S)!==void 0}e.isVirtualWorkspace=P}),define(ye[47],De([1,0,176,11,68,24,2,4,16]),function(ne,e,o,A,a,R,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function k(r){const c=r;return typeof c?.id=="string"&&I.URI.isUri(c.uri)}e.isSingleFolderWorkspaceIdentifier=k;function O(r){return typeof r?.id=="string"&&!k(r)&&!v(r)}e.isEmptyWorkspaceIdentifier=O,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function T(r,c){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,A.basename)(r)}:c?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const l=r;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.toWorkspaceIdentifier=T;function v(r){const c=r;return typeof c?.id=="string"&&I.URI.isUri(c.configPath)}e.isWorkspaceIdentifier=v;function C(r){const c=r;if(c?.uri)return{id:c.id,uri:I.URI.revive(c.uri)};const l=r;if(l?.configPath)return{id:l.id,configPath:I.URI.revive(l.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=C;var y;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function f(r){const c=r;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.isWorkspace=f;function h(r){const c=r;return!!(c&&typeof c=="object"&&I.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.isWorkspaceFolder=h;class u{constructor(c,l,m,i,t){this.h=c,this.j=m,this.k=i,this.l=t,this.c=a.TernarySearchTree.forUris(this.l,()=>!0),this.folders=l}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=a.TernarySearchTree.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class g{constructor(c,l){this.raw=l,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,R.joinPath)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function b(r){return new g({uri:r,index:0,name:(0,R.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,o.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(r,c){return R.extUriBiasedIgnorePathCase.isEqualOrParent(r,c.untitledWorkspacesHome)}e.isUntitledWorkspace=D;function p(r){let c;return I.URI.isUri(r)?c=r:c=r.configuration,c?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=p;function n(r,c){return!D(r,c)&&!p(r)}e.isSavedWorkspace=n;function s(r){return(typeof r=="string"?(0,A.extname)(r):(0,R.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(ye[74],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class o{constructor(a){this.d=a,this.b=new Map,this.c=1}add(a){const R=this.c++;return this.b.set(R,a),this.e(),R}get(a,R){return this.b.has(a)?this.b.get(a)[R]:void 0}delete(a){this.b.delete(a),this.e()}e(){!o.a||console.log(`${this.d} cache size - ${this.b.size}`)}}o.a=!1,e.Cache=o}),define(ye[48],De([1,0,16,24,4]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(o.Schemas)),this.b=new Map,this.extUri=new A.ExtUri(P=>{const S=this.b.get(P.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(P,S){S===null?this.b.delete(P.scheme):this.b.set(P.scheme,S)}isFreeScheme(P){return!this.b.has(P)&&!this.a.has(P)}getCapabilities(P){return this.b.get(P)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,a.createDecorator)("IExtHostFileSystemInfo")}),define(ye[25],De([1,0,4]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,o.createDecorator)("IExtHostInitDataService")}),define(ye[219],De([1,0,13,204,25]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends A.LogService{constructor(P,S){super(P.createLogger(S.logFile,{name:S.logName}))}};R=xe([ze(0,o.ILoggerService),ze(1,a.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(ye[220],De([1,0,19]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class A{constructor(I,P,S){this.h=new Map,this.a=I,this.b=P,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new o.RunOnceScheduler(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of k.values())O.complete()}catch(O){for(const T of k.values())T.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this.d}get(I,P){let S=this.f[I];return typeof S>"u"&&(S=P),S}update(I,P){this.f[I]=P;const S=this.h.get(I);if(S!==void 0)return S.p;const k=new o.DeferredPromise;return this.h.set(I,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.ExtensionMemento=A;class a extends A{setKeysForSync(I){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},I)}constructor(I,P){super(I.identifier.value,!0,P),this.j=I}}e.ExtensionGlobalMemento=a}),define(ye[221],De([1,0,3,2]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class a{constructor(I){this.c=I,this.a=new o.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new o.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(I,P,S,k){const T=this.c.getNotebookDocument(A.URI.revive(I)).acceptModelChanged(P.value,S,k);this.b.fire(T)}$acceptDirtyStateChanged(I,P){this.c.getNotebookDocument(A.URI.revive(I)).acceptDirty(P)}$acceptModelSaved(I){const P=this.c.getNotebookDocument(A.URI.revive(I));this.a.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=a}),define(ye[20],De([1,0,4]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,o.createDecorator)("IExtHostRpcService");class A{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=A});var _e=this&&this.__classPrivateFieldSet||function(ne,e,o,A,a){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!a:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?a.call(ne,o):a?a.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[222],De([1,0,27,3]),function(ne,e,o,A){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(P,S){a.set(this,void 0),this.b=new A.Emitter,this.onDidChange=this.b.event,this.a=o.ExtensionIdentifier.toKey(P.identifier),_e(this,a,S,"f"),Ue(this,a,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(P){return Ue(this,a,"f").get(this.a,P)}store(P,S){return Ue(this,a,"f").store(this.a,P,S)}delete(P){return Ue(this,a,"f").delete(this.a,P)}}e.ExtensionSecrets=R,a=new WeakMap}),define(ye[55],De([1,0,4,129,3,20]),function(ne,e,o,A,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var I;(function(S){function k(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public,privacy:T.privacy??(T.public?A.TunnelPrivacyId.Public:A.TunnelPrivacyId.Private),protocol:T.protocol}}S.fromApiTunnel=k;function O(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.privacy!==A.TunnelPrivacyId.ConstantPrivate&&T.privacy!==A.TunnelPrivacyId.ConstantPrivate,privacy:T.privacy,protocol:T.protocol}}S.fromServiceTunnel=O})(I=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,o.createDecorator)("IExtHostTunnelService");let P=class{constructor(k){this.onDidChangeTunnels=new a.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,O){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,O){return{dispose:()=>{}}}async $providePortAttributes(k,O,T,v,C){return[]}async $forwardPort(k,O){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=xe([ze(0,R.IExtHostRpcService)],P),e.ExtHostTunnelService=P}),define(ye[56],De([1,0,4]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,o.createDecorator)("IURITransformerService");class A{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=A}),define(ye[223],De([1,0,22]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class A{constructor(){this.buffers=[]}add(S){let k=this.buffers.indexOf(S);return k<0&&(k=this.buffers.length,this.buffers.push(S)),k}}function a(P,S){if(S.serializeBuffersForPostMessage){const k=new A,O=(C,y)=>{if(y instanceof ArrayBuffer){const f=k.add(y);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(y)){const f=R(y);if(f){const h=k.add(y.buffer);return{$$vscode_array_buffer_reference$$:!0,index:h,view:{type:f,byteLength:y.byteLength,byteOffset:y.byteOffset}}}}return y},T=JSON.stringify(P,O),v=k.buffers.map(C=>{const y=new Uint8Array(C);return o.VSBuffer.wrap(y)});return{message:T,buffers:v}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=a;function R(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(P,S){const k=S.map(v=>{const C=new ArrayBuffer(v.byteLength);return new Uint8Array(C).set(v.buffer),C}),O=S.length?(v,C)=>{if(C&&typeof C=="object"&&C.$$vscode_array_buffer_reference$$){const y=C,{index:f}=y,h=k[f];if(y.view)switch(y.view.type){case 1:return new Int8Array(h,y.view.byteOffset,y.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(h,y.view.byteOffset,y.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(h,y.view.byteOffset,y.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(h,y.view.byteOffset,y.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(h,y.view.byteOffset,y.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(h,y.view.byteOffset,y.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(h,y.view.byteOffset,y.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(h,y.view.byteOffset,y.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(h,y.view.byteOffset,y.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(h,y.view.byteOffset,y.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(h,y.view.byteOffset,y.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return C}:void 0;return{message:JSON.parse(P,O),arrayBuffers:k}}e.deserializeWebviewMessage=I}),define(ye[224],De([1,0,114]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function A(R){return{transformIncoming:I=>I.scheme==="vscode-remote"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="file"?{scheme:"vscode-local",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoing:I=>I.scheme==="file"?{scheme:"vscode-remote",authority:R,path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="vscode-local"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoingScheme:I=>I==="file"?"vscode-remote":I==="vscode-local"?"file":I}}function a(R){return new o.URITransformer(A(R))}e.createURITransformer=a}),define(ye[130],De([1,0,187,9,2,6,4,39,44,16,45,161,37]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var C;(function(Q){Q[Q.PROGRAMMATIC=1]="PROGRAMMATIC",Q[Q.USER=2]="USER",Q[Q.EDIT=3]="EDIT",Q[Q.NAVIGATION=4]="NAVIGATION",Q[Q.JUMP=5]="JUMP"})(C=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var y;(function(Q){Q[Q.IDENTICAL=1]="IDENTICAL",Q[Q.SIMILAR=2]="SIMILAR",Q[Q.DIFFERENT=3]="DIFFERENT"})(y=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function f(Q){const Y=Q;return!!Y&&typeof Y.getSelection=="function"&&!!Y.onDidChangeSelection}e.isEditorPaneWithSelection=f;function h(Q,Y,Z){for(const me of Z.visibleEditorPanes)if(me.group.id===Y&&Q.matches(me.input))return me.getViewState()}e.findViewStateForEditor=h;function u(Q){if(t(Q))return!1;const Y=Q;return a.URI.isUri(Y?.resource)}e.isResourceEditorInput=u;function g(Q){if(t(Q))return!1;const Y=Q;return Y?.original!==void 0&&Y.modified!==void 0}e.isResourceDiffEditorInput=g;function b(Q){if(t(Q)||g(Q))return!1;const Y=Q;return Y?.primary!==void 0&&Y.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function D(Q){if(t(Q))return!1;const Y=Q;return Y?Y.resource===void 0||Y.resource.scheme===k.Schemas.untitled||Y.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=D;const p=/Untitled-\d+/;function n(Q){return Q.scheme===k.Schemas.untitled&&Q.path.length>1&&!p.test(Q.path)}e.isUntitledWithAssociatedResource=n;function s(Q){if(t(Q))return!1;const Y=Q;return a.URI.isUri(Y?.base?.resource)&&a.URI.isUri(Y?.input1?.resource)&&a.URI.isUri(Y?.input2?.resource)&&a.URI.isUri(Y?.result?.resource)}e.isResourceMergeEditorInput=s;var r;(function(Q){Q[Q.SHORT=0]="SHORT",Q[Q.MEDIUM=1]="MEDIUM",Q[Q.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var c;(function(Q){Q[Q.EXPLICIT=1]="EXPLICIT",Q[Q.AUTO=2]="AUTO",Q[Q.FOCUS_CHANGE=3]="FOCUS_CHANGE",Q[Q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));class l{constructor(){this.a=new Map}registerSource(Y,Z){let me=this.a.get(Y);return me||(me={source:Y,label:Z},this.a.set(Y,me)),me.source}getSourceLabel(Y){return this.a.get(Y)?.label??Y}}e.SaveSourceRegistry=new l;var m;(function(Q){Q[Q.None=0]="None",Q[Q.Readonly=2]="Readonly",Q[Q.Untitled=4]="Untitled",Q[Q.Singleton=8]="Singleton",Q[Q.RequiresTrust=16]="RequiresTrust",Q[Q.CanSplitInGroup=32]="CanSplitInGroup",Q[Q.ForceDescription=64]="ForceDescription",Q[Q.CanDropIntoEditor=128]="CanDropIntoEditor",Q[Q.MultipleEditors=256]="MultipleEditors"})(m=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends R.Disposable{}e.AbstractEditorInput=i;function t(Q){return Q instanceof i}e.isEditorInput=t;function d(Q){const Y=Q;return a.URI.isUri(Y?.preferredResource)}function E(Q){const Y=Q;return t(Y?.primary)&&t(Y?.secondary)}e.isSideBySideEditorInput=E;function w(Q){const Y=Q;return t(Y?.modified)&&t(Y?.original)}e.isDiffEditorInput=w;function L(Q,Y,Z,me,ve){return pe(me,[(0,T.toAction)({id:"workbench.action.openLargeFile",label:(0,o.localize)(2,null),run:()=>{const Ie={...Z,limits:{size:Number.MAX_VALUE}};Q.openEditor(Y,Ie)}}),(0,T.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,o.localize)(3,null),run:()=>ve.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=L;function q(Q){return t(Q?.editor)}e.isEditorInputWithOptions=q;function V(Q){const Y=Q;return q(Q)&&Y?.group!==void 0}e.isEditorInputWithOptionsAndGroup=V;function M(Q){const Y=Q;return typeof Y?.groupId=="number"&&t(Y.editor)}e.isEditorIdentifier=M;var B;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.REPLACE=1]="REPLACE",Q[Q.MOVE=2]="MOVE",Q[Q.UNPIN=3]="UNPIN"})(B=e.EditorCloseContext||(e.EditorCloseContext={}));var N;(function(Q){Q[Q.GROUP_ACTIVE=0]="GROUP_ACTIVE",Q[Q.GROUP_INDEX=1]="GROUP_INDEX",Q[Q.GROUP_LOCKED=2]="GROUP_LOCKED",Q[Q.EDITOR_OPEN=3]="EDITOR_OPEN",Q[Q.EDITOR_CLOSE=4]="EDITOR_CLOSE",Q[Q.EDITOR_MOVE=5]="EDITOR_MOVE",Q[Q.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",Q[Q.EDITOR_LABEL=7]="EDITOR_LABEL",Q[Q.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",Q[Q.EDITOR_PIN=9]="EDITOR_PIN",Q[Q.EDITOR_STICKY=10]="EDITOR_STICKY",Q[Q.EDITOR_DIRTY=11]="EDITOR_DIRTY",Q[Q.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(N=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var U;(function(Q){Q[Q.PRIMARY=1]="PRIMARY",Q[Q.SECONDARY=2]="SECONDARY",Q[Q.BOTH=3]="BOTH",Q[Q.ANY=4]="ANY"})(U=e.SideBySideEditor||(e.SideBySideEditor={}));class ${getOriginalUri(Y,Z){if(!Y)return;if(s(Y))return e.EditorResourceAccessor.getOriginalUri(Y.result,Z);if(Z?.supportSideBySide){const{primary:ve,secondary:Ie}=this.a(Y);if(ve&&Ie){if(Z?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(ve,{filterByScheme:Z.filterByScheme}),secondary:this.getOriginalUri(Ie,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===U.ANY)return this.getOriginalUri(ve,{filterByScheme:Z.filterByScheme})??this.getOriginalUri(Ie,{filterByScheme:Z.filterByScheme});Y=Z.supportSideBySide===U.PRIMARY?ve:Ie}}if(g(Y)||b(Y)||s(Y))return;const me=d(Y)?Y.preferredResource:Y.resource;return!me||!Z||!Z.filterByScheme?me:this.b(me,Z.filterByScheme)}a(Y){return E(Y)||b(Y)?{primary:Y.primary,secondary:Y.secondary}:w(Y)||g(Y)?{primary:Y.modified,secondary:Y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Y,Z){if(!Y)return;if(s(Y))return e.EditorResourceAccessor.getCanonicalUri(Y.result,Z);if(Z?.supportSideBySide){const{primary:ve,secondary:Ie}=this.a(Y);if(ve&&Ie){if(Z?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(ve,{filterByScheme:Z.filterByScheme}),secondary:this.getCanonicalUri(Ie,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===U.ANY)return this.getCanonicalUri(ve,{filterByScheme:Z.filterByScheme})??this.getCanonicalUri(Ie,{filterByScheme:Z.filterByScheme});Y=Z.supportSideBySide===U.PRIMARY?ve:Ie}}if(g(Y)||b(Y)||s(Y))return;const me=Y.resource;return!me||!Z||!Z.filterByScheme?me:this.b(me,Z.filterByScheme)}b(Y,Z){if(Array.isArray(Z)){if(Z.some(me=>Y.scheme===me))return Y}else if(Z===Y.scheme)return Y}}e.EditorResourceAccessor=new $;var z;(function(Q){Q[Q.LEFT=0]="LEFT",Q[Q.RIGHT=1]="RIGHT"})(z=e.CloseDirection||(e.CloseDirection={}));class ae{constructor(){this.c=new Map,this.d=new Map}start(Y){const Z=this.a=Y.get(I.IInstantiationService);for(const[me,ve]of this.c)this.e(me,ve,Z);this.c.clear()}e(Y,Z,me){const ve=me.createInstance(Z);this.d.set(Y,ve)}registerFileEditorFactory(Y){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Y}getFileEditorFactory(){return(0,A.assertIsDefined)(this.b)}registerEditorSerializer(Y,Z){if(this.c.has(Y)||this.d.has(Y))throw new Error(`A editor serializer with type ID '${Y}' was already registered.`);return this.a?this.e(Y,Z,this.a):this.c.set(Y,Z),(0,R.toDisposable)(()=>{this.c.delete(Y),this.d.delete(Y)})}getEditorSerializer(Y){return this.d.get(typeof Y=="string"?Y:Y.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new ae);async function ee(Q,Y,Z){return!Q||!Q.length?[]:await Promise.all(Q.map(async me=>{const ve=a.URI.revive(me.fileUri);if(!ve){Z.info("Cannot resolve the path because it is not valid.",me);return}if(!await Y.canHandleResource(ve)){Z.info("Cannot resolve the path because it cannot be handled",me);return}let Re=me.exists,oe=me.type;if(typeof Re!="boolean"||typeof oe!="number")try{oe=(await Y.stat(ve)).isDirectory?S.FileType.Directory:S.FileType.Unknown,Re=!0}catch(ue){Z.error(ue),Re=!1}if(!Re&&me.openOnlyIfExists){Z.info("Cannot resolve the path because it does not exist",me);return}if(oe===S.FileType.Directory){Z.info("Cannot resolve the path because it is a directory",me);return}const le={...me.options,pinned:!0};return Re?{resource:ve,options:le}:{resource:ve,options:le,forceUntitled:!0}}))}e.pathsToEditors=ee;var x;(function(Q){Q[Q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Q[Q.SEQUENTIAL=1]="SEQUENTIAL"})(x=e.EditorsOrder||(e.EditorsOrder={}));function J(Q){const Y=Q;if(!Y)return!1;const Z=Y;if(Z.modified)return J(Z.modified);const me=Y;return!!(me.contributionsState&&me.viewState&&Array.isArray(me.cursorState))}e.isTextEditorViewState=J;function ie(Q){return(0,O.isErrorWithActions)(Q)}e.isEditorOpenError=ie;function pe(Q,Y,Z){const me=(0,O.createErrorWithActions)(Q,Y);return me.forceMessage=Z?.forceMessage,me.forceSeverity=Z?.forceSeverity,me.allowDialog=Z?.allowDialog,me}e.createEditorOpenError=pe}),define(ye[225],De([1,0,3,188,4,6,28,39,15,61,23,67,216]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,v.registerIcon)("default-view-icon",T.Codicon.window,(0,A.localize)(0,null));var C;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(C=e.Extensions||(e.Extensions={}));var y;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(y=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function f(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=f;class h extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new o.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new o.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.flatten)([...this.g.values()])}registerViewContainer(c,l,m){const i=this.get(c.id);if(i)return i;const t=c;return t.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:t.openCommandActionDescriptor??{id:t.id},(0,I.getOrSet)(this.g,l,[]).push(t),m?.isDefault&&this.h.push(t),this.c.fire({viewContainer:t,viewContainerLocation:l}),t}deregisterViewContainer(c){for(const l of this.g.keys()){const m=this.g.get(l),i=m?.indexOf(c);if(i!==-1){m?.splice(i,1),m.length===0&&this.g.delete(l),this.f.fire({viewContainer:c,viewContainerLocation:l});return}}}get(c){return this.all.filter(l=>l.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(m=>m?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(l=>this.getViewContainerLocation(l)===c)}}P.Registry.add(C.ViewContainersRegistry,new h);var u;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(u=e.ViewContentGroups||(e.ViewContentGroups={}));function g(r,c){const l=r.group??u.More,m=c.group??u.More;return l!==m?l.localeCompare(m):(r.order??5)-(c.order??5)}class b extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new o.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new o.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new o.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new o.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new k.SetMap}registerViews(c,l){this.registerViews2([{views:c,viewContainer:l}])}registerViews2(c){c.forEach(({views:l,viewContainer:m})=>this.l(l,m)),this.c.fire(c)}deregisterViews(c,l){const m=this.m(c,l);m.length&&this.f.fire({views:m,viewContainer:l})}moveViews(c,l){for(const m of this.j.keys())if(m!==l){const i=this.m(c,m);i.length&&(this.l(i,l),this.g.fire({views:i,from:m,to:l}))}}getViews(c){return this.j.get(c)||[]}getView(c){for(const l of this.i){const m=(this.j.get(l)||[]).filter(i=>i.id===c)[0];if(m)return m}return null}getViewContainer(c){for(const l of this.i)if((this.j.get(l)||[]).filter(i=>i.id===c)[0])return l;return null}registerViewWelcomeContent(c,l){return this.k.add(c,l),this.h.fire(c),(0,R.toDisposable)(()=>{this.k.delete(c,l),this.h.fire(c)})}registerViewWelcomeContent2(c,l){const m=new Map;for(const[i,t]of l)this.k.add(c,t),m.set(i,(0,R.toDisposable)(()=>{this.k.delete(c,t),this.h.fire(c)}));return this.h.fire(c),m}getViewWelcomeContent(c){const l=[];return this.k.forEach(c,m=>l.push(m)),l.sort(g)}l(c,l){let m=this.j.get(l);m||(m=[],this.j.set(l,m),this.i.push(l));for(const i of c){if(this.getView(i.id)!==null)throw new Error((0,A.localize)(1,null,i.id));m.push(i)}}m(c,l){const m=this.j.get(l);if(!m)return[];const i=[],t=[];for(const d of m)c.includes(d)?i.push(d):t.push(d);return i.length&&(t.length?this.j.set(l,t):(this.j.delete(l),this.i.splice(this.i.indexOf(l),1))),i}}P.Registry.add(C.ViewsRegistry,new b),e.IViewsService=(0,a.createDecorator)("viewsService"),e.IViewDescriptorService=(0,a.createDecorator)("viewDescriptorService");var D;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(D=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class n{constructor(c,l){this.c=!1,this.d=!1,(0,O.mixin)(this,c),this.d=!!l,this.resolve=async m=>{if(l&&!this.c){const i=await l(m);i&&(this.tooltip=this.tooltip??i.tooltip,this.command=this.command??i.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n;class s extends Error{constructor(c){super((0,A.localize)(2,null,c))}}e.NoTreeViewError=s}),define(ye[131],De([1,0,3,19,189]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new o.Emitter,this.n=new o.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(P){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=P}onEvent(P){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=P}onRequest(P){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=P}sendResponse(P){P.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.s("response",P)}sendRequest(P,S,k,O){const T={command:P};if(S&&Object.keys(S).length>0&&(T.arguments=S),this.s("request",T),typeof O=="number"){const v=setTimeout(()=>{clearTimeout(v);const C=this.f.get(T.seq);if(C){this.f.delete(T.seq);const y={type:"response",seq:0,request_seq:T.seq,success:!1,command:P,message:(0,a.localize)(0,null,O,P)};C(y)}},O)}return k&&this.f.set(T.seq,k),T.seq}acceptMessage(P){this.j?this.j(P):(this.k.push(P),this.k.length===1&&this.q())}o(P,S){return P.type!=="event"||S.type!=="event"}async q(){let P;for(;this.k.length;){if((!P||this.o(this.k[0],P))&&await(0,A.timeout)(0),P=this.k.shift(),!P)return;switch(P.type){case"event":this.i?.(P);break;case"request":this.g?.(P);break;case"response":{const S=P,k=this.f.get(S.request_seq);k&&(this.f.delete(S.request_seq),k(S));break}}}}s(P,S){S.type=P,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const P=new Map;this.f.forEach((S,k)=>P.set(k,S)),await(0,A.timeout)(500),P.forEach((S,k)=>{S({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(ye[226],De([1,0,190,54,4]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new A.RawContextKey("debugType",void 0,{type:"string",description:o.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new A.RawContextKey("debugConfigurationType",void 0,{type:"string",description:o.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new A.RawContextKey("debugState","inactive",{type:"string",description:o.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new A.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:o.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new A.RawContextKey("hasDebugged",!1,{type:"boolean",description:o.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new A.RawContextKey("inDebugMode",!1,{type:"boolean",description:o.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new A.RawContextKey("inDebugRepl",!1,{type:"boolean",description:o.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new A.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:o.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new A.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:o.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new A.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:o.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new A.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:o.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new A.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:o.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new A.RawContextKey("variablesFocused",!0,{type:"boolean",description:o.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new A.RawContextKey("expressionSelected",!1,{type:"boolean",description:o.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new A.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:o.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new A.RawContextKey("callStackItemType",void 0,{type:"string",description:o.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new A.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:o.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new A.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:o.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new A.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:o.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new A.RawContextKey("watchItemType",void 0,{type:"string",description:o.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new A.RawContextKey("canViewMemory",void 0,{type:"boolean",description:o.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new A.RawContextKey("breakpointItemType",void 0,{type:"string",description:o.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new A.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:o.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new A.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:o.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new A.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:o.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new A.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:o.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new A.RawContextKey("stepBackSupported",!1,{type:"boolean",description:o.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new A.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:o.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new A.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:o.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new A.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:o.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new A.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:o.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new A.RawContextKey("breakpointsExist",!1,{type:"boolean",description:o.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new A.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:o.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new A.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:o.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new A.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:o.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new A.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:o.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new A.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:o.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new A.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:o.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new A.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:o.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new A.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:o.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new A.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:o.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new A.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:o.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new A.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:o.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new A.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:o.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new A.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:o.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new A.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:o.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new A.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:o.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new A.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:o.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new A.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:o.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new A.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:o.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new A.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:o.localize(50,null)});const R=v=>o.localize(51,null,v);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:o.localize(52,null)};var I;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(I=e.State||(e.State={}));function P(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var S;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,a.createDecorator)("debugService");var T;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(T=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[227],De([1,0,8,2,11,23,16,32,21,15]),function(ne,e,o,A,a,R,I,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const O=/{([^}]+)}/g;function T(i,t,d){return i.replace(O,function(E,w){return t&&w.length>0&&w[0]!=="_"?E:d&&d.hasOwnProperty(w)?d[w]:E})}e.formatPII=T;function v(i){const t={};for(const d of Object.keys(i))d.startsWith("!")||(t[d]=i[d]);return t}e.filterExceptionsFromTelemetry=v;function C(i){return i.configuration.request==="attach"&&!y(i)&&(!i.parentSession||C(i.parentSession))}e.isSessionAttach=C;function y(i){let t=i.configuration.type;if(!!t)return t==="vslsShare"&&(t=i.configuration.adapterProxy.configuration.type),(0,o.equalsIgnoreCase)(t,"extensionhost")||(0,o.equalsIgnoreCase)(t,"pwa-extensionhost")?i:i.parentSession?y(i.parentSession):void 0}e.getExtensionHostDebugSession=y;function f(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=f;function h(i,t,d){let E,w=0;const L=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let q=null;for(;q=L.exec(i);){const V=q.index+1,M=V+q[0].length;if(V<=t&&M>=d){E=q[0],w=V;break}}if(E){const V=/\w+/g;let M=null;for(;(M=V.exec(E))&&!(M.index+1+w+M[0].length>=d););M&&(E=E.substring(0,V.lastIndex))}return E?{start:w,end:w+E.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;async function u(i,t,d,E){if(i.evaluatableExpressionProvider.has(t)){const w=i.evaluatableExpressionProvider.ordered(t),L=(0,k.coalesce)(await Promise.all(w.map(async q=>{try{return await q.provideEvaluatableExpression(t,d,E??S.CancellationToken.None)}catch{return}})));if(L.length>0){let q=L[0].expression;const V=L[0].range;return q||(q=t.getLineContent(d.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:q}}}else{const w=t.getLineContent(d.lineNumber),{start:L,end:q}=h(w,d.column,d.column),V=w.substring(L-1,q);return{matchingExpression:V,range:new P.Range(d.lineNumber,L,d.lineNumber,L+V.length)}}return null}e.getEvaluatableExpressionAtPosition=u;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(i){return!!(i&&i.match(g))}e.isUri=b;function D(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(b(i.path))return A.URI.parse(i.path);if((0,a.isAbsolute)(i.path))return A.URI.file(i.path)}return i.path}function p(i){if(typeof i.path=="object"){const t=A.URI.revive(i.path);if(t)return t.scheme===I.Schemas.file?t.fsPath:t.toString()}return i.path}function n(i,t){const d=t?D:p,E=(0,R.deepClone)(i);return r(E,(w,L)=>{w&&L&&(L.path=d(L))}),E}e.convertToDAPaths=n;function s(i,t){const d=t?D:p,E=(0,R.deepClone)(i);return r(E,(w,L)=>{!w&&L&&(L.path=d(L))}),E}e.convertToVSCPaths=s;function r(i,t){switch(i.type){case"event":{const d=i;switch(d.event){case"output":t(!1,d.body.source);break;case"loadedSource":t(!1,d.body.source);break;case"breakpoint":t(!1,d.body.breakpoint.source);break;default:break}break}case"request":{const d=i;switch(d.command){case"setBreakpoints":t(!0,d.arguments.source);break;case"breakpointLocations":t(!0,d.arguments.source);break;case"source":t(!0,d.arguments.source);break;case"gotoTargets":t(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(E=>t(!1,E));break;default:break}break}case"response":{const d=i;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(E=>t(!1,E.source));break;case"loadedSources":d.body.sources.forEach(E=>t(!1,E));break;case"scopes":d.body.scopes.forEach(E=>t(!1,E.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(E=>t(!1,E.source));break;case"setBreakpoints":d.body.breakpoints.forEach(E=>t(!1,E.source));break;case"disassemble":d.body?.instructions.forEach(w=>t(!1,w.location));break;default:break}break}}}function c(i){return i.filter(t=>!t.presentation?.hidden).sort((t,d)=>t.presentation?d.presentation?t.presentation.group?d.presentation.group?t.presentation.group!==d.presentation.group?t.presentation.group.localeCompare(d.presentation.group):l(t.presentation.order,d.presentation.order):-1:d.presentation.group?1:l(t.presentation.order,d.presentation.order):-1:d.presentation?1:0)}e.getVisibleAndSorted=c;function l(i,t){return typeof i!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:i-t}async function m(i,t){const d=i.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorLanguageId});if(d!=="none"&&(await t.saveAll(),d==="allEditorsInActiveGroup")){const E=t.activeEditorPane;E&&E.input.resource?.scheme===I.Schemas.untitled&&await t.save({editor:E.input,groupId:E.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=m}),define(ye[228],De([1,0,46,229,23,11,10,8,29,191,131]),function(ne,e,o,A,a,R,I,P,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class T extends O.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(u,g){this.p=g,this.r=Buffer.allocUnsafe(0),this.t=-1,u.on("data",b=>this.w(b))}sendMessage(u){if(this.p){const g=JSON.stringify(u);this.p.write(`Content-Length: ${Buffer.byteLength(g,"utf8")}${T.a}${g}`,"utf8")}}w(u){for(this.r=Buffer.concat([this.r,u]);;){if(this.t>=0){if(this.r.length>=this.t){const g=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,g.length>0)try{this.acceptMessage(JSON.parse(g))}catch(b){this.m.fire(new Error((b.message||b)+`
`+g))}continue}}else{const g=this.r.indexOf(T.a);if(g!==-1){const D=this.r.toString("utf8",0,g).split(T.b);for(const p of D){const n=p.split(T.l);n[0]==="Content-Length"&&(this.t=Number(n[1]))}this.r=this.r.slice(g+T.a.length);continue}}break}}}T.a=`\r
\r
`,T.b=/\r?\n/,T.l=/: */,e.StreamDebugAdapter=T;class v extends T{startSession(){return new Promise((u,g)=>{let b=!1;this.x=this.y(()=>{this.v(this.x,this.x),u(),b=!0}),this.x.on("close",()=>{b?this.m.fire(new Error("connection closed")):g(new Error("connection closed"))}),this.x.on("error",D=>{b?this.m.fire(D):g(D)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=v;class C extends v{constructor(u){super(),this.z=u}y(u){return A.createConnection(this.z.port,this.z.host||"127.0.0.1",u)}}e.SocketDebugAdapter=C;class y extends v{constructor(u){super(),this.z=u}y(u){return A.createConnection(this.z.path,u)}}e.NamedPipeDebugAdapter=y;class f extends T{constructor(u,g){super(),this.y=u,this.z=g}async startSession(){const u=this.y.command,g=this.y.args,b=this.y.options||{};try{if(u)if(R.isAbsolute(u)){if(!await S.Promises.exists(u))throw new Error(k.localize(0,null,u))}else u.indexOf("/")<0&&u.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.z));let D=process.env;if(b.env&&Object.keys(b.env).length>0&&(D=a.mixin(a.deepClone(process.env),b.env)),u==="node")if(Array.isArray(g)&&g.length>0){const p=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:D,execArgv:p?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};b.cwd&&(n.cwd=b.cwd);const s=o.fork(g[0],g.slice(1),n);if(!s.pid)throw new Error(k.localize(2,null,g[0]));this.x=s}else throw new Error(k.localize(3,null));else{const p={env:D};b.cwd&&(p.cwd=b.cwd),this.x=o.spawn(u,g,p)}this.x.on("error",p=>{this.m.fire(p)}),this.x.on("exit",(p,n)=>{this.n.fire(p)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",p=>{this.m.fire(p)}),this.x.stdin.on("error",p=>{this.m.fire(p)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(D){this.m.fire(D)}}async stopSession(){return this.x?(await this.u(),I.isWindows?new Promise((u,g)=>{const b=o.exec(`taskkill /F /T /PID ${this.x.pid}`,function(D,p,n){if(D)return g(D)});b.on("exit",u),b.on("error",g)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(u,g){if(!u)return;const b=Object.create(null);u.runtime&&(u.runtime.indexOf("./")===0?b.runtime=R.join(g,u.runtime):b.runtime=u.runtime),u.runtimeArgs&&(b.runtimeArgs=u.runtimeArgs),u.program&&(R.isAbsolute(u.program)?b.program=u.program:b.program=R.join(g,u.program)),u.args&&(b.args=u.args);const D=u;return D.win&&(b.win=f.A(D.win,g)),D.winx86&&(b.winx86=f.A(D.winx86,g)),D.windows&&(b.windows=f.A(D.windows,g)),D.osx&&(b.osx=f.A(D.osx,g)),D.linux&&(b.linux=f.A(D.linux,g)),b}static platformAdapterExecutable(u,g){let b=Object.create(null);g=g.toLowerCase();for(const c of u)if(c.contributes){const l=c.contributes.debuggers;l&&l.length>0&&l.filter(m=>typeof m.type=="string"&&P.equalsIgnoreCase(m.type,g)).forEach(m=>{const i=f.A(m,c.extensionLocation.fsPath);b=a.mixin(b,i,c.isBuiltin)})}let D;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?D=b.winx86||b.win||b.windows:I.isWindows?D=b.win||b.windows:I.isMacintosh?D=b.osx:I.isLinux&&(D=b.linux),D=D||b;const p=D.program||b.program,n=D.args||b.args,s=D.runtime||b.runtime,r=D.runtimeArgs||b.runtimeArgs;if(s)return{type:"executable",command:s,args:(r||[]).concat(typeof p=="string"?[p]:[]).concat(n||[])};if(p)return{type:"executable",command:p,args:n||[]}}}e.ExecutableDebugAdapter=f}),define(ye[230],De([1,0,46,33,10]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(k,O){return new Promise((T,v)=>{let C="";const y=o.spawn(k,O);y.pid&&y.stdout.on("data",f=>{C+=f.toString()}),y.on("error",f=>{v(f)}),y.on("close",f=>{T(C)})})}async function I(k){if(k)if(a.isWindows){const O=await new Promise((T,v)=>{ne(["windows-process-tree"],T,v)});return new Promise(T=>{O.getProcessTree(k,v=>{T(!!v&&v.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(k)]).then(O=>{const T=O.trim();return!(T.length===0||T.indexOf(" tmux")>=0)},O=>!0);return Promise.resolve(!0)}e.hasChildProcesses=I;var P;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(P||(P={}));function S(k,O,T,v,C){k=k.trim().toLowerCase();let y;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?y=1:k.indexOf("cmd.exe")>=0?y=0:k.indexOf("bash")>=0?y=2:a.isWindows?y=0:y=2;let f,h=" ";switch(y){case 1:if(f=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),v){const u=(0,A.getDriveLetter)(v);u&&(h+=`${u}:; `),h+=`cd ${f(v)}; `}if(C)for(const u in C){const g=C[u];g===null?h+=`Remove-Item env:${u}; `:h+=`\${env:${u}}='${g}'; `}if(O.length>0){const u=O.shift(),g=T?u:f(u);h+=g[0]==="'"?`& ${g} `:`${g} `;for(const b of O)h+=b==="<"||b===">"||T?b:f(b),h+=" "}break;case 0:if(f=u=>(u=u.replace(/\"/g,'""'),u=u.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(g=>u.includes(g))||u.length===0?`"${u}"`:u),v){const u=(0,A.getDriveLetter)(v);u&&(h+=`${u}: && `),h+=`cd ${f(v)} && `}if(C){h+='cmd /C "';for(const u in C){let g=C[u];g===null?h+=`set "${u}=" && `:(g=g.replace(/[&^|<>]/g,b=>`^${b}`),h+=`set "${u}=${g}" && `)}}for(const u of O)h+=u==="<"||u===">"||T?u:f(u),h+=" ";C&&(h+='"');break;case 2:{f=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),g.length===0?'""':g);const u=g=>/[^\w@%\/+=,.:^-]/.test(g)?`'${g.replace(/'/g,"'\\''")}'`:g;if(v&&(h+=`cd ${f(v)} ; `),C){h+="/usr/bin/env";for(const g in C){const b=C[g];b===null?h+=` -u ${u(g)}`:h+=` ${u(`${g}=${b}`)}`}h+=" "}for(const g of O)h+=g==="<"||g===">"||T?g:f(g),h+=" ";break}}return h}e.prepareCommand=S}),define(ye[93],De([1,0,22,38,64,87,16,11,10,54]),function(ne,e,o,A,a,R,I,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var C;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(C=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var y;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(y=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var g;(function(U){U.scheme=I.Schemas.vscodeNotebookCell;const $=["W","X","Y","Z","a","b","c","d","e","f"],z=new RegExp(`^[${$.join("")}]+`),ae=7;function ee(Y,Z){const me=Z.toString(ae),Ie=`${me.length<$.length?$[me.length-1]:"z"}${me}s${(0,o.encodeBase64)(o.VSBuffer.fromString(Y.scheme),!0,!0)}`;return Y.with({scheme:U.scheme,fragment:Ie})}U.generate=ee;function x(Y){if(Y.scheme!==U.scheme)return;const Z=Y.fragment.indexOf("s");if(Z<0)return;const me=parseInt(Y.fragment.substring(0,Z).replace(z,""),ae),ve=(0,o.decodeBase64)(Y.fragment.substring(Z+1)).toString();if(!isNaN(me))return{handle:me,notebook:Y.with({scheme:ve,fragment:null})}}U.parse=x;function J(Y,Z){return Y.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`op${Z??""},${Y.scheme!==I.Schemas.file?Y.scheme:""}`})}U.generateCellOutputUri=J;function ie(Y){if(Y.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const Z=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!Z)return;const me=Z[1]&&Z[1]!==""?Z[1]:void 0,ve=Z[2];return{outputId:me,notebook:Y.with({scheme:ve||I.Schemas.file,fragment:null})}}U.parseCellOutputUri=ie;function pe(Y,Z,me){return U.generate(Y,Z).with({scheme:me})}U.generateCellPropertyUri=pe;function Q(Y,Z){if(Y.scheme===Z)return U.parse(Y.with({scheme:U.scheme}))}U.parseCellPropertyUri=Q})(g=e.CellUri||(e.CellUri={}));const b=U=>S.isWindows?U.replace(/\//g,"\\"):U;class D{constructor($=[],z=e.NOTEBOOK_DISPLAY_ORDER){this.e=z,this.d=[...new Set($)].map(ae=>({pattern:ae,matches:A.parse(b(ae))}))}sort($){const z=new Map(a.Iterable.map($,ee=>[ee,b(ee)]));let ae=[];for(const{matches:ee}of this.d)for(const[x,J]of z)if(ee(J)){ae.push(x),z.delete(x);break}return z.size&&(ae=ae.concat([...z.keys()].sort((ee,x)=>this.e.indexOf(ee)-this.e.indexOf(x)))),ae}prioritize($,z){const ae=this.f($);if(ae===-1){this.d.unshift({pattern:$,matches:A.parse(b($))});return}const ee=new Set(z.map(J=>this.f(J,ae)));ee.delete(-1);const x=Array.from(ee).sort();this.d.splice(ae+1,0,...x.map(J=>this.d[J]));for(let J=x.length-1;J>=0;J--)this.d.splice(x[J],1)}toArray(){return this.d.map($=>$.pattern)}f($,z=this.d.length){const ae=b($);for(let ee=0;ee<z;ee++)if(this.d[ee].matches(ae))return ee;return-1}}e.MimeTypeDisplayOrder=D;function p(U,$,z,ae=(ee,x)=>ee===x){const ee=[];function x(pe,Q,Y){if(Q===0&&Y.length===0)return;const Z=ee[ee.length-1];Z&&Z.start+Z.deleteCount===pe?(Z.deleteCount+=Q,Z.toInsert.push(...Y)):ee.push({start:pe,deleteCount:Q,toInsert:Y})}let J=0,ie=0;for(;;){if(J===U.length){x(J,0,$.slice(ie));break}if(ie===$.length){x(J,U.length-J,[]);break}const pe=U[J],Q=$[ie];if(ae(pe,Q)){J+=1,ie+=1;continue}z(Q)?(x(J,1,[]),J+=1):(x(J,0,[Q]),ie+=1)}return ee}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(U){U.default="default",U.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(U){const $=U;return!!((typeof $.include=="string"||A.isRelativePattern($.include))&&(typeof $.exclude=="string"||A.isRelativePattern($.exclude)))}e.isDocumentExcludePattern=s;function r(U,$,z){if(Array.isArray(U.viewType)&&U.viewType.indexOf($)>=0||U.viewType===$)return!0;if(U.filenamePattern){const ae=s(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,ee=s(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(A.match(ae,(0,P.basename)(z.fsPath).toLowerCase()))return!(ee&&A.match(ee,(0,P.basename)(z.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",outputWordWrap:"notebook.output.wordWrap",logging:"notebook.logging"};var c;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(c=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class l{static create($){return`${l.d}${$}`}static parse($){if($.startsWith(l.d))return $.substring(l.d.length)}}l.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=l;function m(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.isTextStreamMime=m;const i=new TextDecoder;function t(U){const $=[];let z=!1;for(const ae of U)($.length===0||z)&&($.push(ae),z=!0);return L($),N(o.VSBuffer.concat($.map(ae=>o.VSBuffer.wrap(ae))))}e.compressOutputItemStreams=t;const d=`${String.fromCharCode(27)}[A`,E=d.split("").map(U=>U.charCodeAt(0)),w=10;function L(U){U.forEach(($,z)=>{if(z===0||$.length<d.length)return;const ae=U[z-1],ee=$.subarray(0,d.length);if(ee[0]===E[0]&&ee[1]===E[1]&&ee[2]===E[2]){const x=ae.lastIndexOf(w);if(x===-1)return;U[z-1]=ae.subarray(0,x),U[z]=$.subarray(d.length)}})}function q(U){let $=U;do U=$,$=U.replace(/[^\n]\x08/gm,"");while($.length<U.length);return U}function V(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const $=U.match(/^(.*)\r+/m)[1];let z=U.match(/\r+(.*)$/m)[1];z=z+$.slice(z.length,$.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,z)}return U}const M="\b".charCodeAt(0),B="\r".charCodeAt(0);function N(U){return!U.buffer.includes(M)&&!U.buffer.includes(B)?U:o.VSBuffer.fromString(V(q(i.decode(U.buffer))))}}),define(ye[231],De([1,0,4]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var A;(function(a){a[a.Output=1]="Output",a[a.OutputItems=2]="OutputItems",a[a.ExecutionState=3]="ExecutionState"})(A=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,o.createDecorator)("INotebookExecutionService")}),define(ye[57],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(R){R.Delimiter="\0"})(o=e.TestIdPathParts||(e.TestIdPathParts={}));var A;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(A=e.TestPosition||(e.TestPosition={}));class a{static fromExtHostTestItem(I,P,S=I.parent){if(I._isRoot)return new a([P]);const k=[I.id];for(let O=S;O&&O.id!==P;O=O.parent)k.push(O.id);return k.push(P),new a(k.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const P=I.indexOf("\0");return P===-1?I:I.slice(0,P)}static fromString(I){return new a(I.split("\0"))}static join(I,P){return new a([...I.path,P])}static joinToString(I,P){return I.toString()+"\0"+P}static parentId(I){const P=I.lastIndexOf("\0");return P===-1?void 0:I.slice(0,P)}static localId(I){const P=I.lastIndexOf("\0");return P===-1?I:I.slice(P+1)}static compare(I,P){return I===P?0:P.startsWith(I+"\0")?2:I.startsWith(P+"\0")?3:1}constructor(I,P=I.length){if(this.path=I,this.d=P,I.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new a(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let I=1;I<=this.d;I++)yield new a(this.path,I)}*idsToRoot(){for(let I=this.d;I>0;I--)yield new a(this.path,I)}compare(I){if(typeof I=="string")return a.compare(this.toString(),I);for(let P=0;P<I.d&&P<this.d;P++)if(I.path[P]!==this.path[P])return 1;return I.d>this.d?2:I.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let I=1;I<this.d;I++)this.c+="\0",this.c+=this.path[I]}return this.c}}e.TestId=a}),define(ye[75],De([1,0,2,32,57]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(i){i[i.Unset=0]="Unset",i[i.Queued=1]="Queued",i[i.Running=2]="Running",i[i.Passed=3]="Passed",i[i.Failed=4]="Failed",i[i.Skipped=5]="Skipped",i[i.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var I;(function(i){i[i.Run=2]="Run",i[i.Debug=4]="Debug",i[i.Coverage=8]="Coverage",i[i.HasNonDefaultProfile=16]="HasNonDefaultProfile",i[i.HasConfigurable=32]="HasConfigurable",i[i.SupportsContinuousRun=64]="SupportsContinuousRun"})(I=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const P=i=>"runId"in i;e.isStartControllerTests=P;var S;(function(i){i.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),i.deserialize=t=>({range:A.Range.lift(t.range),uri:o.URI.revive(t.uri)})})(S=e.IRichLocation||(e.IRichLocation={}));var k;(function(i){i[i.Error=0]="Error",i[i.Output=1]="Output"})(k=e.TestMessageType||(e.TestMessageType={}));var O;(function(i){i.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&S.serialize(t.location)}),i.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&S.deserialize(t.location)})})(O=e.ITestErrorMessage||(e.ITestErrorMessage={}));const T=(i,t)=>`${t?"s":"e"}${i}`;e.getMarkId=T;var v;(function(i){i.serialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&S.serialize(t.location)}),i.deserialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&S.deserialize(t.location)})})(v=e.ITestOutputMessage||(e.ITestOutputMessage={}));var C;(function(i){i.serialize=t=>t.type===0?O.serialize(t):v.serialize(t),i.deserialize=t=>t.type===0?O.deserialize(t):v.deserialize(t)})(C=e.ITestMessage||(e.ITestMessage={}));var y;(function(i){i.serializeWithoutMessages=t=>({state:t.state,duration:t.duration,messages:[]}),i.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(C.serialize)}),i.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(C.deserialize)})})(y=e.ITestTaskState||(e.ITestTaskState={}));const f="\0",h=(i,t)=>i+f+t;e.namespaceTestTag=h;const u=i=>{const t=i.indexOf(f);return{ctrlId:i.slice(0,t),tagId:i.slice(t+1)}};e.denamespaceTestTag=u;var g;(function(i){i.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),i.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?o.URI.revive(t.uri):void 0,range:t.range?A.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(g=e.ITestItem||(e.ITestItem={}));var b;(function(i){i[i.NotExpandable=0]="NotExpandable",i[i.Expandable=1]="Expandable",i[i.BusyExpanding=2]="BusyExpanding",i[i.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var D;(function(i){i.serialize=t=>({expand:t.expand,item:g.serialize(t.item)}),i.deserialize=t=>({controllerId:a.TestId.root(t.item.extId),expand:t.expand,item:g.deserialize(t.item)})})(D=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(i){i.serialize=t=>{let d;return t.item&&(d={},t.item.label!==void 0&&(d.label=t.item.label),t.item.tags!==void 0&&(d.tags=t.item.tags),t.item.busy!==void 0&&(d.busy=t.item.busy),t.item.uri!==void 0&&(d.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(d.range=t.item.range?.toJSON()),t.item.description!==void 0&&(d.description=t.item.description),t.item.error!==void 0&&(d.error=t.item.error),t.item.sortText!==void 0&&(d.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:d}},i.deserialize=t=>{let d;return t.item&&(d={},t.item.label!==void 0&&(d.label=t.item.label),t.item.tags!==void 0&&(d.tags=t.item.tags),t.item.busy!==void 0&&(d.busy=t.item.busy),t.item.range!==void 0&&(d.range=t.item.range?A.Range.lift(t.item.range):null),t.item.description!==void 0&&(d.description=t.item.description),t.item.error!==void 0&&(d.error=t.item.error),t.item.sortText!==void 0&&(d.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:d}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const n=(i,t)=>{t.expand!==void 0&&(i.expand=t.expand),t.item!==void 0&&(i.item=i.item?Object.assign(i.item,t.item):t.item)};e.applyTestItemUpdate=n;var s;(function(i){i.serializeWithoutMessages=t=>({...D.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.serializeWithoutMessages),retired:t.retired}),i.serialize=t=>({...D.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.serialize),retired:t.retired}),i.deserialize=t=>({...D.deserialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var r;(function(i){i[i.Function=0]="Function",i[i.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var c;(function(i){i[i.Add=0]="Add",i[i.Update=1]="Update",i[i.DocumentSynced=2]="DocumentSynced",i[i.Remove=3]="Remove",i[i.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",i[i.Retire=5]="Retire",i[i.AddTag=6]="AddTag",i[i.RemoveTag=7]="RemoveTag"})(c=e.TestDiffOpType||(e.TestDiffOpType={}));var l;(function(i){i.deserialize=t=>t.op===0?{op:t.op,item:D.deserialize(t.item)}:t.op===1?{op:t.op,item:p.deserialize(t.item)}:t.op===2?{op:t.op,uri:o.URI.revive(t.uri),docv:t.docv}:t,i.serialize=t=>t.op===0?{op:t.op,item:D.serialize(t.item)}:t.op===1?{op:t.op,item:p.serialize(t.item)}:t})(l=e.TestsDiffOp||(e.TestsDiffOp={}));class m{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(t){const d=this.o();for(const E of t)switch(E.op){case 0:this.j(D.deserialize(E.item),d);break;case 1:this.k(p.deserialize(E.item),d);break;case 3:this.l(E.itemId,d);break;case 5:this.m(E.itemId);break;case 4:this.updatePendingRoots(E.amount);break;case 6:this.c.set(E.tag.id,E.tag);break;case 7:this.c.delete(E.id);break}d.complete?.()}j(t,d){const E=a.TestId.parentId(t.item.extId)?.toString();let w;if(!E)w=this.p(t),this.f.add(w),this.d.set(t.item.extId,w);else if(this.d.has(E)){const L=this.d.get(E);L.children.add(t.item.extId),w=this.p(t,L),this.d.set(t.item.extId,w)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(t)}`);return}return d.add?.(w),t.expand===2&&this.g++,w}k(t,d){const E=this.d.get(t.extId);if(!!E)return t.expand!==void 0&&(E.expand===2&&this.g--,t.expand===2&&this.g++),(0,e.applyTestItemUpdate)(E,t),d.update?.(E),E}l(t,d){const E=this.d.get(t);if(!E)return;const w=a.TestId.parentId(E.item.extId)?.toString();w?this.d.get(w).children.delete(E.item.extId):this.f.delete(E);const L=[[t]];for(;L.length;)for(const q of L.pop()){const V=this.d.get(q);V&&(L.push(V.children),this.d.delete(q),d.remove?.(V,V!==E),V.expand===2&&this.g--)}}m(t){}updatePendingRoots(t){this.h+=t}o(){return{}}}e.AbstractIncrementalTestCollection=m}),define(ye[94],De([1,0,19,3,6,50,75,57]),function(ne,e,o,A,a,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(g,b)=>g===b,T=Object.entries({range:(g,b)=>g===b?!0:!g||!b?!1:g.equalsRange(b),busy:k,label:k,description:k,error:k,sortText:k,tags:(g,b)=>!(g.length!==b.length||g.some(D=>!b.includes(D)))}),v=(g,b)=>{let D;for(const[p,n]of T)n(g[p],b[p])||(D?D[p]=b[p]:D={[p]:b[p]});return D};class C extends a.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.B(new o.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new A.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(b){this.h=b;for(const D of this.tree.values())this.G(D)}get resolveHandler(){return this.h}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const D of this.k)if(D.op===2&&D.uri===b.uri){D.docv=b.docv;return}break}case 1:{const D=this.k[this.k.length-1];if(D){if(D.op===1&&D.item.extId===b.item.extId){(0,I.applyTestItemUpdate)(D.item,b.item);return}if(D.op===0&&D.item.item.extId===b.item.extId){(0,I.applyTestItemUpdate)(D.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,D){const p=this.tree.get(b);if(!!p){if((p.expandLevels===void 0||D>p.expandLevels)&&(p.expandLevels=D),p.expand===1){const n=this.I(p);return n.isOpen()?this.H(p,D-1):n.wait().then(()=>this.H(p,D-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.H(p,D-1)):this.H(p,D-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,D){switch(D.op){case 3:this.L(P.TestId.joinToString(b.fullId,D.id));break;case 0:this.u(D.item,b);break;case 5:for(const p of D.ops)this.p(b,p);break;case 1:this.w(D.new,D.old,b.fullId.toString());break;case 2:this.G(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:D.update}});break;case 6:this.s(b.actual.uri);break;default:(0,R.assertNever)(D)}}s(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}u(b,D){const p=P.TestId.fromExtHostTestItem(b,this.root.id,D?.actual),n=this.m.getApiFor(b);n.parent&&n.parent!==D?.actual&&this.m.getChildren(n.parent).delete(b.id);let s=this.tree.get(p.toString());if(!s){s={fullId:p,actual:b,expandLevels:D?.expandLevels?D.expandLevels-1:void 0,expand:0},b.tags.forEach(this.y,this),this.tree.set(s.fullId.toString(),s),this.C(b,D),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:s.expand,item:this.m.toITestItem(b)}}),this.F(b,s,D);return}if(s.actual===b){this.D(b,s,D);return}if(s.actual.uri?.toString()!==b.uri?.toString())return this.L(p.toString()),this.u(b,D);const r=this.m.getChildren(s.actual),c=s.actual,l=v(this.m.toITestItem(c),this.m.toITestItem(b));this.m.getApiFor(c).listener=void 0,s.actual=b,s.expand=0,l&&(l.hasOwnProperty("tags")&&(this.w(b.tags,c.tags,p.toString()),delete l.tags),this.p(s,{op:4,update:l})),this.F(b,s,D);for(const[m,i]of r)this.m.getChildren(b).get(i.id)||this.L(P.TestId.joinToString(p,i.id));this.s(s.actual.uri)}w(b,D,p){const n=new Set(D.map(s=>s.id));for(const s of b)n.delete(s.id)||this.y(s);this.pushDiff({op:1,item:{extId:p,item:{tags:b.map(s=>(0,I.namespaceTestTag)(this.m.controllerId,s.id))}}}),n.forEach(this.z,this)}y(b){const D=this.j.get(b.id);D?D.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,I.namespaceTestTag)(this.m.controllerId,b.id)}}))}z(b){const D=this.j.get(b);D&&!--D.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,I.namespaceTestTag)(this.m.controllerId,b)}))}C(b,D){this.m.getApiFor(b).parent=D&&D.actual!==this.root?D.actual:void 0}D(b,D,p){this.C(b,p);const n=this.m.getApiFor(b);n.parent=p?.actual,n.listener=s=>this.p(D,s),this.G(D)}F(b,D,p){this.D(b,D,p);for(const[n,s]of this.m.getChildren(b))this.u(s,D)}G(b){let D;this.h?b.resolveBarrier?D=b.resolveBarrier.isOpen()?3:2:D=b.actual.canResolveChildren?1:0:D=0,D!==b.expand&&(b.expand=D,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:D}}),D===1&&b.expandLevels!==void 0&&this.I(b))}H(b,D){if(D<0)return;const p=[];for(const[n,s]of this.m.getChildren(b.actual)){const r=this.expand(P.TestId.joinToString(b.fullId,s.id),D);(0,o.isThenable)(r)&&p.push(r)}if(p.length)return Promise.all(p).then(()=>{})}I(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const s=new o.Barrier;return s.open(),s}b.expand=2,this.J(b);const D=b.resolveBarrier=new o.Barrier,p=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,s)};let n;try{n=this.h(b.actual===this.root?void 0:b.actual)}catch(s){p(s)}return(0,o.isThenable)(n)?n.catch(p).then(()=>{D.open(),this.G(b)}):(D.open(),this.G(b)),b.resolveBarrier}J(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}L(b){const D=this.tree.get(b);if(!D)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const p=[D];for(;p.length;){const n=p.pop();if(!!n){this.m.getApiFor(n.actual).listener=void 0;for(const s of n.actual.tags)this.z(s.id);this.tree.delete(n.fullId.toString());for(const[s,r]of this.m.getChildren(n.actual))p.push(this.tree.get(P.TestId.joinToString(n.fullId,r.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=C;class y extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=y;class f extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class h extends Error{constructor(b,D,p){super(`TestItem with ID "${b}" is from controller "${D}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=h;const u=(g,b,D)=>{let p=new Map;return{get size(){return p.size},forEach(n,s){for(const r of p.values())n.call(s,r,this)},[Symbol.iterator](){return p.entries()},replace(n){const s=new Map,r=new Set(p.keys()),c={op:5,ops:[]};for(const l of n){if(!(l instanceof D))throw new f(l.id);const m=b(l).controllerId;if(m!==g.controllerId)throw new h(l.id,m,g.controllerId);if(s.has(l.id))throw new y(l.id);s.set(l.id,l),r.delete(l.id),c.ops.push({op:0,item:l})}for(const l of r.keys())c.ops.push({op:3,id:l});g.listener?.(c),p=s},add(n){if(!(n instanceof D))throw new f(n.id);p.set(n.id,n),g.listener?.({op:0,item:n})},delete(n){p.delete(n)&&g.listener?.({op:3,id:n})},get(n){return p.get(n)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=u}),define(ye[132],De([1,0,94]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const A=new WeakMap,a=(I,P)=>{const S={controllerId:P};return A.set(I,S),S};e.createPrivateApiFor=a;const R=I=>{const P=A.get(I);if(!P)throw new o.InvalidTestItemError(I?.id||"<unknown>");return P};e.getPrivateApiFor=R}),define(ye[95],De([1,0,16,2]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function a(P,S){return P.scheme===o.Schemas.http||P.scheme===o.Schemas.https?P:(S&&S.authority&&S.isRemote&&P.scheme===o.Schemas.file&&(P=A.URI.from({scheme:o.Schemas.vscodeRemote,authority:S.authority,path:P.path})),A.URI.from({scheme:o.Schemas.https,authority:`${P.scheme}+${R(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=a;function R(P){return P.replace(/./g,S=>{const k=S.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?S:"-"+k.toString(16).padStart(4,"0")})}function I(P){return P.replace(/-([0-9a-f]{4})/g,(S,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=I}),define(ye[232],De([1,0,3,6,95]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(P,S,k){this.d=P,this.e=S,this.f=k,this.a=0,this.b=new A.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const O=S.getVisibleTextEditors();for(const T of this.c.values())O.indexOf(T.editor)<0&&T.inset.dispose()}))}dispose(){this.c.forEach(P=>P.inset.dispose()),this.b.dispose()}createWebviewEditorInset(P,S,k,O,T){let v;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===P){v=b;break}if(!v)throw new Error("not a visible editor");const C=this,y=this.a++,f=new o.Emitter,h=new o.Emitter,u=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,a.asWebviewUri)(b,C.f)}get cspSource(){return a.webviewGenericCspSource}set options(b){this.b=b,C.d.$setOptions(y,b)}get options(){return this.b}set html(b){this.a=b,C.d.$setHtml(y,b)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(b){return C.d.$postMessage(y,b)}},g=new class{constructor(){this.editor=P,this.line=S,this.height=k,this.webview=u,this.onDidDispose=h.event}dispose(){C.c.has(y)&&(C.c.delete(y),C.d.$disposeEditorInset(y),h.fire(),h.dispose(),f.dispose())}};return this.d.$createEditorInset(y,v.id,v.value.document.uri,S+1,k,O||{},T.identifier,T.extensionLocation),this.c.set(y,{editor:P,inset:g,onDidReceiveMessage:f}),g}$onDidDispose(P){const S=this.c.get(P);S&&S.inset.dispose()}$onDidReceiveMessage(P,S){this.c.get(P)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=R}),define(ye[233],De([1,0,4]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,o.createDecorator)("configurationResolverService");var A;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(A=e.VariableKind||(e.VariableKind={}));class a extends Error{constructor(I,P){super(P),this.variable=I}}e.VariableError=a}),define(ye[234],De([1,0,11,36,9,23,10,113,194,233,8]),function(ne,e,o,A,a,R,I,P,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(C,y,f,h){this.g=new Map,this.a=C,this.b=y,this.d=f,h&&(this.c=h.then(u=>this.h(u)))}h(C){if(I.isWindows){const y=Object.create(null);return Object.keys(C).forEach(f=>{y[f.toLowerCase()]=C[f]}),y}return C}resolveWithEnvironment(C,y,f){return this.j({env:this.h(C),userHome:void 0},y?y.uri:void 0,f)}async resolveAsync(C,y){const f={env:await this.c,userHome:await this.d};return this.j(f,C?C.uri:void 0,y)}async i(C,y,f,h){const u=R.deepClone(y);I.isWindows&&u.windows?Object.keys(u.windows).forEach(b=>u[b]=u.windows[b]):I.isMacintosh&&u.osx?Object.keys(u.osx).forEach(b=>u[b]=u.osx[b]):I.isLinux&&u.linux&&Object.keys(u.linux).forEach(b=>u[b]=u.linux[b]),delete u.windows,delete u.osx,delete u.linux;const g={env:await this.c,userHome:await this.d};return this.j(g,C?C.uri:void 0,u,f,h)}async resolveAnyAsync(C,y,f){return this.i(C,y,f)}async resolveAnyMap(C,y,f){const h=new Map;return{newConfig:await this.i(C,y,f,h),resolvedVariables:h}}resolveWithInteractionReplace(C,y,f,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,y,f,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,y){if(this.g.has(C))throw new Error("Variable "+C+" is contributed twice.");this.g.set(C,y)}async j(C,y,f,h,u){if(a.isString(f))return this.l(C,y,f,h,u);if(Array.isArray(f))return Promise.all(f.map(g=>this.j(C,y,g,h,u)));if(a.isObject(f)){const g=Object.create(null),b=await Promise.all(Object.keys(f).map(async D=>[await this.l(C,y,D,h,u),await this.j(C,y,f[D],h,u)]));for(const[D,p]of b)g[D]=p;return g}return f}l(C,y,f,h,u){return(0,O.replaceAsync)(f,T.VARIABLE_REGEXP,async(g,b)=>{if(b.includes(T.VARIABLE_LHS))return g;let D=await this.n(C,g,b,y,h);return u?.set(b,D),D!==g&&a.isString(D)&&D.match(T.VARIABLE_REGEXP)&&(D=await this.l(C,y,D,h,u)),D})}m(C){return this.b?this.b.getUriLabel(C,{noPrefix:!0}):C.fsPath}async n(C,y,f,h,u){let g;const b=f.split(":");b.length>1&&(f=b[0],g=b[1]);const D=s=>{const r=this.a.getFilePath();if(r)return(0,P.normalizeDriveLetter)(r);throw new k.VariableError(s,(0,S.localize)(0,null,y))},p=s=>{const r=D(s);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,P.normalizeDriveLetter)(c)}throw new k.VariableError(s,(0,S.localize)(1,null,y,o.basename(r)))},n=s=>{if(g){const r=this.a.getFolderUri(g);if(r)return r;throw new k.VariableError(s,(0,S.localize)(2,null,y,g))}if(h)return h;throw this.a.getWorkspaceFolderCount()>1?new k.VariableError(s,(0,S.localize)(3,null,y)):new k.VariableError(s,(0,S.localize)(4,null,y))};switch(f){case"env":if(g){if(C.env){const s=C.env[I.isWindows?g.toLowerCase():g];if(a.isString(s))return s}return""}throw new k.VariableError(k.VariableKind.Env,(0,S.localize)(5,null,y));case"config":if(g){const s=this.a.getConfigurationValue(h,g);if(a.isUndefinedOrNull(s))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(6,null,y,g));if(a.isObject(s))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(7,null,y,g));return s}throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(8,null,y));case"command":return this.o(k.VariableKind.Command,y,g,u,"command");case"input":return this.o(k.VariableKind.Input,y,g,u,"input");case"extensionInstallFolder":if(g){const s=await this.a.getExtension(g);if(!s)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,y,g));return this.m(s.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,y));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.m(n(k.VariableKind.WorkspaceFolder)));case"cwd":return h||g?(0,P.normalizeDriveLetter)(this.m(n(k.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.normalizeDriveLetter)(o.basename(this.m(n(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(C.userHome)return C.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,S.localize)(11,null,y))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new k.VariableError(k.VariableKind.LineNumber,(0,S.localize)(12,null,y))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new k.VariableError(k.VariableKind.SelectedText,(0,S.localize)(13,null,y))}case"file":return D(k.VariableKind.File);case"fileWorkspaceFolder":return p(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return h||g?o.relative(this.m(n(k.VariableKind.RelativeFile)),D(k.VariableKind.RelativeFile)):D(k.VariableKind.RelativeFile);case"relativeFileDirname":{const s=o.dirname(D(k.VariableKind.RelativeFileDirname));if(h||g){const r=o.relative(this.m(n(k.VariableKind.RelativeFileDirname)),s);return r.length===0?".":r}return s}case"fileDirname":return o.dirname(D(k.VariableKind.FileDirname));case"fileExtname":return o.extname(D(k.VariableKind.FileExtname));case"fileBasename":return o.basename(D(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=o.basename(D(k.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-o.extname(s).length)}case"fileDirnameBasename":return o.basename(o.dirname(D(k.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||y}case"execInstallFolder":{const s=this.a.getAppRoot();return s||y}case"pathSeparator":return o.sep;default:try{const s=g?`${f}:${g}`:f;return this.o(k.VariableKind.Unknown,y,s,u,void 0)}catch{return y}}}}o(C,y,f,h,u){if(f&&h){const g=u===void 0?h[f]:h[u+":"+f];if(typeof g=="string")return g;throw new k.VariableError(C,(0,S.localize)(14,null,y))}return y}}T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=T}),define(ye[133],De([1,0,4,130]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,o.createDecorator)("editorGroupsService");var a;(function(y){y[y.UP=0]="UP",y[y.DOWN=1]="DOWN",y[y.LEFT=2]="LEFT",y[y.RIGHT=3]="RIGHT"})(a=e.GroupDirection||(e.GroupDirection={}));var R;(function(y){y[y.HORIZONTAL=0]="HORIZONTAL",y[y.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(y){y[y.FIRST=0]="FIRST",y[y.LAST=1]="LAST",y[y.NEXT=2]="NEXT",y[y.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var P;(function(y){y[y.MAXIMIZE=0]="MAXIMIZE",y[y.EVEN=1]="EVEN",y[y.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(y){y[y.COPY_EDITORS=0]="COPY_EDITORS",y[y.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function k(y){const f=y;return(0,A.isEditorInput)(f?.editor)&&(0,A.isEditorInput)(f?.replacement)}e.isEditorReplacement=k;var O;(function(y){y[y.CREATION_TIME=0]="CREATION_TIME",y[y.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",y[y.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(y){y[y.NEW_EDITOR=1]="NEW_EDITOR",y[y.MOVE_EDITOR=2]="MOVE_EDITOR",y[y.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function v(y){const f=y;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.isEditorGroup=v;function C(y){return y.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(ye[235],De([1,0,4,133]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,o.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function a(R){const I=R;return typeof R=="number"||(0,A.isEditorGroup)(I)}e.isPreferredGroup=a}),define(ye[236],De([1,0,4,200]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,o.refineServiceDecorator)(A.IEnvironmentService)}),define(ye[134],De([1,0,27,3,11]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=R;class I{static isHostExtension(T,v,C){if(v.getExtensionDescription(T))return!1;const y=C.getExtensionDescription(T);return y?!!((y.main||y.browser)&&y.api==="none"):!1}constructor(T){this.c=new A.Emitter,this.onDidChange=this.c.event,this.d=T,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const T of this.d){if(this.e.has(o.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this.e.set(o.ExtensionIdentifier.toKey(T.identifier),T),this.f.push(T),Array.isArray(T.activationEvents))for(let v of T.activationEvents)v==="onUri"&&(v=`onUri:${o.ExtensionIdentifier.toKey(T.identifier)}`),this.g.has(v)||this.g.set(v,[]),this.g.get(v).push(T)}}set(T){this.d=T,this.h(),this.c.fire(void 0)}deltaExtensions(T,v){this.d=k(this.d,v),this.d=this.d.concat(T);const C=I.j(this.d);return this.d=k(this.d,C.map(y=>y.identifier)),this.h(),this.c.fire(void 0),new R(C)}static j(T){const v=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,g){this.addNode(u),this.addNode(g),this.c.has(u)?this.c.get(u).push(g):this.c.set(u,[g])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,g){const b=v.getArcs(u);for(let D=0;D<b.length;D++)if(!g.has(b[D]))return!1;return!0}getNodes(){return this.e}},C=new Map;for(const u of T){const g=o.ExtensionIdentifier.toKey(u.identifier);if(C.set(g,u),u.extensionDependencies)for(const b of u.extensionDependencies){const D=o.ExtensionIdentifier.toKey(b);v.addArc(g,D)}}const y=new Set;v.getNodes().filter(u=>v.getArcs(u).length===0).forEach(u=>y.add(u));const f=v.getNodes().filter(u=>!y.has(u));let h;do{h=!1;for(let u=0;u<f.length;u++){const g=f[u];v.hasOnlyGoodArcs(g,y)&&(f.splice(u,1),u--,y.add(g),h=!0)}}while(h);return f.map(u=>C.get(u))}containsActivationEvent(T){return this.g.has(T)}containsExtension(T){return this.e.has(o.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const v=this.g.get(T);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(T){const v=this.e.get(o.ExtensionIdentifier.toKey(T));return v||void 0}getExtensionDescriptionByUUID(T){for(const v of this.f)if(v.uuid===T)return v}getExtensionDescriptionByIdOrUUID(T,v){return this.getExtensionDescription(T)??(v?this.getExtensionDescriptionByUUID(v):void 0)}}e.ExtensionDescriptionRegistry=I;var P;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(P||(P={}));function S(O,T){const v=O.isBuiltin?0:O.isUnderDevelopment?2:1,C=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(v!==C)return v-C;const y=a.posix.basename(O.extensionLocation.path),f=a.posix.basename(T.extensionLocation.path);return y<f?-1:y>f?1:0}function k(O,T){const v=new Set;return T.forEach(C=>v.add(o.ExtensionIdentifier.toKey(C))),O.filter(C=>!v.has(o.ExtensionIdentifier.toKey(C.identifier)))}}),define(ye[237],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var o;(function(O){O[O.IPC=1]="IPC",O[O.Socket=2]="Socket",O[O.MessagePort=3]="MessagePort"})(o=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class A{constructor(T){this.pipeName=T,this.type=1}serialize(T){T[A.ENV_KEY]=this.pipeName}}A.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=A;class a{constructor(){this.type=2}serialize(T){T[a.ENV_KEY]="1"}}a.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=a;class R{constructor(){this.type=3}serialize(T){T[R.ENV_KEY]="1"}}R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=R;function I(O){delete O[A.ENV_KEY],delete O[a.ENV_KEY],delete O[R.ENV_KEY]}function P(O,T){I(T),O.serialize(T)}e.writeExtHostConnection=P;function S(O){if(O[A.ENV_KEY])return k(O,new A(O[A.ENV_KEY]));if(O[a.ENV_KEY])return k(O,new a);if(O[R.ENV_KEY])return k(O,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function k(O,T){return I(O),T}}),define(ye[96],De([1,0,22]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var a;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(a=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function I(k){const O=o.VSBuffer.alloc(1);switch(k){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=I;function P(k,O){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=P;var S;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[76],De([1,0,4,3,13,25,96,72,73,23,2,6,181]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let C=class extends T.Disposable{constructor(u,g){super(),this.m=u,this.n=g,this.a=this.B(new A.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new A.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=O.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=g.createLogger(this.j,{id:S.extensionTelemetryLogChannelId,name:(0,v.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(g.onDidChangeLogLevel(b=>{(0,a.isLogLevel)(b)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===a.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(u,g,b){const D=this.getTelemetryDetails(),p=new y(g,b,u,this.k,this.i,this.getBuiltInCommonProperties(u),{isUsageEnabled:D.isUsageEnabled,isErrorsEnabled:D.isErrorsEnabled});return this.l.set(u.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(u,g,b){this.f=u,this.g=g,this.c=b??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(u){const g={};switch(g["common.extname"]=`${u.publisher}.${u.name}`,g["common.extversion"]=u.version,g["common.vscodemachineid"]=this.m.telemetryInfo.machineId,g["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,g["common.vscodeversion"]=this.m.version,g["common.isnewappinstall"]=f(this.m.telemetryInfo.firstSessionDate),g["common.product"]=this.m.environment.appHost,this.m.uiKind){case I.UIKind.Web:g["common.uikind"]="web";break;case I.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,P.getRemoteName)((0,S.cleanRemoteAuthority)(this.m.remote.authority)),g}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const g=this.getTelemetryDetails();this.l.forEach(b=>{b.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(u,g){const b=this.l.get(u.value);return!b||b.ignoreUnhandledExtHostErrors?!1:(b.logError(g),!0)}};C=xe([ze(0,R.IExtHostInitDataService),ze(1,a.ILoggerService)],C),e.ExtHostTelemetry=C;class y{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,g,b,D,p,n,s){this.g=b,this.h=D,this.i=p,this.j=n,this.a=new A.Emitter,this.ignoreUnhandledExtHostErrors=g?.ignoreUnhandledErrors??!1,this.b=g?.ignoreBuiltInCommonProperties??!1,this.c=g?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(u,g){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:g},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let g=u.properties??u;return g=(0,S.cleanData)(g,[]),this.c&&(g=(0,k.mixin)(g,this.c)),this.b||(g=(0,k.mixin)(g,this.j)),u.properties?u.properties=g:u=g,u}k(u,g){!this.f||(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.f?.sendEventData(u,g),this.h.trace(u,g))}logUsage(u,g){!this.d.isUsageEnabled||this.k(u,g)}logError(u,g){!this.d.isErrorsEnabled||!this.f||(typeof u=="string"?this.k(u,g):this.f.sendErrorData(u,g))}get apiTelemetryLogger(){if(!this.e){const u=this,g={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(g)}return this.e}dispose(){this.f?.flush&&(Promise.resolve(this.f.flush()).then(this.f=void 0),this.e=void 0)}}e.ExtHostTelemetryLogger=y;function f(h){const u=Date.now()-new Date(h).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.isNewAppInstall=f,e.IExtHostTelemetry=(0,o.createDecorator)("IExtHostTelemetry")}),define(ye[26],De([1,0,3,2,4,27,213]),function(ne,e,o,A,a,R,I){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,a.createDecorator)("extensionService");class S{constructor(m){this.affinity=m,this.kind=1}equals(m){return this.kind===m.kind&&this.affinity===m.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class k{constructor(m){this.affinity=m,this.kind=2}equals(m){return this.kind===m.kind&&this.affinity===m.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class O{constructor(){this.kind=3,this.affinity=0}equals(m){return this.kind===m.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class T{constructor(m){this.dependency=m}}e.MissingExtensionDependency=T;var v;(function(l){l[l.LocalProcess=1]="LocalProcess",l[l.LocalWebWorker=2]="LocalWebWorker",l[l.Remote=3]="Remote"})(v=e.ExtensionHostKind||(e.ExtensionHostKind={}));function C(l){if(l===null)return"None";switch(l){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=C;class y{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(m,i){const t=[],d=[],E=[],w=[],L=u(this.c),q=u(m),V=(U,$)=>U.extensionLocation.toString()===$.extensionLocation.toString()||U.isBuiltin===$.isBuiltin||U.isUserBuiltin===$.isUserBuiltin||U.isUnderDevelopment===$.isUnderDevelopment;for(const U of this.c){const $=q.get(R.ExtensionIdentifier.toKey(U.identifier));if(!$){t.push(U.identifier),L.delete(R.ExtensionIdentifier.toKey(U.identifier));continue}if(!V(U,$)){t.push(U.identifier),L.delete(R.ExtensionIdentifier.toKey(U.identifier));continue}}for(const U of m){const $=L.get(R.ExtensionIdentifier.toKey(U.identifier));if(!$){d.push(U);continue}if(!V($,U)){t.push($.identifier),L.delete(R.ExtensionIdentifier.toKey($.identifier));continue}}const M=h(this.d),B=h(i);for(const U of this.d)B.has(R.ExtensionIdentifier.toKey(U))||E.push(U);for(const U of i)M.has(R.ExtensionIdentifier.toKey(U))||w.push(U);const N={toRemove:t,toAdd:d,myToRemove:E,myToAdd:w};return this.delta(N),N}delta(m){const{toRemove:i,toAdd:t,myToRemove:d,myToAdd:E}=m,w=h(i),L=h(d);for(let q=0;q<this.c.length;q++)w.has(R.ExtensionIdentifier.toKey(this.c[q].identifier))&&(this.c.splice(q,1),q--);for(let q=0;q<this.d.length;q++)L.has(R.ExtensionIdentifier.toKey(this.d[q]))&&(this.d.splice(q,1),q--);for(const q of t)this.c.push(q);for(const q of E)this.d.push(q)}containsExtension(m){for(const i of this.d)if(R.ExtensionIdentifier.equals(i,m))return!0;return!1}}e.ExtensionHostExtensions=y;class f{constructor(m){if(this[P]="ExtensionIdentifierSet",this.c=new Map,this.d=R.ExtensionIdentifier.toKey,m)for(const i of m)this.add(i)}get size(){return this.c.size}add(m){return this.c.set(this.d(m),m),this}clear(){this.c.clear()}delete(m){return this.c.delete(this.d(m))}has(m){return this.c.has(this.d(m))}forEach(m,i){this.c.forEach(t=>m.call(i,t,t,this))}*entries(){for(const[m,i]of this.c)yield[i,i]}keys(){return this.c.values()}values(){return this.c.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=f;function h(l){const m=new Set;for(const i of l)m.add(R.ExtensionIdentifier.toKey(i));return m}e.extensionIdentifiersArrayToSet=h;function u(l){const m=new Map;for(const i of l)m.set(R.ExtensionIdentifier.toKey(i.identifier),i);return m}function g(l,m){return l.enabledApiProposals?l.enabledApiProposals.includes(m):!1}e.isProposedApiEnabled=g;function b(l,m){if(!g(l,m))throw new Error(`Extension '${l.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${l.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${l.identifier.value}`)}e.checkProposedApiEnabled=b;class D{constructor(m,i,t,d){this.codeLoadingTime=m,this.activateCallTime=i,this.activateResolvedTime=t,this.activationReason=d}}e.ActivationTimes=D;class p{constructor(m,i){this.description=m,this.value=i}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var n;(function(l){l[l.Normal=0]="Normal",l[l.Immediate=1]="Immediate"})(n=e.ActivationKind||(e.ActivationKind={}));function s(l){return{type:l.isBuiltin?0:1,isBuiltin:l.isBuiltin||l.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(l.publisher,l.name),uuid:l.uuid},manifest:l,location:l.extensionLocation,targetPlatform:l.targetPlatform,validations:[],isValid:!0}}e.toExtension=s;function r(l,m){return{identifier:new R.ExtensionIdentifier((0,I.getExtensionId)(l.manifest.publisher,l.manifest.name)),isBuiltin:l.type===0,isUserBuiltin:l.type===1&&l.isBuiltin,isUnderDevelopment:!!m,extensionLocation:l.location,...l.manifest,uuid:l.identifier.uuid,targetPlatform:l.targetPlatform,browserNlsBundleUris:l.browserNlsBundleUris}}e.toExtensionDescription=r;class c{constructor(){this.onDidRegisterExtensions=o.Event.None,this.onDidChangeExtensionsStatus=o.Event.None,this.onDidChangeExtensions=o.Event.None,this.onWillActivateByEvent=o.Event.None,this.onDidChangeResponsiveChange=o.Event.None,this.extensions=[]}activateByEvent(m){return Promise.resolve(void 0)}activationEventIsDone(m){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(m,i){return Promise.resolve(0)}getInspectPorts(m,i){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=c}),define(ye[238],De([1,0,12,134,27,26,13,19]),function(ne,e,o,A,a,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(u,g,b,D){this.startup=u,this.codeLoadingTime=g,this.activateCallTime=b,this.activateResolvedTime=D}}S.NONE=new S(!1,-1,-1,-1),e.ExtensionActivationTimes=S;class k{constructor(u){this.a=u,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(u,g){return u===-1||g===-1?-1:g-u}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=k;class O{constructor(u,g,b,D,p,n){this.activationFailed=u,this.activationFailedError=g,this.activationTimes=b,this.module=D,this.exports=p,this.subscriptions=n}}e.ActivatedExtension=O;class T extends O{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class v extends O{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class C extends O{constructor(u){super(!0,u,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let y=class{constructor(u,g,b,D){this.g=D,this.a=u,this.b=g,this.c=b,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[u,g]of this.d)g.dispose()}isActivated(u){const g=this.d.get(a.ExtensionIdentifier.toKey(u));return Boolean(g&&g.value)}getActivatedExtension(u){const g=this.d.get(a.ExtensionIdentifier.toKey(u));if(!g||!g.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return g.value}async activateByEvent(u,g){if(this.f[u])return;const b=this.a.getExtensionDescriptionsForActivationEvent(u);await this.h(b.map(D=>({id:D.identifier,reason:{startup:g,extensionId:D.identifier,activationEvent:u}}))),this.f[u]=!0}activateById(u,g){const b=this.a.getExtensionDescription(u);if(!b)throw new Error(`Extension '${u}' is not known`);return this.h([{id:b.identifier,reason:g}])}async h(u){const g=u.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(g.map(b=>b.wait()))}j(u){if(this.d.has(a.ExtensionIdentifier.toKey(u.id)))return this.d.get(a.ExtensionIdentifier.toKey(u.id));if(this.l(u.id))return this.k(u,null,[],null);const g=this.a.getExtensionDescription(u.id);if(!g){const p=new Error(`Cannot activate unknown extension '${u.id.value}'`),n=this.k(u,null,[],new C(p));return this.c.onExtensionActivationError(u.id,p,new R.MissingExtensionDependency(u.id.value)),n}const b=[],D=typeof g.extensionDependencies>"u"?[]:g.extensionDependencies;for(const p of D){if(this.m(p))continue;const n=this.d.get(a.ExtensionIdentifier.toKey(p));if(n){b.push(n);continue}if(this.l(p)){b.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:u.reason}));continue}const s=this.a.getExtensionDescription(p);if(s){if(!s.main&&!s.browser)continue;b.push(this.j({id:s.identifier,reason:u.reason}));continue}const r=g.displayName||g.identifier.value,c=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${p}'`),l=this.k(u,g.displayName,[],new C(c));return this.c.onExtensionActivationError(g.identifier,c,new R.MissingExtensionDependency(p)),l}return this.k(u,g.displayName,b,null)}k(u,g,b,D){const p=new f(u.id,g,u.reason,b,D,this.c,this.g);return this.d.set(a.ExtensionIdentifier.toKey(u.id),p),p}l(u){return A.ExtensionDescriptionRegistry.isHostExtension(u,this.a,this.b)}m(u){const g=this.b.getExtensionDescription(u);return g?!g.main&&!g.browser:!1}};y=xe([ze(3,I.ILogService)],y),e.ExtensionsActivator=y;let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(u,g,b,D,p,n,s){this.c=u,this.d=g,this.f=b,this.g=D,this.h=p,this.j=n,this.k=s,this.a=new P.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let u=0;u<this.g.length;u++){const g=this.g[u];if(g.value&&!g.value.activationFailed){this.g.splice(u,1),u--;continue}if(g.value&&g.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);b.detail=g.value.activationFailedError,this.h=new C(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(u=>u.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(u){const g=new Error;if(u&&u.name&&(g.name=u.name),u&&u.message?g.message=`Activating extension '${this.c.value}' failed: ${u.message}.`:g.message=`Activating extension '${this.c.value}' failed: ${u}.`,u&&u.stack&&(g.stack=u.stack),this.h=new C(g),this.b&&o.isCancellationError(u))return;this.j.onExtensionActivationError(this.c,g,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(u)}}};f=xe([ze(6,I.ILogService)],f)});var _e=this&&this.__classPrivateFieldSet||function(ne,e,o,A,a){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!a:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?a.call(ne,o):a?a.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[7],De([1,0,15,12,112,28,87,8,9,2,30,44,128,93,26]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y){"use strict";var f,h,u,g,b,D,p,n,s,r,c,l,m,i,t,d,E,w,L,q,V,M,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function N(G){return Object.assign(G,{apply:function(){const fe=arguments.length===1?[]:arguments[1];return Reflect.construct(G,fe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(G,[]);{const[fe,...Te]=arguments;return Reflect.construct(G,Te,fe.constructor)}}})}var U;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(U=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var $;(function(G){G[G.Command=0]="Command",G[G.Opener=1]="Opener"})($=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let z=D=class{static from(...j){let fe=j;return new D(function(){if(fe){for(const Te of fe)Te&&typeof Te.dispose=="function"&&Te.dispose();fe=void 0}})}constructor(j){f.set(this,void 0),_e(this,f,j,"f")}dispose(){typeof Ue(this,f,"f")=="function"&&(Ue(this,f,"f").call(this),_e(this,f,void 0,"f"))}};f=new WeakMap,z=D=xe([N],z),e.Disposable=z;let ae=p=class{static Min(...j){if(j.length===0)throw new TypeError;let fe=j[0];for(let Te=1;Te<j.length;Te++){const Ke=j[Te];Ke.isBefore(fe)&&(fe=Ke)}return fe}static Max(...j){if(j.length===0)throw new TypeError;let fe=j[0];for(let Te=1;Te<j.length;Te++){const Ke=j[Te];Ke.isAfter(fe)&&(fe=Ke)}return fe}static isPosition(j){if(!j)return!1;if(j instanceof p)return!0;const{line:fe,character:Te}=j;return typeof fe=="number"&&typeof Te=="number"}static of(j){if(j instanceof p)return j;if(this.isPosition(j))return new p(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,fe){if(j<0)throw(0,A.illegalArgument)("line must be non-negative");if(fe<0)throw(0,A.illegalArgument)("character must be non-negative");this.c=j,this.e=fe}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,fe=0){if(j===null||fe===null)throw(0,A.illegalArgument)();let Te;return typeof j>"u"?Te=0:typeof j=="number"?Te=j:(Te=typeof j.lineDelta=="number"?j.lineDelta:0,fe=typeof j.characterDelta=="number"?j.characterDelta:0),Te===0&&fe===0?this:new p(this.line+Te,this.character+fe)}with(j,fe=this.character){if(j===null||fe===null)throw(0,A.illegalArgument)();let Te;return typeof j>"u"?Te=this.line:typeof j=="number"?Te=j:(Te=typeof j.line=="number"?j.line:this.line,fe=typeof j.character=="number"?j.character:this.character),Te===this.line&&fe===this.character?this:new p(Te,fe)}toJSON(){return{line:this.line,character:this.character}}};ae=p=xe([N],ae),e.Position=ae;let ee=n=class{static isRange(j){return j instanceof n?!0:j?ae.isPosition(j.start)&&ae.isPosition(j.end):!1}static of(j){if(j instanceof n)return j;if(this.isRange(j))return new n(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,fe,Te,Ke){let Je,ct;if(typeof j=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Je=new ae(j,fe),ct=new ae(Te,Ke)):ae.isPosition(j)&&ae.isPosition(fe)&&(Je=ae.of(j),ct=ae.of(fe)),!Je||!ct)throw new Error("Invalid arguments");Je.isBefore(ct)?(this.c=Je,this.e=ct):(this.c=ct,this.e=Je)}contains(j){return n.isRange(j)?this.contains(j.start)&&this.contains(j.end):ae.isPosition(j)?!(ae.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const fe=ae.Max(j.start,this.c),Te=ae.Min(j.end,this.e);if(!fe.isAfter(Te))return new n(fe,Te)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const fe=ae.Min(j.start,this.c),Te=ae.Max(j.end,this.end);return new n(fe,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,fe=this.end){if(j===null||fe===null)throw(0,A.illegalArgument)();let Te;return j?ae.isPosition(j)?Te=j:(Te=j.start||this.start,fe=j.end||this.end):Te=this.start,Te.isEqual(this.c)&&fe.isEqual(this.end)?this:new n(Te,fe)}toJSON(){return[this.start,this.end]}};ee=n=xe([N],ee),e.Range=ee;let x=s=class extends ee{static isSelection(j){return j instanceof s?!0:j?ee.isRange(j)&&ae.isPosition(j.anchor)&&ae.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,fe,Te,Ke){let Je,ct;if(typeof j=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Je=new ae(j,fe),ct=new ae(Te,Ke)):ae.isPosition(j)&&ae.isPosition(fe)&&(Je=ae.of(j),ct=ae.of(fe)),!Je||!ct)throw new Error("Invalid arguments");super(Je,ct),this.f=Je,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=s=xe([N],x),e.Selection=x;class J{constructor(j,fe,Te){if(typeof j!="string"||j.length===0)throw(0,A.illegalArgument)("host");if(typeof fe!="number"||fe===0||Math.round(fe)!==fe)throw(0,A.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,A.illegalArgument)("connectionToken");this.host=j,this.port=Math.round(fe),this.connectionToken=Te}}e.ResolvedAuthority=J;class ie extends Error{static NotAvailable(j,fe){return new ie(j,v.RemoteAuthorityResolverErrorCode.NotAvailable,fe)}static TemporarilyNotAvailable(j){return new ie(j,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,fe=v.RemoteAuthorityResolverErrorCode.Unknown,Te){super(j),this._message=j,this._code=fe,this._detail=Te,Object.setPrototypeOf(this,ie.prototype)}}e.RemoteAuthorityResolverError=ie;var pe;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(pe=e.EndOfLine||(e.EndOfLine={}));var Q;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(Q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Y=r=class{static isTextEdit(j){return j instanceof r?!0:j?ee.isRange(j)&&typeof j.newText=="string":!1}static replace(j,fe){return new r(j,fe)}static insert(j,fe){return r.replace(new ee(j,j),fe)}static delete(j){return r.replace(j,"")}static setEndOfLine(j){const fe=new r(new ee(new ae(0,0),new ae(0,0)),"");return fe.newEol=j,fe}get range(){return this.c}set range(j){if(j&&!ee.isRange(j))throw(0,A.illegalArgument)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,A.illegalArgument)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,A.illegalArgument)("newEol");this.f=j}constructor(j,fe){this.c=j,this.e=fe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};Y=r=xe([N],Y),e.TextEdit=Y;let Z=c=class{static isNotebookCellEdit(j){return j instanceof c?!0:j?Vt.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,fe){return new c(j,fe)}static insertCells(j,fe){return new c(new Vt(j,j),fe)}static deleteCells(j){return new c(j,[])}static updateCellMetadata(j,fe){const Te=new c(new Vt(j,j),[]);return Te.newCellMetadata=fe,Te}static updateNotebookMetadata(j){const fe=new c(new Vt(0,0),[]);return fe.newNotebookMetadata=j,fe}constructor(j,fe){this.range=j,this.newCells=fe}};Z=c=xe([N],Z),e.NotebookEdit=Z;class me{static isSnippetTextEdit(j){return j instanceof me?!0:j?ee.isRange(j.range)&&Re.isSnippetString(j.snippet):!1}static replace(j,fe){return new me(j,fe)}static insert(j,fe){return me.replace(new ee(j,j),fe)}constructor(j,fe){this.range=j,this.snippet=fe}}e.SnippetTextEdit=me;var ve;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(ve=e.FileEditType||(e.FileEditType={}));let Ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,fe,Te,Ke){this.c.push({_type:1,from:j,to:fe,options:Te,metadata:Ke})}createFile(j,fe,Te){this.c.push({_type:1,from:void 0,to:j,options:fe,metadata:Te})}deleteFile(j,fe,Te){this.c.push({_type:1,from:j,to:void 0,options:fe,metadata:Te})}e(j,fe,Te){this.c.push({_type:3,metadata:Te,uri:j,edit:{editType:5,metadata:fe},notebookMetadata:fe})}f(j,fe,Te,Ke){const Je=fe.start,ct=fe.end;(Je!==ct||Te.length>0)&&this.c.push({_type:5,uri:j,index:Je,count:ct-Je,cells:Te,metadata:Ke})}g(j,fe,Te,Ke){this.c.push({_type:3,metadata:Ke,uri:j,edit:{editType:8,index:fe,metadata:Te}})}replace(j,fe,Te,Ke){this.c.push({_type:2,uri:j,edit:new Y(fe,Te),metadata:Ke})}insert(j,fe,Te,Ke){this.replace(j,new ee(fe,fe),Te,Ke)}delete(j,fe,Te){this.replace(j,fe,"",Te)}has(j){return this.c.some(fe=>fe._type===2&&fe.uri.toString()===j.toString())}set(j,fe){if(fe)for(const Te of fe){if(!Te)continue;let Ke,Je;Array.isArray(Te)?(Ke=Te[0],Je=Te[1]):Ke=Te,Z.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(j,Ke.range.start,Ke.newCellMetadata,Je):Ke.newNotebookMetadata?this.e(j,Ke.newNotebookMetadata,Je):this.f(j,Ke.range,Ke.newCells,Je):me.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:j,range:Ke.range,edit:Ke.snippet,metadata:Je}):this.c.push({_type:2,uri:j,edit:Ke,metadata:Je})}else{for(let Te=0;Te<this.c.length;Te++){const Ke=this.c[Te];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===j.toString()&&(this.c[Te]=void 0);break}}(0,o.coalesceInPlace)(this.c)}}get(j){const fe=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===j.toString()&&fe.push(Te.edit);return fe}entries(){const j=new R.ResourceMap;for(const fe of this.c)if(fe._type===2){let Te=j.get(fe.uri);Te||(Te=[fe.uri,[]],j.set(fe.uri,Te)),Te[1].push(fe.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ie=xe([N],Ie),e.WorkspaceEdit=Ie;let Re=l=class{static isSnippetString(j){return j instanceof l?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=l.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,fe=this.e++){if(typeof j=="function"){const Te=new l;Te.e=this.e,j(Te),this.e=Te.e,j=Te.value}else j=l.c(j);return this.value+="${",this.value+=fe,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,fe=this.e++){const Te=j.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=fe,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(j,fe){if(typeof fe=="function"){const Te=new l;Te.e=this.e,fe(Te),this.e=Te.e,fe=Te.value}else typeof fe=="string"&&(fe=fe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,fe&&(this.value+=":",this.value+=fe),this.value+="}",this}};Re=l=xe([N],Re),e.SnippetString=Re;var oe;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(oe=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ue=m=class{static isLocation(j){return j instanceof m?!0:j?ee.isRange(j.range)&&k.URI.isUri(j.uri):!1}constructor(j,fe){if(this.uri=j,fe)if(ee.isRange(fe))this.range=ee.of(fe);else if(ae.isPosition(fe))this.range=new ee(fe,fe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ue=m=xe([N],ue),e.Location=ue;let te=class{static is(j){return j?typeof j.message=="string"&&j.location&&ee.isRange(j.location.range)&&k.URI.isUri(j.location.uri):!1}constructor(j,fe){this.location=j,this.message=fe}static isEqual(j,fe){return j===fe?!0:!j||!fe?!1:j.message===fe.message&&j.location.range.isEqual(fe.location.range)&&j.location.uri.toString()===fe.location.uri.toString()}};te=xe([N],te),e.DiagnosticRelatedInformation=te;let ce=class{constructor(j,fe,Te=le.Error){if(!ee.isRange(j))throw new TypeError("range must be set");if(!fe)throw new TypeError("message must be set");this.range=j,this.message=fe,this.severity=Te}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,fe){return j===fe?!0:!j||!fe?!1:j.message===fe.message&&j.severity===fe.severity&&j.code===fe.code&&j.severity===fe.severity&&j.source===fe.source&&j.range.isEqual(fe.range)&&(0,o.equals)(j.tags,fe.tags)&&(0,o.equals)(j.relatedInformation,fe.relatedInformation,te.isEqual)}};ce=xe([N],ce),e.Diagnostic=ce;let se=class{constructor(j,fe){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=fe}};se=xe([N],se),e.Hover=se;var F;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(F=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let H=class{constructor(j,fe=F.Text){this.range=j,this.kind=fe}toJSON(){return{range:this.range,kind:F[this.kind]}}};H=xe([N],H),e.DocumentHighlight=H;var K;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(K=e.SymbolKind||(e.SymbolKind={}));var _;(function(G){G[G.Deprecated=1]="Deprecated"})(_=e.SymbolTag||(e.SymbolTag={}));let de=i=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,fe,Te,Ke,Je){this.name=j,this.kind=fe,this.containerName=Je,typeof Te=="string"&&(this.containerName=Te),Ke instanceof ue?this.location=Ke:Te instanceof ee&&(this.location=new ue(Ke,Te)),i.validate(this)}toJSON(){return{name:this.name,kind:K[this.kind],location:this.location,containerName:this.containerName}}};de=i=xe([N],de),e.SymbolInformation=de;let we=t=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(t.validate)}constructor(j,fe,Te,Ke,Je){this.name=j,this.detail=fe,this.kind=Te,this.range=Ke,this.selectionRange=Je,this.children=[],t.validate(this)}};we=t=xe([N],we),e.DocumentSymbol=we;var Pe;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Pe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let be=class{constructor(j,fe){this.title=j,this.kind=fe}};be=xe([N],be),e.CodeAction=be;let Ce=d=class{constructor(j){this.value=j}append(j){return new d(this.value?this.value+d.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+d.c)}};Ce.c=".",Ce=d=xe([N],Ce),e.CodeActionKind=Ce,Ce.Empty=new Ce(""),Ce.QuickFix=Ce.Empty.append("quickfix"),Ce.Refactor=Ce.Empty.append("refactor"),Ce.RefactorExtract=Ce.Refactor.append("extract"),Ce.RefactorInline=Ce.Refactor.append("inline"),Ce.RefactorMove=Ce.Refactor.append("move"),Ce.RefactorRewrite=Ce.Refactor.append("rewrite"),Ce.Source=Ce.Empty.append("source"),Ce.SourceOrganizeImports=Ce.Source.append("organizeImports"),Ce.SourceFixAll=Ce.Source.append("fixAll");let ke=class{constructor(j,fe){if(this.range=j,this.parent=fe,fe&&!fe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=xe([N],ke),e.SelectionRange=ke;class He{constructor(j,fe,Te,Ke,Je,ct){this.kind=j,this.name=fe,this.detail=Te,this.uri=Ke,this.range=Je,this.selectionRange=ct}}e.CallHierarchyItem=He;class Ge{constructor(j,fe){this.fromRanges=fe,this.from=j}}e.CallHierarchyIncomingCall=Ge;class nt{constructor(j,fe){this.fromRanges=fe,this.to=j}}e.CallHierarchyOutgoingCall=nt;var Qe;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let tt=class{constructor(j,fe){this.range=j,this.command=fe}get isResolved(){return!!this.command}};tt=xe([N],tt),e.CodeLens=tt;let rt=E=class{static isMarkdownString(j){return j instanceof E?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,fe=!1){h.set(this,void 0),_e(this,h,new a.MarkdownString(j,{supportThemeIcons:fe}),"f")}get value(){return Ue(this,h,"f").value}set value(j){Ue(this,h,"f").value=j}get isTrusted(){return Ue(this,h,"f").isTrusted}set isTrusted(j){Ue(this,h,"f").isTrusted=j}get supportThemeIcons(){return Ue(this,h,"f").supportThemeIcons}set supportThemeIcons(j){Ue(this,h,"f").supportThemeIcons=j}get supportHtml(){return Ue(this,h,"f").supportHtml}set supportHtml(j){Ue(this,h,"f").supportHtml=j}get baseUri(){return Ue(this,h,"f").baseUri}set baseUri(j){Ue(this,h,"f").baseUri=j}appendText(j){return Ue(this,h,"f").appendText(j),this}appendMarkdown(j){return Ue(this,h,"f").appendMarkdown(j),this}appendCodeblock(j,fe){return Ue(this,h,"f").appendCodeblock(fe??"",j),this}};h=new WeakMap,rt=E=xe([N],rt),e.MarkdownString=rt;let Be=class{constructor(j,fe){this.label=j,this.documentation=fe}};Be=xe([N],Be),e.ParameterInformation=Be;let it=class{constructor(j,fe){this.label=j,this.documentation=fe,this.parameters=[]}};it=xe([N],it),e.SignatureInformation=it;let W=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};W=xe([N],W),e.SignatureHelp=W;var X;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var he;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(he=e.InlayHintKind||(e.InlayHintKind={}));let Le=class{constructor(j){this.value=j}};Le=xe([N],Le),e.InlayHintLabelPart=Le;let Ne=class{constructor(j,fe,Te){this.position=j,this.label=fe,this.kind=Te}};Ne=xe([N],Ne),e.InlayHint=Ne;var qe;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(G){G[G.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let st=class{constructor(j,fe){this.label=j,this.kind=fe}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};st=xe([N],st),e.CompletionItem=st;let at=class{constructor(j=[],fe=!1){this.items=j,this.isIncomplete=fe}};at=xe([N],at),e.CompletionList=at;let mt=class{constructor(j,fe,Te){this.insertText=j,this.range=fe,this.command=Te}};mt=xe([N],mt),e.InlineSuggestion=mt;let gt=class{constructor(j){this.commands=void 0,this.items=j}};gt=xe([N],gt),e.InlineSuggestionList=gt;var Et;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var lt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var pt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(pt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var xt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(xt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var jt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(jt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var kt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(kt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ft;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(ft=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Tt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Tt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function j(fe){switch(fe){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=j}(kt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Bt=class{constructor(j,fe){if(fe&&!k.URI.isUri(fe))throw(0,A.illegalArgument)("target");if(!ee.isRange(j)||j.isEmpty)throw(0,A.illegalArgument)("range");this.range=j,this.target=fe}};Bt=xe([N],Bt),e.DocumentLink=Bt;let At=class{constructor(j,fe,Te,Ke){this.red=j,this.green=fe,this.blue=Te,this.alpha=Ke}};At=xe([N],At),e.Color=At;let Xe=class{constructor(j,fe){if(fe&&!(fe instanceof At))throw(0,A.illegalArgument)("color");if(!ee.isRange(j)||j.isEmpty)throw(0,A.illegalArgument)("range");this.range=j,this.color=fe}};Xe=xe([N],Xe),e.ColorInformation=Xe;let Nt=class{constructor(j){if(!j||typeof j!="string")throw(0,A.illegalArgument)("label");this.label=j}};Nt=xe([N],Nt),e.ColorPresentation=Nt;var Gt;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Gt=e.ColorFormat||(e.ColorFormat={}));var Ft;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(Ft=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var bt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(bt=e.TerminalExitReason||(e.TerminalExitReason={}));class Ae{constructor(j,fe,Te){if(this.startIndex=j,this.length=fe,this.tooltip=Te,typeof j!="number"||j<0)throw(0,A.illegalArgument)("startIndex");if(typeof fe!="number"||fe<1)throw(0,A.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=Ae;class Oe{constructor(j){this.uri=j}}e.TerminalQuickFixOpener=Oe;class Se{constructor(j){this.terminalCommand=j}}e.TerminalQuickFixCommand=Se;var re;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(re=e.TerminalLocation||(e.TerminalLocation={}));class Fe{constructor(j){if(this.options=j,typeof j!="object")throw(0,A.illegalArgument)("options")}}e.TerminalProfile=Fe;var We;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(We=e.TaskRevealKind||(e.TaskRevealKind={}));var Ye;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Ye=e.TaskPanelKind||(e.TaskPanelKind={}));let Ve=w=class{static from(j){switch(j){case"clean":return w.Clean;case"build":return w.Build;case"rebuild":return w.Rebuild;case"test":return w.Test;default:return}}constructor(j,fe){if(this.label=fe,typeof j!="string"||typeof fe!="string")throw(0,A.illegalArgument)("name");this.c=j}get id(){return this.c}};Ve.Clean=new w("clean","Clean"),Ve.Build=new w("build","Build"),Ve.Rebuild=new w("rebuild","Rebuild"),Ve.Test=new w("test","Test"),Ve=w=xe([N],Ve),e.TaskGroup=Ve;function et(G){let j="";for(let fe=0;fe<G.length;fe++)j+=G[fe].replace(/,/g,",,")+",";return j}let ut=class{constructor(j,fe,Te){if(typeof j!="string")throw(0,A.illegalArgument)("process");this.e=[],this.c=j,fe!==void 0&&(Array.isArray(fe)?(this.e=fe,this.f=Te):this.f=fe)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,A.illegalArgument)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const fe of this.e)j.push(fe);return et(j)}};ut=xe([N],ut),e.ProcessExecution=ut;let Pt=class{constructor(j,fe,Te){if(this.f=[],Array.isArray(fe)){if(!j)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,A.illegalArgument)("command");this.e=j,this.f=fe,this.g=Te}else{if(typeof j!="string")throw(0,A.illegalArgument)("commandLine");this.c=j,this.g=fe}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,A.illegalArgument)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,A.illegalArgument)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const fe of this.f)j.push(typeof fe=="string"?fe:fe.value);return et(j)}};Pt=xe([N],Pt),e.ShellExecution=Pt;var St;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(St=e.ShellQuoting||(e.ShellQuoting={}));var Dt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Dt=e.TaskScope||(e.TaskScope={}));class wt{constructor(j){this.c=j}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(j){this.c=j}get callback(){return this.c}}e.CustomExecution=wt;let Rt=L=class{constructor(j,fe,Te,Ke,Je,ct){this.j=!1,this.k=this.definition=j;let ht;typeof fe=="string"?(this.m=this.name=fe,this.t=this.source=Te,this.execution=Ke,ht=Je,this.j=!0):fe===Dt.Global||fe===Dt.Workspace?(this.target=fe,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Je,ht=ct):(this.target=fe,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Je,ht=ct),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(j){this.h=j}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ut?this.k={type:L.e,id:this.n.computeId()}:this.n instanceof Pt?this.k={type:L.f,id:this.n.computeId()}:this.n instanceof wt?this.k={type:L.c,id:this.n.computeId()}:this.k={type:L.g,id:(0,O.generateUuid)()}}get definition(){return this.k}set definition(j){if(j==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=j}get scope(){return this.l}set target(j){this.y(),this.l=j}get name(){return this.m}set name(j){if(typeof j!="string")throw(0,A.illegalArgument)("name");this.y(),this.m=j}get execution(){return this.n}set execution(j){j===null&&(j=void 0),this.y(),this.n=j;const fe=this.k.type;(L.g===fe||L.e===fe||L.f===fe||L.c===fe)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(j){if(Array.isArray(j))this.y(),this.o=j,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.y(),this.r=j}get source(){return this.t}set source(j){if(typeof j!="string"||j.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.y(),this.t=j}get group(){return this.u}set group(j){j===null&&(j=void 0),this.y(),this.u=j}get detail(){return this.x}set detail(j){j===null&&(j=void 0),this.x=j}get presentationOptions(){return this.v}set presentationOptions(j){j==null&&(j=Object.create(null)),this.y(),this.v=j}get runOptions(){return this.w}set runOptions(j){j==null&&(j=Object.create(null)),this.y(),this.w=j}};Rt.c="customExecution",Rt.e="process",Rt.f="shell",Rt.g="$empty",Rt=L=xe([N],Rt),e.Task=Rt;var yt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(yt=e.ProgressLocation||(e.ProgressLocation={}));var ri;(function(G){function j(fe){const Te=fe;return(0,S.isNumber)(Te.value)?Te.tooltip&&!(0,S.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}G.isViewBadge=j})(ri=e.ViewBadge||(e.ViewBadge={}));let ei=q=class{static isTreeItem(j,fe){const Te=j;if(Te.checkboxState!==void 0){(0,y.checkProposedApiEnabled)(fe,"treeItemCheckbox");const Ke=(0,S.isNumber)(Te.checkboxState)?Te.checkboxState:(0,S.isObject)(Te.checkboxState)&&(0,S.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Je=!(0,S.isNumber)(Te.checkboxState)&&(0,S.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==si.Checked&&Ke!==si.Unchecked||Je!==void 0&&!(0,S.isString)(Je))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(j instanceof q)return!0;if(Te.label!==void 0&&!(0,S.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,S.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,S.isString)(Te.iconPath)&&!k.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,S.isString)(Te.iconPath.id))){const Ke=Te.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!k.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!k.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,S.isString)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!k.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,S.isString)(Te.tooltip)&&!(Te.tooltip instanceof rt)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<Ct.None&&Te.collapsibleState>Ct.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,S.isString)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(j,fe=Ct.None){this.collapsibleState=fe,k.URI.isUri(j)?this.resourceUri=j:this.label=j}};ei=q=xe([N],ei),e.TreeItem=ei;var Ct;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(Ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j,fe){this.value=j,this.id=fe??(0,O.generateUuid)()}};oi=xe([N],oi),e.DataTransferItem=oi;let Jt=class{constructor(j){u.set(this,new Map);for(const[fe,Te]of j??[]){const Ke=Ue(this,u,"f").get(fe);Ke?Ke.push(Te):Ue(this,u,"f").set(fe,[Te])}}get(j){return Ue(this,u,"f").get(j)?.[0]}set(j,fe){Ue(this,u,"f").set(j,[fe])}forEach(j,fe){for(const[Te,Ke]of Ue(this,u,"f"))for(const Je of Ke)j.call(fe,Je,Te,this)}*[(u=new WeakMap,Symbol.iterator)](){for(const[j,fe]of Ue(this,u,"f"))for(const Te of fe)yield[j,Te]}};Jt=xe([N],Jt),e.DataTransfer=Jt;let bi=class{constructor(j){this.insertText=j}};bi=xe([N],bi),e.DocumentDropEdit=bi;let Lt=class{constructor(j){this.insertText=j}};Lt=xe([N],Lt),e.DocumentPasteEdit=Lt;let zt=class{constructor(j,fe){this.id=j,this.color=fe}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};zt=xe([N],zt),e.ThemeIcon=zt,zt.File=new zt("file"),zt.Folder=new zt("folder");let vi=class{constructor(j){this.id=j}};vi=xe([N],vi),e.ThemeColor=vi;var ai;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let _t=class{get base(){return this.c}set base(j){this.c=j,this.e=k.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,fe){if(typeof j!="string"&&(!j||!k.URI.isUri(j)&&!k.URI.isUri(j.uri)))throw(0,A.illegalArgument)("base");if(typeof fe!="string")throw(0,A.illegalArgument)("pattern");typeof j=="string"?this.baseUri=k.URI.file(j):k.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=fe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};_t=xe([N],_t),e.RelativePattern=_t;const dt=new WeakMap;function Bi(G,j){dt.set(G,j)}e.setBreakpointId=Bi;let Ut=class{constructor(j,fe,Te,Ke){this.enabled=typeof j=="boolean"?j:!0,typeof fe=="string"&&(this.condition=fe),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=dt.get(this)??(0,O.generateUuid)()),this.c}};Ut=xe([N],Ut),e.Breakpoint=Ut;let Xt=class extends Ut{constructor(j,fe,Te,Ke,Je){if(super(fe,Te,Ke,Je),j===null)throw(0,A.illegalArgument)("location");this.location=j}};Xt=xe([N],Xt),e.SourceBreakpoint=Xt;let ci=class extends Ut{constructor(j,fe,Te,Ke,Je){super(fe,Te,Ke,Je),this.functionName=j}};ci=xe([N],ci),e.FunctionBreakpoint=ci;let wi=class extends Ut{constructor(j,fe,Te,Ke,Je,ct,ht){if(super(Ke,Je,ct,ht),!fe)throw(0,A.illegalArgument)("dataId");this.label=j,this.dataId=fe,this.canPersist=Te}};wi=xe([N],wi),e.DataBreakpoint=wi;let Ei=class{constructor(j,fe,Te){this.command=j,this.args=fe||[],this.options=Te}};Ei=xe([N],Ei),e.DebugAdapterExecutable=Ei;let li=class{constructor(j,fe){this.port=j,this.host=fe}};li=xe([N],li),e.DebugAdapterServer=li;let Si=class{constructor(j){this.path=j}};Si=xe([N],Si),e.DebugAdapterNamedPipeServer=Si;let ui=class{constructor(j){this.implementation=j}};ui=xe([N],ui),e.DebugAdapterInlineImplementation=ui;let Zt=class{constructor(j,fe){this.range=j,this.expression=fe}};Zt=xe([N],Zt),e.EvaluatableExpression=Zt;var $i;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})($i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ti=class{constructor(j,fe){this.range=j,this.text=fe}};ti=xe([N],ti),e.InlineValueText=ti;let ii=class{constructor(j,fe,Te=!0){this.range=j,this.variableName=fe,this.caseSensitiveLookup=Te}};ii=xe([N],ii),e.InlineValueVariableLookup=ii;let yi=class{constructor(j,fe){this.range=j,this.expression=fe}};yi=xe([N],yi),e.InlineValueEvaluatableExpression=yi;let Di=class{constructor(j,fe){this.frameId=j,this.stoppedLocation=fe}};Di=xe([N],Di),e.InlineValueContext=Di;var ni;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(ni=e.FileChangeType||(e.FileChangeType={}));let Ci=V=class extends Error{static FileExists(j){return new V(j,T.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(j){return new V(j,T.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(j){return new V(j,T.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(j){return new V(j,T.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(j){return new V(j,T.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(j){return new V(j,T.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}constructor(j,fe=T.FileSystemProviderErrorCode.Unknown,Te){super(k.URI.isUri(j)?j.toString(!0):j),this.code=Te?.name??"Unknown",(0,T.markAsFileSystemProviderError)(this,fe),Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Ci=V=xe([N],Ci),e.FileSystemError=Ci;let Ii=class{constructor(j,fe,Te){this.start=j,this.end=fe,this.kind=Te}};Ii=xe([N],Ii),e.FoldingRange=Ii;var zi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(j,fe=[]){this.tokenTypes=j,this.tokenModifiers=fe}}e.SemanticTokensLegend=Ri;function Li(G){return typeof G>"u"||(0,S.isStringArray)(G)}class $e{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,j){this.l=!0;for(let fe=0,Te=j.tokenTypes.length;fe<Te;fe++)this.j.set(j.tokenTypes[fe],fe);for(let fe=0,Te=j.tokenModifiers.length;fe<Te;fe++)this.k.set(j.tokenModifiers[fe],fe)}}push(j,fe,Te,Ke,Je){if(typeof j=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof Je=="number"||typeof Je>"u"))return typeof Je>"u"&&(Je=0),this.n(j,fe,Te,Ke,Je);if(ee.isRange(j)&&typeof fe=="string"&&Li(Te))return this.m(j,fe,Te);throw(0,A.illegalArgument)()}m(j,fe,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(fe))throw new Error("`tokenType` is not in the provided legend");const Ke=j.start.line,Je=j.start.character,ct=j.end.character-j.start.character,ht=this.j.get(fe);let Mt=0;if(Te)for(const Ht of Te){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Ht);Mt|=1<<qt>>>0}this.n(Ke,Je,ct,ht,Mt)}n(j,fe,Te,Ke,Je){if(this.f&&(j<this.c||j===this.c&&fe<this.e)){this.f=!1;const Mt=this.g.length/5|0;let Ht=0,qt=0;for(let Kt=0;Kt<Mt;Kt++){let Qt=this.g[5*Kt],Pi=this.g[5*Kt+1];Qt===0?(Qt=Ht,Pi+=qt):Qt+=Ht,this.g[5*Kt]=Qt,this.g[5*Kt+1]=Pi,Ht=Qt,qt=Pi}}let ct=j,ht=fe;this.f&&this.h>0&&(ct-=this.c,ct===0&&(ht-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=ht,this.g[this.h++]=Te,this.g[this.h++]=Ke,this.g[this.h++]=Je,this.c=j,this.e=fe}static o(j){const fe=[],Te=j.length/5|0;for(let ht=0;ht<Te;ht++)fe[ht]=ht;fe.sort((ht,Mt)=>{const Ht=j[5*ht],qt=j[5*Mt];if(Ht===qt){const Kt=j[5*ht+1],Qt=j[5*Mt+1];return Kt-Qt}return Ht-qt});const Ke=new Uint32Array(j.length);let Je=0,ct=0;for(let ht=0;ht<Te;ht++){const Mt=5*fe[ht],Ht=j[Mt+0],qt=j[Mt+1],Kt=j[Mt+2],Qt=j[Mt+3],Pi=j[Mt+4],sn=Ht-Je,Rn=sn===0?qt-ct:qt,Ai=5*ht;Ke[Ai+0]=sn,Ke[Ai+1]=Rn,Ke[Ai+2]=Kt,Ke[Ai+3]=Qt,Ke[Ai+4]=Pi,Je=Ht,ct=qt}return Ke}build(j){return this.f?new Wt(new Uint32Array(this.g),j):new Wt($e.o(this.g),j)}}e.SemanticTokensBuilder=$e;class Wt{constructor(j,fe){this.resultId=fe,this.data=j}}e.SemanticTokens=Wt;class Oi{constructor(j,fe,Te){this.start=j,this.deleteCount=fe,this.data=Te}}e.SemanticTokensEdit=Oi;class vt{constructor(j,fe){this.resultId=fe,this.edits=j}}e.SemanticTokensEdits=vt;var ji;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(ji=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new zt("arrow-left")},di=xe([N],di),e.QuickInputButtons=di;var Ni;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Vi;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Vi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(j){if(typeof j.badge=="string"){let fe=(0,P.nextCharLength)(j.badge,0);if(fe<j.badge.length&&(fe+=(0,P.nextCharLength)(j.badge,fe)),j.badge.length>fe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!zt.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,fe,Te){this.badge=j,this.tooltip=fe,this.color=Te}}e.FileDecoration=qi;let Ti=class{constructor(j){this.kind=j}};Ti=xe([N],Ti),e.ColorTheme=Ti;var xi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(xi=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{static isNotebookRange(j){return j instanceof Vt?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,fe){if(j<0)throw(0,A.illegalArgument)("start must be positive");if(fe<0)throw(0,A.illegalArgument)("end must be positive");j<=fe?(this.c=j,this.e=fe):(this.c=fe,this.e=j)}with(j){let fe=this.c,Te=this.e;return j.start!==void 0&&(fe=j.start),j.end!==void 0&&(Te=j.end),fe===this.c&&Te===this.e?this:new Vt(fe,Te)}}e.NotebookRange=Vt;class fi{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(fe=>fi.isNotebookCellData(fe))}static isNotebookCellData(j){return!0}constructor(j,fe,Te,Ke,Je,ct,ht){this.kind=j,this.value=fe,this.languageId=Te,this.mime=Ke,this.outputs=Je??[],this.metadata=ct,this.executionSummary=ht,fi.validate(this)}}e.NotebookCellData=fi;class Gi{constructor(j){this.cells=j}}e.NotebookData=Gi;class $t{static isNotebookCellOutputItem(j){return j instanceof $t?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const fe={name:j.name,message:j.message,stack:j.stack};return $t.json(fe,"application/vnd.code.notebook.error")}static stdout(j){return $t.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return $t.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,fe="application/octet-stream"){return new $t(j,fe)}static text(j,fe=I.Mimes.text){const Te=Ue($t,g,"f",b).encode(String(j));return new $t(Te,fe)}static json(j,fe="text/x-json"){const Te=JSON.stringify(j,void 0,"	");return $t.text(Te,fe)}constructor(j,fe){this.data=j,this.mime=fe;const Te=(0,I.normalizeMimeType)(fe,!0);if(!Te)throw new Error(`INVALID mime type: ${fe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}g=$t,b={value:new TextEncoder},e.NotebookCellOutputItem=$t;class mi{static isNotebookCellOutput(j){return j instanceof mi?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,fe=!1){const Te=new Set,Ke=new Set;for(let Je=0;Je<j.length;Je++){const ct=j[Je],ht=(0,I.normalizeMimeType)(ct.mime);if(!Te.has(ht)||(0,C.isTextStreamMime)(ht)){Te.add(ht);continue}Ke.add(Je),fe&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?j:j.filter((Je,ct)=>!Ke.has(ct))}constructor(j,fe,Te){this.items=mi.ensureUniqueMimeTypes(j,!0),typeof fe=="string"?(this.id=fe,this.metadata=Te):(this.id=(0,O.generateUuid)(),this.metadata=fe??Te)}}e.NotebookCellOutput=mi;var Ki;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Ki=e.NotebookCellKind||(e.NotebookCellKind={}));var Xi;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(Xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ge;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(ge=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ee;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Ee=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Me{constructor(j,fe){this.text=j,this.alignment=fe}}e.NotebookCellStatusBarItem=Me;var ot;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(ot=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var It;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(It=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Ot{constructor(j,fe=[]){this.uri=j,this.provides=(0,o.asArray)(fe)}}e.NotebookRendererScript=Ot;class ln{constructor(j){this.label=j}}e.NotebookKernelSourceAction=ln;let Qi=class{constructor(j,fe){this.label=j,this.timestamp=fe}};Qi=xe([N],Qi),e.TimelineItem=Qi;var un;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(un=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(j,fe){this.ranges=j,this.wordPattern=fe}}e.LinkedEditingRanges=fn;class mn{constructor(j,fe){this.c=j,this.e=fe}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Fi=class{constructor(j=void 0,fe=void 0,Te=void 0){this.include=j,this.exclude=fe,this.profile=Te}};Fi=xe([N],Fi),e.TestRunRequest=Fi;let Yi=class extends Fi{constructor(j=void 0,fe=void 0,Te=void 0,Ke=!1){super(j,fe,Te),this.continuous=Ke}};Yi=xe([N],Yi),e.TestRunRequest2=Yi;let Ji=M=class{static diff(j,fe,Te){const Ke=new M(j);return Ke.expectedOutput=fe,Ke.actualOutput=Te,Ke}constructor(j){this.message=j}};Ji=M=xe([N],Ji),e.TestMessage=Ji;let _i=class{constructor(j){this.id=j}};_i=xe([N],_i),e.TestTag=_i;let gi=class{constructor(j,fe){this.covered=j,this.total=fe}};gi=xe([N],gi),e.CoveredCount=gi;let Zi=B=class{static fromDetails(j,fe){const Te=new gi(0,0),Ke=new gi(0,0),Je=new gi(0,0);for(const ht of fe)if("branches"in ht){Te.total+=1,Te.covered+=ht.executionCount>0?1:0;for(const Mt of ht.branches)Ke.total+=1,Ke.covered+=Mt.executionCount>0?1:0}else Je.total+=1,Je.covered+=ht.executionCount>0?1:0;const ct=new B(j,Te,Ke.total>0?Ke:void 0,Je.total>0?Je:void 0);return ct.detailedCoverage=fe,ct}constructor(j,fe,Te,Ke){this.uri=j,this.statementCoverage=fe,this.branchCoverage=Te,this.functionCoverage=Ke}};Zi=B=xe([N],Zi),e.FileCoverage=Zi;let en=class{constructor(j,fe,Te=[]){this.executionCount=j,this.location=fe,this.branches=Te}};en=xe([N],en),e.StatementCoverage=en;let tn=class{constructor(j,fe){this.executionCount=j,this.location=fe}};tn=xe([N],tn),e.BranchCoverage=tn;let nn=class{constructor(j,fe){this.executionCount=j,this.location=fe}};nn=xe([N],nn),e.FunctionCoverage=nn;var bn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(bn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var vn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var wn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(wn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class En{constructor(j,fe,Te,Ke,Je,ct){this.kind=j,this.name=fe,this.detail=Te,this.uri=Ke,this.range=Je,this.selectionRange=ct}}e.TypeHierarchyItem=En;class Sn{constructor(j){this.uri=j}}e.TextTabInput=Sn;class yn{constructor(j,fe){this.original=j,this.modified=fe}}e.TextDiffTabInput=yn;class Dn{constructor(j,fe,Te,Ke){this.base=j,this.input1=fe,this.input2=Te,this.result=Ke}}e.TextMergeTabInput=Dn;class Cn{constructor(j,fe){this.uri=j,this.viewType=fe}}e.CustomEditorTabInput=Cn;class In{constructor(j){this.viewType=j}}e.WebviewEditorTabInput=In;class kn{constructor(j,fe){this.uri=j,this.notebookType=fe}}e.NotebookEditorTabInput=kn;class Tn{constructor(j,fe,Te){this.original=j,this.modified=fe,this.notebookType=Te}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(j,fe){this.uri=j,this.inputBoxUri=fe}}e.InteractiveWindowInput=An}),define(ye[135],De([1,0,50,16,8,165,106,7,15]),function(ne,e,o,A,a,R,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function O(y,f){f?k.set(y,f):k.delete(y)}e.setWordDefinitionFor=O;function T(y){return k.get(y)}class v extends R.MirrorTextModel{constructor(f,h,u,g,b,D,p,n){super(h,u,g,b),this.m=f,this.p=D,this.q=p,this.notebook=n,this.b=!1}dispose(){(0,o.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,S.equals)(this.d,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.c},get fileName(){return f.c.fsPath},get isUntitled(){return f.c.scheme===A.Schemas.untitled},get languageId(){return f.p},get version(){return f.g},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(h){return h?f.s(h):f.getText()},get eol(){return f.f===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return f.d.length},lineAt(h){return f.t(h)},offsetAt(h){return f.u(h)},positionAt(h){return f.v(h)},validateRange(h){return f.w(h)},validatePosition(h){return f.x(h)},getWordRangeAtPosition(h,u){return f.y(h,u)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,o.ok)(!this.b),this.p=f}_acceptIsDirty(f){(0,o.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(f){const h=this.w(f);if(h.isEmpty)return"";if(h.isSingleLine)return this.d[h.start.line].substring(h.start.character,h.end.character);const u=this.f,g=h.start.line,b=h.end.line,D=[];D.push(this.d[g].substring(h.start.character));for(let p=g+1;p<b;p++)D.push(this.d[p]);return D.push(this.d[b].substring(0,h.end.character)),D.join(u)}t(f){let h;if(f instanceof P.Position?h=f.line:typeof f=="number"&&(h=f),typeof h!="number"||h<0||h>=this.d.length||Math.floor(h)!==h)throw new Error("Illegal value for `line`");return new C(h,this.d[h],h===this.d.length-1)}u(f){return f=this.x(f),this.k(),this.h.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.k();const h=this.h.getIndexOf(f),u=this.d[h.index].length;return new P.Position(h.index,Math.min(h.remainder,u))}w(f){if(!(f instanceof P.Range))throw new Error("Invalid argument");const h=this.x(f.start),u=this.x(f.end);return h===f.start&&u===f.end?f:new P.Range(h.line,h.character,u.line,u.character)}x(f){if(!(f instanceof P.Position))throw new Error("Invalid argument");if(this.d.length===0)return f.with(0,0);let{line:h,character:u}=f,g=!1;if(h<0)h=0,u=0,g=!0;else if(h>=this.d.length)h=this.d.length-1,u=this.d[h].length,g=!0;else{const b=this.d[h].length;u<0?(u=0,g=!0):u>b&&(u=b,g=!0)}return g?new P.Position(h,u):f}y(f,h){const u=this.x(f);if(!h)h=T(this.p);else if((0,a.regExpLeadsToEndlessLoop)(h))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${h.source}' because it matches the empty string.`);const g=(0,I.getWordAtText)(u.character+1,(0,I.ensureValidWordDefinition)(h),this.d[u.line],0);if(g)return new P.Range(u.line,g.startColumn-1,u.line,g.endColumn-1)}}e.ExtHostDocumentData=v;class C{constructor(f,h,u){this.a=f,this.b=h,this.c=u}get lineNumber(){return this.a}get text(){return this.b}get range(){return new P.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new P.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=C}),define(ye[239],De([1,0,7,20,3]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(P){this.a=new o.ColorTheme(o.ColorThemeKind.Dark),this.b=new a.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(P){let S;switch(P){case"light":S=o.ColorThemeKind.Light;break;case"hcDark":S=o.ColorThemeKind.HighContrast;break;case"hcLight":S=o.ColorThemeKind.HighContrastLight;break;default:S=o.ColorThemeKind.Dark}this.a=new o.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=xe([ze(0,A.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(ye[14],De([1,0,15,22,149,63,112,28,147,69,87,23,9,2,32,71,124,132,130,93,57,75,235,7]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u,g,b,D,p,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Ae){function Oe(re){const{selectionStartLineNumber:Fe,selectionStartColumn:We,positionLineNumber:Ye,positionColumn:Ve}=re,et=new s.Position(Fe-1,We-1),ut=new s.Position(Ye-1,Ve-1);return new s.Selection(et,ut)}Ae.to=Oe;function Se(re){const{anchor:Fe,active:We}=re;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Ae.from=Se})(r=e.Selection||(e.Selection={}));var c;(function(Ae){function Oe(re){if(!re)return;const{start:Fe,end:We}=re;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Ae.from=Oe;function Se(re){if(!re)return;const{startLineNumber:Fe,startColumn:We,endLineNumber:Ye,endColumn:Ve}=re;return new s.Range(Fe-1,We-1,Ye-1,Ve-1)}Ae.to=Se})(c=e.Range||(e.Range={}));var l;(function(Ae){function Oe(Se){switch(Se){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ae.to=Oe})(l=e.TokenType||(e.TokenType={}));var m;(function(Ae){function Oe(re){return new s.Position(re.lineNumber-1,re.column-1)}Ae.to=Oe;function Se(re){return{lineNumber:re.line+1,column:re.character+1}}Ae.from=Se})(m=e.Position||(e.Position={}));var i;(function(Ae){function Oe(Fe,We){return(0,o.coalesce)((0,o.asArray)(Fe).map(Ye=>Se(Ye,We)))}Ae.from=Oe;function Se(Fe,We){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:re(Fe.scheme,We),pattern:he.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function re(Fe,We){return We&&typeof Fe=="string"?We.transformOutgoingScheme(Fe):Fe}})(i=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(Ae){function Oe(re){switch(re){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ae.from=Oe;function Se(re){switch(re){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ae.to=Se})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var d;(function(Ae){function Oe(re){let Fe;return re.code&&((0,v.isString)(re.code)||(0,v.isNumber)(re.code)?Fe=String(re.code):Fe={value:String(re.code.value),target:re.code.target}),{...c.from(re.range),message:re.message,source:re.source,code:Fe,severity:w.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(E.from),tags:Array.isArray(re.tags)?(0,o.coalesce)(re.tags.map(t.from)):void 0}}Ae.from=Oe;function Se(re){const Fe=new s.Diagnostic(c.to(re),re.message,w.to(re.severity));return Fe.source=re.source,Fe.code=(0,v.isString)(re.code)?re.code:re.code?.value,Fe.relatedInformation=re.relatedInformation&&re.relatedInformation.map(E.to),Fe.tags=re.tags&&(0,o.coalesce)(re.tags.map(t.to)),Fe}Ae.to=Se})(d=e.Diagnostic||(e.Diagnostic={}));var E;(function(Ae){function Oe(re){return{...c.from(re.location.range),message:re.message,resource:re.location.uri}}Ae.from=Oe;function Se(re){return new s.DiagnosticRelatedInformation(new s.Location(re.resource,c.to(re)),re.message)}Ae.to=Se})(E=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var w;(function(Ae){function Oe(re){switch(re){case s.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}Ae.from=Oe;function Se(re){switch(re){case h.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ae.to=Se})(w=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var L;(function(Ae){function Oe(re){return typeof re=="number"&&re>=s.ViewColumn.One?re-1:re===s.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}Ae.from=Oe;function Se(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=Se})(L=e.ViewColumn||(e.ViewColumn={}));function q(Ae){return typeof Ae.range<"u"}function V(Ae){return Ae.length===0?!0:!!q(Ae[0])}e.isDecorationOptionsArr=V;var M;(function(Ae){function Oe(Ve){return Ve.map(Ae.from)}Ae.fromMany=Oe;function Se(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function re(Ve){let et;if(Se(Ve)){const{language:Dt,value:wt}=Ve;et={value:"```"+Dt+`
`+wt+"\n```\n"}}else s.MarkdownString.isMarkdownString(Ve)?et={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?et={value:Ve}:et={value:""};const ut=Object.create(null);et.uris=ut;const Pt=Dt=>{try{let wt=C.URI.parse(Dt,!0);wt=wt.with({query:Fe(wt.query,ut)}),ut[Dt]=wt}catch{}return""},St=new S.marked.Renderer;return St.link=Pt,St.image=Dt=>typeof Dt=="string"?Pt(I.parseHrefAndDimensions(Dt).href):"",(0,S.marked)(et.value,{renderer:St}),et}Ae.from=re;function Fe(Ve,et){if(!Ve)return Ve;let ut;try{ut=(0,k.parse)(Ve)}catch{}if(!ut)return Ve;let Pt=!1;return ut=(0,T.cloneAndChange)(ut,St=>{if(C.URI.isUri(St)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[Dt]=St,Pt=!0,Dt}else return}),Pt?JSON.stringify(ut):Ve}function We(Ve){const et=new s.MarkdownString(Ve.value,Ve.supportThemeIcons);return et.isTrusted=Ve.isTrusted,et.supportHtml=Ve.supportHtml,et.baseUri=Ve.baseUri?C.URI.from(Ve.baseUri):void 0,et}Ae.to=We;function Ye(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Ae.from(Ve)}Ae.fromStrict=Ye})(M=e.MarkdownString||(e.MarkdownString={}));function B(Ae){return V(Ae)?Ae.map(Oe=>({range:c.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?M.fromMany(Oe.hoverMessage):Oe.hoverMessage?M.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ae.map(Oe=>({range:c.from(Oe)}))}e.fromRangeOrRangeWithMessage=B;function N(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?C.URI.file(Ae):Ae}e.pathOrURIToURI=N;var U;(function(Ae){function Oe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?N(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Ae.from=Oe})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var $;(function(Ae){function Oe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?N(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Ae.from=Oe})($=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var z;(function(Ae){function Oe(Se){if(typeof Se>"u")return Se;switch(Se){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Oe})(z=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var ae;(function(Ae){function Oe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?z.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?$.from(Se.light):void 0,dark:Se.dark?$.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?N(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Ae.from=Oe})(ae=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ee;(function(Ae){function Oe(re){return{text:re.newText,eol:re.newEol&&rt.from(re.newEol),range:c.from(re.range)}}Ae.from=Oe;function Se(re){const Fe=new s.TextEdit(c.to(re.range),re.text);return Fe.newEol=typeof re.eol>"u"?void 0:rt.to(re.eol),Fe}Ae.to=Se})(ee=e.TextEdit||(e.TextEdit={}));var x;(function(Ae){function Oe(re,Fe){const We={edits:[]};if(re instanceof s.WorkspaceEdit){const Ye=new P.ResourceSet;for(const Ve of re._allEntries())Ve._type===1&&C.URI.isUri(Ve.to)&&Ve.from===void 0&&Ye.add(Ve.to);for(const Ve of re._allEntries())Ve._type===1?We.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contentsBase64:Ve.options?.contents&&(0,A.encodeBase64)(A.VSBuffer.wrap(Ve.options.contents))},metadata:Ve.metadata}):Ve._type===2?We.edits.push({resource:Ve.uri,textEdit:ee.from(Ve.edit),versionId:Ye.has(Ve.uri)?void 0:Fe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?We.edits.push({resource:Ve.uri,textEdit:{range:c.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ve.uri)?void 0:Fe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?We.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&We.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(at.from)}})}return We}Ae.from=Oe;function Se(re){const Fe=new s.WorkspaceEdit;for(const We of re.edits)We.textEdit?Fe.replace(C.URI.revive(We.resource),c.to(We.textEdit.range),We.textEdit.text):Fe.renameFile(C.URI.revive(We.oldResource),C.URI.revive(We.newResource),We.options);return Fe}Ae.to=Se})(x=e.WorkspaceEdit||(e.WorkspaceEdit={}));var J;(function(Ae){const Oe=Object.create(null);Oe[s.SymbolKind.File]=0,Oe[s.SymbolKind.Module]=1,Oe[s.SymbolKind.Namespace]=2,Oe[s.SymbolKind.Package]=3,Oe[s.SymbolKind.Class]=4,Oe[s.SymbolKind.Method]=5,Oe[s.SymbolKind.Property]=6,Oe[s.SymbolKind.Field]=7,Oe[s.SymbolKind.Constructor]=8,Oe[s.SymbolKind.Enum]=9,Oe[s.SymbolKind.Interface]=10,Oe[s.SymbolKind.Function]=11,Oe[s.SymbolKind.Variable]=12,Oe[s.SymbolKind.Constant]=13,Oe[s.SymbolKind.String]=14,Oe[s.SymbolKind.Number]=15,Oe[s.SymbolKind.Boolean]=16,Oe[s.SymbolKind.Array]=17,Oe[s.SymbolKind.Object]=18,Oe[s.SymbolKind.Key]=19,Oe[s.SymbolKind.Null]=20,Oe[s.SymbolKind.EnumMember]=21,Oe[s.SymbolKind.Struct]=22,Oe[s.SymbolKind.Event]=23,Oe[s.SymbolKind.Operator]=24,Oe[s.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Ae.from=Se;function re(Fe){for(const We in Oe)if(Oe[We]===Fe)return Number(We);return s.SymbolKind.Property}Ae.to=re})(J=e.SymbolKind||(e.SymbolKind={}));var ie;(function(Ae){function Oe(re){switch(re){case s.SymbolTag.Deprecated:return 1}}Ae.from=Oe;function Se(re){switch(re){case 1:return s.SymbolTag.Deprecated}}Ae.to=Se})(ie=e.SymbolTag||(e.SymbolTag={}));var pe;(function(Ae){function Oe(re){return{name:re.name,kind:J.from(re.kind),tags:re.tags&&re.tags.map(ie.from),containerName:re.containerName,location:ve.from(re.location)}}Ae.from=Oe;function Se(re){const Fe=new s.SymbolInformation(re.name,J.to(re.kind),re.containerName,ve.to(re.location));return Fe.tags=re.tags&&re.tags.map(ie.to),Fe}Ae.to=Se})(pe=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(Ae){function Oe(re){const Fe={name:re.name||"!!MISSING: name!!",detail:re.detail,range:c.from(re.range),selectionRange:c.from(re.selectionRange),kind:J.from(re.kind),tags:re.tags?.map(ie.from)??[]};return re.children&&(Fe.children=re.children.map(Oe)),Fe}Ae.from=Oe;function Se(re){const Fe=new s.DocumentSymbol(re.name,re.detail,J.to(re.kind),c.to(re.range),c.to(re.selectionRange));return(0,o.isNonEmptyArray)(re.tags)&&(Fe.tags=re.tags.map(ie.to)),re.children&&(Fe.children=re.children.map(Se)),Fe}Ae.to=Se})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var Y;(function(Ae){function Oe(re){const Fe=new s.CallHierarchyItem(J.to(re.kind),re.name,re.detail||"",C.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Fe._sessionId=re._sessionId,Fe._itemId=re._itemId,Fe}Ae.to=Oe;function Se(re,Fe,We){if(Fe=Fe??re._sessionId,We=We??re._itemId,Fe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:We,name:re.name,detail:re.detail,kind:J.from(re.kind),uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(ie.from)}}Ae.from=Se})(Y=e.CallHierarchyItem||(e.CallHierarchyItem={}));var Z;(function(Ae){function Oe(Se){return new s.CallHierarchyIncomingCall(Y.to(Se.from),Se.fromRanges.map(re=>c.to(re)))}Ae.to=Oe})(Z=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var me;(function(Ae){function Oe(Se){return new s.CallHierarchyOutgoingCall(Y.to(Se.to),Se.fromRanges.map(re=>c.to(re)))}Ae.to=Oe})(me=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(Ae){function Oe(re){return{range:re.range&&c.from(re.range),uri:re.uri}}Ae.from=Oe;function Se(re){return new s.Location(C.URI.revive(re.uri),c.to(re.range))}Ae.to=Se})(ve=e.location||(e.location={}));var Ie;(function(Ae){function Oe(re){const Fe=re,We=re;return{originSelectionRange:Fe.originSelectionRange?c.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:We.uri,range:c.from(Fe.targetRange?Fe.targetRange:We.range),targetSelectionRange:Fe.targetSelectionRange?c.from(Fe.targetSelectionRange):void 0}}Ae.from=Oe;function Se(re){return{targetUri:C.URI.revive(re.uri),targetRange:c.to(re.range),targetSelectionRange:re.targetSelectionRange?c.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?c.to(re.originSelectionRange):void 0}}Ae.to=Se})(Ie=e.DefinitionLink||(e.DefinitionLink={}));var Re;(function(Ae){function Oe(re){return{range:c.from(re.range),contents:M.fromMany(re.contents)}}Ae.from=Oe;function Se(re){return new s.Hover(re.contents.map(M.to),c.to(re.range))}Ae.to=Se})(Re=e.Hover||(e.Hover={}));var oe;(function(Ae){function Oe(re){return{range:c.from(re.range),expression:re.expression}}Ae.from=Oe;function Se(re){return new s.EvaluatableExpression(c.to(re.range),re.expression)}Ae.to=Se})(oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(Ae){function Oe(re){if(re instanceof s.InlineValueText)return{type:"text",range:c.from(re.range),text:re.text};if(re instanceof s.InlineValueVariableLookup)return{type:"variable",range:c.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Oe;function Se(re){switch(re.type){case"text":return{range:c.to(re.range),text:re.text};case"variable":return{range:c.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:c.to(re.range),expression:re.expression}}}Ae.to=Se})(le=e.InlineValue||(e.InlineValue={}));var ue;(function(Ae){function Oe(re){return{frameId:re.frameId,stoppedLocation:c.from(re.stoppedLocation)}}Ae.from=Oe;function Se(re){return new s.InlineValueContext(re.frameId,c.to(re.stoppedLocation))}Ae.to=Se})(ue=e.InlineValueContext||(e.InlineValueContext={}));var te;(function(Ae){function Oe(re){return{range:c.from(re.range),kind:re.kind}}Ae.from=Oe;function Se(re){return new s.DocumentHighlight(c.to(re.range),re.kind)}Ae.to=Se})(te=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(Ae){function Oe(Se){switch(Se){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ae.to=Oe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var se;(function(Ae){function Oe(Se){return{triggerKind:ce.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Ae.to=Oe})(se=e.CompletionContext||(e.CompletionContext={}));var F;(function(Ae){function Oe(re){switch(re){case s.CompletionItemTag.Deprecated:return 1}}Ae.from=Oe;function Se(re){switch(re){case 1:return s.CompletionItemTag.Deprecated}}Ae.to=Se})(F=e.CompletionItemTag||(e.CompletionItemTag={}));var H;(function(Ae){const Oe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Se(We){return Oe.get(We)??9}Ae.from=Se;const re=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Fe(We){return re.get(We)??s.CompletionItemKind.Property}Ae.to=Fe})(H=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(Ae){function Oe(Se,re){const Fe=new s.CompletionItem(Se.label);return Fe.insertText=Se.insertText,Fe.kind=H.to(Se.kind),Fe.tags=Se.tags?.map(F.to),Fe.detail=Se.detail,Fe.documentation=I.isMarkdownString(Se.documentation)?M.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,y.Range.isIRange(Se.range)?Fe.range=c.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:c.to(Se.range.insert),replacing:c.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new s.SnippetString(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof s.Range?new s.TextEdit(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(We=>ee.to(We))),Fe.command=re&&Se.command?re.fromInternal(Se.command):void 0,Fe}Ae.to=Oe})(K=e.CompletionItem||(e.CompletionItem={}));var _;(function(Ae){function Oe(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:M.fromStrict(re.documentation)}}Ae.from=Oe;function Se(re){return{label:re.label,documentation:I.isMarkdownString(re.documentation)?M.to(re.documentation):re.documentation}}Ae.to=Se})(_=e.ParameterInformation||(e.ParameterInformation={}));var de;(function(Ae){function Oe(re){return{label:re.label,documentation:M.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(_.from):[],activeParameter:re.activeParameter}}Ae.from=Oe;function Se(re){return{label:re.label,documentation:I.isMarkdownString(re.documentation)?M.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(_.to):[],activeParameter:re.activeParameter}}Ae.to=Se})(de=e.SignatureInformation||(e.SignatureInformation={}));var we;(function(Ae){function Oe(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(de.from):[]}}Ae.from=Oe;function Se(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(de.to):[]}}Ae.to=Se})(we=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(Ae){function Oe(Se,re){const Fe=new s.InlayHint(m.to(re.position),typeof re.label=="string"?re.label:re.label.map(be.to.bind(void 0,Se)),re.kind&&Ce.to(re.kind));return Fe.textEdits=re.textEdits&&re.textEdits.map(ee.to),Fe.tooltip=I.isMarkdownString(re.tooltip)?M.to(re.tooltip):re.tooltip,Fe.paddingLeft=re.paddingLeft,Fe.paddingRight=re.paddingRight,Fe}Ae.to=Oe})(Pe=e.InlayHint||(e.InlayHint={}));var be;(function(Ae){function Oe(Se,re){const Fe=new s.InlayHintLabelPart(re.label);return Fe.tooltip=I.isMarkdownString(re.tooltip)?M.to(re.tooltip):re.tooltip,f.Command.is(re.command)&&(Fe.command=Se.fromInternal(re.command)),re.location&&(Fe.location=ve.to(re.location)),Fe}Ae.to=Oe})(be=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ce;(function(Ae){function Oe(re){return re}Ae.from=Oe;function Se(re){return re}Ae.to=Se})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Ae){function Oe(re){return{range:c.from(re.range),url:re.target,tooltip:re.tooltip}}Ae.from=Oe;function Se(re){let Fe;if(re.url)try{Fe=typeof re.url=="string"?C.URI.parse(re.url,!0):C.URI.revive(re.url)}catch{}return new s.DocumentLink(c.to(re.range),Fe)}Ae.to=Se})(ke=e.DocumentLink||(e.DocumentLink={}));var He;(function(Ae){function Oe(re){const Fe=new s.ColorPresentation(re.label);return re.textEdit&&(Fe.textEdit=ee.to(re.textEdit)),re.additionalTextEdits&&(Fe.additionalTextEdits=re.additionalTextEdits.map(We=>ee.to(We))),Fe}Ae.to=Oe;function Se(re){return{label:re.label,textEdit:re.textEdit?ee.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Fe=>ee.from(Fe)):void 0}}Ae.from=Se})(He=e.ColorPresentation||(e.ColorPresentation={}));var Ge;(function(Ae){function Oe(re){return new s.Color(re[0],re[1],re[2],re[3])}Ae.to=Oe;function Se(re){return[re.red,re.green,re.blue,re.alpha]}Ae.from=Se})(Ge=e.Color||(e.Color={}));var nt;(function(Ae){function Oe(re){return{range:c.from(re.range)}}Ae.from=Oe;function Se(re){return new s.SelectionRange(c.to(re.range))}Ae.to=Se})(nt=e.SelectionRange||(e.SelectionRange={}));var Qe;(function(Ae){function Oe(Se){switch(Se){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ae.to=Oe})(Qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(Ae){function Oe(re){switch(re){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Oe;function Se(re){switch(re){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ae.to=Se})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var rt;(function(Ae){function Oe(re){if(re===s.EndOfLine.CRLF)return 1;if(re===s.EndOfLine.LF)return 0}Ae.from=Oe;function Se(re){if(re===1)return s.EndOfLine.CRLF;if(re===0)return s.EndOfLine.LF}Ae.to=Se})(rt=e.EndOfLine||(e.EndOfLine={}));var Be;(function(Ae){function Oe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Oe})(Be=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(Ae){function Oe(re){const Fe={start:re.start+1,end:re.end+1};return re.kind&&(Fe.kind=W.from(re.kind)),Fe}Ae.from=Oe;function Se(re){const Fe={start:re.start-1,end:re.end-1};return re.kind&&(Fe.kind=W.to(re.kind)),Fe}Ae.to=Se})(it=e.FoldingRange||(e.FoldingRange={}));var W;(function(Ae){function Oe(re){if(re)switch(re){case s.FoldingRangeKind.Comment:return f.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return f.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return f.FoldingRangeKind.Region}}Ae.from=Oe;function Se(re){if(re)switch(re.value){case f.FoldingRangeKind.Comment.value:return s.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports.value:return s.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region.value:return s.FoldingRangeKind.Region}}Ae.to=Se})(W=e.FoldingRangeKind||(e.FoldingRangeKind={}));var X;(function(Ae){function Oe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?c.from(Se.selection):void 0,override:typeof Se.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Oe})(X=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var he;(function(Ae){function Oe(We){return We instanceof s.RelativePattern?We.toJSON():typeof We=="string"?We:Se(We)||re(We)?new s.RelativePattern(We.baseUri??We.base,We.pattern).toJSON():We}Ae.from=Oe;function Se(We){const Ye=We;return Ye?C.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function re(We){const Ye=We;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Fe(We){return typeof We=="string"?We:new s.RelativePattern(C.URI.revive(We.baseUri),We.pattern)}Ae.to=Fe})(he=e.GlobPattern||(e.GlobPattern={}));var Le;(function(Ae){function Oe(Se){if(Se){if(Array.isArray(Se))return Se.map(Oe);if(typeof Se=="string")return Se;{const re=Se;return{language:re.language,scheme:re.scheme,pattern:he.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Ae.from=Oe})(Le=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(Ae){function Oe(re){return{start:re.start,end:re.end}}Ae.from=Oe;function Se(re){return new s.NotebookRange(re.start,re.end)}Ae.to=Se})(Ne=e.NotebookRange||(e.NotebookRange={}));var qe;(function(Ae){function Oe(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Ae.to=Oe;function Se(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Ae.from=Se})(qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(Ae){function Oe(Se){if(Se===b.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Se===b.NotebookCellExecutionState.Pending)return;if(Se===b.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Ae.to=Oe})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ze;(function(Ae){function Oe(re){switch(re){case s.NotebookCellKind.Markup:return b.CellKind.Markup;case s.NotebookCellKind.Code:default:return b.CellKind.Code}}Ae.from=Oe;function Se(re){switch(re){case b.CellKind.Markup:return s.NotebookCellKind.Markup;case b.CellKind.Code:default:return s.NotebookCellKind.Code}}Ae.to=Se})(Ze=e.NotebookCellKind||(e.NotebookCellKind={}));var st;(function(Ae){function Oe(re){const Fe={metadata:re.metadata??Object.create(null),cells:[]};for(const We of re.cells)s.NotebookCellData.validate(We),Fe.cells.push(at.from(We));return Fe}Ae.from=Oe;function Se(re){const Fe=new s.NotebookData(re.cells.map(at.to));return(0,v.isEmptyObject)(re.metadata)||(Fe.metadata=re.metadata),Fe}Ae.to=Se})(st=e.NotebookData||(e.NotebookData={}));var at;(function(Ae){function Oe(re){return{cellKind:Ze.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:qe.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(gt.from):[]}}Ae.from=Oe;function Se(re){return new s.NotebookCellData(Ze.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(gt.to):void 0,re.metadata,re.internalMetadata?qe.to(re.internalMetadata):void 0)}Ae.to=Se})(at=e.NotebookCellData||(e.NotebookCellData={}));var mt;(function(Ae){function Oe(re){return{mime:re.mime,valueBytes:A.VSBuffer.wrap(re.data)}}Ae.from=Oe;function Se(re){return new s.NotebookCellOutputItem(re.valueBytes.buffer,re.mime)}Ae.to=Se})(mt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var gt;(function(Ae){function Oe(re){return{outputId:re.id,items:re.items.map(mt.from),metadata:re.metadata}}Ae.from=Oe;function Se(re){const Fe=re.items.map(mt.to);return new s.NotebookCellOutput(Fe,re.outputId,re.metadata)}Ae.to=Se})(gt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Et;(function(Ae){function Oe(Fe){return re(Fe)?{include:(0,v.withNullAsUndefined)(he.from(Fe.include)),exclude:(0,v.withNullAsUndefined)(he.from(Fe.exclude))}:(0,v.withNullAsUndefined)(he.from(Fe))}Ae.from=Oe;function Se(Fe){return re(Fe)?{include:he.to(Fe.include),exclude:he.to(Fe.exclude)}:he.to(Fe)}Ae.to=Se;function re(Fe){const We=Fe;return We?!(0,v.isUndefinedOrNull)(We.include)&&!(0,v.isUndefinedOrNull)(We.exclude):!1}})(Et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var lt;(function(Ae){function Oe(Se,re,Fe){const We=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal(We,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Ae.from=Oe})(lt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var pt;(function(Ae){function Oe(Se,re,Fe){const We=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:re.toInternal(We,Fe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Ae.from=Oe})(pt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var xt;(function(Ae){function Oe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Ae.from=Oe})(xt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var jt;(function(Ae){function Oe(re){return{uri:re.uri,provides:re.provides}}Ae.from=Oe;function Se(re){return new s.NotebookRendererScript(C.URI.revive(re.uri),re.provides)}Ae.to=Se})(jt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var kt;(function(Ae){function Oe(re){return{message:M.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,location:re.location&&{range:c.from(re.location.range),uri:re.location.uri}}}Ae.from=Oe;function Se(re){const Fe=new s.TestMessage(typeof re.message=="string"?re.message:M.to(re.message));return Fe.actualOutput=re.actual,Fe.expectedOutput=re.expected,Fe.location=re.location?ve.to(re.location):void 0,Fe}Ae.to=Se})(kt=e.TestMessage||(e.TestMessage={}));var ft;(function(Ae){Ae.namespace=p.namespaceTestTag,Ae.denamespace=p.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var Tt;(function(Ae){function Oe(re){const Fe=(0,u.getPrivateApiFor)(re).controllerId;return{extId:D.TestId.fromExtHostTestItem(re,Fe).toString(),label:re.label,uri:C.URI.revive(re.uri),busy:re.busy,tags:re.tags.map(We=>ft.namespace(Fe,We.id)),range:y.Range.lift(c.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&M.fromStrict(re.error)||null}}Ae.from=Oe;function Se(re){return{parent:void 0,error:void 0,id:D.TestId.fromString(re.extId).localId,label:re.label,uri:C.URI.revive(re.uri),tags:(re.tags||[]).map(Fe=>{const{tagId:We}=ft.denamespace(Fe);return new s.TestTag(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Ae.toPlain=Se})(Tt=e.TestItem||(e.TestItem={})),function(Ae){function Oe(re){return{id:re.id}}Ae.from=Oe;function Se(re){return new s.TestTag(re.id)}Ae.to=Se}(ft=e.TestTag||(e.TestTag={}));var Bt;(function(Ae){const Oe=(re,Fe)=>{const We=[];for(const[Ve,et]of Fe)D.TestId.compare(et.item.extId,Ve)===2&&(Fe.delete(Ve),We.push(et));const Ye={...Tt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(et=>et.type===0).map(kt.to)})),children:We.map(Ve=>Oe(Ve,Fe))};for(const Ve of Ye.children)Ve.parent=Ye;return Ye};function Se(re){const Fe=[],We=new Map;for(const Ye of re.items){We.set(Ye.item.extId,Ye);const Ve=D.TestId.root(Ye.item.extId);re.request.targets.some(et=>et.controllerId===Ve&&et.testIds.includes(Ye.item.extId))&&Fe.push(Ye)}return{completedAt:re.completedAt,results:Fe.map(Ye=>Oe(Ye,We))}}Ae.to=Se})(Bt=e.TestResults||(e.TestResults={}));var At;(function(Ae){function Oe(We){return{covered:We.covered,total:We.covered}}function Se(We){return"line"in We?m.from(We):c.from(We)}function re(We){return"branches"in We?{count:We.executionCount,location:Se(We.location),type:1,branches:We.branches.length?We.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&Se(Ye.location)})):void 0}:{type:0,count:We.executionCount,location:Se(We.location)}}Ae.fromDetailed=re;function Fe(We){return{uri:We.uri,statement:Oe(We.statementCoverage),branch:We.branchCoverage&&Oe(We.branchCoverage),function:We.functionCoverage&&Oe(We.functionCoverage),details:We.detailedCoverage?.map(re)}}Ae.fromFile=Fe})(At=e.TestCoverage||(e.TestCoverage={}));var Xe;(function(Ae){function Oe(Se){switch(Se){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ae.to=Oe})(Xe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Nt;(function(Ae){function Oe(re){const Fe=new s.TypeHierarchyItem(J.to(re.kind),re.name,re.detail||"",C.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Fe._sessionId=re._sessionId,Fe._itemId=re._itemId,Fe}Ae.to=Oe;function Se(re,Fe,We){if(Fe=Fe??re._sessionId,We=We??re._itemId,Fe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:We,kind:J.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(ie.from)}}Ae.from=Se})(Nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Gt;(function(Ae){function Oe(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Ae.from=Oe})(Gt=e.ViewBadge||(e.ViewBadge={}));var Ft;(function(Ae){function Oe(We,Ye,Ve){const et=Ye.fileData;return et?new class extends s.DataTransferItem{asFile(){return{name:et.name,uri:C.URI.revive(et.uri),data:(0,R.once)(()=>Ve())}}}("",Ye.id):We===O.Mimes.uriList&&Ye.uriListData?new s.DataTransferItem(Fe(Ye.uriListData)):new s.DataTransferItem(Ye.asString)}Ae.to=Oe;async function Se(We,Ye){const Ve=await Ye.asString();if(We===O.Mimes.uriList)return{id:Ye.id,asString:Ve,fileData:void 0,uriListData:re(Ve)};const et=Ye.asFile();return{id:Ye.id,asString:Ve,fileData:et?{name:et.name,uri:et.uri}:void 0}}Ae.from=Se;function re(We){return a.UriList.split(We).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return C.URI.parse(Ye)}catch{}return Ye})}function Fe(We){return a.UriList.create(We.map(Ye=>typeof Ye=="string"?Ye:C.URI.revive(Ye)))}})(Ft=e.DataTransferItem||(e.DataTransferItem={}));var bt;(function(Ae){function Oe(re,Fe){const We=re.items.map(([Ye,Ve])=>[Ye,Ft.to(Ye,Ve,()=>Fe(Ve.id))]);return new s.DataTransfer(We)}Ae.toDataTransfer=Oe;async function Se(re){const Fe={items:[]},We=[];return re.forEach((Ye,Ve)=>{We.push((async()=>{Fe.items.push([Ve,await Ft.from(Ve,Ye)])})())}),await Promise.all(We),Fe}Ae.toDataTransferDTO=Se})(bt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[240],De([1,0,2,12,7,14,66]),function(ne,e,o,A,a,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(k,O,T,v={timeout:1500,errors:3}){this.c=k,this.d=O,this.f=T,this.g=v,this.a=new I.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(O,T,v)=>{const y={dispose:this.a.push([O,T,k])};return Array.isArray(v)&&v.push(y),y}}async $participateInSave(k,O){const T=o.URI.revive(k);let v=!1;const C=setTimeout(()=>v=!0,this.g.timeout),y=[];try{for(const f of[...this.a]){if(v)break;const h=this.d.getDocument(T),u=await this.h(f,{document:h,reason:R.TextDocumentSaveReason.to(O)});y.push(u)}}finally{clearTimeout(C)}return y}h([k,O,T],v){const C=this.b.get(k);return typeof C=="number"&&C>this.g.errors?Promise.resolve(!1):this.i(T,k,O,v).then(()=>!0,y=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' threw ERROR`),this.c.error(y),!(y instanceof Error)||y.message!=="concurrent_edits"){const f=this.b.get(k);this.b.set(k,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,O,T,v){const C=[],y=Date.now(),{document:f,reason:h}=v,{version:u}=f,g=Object.freeze({document:f,reason:h,waitUntil(b){if(Object.isFrozen(C))throw(0,A.illegalState)("waitUntil can not be called async");C.push(Promise.resolve(b))}});try{O.apply(T,[g])}catch(b){return Promise.reject(b)}return Object.freeze(C),new Promise((b,D)=>{const p=setTimeout(()=>D(new Error("timeout")),this.g.timeout);return Promise.all(C).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-y}ms`),clearTimeout(p),b(n)}).catch(n=>{clearTimeout(p),D(n)})}).then(b=>{const D={edits:[]};for(const p of b)if(Array.isArray(p)&&p.every(n=>n instanceof a.TextEdit))for(const{newText:n,newEol:s,range:r}of p)D.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:r&&R.Range.from(r),text:n,eol:s&&R.EndOfLine.from(s)}});if(D.edits.length!==0)return u===f.version?this.f.$tryApplyWorkspaceEdit(D):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ye[241],De([1,0,16,2,14,7,93]),function(ne,e,o,A,a,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(T,v,C,y){this.start=T,this.deletedCount=v,this.deletedItems=C,this.items=y}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(T=>T.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(T,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:T}}constructor(T,v,C){this.notebook=T,this.h=v,this.j=C,this.handle=C.handle,this.uri=A.URI.revive(C.uri),this.cellKind=C.cellKind,this.a=C.outputs.map(a.NotebookCellOutput.to),this.e=C.internalMetadata??{},this.b=Object.freeze(C.metadata??{}),this.d=Object.freeze(a.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const T=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return T.notebook.getCellIndex(T)},notebook:T.notebook.apiNotebook,kind:a.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return T.g},set mime(y){T.g=y},get outputs(){return T.a.slice(0)},get metadata(){return T.b},get executionSummary(){return T.d}};this.f=Object.freeze(C)}return this.f}setOutputs(T){this.a=T.map(a.NotebookCellOutput.to)}setOutputItems(T,v,C){const y=C.map(a.NotebookCellOutputItem.to),f=this.a.find(h=>h.id===T);if(f&&(v||(f.items.length=0),f.items.push(...y),f.items.length>1&&f.items.every(h=>I.isTextStreamMime(h.mime)))){const h=new Map,u=[];f.items.forEach(g=>{let b;h.has(g.mime)?b=h.get(g.mime):(b=[],h.set(g.mime,b),u.push(g.mime)),b.push(g.data)}),f.items.length=0,u.forEach(g=>{const b=I.compressOutputItemStreams(h.get(g));f.items.push({mime:g,data:b.buffer})})}}setMetadata(T){this.b=Object.freeze(T)}setInternalMetadata(T){this.e=T,this.d=Object.freeze(a.NotebookCellExecutionSummary.to(T))}setMime(T){}}e.ExtHostCell=S;class k{constructor(T,v,C,y,f){this.k=T,this.l=v,this.m=C,this.uri=y,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const T=this,v={get uri(){return T.uri},get version(){return T.g},get notebookType(){return T.d},get isDirty(){return T.h},get isUntitled(){return T.uri.scheme===o.Schemas.untitled},get isClosed(){return T.j},get metadata(){return T.f},get cellCount(){return T.b.length},cellAt(C){return C=T.n(C),T.b[C].apiCell},getCells(C){return(C?T.p(C):T.b).map(f=>f.apiCell)},save(){return T.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(T){T.metadata&&(this.f=Object.freeze({...this.f,...T.metadata}))}acceptDirty(T){this.h=T}acceptModelChanged(T,v,C){this.g=T.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:C});const y={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},f=[];for(const u of T.rawEvents)u.kind===I.NotebookCellsChangeType.ModelChange?this.r(u.changes,!1,y.contentChanges):u.kind===I.NotebookCellsChangeType.Move?this.s(u.index,u.length,u.newIdx,y.contentChanges):u.kind===I.NotebookCellsChangeType.Output?(this.t(u.index,u.outputs),f.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===I.NotebookCellsChangeType.OutputItem?(this.u(u.index,u.outputId,u.append,u.outputItems),f.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===I.NotebookCellsChangeType.ChangeCellLanguage?(this.v(u.index,u.language),f.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document})):u.kind===I.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document}):u.kind===I.NotebookCellsChangeType.ChangeCellMime?this.w(u.index,u.mime):u.kind===I.NotebookCellsChangeType.ChangeCellMetadata?(this.x(u.index,u.metadata),f.push({cell:this.b[u.index].apiCell,metadata:this.b[u.index].apiCell.metadata})):u.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(u.index,u.internalMetadata),f.push({cell:this.b[u.index].apiCell,executionSummary:this.b[u.index].apiCell.executionSummary}));const h=new Map;for(let u=0;u<f.length;u++){const g=f[u],b=h.get(g.cell);if(b===void 0){const D=y.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});h.set(g.cell,D-1)}else y.cellChanges[b]={...y.cellChanges[b],...g}}return Object.freeze(y),Object.freeze(y.cellChanges),Object.freeze(y.contentChanges),y}n(T){return T=T|0,T<0?0:T>=this.b.length?this.b.length-1:T}o(T){let v=T.start|0,C=T.end|0;return v<0&&(v=0),C>this.b.length&&(C=this.b.length),T.with({start:v,end:C})}p(T){T=this.o(T);const v=[];for(let C=T.start;C<T.end;C++)v.push(this.b[C]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(T,v,C){if(this.j)return;const y=[],f=[],h=[];if(T.reverse().forEach(u=>{const b=u[2].map(n=>{const s=new S(this,this.l,n);return v||f.push(S.asModelAddData(this.apiNotebook,n)),s}),D=new P(u[0],u[1],[],b),p=this.b.splice(u[0],u[1],...b);for(const n of p)h.push(n.uri),D.deletedItems.push(n.apiCell);y.push(D)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:h}),C)for(const u of y)C.push(u.asApiEvent())}s(T,v,C,y){const f=this.b.splice(T,v);this.b.splice(C,0,...f);const h=[new P(T,v,f.map(u=>u.apiCell),[]),new P(C,0,[],f)];for(const u of h)y.push(u.asApiEvent())}t(T,v){this.b[T].setOutputs(v)}u(T,v,C,y){this.b[T].setOutputItems(v,C,y)}v(T,v){const C=this.b[T];C.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(C.uri,v)}w(T,v){const C=this.b[T];C.apiCell.mime=v}x(T,v){this.b[T].setMetadata(v)}y(T,v){this.b[T].setInternalMetadata(v)}getCellFromApiCell(T){return this.b.find(v=>v.apiCell===T)}getCellFromIndex(T){return this.b[T]}getCell(T){return this.b.find(v=>v.handle===T)}getCellIndex(T){return this.b.indexOf(T)}}k.a=0,e.ExtHostNotebookDocument=k}),define(ye[136],De([1,0,12,14,7]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(P,S,k,O,T,v){this.id=P,this.f=S,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=T,this.b=O,this.c=v}get apiEditor(){if(!this.e){const P=this;this.e={get notebook(){return P.notebookData.apiNotebook},get selection(){return P.a[0]},set selection(S){this.selections=[S]},get selections(){return P.a},set selections(S){if(!Array.isArray(S)||!S.every(a.NotebookRange.isNotebookRange))throw(0,o.illegalArgument)("selections");P.a=S,P.g(S)},get visibleRanges(){return P.b},revealRange(S,k){P.f.$tryRevealRange(P.id,A.NotebookRange.from(S),k??a.NotebookEditorRevealType.Default)},get viewColumn(){return P.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(P){this.d=P}_acceptVisibleRanges(P){this.b=P}_acceptSelections(P){this.a=P}g(P){this.f.$trySetSelections(this.id,P.map(A.NotebookRange.from))}_acceptViewColumn(P){this.c=P}}R.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=R}),define(ye[242],De([1,0,3,13,14]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(P,S){this.c=P,this.d=S,this.a=new o.Emitter,this.b=new o.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(P,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,S);const k=this.d.getEditorById(P);S.visibleRanges&&k._acceptVisibleRanges(S.visibleRanges.ranges.map(a.NotebookRange.to)),S.selections&&k._acceptSelections(S.selections.selections.map(a.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const S in P)this.d.getEditorById(S)._acceptViewColumn(a.ViewColumn.to(P[S]))}};R=xe([ze(0,A.ILogService)],R),e.ExtHostNotebookEditors=R}),define(ye[243],De([1,0,14,126,179,21,62,12]),function(ne,e,o,A,a,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,C,y){const f=this.b++,{title:h,location:u,cancellable:g}=C,b={label:(0,a.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(f,{location:o.ProgressLocation.from(u),title:h,source:b,cancellable:g},v.isUnderDevelopment?void 0:v.identifier.value).catch(P.onUnexpectedExternalError),this.d(f,y,!!g)}d(v,C,y){let f;y&&(f=new R.CancellationTokenSource,this.c.set(v,f));const h=g=>{this.a.$progressEnd(g),this.c.delete(g),f?.dispose()};let u;try{u=C(new O(this.a,v),y&&f?f.token:R.CancellationToken.None)}catch(g){throw h(v),g}return u.then(g=>h(v),g=>h(v)),u}$acceptProgressCanceled(v){const C=this.c.get(v);C&&(C.cancel(),this.c.delete(v))}}e.ExtHostProgress=S;function k(T,v){return T.message=v.message,typeof v.increment=="number"&&(typeof T.increment=="number"?T.increment+=v.increment:T.increment=v.increment),T}class O extends A.Progress{constructor(v,C){super(y=>this.throttledReport(y)),this.c=v,this.d=C}throttledReport(v){this.c.$progressReport(this.d,v)}}xe([(0,I.throttle)(100,(T,v)=>k(T,v),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(ye[137],De([1,0,32,132,57,94,75,14,2]),function(ne,e,o,A,a,R,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(b,D,p,n)=>{let s=D;return{enumerable:!0,configurable:!1,get(){return s},set(r){if(!p(s,r)){const c=s;s=r,b.listener?.(n(r,c))}}}},O=(b,D)=>b===D,T={range:(b,D)=>b===D?!0:!b||!D?!1:b.isEqual(D),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(b,D)=>!(b.length!==D.length||b.some(p=>!D.find(n=>p.id===n.id)))},v=b=>D=>({op:4,update:b(D)}),C=(b,D)=>({range:(()=>{let p;const n=v(s=>({range:o.Range.lift(P.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return p},set(s){b.listener?.({op:6}),T.range(p,s)||(p=s,b.listener?.(n(s)))}}})(),label:k(b,D,T.label,v(p=>({label:p}))),description:k(b,void 0,T.description,v(p=>({description:p}))),sortText:k(b,void 0,T.sortText,v(p=>({sortText:p}))),canResolveChildren:k(b,!1,T.canResolveChildren,p=>({op:2,state:p})),busy:k(b,!1,T.busy,v(p=>({busy:p}))),error:k(b,void 0,T.error,v(p=>({error:P.MarkdownString.fromStrict(p)||null}))),tags:k(b,[],T.tags,(p,n)=>({op:1,new:p.map(P.TestTag.from),old:n.map(P.TestTag.from)}))}),y=b=>{const D=a.TestId.fromString(b.extId),p=new h(D.controllerId,D.localId,b.label,S.URI.revive(b.uri)||void 0);return p.range=P.Range.to(b.range||void 0),p.description=b.description||void 0,p.sortText=b.sortText||void 0,p.tags=b.tags.map(n=>P.TestTag.to({id:(0,I.denamespaceTestTag)(n).tagId})),p},f=b=>{let D;for(const p of b.tests){const n=y(p.item);(0,A.getPrivateApiFor)(n).parent=D,D=n}return D};e.toItemFromContext=f;class h{constructor(D,p,n,s){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const r=(0,A.createPrivateApiFor)(this,D);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof u?void 0:r.parent}},children:{value:(0,R.createTestItemChildren)(r,A.getPrivateApiFor,h),enumerable:!0,writable:!1},...C(r,n)})}}e.TestItemImpl=h;class u extends h{constructor(D,p){super(D,D,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=u;class g extends R.TestItemCollection{constructor(D,p,n){super({controllerId:D,getDocumentVersion:s=>s&&n.getDocument(s)?.version,getApiFor:A.getPrivateApiFor,getChildren:s=>s.children,root:new u(D,p),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(ye[138],De([1,0,50,12,101,14,7]),function(ne,e,o,A,a,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class P{constructor(v,C,y){const f=P.c.nextId();v.$registerTextEditorDecorationType(C.identifier,f,R.DecorationRenderOptions.from(y)),this.value=Object.freeze({key:f,dispose(){v.$removeTextEditorDecorationType(f)}})}}P.c=new a.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=P;class S{constructor(v,C){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=C.undoStopBefore,this.f=C.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,C){this.k();let y=null;if(v instanceof I.Position)y=new I.Range(v,v);else if(v instanceof I.Range)y=v;else throw new Error("Unrecognized location");this.l(y,C,!1)}insert(v,C){this.k(),this.l(new I.Range(v,v),C,!0)}delete(v){this.k();let C=null;if(v instanceof I.Range)C=v;else throw new Error("Unrecognized location");this.l(C,null,!0)}l(v,C,y){const f=this.c.validateRange(v);this.g.push({range:f,text:C,forceMoveMarkers:y})}setEndOfLine(v){if(this.k(),v!==I.EndOfLine.LF&&v!==I.EndOfLine.CRLF)throw(0,A.illegalArgument)("endOfLine");this.h=v}}class k{constructor(v,C,y,f){this.c=v,this.d=C,this._accept(y),this.e=f;const h=this;this.value={get tabSize(){return h.f},set tabSize(u){h.m(u)},get indentSize(){return h.g},set indentSize(u){h.o(u)},get insertSpaces(){return h.h},set insertSpaces(u){h.q(u)},get cursorStyle(){return h.j},set cursorStyle(u){h.s(u)},get lineNumbers(){return h.k},set lineNumbers(u){h.t(u)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const C=Math.floor(v);return C>0?C:null}if(typeof v=="string"){const C=parseInt(v,10);return isNaN(C)?null:C>0?C:null}return null}m(v){const C=this.l(v);if(C!==null){if(typeof C=="number"){if(this.f===C)return;this.f=C}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:C}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const C=Math.floor(v);return C>0?C:null}if(typeof v=="string"){const C=parseInt(v,10);return isNaN(C)?null:C>0?C:null}return null}o(v){const C=this.n(v);if(C!==null){if(typeof C=="number"){if(this.g===C)return;this.g=C}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:C}))}}p(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}q(v){const C=this.p(v);if(typeof C=="boolean"){if(this.h===C)return;this.h=C}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:C}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(v)})))}assign(v){const C={};let y=!1;if(typeof v.tabSize<"u"){const f=this.l(v.tabSize);f==="auto"?(y=!0,C.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,y=!0,C.tabSize=f)}if(typeof v.indentSize<"u"){const f=this.n(v.indentSize);f==="tabSize"?(y=!0,C.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,y=!0,C.indentSize=f)}if(typeof v.insertSpaces<"u"){const f=this.p(v.insertSpaces);f==="auto"?(y=!0,C.insertSpaces=f):this.h!==f&&(this.h=f,y=!0,C.insertSpaces=f)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,y=!0,C.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,y=!0,C.lineNumbers=R.TextEditorLineNumbersStyle.from(v.lineNumbers)),y&&this.u("setOptions",this.c.$trySetOptions(this.d,C))}u(v,C){C.catch(y=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(y)})}}e.ExtHostTextEditorOptions=k;class O{constructor(v,C,y,f,h,u,g,b){this.id=v,this.j=C,this.k=y,this.g=!1,this.h=new Set,this.c=h,this.d=new k(this.j,this.id,u,y),this.e=g,this.f=b;const D=this;this.value=Object.freeze({get document(){return f.value},set document(p){throw(0,A.readonly)("document")},get selection(){return D.c&&D.c[0]},set selection(p){if(!(p instanceof I.Selection))throw(0,A.illegalArgument)("selection");D.c=[p],D.l()},get selections(){return D.c},set selections(p){if(!Array.isArray(p)||p.some(n=>!(n instanceof I.Selection)))throw(0,A.illegalArgument)("selections");D.c=p,D.l()},get visibleRanges(){return D.e},set visibleRanges(p){throw(0,A.readonly)("visibleRanges")},get options(){return D.d.value},set options(p){D.g||D.d.assign(p)},get viewColumn(){return D.f},set viewColumn(p){throw(0,A.readonly)("viewColumn")},edit(p,n={undoStopBefore:!0,undoStopAfter:!0}){if(D.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new S(f.value,n);return p(s),D.m(s)},insertSnippet(p,n,s={undoStopBefore:!0,undoStopAfter:!0}){if(D.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!n||Array.isArray(n)&&n.length===0)r=D.c.map(c=>R.Range.from(c));else if(n instanceof I.Position){const{lineNumber:c,column:l}=R.Position.from(n);r=[{startLineNumber:c,startColumn:l,endLineNumber:c,endColumn:l}]}else if(n instanceof I.Range)r=[R.Range.from(n)];else{r=[];for(const c of n)if(c instanceof I.Range)r.push(R.Range.from(c));else{const{lineNumber:l,column:m}=R.Position.from(c);r.push({startLineNumber:l,startColumn:m,endLineNumber:l,endColumn:m})}}return C.$tryInsertSnippet(v,f.value.version,p.value,r,s)},setDecorations(p,n){const s=n.length===0;s&&!D.h.has(p.key)||(s?D.h.delete(p.key):D.h.add(p.key),D.n(()=>{if(R.isDecorationOptionsArr(n))return C.$trySetDecorations(v,p.key,R.fromRangeOrRangeWithMessage(n));{const r=new Array(4*n.length);for(let c=0,l=n.length;c<l;c++){const m=n[c];r[4*c]=m.start.line+1,r[4*c+1]=m.start.character+1,r[4*c+2]=m.end.line+1,r[4*c+3]=m.end.character+1}return C.$trySetDecorationsFast(v,p.key,r)}}))},revealRange(p,n){D.n(()=>C.$tryRevealRange(v,R.Range.from(p),n||I.TextEditorRevealType.Default))},show(p){C.$tryShowEditor(v,R.ViewColumn.from(p))},hide(){C.$tryHideEditor(v)}})}dispose(){(0,o.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,o.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,o.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,o.ok)(!this.g),this.f=v}_acceptSelections(v){(0,o.ok)(!this.g),this.c=v}async l(){const v=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const C=v.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const y=C.edits.map(h=>h.range);y.sort((h,u)=>h.end.line===u.end.line?h.end.character===u.end.character?h.start.line===u.start.line?h.start.character-u.start.character:h.start.line-u.start.line:h.end.character-u.end.character:h.end.line-u.end.line);for(let h=0,u=y.length-1;h<u;h++){const g=y[h].end;if(y[h+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=C.edits.map(h=>({range:R.Range.from(h.range),text:h.text,forceMoveMarkers:h.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,C.documentVersionId,f,{setEndOfLine:typeof C.setEndOfLine=="number"?R.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this.k.warn(C),null))}}e.ExtHostTextEditor=O}),define(ye[244],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[245],De([1,0,195,12,37,123,92,39,27,244,208,197]),function(ne,e,o,A,a,R,I,P,S,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const v=P.Registry.as(I.Extensions.JSONContribution);class C{constructor(p,n,s){this.a=p,this.b=n,this.c=s}d(p,n){this.a({type:p,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(a.default.Error,p)}warn(p){this.d(a.default.Warning,p)}info(p){this.d(a.default.Info,p)}}e.ExtensionMessageCollector=C;class y{static a(p){const n=new Set;for(let s=0,r=p.length;s<r;s++)n.add(S.ExtensionIdentifier.toKey(p[s].description.identifier));return n}static compute(p,n){if(!p||!p.length)return new y(n,[]);if(!n||!n.length)return new y([],p);const s=this.a(p),r=this.a(n),c=n.filter(m=>!s.has(S.ExtensionIdentifier.toKey(m.description.identifier))),l=p.filter(m=>!r.has(S.ExtensionIdentifier.toKey(m.description.identifier)));return new y(c,l)}constructor(p,n){this.added=p,this.removed=n}}e.ExtensionPointUserDelta=y;class f{constructor(p,n){this.name=p,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=y.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,A.onUnexpectedError)(p)}}}e.ExtensionPoint=f;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[o.localize(0,null),o.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:o.localize(2,null),properties:{vscode:{type:"string",description:o.localize(3,null),default:"^1.22.0"}}},publisher:{description:o.localize(4,null),type:"string"},displayName:{description:o.localize(5,null),type:"string"},categories:{description:o.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:o.localize(7,null)}]}},galleryBanner:{type:"object",description:o.localize(8,null),properties:{color:{description:o.localize(9,null),type:"string"},theme:{description:o.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:o.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:o.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:o.localize(13,null)},enabledApiProposals:{markdownDescription:o.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:o.localize(15,null),type:"string",enum:["none"],enumDescriptions:[o.localize(16,null)]},activationEvents:{description:o.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:o.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:o.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:o.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:o.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:o.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:o.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:o.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:o.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:o.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:o.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:o.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:o.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:o.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:o.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:o.localize(32,null)},{label:"onUri",body:"onUri",description:o.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:o.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:o.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:o.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:o.localize(37,null)},{label:"onRenderer",description:o.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:o.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:o.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:o.localize(41,null)},{label:"*",description:o.localize(42,null),body:"*"}]}},badges:{type:"array",description:o.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:o.localize(44,null)},href:{type:"string",description:o.localize(45,null)},description:{type:"string",description:o.localize(46,null)}}}},markdown:{type:"string",description:o.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:o.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:o.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:o.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:o.localize(51,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:o.localize(52,null)},{body:["workspace"],description:o.localize(53,null)},{body:["ui","workspace"],description:o.localize(54,null)},{body:["workspace","ui"],description:o.localize(55,null)},{body:[],description:o.localize(56,null)}]},capabilities:{description:o.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:o.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:o.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(60,null),o.localize(61,null),o.localize(62,null)]},description:{type:"string",markdownDescription:o.localize(63,null)}}},untrustedWorkspaces:{description:o.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:o.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(66,null),o.localize(67,null),o.localize(68,null)]},restrictedConfigurations:{description:o.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:o.localize(70,null)}}}}},sponsor:{description:o.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:o.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:o.localize(73,null),type:"string"},"vscode:uninstall":{description:o.localize(74,null),type:"string"}}},icon:{type:"string",description:o.localize(75,null)},l10n:{type:"string",description:o.localize(76,null)}}};class g{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const n=new f(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,n),p.activationEventsGenerator&&T.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,v.registerSchema(u,e.schema),n}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=g;const b={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(b.ExtensionsRegistry,new g),e.ExtensionsRegistry=P.Registry.as(b.ExtensionsRegistry),v.registerSchema(u,e.schema),v.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:o.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(ye[246],De([1,0,192,9,23,245,54,3]),function(ne,e,o,A,a,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:o.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:o.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:o.localize(2,null),default:""}}};var k;(function(v){function C(y,f,h){if(!y)return;const u=A.isString(y.type)?y.type:void 0;if(!u||u.length===0){h.error(o.localize(3,null));return}const g=[];if(Array.isArray(y.required))for(const b of y.required)A.isString(b)&&g.push(b);return{extensionId:f.value,taskType:u,required:g,properties:y.properties?a.deepClone(y.properties):{},when:y.when?I.ContextKeyExpr.deserialize(y.when):void 0}}v.from=C})(k||(k={}));const O=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(v,C)=>{for(const y of v)y.type&&C.push(`onTaskType:${y.type}`)},jsonSchema:{description:o.localize(4,null),type:"array",items:S}});class T{constructor(){this.d=new P.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((C,y)=>{O.setHandler((f,h)=>{this.c=void 0;try{for(const u of h.removed){const g=u.value;for(const b of g)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const u of h.added){const g=u.value;for(const b of g){const D=k.from(b,u.description.identifier,u.collector);D&&(this.a[D.taskType]=D)}}(h.removed.length>0||h.added.length>0)&&this.d.fire()}catch{}C(void 0)})})}onReady(){return this.b}get(C){return this.a[C]}all(){return Object.keys(this.a).map(C=>this.a[C])}getJsonSchema(){if(this.c===void 0){const C=[];for(const y of this.all()){const f={type:"object",additionalProperties:!1};y.required.length>0&&(f.required=y.required.slice(0)),y.properties!==void 0?f.properties=a.deepClone(y.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[y.taskType]},C.push(f)}this.c={oneOf:C}}return this.c}}e.TaskDefinitionRegistry=new T}),define(ye[247],De([1,0,193,9,24,23,54,246]),function(ne,e,o,A,a,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new I.RawContextKey("taskRunning",!1,o.localize(0,null)),e.TASKS_CATEGORY={value:o.localize(1,null),original:"Tasks"};var S;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function U($){if(!$)return N.Strong;switch($.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=U}(S=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var O;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(N){function U($){switch($.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=U}(O=e.RevealKind||(e.RevealKind={}));var T;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(T=e.RevealProblemKind||(e.RevealProblemKind={})),function(N){function U($){switch($.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=U}(T=e.RevealProblemKind||(e.RevealProblemKind={}));var v;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(v=e.PanelKind||(e.PanelKind={})),function(N){function U($){switch($.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=U}(v=e.PanelKind||(e.PanelKind={}));var C;(function(N){N.defaults={echo:!0,reveal:O.Always,revealProblems:T.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(C=e.PresentationOptions||(e.PresentationOptions={}));var y;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(y=e.RuntimeType||(e.RuntimeType={})),function(N){function U(z){switch(z.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=U;function $(z){switch(z){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=$}(y=e.RuntimeType||(e.RuntimeType={}));var f;(function(N){function U($){return A.isString($)?$:$.value}N.value=U})(f=e.CommandString||(e.CommandString={}));var h;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function U(z){return z===N.Clean._id||z===N.Build._id||z===N.Rebuild._id||z===N.Test._id}N.is=U;function $(z){if(z!==void 0)return A.isString(z)?U(z)?{_id:z,isDefault:!1}:void 0:z}N.from=$})(h=e.TaskGroup||(e.TaskGroup={}));var u;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(u=e.TaskScope||(e.TaskScope={}));var g;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function U($){switch($){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=U})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(N){N.parallel="parallel",N.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var D;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(D=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:D.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class n{constructor(U,$,z,ae,ee,x){this._label="",this._id=U,$&&(this._label=$),z&&(this.type=z),this.runOptions=ae,this.configurationProperties=ee,this._source=x}getDefinition(U){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,$=!1){if(U===void 0)return!1;if(A.isString(U))return U===this._label||U===this.configurationProperties.identifier||$&&U===this._id;const z=this.getDefinition(!0);return z!==void 0&&z._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.CommonTask=n;class s extends n{constructor(U,$,z,ae,ee,x,J,ie){super(U,z,void 0,J,ie,$),this.command={},this._source=$,this.hasDefinedMatchers=x,ee&&(this.command=ee)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let $;switch(this.command?this.command.runtime:void 0){case y.Shell:$="shell";break;case y.Process:$="process";break;case y.CustomExecution:$="customExecution";break;case void 0:$="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:$,_key:this._id,id:this._id}}}static is(U){return U instanceof s}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let $=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&($+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:$};return JSON.stringify(z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?a.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new s(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.CustomTask=s;class r extends n{constructor(U,$,z,ae,ee,x,J){super(U,z,ae,x,J,$),this._source=$,this.configures=ee}static is(U){return U instanceof r}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?a.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let $=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&($+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:$};return JSON.stringify(z)}}e.ConfiguringTask=r;class c extends n{constructor(U,$,z,ae,ee,x,J,ie,pe){super(U,z,ae,ie,pe,$),this.defines=ee,this.hasDefinedMatchers=J,this.command=x,this.icon=pe.icon,this.hide=pe.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof c}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new c(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.ContributedTask=c;class l extends n{constructor(U,$,z,ae,ee,x){super(U,z,ae,ee,x,$),this._source=$}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new l(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.InMemoryTask=l;var m;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(m=e.ExecutionEngine||(e.ExecutionEngine={})),function(N){N._default=N.Terminal}(m=e.ExecutionEngine||(e.ExecutionEngine={}));var i;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(i=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class t{constructor(U){this.c=new Map;for(let $=0;$<U.length;$++)this.c.set(U[$].uri.toString(),$)}compare(U,$){const z=U.getWorkspaceFolder(),ae=$.getWorkspaceFolder();if(z&&ae){let ee=this.c.get(z.uri.toString());ee=ee===void 0?0:ee+1;let x=this.c.get(ae.uri.toString());return x=x===void 0?0:x+1,ee===x?U._label.localeCompare($._label):ee-x}else return!z&&ae?-1:z&&!ae?1:0}}e.TaskSorter=t;var d;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(d=e.TaskEventKind||(e.TaskEventKind={}));var E;(function(N){N.SingleRun="singleRun",N.Background="background"})(E=e.TaskRunType||(e.TaskRunType={}));var w;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(w=e.TaskRunSource||(e.TaskRunSource={}));var L;(function(N){function U($,z,ae,ee){if(z){const x={kind:$,taskId:z._id,taskName:z.configurationProperties.name,runType:z.configurationProperties.isBackground?"background":"singleRun",group:z.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:ae,__task:z};return $==="start"?x.resolvedVariables=ee:$==="processStarted"?x.processId=ee:$==="processEnded"&&(x.exitCode=ee),Object.freeze(x)}else return Object.freeze({kind:"changed"})}N.create=U})(L=e.TaskEvent||(e.TaskEvent={}));var q;(function(N){function U(z){const ae=Object.keys(z).sort();let ee="";for(const x of ae){let J=z[x];J instanceof Object?J=U(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),ee+=x+","+J+","}return ee}function $(z){const ee={_key:U(z),type:z.taskType};return Object.assign(ee,z),ee}N.create=$})(q=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var V;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(V=e.TaskSettingId||(e.TaskSettingId={}));var M;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(M=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(N){function U($,z){const ae=P.TaskDefinitionRegistry.get($.type);if(ae===void 0){const ie=R.deepClone($);return delete ie._key,q.create(ie)}const ee=Object.create(null);ee.type=ae.taskType;const x=new Set;ae.required.forEach(ie=>x.add(ie));const J=ae.properties;for(const ie of Object.keys(J)){const pe=$[ie];if(pe!=null)ee[ie]=pe;else if(x.has(ie)){const Q=J[ie];if(Q.default!==void 0)ee[ie]=R.deepClone(Q.default);else switch(Q.type){case"boolean":ee[ie]=!1;break;case"number":case"integer":ee[ie]=0;break;case"string":ee[ie]="";break;default:z.error(o.localize(2,null,JSON.stringify($,void 0,0),ie));return}}}return q.create(ee)}N.createTaskIdentifier=U})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[248],De([1,0,12]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class A{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((I,P)=>{this.b=I,this.d=P,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(I){this.f||this.h||(this.f=!0,this.g=I,this.a&&this.b(I))}resolveErr(I){this.f||this.h||(this.h=!0,this.i=I,this.a?this.d(I):(0,o.onUnexpectedError)(I))}then(I,P){return this.j().then(I,P)}catch(I){return this.j().then(void 0,I)}finally(I){return this.j().finally(I)}}e.LazyPromise=A;class a extends A{constructor(){super(),this.h=!0,this.i=new o.CancellationError}}e.CanceledLazyPromise=a}),define(ye[58],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class o{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++o.count}}o.count=0,e.ProxyIdentifier=o;const A=[];function a(P){const S=new o(P);return A[S.nid]=S,S}e.createProxyIdentifier=a;function R(P){return A[P].sid}e.getStringIdentifierForProxy=R;class I{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=I}),define(ye[5],De([1,0,58]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var a;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(a=e.TabInputKind||(e.TabInputKind={}));var R;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var I;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class T{static mixin(h){return h._id=T.a++,h}}T.a=0,e.IdObject=T;var v;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var C;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(C=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var y;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,o.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,o.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,o.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,o.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,o.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,o.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,o.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,o.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,o.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,o.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,o.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,o.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,o.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,o.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,o.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,o.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,o.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,o.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,o.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,o.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,o.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,o.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,o.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,o.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,o.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,o.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,o.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,o.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,o.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,o.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,o.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,o.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,o.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,o.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,o.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,o.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,o.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,o.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,o.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,o.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,o.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,o.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,o.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,o.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,o.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,o.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,o.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,o.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,o.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,o.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,o.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,o.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,o.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,o.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,o.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,o.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,o.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,o.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,o.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,o.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,o.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,o.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,o.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,o.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,o.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,o.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,o.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,o.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,o.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,o.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,o.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,o.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,o.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,o.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,o.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,o.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,o.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,o.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,o.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,o.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,o.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,o.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,o.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,o.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,o.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,o.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,o.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,o.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,o.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,o.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,o.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,o.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,o.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,o.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,o.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,o.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,o.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,o.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,o.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,o.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,o.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,o.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,o.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,o.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,o.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,o.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,o.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,o.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,o.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,o.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,o.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,o.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,o.createProxyIdentifier)("ExtHostLocalization")}}),define(ye[77],De([1,0,4,13,5,20]),function(ne,e,o,A,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,o.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(S,k){this.c=k,this.a=new Set,this.b=S.getProxy(a.MainContext.MainThreadTelemetry)}report(S,k,O){const T=this.d(S,k);this.a.has(T)||(this.a.add(T),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:S}))}d(S,k){return`${S}-${k.identifier.value}`}};I=xe([ze(0,R.IExtHostRpcService),ze(1,A.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(P,S,k){}})}),define(ye[249],De([1,0,3,5,7,27]),function(ne,e,o,A,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(S){this.b=new Map,this.c=[],this.d=new o.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(A.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,k,O,T={}){const v=R.ExtensionIdentifier.toKey(S.identifier),C=this.f.get(v)||[],y=[...O].sort().join(" ");let f=C.find(h=>h.providerId===k&&h.scopes===y);if(f)return f.result;{const h=this.g(S,v,k,O,T);f={providerId:k,scopes:y,result:h},C.push(f),this.f.set(v,C);try{await h}finally{const u=C.findIndex(g=>g.providerId===k&&g.scopes===y);u>-1&&(C.splice(u),this.f.set(v,C))}return h}}async g(S,k,O,T,v={}){await this.a.$ensureProvider(O);const C=S.displayName||S.name;return this.a.$getSession(O,T,k,C,v)}async removeSession(S,k){const O=this.b.get(S);return O?O.provider.removeSession(k):this.a.$removeSession(S,k)}registerAuthenticationProvider(S,k,O,T){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:k,provider:O,options:T??{supportsMultipleAccounts:!1}}),this.c.find(C=>C.id===S)||this.c.push({id:S,label:k});const v=O.onDidChangeSessions(C=>{this.a.$sendDidChangeSessions(S,{added:C.added??[],changed:C.changed??[],removed:C.removed??[]})});return this.a.$registerAuthenticationProvider(S,k,T?.supportsMultipleAccounts??!1),new a.Disposable(()=>{v.dispose(),this.b.delete(S);const C=this.c.findIndex(y=>y.id===S);C>-1&&this.c.splice(C),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,k){const O=this.b.get(S);if(O)return Promise.resolve(O.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,k){const O=this.b.get(S);if(O)return Promise.resolve(O.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,k){const O=this.b.get(S);if(O)return Promise.resolve(O.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,k){return this.d.fire({provider:{id:S,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(ye[250],De([1,0,5,20,14]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(P,S){this.a=P.getProxy(o.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>S.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P,S,k){const O=a.WorkspaceEdit.from(P,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,k?.isRefactoring??!1)}};R=xe([ze(0,A.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(ye[251],De([1,0,5]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class A{constructor(R){const I=R.getProxy(o.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(P){return I.$writeText(P)}})}}e.ExtHostClipboard=A});var _e=this&&this.__classPrivateFieldSet||function(ne,e,o,A,a){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!a:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?a.call(ne,o):a?a.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[40],De([1,0,9,7,14,23,5,15,13,69,32,52,2,6,4,20,137,22,58,45,43,73,76]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u,g,b,D,p,n){"use strict";var s,r,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let l=class{constructor(w,L,q){s.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),c.set(this,void 0),_e(this,s,w.getProxy(I.MainContext.MainThreadCommands),"f"),this.d=L,_e(this,c,q,"f"),_e(this,r,w.getProxy(I.MainContext.MainThreadTelemetry),"f"),this.converter=new m(this,V=>{const M=this.c.get(V);return M?.result===t.Void?M:void 0},L),this.f=[{processArgument(V){return(0,k.revive)(V)}},{processArgument(V){return(0,R.cloneAndChange)(V,function(M){if(O.Range.isIRange(M))return a.Range.to(M);if(T.Position.isIPosition(M))return a.Position.to(M);if(O.Range.isIRange(M.range)&&v.URI.isUri(M.uri))return a.location.to(M);if(M instanceof u.VSBuffer)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const L=this.registerCommand(!1,w.id,async(...q)=>{const V=w.args.map((B,N)=>{if(!B.validate(q[N]))throw new Error(`Invalid argument '${B.name}' when running '${w.id}', received: ${q[N]}`);return B.convert(q[N])}),M=await this.executeCommand(w.internalId,...V);return w.result.convert(M,q,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new A.Disposable(()=>{L.dispose(),this.c.delete(w.id)})}registerCommand(w,L,q,V,M,B){if(this.d.trace("ExtHostCommands#registerCommand",L),!L.trim().length)throw new Error("invalid id");if(this.b.has(L))throw new Error(`command '${L}' already exists`);return this.b.set(L,{callback:q,thisArg:V,description:M,extension:B}),w&&Ue(this,s,"f").$registerCommand(L),new A.Disposable(()=>{this.b.delete(L)&&w&&Ue(this,s,"f").$unregisterCommand(L)})}executeCommand(w,...L){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,L,!0)}async g(w,L,q){if(this.b.has(w))return Ue(this,s,"f").$fireCommandActivationEvent(w),this.h(w,L,!1);{let V=!1;const M=(0,R.cloneAndChange)(L,function(B){if(B instanceof A.Position)return a.Position.from(B);if(B instanceof A.Range)return a.Range.from(B);if(B instanceof A.Location)return a.location.from(B);if(A.NotebookRange.isNotebookRange(B))return a.NotebookRange.from(B);if(B instanceof ArrayBuffer)return V=!0,u.VSBuffer.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return V=!0,u.VSBuffer.wrap(B);if(B instanceof u.VSBuffer)return V=!0,B;if(!Array.isArray(B))return B});try{const B=await Ue(this,s,"f").$executeCommand(w,V?new g.SerializableObjectWithBuffers(M):M,q);return(0,k.revive)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this.g(w,L,!1);throw B}}}async h(w,L,q){const V=this.b.get(w);if(!V)throw new Error("Unknown command");const{callback:M,thisArg:B,description:N}=V;if(N)for(let $=0;$<N.args.length;$++)try{(0,o.validateConstraint)(L[$],N.args[$].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${N.args[$].name}' - ${N.args[$].description}`)}const U=D.StopWatch.create();try{return await M.apply(B,L)}catch($){if(w===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...L);z&&(w=z.command)}if(this.d.error($,w,V.extension?.identifier),!q)throw $;if(V.extension?.identifier){const z=Ue(this,c,"f").onExtensionError(V.extension.identifier,$);this.d.trace("forwarded error to extension?",z,V.extension?.identifier)}throw new class extends Error{constructor(){super((0,b.toErrorMessage)($)),this.id=w,this.source=V.extension?.displayName??V.extension?.name}}}finally{this.j(V,w,U.elapsed())}}j(w,L,q){!w.extension||Ue(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new p.TelemetryTrustedValue(L),duration:q})}$executeContributedCommand(w,...L){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const q=this.b.get(w);return q?(L=L.map(V=>this.f.reduce((M,B)=>B.processArgument(M,q.extension?.identifier),V)),this.h(w,L,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),Ue(this,s,"f").$getCommands().then(L=>(w&&(L=L.filter(q=>q[0]!=="_")),L))}$getContributedCommandHandlerDescriptions(){const w=Object.create(null);for(const[L,q]of this.b){const{description:V}=q;V&&(w[L]=V)}return Promise.resolve(w)}};s=new WeakMap,r=new WeakMap,c=new WeakMap,l=xe([ze(0,f.IExtHostRpcService),ze(1,S.ILogService),ze(2,n.IExtHostTelemetry)],l),e.ExtHostCommands=l,e.IExtHostCommands=(0,y.createDecorator)("IExtHostCommands");class m{constructor(w,L,q){this.d=w,this.f=L,this.g=q,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,L){if(!w)return;const q={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return q;const V=this.f(w.command);if(V)q.id=V.internalId,q.arguments=V.args.map((M,B)=>M.convert(w.arguments&&w.arguments[B]));else if((0,P.isNonEmptyArray)(w.arguments)){const M=`${w.command}/${++this.c}`;this.b.set(M,w),L.add((0,C.toDisposable)(()=>{this.b.delete(M),this.g.trace("CommandsConverter#DISPOSE",M)})),q.$ident=M,q.id=this.delegatingCommandId,q.arguments=[M],this.g.trace("CommandsConverter#CREATE",w.command,M)}return q}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const L=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],L?L.command:"MISSING"),L?this.d.executeCommand(L.command,...L.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.CommandsConverter=m;class i{constructor(w,L,q,V){this.name=w,this.description=L,this.validate=q,this.convert=V}optional(){return new i(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,L){return new i(w??this.name,L??this.description,this.validate,this.convert)}}i.Uri=new i("uri","Uri of a text document",E=>v.URI.isUri(E),E=>E),i.Position=new i("position","A position in a text document",E=>A.Position.isPosition(E),a.Position.from),i.Range=new i("range","A range in a text document",E=>A.Range.isRange(E),a.Range.from),i.Selection=new i("selection","A selection in a text document",E=>A.Selection.isSelection(E),a.Selection.from),i.Number=new i("number","",E=>typeof E=="number",E=>E),i.String=new i("string","",E=>typeof E=="string",E=>E),i.CallHierarchyItem=new i("item","A call hierarchy item",E=>E instanceof A.CallHierarchyItem,a.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",E=>E instanceof A.TypeHierarchyItem,a.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",E=>E instanceof h.TestItemImpl,a.TestItem.from),e.ApiCommandArgument=i;class t{constructor(w,L){this.description=w,this.convert=L}}t.Void=new t("no result",E=>E),e.ApiCommandResult=t;class d{constructor(w,L,q,V,M){this.id=w,this.internalId=L,this.description=q,this.args=V,this.result=M}}e.ApiCommand=d}),define(ye[252],De([1,0,2,14,7,71,40,15,120,125,16]),function(ne,e,o,A,a,R,I,P,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(A.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(f,h)=>{if((0,P.isFalsyOrEmpty)(f))return;class u extends a.SymbolInformation{static to(b){const D=new u(b.name,A.SymbolKind.to(b.kind),b.containerName||"",new a.Location(h[0],A.Range.to(b.range)));return D.detail=b.detail,D.range=D.location.range,D.selectionRange=A.Range.to(b.selectionRange),D.children=b.children?b.children.map(u.to):[],D}}return f.map(u.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(A.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(A.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",f=>typeof f=="string",f=>f),new I.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(A.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(A.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(A.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",f=>Array.isArray(f)&&f.every(h=>a.Position.isPosition(h)),f=>f.map(A.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",f=>f.map(h=>{let u;for(const g of h.reverse())u=new a.SelectionRange(A.Range.to(g),u);return u}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",f=>f.map(A.WorkspaceSymbol.to))),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",f=>f.map(A.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",f=>f.map(A.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",f=>f.map(A.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",f=>{if(!!f)return{range:A.Range.to(f.range),placeholder:f.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",f=>{if(!!f){if(f.rejectReason)throw new Error(f.rejectReason);return A.WorkspaceEdit.to(f)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",f=>f.map(A.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new a.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const h=(0,S.decodeSemanticTokensDto)(f);if(h.type==="full")return new a.SemanticTokens(h.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new a.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const h=(0,S.decodeSemanticTokensDto)(f);if(h.type==="full")return new a.SemanticTokens(h.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(f,h,u)=>{if(!f)return new a.CompletionList([]);const g=f.suggestions.map(b=>A.CompletionItem.to(b,u));return new a.CompletionList(g,f.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",f=>{if(f)return A.SignatureHelp.to(f)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(f,h,u)=>C(g=>new a.CodeLens(A.Range.to(g.range),g.command&&u.fromInternal(g.command)))(f))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",f=>a.Range.isRange(f),f=>a.Selection.isSelection(f)?A.Selection.from(f):A.Range.from(f)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(f,h,u)=>C(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(g.command)}else{const b=new a.CodeAction(g.title,g.kind?new a.CodeActionKind(g.kind):void 0);return g.edit&&(b.edit=A.WorkspaceEdit.to(g.edit)),g.command&&(b.command=u.fromInternal(g.command)),b.isPreferred=g.isPreferred,b}})(f))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",f=>f?f.map(h=>new a.ColorInformation(A.Range.to(h.range),A.Color.to(h.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",f=>f instanceof a.Color,A.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",f=>!0,f=>({uri:f.uri,range:A.Range.from(f.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",f=>f?f.map(A.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",(f,h,u)=>f.map(A.InlayHint.to.bind(void 0,u)))),new I.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(f,h)=>{if(f)return f.map(A.FoldingRange.to)})),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(f=>({viewType:f.viewType,displayName:f.displayName,options:{transientOutputs:f.options.transientOutputs,transientCellMetadata:f.options.transientCellMetadata,transientDocumentMetadata:f.options.transientDocumentMetadata},filenamePattern:f.filenamePattern.map(h=>A.NotebookExclusiveDocumentPattern.to(h))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",f=>f.map(A.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new I.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",f=>o.URI.isUri(f)||typeof f=="string"&&(0,k.matchesSomeScheme)(f,O.Schemas.http,O.Schemas.https),f=>f),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[A.ViewColumn.from(f),void 0]:[A.ViewColumn.from(f.viewColumn),A.TextEditorOpenOptions.from(f)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[A.ViewColumn.from(f),void 0]:[A.ViewColumn.from(f.viewColumn),A.TextEditorOpenOptions.from(f)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="object",f=>f&&[A.ViewColumn.from(f.viewColumn),A.TextEditorOpenOptions.from(f)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(A.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(A.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(A.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void),new I.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[I.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],I.ApiCommandResult.Void),new I.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[I.ApiCommandArgument.String.with("name","The context key name"),new I.ApiCommandArgument("value","The context key value",()=>!0,f=>f)],I.ApiCommandResult.Void)];class v{static register(h){T.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=v;function C(f){return h=>{if(Array.isArray(h))return h.map(f)}}function y(f){if(!Array.isArray(f))return;const h=[];for(const u of f)R.isLocationLink(u)?h.push(A.DefinitionLink.to(u)):h.push(A.location.to(u));return h}}),define(ye[253],De([1,0,19,62,3,6,2,71,27,14,7,5]),function(ne,e,o,A,a,R,I,P,S,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(C,y,f){const h=C.getProxy(T.MainContext.MainThreadComments);class u{constructor(){this.b=new Map,this.c=new Map,y.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const m=this.b.get(l.handle);return m?m.value:l}else if(l&&l.$mid===7){const m=this.b.get(l.commentControlHandle);if(!m)return l;const i=m.getCommentThread(l.commentThreadHandle);return i?i.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const m=this.b.get(l.thread.commentControlHandle);if(!m)return l;const i=m.getCommentThread(l.thread.commentThreadHandle);return i?l.$mid===8?i.value:{thread:i.value,text:l.text}:l}else if(l&&l.$mid===10){const m=this.b.get(l.thread.commentControlHandle);if(!m)return l;const i=m.getCommentThread(l.thread.commentThreadHandle);if(!i)return l;const t=l.commentUniqueId,d=i.getCommentByUniqueId(t);return d||l}else if(l&&l.$mid===11){const m=this.b.get(l.thread.commentControlHandle);if(!m)return l;const i=m.getCommentThread(l.thread.commentThreadHandle);if(!i)return l;const t=l.text,d=l.commentUniqueId,E=i.getCommentByUniqueId(d);return E?(typeof E.body=="string"?E.body=t:E.body=new O.MarkdownString(t),E):l}return l}})}createCommentController(l,m,i){const t=u.a++,d=new b(l,t,m,i);this.b.set(d.handle,d);const E=this.c.get(S.ExtensionIdentifier.toKey(l.identifier))||[];return E.push(d),this.c.set(S.ExtensionIdentifier.toKey(l.identifier),E),d.value}$createCommentThreadTemplate(l,m,i){const t=this.b.get(l);!t||t.$createCommentThreadTemplate(m,i)}async $updateCommentThreadTemplate(l,m,i){const t=this.b.get(l);!t||t.$updateCommentThreadTemplate(m,i)}$deleteCommentThread(l,m){this.b.get(l)?.$deleteCommentThread(m)}$provideCommentingRanges(l,m,i){const t=this.b.get(l);if(!t||!t.commentingRangeProvider)return Promise.resolve(void 0);const d=f.getDocument(I.URI.revive(m));return(0,o.asPromise)(()=>t.commentingRangeProvider.provideCommentingRanges(d,i)).then(E=>E?E.map(w=>k.Range.from(w)):void 0)}$toggleReaction(l,m,i,t,d){const E=this.b.get(l);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,o.asPromise)(()=>{const w=E.getCommentThread(m);if(w){const L=w.getCommentByUniqueId(t.uniqueIdInThread);if(E!==void 0&&L&&E.reactionHandler)return E.reactionHandler(L,n(d))}return Promise.resolve(void 0)})}dispose(){}}u.a=0;class g{set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){l.isEqual(this.p)||(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,m,i,t,d,E,w,L){this.m=m,this.n=i,this.o=t,this.p=d,this.q=E,this.extensionDescription=w,this.r=L,this.handle=g.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new a.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${l}.${this.handle}`),h.$createCommentThread(m,this.handle,this.n,this.o,k.Range.from(this.p),w.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this.i.push({dispose:()=>{h.$deleteCommentThread(m,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(V){q.range=V},get comments(){return q.comments},set comments(V){q.comments=V},get collapsibleState(){return q.collapsibleState},set collapsibleState(V){q.collapsibleState=V},get canReply(){return q.canReply},set canReply(V){q.canReply=V},get contextValue(){return q.contextValue},set contextValue(V){q.contextValue=V},get label(){return q.label},set label(V){q.label=V},get state(){return q.state},set state(V){q.state=V},dispose:()=>{q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const l=i=>Object.prototype.hasOwnProperty.call(this.b,i),m={};l("range")&&(m.range=k.Range.from(this.p)),l("label")&&(m.label=this.label),l("contextValue")&&(m.contextValue=this.contextValue??null),l("comments")&&(m.comments=this.q.map(i=>D(this,i,this.k))),l("collapsibleState")&&(m.collapseState=s(this.g)),l("canReply")&&(m.canReply=this.canReply),l("state")&&(m.state=r(this.h)),l("isTemplate")&&(m.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,m)}getCommentByUniqueId(l){for(const m of this.k){const i=m[0],t=m[1];if(l===t)return i}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}g.a=0,xe([(0,A.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class b{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,m,i,t){this.f=l,this.g=m,this.h=i,this.i=t,this.a=new Map,h.$registerCommentController(this.handle,i,t);const d=this;this.value=Object.freeze({id:d.id,label:d.label,get options(){return d.options},set options(E){d.options=E},get commentingRangeProvider(){return d.commentingRangeProvider},set commentingRangeProvider(E){d.commentingRangeProvider=E},get reactionHandler(){return d.reactionHandler},set reactionHandler(E){d.reactionHandler=E},createCommentThread(E,w,L){return d.createCommentThread(E,w,L).value},dispose:()=>{d.dispose()}}),this.e=[],this.e.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(l,m,i,t){if(typeof l=="string"){const d=new g(this.id,this.handle,l,m,i,t,this.f,!1);return this.a.set(d.handle,d),d}else{const d=new g(this.id,this.handle,void 0,l,m,i,this.f,!1);return this.a.set(d.handle,d),d}}$createCommentThreadTemplate(l,m){const i=new g(this.id,this.handle,void 0,I.URI.revive(l),k.Range.to(m),[],this.f,!0);return i.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this.a.set(i.handle,i),i}$updateCommentThreadTemplate(l,m){const i=this.a.get(l);i&&(i.range=k.Range.to(m))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function D(c,l,m){let i=m.get(l);i||(i=++c.commentHandle,m.set(l,i));const t=l.author&&l.author.iconPath?l.author.iconPath.toString():void 0;return{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:i,body:typeof l.body=="string"?l.body:k.MarkdownString.from(l.body),userName:l.author.name,userIconPath:t,label:l.label,commentReactions:l.reactions?l.reactions.map(d=>p(d)):void 0,timestamp:l.timestamp?.toJSON()}}function p(c){return{label:c.label,iconPath:c.iconPath?k.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function n(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?I.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function s(c){if(c!==void 0)switch(c){case O.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function r(c){if(c!==void 0)switch(c){case O.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new u}e.createExtHostComments=v}),define(ye[254],De([1,0,23,5,25,20]),function(ne,e,o,A,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let I=class{constructor(O,T){this.a=O.getProxy(A.MainContext.MainThreadConsole),this.b=T.consoleForward.includeStack,this.c=T.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(O,T){const v=this,C=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){v.e(O,T,C,arguments)}})}e(O,T,v,C){this.a.$logExtensionHostMessage({type:"__$console",severity:T,arguments:S(C,this.b)}),this.c&&this.f(O,v,C)}};I=xe([ze(0,R.IExtHostRpcService),ze(1,a.IExtHostInitDataService)],I),e.AbstractExtHostConsoleForwarder=I;const P=1e5;function S(k,O){const T=[];if(k.length)for(let v=0;v<k.length;v++){let C=k[v];if(typeof C>"u")C="undefined";else if(C instanceof Error){const y=C;y.stack?C=y.stack:C=y.toString()}T.push(C)}if(O){const v=new Error().stack;v&&T.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,o.safeStringify)(T);return v.length>P?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(ye[139],De([1,0,2,5,7,4,20,13,15,8,11,26]),function(ne,e,o,A,a,R,I,P,S,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class Mi{constructor(y,f){this.h=f,this.f=new Map,this.g=y.getProxy(A.MainContext.MainThreadDecorations)}registerFileDecorationProvider(y,f){const h=Mi.c++;this.f.set(h,{provider:y,extensionDescription:f}),this.g.$registerDecorationProvider(h,f.identifier.value);const u=y.onDidChangeFileDecorations&&y.onDidChangeFileDecorations(g=>{if(!g){this.g.$onDidChange(h,null);return}const b=(0,S.asArray)(g);if(b.length<=Mi.d){this.g.$onDidChange(h,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,b.length);const D=b.map(s=>({uri:s,rank:(0,k.count)(s.path,"/")})),p=(0,S.groupBy)(D,(s,r)=>s.rank-r.rank||(0,k.compare)(s.uri.path,r.uri.path)),n=[];e:for(const s of p){let r;for(const c of s){const l=(0,O.dirname)(c.uri.path);if(r!==l&&(r=l,n.push(c.uri)>=Mi.d))break e}}this.g.$onDidChange(h,n)});return new a.Disposable(()=>{u?.dispose(),this.g.$unregisterDecorationProvider(h),this.f.delete(h)})}async $provideDecorations(y,f,h){if(!this.f.has(y))return Object.create(null);const u=Object.create(null),{provider:g,extensionDescription:b}=this.f.get(y);return await Promise.all(f.map(async D=>{try{const{uri:p,id:n}=D,s=await Promise.resolve(g.provideFileDecoration(o.URI.revive(p),h));if(!s)return;try{a.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,T.checkProposedApiEnabled)(b,"codiconDecoration"),u[n]=[s.propagate,s.tooltip,s.badge,s.color]}catch(r){this.h.warn(`INVALID decoration from extension '${b}': ${r}`)}}catch(p){this.h.error(p)}})),u}};v.c=0,v.d=250,v=xe([ze(0,I.IExtHostRpcService),ze(1,P.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var _e=this&&this.__classPrivateFieldSet||function(ne,e,o,A,a){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!a:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?a.call(ne,o):a?a.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[255],De([1,0,177,124,2,5,7,14,3,13,28,48]),function(ne,e,o,A,a,R,I,P,S,k,O,T){"use strict";var v,C,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class f{constructor(g,b,D,p,n,s,r){this.d=g,this.e=b,this.f=D,this.g=p,v.set(this,void 0),C.set(this,void 0),y.set(this,void 0),this.c=!1,_e(this,y,new O.ResourceMap(c=>n.getComparisonKey(c)),"f"),_e(this,v,s,"f"),_e(this,C,r,"f")}dispose(){this.c||(Ue(this,C,"f").fire([...Ue(this,y,"f").keys()]),Ue(this,v,"f")?.$clear(this.e),Ue(this,y,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(g,b){if(!g){this.clear();return}this.h();let D=[];if(a.URI.isUri(g)){if(!b){this.delete(g);return}Ue(this,y,"f").set(g,b.slice()),D=[g]}else if(Array.isArray(g)){D=[];let n;g=[...g].sort(f.j);for(const s of g){const[r,c]=s;if((!n||r.toString()!==n.toString())&&(n&&Ue(this,y,"f").get(n).length===0&&Ue(this,y,"f").delete(n),n=r,D.push(r),Ue(this,y,"f").set(r,[])),c)Ue(this,y,"f").get(r)?.push(...c);else{const l=Ue(this,y,"f").get(r);l&&(l.length=0)}}}if(Ue(this,C,"f").fire(D),!Ue(this,v,"f"))return;const p=[];for(const n of D){let s=[];const r=Ue(this,y,"f").get(n);if(r)if(r.length>this.f){s=[];const c=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const m of r)if(m.severity===c[l]&&s.push({...P.Diagnostic.from(m),modelVersionId:this.g(n)})===this.f)break e;s.push({severity:A.MarkerSeverity.Info,message:(0,o.localize)(0,null,r.length-this.f),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=r.map(c=>({...P.Diagnostic.from(c),modelVersionId:this.g(n)}));p.push([n,s])}Ue(this,v,"f").$changeMany(this.e,p)}delete(g){this.h(),Ue(this,C,"f").fire([g]),Ue(this,y,"f").delete(g),Ue(this,v,"f")?.$changeMany(this.e,[[g,void 0]])}clear(){this.h(),Ue(this,C,"f").fire([...Ue(this,y,"f").keys()]),Ue(this,y,"f").clear(),Ue(this,v,"f")?.$clear(this.e)}forEach(g,b){this.h();for(const[D,p]of this)g.call(b,D,p,this)}*[(v=new WeakMap,C=new WeakMap,y=new WeakMap,Symbol.iterator)](){this.h();for(const g of Ue(this,y,"f").keys())yield[g,this.get(g)]}get(g){this.h();const b=Ue(this,y,"f").get(g);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(g){return this.h(),Array.isArray(Ue(this,y,"f").get(g))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(g,b){return g[0].toString()<b[0].toString()?-1:g[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=f;let h=class pi{static _mapper(g){const b=new O.ResourceMap;for(const D of g)b.set(D,D);return{uris:Object.freeze(Array.from(b.values()))}}constructor(g,b,D,p){this.h=b,this.j=D,this.k=p,this.f=new Map,this.g=new S.DebounceEmitter({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,pi._mapper),this.e=g.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(g,b){const{f:D,e:p,g:n,h:s,j:r,k:c}=this,l=new class{$changeMany(t,d){p.$changeMany(t,d),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,t,d.length===0?"CLEARING":d)}$clear(t){p.$clear(t),s.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,t)}dispose(){p.dispose()}};let m;if(!b)b="_generated_diagnostic_collection_name_#"+pi.c++,m=b;else if(!D.has(b))m=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do m=b+pi.c++;while(D.has(m))}return new class extends f{constructor(){super(b,m,pi.d,t=>c.getDocument(t)?.version,r.extUri,l,n),D.set(m,this)}dispose(){super.dispose(),D.delete(m)}}}getDiagnostics(g){if(g)return this.l(g);{const b=new Map,D=[];for(const p of this.f.values())p.forEach((n,s)=>{let r=b.get(n.toString());typeof r>"u"&&(r=D.length,b.set(n.toString(),r),D.push([n,[]])),D[r][1]=D[r][1].concat(...s)});return D}}l(g){let b=[];for(const D of this.f.values())D.has(g)&&(b=b.concat(D.get(g)));return b}$acceptMarkersChange(g){if(!this.m){const b="_generated_mirror",D=new f(b,b,pi.d,p=>{},this.j.extUri,void 0,this.g);this.f.set(b,D),this.m=D}for(const[b,D]of g)this.m.set(a.URI.revive(b),D.map(P.Diagnostic.to))}};h.c=0,h.d=1e3,h=xe([ze(1,k.ILogService),ze(2,T.IExtHostFileSystemInfo)],h),e.ExtHostDiagnostics=h}),define(ye[256],De([1,0,2,5,26]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(P){this.a=P.getProxy(A.MainContext.MainThreadDialogs)}showOpenDialog(P,S){return S?.allowUIResources&&(0,a.checkProposedApiEnabled)(P,"showLocal"),this.a.$showOpenDialog(S).then(k=>k?k.map(O=>o.URI.revive(O)):void 0)}showSaveDialog(P){return this.a.$showSaveDialog(P).then(S=>S?o.URI.revive(S):void 0)}}e.ExtHostDialogs=R}),define(ye[257],De([1,0,12,2,7,5,16,21,8]),function(ne,e,o,A,a,R,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(T,v,C){this.d=v,this.e=C,this.b=new Map,this.c=T.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(T,v){if(Object.keys(I.Schemas).indexOf(T)>=0)throw new Error(`scheme '${T}' already registered`);const C=k.a++;this.b.set(C,v),this.c.$registerTextContentProvider(C,T);let y;return typeof v.onDidChange=="function"&&(y=v.onDidChange(f=>{if(f.scheme!==T){this.e.warn(`Provider for scheme '${T}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(C,f).then(h=>{if(!h&&typeof h!="string")return;const u=this.d.getDocument(f);if(!u)return;const g=(0,S.splitLines)(h);if(!u.equalLines(g))return this.c.$onVirtualDocumentChange(f,h)},o.onUnexpectedError)})),new a.Disposable(()=>{this.b.delete(C)&&this.c.$unregisterTextContentProvider(C),y&&(y.dispose(),y=void 0)})}$provideTextDocumentContent(T,v){const C=this.b.get(T);return C?Promise.resolve(C.provideTextDocumentContent(A.URI.revive(v),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}k.a=0,e.ExtHostDocumentContentProvider=k}),define(ye[258],De([1,0,3,6,2,5,135,14,9,23,7]),function(ne,e,o,A,a,R,I,P,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(C,y){this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter,this.d=new o.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new A.DisposableStore,this.h=new Map,this.f=C.getProxy(R.MainContext.MainThreadDocuments),this.g=y,this.g.onDidRemoveDocuments(f=>{for(const h of f)this.b.fire(h.document)},void 0,this.e),this.g.onDidAddDocuments(f=>{for(const h of f)this.a.fire(h.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(C){if(!C)return;const y=this.g.getDocument(C);if(y)return y}getDocument(C){const y=this.getDocumentData(C);if(!y?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return y.document}ensureDocumentData(C){const y=this.g.getDocument(C);if(y)return Promise.resolve(y);let f=this.h.get(C.toString());return f||(f=this.f.$tryOpenDocument(C).then(h=>{this.h.delete(C.toString());const u=a.URI.revive(h);return(0,S.assertIsDefined)(this.g.getDocument(u))},h=>(this.h.delete(C.toString()),Promise.reject(h))),this.h.set(C.toString(),f)),f}createDocumentData(C){return this.f.$tryCreateDocument(C).then(y=>a.URI.revive(y))}$acceptModelLanguageChanged(C,y){const f=a.URI.revive(C),h=this.g.getDocument(f);if(!h)throw new Error("unknown document");this.b.fire(h.document),h._acceptLanguageId(y),this.a.fire(h.document)}$acceptModelSaved(C){const y=a.URI.revive(C),f=this.g.getDocument(y);if(!f)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this.d.fire(f.document)}$acceptDirtyStateChanged(C,y){const f=a.URI.revive(C),h=this.g.getDocument(f);if(!h)throw new Error("unknown document");h._acceptIsDirty(y),this.c.fire({document:h.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,y,f){const h=a.URI.revive(C),u=this.g.getDocument(h);if(!u)throw new Error("unknown document");u._acceptIsDirty(f),u.onEvents(y);let g;y.isUndoing?g=O.TextDocumentChangeReason.Undo:y.isRedoing&&(g=O.TextDocumentChangeReason.Redo),this.c.fire((0,k.deepFreeze)({document:u.document,contentChanges:y.changes.map(b=>({range:P.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:g}))}setWordDefinitionFor(C,y){(0,I.setWordDefinitionFor)(C,y)}}e.ExtHostDocuments=T}),define(ye[59],De([1,0,50,3,6,2,4,5,135,20,138,14,13,28,16,64,65]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class u{constructor(D){this.value=D,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let g=class{constructor(D,p){this.h=D,this.i=p,this.a=null,this.b=new Map,this.c=new C.ResourceMap,this.d=new A.Emitter,this.e=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(D){this.acceptDocumentsAndEditorsDelta(D)}acceptDocumentsAndEditorsDelta(D){const p=[],n=[],s=[];if(D.removedDocuments)for(const r of D.removedDocuments){const c=R.URI.revive(r),l=this.c.get(c);l?.unref()&&(this.c.delete(c),p.push(l.value))}if(D.addedDocuments)for(const r of D.addedDocuments){const c=R.URI.revive(r.uri);let l=this.c.get(c);if(l&&c.scheme!==y.Schemas.vscodeNotebookCell&&c.scheme!==y.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);l||(l=new u(new S.ExtHostDocumentData(this.h.getProxy(P.MainContext.MainThreadDocuments),c,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(c,l),n.push(l.value)),l.ref()}if(D.removedEditors)for(const r of D.removedEditors){const c=this.b.get(r);this.b.delete(r),c&&s.push(c)}if(D.addedEditors)for(const r of D.addedEditors){const c=R.URI.revive(r.documentUri);o.ok(this.c.has(c),`document '${c}' does not exist`),o.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const l=this.c.get(c).value,m=new O.ExtHostTextEditor(r.id,this.h.getProxy(P.MainContext.MainThreadTextEditors),this.i,new h.Lazy(()=>l.document),r.selections.map(T.Selection.to),r.options,r.visibleRanges.map(i=>T.Range.to(i)),typeof r.editorPosition=="number"?T.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,m)}D.newActiveEditor!==void 0&&(o.ok(D.newActiveEditor===null||this.b.has(D.newActiveEditor),`active editor '${D.newActiveEditor}' does not exist`),this.a=D.newActiveEditor),(0,a.dispose)(p),(0,a.dispose)(s),D.removedDocuments&&this.e.fire(p),D.addedDocuments&&this.d.fire(n),(D.removedEditors||D.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),D.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(D){return this.c.get(D)?.value}allDocuments(){return f.Iterable.map(this.c.values(),D=>D.value)}getEditor(D){return this.b.get(D)}activeEditor(D){if(!this.a)return;const p=this.b.get(this.a);return D?p:p?.value}allEditors(){return[...this.b.values()]}};g=xe([ze(0,k.IExtHostRpcService),ze(1,v.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[60],De([1,0,14,5,2,3,4,7,20,9,61]),function(ne,e,o,A,a,R,I,P,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class T{constructor(h,u,g){this.e=g,this.d=u,this.acceptDtoUpdate(h)}get apiObject(){if(!this.a){const h=this,u={get isActive(){return h.b.id===h.e()},get label(){return h.b.label},get input(){return h.c},get isDirty(){return h.b.isDirty},get isPinned(){return h.b.isPinned},get isPreview(){return h.b.isPreview},get group(){return h.d.apiObject}};this.a=Object.freeze(u)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(h){this.b=h,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new P.TextTabInput(a.URI.revive(this.b.input.uri));case 2:return new P.TextDiffTabInput(a.URI.revive(this.b.input.original),a.URI.revive(this.b.input.modified));case 3:return new P.TextMergeTabInput(a.URI.revive(this.b.input.base),a.URI.revive(this.b.input.input1),a.URI.revive(this.b.input.input2),a.URI.revive(this.b.input.result));case 6:return new P.CustomEditorTabInput(a.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new P.WebviewEditorTabInput(this.b.input.viewType);case 4:return new P.NotebookEditorTabInput(a.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new P.NotebookDiffEditorTabInput(a.URI.revive(this.b.input.original),a.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new P.TerminalEditorTabInput;case 9:return new P.InteractiveWindowInput(a.URI.revive(this.b.input.uri),a.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(h,u){this.c=[],this.d="",this.b=h,this.e=u;for(const g of h.tabs)g.isActive&&(this.d=g.id),this.c.push(new T(g,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const h=this,u={get isActive(){return h.b.groupId===h.e()},get viewColumn(){return o.ViewColumn.to(h.b.viewColumn)},get activeTab(){return h.c.find(g=>g.tabId===h.d)?.apiObject},get tabs(){return Object.freeze(h.c.map(g=>g.apiObject))}};this.a=Object.freeze(u)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(h){this.b=h}acceptTabOperation(h){if(h.kind===0){const g=new T(h.tabDto,this,()=>this.activeTabId());return this.c.splice(h.index,0,g),h.tabDto.isActive&&(this.d=g.tabId),g}else if(h.kind===1){const g=this.c.splice(h.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${h.index} which does not exist`);return g.tabId===this.d&&(this.d=""),g}else if(h.kind===3){if(h.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this.c.splice(h.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${h.oldIndex} which does not exist`);return this.c.splice(h.index,0,g),g}const u=this.c.find(g=>g.tabId===h.tabDto.id);if(!u)throw new Error("INVALID tab");return h.tabDto.isActive?this.d=h.tabDto.id:this.d===h.tabDto.id&&!h.tabDto.isActive&&(this.d=""),u.acceptDtoUpdate(h.tabDto),u}activeTabId(){return this.d}}let C=class{constructor(h){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=h.getProxy(A.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const h=this,u={onDidChangeTabGroups:h.c.event,onDidChangeTabs:h.b.event,get all(){return Object.freeze(h.e.map(g=>g.apiObject))},get activeTabGroup(){const g=h.d;return(0,k.assertIsDefined)(h.e.find(D=>D.groupId===g)?.apiObject)},close:async(g,b)=>{const D=Array.isArray(g)?g:[g];return D.length?y(D[0])?this.j(D,b):this.i(D,b):!0}};this.f=Object.freeze(u)}return this.f}$acceptEditorTabModel(h){const u=new Set(this.e.map(r=>r.groupId)),g=new Set(h.map(r=>r.groupId)),b=(0,O.diffSets)(u,g),D=this.e.filter(r=>b.removed.includes(r.groupId)).map(r=>r.apiObject),p=[],n=[];this.e=h.map(r=>{const c=new v(r,()=>this.d);return b.added.includes(c.groupId)?p.push(c.apiObject):n.push(c.apiObject),c});const s=(0,k.assertIsDefined)(h.find(r=>r.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:p,closed:D,changed:n}))}$acceptTabGroupUpdate(h){const u=this.e.find(g=>g.groupId===h.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(h),h.isActive&&(this.d=h.groupId),this.c.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(h){const u=this.e.find(b=>b.groupId===h.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const g=u.acceptTabOperation(h);switch(h.kind){case 0:this.b.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}g(h){for(const u of this.e)for(const g of u.tabs)if(g.apiObject===h)return g}h(h){return this.e.find(u=>u.apiObject===h)}async i(h,u){const g=[];for(const b of h){const D=this.g(b);if(!D)throw new Error("Tab close: Invalid tab not found!");g.push(D.tabId)}return this.a.$closeTab(g,u)}async j(h,u){const g=[];for(const b of h){const D=this.h(b);if(!D)throw new Error("Group close: Invalid group not found!");g.push(D.groupId)}return this.a.$closeGroup(g,u)}};C=xe([ze(0,S.IExtHostRpcService)],C),e.ExtHostEditorTabs=C;function y(f){return f.tabs!==void 0}}),define(ye[259],De([1,0,2,5,6,7,14,154,8,22,26]),function(ne,e,o,A,a,R,I,P,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this.a=[]}add(y){this.b=void 0,this.a.push(y)}delete(y){const f=this.a.indexOf(y);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const y=this.a.sort(),f=[];let h,u,g=14,b=14;for(const D of y){let p=h?(0,S.commonPrefixLength)(h,D):0;for(p===0?u=1:u=b;p<D.length;p++)p+1===D.length?(g=b,b=9):b+=1,f.push([u,D.toUpperCase().charCodeAt(p),b]),f.push([u,D.toLowerCase().charCodeAt(p),b]),u=b;h=D,b=g}f.push([9,58,10]),f.push([10,47,12]),this.b=new P.StateMachine(f)}}provideDocumentLinks(y){this.c();const f=[],h=P.LinkComputer.computeLinks({getLineContent(u){return y.lineAt(u-1).text},getLineCount(){return y.lineCount}},this.b);for(const u of h){const g=I.DocumentLink.to(u);g.target&&f.push(g)}return f}}class v{constructor(y,f){this.i=f,this.b=new T,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=y.getProxy(A.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(y,f,h,u={}){if(this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(y,"*",this.b));const g=this.h++;this.b.add(f),this.d.add(f),this.c.set(g,h);let b=2;u.isCaseSensitive&&(b+=1024),u.isReadonly&&(b+=2048),typeof h.copy=="function"&&(b+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&((0,O.checkProposedApiEnabled)(y,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(g,f,b).catch(p=>{console.error(`FAILED to register filesystem provider of ${y.identifier.value}-extension for the scheme ${f}`),console.error(p)});const D=h.onDidChangeFile(p=>{const n=[];for(const s of p){const{uri:r,type:c}=s;if(r.scheme!==f)continue;let l;switch(c){case R.FileChangeType.Changed:l=0;break;case R.FileChangeType.Created:l=1;break;case R.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:r,type:l})}this.a.$onFileSystemChange(g,n)});return(0,a.toDisposable)(()=>{D.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(g),this.a.$unregisterProvider(g)})}static j(y){const{type:f,ctime:h,mtime:u,size:g,permissions:b}=y;return{type:f,ctime:h,mtime:u,size:g,permissions:b}}$stat(y,f){return Promise.resolve(this.k(y).stat(o.URI.revive(f))).then(h=>v.j(h))}$readdir(y,f){return Promise.resolve(this.k(y).readDirectory(o.URI.revive(f)))}$readFile(y,f){return Promise.resolve(this.k(y).readFile(o.URI.revive(f))).then(h=>k.VSBuffer.wrap(h))}$writeFile(y,f,h,u){return Promise.resolve(this.k(y).writeFile(o.URI.revive(f),h.buffer,u))}$delete(y,f,h){return Promise.resolve(this.k(y).delete(o.URI.revive(f),h))}$rename(y,f,h,u){return Promise.resolve(this.k(y).rename(o.URI.revive(f),o.URI.revive(h),u))}$copy(y,f,h,u){const g=this.k(y);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(o.URI.revive(f),o.URI.revive(h),u))}$mkdir(y,f){return Promise.resolve(this.k(y).createDirectory(o.URI.revive(f)))}$watch(y,f,h,u){const g=this.k(y).watch(o.URI.revive(h),u);this.f.set(f,g)}$unwatch(y,f){const h=this.f.get(f);h&&(h.dispose(),this.f.delete(f))}$open(y,f,h){const u=this.k(y);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(o.URI.revive(f),h))}$close(y,f){const h=this.k(y);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(f))}$read(y,f,h,u){const g=this.k(y);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const b=k.VSBuffer.alloc(u);return Promise.resolve(g.read(f,h,b.buffer,0,u)).then(D=>b.slice(0,D))}$write(y,f,h,u){const g=this.k(y);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(f,h,u.buffer,0,u.byteLength))}k(y){const f=this.c.get(y);if(!f){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return f}}e.ExtHostFileSystem=v}),define(ye[78],De([1,0,5,44,7,22,4,20,48,6]),function(ne,e,o,A,a,R,I,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Yt{constructor(v,C){this.b=new Map,this.a=v.getProxy(o.MainContext.MainThreadFileSystem);const y=this;this.value=Object.freeze({async stat(f){try{const h=y.b.get(f.scheme);if(!h)return await y.a.$stat(f);await y.a.$ensureActivation(f.scheme);const u=await h.stat(f);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions}}catch(h){Yt.c(h)}},async readDirectory(f){try{const h=y.b.get(f.scheme);return h?(await y.a.$ensureActivation(f.scheme),(await h.readDirectory(f)).slice()):await y.a.$readdir(f)}catch(h){return Yt.c(h)}},async createDirectory(f){try{return await y.a.$mkdir(f)}catch(h){return Yt.c(h)}},async readFile(f){try{const h=y.b.get(f.scheme);return h?(await y.a.$ensureActivation(f.scheme),(await h.readFile(f)).slice()):(await y.a.$readFile(f)).buffer}catch(h){return Yt.c(h)}},async writeFile(f,h){try{return await y.a.$writeFile(f,R.VSBuffer.wrap(h))}catch(u){return Yt.c(u)}},async delete(f,h){try{const u=y.b.get(f.scheme);return u?(await y.a.$ensureActivation(f.scheme),await u.delete(f,{recursive:!1,...h})):await y.a.$delete(f,{recursive:!1,useTrash:!1,...h})}catch(u){return Yt.c(u)}},async rename(f,h,u){try{return await y.a.$rename(f,h,{overwrite:!1,...u})}catch(g){return Yt.c(g)}},async copy(f,h,u){try{return await y.a.$copy(f,h,{overwrite:!1,...u})}catch(g){return Yt.c(g)}},isWritableFileSystem(f){const h=C.getCapabilities(f);if(typeof h=="number")return!(h&2048)}})}static c(v){if(v instanceof a.FileSystemError)throw v;if(!(v instanceof Error))throw new a.FileSystemError(String(v));if(v.name==="ENOPRO"||v.message.includes("ENOPRO"))throw a.FileSystemError.Unavailable(v.message);switch(v.name){case A.FileSystemProviderErrorCode.FileExists:throw a.FileSystemError.FileExists(v.message);case A.FileSystemProviderErrorCode.FileNotFound:throw a.FileSystemError.FileNotFound(v.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw a.FileSystemError.FileNotADirectory(v.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw a.FileSystemError.FileIsADirectory(v.message);case A.FileSystemProviderErrorCode.NoPermissions:throw a.FileSystemError.NoPermissions(v.message);case A.FileSystemProviderErrorCode.Unavailable:throw a.FileSystemError.Unavailable(v.message);default:throw new a.FileSystemError(v.message,v.name)}}addFileSystemProvider(v,C){return this.b.set(v,C),(0,k.toDisposable)(()=>this.b.delete(v))}};O=xe([ze(0,P.IExtHostRpcService),ze(1,S.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[260],De([1,0,3,38,2,5,14,7]),function(ne,e,o,A,a,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(T,v,C,y,f,h,u,g){this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter;const b=this.h(T,C,f);this.g=0,h&&(this.g+=1),u&&(this.g+=2),g&&(this.g+=4);const D=(0,A.parse)(f),p=typeof f=="string",n=y(s=>{if(!h)for(const r of s.created){const c=a.URI.revive(r);D(c.fsPath)&&(!p||v.getWorkspaceFolder(c))&&this.a.fire(c)}if(!u)for(const r of s.changed){const c=a.URI.revive(r);D(c.fsPath)&&(!p||v.getWorkspaceFolder(c))&&this.b.fire(c)}if(!g)for(const r of s.deleted){const c=a.URI.revive(r);D(c.fsPath)&&(!p||v.getWorkspaceFolder(c))&&this.c.fire(c)}});this.d=P.Disposable.from(b,this.a,this.b,this.c,n)}h(T,v,C){const y=P.Disposable.from();if(typeof C=="string")return y;const f=T.getProxy(R.MainContext.MainThreadFileSystem);let h=!1;(C.pattern.includes(A.GLOBSTAR)||C.pattern.includes(A.GLOB_SPLIT))&&(h=!0);const u=Math.random();return f.$watch(v.identifier.value,u,C.baseUri,{recursive:h,excludes:[]}),P.Disposable.from({dispose:()=>f.$unwatch(u)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class k{constructor(T,v,C){this.j=T,this.k=v,this.l=C,this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter,this.d=new o.Emitter,this.g=new o.AsyncEmitter,this.h=new o.AsyncEmitter,this.i=new o.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(T,v,C,y,f,h){return new S(this.j,T,v,this.a.event,I.GlobPattern.from(C),y,f,h)}$onFileEvent(T){this.a.fire(T)}$onDidRunFileOperation(T,v){switch(T){case 2:this.b.fire(Object.freeze({files:v.map(C=>({oldUri:a.URI.revive(C.source),newUri:a.URI.revive(C.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(C=>a.URI.revive(C.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(C=>a.URI.revive(C.target))}));break;default:}}getOnWillRenameFileEvent(T){return this.m(T,this.g)}getOnWillCreateFileEvent(T){return this.m(T,this.h)}getOnWillDeleteFileEvent(T){return this.m(T,this.i)}m(T,v){return(C,y,f)=>{const h=function(g){C.call(y,g)};return h.extension=T,v.event(h,void 0,f)}}async $onWillRunFileOperation(T,v,C,y){switch(T){case 2:return await this.n(this.g,{files:v.map(f=>({oldUri:a.URI.revive(f.source),newUri:a.URI.revive(f.target)}))},C,y);case 1:return await this.n(this.i,{files:v.map(f=>a.URI.revive(f.target))},C,y);case 0:case 3:return await this.n(this.h,{files:v.map(f=>a.URI.revive(f.target))},C,y)}}async n(T,v,C,y){const f=new Set,h=[];if(await T.fireAsync(v,y,async(g,b)=>{const D=Date.now(),p=await Promise.resolve(g);p instanceof P.WorkspaceEdit&&(h.push([b.extension,p]),f.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-D>C&&this.k.warn("SLOW file-participant",b.extension.identifier)}),y.isCancellationRequested||h.length===0)return;const u={edits:[]};for(const[,g]of h){const{edits:b}=I.WorkspaceEdit.from(g,{getTextDocumentVersion:D=>this.l.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(b)}return{edit:u,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=k}),define(ye[261],De([1,0,2,40]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class a{constructor(I,P,S,k,O){this.a=P,this.b=S,this.c=k;const T=new A.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new A.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new A.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new A.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new A.ApiCommandResult("Notebook and input URI",v=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const C=this.a.getEditorById(v.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:o.URI.revive(v.notebookUri),inputUri:o.URI.revive(v.inputUri),notebookEditor:C.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:o.URI.revive(v.notebookUri),inputUri:o.URI.revive(v.inputUri)}}));this.c.registerApiCommand(T)}$willAddInteractiveDocument(I,P,S,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:S,uri:I,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(o.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,P){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=a}),define(ye[262],De([1,0,6,5]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class a{constructor(I){this.b=0,this.a=I.getProxy(A.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const P=this.b++;return this.a.$registerResourceLabelFormatter(P,I),(0,o.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=a}),define(ye[263],De([1,0,2,23,14,7,71,5,8,32,15,9,150,21,6,120,101,74,43,12,19,26]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u,g,b,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class n{constructor(F,H){this.d=F,this.e=H}async provideDocumentSymbols(F,H){const K=this.d.getDocument(F),_=await this.e.provideDocumentSymbols(K,H);if(!(0,O.isFalsyOrEmpty)(_))return _[0]instanceof R.DocumentSymbol?_.map(a.DocumentSymbol.from):n.f(_)}static f(F){F=F.slice(0).sort((_,de)=>{let we=_.location.range.start.compareTo(de.location.range.start);return we===0&&(we=de.location.range.end.compareTo(_.location.range.end)),we});const H=[],K=[];for(const _ of F){const de={name:_.name||"!!MISSING: name!!",kind:a.SymbolKind.from(_.kind),tags:_.tags?.map(a.SymbolTag.from)||[],detail:"",containerName:_.containerName,range:a.Range.from(_.location.range),selectionRange:a.Range.from(_.location.range),children:[]};for(;;){if(K.length===0){K.push(de),H.push(de);break}const we=K[K.length-1];if(k.Range.containsRange(we.range,de.range)&&!k.Range.equalsRange(we.range,de.range)){we.children?.push(de),K.push(de);break}K.pop()}}return H}}class s{constructor(F,H,K){this.g=F,this.h=H,this.j=K,this.e=new u.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(F,H){const K=this.g.getDocument(F),_=await this.j.provideCodeLenses(K,H);if(!_||H.isCancellationRequested)return;const de=this.e.add(_),we=new y.DisposableStore;this.f.set(de,we);const Pe={cacheId:de,lenses:[]};for(let be=0;be<_.length;be++)Pe.lenses.push({cacheId:[de,be],range:a.Range.from(_[be].range),command:this.h.toInternal(_[be].command,we)});return Pe}async resolveCodeLens(F,H){const K=F.cacheId&&this.e.get(...F.cacheId);if(!K)return;let _;if(typeof this.j.resolveCodeLens!="function"||K.isResolved?_=K:_=await this.j.resolveCodeLens(K,H),_||(_=K),H.isCancellationRequested)return;const de=F.cacheId&&this.f.get(F.cacheId[0]);if(!!de)return F.command=this.h.toInternal(_.command??s.d,de),F}releaseCodeLenses(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}}s.d={command:"missing",title:"!!MISSING: command!!"};function r(se){return Array.isArray(se)?se.map(a.DefinitionLink.from):se?[a.DefinitionLink.from(se)]:[]}class c{constructor(F,H){this.d=F,this.e=H}async provideDefinition(F,H,K){const _=this.d.getDocument(F),de=a.Position.to(H),we=await this.e.provideDefinition(_,de,K);return r(we)}}class l{constructor(F,H){this.d=F,this.e=H}async provideDeclaration(F,H,K){const _=this.d.getDocument(F),de=a.Position.to(H),we=await this.e.provideDeclaration(_,de,K);return r(we)}}class m{constructor(F,H){this.d=F,this.e=H}async provideImplementation(F,H,K){const _=this.d.getDocument(F),de=a.Position.to(H),we=await this.e.provideImplementation(_,de,K);return r(we)}}class i{constructor(F,H){this.d=F,this.e=H}async provideTypeDefinition(F,H,K){const _=this.d.getDocument(F),de=a.Position.to(H),we=await this.e.provideTypeDefinition(_,de,K);return r(we)}}class t{constructor(F,H){this.d=F,this.e=H}async provideHover(F,H,K){const _=this.d.getDocument(F),de=a.Position.to(H),we=await this.e.provideHover(_,de,K);if(!(!we||(0,O.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=_.getWordRangeAtPosition(de)),we.range||(we.range=new R.Range(de,de)),a.Hover.from(we)}}class d{constructor(F,H){this.d=F,this.e=H}async provideEvaluatableExpression(F,H,K){const _=this.d.getDocument(F),de=a.Position.to(H),we=await this.e.provideEvaluatableExpression(_,de,K);if(we)return a.EvaluatableExpression.from(we)}}class E{constructor(F,H){this.d=F,this.e=H}async provideInlineValues(F,H,K,_){const de=this.d.getDocument(F),we=await this.e.provideInlineValues(de,a.Range.to(H),a.InlineValueContext.to(K),_);if(Array.isArray(we))return we.map(Pe=>a.InlineValue.from(Pe))}}class w{constructor(F,H){this.d=F,this.e=H}async provideDocumentHighlights(F,H,K){const _=this.d.getDocument(F),de=a.Position.to(H),we=await this.e.provideDocumentHighlights(_,de,K);if(Array.isArray(we))return we.map(a.DocumentHighlight.from)}}class L{constructor(F,H){this.d=F,this.e=H}async provideLinkedEditingRanges(F,H,K){const _=this.d.getDocument(F),de=a.Position.to(H),we=await this.e.provideLinkedEditingRanges(_,de,K);if(we&&Array.isArray(we.ranges))return{ranges:(0,O.coalesce)(we.ranges.map(a.Range.from)),wordPattern:we.wordPattern}}}class q{constructor(F,H){this.d=F,this.e=H}async provideReferences(F,H,K,_){const de=this.d.getDocument(F),we=a.Position.to(H),Pe=await this.e.provideReferences(de,we,K,_);if(Array.isArray(Pe))return Pe.map(a.location.from)}}class V{constructor(F,H,K,_,de,we,Pe){this.g=F,this.h=H,this.j=K,this.k=_,this.l=de,this.m=we,this.n=Pe,this.e=new u.Cache("CodeAction"),this.f=new Map}async provideCodeActions(F,H,K,_){const de=this.g.getDocument(F),we=v.Selection.isISelection(H)?a.Selection.to(H):a.Range.to(H),Pe=[];for(const nt of this.j.getDiagnostics(F))if(we.intersection(nt.range)&&Pe.push(nt)>V.d)break;const be={diagnostics:Pe,only:K.only?new R.CodeActionKind(K.only):void 0,triggerKind:a.CodeActionTriggerKind.to(K.trigger)},Ce=await this.k.provideCodeActions(de,we,be,_);if(!(0,O.isNonEmptyArray)(Ce)||_.isCancellationRequested)return;const ke=this.e.add(Ce),He=new y.DisposableStore;this.f.set(ke,He);const Ge=[];for(let nt=0;nt<Ce.length;nt++){const Qe=Ce[nt];!Qe||(V.o(Qe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:Qe.title,command:this.h.toInternal(Qe,He)})):(be.only&&(Qe.kind?be.only.contains(Qe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[ke,nt],title:Qe.title,command:Qe.command&&this.h.toInternal(Qe.command,He),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(a.Diagnostic.from),edit:Qe.edit&&a.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:ke,actions:Ge}}async resolveCodeAction(F,H){const[K,_]=F,de=this.e.get(K,_);if(!de||V.o(de)||!this.k.resolveCodeAction)return;const we=await this.k.resolveCodeAction(de,H)??de;return we?.edit?a.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}V.d=1e3;class M{constructor(F,H,K,_){this.d=F,this.e=H,this.f=K,this.g=_}async prepareDocumentPaste(F,H,K,_){if(!this.f.prepareDocumentPaste)return;const de=this.e.getDocument(F),we=H.map(be=>a.Range.to(be)),Pe=a.DataTransfer.toDataTransfer(K,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(de,we,Pe,_),a.DataTransfer.toDataTransferDTO(Pe)}async providePasteEdits(F,H,K,_,de){const we=this.e.getDocument(H),Pe=K.map(ke=>a.Range.to(ke)),be=a.DataTransfer.toDataTransfer(_,async ke=>(await this.d.$resolvePasteFileData(this.g,F,ke)).buffer),Ce=await this.f.provideDocumentPasteEdits(we,Pe,be,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?a.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class B{constructor(F,H){this.d=F,this.e=H}async provideDocumentFormattingEdits(F,H,K){const _=this.d.getDocument(F),de=await this.e.provideDocumentFormattingEdits(_,H,K);if(Array.isArray(de))return de.map(a.TextEdit.from)}}class N{constructor(F,H){this.d=F,this.e=H}async provideDocumentRangeFormattingEdits(F,H,K,_){const de=this.d.getDocument(F),we=a.Range.to(H),Pe=await this.e.provideDocumentRangeFormattingEdits(de,we,K,_);if(Array.isArray(Pe))return Pe.map(a.TextEdit.from)}}class U{constructor(F,H){this.d=F,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,H,K,_,de){const we=this.d.getDocument(F),Pe=a.Position.to(H),be=await this.e.provideOnTypeFormattingEdits(we,Pe,K,_,de);if(Array.isArray(be))return be.map(a.TextEdit.from)}}class ${constructor(F,H){this.e=F,this.f=H,this.d=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(F,H){const K=await this.e.provideWorkspaceSymbols(F,H);if(!(0,O.isNonEmptyArray)(K))return{symbols:[]};const _=this.d.add(K),de={cacheId:_,symbols:[]};for(let we=0;we<K.length;we++){const Pe=K[we];if(!Pe||!Pe.name){this.f.warn("INVALID SymbolInformation",Pe);continue}de.symbols.push({...a.WorkspaceSymbol.from(Pe),cacheId:[_,we]})}return de}async resolveWorkspaceSymbol(F,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const K=this.d.get(...F.cacheId);if(K){const _=await this.e.resolveWorkspaceSymbol(K,H);return _&&(0,A.mixin)(F,a.WorkspaceSymbol.from(_),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class z{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,H,K){this.d=F,this.e=H,this.f=K}async provideRenameEdits(F,H,K,_){const de=this.d.getDocument(F),we=a.Position.to(H);try{const Pe=await this.e.provideRenameEdits(de,we,K,_);return Pe?a.WorkspaceEdit.from(Pe):void 0}catch(Pe){const be=z.g(Pe);return be?{rejectReason:be,edits:void 0}:Promise.reject(Pe)}}async resolveRenameLocation(F,H,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const _=this.d.getDocument(F),de=a.Position.to(H);try{const we=await this.e.prepareRename(_,de,K);let Pe,be;if(R.Range.isRange(we)?(Pe=we,be=_.getText(we)):(0,T.isObject)(we)&&(Pe=we.range,be=we.placeholder),!Pe||!be)return;if(Pe.start.line>de.line||Pe.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:a.Range.from(Pe),text:be}}catch(we){const Pe=z.g(we);return Pe?{rejectReason:Pe,range:void 0,text:void 0}:Promise.reject(we)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class ae{constructor(F,H){this.resultId=F,this.tokens=H}}class ee{constructor(F,H){this.f=F,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,H,K){const _=this.f.getDocument(F),de=H!==0?this.d.get(H):null;let we=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(_,de.resultId,K):await this.g.provideDocumentSemanticTokens(_,K);return de&&this.d.delete(H),we?(we=ee.h(we),this.o(ee.n(de,we),we)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return ee.j(F)?ee.k(F)?F:new R.SemanticTokens(new Uint32Array(F.data),F.resultId):ee.l(F)?ee.m(F)?F:new R.SemanticTokensEdits(F.edits.map(H=>new R.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const H of F.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(F,H){if(!ee.j(H)||!F||!F.tokens)return H;const K=F.tokens,_=K.length,de=H.data,we=de.length;let Pe=0;const be=Math.min(_,we);for(;Pe<be&&K[Pe]===de[Pe];)Pe++;if(Pe===_&&Pe===we)return new R.SemanticTokensEdits([],H.resultId);let Ce=0;const ke=be-Pe;for(;Ce<ke&&K[_-Ce-1]===de[we-Ce-1];)Ce++;return new R.SemanticTokensEdits([{start:Pe,deleteCount:_-Pe-Ce,data:de.subarray(Pe,we-Ce)}],H.resultId)}o(F,H){if(ee.j(F)){const K=this.e++;return this.d.set(K,new ae(F.resultId,F.data)),(0,f.encodeSemanticTokensDto)({id:K,type:"full",data:F.data})}if(ee.l(F)){const K=this.e++;return ee.j(H)?this.d.set(K,new ae(H.resultId,H.data)):this.d.set(K,new ae(F.resultId)),(0,f.encodeSemanticTokensDto)({id:K,type:"delta",deltas:(F.edits||[]).map(_=>({start:_.start,deleteCount:_.deleteCount,data:_.data}))})}return null}}class x{constructor(F,H){this.d=F,this.e=H}async provideDocumentRangeSemanticTokens(F,H,K){const _=this.d.getDocument(F),de=await this.e.provideDocumentRangeSemanticTokens(_,a.Range.to(H),K);return de?this.f(de):null}f(F){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:F.data})}}class J{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,H,K,_,de){this.f=F,this.g=H,this.h=K,this.j=_,this.k=de,this.d=new u.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(F,H,K,_){const de=this.f.getDocument(F),we=a.Position.to(H),Pe=de.getWordRangeAtPosition(we)||new R.Range(we,we),be=Pe.with({end:we}),Ce=new g.StopWatch(!0),ke=await this.h.provideCompletionItems(de,we,_,a.CompletionContext.to(K));if(!ke||_.isCancellationRequested)return;const He=Array.isArray(ke)?new R.CompletionList(ke):ke,Ge=J.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),nt=new y.DisposableStore;this.e.set(Ge,nt);const Qe=[],tt={x:Ge,b:Qe,a:{replace:a.Range.from(Pe),insert:a.Range.from(be)},c:He.isIncomplete||void 0,d:Ce.elapsed()};for(let rt=0;rt<He.items.length;rt++){const Be=He.items[rt],it=this.l(Be,[Ge,rt],be,Pe);Qe.push(it)}return tt}async resolveCompletionItem(F,H){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...F);if(!K)return;const _=await this.h.resolveCompletionItem(K,H);if(!!_)return this.l(_,F)}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,H,K,_){const de=this.e.get(H[0]);if(!de)throw Error("DisposableStore is missing...");const we=this.g.toInternal(F.command,de),Pe={x:H,a:F.label,b:F.kind!==void 0?a.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(a.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:a.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(a.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Pe.h=F.textEdit.newText):typeof F.insertText=="string"?Pe.h=F.insertText:F.insertText instanceof R.SnippetString&&(Pe.h=F.insertText.value,Pe.i|=4);let be;return F.textEdit?be=F.textEdit.range:F.range&&(be=F.range),R.Range.isRange(be)?Pe.j=a.Range.from(be):be&&(!K?.isEqual(be.inserting)||!_?.isEqual(be.replacing))&&(Pe.j={insert:a.Range.from(be.inserting),replace:a.Range.from(be.replacing)}),Pe}}class ie{async provideInlineCompletions(F,H,K,_){}disposeCompletions(F){}handleDidShowCompletionItem(F,H){}handlePartialAccept(F,H,K){}}class pe extends ie{constructor(F,H,K,_){super(),this.f=F,this.g=H,this.h=K,this.j=_,this.d=new Q,this.e=(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[I.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[I.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,H,K,_){const de=this.g.getDocument(F),we=a.Position.to(H),Pe=await this.h.provideInlineCompletionItems(de,we,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:a.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},_);if(!Pe||_.isCancellationRequested)return;const be=Array.isArray(Pe)?Pe:Pe.items,Ce=this.e?Array.isArray(Pe)?[]:Pe.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:be}),items:be.map((Ge,nt)=>{let Qe;Ge.command&&(ke||(ke=new y.DisposableStore),Qe=this.j.toInternal(Ge.command,ke));const tt=Ge.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ge.filterText,range:Ge.range?a.Range.from(Ge.range):void 0,command:Qe,idx:nt,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:Ce.map(Ge=>(ke||(ke=new y.DisposableStore),this.j.toInternal(Ge,ke)))}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,H){const K=this.d.get(F)?.items[H];K&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(K)}handlePartialAccept(F,H,K){const _=this.d.get(F)?.items[H];_&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(_,K)}}class Q{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const H=this.e++;return this.d.set(H,F),H}disposeReferenceId(F){const H=this.d.get(F);return this.d.delete(F),H}get(F){return this.d.get(F)}}class Y{constructor(F,H){this.e=F,this.f=H,this.d=new u.Cache("SignatureHelp")}async provideSignatureHelp(F,H,K,_){const de=this.e.getDocument(F),we=a.Position.to(H),Pe=this.g(K),be=await this.f.provideSignatureHelp(de,we,_,Pe);if(be){const Ce=this.d.add([be]);return{...a.SignatureHelp.from(be),id:Ce}}}g(F){let H;if(F.activeSignatureHelp){const K=a.SignatureHelp.to(F.activeSignatureHelp),_=this.d.get(F.activeSignatureHelp.id,0);_?(H=_,H.activeSignature=K.activeSignature,H.activeParameter=K.activeParameter):H=K}return{...F,activeSignatureHelp:H}}releaseSignatureHelp(F){this.d.delete(F)}}class Z{constructor(F,H,K,_,de){this.f=F,this.g=H,this.h=K,this.j=_,this.k=de,this.d=new u.Cache("InlayHints"),this.e=new Map}async provideInlayHints(F,H,K){const _=this.f.getDocument(F),de=a.Range.to(H),we=await this.h.provideInlayHints(_,de,K);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${H}`);return}if(K.isCancellationRequested)return;const Pe=this.d.add(we);this.e.set(Pe,new y.DisposableStore);const be={hints:[],cacheId:Pe};for(let Ce=0;Ce<we.length;Ce++)this.l(we[Ce],de)&&be.hints.push(this.m(we[Ce],[Pe,Ce]));return this.j.trace(`[InlayHints] ${be.hints.length} inlay hints from '${this.k.identifier.value}' for ${H}`),be}async resolveInlayHint(F,H){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...F);if(!K)return;const _=await this.h.resolveInlayHint(K,H);if(!!_&&!!this.l(_))return this.m(_,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,H){return F.label.length===0||Array.isArray(F.label)&&F.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(H&&!H.contains(F.position))}m(F,H){const K=this.e.get(H[0]);if(!K)throw Error("DisposableStore is missing...");const _={label:"",cacheId:H,tooltip:a.MarkdownString.fromStrict(F.tooltip),position:a.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(a.TextEdit.from),kind:F.kind&&a.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?_.label=F.label:_.label=F.label.map(de=>{const we={label:de.value};return we.tooltip=a.MarkdownString.fromStrict(de.tooltip),R.Location.isLocation(de.location)&&(we.location=a.location.from(de.location)),de.command&&(we.command=this.g.toInternal(de.command,K)),we}),_}}class me{constructor(F,H){this.e=F,this.f=H,this.d=new u.Cache("DocumentLink")}async provideLinks(F,H){const K=this.e.getDocument(F),_=await this.f.provideDocumentLinks(K,H);if(!(!Array.isArray(_)||_.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:_.filter(me.g).map(a.DocumentLink.from)};{const de=this.d.add(_),we={links:[],cacheId:de};for(let Pe=0;Pe<_.length;Pe++){if(!me.g(_[Pe]))continue;const be=a.DocumentLink.from(_[Pe]);be.cacheId=[de,Pe],we.links.push(be)}return we}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,H){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...F);if(!K)return;const _=await this.f.resolveDocumentLink(K,H);if(!(!_||!me.g(_)))return a.DocumentLink.from(_)}releaseLinks(F){this.d.delete(F)}}class ve{constructor(F,H){this.d=F,this.e=H}async provideColors(F,H){const K=this.d.getDocument(F),_=await this.e.provideDocumentColors(K,H);return Array.isArray(_)?_.map(we=>({color:a.Color.from(we.color),range:a.Range.from(we.range)})):[]}async provideColorPresentations(F,H,K){const _=this.d.getDocument(F),de=a.Range.to(H.range),we=a.Color.to(H.color),Pe=await this.e.provideColorPresentations(we,{document:_,range:de},K);if(!!Array.isArray(Pe))return Pe.map(a.ColorPresentation.from)}}class Ie{constructor(F,H){this.d=F,this.e=H}async provideFoldingRanges(F,H,K){const _=this.d.getDocument(F),de=await this.e.provideFoldingRanges(_,H,K);if(!!Array.isArray(de))return de.map(a.FoldingRange.from)}}class Re{constructor(F,H,K){this.d=F,this.e=H,this.f=K}async provideSelectionRanges(F,H,K){const _=this.d.getDocument(F),de=H.map(a.Position.to),we=await this.e.provideSelectionRanges(_,de,K);if(!(0,O.isNonEmptyArray)(we))return[];if(we.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Pe=[];for(let be=0;be<de.length;be++){const Ce=[];Pe.push(Ce);let ke=de[be],He=we[be];for(;;){if(!He.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(a.SelectionRange.from(He)),!He.parent)break;ke=He.range,He=He.parent}}return Pe}}class oe{constructor(F,H){this.f=F,this.g=H,this.d=new h.IdGenerator(""),this.e=new Map}async prepareSession(F,H,K){const _=this.f.getDocument(F),de=a.Position.to(H),we=await this.g.prepareCallHierarchy(_,de,K);if(!we)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(we)?we.map(be=>this.h(Pe,be)):[this.h(Pe,we)]}async provideCallsTo(F,H,K){const _=this.j(F,H);if(!_)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(_,K);if(!!de)return de.map(we=>({from:this.h(F,we.from),fromRanges:we.fromRanges.map(Pe=>a.Range.from(Pe))}))}async provideCallsFrom(F,H,K){const _=this.j(F,H);if(!_)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(_,K);if(!!de)return de.map(we=>({to:this.h(F,we.to),fromRanges:we.fromRanges.map(Pe=>a.Range.from(Pe))}))}releaseSession(F){this.e.delete(F)}h(F,H){const K=this.e.get(F),_=a.CallHierarchyItem.from(H,F,K.size.toString(36));return K.set(_._itemId,H),_}j(F,H){return this.e.get(F)?.get(H)}}class le{constructor(F,H){this.f=F,this.g=H,this.d=new h.IdGenerator(""),this.e=new Map}async prepareSession(F,H,K){const _=this.f.getDocument(F),de=a.Position.to(H),we=await this.g.prepareTypeHierarchy(_,de,K);if(!we)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(we)?we.map(be=>this.h(Pe,be)):[this.h(Pe,we)]}async provideSupertypes(F,H,K){const _=this.j(F,H);if(!_)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(_,K);if(!!de)return de.map(we=>this.h(F,we))}async provideSubtypes(F,H,K){const _=this.j(F,H);if(!_)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(_,K);if(!!de)return de.map(we=>this.h(F,we))}releaseSession(F){this.e.delete(F)}h(F,H){const K=this.e.get(F),_=a.TypeHierarchyItem.from(H,F,K.size.toString(36));return K.set(_._itemId,H),_}j(F,H){return this.e.get(F)?.get(H)}}class ue{constructor(F,H,K,_){this.d=F,this.e=H,this.f=K,this.g=_}async provideDocumentOnDropEdits(F,H,K,_,de){const we=this.e.getDocument(H),Pe=a.Position.to(K),be=a.DataTransfer.toDataTransfer(_,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,ke)).buffer),Ce=await this.f.provideDocumentDropEdits(we,Pe,be,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?a.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class te{constructor(F,H){this.adapter=F,this.extension=H}}class ce{constructor(F,H,K,_,de,we,Pe,be){this.g=H,this.h=K,this.j=_,this.k=de,this.l=we,this.m=Pe,this.n=be,this.f=new Map,this.e=F.getProxy(P.MainContext.MainThreadLanguageFeatures)}o(F){return a.DocumentSelector.from(F,this.g)}p(F){return new R.Disposable(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return ce.d++}async s(F,H,K,_,de,we=!1){const Pe=this.f.get(F);if(!Pe||!(Pe.adapter instanceof H))return _;const be=Date.now();we||this.l.trace(`[${Pe.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ce=K(Pe.adapter,Pe.extension);return Promise.resolve(Ce).catch(ke=>{(0,b.isCancellationError)(ke)||(this.l.error(`[${Pe.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Pe.extension.identifier,ke))}).finally(()=>{we||this.l.trace(`[${Pe.extension.identifier.value}] provider DONE after ${Date.now()-be}ms`)}),C.CancellationToken.isCancellationToken(de)?(0,D.raceCancellationError)(Ce,de):Ce}t(F,H){const K=this.q();return this.f.set(K,new te(F,H)),K}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,H,K,_){const de=this.t(new n(this.h,K),F),we=_&&_.label||ce.u(F);return this.e.$registerDocumentSymbolProvider(de,this.o(H),we),this.p(de)}$provideDocumentSymbols(F,H,K){return this.s(F,n,_=>_.provideDocumentSymbols(o.URI.revive(H),K),void 0,K)}registerCodeLensProvider(F,H,K){const _=this.q(),de=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(_,new te(new s(this.h,this.j.converter,K),F)),this.e.$registerCodeLensSupport(_,this.o(H),de);let we=this.p(_);if(de!==void 0){const Pe=K.onDidChangeCodeLenses(be=>this.e.$emitCodeLensEvent(de));we=R.Disposable.from(we,Pe)}return we}$provideCodeLenses(F,H,K){return this.s(F,s,_=>_.provideCodeLenses(o.URI.revive(H),K),void 0,K)}$resolveCodeLens(F,H,K){return this.s(F,s,_=>_.resolveCodeLens(H,K),void 0,void 0)}$releaseCodeLenses(F,H){this.s(F,s,K=>Promise.resolve(K.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(F,H,K){const _=this.t(new c(this.h,K),F);return this.e.$registerDefinitionSupport(_,this.o(H)),this.p(_)}$provideDefinition(F,H,K,_){return this.s(F,c,de=>de.provideDefinition(o.URI.revive(H),K,_),[],_)}registerDeclarationProvider(F,H,K){const _=this.t(new l(this.h,K),F);return this.e.$registerDeclarationSupport(_,this.o(H)),this.p(_)}$provideDeclaration(F,H,K,_){return this.s(F,l,de=>de.provideDeclaration(o.URI.revive(H),K,_),[],_)}registerImplementationProvider(F,H,K){const _=this.t(new m(this.h,K),F);return this.e.$registerImplementationSupport(_,this.o(H)),this.p(_)}$provideImplementation(F,H,K,_){return this.s(F,m,de=>de.provideImplementation(o.URI.revive(H),K,_),[],_)}registerTypeDefinitionProvider(F,H,K){const _=this.t(new i(this.h,K),F);return this.e.$registerTypeDefinitionSupport(_,this.o(H)),this.p(_)}$provideTypeDefinition(F,H,K,_){return this.s(F,i,de=>de.provideTypeDefinition(o.URI.revive(H),K,_),[],_)}registerHoverProvider(F,H,K,_){const de=this.t(new t(this.h,K),F);return this.e.$registerHoverProvider(de,this.o(H)),this.p(de)}$provideHover(F,H,K,_){return this.s(F,t,de=>de.provideHover(o.URI.revive(H),K,_),void 0,_)}registerEvaluatableExpressionProvider(F,H,K,_){const de=this.t(new d(this.h,K),F);return this.e.$registerEvaluatableExpressionProvider(de,this.o(H)),this.p(de)}$provideEvaluatableExpression(F,H,K,_){return this.s(F,d,de=>de.provideEvaluatableExpression(o.URI.revive(H),K,_),void 0,_)}registerInlineValuesProvider(F,H,K,_){const de=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new E(this.h,K),F);this.e.$registerInlineValuesProvider(we,this.o(H),de);let Pe=this.p(we);if(de!==void 0){const be=K.onDidChangeInlineValues(Ce=>this.e.$emitInlineValuesEvent(de));Pe=R.Disposable.from(Pe,be)}return Pe}$provideInlineValues(F,H,K,_,de){return this.s(F,E,we=>we.provideInlineValues(o.URI.revive(H),K,_,de),void 0,de)}registerDocumentHighlightProvider(F,H,K){const _=this.t(new w(this.h,K),F);return this.e.$registerDocumentHighlightProvider(_,this.o(H)),this.p(_)}$provideDocumentHighlights(F,H,K,_){return this.s(F,w,de=>de.provideDocumentHighlights(o.URI.revive(H),K,_),void 0,_)}registerLinkedEditingRangeProvider(F,H,K){const _=this.t(new L(this.h,K),F);return this.e.$registerLinkedEditingRangeProvider(_,this.o(H)),this.p(_)}$provideLinkedEditingRanges(F,H,K,_){return this.s(F,L,async de=>{const we=await de.provideLinkedEditingRanges(o.URI.revive(H),K,_);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ce.w(we.wordPattern):void 0}},void 0,_)}registerReferenceProvider(F,H,K){const _=this.t(new q(this.h,K),F);return this.e.$registerReferenceSupport(_,this.o(H)),this.p(_)}$provideReferences(F,H,K,_,de){return this.s(F,q,we=>we.provideReferences(o.URI.revive(H),K,_,de),void 0,de)}registerCodeActionProvider(F,H,K,_){const de=new y.DisposableStore,we=this.t(new V(this.h,this.j.converter,this.k,K,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(we,this.o(H),{providedKinds:_?.providedCodeActionKinds?.map(Pe=>Pe.value),documentation:_?.documentation?.map(Pe=>({kind:Pe.kind.value,command:this.j.converter.toInternal(Pe.command,de)}))},ce.u(F),Boolean(K.resolveCodeAction)),de.add(this.p(we)),de}$provideCodeActions(F,H,K,_,de){return this.s(F,V,we=>we.provideCodeActions(o.URI.revive(H),K,_,de),void 0,de)}$resolveCodeAction(F,H,K){return this.s(F,V,_=>_.resolveCodeAction(H,K),void 0,void 0)}$releaseCodeActions(F,H){this.s(F,V,K=>Promise.resolve(K.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(F,H,K){const _=this.t(new B(this.h,K),F);return this.e.$registerDocumentFormattingSupport(_,this.o(H),F.identifier,F.displayName||F.name),this.p(_)}$provideDocumentFormattingEdits(F,H,K,_){return this.s(F,B,de=>de.provideDocumentFormattingEdits(o.URI.revive(H),K,_),void 0,_)}registerDocumentRangeFormattingEditProvider(F,H,K){const _=this.t(new N(this.h,K),F);return this.e.$registerRangeFormattingSupport(_,this.o(H),F.identifier,F.displayName||F.name),this.p(_)}$provideDocumentRangeFormattingEdits(F,H,K,_,de){return this.s(F,N,we=>we.provideDocumentRangeFormattingEdits(o.URI.revive(H),K,_,de),void 0,de)}registerOnTypeFormattingEditProvider(F,H,K,_){const de=this.t(new U(this.h,K),F);return this.e.$registerOnTypeFormattingSupport(de,this.o(H),_,F.identifier),this.p(de)}$provideOnTypeFormattingEdits(F,H,K,_,de,we){return this.s(F,U,Pe=>Pe.provideOnTypeFormattingEdits(o.URI.revive(H),K,_,de,we),void 0,we)}registerWorkspaceSymbolProvider(F,H){const K=this.t(new $(H,this.l),F);return this.e.$registerNavigateTypeSupport(K,typeof H.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(F,H,K){return this.s(F,$,_=>_.provideWorkspaceSymbols(H,K),{symbols:[]},K)}$resolveWorkspaceSymbol(F,H,K){return this.s(F,$,_=>_.resolveWorkspaceSymbol(H,K),void 0,void 0)}$releaseWorkspaceSymbols(F,H){this.s(F,$,K=>K.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(F,H,K){const _=this.t(new z(this.h,K,this.l),F);return this.e.$registerRenameSupport(_,this.o(H),z.supportsResolving(K)),this.p(_)}$provideRenameEdits(F,H,K,_,de){return this.s(F,z,we=>we.provideRenameEdits(o.URI.revive(H),K,_,de),void 0,de)}$resolveRenameLocation(F,H,K,_){return this.s(F,z,de=>de.resolveRenameLocation(o.URI.revive(H),K,_),void 0,_)}registerDocumentSemanticTokensProvider(F,H,K,_){const de=this.t(new ee(this.h,K),F),we=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(H),_,we);let Pe=this.p(de);if(we){const be=K.onDidChangeSemanticTokens(Ce=>this.e.$emitDocumentSemanticTokensEvent(we));Pe=R.Disposable.from(Pe,be)}return Pe}$provideDocumentSemanticTokens(F,H,K,_){return this.s(F,ee,de=>de.provideDocumentSemanticTokens(o.URI.revive(H),K,_),null,_)}$releaseDocumentSemanticTokens(F,H){this.s(F,ee,K=>K.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,H,K,_){const de=this.t(new x(this.h,K),F);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(H),_),this.p(de)}$provideDocumentRangeSemanticTokens(F,H,K,_){return this.s(F,x,de=>de.provideDocumentRangeSemanticTokens(o.URI.revive(H),K,_),null,_)}registerCompletionItemProvider(F,H,K,_){const de=this.t(new J(this.h,this.j.converter,K,this.m,F),F);return this.e.$registerCompletionsProvider(de,this.o(H),_,J.supportsResolving(K),`${F.identifier.value}(${_.join("")})`),this.p(de)}$provideCompletionItems(F,H,K,_,de){return this.s(F,J,we=>we.provideCompletionItems(o.URI.revive(H),K,_,de),void 0,de)}$resolveCompletionItem(F,H,K){return this.s(F,J,_=>_.resolveCompletionItem(H,K),void 0,K)}$releaseCompletionItems(F,H){this.s(F,J,K=>K.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(F,H,K){const _=new pe(F,this.h,K,this.j.converter),de=this.t(_,F);return this.e.$registerInlineCompletionsSupport(de,this.o(H),_.supportsHandleEvents),this.p(de)}$provideInlineCompletions(F,H,K,_,de){return this.s(F,ie,we=>we.provideInlineCompletions(o.URI.revive(H),K,_,de),void 0,de)}$handleInlineCompletionDidShow(F,H,K){this.s(F,ie,async _=>{_.handleDidShowCompletionItem(H,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,H,K,_){this.s(F,ie,async de=>{de.handlePartialAccept(H,K,_)},void 0,void 0)}$freeInlineCompletionsList(F,H){this.s(F,ie,async K=>{K.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(F,H,K,_){const de=Array.isArray(_)?{triggerCharacters:_,retriggerCharacters:[]}:_,we=this.t(new Y(this.h,K),F);return this.e.$registerSignatureHelpProvider(we,this.o(H),de),this.p(we)}$provideSignatureHelp(F,H,K,_,de){return this.s(F,Y,we=>we.provideSignatureHelp(o.URI.revive(H),K,_,de),void 0,de)}$releaseSignatureHelp(F,H){this.s(F,Y,K=>K.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(F,H,K){const _=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new Z(this.h,this.j.converter,K,this.l,F),F);this.e.$registerInlayHintsProvider(de,this.o(H),typeof K.resolveInlayHint=="function",_,ce.u(F));let we=this.p(de);if(_!==void 0){const Pe=K.onDidChangeInlayHints(be=>this.e.$emitInlayHintsEvent(_));we=R.Disposable.from(we,Pe)}return we}$provideInlayHints(F,H,K,_){return this.s(F,Z,de=>de.provideInlayHints(o.URI.revive(H),K,_),void 0,_)}$resolveInlayHint(F,H,K){return this.s(F,Z,_=>_.resolveInlayHint(H,K),void 0,K)}$releaseInlayHints(F,H){this.s(F,Z,K=>K.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(F,H,K){const _=this.t(new me(this.h,K),F);return this.e.$registerDocumentLinkProvider(_,this.o(H),typeof K.resolveDocumentLink=="function"),this.p(_)}$provideDocumentLinks(F,H,K){return this.s(F,me,_=>_.provideLinks(o.URI.revive(H),K),void 0,K,H.scheme==="output")}$resolveDocumentLink(F,H,K){return this.s(F,me,_=>_.resolveLink(H,K),void 0,void 0,!0)}$releaseDocumentLinks(F,H){this.s(F,me,K=>K.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(F,H,K){const _=this.t(new ve(this.h,K),F);return this.e.$registerDocumentColorProvider(_,this.o(H)),this.p(_)}$provideDocumentColors(F,H,K){return this.s(F,ve,_=>_.provideColors(o.URI.revive(H),K),[],K)}$provideColorPresentations(F,H,K,_){return this.s(F,ve,de=>de.provideColorPresentations(o.URI.revive(H),K,_),void 0,_)}registerFoldingRangeProvider(F,H,K){const _=this.q(),de=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(_,new te(new Ie(this.h,K),F)),this.e.$registerFoldingRangeProvider(_,this.o(H),F.identifier,de);let we=this.p(_);if(de!==void 0){const Pe=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));we=R.Disposable.from(we,Pe)}return we}$provideFoldingRanges(F,H,K,_){return this.s(F,Ie,de=>de.provideFoldingRanges(o.URI.revive(H),K,_),void 0,_)}registerSelectionRangeProvider(F,H,K){const _=this.t(new Re(this.h,K,this.l),F);return this.e.$registerSelectionRangeProvider(_,this.o(H)),this.p(_)}$provideSelectionRanges(F,H,K,_){return this.s(F,Re,de=>de.provideSelectionRanges(o.URI.revive(H),K,_),[],_)}registerCallHierarchyProvider(F,H,K){const _=this.t(new oe(this.h,K),F);return this.e.$registerCallHierarchyProvider(_,this.o(H)),this.p(_)}$prepareCallHierarchy(F,H,K,_){return this.s(F,oe,de=>Promise.resolve(de.prepareSession(o.URI.revive(H),K,_)),void 0,_)}$provideCallHierarchyIncomingCalls(F,H,K,_){return this.s(F,oe,de=>de.provideCallsTo(H,K,_),void 0,_)}$provideCallHierarchyOutgoingCalls(F,H,K,_){return this.s(F,oe,de=>de.provideCallsFrom(H,K,_),void 0,_)}$releaseCallHierarchy(F,H){this.s(F,oe,K=>Promise.resolve(K.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(F,H,K){const _=this.t(new le(this.h,K),F);return this.e.$registerTypeHierarchyProvider(_,this.o(H)),this.p(_)}$prepareTypeHierarchy(F,H,K,_){return this.s(F,le,de=>Promise.resolve(de.prepareSession(o.URI.revive(H),K,_)),void 0,_)}$provideTypeHierarchySupertypes(F,H,K,_){return this.s(F,le,de=>de.provideSupertypes(H,K,_),void 0,_)}$provideTypeHierarchySubtypes(F,H,K,_){return this.s(F,le,de=>de.provideSubtypes(H,K,_),void 0,_)}$releaseTypeHierarchy(F,H){this.s(F,le,K=>Promise.resolve(K.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(F,H,K){const _=this.q();return this.f.set(_,new te(new ue(this.e,this.h,K,_),F)),this.e.$registerDocumentOnDropEditProvider(_,this.o(H)),this.p(_)}$provideDocumentOnDropEdits(F,H,K,_,de,we){return this.s(F,ue,Pe=>Promise.resolve(Pe.provideDocumentOnDropEdits(H,o.URI.revive(K),_,de,we)),void 0,void 0)}registerDocumentPasteEditProvider(F,H,K,_){const de=this.q();return this.f.set(de,new te(new M(this.e,this.h,K,de),F)),this.e.$registerPasteEditProvider(de,this.o(H),!!K.prepareDocumentPaste,_.pasteMimeTypes),this.p(de)}$prepareDocumentPaste(F,H,K,_,de){return this.s(F,M,we=>we.prepareDocumentPaste(o.URI.revive(H),K,_,de),void 0,de)}$providePasteEdits(F,H,K,_,de,we){return this.s(F,M,Pe=>Pe.providePasteEdits(H,o.URI.revive(K),_,de,we),void 0,we)}static w(F){return{pattern:F.source,flags:(0,S.regExpFlags)(F)}}static y(F){return{decreaseIndentPattern:ce.w(F.decreaseIndentPattern),increaseIndentPattern:ce.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?ce.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?ce.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:ce.w(F.beforeText),afterText:F.afterText?ce.w(F.afterText):void 0,previousLineText:F.previousLineText?ce.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(ce.z)}setLanguageConfiguration(F,H,K){const{wordPattern:_}=K;if(_&&(0,S.regExpLeadsToEndlessLoop)(_))throw new Error(`Invalid language configuration: wordPattern '${_}' is not allowed to match the empty string.`);_?this.h.setWordDefinitionFor(H,_):this.h.setWordDefinitionFor(H,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const de=this.q(),we={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?ce.w(K.wordPattern):void 0,indentationRules:K.indentationRules?ce.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?ce.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport};return this.e.$setLanguageConfiguration(de,H,we),this.p(de)}$setWordDefinitions(F){for(const H of F)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}ce.d=0,e.ExtHostLanguageFeatures=ce}),define(ye[264],De([1,0,5,14,7,37,19,6]),function(ne,e,o,A,a,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(O,T,v,C){this.c=T,this.d=v,this.e=C,this.b=[],this.f=0,this.g=new Set,this.a=O.getProxy(o.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this.b=O}async getLanguages(){return this.b.slice(0)}async changeLanguage(O,T){await this.a.$changeLanguage(O,T);const v=this.c.getDocumentData(O);if(!v)throw new Error(`document '${O.toString()}' NOT found`);return v.document}async tokenAtPosition(O,T){const v=O.version,C=A.Position.from(T),y=await this.a.$tokensAtPosition(O.uri,C),f={type:a.StandardTokenType.Other,range:O.getWordRangeAtPosition(T)??new a.Range(T.line,T.character,T.line,T.character)};if(!y)return f;const h={range:A.Range.to(y.range),type:A.TokenType.to(y.type)};return!h.range.contains(T)||v!==O.version?f:h}createLanguageStatusItem(O,T,v){const C=this.f++,y=this.a,f=this.g,h=`${O.identifier.value}/${T}`;if(f.has(h))throw new Error(`LanguageStatusItem with id '${T}' ALREADY exists`);f.add(h);const u={selector:v,id:T,name:O.displayName??O.name,severity:a.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const b=new P.DisposableStore,D=()=>{g?.dispose(),g=(0,I.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(C,{id:h,name:u.name??O.displayName??O.name,source:O.displayName??O.name,selector:A.DocumentSelector.from(u.selector,this.e),label:u.text,detail:u.detail??"",severity:u.severity===a.LanguageStatusSeverity.Error?R.default.Error:u.severity===a.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:u.command&&this.d.toInternal(u.command,b),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},p={dispose(){b.dispose(),g?.dispose(),y.$removeLanguageStatus(C),f.delete(h)},get id(){return u.id},get name(){return u.name},set name(n){u.name=n,D()},get selector(){return u.selector},set selector(n){u.selector=n,D()},get text(){return u.text},set text(n){u.text=n,D()},get detail(){return u.detail},set detail(n){u.detail=n,D()},get severity(){return u.severity},set severity(n){u.severity=n,D()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(n){u.accessibilityInformation=n,D()},get command(){return u.command},set command(n){u.command=n,D()},get busy(){return u.busy},set busy(n){u.busy=n,D()}};return D(),p}}e.ExtHostLanguages=S}),define(ye[97],De([1,0,10,8,2,4,13,5,25,20]),function(ne,e,o,A,a,R,I,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(v,C,y){this.f=y,this.d=new Map,this.a=C.getProxy(P.MainContext.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===o.LANGUAGE_DEFAULT}getMessage(v,C){const{message:y,args:f,comment:h}=C;if(this.c)return(0,A.format2)(y,f??{});let u=y;h&&h.length>0&&(u+=`/${Array.isArray(h)?h.join(""):h}`);const g=this.d.get(v)?.contents[u];return g||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${u}`),(0,A.format2)(g??y,f??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let C;const y=await this.g(v);if(!y){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(y),h=JSON.parse(f);C=v.isBuiltin?h.contents?.bundle:h}catch(f){this.f.error(`Failed to load translations for ${v.identifier.value} from ${y}: ${f.message}`);return}C&&this.d.set(v.identifier.value,{contents:C,uri:y})}async g(v){if(v.isBuiltin){const C=await this.a.$fetchBuiltInBundleUri(v.identifier.value,this.b);return a.URI.revive(C)}return v.l10n?a.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};O=xe([ze(0,S.IExtHostInitDataService),ze(1,k.IExtHostRpcService),ze(2,I.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(ye[140],De([1,0,13,5,25,20,2,69]),function(ne,e,o,A,a,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let S=class extends o.AbstractLoggerService{constructor(T,v){super(v.logLevel,v.loggers.map(C=>(0,P.revive)(C))),this.l=T.getProxy(A.MainContext.MainThreadLogger)}$setLogLevel(T,v){v?this.setLogLevel(I.URI.revive(v),T):this.setLogLevel(T)}setVisibility(T,v){super.setVisibility(T,v),this.l.$setVisibility(T,v)}k(T,v,C){return new k(this.l,T,v,C)}};S=xe([ze(0,R.IExtHostRpcService),ze(1,a.IExtHostInitDataService)],S),e.ExtHostLoggerService=S;class k extends o.AbstractMessageLogger{constructor(T,v,C,y){super(y?.logLevel==="always"),this.m=T,this.n=v,this.k=!1,this.l=[],this.setLevel(C),this.m.$createLogger(v,y).then(()=>{this.r(this.l),this.k=!0})}g(T,v){const C=[[T,v]];this.k?this.r(C):this.l.push(...C)}r(T){this.m.$log(this.n,T)}}}),define(ye[265],De([1,0,5,13,26]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(P){return P&&P.title}let I=class{constructor(S,k){this.b=k,this.a=S.getProxy(o.MainContext.MainThreadMessageService)}showMessage(S,k,O,T,v){const C={source:{identifier:S.identifier,label:S.displayName||S.name}};let y;typeof T=="string"||R(T)?y=[T,...v]:(C.modal=T?.modal,C.useCustom=T?.useCustom,C.detail=T?.detail,y=v),C.useCustom&&(0,a.checkProposedApiEnabled)(S,"resolvers");const f=[];for(let h=0;h<y.length;h++){const u=y[h];if(typeof u=="string")f.push({title:u,handle:h,isCloseAffordance:!1});else if(typeof u=="object"){const{title:g,isCloseAffordance:b}=u;f.push({title:g,isCloseAffordance:!!b,handle:h})}else this.b.warn("Invalid message item:",u)}return this.a.$showMessage(k,O,C,f).then(h=>{if(typeof h=="number")return y[h]})}};I=xe([ze(1,A.ILogService)],I),e.ExtHostMessageService=I}),define(ye[266],De([1,0,22,3,6,28,8,9,2,74,5,40,14,7,58,241,136]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class u{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,D,p,n){this.q=p,this.r=n,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new A.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(O.MainContext.MainThreadNotebook),this.c=b.getProxy(O.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(O.MainContext.MainThreadNotebookEditors),this.i=D.converter,D.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===13){const r=s.notebookEditor?.notebookUri,c=s.cell.handle,m=this.g.get(r)?.getCell(c);if(m)return m.apiCell}if(s&&s.$mid===14){const r=s.uri,c=this.g.get(r);if(c)return c.apiNotebook}return s}}),u.x(D)}getEditorById(b){const D=this.h.get(b);if(!D)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return D}getIdByEditor(b){for(const[D,p]of this.h)if(p.apiEditor===b)return D}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,D){const p=this.g.get(b);if(!p&&!D)throw new Error(`NO notebook document for '${b}'`);return p}static s(b,D){if(!D)return;const p=D.filenamePattern.map(n=>v.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(D.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:D.displayName,filenamePattern:p,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,D,p){const n=u.a++,s=typeof p.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(n,p),this.b.$registerNotebookCellStatusBarItemProvider(n,s,D);let r;return s!==void 0&&(r=p.onDidChangeCellStatusBarItems(c=>this.b.$emitCellStatusBarEvent(s))),new C.Disposable(()=>{this.f.delete(n),this.b.$unregisterNotebookCellStatusBarItemProvider(n,s),r?.dispose()})}async createNotebookDocument(b){const D=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&v.NotebookData.from(b.content)});return S.URI.revive(D)}async openNotebookDocument(b){const D=this.g.get(b);if(D)return D.apiNotebook;const p=await this.c.$tryOpenNotebook(b),n=this.g.get(S.URI.revive(p));return(0,P.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(b,D){S.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let p;typeof D=="object"?p={position:v.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(v.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:p={preserveFocus:!1};const n=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,p),s=n&&this.h.get(n)?.apiEditor;if(s)return s;throw n?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,D,p,n){const s=this.f.get(b),r=S.URI.revive(D),c=this.g.get(r);if(!c||!s)return;const l=c.getCellFromIndex(p);if(!l)return;const m=await s.provideCellStatusBarItems(l.apiCell,n);if(!m)return;const i=new a.DisposableStore,t=this.p.add([i]),E=(Array.isArray(m)?m:[m]).map(w=>v.NotebookStatusBarItem.from(w,this.i,i));return{cacheId:t,items:E}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,D,p,n,s){if((0,I.isFalsyOrWhitespace)(D))throw new Error("viewType cannot be empty or just whitespace");const r=this.t++;return this.u.set(r,p),this.b.$registerNotebookSerializer(r,{id:b.identifier,location:b.extensionLocation},D,v.NotebookDocumentContentOptions.from(n),u.s(b,s)),(0,a.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(r)})}async $dataToNotebook(b,D,p){const n=this.u.get(b);if(!n)throw new Error("NO serializer found");const s=await n.deserializeNotebook(D.buffer,p);return new y.SerializableObjectWithBuffers(v.NotebookData.from(s))}async $notebookToData(b,D,p){const n=this.u.get(b);if(!n)throw new Error("NO serializer found");const s=await n.serializeNotebook(v.NotebookData.to(D.value),p);return o.VSBuffer.wrap(s)}w(b,D,p){if(this.h.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const n=new h.ExtHostNotebookEditor(D,this.d,b,p.visibleRanges.map(v.NotebookRange.to),p.selections.map(v.NotebookRange.to),typeof p.viewColumn=="number"?v.ViewColumn.to(p.viewColumn):void 0);this.h.set(D,n)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const p of b.value.removedDocuments){const n=S.URI.revive(p),s=this.g.get(n);s&&(s.dispose(),this.g.delete(n),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(r=>r.document.uri)}),this.n.fire(s.apiNotebook));for(const r of this.h.values())r.notebookData.uri.toString()===n.toString()&&this.h.delete(r.id)}if(b.value.addedDocuments){const p=[];for(const n of b.value.addedDocuments){const s=S.URI.revive(n.uri);if(this.g.has(s))throw new Error(`adding EXISTING notebook ${s} `);const r=new f.ExtHostNotebookDocument(this.c,this.q,this.r,s,n);p.push(...n.cells.map(c=>f.ExtHostCell.asModelAddData(r.apiNotebook,c))),this.g.get(s)?.dispose(),this.g.set(s,r),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this.m.fire(r.apiNotebook)}}if(b.value.addedEditors)for(const p of b.value.addedEditors){if(this.h.has(p.id))return;const n=S.URI.revive(p.documentUri),s=this.g.get(n);s&&this.w(s,p.id,p)}const D=[];if(b.value.removedEditors)for(const p of b.value.removedEditors){const n=this.h.get(p);n&&(this.h.delete(p),this.k?.id===n.id&&(this.k=void 0),D.push(n))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(n=>this.h.get(n)).filter(n=>!!n);const p=new Set;this.l.forEach(n=>p.add(n.id));for(const n of this.h.values()){const s=p.has(n.id);n._acceptVisibility(s)}this.l=[...this.h.values()].map(n=>n).filter(n=>n.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.h.get(b.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${b.value.newActiveEditor}`),this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const D=T.ApiCommandArgument.String.with("notebookType","A notebook type"),p=new T.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new T.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>o.VSBuffer.wrap(s))],new T.ApiCommandResult("Notebook Data",s=>v.NotebookData.to(s.value))),n=new T.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new T.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new y.SerializableObjectWithBuffers(v.NotebookData.from(s)))],new T.ApiCommandResult("Bytes",s=>s.buffer));b.registerApiCommand(p),b.registerApiCommand(n)}}u.a=0,e.ExtHostNotebookController=u}),define(ye[267],De([1,0,15,19,21,3,6,28,2,27,13,74,5,40,14,7,95,231,26,58]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let D=class{constructor(l,m,i,t,d){this.k=m,this.l=i,this.m=t,this.n=d,this.b=new P.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new T.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=l.getProxy(v.MainContext.MainThreadNotebookKernels);const E=new C.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new C.ApiCommandArgument("options","Select kernel options",w=>!0,w=>{if(w&&"notebookEditor"in w&&"id"in w){const L=this.l.getIdByEditor(w.notebookEditor);return{id:w.id,extension:w.extension,notebookEditorId:L}}else if(w&&"notebookEditor"in w){const L=this.l.getIdByEditor(w.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${w.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return w})],C.ApiCommandResult.Void);this.m.registerApiCommand(E)}createNotebookController(l,m,i,t,d,E){for(const ie of this.h.values())if(ie.controller.id===m&&k.ExtensionIdentifier.equals(l.identifier,ie.extensionId))throw new Error(`notebook controller with id '${m}' ALREADY exist`);const w=this.i++,L=this;this.n.trace(`NotebookController[${w}], CREATED by ${l.identifier.value}, ${m}`);const q=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${l.identifier}'`);let V=!1;const M=new I.DisposableStore,B=new R.Emitter,N=new R.Emitter,U={id:r(l.identifier,m),notebookType:i,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:t||l.identifier.value,preloads:E?E.map(y.NotebookRendererScript.from):[]};let $=d??q,z;this.a.$addKernel(w,U).catch(ie=>{console.log(ie),V=!0});let ae=0;const ee=()=>{if(V)return;const ie=++ae;Promise.resolve().then(()=>{ie===ae&&this.a.$updateKernel(w,U)})},x=new P.ResourceMap,J={get id(){return m},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return U.label},set label(ie){U.label=ie??l.displayName??l.name,ee()},get detail(){return U.detail??""},set detail(ie){U.detail=ie,ee()},get description(){return U.description??""},set description(ie){U.description=ie,ee()},get kind(){return(0,g.checkProposedApiEnabled)(l,"notebookControllerKind"),U.kind??""},set kind(ie){(0,g.checkProposedApiEnabled)(l,"notebookControllerKind"),U.kind=ie,ee()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(ie){U.supportedLanguages=ie,ee()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){U.supportsExecutionOrder=ie,ee()},get rendererScripts(){return U.preloads?U.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return $},set executeHandler(ie){$=ie??q},get interruptHandler(){return z},set interruptHandler(ie){z=ie,U.supportsInterrupt=Boolean(ie),ee()},createNotebookCellExecution(ie){if(V)throw new Error("notebook controller is DISPOSED");if(!x.has(ie.notebook.uri))throw L.n.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(pe=>pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return L._createNotebookCellExecution(ie,r(l.identifier,this.id))},dispose:()=>{V||(this.n.trace(`NotebookController[${w}], DISPOSED`),V=!0,this.h.delete(w),M.dispose(),B.dispose(),N.dispose(),this.a.$removeKernel(w))},updateNotebookAffinity(ie,pe){pe===f.NotebookControllerAffinity2.Hidden&&(0,g.checkProposedApiEnabled)(l,"notebookControllerAffinityHidden"),L.a.$updateNotebookPriority(w,ie.uri,pe)},onDidReceiveMessage:N.event,postMessage(ie,pe){return(0,g.checkProposedApiEnabled)(l,"notebookMessaging"),L.a.$postMessage(w,pe&&L.l.getIdByEditor(pe),ie)},asWebviewUri(ie){return(0,g.checkProposedApiEnabled)(l,"notebookMessaging"),(0,h.asWebviewUri)(ie,L.k.remote)}};return this.h.set(w,{extensionId:l.identifier,controller:J,onDidReceiveMessage:N,onDidChangeSelection:B,associatedNotebooks:x}),J}getIdByController(l){for(const[m,i]of this.h)if(i.controller===l)return r(i.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,m){const i=this.d++,t=this;this.n.trace(`NotebookControllerDetectionTask[${i}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(i,m);const d={dispose:()=>{this.c.delete(i),t.a.$removeKernelDetectionTask(i)}};return this.c.set(i,d),d}registerKernelSourceActionProvider(l,m,i){const t=this.f++,d=typeof i.onDidChangeNotebookKernelSourceActions=="function"?t:void 0,E=this;this.e.set(t,i),this.n.trace(`NotebookKernelSourceActionProvider[${t}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(t,t,m);let w;return d!==void 0&&(w=i.onDidChangeNotebookKernelSourceActions(L=>this.a.$emitNotebookKernelSourceActionsChangeEvent(d))),{dispose:()=>{this.e.delete(t),E.a.$removeKernelSourceActionProvider(t,t),w?.dispose()}}}async $provideKernelSourceActions(l,m){const i=this.e.get(l);if(i){const t=new I.DisposableStore;return this.g.add([t]),(await i.provideNotebookKernelSourceActions(m)??[]).map(E=>y.NotebookKernelSourceAction.from(E,this.m.converter,t))}return[]}$acceptNotebookAssociation(l,m,i){const t=this.h.get(l);if(t){const d=this.l.getNotebookDocument(S.URI.revive(m));i?t.associatedNotebooks.set(d.uri,!0):t.associatedNotebooks.delete(d.uri),this.n.trace(`NotebookController[${l}] ASSOCIATE notebook`,d.uri.toString(),i),t.onDidChangeSelection.fire({selected:i,notebook:d.apiNotebook})}}async $executeCells(l,m,i){const t=this.h.get(l);if(!t)return;const d=this.l.getNotebookDocument(S.URI.revive(m)),E=[];for(const w of i){const L=d.getCell(w);L&&E.push(L.apiCell)}try{this.n.trace(`NotebookController[${l}] EXECUTE cells`,d.uri.toString(),E.length),await t.controller.executeHandler.call(t.controller,E,d.apiNotebook,t.controller)}catch(w){this.n.error(`NotebookController[${l}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(l,m,i){const t=this.h.get(l);if(!t)return;const d=this.l.getNotebookDocument(S.URI.revive(m));if(t.controller.interruptHandler)await t.controller.interruptHandler.call(t.controller,d.apiNotebook);else for(const E of i){const w=d.getCell(E);w&&this.b.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(l,m,i){const t=this.h.get(l);if(!t)return;const d=this.l.getEditorById(m);t.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:i}))}$cellExecutionChanged(l,m,i){const d=this.l.getNotebookDocument(S.URI.revive(l)).getCell(m);if(d){const E=i?y.NotebookCellExecutionState.to(i):f.NotebookCellExecutionState.Idle;E!==void 0&&this.j.fire({cell:d.apiCell,state:E})}}_createNotebookCellExecution(l,m){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this.l.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!t)throw new Error("invalid cell");if(this.b.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const d=new n(m,t,this.a);this.b.set(t.uri,d);const E=d.onDidChangeState(()=>{d.state===p.Resolved&&(d.dispose(),E.dispose(),this.b.delete(t.uri))});return d.asApiObject()}};D=xe([ze(4,O.ILogService)],D),e.ExtHostNotebookKernels=D;var p;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(p||(p={}));class n extends I.Disposable{get state(){return this.f}constructor(l,m,i){super(),this.j=m,this.k=i,this.b=n.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new a.CancellationTokenSource),this.h=new s(10,t=>this.m(t)),this.i=m.internalMetadata.executionOrder,this.k.$createExecution(this.b,l,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(l){await this.h.addItem(l)}async m(l){const m=Array.isArray(l)?l:[l];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(m))}n(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(l){let m=this.j;if(l&&(m=this.j.notebook.getCellFromApiCell(l)),!m)throw new Error("INVALID cell");return m.handle}s(l){return l.map(m=>{const i=f.NotebookCellOutput.ensureUniqueMimeTypes(m.items,!0);return i===m.items?y.NotebookCellOutput.from(m):y.NotebookCellOutput.from({items:i,id:m.id,metadata:m.metadata})})}async t(l,m,i){const t=this.r(m),d=this.s((0,o.asArray)(l));return this.l({editType:u.CellExecutionUpdateType.Output,cellHandle:t,append:i,outputs:d})}async w(l,m,i){return l=f.NotebookCellOutput.ensureUniqueMimeTypes((0,o.asArray)(l),!0),this.l({editType:u.CellExecutionUpdateType.OutputItems,items:l.map(y.NotebookCellOutputItem.from),outputId:m.id,append:i})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.j.apiCell},get executionOrder(){return l.i},set executionOrder(i){l.i=i,l.m([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:l.i}])},start(i){if(l.f===p.Resolved||l.f===p.Started)throw new Error("Cannot call start again");l.f=p.Started,l.c.fire(),l.m({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:i})},end(i,t){if(l.f===p.Resolved)throw new Error("Cannot call resolve twice");l.f=p.Resolved,l.c.fire(),l.h.flush(),l.k.$completeExecution(l.b,new b.SerializableObjectWithBuffers({runEndTime:t,lastRunSuccess:i}))},clearOutput(i){return l.n(),l.t([],i,!1)},appendOutput(i,t){return l.n(),l.t(i,t,!0)},replaceOutput(i,t){return l.n(),l.t(i,t,!1)},appendOutputItems(i,t){return l.n(),l.w(i,t,!0)},replaceOutputItems(i,t){return l.n(),l.w(i,t,!1)}})}}n.a=0;class s{constructor(l,m){this.d=l,this.e=m,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new A.DeferredPromise,this.b=Date.now(),(0,A.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const m=this.a;return this.a=[],this.e(m).finally(()=>l.complete())}}function r(c,l){return`${c.value}/${l}`}e.createKernelId=r}),define(ye[268],De([1,0,3,5,136]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(P,S){this.c=S,this.a=new Map,this.b=P.getProxy(A.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,S,k){const O=this.c.getEditorById(P);this.a.get(S)?.fire({editor:O.apiEditor,message:k})}createRendererMessaging(P,S){if(!P.contributes?.notebookRenderer?.some(O=>O.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(O,T,v)=>this.d(S).event(O,T,v),postMessage:(O,T)=>{a.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,T]=[T,O]);const v=T&&a.ExtHostNotebookEditor.apiEditorsToExtHost.get(T);return this.b.$postMessage(v?.id,S,O)}}}d(P){let S=this.a.get(P);return S||(S=new o.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(P)}}),this.a.set(P,S),S)}}e.ExtHostNotebookRenderers=R}),define(ye[269],De([1,0,6,9,2,26,5]),function(ne,e,o,A,a,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class P{constructor(k){this.b=new Map,this.a=k.getProxy(I.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(k,O,T){if((0,R.checkProposedApiEnabled)(k,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,T),this.a.$registerProfileContentHandler(O,T.name,T.description,k.identifier.value),(0,o.toDisposable)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(k,O,T,v){const C=this.b.get(k);if(!C)throw new Error(`Unknown handler with id: ${k}`);return C.saveProfile(O,T,v)}async $readProfile(k,O,T){const v=this.b.get(k);if(!v)throw new Error(`Unknown handler with id: ${k}`);return v.readProfile((0,A.isString)(O)?O:a.URI.revive(O),T)}}e.ExtHostProfileContentHandlers=P}),define(ye[270],De([1,0,2,5,19,14]),function(ne,e,o,A,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class I{constructor(S,k){this.d=k,this.c=new Map,this.b=S.getProxy(A.MainContext.MainThreadQuickDiff)}$provideOriginalResource(S,k,O){const T=o.URI.revive(k),v=this.c.get(S);return v?(0,a.asPromise)(()=>v.provideOriginalResource(T,O)).then(C=>C||null):Promise.resolve(null)}registerQuickDiffProvider(S,k,O,T){const v=I.a++;return this.c.set(v,k),this.b.$registerQuickDiffProvider(v,R.DocumentSelector.from(S,this.d),O,T),{dispose:()=>{this.b.$unregisterQuickDiffProvider(v),this.c.delete(v)}}}}I.a=0,e.ExtHostQuickDiff=I}),define(ye[271],De([1,0,21,3,6,5,2,7,12,15,37,51,26,14]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function y(f,h,u){const g=f.getProxy(R.MainContext.MainThreadQuickOpen);class b{constructor(i,t){this.e=new Map,this.f=0,this.a=i,this.b=t}showQuickPick(i,t,d,E=o.CancellationToken.None){this.c=void 0;const w=Promise.resolve(t),L=++this.f,q=g.$show(L,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},E),V={},M=q.then(()=>V);return Promise.race([M,w]).then(B=>{if(B===V)return;const N=(0,v.isProposedApiEnabled)(i,"quickPickItemTooltip");return w.then(U=>{const $=[];for(let z=0;z<U.length;z++){const ae=U[z];typeof ae=="string"?$.push({label:ae,handle:z}):ae.kind===P.QuickPickItemKind.Separator?$.push({type:"separator",label:ae.label}):(ae.tooltip&&!N&&console.warn(`Extension '${i.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${i.identifier.value}`),$.push({label:ae.label,description:ae.description,detail:ae.detail,picked:ae.picked,alwaysShow:ae.alwaysShow,tooltip:N?C.MarkdownString.fromStrict(ae.tooltip):void 0,handle:z}))}return d&&typeof d.onDidSelectItem=="function"&&(this.c=z=>{d.onDidSelectItem(U[z])}),g.$setItems(L,$),q.then(z=>{if(typeof z=="number")return U[z];if(Array.isArray(z))return z.map(ae=>U[ae])})})}).then(void 0,B=>{if(!(0,S.isCancellationError)(B))return g.$setError(L,B),Promise.reject(B)})}$onItemSelected(i){this.c?.(i)}showInput(i,t=o.CancellationToken.None){return this.d=i?.validateInput,g.$input(i,typeof this.d=="function",t).then(void 0,d=>{if(!(0,S.isCancellationError)(d))return Promise.reject(d)})}async $validateInput(i){if(!this.d)return;const t=await this.d(i);if(!t||typeof t=="string")return t;let d;switch(t.severity){case P.InputBoxValidationSeverity.Info:d=O.default.Info;break;case P.InputBoxValidationSeverity.Warning:d=O.default.Warning;break;case P.InputBoxValidationSeverity.Error:d=O.default.Error;break;default:d=t.message?O.default.Error:O.default.Ignore;break}return{content:t.message,severity:d}}async showWorkspaceFolderPick(i,t=o.CancellationToken.None){const d=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!d)return;const E=await this.a.getWorkspaceFolders2();if(!!E)return E.find(w=>w.uri.toString()===d.uri.toString())}createQuickPick(i){const t=new c(i,()=>this.e.delete(t._id));return this.e.set(t._id,t),t}createInputBox(i){const t=new l(i,()=>this.e.delete(t._id));return this.e.set(t._id,t),t}$onDidChangeValue(i,t){this.e.get(i)?._fireDidChangeValue(t)}$onDidAccept(i){this.e.get(i)?._fireDidAccept()}$onDidChangeActive(i,t){const d=this.e.get(i);d instanceof c&&d._fireDidChangeActive(t)}$onDidChangeSelection(i,t){const d=this.e.get(i);d instanceof c&&d._fireDidChangeSelection(t)}$onDidTriggerButton(i,t){this.e.get(i)?._fireDidTriggerButton(t)}$onDidTriggerItemButton(i,t,d){const E=this.e.get(i);E instanceof c&&E._fireDidTriggerItemButton(t,d)}$onDidHide(i){this.e.get(i)?._fireDidHide()}}class D{constructor(i,t){this.x=i,this.y=t,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new A.Emitter,this.q=new A.Emitter,this.r=new A.Emitter,this.s=new A.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(i){this.b=i,this.z({title:i})}get step(){return this.c}set step(i){this.c=i,this.z({step:i})}get totalSteps(){return this.d}set totalSteps(i){this.d=i,this.z({totalSteps:i})}get enabled(){return this.g}set enabled(i){this.g=i,this.z({enabled:i})}get busy(){return this.j}set busy(i){this.j=i,this.z({busy:i})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(i){this.k=i,this.z({ignoreFocusOut:i})}get value(){return this.l}set value(i){this.l=i,this.z({value:i})}get placeholder(){return this.m}set placeholder(i){this.m=i,this.z({placeholder:i})}get buttons(){return this.n}set buttons(i){this.n=i.slice(),this.o.clear(),i.forEach((t,d)=>{const E=t===P.QuickInputButtons.Back?-1:d;this.o.set(E,t)}),this.z({buttons:i.map((t,d)=>({...r(t),tooltip:t.tooltip,handle:t===P.QuickInputButtons.Back?-1:d}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(i){this.l=i,this.q.fire(i)}_fireDidTriggerButton(i){const t=this.o.get(i);t&&this.r.fire(t)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,a.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),g.$dispose(this._id))}z(i){if(!this.v){for(const t of Object.keys(i)){const d=i[t];this.u[t]=d===void 0?null:d}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){g.$createOrUpdate(this.u),this.u={id:this._id}}}D.a=1;function p(m){if(m instanceof P.ThemeIcon)return{id:m.id};const i=s(m),t=n(m);return{dark:typeof i=="string"?I.URI.file(i):i,light:typeof t=="string"?I.URI.file(t):t}}function n(m){return typeof m=="object"&&"light"in m?m.light:m}function s(m){return typeof m=="object"&&"dark"in m?m.dark:m}function r(m){const i=p(m.iconPath);let t,d;return"id"in i?d=T.ThemeIcon.asClassName(i):t=i,{iconPath:t,iconClass:d}}class c extends D{constructor(i,t){super(i.identifier,t),this.O=i,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new A.Emitter,this.L=[],this.M=new A.Emitter,this.N=new A.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(i){this.B=i.slice(),this.C.clear(),this.D.clear(),i.forEach((E,w)=>{this.C.set(w,E),this.D.set(E,w)});const t=(0,v.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),d=[];for(let E=0;E<i.length;E++){const w=i[E];w.kind===P.QuickPickItemKind.Separator?d.push({type:"separator",label:w.label}):(w.tooltip&&!t&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),d.push({handle:E,label:w.label,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:t?C.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((L,q)=>({...r(L),tooltip:L.tooltip,handle:q}))}))}this.z({items:d})}get canSelectMany(){return this.E}set canSelectMany(i){this.E=i,this.z({canSelectMany:i})}get matchOnDescription(){return this.F}set matchOnDescription(i){this.F=i,this.z({matchOnDescription:i})}get matchOnDetail(){return this.G}set matchOnDetail(i){this.G=i,this.z({matchOnDetail:i})}get sortByLabel(){return this.H}set sortByLabel(i){this.H=i,this.z({sortByLabel:i})}get keepScrollPosition(){return this.I}set keepScrollPosition(i){this.I=i,this.z({keepScrollPosition:i})}get activeItems(){return this.J}set activeItems(i){this.J=i.filter(t=>this.D.has(t)),this.z({activeItems:this.J.map(t=>this.D.get(t))})}get selectedItems(){return this.L}set selectedItems(i){this.L=i.filter(t=>this.D.has(t)),this.z({selectedItems:this.L.map(t=>this.D.get(t))})}_fireDidChangeActive(i){const t=(0,k.coalesce)(i.map(d=>this.C.get(d)));this.J=t,this.K.fire(t)}_fireDidChangeSelection(i){const t=(0,k.coalesce)(i.map(d=>this.C.get(d)));this.L=t,this.M.fire(t)}_fireDidTriggerItemButton(i,t){const d=this.C.get(i);if(!d||!d.buttons||!d.buttons.length)return;const E=d.buttons[t];E&&this.N.fire({button:E,item:d})}}class l extends D{constructor(i,t){super(i.identifier,t),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(i){this.B=i,this.z({password:i})}get prompt(){return this.C}set prompt(i){this.C=i,this.z({prompt:i})}get valueSelection(){return this.D}set valueSelection(i){this.D=i,this.z({valueSelection:i})}get validationMessage(){return this.E}set validationMessage(i){this.E=i,i?typeof i=="string"?this.z({validationMessage:i,severity:O.default.Error}):this.z({validationMessage:i.message,severity:i.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new b(h,u)}e.createExtHostQuickOpen=y});var Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(ne):A?A.value:e.get(ne)},_e=this&&this.__classPrivateFieldSet||function(ne,e,o,A,a){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!a:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?a.call(ne,o):a?a.value=o:e.set(ne,o),o};define(ye[272],De([1,0,2,3,62,6,19,5,15,108,13,27,51,14,26]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y){"use strict";var f,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(t){if(t)return typeof t.iconPath=="string"?o.URI.file(t.iconPath):o.URI.isUri(t.iconPath)||v.ThemeIcon.isThemeIcon(t.iconPath)?t.iconPath:void 0}function g(t,d){if(!t.iconPath&&!d.iconPath)return 0;if(t.iconPath){if(!d.iconPath)return 1}else return-1;const E=typeof t.iconPath=="string"?t.iconPath:o.URI.isUri(t.iconPath)?t.iconPath.fsPath:t.iconPath.id,w=typeof d.iconPath=="string"?d.iconPath:o.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,k.comparePaths)(E,w)}function b(t,d){let E=0;if(t.strikeThrough!==d.strikeThrough)return t.strikeThrough?1:-1;if(t.faded!==d.faded)return t.faded?1:-1;if(t.tooltip!==d.tooltip)return(t.tooltip||"").localeCompare(d.tooltip||"");if(E=g(t,d),E!==0)return E;if(t.light&&d.light)E=g(t.light,d.light);else{if(t.light)return 1;if(d.light)return-1}if(E!==0)return E;if(t.dark&&d.dark)E=g(t.dark,d.dark);else{if(t.dark)return 1;if(d.dark)return-1}return E}function D(t,d){if(t.command!==d.command)return t.command<d.command?-1:1;if(t.title!==d.title)return t.title<d.title?-1:1;if(t.tooltip!==d.tooltip){if(t.tooltip!==void 0&&d.tooltip!==void 0)return t.tooltip<d.tooltip?-1:1;if(t.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(t.arguments===d.arguments)return 0;if(t.arguments)if(d.arguments){if(t.arguments.length!==d.arguments.length)return t.arguments.length-d.arguments.length}else return 1;else return-1;for(let E=0;E<t.arguments.length;E++){const w=t.arguments[E],L=d.arguments[E];if(w!==L)return w<L?-1:1}return 0}function p(t,d){let E=(0,k.comparePaths)(t.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(E!==0)return E;if(t.command&&d.command)E=D(t.command,d.command);else{if(t.command)return 1;if(d.command)return-1}if(E!==0)return E;if(t.decorations&&d.decorations)E=b(t.decorations,d.decorations);else{if(t.decorations)return 1;if(d.decorations)return-1}return E}function n(t,d){for(let E=0;E<t.length;E++)if(t[E]!==d[E])return!1;return!0}function s(t,d){return t.command===d.command&&t.title===d.title&&t.tooltip===d.tooltip&&(t.arguments&&d.arguments?n(t.arguments,d.arguments):t.arguments===d.arguments)}function r(t,d){return(0,S.equals)(t,d,s)}class c{get value(){return this.d}set value(d){d=d??"",Ue(this,f,"f").$setInputBoxValue(this.l,d),this.m(d)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(d){Ue(this,f,"f").$setInputBoxPlaceholder(this.l,d),this.f=d}get validateInput(){return(0,y.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(d){if((0,y.checkProposedApiEnabled)(this.k,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=d,Ue(this,f,"f").$setValidationProviderIsEnabled(this.l,!!d)}get enabled(){return this.h}set enabled(d){d=!!d,this.h!==d&&(this.h=d,Ue(this,f,"f").$setInputBoxEnablement(this.l,d))}get visible(){return this.j}set visible(d){d=!!d,this.j!==d&&(this.j=d,Ue(this,f,"f").$setInputBoxVisibility(this.l,d))}constructor(d,E,w){this.k=d,this.l=w,f.set(this,void 0),this.d="",this.e=new A.Emitter,this.f="",this.h=!0,this.j=!0,_e(this,f,E,"f")}showValidationMessage(d,E){(0,y.checkProposedApiEnabled)(this.k,"scmValidation"),Ue(this,f,"f").$showValidationMessage(this.l,d,E)}$onInputBoxValueChange(d){this.m(d)}m(d){this.d=d,this.e.fire(d)}}e.ExtHostSCMInputBox=c,f=new WeakMap;class l{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(d){this.v=d,this.q.$updateGroupLabel(this.t,this.handle,d)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(d){this.p=d,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(d){this.f=[...d],this.k.fire()}constructor(d,E,w,L,q){this.q=d,this.s=E,this.t=w,this.u=L,this.v=q,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new A.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new A.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=l.d++}getResourceState(d){return this.g.get(d)}$executeResourceCommand(d,E){const w=this.h.get(d);return w?(0,I.asPromise)(()=>this.s.executeCommand(w.command,...w.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this.f].sort(p),w=(0,S.sortedDiff)(this.o,d,p).map(V=>{const M=V.toInsert.map(B=>{const N=this.e++;this.g.set(N,B);const U=B.resourceUri;let $;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const Z=new R.DisposableStore;$=this.s.converter.toInternal(B.command,Z),this.j.set(N,Z)}else this.h.set(N,B.command);const z=u(B.decorations),ae=B.decorations&&u(B.decorations.light)||z,ee=B.decorations&&u(B.decorations.dark)||z,x=[ae,ee],J=B.decorations&&B.decorations.tooltip||"",ie=B.decorations&&!!B.decorations.strikeThrough,pe=B.decorations&&!!B.decorations.faded,Q=B.contextValue||"";return{rawResource:[N,U,x,J,ie,pe,Q,$],handle:N}});return{start:V.start,deleteCount:V.deleteCount,toInsert:M}}),L=w.map(({start:V,deleteCount:M,toInsert:B})=>[V,M,B.map(N=>N.rawResource)]),q=w.reverse();for(const{start:V,deleteCount:M,toInsert:B}of q){const N=B.map($=>$.handle),U=this.n.splice(V,M,...N);for(const $ of U)this.g.delete($),this.h.delete($),this.j.get($)?.dispose(),this.j.delete($)}return this.o=d,L}dispose(){this.l=!0,this.m.fire()}}l.d=0;class m{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(d){this.g!==d&&(this.g=d,Ue(this,h,"f").$updateSourceControl(this.t,{count:d}))}get quickDiffProvider(){return this.h}set quickDiffProvider(d){this.h=d,d?.label&&(0,y.checkProposedApiEnabled)(this.u,"quickDiffProvider"),Ue(this,h,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!d,quickDiffLabel:d?.label})}get commitTemplate(){return this.j}set commitTemplate(d){d!==this.j&&(this.j=d,Ue(this,h,"f").$updateSourceControl(this.t,{commitTemplate:d}))}get acceptInputCommand(){return this.l}set acceptInputCommand(d){this.k.value=new R.DisposableStore,this.l=d;const E=this.v.converter.toInternal(d,this.k.value);Ue(this,h,"f").$updateSourceControl(this.t,{acceptInputCommand:E})}get actionButton(){return(0,y.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(d){(0,y.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=d;const E=d!==void 0?{command:this.v.converter.toInternal(d.command,this.m.value),secondaryCommands:d.secondaryCommands?.map(w=>w.map(L=>this.v.converter.toInternal(L,this.m.value))),description:d.description,enabled:d.enabled}:void 0;Ue(this,h,"f").$updateSourceControl(this.t,{actionButton:E??null})}get statusBarCommands(){return this.p}set statusBarCommands(d){if(this.p&&d&&r(this.p,d))return;this.o.value=new R.DisposableStore,this.p=d;const E=(d||[]).map(w=>this.v.converter.toInternal(w,this.o.value));Ue(this,h,"f").$updateSourceControl(this.t,{statusBarCommands:E})}get selected(){return this.q}constructor(d,E,w,L,q,V){this.u=d,this.v=w,this.w=L,this.x=q,this.y=V,h.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new A.Emitter,this.onDidChangeSelection=this.s.event,this.t=m.d++,this.z=new Map,this.A=new Set,_e(this,h,E,"f"),this.f=new c(d,Ue(this,h,"f"),this.t),Ue(this,h,"f").$registerSourceControl(this.t,L,q,V)}createResourceGroup(d,E){const w=new l(Ue(this,h,"f"),this.v,this.t,d,E),L=A.Event.once(w.onDidDispose)(()=>this.z.delete(w));return this.z.set(w,L),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const d=[],E=[];for(const[w,L]of this.z){L.dispose();const q=w.onDidUpdateResourceStates(()=>{this.A.add(w),this.eventuallyUpdateResourceStates()});A.Event.once(w.onDidDispose)(()=>{this.A.delete(w),q.dispose(),this.e.delete(w.handle),Ue(this,h,"f").$unregisterGroup(this.t,w.handle)}),d.push([w.handle,w.id,w.label,w.features]);const V=w._takeResourceStateSnapshot();V.length>0&&E.push([w.handle,V]),this.e.set(w.handle,w)}Ue(this,h,"f").$registerGroups(this.t,d,E),this.z.clear()}eventuallyUpdateResourceStates(){const d=[];this.A.forEach(E=>{const w=E._takeResourceStateSnapshot();w.length!==0&&d.push([E.handle,w])}),d.length>0&&Ue(this,h,"f").$spliceResourceStates(this.t,d),this.A.clear()}getResourceGroup(d){return this.e.get(d)}setSelectionState(d){this.q=d,this.s.fire(d)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(d=>d.dispose()),Ue(this,h,"f").$unregisterSourceControl(this.t)}}h=new WeakMap,m.d=0,xe([(0,a.debounce)(100)],m.prototype,"eventuallyAddResourceGroups",null),xe([(0,a.debounce)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let i=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(d,E,w){this.l=E,this.m=w,this.g=new Map,this.h=new Map,this.j=new A.Emitter,this.e=d.getProxy(P.MainContext.MainThreadSCM),this.f=d.getProxy(P.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const q=this.g.get(L.sourceControlHandle);if(!q)return L;const V=q.getResourceGroup(L.groupHandle);return V?V.getResourceState(L.handle):L}else if(L&&L.$mid===4){const q=this.g.get(L.sourceControlHandle);return q?q.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const q=this.g.get(L.handle);return q||L}return L}})}createSourceControl(d,E,w,L){this.m.trace("ExtHostSCM#createSourceControl",d.identifier.value,E,w,L),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const q=on.d++,V=new m(d,this.e,this.l,E,w,L);this.g.set(q,V);const M=this.h.get(T.ExtensionIdentifier.toKey(d.identifier))||[];return M.push(V),this.h.set(T.ExtensionIdentifier.toKey(d.identifier),M),V}getLastInputBox(d){this.m.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const E=this.h.get(T.ExtensionIdentifier.toKey(d.identifier)),w=E&&E[E.length-1];return w&&w.inputBox}$provideOriginalResource(d,E,w){const L=o.URI.revive(E);this.m.trace("ExtHostSCM#$provideOriginalResource",d,L.toString());const q=this.g.get(d);return!q||!q.quickDiffProvider||!q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>q.quickDiffProvider.provideOriginalResource(L,w)).then(V=>V||null)}$onInputBoxValueChange(d,E){this.m.trace("ExtHostSCM#$onInputBoxValueChange",d);const w=this.g.get(d);return w&&w.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(d,E,w,L){this.m.trace("ExtHostSCM#$executeResourceCommand",d,E,w);const q=this.g.get(d);if(!q)return Promise.resolve(void 0);const V=q.getResourceGroup(E);return V?V.$executeResourceCommand(w,L):Promise.resolve(void 0)}$validateInput(d,E,w){this.m.trace("ExtHostSCM#$validateInput",d);const L=this.g.get(d);return!L||!L.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>L.inputBox.validateInput(E,w)).then(q=>{if(!q)return Promise.resolve(void 0);const V=C.MarkdownString.fromStrict(q.message);return V?Promise.resolve([V,q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this.g.get(d)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=d,Promise.resolve(void 0)}};i.d=0,i=xe([ze(2,O.ILogService)],i),e.ExtHostSCM=i}),define(ye[98],De([1,0,5,3,4]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(P){this.b=new A.Emitter,this.onDidChangePassword=this.b.event,this.a=P.getProxy(o.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this.b.fire(P)}get(P,S){return this.a.$getPassword(P,S)}store(P,S,k){return this.a.$setPassword(P,S,k)}delete(P,S){return this.a.$deletePassword(P,S)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,a.createDecorator)("IExtHostSecretState")});var _e=this&&this.__classPrivateFieldSet||function(ne,e,o,A,a){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!a:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?a.call(ne,o):a?a.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[273],De([1,0,7,5,180,6,14,9]),function(ne,e,o,A,a,R,I,P){"use strict";var S,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(y,f,h,u,g=o.StatusBarAlignment.Left,b){S.set(this,void 0),k.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new R.DisposableStore,_e(this,S,y,"f"),_e(this,k,f,"f"),this.c=O.a++,this.e=h,this.f=u,this.g=g,this.h=this.u(b)}u(y){if(!!(0,P.isNumber)(y))return y===Number.POSITIVE_INFINITY?Number.MAX_VALUE:y===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:y}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(y){this.k=y,this.v()}set name(y){this.m=y,this.v()}set tooltip(y){this.l=y,this.v()}set color(y){this.n=y,this.v()}set backgroundColor(y){y&&!O.b.has(y.id)&&(y=void 0),this.o=y,this.v()}set command(y){this.r?.fromApi!==y&&(this.p&&this.q.add(this.p),this.p=new R.DisposableStore,typeof y=="string"?this.r={fromApi:y,internal:Ue(this,k,"f").toInternal({title:"",command:y},this.p)}:y?this.r={fromApi:y,internal:Ue(this,k,"f").toInternal(y,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(y){this.t=y,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ue(this,S,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let y;this.e?this.f?y=`${this.e.identifier.value}.${this.f}`:y=this.e.identifier.value:y=this.f;let f;this.m?f=this.m:f=(0,a.localize)(0,null,this.e.displayName||this.e.name);let h=this.n;this.o&&(h=O.b.get(this.o.id));const u=I.MarkdownString.fromStrict(this.l);Ue(this,S,"f").$setEntry(this.c,y,f,this.k,u,this.r?.internal,h,this.o,this.g===o.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}S=new WeakMap,k=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new o.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new o.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=O;class T{constructor(y){this.b=[],this.a=y.createStatusBarEntry(void 0,"status.extensionMessage",o.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,a.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(y){const f={message:y};return this.b.unshift(f),this.c(),new o.Disposable(()=>{const h=this.b.indexOf(f);h>=0&&(this.b.splice(h,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class v{constructor(y,f){this.a=y.getProxy(A.MainContext.MainThreadStatusBar),this.b=f,this.c=new T(this)}createStatusBarEntry(y,f,h,u){return new O(this.a,this.b,y,f,h,u)}setStatusBarMessage(y,f){const h=this.c.setMessage(y);let u;return typeof f=="number"?u=setTimeout(()=>h.dispose(),f):typeof f<"u"&&f.then(()=>h.dispose(),()=>h.dispose()),new o.Disposable(()=>{h.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=v}),define(ye[99],De([1,0,5,3,4]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(P,S){this.c=S,this.b=new A.Emitter,this.onDidChangeStorage=this.b.event,this.a=P.getProxy(o.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,S){this.a.$registerExtensionStorageKeysToSync(P,S)}async initializeExtensionStorage(P,S,k){const O=await this.a.$initializeExtensionStorage(P,S);let T;return O&&(T=this.d(P,S,O)),T||k}setValue(P,S,k){return this.a.$setValue(P,S,k)}$acceptValue(P,S,k){const O=this.d(P,S,k);O&&this.b.fire({shared:P,key:S,value:O})}d(P,S,k){try{return JSON.parse(k)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${P}): ${O}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,a.createDecorator)("IExtHostStorage")}),define(ye[79],De([1,0,4,25,13,78,2]),function(ne,e,o,A,a,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,o.createDecorator)("IExtensionStoragePaths");let P=class{constructor(k,O,T){this.d=O,this.f=T,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(k){return I.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,O=await this.g(k);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(I.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:I.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(T){this.d.error("[ExtHostStorage]",T);return}}workspaceValue(k){if(this.c)return I.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return I.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=xe([ze(0,A.IExtHostInitDataService),ze(1,a.ILogService),ze(2,R.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(ye[41],De([1,0,3,5,4,2,20,6,7,182,12,214,21,30,215,51,9,19,14]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,a.createDecorator)("IExtHostTerminalService");class b{constructor(i,t,d,E){this.k=i,this._id=t,this.l=d,this.m=E,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(L=>this.f=L);const w=this;this.value={get name(){return w.m||""},get processId(){return w.b},get creationOptions(){return w.l},get exitStatus(){return w.h},get state(){return w.j},sendText(L,q=!0){w.o(),w.k.$sendText(w._id,L,q)},show(L){w.o(),w.k.$show(w._id,L)},hide(){w.o(),w.k.$hide(w._id)},dispose(){w.a||(w.a=!0,w.k.$dispose(w._id))},get dimensions(){if(!(w.d===void 0||w.g===void 0))return{columns:w.d,rows:w.g}}}}async create(i,t){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:i.name,shellPath:(0,h.withNullAsUndefined)(i.shellPath),shellArgs:(0,h.withNullAsUndefined)(i.shellArgs),cwd:(0,h.withNullAsUndefined)(i.cwd),env:(0,h.withNullAsUndefined)(i.env),icon:(0,h.withNullAsUndefined)(c(i.iconPath)),color:f.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,h.withNullAsUndefined)(i.message),strictEnv:(0,h.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,h.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,h.withNullAsUndefined)(t?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,h.withNullAsUndefined)(t?.useShellEnvironment),location:t?.location||this.n(i.location,t?.resolvedExtHostIdentifier),isTransient:(0,h.withNullAsUndefined)(i.isTransient)})}async createExtensionTerminal(i,t,d,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:d,color:f.ThemeColor.isThemeColor(E)?E.id:void 0,location:this.n(i,t),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(i,t){return typeof i=="object"?"parentTerminal"in i&&i.parentTerminal&&t?{parentTerminal:t}:"viewColumn"in i?{viewColumn:g.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus}:void 0:i}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(i){this.m=i}setExitStatus(i,t){this.h=Object.freeze({code:i,reason:t})}setDimensions(i,t){return i===this.d&&t===this.g||i===0||t===0?!1:(this.d=i,this.g=t,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(i){this.f?(this.f(i),this.f=void 0):this.b.then(t=>{t!==i&&(this.b=Promise.resolve(i))})}}e.ExtHostTerminal=b;class D{get onProcessReady(){return this.b.event}constructor(i){this.g=i,this.id=0,this.shouldPersist=!1,this.a=new o.Emitter,this.onProcessData=this.a.event,this.b=new o.Emitter,this.d=new o.Emitter,this.onDidChangeProperty=this.d.event,this.f=new o.Emitter,this.onProcessExit=this.f.event}refreshProperty(i){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${i}`)}updateProperty(i,t){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${i}, value: ${t}`)}async start(){}shutdown(){this.g.close()}input(i){this.g.handleInput?.(i)}resize(i,t){this.g.setDimensions?.({columns:i,rows:t})}async processBinary(i){}acknowledgeDataEvent(i){}async setUnicodeVersion(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this.g.onDidWrite(t=>this.a.fire(t)),this.g.onDidClose?.((t=void 0)=>{this.f.fire(t===void 0?void 0:t)}),this.g.onDidOverrideDimensions?.(t=>{t&&this.d.fire({type:"overrideDimensions",value:{cols:t.columns,rows:t.rows}})}),this.g.onDidChangeName?.(t=>{this.d.fire({type:"title",value:t})}),this.g.open(i||void 0),i&&this.g.setDimensions?.(i),this.b.fire({pid:-1,cwd:""})}}let p=1,n=class extends P.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(i=>i.value)}get onDidWriteTerminalData(){return this.I.event}constructor(i,t){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new o.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new o.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new o.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new o.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new o.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new o.Emitter,this.onDidChangeShell=this.J.event,this.a=t.getProxy(A.MainContext.MainThreadTerminalService),this.s=new y.TerminalDataBufferer(this.a.$sendProcessData),this.I=new o.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(i),this.B({dispose:()=>{for(const[d,E]of this.g)E.shutdown(!0)}})}getDefaultShell(i){return(i?this.n:this.m)?.path||""}getDefaultShellArgs(i){return(i?this.n:this.m)?.args||[]}createExtensionTerminal(i,t){const d=new b(this.a,(0,C.generateUuid)(),i,i.name),E=new D(i.pty);return d.createExtensionTerminal(i.location,this.L(i,t).resolvedExtHostIdentifier,c(i.iconPath),l(i.color)).then(w=>{const L=this.M(w,E);this.h[w]=L}),this.f.push(d),d.value}L(i,t){if(t=t||{},i.location&&typeof i.location=="object"&&"parentTerminal"in i.location){const d=i.location.parentTerminal;if(d){const E=this.f.find(w=>w.value===d);E&&(t.resolvedExtHostIdentifier=E._id)}}else i.location&&typeof i.location!="object"?t.location=i.location:t.location&&typeof t.location=="object"&&"splitActiveTerminal"in t.location&&(t.location={splitActiveTerminal:!0});return t}attachPtyToTerminal(i,t){if(!this.O(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const E=new D(t),w=this.M(i,E);this.h[i]=w}async $acceptActiveTerminalChanged(i){const t=this.b;if(i===null){this.b=void 0,t!==this.b&&this.F.fire(this.b);return}const d=this.O(i);d&&(this.b=d,t!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(i,t){const d=this.O(i);d&&this.I.fire({terminal:d.value,data:t})}async $acceptTerminalDimensions(i,t,d){const E=this.O(i);E&&E.setDimensions(t,d)&&this.G.fire({terminal:E.value,dimensions:E.value.dimensions})}async $acceptTerminalMaximumDimensions(i,t,d){this.g.get(i)?.resize(t,d)}async $acceptTerminalTitleChange(i,t){const d=this.O(i);d&&(d.name=t)}async $acceptTerminalClosed(i,t,d){const E=this.Q(this.f,i);if(E!==null){const w=this.f.splice(E,1)[0];w.setExitStatus(t,d),this.C.fire(w.value)}}$acceptTerminalOpened(i,t,d,E){if(t){const q=this.Q(this.f,t);if(q!==null){this.f[q]._id=i,this.D.fire(this.terminals[q]),this.f[q].isOpen=!0;return}}const w={name:E.name,shellPath:E.executable,shellArgs:E.args,cwd:typeof E.cwd=="string"?E.cwd:R.URI.revive(E.cwd),env:E.env,hideFromUser:E.hideFromUser},L=new b(this.a,i,w,d);this.f.push(L),this.D.fire(L.value),L.isOpen=!0}async $acceptTerminalProcessId(i,t){this.O(i)?._setProcessId(t)}async $startExtensionTerminal(i,t){const d=this.O(i);if(!d)return{message:(0,k.localize)(0,null,i)};d.isOpen||await new Promise(w=>{const L=this.onDidOpenTerminal(async q=>{q===d.value&&(L.dispose(),w())})});const E=this.g.get(i);E?E.startSendingEvents(t):this.j[i]={initialDimensions:t}}M(i,t){const d=new P.DisposableStore;d.add(t.onProcessReady(w=>this.a.$sendProcessReady(i,w.pid,w.cwd))),d.add(t.onDidChangeProperty(w=>this.a.$sendProcessProperty(i,w))),this.s.startBuffering(i,t.onProcessData),d.add(t.onProcessExit(w=>this.N(i,w))),this.g.set(i,t);const E=this.j[i];return E&&t instanceof D&&(t.startSendingEvents(E.initialDimensions),delete this.j[i]),d}$acceptProcessAckDataEvent(i,t){this.g.get(i)?.acknowledgeDataEvent(t)}$acceptProcessInput(i,t){this.g.get(i)?.input(t)}$acceptTerminalInteraction(i){const t=this.O(i);t?.setInteractedWith()&&this.H.fire(t.value)}$acceptProcessResize(i,t,d){try{this.g.get(i)?.resize(t,d)}catch(E){if(E.code!=="EPIPE"&&E.code!=="ERR_IPC_CHANNEL_CLOSED")throw E}}$acceptProcessShutdown(i,t){this.g.get(i)?.shutdown(t)}$acceptProcessRequestInitialCwd(i){this.g.get(i)?.getInitialCwd().then(t=>this.a.$sendProcessProperty(i,{type:"initialCwd",value:t}))}$acceptProcessRequestCwd(i){this.g.get(i)?.getCwd().then(t=>this.a.$sendProcessProperty(i,{type:"cwd",value:t}))}$acceptProcessRequestLatency(i){return Promise.resolve(i)}registerLinkProvider(i){return this.u.add(i),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(i),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(i,t,d){if(this.v.has(t))throw new Error(`Terminal profile provider "${t}" already registered`);return this.v.set(t,d),this.a.$registerProfileProvider(t,i.identifier.value),new S.Disposable(()=>{this.v.delete(t),this.a.$unregisterProfileProvider(t)})}registerTerminalQuickFixProvider(i,t,d){if(this.w.has(i))throw new Error(`Terminal quick fix provider "${i}" is already registered`);return this.w.set(i,d),this.a.$registerQuickFixProvider(i,t),new S.Disposable(()=>{this.w.delete(i),this.a.$unregisterQuickFixProvider(i)})}async $provideTerminalQuickFixes(i,t){const d=new v.CancellationTokenSource().token;if(d.isCancellationRequested)return;const E=this.w.get(i);if(!E)return;const w=await E.provideTerminalQuickFixes(t,d);if(w!==null)return w}async $createContributedProfileTerminal(i,t){const d=new v.CancellationTokenSource().token;let E=await this.v.get(i)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(E&&!("options"in E)&&(E={options:E}),!E||!("options"in E))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in E.options){this.createExtensionTerminal(E.options,t);return}this.createTerminalFromOptions(E.options,t)}}async $provideLinks(i,t){const d=this.O(i);if(!d)return[];this.y.delete(i),this.z.get(i)?.dispose(!0);const w=new v.CancellationTokenSource;this.z.set(i,w);const L=[],q={terminal:d.value,line:t},V=[];for(const N of this.u)V.push(u.Promises.withAsyncBody(async U=>{w.token.onCancellationRequested(()=>U({provider:N,links:[]}));const $=await N.provideTerminalLinks(q,w.token)||[];w.token.isCancellationRequested||U({provider:N,links:$})}));const M=await Promise.all(V);if(w.token.isCancellationRequested)return[];const B=new Map;for(const N of M)N&&N.links.length>0&&L.push(...N.links.map(U=>{const $={id:p++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return B.set($.id,{provider:N.provider,link:U}),$}));return this.y.set(i,B),L}$activateLink(i,t){const d=this.y.get(i)?.get(t);!d||d.provider.handleTerminalLink(d.link)}N(i,t){this.s.stopBuffering(i),this.g.delete(i),delete this.j[i];const d=this.h[i];d&&(d.dispose(),delete this.h[i]),this.a.$sendProcessExit(i,t)}O(i){return this.P(this.f,i)}P(i,t){const d=this.Q(i,t);return d!==null?i[d]:null}Q(i,t){let d=null;return i.some((E,w)=>E._id===t?(d=w,!0):!1),d}getEnvironmentVariableCollection(i){let t=this.l.get(i.identifier.value);return t||(t=new s,this.S(i.identifier.value,t)),t}R(i,t){const d=(0,T.serializeEnvironmentVariableCollection)(t.map);this.a.$setEnvironmentVariableCollection(i,t.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(i){i.forEach(t=>{const d=t[0],E=new s(t[1]);this.S(d,E)})}$acceptDefaultProfile(i,t){const d=this.m;this.m=i,this.n=t,d?.path!==i.path&&this.J.fire(i.path)}S(i,t){this.l.set(i,t),t.onDidChangeCollection(()=>{this.R(i,t)})}};n=xe([ze(1,I.IExtHostRpcService)],n),e.BaseExtHostTerminalService=n;class s{get persistent(){return this.a}set persistent(i){this.a=i,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(i){this.map=new Map,this.a=!0,this.b=new o.Emitter,this.map=new Map(i)}get size(){return this.map.size}replace(i,t){this.d(i,{value:t,type:S.EnvironmentVariableMutatorType.Replace})}append(i,t){this.d(i,{value:t,type:S.EnvironmentVariableMutatorType.Append})}prepend(i,t){this.d(i,{value:t,type:S.EnvironmentVariableMutatorType.Prepend})}d(i,t){const d=this.map.get(i);(!d||d.value!==t.value||d.type!==t.type)&&(this.map.set(i,t),this.b.fire())}get(i){return this.map.get(i)}forEach(i,t){this.map.forEach((d,E)=>i.call(t,E,d,this))}[Symbol.iterator](){return this.map.entries()}delete(i){this.map.delete(i),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let r=class extends n{constructor(i){super(!1,i)}createTerminal(i,t,d){throw new O.NotSupportedError}createTerminalFromOptions(i,t){throw new O.NotSupportedError}};r=xe([ze(0,I.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function c(m){if(!(!m||typeof m=="string"))return"id"in m?{id:m.id,color:m.color}:m}function l(m){return f.ThemeColor.isThemeColor(m)?m:void 0}});var Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(ne):A?A.value:e.get(ne)},_e=this&&this.__classPrivateFieldSet||function(ne,e,o,A,a){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!a:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?a.call(ne,o):a?a.value=o:e.set(ne,o),o};define(ye[274],De([1,0,15,19,22,21,3,63,88,6,23,9,30,5,20,137,14,7,57,94,75,26]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u,g,b,D,p){"use strict";var n,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(N,U,$){this.j=$,this.c=new I.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=N.getProxy(C.MainContext.MainThreadTesting),this.h=new q(this.f),this.g=new i(this.f),U.registerArgumentProcessor({processArgument:z=>{if(z?.$mid!==15)return z;const ae=z,ee=ae.tests[ae.tests.length-1].item.extId;return this.d.get(g.TestId.root(ee))?.collection.tree.get(ee)?.actual??(0,f.toItemFromContext)(z)}})}createTestController(N,U,$,z){if(this.d.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const ae=new k.DisposableStore,ee=ae.add(new f.ExtHostTestItemCollection(U,$,this.j));ee.root.label=$;const x=new Map,J=this.f,ie={items:ee.root.children,get label(){return $},set label(Q){$=Q,ee.root.label=Q,J.$updateController(U,{label:$})},get refreshHandler(){return z},set refreshHandler(Q){z=Q,J.$updateController(U,{canRefresh:!!Q})},get id(){return U},createRunProfile:(Q,Y,Z,me,ve,Ie)=>{let Re=(0,S.hash)(Q);for(;x.has(Re);)Re++;return Ie!==void 0&&(0,p.checkProposedApiEnabled)(N,"testContinuousRun"),new V(this.f,x,U,Re,Q,Y,Z,me,ve,Ie)},createTestItem(Q,Y,Z){return new f.TestItemImpl(U,Q,Y,Z)},createTestRun:(Q,Y,Z=!0)=>this.g.createTestRun(U,ee,Q,Y,Z),set resolveHandler(Q){ee.resolveHandler=Q},get resolveHandler(){return ee.resolveHandler},dispose:()=>{ae.dispose()}};J.$registerTestController(U,$,!!z),ae.add((0,k.toDisposable)(()=>J.$unregisterTestController(U)));const pe={controller:ie,collection:ee,profiles:x};return this.d.set(U,pe),ae.add((0,k.toDisposable)(()=>this.d.delete(U))),ae.add(ee.onDidGenerateDiff(Q=>J.$publishDiff(U,Q.map(D.TestsDiffOp.serialize)))),ie}createTestObserver(){return this.h.checkout()}async runTests(N,U=R.CancellationToken.None){const $=t(N);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.d.get($.controllerId);if(!z)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(ae=>g.TestId.fromExtHostTestItem(ae,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:M[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:N.exclude?.map(ae=>ae.id)},U)}$syncTests(){for(const{collection:N}of this.d.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,U,$){return(0,o.mapFind)(this.g.trackers,ae=>ae.id===N?ae.getCoverage(U):void 0)?.provideFileCoverage($)??Promise.resolve([])}$resolveFileCoverage(N,U,$,z){return(0,o.mapFind)(this.g.trackers,ee=>ee.id===N?ee.getCoverage(U):void 0)?.resolveFileCoverage($,z)??Promise.resolve([])}$configureRunProfile(N,U){this.d.get(N)?.profiles.get(U)?.configureHandler?.()}async $refreshTests(N,U){await this.d.get(N)?.controller.refreshHandler?.(U)}$publishTestResults(N){this.results=Object.freeze(N.map(U=>(0,O.deepFreeze)(h.TestResults.to(U))).concat(this.results).sort((U,$)=>$.completedAt-U.completedAt).slice(0,32)),this.c.fire()}async $expandTest(N,U){const $=this.d.get(g.TestId.fromString(N).controllerId)?.collection;$&&(await $.expand(N,U<0?1/0:U),$.flushDiff())}$acceptDiff(N){this.h.applyDiff(N.map(D.TestsDiffOp.deserialize))}async $runControllerTests(N,U){return Promise.all(N.map($=>this.k($,!1,U)))}async $startContinuousRun(N,U){const $=new R.CancellationTokenSource(U),z=await Promise.all(N.map(ae=>this.k(ae,!0,$.token)));return!U.isCancellationRequested&&!z.some(ae=>ae.error)&&await new Promise(ae=>U.onCancellationRequested(ae)),$.dispose(!0),z}async k(N,U,$){const z=this.d.get(N.controllerId);if(!z)return{};const{collection:ae,profiles:ee}=z,x=ee.get(N.profileId);if(!x)return{};const J=N.testIds.map(Y=>ae.tree.get(Y)).filter(T.isDefined),ie=N.excludeExtIds.map(Y=>z.collection.tree.get(Y)).filter(T.isDefined).filter(Y=>J.some(Z=>Z.fullId.compare(Y.fullId)===2));if(!J.length)return{};const pe=new u.TestRunRequest2(J.some(Y=>Y.actual instanceof f.TestItemRootImpl)?void 0:J.map(Y=>Y.actual),ie.map(Y=>Y.actual),x,U),Q=(0,D.isStartControllerTests)(N)&&this.g.prepareForMainThreadTestRun(pe,d.fromInternal(N,z.collection),$);try{return await x.runHandler(pe,$),{}}catch(Y){return{error:String(Y)}}finally{Q&&(Q.hasRunningTasks&&!$.isCancellationRequested&&await I.Event.toPromise(Q.onEnd),Q.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.g.cancelAllRuns():this.g.cancelRunById(N)}};r=xe([ze(0,y.IExtHostRpcService)],r),e.ExtHostTesting=r;const c=1e4;var l;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(l||(l={}));class m extends k.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(N,U,$){super(),this.k=N,this.l=U,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new I.Emitter),this.onEnd=this.j.event,this.h=this.B(new R.CancellationTokenSource($));const z=this.B(new A.RunOnceScheduler(()=>this.m(),c));this.B(this.h.token.onCancellationRequested(()=>z.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(N){return this.f.get(N)?.coverage}createRun(N){const U=this.k.id,$=this.k.controllerId,z=(0,v.generateUuid)(),ae=new E(this.l,U,z),ee=pe=>(Q,...Y)=>{if(J){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(Q)||(this.s(Q),pe(Q,...Y))},x=(pe,Q)=>{const Y=Q instanceof Array?Q.map(h.TestMessage.from):[h.TestMessage.from(Q)];if(pe.uri&&pe.range){const Z={range:h.Range.from(pe.range),uri:pe.uri};for(const me of Y)me.location=me.location||Z}this.l.$appendTestMessagesInRun(U,z,g.TestId.fromExtHostTestItem(pe,$).toString(),Y)};let J=!1;const ie={isPersisted:this.k.isPersisted,token:this.h.token,name:N,get coverageProvider(){return ae.coverageProvider},set coverageProvider(pe){ae.coverageProvider=pe},enqueued:ee(pe=>{this.l.$updateTestStateInRun(U,z,g.TestId.fromExtHostTestItem(pe,$).toString(),1)}),skipped:ee(pe=>{this.l.$updateTestStateInRun(U,z,g.TestId.fromExtHostTestItem(pe,$).toString(),5)}),started:ee(pe=>{this.l.$updateTestStateInRun(U,z,g.TestId.fromExtHostTestItem(pe,$).toString(),2)}),errored:ee((pe,Q,Y)=>{x(pe,Q),this.l.$updateTestStateInRun(U,z,g.TestId.fromExtHostTestItem(pe,$).toString(),6,Y)}),failed:ee((pe,Q,Y)=>{x(pe,Q),this.l.$updateTestStateInRun(U,z,g.TestId.fromExtHostTestItem(pe,$).toString(),4,Y)}),passed:ee((pe,Q)=>{this.l.$updateTestStateInRun(U,z,g.TestId.fromExtHostTestItem(pe,this.k.controllerId).toString(),3,Q)}),appendOutput:(pe,Q,Y)=>{J||(Y&&(this.k.isIncluded(Y)?this.s(Y):Y=void 0),this.l.$appendOutputToRun(U,z,a.VSBuffer.fromString(pe),Q&&h.location.from(Q),Y&&g.TestId.fromExtHostTestItem(Y,$).toString()))},end:()=>{J||(J=!0,this.l.$finishedTestRunTask(U,z),this.f.delete(z),this.f.size||this.p())}};return this.f.set(z,{run:ie,coverage:ae}),this.l.$startedTestRunTask(U,{id:z,name:N,running:!0}),ie}m(){for(const{run:N}of this.f.values())N.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(N){if(!(N instanceof f.TestItemImpl))throw new b.InvalidTestItemError(N.id);if(this.g.has(g.TestId.fromExtHostTestItem(N,this.k.controllerId).toString()))return;const U=[],$=this.k.colllection.root;for(;;){const z=h.TestItem.from(N);if(U.unshift(z),this.g.has(z.extId)||(this.g.add(z.extId),N===$))break;N=N.parent||$}this.l.$addTestsToRun(this.k.controllerId,this.k.id,U)}}class i{get trackers(){return this.c.values()}constructor(N){this.d=N,this.c=new Map}prepareForMainThreadTestRun(N,U,$){return this.f(N,U,$)}cancelRunById(N){for(const U of this.c.values())if(U.id===N){U.cancel();return}}cancelAllRuns(){for(const N of this.c.values())N.cancel()}createTestRun(N,U,$,z,ae){const ee=this.c.get($);if(ee)return ee.createRun(z);const x=d.fromPublic(N,U,$,ae),J=t($);this.d.$startedExtensionTestRun({controllerId:N,continuous:!!$.continuous,profile:J&&{group:M[J.kind],id:J.profileId},exclude:$.exclude?.map(pe=>g.TestId.fromExtHostTestItem(pe,U.root.id).toString())??[],id:x.id,include:$.include?.map(pe=>g.TestId.fromExtHostTestItem(pe,U.root.id).toString())??[U.root.id],persist:ae});const ie=this.f($,x);return ie.onEnd(()=>{this.d.$finishedExtensionTestRun(x.id),ie.dispose()}),ie.createRun(z)}f(N,U,$){const z=new m(U,this.d,$);return this.c.set(N,z),z.onEnd(()=>this.c.delete(N)),z}}e.TestRunCoordinator=i;const t=B=>{if(!!B.profile){if(!(B.profile instanceof V))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class d{static fromPublic(N,U,$,z){return new d(N,(0,v.generateUuid)(),$.include?.map(ae=>g.TestId.fromExtHostTestItem(ae,N).toString())??[N],$.exclude?.map(ae=>g.TestId.fromExtHostTestItem(ae,N).toString())??[],z,U)}static fromInternal(N,U){return new d(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,U)}constructor(N,U,$,z,ae,ee){this.controllerId=N,this.id=U,this.isPersisted=ae,this.colllection=ee,this.c=$.map(x=>x+"\0"),this.d=z.map(x=>x+"\0")}isIncluded(N){const U=g.TestId.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const $ of this.d)if(U===$||U.startsWith($))return!1;for(const $ of this.c)if(U===$||U.startsWith($))return!0;return!1}}e.TestRunDto=d;class E{set coverageProvider(N){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!N||(this.c=N,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(N,U,$){this.f=N,this.g=U,this.h=$}async provideFileCoverage(N){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(N))());try{return(await this.d)?.map(h.TestCoverage.fromFile)??[]}catch(U){throw this.d=void 0,U}}async resolveFileCoverage(N,U){const $=await this.d;let z=$?.[N];return!this.c||!$||!z?[]:(z.detailedCoverage||(z=$[N]=await this.c.resolveFileCoverage?.(z,U)??z),z.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class w{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(N){this.h=N,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(N){this.c.add(N)}update(N){Object.assign(N.revived,h.TestItem.toPlain(N.item)),this.c.has(N)||this.d.add(N)}remove(N){if(this.c.has(N)){this.c.delete(N);return}this.d.delete(N);const U=g.TestId.parentId(N.item.extId);if(U&&this.g.has(U.toString())){this.g.add(N.item.extId);return}this.f.add(N)}getChangeEvent(){const{c:N,d:U,f:$}=this;return{get added(){return[...N].map(z=>z.revived)},get updated(){return[...U].map(z=>z.revived)},get removed(){return[...$].map(z=>z.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class L extends D.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new I.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(N){return this.d.get(N)}getMirroredTestDataByReference(N){return this.d.get(N.id)}p(N,U){return{...N,revived:h.TestItem.toPlain(N.item),depth:U?U.depth+1:0,children:new Set}}o(){return new w(this.q)}}class q{constructor(N){this.d=N}checkout(){this.c||(this.c=this.f());const N=this.c;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(U=>U.revived)},dispose:(0,P.once)(()=>{--N.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(N){return this.c?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.c?.tests.apply(N)}f(){const N=new L;return this.d.$subscribeToDiffs(),{observers:0,tests:N}}}class V{get label(){return this.d}set label(N){N!==this.d&&(this.d=N,Ue(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(N){N!==this.g&&(this.g=N,Ue(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this.f}set isDefault(N){N!==this.f&&(this.f=N,Ue(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,Ue(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?h.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this.c}set configureHandler(N){N!==this.c&&(this.c=N,Ue(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}constructor(N,U,$,z,ae,ee,x,J=!1,ie=void 0,pe=!1){this.controllerId=$,this.profileId=z,this.d=ae,this.kind=ee,this.runHandler=x,this.f=J,this._tag=ie,this.g=pe,n.set(this,void 0),s.set(this,void 0),_e(this,n,N,"f"),_e(this,s,U,"f"),U.set(z,this);const Q=M[ee];if(typeof Q!="number")throw new Error(`Unknown TestRunProfile.group ${ee}`);Ue(this,n,"f").$publishTestRunProfile({profileId:z,controllerId:$,tag:ie?h.TestTag.namespace(this.controllerId,ie.id):null,label:ae,group:Q,isDefault:J,hasConfigurationHandler:!1,supportsContinuousRun:pe})}dispose(){Ue(this,s,"f")?.delete(this.profileId)&&(_e(this,s,void 0,"f"),Ue(this,n,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=V,n=new WeakMap,s=new WeakMap;const M={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(ye[275],De([1,0,15,3,5,138,14,7]),function(ne,e,o,A,a,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(O,T){this.i=T,this.a=new A.Emitter,this.b=new A.Emitter,this.c=new A.Emitter,this.d=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=O.getProxy(a.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(O){const T=this.i.allEditors();return O?T:T.map(v=>v.value)}async showTextDocument(O,T,v){let C;typeof T=="number"?C={position:I.ViewColumn.from(T),preserveFocus:v}:typeof T=="object"?C={position:I.ViewColumn.from(T.viewColumn),preserveFocus:T.preserveFocus,selection:typeof T.selection=="object"?I.Range.from(T.selection):void 0,pinned:typeof T.preview=="boolean"?!T.preview:void 0}:C={preserveFocus:!1};const y=await this.h.$tryShowTextDocument(O.uri,C),f=y&&this.i.getEditor(y);if(f)return f.value;throw y?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,T){return new R.TextEditorDecorationType(this.h,O,T).value}$acceptEditorPropertiesChanged(O,T){const v=this.i.getEditor(O);if(!v)throw new Error("unknown text editor");if(T.options&&v._acceptOptions(T.options),T.selections){const C=T.selections.selections.map(I.Selection.to);v._acceptSelections(C)}if(T.visibleRanges){const C=o.coalesce(T.visibleRanges.map(I.Range.to));v._acceptVisibleRanges(C)}if(T.options&&this.b.fire({textEditor:v.value,options:{...T.options,lineNumbers:I.TextEditorLineNumbersStyle.to(T.options.lineNumbers)}}),T.selections){const C=P.TextEditorSelectionChangeKind.fromValue(T.selections.source),y=T.selections.selections.map(I.Selection.to);this.a.fire({textEditor:v.value,selections:y,kind:C})}if(T.visibleRanges){const C=o.coalesce(T.visibleRanges.map(I.Range.to));this.c.fire({textEditor:v.value,visibleRanges:C})}}$acceptEditorPositionData(O){for(const T in O){const v=this.i.getEditor(T);if(!v)throw new Error("Unknown text editor");const C=I.ViewColumn.to(O[T]);v.value.viewColumn!==C&&(v._acceptViewColumn(C),this.d.fire({textEditor:v.value,viewColumn:C}))}}getDiffInformation(O){return Promise.resolve(this.h.$getDiffInformation(O))}}e.ExtHostEditors=S}),define(ye[276],De([1,0,2,4,5,6,7,14,27,9]),function(ne,e,o,A,a,R,I,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,A.createDecorator)("IExtHostTimeline");class O{constructor(C,y){this.b=new Map,this.c=new Map,this.a=C.getProxy(a.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:(f,h)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&S.ExtensionIdentifier.equals(h,this.b.get(f.source)?.extension)){const u=f.uri===void 0?void 0:o.URI.revive(f.uri);return this.c.get(f.source)?.get(T(u))?.get(f.handle)}else return;return f}})}async $getTimeline(C,y,f,h){return this.b.get(C)?.provider.provideTimeline(o.URI.revive(y),f,h)}registerTimelineProvider(C,y,f,h){const u=new R.DisposableStore,g=this.d(y.id,h,u).bind(this);let b;y.onDidChange&&(b=y.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:y.id}),this));const D=this.c;return this.f({...y,scheme:C,onDidChange:void 0,async provideTimeline(p,n,s){n?.resetCache&&(u.clear(),D.get(y.id)?.clear());const r=await y.provideTimeline(p,n,s);if(r==null)return;const c=g(p,n);return{...r,source:y.id,items:r.items.map(c)}},dispose(){for(const p of D.values())p.get(y.id)?.clear();b?.dispose(),u.dispose()}},f)}d(C,y,f){return(h,u)=>{let g;if(u?.cacheResults){let b=this.c.get(C);b===void 0&&(b=new Map,this.c.set(C,b));const D=T(h);g=b.get(D),g===void 0&&(g=new Map,b.set(D,g))}return b=>{const{iconPath:D,...p}=b,n=`${C}|${b.id??b.timestamp}`;g?.set(n,b);let s,r,c;b.iconPath&&(D instanceof I.ThemeIcon?c={id:D.id,color:D.color}:o.URI.isUri(D)?(s=D,r=D):{light:s,dark:r}=D);let l;return I.MarkdownString.isMarkdownString(p.tooltip)?l=P.MarkdownString.from(p.tooltip):(0,k.isString)(p.tooltip)?l=p.tooltip:I.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=P.MarkdownString.from(p.detail)):(0,k.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=p.detail),{...p,id:p.id??void 0,handle:n,source:C,command:b.command?y.toInternal(b.command,f):void 0,icon:s,iconDark:r,themeIcon:c,tooltip:l,accessibilityInformation:b.accessibilityInformation}}}}f(C,y){if(this.b.get(C.id))throw new Error(`Timeline Provider ${C.id} already exists.`);return this.a.$registerTimelineProvider({id:C.id,label:C.label,scheme:C.scheme}),this.b.set(C.id,{provider:C,extension:y}),(0,R.toDisposable)(()=>{for(const h of this.c.values())h.get(C.id)?.clear();this.b.delete(C.id),this.a.$unregisterTimelineProvider(C.id),C.dispose()})}}e.ExtHostTimeline=O;function T(v){return v?.toString()}}),define(ye[277],De([1,0,6,16,2,5]),function(ne,e,o,A,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(S){this.c=new Map,this.b=S.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,k,O,T){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const v=T.schemes.find(C=>!I.a.has(C));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(k,O),this.b.$registerUriOpener(k,T.schemes,S,T.label),(0,o.toDisposable)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(S,k,O){const T=this.c.get(S);if(!T)throw new Error(`Unknown opener with id: ${S}`);const v=a.URI.revive(k);return T.canOpenExternalUri(v,O)}async $openUri(S,k,O){const T=this.c.get(S);if(!T)throw new Error(`Unknown opener id: '${S}'`);return T.openExternalUri(a.URI.revive(k.resolvedUri),{sourceUri:a.URI.revive(k.sourceUri)},O)}}I.a=new Set([A.Schemas.http,A.Schemas.https]),e.ExtHostUriOpeners=I}),define(ye[278],De([1,0,5,2,6,12,27]),function(ne,e,o,A,a,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(k){this.c=new Set,this.d=new Map,this.b=k.getProxy(o.MainContext.MainThreadUrls)}registerUriHandler(k,O){if(this.c.has(I.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const T=P.a++;return this.c.add(I.ExtensionIdentifier.toKey(k)),this.d.set(T,O),this.b.$registerUriHandler(T,k),(0,a.toDisposable)(()=>{this.c.delete(I.ExtensionIdentifier.toKey(k)),this.d.delete(T),this.b.$unregisterUriHandler(T)})}$handleExternalUri(k,O){const T=this.d.get(k);if(!T)return Promise.resolve(void 0);try{T.handleUri(A.URI.revive(O))}catch(v){(0,R.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(k){return A.URI.revive(await this.b.$createAppUri(k))}}P.a=0,e.ExtHostUrls=P});var _e=this&&this.__classPrivateFieldSet||function(ne,e,o,A,a){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!a:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?a.call(ne,o):a?a.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[80],De([1,0,3,16,23,2,198,223,95,5]),function(ne,e,o,A,a,R,I,P,S,k){"use strict";var O,T,v,C,y,f,h,u,g,b,D,p,n;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(w,L,q,V,M,B,N){O.set(this,void 0),T.set(this,void 0),v.set(this,void 0),C.set(this,void 0),y.set(this,void 0),f.set(this,void 0),h.set(this,""),u.set(this,void 0),g.set(this,!1),b.set(this,!1),D.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new o.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,n.set(this,new o.Emitter),this._onDidDispose=Ue(this,n,"f").event,_e(this,O,w,"f"),_e(this,T,L,"f"),_e(this,u,q,"f"),_e(this,C,V,"f"),_e(this,y,M,"f"),_e(this,f,B,"f"),_e(this,D,r(B),"f"),_e(this,p,c(B),"f"),_e(this,v,N,"f")}dispose(){_e(this,g,!0,"f"),Ue(this,n,"f").fire(),Ue(this,n,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(w){return _e(this,b,!0,"f"),(0,S.asWebviewUri)(w,Ue(this,C,"f"))}get cspSource(){const w=Ue(this,f,"f").extensionLocation;if(w.scheme===A.Schemas.https||w.scheme===A.Schemas.http){let L=w.toString();return L.endsWith("/")||(L+="/"),L+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Ue(this,h,"f")}set html(w){this.a(),Ue(this,h,"f")!==w&&(_e(this,h,w,"f"),Ue(this,p,"f")&&!Ue(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(w)&&(_e(this,b,!0,"f"),Ue(this,v,"f").report("Webview vscode-resource: uris",Ue(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,T,"f").$setHtml(Ue(this,O,"f"),this.b(w)))}get options(){return this.a(),Ue(this,u,"f")}set options(w){this.a(),a.equals(Ue(this,u,"f"),w)||Ue(this,T,"f").$setOptions(Ue(this,O,"f"),i(Ue(this,f,"f"),Ue(this,y,"f"),w)),_e(this,u,w,"f")}async postMessage(w){if(Ue(this,g,"f"))return!1;const L=(0,P.serializeWebviewMessage)(w,{serializeBuffersForPostMessage:Ue(this,D,"f")});return Ue(this,T,"f").$postMessage(Ue(this,O,"f"),L.message,...L.buffers)}a(){if(Ue(this,g,"f"))throw new Error("Webview is disposed")}b(w){if(!Ue(this,p,"f"))return w;const L=Ue(this,f,"f").extensionLocation?.scheme===A.Schemas.vscodeRemote,q=Ue(this,f,"f").extensionLocation.scheme===A.Schemas.vscodeRemote?Ue(this,f,"f").extensionLocation.authority:void 0;return w.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,M,B,N,U,$)=>{const z=R.URI.from({scheme:N||"file",path:decodeURIComponent(U)}),ae=(0,S.asWebviewUri)(z,{isRemote:L,authority:q}).toString();return`${M}${ae}${$}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,M,B,N,U,$)=>{const z=R.URI.from({scheme:N||"file",path:decodeURIComponent(U)}),ae=(0,S.asWebviewUri)(z,{isRemote:L,authority:q}).toString();return`${M}${ae}${$}`})}}e.ExtHostWebview=s,O=new WeakMap,T=new WeakMap,v=new WeakMap,C=new WeakMap,y=new WeakMap,f=new WeakMap,h=new WeakMap,u=new WeakMap,g=new WeakMap,b=new WeakMap,D=new WeakMap,p=new WeakMap,n=new WeakMap;function r(E){try{const w=(0,I.normalizeVersion)((0,I.parseVersion)(E.engines.vscode));return!!w&&w.majorBase>=1&&w.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function c(E){try{const w=(0,I.normalizeVersion)((0,I.parseVersion)(E.engines.vscode));return w?w.majorBase<1||w.majorBase===1&&w.minorBase<60:!1}catch{return!1}}class l{constructor(w,L,q,V,M){this.c=L,this.d=q,this.e=V,this.f=M,this.b=new Map,this.a=w.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(w,L,q){const V=this.g(w);if(V){const{message:M}=(0,P.deserializeWebviewMessage)(L,q.value);V._onMessageEmitter.fire(M)}}$onMissingCsp(w,L){this.e.warn(`${L} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(w,L,q){const V=new s(w,this.a,t(L),this.c,this.d,q,this.f);return this.b.set(w,V),V._onDidDispose(()=>{this.b.delete(w)}),V}deleteWebview(w){this.b.delete(w)}g(w){return this.b.get(w)}}e.ExtHostWebviews=l;function m(E){return{id:E.identifier,location:E.extensionLocation}}e.toExtensionData=m;function i(E,w,L){return{enableCommandUris:L.enableCommandUris,enableScripts:L.enableScripts,enableForms:L.enableForms,portMapping:L.portMapping,localResourceRoots:L.localResourceRoots||d(E,w)}}e.serializeWebviewOptions=i;function t(E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,enableForms:E.enableForms,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots?.map(w=>R.URI.from(w))}}function d(E,w){return[...(w?.getWorkspaceFolders()||[]).map(L=>L.uri),E.extensionLocation]}}),define(ye[279],De([1,0,21,88,6,16,24,2,14,80,74,5,7]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class C{constructor(s,r){this.document=s,this.b=r,this.a=1,this.c=new O.Cache("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,r){await this.f(s).undo(),r||this.disposeBackup()}async redo(s,r){await this.f(s).redo(),r||this.disposeBackup()}disposeEdits(s){for(const r of s)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=p(this.document.uri)+this.a++;return(0,I.joinPath)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const r=this.c.get(s,0);if(!r)throw new Error("No edit found");return r}}class y{constructor(){this.a=new Map}get(s,r){return this.a.get(this.b(s,r))}add(s,r,c){const l=this.b(s,r.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${s} resource:${r.uri}`);const m=new C(r,c);return this.a.set(l,m),m}delete(s,r){const c=this.b(s,r.uri);this.a.delete(c)}b(s,r){return`${s}@@@${r}`}}var f;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(f||(f={}));class h{constructor(){this.a=new Map}addTextProvider(s,r,c){return this.b(0,s,r,c)}addCustomProvider(s,r,c){return this.b(1,s,r,c)}get(s){return this.a.get(s)}b(s,r,c,l){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:s,extension:c,provider:l}),new v.Disposable(()=>this.a.delete(r))}}class u{constructor(s,r,c,l,m){this.d=r,this.f=c,this.g=l,this.h=m,this.b=new h,this.c=new y,this.a=s.getProxy(T.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,r,c,l){const m=new a.DisposableStore;return b(c)?(m.add(this.b.addTextProvider(r,s,c)),this.a.$registerTextEditorProvider((0,k.toExtensionData)(s),r,l.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(s))):(m.add(this.b.addCustomProvider(r,s,c)),g(c)&&m.add(c.onDidChangeCustomDocument(i=>{const t=this.i(r,i.document.uri);if(D(i)){const d=t.addEdit(i);this.a.$onDidEdit(i.document.uri,r,d,i.label)}else this.a.$onContentChange(i.document.uri,r)})),this.a.$registerCustomEditorProvider((0,k.toExtensionData)(s),r,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(s))),v.Disposable.from(m,new v.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(s,r,c,l,m){const i=this.b.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(i.type!==1)throw new Error(`Invalid provide type for '${r}'`);const t=P.URI.revive(s),d=await i.provider.openCustomDocument(t,{backupId:c,untitledDocumentData:l?.buffer},m);let E;return g(i.provider)&&this.f&&(E=this.f.workspaceValue(i.extension)??this.f.globalValue(i.extension)),this.c.add(r,d,E),{editable:g(i.provider)}}async $disposeCustomDocument(s,r){const c=this.b.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${r}'`);const l=P.URI.revive(s),{document:m}=this.i(r,l);this.c.delete(r,m),m.dispose()}async $resolveCustomEditor(s,r,c,l,m,i){const t=this.b.get(c);if(!t)throw new Error(`No provider found for '${c}'`);const d=S.ViewColumn.to(m),E=this.g.createNewWebview(r,l.contentOptions,t.extension),w=this.h.createNewWebviewPanel(r,c,l.title,d,l.options,E,!0),L=P.URI.revive(s);switch(t.type){case 1:{const{document:q}=this.i(c,L);return t.provider.resolveCustomEditor(q,w,i)}case 0:{const q=this.d.getDocument(L);return t.provider.resolveCustomTextEditor(q,w,i)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,r,c){this.i(r,s).disposeEdits(c)}async $onMoveCustomEditor(s,r,c){const l=this.b.get(c);if(!l)throw new Error(`No provider found for '${c}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const m=this.h.getWebviewPanel(s);if(!m)throw new Error("No webview found");const i=P.URI.revive(r),t=this.d.getDocument(i);await l.provider.moveCustomTextEditor(t,m,o.CancellationToken.None)}async $undo(s,r,c,l){return this.i(r,s).undo(c,l)}async $redo(s,r,c,l){return this.i(r,s).redo(c,l)}async $revert(s,r,c){const l=this.i(r,s);await this.j(r).revertCustomDocument(l.document,c),l.disposeBackup()}async $onSave(s,r,c){const l=this.i(r,s);await this.j(r).saveCustomDocument(l.document,c),l.disposeBackup()}async $onSaveAs(s,r,c,l){const m=this.i(r,s);return this.j(r).saveCustomDocumentAs(m.document,P.URI.revive(c),l)}async $backup(s,r,c){const l=this.i(r,s),i=await this.j(r).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},c);return l.updateBackup(i),i.id}i(s,r){const c=this.c.get(s,P.URI.revive(r));if(!c)throw new Error("No custom document found");return c}j(s){const c=this.b.get(s)?.provider;if(!c||!g(c))throw new Error("Custom document is not editable");return c}}e.ExtHostCustomEditors=u;function g(n){return!!n.onDidChangeCustomDocument}function b(n){return typeof n.resolveCustomTextEditor=="function"}function D(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function p(n){const s=n.scheme===R.Schemas.file||n.scheme===R.Schemas.untitled?n.fsPath:n.toString();return(0,A.hash)(s)+""}});var _e=this&&this.__classPrivateFieldSet||function(ne,e,o,A,a){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!a:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?a.call(ne,o):a?a.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[280],De([1,0,3,6,2,30,14,80,5,7]),function(ne,e,o,A,a,R,I,P,S,k){"use strict";var O,T,v,C,y,f,h,u,g,b,D,p,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends A.Disposable{constructor(m,i,t,d){super(),O.set(this,void 0),T.set(this,void 0),v.set(this,void 0),C.set(this,void 0),y.set(this,void 0),f.set(this,void 0),h.set(this,void 0),u.set(this,void 0),g.set(this,!0),b.set(this,void 0),D.set(this,!1),p.set(this,this.B(new o.Emitter)),this.onDidDispose=Ue(this,p,"f").event,n.set(this,this.B(new o.Emitter)),this.onDidChangeViewState=Ue(this,n,"f").event,_e(this,O,m,"f"),_e(this,T,i,"f"),_e(this,C,t,"f"),_e(this,v,d.viewType,"f"),_e(this,y,d.panelOptions,"f"),_e(this,u,d.viewColumn,"f"),_e(this,f,d.title,"f"),_e(this,b,d.active,"f")}dispose(){Ue(this,D,"f")||(_e(this,D,!0,"f"),Ue(this,p,"f").fire(),Ue(this,T,"f").$disposeWebview(Ue(this,O,"f")),Ue(this,C,"f").dispose(),super.dispose())}get webview(){return this.c(),Ue(this,C,"f")}get viewType(){return this.c(),Ue(this,v,"f")}get title(){return this.c(),Ue(this,f,"f")}set title(m){this.c(),Ue(this,f,"f")!==m&&(_e(this,f,m,"f"),Ue(this,T,"f").$setTitle(Ue(this,O,"f"),m))}get iconPath(){return this.c(),Ue(this,h,"f")}set iconPath(m){this.c(),Ue(this,h,"f")!==m&&(_e(this,h,m,"f"),Ue(this,T,"f").$setIconPath(Ue(this,O,"f"),a.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Ue(this,y,"f")}get viewColumn(){if(this.c(),!(typeof Ue(this,u,"f")=="number"&&Ue(this,u,"f")<0))return Ue(this,u,"f")}get active(){return this.c(),Ue(this,b,"f")}get visible(){return this.c(),Ue(this,g,"f")}_updateViewState(m){Ue(this,D,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(_e(this,b,m.active,"f"),_e(this,g,m.visible,"f"),_e(this,u,m.viewColumn,"f"),Ue(this,n,"f").fire({webviewPanel:this}))}reveal(m,i){this.c(),Ue(this,T,"f").$reveal(Ue(this,O,"f"),{viewColumn:typeof m>"u"?void 0:I.ViewColumn.from(m),preserveFocus:!!i})}c(){if(Ue(this,D,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,T=new WeakMap,v=new WeakMap,C=new WeakMap,y=new WeakMap,f=new WeakMap,h=new WeakMap,u=new WeakMap,g=new WeakMap,b=new WeakMap,D=new WeakMap,p=new WeakMap,n=new WeakMap;class r{static c(){return(0,R.generateUuid)()}constructor(m,i,t){this.g=i,this.h=t,this.e=new Map,this.f=new Map,this.d=m.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(m,i,t,d,E={}){const w=typeof d=="object"?d.viewColumn:d,L={viewColumn:I.ViewColumn.from(w),preserveFocus:typeof d=="object"&&!!d.preserveFocus},q=(0,P.shouldSerializeBuffersForPostMessage)(m),V=r.c();this.d.$createWebviewPanel((0,P.toExtensionData)(m),V,i,{title:t,panelOptions:c(E),webviewOptions:(0,P.serializeWebviewOptions)(m,this.h,E),serializeBuffersForPostMessage:q},L);const M=this.g.createNewWebview(V,E,m);return this.createNewWebviewPanel(V,i,t,w,E,M,!0)}$onDidChangeWebviewPanelViewStates(m){const i=Object.keys(m);i.sort((t,d)=>{const E=m[t],w=m[d];return E.active?1:w.active?-1:+E.visible-+w.visible});for(const t of i){const d=this.getWebviewPanel(t);if(!d)continue;const E=m[t];d._updateViewState({active:E.active,visible:E.visible,viewColumn:I.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.e.delete(m),this.g.deleteWebview(m)}registerWebviewPanelSerializer(m,i,t){if(this.f.has(i))throw new Error(`Serializer for '${i}' already registered`);return this.f.set(i,{serializer:t,extension:m}),this.d.$registerSerializer(i,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(m)}),new k.Disposable(()=>{this.f.delete(i),this.d.$unregisterSerializer(i)})}async $deserializeWebviewPanel(m,i,t,d){const E=this.f.get(i);if(!E)throw new Error(`No serializer found for '${i}'`);const{serializer:w,extension:L}=E,q=this.g.createNewWebview(m,t.webviewOptions,L),V=this.createNewWebviewPanel(m,i,t.title,d,t.panelOptions,q,t.active);await w.deserializeWebviewPanel(V,t.state)}createNewWebviewPanel(m,i,t,d,E,w,L){const q=new s(m,this.d,w,{viewType:i,title:t,viewColumn:d,panelOptions:E,active:L});return this.e.set(m,q),q}getWebviewPanel(m){return this.e.get(m)}}e.ExtHostWebviewPanels=r;function c(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var _e=this&&this.__classPrivateFieldSet||function(ne,e,o,A,a){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!a:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?a.call(ne,o):a?a.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[281],De([1,0,3,6,80,14,5,7]),function(ne,e,o,A,a,R,I,P){"use strict";var S,k,O,T,v,C,y,f,h,u,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends A.Disposable{constructor(n,s,r,c,l,m){super(),S.set(this,void 0),k.set(this,void 0),O.set(this,void 0),T.set(this,void 0),v.set(this,!1),C.set(this,void 0),y.set(this,void 0),f.set(this,void 0),h.set(this,void 0),u.set(this,this.B(new o.Emitter)),this.onDidChangeVisibility=Ue(this,u,"f").event,g.set(this,this.B(new o.Emitter)),this.onDidDispose=Ue(this,g,"f").event,_e(this,O,r,"f"),_e(this,y,c,"f"),_e(this,S,n,"f"),_e(this,k,s,"f"),_e(this,T,l,"f"),_e(this,C,m,"f")}dispose(){Ue(this,v,"f")||(_e(this,v,!0,"f"),Ue(this,g,"f").fire(),Ue(this,T,"f").dispose(),super.dispose())}get title(){return this.a(),Ue(this,y,"f")}set title(n){this.a(),Ue(this,y,"f")!==n&&(_e(this,y,n,"f"),Ue(this,k,"f").$setWebviewViewTitle(Ue(this,S,"f"),n))}get description(){return this.a(),Ue(this,f,"f")}set description(n){this.a(),Ue(this,f,"f")!==n&&(_e(this,f,n,"f"),Ue(this,k,"f").$setWebviewViewDescription(Ue(this,S,"f"),n))}get visible(){return Ue(this,C,"f")}get webview(){return Ue(this,T,"f")}get viewType(){return Ue(this,O,"f")}_setVisible(n){n===Ue(this,C,"f")||Ue(this,v,"f")||(_e(this,C,n,"f"),Ue(this,u,"f").fire())}get badge(){return this.a(),Ue(this,h,"f")}set badge(n){this.a(),!(n?.value===Ue(this,h,"f")?.value&&n?.tooltip===Ue(this,h,"f")?.tooltip)&&(_e(this,h,R.ViewBadge.from(n),"f"),Ue(this,k,"f").$setWebviewViewBadge(Ue(this,S,"f"),n))}show(n){this.a(),Ue(this,k,"f").$show(Ue(this,S,"f"),!!n)}a(){if(Ue(this,v,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,k=new WeakMap,O=new WeakMap,T=new WeakMap,v=new WeakMap,C=new WeakMap,y=new WeakMap,f=new WeakMap,h=new WeakMap,u=new WeakMap,g=new WeakMap;class D{constructor(n,s){this.d=s,this.b=new Map,this.c=new Map,this.a=n.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(n,s,r,c){if(this.b.has(s))throw new Error(`View provider for '${s}' already registered`);return this.b.set(s,{provider:r,extension:n}),this.a.$registerWebviewViewProvider((0,a.toExtensionData)(n),s,{retainContextWhenHidden:c?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,a.shouldSerializeBuffersForPostMessage)(n)}),new P.Disposable(()=>{this.b.delete(s),this.a.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(n,s,r,c,l){const m=this.b.get(s);if(!m)throw new Error(`No view provider found for '${s}'`);const{provider:i,extension:t}=m,d=this.d.createNewWebview(n,{},t),E=new b(n,this.a,s,r,d,!0);this.c.set(n,E),await i.resolveWebviewView(E,{state:c},l)}async $onDidChangeWebviewViewVisibility(n,s){this.e(n)._setVisible(s)}async $disposeWebviewView(n){const s=this.e(n);this.c.delete(n),s.dispose(),this.d.deleteWebview(n)}e(n){const s=this.c.get(n);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=D}),define(ye[141],De([1,0,3,5,2,16,8,4,20]),function(ne,e,o,A,a,R,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class an{get state(){return this.d}constructor(T){this.c=new o.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=T.getProxy(A.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}$onDidChangeWindowFocus(T){T!==this.d.focused&&(this.d={...this.d,focused:T},this.c.fire(this.d))}openUri(T,v){let C;if(typeof T=="string"){C=T;try{T=a.URI.parse(T)}catch{return Promise.reject(`Invalid uri - '${T}'`)}}return(0,I.isFalsyOrWhitespace)(T.scheme)?Promise.reject("Invalid scheme - cannot be empty"):T.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${T.scheme}'`):this.b.$openUri(T,C,v)}async asExternalUri(T,v){if((0,I.isFalsyOrWhitespace)(T.scheme))return Promise.reject("Invalid scheme - cannot be empty");const C=await this.b.$asExternalUri(T,v);return a.URI.from(C)}};k.a={focused:!0},k=xe([ze(0,S.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(ye[282],De([1,0,119,283,70,40,2,13,47]),function(ne,e,o,A,a,R,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(v,C,y){this.b=v,this.c=C,this.f=y,this.a=A.createServer((f,h)=>this.h(f,h)),this.g().catch(f=>(C.error(f),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,C){const y=(h,u)=>{C.writeHead(h,{"content-type":"application/json"}),C.end(JSON.stringify(u||null),g=>g&&this.c.error(g))},f=[];v.setEncoding("utf8"),v.on("data",h=>f.push(h)),v.on("end",async()=>{try{const h=JSON.parse(f.join(""));let u;switch(h.type){case"open":u=await this.i(h);break;case"openExternal":u=await this.j(h);break;case"status":u=await this.l(h);break;case"extensionManagement":u=await this.k(h);break;default:y(404,`Unknown message type: ${h.type}`);break}y(200,u)}catch(h){const u=h instanceof Error?h.message:JSON.stringify(h);y(500,u),this.c.error("Error while processing pipe request",h)}})}async i(v){const{fileURIs:C,folderURIs:y,forceNewWindow:f,diffMode:h,mergeMode:u,addMode:g,forceReuseWindow:b,gotoLineMode:D,waitMarkerFilePath:p,remoteAuthority:n}=v,s=[];if(Array.isArray(y))for(const m of y)try{s.push({folderUri:I.URI.parse(m)})}catch{}if(Array.isArray(C))for(const m of C)try{(0,S.hasWorkspaceFileExtension)(m)?s.push({workspaceUri:I.URI.parse(m)}):s.push({fileUri:I.URI.parse(m)})}catch{}const r=p?I.URI.file(p):void 0,l={forceNewWindow:f,diffMode:h,mergeMode:u,addMode:g,gotoLineMode:D,forceReuseWindow:b,preferNewWindow:!b&&!r&&!g,waitMarkerFileURI:r,remoteAuthority:n};return this.b.executeCommand("_remoteCLI.windowOpen",s,l),""}async j(v){for(const C of v.uris){const y=I.URI.parse(C),f=y.scheme==="file"?y:C;await this.b.executeCommand("_remoteCLI.openExternal",f)}}async k(v){const C=f=>f?.map(h=>/\.vsix$/i.test(h)?I.URI.parse(h):h),y={list:v.list,install:C(v.install),uninstall:C(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",y)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&a.existsSync(this.f)&&a.unlinkSync(this.f)}}e.CLIServerBase=k;let O=class extends k{constructor(v,C){super(v,C,(0,o.createRandomIPCHandle)())}};O=xe([ze(0,R.IExtHostCommands),ze(1,P.ILogService)],O),e.CLIServer=O}),define(ye[284],De([1,0,254,25,20]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let I=class extends o.AbstractExtHostConsoleForwarder{constructor(S,k){super(S,k),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(S,k,O){const T=S==="error"||S==="warn"?process.stderr:process.stdout;this.g=!0,T.write(`
START_NATIVE_LOG
`),k.apply(console,O),T.write(`
END_NATIVE_LOG
`),this.g=!1}j(S,k){const O=process[S],T=O.write;let v="";Object.defineProperty(O,"write",{set:()=>{},get:()=>(C,y,f)=>{if(!this.g){v+=C.toString(y);const h=v.length>R?v.length:v.lastIndexOf(`
`);h!==-1&&(console[k](v.slice(0,h)),v=v.slice(h+1))}T.call(O,C,y,f)}})}};I=xe([ze(0,a.IExtHostRpcService),ze(1,A.IExtHostInitDataService)],I),e.ExtHostConsoleForwarder=I}),define(ye[285],De([1,0,11,89,30,40,6,5,2,20]),function(ne,e,o,A,a,R,I,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let O=class extends I.Disposable{constructor(v,C){super();const y=v.getProxy(P.MainContext.MainThreadDownloadService);C.registerCommand(!1,"_workbench.downloadResource",async f=>{const h=S.URI.file((0,o.join)((0,A.tmpdir)(),(0,a.generateUuid)()));return await y.$download(f,h),h})}};O=xe([ze(0,k.IExtHostRpcService),ze(1,R.IExtHostCommands)],O),e.ExtHostDownloadService=O}),define(ye[286],De([1,0,140,16,205,30]),function(ne,e,o,A,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class I extends o.ExtHostLoggerService{k(S,k,O){return S.scheme===A.Schemas.file?new a.SpdLogLogger(O?.name||(0,R.generateUuid)(),S.fsPath,!O?.donotRotate,!!O?.donotUseFormatters,k):super.k(S,k,O)}registerLogger(S){super.registerLogger(S),this.l.$registerLogger(S)}deregisterLogger(S){super.deregisterLogger(S),this.l.$deregisterLogger(S)}}e.ExtHostLoggerService=I}),define(ye[287],De([1,0,70,11,2,79,6,16,19,29]),function(ne,e,o,A,a,R,I,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class O extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(n){const s=await super.g(n);if(s.scheme!==P.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const r=s.fsPath;let c=0;do{let l;c===0?l=r:l=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${c}`:`${r}-${c}`,await T(l);const m=A.join(l,"vscode.lock"),i=await f(this.d,m,!1);if(i)return this.i=i,process.on("exit",()=>{i.dispose()}),a.URI.file(l);c++}while(c<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=O;async function T(p){try{await k.Promises.stat(p);return}catch{}try{await k.Promises.mkdir(p,{recursive:!0})}catch{}}const v=1e3,C=10*60*1e3;class y extends I.Disposable{constructor(n,s){super(),this.b=n,this.c=s,this.a=this.B(new S.IntervalTimer),this.a.cancelAndSet(async()=>{const r=await h(n,s);(!r||r.pid!==process.pid)&&(n.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await k.Promises.utimes(s,new Date,new Date)}catch(c){n.error(c),n.info(`Lock '${s}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{o.unlinkSync(this.c)}catch{}}async setWillRelease(n){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+n};await k.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function f(p,n,s){try{const c={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(n,JSON.stringify(c),{flag:"wx"})}catch(c){p.error(c)}const r=await h(p,n);return!r||r.pid!==process.pid?s?(p.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(p.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),b(p,n)):(p.info(`Lock '${n}': Lock acquired.`),new y(p,n))}async function h(p,n){let s;try{s=await k.Promises.readFile(n)}catch(r){return p.error(r),null}try{return JSON.parse(String(s))}catch(r){return p.error(r),null}}async function u(p,n){let s;try{s=await k.Promises.stat(n)}catch(r){return p.error(r),0}return s.mtime.getTime()}function g(p){try{return process.kill(p,0),!0}catch{return!1}}async function b(p,n){const s=await h(p,n);if(!s)return p.info(`Lock '${n}': Could not read pid of lock holder.`),D(p,n);if(s.willReleaseAt){let i=s.willReleaseAt-Date.now();if(i<5e3){for(i>0?p.info(`Lock '${n}': The lockfile is scheduled to be released in ${i} ms.`):p.info(`Lock '${n}': The lockfile is scheduled to have been released.`);i>0;){if(await(0,S.timeout)(Math.min(100,i)),await u(p,n)===0)return D(p,n);i=s.willReleaseAt-Date.now()}return D(p,n)}}if(!g(s.pid))return p.info(`Lock '${n}': The pid ${s.pid} appears to be gone.`),D(p,n);const r=await u(p,n),c=Date.now()-r;if(c<=C)return p.info(`Lock '${n}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;p.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const l=await u(p,n),m=Date.now()-l;return m<=C?(p.info(`Lock '${n}': The lock does not look stale, elapsed: ${m} ms, giving up.`),null):(p.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),D(p,n))}async function D(p,n){p.info(`Lock '${n}': Deleting a stale lock.`);try{await k.Promises.unlink(n)}catch{}return f(p,n,!0)}}),define(ye[288],De([1,0,30,20,41]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends a.BaseExtHostTerminalService{constructor(P){super(!0,P)}createTerminal(P,S,k){return this.createTerminalFromOptions({name:P,shellPath:S,shellArgs:k})}createTerminalFromOptions(P,S){const k=new a.ExtHostTerminal(this.a,(0,o.generateUuid)(),P,P.name);return this.f.push(k),k.create(P,this.L(P,S)),k.value}};R=xe([ze(0,A.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(ye[289],De([1,0,5,20,186,6,25,2,46,24,29,7,10,55,3,129,102,13]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class g extends f.DisposableTunnel{}function b(i){const t=i.trim().split(`
`),d=[];return t.forEach(w=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(w);L&&L.length>=3&&d.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),d.reduce((w,L)=>(w[L.socket]=L,w),{})}e.getSockets=b;function D(...i){const t=[].concat(...i.map(n));return[...new Map(t.filter(d=>d.st==="0A").map(d=>{const E=d.local_address.split(":");return{socket:parseInt(d.inode,10),ip:p(E[0]),port:parseInt(E[1],16)}}).map(d=>[d.ip+":"+d.port,d])).values()]}e.loadListeningPorts=D;function p(i){let t="";if(i.length===8)for(let d=i.length-2;d>=0;d-=2)t+=parseInt(i.substr(d,2),16),d!==0&&(t+=".");else for(let d=i.length-4;d>=0;d-=4)t+=parseInt(i.substr(d,4),16).toString(16),d!==0&&(t+=":");return t}function n(i){const t=i.trim().split(`
`),d=t.shift().trim().split(/\s+/).filter(w=>w!=="rx_queue"&&w!=="tm->when");return t.map(w=>w.trim().split(/\s+/).reduce((L,q,V)=>(L[d[V]||V]=q,L),{}))}e.loadConnectionTable=n;function s(i){return!!i.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||i.indexOf("out/server-main.js")!==-1||i.indexOf("_productName=VSCode")!==-1}function r(i){const t=i.trim().split(`
`),d=[];return t.forEach(E=>{const w=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);w&&w.length>=4&&d.push({pid:parseInt(w[1],10),ppid:parseInt(w[2]),cmd:w[3]})}),d}e.getRootProcesses=r;async function c(i,t,d){const E=d.reduce((L,q)=>(L[q.pid]=q,L),{}),w=[];return i.forEach(({socket:L,ip:q,port:V})=>{const M=t[L]?t[L].pid:void 0,B=M?E[M]?.cmd:void 0;M&&B&&!s(B)&&w.push({host:q,port:V,detail:B,pid:M})}),w}e.findPorts=c;function l(i,t,d){const E=new Map,w=r(t);for(const L of i){const q=d.get(L.port);if(q){E.set(L.port,q);continue}const V=w.find(M=>M.cmd.includes(`${L.port}`));if(V){let M=V,B;do B=w.find(N=>N.ppid===M.pid),B&&(M=B);while(B);E.set(L.port,{host:L.ip,port:L.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else E.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=l;let m=class extends R.Disposable{constructor(t,d,E){super(),this.n=E,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new y.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=t.getProxy(o.MainContext.MainThreadTunnelService),v.isLinux&&d.remote.isRemote&&d.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(t,d){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${d.remoteAddress.host}:${d.remoteAddress.port}.`);const E=await this.a.$openTunnel(d,t.displayName);if(E){const w=new g(E.remoteAddress,E.localAddress,()=>this.a.$closeTunnel(E.remoteAddress));return this.B(w),w}}async getTunnels(){return this.a.$getTunnels()}p(t){return Math.max(t*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(t,d){const E=this.r();return this.l.set(E,{selector:t,provider:d}),this.a.$registerPortsAttributesProvider(t,E),new T.Disposable(()=>{this.l.delete(E),this.a.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(t,d,E,w,L){const q=[];for(const M of t){const B=this.l.get(M);if(!B)return[];q.push(...await Promise.all(d.map(async N=>B.provider.providePortAttributes(N,E,w,L))))}const V=q.filter(M=>!!M);return V.length>0?V.map(M=>({autoForwardAction:M.autoForwardAction,port:M.port})):[]}async $registerCandidateFinder(t){if(t&&this.h)return;this.h=t;const d=new h.MovingAverage;let E;for(;this.h;){const w=new Date().getTime(),L=(await this.findCandidatePorts()).filter(V=>(0,f.isLocalhost)(V.host)||(0,f.isAllInterfaces)(V.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${L.map(V=>V.port).join(", ")}`);const q=new Date().getTime()-w;d.update(q),(!E||JSON.stringify(E)!==JSON.stringify(L))&&(E=L,await this.a.$onFoundNewCandidates(E)),await new Promise(V=>setTimeout(()=>V(),this.p(d.value)))}}async setTunnelFactory(t){if(t){if(t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.c=t.showCandidatePort,this.a.$setCandidateFilter()),t.tunnelFactory){this.b=t.tunnelFactory;let d=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&d.length===0&&(d=[{id:"private",label:a.localize(0,null),themeIcon:"lock"},{id:"public",label:a.localize(1,null),themeIcon:"eye"}]);const E=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:d}:void 0;this.a.$setTunnelProvider(E)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(t,d){if(this.f.has(t.host)){const E=this.f.get(t.host);E.has(t.port)&&(d&&E.get(t.port).disposeListener.dispose(),await E.get(t.port).tunnel.dispose(),E.delete(t.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(t,d){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this.b(t,d);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const w=await E;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(t.remoteAddress.host)||this.f.set(t.remoteAddress.host,new Map);const L=this.B(w.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(w.remoteAddress))));return this.f.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:w,disposeListener:L}),C.TunnelDtoConverter.fromApiTunnel(w)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(t){const d=await Promise.all(t.map(w=>this.c(w.host,w.port,w.detail??""))),E=t.filter((w,L)=>d[L]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(w=>w.port).join(", ")} to ${E.map(w=>w.port).join(", ")}`),E}async findCandidatePorts(){let t="",d="";try{t=await O.Promises.readFile("/proc/net/tcp","utf8"),d=await O.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const E=D(t,d),w=await new Promise($=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(z,ae,ee)=>{$(ae)})}),L=b(w),q=await O.Promises.readdir("/proc"),V=[];for(const $ of q)try{const z=Number($),ae=k.joinPath(P.URI.file("/proc"),$);if((await O.Promises.stat(ae.fsPath)).isDirectory()&&!isNaN(z)){const x=await O.Promises.readlink(k.joinPath(ae,"cwd").fsPath),J=await O.Promises.readFile(k.joinPath(ae,"cmdline").fsPath,"utf8");V.push({pid:z,cwd:x,cmd:J})}}catch{}const M=[],B=E.filter($=>{const z=L[$.socket];return z||M.push($),z}),N=c(B,L,V);let U;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const $=await new Promise(z=>{(0,S.exec)("ps -F -A -l | grep root",(ae,ee,x)=>{z(ee)})});this.j=l(M,$,this.j),U=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.map(z=>z.port).join(", ")}`)}return N.then($=>U?$.concat(U):$)}};m=xe([ze(0,A.IExtHostRpcService),ze(1,I.IExtHostInitDataService),ze(2,u.ILogService)],m),e.ExtHostTunnelService=m}),define(ye[290],De([1,0,19,22,21,12,3,6,114,248,58]),function(ne,e,o,A,a,R,I,P,S,k,O){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(E,w){try{return JSON.stringify(E,w)}catch{return"null"}}const C="$$ref$$",y={[C]:-1};class f{constructor(w,L){this.jsonString=w,this.referencedBuffers=L}}function h(E,w=null,L=!1){const q=[];return{jsonString:(L?v:JSON.stringify)(E,(M,B)=>{if(typeof B>"u")return y;if(typeof B=="object"){if(B instanceof A.VSBuffer){const N=q.push(B)-1;return{[C]:N}}if(w)return w(M,B)}return B}),referencedBuffers:q}}e.stringifyJsonWithBufferRefs=h;function u(E,w,L){return JSON.parse(E,(q,V)=>{if(V){const M=V[C];if(typeof M=="number")return w[M];if(L&&V.$mid===1)return L.transformIncoming(V)}return V})}e.parseJsonAndRestoreBufferRefs=u;function g(E,w){return JSON.stringify(E,w)}function b(E){return E?(w,L)=>L&&L.$mid===1?E.transformOutgoing(L):L:null}var D;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},s=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class c extends P.Disposable{constructor(w,L=null,q=null){super(),this[T]=!0,this.b=this.B(new I.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=w,this.f=L,this.g=q,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let V=0,M=O.ProxyIdentifier.count;V<M;V++)this.k[V]=null,this.l[V]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new o.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(V=>this.G(V))}dispose(){this.j=!0,Object.keys(this.s).forEach(w=>{this.s[w].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(w){this.u===0&&(this.v=Date.now()+c.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(w){this.v=Date.now()+c.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(w){this.t!==w&&(this.t=w,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(w){return this.g?(0,S.transformIncomingURIs)(w,this.g):w}getProxy(w){const{nid:L,sid:q}=w;return this.l[L]||(this.l[L]=this.F(L,q)),this.l[L]}F(w,L){const q={get:(V,M)=>(typeof M=="string"&&!V[M]&&M.charCodeAt(0)===36&&(V[M]=(...B)=>this.O(w,M,B)),M===r?L:V[M])};return new Proxy(Object.create(null),q)}set(w,L){return this.k[w.nid]=L,L}assertRegistered(w){for(let L=0,q=w.length;L<q;L++){const V=w[L];if(!this.k[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}G(w){if(this.j)return;const L=w.byteLength,q=l.read(w,0),V=q.readUInt8(),M=q.readUInt32();switch(V){case 1:case 2:{let{rpcId:B,method:N,args:U}=i.deserializeRequestJSONArgs(q);this.g&&(U=(0,S.transformIncomingURIs)(U,this.g)),this.H(L,M,B,N,U,V===2);break}case 3:case 4:{let{rpcId:B,method:N,args:U}=i.deserializeRequestMixedArgs(q);this.g&&(U=(0,S.transformIncomingURIs)(U,this.g)),this.H(L,M,B,N,U,V===4);break}case 5:{this.f?.logIncoming(L,M,0,"ack"),this.z(M);break}case 6:{this.I(L,M);break}case 7:{this.J(L,M,void 0);break}case 9:{let B=i.deserializeReplyOKJSON(q);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.J(L,M,B);break}case 10:{const B=i.deserializeReplyOKJSONWithBuffers(q,this.g);this.J(L,M,B);break}case 8:{const B=i.deserializeReplyOKVSBuffer(q);this.J(L,M,B);break}case 11:{let B=i.deserializeReplyErrError(q);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.L(L,M,B);break}case 12:{this.L(L,M,void 0);break}default:console.error("received unexpected message"),console.error(w)}}H(w,L,q,V,M,B){this.f?.logIncoming(w,L,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(q)}.${V}(`,M);const N=String(L);let U,$;if(B){const ae=new a.CancellationTokenSource;M.push(ae.token),U=this.M(q,V,M),$=()=>ae.cancel()}else U=this.M(q,V,M),$=n;this.p[N]=$;const z=i.serializeAcknowledged(L);this.f?.logOutgoing(z.byteLength,L,1,"ack"),this.c.send(z),U.then(ae=>{delete this.p[N];const ee=i.serializeReplyOK(L,ae,this.h);this.f?.logOutgoing(ee.byteLength,L,1,"reply:",ae),this.c.send(ee)},ae=>{delete this.p[N];const ee=i.serializeReplyErr(L,ae);this.f?.logOutgoing(ee.byteLength,L,1,"replyErr:",ae),this.c.send(ee)})}I(w,L){this.f?.logIncoming(w,L,1,"receiveCancel");const q=String(L);this.p[q]?.()}J(w,L,q){this.f?.logIncoming(w,L,0,"receiveReply:",q);const V=String(L);if(!this.s.hasOwnProperty(V))return;const M=this.s[V];delete this.s[V],M.resolveOk(q)}L(w,L,q){this.f?.logIncoming(w,L,0,"receiveReplyErr:",q);const V=String(L);if(!this.s.hasOwnProperty(V))return;const M=this.s[V];delete this.s[V];let B;q&&(q.$isError?(B=new Error,B.name=q.name,B.message=q.message,B.stack=q.stack):B=q),M.resolveErr(B)}M(w,L,q){try{return Promise.resolve(this.N(w,L,q))}catch(V){return Promise.reject(V)}}N(w,L,q){const V=this.k[w];if(!V)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(w));const M=V[L];if(typeof M!="function")throw new Error("Unknown method "+L+" on actor "+(0,O.getStringIdentifierForProxy)(w));return M.apply(V,q)}O(w,L,q){if(this.j)return new k.CanceledLazyPromise;let V=null;if(q.length>0&&a.CancellationToken.isCancellationToken(q[q.length-1])&&(V=q.pop()),V&&V.isCancellationRequested)return Promise.reject(R.canceled());const M=i.serializeRequestArguments(q,this.h),B=++this.m,N=String(B),U=new k.LazyPromise;V&&V.onCancellationRequested(()=>{const z=i.serializeCancel(B);this.f?.logOutgoing(z.byteLength,B,0,"cancel"),this.c.send(i.serializeCancel(B))}),this.s[N]=U,this.y(B);const $=i.serializeRequest(B,w,L,M,!!V);return this.f?.logOutgoing($.byteLength,B,0,`request: ${(0,O.getStringIdentifierForProxy)(w)}.${L}(`,q),this.c.send($),U}}T=s,c.a=3*1e3,e.RPCProtocol=c;class l{static alloc(w,L,q){const V=new l(A.VSBuffer.alloc(q+1+4),0);return V.writeUInt8(w),V.writeUInt32(L),V}static read(w,L){return new l(w,L)}get buffer(){return this.a}constructor(w,L){this.a=w,this.b=L}static sizeUInt8(){return 1}writeUInt8(w){this.a.writeUInt8(w,this.b),this.b+=1}readUInt8(){const w=this.a.readUInt8(this.b);return this.b+=1,w}writeUInt32(w){this.a.writeUInt32BE(w,this.b),this.b+=4}readUInt32(){const w=this.a.readUInt32BE(this.b);return this.b+=4,w}static sizeShortString(w){return 1+w.byteLength}writeShortString(w){this.a.writeUInt8(w.byteLength,this.b),this.b+=1,this.a.set(w,this.b),this.b+=w.byteLength}readShortString(){const w=this.a.readUInt8(this.b);this.b+=1;const q=this.a.slice(this.b,this.b+w).toString();return this.b+=w,q}static sizeLongString(w){return 4+w.byteLength}writeLongString(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readLongString(){const w=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+w).toString();return this.b+=w,q}writeBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}static sizeVSBuffer(w){return 4+w.byteLength}writeVSBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readVSBuffer(){const w=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+w);return this.b+=w,L}static sizeMixedArray(w){let L=0;L+=1;for(let q=0,V=w.length;q<V;q++){const M=w[q];switch(L+=1,M.type){case 1:L+=this.sizeLongString(M.value);break;case 2:L+=this.sizeVSBuffer(M.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(M.value);for(let B=0;B<M.buffers.length;++B)L+=this.sizeVSBuffer(M.buffers[B]);break;case 4:break}}return L}writeMixedArray(w){this.a.writeUInt8(w.length,this.b),this.b+=1;for(let L=0,q=w.length;L<q;L++){const V=w[L];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let M=0;M<V.buffers.length;++M)this.writeBuffer(V.buffers[M]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const w=this.a.readUInt8(this.b);this.b+=1;const L=new Array(w);for(let q=0;q<w;q++)switch(this.readUInt8()){case 1:L[q]=this.readLongString();break;case 2:L[q]=this.readVSBuffer();break;case 3:{const M=this.readUInt32(),B=this.readLongString(),N=[];for(let U=0;U<M;++U)N.push(this.readVSBuffer());L[q]=new O.SerializableObjectWithBuffers(u(B,N,null));break}case 4:L[q]=void 0;break}return L}}l.sizeUInt32=4;var m;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(m||(m={}));class i{static a(w){for(let L=0,q=w.length;L<q;L++)if(w[L]instanceof A.VSBuffer||w[L]instanceof O.SerializableObjectWithBuffers||typeof w[L]>"u")return!0;return!1}static serializeRequestArguments(w,L){if(this.a(w)){const q=[];for(let V=0,M=w.length;V<M;V++){const B=w[V];if(B instanceof A.VSBuffer)q[V]={type:2,value:B};else if(typeof B>"u")q[V]={type:4};else if(B instanceof O.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:U}=h(B.value,L);q[V]={type:3,value:A.VSBuffer.fromString(N),buffers:U}}else q[V]={type:1,value:A.VSBuffer.fromString(g(B,L))}}return{type:1,args:q}}return{type:0,args:g(w,L)}}static serializeRequest(w,L,q,V,M){switch(V.type){case 0:return this.b(w,L,q,V.args,M);case 1:return this.c(w,L,q,V.args,M)}}static b(w,L,q,V,M){const B=A.VSBuffer.fromString(q),N=A.VSBuffer.fromString(V);let U=0;U+=l.sizeUInt8(),U+=l.sizeShortString(B),U+=l.sizeLongString(N);const $=l.alloc(M?2:1,w,U);return $.writeUInt8(L),$.writeShortString(B),$.writeLongString(N),$.buffer}static deserializeRequestJSONArgs(w){const L=w.readUInt8(),q=w.readShortString(),V=w.readLongString();return{rpcId:L,method:q,args:JSON.parse(V)}}static c(w,L,q,V,M){const B=A.VSBuffer.fromString(q);let N=0;N+=l.sizeUInt8(),N+=l.sizeShortString(B),N+=l.sizeMixedArray(V);const U=l.alloc(M?4:3,w,N);return U.writeUInt8(L),U.writeShortString(B),U.writeMixedArray(V),U.buffer}static deserializeRequestMixedArgs(w){const L=w.readUInt8(),q=w.readShortString(),V=w.readMixedArray(),M=new Array(V.length);for(let B=0,N=V.length;B<N;B++){const U=V[B];typeof U=="string"?M[B]=JSON.parse(U):M[B]=U}return{rpcId:L,method:q,args:M}}static serializeAcknowledged(w){return l.alloc(5,w,0).buffer}static serializeCancel(w){return l.alloc(6,w,0).buffer}static serializeReplyOK(w,L,q){if(typeof L>"u")return this.d(w);if(L instanceof A.VSBuffer)return this.e(w,L);if(L instanceof O.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:M}=h(L.value,q,!0);return this.g(w,V,M)}else return this.f(w,v(L,q))}static d(w){return l.alloc(7,w,0).buffer}static e(w,L){let q=0;q+=l.sizeVSBuffer(L);const V=l.alloc(8,w,q);return V.writeVSBuffer(L),V.buffer}static deserializeReplyOKVSBuffer(w){return w.readVSBuffer()}static f(w,L){const q=A.VSBuffer.fromString(L);let V=0;V+=l.sizeLongString(q);const M=l.alloc(9,w,V);return M.writeLongString(q),M.buffer}static g(w,L,q){const V=A.VSBuffer.fromString(L);let M=0;M+=l.sizeUInt32,M+=l.sizeLongString(V);for(const N of q)M+=l.sizeVSBuffer(N);const B=l.alloc(10,w,M);B.writeUInt32(q.length),B.writeLongString(V);for(const N of q)B.writeBuffer(N);return B.buffer}static deserializeReplyOKJSON(w){const L=w.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(w,L){const q=w.readUInt32(),V=w.readLongString(),M=[];for(let B=0;B<q;++B)M.push(w.readVSBuffer());return new O.SerializableObjectWithBuffers(u(V,M,L))}static serializeReplyErr(w,L){const q=L?v(R.transformErrorForSerialization(L),null):void 0;if(typeof q!="string")return this.h(w);const V=A.VSBuffer.fromString(q);let M=0;M+=l.sizeLongString(V);const B=l.alloc(11,w,M);return B.writeLongString(V),B.buffer}static deserializeReplyErrError(w){const L=w.readLongString();return JSON.parse(L)}static h(w){return l.alloc(12,w,0).buffer}}var t;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(t||(t={}));var d;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(d||(d={}))}),define(ye[291],De([1,0,3,39,54,4]),function(ne,e,o,A,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new a.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new a.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new a.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)("outputService");var I;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class P{constructor(){this.a=new Map,this.b=new o.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new o.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(O=>k.push(O)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}A.Registry.add(e.Extensions.OutputChannels,new P),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new a.RawContextKey("activeOutputChannel","")}),define(ye[142],De([1,0,5,4,20,27,13,291,78,25,48,158,22,9,44,3,6]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class u extends I.AbstractMessageLogger{get disposed(){return this.l}constructor(p,n,s,r,c){super(),this.id=p,this.name=n,this.m=s,this.n=r,this.extension=c,this.k=0,this.l=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.k;this.m.flush(),this.n.$update(this.id,P.OutputChannelUpdateMode.Clear,p)}replace(p){const n=this.k;this.info(p),this.n.$update(this.id,P.OutputChannelUpdateMode.Replace,n),this.visible&&this.m.flush()}show(p,n){this.m.flush(),this.n.$reveal(this.id,!!(typeof p=="boolean"?p:n))}hide(){this.n.$close(this.id)}g(p,n){this.k+=v.VSBuffer.fromString(n).byteLength,(0,I.log)(this.m,p,n),this.visible&&(this.m.flush(),this.n.$update(this.id,P.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class g extends u{appendLine(p){this.append(p)}}let b=class{constructor(p,n,s,r,c,l){this.i=n,this.j=s,this.k=r,this.l=c,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(o.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[n,s]of this.g)s.visible=n===this.h}createOutputChannel(p,n,s){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const r=typeof n=="object"&&n.log,c=(0,C.isString)(n)?n:void 0;if((0,C.isString)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const m=this.i.environment.extensionLogLevel?.find(([t])=>R.ExtensionIdentifier.equals(s.identifier,t))?.[1];m&&(l=(0,I.parseLogLevel)(m));const i=r?this.o(p,l,s):this.n(p,c,s);return i.then(t=>{this.g.set(t.id,t),t.visible=t.id===this.h}),r?this.r(p,l??this.m.getLevel(),i):this.q(p,i)}async n(p,n,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,c=this.k.extUri.joinPath(r,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(p,c,n,s.identifier.value);return new u(m,p,l,this.a,s)}async o(p,n,s){const r=await this.p(s),c=this.k.extUri.joinPath(r,`${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=c.toString(),m=this.l.createLogger(c,{id:l,name:p,logLevel:n,extensionId:s.identifier.value});return new g(l,p,m,this.a,s)}p(p){let n=this.d.get(p.identifier.value);if(!n){const s=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(s)}catch(r){if((0,y.toFileSystemProviderErrorCode)(r)!==y.FileSystemProviderErrorCode.FileExists)throw r}return s})())}return n}q(p,n){let s=!1;const r=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return p},append(c){r(),n.then(l=>l.append(c))},appendLine(c){r(),n.then(l=>l.appendLine(c))},clear(){r(),n.then(c=>c.clear())},replace(c){r(),n.then(l=>l.replace(c))},show(c,l){r(),n.then(m=>m.show(c,l))},hide(){r(),n.then(c=>c.hide())},dispose(){s=!0,n.then(c=>c.dispose())}}}r(p,n,s){const r=new h.DisposableStore,c=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},l=r.add(new f.Emitter);function m(i){n=i,l.fire(i)}return s.then(i=>{r.add(i),i.logLevel!==n&&m(i.logLevel),r.add(i.onDidChangeLogLevel(t=>m(t)))}),{...this.q(p,s),get logLevel(){return n},onDidChangeLogLevel:l.event,trace(i,...t){c(),s.then(d=>d.trace(i,...t))},debug(i,...t){c(),s.then(d=>d.debug(i,...t))},info(i,...t){c(),s.then(d=>d.info(i,...t))},warn(i,...t){c(),s.then(d=>d.warn(i,...t))},error(i,...t){c(),s.then(d=>d.error(i,...t))},dispose(){r.dispose()}}}};b=xe([ze(0,a.IExtHostRpcService),ze(1,k.IExtHostInitDataService),ze(2,S.IExtHostConsumerFileSystem),ze(3,O.IExtHostFileSystemInfo),ze(4,I.ILoggerService),ze(5,I.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(ye[292],De([1,0,4]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,o.createDecorator)("remoteAgentService")}),define(ye[293],De([1,0,33,16,11,10,24,2,4,218,47,236,292]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let C=class cn{constructor(f,h,u,g){this.d=f,this.e=h,this.f=u,this.g=g,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??f})()}hasValidBasename(f,h,u){return typeof h=="string"||typeof h>"u"?this.a.then(g=>this.h(f,g,h)):this.h(f,h,u)}h(f,h,u){return f.scheme===A.Schemas.file||f.scheme===A.Schemas.vscodeRemote?(0,o.isValidBasename)(u??(0,I.basename)(f),h===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,h){if(f.remoteAuthority)return A.Schemas.vscodeRemote;const u=(0,k.getVirtualWorkspaceScheme)(h.getWorkspace());if(u)return u;const g=h.getWorkspace().folders[0];if(g)return g.uri.scheme;const b=h.getWorkspace().configuration;return b?b.scheme:A.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?a.win32:a.posix)}async fileURI(f){let h="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const g=f.indexOf("/",2);g===-1?(h=f.substring(2),f="/"):(h=f.substring(2,g),f=f.substring(g)||"/")}return P.URI.from({scheme:A.Schemas.file,authority:h,path:f,query:"",fragment:""})}};C=xe([ze(1,v.IRemoteAgentService),ze(2,T.IWorkbenchEnvironmentService),ze(3,O.IWorkspaceContextService)],C),e.AbstractPathService=C}),define(ye[81],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class o{constructor(I,P){this.line=I,this.character=P}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,P){return new o(0,0)}with(I){return new o(0,0)}}e.Position=o;class A{constructor(I,P,S,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new o(I,P),this.end=new o(S,k)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new A(0,0,0,0)}with(I){return new A(0,0,0,0)}}e.Range=A;var a;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(a=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[31],De([1,0,15,38,23,33,8,4,11,12,81,19]),function(ne,e,o,A,a,R,I,P,S,k,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",C=" characters skipped \u27EB",y=(v.length+C.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var f;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function u(J){return!!J.preview}e.resultIsMatch=u;function g(J){return!!J.resource}e.isFileMatch=g;function b(J){return!!J.message}e.isProgressMessage=b;var D;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(D=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=p;class n{constructor(ie,pe,Q){this.ranges=pe;const Y=Array.isArray(pe)?pe:[pe];if(Q&&Q.matchLines===1&&s(Y)){ie=(0,I.getNLines)(ie,Q.matchLines);let Z="",me=0,ve=0;const Ie=Math.floor(Q.charsPerLine/5),Re=[];for(const oe of Y){const le=Math.max(oe.startColumn-Ie,0),ue=oe.startColumn+Q.charsPerLine;if(le>ve+Ie+y){const te=v+(le-ve)+C;Z+=te+ie.slice(le,ue),me+=le-(ve+te.length)}else Z+=ie.slice(ve,ue);Re.push(new c(0,oe.startColumn-me,oe.endColumn-me)),ve=ue}this.preview={text:Z,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const Z=Array.isArray(pe)?pe[0].startLineNumber:pe.startLineNumber;this.preview={text:ie,matches:(0,o.mapArrayOrNot)(pe,me=>new r(me.startLineNumber-Z,me.startColumn,me.endLineNumber-Z,me.endColumn))}}}}e.TextSearchMatch=n;function s(J){const ie=J[0].startLineNumber;for(const pe of J)if(pe.startLineNumber!==ie||pe.endLineNumber!==ie)return!1;return!0}class r{constructor(ie,pe,Q,Y){this.startLineNumber=ie,this.startColumn=pe,this.endLineNumber=Q,this.endColumn=Y}}e.SearchRange=r;class c extends r{constructor(ie,pe,Q){super(ie,pe,ie,Q)}}e.OneLineRange=c;var l;(function(J){J.List="list",J.Tree="tree"})(l=e.ViewMode||(e.ViewMode={}));var m;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(m=e.SearchSortOrder||(e.SearchSortOrder={}));function i(J,ie=!0){const pe=J&&J.files&&J.files.exclude,Q=ie&&J&&J.search&&J.search.exclude;if(!pe&&!Q)return;if(!pe||!Q)return pe||Q;let Y=Object.create(null);return Y=a.mixin(Y,a.deepClone(pe)),Y=a.mixin(Y,a.deepClone(Q),!0),Y}e.getExcludes=i;function t(J,ie){return J.excludePattern&&A.match(J.excludePattern,ie)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&A.match(J.includePattern,ie)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(pe=>{const Q=pe.folder.fsPath;if(R.isEqualOrParent(ie,Q)){const Y=S.relative(Q,ie);return!pe.includePattern||!!A.match(pe.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=t;var d;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(ie,pe){super(ie),this.code=pe}}e.SearchError=E;function w(J){const ie=J.message;if((0,k.isCancellationError)(J))return new E(ie,d.canceled);try{const pe=JSON.parse(ie);return new E(pe.message,pe.code)}catch{return new E(ie,d.other)}}e.deserializeSearchError=w;function L(J){const ie={message:J.message,code:J.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=L;function q(J){return J.type==="error"?!0:J.type==="success"}e.isSerializedSearchComplete=q;function V(J){return J.type==="success"}e.isSerializedSearchSuccess=V;function M(J){return!!J.path}e.isSerializedFileMatch=M;function B(J,ie){const pe=J.searchPath?J.searchPath:J.relativePath;return(0,I.fuzzyContains)(pe,ie)}e.isFilePatternMatch=B;class N{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function U(J,ie){const pe={...J||{},...ie||{}};return Object.keys(pe).filter(Q=>{const Y=pe[Q];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=U;class ${constructor(ie,pe){this.c=null,this.a={...ie.excludePattern||{},...pe.excludePattern||{}},this.b=A.parse(this.a);let Q=ie.includePattern;pe.includePattern&&(Q?Q={...Q,...pe.includePattern}:Q=pe.includePattern),Q&&(this.c=A.parse(Q))}matchesExcludesSync(ie,pe,Q){return!!(this.b&&this.b(ie,pe,Q))}includedInQuerySync(ie,pe,Q){return!(this.b&&this.b(ie,pe,Q)||this.c&&!this.c(ie,pe,Q))}includedInQuery(ie,pe,Q){const Y=this.b(ie,pe,Q),Z=()=>this.c?!!this.c(ie,pe,Q):!0;return(0,T.isThenable)(Y)?Y.then(me=>me?!1:Z()):Z()}hasSiblingExcludeClauses(){return z(this.a)}}e.QueryGlobTester=$;function z(J){for(const ie in J)if(typeof J[ie]!="boolean")return!0;return!1}function ae(J){if(!J)return;let ie;return pe=>(ie||(ie=(J()||Promise.resolve([])).then(Q=>Q?x(Q):{})),ie.then(Q=>!!Q[pe]))}e.hasSiblingPromiseFn=ae;function ee(J){if(!J)return;let ie;return pe=>{if(!ie){const Q=J();ie=Q?x(Q):{}}return!!ie[pe]}}e.hasSiblingFn=ee;function x(J){const ie={};for(const pe of J)ie[pe]=!0;return ie}}),define(ye[34],De([1,0,15,19,21,3,6,68,16,102,24,8,9,2,184,4,13,206,47,48,25,20,14,7,56,31,5]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u,g,b,D,p,n,s,r,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function m(V,M,B){return new O.ExtUri(N=>E(N,B)).isEqual(V,M)}function i(V,M,B){return m(V.uri,M.uri,B)?0:(0,T.compare)(V.uri.toString(),M.uri.toString())}function t(V,M,B){return V.index!==M.index?V.index<M.index?-1:1:m(V.uri,M.uri,B)?(0,T.compare)(V.name,M.name):(0,T.compare)(V.uri.toString(),M.uri.toString())}function d(V,M,B,N){const U=V.slice(0).sort((z,ae)=>B(z,ae,N)),$=M.slice(0).sort((z,ae)=>B(z,ae,N));return(0,o.delta)(U,$,(z,ae)=>B(z,ae,N))}function E(V,M){const B=M.getCapabilities(V.scheme);return!(B&&B&1024)}class w extends g.Workspace{static toExtHostWorkspace(M,B,N,U){if(!M)return{workspace:null,added:[],removed:[]};const{id:$,name:z,folders:ae,configuration:ee,transient:x,isUntitled:J}=M,ie=[],pe=B;B?ae.forEach((me,ve)=>{const Ie=C.URI.revive(me.uri),Re=w.o(N||B,Ie,U);Re?(Re.name=me.name,Re.index=me.index,ie.push(Re)):ie.push({uri:Ie,name:me.name,index:ve})}):ie.push(...ae.map(({uri:me,name:ve,index:Ie})=>({uri:C.URI.revive(me),name:ve,index:Ie}))),ie.sort((me,ve)=>me.index<ve.index?-1:1);const Q=new w($,z,ie,!!x,ee?C.URI.revive(ee):null,!!J,me=>E(me,U)),{added:Y,removed:Z}=d(pe?pe.workspaceFolders:[],Q.workspaceFolders,i,U);return{workspace:Q,added:Y,removed:Z}}static o(M,B,N){for(let U=0;U<M.folders.length;U++){const $=M.workspaceFolders[U];if(m($.uri,B,N))return $}}constructor(M,B,N,U,$,z,ae){super(M,N.map(ee=>new g.WorkspaceFolder(ee)),U,$,ae),this.t=B,this.u=z,this.q=[],this.s=P.TernarySearchTree.forUris(ae),N.forEach(ee=>{this.q.push(ee),this.s.set(ee.uri,ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,B){return B&&this.s.get(M)&&(M=(0,O.dirname)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let L=class{constructor(M,B,N,U,$){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new R.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.AsyncEmitter,this.h=U,this.s=N,this.t=$,this.j=new k.Counter,this.k=new A.Barrier,this.o=M.getProxy(l.MainContext.MainThreadWorkspace),this.q=M.getProxy(l.MainContext.MainThreadMessageService);const z=B.workspace;this.l=z?new w(z.id,z.name,[],!!z.transient,z.configuration?C.URI.revive(z.configuration):null,!!z.isUntitled,ae=>E(ae,N)):void 0}$initializeWorkspace(M,B){this.v=B,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?C.URI.from({scheme:S.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,B,N,...U){const $=[];if(Array.isArray(U)&&U.forEach(J=>{C.URI.isUri(J.uri)&&!$.some(ie=>m(ie.uri,J.uri,this.s))&&$.push({uri:J.uri,name:J.name||(0,O.basenameOrAuthority)(J.uri)})}),this.n||[B,N].some(J=>typeof J!="number"||J<0)||N===0&&$.length===0)return!1;const z=this.x?this.x.workspaceFolders:[];if(B+N>z.length)return!1;const ae=z.slice(0);ae.splice(B,N,...$.map(J=>({uri:J.uri,name:J.name||(0,O.basenameOrAuthority)(J.uri),index:void 0})));for(let J=0;J<ae.length;J++){const ie=ae[J];if(ae.some((pe,Q)=>Q!==J&&m(ie.uri,pe.uri,this.s)))return!1}ae.forEach((J,ie)=>J.index=ie);const{added:ee,removed:x}=d(z,ae,t,this.s);if(ee.length===0&&x.length===0)return!1;if(this.o){const J=M.displayName||M.name;this.o.$updateWorkspaceFolders(J,B,N,$).then(void 0,ie=>{this.n=void 0;const pe={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(u.Severity.Error,(0,y.localize)(0,null,J,ie.toString()),pe,[])})}return this.y(ae),!0}getWorkspaceFolder(M,B){if(!!this.x)return this.x.getWorkspaceFolder(M,B)}async getWorkspaceFolder2(M,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,B)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,B){let N,U="";if(typeof M=="string"?(N=C.URI.file(M),U=M):typeof M<"u"&&(N=M,U=M.fsPath),!N)return U;const $=this.getWorkspaceFolder(N,!0);if(!$)return U;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let z=(0,O.relativePath)($.uri,N);return B&&$.name&&(z=`${$.name}/${z}`),z}y(M){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:B,added:N,removed:U}=w.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:U}))}findFiles(M,B,N,U,$=a.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let z;if(B===null?z=!1:B&&(typeof B=="string"?z=B:z=B.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:ae,folder:ee}=q(n.GlobPattern.from(M));return this.o.$startFileSearch((0,v.withUndefinedAsNull)(ae),(0,v.withUndefinedAsNull)(ee),(0,v.withUndefinedAsNull)(z),(0,v.withUndefinedAsNull)(N),$).then(x=>Array.isArray(x)?x.map(J=>C.URI.revive(J)):[])}async findTextInFiles(M,B,N,U,$=a.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const z=this.j.getNext(),ae=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:ee,folder:x}=q(n.GlobPattern.from(B.include)),J=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ie={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:ae,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:ee,excludePattern:J},pe=!1;if(this.u[z]=Q=>{if(pe)return;const Y=C.URI.revive(Q.resource);Q.results.forEach(Z=>{(0,c.resultIsMatch)(Z)?N({uri:Y,preview:{text:Z.preview.text,matches:(0,o.mapArrayOrNot)(Z.preview.matches,me=>new s.Range(me.startLineNumber,me.startColumn,me.endLineNumber,me.endColumn))},ranges:(0,o.mapArrayOrNot)(Z.ranges,me=>new s.Range(me.startLineNumber,me.startColumn,me.endLineNumber,me.endColumn))}):N({uri:Y,text:Z.text,lineNumber:Z.lineNumber})})},$.isCancellationRequested)return{};try{const Q=await this.o.$startTextSearch(M,(0,v.withUndefinedAsNull)(x),ie,z,$);return delete this.u[z],Q||{}}catch(Q){throw delete this.u[z],Q}}$handleTextSearchResult(M,B){this.u[B]?.(M)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,B){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,B);const N=this.t.transformOutgoingScheme(M),U=this.z++;return this.o.$registerEditSessionIdentityProvider(U,N),(0,I.toDisposable)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(M,B){this.h.info("Getting edit session identifier for workspaceFolder",M);const N=await this.resolveWorkspaceFolder(C.URI.revive(M));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const U=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!U),!U)return;const $=await U.provideEditSessionIdentity(N,B);if(this.h.info("Provider returned edit session identifier: ",$),!!$)return $}async $provideEditSessionIdentityMatch(M,B,N,U){this.h.info("Getting edit session identifier for workspaceFolder",M);const $=await this.resolveWorkspaceFolder(C.URI.revive(M));if(!$){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",$);const z=this.w.get($.uri.scheme);if(this.h.info(`Provider for scheme ${$.uri.scheme} is defined: `,!!z),!z)return;const ae=await z.provideEditSessionIdentityMatch?.(B,N,U);if(this.h.info("Provider returned edit session identifier match result: ",ae),!!ae)return ae}getOnWillCreateEditSessionIdentityEvent(M){return(B,N,U)=>{const $=function(ae){B.call(N,ae)};return $.extension=M,this.A.event($,void 0,U)}}async $onWillCreateEditSessionIdentity(M,B,N){const U=await this.resolveWorkspaceFolder(C.URI.revive(M));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:U},B,async($,z)=>{const ae=Date.now();await Promise.resolve($),Date.now()-ae>N&&this.h.warn("SLOW edit session create-participant",z.extension.identifier)}),B.isCancellationRequested}};L=xe([ze(0,p.IExtHostRpcService),ze(1,D.IExtHostInitDataService),ze(2,b.IExtHostFileSystemInfo),ze(3,h.ILogService),ze(4,r.IURITransformerService)],L),e.ExtHostWorkspace=L,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function q(V){let M,B;return V&&(typeof V=="string"?M=V:(M=V.pattern,B=C.URI.revive(V.baseUri))),{includePattern:M,folder:B}}}),define(ye[35],De([1,0,23,3,34,5,7,209,127,9,19,4,20,13,2]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(s,r){if(r){const c=r.split(".");let l=s;for(let m=0;l&&m<c.length;m++)l=l[c[m]];return l}}function h(s){return s instanceof y.URI}function u(s){return s&&s.uri instanceof y.URI&&s.languageId&&typeof s.languageId=="string"}function g(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&s.uri instanceof y.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function D(s){if(h(s))return{resource:s};if(u(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(g(s))return{overrideIdentifier:s.languageId};if(b(s))return{resource:s.uri};if(s===null)return{resource:null}}let p=class{constructor(r,c,l){this.a=r.getProxy(R.MainContext.MainThreadConfiguration),this.c=c,this.b=l,this.d=new O.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new n(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,c){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(r,c))}};p=xe([ze(0,v.IExtHostRpcService),ze(1,a.IExtHostWorkspace),ze(2,C.ILogService)],p),e.ExtHostConfiguration=p;class n{constructor(r,c,l,m){this.a=new A.Emitter,this.b=r,this.f=m,this.c=c,this.e=P.Configuration.parse(l),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,c){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=P.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(c,l))}getConfiguration(r,c,l){const m=D(c)||{},i=this.g(r?f(this.e.getValue(void 0,m,this.c.workspace),r):this.e.getValue(void 0,m,this.c.workspace));r&&this.h(r,m,l?.identifier);function t(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case I.ConfigurationTarget.Global:return 2;case I.ConfigurationTarget.Workspace:return 5;case I.ConfigurationTarget.WorkspaceFolder:return 6}}const d={has(E){return typeof f(i,E)<"u"},get:(E,w)=>{this.h(r?`${r}.${E}`:E,m,l?.identifier);let L=f(i,E);if(typeof L>"u")L=w;else{let q;const V=(M,B)=>{let N;const U=()=>{q=q||(0,o.deepClone)(i),N=N||f(q,B)};return(0,k.isObject)(M)?new Proxy(M,{get:($,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return U(),()=>N;if(q)return N=N||f(q,B),N[z];const ae=$[z];return typeof z=="string"?V(ae,`${B}.${z}`):ae},set:($,z,ae)=>(U(),N&&(N[z]=ae),!0),deleteProperty:($,z)=>(U(),N&&delete N[z],!0),defineProperty:($,z,ae)=>(U(),N&&Object.defineProperty(N,z,ae),!0)}):M};L=V(L,E)}return L},update:(E,w,L,q)=>{E=r?`${r}.${E}`:E;const V=t(L);return w!==void 0?this.b.$updateConfigurationOption(V,E,w,m,q):this.b.$removeConfigurationOption(V,E,m,q)},inspect:E=>{E=r?`${r}.${E}`:E;const w=this.e.inspect(E,m,this.c.workspace);if(w)return{key:E,defaultValue:(0,o.deepClone)(w.policy?.value??w.default?.value),globalValue:(0,o.deepClone)(w.user?.value??w.application?.value),workspaceValue:(0,o.deepClone)(w.workspace?.value),workspaceFolderValue:(0,o.deepClone)(w.workspaceFolder?.value),defaultLanguageValue:(0,o.deepClone)(w.default?.override),globalLanguageValue:(0,o.deepClone)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,o.deepClone)(w.workspace?.override),workspaceFolderLanguageValue:(0,o.deepClone)(w.workspaceFolder?.override),languageIds:(0,o.deepClone)(w.overrideIdentifiers)}}};return typeof i=="object"&&(0,o.mixin)(d,i,!1),Object.freeze(d)}g(r){const c=l=>(0,k.isObject)(l)?new Proxy(l,{get:(m,i)=>c(m[i]),set:(m,i,t)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(i)}' of object`)},deleteProperty:(m,i)=>{throw new Error(`TypeError: Cannot delete read only property '${String(i)}' of object`)},defineProperty:(m,i)=>{throw new Error(`TypeError: Cannot define property '${String(i)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return c(r)}h(r,c,l){const m=S.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),i=l?`[${l.value}] `:"";if(m===4){typeof c?.resource>"u"&&this.f.warn(`${i}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){c?.resource&&this.f.warn(`${i}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,c){const l=new P.ConfigurationChangeEvent(r,c,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,i)=>l.affectsConfiguration(m,D(i))})}k(r){return r.reduce((c,l)=>(c.set(l[0],l[1]),c),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,T.createDecorator)("IExtHostConfiguration")});var _e=this&&this.__classPrivateFieldSet||function(ne,e,o,A,a){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!a:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?a.call(ne,o):a?a.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[82],De([1,0,2,19,3,5,7,34,59,35,21,41,20,25,4,16,10,13,77,247,12]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u,g,b,D){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var n;(function(M){function B(U){if(U!=null)return U}M.from=B;function N(U){if(U!=null)return U}M.to=N})(n||(n={}));var s;(function(M){function B(U){if(U!=null)return U}M.from=B;function N(U){if(U!=null)return U}M.to=N})(s||(s={}));var r;(function(M){function B(U){if(U!=null)return U}M.from=B;function N(U){if(U!=null)return U}M.to=N})(r||(r={}));var c;(function(M){function B($){if($){const z=$;return z&&!!z.process}else return!1}M.is=B;function N($){if($==null)return;const z={process:$.process,args:$.args};return $.options&&(z.options=r.from($.options)),z}M.from=N;function U($){if($!=null)return new I.ProcessExecution($.process,$.args,$.options)}M.to=U})(c||(c={}));var l;(function(M){function B(U){if(U!=null)return U}M.from=B;function N(U){if(U!=null)return U}M.to=N})(l||(l={}));var m;(function(M){function B($){if($){const z=$;return z&&(!!z.commandLine||!!z.command)}else return!1}M.is=B;function N($){if($==null)return;const z={};return $.commandLine!==void 0?z.commandLine=$.commandLine:(z.command=$.command,z.args=$.args),$.options&&(z.options=l.from($.options)),z}M.from=N;function U($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new I.ShellExecution($.commandLine,$.options):new I.ShellExecution($.command,$.args?$.args:[],$.options)}M.to=U})(m||(m={}));var i;(function(M){function B($){if($){const z=$;return z&&z.customExecution==="customExecution"}else return!1}M.is=B;function N($){return{customExecution:"customExecution"}}M.from=N;function U($,z){return z.get($)}M.to=U})(i=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var t;(function(M){function B(N,U){let $;return N.scope!==void 0&&typeof N.scope!="number"?$=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===I.TaskScope.Workspace&&U&&U.workspaceFile?$=U.workspaceFile:$=b.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:$}}M.from=B})(t=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(M){function B(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}M.from=B})(d||(d={}));var E;(function(M){function B($,z){if($==null)return[];const ae=[];for(const ee of $){const x=N(ee,z);x&&ae.push(x)}return ae}M.fromMany=B;function N($,z){if($==null)return;let ae;$.execution instanceof I.ProcessExecution?ae=c.from($.execution):$.execution instanceof I.ShellExecution?ae=m.from($.execution):$.execution&&$.execution instanceof I.CustomExecution&&(ae=i.from($.execution));const ee=n.from($.definition);let x;return $.scope?typeof $.scope=="number"?x=$.scope:x=$.scope.uri:x=I.TaskScope.Workspace,!ee||!x?void 0:{_id:$._id,definition:ee,name:$.name,source:{extensionId:z.identifier.value,label:$.source,scope:x},execution:ae,isBackground:$.isBackground,group:d.from($.group),presentationOptions:s.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}M.from=N;async function U($,z,ae){if($==null)return;let ee;c.is($.execution)?ee=c.to($.execution):m.is($.execution)?ee=m.to($.execution):i.is($.execution)&&(ee=i.to($._id,ae));const x=n.to($.definition);let J;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?J=$.source.scope:J=await z.resolveWorkspaceFolder(o.URI.revive($.source.scope)):J=I.TaskScope.Workspace),!x||!J)return;const ie=new I.Task(x,J,$.name,$.source.label,ee,$.problemMatchers);return $.isBackground!==void 0&&(ie.isBackground=$.isBackground),$.group!==void 0&&(ie.group=I.TaskGroup.from($.group._id),ie.group&&$.group.isDefault&&(ie.group=new I.TaskGroup(ie.group.id,ie.group.label),$.group.isDefault===!0&&(ie.group.isDefault=$.group.isDefault))),$.presentationOptions&&(ie.presentationOptions=s.to($.presentationOptions)),$._id&&(ie._id=$._id),$.detail&&(ie.detail=$.detail),ie}M.to=U})(E=e.TaskDTO||(e.TaskDTO={}));var w;(function(M){function B(U){return U}M.from=B;function N(U){if(!!U)return Object.assign(Object.create(null),U)}M.to=N})(w||(w={}));class L{constructor(B,N,U){this._id=N,this.a=U,p.set(this,void 0),_e(this,p,B,"f")}get task(){return this.a}terminate(){Ue(this,p,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}p=new WeakMap;let q=class{constructor(B,N,U,$,z,ae,ee,x){this.q=new a.Emitter,this.r=new a.Emitter,this.s=new a.Emitter,this.t=new a.Emitter,this.a=B.getProxy(R.MainContext.MainThreadTask),this.b=U,this.c=$,this.d=z,this.e=ae,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ee,this.g=x,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,N,U){if(!U)return new I.Disposable(()=>{});const $=this.w();return this.j.set($,{type:N,provider:U,extension:B}),this.a.$registerTaskProvider($,N),new I.Disposable(()=>{this.j.delete($),this.a.$unregisterTaskProvider($)})}registerTaskSystem(B,N){this.a.$registerTaskSystem(B,N)}fetchTasks(B){return this.a.$fetchTasks(w.from(B)).then(async N=>{const U=[];for(const $ of N){const z=await E.to($,this.b,this.m);z&&U.push(z)}return U})}get taskExecutions(){const B=[];return this.k.forEach(N=>B.push(N)),B}terminateTask(B){if(!(B instanceof L))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,N,U){const $=this.m.get(B.id);$&&(this.o.set(B.id,$),this.e.attachPtyToTerminal(N,await $.callback(U))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const N=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.A(B),this.r.fire({execution:N})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const N=await this.y(B.id);this.s.fire({execution:N,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const N=await this.y(B.id);this.t.fire({execution:N,exitCode:B.exitCode})}$provideTasks(B,N){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));const $=[],z=(0,A.asPromise)(()=>U.provider.provideTasks(O.CancellationToken.None)).then(ae=>this.u(N,$,U,ae));return new Promise(ae=>{z.then(ee=>{Promise.all($).then(()=>{ae(ee)})})})}async $resolveTask(B,N){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));if(N.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${U.type}].`);const $=await E.to(N,this.b,this.m);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const z=await U.provider.resolveTask($,O.CancellationToken.None);if(!z)return;this.z(z,U);const ae=E.from(z,U.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return i.is(ae.execution)&&await this.x(ae,z,!0),await this.v(ae)}w(){return this.h++}async x(B,N,U){const $=await this.a.$createTaskId(B);!U&&!this.m.has($)&&(this.n.add($),this.o.set($,N.execution)),this.m.set($,N.execution)}async y(B,N){if(typeof B=="string"){const z=this.l.get(B);if(!z)throw new D.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return z}const U=this.l.get(B.id);if(U)return U;const $=new Promise((z,ae)=>{function ee(x,J,ie){ie?z(new L(x,J.id,ie)):ae("Unexpected: Task does not exist.")}N?ee(this,B,N):E.to(B.task,this.b,this.m).then(x=>ee(this,B,x))});return this.l.set(B.id,$),$.then(z=>(this.k.set(B.id,z),z),z=>Promise.reject(z))}z(B,N){B._deprecated&&this.g.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}A(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const U=this.n.values();let $=U.next();for(;!$.done;)!this.o.has($.value)&&this.p!==$.value&&(this.m.delete($.value),this.n.delete($.value)),$=U.next()}};q=xe([ze(0,v.IExtHostRpcService),ze(1,C.IExtHostInitDataService),ze(2,P.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,k.IExtHostConfiguration),ze(5,T.IExtHostTerminalService),ze(6,u.ILogService),ze(7,g.IExtHostApiDeprecationService)],q),e.ExtHostTaskBase=q;let V=class extends q{constructor(B,N,U,$,z,ae,ee,x){super(B,N,U,$,z,ae,ee,x),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:h.PlatformToString(0)})}async executeTask(B,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const U=E.from(N,B);if(U===void 0)throw new Error("Task is not valid");if(i.is(U.execution))await this.x(U,N,!1);else throw new D.NotSupportedError;const $=await this.y(await this.a.$getTaskExecution(U),N);return this.a.$executeTask(U).catch(z=>{throw new Error(z)}),$}u(B,N,U,$){const z=[];if($)for(const ae of $){this.z(ae,U),(!ae.definition||!B[ae.definition.type])&&this.f.warn(`The task [${ae.source}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`);const ee=E.from(ae,U.extension);ee&&i.is(ee.execution)?(z.push(ee),N.push(this.x(ee,ae,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:z,extension:U.extension}}async v(B){if(i.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,N,U){}};V=xe([ze(0,v.IExtHostRpcService),ze(1,C.IExtHostInitDataService),ze(2,P.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,k.IExtHostConfiguration),ze(5,T.IExtHostTerminalService),ze(6,u.ILogService),ze(7,g.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,y.createDecorator)("IExtHostTask")}),define(ye[294],De([1,0,11,21,45,38,24,43,31]),function(ne,e,o,A,a,R,I,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(v,C,y){this.k=v,this.l=C,this.o=y,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&R.parse(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&R.parse(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const C=this.k.folderQueries||[];return new Promise((y,f)=>{const h=u=>{this.f++,v(u)};if(this.g)return y({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(u=>{const g=u.toString(),b=o.basename(g);this.j&&this.j(g,b)||this.v(h,{base:u,basename:b})}),Promise.all(C.map(u=>this.p(u,h))).then(u=>{y({limitHit:this.e,stats:u[0]||void 0})},u=>{f(new Error((0,a.toErrorMessage)(u)))})})}async p(v,C){const y=new A.CancellationTokenSource,f=this.q(v),h=this.r(),u=new S.QueryGlobTester(this.k,v),g=!u.hasSiblingExcludeClauses();let b;try{this.h.add(y),b=P.StopWatch.create();const D=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,y.token),p=b.elapsed(),n=P.StopWatch.create();return this.g&&!this.e||(D&&D.forEach(s=>{const r=o.posix.relative(v.folder.path,s.path);if(g){const c=o.basename(s.path);this.v(C,{base:v.folder,relativePath:r,basename:c});return}this.s(h,v.folder,r,C)}),this.g&&!this.e)?null:(this.u(h,u,C),{providerTime:p,postProcessTime:n.elapsed()})}finally{y.dispose(),this.h.delete(y)}}q(v){const C=(0,S.resolvePatternsForProvider)(this.k.includePattern,v.includePattern),y=(0,S.resolvePatternsForProvider)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:y,includes:C,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},C,y,f){if(y===this.a){const u=o.basename(this.a);this.v(f,{base:C,relativePath:this.a,basename:u})}function h(u){const g=o.basename(u),b=o.dirname(u);let D=v[b];D||(D=v[b]=[],h(b)),D.push({base:C,relativePath:u,basename:g})}h(y)}u({rootEntries:v,pathToEntries:C},y,f){const h=this,u=this.a;function g(b){const D=(0,S.hasSiblingFn)(()=>b.map(p=>p.basename));for(let p=0,n=b.length;p<n;p++){const s=b[p],{relativePath:r,basename:c}=s;if(y.matchesExcludesSync(r,c,u!==c?D:void 0))continue;const l=C[r];if(l)g(l);else{if(r===u)continue;h.v(f,s)}if(h.e)break}}g(v)}v(v,C){(!this.b||C.relativePath&&this.b(C.relativePath,C.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(C))}}class O{constructor(){this.b=new Map}fileSearch(v,C,y,f){const h=this.c(v.cacheKey),u=new k(v,C,h&&h.token);let g=0;const b=D=>{g+=D.length,y(D.map(p=>this.d(p)))};return this.e(u,O.a,b,f).then(D=>({limitHit:D.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:D.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(!!v)return this.b.has(v)||this.b.set(v,new A.CancellationTokenSource),this.b.get(v)}d(v){return v.relativePath?{resource:I.joinPath(v.base,v.relativePath)}:{resource:v.base}}e(v,C,y,f){f.onCancellationRequested(()=>{v.cancel()});const h=g=>{g&&(u.push(g),C>0&&u.length>=C&&(y(u),u=[]))};let u=[];return v.search(h).then(g=>(u.length&&y(u),g),g=>(u.length&&y(u),Promise.reject(g)))}}O.a=512,e.FileSearchManager=O}),define(ye[295],De([1,0,15,61,38,113,28,16,11,24,8,9,2,166,196,53,13,47,133,293,31]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u,g,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(E,w,L,q,V){this.a=E,this.b=w,this.c=L,this.d=q,this.e=V}text(E,w,L={}){E=this.f(E,L);const q=this.a.getValue(),V=w&&w.some(B=>!this.a.getValue({resource:B}).search.useRipgrep);return{...this.h(w?.map(u.toWorkspaceFolder),L),type:2,contentPattern:E,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:q.search.usePCRE2||V||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(E,w){const L=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const q={...E,wordSeparators:L.editor.wordSeparators};return this.j(E,w)&&(q.isCaseSensitive=!0),this.k(E)&&(q.isMultiline=!0),q}file(E,w={}){return{...this.h(E,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(E,w){return E?(E=Array.isArray(E)?E.map(l):l(E),w?this.parseSearchPaths(E):{pattern:s(...Array.isArray(E)?E:[E])}):{}}h(E=[],w={}){const L=this.g(w.includePattern,w.expandPatterns),q=this.g(w.excludePattern,w.expandPatterns),V=E.length>1,M=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(U=>this.q(U,w,q)):E.map(U=>this.r(U,w,q,V))).filter(U=>!!U),B={_reason:w._reason,folderQueries:M,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:q.pattern,includePattern:L.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const U=o.coalesce(o.flatten(this.c.groups.map(ae=>ae.editors.map(ee=>ee.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const $=U.filter(ae=>(0,D.pathIncludedInQuery)(B,ae.fsPath)),z=this.i($);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...B,...z}}const N=w.extraFileResources&&w.extraFileResources.filter(U=>(0,D.pathIncludedInQuery)(B,U.fsPath));return B.extraFileResources=N&&N.length?N:void 0,B}i(E){const w=[],L=new I.ResourceMap,q={};let V=!1;return E.forEach(M=>{if(M.scheme===P.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(M)){const N=this.b.getWorkspaceFolder(M)?.uri??M.with({path:S.dirname(M.fsPath)});let U=L.get(N);U||(V=!0,U={folder:N,includePattern:{}},w.push(U),L.set(N,U));const $=S.relative(N.fsPath,M.fsPath);(0,T.assertIsDefined)(U.includePattern)[$.replace(/\\/g,"/")]=!0}else M.fsPath&&(V=!0,q[M.fsPath]=!0)}),{folderQueries:w,includePattern:q,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(E,w){if(w.isSmartCase){if(E.isRegExp){if(O.containsUppercaseCharacter(E.pattern,!0))return!0}else if(O.containsUppercaseCharacter(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,C.isMultilineRegexSource)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const w=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),q=(Array.isArray(E)?E:r(E)).map(z=>{const ae=this.e.resolvedUserHome;return ae?(0,R.untildify)(z,ae.scheme===P.Schemas.file?ae.fsPath:ae.path):z}),V=A.groupBy(q,z=>w(z)?"searchPaths":"exprSegments"),M=(V.exprSegments||[]).map(z=>O.rtrim(z,"/")).map(z=>O.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),c(z))),B={},N=this.m(V.searchPaths||[]);N&&N.length&&(B.searchPaths=N);const U=o.flatten(M),$=s(...U);return $&&(B.pattern=$),B}l(E,w){return w.disregardExcludeSettings?void 0:(0,D.getExcludes)(E,!w.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const w=E.flatMap(q=>{let{pathPortion:V,globPortion:M}=n(q);return M&&(M=m(M)),this.n(V).flatMap(N=>this.o(N,M))}),L=new Map;return w.forEach(q=>{const V=q.searchPath.toString(),M=L.get(V);M?q.pattern&&(M.pattern=M.pattern||{},M.pattern[q.pattern]=!0):L.set(V,{searchPath:q.searchPath,pattern:q.pattern?s(q.pattern):void 0})}),Array.from(L.values())}n(E){if(S.isAbsolute(E)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==P.Schemas.file?[{searchPath:w[0].uri.with({path:E})}]:[{searchPath:v.URI.file(S.normalize(E))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(E=l(E),E.startsWith("../")||E===".."){const q=S.posix.resolve(w.path,E);return[{searchPath:w.with({path:q})}]}const L=m(E);return[{searchPath:w,pattern:L}]}else{if(E==="./"||E===".\\")return[];{const w=E.replace(/^\.[\/\\]/,""),q=this.b.getWorkspace().folders.map(V=>{const M=w.match(new RegExp(`^${O.escapeRegExpCharacters(V.name)}(?:/(.*)|$)`));return M?{match:M,folder:V}:null}).filter(T.isDefined);if(q.length)return q.map(V=>{const M=V.match[1];return{searchPath:V.folder.uri,pattern:M&&m(M)}});{const V=E.match(/\.[\/\\](.+)[\/\\]?/),M=V?V[1]:E,B=y.localize(0,null,M);throw new Error(B)}}}}o(E,w){const L=E.pattern&&w?`${E.pattern}/${w}`:E.pattern||w,q=[{searchPath:E.searchPath,pattern:L}];return L&&!L.endsWith("**")&&q.push({searchPath:E.searchPath,pattern:L+"/**"}),q}q(E,w,L){const q=this.r((0,u.toWorkspaceFolder)(E.searchPath),w,L,!1);return q?{...q,includePattern:E.pattern}:null}r(E,w,L,q){let V;const M=v.URI.isUri(E)?E:E.uri;if(L.searchPaths){const z=L.searchPaths.filter(ae=>(0,k.isEqual)(ae.searchPath,M))[0];if(z&&!z.pattern)return null;z&&(V=z.pattern)}const B=this.a.getValue({resource:M}),U={...this.l(B,w)||{},...V||{}},$=v.URI.isUri(E)?(0,k.basename)(E):E.name;return{folder:M,folderName:q?$:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!B.search.followSymlinks}}};p=xe([ze(0,f.IConfigurationService),ze(1,u.IWorkspaceContextService),ze(2,g.IEditorGroupsService),ze(3,h.ILogService),ze(4,b.IPathService)],p),e.QueryBuilder=p;function n(d){const E=d.match(/[\*\{\}\(\)\[\]\?]/);if(E){const w=E.index,L=d.substr(0,w).match(/[/|\\][^/\\]*$/);if(L){let q=d.substr(0,L.index);return q.match(/[/\\]/)||(q+="/"),{pathPortion:q,globPortion:d.substr((L.index||0)+1)}}}return{pathPortion:d}}function s(...d){return d.length?d.reduce((E,w)=>(E[w]=!0,E),Object.create(null)):void 0}function r(d){return a.splitGlobAware(d,",").map(E=>E.trim()).filter(E=>!!E.length)}function c(d){return[`**/${d}/**`,`**/${d}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function l(d){return d.replace(/\\/g,"/")}function m(d){return l(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function i(d){return d.replace(/([?*[\]])/g,"[$1]")}function t(d,E){d=o.distinct(d,q=>q.toString());const w=[],L=E.getWorkspace();return d&&d.forEach(q=>{let V;if(E.getWorkbenchState()===2)V=(0,k.relativePath)(L.folders[0].uri,q),V&&V!=="."&&(V="./"+V);else{const M=E.getWorkspaceFolder(q);if(M){const B=M.name;if(L.folders.filter(U=>U.name===B).length===1){const U=(0,k.relativePath)(M.uri,q);U===""?V=`./${M.name}`:V=`./${M.name}/${U}`}else V=q.fsPath}}V&&w.push(i(V))}),w}e.resolveResourcesForSearchIncludes=t}),define(ye[296],De([1,0,24,2,21,12,4,295,31,47]),function(ne,e,o,A,a,R,I,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function T(f,h){const u=h.activationEvents;if(!u)return Promise.resolve(void 0);const g=[],b=[];for(const c of u)if(/^workspaceContains:/.test(c)){const l=c.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||f.forceUsingSearch?b.push(l):g.push(l)}if(g.length===0&&b.length===0)return Promise.resolve(void 0);let D;const p=new Promise((c,l)=>{D=c}),n=c=>D({activationEvent:c}),s=Promise.all(g.map(c=>v(f,c,n))).then(()=>{}),r=C(f,h.identifier,b,n);return Promise.all([s,r]).then(()=>{D(void 0)}),p}e.checkActivateWorkspaceContainsExtension=T;async function v(f,h,u){for(const g of f.folders)if(await f.exists(o.joinPath(A.URI.revive(g),h))){u(`workspaceContains:${h}`);return}}async function C(f,h,u,g){if(u.length===0)return Promise.resolve(void 0);const b=new a.CancellationTokenSource,D=f.checkExists(f.folders,u,b.token),p=setTimeout(async()=>{b.cancel(),f.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},O);let n=!1;try{n=await D}catch(s){R.isCancellationError(s)||R.onUnexpectedError(s)}b.dispose(),clearTimeout(p),n&&g(`workspaceContains:${u.join(",")}`)}function y(f,h,u,g){const b=f.get(I.IInstantiationService),D=f.get(S.ISearchService),n=b.createInstance(P.QueryBuilder).file(h.map(s=>(0,k.toWorkspaceFolder)(A.URI.revive(s))),{_reason:"checkExists",includePattern:u,exists:!0});return D.fileSearch(n,g).then(s=>!!s.limitHit,s=>R.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=y});var _e=this&&this.__classPrivateFieldSet||function(ne,e,o,A,a){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!a)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!a:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?a.call(ne,o):a?a.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,A){if(o==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?A:o==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[42],De([1,0,178,11,83,24,19,6,68,2,13,5,35,238,99,34,26,134,12,27,22,220,7,128,4,25,79,20,91,55,41,3,296,98,222,16,97,43,10]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u,g,b,D,p,n,s,r,c,l,m,i,t,d,E,w,L,q,V,M,B,N){"use strict";var U,$,z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let ae=class Ui extends P.Disposable{constructor(Q,Y,Z,me,ve,Ie,Re,oe,le,ue,te){super(),this.a=this.B(new E.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=Y,this.g=Z,this.f=Re,this.j=me,this.k=ve,this.l=Ie,this.m=le,this.p=ue,this.s=te,this.t=this.g.getProxy(T.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(T.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(T.MainContext.MainThreadExtensionService),this.w=new I.Barrier,this.y=new I.Barrier,this.z=new I.Barrier,this.C=new I.Barrier,this.F=new u.ExtensionDescriptionRegistry(this.f.allExtensions);const ce=(0,h.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new u.ExtensionDescriptionRegistry(J(this.F,ce)),this.G=new y.ExtHostStorage(this.g,this.l),this.H=new L.ExtHostSecretState(this.g),this.I=oe,this.h=Q.createChild(new i.ServiceCollection([y.IExtHostStorage,this.G],[L.IExtHostSecretState,this.H])),this.J=this.B(new C.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(se,F,H)=>{this.v.$onExtensionActivationError(se,g.transformErrorForSerialization(F),H)},actualActivateExtension:async(se,F)=>{if(u.ExtensionDescriptionRegistry.isHostExtension(se,this.D,this.F))return await this.v.$activateExtension(se,F),new C.HostExtension;const H=this.D.getExtensionDescription(se);return this.Y(H,F)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.ob(),this.w.open(),await this.j.waitForInitializeCall(),a.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.lb()}catch(Q){g.onUnexpectedError(Q)}}async Q(){this.I.onWillDeactivateAll();let Q=[];try{Q=this.D.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this.X(ve))}catch{}await Promise.all(Q)}terminate(Q,Y=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${Q}`),this.l.flush(),this.p.dispose(),this.J.dispose(),g.setUnexpectedErrorHandler(me=>{this.l.error(me)}),this.g.dispose();const Z=this.Q();Promise.race([(0,I.timeout)(5e3),Z]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${Y}`):this.l.info(`Extension host exiting with code ${Y}`),this.l.flush(),this.l.dispose(),this.c.exit(Y)})}isActivated(Q){return this.z.isOpen()?this.J.isActivated(Q):!1}async getExtension(Q){const Y=await this.v.$getExtension(Q);let Z;if(Y?.browserNlsBundleUris){Z={};for(const me of Object.keys(Y.browserNlsBundleUris))Z[me]=k.URI.revive(Y.browserNlsBundleUris[me])}return Y&&{...Y,identifier:new b.ExtensionIdentifier(Y.identifier.value),extensionLocation:k.URI.revive(Y.extensionLocation),browserNlsBundleUris:Z}}R(Q,Y){return this.J.activateByEvent(Q,Y)}S(Q,Y){return this.J.activateById(Q,Y)}activateByIdWithErrors(Q,Y){return this.S(Q,Y).then(()=>{const Z=this.J.getActivatedExtension(Q);if(Z.activationFailed)return Promise.reject(Z.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(Q=>this.D)}getExtensionExports(Q){return this.z.isOpen()?this.J.getActivatedExtension(Q).exports:null}async U(Q){if(Q.scheme!==V.Schemas.file)return Q;const Y=await this.c.realpath(Q.fsPath);return k.URI.file(Y)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(Q=>new ie(Q))),this.L}async W(Q){const Y=S.TernarySearchTree.forUris(Z=>R.extUriBiasedIgnorePathCase.ignorePathCasing(Z));return await Promise.all(Q.map(async Z=>{if(this.pb(Z)){const me=await this.U(Z.extensionLocation);Y.set(me,Z)}})),Y}X(Q){let Y=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(Q))return Y;const Z=this.J.getActivatedExtension(Q);if(!Z)return Y;try{typeof Z.module.deactivate=="function"&&(Y=Promise.resolve(Z.module.deactivate()).then(void 0,me=>(this.l.error(me),Promise.resolve(void 0))))}catch(me){this.l.error(`An error occurred when deactivating the extension '${Q.value}':`),this.l.error(me)}try{(0,P.dispose)(Z.subscriptions)}catch(me){this.l.error(`An error occurred when deactivating the subscriptions for extension '${Q.value}':`),this.l.error(me)}return Y}async Y(Q,Y){return this.f.remote.isRemote?this.v.$onWillActivateExtension(Q.identifier):await this.v.$onWillActivateExtension(Q.identifier),this.ab(Q,Y).then(Z=>{const me=Z.activationTimes;return this.v.$onDidActivateExtension(Q.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,Y),this.Z(Q,Y,"success",me),Z},Z=>{throw this.Z(Q,Y,"failure"),Z})}Z(Q,Y,Z,me){const ve=ee(Q,Y);this.u.$publicLog2("extensionActivationTimes",{...ve,...me||{},outcome:Z})}ab(Q,Y){const Z=ee(Q,Y);this.u.$publicLog2("activatePlugin",Z);const me=this.pb(Q);if(!me)return Promise.resolve(new C.EmptyExtension(C.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${Y.startup}, activationEvent: '${Y.activationEvent}'${Q.identifier.value!==Y.extensionId.value?`, root cause: ${Y.extensionId.value}`:""}`),this.l.flush();const ve=new C.ExtensionActivationTimesBuilder(Y.startup);return Promise.all([this.qb(Q,(0,R.joinPath)(Q.extensionLocation,me),ve),this.bb(Q)]).then(Ie=>(a.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),Ui.cb(this.l,Q.identifier,Ie[0],Ie[1],ve))).then(Ie=>(a.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),Ie))}bb(Q){const Y=new p.ExtensionGlobalMemento(Q,this.G),Z=new p.ExtensionMemento(Q.identifier.value,!1,this.G),me=new q.ExtensionSecrets(Q,this.H),ve=Q.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,Ie=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([Y.whenReady,Z.whenReady,this.I.whenReady]).then(()=>{const Re=this;let oe,le;const ue=(0,h.isProposedApiEnabled)(Q,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(Q.identifier)):void 0;return Object.freeze({globalState:Y,workspaceState:Z,secrets:me,subscriptions:[],get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(te){return A.join(Q.extensionLocation.fsPath,te)},get storagePath(){return Re.I.workspaceValue(Q)?.fsPath},get globalStoragePath(){return Re.I.globalValue(Q).fsPath},get logPath(){return A.join(Re.f.logsLocation.fsPath,Q.identifier.value)},get logUri(){return k.URI.joinPath(Re.f.logsLocation,Q.identifier.value)},get storageUri(){return Re.I.workspaceValue(Q)},get globalStorageUri(){return Re.I.globalValue(Q)},get extensionMode(){return ve},get extension(){return oe===void 0&&(oe=new x(Re,Q.identifier,Q,Ie,!1)),oe},get extensionRuntime(){return(0,h.checkProposedApiEnabled)(Q,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re.p.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!le){if(!ue)return;const te=E.Event.buffer(E.Event.fromDOMEventEmitter(ue,"message",ce=>ce.data));ue.start(),le={onDidReceiveMessage:te,postMessage:ue.postMessage.bind(ue)}}return le}})})}static cb(Q,Y,Z,me,ve){return Z=Z||{activate:void 0,deactivate:void 0},this.db(Q,Y,Z,me,ve).then(Ie=>new C.ActivatedExtension(!1,null,ve.build(),Z,Ie,me.subscriptions))}static db(Q,Y,Z,me,ve){if(typeof Z.activate=="function")try{ve.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const Ie=typeof global=="object"?global:self,Re=Z.activate.apply(Ie,[me]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Re).then(oe=>(ve.activateResolveStop(),oe))}catch(Ie){return Promise.reject(Ie)}else return Promise.resolve(Z)}eb(Q,Y){this.S(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:Y}).then(void 0,Z=>{this.l.error(Z)})}fb(Q,Y=0){const me=Date.now();(0,N.setTimeout0)(()=>{for(let ve=Y;ve<Q.length;ve+=1){const Ie=Q[ve];for(const Re of Ie.activationEvents??[])if(Re==="onStartupFinished")if(Date.now()-me>50){this.fb(Q,ve);break}else this.eb(Ie,Re)}})}gb(){this.v.$setPerformanceMarks(a.getMarks()),this.k.getConfigProvider().then(Q=>{const Y=Q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Z=this.D.getAllExtensionDescriptions();if(Y)this.fb(Z);else for(const me of Z)if(me.activationEvents)for(const ve of me.activationEvents)ve==="onStartupFinished"&&this.eb(me,ve)})}hb(){const Q=this.R("*",!0).then(void 0,ve=>{this.l.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.ib(ve.added)));const Y=this.j.workspace?this.j.workspace.folders:[],Z=this.ib(Y),me=Promise.all([Q,Z]).then(()=>{});return Promise.race([me,(0,I.timeout)(1e4)]).then(()=>{this.gb()}),me}ib(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(Y=>this.jb(Q,Y))).then(()=>{})}async jb(Q,Y){if(this.isActivated(Y.identifier))return;const Z=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.l,folders:Q.map(Ie=>Ie.uri),forceUsingSearch:Z,exists:Ie=>this.c.exists(Ie.fsPath),checkExists:(Ie,Re,oe)=>this.t.$checkExists(Ie,Re,oe)},ve=await(0,w.checkActivateWorkspaceContainsExtension)(me,Y);if(!!ve)return this.S(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:ve.activationEvent}).then(void 0,Ie=>this.l.error(Ie))}async $extensionTestsExecute(){await this.C.wait();try{return await this.kb()}catch(Q){throw console.error(Q),Q}}async kb(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:Y}=this.f.environment;if(!Q||!Y)throw new Error(o.localize(0,null));const Z=await this.qb(null,Y,new C.ExtensionActivationTimesBuilder(!1));if(!Z||typeof Z.run!="function")throw new Error(o.localize(1,null,Y.toString()));return new Promise((me,ve)=>{const Ie=(le,ue)=>{le?ve(le):me(typeof ue=="number"&&ue>0?1:0)},Re=(0,R.originalFSPath)(Y),oe=Z.run(Re,Ie);oe&&oe.then&&oe.then(()=>{me(0)}).catch(le=>{ve(le instanceof Error&&le.stack?le.stack:String(le))})})}lb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.hb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,Y){return this.M[Q]=Y,(0,P.toDisposable)(()=>{delete this.M[Q]})}async mb(Q){const Y=Q.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const Z=Q.substr(0,Y);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${Z}`,!1),{authorityPrefix:Z,resolver:this.M[Z]}}async $resolveAuthority(Q,Y){const Z=B.StopWatch.create(!1),me=()=>`[resolveAuthority(${(0,s.getRemoteAuthorityPrefix)(Q)},${Y})][${Z.elapsed()}ms] `,ve=ue=>this.l.info(`${me()}${ue}`),Ie=(ue,te=void 0)=>this.l.error(`${me()}${ue}`,te);ve("activating resolver...");const{authorityPrefix:Re,resolver:oe}=await this.mb(Q);if(!oe)return Ie("no resolver"),{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Re}.`,detail:void 0}};const le=new I.IntervalTimer;try{ve("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(oe)),le.cancelAndSet(()=>ve("waiting..."),1e3),ve("invoking resolve()..."),a.mark(`code/extHost/willResolveAuthority/${Re}`);const ue=await oe.resolve(Q,{resolveAttempt:Y});a.mark(`code/extHost/didResolveAuthorityOK/${Re}`),le.dispose(),ve(`returned ${ue.host}:${ue.port}`);const te={authority:Q,host:ue.host,port:ue.port,connectionToken:ue.connectionToken},ce={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted,authenticationSession:ue.authenticationSessionForInitializingExtensions?{id:ue.authenticationSessionForInitializingExtensions.id,providerId:ue.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:te,options:ce,tunnelInformation:{environmentTunnels:ue.environmentTunnels,features:ue.tunnelFeatures}}}}catch(ue){if(a.mark(`code/extHost/didResolveAuthorityError/${Re}`),le.dispose(),Ie("returned an error",ue),ue instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:ue._code,message:ue._message,detail:ue._detail}};throw ue}}async $getCanonicalURI(Q,Y){this.l.info(`$getCanonicalURI invoked for authority (${(0,s.getRemoteAuthorityPrefix)(Q)})`);const{resolver:Z}=await this.mb(Q);if(!Z)return null;const me=k.URI.revive(Y);if(typeof Z.getCanonicalURI>"u")return me;const ve=await(0,I.asPromise)(()=>Z.getCanonicalURI(me));return ve||me}static nb(Q,Y,Z){const me=new u.ExtensionDescriptionRegistry(Q.getAllExtensionDescriptions());me.deltaExtensions(Z.toAdd,Z.toRemove);const ve=(0,h.extensionIdentifiersArrayToSet)(Y.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of Z.myToRemove)ve.delete(b.ExtensionIdentifier.toKey(Re));for(const Re of Z.myToAdd)ve.add(b.ExtensionIdentifier.toKey(Re));const Ie=J(me,ve);return{globalRegistry:me,myExtensions:Ie}}$startExtensionHost(Q){Q.toAdd.forEach(me=>me.extensionLocation=k.URI.revive(me.extensionLocation));const{globalRegistry:Y,myExtensions:Z}=Ui.nb(this.F,this.D,Q);return this.F.set(Y.getAllExtensionDescriptions()),this.D.set(Z),this.lb()}$activateByEvent(Q,Y){return Y===1?this.R(Q,!1):this.z.wait().then(Z=>this.R(Q,!1))}async $activate(Q,Y){return await this.z.wait(),this.D.getExtensionDescription(Q)?(await this.S(Q,Y),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(Ie=>Ie.extensionLocation=k.URI.revive(Ie.extensionLocation));const{globalRegistry:Y,myExtensions:Z}=Ui.nb(this.F,this.D,Q),me=await this.W(Z);return(await this.getExtensionPathIndex()).setSearchTree(me),this.F.set(Y.getAllExtensionDescriptions()),this.D.set(Z),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){const Y=D.VSBuffer.alloc(Q),Z=Math.random()%256;for(let me=0;me<Q;me++)Y.writeUInt8(Z,me);return Y}async $updateRemoteConnectionData(Q){this.P=Q,this.a.fire()}};ae=xe([ze(0,r.IInstantiationService),ze(1,e.IHostUtils),ze(2,m.IExtHostRpcService),ze(3,f.IExtHostWorkspace),ze(4,v.IExtHostConfiguration),ze(5,O.ILogService),ze(6,c.IExtHostInitDataService),ze(7,l.IExtensionStoragePaths),ze(8,t.IExtHostTunnelService),ze(9,d.IExtHostTerminalService),ze(10,M.IExtHostLocalizationService)],ae),e.AbstractExtHostExtensionService=ae;function ee(pe,Q){return{id:pe.identifier.value,name:pe.name,extensionVersion:pe.version,publisherDisplayName:pe.publisher,activationEvents:pe.activationEvents?pe.activationEvents.join(","):null,isBuiltin:pe.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class x{constructor(Q,Y,Z,me,ve){U.set(this,void 0),$.set(this,void 0),z.set(this,void 0),_e(this,U,Q,"f"),_e(this,$,Y,"f"),_e(this,z,Z.identifier,"f"),this.id=Z.identifier.value,this.extensionUri=Z.extensionLocation,this.extensionPath=A.normalize((0,R.originalFSPath)(Z.extensionLocation)),this.packageJSON=Z,this.extensionKind=me,this.isFromDifferentExtensionHost=ve}get isActive(){return Ue(this,U,"f").isActivated(Ue(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,U,"f").getExtensionExports(Ue(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,U,"f").activateByIdWithErrors(Ue(this,z,"f"),{startup:!1,extensionId:Ue(this,$,"f"),activationEvent:"api"}),this.exports}}e.Extension=x,U=new WeakMap,$=new WeakMap,z=new WeakMap;function J(pe,Q){return pe.getAllExtensionDescriptions().filter(Y=>Q.has(b.ExtensionIdentifier.toKey(Y.identifier)))}class ie{constructor(Q){this.a=Q}setSearchTree(Q){this.a=Q}findSubstr(Q){return this.a.findSubstr(Q)}forEach(Q){return this.a.forEach(Q)}}e.ExtensionPaths=ie}),define(ye[297],De([1,0,83,2,5,35,26,27,20,25,4,42,36,13,8]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(p,n,s,r,c,l,m){this.c=p,this.d=n,this.e=s,this.f=r,this.g=c,this.h=l,this.i=m,this.a=new Map,this.b=[]}async install(){this.j(),o.mark("code/extHost/willWaitForConfig");const p=await this.f.getConfigProvider();o.mark("code/extHost/didWaitForConfig");const n=await this.g.getExtensionPathIndex();this.register(new u(this.c,n,this.d,p,this.i)),this.register(this.e.createInstance(g,n)),this.register(this.e.createInstance(h)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,n,this.h.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const n of p.nodeModuleName)this.a.set(n,p);else this.a.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this.b.push(n=>p.alternativeModuleName(n))}};f=xe([ze(2,O.IInstantiationService),ze(3,R.IExtHostConfiguration),ze(4,T.IExtHostExtensionService),ze(5,k.IExtHostInitDataService),ze(6,C.ILogService)],f),e.RequireInterceptor=f;let h=class rn{constructor(p){if(p.environment.appRoot&&rn.a.size){const n=(0,y.escapeRegExpCharacters)(this.c(p.environment.appRoot.fsPath)),s="[a-z0-9_.-]",r=`@${s}+\\/${s}+|${s}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${n}/${c}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(p){if(!this.b)return;const n=this.b.exec(this.c(p));if(!n)return;const[,s,r,c]=n,l=rn.a.get(r);if(l!==void 0)return console.warn(`${r} as been renamed to ${l}, please update your imports`),s+l+c}c(p){return p.replace(/\\/g,"/")}};h.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),h=xe([ze(0,k.IExtHostInitDataService)],h);class u{constructor(p,n,s,r,c){this.c=p,this.d=n,this.e=s,this.f=r,this.g=c,this.nodeModuleName="vscode",this.a=new Map}load(p,n){const s=this.d.findSubstr(n);if(s){let r=this.a.get(P.ExtensionIdentifier.toKey(s.identifier));return r||(r=this.c(s,this.e,this.f),this.a.set(P.ExtensionIdentifier.toKey(s.identifier),r)),r}if(!this.b){let r="";this.d.forEach((c,l)=>r+=`	${l} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${r}`),this.b=this.c(I.nullExtensionDescription,this.e,this.f)}return this.b}}let g=class{constructor(p,n,s){this.d=p,this.nodeModuleName="keytar",this.a=n.getProxy(a.MainContext.MainThreadTelemetry);const{environment:r}=s,c=n.getProxy(a.MainContext.MainThreadKeytar);if(r.appRoot){let l=r.appRoot.fsPath;v.platform==="win32"&&(l=l.replace(/\\/g,"/")),l[l.length-1]==="/"&&(l=l.substr(0,l.length-1)),this.b=new Set,this.b.add(`${l}/node_modules.asar/keytar`),this.b.add(`${l}/node_modules/keytar`)}this.c={getPassword:(l,m)=>c.$getPassword(l,m),setPassword:(l,m,i)=>c.$setPassword(l,m,i),deletePassword:(l,m)=>c.$deletePassword(l,m),findPassword:l=>c.$findPassword(l),findCredentials(l){return c.$findCredentials(l)}}}load(p,n){const s=this.d.findSubstr(n);return this.a.$publicLog2("shimming.keytar",{extension:s?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(p){const n=p.length;if(n<=7||!this.b)return;const s=n-7;if((p.charAt(s)==="/"||p.charAt(s)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.b.has(p)))return"keytar"}};g=xe([ze(1,S.IExtHostRpcService),ze(2,k.IExtHostInitDataService)],g);let b=class{constructor(p,n,s){this.e=p,this.f=n,this.nodeModuleName=["open","opn"],this.d=s.getProxy(a.MainContext.MainThreadTelemetry);const r=s.getProxy(a.MainContext.MainThreadWindow);this.c=(c,l)=>{const m=A.URI.parse(c);return l?this.g(c,l):m.scheme==="http"||m.scheme==="https"?r.$openUri(m,c,{allowTunneling:!0}):m.scheme==="mailto"||m.scheme===this.f?r.$openUri(m,c,{}):this.g(c,l)}}load(p,n,s){const r=this.e.findSubstr(n);return r&&(this.a=r.identifier.value,this.h()),this.b=s(p),this.c}g(p,n){return this.i(),this.b(p,n)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=xe([ze(2,S.IExtHostRpcService)],b)}),define(ye[49],De([1,0,65,6,11,36,4,59,60,42,7,34,234,35]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,I.createDecorator)("IExtHostVariableResolverProvider");class y extends v.AbstractVariableResolverService{constructor(u,g,b,D,p,n,s){function r(){if(b){const c=b.activeEditor();if(c)return c.document.uri;const l=D.tabGroups.all.find(m=>m.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof O.TextDiffTabInput||l.input instanceof O.NotebookDiffEditorTabInput)return l.input.modified;if(l.input instanceof O.TextTabInput||l.input instanceof O.NotebookEditorTabInput||l.input instanceof O.CustomEditorTabInput)return l.input.uri}}}super({getFolderUri:c=>{const l=n.folders.filter(m=>m.name===c);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(c,l)=>p.getConfiguration(void 0,c).get(l),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=r();if(c)return a.normalize(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const c=r();if(c){const l=g.getWorkspaceFolder(c);if(l)return a.normalize(l.uri.fsPath)}}},getSelectedText:()=>{if(b){const c=b.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(b){const c=b.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>u.getExtension(c)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let f=class extends A.Disposable{constructor(u,g,b,D,p){super(),this.b=u,this.c=g,this.g=b,this.h=D,this.i=p,this.a=new o.Lazy(async()=>{const n=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new y(this.b,this.c,this.g,this.i,n,r,this.j())})}getResolver(){return this.a.value}j(){}};f=xe([ze(0,k.IExtHostExtensionService),ze(1,T.IExtHostWorkspace),ze(2,P.IExtHostDocumentsAndEditors),ze(3,C.IExtHostConfiguration),ze(4,S.IExtHostEditorTabs)],f),e.ExtHostVariableResolverProviderService=f}),define(ye[84],De([1,0,19,3,9,2,4,5,60,42,20,7,34,131,227,35,49]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,I.createDecorator)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,c,l,m,i,t){this.D=c,this.E=l,this.F=m,this.G=i,this.H=t,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new A.Emitter,this.n=new A.Emitter,this.o=new A.Emitter,this.u=new A.Emitter,this.k=r.getProxy(P.MainContext.MainThreadDebugService),this.z=new A.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(d=>{d.onDidChange(E=>{this.I(d)}),this.I(d)})}asDebugSourceUri(r,c){const l=r;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let m=`debug:${encodeURIComponent(l.path||"")}`,i="?";return c&&(m+=`${i}session=${encodeURIComponent(c.id)}`,i="&"),m+=`${i}ref=${l.sourceReference}`,R.URI.parse(m)}else{if(l.path)return R.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(r){const c=[];for(const l of r.getAllExtensionDescriptions())if(l.contributes){const m=l.contributes.debuggers;if(m&&m.length>0)for(const i of m)(0,y.isDebuggerMainContribution)(i)&&c.push(i.type)}this.k.$registerDebugTypes(c)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const r=[];return this.w.forEach(c=>r.push(c)),r}addBreakpoints(r){this.T();const c=r.filter(i=>{const t=i.id;return this.w.has(t)?!1:(this.w.set(t,i),!0)});this.U(c,[],[]);const l=[],m=new Map;for(const i of c)if(i instanceof T.SourceBreakpoint){let t=m.get(i.location.uri.toString());t||(t={type:"sourceMulti",uri:i.location.uri,lines:[]},m.set(i.location.uri.toString(),t),l.push(t)),t.lines.push({id:i.id,enabled:i.enabled,condition:i.condition,hitCondition:i.hitCondition,logMessage:i.logMessage,line:i.location.range.start.line,character:i.location.range.start.character})}else i instanceof T.FunctionBreakpoint&&l.push({type:"function",id:i.id,enabled:i.enabled,hitCondition:i.hitCondition,logMessage:i.logMessage,condition:i.condition,functionName:i.functionName});return this.k.$registerBreakpoints(l)}removeBreakpoints(r){this.T();const c=r.filter(t=>this.w.delete(t.id));this.U([],c,[]);const l=c.filter(t=>t instanceof T.SourceBreakpoint).map(t=>t.id),m=c.filter(t=>t instanceof T.FunctionBreakpoint).map(t=>t.id),i=c.filter(t=>t instanceof T.DataBreakpoint).map(t=>t.id);return this.k.$unregisterBreakpoints(l,m,i)}startDebugging(r,c,l){return this.k.$startDebugging(r?r.uri:void 0,c,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,suppressSaveBeforeStart:l.suppressSaveBeforeStart,suppressDebugStatusbar:l.suppressDebugStatusbar??l.debugUI?.simple,suppressDebugToolbar:l.suppressDebugToolbar??l.debugUI?.simple,suppressDebugView:l.suppressDebugView??l.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,c,l){if(!c)return new T.Disposable(()=>{});const m=this.d++;return this.f.push({type:r,handle:m,provider:c}),this.k.$registerDebugConfigurationProvider(r,l,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,m),new T.Disposable(()=>{this.f=this.f.filter(i=>i.provider!==c),this.k.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(r,c,l){if(!l)return new T.Disposable(()=>{});if(!this.P(r,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.M(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this.g++;return this.h.push({type:c,handle:m,factory:l}),this.k.$registerDebugAdapterDescriptorFactory(c,m),new T.Disposable(()=>{this.h=this.h.filter(i=>i.factory!==l),this.k.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(r,c){if(!c)return new T.Disposable(()=>{});const l=this.i++;return this.j.push({type:r,handle:l,factory:c}),new T.Disposable(()=>{this.j=this.j.filter(m=>m.factory!==c)})}async $runInTerminal(r,c){return Promise.resolve(void 0)}async $substituteVariables(r,c){let l;const m=await this.W(r);return m&&(l={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(l,c)}J(r,c){if(r.type==="implementation")return new p(r.implementation)}K(){}async $startDASession(r,c){const l=this,m=await this.V(c);return this.R(this.M(m.type),m).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const t=this.L(i),d=this.J(t,m);if(!d)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const E=d;return this.A.set(r,E),this.Q(m).then(w=>(w&&this.B.set(r,w),E.onMessage(async L=>{if(L.type==="request"&&L.command==="handshake"){const q=L,V={type:"response",seq:0,command:q.command,request_seq:q.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const M=await this.C.sign(q.arguments.value);V.body={signature:M},E.sendResponse(V)}else throw new Error("no signer")}catch(M){V.success=!1,V.message=M.message,E.sendResponse(V)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(L),L=(0,y.convertToVSCPaths)(L,!0),l.k.$acceptDAMessage(r,L)}),E.onError(L=>{w&&w.onError&&w.onError(L),this.k.$acceptDAError(r,L.name,L.message,L.stack)}),E.onExit(L=>{w&&w.onExit&&w.onExit((0,a.withNullAsUndefined)(L),void 0),this.k.$acceptDAExit(r,(0,a.withNullAsUndefined)(L),void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),E.startSession()))})}$sendDAMessage(r,c){c=(0,y.convertToDAPaths)(c,!1);const l=this.B.get(r);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(c),this.A.get(r)?.sendMessage(c)}$stopDASession(r){const c=this.B.get(r);this.B.delete(r),c&&c.onWillStopSession&&c.onWillStopSession();const l=this.A.get(r);return this.A.delete(r),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const c=[],l=[],m=[];if(r.added)for(const i of r.added){const t=i.id;if(t&&!this.w.has(t)){let d;if(i.type==="function")d=new T.FunctionBreakpoint(i.functionName,i.enabled,i.condition,i.hitCondition,i.logMessage);else if(i.type==="data")d=new T.DataBreakpoint(i.label,i.dataId,i.canPersist,i.enabled,i.hitCondition,i.condition,i.logMessage);else{const E=R.URI.revive(i.uri);d=new T.SourceBreakpoint(new T.Location(E,new T.Position(i.line,i.character)),i.enabled,i.condition,i.hitCondition,i.logMessage)}(0,T.setBreakpointId)(d,t),this.w.set(t,d),c.push(d)}}if(r.removed)for(const i of r.removed){const t=this.w.get(i);t&&(this.w.delete(i),l.push(t))}if(r.changed){for(const i of r.changed)if(i.id){const t=this.w.get(i.id);if(t){if(t instanceof T.FunctionBreakpoint&&i.type==="function"){const d=t;d.enabled=i.enabled,d.condition=i.condition,d.hitCondition=i.hitCondition,d.logMessage=i.logMessage,d.functionName=i.functionName}else if(t instanceof T.SourceBreakpoint&&i.type==="source"){const d=t;d.enabled=i.enabled,d.condition=i.condition,d.hitCondition=i.hitCondition,d.logMessage=i.logMessage,d.location=new T.Location(R.URI.revive(i.uri),new T.Position(i.line,i.character))}m.push(t)}}}this.U(c,l,m)}$provideDebugConfigurations(r,c,l){return(0,o.asPromise)(async()=>{const m=this.O(r);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const i=await this.W(c);return m.provideDebugConfigurations(i,l)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(r,c,l,m){return(0,o.asPromise)(async()=>{const i=this.O(r);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const t=await this.W(c);return i.resolveDebugConfiguration(t,l,m)})}$resolveDebugConfigurationWithSubstitutedVariables(r,c,l,m){return(0,o.asPromise)(async()=>{const i=this.O(r);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const t=await this.W(c);return i.resolveDebugConfigurationWithSubstitutedVariables(t,l,m)})}async $provideDebugAdapter(r,c){const l=this.N(r);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.V(c);return this.R(l,m).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.L(i)})}async $acceptDebugSessionStarted(r){const c=await this.V(r);this.m.fire(c)}async $acceptDebugSessionTerminated(r){const c=await this.V(r);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,c){(await this.V(r))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(r,c){const m={session:await this.V(r),event:c.event,body:c.body};this.u.fire(m)}L(r){if(r instanceof T.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof T.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}M(r){const c=this.h.filter(l=>l.type===r);if(c.length>0)return c[0].factory}N(r){const c=this.h.filter(l=>l.handle===r);if(c.length>0)return c[0].factory}O(r){const c=this.f.filter(l=>l.handle===r);if(c.length>0)return c[0].provider}P(r,c){if(r.contributes){const l=r.contributes.debuggers;if(l&&l.length>0){for(const m of l)if(m.label&&m.type&&m.type===c)return!0}}return!1}Q(r){const l=r.configuration.type,m=this.j.filter(i=>i.type===l||i.type==="*").map(i=>(0,o.asPromise)(()=>i.factory.createDebugAdapterTracker(r)).then(t=>t,t=>null));return Promise.race([Promise.all(m).then(i=>{const t=i.filter(d=>!!d);if(t.length>0)return new D(t)}),new Promise(i=>setTimeout(()=>i(void 0),1e3))]).catch(i=>{})}async R(r,c){const l=c.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new T.DebugAdapterServer(l));if(r){const i=await this.E.getExtensionRegistry();return(0,o.asPromise)(()=>r.createDebugAdapterDescriptor(c,this.S(c,i))).then(t=>{if(t)return t})}const m=await this.E.getExtensionRegistry();return Promise.resolve(this.S(c,m))}S(r,c){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(r,c,l){(r.length>0||c.length>0||l.length>0)&&this.z.fire(Object.freeze({added:r,removed:c,changed:l}))}async V(r){if(r)if(typeof r=="string"){const c=this.l.get(r);if(c)return c}else{let c=this.l.get(r.id);if(!c){const l=await this.W(r.folderUri),m=r.parent?this.l.get(r.parent):void 0;c=new g(this.k,r.id,r.type,r.name,l,r.configuration,m),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(r){if(r){const c=R.URI.revive(r);return this.D.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};u=xe([ze(0,O.IExtHostRpcService),ze(1,v.IExtHostWorkspace),ze(2,k.IExtHostExtensionService),ze(3,f.IExtHostConfiguration),ze(4,S.IExtHostEditorTabs),ze(5,h.IExtHostVariableResolverProvider)],u),e.ExtHostDebugServiceBase=u;class g{constructor(r,c,l,m,i,t,d){this.d=r,this.f=c,this.g=l,this.h=m,this.i=i,this.j=t,this.k=d}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,c){return this.d.$customDebugAdapterRequest(this.f,r,c)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=g;class b{constructor(r){this.value=Object.freeze({append(c){r.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.ExtHostDebugConsole=b;class D{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(c=>c.onError?c.onError(r):void 0)}onExit(r,c){this.d.forEach(l=>l.onExit?l.onExit(r,c):void 0)}}class p extends C.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let n=class extends u{constructor(r,c,l,m,i,t){super(r,c,l,m,i,t)}};n=xe([ze(0,O.IExtHostRpcService),ze(1,v.IExtHostWorkspace),ze(2,k.IExtHostExtensionService),ze(3,f.IExtHostConfiguration),ze(4,S.IExtHostEditorTabs),ze(5,h.IExtHostVariableResolverProvider)],n),e.WorkerExtHostDebugService=n}),define(ye[298],De([1,0,12,83,2,5,290,13,90,91,25,203,20,56,42,76]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class h{static async installEarlyHandler(b){const D=b.get(P.ILogService),n=b.get(v.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);o.setUnexpectedErrorHandler(s=>{D.error(s);const r=o.transformErrorForSerialization(s);n.$onUnexpectedError(r)})}static async installFullHandler(b){const D=b.get(P.ILogService),p=b.get(v.IExtHostRpcService),n=b.get(y.IExtHostExtensionService),s=b.get(f.IExtHostTelemetry),r=p.getProxy(R.MainContext.MainThreadExtensionService),c=p.getProxy(R.MainContext.MainThreadErrors),l=await n.getExtensionPathIndex(),m=new WeakMap;Error.prepareStackTrace=(i,t)=>{let d="",E,w;for(const L of t)d+=`
	at ${L.toString()}`,w=L.getFileName(),!E&&w&&(E=l.findSubstr(a.URI.file(w)));return m.set(i,E?.identifier),`${i.name||"Error"}: ${i.message||""}${d}`},o.setUnexpectedErrorHandler(i=>{D.error(i);const t=o.transformErrorForSerialization(i),d=m.get(i);if(!d){c.$onUnexpectedError(t);return}r.$onExtensionRuntimeError(d,t);const E=s.onExtensionError(d,i);D.trace("forwarded error to extension?",E,d)})}}Error.stackTraceLimit=100;class u{constructor(b,D,p,n,s){this.a=p,this.b=new I.RPCProtocol(b,null,n),D=u.e(D,this.b);const r=new k.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());r.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...D,messagePorts:s}),r.set(v.IExtHostRpcService,new v.ExtHostRpcService(this.b)),r.set(C.IURITransformerService,new C.URITransformerService(n)),r.set(y.IHostUtils,p);const c=new T.InstantiationService(r,!0);c.invokeFunction(h.installEarlyHandler),this.d=c.invokeFunction(l=>l.get(P.ILogService)),A.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",D),this.c=c.invokeFunction(l=>l.get(y.IExtHostExtensionService)),this.c.initialize(),c.invokeFunction(h.installFullHandler)}async asBrowserUri(b){const D=this.b.getProxy(R.MainContext.MainThreadExtensionService);return a.URI.revive(await D.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,D){b.allExtensions.forEach(n=>{n.extensionLocation=a.URI.revive(D.transformIncomingURIs(n.extensionLocation));const s={};n.browserNlsBundleUris&&(Object.keys(n.browserNlsBundleUris).forEach(r=>s[r]=a.URI.revive(D.transformIncomingURIs(n.browserNlsBundleUris[r]))),n.browserNlsBundleUris=s)}),b.environment.appRoot=a.URI.revive(D.transformIncomingURIs(b.environment.appRoot));const p=b.environment.extensionDevelopmentLocationURI;return p&&(b.environment.extensionDevelopmentLocationURI=p.map(n=>a.URI.revive(D.transformIncomingURIs(n)))),b.environment.extensionTestsLocationURI=a.URI.revive(D.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=a.URI.revive(D.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=a.URI.revive(D.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=a.URI.revive(D.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=a.URI.revive(D.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=a.URI.revive(D.transformIncomingURIs(b.logsLocation)),b.logFile=a.URI.revive(D.transformIncomingURIs(b.logFile)),b.workspace=D.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=u}),define(ye[299],De([1,0,19,10,185,202,210,84,60,42,20,41,7,49,34,228,230,35]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let g=class extends P.ExtHostDebugServiceBase{constructor(s,r,c,l,m,i,t){super(s,r,c,l,i,t),this.Z=m,this.X=new p}J(s,r){switch(s.type){case"server":return new f.SocketDebugAdapter(s);case"pipeServer":return new f.NamedPipeDebugAdapter(s);case"executable":return new f.ExecutableDebugAdapter(s,r.type)}return super.J(s,r)}S(s,r){const c=f.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),s.type);if(c)return new v.DebugAdapterExecutable(c.command,c.args,c.options)}K(){return new I.SignService}async $runInTerminal(s,r){if(s.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const c=await this.F.getConfigProvider(),l=this.Z.getDefaultShell(!0),m=this.Z.getDefaultShellArgs(!0),i=s.title||a.localize(0,null),t=JSON.stringify({shell:l,shellArgs:m});let d=await this.X.checkout(t,i),E,w=!1;if(d)E=s.cwd;else{const M={shellPath:l,shellArgs:m,cwd:s.cwd,name:i,iconPath:new v.ThemeIcon("debug")};w=!0,d=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(d,t)}d.show(!0);const L=await d.processId;w?await new Promise(M=>setTimeout(M,1e3)):c.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0||l.indexOf("cmd.exe")>=0?d.sendText("cls"):l.indexOf("bash")>=0?d.sendText("clear"):A.isWindows?d.sendText("cls"):d.sendText("clear"));const q=(0,h.prepareCommand)(l,s.args,!!s.argsCanBeInterpretedByShell,E,s.env);d.sendText(q);const V=this.onDidTerminateDebugSession(M=>{M.id===r&&(this.X.free(d),V.dispose())});return L}else if(s.kind==="external")return D(s,await this.F.getConfigProvider());return super.$runInTerminal(s,r)}};g=xe([ze(0,O.IExtHostRpcService),ze(1,y.IExtHostWorkspace),ze(2,k.IExtHostExtensionService),ze(3,u.IExtHostConfiguration),ze(4,T.IExtHostTerminalService),ze(5,S.IExtHostEditorTabs),ze(6,C.IExtHostVariableResolverProvider)],g),e.ExtHostDebugService=g;let b;function D(n,s){if(!b)if(A.isWindows)b=new R.WindowsExternalTerminalService;else if(A.isMacintosh)b=new R.MacExternalTerminalService;else if(A.isLinux)b=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=s.getConfiguration("terminal");return b.runInTerminal(n.title,n.cwd,n.args,n.env||{},r.external||{})}class p{constructor(){this.b=new Map}async checkout(s,r){const l=[...this.b.entries()].map(([m,i])=>(0,o.createCancelablePromise)(async t=>{if(m.name!==r||i.lastUsedAt!==-1&&await(0,h.hasChildProcesses)(await m.processId))return null;const d=Date.now();return i.lastUsedAt+p.a>d||t.isCancellationRequested||i.config!==s?null:(i.lastUsedAt=d,m)}));return await(0,o.firstParallel)(l,m=>!!m)}insert(s,r){this.b.set(s,{lastUsedAt:Date.now(),config:r})}free(s){const r=this.b.get(s);r&&(r.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}p.a=1e3}),define(ye[300],De([1,0,11,2,116,34,59,35,47,41,20,25,82,16,13,77,24,89,49]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let b=class extends v.ExtHostTaskBase{constructor(p,n,s,r,c,l,m,i,t){super(p,n,s,r,c,l,m,i),this.B=s,this.C=t,n.remote.isRemote&&n.remote.authority?this.registerTaskSystem(C.Schemas.vscodeRemote,{scheme:C.Schemas.vscodeRemote,authority:n.remote.authority,platform:process.platform}):this.registerTaskSystem(C.Schemas.file,{scheme:C.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(p,n){const s=n;if(!n.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const r=v.TaskHandleDTO.from(s,this.B),c=await this.a.$getTaskExecution(r);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.y(c,n);return this.a.$executeTask(r).catch(()=>{}),l}else{const r=v.TaskDTO.from(n,p);if(r===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(r.execution)&&await this.x(r,n,!1);const c=await this.y(await this.a.$getTaskExecution(r),n);return this.a.$executeTask(r).catch(()=>{}),c}}u(p,n,s,r){const c=[];if(r)for(const l of r){this.z(l,s),(!l.definition||!p[l.definition.type])&&this.f.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const m=v.TaskDTO.from(l,s.extension);m&&(c.push(m),v.CustomExecutionDTO.is(m.execution)&&n.push(this.x(m,l,!0)))}return{tasks:c,extension:s.extension}}async v(p){return p}async F(p){let n=p&&p.length>0?p[0]:void 0;if(!n){const s=A.URI.file((0,u.homedir)());n=new S.WorkspaceFolder({uri:s,name:h.basename(s),index:0})}return{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(p,n){const s=A.URI.revive(p),r={process:void 0,variables:Object.create(null)},c=await this.b.resolveWorkspaceFolder(s),l=await this.b.getWorkspaceFolders2()??[],m=await this.C.getResolver(),i=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(l);for(const t of n.variables)r.variables[t]=await m.resolveAsync(i,t);if(n.process!==void 0){let t;if(n.process.path!==void 0){t=n.process.path.split(o.delimiter);for(let d=0;d<t.length;d++)t[d]=await m.resolveAsync(i,t[d])}r.process=await a.win32.findExecutable(await m.resolveAsync(i,n.process.name),n.process.cwd!==void 0?await m.resolveAsync(i,n.process.cwd):void 0,t)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(p,n,s){return a.win32.findExecutable(p,n,s)}};b=xe([ze(0,O.IExtHostRpcService),ze(1,T.IExtHostInitDataService),ze(2,R.IExtHostWorkspace),ze(3,I.IExtHostDocumentsAndEditors),ze(4,P.IExtHostConfiguration),ze(5,k.IExtHostTerminalService),ze(6,y.ILogService),ze(7,f.IExtHostApiDeprecationService),ze(8,g.IExtHostVariableResolverProvider)],b),e.ExtHostTask=b}),define(ye[301],De([1,0,89,49]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class a extends A.ExtHostVariableResolverProviderService{j(){return(0,o.homedir)()}}e.NodeExtHostVariableResolverProviderService=a}),define(ye[143],De([1,0,15,19,21,45,16,11,24,2,31]),function(ne,e,o,A,a,R,I,P,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class T{constructor(g,b,D,p){this.d=g,this.e=b,this.f=D,this.g=p,this.a=null,this.b=!1,this.c=0}search(g,b){const D=this.d.folderQueries||[],p=new a.CancellationTokenSource;return b.onCancellationRequested(()=>p.cancel()),new Promise((n,s)=>{this.a=new C(g);let r=!1;const c=(l,m)=>{if(!r&&!this.b){const i=this.h(l);f(l)&&typeof this.d.maxResults=="number"&&this.c+i>this.d.maxResults&&(this.b=!0,r=!0,p.cancel(),l=this.j(l,this.d.maxResults-this.c));const t=this.h(l);this.c+=t,(t>0||!f(l))&&this.a.add(l,m)}};Promise.all(D.map((l,m)=>this.k(l,i=>c(i,m),p.token))).then(l=>{p.dispose(),this.a.flush();const m=l.some(i=>!!i&&!!i.limitHit);n({limitHit:this.b||m,messages:(0,o.flatten)(l.map(i=>i?.message?Array.isArray(i.message)?i.message:[i.message]:[])),stats:{type:this.g}})},l=>{p.dispose();const m=(0,R.toErrorMessage)(l);s(new Error(m))})})}h(g){return f(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}j(g,b){const D=Array.isArray(g.ranges)?g.ranges:[g.ranges],p=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:D.slice(0,b),preview:{matches:p.slice(0,b),text:g.preview.text},uri:g.uri}}async k(g,b,D){const p=new O.QueryGlobTester(this.d,g),n=[],s={report:l=>{if(!this.l(l))return;const m=g.folder.scheme===I.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(l.uri))):void 0,i=S.relativePath(g.folder,l.uri);if(i){const t=p.includedInQuery(i,P.basename(i),m);(0,A.isThenable)(t)?n.push(t.then(d=>{d&&b(l)})):t&&b(l)}}},r=this.n(g),c=await this.e.provideTextSearchResults(v(this.d.contentPattern),r,s,D);return n.length&&await Promise.all(n),c}l(g){if(f(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(g){const b=(0,O.resolvePatternsForProvider)(this.d.includePattern,g.includePattern),D=(0,O.resolvePatternsForProvider)(this.d.excludePattern,g.excludePattern),p={folder:k.URI.from(g.folder),excludes:D,includes:b,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.f.toCanonicalName(g.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.TextSearchManager=T;function v(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class C{constructor(g){this.e=g,this.b=-1,this.d=null,this.a=new h(512,b=>this.g(b))}add(g,b){this.d&&(this.b!==b||!S.isEqual(this.c,g.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:g.uri,results:[]}),this.d.results.push(y(g))}f(){const g=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,g)}flush(){this.f(),this.a.flush()}g(g){this.e(g)}}e.TextSearchResultsCollector=C;function y(u){return f(u)?{preview:{matches:(0,o.mapArrayOrNot)(u.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:u.preview.text},ranges:(0,o.mapArrayOrNot)(u.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function f(u){return!!u.preview}e.extensionResultIsMatch=f;class h{constructor(g,b){this.g=g,this.h=b,this.c=0,this.d=[],this.e=0}addItem(g,b){!g||this.j(g,b)}addItems(g,b){!g||this.k(g,b)}j(g,b){this.d.push(g),this.e+=b,this.l()}k(g,b){this.d=this.d.concat(g),this.e+=b,this.l()}l(){this.c<h.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},h.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}h.a=4e3,h.b=50,e.BatchedCollector=h}),define(ye[85],De([1,0,6,5,4,294,20,56,13,2,143]),function(ne,e,o,A,a,R,I,P,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,a.createDecorator)("IExtHostSearch");let T=class{constructor(f,h,u){this.k=f,this.l=h,this.n=u,this.c=this.k.getProxy(A.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,h){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const u=this.d++;return this.e.set(u,h),this.c.$registerTextSearchProvider(u,this.o(f)),(0,o.toDisposable)(()=>{this.g.delete(f),this.e.delete(u),this.c.$unregisterProvider(u)})}registerFileSearchProvider(f,h){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const u=this.d++;return this.h.set(u,h),this.c.$registerFileSearchProvider(u,this.o(f)),(0,o.toDisposable)(()=>{this.i.delete(f),this.h.delete(u),this.c.$unregisterProvider(u)})}$provideFileSearchResults(f,h,u,g){const b=v(u),D=this.h.get(f);if(D)return this.j.fileSearch(b,D,p=>{this.c.$handleFileMatch(f,h,p.map(n=>n.resource))},g);throw new Error("unknown provider: "+f)}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,h,u,g){const b=this.e.get(f);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const D=v(u);return this.q(D,b).search(n=>this.c.$handleTextMatch(f,h,n),g)}$enableExtensionHostSearch(){}q(f,h){return new O.TextSearchManager(f,h,{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}};T=xe([ze(0,I.IExtHostRpcService),ze(1,P.IURITransformerService),ze(2,S.ILogService)],T),e.ExtHostSearch=T;function v(y){return{...y,folderQueries:y.folderQueries&&y.folderQueries.map(C),extraFileResources:y.extraFileResources&&y.extraFileResources.map(f=>k.URI.revive(f))}}e.reviveQuery=v;function C(y){return{...y,folder:k.URI.revive(y.folder)}}}),define(ye[302],De([1,0,90,142,34,139,35,40,59,41,82,84,85,99,55,77,141,78,48,98,76,60,140,13,219,49,97]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u,g,b,D,p,n,s,r,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(l.IExtHostLocalizationService,l.ExtHostLocalizationService,1),(0,o.registerSingleton)(s.ILoggerService,n.ExtHostLoggerService,1),(0,o.registerSingleton)(s.ILogService,r.ExtHostLogService,1),(0,o.registerSingleton)(f.IExtHostApiDeprecationService,f.ExtHostApiDeprecationService,1),(0,o.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands,0),(0,o.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration,0),(0,o.registerSingleton)(u.IExtHostConsumerFileSystem,u.ExtHostConsumerFileSystem,0),(0,o.registerSingleton)(T.IExtHostDebugService,T.WorkerExtHostDebugService,0),(0,o.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,o.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,o.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,0),(0,o.registerSingleton)(A.IExtHostOutputService,A.ExtHostOutputService,1),(0,o.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch,0),(0,o.registerSingleton)(C.IExtHostStorage,C.ExtHostStorage,0),(0,o.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,o.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,o.registerSingleton)(y.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,o.registerSingleton)(h.IExtHostWindow,h.ExtHostWindow,0),(0,o.registerSingleton)(a.IExtHostWorkspace,a.ExtHostWorkspace,0),(0,o.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,o.registerSingleton)(D.IExtHostTelemetry,D.ExtHostTelemetry,0),(0,o.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,o.registerSingleton)(c.IExtHostVariableResolverProvider,c.ExtHostVariableResolverProviderService,0)}),define(ye[100],De([1,0,15,13,31,81]),function(ne,e,o,A,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function I(T){return T.startsWith("**")||T.startsWith("/")?T:`/${T}`}e.anchorGlob=I;function P(T,v,C,y){const f=(0,o.mapArrayOrNot)(C,S),h=new a.TextSearchMatch(v,f,y),u=h.preview.matches;return{ranges:(0,o.mapArrayOrNot)(f,k),uri:T,preview:{text:h.preview.text,matches:(0,o.mapArrayOrNot)(u,k)}}}e.createTextSearchResult=P;function S(T){return new a.SearchRange(T.start.line,T.start.character,T.end.line,T.end.character)}function k(T){return new R.Range(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn)}let O=class{constructor(v,C){this.a=v,this.b=C}appendLine(v){this.b.debug(`${this.a}#search`,v)}};O=xe([ze(1,A.ILogService)],O),e.OutputChannel=O}),define(ye[303],De([1,0,46,11,86,33,10,8,100,304]),function(ne,e,o,A,a,R,I,P,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const O=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function T(b,D,p,n){const s=v(b,D,p,n),r=D.folder.fsPath;return{cmd:o.spawn(O,s.args,{cwd:r}),rgDiskPath:O,siblingClauses:s.siblingClauses,rgArgs:s,cwd:r}}e.spawnRipgrepCmd=T;function v(b,D,p,n){const s=["--files","--hidden","--case-sensitive"];y([D],p,!1).forEach(c=>{const l=(0,S.anchorGlob)(c);if(s.push("-g",l),I.isMacintosh){const m=(0,a.normalizeNFD)(l);m!==l&&s.push("-g",m)}});const r=C([D],n,void 0,!1);return r.globArgs.forEach(c=>{const l=`!${(0,S.anchorGlob)(c)}`;if(s.push("-g",l),I.isMacintosh){const m=(0,a.normalizeNFD)(l);m!==l&&s.push("-g",m)}}),D.disregardIgnoreFiles!==!1?s.push("--no-ignore"):D.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),D.ignoreSymlinks||s.push("--follow"),b.exists&&s.push("--quiet"),s.push("--no-config"),D.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:r.siblingClauses}}function C(b,D,p,n=!0){const s=[];let r={};return b.forEach(c=>{const l=Object.assign({},c.excludePattern||{},D||{}),m=f(l,n?c.folder.fsPath:void 0,p);s.push(...m.globArgs),m.siblingClauses&&(r=Object.assign(r,m.siblingClauses))}),{globArgs:s,siblingClauses:r}}function y(b,D,p=!0){const n=[];return b.forEach(s=>{const r=Object.assign({},D||{},s.includePattern||{}),c=f(r,p?s.folder.fsPath:void 0);n.push(...c.globArgs)}),n}function f(b,D,p){const n=[],s={};return Object.keys(b).forEach(r=>{if(p&&p.has(r)||!r)return;const c=b[r];r=u(D?h(D,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof c=="boolean"&&c?(r.startsWith("\\\\")&&(r+="**"),n.push(g(r))):c&&c.when&&(s[r]=c)}),{globArgs:n,siblingClauses:s}}function h(b,D){return A.isAbsolute(D)?D:A.join(b,D)}e.getAbsoluteGlob=h;function u(b){return b=P.rtrim(b,"\\"),P.rtrim(b,"/")}function g(b){return R.getRoot(b).toLowerCase()==="c:/"?b.replace(/^c:[/\\]/i,"/"):b}e.fixDriveC=g}),define(ye[305],De([1,0,46,70,11,306,15,45,38,86,33,10,43,8,9,29,31,303,111]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const b=new Set;process.on("exit",()=>{b.forEach(r=>r())});class D{constructor(c){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=c,this.b=c.filePattern||"",this.d=c.includePattern&&S.parse(c.includePattern),this.f=c.maxResults||null,this.g=!!c.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,g.prepareQuery)(this.b).normalizedLowercase),this.u=c.excludePattern&&S.parse(c.excludePattern),this.t=new Map,c.folderQueries.forEach(l=>{const m=Object.assign({},l.excludePattern||{},this.a.excludePattern||{}),i=l.folder.fsPath;c.folderQueries.map(t=>t.folder.fsPath).filter(t=>t!==i).forEach(t=>{(0,O.isEqualOrParent)(t,i)&&(m[a.relative(i,t)]=!0)}),this.t.set(i,new n(m,i))})}cancel(){this.l=!0,b.forEach(c=>c())}walk(c,l,m,i,t){if(this.m=v.StopWatch.create(!1),this.l)return t(null,this.j);l.forEach(d=>{const E=a.basename(d.fsPath);this.u&&this.u(d.fsPath,E)||this.J(m,{relativePath:d.fsPath,searchPath:void 0})}),this.r=v.StopWatch.create(!1),this.w(c,(d,E)=>{this.x(this.y,this,d,m,i,w=>{if(w){const L=(0,P.toErrorMessage)(w);console.error(L),this.q.push(L),E(w,void 0)}else E(null,void 0)})},(d,E)=>{this.m.stop();const w=d?I.coalesce(d)[0]:null;t(w,this.j)})}w(c,l,m){const i=new Array(c.length),t=new Array(c.length);let d=!1,E=0;if(c.length===0)return m(null,[]);c.forEach((w,L)=>{l(w,(q,V)=>{if(q?(d=!0,i[L]=null,t[L]=q):(i[L]=V,t[L]=null),++E===c.length)return m(d?t:null,i)})})}x(c,l,...m){try{c.apply(l,m)}catch(i){m[m.length-1](i)}}y(c,l,m,i){const t=c.folder.fsPath,d=T.isMacintosh,E=()=>M&&M.kill();b.add(E);let w=$=>{b.delete(E),w=()=>{},i($)},L="";const q=this.D(),V=(0,u.spawnRipgrepCmd)(this.a,c,this.a.includePattern,this.t.get(c.folder.fsPath).expression),M=V.cmd,B=!Object.keys(V.siblingClauses).length,N=V.rgArgs.args.map($=>$.match(/^-/)?$:`'${$}'`).join(" ");let U=`${V.rgDiskPath} ${N}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),m({message:U}),this.s=0,this.z(M,"utf8",m,($,z,ae)=>{if($){w($);return}if(this.j){w();return}const x=(L+(d?k.normalizeNFC(z||""):z)).split(`
`);if(ae){const J=x.length;x[J-1]=x[J-1].trim(),x[J-1]||x.pop()}else L=x.pop()||"";if(x.length&&x[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.s+=x.length,B){for(const J of x)if(this.J(l,{base:t,relativePath:J,searchPath:this.N(c,J)}),this.j){E();break}(ae||this.j)&&w();return}this.G(c,q,t,x,l),ae&&(this.H(q,t,l),w())})}spawnFindCmd(c){const l=this.t.get(c.folder.fsPath),m=l.getBasenameTerms(),i=l.getPathTerms(),t=["-L","."];if(m.length||i.length){t.push("-not","(","(");for(const d of m)t.push("-name",d),t.push("-o");for(const d of i)t.push("-path",d),t.push("-o");t.pop(),t.push(")","-prune",")")}return t.push("-type","f"),o.spawn("find",t,{cwd:c.folder.fsPath})}readStdout(c,l,m){let i="";this.z(c,l,()=>{},(t,d,E)=>{if(t){m(t);return}i+=d,E&&m(null,i)})}z(c,l,m,i){let t=(w,L,q)=>{(w||q)&&(t=()=>{},this.r?.stop()),i(w,L,q)},d=!1;c.stdout?(this.A(c.stdout,l,t),c.stdout.once("data",()=>d=!0)):m({message:"stdout is null"});let E;c.stderr?E=this.B(c.stderr):m({message:"stderr is null"}),c.on("error",w=>{t(w)}),c.on("close",w=>{let L;!d&&(L=this.C(E,l))&&s(L)?t(new Error(`command failed with error code ${w}: ${this.C(E,l)}`)):(this.g&&w===0&&(this.j=!0),t(null,"",!0))})}A(c,l,m){const i=new R.StringDecoder(l);return c.on("data",t=>{m(null,i.write(t))}),i}B(c){const l=[];return c.on("data",m=>{l.push(m)}),l}C(c,l){const m=new R.StringDecoder(l);return c.map(i=>m.write(i)).join("")}D(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}G(c,{pathToEntries:l},m,i,t){i.indexOf(this.b)!==-1&&this.J(t,{base:m,relativePath:this.b,searchPath:this.N(c,this.b)});const d=E=>{const w=a.basename(E),L=a.dirname(E);let q=l[L];q||(q=l[L]=[],d(L)),q.push({base:m,relativePath:E,basename:w,searchPath:this.N(c,E)})};i.forEach(d)}H({rootEntries:c,pathToEntries:l},m,i){const t=this,d=this.t.get(m),E=this.b;function w(L){t.o++;const q=(0,h.hasSiblingFn)(()=>L.map(V=>V.basename));for(let V=0,M=L.length;V<M;V++){const B=L[V],{relativePath:N,basename:U}=B;if(d.test(N,U,E!==U?q:void 0))continue;const $=l[N];if($)w($);else{if(t.p++,N===E)continue;t.J(i,B)}if(t.j)break}}w(c)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(c,l,m,i,t){const d=c.folder,E=(0,h.hasSiblingFn)(()=>m);this.w(m,(w,L)=>{if(this.l||this.j)return L(null);const q=l?[l,w].join(a.sep):w;if(this.t.get(c.folder.fsPath).test(q,w,this.a.filePattern!==w?E:void 0))return L(null);const V=[d.fsPath,q].join(a.sep);A.lstat(V,(M,B)=>{if(M||this.l||this.j)return L(null);this.L(V,B,(N,U)=>N||this.l||this.j?L(null):U.isDirectory()?(this.o++,this.M(V,B,($,z)=>$||this.l||this.j||(z=z||"",this.v[z])?L(null):(this.v[z]=!0,f.Promises.readdir(V).then(ae=>{if(this.l||this.j)return L(null);this.I(c,q,ae,i,ee=>L(ee||null))},ae=>{L(null)})))):(this.p++,q===this.b||this.h&&y.isNumber(U.size)&&U.size>this.h||this.J(i,{base:d.fsPath,relativePath:q,searchPath:this.N(c,q)}),L(null,void 0)))})},w=>{const L=w&&I.coalesce(w);return t(L&&L.length>0?L[0]:void 0)})}J(c,l){this.K(l)&&(!this.d||this.d(l.relativePath,a.basename(l.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||c(l))}K(c){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,h.isFilePatternMatch)(c,this.c)}return!0}L(c,l,m){return l.isSymbolicLink()?A.stat(c,m):m(null,l)}M(c,l,m){return l.isSymbolicLink()?A.realpath(c,(i,t)=>i?m(i):m(null,t)):m(null,c)}N(c,l){return c.folderName?a.join(c.folderName,l):l}}e.FileWalker=D;class p{constructor(c){this.a=c.folderQueries,this.b=c.extraFileResources||[],this.c=new D(c)}search(c,l,m){this.c.walk(this.a,this.b,c,l,(i,t)=>{m(i,{limitHit:t,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=p;class n{constructor(c,l){this.expression=c,this.c=l,this.d(c)}d(c){let l,m;Object.keys(c).filter(i=>c[i]).forEach(i=>{a.isAbsolute(i)?(l=l||S.getEmptyExpression(),l[i]=c[i]):(m=m||S.getEmptyExpression(),m[i]=c[i])}),this.a=l&&S.parse(l,{trimForExclusions:!0}),this.b=m&&S.parse(m,{trimForExclusions:!0})}test(c,l,m){return this.b&&this.b(c,l,m)||this.a&&this.a(a.join(this.c,c),l,m)}getBasenameTerms(){const c=[];return this.a&&c.push(...S.getBasenameTerms(this.a)),this.b&&c.push(...S.getBasenameTerms(this.b)),c}getPathTerms(){const c=[];return this.a&&c.push(...S.getPathTerms(this.a)),this.b&&c.push(...S.getPathTerms(this.b)),c}}function s(r){const c=r.trim().split(`
`),l=c[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return C.uppercaseFirstLetter(c[c.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(ye[307],De([1,0,103,22]),function(ne,e,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function a(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(c=>c===r)}e.isUTFEncoding=a,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,I=512,P=512*8,S=512*128;var k;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(k=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class O extends Error{constructor(c,l){super(c),this.decodeStreamErrorKind=l}}e.DecodeStreamError=O;class T{static async create(c){let l;if(c!==e.UTF8)l=(await new Promise((i,t)=>{ne(["@vscode/iconv-lite-umd"],i,t)})).getDecoder(f(c));else{const m=new TextDecoder;l={write(i){return m.decode(i,{stream:!0})},end(){return m.decode()}}}return new T(l)}constructor(c){this.a=c}write(c){return this.a.write(c)}end(){return this.a.end()}}function v(r,c){const l=c.minBytesRequiredForDetection??c.guessEncoding?P:I;return new Promise((m,i)=>{const t=(0,o.newWriteableStream)(V=>V.join("")),d=[];let E=0,w;const L=async()=>{try{const V=await s({buffer:A.VSBuffer.concat(d),bytesRead:E},c.guessEncoding);if(V.seemsBinary&&c.acceptTextOnly)throw new O("Stream is binary but only text is accepted for decoding",1);V.encoding=await c.overwriteEncoding(V.encoding),w=await T.create(V.encoding);const M=w.write(A.VSBuffer.concat(d).buffer);t.write(M),d.length=0,E=0,m({stream:t,detected:V})}catch(V){q?.dispose(),t.destroy(),i(V)}},q=(0,o.listenStream)(r,{onData:async V=>{w?t.write(w.write(V.buffer)):(d.push(V),E+=V.byteLength,E>=l&&(r.pause(),await L(),setTimeout(()=>r.resume())))},onError:V=>t.error(V),onEnd:async()=>{w||await L(),t.end(w?.end())}})})}e.toDecodeStream=v;async function C(r,c,l){const i=(await new Promise((E,w)=>{ne(["@vscode/iconv-lite-umd"],E,w)})).getEncoder(f(c),l);let t=!1,d=!1;return{read(){if(d)return null;const E=r.read();if(typeof E!="string"){if(d=!0,!t&&l?.addBOM)switch(c){case e.UTF8:case e.UTF8_with_bom:return A.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const w=i.end();return w&&w.length>0?(t=!0,A.VSBuffer.wrap(w)):null}return t=!0,A.VSBuffer.wrap(i.write(E))}}}e.toEncodeReadable=C;async function y(r){return(await new Promise((l,m)=>{ne(["@vscode/iconv-lite-umd"],l,m)})).encodingExists(f(r))}e.encodingExists=y;function f(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=f;function h(r,c){if(!r||c<e.UTF16be_BOM.length)return null;const l=r.readUInt8(0),m=r.readUInt8(1);if(l===e.UTF16be_BOM[0]&&m===e.UTF16be_BOM[1])return e.UTF16be;if(l===e.UTF16le_BOM[0]&&m===e.UTF16le_BOM[1])return e.UTF16le;if(c<e.UTF8_BOM.length)return null;const i=r.readUInt8(2);return l===e.UTF8_BOM[0]&&m===e.UTF8_BOM[1]&&i===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=h;const u=["ascii","utf-16","utf-32"];async function g(r){const c=await new Promise((d,E)=>{ne(["jschardet"],d,E)}),l=r.slice(0,S),m=p(l.buffer),i=c.detect(m);if(!i||!i.encoding)return null;const t=i.encoding.toLowerCase();return 0<=u.indexOf(t)?null:D(i.encoding)}const b={ibm866:"cp866",big5:"cp950"};function D(r){const c=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[c]||c}function p(r){let c="";for(let l=0;l<r.length;l++)c+=String.fromCharCode(r[l]);return c}function n(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const c=r.match(/windows(\d+)/);return c?"windows-"+c[1]:r}}}e.toCanonicalName=n;function s({buffer:r,bytesRead:c},l){let m=h(r,c),i=!1;if(m!==e.UTF16be&&m!==e.UTF16le&&r){let t=!0,d=!0,E=!1;for(let w=0;w<c&&w<R;w++){const L=w%2===1,q=r.readUInt8(w)===0;if(q&&(E=!0),t&&(L&&!q||!L&&q)&&(t=!1),d&&(L&&q||!L&&!q)&&(d=!1),q&&!t&&!d)break}E&&(t?m=e.UTF16le:d?m=e.UTF16be:i=!0)}return l&&!i&&!m&&r?g(r.slice(0,c)).then(t=>({seemsBinary:!1,encoding:t})):{seemsBinary:i,encoding:m}}e.detectEncodingFromBuffer=s,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[144],De([1,0,307,29,143]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends a.TextSearchManager{constructor(P,S,k=A,O="searchProcess"){super(P,S,{readdir:T=>k.Promises.readdir(T.fsPath),toCanonicalName:T=>(0,o.toCanonicalName)(T)},O)}}e.NativeTextSearchManager=R}),define(ye[308],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class o{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(a){if(a&&this.a.has(a)){const R=this.a.get(a);return this.a.delete(a),R}}addDragOperationTransfer(a,R){this.a.set(a,R)}getRenderedTreeElement(a){if(this.b.has(a))return this.b.get(a)}addRenderedTreeItemElement(a,R){this.b.set(a,R)}removeRenderedTreeItemElement(a){this.b.has(a)&&this.b.delete(a)}}e.TreeviewsService=o}),define(ye[309],De([1,0,183,7,24,2,3,6,225,19,7,9,15,14,21,308,26]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(D,p){if((0,T.isString)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let n;return Array.isArray(D.highlights)&&(n=D.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),n=n.length?n:void 0),{label:D.label,highlights:n}}}class g{constructor(p,n,s){this.d=p,this.e=n,this.f=s,this.a=new Map,this.b=new f.TreeviewsService;function r(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:c=>r(c)?this.i(c):Array.isArray(c)&&c.length>0?c.map(l=>r(l)?this.i(l):l):c})}registerTreeDataProvider(p,n,s){const r=this.createTreeView(p,{treeDataProvider:n},s);return{dispose:()=>r.dispose()}}createTreeView(p,n,s){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=n.dragAndDropController?.dropMimeTypes??[],c=n.dragAndDropController?.dragMimeTypes??[],l=!!n.dragAndDropController?.handleDrag,m=!!n.dragAndDropController?.handleDrop,i=this.h(p,n,s),t=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:r,dragMimeTypes:c,hasHandleDrag:l,hasHandleDrop:m});return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,h.checkProposedApiEnabled)(s,"treeItemCheckbox"),i.onDidChangeCheckboxState},get message(){return i.message},set message(d){i.message=d},get title(){return i.title},set title(d){i.title=d},get description(){return i.description},set description(d){i.description=d},get badge(){return i.badge},set badge(d){d!==void 0&&O.ViewBadge.isViewBadge(d)?i.badge={value:Math.floor(Math.abs(d.value)),tooltip:d.tooltip}:d===void 0&&(i.badge=void 0)},reveal:(d,E)=>i.reveal(d,E),dispose:async()=>{await t,this.a.delete(p),i.dispose()}}}$getChildren(p,n){const s=this.a.get(p);return s?s.getChildren(n):Promise.reject(new S.NoTreeViewError(p))}async $handleDrop(p,n,s,r,c,l,m,i){const t=this.a.get(p);if(!t)return Promise.reject(new S.NoTreeViewError(p));const d=C.DataTransfer.toDataTransfer(s,async E=>(await this.d.$resolveDropFileData(p,n,E)).buffer);return m===p&&i&&await this.g(d,t,i,c,l),t.onDrop(d,r,c)}async g(p,n,s,r,c){const l=this.b.removeDragOperationTransfer(c);if(l)(await l)?.forEach((m,i)=>{m&&p.set(i,m)});else if(c&&n.handleDrag){const m=n.handleDrag(s,p,r);this.b.addDragOperationTransfer(c,m),await m}return p}async $handleDrag(p,n,s,r){const c=this.a.get(p);if(!c)return Promise.reject(new S.NoTreeViewError(p));const l=await this.g(new A.DataTransfer,c,n,r,s);if(!!l)return C.DataTransfer.toDataTransferDTO(l)}async $hasResolve(p){const n=this.a.get(p);if(!n)throw new S.NoTreeViewError(p);return n.hasResolve}$resolve(p,n,s){const r=this.a.get(p);if(!r)throw new S.NoTreeViewError(p);return r.resolveTreeItem(n,s)}$setExpanded(p,n,s){const r=this.a.get(p);if(!r)throw new S.NoTreeViewError(p);r.setExpanded(n,s)}$setSelection(p,n){const s=this.a.get(p);if(!s)throw new S.NoTreeViewError(p);s.setSelection(n)}$setFocus(p,n){const s=this.a.get(p);if(!s)throw new S.NoTreeViewError(p);s.setFocus(n)}$setVisible(p,n){const s=this.a.get(p);if(!s)throw new S.NoTreeViewError(p);s.setVisible(n)}$changeCheckboxState(p,n){const s=this.a.get(p);if(!s)throw new S.NoTreeViewError(p);s.setCheckboxState(n)}h(p,n,s){const r=new b(p,n,this.d,this.e.converter,this.f,s);return this.a.set(p,r),r}i(p){const n=this.a.get(p.$treeViewId);return n&&"$treeItemHandle"in p?n.getExtensionElement(p.$treeItemHandle):n&&"$focusedTreeItem"in p&&p.$focusedTreeItem?n.focusedElement:null}}e.ExtHostTreeViews=g;class b extends P.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,T.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,n,s,r,c,l){if(super(),this.C=p,this.D=s,this.F=r,this.G=c,this.H=l,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new I.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new I.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new I.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new I.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new I.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new I.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new y.CancellationTokenSource,l.contributes&&l.contributes.views)for(const t in l.contributes.views)for(const d of l.contributes.views[t])d.id===p&&(this.J=d.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(t=>this.w.fire({message:!1,element:t})));let m,i;this.B(I.Event.debounce(this.w.event,(t,d)=>(t||(t={message:!1,elements:[]}),d.element!==!1&&(m||(m=new Promise(E=>i=E),this.y=this.y.then(()=>m)),Array.isArray(d.element)?t.elements.push(...d.element):t.elements.push(d.element)),d.message&&(t.message=!0),t),200,!0)(({message:t,elements:d})=>{d.length&&(this.z=this.z.then(()=>{const E=i;return m=null,this.U(d).then(()=>E())})),t&&this.D.$setMessage(this.C,this.I)}))}async getChildren(p){const n=p?this.getExtensionElement(p):void 0;if(p&&!n)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let s=this.Q(p);return s||(s=await this.R(n)),s?s.map(r=>r.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,n){n=n||{select:!0,focus:!1};const s=(0,T.isUndefinedOrNull)(n.select)?!0:n.select,r=(0,T.isUndefinedOrNull)(n.focus)?!1:n.focus,c=(0,T.isUndefinedOrNull)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.y.then(()=>this.N(p)).then(l=>this.P(p,l[l.length-1]).then(m=>this.D.$reveal(this.C,{item:m.item,parentChain:l.map(i=>i.item)},{select:s,focus:r,expand:c})),l=>this.G.error(l)):this.D.$reveal(this.C,void 0,{select:s,focus:r,expand:c})}get message(){return this.I}set message(p){this.I=p,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.D.$setTitle(this.C,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.D.$setTitle(this.C,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=C.ViewBadge.from(p),this.D.$setBadge(this.C,p))}setExpanded(p,n){const s=this.getExtensionElement(p);s&&(n?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(p){(0,v.equals)(this.l,p)||(this.l=p,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const n=(await Promise.all(p.map(async s=>{const r=this.getExtensionElement(s.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:s.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);n.forEach(s=>{s.treeItem.checkboxState=s.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}),this.v.fire({items:n.map(s=>[s.extensionItem,s.newState])})}async handleDrag(p,n,s){const r=[];for(const c of p){const l=this.getExtensionElement(c);l&&r.push(l)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,n,s),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,n,s){const r=n?this.getExtensionElement(n):void 0;if(!(!r&&n||!this.g?.handleDrop))return(0,k.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,p,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,n){if(!this.f.resolveTreeItem)return;const s=this.i.get(p);if(s){const r=this.j.get(s);if(r){const c=await this.f.resolveTreeItem(r.extensionItem,s,n)??r.extensionItem;return this.db(c),r.item.tooltip=this.ab(c.tooltip),r.item.command=this.bb(r.disposableStore,c.command),r.item}}}N(p){return this.O(p).then(n=>n?this.N(n).then(s=>this.P(n,s[s.length-1]).then(r=>(s.push(r),s))):Promise.resolve([]))}O(p){const n=this.j.get(p);return n?Promise.resolve(n.parent?this.i.get(n.parent.item.handle):void 0):(0,k.asPromise)(()=>this.f.getParent(p))}P(p,n){const s=this.j.get(p);return s?Promise.resolve(s):(0,k.asPromise)(()=>this.f.getTreeItem(p)).then(r=>this.gb(p,r,n,!0)).then(r=>this.getChildren(n?n.item.handle:void 0).then(()=>{const c=this.getExtensionElement(r);if(c){const l=this.j.get(c);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(p){if(p){let n;if(typeof p=="string"){const s=this.getExtensionElement(p);n=s?this.j.get(s):void 0}else n=p;return n&&n.children||void 0}return this.h}async R(p){this.nb(p);const n=new y.CancellationTokenSource(this.S.token);try{const s=p?this.j.get(p):void 0,r=await this.f.getChildren(p);if(n.token.isCancellationRequested)return;const c=await Promise.all((0,v.coalesce)(r||[]).map(async l=>{const m=await this.f.getTreeItem(l);return m&&!n.token.isCancellationRequested?this.Z(l,m,s):null}));return n.token.isCancellationRequested?void 0:(0,v.coalesce)(c)}finally{n.dispose()}}U(p){if(p.some(s=>!s))return this.S.dispose(!0),this.S=new y.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const s=this.W(p);if(s.length)return this.X(s)}return Promise.resolve(void 0)}W(p){const n=new Set,s=p.map(c=>this.j.get(c));for(const c of s)if(c&&!n.has(c.item.handle)){let l=c;for(;l&&l.parent&&s.findIndex(m=>l&&l.parent&&m&&m.item.handle===l.parent.item.handle)===-1;){const m=this.i.get(l.parent.item.handle);l=m?this.j.get(m):void 0}l&&!l.parent&&n.add(c.item.handle)}const r=[];return n.forEach(c=>{const l=this.i.get(c);if(l){const m=this.j.get(l);m&&(!m.parent||!n.has(m.parent.item.handle))&&r.push(c)}}),r}X(p){const n={};return Promise.all(p.map(s=>this.Y(s).then(r=>{r&&(n[s]=r.item)}))).then(()=>Object.keys(n).length?this.D.$refresh(this.C,n):void 0)}Y(p){const n=this.getExtensionElement(p);if(n){const s=this.j.get(n);if(s)return this.nb(n),(0,k.asPromise)(()=>this.f.getTreeItem(n)).then(r=>{if(r){const c=this.eb(n,r,s.parent);return this.lb(n,c,s,s.parent),s.dispose(),c}return null})}return Promise.resolve(null)}Z(p,n,s){const r=this.eb(p,n,s);if(n.id&&this.i.has(r.item.handle))throw new Error((0,o.localize)(0,null,n.id));return this.kb(p,r),this.mb(r,s),r}ab(p){return O.MarkdownString.isMarkdownString(p)?C.MarkdownString.from(p):p}bb(p,n){return n?{...this.F.toInternal(n,p),originalId:n.command}:void 0}cb(p){if(!p.checkboxState)return;let n,s;return typeof p.checkboxState=="number"?n=p.checkboxState:(n=p.checkboxState.state,s=p.checkboxState.tooltip),{isChecked:n===O.TreeItemCheckboxState.Checked,tooltip:s}}db(p){if(!O.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,n,s){this.db(n);const r=new P.DisposableStore,c=this.gb(p,n,s),l=this.hb(n);return{item:{handle:c,parentHandle:s?s.item.handle:void 0,label:u(n.label,this.H),description:n.description,resourceUri:n.resourceUri,tooltip:this.ab(n.tooltip),command:this.bb(r,n.command),contextValue:n.contextValue,icon:l,iconDark:this.ib(n)||l,themeIcon:this.fb(n),collapsibleState:(0,T.isUndefinedOrNull)(n.collapsibleState)?O.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.cb(n)},extensionItem:n,parent:s,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(p){return p.iconPath instanceof O.ThemeIcon?p.iconPath:void 0}gb(p,{id:n,label:s,resourceUri:r},c,l){if(n)return`${b.b}/${n}`;const m=u(s,this.H),i=c?c.item.handle:b.a;let t=m?m.label:r?(0,a.basename)(r):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const d=this.j.has(p)?this.j.get(p).item.handle:void 0,E=this.Q(c)||[];let w,L=0;do{if(w=`${i}/${L}:${t}`,l||!this.i.has(w)||d===w)break;L++}while(L<=E.length);return w}hb(p){if(p.iconPath&&!(p.iconPath instanceof O.ThemeIcon))return typeof p.iconPath=="string"||R.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof O.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return R.URI.isUri(p)?p:R.URI.file(p)}kb(p,n){this.i.set(n.item.handle,p),this.j.set(p,n)}lb(p,n,s,r){this.i.delete(n.item.handle),this.j.delete(p),n.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.kb(p,n);const c=this.Q(r)||[],l=c.filter(m=>m.item.handle===s.item.handle)[0];l&&c.splice(c.indexOf(l),1,n)}mb(p,n){n?(n.children||(n.children=[]),n.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const n=this.j.get(p);if(n){if(n.children)for(const s of n.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}n.children=void 0}}else this.pb()}ob(p){const n=this.j.get(p);if(n){if(n.children)for(const s of n.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}this.j.delete(p),this.i.delete(n.item.handle),n.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}b.a="0",b.b="1"}),define(ye[310],De([1,0,21,12,3,37,2,121,107,153,164,44,5,96,252,251,40,253,35,255,256,257,240,258,59,42,259,260,263,264,265,142,243,271,272,273,99,41,275,309,14,7,73,278,80,141,34,232,262,72,139,82,84,85,13,56,20,25,266,239,55,77,249,276,79,78,281,279,280,250,48,274,277,98,60,76,267,81,268,16,125,242,221,261,6,26,226,97,217,269,270]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u,g,b,D,p,n,s,r,c,l,m,i,t,d,E,w,L,q,V,M,B,N,U,$,z,ae,ee,x,J,ie,pe,Q,Y,Z,me,ve,Ie,Re,oe,le,ue,te,ce,se,F,H,K,_,de,we,Pe,be,Ce,ke,He,Ge,nt,Qe,tt,rt,Be,it,W,X,he,Le,Ne,qe,je,Ze,st,at,mt,gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Et(lt){const pt=lt.get(ue.IExtHostInitDataService),xt=lt.get(ke.IExtHostFileSystemInfo),jt=lt.get(de.IExtHostConsumerFileSystem),kt=lt.get(c.IExtHostExtensionService),ft=lt.get(ie.IExtHostWorkspace),Tt=lt.get(tt.IExtHostTelemetry),Bt=lt.get(g.IExtHostConfiguration),At=lt.get(oe.IURITransformerService),Xe=lt.get(le.IExtHostRpcService),Nt=lt.get(M.IExtHostStorage),Gt=lt.get(_.IExtensionStoragePaths),Ft=lt.get(Re.ILoggerService),bt=lt.get(Re.ILogService),Ae=lt.get(se.IExtHostTunnelService),Oe=lt.get(F.IExtHostApiDeprecationService),Se=lt.get(J.IExtHostWindow),re=lt.get(nt.IExtHostSecretState),Fe=lt.get(Qe.IExtHostEditorTabs);Xe.set(v.ExtHostContext.ExtHostFileSystemInfo,xt),Xe.set(v.ExtHostContext.ExtHostLogLevelServiceShape,Ft),Xe.set(v.ExtHostContext.ExtHostWorkspace,ft),Xe.set(v.ExtHostContext.ExtHostConfiguration,Bt),Xe.set(v.ExtHostContext.ExtHostExtensionService,kt),Xe.set(v.ExtHostContext.ExtHostStorage,Nt),Xe.set(v.ExtHostContext.ExtHostTunnelService,Ae),Xe.set(v.ExtHostContext.ExtHostWindow,Se),Xe.set(v.ExtHostContext.ExtHostSecretState,re),Xe.set(v.ExtHostContext.ExtHostTelemetry,Tt),Xe.set(v.ExtHostContext.ExtHostEditorTabs,Fe);const We=Xe.set(v.ExtHostContext.ExtHostDecorations,lt.get(Z.IExtHostDecorations)),Ye=Xe.set(v.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(r.IExtHostDocumentsAndEditors)),Ve=Xe.set(v.ExtHostContext.ExtHostCommands,lt.get(h.IExtHostCommands)),et=Xe.set(v.ExtHostContext.ExtHostTerminalService,lt.get(B.IExtHostTerminalService)),ut=Xe.set(v.ExtHostContext.ExtHostDebugService,lt.get(ve.IExtHostDebugService)),Pt=Xe.set(v.ExtHostContext.ExtHostSearch,lt.get(Ie.IExtHostSearch)),St=Xe.set(v.ExtHostContext.ExtHostTask,lt.get(me.IExtHostTask)),Dt=Xe.set(v.ExtHostContext.ExtHostOutputService,lt.get(E.IExtHostOutputService)),wt=Xe.set(v.ExtHostContext.ExtHostLocalization,lt.get(st.IExtHostLocalizationService)),Rt=Xe.set(v.ExtHostContext.ExtHostUrls,new ee.ExtHostUrls(Xe)),yt=Xe.set(v.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(Xe,Ye)),ri=Xe.set(v.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Xe,Ye,bt)),ei=Xe.set(v.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(bt,yt,Xe.getProxy(v.MainContext.MainThreadBulkEdits))),Ct=Xe.set(v.ExtHostContext.ExtHostNotebook,new te.ExtHostNotebookController(Xe,Ve,Ye,yt)),si=Xe.set(v.ExtHostContext.ExtHostNotebookDocuments,new Le.ExtHostNotebookDocuments(Ct)),oi=Xe.set(v.ExtHostContext.ExtHostNotebookEditors,new he.ExtHostNotebookEditors(bt,Ct)),Jt=Xe.set(v.ExtHostContext.ExtHostNotebookKernels,new rt.ExtHostNotebookKernels(Xe,pt,Ct,Ve,bt)),bi=Xe.set(v.ExtHostContext.ExtHostNotebookRenderers,new it.ExtHostNotebookRenderers(Xe,Ct)),Lt=Xe.set(v.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Xe,Ye)),zt=Xe.set(v.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(Xe.getProxy(v.MainContext.MainThreadTreeViews),Ve,bt)),vi=Xe.set(v.ExtHostContext.ExtHostEditorInsets,new pe.ExtHostEditorInsets(Xe.getProxy(v.MainContext.MainThreadEditorInsets),Lt,pt.remote)),ai=Xe.set(v.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Xe,bt,xt,Ye)),_t=Xe.set(v.ExtHostContext.ExtHostLanguages,new t.ExtHostLanguages(Xe,yt,Ve.converter,At)),dt=Xe.set(v.ExtHostContext.ExtHostLanguageFeatures,new i.ExtHostLanguageFeatures(Xe,At,yt,Ve,ai,bt,Oe,Tt)),Bi=Xe.set(v.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(Xe,dt)),Ut=Xe.set(v.ExtHostContext.ExtHostFileSystemEventService,new m.ExtHostFileSystemEventService(Xe,bt,Ye)),Xt=Xe.set(v.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(Xe,ft,Ve)),ci=Xe.set(v.ExtHostContext.ExtHostSCM,new q.ExtHostSCM(Xe,Ve,bt)),wi=Xe.set(v.ExtHostContext.ExtHostQuickDiff,new gt.ExtHostQuickDiff(Xe,At)),Ei=Xe.set(v.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(Xe,Ve,yt)),li=Xe.set(v.ExtHostContext.ExtHostProgress,new w.ExtHostProgress(Xe.getProxy(v.MainContext.MainThreadProgress))),Si=Xe.set(v.ExtHostContext.ExtHosLabelService,new Q.ExtHostLabelService(Xe)),ui=Xe.set(v.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Xe)),Zt=Xe.set(v.ExtHostContext.ExtHostAuthentication,new H.ExtHostAuthentication(Xe)),$i=Xe.set(v.ExtHostContext.ExtHostTimeline,new K.ExtHostTimeline(Xe,Ve)),ti=Xe.set(v.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(Xe,pt.remote,ft,bt,Oe)),ii=Xe.set(v.ExtHostContext.ExtHostWebviewPanels,new be.ExtHostWebviewPanels(Xe,ti,ft)),yi=Xe.set(v.ExtHostContext.ExtHostCustomEditors,new Pe.ExtHostCustomEditors(Xe,yt,Gt,ti,ii)),Di=Xe.set(v.ExtHostContext.ExtHostWebviewViews,new we.ExtHostWebviewViews(Xe,ti)),ni=Xe.set(v.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(Xe,Ve,Ye)),Ci=Xe.set(v.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(Xe)),Ii=Xe.set(v.ExtHostContext.ExtHostProfileContentHandlers,new mt.ExtHostProfileContentHandlers(Xe));Xe.set(v.ExtHostContext.ExtHostInteractive,new Ne.ExtHostInteractive(Xe,Ct,Ye,Ve,bt));const zi=Object.values(v.ExtHostContext);Xe.assertRegistered(zi);const Wi=new Ce.ExtHostBulkEdits(Xe,Ye),Hi=new f.ExtHostClipboard(Xe),ki=new d.ExtHostMessageService(Xe,bt),Ri=new D.ExtHostDialogs(Xe),Li=new V.ExtHostStatusBar(Xe,Ve.converter);return y.ExtHostApiCommands.register(Ve),function($e,Wt,Oi){const vt=function(){let ge=!$e.isUnderDevelopment;function Ee(){ge||(bt.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Me(ot){if(Array.isArray(ot))ot.forEach(Me);else if(typeof ot=="string")Ee();else{const It=ot;typeof It.scheme>"u"&&Ee(),typeof It.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return ot}}(),ji={getSession(ge,Ee,Me){return Zt.getSession($e,ge,Ee,Me)},async hasSession(ge,Ee){return(0,je.checkProposedApiEnabled)($e,"authSession"),!!await Zt.getSession($e,ge,Ee,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(ge,Ee,Me,ot){return Zt.registerAuthenticationProvider(ge,Ee,Me,ot)}},di={registerCommand(ge,Ee,Me){return Ve.registerCommand(!0,ge,Ee,Me,void 0,$e)},registerTextEditorCommand(ge,Ee,Me){return Ve.registerCommand(!0,ge,(...ot)=>{const It=Lt.getActiveTextEditor();if(!It){bt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return It.edit(Ot=>{Ee.apply(Me,[It,Ot,...ot])}).then(Ot=>{Ot||bt.warn("Edits from command "+ge+" were not applied.")},Ot=>{bt.warn("An error occurred while running command "+ge,Ot)})},void 0,void 0,$e)},registerDiffInformationCommand:(ge,Ee,Me)=>((0,je.checkProposedApiEnabled)($e,"diffCommand"),Ve.registerCommand(!0,ge,async(...ot)=>{const It=Ye.activeEditor(!0);if(!It){bt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Ot=await Lt.getDiffInformation(It.id);Ee.apply(Me,[Ot,...ot])},void 0,void 0,$e)),executeCommand(ge,...Ee){return Ve.executeCommand(ge,...Ee)},getCommands(ge=!1){return Ve.getCommands(ge)}},Ni={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return et.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.checkProposedApiEnabled)($e,"envShellEvent"),et.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)($e,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)($e,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,tt.isNewAppInstall)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge){return tt.ExtHostTelemetryLogger.validateSender(ge),Tt.instantiateLogger($e,ge)},openExternal(ge,Ee){return Se.openUri(ge,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===pt.environment.appUriScheme)return Rt.createAppUri(ge);try{return await Se.asExternalUri(ge,{allowTunneling:!!pt.remote.authority})}catch(Ee){if((0,X.matchesScheme)(ge,W.Schemas.http)||(0,X.matchesScheme)(ge,W.Schemas.https))return ge;throw Ee}},get remoteName(){return(0,Y.getRemoteName)(pt.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)($e,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return bt.onDidChangeLogLevel}};pt.environment.extensionTestsLocationURI||Object.freeze(Ni);const Vi={createTestController(ge,Ee,Me){return ni.createTestController($e,ge,Ee,Me)},createTestObserver(){return(0,je.checkProposedApiEnabled)($e,"testObserver"),ni.createTestObserver()},runTests(ge){return(0,je.checkProposedApiEnabled)($e,"testObserver"),ni.runTests(ge)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)($e,"testObserver"),ni.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)($e,"testObserver"),ni.results}},hi=pt.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,qi={getExtension(ge,Ee){(0,je.isProposedApiEnabled)($e,"extensionsAny")||(Ee=!1);const Me=Wt.mine.getExtensionDescription(ge);if(Me)return new c.Extension(kt,$e.identifier,Me,hi,!1);if(Ee){const ot=Wt.all.getExtensionDescription(ge);if(ot)return new c.Extension(kt,$e.identifier,ot,hi,!0)}},get all(){const ge=[];for(const Ee of Wt.mine.getAllExtensionDescriptions())ge.push(new c.Extension(kt,$e.identifier,Ee,hi,!1));return ge},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)($e,"extensionsAny");const ge=new je.ExtensionIdentifierSet(Wt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),Ee=[];for(const Me of Wt.all.getAllExtensionDescriptions()){const ot=!ge.has(Me.identifier);Ee.push(new c.Extension(kt,$e.identifier,Me,hi,ot))}return Ee},get onDidChange(){return(0,je.isProposedApiEnabled)($e,"extensionsAny")?a.Event.any(Wt.mine.onDidChange,Wt.all.onDidChange):Wt.mine.onDidChange}},Ti={createDiagnosticCollection(ge){return ai.createDiagnosticCollection($e.identifier,ge)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ge=>ai.getDiagnostics(ge),getLanguages(){return _t.getLanguages()},setTextDocumentLanguage(ge,Ee){return _t.changeLanguage(ge.uri,Ee)},match(ge,Ee){const Me=yt.getDocumentData(Ee.uri)?.notebook;return(0,O.score)($.LanguageSelector.from(ge),Ee.uri,Ee.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(ge,Ee,Me){return dt.registerCodeActionProvider($e,vt(ge),Ee,Me)},registerDocumentPasteEditProvider(ge,Ee,Me){return(0,je.checkProposedApiEnabled)($e,"documentPaste"),dt.registerDocumentPasteEditProvider($e,vt(ge),Ee,Me)},registerCodeLensProvider(ge,Ee){return dt.registerCodeLensProvider($e,vt(ge),Ee)},registerDefinitionProvider(ge,Ee){return dt.registerDefinitionProvider($e,vt(ge),Ee)},registerDeclarationProvider(ge,Ee){return dt.registerDeclarationProvider($e,vt(ge),Ee)},registerImplementationProvider(ge,Ee){return dt.registerImplementationProvider($e,vt(ge),Ee)},registerTypeDefinitionProvider(ge,Ee){return dt.registerTypeDefinitionProvider($e,vt(ge),Ee)},registerHoverProvider(ge,Ee){return dt.registerHoverProvider($e,vt(ge),Ee,$e.identifier)},registerEvaluatableExpressionProvider(ge,Ee){return dt.registerEvaluatableExpressionProvider($e,vt(ge),Ee,$e.identifier)},registerInlineValuesProvider(ge,Ee){return dt.registerInlineValuesProvider($e,vt(ge),Ee,$e.identifier)},registerDocumentHighlightProvider(ge,Ee){return dt.registerDocumentHighlightProvider($e,vt(ge),Ee)},registerLinkedEditingRangeProvider(ge,Ee){return dt.registerLinkedEditingRangeProvider($e,vt(ge),Ee)},registerReferenceProvider(ge,Ee){return dt.registerReferenceProvider($e,vt(ge),Ee)},registerRenameProvider(ge,Ee){return dt.registerRenameProvider($e,vt(ge),Ee)},registerDocumentSymbolProvider(ge,Ee,Me){return dt.registerDocumentSymbolProvider($e,vt(ge),Ee,Me)},registerWorkspaceSymbolProvider(ge){return dt.registerWorkspaceSymbolProvider($e,ge)},registerDocumentFormattingEditProvider(ge,Ee){return dt.registerDocumentFormattingEditProvider($e,vt(ge),Ee)},registerDocumentRangeFormattingEditProvider(ge,Ee){return dt.registerDocumentRangeFormattingEditProvider($e,vt(ge),Ee)},registerOnTypeFormattingEditProvider(ge,Ee,Me,...ot){return dt.registerOnTypeFormattingEditProvider($e,vt(ge),Ee,[Me].concat(ot))},registerDocumentSemanticTokensProvider(ge,Ee,Me){return dt.registerDocumentSemanticTokensProvider($e,vt(ge),Ee,Me)},registerDocumentRangeSemanticTokensProvider(ge,Ee,Me){return dt.registerDocumentRangeSemanticTokensProvider($e,vt(ge),Ee,Me)},registerSignatureHelpProvider(ge,Ee,Me,...ot){return typeof Me=="object"?dt.registerSignatureHelpProvider($e,vt(ge),Ee,Me):dt.registerSignatureHelpProvider($e,vt(ge),Ee,typeof Me>"u"?[]:[Me,...ot])},registerCompletionItemProvider(ge,Ee,...Me){return dt.registerCompletionItemProvider($e,vt(ge),Ee,Me)},registerInlineCompletionItemProvider(ge,Ee){return Ee.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,je.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider($e,vt(ge),Ee)},registerDocumentLinkProvider(ge,Ee){return dt.registerDocumentLinkProvider($e,vt(ge),Ee)},registerColorProvider(ge,Ee){return dt.registerColorProvider($e,vt(ge),Ee)},registerFoldingRangeProvider(ge,Ee){return dt.registerFoldingRangeProvider($e,vt(ge),Ee)},registerSelectionRangeProvider(ge,Ee){return dt.registerSelectionRangeProvider($e,ge,Ee)},registerCallHierarchyProvider(ge,Ee){return dt.registerCallHierarchyProvider($e,ge,Ee)},registerTypeHierarchyProvider(ge,Ee){return dt.registerTypeHierarchyProvider($e,ge,Ee)},setLanguageConfiguration:(ge,Ee)=>dt.setLanguageConfiguration($e,ge,Ee),getTokenInformationAtPosition(ge,Ee){return(0,je.checkProposedApiEnabled)($e,"tokenInformation"),_t.tokenAtPosition(ge,Ee)},registerInlayHintsProvider(ge,Ee){return dt.registerInlayHintsProvider($e,ge,Ee)},createLanguageStatusItem(ge,Ee){return _t.createLanguageStatusItem($e,ge,Ee)},registerDocumentDropEditProvider(ge,Ee){return dt.registerDocumentOnDropEditProvider($e,ge,Ee)}},xi={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return et.activeTerminal},get terminals(){return et.terminals},async showTextDocument(ge,Ee,Me){const ot=await(I.URI.isUri(ge)?Promise.resolve(Vt.openTextDocument(ge)):Promise.resolve(ge));return Lt.showTextDocument(ot,Ee,Me)},createTextEditorDecorationType(ge){return Lt.createTextEditorDecorationType($e,ge)},onDidChangeActiveTextEditor(ge,Ee,Me){return Lt.onDidChangeActiveTextEditor(ge,Ee,Me)},onDidChangeVisibleTextEditors(ge,Ee,Me){return Lt.onDidChangeVisibleTextEditors(ge,Ee,Me)},onDidChangeTextEditorSelection(ge,Ee,Me){return Lt.onDidChangeTextEditorSelection(ge,Ee,Me)},onDidChangeTextEditorOptions(ge,Ee,Me){return Lt.onDidChangeTextEditorOptions(ge,Ee,Me)},onDidChangeTextEditorVisibleRanges(ge,Ee,Me){return Lt.onDidChangeTextEditorVisibleRanges(ge,Ee,Me)},onDidChangeTextEditorViewColumn(ge,Ee,Me){return Lt.onDidChangeTextEditorViewColumn(ge,Ee,Me)},onDidCloseTerminal(ge,Ee,Me){return et.onDidCloseTerminal(ge,Ee,Me)},onDidOpenTerminal(ge,Ee,Me){return et.onDidOpenTerminal(ge,Ee,Me)},onDidChangeActiveTerminal(ge,Ee,Me){return et.onDidChangeActiveTerminal(ge,Ee,Me)},onDidChangeTerminalDimensions(ge,Ee,Me){return(0,je.checkProposedApiEnabled)($e,"terminalDimensions"),et.onDidChangeTerminalDimensions(ge,Ee,Me)},onDidChangeTerminalState(ge,Ee,Me){return et.onDidChangeTerminalState(ge,Ee,Me)},onDidWriteTerminalData(ge,Ee,Me){return(0,je.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),et.onDidWriteTerminalData(ge,Ee,Me)},get state(){return Se.state},onDidChangeWindowState(ge,Ee,Me){return Se.onDidChangeWindowState(ge,Ee,Me)},showInformationMessage(ge,...Ee){return ki.showMessage($e,R.default.Info,ge,Ee[0],Ee.slice(1))},showWarningMessage(ge,...Ee){return ki.showMessage($e,R.default.Warning,ge,Ee[0],Ee.slice(1))},showErrorMessage(ge,...Ee){return ki.showMessage($e,R.default.Error,ge,Ee[0],Ee.slice(1))},showQuickPick(ge,Ee,Me){return Xt.showQuickPick($e,ge,Ee,Me)},showWorkspaceFolderPick(ge){return Xt.showWorkspaceFolderPick(ge)},showInputBox(ge,Ee){return Xt.showInput(ge,Ee)},showOpenDialog(ge){return Ri.showOpenDialog($e,ge)},showSaveDialog(ge){return Ri.showSaveDialog(ge)},createStatusBarItem(ge,Ee,Me){let ot,It,Ot;return typeof ge=="string"?(ot=ge,It=Ee,Ot=Me):(It=ge,Ot=Ee),Li.createStatusBarEntry($e,ot,It,Ot)},setStatusBarMessage(ge,Ee){return Li.setStatusBarMessage(ge,Ee)},withScmProgress(ge){return Oe.report("window.withScmProgress",$e,"Use 'withProgress' instead."),li.withProgress($e,{location:z.ProgressLocation.SourceControl},(Ee,Me)=>ge({report(ot){}}))},withProgress(ge,Ee){return li.withProgress($e,ge,Ee)},createOutputChannel(ge,Ee){return Dt.createOutputChannel(ge,Ee,$e)},createWebviewPanel(ge,Ee,Me,ot){return ii.createWebviewPanel($e,ge,Ee,Me,ot)},createWebviewTextEditorInset(ge,Ee,Me,ot){return(0,je.checkProposedApiEnabled)($e,"editorInsets"),vi.createWebviewEditorInset(ge,Ee,Me,ot,$e)},createTerminal(ge,Ee,Me){return typeof ge=="object"?"pty"in ge?et.createExtensionTerminal(ge):et.createTerminalFromOptions(ge):et.createTerminal(ge,Ee,Me)},registerTerminalLinkProvider(ge){return et.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,Ee){return et.registerProfileProvider($e,ge,Ee)},registerTerminalQuickFixProvider(ge,Ee){return(0,je.checkProposedApiEnabled)($e,"terminalQuickFixProvider"),et.registerTerminalQuickFixProvider(ge,$e.identifier.value,Ee)},registerTreeDataProvider(ge,Ee){return zt.registerTreeDataProvider(ge,Ee,$e)},createTreeView(ge,Ee){return zt.createTreeView(ge,Ee,$e)},registerWebviewPanelSerializer:(ge,Ee)=>ii.registerWebviewPanelSerializer($e,ge,Ee),registerCustomEditorProvider:(ge,Ee,Me={})=>yi.registerCustomEditorProvider($e,ge,Ee,Me),registerFileDecorationProvider(ge){return We.registerFileDecorationProvider(ge,$e)},registerUriHandler(ge){return Rt.registerUriHandler($e.identifier,ge)},createQuickPick(){return Xt.createQuickPick($e)},createInputBox(){return Xt.createInputBox($e)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(ge,Ee,Me){return ui.onDidChangeActiveColorTheme(ge,Ee,Me)},registerWebviewViewProvider(ge,Ee,Me){return Di.registerWebviewViewProvider($e,ge,Ee,Me?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,Ee,Me){return Ct.onDidChangeActiveNotebookEditor(ge,Ee,Me)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Ct.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,Ee,Me){return oi.onDidChangeNotebookEditorSelection(ge,Ee,Me)},onDidChangeNotebookEditorVisibleRanges(ge,Ee,Me){return oi.onDidChangeNotebookEditorVisibleRanges(ge,Ee,Me)},showNotebookDocument(ge,Ee){return Ct.showNotebookDocument(ge,Ee)},registerExternalUriOpener(ge,Ee,Me){return(0,je.checkProposedApiEnabled)($e,"externalUriOpener"),Ci.registerExternalUriOpener($e.identifier,ge,Ee,Me)},registerProfileContentHandler(ge,Ee){return(0,je.checkProposedApiEnabled)($e,"profileContentHandlers"),Ii.registrProfileContentHandler($e,ge,Ee)},registerQuickDiffProvider(ge,Ee,Me,ot){return(0,je.checkProposedApiEnabled)($e,"quickDiffProvider"),wi.registerQuickDiffProvider(vt(ge),Ee,Me,ot)},get tabGroups(){return Fe.tabGroups}},Vt={get rootPath(){return Oe.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ge){throw A.readonly()},getWorkspaceFolder(ge){return ft.getWorkspaceFolder(ge)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ge){throw A.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ge){throw A.readonly()},updateWorkspaceFolders:(ge,Ee,...Me)=>ft.updateWorkspaceFolders($e,ge,Ee||0,...Me),onDidChangeWorkspaceFolders:function(ge,Ee,Me){return ft.onDidChangeWorkspace(ge,Ee,Me)},asRelativePath:(ge,Ee)=>ft.getRelativePath(ge,Ee),findFiles:(ge,Ee,Me,ot)=>ft.findFiles(ge,Ee,Me,$e.identifier,ot),findTextInFiles:(ge,Ee,Me,ot)=>{(0,je.checkProposedApiEnabled)($e,"findTextInFiles");let It,Ot;return typeof Ee=="object"?(It=Ee,Ot=Me):(It={},Ot=Ee,ot=Me),ft.findTextInFiles(ge,It||{},Ot,$e.identifier,ot)},saveAll:ge=>ft.saveAll(ge),applyEdit(ge,Ee){return Wi.applyWorkspaceEdit(ge,$e,Ee)},createFileSystemWatcher:(ge,Ee,Me,ot)=>Ut.createFileSystemWatcher(ft,$e,ge,Ee,Me,ot),get textDocuments(){return yt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw A.readonly()},openTextDocument(ge){let Ee;const Me=ge;if(typeof ge=="string")Ee=Promise.resolve(I.URI.file(ge));else if(I.URI.isUri(ge))Ee=Promise.resolve(ge);else if(!Me||typeof Me=="object")Ee=yt.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ot=>yt.ensureDocumentData(ot).then(It=>It.document))},onDidOpenTextDocument:(ge,Ee,Me)=>yt.onDidAddDocument(ge,Ee,Me),onDidCloseTextDocument:(ge,Ee,Me)=>yt.onDidRemoveDocument(ge,Ee,Me),onDidChangeTextDocument:(ge,Ee,Me)=>yt.onDidChangeDocument(ge,Ee,Me),onDidSaveTextDocument:(ge,Ee,Me)=>yt.onDidSaveDocument(ge,Ee,Me),onWillSaveTextDocument:(ge,Ee,Me)=>ei.getOnWillSaveTextDocumentEvent($e)(ge,Ee,Me),get notebookDocuments(){return Ct.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,Ee){let Me;if(I.URI.isUri(ge))Me=ge,await Ct.openNotebookDocument(ge);else if(typeof ge=="string")Me=I.URI.revive(await Ct.createNotebookDocument({viewType:ge,content:Ee}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(ge,Ee,Me){return si.onDidSaveNotebookDocument(ge,Ee,Me)},onDidChangeNotebookDocument(ge,Ee,Me){return si.onDidChangeNotebookDocument(ge,Ee,Me)},get onDidOpenNotebookDocument(){return Ct.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Ct.onDidCloseNotebookDocument},registerNotebookSerializer(ge,Ee,Me,ot){return Ct.registerNotebookSerializer($e,ge,Ee,Me,(0,je.isProposedApiEnabled)($e,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ge,Ee,Me)=>Oi.onDidChangeConfiguration(ge,Ee,Me),getConfiguration(ge,Ee){return Ee=arguments.length===1?void 0:Ee,Oi.getConfiguration(ge,Ee,$e)},registerTextDocumentContentProvider(ge,Ee){return ri.registerTextDocumentContentProvider(ge,Ee)},registerTaskProvider:(ge,Ee)=>(Oe.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider($e,ge,Ee)),registerFileSystemProvider(ge,Ee,Me){return(0,qe.combinedDisposable)(Bi.registerFileSystemProvider($e,ge,Ee,Me),jt.addFileSystemProvider(ge,Ee))},get fs(){return jt.value},registerFileSearchProvider:(ge,Ee)=>((0,je.checkProposedApiEnabled)($e,"fileSearchProvider"),Pt.registerFileSearchProvider(ge,Ee)),registerTextSearchProvider:(ge,Ee)=>((0,je.checkProposedApiEnabled)($e,"textSearchProvider"),Pt.registerTextSearchProvider(ge,Ee)),registerRemoteAuthorityResolver:(ge,Ee)=>((0,je.checkProposedApiEnabled)($e,"resolvers"),kt.registerRemoteAuthorityResolver(ge,Ee)),registerResourceLabelFormatter:ge=>((0,je.checkProposedApiEnabled)($e,"resolvers"),Si.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,Ee,Me)=>Ut.onDidCreateFile(ge,Ee,Me),onDidDeleteFiles:(ge,Ee,Me)=>Ut.onDidDeleteFile(ge,Ee,Me),onDidRenameFiles:(ge,Ee,Me)=>Ut.onDidRenameFile(ge,Ee,Me),onWillCreateFiles:(ge,Ee,Me)=>Ut.getOnWillCreateFileEvent($e)(ge,Ee,Me),onWillDeleteFiles:(ge,Ee,Me)=>Ut.getOnWillDeleteFileEvent($e)(ge,Ee,Me),onWillRenameFiles:(ge,Ee,Me)=>Ut.getOnWillRenameFileEvent($e)(ge,Ee,Me),openTunnel:ge=>((0,je.checkProposedApiEnabled)($e,"tunnels"),Ae.openTunnel($e,ge).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,je.checkProposedApiEnabled)($e,"tunnels"),Ae.getTunnels()},onDidChangeTunnels:(ge,Ee,Me)=>((0,je.checkProposedApiEnabled)($e,"tunnels"),Ae.onDidChangeTunnels(ge,Ee,Me)),registerPortAttributesProvider:(ge,Ee)=>((0,je.checkProposedApiEnabled)($e,"portsAttributes"),Ae.registerPortsAttributesProvider(ge,Ee)),registerTimelineProvider:(ge,Ee)=>((0,je.checkProposedApiEnabled)($e,"timeline"),$i.registerTimelineProvider(ge,Ee,$e.identifier,Ve.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ge=>((0,je.checkProposedApiEnabled)($e,"workspaceTrust"),ft.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,Ee,Me)=>ft.onDidGrantWorkspaceTrust(ge,Ee,Me),registerEditSessionIdentityProvider:(ge,Ee)=>((0,je.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ge,Ee)),onWillCreateEditSessionIdentity:(ge,Ee,Me)=>((0,je.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent($e)(ge,Ee,Me))},fi={get inputBox(){return Oe.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox($e)},createSourceControl(ge,Ee,Me){return ci.createSourceControl($e,ge,Ee,Me)}},Gi={createCommentController(ge,Ee){return Ei.createCommentController($e,ge,Ee)}},$t={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(ge,Ee,Me){return ut.onDidStartDebugSession(ge,Ee,Me)},onDidTerminateDebugSession(ge,Ee,Me){return ut.onDidTerminateDebugSession(ge,Ee,Me)},onDidChangeActiveDebugSession(ge,Ee,Me){return ut.onDidChangeActiveDebugSession(ge,Ee,Me)},onDidReceiveDebugSessionCustomEvent(ge,Ee,Me){return ut.onDidReceiveDebugSessionCustomEvent(ge,Ee,Me)},onDidChangeBreakpoints(ge,Ee,Me){return ut.onDidChangeBreakpoints(ge,Ee,Me)},registerDebugConfigurationProvider(ge,Ee,Me){return ut.registerDebugConfigurationProvider(ge,Ee,Me||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,Ee){return ut.registerDebugAdapterDescriptorFactory($e,ge,Ee)},registerDebugAdapterTrackerFactory(ge,Ee){return ut.registerDebugAdapterTrackerFactory(ge,Ee)},startDebugging(ge,Ee,Me){return!Me||typeof Me=="object"&&"configuration"in Me?ut.startDebugging(ge,Ee,{parentSession:Me}):ut.startDebugging(ge,Ee,Me||{})},stopDebugging(ge){return ut.stopDebugging(ge)},addBreakpoints(ge){return ut.addBreakpoints(ge)},removeBreakpoints(ge){return ut.removeBreakpoints(ge)},asDebugSourceUri(ge,Ee){return ut.asDebugSourceUri(ge,Ee)}},mi={registerTaskProvider:(ge,Ee)=>St.registerTaskProvider($e,ge,Ee),fetchTasks:ge=>St.fetchTasks(ge),executeTask:ge=>St.executeTask($e,ge),get taskExecutions(){return St.taskExecutions},onDidStartTask:(ge,Ee,Me)=>St.onDidStartTask(ge,Ee,Me),onDidEndTask:(ge,Ee,Me)=>St.onDidEndTask(ge,Ee,Me),onDidStartTaskProcess:(ge,Ee,Me)=>St.onDidStartTaskProcess(ge,Ee,Me),onDidEndTaskProcess:(ge,Ee,Me)=>St.onDidEndTaskProcess(ge,Ee,Me)},Ki={createNotebookController(ge,Ee,Me,ot,It){return Jt.createNotebookController($e,ge,Ee,Me,ot,(0,je.isProposedApiEnabled)($e,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(ge,Ee)=>Ct.registerNotebookCellStatusBarItemProvider($e,ge,Ee),createRendererMessaging(ge){return bi.createRendererMessaging($e,ge)},createNotebookControllerDetectionTask(ge){return(0,je.checkProposedApiEnabled)($e,"notebookKernelSource"),Jt.createNotebookControllerDetectionTask($e,ge)},registerKernelSourceActionProvider(ge,Ee){return(0,je.checkProposedApiEnabled)($e,"notebookKernelSource"),Jt.registerKernelSourceActionProvider($e,ge,Ee)},onDidChangeNotebookCellExecutionState(ge,Ee,Me){return(0,je.checkProposedApiEnabled)($e,"notebookCellExecutionState"),Jt.onDidChangeNotebookCellExecutionState(ge,Ee,Me)}},Xi={t(...ge){if(typeof ge[0]=="string"){const Ee=ge.shift(),Me=!ge||typeof ge[0]!="object"?ge:ge[0];return wt.getMessage($e.identifier.value,{message:Ee,args:Me})}return wt.getMessage($e.identifier.value,ge[0])},get bundle(){return wt.getBundle($e.identifier.value)},get uri(){return wt.getBundleUri($e.identifier.value)}};return{version:pt.version,authentication:ji,commands:di,comments:Gi,debug:$t,env:Ni,extensions:qi,l10n:Xi,languages:Ti,notebooks:Ki,scm:fi,tasks:mi,tests:Vi,window:xi,workspace:Vt,Breakpoint:z.Breakpoint,TerminalOutputAnchor:z.TerminalOutputAnchor,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:o.CancellationTokenSource,CandidatePortSource:v.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentThreadState:z.CommentThreadState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,EventEmitter:a.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileDecoration2:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:T.FileType,FilePermission:T.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionList:z.InlineSuggestionList,Hover:z.Hover,IndentAction:k.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalQuickFixCommand:z.TerminalQuickFixCommand,TerminalQuickFixOpener:z.TerminalQuickFixOpener,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TerminalExitReason:z.TerminalExitReason,TerminalQuickFixType:z.TerminalQuickFixType,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,SnippetTextEdit:z.SnippetTextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItem2:z.TreeItem,TreeItemCheckboxState:z.TreeItemCheckboxState,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:C.UIKind,Uri:I.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,DocumentDropEdit:z.DocumentDropEdit,DocumentPasteEdit:z.DocumentPasteEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,NotebookControllerAffinity2:z.NotebookControllerAffinity2,NotebookEdit:z.NotebookEdit,NotebookKernelSourceAction:z.NotebookKernelSourceAction,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestRunRequest2:z.TestRunRequest2,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:Be.TextSearchCompleteMessageType,DataTransfer:z.DataTransfer,DataTransferItem:z.DataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind,InputBoxValidationSeverity:z.InputBoxValidationSeverity,TabInputText:z.TextTabInput,TabInputTextDiff:z.TextDiffTabInput,TabInputTextMerge:z.TextMergeTabInput,TabInputCustom:z.CustomEditorTabInput,TabInputNotebook:z.NotebookEditorTabInput,TabInputNotebookDiff:z.NotebookDiffEditorTabInput,TabInputWebview:z.WebviewEditorTabInput,TabInputTerminal:z.TerminalEditorTabInput,TabInputInteractiveWindow:z.InteractiveWindowInput,TelemetryTrustedValue:ae.TelemetryTrustedValue,LogLevel:Re.LogLevel,EditSessionIdentityMatch:at.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Et}),define(ye[311],De([1,0,283,320,321,2,322]),function(ne,e,o,A,a,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(T,v,C,y,f,h){const u=h.environment.useHostProxy,g=typeof u=="boolean"?u:!h.remote.isRemote,b=(0,I.createProxyResolver)({resolveProxy:p=>T.resolveProxy(p),getHttpProxySetting:()=>v.getConfiguration("http").get("proxy"),log:(p,n,...s)=>{switch(p){case I.LogLevel.Trace:y.trace(n,...s);break;case I.LogLevel.Debug:y.debug(n,...s);break;case I.LogLevel.Info:y.info(n,...s);break;case I.LogLevel.Warning:y.warn(n,...s);break;case I.LogLevel.Error:y.error(n,...s);break;case I.LogLevel.Critical:y.error(n,...s);break;case I.LogLevel.Off:break;default:r(p,n,s);break}function r(c,l,...m){y.error("Unknown log level",c),y.error(l,...m)}},getLogLevel:()=>y.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:g,env:process.env}),D=S(v,b);return O(C,D)}e.connectProxyResolver=P;function S(T,v){const C={config:T.getConfiguration("http").get("proxySupport")||"off"};T.onDidChangeConfiguration(f=>{C.config=T.getConfiguration("http").get("proxySupport")||"off"});const y={config:!!T.getConfiguration("http").get("systemCertificates")};return T.onDidChangeConfiguration(f=>{y.config=!!T.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},o,(0,I.createHttpPatch)(o,v,{config:"off"},y,!0)),on:Object.assign({},o,(0,I.createHttpPatch)(o,v,{config:"on"},y,!0)),override:Object.assign({},o,(0,I.createHttpPatch)(o,v,{config:"override"},y,!0)),onRequest:Object.assign({},o,(0,I.createHttpPatch)(o,v,C,y,!0)),default:Object.assign(o,(0,I.createHttpPatch)(o,v,C,y,!1))},https:{off:Object.assign({},A,(0,I.createHttpPatch)(A,v,{config:"off"},y,!0)),on:Object.assign({},A,(0,I.createHttpPatch)(A,v,{config:"on"},y,!0)),override:Object.assign({},A,(0,I.createHttpPatch)(A,v,{config:"override"},y,!0)),onRequest:Object.assign({},A,(0,I.createHttpPatch)(A,v,C,y,!0)),default:Object.assign(A,(0,I.createHttpPatch)(A,v,C,y,!1))},tls:Object.assign(a,(0,I.createTlsPatch)(a))}}const k=new Map;function O(T,v){return T.getExtensionPathIndex().then(C=>{const y=globalThis._VSCODE_NODE_MODULES.module,f=y._load;y._load=function(u,g,b){if(u==="tls")return v.tls;if(u!=="http"&&u!=="https")return f.apply(this,arguments);const D=v[u],p=C.findSubstr(R.URI.file(g.filename));let n=k.get(p);if(n||k.set(p,n={}),!n[u]){const s=D.default;n[u]={...s}}return n[u]}})}}),define(ye[312],De([1,0,83,310,297,311,42,285,2,16,7,282,115,284]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class y extends a.RequireInterceptor{j(){const u=this,g=globalThis._VSCODE_NODE_MODULES.module,b=g._load;g._load=function(s,r,c){return s=p(s),u.a.has(s)?u.a.get(s).load(s,S.URI.file((0,v.realpathSync)(r.filename)),l=>b.apply(this,[l,r,c])):b.apply(this,arguments)};const D=g._resolveLookupPaths;g._resolveLookupPaths=(n,s)=>D.call(this,p(n),s);const p=n=>{for(const s of u.b){const r=s(n);if(r){n=r;break}}return n}}}class f extends I.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=O.ExtensionRuntime.Node}async ob(){this.h.createInstance(C.ExtHostConsoleForwarder);const u=this.h.invokeFunction(A.createApiFactoryAndRegisterActors);if(this.h.createInstance(P.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const D=this.h.createInstance(T.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=D.ipcHandlePath}await this.h.createInstance(y,u,{mine:this.D,all:this.F}).install(),o.mark("code/extHost/didInitAPI");const b=await this.k.getConfigProvider();await(0,R.connectProxyResolver)(this.j,b,this,this.l,this.u,this.f),o.mark("code/extHost/didInitProxyResolver")}pb(u){return u.main}async qb(u,g,b){if(g.scheme!==k.Schemas.file)throw new Error(`Cannot load URI: '${g}', must be of file-scheme`);let D=null;b.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${g.toString(!0)}`),this.l.flush();const p=u?.identifier.value;u&&await this.s.initializeLocalizedMessages(u);try{p&&o.mark(`code/extHost/willLoadExtensionCode/${p}`),D=ne.__$__nodeRequire(g.fsPath)}finally{p&&o.mark(`code/extHost/didLoadExtensionCode/${p}`),b.codeLoadingStop()}return D}async $setRemoteEnvironment(u){if(!!this.f.remote.isRemote)for(const g in u){const b=u[g];b===null?delete process.env[g]:process.env[g]=b}}}e.ExtHostExtensionService=f}),define(ye[145],De([1,0,46,323,306,15,61,38,11,8,2,31,81,324,304,100]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const h=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class u{constructor(w){this.a=w}provideTextSearchResults(w,L,q,V){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...L,folder:L.folder.toString()})}`),new Promise((M,B)=>{V.onCancellationRequested(()=>J());const N=s(w,L),U=L.folder.fsPath,$=N.map(Z=>Z.match(/^-/)?Z:`'${Z}'`).join(" ");this.a.appendLine(`${h} ${$}
 - cwd: ${U}`);let z=o.spawn(h,N,{cwd:U});z.on("error",Z=>{console.error(Z),this.a.appendLine("Error: "+(Z&&Z.message)),B((0,T.serializeSearchError)(new T.SearchError(Z&&Z.message,T.SearchErrorCode.rgProcessError)))});let ae=!1;const ee=new D(L.maxResults,U,L.previewOptions);ee.on("result",Z=>{ae=!0,pe="",q.report(Z)});let x=!1;const J=()=>{x=!0,z?.kill(),ee?.cancel()};let ie=!1;ee.on("hitLimit",()=>{ie=!0,J()});let pe="";z.stdout.on("data",Z=>{ee.handleData(Z),ae||(pe+=Z)});let Q=!1;z.stdout.once("data",()=>Q=!0);let Y="";z.stderr.on("data",Z=>{const me=Z.toString();this.a.appendLine(me),Y.length+me.length<1e6&&(Y+=me)}),z.on("close",()=>{if(this.a.appendLine(Q?"Got data from stdout":"No data from stdout"),this.a.appendLine(ae?"Got result from parser":"No result from parser"),pe&&this.a.appendLine(`Got data without result: ${pe}`),this.a.appendLine(""),x)M({limitHit:ie});else{ee.flush(),z=null;let Z;Y&&!Q&&(Z=g(Y))?B((0,T.serializeSearchError)(new T.SearchError(Z.message,Z.code))):M({limitHit:ie})}})})}}e.RipgrepTextSearchEngine=u;function g(E){const w=E.split(`
`),L=w[0].trim();if(w.some(V=>V.startsWith("regex parse error")))return new T.SearchError(b(w),T.SearchErrorCode.regexParseError);const q=L.match(/grep config error: unknown encoding: (.*)/);if(q)return new T.SearchError(`Unknown encoding: ${q[1]}`,T.SearchErrorCode.unknownEncoding);if(L.startsWith("error parsing glob"))return new T.SearchError(L.charAt(0).toUpperCase()+L.substr(1),T.SearchErrorCode.globParseError);if(L.startsWith("the literal"))return new T.SearchError(L.charAt(0).toUpperCase()+L.substr(1),T.SearchErrorCode.invalidLiteral);if(L.startsWith("PCRE2: error compiling pattern"))return new T.SearchError(L,T.SearchErrorCode.regexParseError)}function b(E){const w=["Regex parse error"],L=E.filter(q=>q.startsWith("PCRE2:"));if(L.length>=1){const q=L[0].replace("PCRE2:","");if(q.indexOf(":")!==-1&&q.split(":").length>=2){const V=q.split(":")[1];w.push(":"+V)}}return w.join("")}class D extends A.EventEmitter{constructor(w,L,q){super(),this.g=w,this.h=L,this.j=q,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new a.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,L){return super.on(w,L),this}handleData(w){if(this.b)return;const L=typeof w=="string"?w:this.d.write(w);this.k(L)}k(w){let L=w.indexOf(`
`);const q=this.a+w;if(L>=0)L+=this.a.length;else{this.a=q;return}let V=0;for(;L>=0;)this.m(q.substring(V,L).trim()),V=L+1,L=q.indexOf(`
`,V);this.a=q.substring(V)}m(w){if(this.b||!w)return;let L;try{L=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(L.type==="match"){const q=p(L.data.path),V=O.URI.file(S.join(this.h,q)),M=this.n(L.data,V);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(L.type==="context"){const q=p(L.data.path),V=O.URI.file(S.join(this.h,q));this.o(L.data,V).forEach(B=>this.p(B))}}n(w,L){const q=w.line_number-1,V=p(w.lines),M=Buffer.from(V);let B=0,N=0,U=q;w.submatches.length===0&&w.submatches.push(V.length?{start:0,end:1,match:{text:V[0]}}:{start:0,end:0,match:{text:""}});const $=(0,R.coalesce)(w.submatches.map((z,ae)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ee=p(z.match),x=M.slice(B,z.start).toString(),J=n(x),ie=J.numLines>0?J.lastLineLength:J.lastLineLength+N,pe=n(ee),Q=J.numLines+U,Y=pe.numLines+Q,Z=pe.numLines>0?pe.lastLineLength:pe.lastLineLength+ie;return B=z.end,N=Z,U=Y,new v.Range(Q,ie,Y,Z)}));return(0,f.createTextSearchResult)(L,V,$,this.j)}o(w,L){const q=p(w.lines),V=w.line_number;return q.replace(/\r?\n$/,"").split(`
`).map((M,B)=>({text:M,uri:L,lineNumber:V+B}))}p(w){this.emit("result",w)}}e.RipgrepParser=D;function p(E){return E.bytes?Buffer.from(E.bytes,"base64").toString():E.text}function n(E){const w=/\n/g;let L=0,q=-1,V;for(;V=w.exec(E);)L++,q=V.index;const M=q>=0?E.length-q-1:E.length;return{numLines:L,lastLineLength:M}}function s(E,w){const L=["--hidden"];L.push(E.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:q,otherIncludes:V}=(0,I.groupBy)(w.includes,B=>B.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(V&&V.length){const B=new Set;V.forEach(N=>{B.add(N)}),L.push("-g","!*"),B.forEach(N=>{r(N).map(f.anchorGlob).forEach(U=>{L.push("-g",U)})})}q&&q.length&&q.forEach(B=>{L.push("-g",B)}),w.excludes.map(f.anchorGlob).forEach(B=>L.push("-g",`!${B}`)),w.maxFileSize&&L.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?w.useParentIgnoreFiles||L.push("--no-ignore-parent"):L.push("--no-ignore"),w.followSymlinks&&L.push("--follow"),w.encoding&&w.encoding!=="utf8"&&L.push("--encoding",w.encoding),E.pattern==="--"&&(E.isRegExp=!0,E.pattern="\\-\\-"),E.isMultiline&&!E.isRegExp&&(E.pattern=(0,k.escapeRegExpCharacters)(E.pattern),E.isRegExp=!0),w.usePCRE2&&L.push("--pcre2"),L.push("--crlf"),E.isRegExp&&(E.pattern=c(E.pattern),L.push("--engine","auto"));let M;if(E.isWordMatch){const N=(0,k.createRegExp)(E.pattern,!!E.isRegExp,{wholeWord:E.isWordMatch}).source.replace(/\\\//g,"/");L.push("--regexp",N)}else if(E.isRegExp){let B=m(E.pattern);B=i(B),L.push("--regexp",B)}else M=E.pattern,L.push("--fixed-strings");return L.push("--no-config"),w.useGlobalIgnoreFiles||L.push("--no-ignore-global"),L.push("--json"),E.isMultiline&&L.push("--multiline"),w.beforeContext&&L.push("--before-context",w.beforeContext+""),w.afterContext&&L.push("--after-context",w.afterContext+""),L.push("--"),M&&L.push(M),L.push("."),L}e.getRgArgs=s;function r(E){return d(E).flatMap(L=>{const q=(0,P.splitGlobAware)(L,"/");return q.map((V,M)=>q.slice(0,M+1).join("/"))})}function c(E){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;E.match(w);)E=E.replace(w,"$1\\x{$2}");const L=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;E.match(L);)E=E.replace(L,"$1\\x{$2}");return E}e.unicodeEscapesToPCRE2=c;const l=E=>E.type==="Assertion"&&E.kind==="lookbehind";function m(E){let w;try{w=new C.RegExpParser().parsePattern(E)}catch{return E}let L="",q=0;const V=(N,U,$)=>{L+=E.slice(q,N)+$,q=U},M=[];return new C.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const U=M[0];if(!U)V(N.start,N.end,"\\r?\\n");else if(!M.some(l))if(U.type==="CharacterClass")if(U.negate){const $=E.slice(U.start+2,N.start)+E.slice(N.end,U.end-1);U.parent?.type==="Quantifier"?V(U.start,U.end,$?`[^${$}]`:"."):V(U.start,U.end,"(?!\\r?\\n"+($?`|[${$}]`:"")+")")}else{const $=E.slice(U.start+1,N.start)+E.slice(N.end,U.end-1);V(U.start,U.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else U.type==="Quantifier"&&V(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){M.unshift(N)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(N){M.unshift(N)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(N){M.unshift(N)},onCharacterClassLeave(){M.shift()},onAssertionEnter(N){l(N)&&M.push(N)},onAssertionLeave(N){M[0]===N&&M.shift()}}).visit(w),L+=E.slice(q),L}e.fixRegexNewline=m;function i(E){return E.replace(/\n/g,"\\r?\\n")}e.fixNewline=i;function t(E){let w=!1,L=!1,q="",V="";for(let M=0;M<E.length;M++){const B=E[M];switch(B){case"\\":L?(w?V+="\\"+B:q+="\\"+B,L=!1):L=!0;break;case"{":if(L)w?V+=B:q+=B,L=!1;else{if(w)return{strInBraces:q+"{"+V+"{"+E.substring(M+1)};w=!0}break;case"}":if(L)w?V+=B:q+=B,L=!1;else{if(w)return{fixedStart:q,strInBraces:V,fixedEnd:E.substring(M+1)};q+=B}break;default:w?V+=(L?"\\":"")+B:q+=(L?"\\":"")+B,L=!1;break}}return{strInBraces:q+(w?"{"+V:"")}}function d(E){const{fixedStart:w,strInBraces:L,fixedEnd:q}=t(E);if(w===void 0||q===void 0)return[L];let V=(0,P.splitGlobAware)(L,",");V.length||(V=[""]);const M=d(q);return V.flatMap(B=>{const N=w+B;return M.map(U=>N+U)})}e.performBraceExpansionForRipgrep=d}),define(ye[313],De([1,0,21,145,126,16]),function(ne,e,o,A,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class I{constructor(k){this.b=k,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(k,O,T,v){const C=new A.RipgrepTextSearchEngine(this.b);if(O.folder.scheme===R.Schemas.vscodeUserData){const y={...O,folder:O.folder.with({scheme:R.Schemas.file})},f=new a.Progress(h=>T.report({...h,uri:h.uri.with({scheme:O.folder.scheme})}));return this.c(v,h=>C.provideTextSearchResults(k,y,f,h))}else return this.c(v,y=>C.provideTextSearchResults(k,O,T,y))}async c(k,O){const T=P(k);this.a.add(T);const v=await O(T.token);return this.a.delete(T),v}d(){this.a.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=I;function P(S){const k=new o.CancellationTokenSource;return S.onCancellationRequested(()=>k.cancel()),k}}),define(ye[314],De([1,0,29,145,144]),function(ne,e,o,A,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(S){this.a=S}search(S,k,O){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const T={appendLine(C){O({message:C})}},v=new a.NativeTextSearchManager(this.a,new A.RipgrepTextSearchEngine(T),o);return new Promise((C,y)=>v.search(f=>{k(f.map(I))},S).then(f=>C({limitHit:f.limitHit,type:"success",stats:f.stats}),y))}}e.TextSearchEngineAdapter=R;function I(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((S,k)=>{if(k.ranges){const O=k;return S+(Array.isArray(O.ranges)?O.ranges.length:1)}else return S+1},0)}}}),define(ye[315],De([1,0,15,19,12,3,111,11,43,2,44,31,305,314]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class y{constructor(D="searchProcess"){this.d=D,this.b=Object.create(null)}fileSearch(D){let p;const n=u(D),s=new R.Emitter({onDidAddFirstListener:()=>{p=(0,A.createCancelablePromise)(r=>this.doFileSearchWithEngine(v.Engine,n,c=>s.fire(c),r)),p.then(r=>s.fire(r),r=>s.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return s.event}textSearch(D){let p;const n=u(D),s=new R.Emitter({onDidAddFirstListener:()=>{p=(0,A.createCancelablePromise)(r=>this.f(n,c=>s.fire(c),r)),p.then(r=>s.fire(r),r=>s.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return s.event}f(D,p,n){return D.maxFileSize=(0,O.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new C.TextSearchEngineAdapter(D).search(n,p,p)}doFileSearch(D,p,n){return this.doFileSearchWithEngine(v.Engine,D,p,n)}doFileSearchWithEngine(D,p,n,s,r=y.a){let c=0;const l=i=>{Array.isArray(i)?(c+=i.length,n(i.map(t=>this.g(t)))):i.relativePath?(c++,n(this.g(i))):n(i)};if(p.sortByScore){let i=this.k(p,l,s);if(!i){const t=p.maxResults?Object.assign({},p,{maxResults:null}):p,d=new D(t);i=this.h(d,p,n,l,s)}return new Promise((t,d)=>{i.then(([E,w])=>{const L=w.map(q=>this.g(q));this.n(L,n,r),t(E)},d)})}const m=new D(p);return this.q(m,l,r,s).then(i=>({limitHit:i.limitHit,type:"success",stats:{detailStats:i.stats,type:this.d,fromCache:!1,resultCount:c,sortingTime:void 0}}))}g(D){return{path:D.base?(0,P.join)(D.base,D.relativePath):D.relativePath}}h(D,p,n,s,r){const c=new R.Emitter;let l=(0,A.createCancelablePromise)(i=>{let t=[];const d=E=>{Array.isArray(E)?t=E:(s(E),c.fire(E))};return this.q(D,d,-1,i).then(E=>[E,t])}),m;if(p.cacheKey){m=this.j(p.cacheKey);const i={promise:l,event:c.event,resolved:!1};m.resultsToSearchCache[p.filePattern||""]=i,l.then(()=>{i.resolved=!0},t=>{delete m.resultsToSearchCache[p.filePattern||""]}),l=this.r(l)}return l.then(([i,t])=>{const d=m?m.scorerCache:Object.create(null),E=(typeof p.maxResults!="number"||p.maxResults>0)&&S.StopWatch.create(!1);return this.l(p,t,d,r).then(w=>{const L=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:i.stats,sortingTime:L,fromCache:!1,type:this.d,workspaceFolderCount:p.folderQueries.length,resultCount:w.length},messages:i.messages,limitHit:i.limitHit||typeof p.maxResults=="number"&&t.length>p.maxResults},w]})})}j(D){const p=this.b[D];return p||(this.b[D]=new f)}k(D,p,n){const s=D.cacheKey&&this.b[D.cacheKey];if(!s)return;const r=this.o(s,D.filePattern||"",p,n);if(r)return r.then(([c,l,m])=>{const i=S.StopWatch.create(!1);return this.l(D,l,s.scorerCache,n).then(t=>{const d=i.elapsed(),E={fromCache:!0,detailStats:m,type:this.d,resultCount:l.length,sortingTime:d};return[{type:"success",limitHit:c.limitHit||typeof D.maxResults=="number"&&l.length>D.maxResults,stats:E},t]})})}l(D,p,n,s){const r=(0,I.prepareQuery)(D.filePattern||""),c=(m,i)=>(0,I.compareItemsByFuzzyScore)(m,i,r,!0,h,n),l=typeof D.maxResults=="number"?D.maxResults:Number.MAX_VALUE;return o.topAsync(p,c,l,1e4,s)}n(D,p,n){if(n&&n>0)for(let s=0;s<D.length;s+=n)p(D.slice(s,s+n));else p(D)}o(D,p,n,s){const r=S.StopWatch.create(!1),c=p.indexOf(P.sep)>=0;let l;for(const d in D.resultsToSearchCache)if(p.startsWith(d)){if(c&&d.indexOf(P.sep)<0&&d!=="")continue;const E=D.resultsToSearchCache[d];l={promise:this.r(E.promise),event:E.event,resolved:E.resolved};break}if(!l)return null;const m=r.elapsed(),i=S.StopWatch.create(!1),t=l.event(n);return s&&s.onCancellationRequested(()=>{t.dispose()}),l.promise.then(([d,E])=>{if(s&&s.isCancellationRequested)throw(0,a.canceled)();const w=[],L=(0,I.prepareQuery)(p).normalizedLowercase;for(const q of E)!(0,T.isFilePatternMatch)(q,L)||w.push(q);return[d,w,{cacheWasResolved:l.resolved,cacheLookupTime:m,cacheFilterTime:i.elapsed(),cacheEntryCount:E.length}]})}q(D,p,n,s){return new Promise((r,c)=>{let l=[];s?.onCancellationRequested(()=>D.cancel()),D.search(m=>{m&&(n?(l.push(m),n>0&&l.length>=n&&(p(l),l=[])):p(m))},m=>{p(m)},(m,i)=>{l.length&&p(l),m?c(m):r(i)})})}clearCache(D){return delete this.b[D],Promise.resolve(void 0)}r(D){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(p,n){return D.then(p,n)}catch(p){return this.then(void 0,p)}finally(p){return D.finally(p)}}}}y.a=512,e.SearchService=y;class f{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const h=new class{getItemLabel(b){return(0,P.basename)(b.relativePath)}getItemDescription(b){return(0,P.dirname)(b.relativePath)}getItemPath(b){return b.relativePath}};function u(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(g),extraFileResources:b.extraFileResources&&b.extraFileResources.map(D=>k.URI.revive(D))}}function g(b){return{...b,folder:k.URI.revive(b.folder)}}}),define(ye[316],De([1,0,6,16,2,29,13,25,20,85,56,31,315,313,100,144]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let h=class extends k.ExtHostSearch{constructor(g,b,D,p){super(g,D,p),this.s=R,this.t=-1,this.v=null,this.w=!1;const n=new y.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(A.Schemas.vscodeUserData,new C.RipgrepSearchProvider(n)),b.remote.isRemote&&b.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const g=new y.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(A.Schemas.file,new C.RipgrepSearchProvider(g)),this.y(A.Schemas.file,new v.SearchService("fileSearchProvider"))}y(g,b){const D=this.d++;return this.v=b,this.t=D,this.c.$registerFileSearchProvider(D,this.o(g)),(0,o.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(D)})}$provideFileSearchResults(g,b,D,p){const n=(0,k.reviveQuery)(D);return g===this.t?this.z(g,b,n,p):super.$provideFileSearchResults(g,b,D,p)}z(g,b,D,p){const n=s=>{if((0,T.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this.c.$handleFileMatch(g,b,s.map(r=>a.URI.file(r.path)));return}s.message&&this.n.debug("ExtHostSearch",s.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(D,n,p)}$clearCache(g){return this.v?.clearCache(g),super.$clearCache(g)}q(g,b){return new f.NativeTextSearchManager(g,b,void 0,"textSearchProvider")}};h=xe([ze(0,S.IExtHostRpcService),ze(1,P.IExtHostInitDataService),ze(2,O.IURITransformerService),ze(3,I.ILogService)],h),e.NativeExtHostSearch=h}),define(ye[317],De([1,0,90,288,300,299,316,312,289,84,42,85,82,41,55,79,287,286,13,301,49]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u,g,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(O.IExtHostExtensionService,P.ExtHostExtensionService,0),(0,o.registerSingleton)(g.ILoggerService,u.ExtHostLoggerService,1),(0,o.registerSingleton)(f.IExtensionStoragePaths,h.ExtensionStoragePaths,0),(0,o.registerSingleton)(k.IExtHostDebugService,R.ExtHostDebugService,0),(0,o.registerSingleton)(T.IExtHostSearch,I.NativeExtHostSearch,0),(0,o.registerSingleton)(v.IExtHostTask,a.ExtHostTask,0),(0,o.registerSingleton)(C.IExtHostTerminalService,A.ExtHostTerminalService,0),(0,o.registerSingleton)(y.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,o.registerSingleton)(D.IExtHostVariableResolverProvider,b.NodeExtHostVariableResolverProviderService,0)}),define(ye[325],De([1,0,229,326,83,12,118,119,207,96,298,22,29,115,19,121,224,237,302,317]),function(ne,e,o,A,a,R,I,P,S,k,O,T,v,C,y,f,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let m=0;m<process.execArgv.length;m++)process.execArgv[m]==="--inspect-port=0"&&(process.execArgv.splice(m,1),m--)}();const g=A(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const l=globalThis._VSCODE_NODE_MODULES.module,m=l._load;l._load=function(i){if(i==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return m.apply(this,arguments)}})();const b=process.exit.bind(process);function D(l){process.exit=function(m){if(l)b(m);else{const i=new Error("An extension called process.exit() and this was prevented.");console.warn(i.stack)}},process.crash=function(){const m=new Error("An extension called process.crash() and this was prevented.");console.warn(m.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let p=function(l){b()};function n(){const l=(0,u.readExtHostConnection)(process.env);if(l.type===3)return new Promise((m,i)=>{const t=d=>{const E=d[0],w=new I.BufferedEmitter;E.on("message",L=>w.fire(T.VSBuffer.wrap(L.data))),E.on("close",()=>{p("renderer closed the MessagePort")}),E.start(),m({onMessage:w.event,send:L=>E.postMessage(L.buffer)})};process.parentPort.on("message",d=>t(d.ports))});if(l.type===2)return new Promise((m,i)=>{let t=null;const d=setTimeout(()=>{p("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=108e5,w=3e5,L=new y.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (1)"),E),q=new y.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (2)"),w);process.on("message",(M,B)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const N=T.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let U;if(M.skipWebSocketFrames)U=new P.NodeSocket(B,"extHost-socket");else{const $=T.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));U=new P.WebSocketNodeSocket(new P.NodeSocket(B,"extHost-socket"),M.permessageDeflate,$,!1)}t?(L.cancel(),q.cancel(),t.beginAcceptReconnection(U,N),t.endAcceptReconnection(),t.sendResume()):(clearTimeout(d),t=new I.PersistentProtocol({socket:U,initialChunk:N}),t.sendResume(),t.onDidDispose(()=>p("renderer disconnected")),m(t),t.onSocketClose(()=>{L.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(q.isScheduled())return;L.isScheduled()&&q.schedule()}});const V={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(V)});{const m=l.pipeName;return new Promise((i,t)=>{const d=o.createConnection(m,()=>{d.removeListener("error",t);const E=new I.PersistentProtocol({socket:new P.NodeSocket(d,"extHost-renderer")});E.sendResume(),i(E)});d.once("error",t),d.on("close",()=>{p("renderer closed the socket")})})}}async function s(){const l=await n();return new class{constructor(){this.a=new I.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,l.onMessage(m=>{(0,k.isMessageOfType)(m,2)?(this.b=!0,p("received terminate message from renderer")):this.a.fire(m)})}send(m){this.b||l.send(m)}async drain(){if(l.drain)return l.drain()}}}function r(l){return new Promise(m=>{const i=l.onMessage(t=>{i.dispose();const d=JSON.parse(t.toString()),E=d.commit,w=S.default.commit;if(E&&w&&E!==w&&b(55),d.parentPid){let L=0;setInterval(function(){try{process.kill(d.parentPid,0),L=0}catch(V){V&&V.code==="EPERM"?(L++,L>=3&&p(`parent process ${d.parentPid} does not exist anymore (3 x EPERM): ${V.message} (code: ${V.code}) (errno: ${V.errno})`)):p(`parent process ${d.parentPid} does not exist anymore: ${V.message} (code: ${V.code}) (errno: ${V.errno})`)}},1e3);let q;try{q=globalThis._VSCODE_NODE_MODULES["native-watchdog"],q.start(d.parentPid)}catch(V){(0,R.onUnexpectedError)(V)}}l.send((0,k.createMessageOfType)(0)),m({protocol:l,initData:d})});l.send((0,k.createMessageOfType)(1))})}async function c(){const l=[];process.on("unhandledRejection",(L,q)=>{l.push(q),setTimeout(()=>{const V=l.indexOf(q);V>=0&&q.catch(M=>{l.splice(V,1),(0,R.isCancellationError)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),L&&(0,R.onUnexpectedError)(L))})},1e3)}),process.on("rejectionHandled",L=>{const q=l.indexOf(L);q>=0&&l.splice(q,1)}),process.on("uncaughtException",function(L){(0,R.isSigPipeError)(L)||(0,R.onUnexpectedError)(L)}),a.mark("code/extHost/willConnectToRenderer");const m=await s();a.mark("code/extHost/didConnectToRenderer");const i=await r(m);a.mark("code/extHost/didWaitForInitData");const{initData:t}=i;D(!!t.environment.extensionTestsLocationURI),t.environment.useHostProxy=g.useHostProxy!==void 0?g.useHostProxy!=="false":void 0,t.environment.skipWorkspaceStorageLock=(0,f.boolean)(g.skipWorkspaceStorageLock,!1);const d=new class{constructor(){this.pid=process.pid}exit(q){b(q)}exists(q){return v.Promises.exists(q)}realpath(q){return(0,C.realpath)(q)}};let E=null;t.remote.authority&&g.transformURIs&&(E=(0,h.createURITransformer)(t.remote.authority));const w=new O.ExtensionHostMain(i.protocol,t,d,E);p=L=>w.terminate(L)}c().catch(l=>console.log(l))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/96a795cc0b1cd62f9ff66c347637f917c6dde3da/core/vs/workbench/api/node/extensionHostProcess.js.map
