/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Te=function(te){for(var e=[],n=0,k=te.length;n<k;n++)e[n]=ke[te[n]];return e};define(ke[63],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function n(y,R){const S=Object.create(null);for(const T of y){const N=R(T);let w=S[N];w||(w=S[N]=[]),w.push(T)}return S}e.groupBy=n;function k(y,R){const S=[],T=[];for(const N of y)R.has(N)||S.push(N);for(const N of R)y.has(N)||T.push(N);return{removed:S,added:T}}e.diffSets=k;function D(y,R){const S=[],T=[];for(const[N,w]of y)R.has(N)||S.push(w);for(const[N,w]of R)y.has(N)||T.push(w);return{removed:S,added:T}}e.diffMaps=D;class M{constructor(){this.a=new Map}add(R,S){let T=this.a.get(R);T||(T=new Set,this.a.set(R,T)),T.add(S)}delete(R,S){const T=this.a.get(R);!T||(T.delete(S),T.size===0&&this.a.delete(R))}forEach(R,S){const T=this.a.get(R);!T||T.forEach(S)}}e.SetMap=M}),define(ke[64],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function n(y){return(R,S,T)=>{let N=null,w=null;if(typeof T.value=="function"?(N="value",w=T.value):typeof T.get=="function"&&(N="get",w=T.get),!w)throw new Error("not supported");T[N]=y(w,S)}}function k(y,R,S){let T=null,N=null;if(typeof S.value=="function"?(T="value",N=S.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(T="get",N=S.get),!N)throw new Error("not supported");const w=`$memoize$${R}`;S[T]=function(...h){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,h)}),this[w]}}e.memoize=k;function D(y,R,S){return n((T,N)=>{const w=`$debounce$${N}`,h=`$debounce$result$${N}`;return function(...v){this[h]||(this[h]=S?S():void 0),clearTimeout(this[w]),R&&(this[h]=R(this[h],...v),v=[this[h]]),this[w]=setTimeout(()=>{T.apply(this,v),this[h]=S?S():void 0},y)}})}e.debounce=D;function M(y,R,S){return n((T,N)=>{const w=`$throttle$timer$${N}`,h=`$throttle$result$${N}`,v=`$throttle$lastRun$${N}`,m=`$throttle$pending$${N}`;return function(...a){if(this[h]||(this[h]=S?S():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),R&&(this[h]=R(this[h],...a)),this[m])return;const o=this[v]+y;o<=Date.now()?(this[v]=Date.now(),T.apply(this,[this[h]]),this[h]=S?S():void 0):(this[m]=!0,this[w]=setTimeout(()=>{this[m]=!1,this[v]=Date.now(),T.apply(this,[this[h]]),this[h]=S?S():void 0},o-Date.now()))}})}e.throttle=M}),define(ke[83],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(D){this.a=D,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(ke[111],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function y(t,d=!1){let r=0;const l=t.length;let c="",b=0,i=16,s=0;function f($){let O=0,F=0;for(;O<$;){const H=t.charCodeAt(r);if(H>=48&&H<=57)F=F*16+H-48;else if(H>=65&&H<=70)F=F*16+H-65+10;else if(H>=97&&H<=102)F=F*16+H-97+10;else break;r++,O++}return O<$&&(F=-1),F}function P($){r=$,c="",b=0,i=16,s=0}function C(){const $=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&T(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&T(t.charCodeAt(r)))for(r++;r<t.length&&T(t.charCodeAt(r));)r++;else return s=3,t.substring($,r);let O=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&T(t.charCodeAt(r))){for(r++;r<t.length&&T(t.charCodeAt(r));)r++;O=r}else s=3;return t.substring($,O)}function j(){let $="",O=r;for(;;){if(r>=l){$+=t.substring(O,r),s=2;break}const F=t.charCodeAt(r);if(F===34){$+=t.substring(O,r),r++;break}if(F===92){if($+=t.substring(O,r),r++,r>=l){s=2;break}switch(t.charCodeAt(r++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const V=f(4);V>=0?$+=String.fromCharCode(V):s=4;break}default:s=5}O=r;continue}if(F>=0&&F<=31)if(S(F)){$+=t.substring(O,r),s=2;break}else s=6;r++}return $}function _(){if(c="",s=0,b=r,r>=l)return b=l,i=17;let $=t.charCodeAt(r);if(R($)){do r++,c+=String.fromCharCode($),$=t.charCodeAt(r);while(R($));return i=15}if(S($))return r++,c+=String.fromCharCode($),$===13&&t.charCodeAt(r)===10&&(r++,c+=`
`),i=14;switch($){case 123:return r++,i=1;case 125:return r++,i=2;case 91:return r++,i=3;case 93:return r++,i=4;case 58:return r++,i=6;case 44:return r++,i=5;case 34:return r++,c=j(),i=10;case 47:{const O=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<l&&!S(t.charCodeAt(r));)r++;return c=t.substring(O,r),i=12}if(t.charCodeAt(r+1)===42){r+=2;const F=l-1;let H=!1;for(;r<F;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,s=1),c=t.substring(O,r),i=13}return c+=String.fromCharCode($),r++,i=16}case 45:if(c+=String.fromCharCode($),r++,r===l||!T(t.charCodeAt(r)))return i=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=C(),i=11;default:for(;r<l&&K($);)r++,$=t.charCodeAt(r);if(b!==r){switch(c=t.substring(b,r),c){case"true":return i=8;case"false":return i=9;case"null":return i=7}return i=16}return c+=String.fromCharCode($),r++,i=16}}function K($){if(R($)||S($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function A(){let $;do $=_();while($>=12&&$<=15);return $}return{setPosition:P,getPosition:()=>r,scan:d?A:_,getToken:()=>i,getTokenValue:()=>c,getTokenOffset:()=>b,getTokenLength:()=>r-b,getTokenError:()=>s}}e.createScanner=y;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function T(t){return t>=48&&t<=57}var N;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(N||(N={}));function w(t,d){const r=[],l=new Object;let c;const b={value:{},offset:0,length:0,type:"object",parent:void 0};let i=!1;function s(f,P,C,j){b.value=f,b.offset=P,b.length=C,b.type=j,b.colonOffset=void 0,c=b}try{E(t,{onObjectBegin:(f,P)=>{if(d<=f)throw l;c=void 0,i=d>f,r.push("")},onObjectProperty:(f,P,C)=>{if(d<P||(s(f,P,C,"property"),r[r.length-1]=f,d<=P+C))throw l},onObjectEnd:(f,P)=>{if(d<=f)throw l;c=void 0,r.pop()},onArrayBegin:(f,P)=>{if(d<=f)throw l;c=void 0,r.push(0)},onArrayEnd:(f,P)=>{if(d<=f)throw l;c=void 0,r.pop()},onLiteralValue:(f,P,C)=>{if(d<P||(s(f,P,C,p(f)),d<=P+C))throw l},onSeparator:(f,P,C)=>{if(d<=P)throw l;if(f===":"&&c&&c.type==="property")c.colonOffset=P,i=!1,c=void 0;else if(f===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(i=!0,r[r.length-1]=""),c=void 0}}})}catch(f){if(f!==l)throw f}return{path:r,previousNode:c,isAtPropertyKey:i,matches:f=>{let P=0;for(let C=0;P<f.length&&C<r.length;C++)if(f[P]===r[C]||f[P]==="*")P++;else if(f[P]!=="**")return!1;return P===f.length}}}e.getLocation=w;function h(t,d=[],r=M.DEFAULT){let l=null,c=[];const b=[];function i(f){Array.isArray(c)?c.push(f):l!==null&&(c[l]=f)}return E(t,{onObjectBegin:()=>{const f={};i(f),b.push(c),c=f,l=null},onObjectProperty:f=>{l=f},onObjectEnd:()=>{c=b.pop()},onArrayBegin:()=>{const f=[];i(f),b.push(c),c=f,l=null},onArrayEnd:()=>{c=b.pop()},onLiteralValue:i,onError:(f,P,C)=>{d.push({error:f,offset:P,length:C})}},r),c[0]}e.parse=h;function v(t,d=[],r=M.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(f){l.type==="property"&&(l.length=f-l.offset,l=l.parent)}function b(f){return l.children.push(f),f}E(t,{onObjectBegin:f=>{l=b({type:"object",offset:f,length:-1,parent:l,children:[]})},onObjectProperty:(f,P,C)=>{l=b({type:"property",offset:P,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:f,offset:P,length:C,parent:l})},onObjectEnd:(f,P)=>{l.length=f+P-l.offset,l=l.parent,c(f+P)},onArrayBegin:(f,P)=>{l=b({type:"array",offset:f,length:-1,parent:l,children:[]})},onArrayEnd:(f,P)=>{l.length=f+P-l.offset,l=l.parent,c(f+P)},onLiteralValue:(f,P,C)=>{b({type:p(f),offset:P,length:C,parent:l,value:f}),c(P+C)},onSeparator:(f,P,C)=>{l.type==="property"&&(f===":"?l.colonOffset=P:f===","&&c(P))},onError:(f,P,C)=>{d.push({error:f,offset:P,length:C})}},r);const s=l.children[0];return s&&delete s.parent,s}e.parseTree=v;function m(t,d){if(!t)return;let r=t;for(const l of d)if(typeof l=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let c=!1;for(const b of r.children)if(Array.isArray(b.children)&&b.children[0].value===l){r=b.children[1],c=!0;break}if(!c)return}else{const c=l;if(r.type!=="array"||c<0||!Array.isArray(r.children)||c>=r.children.length)return;r=r.children[c]}return r}e.findNodeAtLocation=m;function a(t){if(!t.parent||!t.parent.children)return[];const d=a(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;d.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&d.push(r)}return d}e.getNodePath=a;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const d=Object.create(null);for(const r of t.children){const l=r.children[1];l&&(d[r.children[0].value]=o(l))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=o;function u(t,d,r=!1){return d>=t.offset&&d<t.offset+t.length||r&&d===t.offset+t.length}e.contains=u;function g(t,d,r=!1){if(u(t,d,r)){const l=t.children;if(Array.isArray(l))for(let c=0;c<l.length&&l[c].offset<=d;c++){const b=g(l[c],d,r);if(b)return b}return t}}e.findNodeAtOffset=g;function E(t,d,r=M.DEFAULT){const l=y(t,!1);function c(Se){return Se?()=>Se(l.getTokenOffset(),l.getTokenLength()):()=>!0}function b(Se){return Se?G=>Se(G,l.getTokenOffset(),l.getTokenLength()):()=>!0}const i=c(d.onObjectBegin),s=b(d.onObjectProperty),f=c(d.onObjectEnd),P=c(d.onArrayBegin),C=c(d.onArrayEnd),j=b(d.onLiteralValue),_=b(d.onSeparator),K=c(d.onComment),A=b(d.onError),$=r&&r.disallowComments,O=r&&r.allowTrailingComma;function F(){for(;;){const Se=l.scan();switch(l.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:$||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(Se){case 12:case 13:$?H(10):K();break;case 16:H(1);break;case 15:case 14:break;default:return Se}}}function H(Se,G=[],X=[]){if(A(Se),G.length+X.length>0){let J=l.getToken();for(;J!==17;){if(G.indexOf(J)!==-1){F();break}else if(X.indexOf(J)!==-1)break;J=F()}}}function V(Se){const G=l.getTokenValue();return Se?j(G):s(G),F(),!0}function ae(){switch(l.getToken()){case 11:{let Se=0;try{Se=JSON.parse(l.getTokenValue()),typeof Se!="number"&&(H(2),Se=0)}catch{H(2)}j(Se);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return F(),!0}function pe(){return l.getToken()!==10?(H(3,[],[2,5]),!1):(V(!1),l.getToken()===6?(_(":"),F(),ue()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function re(){i(),F();let Se=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(Se||H(4,[],[]),_(","),F(),l.getToken()===2&&O)break}else Se&&H(6,[],[]);pe()||H(4,[],[2,5]),Se=!0}return f(),l.getToken()!==2?H(7,[2],[]):F(),!0}function ce(){P(),F();let Se=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(Se||H(4,[],[]),_(","),F(),l.getToken()===4&&O)break}else Se&&H(6,[],[]);ue()||H(4,[],[4,5]),Se=!0}return C(),l.getToken()!==4?H(8,[4],[]):F(),!0}function ue(){switch(l.getToken()){case 3:return ce();case 1:return re();case 10:return V(!0);default:return ae()}}return F(),l.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):ue()?(l.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=E;function L(t,d){const r=y(t),l=[];let c,b=0,i;do switch(i=r.getPosition(),c=r.scan(),c){case 12:case 13:case 17:b!==i&&l.push(t.substring(b,i)),d!==void 0&&l.push(r.getTokenValue().replace(/[^\r\n]/g,d)),b=r.getPosition();break}while(c!==17);return l.join("")}e.stripComments=L;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(ke[28],Te([1,0]),function(te,e){"use strict";var n,k,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(m,a,o){let u=m.get(a);return u===void 0&&(u=o,m.set(a,u)),u}e.getOrSet=M;function y(m){const a=[];return m.forEach((o,u)=>{a.push(`${u} => ${o}`)}),`Map(${m.size}) {${a.join(", ")}}`}e.mapToString=y;function R(m){const a=[];return m.forEach(o=>{a.push(o)}),`Set(${m.size}) {${a.join(", ")}}`}e.setToString=R;class S{constructor(a,o){this.uri=a,this.value=o}}class T{constructor(a,o){this[n]="ResourceMap",a instanceof T?(this.b=new Map(a.b),this.c=o??T.a):(this.b=new Map,this.c=a??T.a)}set(a,o){return this.b.set(this.c(a),new S(a,o)),this}get(a){return this.b.get(this.c(a))?.value}has(a){return this.b.has(this.c(a))}get size(){return this.b.size}clear(){this.b.clear()}delete(a){return this.b.delete(this.c(a))}forEach(a,o){typeof o<"u"&&(a=a.bind(o));for(const[u,g]of this.b)a(g.value,g.uri,this)}*values(){for(const a of this.b.values())yield a.value}*keys(){for(const a of this.b.values())yield a.uri}*entries(){for(const a of this.b.values())yield[a.uri,a.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.b)yield[a.uri,a.value]}}T.a=m=>m.toString(),e.ResourceMap=T;class N{constructor(a,o){this[k]="ResourceSet",!a||typeof a=="function"?this.a=new T(a):(this.a=new T(o),a.forEach(this.add,this))}get size(){return this.a.size}add(a){return this.a.set(a,a),this}clear(){this.a.clear()}delete(a){return this.a.delete(a)}forEach(a,o){this.a.forEach((u,g)=>a.call(o,g,g,this))}has(a){return this.a.has(a)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=N;var w;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class h{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(a){return this.a.has(a)}get(a,o=0){const u=this.a.get(a);if(!!u)return o!==0&&this.j(u,o),u.value}set(a,o,u=0){let g=this.a.get(a);if(g)g.value=o,u!==0&&this.j(g,u);else{switch(g={key:a,value:o,next:void 0,previous:void 0},u){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(a,g),this.d++}return this}delete(a){return!!this.remove(a)}remove(a){const o=this.a.get(a);if(!!o)return this.a.delete(a),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const a=this.b;return this.a.delete(a.key),this.i(a),this.d--,a.value}forEach(a,o){const u=this.e;let g=this.b;for(;g;){if(o?a.bind(o)(g.value,g.key,this):a(g.value,g.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const a=this,o=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(a.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const E={value:u.key,done:!1};return u=u.next,E}else return{value:void 0,done:!0}}};return g}values(){const a=this,o=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(a.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const E={value:u.value,done:!1};return u=u.next,E}else return{value:void 0,done:!0}}};return g}entries(){const a=this,o=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(a.e!==o)throw new Error("LinkedMap got modified during iteration.");if(u){const E={value:[u.key,u.value],done:!1};return u=u.next,E}else return{value:void 0,done:!0}}};return g}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(a){if(a>=this.size)return;if(a===0){this.clear();return}let o=this.b,u=this.size;for(;o&&u>a;)this.a.delete(o.key),o=o.next,u--;this.b=o,this.d=u,o&&(o.previous=void 0),this.e++}g(a){if(!this.b&&!this.c)this.c=a;else if(this.b)a.next=this.b,this.b.previous=a;else throw new Error("Invalid list");this.b=a,this.e++}h(a){if(!this.b&&!this.c)this.b=a;else if(this.c)a.previous=this.c,this.c.next=a;else throw new Error("Invalid list");this.c=a,this.e++}i(a){if(a===this.b&&a===this.c)this.b=void 0,this.c=void 0;else if(a===this.b){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.b=a.next}else if(a===this.c){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.c=a.previous}else{const o=a.next,u=a.previous;if(!o||!u)throw new Error("Invalid list");o.previous=u,u.next=o}a.next=void 0,a.previous=void 0,this.e++}j(a,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(a===this.b)return;const u=a.next,g=a.previous;a===this.c?(g.next=void 0,this.c=g):(u.previous=g,g.next=u),a.previous=void 0,a.next=this.b,this.b.previous=a,this.b=a,this.e++}else if(o===2){if(a===this.c)return;const u=a.next,g=a.previous;a===this.b?(u.previous=void 0,this.b=u):(u.previous=g,g.next=u),a.next=void 0,a.previous=this.c,this.c.next=a,this.c=a,this.e++}}}toJSON(){const a=[];return this.forEach((o,u)=>{a.push([u,o])}),a}fromJSON(a){this.clear();for(const[o,u]of a)this.set(o,u)}}e.LinkedMap=h;class v extends h{constructor(a,o=1){super(),this.k=a,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(a){this.k=a,this.m()}get ratio(){return this.l}set ratio(a){this.l=Math.min(Math.max(0,a),1),this.m()}get(a,o=2){return super.get(a,o)}peek(a){return super.get(a,0)}set(a,o){return super.set(a,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=v}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ke[112],Te([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(Pe,Ie){for(var we=0;we<Ie.length;we++){var se=Ie[we];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Pe,se.key,se)}}function n(Pe,Ie,we){return Ie&&e(Pe.prototype,Ie),we&&e(Pe,we),Object.defineProperty(Pe,"prototype",{writable:!1}),Pe}function k(Pe,Ie){if(!!Pe){if(typeof Pe=="string")return D(Pe,Ie);var we=Object.prototype.toString.call(Pe).slice(8,-1);if(we==="Object"&&Pe.constructor&&(we=Pe.constructor.name),we==="Map"||we==="Set")return Array.from(Pe);if(we==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(we))return D(Pe,Ie)}}function D(Pe,Ie){(Ie==null||Ie>Pe.length)&&(Ie=Pe.length);for(var we=0,se=new Array(Ie);we<Ie;we++)se[we]=Pe[we];return se}function M(Pe,Ie){var we=typeof Symbol<"u"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(we)return(we=we.call(Pe)).next.bind(we);if(Array.isArray(Pe)||(we=k(Pe))||Ie&&Pe&&typeof Pe.length=="number"){we&&(Pe=we);var se=0;return function(){return se>=Pe.length?{done:!0}:{done:!1,value:Pe[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=y();function R(Pe){te.defaults=Pe}var S=/[&<>"']/,T=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(Ie){return h[Ie]};function m(Pe,Ie){if(Ie){if(S.test(Pe))return Pe.replace(T,v)}else if(N.test(Pe))return Pe.replace(w,v);return Pe}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Pe){return Pe.replace(a,function(Ie,we){return we=we.toLowerCase(),we==="colon"?":":we.charAt(0)==="#"?we.charAt(1)==="x"?String.fromCharCode(parseInt(we.substring(2),16)):String.fromCharCode(+we.substring(1)):""})}var u=/(^|[^\[])\^/g;function g(Pe,Ie){Pe=typeof Pe=="string"?Pe:Pe.source,Ie=Ie||"";var we={replace:function(le,Z){return Z=Z.source||Z,Z=Z.replace(u,"$1"),Pe=Pe.replace(le,Z),we},getRegex:function(){return new RegExp(Pe,Ie)}};return we}var E=/[^\w:]/g,L=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Pe,Ie,we){if(Pe){var se;try{se=decodeURIComponent(o(we)).replace(E,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Ie&&!L.test(we)&&(we=c(Ie,we));try{we=encodeURI(we).replace(/%25/g,"%")}catch{return null}return we}var t={},d=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(Pe,Ie){t[" "+Pe]||(d.test(Pe)?t[" "+Pe]=Pe+"/":t[" "+Pe]=f(Pe,"/",!0)),Pe=t[" "+Pe];var we=Pe.indexOf(":")===-1;return Ie.substring(0,2)==="//"?we?Ie:Pe.replace(r,"$1")+Ie:Ie.charAt(0)==="/"?we?Ie:Pe.replace(l,"$1")+Ie:Pe+Ie}var b={exec:function(){}};function i(Pe){for(var Ie=1,we,se;Ie<arguments.length;Ie++){we=arguments[Ie];for(se in we)Object.prototype.hasOwnProperty.call(we,se)&&(Pe[se]=we[se])}return Pe}function s(Pe,Ie){var we=Pe.replace(/\|/g,function(Z,I,B){for(var W=!1,q=I;--q>=0&&B[q]==="\\";)W=!W;return W?"|":" |"}),se=we.split(/ \|/),le=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>Ie)se.splice(Ie);else for(;se.length<Ie;)se.push("");for(;le<se.length;le++)se[le]=se[le].trim().replace(/\\\|/g,"|");return se}function f(Pe,Ie,we){var se=Pe.length;if(se===0)return"";for(var le=0;le<se;){var Z=Pe.charAt(se-le-1);if(Z===Ie&&!we)le++;else if(Z!==Ie&&we)le++;else break}return Pe.slice(0,se-le)}function P(Pe,Ie){if(Pe.indexOf(Ie[1])===-1)return-1;for(var we=Pe.length,se=0,le=0;le<we;le++)if(Pe[le]==="\\")le++;else if(Pe[le]===Ie[0])se++;else if(Pe[le]===Ie[1]&&(se--,se<0))return le;return-1}function C(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(Pe,Ie){if(Ie<1)return"";for(var we="";Ie>1;)Ie&1&&(we+=Pe),Ie>>=1,Pe+=Pe;return we+Pe}function _(Pe,Ie,we,se){var le=Ie.href,Z=Ie.title?m(Ie.title):null,I=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){se.state.inLink=!0;var B={type:"link",raw:we,href:le,title:Z,text:I,tokens:se.inlineTokens(I)};return se.state.inLink=!1,B}return{type:"image",raw:we,href:le,title:Z,text:m(I)}}function K(Pe,Ie){var we=Pe.match(/^(\s+)(?:```)/);if(we===null)return Ie;var se=we[1];return Ie.split(`
`).map(function(le){var Z=le.match(/^\s+/);if(Z===null)return le;var I=Z[0];return I.length>=se.length?le.slice(se.length):le}).join(`
`)}var A=function(){function Pe(we){this.options=we||te.defaults}var Ie=Pe.prototype;return Ie.space=function(se){var le=this.rules.block.newline.exec(se);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},Ie.code=function(se){var le=this.rules.block.code.exec(se);if(le){var Z=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?Z:f(Z,`
`)}}},Ie.fences=function(se){var le=this.rules.block.fences.exec(se);if(le){var Z=le[0],I=K(Z,le[3]||"");return{type:"code",raw:Z,lang:le[2]?le[2].trim():le[2],text:I}}},Ie.heading=function(se){var le=this.rules.block.heading.exec(se);if(le){var Z=le[2].trim();if(/#$/.test(Z)){var I=f(Z,"#");(this.options.pedantic||!I||/ $/.test(I))&&(Z=I.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:Z,tokens:this.lexer.inline(Z)}}},Ie.hr=function(se){var le=this.rules.block.hr.exec(se);if(le)return{type:"hr",raw:le[0]}},Ie.blockquote=function(se){var le=this.rules.block.blockquote.exec(se);if(le){var Z=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(Z,[]),text:Z}}},Ie.list=function(se){var le=this.rules.block.list.exec(se);if(le){var Z,I,B,W,q,ee,fe,De,oe,ve,be,He,je=le[1].trim(),it=je.length>1,Xe={type:"list",raw:"",ordered:it,start:it?+je.slice(0,-1):"",loose:!1,items:[]};je=it?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=it?je:"[*+-]");for(var et=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(He=!1,!(!(le=et.exec(se))||this.rules.block.hr.test(se)));){if(Z=le[0],se=se.substring(Z.length),De=le[2].split(`
`,1)[0],oe=se.split(`
`,1)[0],this.options.pedantic?(W=2,be=De.trimLeft()):(W=le[2].search(/[^ ]/),W=W>4?1:W,be=De.slice(W),W+=le[1].length),ee=!1,!De&&/^ *$/.test(oe)&&(Z+=oe+`
`,se=se.substring(oe.length+1),He=!0),!He)for(var nt=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ne=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:```|~~~)"),Q=new RegExp("^ {0,"+Math.min(3,W-1)+"}#");se&&(ve=se.split(`
`,1)[0],De=ve,this.options.pedantic&&(De=De.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(De)||Q.test(De)||nt.test(De)||Ne.test(se)));){if(De.search(/[^ ]/)>=W||!De.trim())be+=`
`+De.slice(W);else if(!ee)be+=`
`+De;else break;!ee&&!De.trim()&&(ee=!0),Z+=ve+`
`,se=se.substring(ve.length+1)}Xe.loose||(fe?Xe.loose=!0:/\n *\n *$/.test(Z)&&(fe=!0)),this.options.gfm&&(I=/^\[[ xX]\] /.exec(be),I&&(B=I[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:Z,task:!!I,checked:B,loose:!1,text:be}),Xe.raw+=Z}Xe.items[Xe.items.length-1].raw=Z.trimRight(),Xe.items[Xe.items.length-1].text=be.trimRight(),Xe.raw=Xe.raw.trimRight();var Y=Xe.items.length;for(q=0;q<Y;q++){this.lexer.state.top=!1,Xe.items[q].tokens=this.lexer.blockTokens(Xe.items[q].text,[]);var ge=Xe.items[q].tokens.filter(function($e){return $e.type==="space"}),We=ge.every(function($e){for(var Qe=$e.raw.split(""),Ke=0,tt=M(Qe),at;!(at=tt()).done;){var Et=at.value;if(Et===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Xe.loose&&ge.length&&We&&(Xe.loose=!0,Xe.items[q].loose=!0)}return Xe}},Ie.html=function(se){var le=this.rules.block.html.exec(se);if(le){var Z={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var I=this.options.sanitizer?this.options.sanitizer(le[0]):m(le[0]);Z.type="paragraph",Z.text=I,Z.tokens=this.lexer.inline(I)}return Z}},Ie.def=function(se){var le=this.rules.block.def.exec(se);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var Z=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Z,raw:le[0],href:le[2],title:le[3]}}},Ie.table=function(se){var le=this.rules.block.table.exec(se);if(le){var Z={type:"table",header:s(le[1]).map(function(fe){return{text:fe}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Z.header.length===Z.align.length){Z.raw=le[0];var I=Z.align.length,B,W,q,ee;for(B=0;B<I;B++)/^ *-+: *$/.test(Z.align[B])?Z.align[B]="right":/^ *:-+: *$/.test(Z.align[B])?Z.align[B]="center":/^ *:-+ *$/.test(Z.align[B])?Z.align[B]="left":Z.align[B]=null;for(I=Z.rows.length,B=0;B<I;B++)Z.rows[B]=s(Z.rows[B],Z.header.length).map(function(fe){return{text:fe}});for(I=Z.header.length,W=0;W<I;W++)Z.header[W].tokens=this.lexer.inline(Z.header[W].text);for(I=Z.rows.length,W=0;W<I;W++)for(ee=Z.rows[W],q=0;q<ee.length;q++)ee[q].tokens=this.lexer.inline(ee[q].text);return Z}}},Ie.lheading=function(se){var le=this.rules.block.lheading.exec(se);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},Ie.paragraph=function(se){var le=this.rules.block.paragraph.exec(se);if(le){var Z=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:Z,tokens:this.lexer.inline(Z)}}},Ie.text=function(se){var le=this.rules.block.text.exec(se);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},Ie.escape=function(se){var le=this.rules.inline.escape.exec(se);if(le)return{type:"escape",raw:le[0],text:m(le[1])}},Ie.tag=function(se){var le=this.rules.inline.tag.exec(se);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):m(le[0]):le[0]}},Ie.link=function(se){var le=this.rules.inline.link.exec(se);if(le){var Z=le[2].trim();if(!this.options.pedantic&&/^</.test(Z)){if(!/>$/.test(Z))return;var I=f(Z.slice(0,-1),"\\");if((Z.length-I.length)%2===0)return}else{var B=P(le[2],"()");if(B>-1){var W=le[0].indexOf("!")===0?5:4,q=W+le[1].length+B;le[2]=le[2].substring(0,B),le[0]=le[0].substring(0,q).trim(),le[3]=""}}var ee=le[2],fe="";if(this.options.pedantic){var De=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ee);De&&(ee=De[1],fe=De[3])}else fe=le[3]?le[3].slice(1,-1):"";return ee=ee.trim(),/^</.test(ee)&&(this.options.pedantic&&!/>$/.test(Z)?ee=ee.slice(1):ee=ee.slice(1,-1)),_(le,{href:ee&&ee.replace(this.rules.inline._escapes,"$1"),title:fe&&fe.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},Ie.reflink=function(se,le){var Z;if((Z=this.rules.inline.reflink.exec(se))||(Z=this.rules.inline.nolink.exec(se))){var I=(Z[2]||Z[1]).replace(/\s+/g," ");if(I=le[I.toLowerCase()],!I||!I.href){var B=Z[0].charAt(0);return{type:"text",raw:B,text:B}}return _(Z,I,Z[0],this.lexer)}},Ie.emStrong=function(se,le,Z){Z===void 0&&(Z="");var I=this.rules.inline.emStrong.lDelim.exec(se);if(!!I&&!(I[3]&&Z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var B=I[1]||I[2]||"";if(!B||B&&(Z===""||this.rules.inline.punctuation.exec(Z))){var W=I[0].length-1,q,ee,fe=W,De=0,oe=I[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,le=le.slice(-1*se.length+W);(I=oe.exec(le))!=null;)if(q=I[1]||I[2]||I[3]||I[4]||I[5]||I[6],!!q){if(ee=q.length,I[3]||I[4]){fe+=ee;continue}else if((I[5]||I[6])&&W%3&&!((W+ee)%3)){De+=ee;continue}if(fe-=ee,!(fe>0)){if(ee=Math.min(ee,ee+fe+De),Math.min(W,ee)%2){var ve=se.slice(1,W+I.index+ee);return{type:"em",raw:se.slice(0,W+I.index+ee+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var be=se.slice(2,W+I.index+ee-1);return{type:"strong",raw:se.slice(0,W+I.index+ee+1),text:be,tokens:this.lexer.inlineTokens(be)}}}}}},Ie.codespan=function(se){var le=this.rules.inline.code.exec(se);if(le){var Z=le[2].replace(/\n/g," "),I=/[^ ]/.test(Z),B=/^ /.test(Z)&&/ $/.test(Z);return I&&B&&(Z=Z.substring(1,Z.length-1)),Z=m(Z,!0),{type:"codespan",raw:le[0],text:Z}}},Ie.br=function(se){var le=this.rules.inline.br.exec(se);if(le)return{type:"br",raw:le[0]}},Ie.del=function(se){var le=this.rules.inline.del.exec(se);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},Ie.autolink=function(se,le){var Z=this.rules.inline.autolink.exec(se);if(Z){var I,B;return Z[2]==="@"?(I=m(this.options.mangle?le(Z[1]):Z[1]),B="mailto:"+I):(I=m(Z[1]),B=I),{type:"link",raw:Z[0],text:I,href:B,tokens:[{type:"text",raw:I,text:I}]}}},Ie.url=function(se,le){var Z;if(Z=this.rules.inline.url.exec(se)){var I,B;if(Z[2]==="@")I=m(this.options.mangle?le(Z[0]):Z[0]),B="mailto:"+I;else{var W;do W=Z[0],Z[0]=this.rules.inline._backpedal.exec(Z[0])[0];while(W!==Z[0]);I=m(Z[0]),Z[1]==="www."?B="http://"+I:B=I}return{type:"link",raw:Z[0],text:I,href:B,tokens:[{type:"text",raw:I,text:I}]}}},Ie.inlineText=function(se,le){var Z=this.rules.inline.text.exec(se);if(Z){var I;return this.lexer.state.inRawBlock?I=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):m(Z[0]):Z[0]:I=m(this.options.smartypants?le(Z[0]):Z[0]),{type:"text",raw:Z[0],text:I}}},Pe}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:b,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=g($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=g(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=g($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=g($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=g($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=g($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=i({},$),$.gfm=i({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=g($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=g($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=i({},$.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:b,paragraph:g($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:b,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:b,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=g(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=g($._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=g(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=g(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=g(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=g(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=g(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=g(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=g(O.reflink).replace("label",O._label).replace("ref",$._label).getRegex(),O.nolink=g(O.nolink).replace("ref",$._label).getRegex(),O.reflinkSearch=g(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=i({},O),O.pedantic=i({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=i({},O.normal,{escape:g(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=g(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=i({},O.gfm,{br:g(O.br).replace("{2,}","*").getRegex(),text:g(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Pe){var Ie="",we,se,le=Pe.length;for(we=0;we<le;we++)se=Pe.charCodeAt(we),Math.random()>.5&&(se="x"+se.toString(16)),Ie+="&#"+se+";";return Ie}var V=function(){function Pe(we){this.tokens=[],this.tokens.links=Object.create(null),this.options=we||te.defaults,this.options.tokenizer=this.options.tokenizer||new A,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:$.normal,inline:O.normal};this.options.pedantic?(se.block=$.pedantic,se.inline=O.pedantic):this.options.gfm&&(se.block=$.gfm,this.options.breaks?se.inline=O.breaks:se.inline=O.gfm),this.tokenizer.rules=se}Pe.lex=function(se,le){var Z=new Pe(le);return Z.lex(se)},Pe.lexInline=function(se,le){var Z=new Pe(le);return Z.inlineTokens(se)};var Ie=Pe.prototype;return Ie.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},Ie.blockTokens=function(se,le){var Z=this;le===void 0&&(le=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(fe,De,oe){return De+"    ".repeat(oe.length)});for(var I,B,W,q;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(fe){return(I=fe.call({lexer:Z},se,le))?(se=se.substring(I.raw.length),le.push(I),!0):!1}))){if(I=this.tokenizer.space(se)){se=se.substring(I.raw.length),I.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(I);continue}if(I=this.tokenizer.code(se)){se=se.substring(I.raw.length),B=le[le.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+I.raw,B.text+=`
`+I.text,this.inlineQueue[this.inlineQueue.length-1].src=B.text):le.push(I);continue}if(I=this.tokenizer.fences(se)){se=se.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.heading(se)){se=se.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.hr(se)){se=se.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.blockquote(se)){se=se.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.list(se)){se=se.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.html(se)){se=se.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.def(se)){se=se.substring(I.raw.length),B=le[le.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+I.raw,B.text+=`
`+I.raw,this.inlineQueue[this.inlineQueue.length-1].src=B.text):this.tokens.links[I.tag]||(this.tokens.links[I.tag]={href:I.href,title:I.title});continue}if(I=this.tokenizer.table(se)){se=se.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.lheading(se)){se=se.substring(I.raw.length),le.push(I);continue}if(W=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var fe=1/0,De=se.slice(1),oe=void 0;Z.options.extensions.startBlock.forEach(function(ve){oe=ve.call({lexer:this},De),typeof oe=="number"&&oe>=0&&(fe=Math.min(fe,oe))}),fe<1/0&&fe>=0&&(W=se.substring(0,fe+1))}(),this.state.top&&(I=this.tokenizer.paragraph(W))){B=le[le.length-1],q&&B.type==="paragraph"?(B.raw+=`
`+I.raw,B.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):le.push(I),q=W.length!==se.length,se=se.substring(I.raw.length);continue}if(I=this.tokenizer.text(se)){se=se.substring(I.raw.length),B=le[le.length-1],B&&B.type==="text"?(B.raw+=`
`+I.raw,B.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):le.push(I);continue}if(se){var ee="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return this.state.top=!0,le},Ie.inline=function(se,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:se,tokens:le}),le},Ie.inlineTokens=function(se,le){var Z=this;le===void 0&&(le=[]);var I,B,W,q=se,ee,fe,De;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(ee=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)oe.includes(ee[0].slice(ee[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,ee.index)+"["+j("a",ee[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ee=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,ee.index)+"["+j("a",ee[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ee=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,ee.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(fe||(De=""),fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(be){return(I=be.call({lexer:Z},se,le))?(se=se.substring(I.raw.length),le.push(I),!0):!1}))){if(I=this.tokenizer.escape(se)){se=se.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.tag(se)){se=se.substring(I.raw.length),B=le[le.length-1],B&&I.type==="text"&&B.type==="text"?(B.raw+=I.raw,B.text+=I.text):le.push(I);continue}if(I=this.tokenizer.link(se)){se=se.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(I.raw.length),B=le[le.length-1],B&&I.type==="text"&&B.type==="text"?(B.raw+=I.raw,B.text+=I.text):le.push(I);continue}if(I=this.tokenizer.emStrong(se,q,De)){se=se.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.codespan(se)){se=se.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.br(se)){se=se.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.del(se)){se=se.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.autolink(se,H)){se=se.substring(I.raw.length),le.push(I);continue}if(!this.state.inLink&&(I=this.tokenizer.url(se,H))){se=se.substring(I.raw.length),le.push(I);continue}if(W=se,this.options.extensions&&this.options.extensions.startInline&&function(){var be=1/0,He=se.slice(1),je=void 0;Z.options.extensions.startInline.forEach(function(it){je=it.call({lexer:this},He),typeof je=="number"&&je>=0&&(be=Math.min(be,je))}),be<1/0&&be>=0&&(W=se.substring(0,be+1))}(),I=this.tokenizer.inlineText(W,F)){se=se.substring(I.raw.length),I.raw.slice(-1)!=="_"&&(De=I.raw.slice(-1)),fe=!0,B=le[le.length-1],B&&B.type==="text"?(B.raw+=I.raw,B.text+=I.text):le.push(I);continue}if(se){var ve="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return le},n(Pe,null,[{key:"rules",get:function(){return{block:$,inline:O}}}]),Pe}(),ae=function(){function Pe(we){this.options=we||te.defaults}var Ie=Pe.prototype;return Ie.code=function(se,le,Z){var I=(le||"").match(/\S*/)[0];if(this.options.highlight){var B=this.options.highlight(se,I);B!=null&&B!==se&&(Z=!0,se=B)}return se=se.replace(/\n$/,"")+`
`,I?'<pre><code class="'+this.options.langPrefix+m(I,!0)+'">'+(Z?se:m(se,!0))+`</code></pre>
`:"<pre><code>"+(Z?se:m(se,!0))+`</code></pre>
`},Ie.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Ie.html=function(se){return se},Ie.heading=function(se,le,Z,I){if(this.options.headerIds){var B=this.options.headerPrefix+I.slug(Z);return"<h"+le+' id="'+B+'">'+se+"</h"+le+`>
`}return"<h"+le+">"+se+"</h"+le+`>
`},Ie.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ie.list=function(se,le,Z){var I=le?"ol":"ul",B=le&&Z!==1?' start="'+Z+'"':"";return"<"+I+B+`>
`+se+"</"+I+`>
`},Ie.listitem=function(se){return"<li>"+se+`</li>
`},Ie.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ie.paragraph=function(se){return"<p>"+se+`</p>
`},Ie.table=function(se,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+le+`</table>
`},Ie.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Ie.tablecell=function(se,le){var Z=le.header?"th":"td",I=le.align?"<"+Z+' align="'+le.align+'">':"<"+Z+">";return I+se+("</"+Z+`>
`)},Ie.strong=function(se){return"<strong>"+se+"</strong>"},Ie.em=function(se){return"<em>"+se+"</em>"},Ie.codespan=function(se){return"<code>"+se+"</code>"},Ie.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ie.del=function(se){return"<del>"+se+"</del>"},Ie.link=function(se,le,Z){if(se=p(this.options.sanitize,this.options.baseUrl,se),se===null)return Z;var I='<a href="'+m(se)+'"';return le&&(I+=' title="'+le+'"'),I+=">"+Z+"</a>",I},Ie.image=function(se,le,Z){if(se=p(this.options.sanitize,this.options.baseUrl,se),se===null)return Z;var I='<img src="'+se+'" alt="'+Z+'"';return le&&(I+=' title="'+le+'"'),I+=this.options.xhtml?"/>":">",I},Ie.text=function(se){return se},Pe}(),pe=function(){function Pe(){}var Ie=Pe.prototype;return Ie.strong=function(se){return se},Ie.em=function(se){return se},Ie.codespan=function(se){return se},Ie.del=function(se){return se},Ie.html=function(se){return se},Ie.text=function(se){return se},Ie.link=function(se,le,Z){return""+Z},Ie.image=function(se,le,Z){return""+Z},Ie.br=function(){return""},Pe}(),re=function(){function Pe(){this.seen={}}var Ie=Pe.prototype;return Ie.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ie.getNextSafeSlug=function(se,le){var Z=se,I=0;if(this.seen.hasOwnProperty(Z)){I=this.seen[se];do I++,Z=se+"-"+I;while(this.seen.hasOwnProperty(Z))}return le||(this.seen[se]=I,this.seen[Z]=0),Z},Ie.slug=function(se,le){le===void 0&&(le={});var Z=this.serialize(se);return this.getNextSafeSlug(Z,le.dryrun)},Pe}(),ce=function(){function Pe(we){this.options=we||te.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new pe,this.slugger=new re}Pe.parse=function(se,le){var Z=new Pe(le);return Z.parse(se)},Pe.parseInline=function(se,le){var Z=new Pe(le);return Z.parseInline(se)};var Ie=Pe.prototype;return Ie.parse=function(se,le){le===void 0&&(le=!0);var Z="",I,B,W,q,ee,fe,De,oe,ve,be,He,je,it,Xe,et,nt,Ne,rt,Q,Y=se.length;for(I=0;I<Y;I++){if(be=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Q=this.options.extensions.renderers[be.type].call({parser:this},be),Q!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(be.type))){Z+=Q||"";continue}switch(be.type){case"space":continue;case"hr":{Z+=this.renderer.hr();continue}case"heading":{Z+=this.renderer.heading(this.parseInline(be.tokens),be.depth,o(this.parseInline(be.tokens,this.textRenderer)),this.slugger);continue}case"code":{Z+=this.renderer.code(be.text,be.lang,be.escaped);continue}case"table":{for(oe="",De="",q=be.header.length,B=0;B<q;B++)De+=this.renderer.tablecell(this.parseInline(be.header[B].tokens),{header:!0,align:be.align[B]});for(oe+=this.renderer.tablerow(De),ve="",q=be.rows.length,B=0;B<q;B++){for(fe=be.rows[B],De="",ee=fe.length,W=0;W<ee;W++)De+=this.renderer.tablecell(this.parseInline(fe[W].tokens),{header:!1,align:be.align[W]});ve+=this.renderer.tablerow(De)}Z+=this.renderer.table(oe,ve);continue}case"blockquote":{ve=this.parse(be.tokens),Z+=this.renderer.blockquote(ve);continue}case"list":{for(He=be.ordered,je=be.start,it=be.loose,q=be.items.length,ve="",B=0;B<q;B++)et=be.items[B],nt=et.checked,Ne=et.task,Xe="",et.task&&(rt=this.renderer.checkbox(nt),it?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=rt+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=rt+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:rt}):Xe+=rt),Xe+=this.parse(et.tokens,it),ve+=this.renderer.listitem(Xe,Ne,nt);Z+=this.renderer.list(ve,He,je);continue}case"html":{Z+=this.renderer.html(be.text);continue}case"paragraph":{Z+=this.renderer.paragraph(this.parseInline(be.tokens));continue}case"text":{for(ve=be.tokens?this.parseInline(be.tokens):be.text;I+1<Y&&se[I+1].type==="text";)be=se[++I],ve+=`
`+(be.tokens?this.parseInline(be.tokens):be.text);Z+=le?this.renderer.paragraph(ve):ve;continue}default:{var ge='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(ge);return}else throw new Error(ge)}}}return Z},Ie.parseInline=function(se,le){le=le||this.renderer;var Z="",I,B,W,q=se.length;for(I=0;I<q;I++){if(B=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[B.type]&&(W=this.options.extensions.renderers[B.type].call({parser:this},B),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(B.type))){Z+=W||"";continue}switch(B.type){case"escape":{Z+=le.text(B.text);break}case"html":{Z+=le.html(B.text);break}case"link":{Z+=le.link(B.href,B.title,this.parseInline(B.tokens,le));break}case"image":{Z+=le.image(B.href,B.title,B.text);break}case"strong":{Z+=le.strong(this.parseInline(B.tokens,le));break}case"em":{Z+=le.em(this.parseInline(B.tokens,le));break}case"codespan":{Z+=le.codespan(B.text);break}case"br":{Z+=le.br();break}case"del":{Z+=le.del(this.parseInline(B.tokens,le));break}case"text":{Z+=le.text(B.text);break}default:{var ee='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(ee);return}else throw new Error(ee)}}}return Z},Pe}();function ue(Pe,Ie,we){if(typeof Pe>"u"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Ie=="function"&&(we=Ie,Ie=null),Ie=i({},ue.defaults,Ie||{}),C(Ie),we){var se=Ie.highlight,le;try{le=V.lex(Pe,Ie)}catch(q){return we(q)}var Z=function(ee){var fe;if(!ee)try{Ie.walkTokens&&ue.walkTokens(le,Ie.walkTokens),fe=ce.parse(le,Ie)}catch(De){ee=De}return Ie.highlight=se,ee?we(ee):we(null,fe)};if(!se||se.length<3||(delete Ie.highlight,!le.length))return Z();var I=0;ue.walkTokens(le,function(q){q.type==="code"&&(I++,setTimeout(function(){se(q.text,q.lang,function(ee,fe){if(ee)return Z(ee);fe!=null&&fe!==q.text&&(q.text=fe,q.escaped=!0),I--,I===0&&Z()})},0))}),I===0&&Z();return}function B(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,Ie.silent)return"<p>An error occurred:</p><pre>"+m(q.message+"",!0)+"</pre>";throw q}try{var W=V.lex(Pe,Ie);if(Ie.walkTokens){if(Ie.async)return Promise.all(ue.walkTokens(W,Ie.walkTokens)).then(function(){return ce.parse(W,Ie)}).catch(B);ue.walkTokens(W,Ie.walkTokens)}return ce.parse(W,Ie)}catch(q){B(q)}}ue.options=ue.setOptions=function(Pe){return i(ue.defaults,Pe),R(ue.defaults),ue},ue.getDefaults=y,ue.defaults=te.defaults,ue.use=function(){for(var Pe=arguments.length,Ie=new Array(Pe),we=0;we<Pe;we++)Ie[we]=arguments[we];var se=i.apply(void 0,[{}].concat(Ie)),le=ue.defaults.extensions||{renderers:{},childTokens:{}},Z;Ie.forEach(function(I){if(I.extensions&&(Z=!0,I.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var q=le.renderers?le.renderers[W.name]:null;q?le.renderers[W.name]=function(){for(var ee=arguments.length,fe=new Array(ee),De=0;De<ee;De++)fe[De]=arguments[De];var oe=W.renderer.apply(this,fe);return oe===!1&&(oe=q.apply(this,fe)),oe}:le.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[W.level]?le[W.level].unshift(W.tokenizer):le[W.level]=[W.tokenizer],W.start&&(W.level==="block"?le.startBlock?le.startBlock.push(W.start):le.startBlock=[W.start]:W.level==="inline"&&(le.startInline?le.startInline.push(W.start):le.startInline=[W.start]))}W.childTokens&&(le.childTokens[W.name]=W.childTokens)})),I.renderer&&function(){var W=ue.defaults.renderer||new ae,q=function(De){var oe=W[De];W[De]=function(){for(var ve=arguments.length,be=new Array(ve),He=0;He<ve;He++)be[He]=arguments[He];var je=I.renderer[De].apply(W,be);return je===!1&&(je=oe.apply(W,be)),je}};for(var ee in I.renderer)q(ee);se.renderer=W}(),I.tokenizer&&function(){var W=ue.defaults.tokenizer||new A,q=function(De){var oe=W[De];W[De]=function(){for(var ve=arguments.length,be=new Array(ve),He=0;He<ve;He++)be[He]=arguments[He];var je=I.tokenizer[De].apply(W,be);return je===!1&&(je=oe.apply(W,be)),je}};for(var ee in I.tokenizer)q(ee);se.tokenizer=W}(),I.walkTokens){var B=ue.defaults.walkTokens;se.walkTokens=function(W){var q=[];return q.push(I.walkTokens.call(this,W)),B&&(q=q.concat(B.call(this,W))),q}}Z&&(se.extensions=le),ue.setOptions(se)})},ue.walkTokens=function(Pe,Ie){for(var we=[],se=function(){var B=Z.value;switch(we=we.concat(Ie.call(ue,B)),B.type){case"table":{for(var W=M(B.header),q;!(q=W()).done;){var ee=q.value;we=we.concat(ue.walkTokens(ee.tokens,Ie))}for(var fe=M(B.rows),De;!(De=fe()).done;)for(var oe=De.value,ve=M(oe),be;!(be=ve()).done;){var He=be.value;we=we.concat(ue.walkTokens(He.tokens,Ie))}break}case"list":{we=we.concat(ue.walkTokens(B.items,Ie));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[B.type]?ue.defaults.extensions.childTokens[B.type].forEach(function(je){we=we.concat(ue.walkTokens(B[je],Ie))}):B.tokens&&(we=we.concat(ue.walkTokens(B.tokens,Ie)))}},le=M(Pe),Z;!(Z=le()).done;)se();return we},ue.parseInline=function(Pe,Ie){if(typeof Pe>"u"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Ie=i({},ue.defaults,Ie||{}),C(Ie);try{var we=V.lexInline(Pe,Ie);return Ie.walkTokens&&ue.walkTokens(we,Ie.walkTokens),ce.parseInline(we,Ie)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Ie.silent)return"<p>An error occurred:</p><pre>"+m(se.message+"",!0)+"</pre>";throw se}},ue.Parser=ce,ue.parser=ce.parse,ue.Renderer=ae,ue.TextRenderer=pe,ue.Lexer=V,ue.lexer=V.lex,ue.Tokenizer=A,ue.Slugger=re,ue.parse=ue;var Se=ue.options,G=ue.setOptions,X=ue.use,J=ue.walkTokens,de=ue.parseInline,ye=ue,Fe=ce.parse,ze=V.lex;te.Lexer=V,te.Parser=ce,te.Renderer=ae,te.Slugger=re,te.TextRenderer=pe,te.Tokenizer=A,te.getDefaults=y,te.lexer=ze,te.marked=ue,te.options=Se,te.parse=ye,te.parseInline=de,te.parser=Fe,te.setOptions=G,te.use=X,te.walkTokens=J,Object.defineProperty(te,"__esModule",{value:!0})}),define(ke[113],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(R,S,T){return Math.min(Math.max(R,S),T)}e.clamp=n;function k(R,S){return(S+R%S)%S}e.rot=k;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class M{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=M;class y{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const T=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=T,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=y}),function(){function te(D){const M=[];typeof D=="number"&&M.push("code/timeOrigin",D);function y(S){M.push(S,Date.now())}function R(){const S=[];for(let T=0;T<M.length;T+=2)S.push({name:M[T],startTime:M[T+1]});return S}return{mark:y,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const y of performance.getEntriesByType("mark"))M.push({name:y.name,startTime:Math.round(D+y.startTime)});return M}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function n(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=n(k))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var k in n)(typeof exports=="object"?exports:te)[k]=n[k]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function n(k){if(e[k])return e[k].exports;var D=e[k]={i:k,l:!1,exports:{}};return te[k].call(D.exports,D,D.exports,n),D.l=!0,D.exports}return n.m=te,n.c=e,n.d=function(k,D,M){n.o(k,D)||Object.defineProperty(k,D,{enumerable:!0,get:M})},n.r=function(k){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},n.t=function(k,D){if(1&D&&(k=n(k)),8&D||4&D&&typeof k=="object"&&k&&k.__esModule)return k;var M=Object.create(null);if(n.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:k}),2&D&&typeof k!="string")for(var y in k)n.d(M,y,function(R){return k[R]}.bind(null,y));return M},n.n=function(k){var D=k&&k.__esModule?function(){return k.default}:function(){return k};return n.d(D,"a",D),D},n.o=function(k,D){return Object.prototype.hasOwnProperty.call(k,D)},n.p="",n(n.s=0)}([function(te,e,n){(function(k){var D;e=te.exports=X,D=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,y=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],T=0,N=T++;S[N]="0|[1-9]\\d*";var w=T++;S[w]="[0-9]+";var h=T++;S[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=T++;S[v]="("+S[N]+")\\.("+S[N]+")\\.("+S[N]+")";var m=T++;S[m]="("+S[w]+")\\.("+S[w]+")\\.("+S[w]+")";var a=T++;S[a]="(?:"+S[N]+"|"+S[h]+")";var o=T++;S[o]="(?:"+S[w]+"|"+S[h]+")";var u=T++;S[u]="(?:-("+S[a]+"(?:\\."+S[a]+")*))";var g=T++;S[g]="(?:-?("+S[o]+"(?:\\."+S[o]+")*))";var E=T++;S[E]="[0-9A-Za-z-]+";var L=T++;S[L]="(?:\\+("+S[E]+"(?:\\."+S[E]+")*))";var p=T++,t="v?"+S[v]+S[u]+"?"+S[L]+"?";S[p]="^"+t+"$";var d="[v=\\s]*"+S[m]+S[g]+"?"+S[L]+"?",r=T++;S[r]="^"+d+"$";var l=T++;S[l]="((?:<|>)?=?)";var c=T++;S[c]=S[w]+"|x|X|\\*";var b=T++;S[b]=S[N]+"|x|X|\\*";var i=T++;S[i]="[v=\\s]*("+S[b]+")(?:\\.("+S[b]+")(?:\\.("+S[b]+")(?:"+S[u]+")?"+S[L]+"?)?)?";var s=T++;S[s]="[v=\\s]*("+S[c]+")(?:\\.("+S[c]+")(?:\\.("+S[c]+")(?:"+S[g]+")?"+S[L]+"?)?)?";var f=T++;S[f]="^"+S[l]+"\\s*"+S[i]+"$";var P=T++;S[P]="^"+S[l]+"\\s*"+S[s]+"$";var C=T++;S[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=T++;S[j]="(?:~>?)";var _=T++;S[_]="(\\s*)"+S[j]+"\\s+",R[_]=new RegExp(S[_],"g");var K=T++;S[K]="^"+S[j]+S[i]+"$";var A=T++;S[A]="^"+S[j]+S[s]+"$";var $=T++;S[$]="(?:\\^)";var O=T++;S[O]="(\\s*)"+S[$]+"\\s+",R[O]=new RegExp(S[O],"g");var F=T++;S[F]="^"+S[$]+S[i]+"$";var H=T++;S[H]="^"+S[$]+S[s]+"$";var V=T++;S[V]="^"+S[l]+"\\s*("+d+")$|^$";var ae=T++;S[ae]="^"+S[l]+"\\s*("+t+")$|^$";var pe=T++;S[pe]="(\\s*)"+S[l]+"\\s*("+d+"|"+S[i]+")",R[pe]=new RegExp(S[pe],"g");var re=T++;S[re]="^\\s*("+S[i]+")\\s+-\\s+("+S[i]+")\\s*$";var ce=T++;S[ce]="^\\s*("+S[s]+")\\s+-\\s+("+S[s]+")\\s*$";var ue=T++;S[ue]="(<|>)?=?\\s*\\*";for(var Se=0;Se<35;Se++)D(Se,S[Se]),R[Se]||(R[Se]=new RegExp(S[Se]));function G(oe,ve){if(oe instanceof X)return oe;if(typeof oe!="string"||oe.length>M||!(ve?R[r]:R[p]).test(oe))return null;try{return new X(oe,ve)}catch{return null}}function X(oe,ve){if(oe instanceof X){if(oe.loose===ve)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof X))return new X(oe,ve);D("SemVer",oe,ve),this.loose=ve;var be=oe.trim().match(ve?R[r]:R[p]);if(!be)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>y||this.major<0)throw new TypeError("Invalid major version");if(this.minor>y||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>y||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(He){if(/^[0-9]+$/.test(He)){var je=+He;if(je>=0&&je<y)return je}return He}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=G,e.valid=function(oe,ve){var be=G(oe,ve);return be?be.version:null},e.clean=function(oe,ve){var be=G(oe.trim().replace(/^[=v]+/,""),ve);return be?be.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(oe){return D("SemVer.compare",this.version,this.loose,oe),oe instanceof X||(oe=new X(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},X.prototype.compareMain=function(oe){return oe instanceof X||(oe=new X(oe,this.loose)),de(this.major,oe.major)||de(this.minor,oe.minor)||de(this.patch,oe.patch)},X.prototype.comparePre=function(oe){if(oe instanceof X||(oe=new X(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var ve=0;do{var be=this.prerelease[ve],He=oe.prerelease[ve];if(D("prerelease compare",ve,be,He),be===void 0&&He===void 0)return 0;if(He===void 0)return 1;if(be===void 0)return-1;if(be!==He)return de(be,He)}while(++ve)},X.prototype.inc=function(oe,ve){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,ve,be,He){typeof be=="string"&&(He=be,be=void 0);try{return new X(oe,be).inc(ve,He).version}catch{return null}},e.diff=function(oe,ve){if(Pe(oe,ve))return null;var be=G(oe),He=G(ve);if(be.prerelease.length||He.prerelease.length){for(var je in be)if((je==="major"||je==="minor"||je==="patch")&&be[je]!==He[je])return"pre"+je;return"prerelease"}for(var je in be)if((je==="major"||je==="minor"||je==="patch")&&be[je]!==He[je])return je},e.compareIdentifiers=de;var J=/^[0-9]+$/;function de(oe,ve){var be=J.test(oe),He=J.test(ve);return be&&He&&(oe=+oe,ve=+ve),be&&!He?-1:He&&!be?1:oe<ve?-1:oe>ve?1:0}function ye(oe,ve,be){return new X(oe,be).compare(new X(ve,be))}function Fe(oe,ve,be){return ye(oe,ve,be)>0}function ze(oe,ve,be){return ye(oe,ve,be)<0}function Pe(oe,ve,be){return ye(oe,ve,be)===0}function Ie(oe,ve,be){return ye(oe,ve,be)!==0}function we(oe,ve,be){return ye(oe,ve,be)>=0}function se(oe,ve,be){return ye(oe,ve,be)<=0}function le(oe,ve,be,He){var je;switch(ve){case"===":typeof oe=="object"&&(oe=oe.version),typeof be=="object"&&(be=be.version),je=oe===be;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof be=="object"&&(be=be.version),je=oe!==be;break;case"":case"=":case"==":je=Pe(oe,be,He);break;case"!=":je=Ie(oe,be,He);break;case">":je=Fe(oe,be,He);break;case">=":je=we(oe,be,He);break;case"<":je=ze(oe,be,He);break;case"<=":je=se(oe,be,He);break;default:throw new TypeError("Invalid operator: "+ve)}return je}function Z(oe,ve){if(oe instanceof Z){if(oe.loose===ve)return oe;oe=oe.value}if(!(this instanceof Z))return new Z(oe,ve);D("comparator",oe,ve),this.loose=ve,this.parse(oe),this.semver===I?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(oe,ve){return de(ve,oe)},e.major=function(oe,ve){return new X(oe,ve).major},e.minor=function(oe,ve){return new X(oe,ve).minor},e.patch=function(oe,ve){return new X(oe,ve).patch},e.compare=ye,e.compareLoose=function(oe,ve){return ye(oe,ve,!0)},e.rcompare=function(oe,ve,be){return ye(ve,oe,be)},e.sort=function(oe,ve){return oe.sort(function(be,He){return e.compare(be,He,ve)})},e.rsort=function(oe,ve){return oe.sort(function(be,He){return e.rcompare(be,He,ve)})},e.gt=Fe,e.lt=ze,e.eq=Pe,e.neq=Ie,e.gte=we,e.lte=se,e.cmp=le,e.Comparator=Z;var I={};function B(oe,ve){if(oe instanceof B)return oe.loose===ve?oe:new B(oe.raw,ve);if(oe instanceof Z)return new B(oe.value,ve);if(!(this instanceof B))return new B(oe,ve);if(this.loose=ve,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function W(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function q(oe,ve,be,He,je,it,Xe,et,nt,Ne,rt,Q,Y){return((ve=W(be)?"":W(He)?">="+be+".0.0":W(je)?">="+be+"."+He+".0":">="+ve)+" "+(et=W(nt)?"":W(Ne)?"<"+(+nt+1)+".0.0":W(rt)?"<"+nt+"."+(+Ne+1)+".0":Q?"<="+nt+"."+Ne+"."+rt+"-"+Q:"<="+et)).trim()}function ee(oe,ve){for(var be=0;be<oe.length;be++)if(!oe[be].test(ve))return!1;if(ve.prerelease.length){for(be=0;be<oe.length;be++)if(D(oe[be].semver),oe[be].semver!==I&&oe[be].semver.prerelease.length>0){var He=oe[be].semver;if(He.major===ve.major&&He.minor===ve.minor&&He.patch===ve.patch)return!0}return!1}return!0}function fe(oe,ve,be){try{ve=new B(ve,be)}catch{return!1}return ve.test(oe)}function De(oe,ve,be,He){var je,it,Xe,et,nt;switch(oe=new X(oe,He),ve=new B(ve,He),be){case">":je=Fe,it=se,Xe=ze,et=">",nt=">=";break;case"<":je=ze,it=we,Xe=Fe,et="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(fe(oe,ve,He))return!1;for(var Ne=0;Ne<ve.set.length;++Ne){var rt=ve.set[Ne],Q=null,Y=null;if(rt.forEach(function(ge){ge.semver===I&&(ge=new Z(">=0.0.0")),Q=Q||ge,Y=Y||ge,je(ge.semver,Q.semver,He)?Q=ge:Xe(ge.semver,Y.semver,He)&&(Y=ge)}),Q.operator===et||Q.operator===nt||(!Y.operator||Y.operator===et)&&it(oe,Y.semver)||Y.operator===nt&&Xe(oe,Y.semver))return!1}return!0}Z.prototype.parse=function(oe){var ve=this.loose?R[V]:R[ae],be=oe.match(ve);if(!be)throw new TypeError("Invalid comparator: "+oe);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new X(be[2],this.loose):this.semver=I},Z.prototype.toString=function(){return this.value},Z.prototype.test=function(oe){return D("Comparator.test",oe,this.loose),this.semver===I||(typeof oe=="string"&&(oe=new X(oe,this.loose)),le(oe,this.operator,this.semver,this.loose))},Z.prototype.intersects=function(oe,ve){if(!(oe instanceof Z))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new B(oe.value,ve),fe(this.value,be,ve);if(oe.operator==="")return be=new B(this.value,ve),fe(oe.semver,be,ve);var He=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),it=this.semver.version===oe.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),et=le(this.semver,"<",oe.semver,ve)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),nt=le(this.semver,">",oe.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return He||je||it&&Xe||et||nt},e.Range=B,B.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},B.prototype.toString=function(){return this.range},B.prototype.parseRange=function(oe){var ve=this.loose;oe=oe.trim(),D("range",oe,ve);var be=ve?R[ce]:R[re];oe=oe.replace(be,q),D("hyphen replace",oe),oe=oe.replace(R[pe],"$1$2$3"),D("comparator trim",oe,R[pe]),oe=(oe=(oe=oe.replace(R[_],"$1~")).replace(R[O],"$1^")).split(/\s+/).join(" ");var He=ve?R[V]:R[ae],je=oe.split(" ").map(function(it){return function(Xe,et){return D("comp",Xe),Xe=function(nt,Ne){return nt.trim().split(/\s+/).map(function(rt){return function(Q,Y){D("caret",Q,Y);var ge=Y?R[H]:R[F];return Q.replace(ge,function(We,$e,Qe,Ke,tt){var at;return D("caret",Q,We,$e,Qe,Ke,tt),W($e)?at="":W(Qe)?at=">="+$e+".0.0 <"+(+$e+1)+".0.0":W(Ke)?at=$e==="0"?">="+$e+"."+Qe+".0 <"+$e+"."+(+Qe+1)+".0":">="+$e+"."+Qe+".0 <"+(+$e+1)+".0.0":tt?(D("replaceCaret pr",tt),tt.charAt(0)!=="-"&&(tt="-"+tt),at=$e==="0"?Qe==="0"?">="+$e+"."+Qe+"."+Ke+tt+" <"+$e+"."+Qe+"."+(+Ke+1):">="+$e+"."+Qe+"."+Ke+tt+" <"+$e+"."+(+Qe+1)+".0":">="+$e+"."+Qe+"."+Ke+tt+" <"+(+$e+1)+".0.0"):(D("no pr"),at=$e==="0"?Qe==="0"?">="+$e+"."+Qe+"."+Ke+" <"+$e+"."+Qe+"."+(+Ke+1):">="+$e+"."+Qe+"."+Ke+" <"+$e+"."+(+Qe+1)+".0":">="+$e+"."+Qe+"."+Ke+" <"+(+$e+1)+".0.0"),D("caret return",at),at})}(rt,Ne)}).join(" ")}(Xe,et),D("caret",Xe),Xe=function(nt,Ne){return nt.trim().split(/\s+/).map(function(rt){return function(Q,Y){var ge=Y?R[A]:R[K];return Q.replace(ge,function(We,$e,Qe,Ke,tt){var at;return D("tilde",Q,We,$e,Qe,Ke,tt),W($e)?at="":W(Qe)?at=">="+$e+".0.0 <"+(+$e+1)+".0.0":W(Ke)?at=">="+$e+"."+Qe+".0 <"+$e+"."+(+Qe+1)+".0":tt?(D("replaceTilde pr",tt),tt.charAt(0)!=="-"&&(tt="-"+tt),at=">="+$e+"."+Qe+"."+Ke+tt+" <"+$e+"."+(+Qe+1)+".0"):at=">="+$e+"."+Qe+"."+Ke+" <"+$e+"."+(+Qe+1)+".0",D("tilde return",at),at})}(rt,Ne)}).join(" ")}(Xe,et),D("tildes",Xe),Xe=function(nt,Ne){return D("replaceXRanges",nt,Ne),nt.split(/\s+/).map(function(rt){return function(Q,Y){Q=Q.trim();var ge=Y?R[P]:R[f];return Q.replace(ge,function(We,$e,Qe,Ke,tt,at){D("xRange",Q,We,$e,Qe,Ke,tt,at);var Et=W(Qe),Ct=Et||W(Ke),It=Ct||W(tt);return $e==="="&&It&&($e=""),Et?We=$e===">"||$e==="<"?"<0.0.0":"*":$e&&It?(Ct&&(Ke=0),It&&(tt=0),$e===">"?($e=">=",Ct?(Qe=+Qe+1,Ke=0,tt=0):It&&(Ke=+Ke+1,tt=0)):$e==="<="&&($e="<",Ct?Qe=+Qe+1:Ke=+Ke+1),We=$e+Qe+"."+Ke+"."+tt):Ct?We=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":It&&(We=">="+Qe+"."+Ke+".0 <"+Qe+"."+(+Ke+1)+".0"),D("xRange return",We),We})}(rt,Ne)}).join(" ")}(Xe,et),D("xrange",Xe),Xe=function(nt,Ne){return D("replaceStars",nt,Ne),nt.trim().replace(R[ue],"")}(Xe,et),D("stars",Xe),Xe}(it,ve)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(it){return!!it.match(He)})),je=je.map(function(it){return new Z(it,ve)})},B.prototype.intersects=function(oe,ve){if(!(oe instanceof B))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(He){return oe.set.some(function(je){return je.every(function(it){return He.intersects(it,ve)})})})})},e.toComparators=function(oe,ve){return new B(oe,ve).set.map(function(be){return be.map(function(He){return He.value}).join(" ").trim().split(" ")})},B.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new X(oe,this.loose));for(var ve=0;ve<this.set.length;ve++)if(ee(this.set[ve],oe))return!0;return!1},e.satisfies=fe,e.maxSatisfying=function(oe,ve,be){var He=null,je=null;try{var it=new B(ve,be)}catch{return null}return oe.forEach(function(Xe){it.test(Xe)&&(He&&je.compare(Xe)!==-1||(je=new X(He=Xe,be)))}),He},e.minSatisfying=function(oe,ve,be){var He=null,je=null;try{var it=new B(ve,be)}catch{return null}return oe.forEach(function(Xe){it.test(Xe)&&(He&&je.compare(Xe)!==1||(je=new X(He=Xe,be)))}),He},e.validRange=function(oe,ve){try{return new B(oe,ve).range||"*"}catch{return null}},e.ltr=function(oe,ve,be){return De(oe,ve,"<",be)},e.gtr=function(oe,ve,be){return De(oe,ve,">",be)},e.outside=De,e.prerelease=function(oe,ve){var be=G(oe,ve);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(oe,ve,be){return oe=new B(oe,be),ve=new B(ve,be),oe.intersects(ve)},e.coerce=function(oe){if(oe instanceof X)return oe;if(typeof oe!="string")return null;var ve=oe.match(R[C]);return ve==null?null:G((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,n(1))},function(te,e){var n,k,D=te.exports={};function M(){throw new Error("setTimeout has not been defined")}function y(){throw new Error("clearTimeout has not been defined")}function R(o){if(n===setTimeout)return setTimeout(o,0);if((n===M||!n)&&setTimeout)return n=setTimeout,setTimeout(o,0);try{return n(o,0)}catch{try{return n.call(null,o,0)}catch{return n.call(this,o,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:M}catch{n=M}try{k=typeof clearTimeout=="function"?clearTimeout:y}catch{k=y}})();var S,T=[],N=!1,w=-1;function h(){N&&S&&(N=!1,S.length?T=S.concat(T):w=-1,T.length&&v())}function v(){if(!N){var o=R(h);N=!0;for(var u=T.length;u;){for(S=T,T=[];++w<u;)S&&S[w].run();w=-1,u=T.length}S=null,N=!1,function(g){if(k===clearTimeout)return clearTimeout(g);if((k===y||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(g);try{k(g)}catch{try{return k.call(null,g)}catch{return k.call(this,g)}}}(o)}}function m(o,u){this.fun=o,this.array=u}function a(){}D.nextTick=function(o){var u=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)u[g-1]=arguments[g];T.push(new m(o,u)),T.length!==1||N||R(v)},m.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=a,D.addListener=a,D.once=a,D.off=a,D.removeListener=a,D.removeAllListeners=a,D.emit=a,D.prependListener=a,D.prependOnceListener=a,D.listeners=function(o){return[]},D.binding=function(o){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(o){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(ke[114],Te([1,0,12,6]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(L){const p=L;return p?typeof p.read=="function":!1}e.isReadable=D;function M(L){const p=L;return p?[p.on,p.pause,p.resume,p.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=M;function y(L){const p=L;return p?M(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=y;function R(L,p){return new S(L,p)}e.newWriteableStream=R;class S{constructor(p,t){this.e=p,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(t=>t(p))}h(p){this.c.error.length===0?(0,n.onUnexpectedError)(p):this.c.error.slice(0).forEach(t=>t(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,t){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(p,t){if(this.a.destroyed)return;let d;switch(p){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const r=d.indexOf(t);r>=0&&d.splice(r,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function T(L,p){const t=[];let d;for(;(d=L.read())!==null;)t.push(d);return p(t)}e.consumeReadable=T;function N(L,p,t){const d=[];let r;for(;(r=L.read())!==null&&d.length<t;)d.push(r);return r===null&&d.length>0?p(d):{read:()=>{if(d.length>0)return d.shift();if(typeof r<"u"){const l=r;return r=void 0,l}return L.read()}}}e.peekReadable=N;function w(L,p){return new Promise((t,d)=>{const r=[];h(L,{onData:l=>{p&&r.push(l)},onError:l=>{p?d(l):t(void 0)},onEnd:()=>{t(p?p(r):void 0)}})})}e.consumeStream=w;function h(L,p){let t=!1;return L.on("error",d=>{t||p.onError(d)}),L.on("end",()=>{t||p.onEnd()}),L.on("data",d=>{t||p.onData(d)}),(0,k.toDisposable)(()=>t=!0)}e.listenStream=h;function v(L,p){return new Promise((t,d)=>{const r=new k.DisposableStore,l=[],c=s=>{if(l.push(s),l.length>p)return r.dispose(),L.pause(),t({stream:L,buffer:l,ended:!1})},b=s=>d(s),i=()=>t({stream:L,buffer:l,ended:!0});r.add((0,k.toDisposable)(()=>L.removeListener("error",b))),L.on("error",b),r.add((0,k.toDisposable)(()=>L.removeListener("end",i))),L.on("end",i),r.add((0,k.toDisposable)(()=>L.removeListener("data",c))),L.on("data",c)})}e.peekStream=v;function m(L,p){const t=R(p);return t.end(L),t}e.toStream=m;function a(){const L=R(()=>{throw new Error("not supported")});return L.end(),L}e.emptyStream=a;function o(L){let p=!1;return{read:()=>p?null:(p=!0,L)}}e.toReadable=o;function u(L,p,t){const d=R(t);return h(L,{onData:r=>d.write(p.data(r)),onError:r=>d.error(p.error?p.error(r):r),onEnd:()=>d.end()}),d}e.transform=u;function g(L,p,t){let d=!1;return{read:()=>{const r=p.read();return d?r:(d=!0,r!==null?t([L,r]):L)}}}e.prefixedReadable=g;function E(L,p,t){let d=!1;const r=R(t);return h(p,{onData:l=>d?r.write(l):(d=!0,r.write(t([L,l]))),onError:l=>r.error(l),onEnd:()=>{d||(d=!0,r.write(L)),r.end()}}),r}e.prefixedStream=E}),define(ke[23],Te([1,0,114]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer<"u";let D,M;class y{static alloc(s){return k?new y(Buffer.allocUnsafe(s)):new y(new Uint8Array(s))}static wrap(s){return k&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new y(s)}static fromString(s,f){return!(f?.dontUseNodeBuffer||!1)&&k?new y(Buffer.from(s)):(D||(D=new TextEncoder),new y(D.encode(s)))}static fromByteArray(s){const f=y.alloc(s.length);for(let P=0,C=s.length;P<C;P++)f.buffer[P]=s[P];return f}static concat(s,f){if(typeof f>"u"){f=0;for(let j=0,_=s.length;j<_;j++)f+=s[j].byteLength}const P=y.alloc(f);let C=0;for(let j=0,_=s.length;j<_;j++){const K=s[j];P.set(K,C),C+=K.byteLength}return P}constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}clone(){const s=y.alloc(this.byteLength);return s.set(this),s}toString(){return k?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(s,f){return new y(this.buffer.subarray(s,f))}set(s,f){if(s instanceof y)this.buffer.set(s.buffer,f);else if(s instanceof Uint8Array)this.buffer.set(s,f);else if(s instanceof ArrayBuffer)this.buffer.set(new Uint8Array(s),f);else if(ArrayBuffer.isView(s))this.buffer.set(new Uint8Array(s.buffer,s.byteOffset,s.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(s){return T(this.buffer,s)}writeUInt32BE(s,f){N(this.buffer,s,f)}readUInt32LE(s){return w(this.buffer,s)}writeUInt32LE(s,f){h(this.buffer,s,f)}readUInt8(s){return v(this.buffer,s)}writeUInt8(s,f){m(this.buffer,s,f)}}e.VSBuffer=y;function R(i,s){return i[s+0]<<0>>>0|i[s+1]<<8>>>0}e.readUInt16LE=R;function S(i,s,f){i[f+0]=s&255,s=s>>>8,i[f+1]=s&255}e.writeUInt16LE=S;function T(i,s){return i[s]*2**24+i[s+1]*2**16+i[s+2]*2**8+i[s+3]}e.readUInt32BE=T;function N(i,s,f){i[f+3]=s,s=s>>>8,i[f+2]=s,s=s>>>8,i[f+1]=s,s=s>>>8,i[f]=s}e.writeUInt32BE=N;function w(i,s){return i[s+0]<<0>>>0|i[s+1]<<8>>>0|i[s+2]<<16>>>0|i[s+3]<<24>>>0}e.readUInt32LE=w;function h(i,s,f){i[f+0]=s&255,s=s>>>8,i[f+1]=s&255,s=s>>>8,i[f+2]=s&255,s=s>>>8,i[f+3]=s&255}e.writeUInt32LE=h;function v(i,s){return i[s]}e.readUInt8=v;function m(i,s,f){i[f]=s}e.writeUInt8=m;function a(i){return n.consumeReadable(i,s=>y.concat(s))}e.readableToBuffer=a;function o(i){return n.toReadable(i)}e.bufferToReadable=o;function u(i){return n.consumeStream(i,s=>y.concat(s))}e.streamToBuffer=u;async function g(i){return i.ended?y.concat(i.buffer):y.concat([...i.buffer,await u(i.stream)])}e.bufferedStreamToBuffer=g;function E(i){return n.toStream(i,s=>y.concat(s))}e.bufferToStream=E;function L(i){return n.transform(i,{data:s=>typeof s=="string"?y.fromString(s):y.wrap(s)},s=>y.concat(s))}e.streamToBufferReadableStream=L;function p(i){return n.newWriteableStream(s=>y.concat(s),i)}e.newWriteableBufferStream=p;function t(i,s){return n.prefixedReadable(i,s,f=>y.concat(f))}e.prefixedBufferReadable=t;function d(i,s){return n.prefixedStream(i,s,f=>y.concat(f))}e.prefixedBufferStream=d;function r(i){let s=0,f=0,P=0;const C=new Uint8Array(Math.floor(i.length/4*3)),j=K=>{switch(f){case 3:C[P++]=s|K,f=0;break;case 2:C[P++]=s|K>>>2,s=K<<6,f=3;break;case 1:C[P++]=s|K>>>4,s=K<<4,f=2;break;default:s=K<<2,f=1}};for(let K=0;K<i.length;K++){const A=i.charCodeAt(K);if(A>=65&&A<=90)j(A-65);else if(A>=97&&A<=122)j(A-97+26);else if(A>=48&&A<=57)j(A-48+52);else if(A===43||A===45)j(62);else if(A===47||A===95)j(63);else{if(A===61)break;throw new SyntaxError(`Unexpected base64 character ${i[K]}`)}}const _=P;for(;f>0;)j(0);return y.wrap(C).slice(0,_)}e.decodeBase64=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:i},s=!0,f=!1){const P=f?c:l;let C="";const j=i.byteLength%3;let _=0;for(;_<i.byteLength-j;_+=3){const K=i[_+0],A=i[_+1],$=i[_+2];C+=P[K>>>2],C+=P[(K<<4|A>>>4)&63],C+=P[(A<<2|$>>>6)&63],C+=P[$&63]}if(j===1){const K=i[_+0];C+=P[K>>>2],C+=P[K<<4&63],s&&(C+="==")}else if(j===2){const K=i[_+0],A=i[_+1];C+=P[K>>>2],C+=P[(K<<4|A>>>4)&63],C+=P[A<<2&63],s&&(C+="=")}return C}e.encodeBase64=b}),define(ke[115],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ke[38],Te([1,0,84]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var k;(function(y){function R(S){return S&&typeof S=="object"&&typeof S.id=="string"}y.isThemeColor=R})(k=e.ThemeColor||(e.ThemeColor={}));function D(y){return{id:y}}e.themeColorFromId=D;var M;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function S(g){const E=R.exec(g.id);if(!E)return S(n.Codicon.error);const[,L,p]=E,t=["codicon","codicon-"+L];return p&&t.push("codicon-modifier-"+p.substring(1)),t}y.asClassNameArray=S;function T(g){return S(g).join(" ")}y.asClassName=T;function N(g){return"."+S(g).join(".")}y.asCSSSelector=N;function w(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||k.isThemeColor(g.color))}y.isThemeIcon=w;const h=new RegExp(`^\\$\\((${y.iconNameExpression}(?:${y.iconModifierExpression})?)\\)$`);function v(g){const E=h.exec(g);if(!E)return;const[,L]=E;return{id:L}}y.fromString=v;function m(g){return{id:g}}y.fromId=m;function a(g,E){let L=g.id;const p=L.lastIndexOf("~");return p!==-1&&(L=L.substring(0,p)),E&&(L=`${L}~${E}`),{id:L}}y.modify=a;function o(g){const E=g.id.lastIndexOf("~");if(E!==-1)return g.id.substring(E+1)}y.getModifier=o;function u(g,E){return g.id===E.id&&g.color?.id===E.color?.id}y.isEqual=u})(M=e.ThemeIcon||(e.ThemeIcon={}))}),define(ke[34],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(D){return n.test(D)}e.isUUID=k,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(R){for(let S=0;S<R.length;S++)R[S]=Math.floor(Math.random()*256);return R};const M=new Uint8Array(16),y=[];for(let R=0;R<256;R++)y.push(R.toString(16).padStart(2,"0"));return function(){D(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let S=0,T="";return T+=y[M[S++]],T+=y[M[S++]],T+=y[M[S++]],T+=y[M[S++]],T+="-",T+=y[M[S++]],T+=y[M[S++]],T+="-",T+=y[M[S++]],T+=y[M[S++]],T+="-",T+=y[M[S++]],T+=y[M[S++]],T+="-",T+=y[M[S++]],T+=y[M[S++]],T+=y[M[S++]],T+=y[M[S++]],T+=y[M[S++]],T+=y[M[S++]],T}}()}),define(ke[116],Te([1,0,16,34]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function D(R){return{id:(0,k.generateUuid)(),asString:async()=>R,asFile:()=>{},value:typeof R=="string"?R:void 0}}e.createStringDataTransferItem=D;function M(R,S,T){return{id:(0,k.generateUuid)(),asString:async()=>"",asFile:()=>({name:R,uri:S,data:T}),value:void 0}}e.createFileDataTransferItem=M;class y{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,T){const N=this.a.get(S);N?N.push(T):this.a.set(this.b(S),[T])}replace(S,T){this.a.set(this.b(S),[T])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,T]of this.a.entries())for(const N of T)yield[S,N]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[T,N]of this.entries())S(N,T)}b(S){return S.toLowerCase()}}e.VSDataTransfer=y,e.UriList=Object.freeze({create:R=>(0,n.distinct)(R.map(S=>S.toString())).join(`\r
`),split:R=>R.split(`\r
`),parse:R=>e.UriList.split(R).filter(S=>!S.startsWith("#"))})}),define(ke[117],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[118],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(n=e.IndentAction||(e.IndentAction={}));class k{constructor(R){if(this.e=null,this.f=!1,this.open=R.open,this.close=R.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(R.notIn))for(let S=0,T=R.notIn.length;S<T;S++)switch(R.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(R){switch(R){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(R,S){if(R.getTokenCount()===0)return!0;const T=R.findTokenIndexAtOffset(S-2),N=R.getStandardTokenType(T);return this.isOK(N)}g(R,S){for(let T=R;T<=S;T++){const N=String.fromCharCode(T);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=k;class D{constructor(R){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of R)M(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),M(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),M(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),M(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&M(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=D;function M(y,R,S){y.has(R)?y.get(R).push(S):y.set(R,[S])}}),define(ke[119],Te([13,14]),function(te,e){return te.create("vs/base/common/actions",e)}),define(ke[120],Te([13,14]),function(te,e){return te.create("vs/base/common/date",e)}),define(ke[121],Te([1,0,120]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,D=k*60,M=D*24,y=M*7,R=M*30,S=M*365;function T(w,h,v,m){typeof w!="number"&&(w=w.getTime());const a=Math.round((new Date().getTime()-w)/1e3);if(a<-30)return(0,n.localize)(0,null,T(new Date().getTime()+a*1e3,!1));if(!m&&a<30)return(0,n.localize)(1,null);let o;return a<k?(o=a,h?o===1?v?(0,n.localize)(2,null,o):(0,n.localize)(3,null,o):v?(0,n.localize)(4,null,o):(0,n.localize)(5,null,o):o===1?v?(0,n.localize)(6,null,o):(0,n.localize)(7,null,o):v?(0,n.localize)(8,null,o):(0,n.localize)(9,null,o)):a<D?(o=Math.floor(a/k),h?o===1?v?(0,n.localize)(10,null,o):(0,n.localize)(11,null,o):v?(0,n.localize)(12,null,o):(0,n.localize)(13,null,o):o===1?v?(0,n.localize)(14,null,o):(0,n.localize)(15,null,o):v?(0,n.localize)(16,null,o):(0,n.localize)(17,null,o)):a<M?(o=Math.floor(a/D),h?o===1?v?(0,n.localize)(18,null,o):(0,n.localize)(19,null,o):v?(0,n.localize)(20,null,o):(0,n.localize)(21,null,o):o===1?v?(0,n.localize)(22,null,o):(0,n.localize)(23,null,o):v?(0,n.localize)(24,null,o):(0,n.localize)(25,null,o)):a<y?(o=Math.floor(a/M),h?o===1?(0,n.localize)(26,null,o):(0,n.localize)(27,null,o):o===1?(0,n.localize)(28,null,o):(0,n.localize)(29,null,o)):a<R?(o=Math.floor(a/y),h?o===1?v?(0,n.localize)(30,null,o):(0,n.localize)(31,null,o):v?(0,n.localize)(32,null,o):(0,n.localize)(33,null,o):o===1?v?(0,n.localize)(34,null,o):(0,n.localize)(35,null,o):v?(0,n.localize)(36,null,o):(0,n.localize)(37,null,o)):a<S?(o=Math.floor(a/R),h?o===1?v?(0,n.localize)(38,null,o):(0,n.localize)(39,null,o):v?(0,n.localize)(40,null,o):(0,n.localize)(41,null,o):o===1?v?(0,n.localize)(42,null,o):(0,n.localize)(43,null,o):v?(0,n.localize)(44,null,o):(0,n.localize)(45,null,o)):(o=Math.floor(a/S),h?o===1?v?(0,n.localize)(46,null,o):(0,n.localize)(47,null,o):v?(0,n.localize)(48,null,o):(0,n.localize)(49,null,o):o===1?v?(0,n.localize)(50,null,o):(0,n.localize)(51,null,o):v?(0,n.localize)(52,null,o):(0,n.localize)(53,null,o))}e.fromNow=T;function N(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(ke[122],Te([13,14]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(ke[39],Te([1,0,16,9,122]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(w,h){return h&&(w.stack||w.stacktrace)?D.localize(0,null,R(w),y(w.stack)||y(w.stacktrace)):R(w)}function y(w){return Array.isArray(w)?w.join(`
`):w}function R(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?D.localize(1,null,w.message):w.message||D.localize(2,null)}function S(w=null,h=!1){if(!w)return D.localize(3,null);if(Array.isArray(w)){const v=n.coalesce(w),m=S(v[0],h);return v.length>1?D.localize(4,null,m,v.length):m}if(k.isString(w))return w;if(w.detail){const v=w.detail;if(v.error)return M(v.error,h);if(v.exception)return M(v.exception,h)}return w.stack?M(w,h):w.message?w.message:D.localize(5,null)}e.toErrorMessage=S;function T(w){const h=w;return h instanceof Error&&Array.isArray(h.actions)}e.isErrorWithActions=T;function N(w,h){let v;return typeof w=="string"?v=new Error(w):v=w,v.actions=h,v}e.createErrorWithActions=N}),define(ke[123],Te([1,0,85,19]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new n.Lazy(()=>{const s=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:s,collatorIsNumeric:s.resolvedOptions().numeric}}),M=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(s,f,P=!1){const C=s||"",j=f||"",_=D.value.collator.compare(C,j);return D.value.collatorIsNumeric&&_===0&&C!==j?C<j?-1:1:_}e.compareFileNames=R;function S(s,f){const P=M.value.collator;return s=s||"",f=f||"",L(P,s,f)}e.compareFileNamesDefault=S;function T(s,f){const P=M.value.collator;return s=s||"",f=f||"",r(s,f)||L(P,s,f)}e.compareFileNamesUpper=T;function N(s,f){const P=M.value.collator;return s=s||"",f=f||"",d(s,f)||L(P,s,f)}e.compareFileNamesLower=N;function w(s,f){return s=s||"",f=f||"",s===f?0:s<f?-1:1}e.compareFileNamesUnicode=w;function h(s,f){const[P,C]=g(s),[j,_]=g(f);let K=D.value.collator.compare(C,_);if(K===0){if(D.value.collatorIsNumeric&&C!==_)return C<_?-1:1;if(K=D.value.collator.compare(P,j),D.value.collatorIsNumeric&&K===0&&P!==j)return P<j?-1:1}return K}e.compareFileExtensions=h;function v(s,f){s=s||"",f=f||"";const P=E(s),C=E(f),j=M.value.collator,_=y.value.collator;return L(_,P,C)||L(j,s,f)}e.compareFileExtensionsDefault=v;function m(s,f){s=s||"",f=f||"";const P=E(s),C=E(f),j=M.value.collator,_=y.value.collator;return L(_,P,C)||r(s,f)||L(j,s,f)}e.compareFileExtensionsUpper=m;function a(s,f){s=s||"",f=f||"";const P=E(s),C=E(f),j=M.value.collator,_=y.value.collator;return L(_,P,C)||d(s,f)||L(j,s,f)}e.compareFileExtensionsLower=a;function o(s,f){s=s||"",f=f||"";const P=E(s).toLowerCase(),C=E(f).toLowerCase();return P!==C?P<C?-1:1:s!==f?s<f?-1:1:0}e.compareFileExtensionsUnicode=o;const u=/^(.*?)(\.([^.]*))?$/;function g(s,f=!1){const P=s?u.exec(s):[];let C=[P&&P[1]||"",P&&P[3]||""];return f&&(!C[0]&&C[1]||C[0]&&C[0].charAt(0)===".")&&(C=[C[0]+"."+C[1],""]),C}function E(s){const f=s?u.exec(s):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function L(s,f,P){const C=s.compare(f,P);return C!==0?C:f.length!==P.length?f.length<P.length?-1:1:0}function p(s){const f=s.charAt(0);return f.toLocaleUpperCase()!==f}function t(s){const f=s.charAt(0);return f.toLocaleLowerCase()!==f}function d(s,f){return p(s)&&t(f)?-1:t(s)&&p(f)?1:0}function r(s,f){return t(s)&&p(f)?-1:p(s)&&t(f)?1:0}function l(s,f,P=!1){return P||(s=s&&s.toLowerCase(),f=f&&f.toLowerCase()),s===f?0:s<f?-1:1}function c(s,f,P=!1){const C=s.split(k.sep),j=f.split(k.sep),_=C.length-1,K=j.length-1;let A,$;for(let O=0;;O++){if(A=_===O,$=K===O,A&&$)return R(C[O],j[O],P);if(A)return-1;if($)return 1;const F=l(C[O],j[O],P);if(F!==0)return F}}e.comparePaths=c;function b(s,f,P){const C=s.toLowerCase(),j=f.toLowerCase(),_=i(s,f,P);if(_)return _;const K=C.endsWith(P),A=j.endsWith(P);if(K!==A)return K?-1:1;const $=R(C,j);return $!==0?$:C.localeCompare(j)}e.compareAnything=b;function i(s,f,P){const C=s.toLowerCase(),j=f.toLowerCase(),_=C.startsWith(P),K=j.startsWith(P);if(_!==K)return _?-1:1;if(_&&K){if(C.length<j.length)return-1;if(C.length>j.length)return 1}return 0}e.compareByPrefix=i}),define(ke[65],Te([1,0,19]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(N){const w=(0,n.extname)(N),h=k[w.toLowerCase()];return h!==void 0?h:y(N)}e.getMediaOrTextMime=M;function y(N){const w=(0,n.extname)(N);return D[w.toLowerCase()]}e.getMediaMime=y;function R(N){for(const w in D)if(D[w]===N)return w}e.getExtensionForMimeType=R;const S=/^(.+)\/(.+?)(;.+)?$/;function T(N,w){const h=S.exec(N);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:w?void 0:N}e.normalizeMimeType=T}),define(ke[124],Te([1,0,4,6,119]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class M extends k.Disposable{constructor(h,v="",m="",a=!0,o){super(),this.h=this.B(new n.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=h,this.m=v,this.u=m,this.w=a,this.C=o}get id(){return this.j}get label(){return this.m}set label(h){this.D(h)}D(h){this.m!==h&&(this.m=h,this.h.fire({label:h}))}get tooltip(){return this.n||""}set tooltip(h){this.F(h)}F(h){this.n!==h&&(this.n=h,this.h.fire({tooltip:h}))}get class(){return this.u}set class(h){this.G(h)}G(h){this.u!==h&&(this.u=h,this.h.fire({class:h}))}get enabled(){return this.w}set enabled(h){this.H(h)}H(h){this.w!==h&&(this.w=h,this.h.fire({enabled:h}))}get checked(){return this.z}set checked(h){this.I(h)}I(h){this.z!==h&&(this.z=h,this.h.fire({checked:h}))}async run(h,v){this.C&&await this.C(h)}}e.Action=M;class y extends k.Disposable{constructor(){super(...arguments),this.f=this.B(new n.Emitter),this.onWillRun=this.f.event,this.h=this.B(new n.Emitter),this.onDidRun=this.h.event}async run(h,v){if(!h.enabled)return;this.f.fire({action:h});let m;try{await this.runAction(h,v)}catch(a){m=a}this.h.fire({action:h,error:m})}async runAction(h,v){await h.run(v)}}e.ActionRunner=y;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let v=[];for(const m of h)m.length&&(v.length?v=[...v,new R,...m]:v=m);return v}async run(){}}R.ID="vs.actions.separator",e.Separator=R;class S{get actions(){return this.a}constructor(h,v,m,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=v,this.class=a,this.a=m}async run(){}}e.SubmenuAction=S;class T extends M{constructor(){super(T.ID,D.localize(0,null),void 0,!1)}}T.ID="vs.actions.empty",e.EmptySubmenuAction=T;function N(w){return{id:w.id,label:w.label,class:void 0,enabled:w.enabled??!0,checked:w.checked??!1,run:async()=>w.run(),tooltip:w.label}}e.toAction=N}),define(ke[40],Te([1,0,19,20,10,9]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(c){return c===47||c===92}e.isPathSeparator=y;function R(c){return c.replace(/[\\/]/g,n.posix.sep)}e.toSlashes=R;function S(c){return c.indexOf("/")===-1&&(c=R(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=S;function T(c,b=n.posix.sep){if(!c)return"";const i=c.length,s=c.charCodeAt(0);if(y(s)){if(y(c.charCodeAt(1))&&!y(c.charCodeAt(2))){let P=3;const C=P;for(;P<i&&!y(c.charCodeAt(P));P++);if(C!==P&&!y(c.charCodeAt(P+1))){for(P+=1;P<i;P++)if(y(c.charCodeAt(P)))return c.slice(0,P+1).replace(/[\\/]/g,b)}}return b}else if(u(s)&&c.charCodeAt(1)===58)return y(c.charCodeAt(2))?c.slice(0,2)+b:c.slice(0,2);let f=c.indexOf("://");if(f!==-1){for(f+=3;f<i;f++)if(y(c.charCodeAt(f)))return c.slice(0,f+1)}return""}e.getRoot=T;function N(c){if(!k.isWindows||!c||c.length<5)return!1;let b=c.charCodeAt(0);if(b!==92||(b=c.charCodeAt(1),b!==92))return!1;let i=2;const s=i;for(;i<c.length&&(b=c.charCodeAt(i),b!==92);i++);return!(s===i||(b=c.charCodeAt(i+1),isNaN(b)||b===92))}e.isUNC=N;const w=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(c,b=k.isWindows){const i=b?w:h;return!(!c||c.length===0||/^\s+$/.test(c)||(i.lastIndex=0,i.test(c))||b&&v.test(c)||c==="."||c===".."||b&&c[c.length-1]==="."||b&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=m;function a(c,b,i){const s=c===b;return!i||s?s:!c||!b?!1:(0,D.equalsIgnoreCase)(c,b)}e.isEqual=a;function o(c,b,i,s=n.sep){if(c===b)return!0;if(!c||!b||b.length>c.length)return!1;if(i){if(!(0,D.startsWithIgnoreCase)(c,b))return!1;if(b.length===c.length)return!0;let P=b.length;return b.charAt(b.length-1)===s&&P--,c.charAt(P)===s}return b.charAt(b.length-1)!==s&&(b+=s),c.indexOf(b)===0}e.isEqualOrParent=o;function u(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=u;function g(c,b){return k.isWindows&&c.endsWith(":")&&(c+=n.sep),(0,n.isAbsolute)(c)||(c=(0,n.join)(b,c)),c=(0,n.normalize)(c),k.isWindows?(c=(0,D.rtrim)(c,n.sep),c.endsWith(":")&&(c+=n.sep)):(c=(0,D.rtrim)(c,n.sep),c||(c=n.sep)),c}e.sanitizeFilePath=g;function E(c){const b=(0,n.normalize)(c);return k.isWindows?c.length>3?!1:L(b)&&(c.length===2||b.charCodeAt(2)===92):b===n.posix.sep}e.isRootOrDriveLetter=E;function L(c,b=k.isWindows){return b?u(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=L;function p(c){return L(c)?c[0]:void 0}e.getDriveLetter=p;function t(c,b,i){return b.length>c.length?-1:c===b?0:(i&&(c=c.toLowerCase(),b=b.toLowerCase()),c.indexOf(b))}e.indexOfPath=t;function d(c){const b=c.split(":");let i,s,f;for(const P of b){const C=Number(P);(0,M.isNumber)(C)?s===void 0?s=C:f===void 0&&(f=C):i=i?[i,P].join(":"):P}if(!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:s!==void 0?s:void 0,column:f!==void 0?f:s!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function l(c,b,i=8){let s="";for(let P=0;P<i;P++)s+=r.charAt(Math.floor(Math.random()*r.length));let f;return b?f=`${b}-${s}`:f=s,c?(0,n.join)(c,f):f}e.randomPath=l}),define(ke[125],Te([1,0,28,10]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...Z){return function(I,B){for(let W=0,q=Z.length;W<q;W++){const ee=Z[W](I,B);if(ee)return ee}return null}}e.or=D,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(Z,I,B){if(!B||B.length<I.length)return null;let W;return Z?W=k.startsWithIgnoreCase(B,I):W=B.indexOf(I)===0,W?I.length>0?[{start:0,end:I.length}]:[]:null}function y(Z,I){const B=I.toLowerCase().indexOf(Z.toLowerCase());return B===-1?null:[{start:B,end:B+Z.length}]}e.matchesContiguousSubString=y;function R(Z,I){return S(Z.toLowerCase(),I.toLowerCase(),0,0)}e.matchesSubString=R;function S(Z,I,B,W){if(B===Z.length)return[];if(W===I.length)return null;if(Z[B]===I[W]){let q=null;return(q=S(Z,I,B+1,W+1))?u({start:W,end:W+1},q):null}return S(Z,I,B,W+1)}function T(Z){return 97<=Z&&Z<=122}function N(Z){return 65<=Z&&Z<=90}e.isUpper=N;function w(Z){return 48<=Z&&Z<=57}function h(Z){return Z===32||Z===9||Z===10||Z===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>v.add(Z.charCodeAt(0)));function m(Z){return h(Z)||v.has(Z)}function a(Z,I){return Z===I||m(Z)&&m(I)}function o(Z){return T(Z)||N(Z)||w(Z)}function u(Z,I){return I.length===0?I=[Z]:Z.end===I[0].start?I[0].start=Z.start:I.unshift(Z),I}function g(Z,I){for(let B=I;B<Z.length;B++){const W=Z.charCodeAt(B);if(N(W)||w(W)||B>0&&!o(Z.charCodeAt(B-1)))return B}return Z.length}function E(Z,I,B,W){if(B===Z.length)return[];if(W===I.length)return null;if(Z[B]!==I[W].toLowerCase())return null;{let q=null,ee=W+1;for(q=E(Z,I,B+1,W+1);!q&&(ee=g(I,ee))<I.length;)q=E(Z,I,B+1,ee),ee++;return q===null?null:u({start:W,end:W+1},q)}}function L(Z){let I=0,B=0,W=0,q=0,ee=0;for(let be=0;be<Z.length;be++)ee=Z.charCodeAt(be),N(ee)&&I++,T(ee)&&B++,o(ee)&&W++,w(ee)&&q++;const fe=I/Z.length,De=B/Z.length,oe=W/Z.length,ve=q/Z.length;return{upperPercent:fe,lowerPercent:De,alphaPercent:oe,numericPercent:ve}}function p(Z){const{upperPercent:I,lowerPercent:B}=Z;return B===0&&I>.6}function t(Z){const{upperPercent:I,lowerPercent:B,alphaPercent:W,numericPercent:q}=Z;return B>.2&&I<.8&&W>.6&&q<.2}function d(Z){let I=0,B=0,W=0,q=0;for(let ee=0;ee<Z.length;ee++)W=Z.charCodeAt(ee),N(W)&&I++,T(W)&&B++,h(W)&&q++;return(I===0||B===0)&&q===0?Z.length<=30:I<=5}function r(Z,I){if(!I||(I=I.trim(),I.length===0)||!d(Z)||I.length>60)return null;const B=L(I);if(!t(B)){if(!p(B))return null;I=I.toLowerCase()}let W=null,q=0;for(Z=Z.toLowerCase();q<I.length&&(W=E(Z,I,0,q))===null;)q=g(I,q+1);return W}e.matchesCamelCase=r;function l(Z,I,B=!1){if(!I||I.length===0)return null;let W=null,q=0;for(Z=Z.toLowerCase(),I=I.toLowerCase();q<I.length&&(W=c(Z,I,0,q,B))===null;)q=b(I,q+1);return W}e.matchesWords=l;function c(Z,I,B,W,q){if(B===Z.length)return[];if(W===I.length)return null;if(a(Z.charCodeAt(B),I.charCodeAt(W))){let ee=null,fe=W+1;if(ee=c(Z,I,B+1,W+1,q),!q)for(;!ee&&(fe=b(I,fe))<I.length;)ee=c(Z,I,B+1,fe,q),fe++;return ee?Z.charCodeAt(B)!==I.charCodeAt(W)?ee:u({start:W,end:W+1},ee):null}else return null}function b(Z,I){for(let B=I;B<Z.length;B++)if(m(Z.charCodeAt(B))||B>0&&m(Z.charCodeAt(B-1)))return B;return Z.length}const i=D(e.matchesPrefix,r,y),s=D(e.matchesPrefix,r,R),f=new n.LRUCache(1e4);function P(Z,I,B=!1){if(typeof Z!="string"||typeof I!="string")return null;let W=f.get(Z);W||(W=new RegExp(k.convertSimple2RegExpPattern(Z),"i"),f.set(Z,W));const q=W.exec(I);return q?[{start:q.index,end:q.index+q[0].length}]:B?s(Z,I):i(Z,I)}e.matchesFuzzy=P;function C(Z,I){const B=Fe(Z,Z.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?_(B):null}e.matchesFuzzy2=C;function j(Z,I,B,W,q,ee){const fe=Math.min(13,Z.length);for(;B<fe;B++){const De=Fe(Z,I,B,W,q,ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(De)return De}return[0,ee]}e.anyScore=j;function _(Z){if(typeof Z>"u")return[];const I=[],B=Z[1];for(let W=Z.length-1;W>1;W--){const q=Z[W]+B,ee=I[I.length-1];ee&&ee.end===q?ee.end=q+1:I.push({start:q,end:q+1})}return I}e.createMatches=_;const K=128;function A(){const Z=[],I=[];for(let B=0;B<=K;B++)I[B]=0;for(let B=0;B<=K;B++)Z.push(I.slice(0));return Z}function $(Z){const I=[];for(let B=0;B<=Z;B++)I[B]=0;return I}const O=$(2*K),F=$(2*K),H=A(),V=A(),ae=A(),pe=!1;function re(Z,I,B,W,q){function ee(De,oe,ve=" "){for(;De.length<oe;)De=ve+De;return De}let fe=` |   |${W.split("").map(De=>ee(De,3)).join("|")}
`;for(let De=0;De<=B;De++)De===0?fe+=" |":fe+=`${I[De-1]}|`,fe+=Z[De].slice(0,q+1).map(oe=>ee(oe.toString(),3)).join("|")+`
`;return fe}function ce(Z,I,B,W){Z=Z.substr(I),B=B.substr(W),console.log(re(V,Z,Z.length,B,B.length)),console.log(re(ae,Z,Z.length,B,B.length)),console.log(re(H,Z,Z.length,B,B.length))}function ue(Z,I){if(I<0||I>=Z.length)return!1;const B=Z.codePointAt(I);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(B)}}function Se(Z,I){if(I<0||I>=Z.length)return!1;switch(Z.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function G(Z,I,B){return I[Z]!==B[Z]}function X(Z,I,B,W,q,ee,fe=!1){for(;I<B&&q<ee;)Z[I]===W[q]&&(fe&&(O[I]=q),I+=1),q+=1;return I===B}e.isPatternInWord=X;var J;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(J||(J={}));var de;(function(Z){Z.Default=[-100,0];function I(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}Z.isDefault=I})(de=e.FuzzyScore||(e.FuzzyScore={}));class ye{constructor(I,B){this.firstMatchCanBeWeak=I,this.boostFullMatch=B}}ye.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=ye;function Fe(Z,I,B,W,q,ee,fe=ye.default){const De=Z.length>K?K:Z.length,oe=W.length>K?K:W.length;if(B>=De||ee>=oe||De-B>oe-ee||!X(I,B,De,q,ee,oe,!0))return;ze(De,oe,B,ee,I,q);let ve=1,be=1,He=B,je=ee;const it=[!1];for(ve=1,He=B;He<De;ve++,He++){const rt=O[He],Q=F[He],Y=He+1<De?F[He+1]:oe;for(be=rt-ee+1,je=rt;je<Y;be++,je++){let ge=Number.MIN_SAFE_INTEGER,We=!1;je<=Q&&(ge=Pe(Z,I,He,B,W,q,je,oe,ee,H[ve-1][be-1]===0,it));let $e=0;ge!==Number.MAX_SAFE_INTEGER&&(We=!0,$e=ge+V[ve-1][be-1]);const Qe=je>rt,Ke=Qe?V[ve][be-1]+(H[ve][be-1]>0?-5:0):0,tt=je>rt+1&&H[ve][be-1]>0,at=tt?V[ve][be-2]+(H[ve][be-2]>0?-5:0):0;if(tt&&(!Qe||at>=Ke)&&(!We||at>=$e))V[ve][be]=at,ae[ve][be]=3,H[ve][be]=0;else if(Qe&&(!We||Ke>=$e))V[ve][be]=Ke,ae[ve][be]=2,H[ve][be]=0;else if(We)V[ve][be]=$e,ae[ve][be]=1,H[ve][be]=H[ve-1][be-1]+1;else throw new Error("not possible")}}if(pe&&ce(Z,B,W,ee),!it[0]&&!fe.firstMatchCanBeWeak)return;ve--,be--;const Xe=[V[ve][be],ee];let et=0,nt=0;for(;ve>=1;){let rt=be;do{const Q=ae[ve][rt];if(Q===3)rt=rt-2;else if(Q===2)rt=rt-1;else break}while(rt>=1);et>1&&I[B+ve-1]===q[ee+be-1]&&!G(rt+ee-1,W,q)&&et+1>H[ve][rt]&&(rt=be),rt===be?et++:et=1,nt||(nt=rt),ve--,be=rt-1,Xe.push(be)}oe===De&&fe.boostFullMatch&&(Xe[0]+=2);const Ne=nt-De;return Xe[0]-=Ne,Xe}e.fuzzyScore=Fe;function ze(Z,I,B,W,q,ee){let fe=Z-1,De=I-1;for(;fe>=B&&De>=W;)q[fe]===ee[De]&&(F[fe]=De,fe--),De--}function Pe(Z,I,B,W,q,ee,fe,De,oe,ve,be){if(I[B]!==ee[fe])return Number.MIN_SAFE_INTEGER;let He=1,je=!1;return fe===B-W?He=Z[B]===q[fe]?7:5:G(fe,q,ee)&&(fe===0||!G(fe-1,q,ee))?(He=Z[B]===q[fe]?7:5,je=!0):ue(ee,fe)&&(fe===0||!ue(ee,fe-1))?He=5:(ue(ee,fe-1)||Se(ee,fe-1))&&(He=5,je=!0),He>1&&B===W&&(be[0]=!0),je||(je=G(fe,q,ee)||ue(ee,fe-1)||Se(ee,fe-1)),B===W?fe>oe&&(He-=je?3:5):ve?He+=je?2:0:He+=je?0:1,fe+1===De&&(He-=je?3:5),He}function Ie(Z,I,B,W,q,ee,fe){return se(Z,I,B,W,q,ee,!0,fe)}e.fuzzyScoreGracefulAggressive=Ie;function we(Z,I,B,W,q,ee,fe){return se(Z,I,B,W,q,ee,!1,fe)}e.fuzzyScoreGraceful=we;function se(Z,I,B,W,q,ee,fe,De){let oe=Fe(Z,I,B,W,q,ee,De);if(oe&&!fe)return oe;if(Z.length>=3){const ve=Math.min(7,Z.length-1);for(let be=B+1;be<ve;be++){const He=le(Z,be);if(He){const je=Fe(He,He.toLowerCase(),B,W,q,ee,De);je&&(je[0]-=3,(!oe||je[0]>oe[0])&&(oe=je))}}}return oe}function le(Z,I){if(I+1>=Z.length)return;const B=Z[I],W=Z[I+1];if(B!==W)return Z.slice(0,I)+W+B+Z.slice(I+2)}}),define(ke[126],Te([1,0,125,10,38]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",y=new RegExp(`\\$\\(${D.ThemeIcon.iconNameExpression}(?:${D.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${y.source}`,"g");function S(u){return u.replace(R,(g,E)=>E?g:`\\${g}`)}e.escapeIcons=S;const T=new RegExp(`\\\\${y.source}`,"g");function N(u){return u.replace(T,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=N;const w=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function h(u){return u.indexOf(M)===-1?u:u.replace(w,(g,E,L,p)=>L?g:E||p||"")}e.stripIcons=h;function v(u){return u?u.replace(/\$\((.*?)\)/g,(g,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=v;const m=new RegExp(`\\$\\(${D.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(u){m.lastIndex=0;let g="";const E=[];let L=0;for(;;){const p=m.lastIndex,t=m.exec(u),d=u.substring(p,t?.index);if(d.length>0){g+=d;for(let r=0;r<d.length;r++)E.push(L)}if(!t)break;L+=t[0].length}return{text:g,iconOffsets:E}}e.parseLabelWithIcons=a;function o(u,g,E=!1){const{text:L,iconOffsets:p}=g;if(!p||p.length===0)return(0,n.matchesFuzzy)(u,L,E);const t=(0,k.ltrim)(L," "),d=L.length-t.length,r=(0,n.matchesFuzzy)(u,t,E);if(r)for(const l of r){const c=p[l.start+d]+d;l.start+=c,l.end+=c}return r}e.matchesFuzzyIconAware=o}),define(ke[29],Te([1,0,10]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(k||(k={})),function(D){const M="error",y="warning",R="warn",S="info",T="ignore";function N(h){return h?n.equalsIgnoreCase(M,h)?D.Error:n.equalsIgnoreCase(y,h)||n.equalsIgnoreCase(R,h)?D.Warning:n.equalsIgnoreCase(S,h)?D.Info:D.Ignore:D.Ignore}D.fromValue=N;function w(h){switch(h){case D.Error:return M;case D.Warning:return y;case D.Info:return S;default:return T}}D.toString=w}(k||(k={})),e.default=k}),define(ke[48],Te([1,0,16,10]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const m=v.charCodeAt(0),a=this.b.charCodeAt(this.c);return m-a}value(){return this.b[this.c]}}e.StringIterator=D;class M{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,k.compareSubstring)(v,this.b,0,v.length,this.c,this.d):(0,k.compareSubstringIgnoreCase)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=M;class y{constructor(v=!0,m=!0){this.f=v,this.g=m}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let m=v.length-1;m>=0;m--,this.c--){const a=this.b.charCodeAt(m);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,k.compareSubstring)(v,this.b,0,v.length,this.d,this.e):(0,k.compareSubstringIgnoreCase)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=y;var R;(function(h){h[h.Scheme=1]="Scheme",h[h.Authority=2]="Authority",h[h.Path=3]="Path",h[h.Query=4]="Query",h[h.Fragment=5]="Fragment"})(R||(R={}));class S{constructor(v,m){this.f=v,this.g=m,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new y(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,k.compareIgnoreCase)(v,this.c.scheme);if(this.d[this.e]===2)return(0,k.compareIgnoreCase)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,k.compare)(v,this.c.query);if(this.d[this.e]===5)return(0,k.compare)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class T{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(h){h[h.Left=-1]="Left",h[h.Mid=0]="Mid",h[h.Right=1]="Right"})(N||(N={}));class w{static forUris(v=()=>!1,m=()=>!1){return new w(new S(v,m))}static forPaths(v=!1){return new w(new y(void 0,!v))}static forStrings(){return new w(new D)}static forConfigKeys(){return new w(new M)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,m){if(m){const a=m.slice(0);(0,n.shuffle)(a);for(const o of a)this.set(o,v)}else{const a=v.slice(0);(0,n.shuffle)(a);for(const o of a)this.set(o[0],o[1])}}set(v,m){const a=this.b.reset(v);let o;this.c||(this.c=new T,this.c.segment=a.value());const u=[];for(o=this.c;;){const E=a.cmp(o.segment);if(E>0)o.left||(o.left=new T,o.left.segment=a.value()),u.push([-1,o]),o=o.left;else if(E<0)o.right||(o.right=new T,o.right.segment=a.value()),u.push([1,o]),o=o.right;else if(a.hasNext())a.next(),o.mid||(o.mid=new T,o.mid.segment=a.value()),u.push([0,o]),o=o.mid;else break}const g=o.value;o.value=m,o.key=v;for(let E=u.length-1;E>=0;E--){const L=u[E][1];L.updateHeight();const p=L.balanceFactor();if(p<-1||p>1){const t=u[E][0],d=u[E+1][0];if(t===1&&d===1)u[E][1]=L.rotateLeft();else if(t===-1&&d===-1)u[E][1]=L.rotateRight();else if(t===1&&d===-1)L.right=u[E+1][1]=u[E+1][1].rotateRight(),u[E][1]=L.rotateLeft();else if(t===-1&&d===1)L.left=u[E+1][1]=u[E+1][1].rotateLeft(),u[E][1]=L.rotateRight();else throw new Error;if(E>0)switch(u[E-1][0]){case-1:u[E-1][1].left=u[E][1];break;case 1:u[E-1][1].right=u[E][1];break;case 0:u[E-1][1].mid=u[E][1];break}else this.c=u[0][1]}}return g}get(v){return this.d(v)?.value}d(v){const m=this.b.reset(v);let a=this.c;for(;a;){const o=m.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(m.hasNext())m.next(),a=a.mid;else break}return a}has(v){const m=this.d(v);return!(m?.value===void 0&&m?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,m){const a=this.b.reset(v),o=[];let u=this.c;for(;u;){const g=a.cmp(u.segment);if(g>0)o.push([-1,u]),u=u.left;else if(g<0)o.push([1,u]),u=u.right;else if(a.hasNext())a.next(),o.push([0,u]),u=u.mid;else break}if(!!u){if(m?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this.f(u.right);if(g.key){const{key:E,value:L,segment:p}=g;this.e(g.key,!1),u.key=E,u.value=L,u.segment=p}}else{const g=u.left??u.right;if(o.length>0){const[E,L]=o[o.length-1];switch(E){case-1:L.left=g;break;case 0:L.mid=g;break;case 1:L.right=g;break}}else this.c=g}for(let g=o.length-1;g>=0;g--){const E=o[g][1];E.updateHeight();const L=E.balanceFactor();if(L>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),o[g][1]=E.rotateLeft()):L<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),o[g][1]=E.rotateRight()),g>0)switch(o[g-1][0]){case-1:o[g-1][1].left=o[g][1];break;case 1:o[g-1][1].right=o[g][1];break;case 0:o[g-1][1].mid=o[g][1];break}else this.c=o[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const m=this.b.reset(v);let a=this.c,o;for(;a;){const u=m.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(m.hasNext())m.next(),o=a.value||o,a=a.mid;else break}return a&&a.value||o}findSuperstr(v){return this.g(v,!1)}g(v,m){const a=this.b.reset(v);let o=this.c;for(;o;){const u=a.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else return o.mid?this.h(o.mid):m?o.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[m,a]of this)v(a,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const m=[];return this.j(v,m),m[Symbol.iterator]()}j(v,m){!v||(v.left&&this.j(v.left,m),v.value&&m.push([v.key,v.value]),v.mid&&this.j(v.mid,m),v.right&&this.j(v.right,m))}_isBalanced(){const v=m=>{if(!m)return!0;const a=m.balanceFactor();return a<-1||a>1?!1:v(m.left)&&v(m.right)};return v(this.c)}}e.TernarySearchTree=w}),define(ke[66],Te([1,0,23,10,2]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(T){return JSON.stringify(T,R)}e.stringify=M;function y(T){let N=JSON.parse(T);return N=S(N),N}e.parse=y;function R(T,N){return N instanceof RegExp?{$mid:2,source:N.source,flags:(0,k.regExpFlags)(N)}:N}function S(T,N=0){if(!T||N>200)return T;if(typeof T=="object"){switch(T.$mid){case 1:return D.URI.revive(T);case 2:return new RegExp(T.source,T.flags);case 16:return new Date(T.source)}if(T instanceof n.VSBuffer||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let w=0;w<T.length;++w)T[w]=S(T[w],N+1);else for(const w in T)Object.hasOwnProperty.call(T,w)&&(T[w]=S(T[w],N+1))}return T}e.revive=S}),define(ke[15],Te([1,0,12,20,2]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(T){T.inMemory="inmemory",T.vscode="vscode",T.internal="private",T.walkThrough="walkThrough",T.walkThroughSnippet="walkThroughSnippet",T.http="http",T.https="https",T.file="file",T.mailto="mailto",T.untitled="untitled",T.data="data",T.command="command",T.vscodeRemote="vscode-remote",T.vscodeRemoteResource="vscode-remote-resource",T.vscodeUserData="vscode-userdata",T.vscodeCustomEditor="vscode-custom-editor",T.vscodeNotebookCell="vscode-notebook-cell",T.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",T.vscodeNotebookCellOutput="vscode-notebook-cell-output",T.vscodeInteractive="vscode-interactive",T.vscodeInteractiveInput="vscode-interactive-input",T.vscodeSettings="vscode-settings",T.vscodeWorkspaceTrust="vscode-workspace-trust",T.vscodeTerminal="vscode-terminal",T.webviewPanel="webview-panel",T.vscodeWebview="vscode-webview",T.extension="extension",T.vscodeFileResource="vscode-file",T.tmp="tmp",T.vsls="vsls",T.vscodeSourceControl="vscode-scm"})(M=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(N){this.d=N}setDelegate(N){this.e=N}setServerRootPath(N){this.f=`${N}/${M.vscodeRemoteResource}`}set(N,w,h){this.a[N]=w,this.b[N]=h}setConnectionToken(N,w){this.c[N]=w}getPreferredWebSchema(){return this.d}rewrite(N){if(this.e)try{return this.e(N)}catch(o){return n.onUnexpectedError(o),N}const w=N.authority;let h=this.a[w];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const v=this.b[w],m=this.c[w];let a=`path=${encodeURIComponent(N.path)}`;return typeof m=="string"&&(a+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),D.URI.from({scheme:k.isWeb?this.d:M.vscodeRemoteResource,authority:`${h}:${v}`,path:this.f,query:a})}}e.RemoteAuthorities=new y,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(N){const w=this.b(N,te);return this.uriToBrowserUri(w)}uriToBrowserUri(N){return N.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(N):N.scheme===M.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${M.vscodeFileResource}://${R.a}`)?N.with({scheme:M.vscodeFileResource,authority:N.authority||R.a,query:null,fragment:null}):N}asFileUri(N){const w=this.b(N,te);return this.uriToFileUri(w)}uriToFileUri(N){return N.scheme===M.vscodeFileResource?N.with({scheme:M.file,authority:N.authority!==R.a?N.authority:null,query:null,fragment:null}):N}b(N,w){return D.URI.isUri(N)?N:D.URI.parse(w.toUrl(N))}}R.a="vscode-app",e.FileAccess=new R;var S;(function(T){const N=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);T.CoopAndCoep=Object.freeze(N.get("3"));const w="vscode-coi";function h(m){let a;typeof m=="string"?a=new URL(m).searchParams:m instanceof URL?a=m.searchParams:D.URI.isUri(m)&&(a=new URL(m.toString(!0)).searchParams);const o=a?.get(w);if(!!o)return N.get(o)}T.getHeadersFromQuery=h;function v(m,a,o){if(!globalThis.crossOriginIsolated)return;const u=a&&o?"3":o?"2":"1";m instanceof URLSearchParams?m.set(w,u):m[w]=u}T.addSearchParam=v})(S=e.COI||(e.COI={}))}),define(ke[24],Te([1,0,40,15,19,20,10,2]),function(te,e,n,k,D,M,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(v){return(0,R.uriToFsPath)(v,!0)}e.originalFSPath=S;class T{constructor(m){this.a=m}compare(m,a,o=!1){return m===a?0:(0,y.compare)(this.getComparisonKey(m,o),this.getComparisonKey(a,o))}isEqual(m,a,o=!1){return m===a?!0:!m||!a?!1:this.getComparisonKey(m,o)===this.getComparisonKey(a,o)}getComparisonKey(m,a=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,a,o=!1){if(m.scheme===a.scheme){if(m.scheme===k.Schemas.file)return n.isEqualOrParent(S(m),S(a),this.a(m))&&m.query===a.query&&(o||m.fragment===a.fragment);if((0,e.isEqualAuthority)(m.authority,a.authority))return n.isEqualOrParent(m.path,a.path,this.a(m),"/")&&m.query===a.query&&(o||m.fragment===a.fragment)}return!1}joinPath(m,...a){return R.URI.joinPath(m,...a)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return D.posix.basename(m.path)}extname(m){return D.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let a;return m.scheme===k.Schemas.file?a=R.URI.file(D.dirname(S(m))).path:(a=D.posix.dirname(m.path),m.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),a="/")),m.with({path:a})}normalizePath(m){if(!m.path.length)return m;let a;return m.scheme===k.Schemas.file?a=R.URI.file(D.normalize(S(m))).path:a=D.posix.normalize(m.path),m.with({path:a})}relativePath(m,a){if(m.scheme!==a.scheme||!(0,e.isEqualAuthority)(m.authority,a.authority))return;if(m.scheme===k.Schemas.file){const g=D.relative(S(m),S(a));return M.isWindows?n.toSlashes(g):g}let o=m.path||"/";const u=a.path||"/";if(this.a(m)){let g=0;for(const E=Math.min(o.length,u.length);g<E&&!(o.charCodeAt(g)!==u.charCodeAt(g)&&o.charAt(g).toLowerCase()!==u.charAt(g).toLowerCase());g++);o=u.substr(0,g)+o.substr(g)}return D.posix.relative(o,u)}resolvePath(m,a){if(m.scheme===k.Schemas.file){const o=R.URI.file(D.resolve(S(m),a));return m.with({authority:o.authority,path:o.path})}return a=n.toPosixPath(a),m.with({path:D.posix.resolve(m.path,a)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,a){return m===a||m!==void 0&&a!==void 0&&(0,y.equalsIgnoreCase)(m,a)}hasTrailingPathSeparator(m,a=D.sep){if(m.scheme===k.Schemas.file){const o=S(m);return o.length>n.getRoot(o).length&&o[o.length-1]===a}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,a=D.sep){return(0,e.hasTrailingPathSeparator)(m,a)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,a=D.sep){let o=!1;if(m.scheme===k.Schemas.file){const u=S(m);o=u!==void 0&&u.length===n.getRoot(u).length&&u[u.length-1]===a}else{a="/";const u=m.path;o=u.length===1&&u.charCodeAt(u.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(m,a)?m.with({path:m.path+"/"}):m}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(v=>v.scheme===k.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new T(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(v,m){const a=[];for(let o=0;o<v.length;o++){const u=m(v[o]);v.some((g,E)=>E===o?!1:(0,e.isEqualOrParent)(u,m(g)))||a.push(v[o])}return a}e.distinctParents=N;var w;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function m(a){const o=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(E=>{const[L,p]=E.split(":");L&&p&&o.set(L,p)});const g=a.path.substring(0,a.path.indexOf(";"));return g&&o.set(v.META_DATA_MIME,g),o}v.parseMetaData=m})(w=e.DataUri||(e.DataUri={}));function h(v,m,a){if(m){let o=v.path;return o&&o[0]!==D.posix.sep&&(o=D.posix.sep+o),v.with({scheme:a,authority:m,path:o})}return v.with({scheme:a})}e.toLocalResource=h}),define(ke[17],Te([1,0,21,12,4,6,24,20,115]),function(te,e,n,k,D,M,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function T(X){return!!X&&typeof X.then=="function"}e.isThenable=T;function N(X){const J=new n.CancellationTokenSource,de=X(J.token),ye=new Promise((Fe,ze)=>{const Pe=J.token.onCancellationRequested(()=>{Pe.dispose(),J.dispose(),ze(new k.CancellationError)});Promise.resolve(de).then(Ie=>{Pe.dispose(),J.dispose(),Fe(Ie)},Ie=>{Pe.dispose(),J.dispose(),ze(Ie)})});return new class{cancel(){J.cancel()}then(Fe,ze){return ye.then(Fe,ze)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return ye.finally(Fe)}}}e.createCancelablePromise=N;function w(X,J,de){return new Promise((ye,Fe)=>{const ze=J.onCancellationRequested(()=>{ze.dispose(),ye(de)});X.then(ye,Fe).finally(()=>ze.dispose())})}e.raceCancellation=w;function h(X,J){return new Promise((de,ye)=>{const Fe=J.onCancellationRequested(()=>{Fe.dispose(),ye(new k.CancellationError)});X.then(de,ye).finally(()=>Fe.dispose())})}e.raceCancellationError=h;async function v(X){let J=-1;const de=X.map((Fe,ze)=>Fe.then(Pe=>(J=ze,Pe))),ye=await Promise.race(de);return X.forEach((Fe,ze)=>{ze!==J&&Fe.cancel()}),ye}e.raceCancellablePromises=v;function m(X,J,de){let ye;const Fe=setTimeout(()=>{ye?.(void 0),de?.()},J);return Promise.race([X.finally(()=>clearTimeout(Fe)),new Promise(ze=>ye=ze)])}e.raceTimeout=m;function a(X){return new Promise((J,de)=>{const ye=X();T(ye)?ye.then(J,de):J(ye)})}e.asPromise=a;class o{constructor(){this.a=null,this.b=null,this.d=null}queue(J){if(this.a){if(this.d=J,!this.b){const de=()=>{this.b=null;const ye=this.queue(this.d);return this.d=null,ye};this.b=new Promise(ye=>{this.a.then(de,de).then(ye)})}return new Promise((de,ye)=>{this.b.then(de,ye)})}return this.a=J(),new Promise((de,ye)=>{this.a.then(Fe=>{this.a=null,de(Fe)},Fe=>{this.a=null,ye(Fe)})})}}e.Throttler=o;class u{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.Sequencer=u;class g{constructor(){this.a=new Map}queue(J,de){const Fe=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(de).finally(()=>{this.a.get(J)===Fe&&this.a.delete(J)});return this.a.set(J,Fe),Fe}}e.SequencerByKey=g;const E=(X,J)=>{let de=!0;const ye=setTimeout(()=>{de=!1,J()},X);return{isTriggered:()=>de,dispose:()=>{clearTimeout(ye),de=!1}}},L=X=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,X())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class p{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,de=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((Fe,ze)=>{this.d=Fe,this.f=ze}).then(()=>{if(this.b=null,this.d=null,this.g){const Fe=this.g;return this.g=null,Fe()}}));const ye=()=>{this.a=null,this.d?.(null)};return this.a=de===S.MicrotaskDelay?L(ye):E(de,ye),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=p;class t{constructor(J){this.a=new p(J),this.b=new o}trigger(J,de){return this.a.trigger(()=>this.b.queue(J),de)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class d{constructor(){this.a=!1,this.b=new Promise((J,de)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=d;class r extends d{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function l(X,J){return J?new Promise((de,ye)=>{const Fe=setTimeout(()=>{ze.dispose(),de()},X),ze=J.onCancellationRequested(()=>{clearTimeout(Fe),ze.dispose(),ye(new k.CancellationError)})}):N(de=>l(X,de))}e.timeout=l;function c(X,J=0){const de=setTimeout(X,J);return(0,M.toDisposable)(()=>clearTimeout(de))}e.disposableTimeout=c;function b(X){const J=[];let de=0;const ye=X.length;function Fe(){return de<ye?X[de++]():null}function ze(Pe){Pe!=null&&J.push(Pe);const Ie=Fe();return Ie?Ie.then(ze):Promise.resolve(J)}return Promise.resolve(null).then(ze)}e.sequence=b;function i(X,J=ye=>!!ye,de=null){let ye=0;const Fe=X.length,ze=()=>{if(ye>=Fe)return Promise.resolve(de);const Pe=X[ye++];return Promise.resolve(Pe()).then(we=>J(we)?Promise.resolve(we):ze())};return ze()}e.first=i;function s(X,J=ye=>!!ye,de=null){if(X.length===0)return Promise.resolve(de);let ye=X.length;const Fe=()=>{ye=-1;for(const ze of X)ze.cancel?.()};return new Promise((ze,Pe)=>{for(const Ie of X)Ie.then(we=>{--ye>=0&&J(we)?(Fe(),ze(we)):ye===0&&ze(de)}).catch(we=>{--ye>=0&&(Fe(),Pe(we))})})}e.firstParallel=s;class f{constructor(J){this.a=0,this.d=J,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(J){return this.a++,new Promise((de,ye)=>{this.f.push({factory:J,c:de,e:ye}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const J=this.f.shift();this.b++;const de=J.factory();de.then(J.c,J.e),de.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=f;class P extends f{constructor(){super(1)}}e.Queue=P;class C{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const J=new pe;return this.b.add(J),J.p}d(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueFor(J,de=y.extUri){const ye=de.getComparisonKey(J);let Fe=this.a.get(ye);return Fe||(Fe=new P,D.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.a.delete(ye),this.f()}),this.a.set(ye,Fe)),Fe}f(){!this.d()||this.g()}g(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.g()}}e.ResourceQueue=C;class j{constructor(J,de){this.a=-1,typeof J=="function"&&typeof de=="number"&&this.setIfNotSet(J,de)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,de){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},de)}setIfNotSet(J,de){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},de))}}e.TimeoutTimer=j;class _{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(J,de){this.cancel(),this.a=setInterval(()=>{J()},de)}}e.IntervalTimer=_;class K{constructor(J,de){this.b=-1,this.a=J,this.d=de,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class A{constructor(J,de){de%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${de}ms is not a multiple of 1000ms.`),this.a=J,this.b=de,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=A;class $ extends K{constructor(J,de){super(J,de),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=$;class O extends M.Disposable{constructor(J,de){super(),this.g=J,this.h=de,this.a=[],this.b=this.B(new M.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const de of J)this.a.push(de);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=X=>{(0,R.setTimeout0)(()=>{if(J)return;const de=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.runWhenIdle=(X,J)=>{const de=requestIdleCallback(X,typeof J=="number"?{timeout:J}:void 0);let ye=!1;return{dispose(){ye||(ye=!0,cancelIdleCallback(de))}}}}();class F{constructor(J){this.d=!1,this.a=()=>{try{this.f=J()}catch(de){this.g=de}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function H(X,J,de){let ye;for(let Fe=0;Fe<de;Fe++)try{return await X()}catch(ze){ye=ze,await l(J)}throw ye}e.retry=H;class V{hasPending(J){return this.a?typeof J=="number"?this.a.taskId===J:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(J,de,ye){return this.a={taskId:J,cancel:()=>ye?.(),promise:de},de.then(()=>this.d(J),()=>this.d(J)),de}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}setNext(J){if(this.b)this.b.run=J;else{let de,ye;const Fe=new Promise((ze,Pe)=>{de=ze,ye=Pe});this.b={run:J,promise:Fe,promiseResolve:de,promiseReject:ye}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=V;class ae{constructor(J,de=()=>Date.now()){this.d=J,this.f=de,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.IntervalCounter=ae;class pe{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((J,de)=>{this.a=J,this.b=de})}complete(J){return new Promise(de=>{this.a(J),this.f=!0,de()})}error(J){return new Promise(de=>{this.b(J),this.d=!0,de()})}cancel(){new Promise(J=>{this.b(new k.CancellationError),this.d=!0,J()})}}e.DeferredPromise=pe;var re;(function(X){async function J(ye){let Fe;const ze=await Promise.all(ye.map(Pe=>Pe.then(Ie=>Ie,Ie=>{Fe||(Fe=Ie)})));if(typeof Fe<"u")throw Fe;return ze}X.settled=J;function de(ye){return new Promise(async(Fe,ze)=>{try{await ye(Fe,ze)}catch(Pe){ze(Pe)}})}X.withAsyncBody=de})(re=e.Promises||(e.Promises={}));var ce;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(ce||(ce={}));class ue{static fromArray(J){return new ue(de=>{de.emitMany(J)})}static fromPromise(J){return new ue(async de=>{de.emitMany(await J)})}static fromPromises(J){return new ue(async de=>{await Promise.all(J.map(async ye=>de.emitOne(await ye)))})}static merge(J){return new ue(async de=>{await Promise.all(J.map(async ye=>{for await(const Fe of ye)de.emitOne(Fe)}))})}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const de={emitOne:ye=>this.g(ye),emitMany:ye=>this.h(ye),reject:ye=>this.k(ye)};try{await Promise.resolve(J(de)),this.j()}catch(ye){this.k(ye)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(J,de){return new ue(async ye=>{for await(const Fe of J)ye.emitOne(de(Fe))})}map(J){return ue.map(this,J)}static filter(J,de){return new ue(async ye=>{for await(const Fe of J)de(Fe)&&ye.emitOne(Fe)})}filter(J){return ue.filter(this,J)}static coalesce(J){return ue.filter(J,de=>!!de)}coalesce(){return ue.coalesce(this)}static async toPromise(J){const de=[];for await(const ye of J)de.push(ye);return de}toPromise(){return ue.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}ue.EMPTY=ue.fromArray([]),e.AsyncIterableObject=ue;class Se extends ue{constructor(J,de){super(de),this.l=J}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Se;function G(X){const J=new n.CancellationTokenSource,de=X(J.token);return new Se(J,async ye=>{const Fe=J.token.onCancellationRequested(()=>{Fe.dispose(),J.dispose(),ye.reject(new k.CancellationError)});try{for await(const ze of de){if(J.token.isCancellationRequested)return;ye.emitOne(ze)}Fe.dispose(),J.dispose()}catch(ze){Fe.dispose(),J.dispose(),ye.reject(ze)}})}e.createCancelableAsyncIterable=G}),define(ke[35],Te([1,0,16,17,40,28,19,20,10]),function(te,e,n,k,D,M,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const N="[/\\\\]",w="[^/\\\\]",h=/\//g;function v(ae,pe){switch(ae){case 0:return"";case 1:return`${w}*?`;default:return`(?:${N}|${w}+${N}${pe?`|${N}${w}+`:""})*?`}}function m(ae,pe){if(!ae)return[];const re=[];let ce=!1,ue=!1,Se="";for(const G of ae){switch(G){case pe:if(!ce&&!ue){re.push(Se),Se="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}Se+=G}return Se&&re.push(Se),re}e.splitGlobAware=m;function a(ae){if(!ae)return"";let pe="";const re=m(ae,e.GLOB_SPLIT);if(re.every(ce=>ce===e.GLOBSTAR))pe=".*";else{let ce=!1;re.forEach((ue,Se)=>{if(ue===e.GLOBSTAR){if(ce)return;pe+=v(2,Se===re.length-1)}else{let G=!1,X="",J=!1,de="";for(const ye of ue){if(ye!=="}"&&G){X+=ye;continue}if(J&&(ye!=="]"||!de)){let Fe;ye==="-"?Fe=ye:(ye==="^"||ye==="!")&&!de?Fe="^":ye===e.GLOB_SPLIT?Fe="":Fe=(0,S.escapeRegExpCharacters)(ye),de+=Fe;continue}switch(ye){case"{":G=!0;continue;case"[":J=!0;continue;case"}":{pe+=`(?:${m(X,",").map(Pe=>a(Pe)).join("|")})`,G=!1,X="";break}case"]":{pe+="["+de+"]",J=!1,de="";break}case"?":pe+=w;continue;case"*":pe+=v(1);continue;default:pe+=(0,S.escapeRegExpCharacters)(ye)}}Se<re.length-1&&(re[Se+1]!==e.GLOBSTAR||Se+2<re.length)&&(pe+=N)}ce=ue===e.GLOBSTAR})}return pe}const o=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,L=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.LRUCache(1e4),d=function(){return!1},r=function(){return null};function l(ae,pe){if(!ae)return r;let re;typeof ae!="string"?re=ae.pattern:re=ae,re=re.trim();const ce=`${re}_${!!pe.trimForExclusions}`;let ue=t.get(ce);if(ue)return c(ue,ae);let Se;return o.test(re)?ue=i(re.substr(4),re):(Se=u.exec(b(re,pe)))?ue=s(Se[1],re):(pe.trimForExclusions?E:g).test(re)?ue=f(re,pe):(Se=L.exec(b(re,pe)))?ue=P(Se[1].substr(1),re,!0):(Se=p.exec(b(re,pe)))?ue=P(Se[1],re,!1):ue=C(re),t.set(ce,ue),c(ue,ae)}function c(ae,pe){if(typeof pe=="string")return ae;const re=function(ce,ue){return(0,D.isEqualOrParent)(ce,pe.base,!R.isLinux)?ae((0,S.ltrim)(ce.substr(pe.base.length),y.sep),ue):null};return re.allBasenames=ae.allBasenames,re.allPaths=ae.allPaths,re.basenames=ae.basenames,re.patterns=ae.patterns,re}function b(ae,pe){return pe.trimForExclusions&&ae.endsWith("/**")?ae.substr(0,ae.length-2):ae}function i(ae,pe){return function(re,ce){return typeof re=="string"&&re.endsWith(ae)?pe:null}}function s(ae,pe){const re=`/${ae}`,ce=`\\${ae}`,ue=function(G,X){return typeof G!="string"?null:X?X===ae?pe:null:G===ae||G.endsWith(re)||G.endsWith(ce)?pe:null},Se=[ae];return ue.basenames=Se,ue.patterns=[pe],ue.allBasenames=Se,ue}function f(ae,pe){const re=H(ae.slice(1,-1).split(",").map(X=>l(X,pe)).filter(X=>X!==r),ae),ce=re.length;if(!ce)return r;if(ce===1)return re[0];const ue=function(X,J){for(let de=0,ye=re.length;de<ye;de++)if(re[de](X,J))return ae;return null},Se=re.find(X=>!!X.allBasenames);Se&&(ue.allBasenames=Se.allBasenames);const G=re.reduce((X,J)=>J.allPaths?X.concat(J.allPaths):X,[]);return G.length&&(ue.allPaths=G),ue}function P(ae,pe,re){const ce=y.sep===y.posix.sep,ue=ce?ae:ae.replace(h,y.sep),Se=y.sep+ue,G=y.posix.sep+ae;let X;return re?X=function(J,de){return typeof J=="string"&&(J===ue||J.endsWith(Se)||!ce&&(J===ae||J.endsWith(G)))?pe:null}:X=function(J,de){return typeof J=="string"&&(J===ue||!ce&&J===ae)?pe:null},X.allPaths=[(re?"*/":"./")+ae],X}function C(ae){try{const pe=new RegExp(`^${a(ae)}$`);return function(re){return pe.lastIndex=0,typeof re=="string"&&pe.test(re)?ae:null}}catch{return r}}function j(ae,pe,re){return!ae||typeof pe!="string"?!1:_(ae)(pe,void 0,re)}e.match=j;function _(ae,pe={}){if(!ae)return d;if(typeof ae=="string"||K(ae)){const re=l(ae,pe);if(re===r)return d;const ce=function(ue,Se){return!!re(ue,Se)};return re.allBasenames&&(ce.allBasenames=re.allBasenames),re.allPaths&&(ce.allPaths=re.allPaths),ce}return O(ae,pe)}e.parse=_;function K(ae){const pe=ae;return pe?typeof pe.base=="string"&&typeof pe.pattern=="string":!1}e.isRelativePattern=K;function A(ae){return ae.allBasenames||[]}e.getBasenameTerms=A;function $(ae){return ae.allPaths||[]}e.getPathTerms=$;function O(ae,pe){const re=H(Object.getOwnPropertyNames(ae).map(X=>F(X,ae[X],pe)).filter(X=>X!==r)),ce=re.length;if(!ce)return r;if(!re.some(X=>!!X.requiresSiblings)){if(ce===1)return re[0];const X=function(ye,Fe){let ze;for(let Pe=0,Ie=re.length;Pe<Ie;Pe++){const we=re[Pe](ye,Fe);if(typeof we=="string")return we;(0,k.isThenable)(we)&&(ze||(ze=[]),ze.push(we))}return ze?(async()=>{for(const Pe of ze){const Ie=await Pe;if(typeof Ie=="string")return Ie}return null})():null},J=re.find(ye=>!!ye.allBasenames);J&&(X.allBasenames=J.allBasenames);const de=re.reduce((ye,Fe)=>Fe.allPaths?ye.concat(Fe.allPaths):ye,[]);return de.length&&(X.allPaths=de),X}const ue=function(X,J,de){let ye,Fe;for(let ze=0,Pe=re.length;ze<Pe;ze++){const Ie=re[ze];Ie.requiresSiblings&&de&&(J||(J=(0,y.basename)(X)),ye||(ye=J.substr(0,J.length-(0,y.extname)(X).length)));const we=Ie(X,J,ye,de);if(typeof we=="string")return we;(0,k.isThenable)(we)&&(Fe||(Fe=[]),Fe.push(we))}return Fe?(async()=>{for(const ze of Fe){const Pe=await ze;if(typeof Pe=="string")return Pe}return null})():null},Se=re.find(X=>!!X.allBasenames);Se&&(ue.allBasenames=Se.allBasenames);const G=re.reduce((X,J)=>J.allPaths?X.concat(J.allPaths):X,[]);return G.length&&(ue.allPaths=G),ue}function F(ae,pe,re){if(pe===!1)return r;const ce=l(ae,re);if(ce===r)return r;if(typeof pe=="boolean")return ce;if(pe){const ue=pe.when;if(typeof ue=="string"){const Se=(G,X,J,de)=>{if(!de||!ce(G,X))return null;const ye=ue.replace("$(basename)",()=>J),Fe=de(ye);return(0,k.isThenable)(Fe)?Fe.then(ze=>ze?ae:null):Fe?ae:null};return Se.requiresSiblings=!0,Se}}return ce}function H(ae,pe){const re=ae.filter(X=>!!X.basenames);if(re.length<2)return ae;const ce=re.reduce((X,J)=>{const de=J.basenames;return de?X.concat(de):X},[]);let ue;if(pe){ue=[];for(let X=0,J=ce.length;X<J;X++)ue.push(pe)}else ue=re.reduce((X,J)=>{const de=J.patterns;return de?X.concat(de):X},[]);const Se=function(X,J){if(typeof X!="string")return null;if(!J){let ye;for(ye=X.length;ye>0;ye--){const Fe=X.charCodeAt(ye-1);if(Fe===47||Fe===92)break}J=X.substr(ye)}const de=ce.indexOf(J);return de!==-1?ue[de]:null};Se.basenames=ce,Se.patterns=ue,Se.allBasenames=ce;const G=ae.filter(X=>!X.basenames);return G.push(Se),G}function V(ae,pe){return(0,n.equals)(ae,pe,(re,ce)=>typeof re=="string"&&typeof ce=="string"?re===ce:typeof re!="string"&&typeof ce!="string"?re.base===ce.base&&re.pattern===ce.pattern:!1)}e.patternsEquals=V}),define(ke[86],Te([1,0,12,126,24,10,2]),function(te,e,n,k,D,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var R;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(R=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(u="",g=!1){if(this.value=u,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(u,g=0){return this.value+=h(this.supportThemeIcons?(0,k.escapeIcons)(u):u).replace(/([ \t]+)/g,(E,L)=>"&nbsp;".repeat(L.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,g){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(u,g,E){return this.value+="[",this.value+=this.c(g,"]"),this.value+="](",this.value+=this.c(String(u),")"),E&&(this.value+=` "${this.c(this.c(E,'"'),")")}"`),this.value+=")",this}c(u,g){const E=new RegExp((0,M.escapeRegExpCharacters)(g),"g");return u.replace(E,(L,p)=>u.charAt(p-1)!=="\\"?`\\${L}`:L)}}e.MarkdownString=S;function T(o){return N(o)?!o.value:Array.isArray(o)?o.every(T):!0}e.isEmptyMarkdownString=T;function N(o){return o instanceof S?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=N;function w(o,u){return o===u?!0:!o||!u?!1:o.value===u.value&&o.isTrusted===u.isTrusted&&o.supportThemeIcons===u.supportThemeIcons&&o.supportHtml===u.supportHtml&&(o.baseUri===u.baseUri||!!o.baseUri&&!!u.baseUri&&(0,D.isEqual)(y.URI.from(o.baseUri),y.URI.from(u.baseUri)))}e.markdownStringEqual=w;function h(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=h;function v(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=v;function m(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=m;function a(o){const u=[],g=o.split("|").map(L=>L.trim());o=g[0];const E=g[1];if(E){const L=/height=(\d+)/.exec(E),p=/width=(\d+)/.exec(E),t=L?L[1]:"",d=p?p[1]:"",r=isFinite(parseInt(d)),l=isFinite(parseInt(t));r&&u.push(`width="${d}"`),l&&u.push(`height="${t}"`)}return{href:o,dimensions:u}}e.parseHrefAndDimensions=a}),define(ke[87],Te([1,0,16,40,19,20,24,10]),function(te,e,n,k,D,M,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(r,l){const{os:c,tildify:b,relative:i}=l;if(i){const P=T(r,i,c);if(typeof P=="string")return P}let s=r.fsPath;if(c===1&&!M.isWindows?s=s.replace(/\//g,"\\"):c!==1&&M.isWindows&&(s=s.replace(/\\/g,"/")),c!==1&&b?.userHome){const P=b.userHome.fsPath;let C;r.scheme!==b.userHome.scheme&&r.path.startsWith(D.posix.sep)?C=b.userHome.with({path:r.path}).fsPath:C=r.fsPath,s=h(C,P,c)}return(c===1?D.win32:D.posix).normalize(N(s,c===1))}e.getPathLabel=S;function T(r,l,c){const b=c===1?D.win32:D.posix,i=c===3?y.extUri:y.extUriIgnorePathCase,s=l.getWorkspace(),f=(0,n.firstOrDefault)(s.folders);if(!f)return;r.scheme!==f.uri.scheme&&r.path.startsWith(D.posix.sep)&&(r=f.uri.with({path:r.path}));const P=l.getWorkspaceFolder(r);if(!P)return;let C;if(i.isEqual(P.uri,r)?C="":C=i.relativePath(P.uri,r)??"",C&&(C=b.normalize(C)),s.folders.length>1&&!l.noPrefix){const j=P.name?P.name:i.basenameOrAuthority(P.uri);C=C?`${j} \u2022 ${C}`:j}return C}function N(r,l=M.isWindows){return(0,k.hasDriveLetter)(r,l)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=N;let w=Object.create(null);function h(r,l,c=M.OS){if(c===1||!r||!l)return r;let b=w.original===l?w.normalized:void 0;b||(b=l,M.isWindows&&(b=(0,k.toSlashes)(b)),b=`${(0,R.rtrim)(b,D.posix.sep)}${D.posix.sep}`,w={original:l,normalized:b});let i=r;return M.isWindows&&(i=(0,k.toSlashes)(i)),(c===3?i.startsWith(b):(0,R.startsWithIgnoreCase)(i,b))?`~/${i.substr(b.length)}`:r}e.tildify=h;function v(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=v;const m="\u2026",a="\\\\",o="~";function u(r,l=D.sep){const c=new Array(r.length);let b=!1;for(let i=0;i<r.length;i++){const s=r[i];if(s===""){c[i]=`.${l}`;continue}if(!s){c[i]=s;continue}b=!0;let f="",P=s;P.indexOf(a)===0?(f=P.substr(0,P.indexOf(a)+a.length),P=P.substr(P.indexOf(a)+a.length)):P.indexOf(l)===0?(f=P.substr(0,P.indexOf(l)+l.length),P=P.substr(P.indexOf(l)+l.length)):P.indexOf(o)===0&&(f=P.substr(0,P.indexOf(o)+o.length),P=P.substr(P.indexOf(o)+o.length));const C=P.split(l);for(let j=1;b&&j<=C.length;j++)for(let _=C.length-j;b&&_>=0;_--){b=!1;let K=C.slice(_,_+j).join(l);for(let A=0;!b&&A<r.length;A++)if(A!==i&&r[A]&&r[A].indexOf(K)>-1){const $=_+j===C.length,O=_>0&&r[A].indexOf(l)>-1?l+K:K,F=r[A].endsWith(O);b=!$||F}if(!b){let A="";(C[0].endsWith(":")||f!=="")&&(_===1&&(_=0,j++,K=C[0]+l+K),_>0&&(A=C[0]+l),A=f+A),_>0&&(A=A+m+l),A=A+K,_+j<C.length&&(A=A+l+m),c[i]=A}}b&&(c[i]=s)}return c}e.shorten=u;var g;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function E(r,l=Object.create(null)){const c=[];let b=!1,i="";for(const s of r)if(s==="$"||b&&s==="{")i&&c.push({value:i,type:g.TEXT}),i="",b=!0;else if(s==="}"&&b){const f=l[i];if(typeof f=="string")f.length&&c.push({value:f,type:g.VARIABLE});else if(f){const P=c[c.length-1];(!P||P.type!==g.SEPARATOR)&&c.push({value:f.label,type:g.SEPARATOR})}i="",b=!1}else i+=s;return i&&!b&&c.push({value:i,type:g.TEXT}),c.filter((s,f)=>{if(s.type===g.SEPARATOR){const P=c[f-1],C=c[f+1];return[P,C].every(j=>j&&(j.type===g.VARIABLE||j.type===g.TEXT)&&j.value.length>0)}return!0}).map(s=>s.value).join("")}e.template=E;function L(r,l){return M.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):r.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=L;function p(r,l){return M.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):M.isWindows?r.replace(/&&|&/g,c=>c==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function d(r){const l=r.indexOf("/")!==-1?D.posix:D.win32,c=l.basename(r),b=l.dirname(r);return c.length?{name:c,parentPath:b}:{name:b,parentPath:""}}e.splitName=d}),define(ke[127],Te([1,0,23,2]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(w){return w.toJSON()}class M{constructor(h){this.a=h}transformIncoming(h){const v=this.a.transformIncoming(h);return v===h?h:D(k.URI.from(v))}transformOutgoing(h){const v=this.a.transformOutgoing(h);return v===h?h:D(k.URI.from(v))}transformOutgoingURI(h){const v=this.a.transformOutgoing(h);return v===h?h:k.URI.from(v)}transformOutgoingScheme(h){return this.a.transformOutgoingScheme(h)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function y(w,h,v){if(!w||v>200)return null;if(typeof w=="object"){if(w instanceof k.URI)return h.transformOutgoing(w);for(const m in w)if(Object.hasOwnProperty.call(w,m)){const a=y(w[m],h,v+1);a!==null&&(w[m]=a)}}return null}function R(w,h){const v=y(w,h,0);return v===null?w:v}e.transformOutgoingURIs=R;function S(w,h,v,m){if(!w||m>200)return null;if(typeof w=="object"){if(w.$mid===1)return v?k.URI.revive(h.transformIncoming(w)):h.transformIncoming(w);if(w instanceof n.VSBuffer)return null;for(const a in w)if(Object.hasOwnProperty.call(w,a)){const o=S(w[a],h,v,m+1);o!==null&&(w[a]=o)}}return null}function T(w,h){const v=S(w,h,!1,0);return v===null?w:v}e.transformIncomingURIs=T;function N(w,h){const v=S(w,h,!0,0);return v===null?w:v}e.transformAndReviveIncomingURIs=N}),define(ke[128],Te([1,0,35,19]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(M,y,R,S,T,N){if(Array.isArray(M)){let w=0;for(const h of M){const v=D(h,y,R,S,T,N);if(v===10)return v;v>w&&(w=v)}return w}else{if(typeof M=="string")return S?M==="*"?5:M===R?10:0:0;if(M){const{language:w,pattern:h,scheme:v,hasAccessToAllModels:m,notebookType:a}=M;if(!S&&!m)return 0;a&&T&&(y=T);let o=0;if(v)if(v===y.scheme)o=10;else if(v==="*")o=5;else return 0;if(w)if(w===R)o=10;else if(w==="*")o=Math.max(o,5);else return 0;if(a)if(a===N)o=10;else if(a==="*"&&N!==void 0)o=Math.max(o,5);else return 0;if(h){let u;if(typeof h=="string"?u=h:u={...h,base:(0,k.normalize)(h.base)},u===y.fsPath||(0,n.match)(u,y.fsPath))o=10;else return 0}return o}else return 0}}e.score=D}),define(ke[88],Te([1,0,23,20]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(D||(D={}));function M(w){for(let h=0,v=w.length;h<v;h+=4){const m=w[h+0],a=w[h+1],o=w[h+2],u=w[h+3];w[h+0]=u,w[h+1]=o,w[h+2]=a,w[h+3]=m}}function y(w){const h=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return k.isLittleEndian()||M(h),n.VSBuffer.wrap(h)}function R(w){const h=w.buffer;if(k.isLittleEndian()||M(h),h.byteOffset%4===0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const v=new Uint8Array(h.byteLength);return v.set(h),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function S(w){const h=new Uint32Array(T(w));let v=0;if(h[v++]=w.id,w.type==="full")h[v++]=1,h[v++]=w.data.length,h.set(w.data,v),v+=w.data.length;else{h[v++]=2,h[v++]=w.deltas.length;for(const m of w.deltas)h[v++]=m.start,h[v++]=m.deleteCount,m.data?(h[v++]=m.data.length,h.set(m.data,v),v+=m.data.length):h[v++]=0}return y(h)}e.encodeSemanticTokensDto=S;function T(w){let h=0;if(h+=1+1,w.type==="full")h+=1+w.data.length;else{h+=1,h+=(1+1+1)*w.deltas.length;for(const v of w.deltas)v.data&&(h+=v.data.length)}return h}function N(w){const h=R(w);let v=0;const m=h[v++];if(h[v++]===1){const g=h[v++],E=h.subarray(v,v+g);return v+=g,{id:m,type:"full",data:E}}const o=h[v++],u=[];for(let g=0;g<o;g++){const E=h[v++],L=h[v++],p=h[v++];let t;p>0&&(t=h.subarray(v,v+p),v+=p),u[g]={start:E,deleteCount:L,data:t}}return{id:m,type:"delta",deltas:u}}e.decodeSemanticTokensDto=N}),define(ke[129],Te([13,14]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(ke[130],Te([1,0,129,20,131,16,22,117]),function(te,e,n,k,D,M,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=T;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class w{constructor(Y,ge,We,$e){this.id=Y,this.name=ge,this.defaultValue=We,this.schema=$e}applyUpdate(Y,ge){return v(Y,ge)}compute(Y,ge,We){return We}}class h{constructor(Y,ge){this.newValue=Y,this.didChange=ge}}e.ApplyUpdateResult=h;function v(Q,Y){if(typeof Q!="object"||typeof Y!="object"||!Q||!Y)return new h(Y,Q!==Y);if(Array.isArray(Q)||Array.isArray(Y)){const We=Array.isArray(Q)&&Array.isArray(Y)&&M.equals(Q,Y);return new h(Y,!We)}let ge=!1;for(const We in Y)if(Y.hasOwnProperty(We)){const $e=v(Q[We],Y[We]);$e.didChange&&(Q[We]=$e.newValue,ge=!0)}return new h(Q,ge)}class m{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,ge){return v(Y,ge)}validate(Y){return this.defaultValue}}class a{constructor(Y,ge,We,$e){this.id=Y,this.name=ge,this.defaultValue=We,this.schema=$e}applyUpdate(Y,ge){return v(Y,ge)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,ge,We){return We}}function o(Q,Y){return typeof Q>"u"?Y:Q==="false"?!1:Boolean(Q)}e.boolean=o;class u extends a{constructor(Y,ge,We,$e=void 0){typeof $e<"u"&&($e.type="boolean",$e.default=We),super(Y,ge,We,$e)}validate(Y){return o(Y,this.defaultValue)}}function g(Q,Y,ge,We){if(typeof Q>"u")return Y;let $e=parseInt(Q,10);return isNaN($e)?Y:($e=Math.max(ge,$e),$e=Math.min(We,$e),$e|0)}e.clampedInt=g;class E extends a{static clampedInt(Y,ge,We,$e){return g(Y,ge,We,$e)}constructor(Y,ge,We,$e,Qe,Ke=void 0){typeof Ke<"u"&&(Ke.type="integer",Ke.default=We,Ke.minimum=$e,Ke.maximum=Qe),super(Y,ge,We,Ke),this.minimum=$e,this.maximum=Qe}validate(Y){return E.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class L extends a{static clamp(Y,ge,We){return Y<ge?ge:Y>We?We:Y}static float(Y,ge){if(typeof Y=="number")return Y;if(typeof Y>"u")return ge;const We=parseFloat(Y);return isNaN(We)?ge:We}constructor(Y,ge,We,$e,Qe){typeof Qe<"u"&&(Qe.type="number",Qe.default=We),super(Y,ge,We,Qe),this.validationFn=$e}validate(Y){return this.validationFn(L.float(Y,this.defaultValue))}}class p extends a{static string(Y,ge){return typeof Y!="string"?ge:Y}constructor(Y,ge,We,$e=void 0){typeof $e<"u"&&($e.type="string",$e.default=We),super(Y,ge,We,$e)}validate(Y){return p.string(Y,this.defaultValue)}}function t(Q,Y,ge){return typeof Q!="string"||ge.indexOf(Q)===-1?Y:Q}e.stringSet=t;class d extends a{constructor(Y,ge,We,$e,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.enum=$e,Qe.default=We),super(Y,ge,We,Qe),this.c=$e}validate(Y){return t(Y,this.defaultValue,this.c)}}class r extends w{constructor(Y,ge,We,$e,Qe,Ke,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=Qe,tt.default=$e),super(Y,ge,We,tt),this.c=Qe,this.d=Ke}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function l(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends w{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",tags:["accessibility"],description:n.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,ge,We){return We===0?Y.accessibilitySupport:We}}class b extends w{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:n.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{insertSpace:o(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function P(Q){switch(Q){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=P;function C(Q){switch(Q){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class j extends m{constructor(){super(135)}compute(Y,ge,We){const $e=["monaco-editor"];return ge.get(36)&&$e.push(ge.get(36)),Y.extraEditorClassName&&$e.push(Y.extraEditorClassName),ge.get(70)==="default"?$e.push("mouse-default"):ge.get(70)==="copy"&&$e.push("mouse-copy"),ge.get(105)&&$e.push("showUnused"),ge.get(133)&&$e.push("showDeprecated"),$e.join(" ")}}class _ extends u{constructor(){super(34,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(Y,ge,We){return We&&Y.emptySelectionClipboard}}class K extends w{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:n.localize(16,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:n.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{cursorMoveOnType:o(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":t(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":t(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(ge.loop,this.defaultValue.loop)}}}class A extends w{constructor(){super(48,"fontLigatures",A.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?A.OFF:Y==="true"?A.ON:Y:Boolean(Y)?A.ON:A.OFF}}A.OFF='"liga" off, "calt" off',A.ON='"liga" on, "calt" on',e.EditorFontLigatures=A;class $ extends w{constructor(){super(51,"fontVariations",$.OFF,{anyOf:[{type:"boolean",description:n.localize(22,null)},{type:"string",description:n.localize(23,null)}],description:n.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?$.OFF:Y==="true"?$.TRANSLATE:Y:Boolean(Y)?$.TRANSLATE:$.OFF}compute(Y,ge,We){return Y.fontInfo.fontVariationSettings}}$.OFF="normal",$.TRANSLATE="translate",e.EditorFontVariations=$;class O extends m{constructor(){super(47)}compute(Y,ge,We){return Y.fontInfo}}class F extends a{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(25,null)})}validate(Y){const ge=L.float(Y,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:L.clamp(ge,6,100)}compute(Y,ge,We){return Y.fontInfo.fontSize}}class H extends w{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.d,maximum:H.e,errorMessage:n.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(E.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,H.d,H.e))}}H.c=["normal","bold","100","200","300","400","500","600","700","800","900"],H.d=1,H.e=1e3;class V extends w{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[n.localize(28,null),n.localize(29,null),n.localize(30,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:n.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:n.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:n.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:We,description:n.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:We,description:n.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:We,description:n.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:We,description:n.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:We,description:n.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{multiple:t(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??t(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??t(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??t(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??t(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??t(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ae extends w{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:n.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:n.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:n.localize(44,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:n.localize(45,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:o(ge.enabled,this.defaultValue.enabled),delay:E.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:o(ge.sticky,this.defaultValue.sticky),above:o(ge.above,this.defaultValue.above)}}}var pe;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(pe=e.RenderMinimap||(e.RenderMinimap={}));class re extends m{constructor(){super(138)}compute(Y,ge,We){return re.computeLayout(ge,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const ge=Y.height/Y.lineHeight,We=Math.floor(Y.paddingTop/Y.lineHeight);let $e=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&($e=Math.max($e,ge-1));const Qe=(We+Y.viewLineCount+$e)/(Y.pixelRatio*Y.height),Ke=Math.floor(Y.viewLineCount/Qe);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:$e,desiredRatio:Qe,minimapLineCount:Ke}}static c(Y,ge){const We=Y.outerWidth,$e=Y.outerHeight,Qe=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const Ke=ge.stableMinimapLayoutInput,tt=Ke&&Y.outerHeight===Ke.outerHeight&&Y.lineHeight===Ke.lineHeight&&Y.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&Y.pixelRatio===Ke.pixelRatio&&Y.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&Y.paddingTop===Ke.paddingTop&&Y.paddingBottom===Ke.paddingBottom&&Y.minimap.enabled===Ke.minimap.enabled&&Y.minimap.side===Ke.minimap.side&&Y.minimap.size===Ke.minimap.size&&Y.minimap.showSlider===Ke.minimap.showSlider&&Y.minimap.renderCharacters===Ke.minimap.renderCharacters&&Y.minimap.maxColumn===Ke.minimap.maxColumn&&Y.minimap.scale===Ke.minimap.scale&&Y.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&Y.isViewportWrapping===Ke.isViewportWrapping,at=Y.lineHeight,Et=Y.typicalHalfwidthCharacterWidth,Ct=Y.scrollBeyondLastLine,It=Y.minimap.renderCharacters;let Dt=Qe>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const ut=Y.minimap.maxColumn,ft=Y.minimap.size,Kt=Y.minimap.side,Vt=Y.verticalScrollbarWidth,kt=Y.viewLineCount,ht=Y.remainingWidth,Tt=Y.isViewportWrapping,$t=It?2:3;let At=Math.floor(Qe*$e);const Ge=At/Qe;let Ft=!1,xt=!1,Nt=$t*Dt,mt=Dt/Qe,Ce=1;if(ft==="fill"||ft==="fit"){const{typicalViewportLineCount:Be,extraLinesBeforeFirstLine:Ze,extraLinesBeyondLastLine:ct,desiredRatio:Pt,minimapLineCount:vt}=re.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:Ct,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:$e,lineHeight:at,pixelRatio:Qe});if(kt/vt>1)Ft=!0,xt=!0,Dt=1,Nt=1,mt=Dt/Qe;else{let pt=!1,Rt=Dt+1;if(ft==="fit"){const bt=Math.ceil((Ze+kt+ct)*Nt);Tt&&tt&&ht<=ge.stableFitRemainingWidth?(pt=!0,Rt=ge.stableFitMaxMinimapScale):pt=bt>At}if(ft==="fill"||pt){Ft=!0;const bt=Dt;Nt=Math.min(at*Qe,Math.max(1,Math.floor(1/Pt))),Tt&&tt&&ht<=ge.stableFitRemainingWidth&&(Rt=ge.stableFitMaxMinimapScale),Dt=Math.min(Rt,Math.max(1,Math.floor(Nt/$t))),Dt>bt&&(Ce=Math.min(2,Dt/bt)),mt=Dt/Qe/Ce,At=Math.ceil(Math.max(Be,Ze+kt+ct)*Nt),Tt?(ge.stableMinimapLayoutInput=Y,ge.stableFitRemainingWidth=ht,ge.stableFitMaxMinimapScale=Dt):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const Ae=Math.floor(ut*mt),me=Math.min(Ae,Math.max(0,Math.floor((ht-Vt-2)*mt/(Et+mt)))+e.MINIMAP_GUTTER_WIDTH);let x=Math.floor(Qe*me);const Re=x/Qe;x=Math.floor(x*Ce);const Ue=It?1:2,Ye=Kt==="left"?0:We-me-Vt;return{renderMinimap:Ue,minimapLeft:Ye,minimapWidth:me,minimapHeightIsEditorHeight:Ft,minimapIsSampling:xt,minimapScale:Dt,minimapLineHeight:Nt,minimapCanvasInnerWidth:x,minimapCanvasInnerHeight:At,minimapCanvasOuterWidth:Re,minimapCanvasOuterHeight:Ge}}static computeLayout(Y,ge){const We=ge.outerWidth|0,$e=ge.outerHeight|0,Qe=ge.lineHeight|0,Ke=ge.lineNumbersDigitCount|0,tt=ge.typicalHalfwidthCharacterWidth,at=ge.maxDigitWidth,Et=ge.pixelRatio,Ct=ge.viewLineCount,It=Y.get(130),Dt=It==="inherit"?Y.get(129):It,ut=Dt==="inherit"?Y.get(125):Dt,ft=Y.get(128),Kt=ge.isDominatedByLongLines,Vt=Y.get(54),kt=Y.get(64).renderType!==0,ht=Y.get(65),Tt=Y.get(99),$t=Y.get(80),At=Y.get(69),Ge=Y.get(97),Ft=Ge.verticalScrollbarSize,xt=Ge.verticalHasArrows,Nt=Ge.arrowSize,mt=Ge.horizontalScrollbarSize,Ce=Y.get(40),Ae=Y.get(104)!=="never";let me=Y.get(62);Ce&&Ae&&(me+=16);let x=0;if(kt){const ei=Math.max(Ke,ht);x=Math.round(ei*at)}let Re=0;Vt&&(Re=Qe);let Ue=0,Ye=Ue+Re,Be=Ye+x,Ze=Be+me;const ct=We-Re-x-me;let Pt=!1,vt=!1,wt=-1;Dt==="inherit"&&Kt?(Pt=!0,vt=!0):ut==="on"||ut==="bounded"?vt=!0:ut==="wordWrapColumn"&&(wt=ft);const pt=re.c({outerWidth:We,outerHeight:$e,lineHeight:Qe,typicalHalfwidthCharacterWidth:tt,pixelRatio:Et,scrollBeyondLastLine:Tt,paddingTop:$t.top,paddingBottom:$t.bottom,minimap:At,verticalScrollbarWidth:Ft,viewLineCount:Ct,remainingWidth:ct,isViewportWrapping:vt},ge.memory||new N);pt.renderMinimap!==0&&pt.minimapLeft===0&&(Ue+=pt.minimapWidth,Ye+=pt.minimapWidth,Be+=pt.minimapWidth,Ze+=pt.minimapWidth);const Rt=ct-pt.minimapWidth,bt=Math.max(1,Math.floor((Rt-Ft-2)/tt)),ri=xt?Nt:0;return vt&&(wt=Math.max(1,bt),ut==="bounded"&&(wt=Math.min(wt,ft))),{width:We,height:$e,glyphMarginLeft:Ue,glyphMarginWidth:Re,lineNumbersLeft:Ye,lineNumbersWidth:x,decorationsLeft:Be,decorationsWidth:me,contentLeft:Ze,contentWidth:Rt,minimap:pt,viewportColumn:bt,isWordWrapMinified:Pt,isViewportWrapping:vt,wrappingColumn:wt,verticalScrollbarWidth:Ft,horizontalScrollbarHeight:mt,overviewRuler:{top:ri,width:Ft,height:$e-2*ri,right:0}}}}e.EditorLayoutInfoComputer=re;class ce extends w{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[n.localize(46,null),n.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:n.localize(48,null)}})}validate(Y){return t(Y,"simple",["simple","advanced"])}compute(Y,ge,We){return ge.get(2)===2?"advanced":We}}class ue extends w{constructor(){const Y={enabled:!0};super(61,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:n.localize(49,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:o(Y.enabled,this.defaultValue.enabled)}}}class Se extends w{constructor(){const Y={enabled:!1,maxLineCount:5};super(109,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:n.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:n.localize(51,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:o(ge.enabled,this.defaultValue.enabled),maxLineCount:E.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class G extends w{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:n.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[n.localize(53,null),n.localize(54,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(55,null,k.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:n.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:n.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:n.localize(59,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:t(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:E.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(ge.fontFamily,this.defaultValue.fontFamily),padding:o(ge.padding,this.defaultValue.padding)}}}class X extends w{constructor(){super(62,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):E.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,ge,We){return We<0?E.clampedInt(-We*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):We}}class J extends L{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>L.clamp(Y,0,150),{markdownDescription:n.localize(60,null)})}compute(Y,ge,We){return Y.fontInfo.lineHeight}}class de extends w{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:n.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:n.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(63,null),n.localize(64,null),n.localize(65,null)],default:Y.size,description:n.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:n.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:n.localize(68,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:n.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:n.localize(71,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:o(ge.enabled,this.defaultValue.enabled),autohide:o(ge.autohide,this.defaultValue.autohide),size:t(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(ge.side,this.defaultValue.side,["right","left"]),showSlider:t(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(ge.renderCharacters,this.defaultValue.renderCharacters),scale:E.clampedInt(ge.scale,1,1,3),maxColumn:E.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ye(Q){return Q==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Fe extends w{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(73,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{top:E.clampedInt(ge.top,0,0,1e3),bottom:E.clampedInt(ge.bottom,0,0,1e3)}}}class ze extends w{constructor(){const Y={enabled:!0,cycle:!0};super(81,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:n.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:n.localize(75,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:o(ge.enabled,this.defaultValue.enabled),cycle:o(ge.cycle,this.defaultValue.cycle)}}}class Pe extends m{constructor(){super(136)}compute(Y,ge,We){return Y.pixelRatio}}class Ie extends w{constructor(){const Y={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[n.localize(76,null),n.localize(77,null),n.localize(78,null)]}];super(84,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:Y.strings,description:n.localize(79,null)},comments:{anyOf:ge,default:Y.comments,description:n.localize(80,null)},other:{anyOf:ge,default:Y.other,description:n.localize(81,null)}},default:Y,markdownDescription:n.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const Et=Y?"on":"off";return{comments:Et,strings:Et,other:Et}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:ge,comments:We,strings:$e}=Y,Qe=["on","inline","off"];let Ke,tt,at;return typeof ge=="boolean"?Ke=ge?"on":"off":Ke=t(ge,this.defaultValue.other,Qe),typeof We=="boolean"?tt=We?"on":"off":tt=t(We,this.defaultValue.comments,Qe),typeof $e=="boolean"?at=$e?"on":"off":at=t($e,this.defaultValue.strings,Qe),{other:Ke,comments:tt,strings:at}}}var we;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(we=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class se extends w{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(83,null),n.localize(84,null),n.localize(85,null),n.localize(86,null)],default:"on",description:n.localize(87,null)})}validate(Y){let ge=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(ge=4,We=Y):Y==="interval"?ge=3:Y==="relative"?ge=2:Y==="on"?ge=1:ge=0),{renderType:ge,renderFn:We}}}function le(Q){const Y=Q.get(92);return Y==="editable"?Q.get(86):Y!=="on"}e.filterValidationDecorations=le;class Z extends w{constructor(){const Y=[],ge={type:"number",description:n.localize(88,null)};super(96,"rulers",Y,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:n.localize(89,null),format:"color-hex"}}}]},default:Y,description:n.localize(90,null)})}validate(Y){if(Array.isArray(Y)){const ge=[];for(const We of Y)if(typeof We=="number")ge.push({column:E.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const $e=We;ge.push({column:E.clampedInt($e.column,0,0,1e4),color:$e.color})}return ge.sort((We,$e)=>We.column-$e.column),ge}return this.defaultValue}}function I(Q,Y){if(typeof Q!="string")return Y;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends w{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(91,null),n.localize(92,null),n.localize(93,null)],default:"auto",description:n.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(95,null),n.localize(96,null),n.localize(97,null)],default:"auto",description:n.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:n.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:n.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:n.localize(101,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y,We=E.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=E.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:E.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:I(ge.vertical,this.defaultValue.vertical),horizontal:I(ge.horizontal,this.defaultValue.horizontal),useShadows:o(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:E.clampedInt(ge.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:E.clampedInt(ge.verticalSliderSize,$e,0,1e3),scrollByPage:o(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends w{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:n.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:n.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:n.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:n.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:n.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:n.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:n.localize(108,null)}})}applyUpdate(Y,ge){let We=!1;ge.allowedCharacters&&Y&&(y.equals(Y.allowedCharacters,ge.allowedCharacters)||(Y={...Y,allowedCharacters:ge.allowedCharacters},We=!0)),ge.allowedLocales&&Y&&(y.equals(Y.allowedLocales,ge.allowedLocales)||(Y={...Y,allowedLocales:ge.allowedLocales},We=!0));const $e=super.applyUpdate(Y,ge);return We?new h($e.newValue,!0):$e}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{nonBasicASCII:De(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:De(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:De(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,ge){if(typeof Y!="object"||!Y)return ge;const We={};for(const[$e,Qe]of Object.entries(Y))Qe===!0&&(We[$e]=!0);return We}}class q extends w{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:n.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover"],enumDescriptions:[n.localize(110,null),n.localize(111,null)],description:n.localize(112,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:o(ge.enabled,this.defaultValue.enabled),mode:t(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:t(ge.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class ee extends w{constructor(){const Y={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:n.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:n.localize(114,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{enabled:o(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class fe extends w{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(115,null),n.localize(116,null),n.localize(117,null)],default:Y.bracketPairs,description:n.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(119,null),n.localize(120,null),n.localize(121,null)],default:Y.bracketPairsHorizontal,description:n.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:n.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:n.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[n.localize(125,null),n.localize(126,null),n.localize(127,null)],default:Y.highlightActiveIndentation,description:n.localize(128,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{bracketPairs:De(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:De(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:De(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function De(Q,Y,ge){const We=ge.indexOf(Q);return We===-1?Y:ge[We]}class oe extends w{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(129,null),n.localize(130,null)],default:Y.insertMode,description:n.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:n.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:n.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:n.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[n.localize(135,null),n.localize(136,null),n.localize(137,null),n.localize(138,null)],default:Y.selectionMode,markdownDescription:n.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:n.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:n.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:n.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:n.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:n.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:n.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(176,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ge=Y;return{insertMode:t(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:t(ge.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(ge.showIcons,this.defaultValue.showIcons),showStatusBar:o(ge.showStatusBar,this.defaultValue.showStatusBar),preview:o(ge.preview,this.defaultValue.preview),previewMode:t(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(ge.showMethods,this.defaultValue.showMethods),showFunctions:o(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:o(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(ge.showFields,this.defaultValue.showFields),showVariables:o(ge.showVariables,this.defaultValue.showVariables),showClasses:o(ge.showClasses,this.defaultValue.showClasses),showStructs:o(ge.showStructs,this.defaultValue.showStructs),showInterfaces:o(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:o(ge.showModules,this.defaultValue.showModules),showProperties:o(ge.showProperties,this.defaultValue.showProperties),showEvents:o(ge.showEvents,this.defaultValue.showEvents),showOperators:o(ge.showOperators,this.defaultValue.showOperators),showUnits:o(ge.showUnits,this.defaultValue.showUnits),showValues:o(ge.showValues,this.defaultValue.showValues),showConstants:o(ge.showConstants,this.defaultValue.showConstants),showEnums:o(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:o(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(ge.showKeywords,this.defaultValue.showKeywords),showWords:o(ge.showWords,this.defaultValue.showWords),showColors:o(ge.showColors,this.defaultValue.showColors),showFiles:o(ge.showFiles,this.defaultValue.showFiles),showReferences:o(ge.showReferences,this.defaultValue.showReferences),showFolders:o(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:o(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(ge.showSnippets,this.defaultValue.showSnippets),showUsers:o(ge.showUsers,this.defaultValue.showUsers),showIssues:o(ge.showIssues,this.defaultValue.showIssues)}}}class ve extends w{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(177,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var be;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(be=e.WrappingIndent||(e.WrappingIndent={}));class He extends w{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[n.localize(178,null),n.localize(179,null),n.localize(180,null),n.localize(181,null)],description:n.localize(182,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,ge,We){return ge.get(2)===2?0:We}}class je extends m{constructor(){super(139)}compute(Y,ge,We){const $e=ge.get(138);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}class it extends w{constructor(){const Y={enabled:!0};super(33,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:n.localize(183,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:o(Y.enabled,this.defaultValue.enabled)}}}const Xe="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?et:k.isLinux?nt:Xe,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var rt;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.bracketPairColorization=12]="bracketPairColorization",Q[Q.guides=13]="guides",Q[Q.codeLens=14]="codeLens",Q[Q.codeLensFontFamily=15]="codeLensFontFamily",Q[Q.codeLensFontSize=16]="codeLensFontSize",Q[Q.colorDecorators=17]="colorDecorators",Q[Q.colorDecoratorsLimit=18]="colorDecoratorsLimit",Q[Q.columnSelection=19]="columnSelection",Q[Q.comments=20]="comments",Q[Q.contextmenu=21]="contextmenu",Q[Q.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=23]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=25]="cursorStyle",Q[Q.cursorSurroundingLines=26]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=28]="cursorWidth",Q[Q.disableLayerHinting=29]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",Q[Q.domReadOnly=31]="domReadOnly",Q[Q.dragAndDrop=32]="dragAndDrop",Q[Q.dropIntoEditor=33]="dropIntoEditor",Q[Q.emptySelectionClipboard=34]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=36]="extraEditorClassName",Q[Q.fastScrollSensitivity=37]="fastScrollSensitivity",Q[Q.find=38]="find",Q[Q.fixedOverflowWidgets=39]="fixedOverflowWidgets",Q[Q.folding=40]="folding",Q[Q.foldingStrategy=41]="foldingStrategy",Q[Q.foldingHighlight=42]="foldingHighlight",Q[Q.foldingImportsByDefault=43]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=44]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=46]="fontFamily",Q[Q.fontInfo=47]="fontInfo",Q[Q.fontLigatures=48]="fontLigatures",Q[Q.fontSize=49]="fontSize",Q[Q.fontWeight=50]="fontWeight",Q[Q.fontVariations=51]="fontVariations",Q[Q.formatOnPaste=52]="formatOnPaste",Q[Q.formatOnType=53]="formatOnType",Q[Q.glyphMargin=54]="glyphMargin",Q[Q.gotoLocation=55]="gotoLocation",Q[Q.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",Q[Q.hover=57]="hover",Q[Q.inDiffEditor=58]="inDiffEditor",Q[Q.inlineSuggest=59]="inlineSuggest",Q[Q.letterSpacing=60]="letterSpacing",Q[Q.lightbulb=61]="lightbulb",Q[Q.lineDecorationsWidth=62]="lineDecorationsWidth",Q[Q.lineHeight=63]="lineHeight",Q[Q.lineNumbers=64]="lineNumbers",Q[Q.lineNumbersMinChars=65]="lineNumbersMinChars",Q[Q.linkedEditing=66]="linkedEditing",Q[Q.links=67]="links",Q[Q.matchBrackets=68]="matchBrackets",Q[Q.minimap=69]="minimap",Q[Q.mouseStyle=70]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=72]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=74]="multiCursorModifier",Q[Q.multiCursorPaste=75]="multiCursorPaste",Q[Q.multiCursorLimit=76]="multiCursorLimit",Q[Q.occurrencesHighlight=77]="occurrencesHighlight",Q[Q.overviewRulerBorder=78]="overviewRulerBorder",Q[Q.overviewRulerLanes=79]="overviewRulerLanes",Q[Q.padding=80]="padding",Q[Q.parameterHints=81]="parameterHints",Q[Q.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=84]="quickSuggestions",Q[Q.quickSuggestionsDelay=85]="quickSuggestionsDelay",Q[Q.readOnly=86]="readOnly",Q[Q.renameOnType=87]="renameOnType",Q[Q.renderControlCharacters=88]="renderControlCharacters",Q[Q.renderFinalNewline=89]="renderFinalNewline",Q[Q.renderLineHighlight=90]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=92]="renderValidationDecorations",Q[Q.renderWhitespace=93]="renderWhitespace",Q[Q.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",Q[Q.roundedSelection=95]="roundedSelection",Q[Q.rulers=96]="rulers",Q[Q.scrollbar=97]="scrollbar",Q[Q.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=99]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=100]="scrollPredominantAxis",Q[Q.selectionClipboard=101]="selectionClipboard",Q[Q.selectionHighlight=102]="selectionHighlight",Q[Q.selectOnLineNumbers=103]="selectOnLineNumbers",Q[Q.showFoldingControls=104]="showFoldingControls",Q[Q.showUnused=105]="showUnused",Q[Q.snippetSuggestions=106]="snippetSuggestions",Q[Q.smartSelect=107]="smartSelect",Q[Q.smoothScrolling=108]="smoothScrolling",Q[Q.stickyScroll=109]="stickyScroll",Q[Q.stickyTabStops=110]="stickyTabStops",Q[Q.stopRenderingLineAfter=111]="stopRenderingLineAfter",Q[Q.suggest=112]="suggest",Q[Q.suggestFontSize=113]="suggestFontSize",Q[Q.suggestLineHeight=114]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",Q[Q.suggestSelection=116]="suggestSelection",Q[Q.tabCompletion=117]="tabCompletion",Q[Q.tabIndex=118]="tabIndex",Q[Q.unicodeHighlighting=119]="unicodeHighlighting",Q[Q.unusualLineTerminators=120]="unusualLineTerminators",Q[Q.useShadowDOM=121]="useShadowDOM",Q[Q.useTabStops=122]="useTabStops",Q[Q.wordBreak=123]="wordBreak",Q[Q.wordSeparators=124]="wordSeparators",Q[Q.wordWrap=125]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=128]="wordWrapColumn",Q[Q.wordWrapOverride1=129]="wordWrapOverride1",Q[Q.wordWrapOverride2=130]="wordWrapOverride2",Q[Q.wrappingIndent=131]="wrappingIndent",Q[Q.wrappingStrategy=132]="wrappingStrategy",Q[Q.showDeprecated=133]="showDeprecated",Q[Q.inlayHints=134]="inlayHints",Q[Q.editorClassName=135]="editorClassName",Q[Q.pixelRatio=136]="pixelRatio",Q[Q.tabFocusMode=137]="tabFocusMode",Q[Q.layoutInfo=138]="layoutInfo",Q[Q.wrappingInfo=139]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(184,null)})),acceptSuggestionOnEnter:Ne(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(185,null),""],markdownDescription:n.localize(186,null)})),accessibilitySupport:Ne(new c),accessibilityPageSize:Ne(new E(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(187,null),tags:["accessibility"]})),ariaLabel:Ne(new p(4,"ariaLabel",n.localize(188,null))),autoClosingBrackets:Ne(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(189,null),n.localize(190,null),""],description:n.localize(191,null)})),autoClosingDelete:Ne(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(192,null),""],description:n.localize(193,null)})),autoClosingOvertype:Ne(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(194,null),""],description:n.localize(195,null)})),autoClosingQuotes:Ne(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(196,null),n.localize(197,null),""],description:n.localize(198,null)})),autoIndent:Ne(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[n.localize(199,null),n.localize(200,null),n.localize(201,null),n.localize(202,null),n.localize(203,null)],description:n.localize(204,null)})),automaticLayout:Ne(new u(10,"automaticLayout",!1)),autoSurround:Ne(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(205,null),n.localize(206,null),n.localize(207,null),""],description:n.localize(208,null)})),bracketPairColorization:Ne(new ee),bracketPairGuides:Ne(new fe),stickyTabStops:Ne(new u(110,"stickyTabStops",!1,{description:n.localize(209,null)})),codeLens:Ne(new u(14,"codeLens",!0,{description:n.localize(210,null)})),codeLensFontFamily:Ne(new p(15,"codeLensFontFamily","",{description:n.localize(211,null)})),codeLensFontSize:Ne(new E(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(212,null)})),colorDecorators:Ne(new u(17,"colorDecorators",!0,{description:n.localize(213,null)})),colorDecoratorsLimit:Ne(new E(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:n.localize(214,null)})),columnSelection:Ne(new u(19,"columnSelection",!1,{description:n.localize(215,null)})),comments:Ne(new b),contextmenu:Ne(new u(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new u(22,"copyWithSyntaxHighlighting",!0,{description:n.localize(216,null)})),cursorBlinking:Ne(new r(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:n.localize(217,null)})),cursorSmoothCaretAnimation:Ne(new d(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[n.localize(218,null),n.localize(219,null),n.localize(220,null)],description:n.localize(221,null)})),cursorStyle:Ne(new r(25,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:n.localize(222,null)})),cursorSurroundingLines:Ne(new E(26,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(223,null)})),cursorSurroundingLinesStyle:Ne(new d(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(224,null),n.localize(225,null)],description:n.localize(226,null)})),cursorWidth:Ne(new E(28,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(227,null)})),disableLayerHinting:Ne(new u(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new u(30,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new u(31,"domReadOnly",!1)),dragAndDrop:Ne(new u(32,"dragAndDrop",!0,{description:n.localize(228,null)})),emptySelectionClipboard:Ne(new _),dropIntoEditor:Ne(new it),stickyScroll:Ne(new Se),experimentalWhitespaceRendering:Ne(new d(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[n.localize(229,null),n.localize(230,null),n.localize(231,null)],description:n.localize(232,null)})),extraEditorClassName:Ne(new p(36,"extraEditorClassName","")),fastScrollSensitivity:Ne(new L(37,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:n.localize(233,null)})),find:Ne(new K),fixedOverflowWidgets:Ne(new u(39,"fixedOverflowWidgets",!1)),folding:Ne(new u(40,"folding",!0,{description:n.localize(234,null)})),foldingStrategy:Ne(new d(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(235,null),n.localize(236,null)],description:n.localize(237,null)})),foldingHighlight:Ne(new u(42,"foldingHighlight",!0,{description:n.localize(238,null)})),foldingImportsByDefault:Ne(new u(43,"foldingImportsByDefault",!1,{description:n.localize(239,null)})),foldingMaximumRegions:Ne(new E(44,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(240,null)})),unfoldOnClickAfterEndOfLine:Ne(new u(45,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(241,null)})),fontFamily:Ne(new p(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:n.localize(242,null)})),fontInfo:Ne(new O),fontLigatures2:Ne(new A),fontSize:Ne(new F),fontWeight:Ne(new H),fontVariations:Ne(new $),formatOnPaste:Ne(new u(52,"formatOnPaste",!1,{description:n.localize(243,null)})),formatOnType:Ne(new u(53,"formatOnType",!1,{description:n.localize(244,null)})),glyphMargin:Ne(new u(54,"glyphMargin",!0,{description:n.localize(245,null)})),gotoLocation:Ne(new V),hideCursorInOverviewRuler:Ne(new u(56,"hideCursorInOverviewRuler",!1,{description:n.localize(246,null)})),hover:Ne(new ae),inDiffEditor:Ne(new u(58,"inDiffEditor",!1)),letterSpacing:Ne(new L(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>L.clamp(Q,-5,20),{description:n.localize(247,null)})),lightbulb:Ne(new ue),lineDecorationsWidth:Ne(new X),lineHeight:Ne(new J),lineNumbers:Ne(new se),lineNumbersMinChars:Ne(new E(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new u(66,"linkedEditing",!1,{description:n.localize(248,null)})),links:Ne(new u(67,"links",!0,{description:n.localize(249,null)})),matchBrackets:Ne(new d(68,"matchBrackets","always",["always","near","never"],{description:n.localize(250,null)})),minimap:Ne(new de),mouseStyle:Ne(new d(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new L(71,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:n.localize(251,null)})),mouseWheelZoom:Ne(new u(72,"mouseWheelZoom",!1,{markdownDescription:n.localize(252,null)})),multiCursorMergeOverlapping:Ne(new u(73,"multiCursorMergeOverlapping",!0,{description:n.localize(253,null)})),multiCursorModifier:Ne(new r(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ye,{markdownEnumDescriptions:[n.localize(254,null),n.localize(255,null)],markdownDescription:n.localize(256,null)})),multiCursorPaste:Ne(new d(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(257,null),n.localize(258,null)],markdownDescription:n.localize(259,null)})),multiCursorLimit:Ne(new E(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:n.localize(260,null)})),occurrencesHighlight:Ne(new u(77,"occurrencesHighlight",!0,{description:n.localize(261,null)})),overviewRulerBorder:Ne(new u(78,"overviewRulerBorder",!0,{description:n.localize(262,null)})),overviewRulerLanes:Ne(new E(79,"overviewRulerLanes",3,0,3)),padding:Ne(new Fe),parameterHints:Ne(new ze),peekWidgetDefaultFocus:Ne(new d(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(263,null),n.localize(264,null)],description:n.localize(265,null)})),definitionLinkOpensInPeek:Ne(new u(83,"definitionLinkOpensInPeek",!1,{description:n.localize(266,null)})),quickSuggestions:Ne(new Ie),quickSuggestionsDelay:Ne(new E(85,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(267,null)})),readOnly:Ne(new u(86,"readOnly",!1)),renameOnType:Ne(new u(87,"renameOnType",!1,{description:n.localize(268,null),markdownDeprecationMessage:n.localize(269,null)})),renderControlCharacters:Ne(new u(88,"renderControlCharacters",!0,{description:n.localize(270,null),restricted:!0})),renderFinalNewline:Ne(new d(89,"renderFinalNewline",k.isLinux?"dimmed":"on",["off","on","dimmed"],{description:n.localize(271,null)})),renderLineHighlight:Ne(new d(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(272,null)],description:n.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Ne(new u(91,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(274,null)})),renderValidationDecorations:Ne(new d(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new d(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(275,null),n.localize(276,null),n.localize(277,null),""],description:n.localize(278,null)})),revealHorizontalRightPadding:Ne(new E(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new u(95,"roundedSelection",!0,{description:n.localize(279,null)})),rulers:Ne(new Z),scrollbar:Ne(new B),scrollBeyondLastColumn:Ne(new E(98,"scrollBeyondLastColumn",4,0,1073741824,{description:n.localize(280,null)})),scrollBeyondLastLine:Ne(new u(99,"scrollBeyondLastLine",!0,{description:n.localize(281,null)})),scrollPredominantAxis:Ne(new u(100,"scrollPredominantAxis",!0,{description:n.localize(282,null)})),selectionClipboard:Ne(new u(101,"selectionClipboard",!0,{description:n.localize(283,null),included:k.isLinux})),selectionHighlight:Ne(new u(102,"selectionHighlight",!0,{description:n.localize(284,null)})),selectOnLineNumbers:Ne(new u(103,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new d(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[n.localize(285,null),n.localize(286,null),n.localize(287,null)],description:n.localize(288,null)})),showUnused:Ne(new u(105,"showUnused",!0,{description:n.localize(289,null)})),showDeprecated:Ne(new u(133,"showDeprecated",!0,{description:n.localize(290,null)})),inlayHints:Ne(new G),snippetSuggestions:Ne(new d(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(291,null),n.localize(292,null),n.localize(293,null),n.localize(294,null)],description:n.localize(295,null)})),smartSelect:Ne(new ve),smoothScrolling:Ne(new u(108,"smoothScrolling",!1,{description:n.localize(296,null)})),stopRenderingLineAfter:Ne(new E(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new oe),inlineSuggest:Ne(new q),suggestFontSize:Ne(new E(113,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new E(114,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new u(115,"suggestOnTriggerCharacters",!0,{description:n.localize(299,null)})),suggestSelection:Ne(new d(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(300,null),n.localize(301,null),n.localize(302,null)],description:n.localize(303,null)})),tabCompletion:Ne(new d(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(304,null),n.localize(305,null),n.localize(306,null)],description:n.localize(307,null)})),tabIndex:Ne(new E(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new W),unusualLineTerminators:Ne(new d(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(308,null),n.localize(309,null),n.localize(310,null)],description:n.localize(311,null)})),useShadowDOM:Ne(new u(121,"useShadowDOM",!0)),useTabStops:Ne(new u(122,"useTabStops",!0,{description:n.localize(312,null)})),wordBreak:Ne(new d(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[n.localize(313,null),n.localize(314,null)],description:n.localize(315,null)})),wordSeparators:Ne(new p(124,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:n.localize(316,null)})),wordWrap:Ne(new d(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(317,null),n.localize(318,null),n.localize(319,null),n.localize(320,null)],description:n.localize(321,null)})),wordWrapBreakAfterCharacters:Ne(new p(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new p(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new E(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(322,null)})),wordWrapOverride1:Ne(new d(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new d(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new j),pixelRatio:Ne(new Pe),tabFocusMode:Ne(new u(137,"tabFocusMode",!1,{markdownDescription:n.localize(323,null)})),layoutInfo:Ne(new re),wrappingInfo:Ne(new je),wrappingIndent:Ne(new He),wrappingStrategy:Ne(new ce)}}),define(ke[132],Te([13,14]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[133],Te([13,14]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[134],Te([13,14]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[135],Te([13,14]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(ke[136],Te([13,14]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(ke[137],Te([13,14]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[138],Te([13,14]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(ke[139],Te([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[140],Te([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[141],Te([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(ke[142],Te([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[143],Te([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[144],Te([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[145],Te([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[146],Te([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[147],Te([13,14]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(ke[148],Te([13,14]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(ke[149],Te([13,14]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[150],Te([13,14]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[151],Te([13,14]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[152],Te([13,14]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[153],Te([13,14]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[154],Te([13,14]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[155],Te([13,14]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[156],Te([1,0,12]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class k{constructor(){this.a=new Map}register(M,y){this.a.set(M,y)}updateManifest(M){if(!(typeof M.main>"u"&&typeof M.browser>"u")&&(M.activationEvents===void 0&&Object.assign(M,{activationEvents:[]}),!(!Array.isArray(M.activationEvents)||!M.contributes)))for(const y in M.contributes){const R=this.a.get(y);if(!R)continue;const S=M.contributes[y],T=Array.isArray(S)?S:[S];try{R(T,M.activationEvents)}catch(N){(0,n.onUnexpectedError)(N)}}}}e.ImplicitActivationEventsImpl=k,e.ImplicitActivationEvents=new k}),define(ke[157],Te([1,0,24,29,134,257]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function S(u){return u=u.trim(),u==="*"||y.test(u)}e.isValidVersionStr=S;function T(u){if(!S(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=u.match(y);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=T;function N(u){if(!u)return null;const g=u.majorBase,E=u.majorMustEqual,L=u.minorBase;let p=u.minorMustEqual;const t=u.patchBase;let d=u.patchMustEqual;u.hasCaret&&(g===0||(p=!1),d=!1);let r=0;if(u.preRelease){const l=R.exec(u.preRelease);if(l){const[,c,b,i]=l;r=Date.UTC(Number(c),Number(b)-1,Number(i))}}return{majorBase:g,majorMustEqual:E,minorBase:L,minorMustEqual:p,patchBase:t,patchMustEqual:d,isMinimum:u.hasGreaterEquals,notBefore:r}}e.normalizeVersion=N;function w(u,g,E){let L;typeof u=="string"?L=N(T(u)):L=u;let p;g instanceof Date?p=g.getTime():typeof g=="string"&&(p=new Date(g).getTime());let t;if(typeof E=="string"?t=N(T(E)):t=E,!L||!t)return!1;const d=L.majorBase,r=L.minorBase,l=L.patchBase;let c=t.majorBase,b=t.minorBase,i=t.patchBase;const s=t.notBefore;let f=t.majorMustEqual,P=t.minorMustEqual,C=t.patchMustEqual;return t.isMinimum?d>c?!0:d<c?!1:r>b?!0:r<b||p&&p<s?!1:l>=i:(d===1&&c===0&&(!f||!P||!C)&&(c=1,b=0,i=0,f=!0,P=!1,C=!1),d<c?!1:d>c?!f:r<b?!1:r>b?!P:l<i?!1:l>i?!C:!(p&&p<s))}e.isValidVersion=w;function h(u,g,E,L,p){const t=[];if(typeof L.publisher<"u"&&typeof L.publisher!="string")return t.push([k.default.Error,D.localize(0,null)]),t;if(typeof L.name!="string")return t.push([k.default.Error,D.localize(1,null,"name")]),t;if(typeof L.version!="string")return t.push([k.default.Error,D.localize(2,null,"version")]),t;if(!L.engines)return t.push([k.default.Error,D.localize(3,null,"engines")]),t;if(typeof L.engines.vscode!="string")return t.push([k.default.Error,D.localize(4,null,"engines.vscode")]),t;if(typeof L.extensionDependencies<"u"&&!o(L.extensionDependencies))return t.push([k.default.Error,D.localize(5,null,"extensionDependencies")]),t;if(typeof L.activationEvents<"u"){if(!o(L.activationEvents))return t.push([k.default.Error,D.localize(6,null,"activationEvents")]),t;if(typeof L.main>"u"&&typeof L.browser>"u")return t.push([k.default.Error,D.localize(7,null,"activationEvents","main")]),t}if(typeof L.extensionKind<"u"&&typeof L.main>"u"&&t.push([k.default.Warning,D.localize(8,null,"extensionKind")]),typeof L.main<"u"){if(typeof L.main!="string")return t.push([k.default.Error,D.localize(9,null,"main")]),t;{const l=(0,n.joinPath)(E,L.main);(0,n.isEqualOrParent)(l,E)||t.push([k.default.Warning,D.localize(10,null,l.path,E.path)])}if(typeof L.activationEvents>"u")return t.push([k.default.Error,D.localize(11,null,"activationEvents","main")]),t}if(typeof L.browser<"u"){if(typeof L.browser!="string")return t.push([k.default.Error,D.localize(12,null,"browser")]),t;{const l=(0,n.joinPath)(E,L.browser);(0,n.isEqualOrParent)(l,E)||t.push([k.default.Warning,D.localize(13,null,l.path,E.path)])}if(typeof L.activationEvents>"u")return t.push([k.default.Error,D.localize(14,null,"activationEvents","browser")]),t}if(!M.valid(L.version))return t.push([k.default.Error,D.localize(15,null)]),t;const d=[];if(!v(u,g,L,p,d))for(const l of d)t.push([k.default.Error,l]);return t}e.validateExtensionManifest=h;function v(u,g,E,L,p){return L||typeof E.main>"u"&&typeof E.browser>"u"?!0:a(u,g,E.engines.vscode,p)}e.isValidExtensionVersion=v;function m(u,g,E){return u==="*"||a(g,E,u)}e.isEngineValid=m;function a(u,g,E,L=[]){const p=N(T(E));if(!p)return L.push(D.localize(16,null,E)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return L.push(D.localize(17,null,E)),!1}else if(!p.majorMustEqual)return L.push(D.localize(18,null,E)),!1;return w(u,g,p)?!0:(L.push(D.localize(19,null,u,E)),!1)}function o(u){if(!Array.isArray(u))return!1;for(let g=0,E=u.length;g<E;g++)if(typeof u[g]!="string")return!1;return!0}}),define(ke[89],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(D,M=[],y=!1){this.ctor=D,this.staticArguments=M,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=n}),define(ke[67],Te([1,0,89]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const k=[];var D;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function M(R,S,T){S instanceof n.SyncDescriptor||(S=new n.SyncDescriptor(S,[],Boolean(T))),k.push([R,S])}e.registerSingleton=M;function y(){return k}e.getSingletonServiceDescriptors=y}),define(ke[158],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(M,y){this.key=M,this.data=y,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class k{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const y of this.a.values())y.outgoing.size===0&&M.push(y);return M}insertEdge(M,y){const R=this.lookupOrInsertNode(M),S=this.lookupOrInsertNode(y);R.outgoing.set(S.key,S),S.incoming.set(R.key,R)}removeNode(M){const y=this.b(M);this.a.delete(y);for(const R of this.a.values())R.outgoing.delete(y),R.incoming.delete(y)}lookupOrInsertNode(M){const y=this.b(M);let R=this.a.get(y);return R||(R=new n(y,M),this.a.set(y,R)),R}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[y,R]of this.a)M.push(`${y}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,y]of this.a){const R=new Set([M]),S=this.c(y,R);if(S)return S}}c(M,y){for(const[R,S]of M.outgoing){if(y.has(R))return[...y,R].join(" -> ");y.add(R);const T=this.c(S,y);if(T)return T;y.delete(R)}}}e.Graph=k}),define(ke[3],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function R(S){return S[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=R})(n=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function k(y,R,S){R[n.DI_TARGET]===R?R[n.DI_DEPENDENCIES].push({id:y,index:S}):(R[n.DI_DEPENDENCIES]=[{id:y,index:S}],R[n.DI_TARGET]=R)}function D(y){if(n.serviceIds.has(y))return n.serviceIds.get(y);const R=function(S,T,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(R,S,N)};return R.toString=()=>y,n.serviceIds.set(y,R),R}e.createDecorator=D;function M(y){return y}e.refineServiceDecorator=M}),define(ke[41],Te([1,0,9,2,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function M(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof k.URI)}e.isConfigurationOverrides=M;function y(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof k.URI)}e.isConfigurationUpdateOverrides=y;var R;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function T(o,u){const g=Object.create(null);for(const E in o)N(g,E,o[E],u);return g}e.toValuesTree=T;function N(o,u,g,E){const L=u.split("."),p=L.pop();let t=o;for(let d=0;d<L.length;d++){const r=L[d];let l=t[r];switch(typeof l){case"undefined":l=t[r]=Object.create(null);break;case"object":break;default:E(`Ignoring ${u} as ${L.slice(0,d+1).join(".")} is ${JSON.stringify(l)}`);return}t=l}if(typeof t=="object"&&t!==null)try{t[p]=g}catch{E(`Ignoring ${u} as ${L.join(".")} is ${JSON.stringify(t)}`)}else E(`Ignoring ${u} as ${L.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=N;function w(o,u){const g=u.split(".");h(o,g)}e.removeFromValueTree=w;function h(o,u){const g=u.shift();if(u.length===0){delete o[g];return}if(Object.keys(o).indexOf(g)!==-1){const E=o[g];typeof E=="object"&&!Array.isArray(E)&&(h(E,u),Object.keys(E).length===0&&delete o[g])}}function v(o,u,g){function E(t,d){let r=t;for(const l of d){if(typeof r!="object"||r===null)return;r=r[l]}return r}const L=u.split("."),p=E(o,L);return typeof p>"u"?g:p}e.getConfigurationValue=v;function m(o,u,g){Object.keys(u).forEach(E=>{E!=="__proto__"&&(E in o?n.isObject(o[E])&&n.isObject(u[E])?m(o[E],u[E],g):g&&(o[E]=u[E]):o[E]=u[E])})}e.merge=m;function a(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=a}),define(ke[42],Te([1,0,20,10,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",n.isMacintosh),M.set("isLinux",n.isLinux),M.set("isWindows",n.isWindows),M.set("isWeb",n.isWeb),M.set("isMacNative",n.isMacintosh&&!n.isWeb),M.set("isEdge",n.isEdge),M.set("isFirefox",n.isFirefox),M.set("isChrome",n.isChrome),M.set("isSafari",n.isSafari);const y=Object.prototype.hasOwnProperty;var R;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return w.INSTANCE}static true(){return h.INSTANCE}static has(A){return v.create(A)}static equals(A,$){return m.create(A,$)}static notEquals(A,$){return u.create(A,$)}static regex(A,$){return r.create(A,$)}static in(A,$){return a.create(A,$)}static notIn(A,$){return o.create(A,$)}static not(A){return g.create(A)}static and(...A){return b.create(A,null,!0)}static or(...A){return i.create(A,null,!0)}static greater(A,$){return L.create(A,$)}static greaterEquals(A,$){return p.create(A,$)}static smaller(A,$){return t.create(A,$)}static smallerEquals(A,$){return d.create(A,$)}static deserialize(A){if(!!A)return this.c(A)}static c(A){const $=A.split("||");return i.create($.map(O=>this.d(O)),null,!0)}static d(A){const $=A.split("&&");return b.create($.map(O=>this.f(O)),null,!0)}static f(A){if(A=A.trim(),A.indexOf("!=")>=0){const $=A.split("!=");return u.create($[0].trim(),this.g($[1]))}if(A.indexOf("==")>=0){const $=A.split("==");return m.create($[0].trim(),this.g($[1]))}if(A.indexOf("=~")>=0){const $=A.split("=~");return r.create($[0].trim(),this.h($[1]))}if(A.indexOf(" not in ")>=0){const $=A.split(" not in ");return o.create($[0].trim(),this.g($[1]))}if(A.indexOf(" in ")>=0){const $=A.split(" in ");return a.create($[0].trim(),this.g($[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const $=A.split(">=");return p.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const $=A.split(">");return L.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const $=A.split("<=");return d.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const $=A.split("<");return t.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(A)?g.create(A.substr(1).trim()):v.create(A)}static g(A){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;const $=/^'([^']*)'$/.exec(A);return $?$[1].trim():A}static h(A){if((0,k.isFalsyOrWhitespace)(A))return console.warn("missing regexp-value for =~-expression"),null;const $=A.indexOf("/"),O=A.lastIndexOf("/");if($===O||$<0)return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null;const F=A.slice($+1,O),H=A[O+1]==="i"?"i":"";try{return new RegExp(F,H)}catch(V){return console.warn(`bad regexp-value '${A}', parse error: ${V}`),null}}}e.ContextKeyExpr=S;function T(K,A){const $=K?K.substituteConstants():void 0,O=A?A.substituteConstants():void 0;return!$&&!O?!0:!$||!O?!1:$.equals(O)}e.expressionsAreEqualWithConstantSubstitution=T;function N(K,A){return K.cmp(A)}class w{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return h.INSTANCE}}w.INSTANCE=new w,e.ContextKeyFalseExpr=w;class h{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return w.INSTANCE}}h.INSTANCE=new h,e.ContextKeyTrueExpr=h;class v{static create(A,$=null){const O=M.get(A);return typeof O=="boolean"?O?h.INSTANCE:w.INSTANCE:new v(A,$)}constructor(A,$){this.key=A,this.c=$,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:f(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=M.get(this.key);return typeof A=="boolean"?A?h.INSTANCE:w.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=g.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=v;class m{static create(A,$,O=null){if(typeof $=="boolean")return $?v.create(A,O):g.create(A,O);const F=M.get(A);return typeof F=="boolean"?$===(F?"true":"false")?h.INSTANCE:w.INSTANCE:new m(A,$,O)}constructor(A,$,O){this.c=A,this.d=$,this.f=O,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=M.get(this.c);if(typeof A=="boolean"){const $=A?"true":"false";return this.d===$?h.INSTANCE:w.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=m;class a{static create(A,$){return new a(A,$)}constructor(A,$){this.d=A,this.f=$,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:P(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const $=A.getValue(this.f),O=A.getValue(this.d);return Array.isArray($)?$.includes(O):typeof O=="string"&&typeof $=="object"&&$!==null?y.call($,O):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=o.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=a;class o{static create(A,$){return new o(A,$)}constructor(A,$){this.d=A,this.f=$,this.type=11,this.c=a.create(A,$)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=o;class u{static create(A,$,O=null){if(typeof $=="boolean")return $?g.create(A,O):v.create(A,O);const F=M.get(A);return typeof F=="boolean"?$===(F?"true":"false")?w.INSTANCE:h.INSTANCE:new u(A,$,O)}constructor(A,$,O){this.c=A,this.d=$,this.f=O,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=M.get(this.c);if(typeof A=="boolean"){const $=A?"true":"false";return this.d===$?w.INSTANCE:h.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=u;class g{static create(A,$=null){const O=M.get(A);return typeof O=="boolean"?O?w.INSTANCE:h.INSTANCE:new g(A,$)}constructor(A,$){this.c=A,this.d=$,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:f(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=M.get(this.c);return typeof A=="boolean"?A?w.INSTANCE:h.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.ContextKeyNotExpr=g;function E(K,A){if(typeof K=="string"){const $=parseFloat(K);isNaN($)||(K=$)}return typeof K=="string"||typeof K=="number"?A(K):w.INSTANCE}class L{static create(A,$,O=null){return E($,F=>new L(A,F,O))}constructor(A,$,O){this.c=A,this.d=$,this.f=O,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=L;class p{static create(A,$,O=null){return E($,F=>new p(A,F,O))}constructor(A,$,O){this.c=A,this.d=$,this.f=O,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=t.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=p;class t{static create(A,$,O=null){return E($,F=>new t(A,F,O))}constructor(A,$,O){this.c=A,this.d=$,this.f=O,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=t;class d{static create(A,$,O=null){return E($,F=>new d(A,F,O))}constructor(A,$,O){this.c=A,this.d=$,this.f=O,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=d;class r{static create(A,$){return new r(A,$)}constructor(A,$){this.d=A,this.f=$,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const $=this.f?this.f.source:"",O=A.f?A.f.source:"";return $<O?-1:$>O?1:0}equals(A){if(A.type===this.type){const $=this.f?this.f.source:"",O=A.f?A.f.source:"";return this.d===A.d&&$===O}return!1}substituteConstants(){return this}evaluate(A){const $=A.getValue(this.d);return this.f?this.f.test($):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=l.create(this)),this.c}}e.ContextKeyRegexExpr=r;class l{static create(A){return new l(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(A){return new l(this.c.map(A))}negate(){return this.c}}e.ContextKeyNotRegexExpr=l;function c(K){let A=null;for(let $=0,O=K.length;$<O;$++){const F=K[$].substituteConstants();if(K[$]!==F&&A===null){A=[];for(let H=0;H<$;H++)A[H]=K[H]}A!==null&&(A[$]=F)}return A===null?K:A}class b{static create(A,$,O){return b.d(A,$,O)}constructor(A,$){this.expr=A,this.c=$,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let $=0,O=this.expr.length;$<O;$++){const F=N(this.expr[$],A.expr[$]);if(F!==0)return F}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let $=0,O=this.expr.length;$<O;$++)if(!this.expr[$].equals(A.expr[$]))return!1;return!0}return!1}substituteConstants(){const A=c(this.expr);return A===this.expr?this:b.create(A,this.c,!1)}evaluate(A){for(let $=0,O=this.expr.length;$<O;$++)if(!this.expr[$].evaluate(A))return!1;return!0}static d(A,$,O){const F=[];let H=!1;for(const V of A)if(!!V){if(V.type===1){H=!0;continue}if(V.type===0)return w.INSTANCE;if(V.type===6){F.push(...V.expr);continue}F.push(V)}if(F.length===0&&H)return h.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(N);for(let V=1;V<F.length;V++)F[V-1].equals(F[V])&&(F.splice(V,1),V--);if(F.length===1)return F[0];for(;F.length>1;){const V=F[F.length-1];if(V.type!==9)break;F.pop();const ae=F.pop(),pe=F.length===0,re=i.create(V.expr.map(ce=>b.create([ce,ae],null,O)),null,pe);re&&(F.push(re),F.sort(N))}if(F.length===1)return F[0];if(O){for(let V=0;V<F.length;V++)for(let ae=V+1;ae<F.length;ae++)if(F[V].negate().equals(F[ae]))return w.INSTANCE;if(F.length===1)return F[0]}return new b(F,$)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const $ of this.expr)A.push(...$.keys());return A}map(A){return new b(this.expr.map($=>$.map(A)),null)}negate(){if(!this.c){const A=[];for(const $ of this.expr)A.push($.negate());this.c=i.create(A,this,!0)}return this.c}}class i{static create(A,$,O){return i.d(A,$,O)}constructor(A,$){this.expr=A,this.c=$,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let $=0,O=this.expr.length;$<O;$++){const F=N(this.expr[$],A.expr[$]);if(F!==0)return F}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let $=0,O=this.expr.length;$<O;$++)if(!this.expr[$].equals(A.expr[$]))return!1;return!0}return!1}substituteConstants(){const A=c(this.expr);return A===this.expr?this:i.create(A,this.c,!1)}evaluate(A){for(let $=0,O=this.expr.length;$<O;$++)if(this.expr[$].evaluate(A))return!0;return!1}static d(A,$,O){let F=[],H=!1;if(A){for(let V=0,ae=A.length;V<ae;V++){const pe=A[V];if(!!pe){if(pe.type===0){H=!0;continue}if(pe.type===1)return h.INSTANCE;if(pe.type===9){F=F.concat(pe.expr);continue}F.push(pe)}}if(F.length===0&&H)return w.INSTANCE;F.sort(N)}if(F.length!==0){if(F.length===1)return F[0];for(let V=1;V<F.length;V++)F[V-1].equals(F[V])&&(F.splice(V,1),V--);if(F.length===1)return F[0];if(O){for(let V=0;V<F.length;V++)for(let ae=V+1;ae<F.length;ae++)if(F[V].negate().equals(F[ae]))return h.INSTANCE;if(F.length===1)return F[0]}return new i(F,$)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const $ of this.expr)A.push(...$.keys());return A}map(A){return new i(this.expr.map($=>$.map(A)),null)}negate(){if(!this.c){const A=[];for(const $ of this.expr)A.push($.negate());for(;A.length>1;){const $=A.shift(),O=A.shift(),F=[];for(const H of _($))for(const V of _(O))F.push(b.create([H,V],null,!1));A.unshift(i.create(F,null,!1))}this.c=i.create(A,this,!0)}return this.c}}class s extends v{static all(){return s.d.values()}constructor(A,$,O){super(A,null),this.f=$,typeof O=="object"?s.d.push({...O,key:A}):O!==!0&&s.d.push({key:A,description:O,type:$!=null?typeof $:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return m.create(this.key,A)}notEqualsTo(A){return u.create(this.key,A)}}s.d=[],e.RawContextKey=s,e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function f(K,A){return K<A?-1:K>A?1:0}function P(K,A,$,O){return K<$?-1:K>$?1:A<O?-1:A>O?1:0}function C(K,A){if(K.type===0||A.type===1)return!0;if(K.type===9)return A.type===9?j(K.expr,A.expr):!1;if(A.type===9){for(const $ of A.expr)if(C(K,$))return!0;return!1}if(K.type===6){if(A.type===6)return j(A.expr,K.expr);for(const $ of K.expr)if(C($,A))return!0;return!1}return K.equals(A)}e.implies=C;function j(K,A){let $=0,O=0;for(;$<K.length&&O<A.length;){const F=K[$].cmp(A[O]);if(F<0)return!1;F===0&&$++,O++}return $===K.length}function _(K){return K.type===9?K.expr:[K]}}),define(ke[159],Te([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(ke[90],Te([1,0,133,3]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function D(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function M(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function y(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function R(u,g){return g==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function S(u,g,E){return R(g,E)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===E?!0:T(E).includes(u)}e.isTargetPlatformCompatible=S;function T(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=T;function N(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=N;var w;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var h;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var v;(function(u){u.Install="install",u.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var m;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var a;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(a=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(g,E){super(g),this.code=E,this.name=E}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,n.localize)(1,null),original:"Preferences"}}),define(ke[43],Te([1,0,48,19,10,9,2,135,3,20,15]),function(te,e,n,k,D,M,y,R,S,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function w(re){return re.create===!0}e.isFileOpenForWriteOptions=w;var h;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(h=e.FileType||(e.FileType={}));var v;(function(re){re[re.Readonly=1]="Readonly"})(v=e.FilePermission||(e.FilePermission={}));var m;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function a(re){return!!(re.capabilities&2)}e.hasReadWriteCapability=a;function o(re){return!!(re.capabilities&8)}e.hasFileFolderCopyCapability=o;function u(re){return!!(re.capabilities&32768)}e.hasFileCloneCapability=u;function g(re){return!!(re.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function E(re){return!!(re.capabilities&16)}e.hasFileReadStreamCapability=E;function L(re){return a(re)?!!(re.capabilities&16384):!1}e.hasFileAtomicReadCapability=L;var p;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(ce,ue){const Se=new t(ce.toString(),ue);return l(Se,ue),Se}constructor(ce,ue){super(ce),this.code=ue}}e.FileSystemProviderError=t;function d(re,ce){return t.create(re,ce)}e.createFileSystemProviderError=d;function r(re){return re||d((0,R.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=r;function l(re,ce){return re.name=ce?`${ce} (FileSystemError)`:"FileSystemError",re}e.markAsFileSystemProviderError=l;function c(re){if(!re)return p.Unknown;if(re instanceof t)return re.code;const ce=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!ce)return p.Unknown;switch(ce[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=c;function b(re){if(re instanceof j)return re.fileOperationResult;switch(c(re)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=b;var i;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor(ce,ue,Se){this.resource=ce,this.operation=ue,this.target=Se}isOperation(ce){return this.operation===ce}}e.FileOperationEvent=s;var f;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class P{constructor(ce,ue){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const Se=new Map;for(const G of ce){const X=Se.get(G.type);switch(X?X.push([G.resource,G]):Se.set(G.type,[[G.resource,G]]),G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}}for(const[G,X]of Se)switch(G){case 1:this.a=n.TernarySearchTree.forUris(()=>ue),this.a.fill(X);break;case 0:this.b=n.TernarySearchTree.forUris(()=>ue),this.b.fill(X);break;case 2:this.c=n.TernarySearchTree.forUris(()=>ue),this.c.fill(X);break}}contains(ce,...ue){return this.d(ce,{includeChildren:!1},...ue)}affects(ce,...ue){return this.d(ce,{includeChildren:!0},...ue)}d(ce,ue,...Se){if(!ce)return!1;const G=Se.length>0;return!!((!G||Se.includes(1))&&(this.a?.get(ce)||ue.includeChildren&&this.a?.findSuperstr(ce))||(!G||Se.includes(0))&&(this.b?.get(ce)||ue.includeChildren&&this.b?.findSuperstr(ce))||(!G||Se.includes(2))&&(this.c?.findSubstr(ce)||ue.includeChildren&&this.c?.findSuperstr(ce)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=P;function C(re,ce,ue){return!re||!ce||re===ce||ce.length>re.length?!1:(ce.charAt(ce.length-1)!==k.sep&&(ce+=k.sep),ue?(0,D.startsWithIgnoreCase)(re,ce):re.indexOf(ce)===0)}e.isParent=C;class j extends Error{constructor(ce,ue,Se){super(ce),this.fileOperationResult=ue,this.options=Se}}e.FileOperationError=j;class _ extends j{constructor(ce,ue,Se,G){super(ce,ue,G),this.fileOperationResult=ue,this.size=Se}}e.TooLargeFileOperationError=_;class K extends j{constructor(ce,ue,Se){super(ce,2,Se),this.stat=ue}}e.NotModifiedSinceFileOperationError=K;var A;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",re[re.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var $;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})($=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}e.etag=O;async function F(re,ce){if(!ce.hasProvider(y.URI.from({scheme:re.scheme})))return new Promise(ue=>{const Se=ce.onDidChangeFileSystemProviderRegistrations(G=>{G.scheme===re.scheme&&G.added&&(Se.dispose(),ue())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class H{static formatSize(ce){return(0,M.isNumber)(ce)||(ce=0),ce<H.KB?(0,R.localize)(1,null,ce.toFixed(0)):ce<H.MB?(0,R.localize)(2,null,(ce/H.KB).toFixed(2)):ce<H.GB?(0,R.localize)(3,null,(ce/H.MB).toFixed(2)):ce<H.TB?(0,R.localize)(4,null,(ce/H.GB).toFixed(2)):(0,R.localize)(5,null,(ce/H.TB).toFixed(2))}}H.KB=1024,H.MB=H.KB*H.KB,H.GB=H.MB*H.KB,H.TB=H.GB*H.KB,e.ByteSize=H;var V;(function(re){re[re.IA32=0]="IA32",re[re.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function ae(re){return{maxFileSize:re===0?300*H.MB:16*H.GB,maxHeapSize:re===0?700*H.MB:2*700*H.MB}}e.getPlatformFileLimits=ae;function pe(re){const ce=typeof re=="string"||re?.scheme===N.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===N.Schemas.file?1024*H.MB:ce?10*H.MB:T.isWeb?50*H.MB:1024*H.MB}e.getLargeFileConfirmationLimit=pe}),define(ke[68],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...D){this.a=new Map;for(const[M,y]of D)this.set(M,y)}set(D,M){const y=this.a.get(D);return this.a.set(D,M),y}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=n}),define(ke[160],Te([1,0,17,12,6,89,158,3,68,161]),function(te,e,n,k,D,M,y,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const N=!1;class w extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class h{constructor(o=new S.ServiceCollection,u=!1,g,E=N){this.f=o,this.g=u,this.h=g,this.i=E,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=E?g?._globalGraph??new y.Graph(L=>L):void 0}createChild(o){return new h(o,this.g,this,this.i)}invokeFunction(o,...u){const g=m.traceInvocation(this.i,o);let E=!1;try{return o({get:p=>{if(E)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(p,g);if(!t)throw new Error(`[invokeFunction] unknown service '${p}'`);return t}},...u)}finally{E=!0,g.stop()}}createInstance(o,...u){let g,E;return o instanceof M.SyncDescriptor?(g=m.traceCreation(this.i,o.ctor),E=this.j(o.ctor,o.staticArguments.concat(u),g)):(g=m.traceCreation(this.i,o),E=this.j(o,u,g)),g.stop(),E}j(o,u=[],g){const E=R._util.getServiceDependencies(o).sort((t,d)=>t.index-d.index),L=[];for(const t of E){const d=this.m(t.id,g);d||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),L.push(d)}const p=E.length>0?E[0].index:u.length;if(u.length!==p){console.trace(`[createInstance] First service dependency of ${o.name} at position ${p+1} conflicts with ${u.length} static arguments`);const t=p-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,p)}return Reflect.construct(o,u.concat(L))}k(o,u){if(this.f.get(o)instanceof M.SyncDescriptor)this.f.set(o,u);else if(this.h)this.h.k(o,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const u=this.f.get(o);return!u&&this.h?this.h.l(o):u}m(o,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const g=this.l(o);return g instanceof M.SyncDescriptor?this.q(o,g,u.branch(o,!0)):(u.branch(o,!1),g)}q(o,u,g){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,u,g)}finally{this.o.delete(o)}}r(o,u,g){const E=new y.Graph(t=>t.id.toString());let L=0;const p=[{id:o,desc:u,_trace:g}];for(;p.length;){const t=p.pop();if(E.lookupOrInsertNode(t),L++>1e3)throw new w(E);for(const d of R._util.getServiceDependencies(t.desc.ctor)){const r=this.l(d.id);if(r||this.u(`[createInstance] ${o} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(d.id)),r instanceof M.SyncDescriptor){const l={id:d.id,desc:r,_trace:t._trace.branch(d.id,!0)};E.insertEdge(t,l),p.push(l)}}}for(;;){const t=E.roots();if(t.length===0){if(!E.isEmpty())throw new w(E);break}for(const{data:d}of t){if(this.l(d.id)instanceof M.SyncDescriptor){const l=this.s(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.k(d.id,l)}E.removeNode(d)}}return this.l(o)}s(o,u,g=[],E,L){if(this.f.get(o)instanceof M.SyncDescriptor)return this.t(o,u,g,E,L);if(this.h)return this.h.s(o,u,g,E,L);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(o,u,g=[],E,L){if(E){const p=new h(void 0,this.g,this,this.i);p.c=String(o);const t=new Map,d=new n.IdleValue(()=>{const r=p.j(u,g,L);for(const[l,c]of t){const b=r[l];if(typeof b=="function")for(const i of c)b.apply(r,i)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,l){if(!d.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let i=t.get(l);return i||(i=new T.LinkedList,t.set(l,i)),(f,P,C)=>{const j=i.push([f,P,C]);return(0,D.toDisposable)(j)}}if(l in r)return r[l];const c=d.value;let b=c[l];return typeof b!="function"||(b=b.bind(c),r[l]=b),b},set(r,l,c){return d.value[l]=c,!0},getPrototypeOf(r){return u.prototype}})}else return this.j(u,g,L)}u(o,u){if(u&&console.warn(o),this.g)throw new Error(o)}}e.InstantiationService=h;var v;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(v||(v={}));class m{static traceInvocation(o,u){return o?new m(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(o,u){return o?new m(1,u.name):m.c}constructor(o,u){this.type=o,this.name=u,this.g=Date.now(),this.h=[]}branch(o,u){const g=new m(3,o.toString());return this.h.push([o,u,g]),g}stop(){const o=Date.now()-this.g;m.f+=o;let u=!1;function g(L,p){const t=[],d=new Array(L+1).join("	");for(const[r,l,c]of p.h)if(l&&c){u=!0,t.push(`${d}CREATES -> ${r}`);const b=g(L+1,c);b&&t.push(b)}else t.push(`${d}uses -> ${r}`);return t.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(o>2||u)&&m.all.add(E.join(`
`))}}m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0,e.Trace=m}),define(ke[11],Te([1,0,39,4,6,28,20,9,2,3]),function(te,e,n,k,D,M,y,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function N(){return new Date().toISOString()}function w(i){return(0,R.isNumber)(i)}e.isLogLevel=w;var h;(function(i){i[i.Off=0]="Off",i[i.Trace=1]="Trace",i[i.Debug=2]="Debug",i[i.Info=3]="Info",i[i.Warning=4]="Warning",i[i.Error=5]="Error"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;function v(i,s,f){switch(s){case h.Trace:i.trace(f);break;case h.Debug:i.debug(f);break;case h.Info:i.info(f);break;case h.Warning:i.warn(f);break;case h.Error:i.error(f);break;case h.Off:break;default:throw new Error(`Invalid log level ${s}`)}}e.log=v;function m(i){let s="";for(let f=0;f<i.length;f++){let P=i[f];if(typeof P=="object")try{P=JSON.stringify(P)}catch{}s+=(f>0?" ":"")+P}return s}e.format=m;class a extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new k.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(s){this.b!==s&&(this.b=s,this.c.fire(this.b))}getLevel(){return this.b}f(s){return this.b!==h.Off&&this.b<=s}}e.AbstractLogger=a;class o extends a{constructor(s){super(),this.h=s}f(s){return this.h||super.f(s)}trace(s,...f){this.f(h.Trace)&&this.g(h.Trace,m([s,...f]))}debug(s,...f){this.f(h.Debug)&&this.g(h.Debug,m([s,...f]))}info(s,...f){this.f(h.Info)&&this.g(h.Info,m([s,...f]))}warn(s,...f){this.f(h.Warning)&&this.g(h.Warning,m([s,...f]))}error(s,...f){if(this.f(h.Error))if(s instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=s.stack,this.g(h.Error,m(P))}else this.g(h.Error,m([s,...f]))}flush(){}}e.AbstractMessageLogger=o;class u extends a{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.g=!y.isWindows}trace(s,...f){this.f(h.Trace)&&(this.g?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,s,...f):console.log(`[main ${N()}]`,s,...f))}debug(s,...f){this.f(h.Debug)&&(this.g?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,s,...f):console.log(`[main ${N()}]`,s,...f))}info(s,...f){this.f(h.Info)&&(this.g?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,s,...f):console.log(`[main ${N()}]`,s,...f))}warn(s,...f){this.f(h.Warning)&&(this.g?console.warn(`\x1B[93m[main ${N()}]\x1B[0m`,s,...f):console.warn(`[main ${N()}]`,s,...f))}error(s,...f){this.f(h.Error)&&(this.g?console.error(`\x1B[91m[main ${N()}]\x1B[0m`,s,...f):console.error(`[main ${N()}]`,s,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class g extends a{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...f){this.f(h.Trace)&&console.log("%cTRACE","color: #888",s,...f)}debug(s,...f){this.f(h.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",s,...f)}info(s,...f){this.f(h.Info)&&console.log("%c INFO","color: #33f",s,...f)}warn(s,...f){this.f(h.Warning)&&console.log("%c WARN","color: #993",s,...f)}error(s,...f){this.f(h.Error)&&console.log("%c  ERR","color: #f33",s,...f)}dispose(){}flush(){}}e.ConsoleLogger=g;class E extends a{constructor(s,f=e.DEFAULT_LOG_LEVEL){super(),this.g=s,this.setLevel(f)}trace(s,...f){this.f(h.Trace)&&this.g.log(h.Trace,[this.h(s),...f])}debug(s,...f){this.f(h.Debug)&&this.g.log(h.Debug,[this.h(s),...f])}info(s,...f){this.f(h.Info)&&this.g.log(h.Info,[this.h(s),...f])}warn(s,...f){this.f(h.Warning)&&this.g.log(h.Warning,[this.h(s),...f])}error(s,...f){this.f(h.Error)&&this.g.log(h.Error,[this.h(s),...f])}h(s){return typeof s=="string"?s:(0,n.toErrorMessage)(s,this.f(h.Trace))}dispose(){}flush(){}}e.AdapterLogger=E;class L extends a{constructor(s){super(),this.g=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const f of this.g)f.setLevel(s);super.setLevel(s)}trace(s,...f){for(const P of this.g)P.trace(s,...f)}debug(s,...f){for(const P of this.g)P.debug(s,...f)}info(s,...f){for(const P of this.g)P.info(s,...f)}warn(s,...f){for(const P of this.g)P.warn(s,...f)}error(s,...f){for(const P of this.g)P.error(s,...f)}flush(){for(const s of this.g)s.flush()}dispose(){for(const s of this.g)s.dispose()}}e.MultiplexLogger=L;class p extends D.Disposable{constructor(s,f){if(super(),this.j=s,this.b=new M.ResourceMap,this.c=new M.ResourceMap,this.f=this.B(new k.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new k.Emitter),this.onDidChangeVisibility=this.h.event,f)for(const P of f)this.c.set(P.resource,P)}getLogger(s){return this.b.get(s)}createLogger(s,f){let P=this.b.get(s);const C=f?.logLevel==="always"?h.Trace:f?.logLevel;return P||(P=this.k(s,C??this.getLogLevel(s)??this.j,f),this.b.set(s,P)),this.registerLogger({resource:s,id:f?.id??s.toString(),logLevel:C,name:f?.name,hidden:f?.hidden,extensionId:f?.extensionId}),P}setLogLevel(s,f){if(S.URI.isUri(s)){const P=s,C=f,j=this.c.get(P);j&&C!==j.logLevel&&(j.logLevel=C===this.j?void 0:C,this.b.get(P)?.setLevel(C),this.c.set(j.resource,j),this.g.fire([P,C]))}else{this.j=s;for(const[P,C]of this.b.entries())this.c.get(P)?.logLevel===void 0&&C.setLevel(this.j);this.g.fire(this.j)}}setVisibility(s,f){const P=this.c.get(s);P&&f!==!P.hidden&&(P.hidden=!f,this.c.set(P.resource,P),this.h.fire([s,f]))}getLogLevel(s){let f;return s&&(f=this.c.get(s)?.logLevel),f??this.j}registerLogger(s){const f=this.c.get(s.resource);f?f.hidden!==s.hidden&&this.setVisibility(s.resource,!s.hidden):(this.c.set(s.resource,s),this.f.fire({added:[s],removed:[]}))}deregisterLogger(s){const f=this.c.get(s);if(f){this.c.delete(s);const P=this.b.get(s);P&&(this.b.delete(s),P.dispose()),this.f.fire({added:[],removed:[f]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(s){return this.c.get(s)}dispose(){this.b.forEach(s=>s.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=p;class t{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(s){}getLevel(){return h.Info}trace(s,...f){}debug(s,...f){}info(s,...f){}warn(s,...f){}error(s,...f){}critical(s,...f){}dispose(){}flush(){}}e.NullLogger=t;class d extends t{}e.NullLogService=d;class r extends p{constructor(){super(h.Info)}k(s,f,P){return new t}}e.NullLoggerService=r;function l(i){if(i.verbose)return h.Trace;if(typeof i.logLevel=="string"){const s=b(i.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function c(i){switch(i){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}e.LogLevelToString=c;function b(i){switch(i){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.parseLogLevel=b}),define(ke[162],Te([1,0,6,11]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends n.Disposable{constructor(y,R=[]){super(),this.a=new k.MultiplexLogger([y,...R]),this.B(y.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(y){this.a.setLevel(y)}getLevel(){return this.a.getLevel()}trace(y,...R){this.a.trace(y,...R)}debug(y,...R){this.a.debug(y,...R)}info(y,...R){this.a.info(y,...R)}warn(y,...R){this.a.warn(y,...R)}error(y,...R){this.a.error(y,...R)}flush(){this.a.flush()}}e.LogService=D}),define(ke[91],Te([1,0,29,136,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var y;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function T(m,a){return a-m}S.compare=T;const N=Object.create(null);N[S.Error]=(0,k.localize)(0,null),N[S.Warning]=(0,k.localize)(1,null),N[S.Info]=(0,k.localize)(2,null);function w(m){return N[m]||""}S.toString=w;function h(m){switch(m){case n.default.Error:return S.Error;case n.default.Warning:return S.Warning;case n.default.Info:return S.Info;case n.default.Ignore:return S.Hint}}S.fromSeverity=h;function v(m){switch(m){case S.Error:return n.default.Error;case S.Warning:return n.default.Warning;case S.Info:return n.default.Info;case S.Hint:return n.default.Ignore}}S.toSeverity=v}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var R;(function(S){const T="";function N(h){return w(h,!0)}S.makeKey=N;function w(h,v){const m=[T];return h.source?m.push(h.source.replace("\xA6","\\\xA6")):m.push(T),h.code?typeof h.code=="string"?m.push(h.code.replace("\xA6","\\\xA6")):m.push(h.code.value.replace("\xA6","\\\xA6")):m.push(T),h.severity!==void 0&&h.severity!==null?m.push(y.toString(h.severity)):m.push(T),h.message&&v?m.push(h.message.replace("\xA6","\\\xA6")):m.push(T),h.startLineNumber!==void 0&&h.startLineNumber!==null?m.push(h.startLineNumber.toString()):m.push(T),h.startColumn!==void 0&&h.startColumn!==null?m.push(h.startColumn.toString()):m.push(T),h.endLineNumber!==void 0&&h.endLineNumber!==null?m.push(h.endLineNumber.toString()):m.push(T),h.endColumn!==void 0&&h.endColumn!==null?m.push(h.endColumn.toString()):m.push(T),m.push(T),m.join("\xA6")}S.makeKeyOptionalMessage=w})(R=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(ke[163],Te([1,0,4,29,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=k.default,e.INotificationService=(0,D.createDecorator)("notificationService");var M;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.PROFILE=1]="PROFILE",T[T.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class R{constructor(){this.progress=new S,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=R;class S{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=S}),define(ke[92],Te([1,0,10,2,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,D.createDecorator)("openerService");function M(T,N){return k.URI.isUri(T)?(0,n.equalsIgnoreCase)(T.scheme,N):(0,n.startsWithIgnoreCase)(T,N+":")}e.matchesScheme=M;function y(T,...N){return N.some(w=>M(T,w))}e.matchesSomeScheme=y;function R(T,N){return T.with({fragment:`${N.startLineNumber},${N.startColumn}${N.endLineNumber?`-${N.endLineNumber}${N.endColumn?`,${N.endColumn}`:""}`:""}`})}e.withSelection=R;function S(T){let N;const w=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(T.fragment);return w&&(N={startLineNumber:parseInt(w[1]),startColumn:w[2]?parseInt(w[2]):1,endLineNumber:w[4]?parseInt(w[4]):void 0,endColumn:w[4]?w[5]?parseInt(w[5]):1:void 0},T=T.with({fragment:""})),{selection:N,uri:T}}e.extractSelection=S}),define(ke[164],Te([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(te,e,n,k){var D=arguments.length,M=D<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,n):k,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(te,e,n,k);else for(var R=te.length-1;R>=0;R--)(y=te[R])&&(M=(D<3?y(M):D>3?y(e,n,M):y(e,n))||M);return D>3&&M&&Object.defineProperty(e,n,M),M},Ve=this&&this.__param||function(te,e){return function(n,k){e(n,k,te)}};define(ke[165],Te([1,0,17,21,6,3]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var y;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{get value(){return this.a}constructor(w){this.b=w}report(w){this.a=w,this.b(this.a)}}R.None=Object.freeze({report(){}}),e.Progress=R;let S=class extends D.Disposable{constructor(w,h){super(),this.a=new n.DeferredPromise,h.withProgress(w,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,D.toDisposable)(()=>this.a.complete()))}report(w){this.b?this.b.report(w):this.c=w}};S=qe([Ve(1,e.IProgressService)],S),e.UnmanagedProgress=S;class T extends D.Disposable{constructor(w){super(),this.g=w,this.a=0,this.b=this.B(new D.DisposableStore)}start(w){this.stop();const h=++this.a,v=new k.CancellationTokenSource;return this.f=setTimeout(()=>{h===this.a&&(this.c=this.g.show(!0))},w),this.b.add((0,D.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,D.toDisposable)(()=>v.cancel())),this.b.add((0,D.toDisposable)(()=>this.c?this.c.done():void 0)),{id:h,token:v.token,stop:()=>this.h(h),isCurrent:()=>this.a===h}}stop(){this.h(this.a)}h(w){this.a===w&&this.b.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(ke[30],Te([1,0,49,9]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(y,R){n.ok(k.isString(y)),n.ok(k.isObject(R)),n.ok(!this.a.has(y),"There is already an extension with this id"),this.a.set(y,R)}knows(y){return this.a.has(y)}as(y){return this.a.get(y)||null}}e.Registry=new D}),define(ke[69],Te([1,0,4,30]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class M{constructor(){this.b=new n.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,T){this.a[D(S)]=T,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const y=new M;k.Registry.add(e.Extensions.JSONContribution,y)}),define(ke[93],Te([1,0,16,4,9,132,41,69,30]),function(te,e,n,k,D,M,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var T;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(T=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var N;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=S.Registry.as(R.Extensions.JSONContribution);class h{constructor(){this.h=new Set,this.i=new k.Emitter,this.onDidSchemaChange=this.i.event,this.j=new k.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const r=new Set;this.n(t,d,r),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const d=new Set;this.o(t,d),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:t,remove:d}){const r=new Set;this.o(d,r),this.n(t,!1,r),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const d=new Set;this.k(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(t,d){const r=[];for(const{overrides:l,source:c}of t)for(const b in l)if(d.add(b),e.OVERRIDE_PROPERTY_REGEX.test(b)){const i=this.a.get(b),s=i?.valuesSources??new Map;if(c)for(const j of Object.keys(l[b]))s.set(j,c);const f={...i?.value||{},...l[b]};this.a.set(b,{source:c,value:f,valuesSources:s});const P=(0,y.getLanguageTagSettingPlainKey)(b),C={type:"object",default:f,description:M.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:D.isString(c)?void 0:c,defaultValueSource:c};r.push(...a(b)),this.d[b]=C,this.b.properties[b]=C}else{this.a.set(b,{value:l[b],source:c});const i=this.d[b];i&&(this.w(b,i),this.r(b,i))}this.m(r)}deregisterDefaultConfigurations(t){const d=new Set;this.l(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(t,d){for(const{overrides:r,source:l}of t)for(const c in r){const b=this.a.get(c),i=D.isString(l)?l:l?.id,s=D.isString(b?.source)?b?.source:b?.source?.id;if(i===s)if(d.add(c),this.a.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.d[c],delete this.b.properties[c];else{const f=this.d[c];f&&(this.w(c,f),this.r(c,f))}}this.u()}deltaConfiguration(t){let d=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),d=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),d=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const d of t)this.h.add(d);this.u()}n(t,d,r){t.forEach(l=>{this.p(l,d,l.extensionInfo,l.restrictedProperties,void 0,r),this.c.push(l),this.q(l)})}o(t,d){const r=l=>{if(l.properties)for(const c in l.properties){d.add(c);const b=this.d[c];b?.policy?.name&&this.e.delete(b.policy.name),delete this.d[c],this.s(c,l.properties[c])}l.allOf?.forEach(c=>r(c))};for(const l of t){r(l);const c=this.c.indexOf(l);c!==-1&&this.c.splice(c,1)}}p(t,d=!0,r,l,c=3,b){c=D.isUndefinedOrNull(t.scope)?c:t.scope;const i=t.properties;if(i)for(const f in i){const P=i[f];if(d&&E(f,P)){delete i[f];continue}if(P.source=r,P.defaultDefaultValue=i[f].default,this.w(f,P),e.OVERRIDE_PROPERTY_REGEX.test(f)?P.scope=void 0:(P.scope=D.isUndefinedOrNull(P.scope)?c:P.scope,P.restricted=D.isUndefinedOrNull(P.restricted)?!!l?.includes(f):P.restricted),i[f].hasOwnProperty("included")&&!i[f].included){this.f[f]=i[f],delete i[f];continue}else this.d[f]=i[f],i[f].policy?.name&&this.e.set(i[f].policy.name,f);!i[f].deprecationMessage&&i[f].markdownDeprecationMessage&&(i[f].deprecationMessage=i[f].markdownDeprecationMessage),b.add(f)}const s=t.allOf;if(s)for(const f of s)this.p(f,d,r,l,c,b)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const d=r=>{const l=r.properties;if(l)for(const b in l)this.r(b,l[b]);r.allOf?.forEach(d)};d(t)}r(t,d){switch(e.allSettings.properties[t]=d,d.scope){case 1:e.applicationSettings.properties[t]=d;break;case 2:e.machineSettings.properties[t]=d;break;case 6:e.machineOverridableSettings.properties[t]=d;break;case 3:e.windowSettings.properties[t]=d;break;case 4:e.resourceSettings.properties[t]=d;break;case 5:e.resourceSettings.properties[t]=d,this.g.properties[t]=d;break}}s(t,d){switch(delete e.allSettings.properties[t],d.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const d=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(d,r),e.allSettings.properties[d]=r,e.applicationSettings.properties[d]=r,e.machineSettings.properties[d]=r,e.machineOverridableSettings.properties[d]=r,e.windowSettings.properties[d]=r,e.resourceSettings.properties[d]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,d){const r=this.a.get(t);let l=r?.value,c=r?.source;D.isUndefined(l)&&(l=d.defaultDefaultValue,c=void 0),D.isUndefined(l)&&(l=u(d.type)),d.default=l,d.defaultValueSource=c}}const v="\\[([^\\]]+)\\]",m=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function a(p){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let d=m.exec(p);for(;d?.length;){const r=d[1].trim();r&&t.push(r),d=m.exec(p)}}return(0,n.distinct)(t)}e.overrideIdentifiersFromKey=a;function o(p){return p.reduce((t,d)=>`${t}[${d}]`,"")}e.keyFromOverrideIdentifiers=o;function u(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const g=new h;S.Registry.add(e.Extensions.Configuration,g);function E(p,t){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?M.localize(7,null,p):g.getConfigurationProperties()[p]!==void 0?M.localize(8,null,p):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,p,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.validateProperty=E;function L(){const p=[],t=g.getConfigurationProperties();for(const d of Object.keys(t))p.push([d,t[d].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=L}),define(ke[166],Te([1,0,16,4,111,6,28,22,9,2,41,93,30]),function(te,e,n,k,D,M,y,R,S,T,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function v(d){return Object.isFrozen(d)?d:R.deepFreeze(d)}class m{constructor(r={},l=[],c=[],b){this.b=r,this.c=l,this.d=c,this.raw=b,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(l=>{if(l instanceof m)return l;const c=new a("");return c.parseRaw(l),c.configurationModel});this.f=r.reduce((l,c)=>c===l?c:l.merge(c),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,N.getConfigurationValue)(this.contents,r):this.contents}inspect(r,l){const c=this.rawConfiguration.getValue(r),b=l?this.rawConfiguration.getOverrideValue(r,l):void 0,i=l?this.rawConfiguration.override(l).getValue(r):c;return{value:c,override:b,merged:i}}getOverrideValue(r,l){const c=this.i(l);return c?r?(0,N.getConfigurationValue)(c,r):c:void 0}getKeysForOverrideIdentifier(r){const l=[];for(const c of this.overrides)c.identifiers.includes(r)&&l.push(...c.keys);return n.distinct(l)}getAllOverrideIdentifiers(){const r=[];for(const l of this.overrides)r.push(...l.identifiers);return n.distinct(r)}override(r){let l=this.a.get(r);return l||(l=this.g(r),this.a.set(r,l)),l}merge(...r){const l=R.deepClone(this.contents),c=R.deepClone(this.overrides),b=[...this.keys],i=this.raw?.length?[...this.raw]:[this];for(const s of r)if(i.push(...s.raw?.length?s.raw:[s]),!s.isEmpty()){this.h(l,s.contents);for(const f of s.overrides){const[P]=c.filter(C=>n.equals(C.identifiers,f.identifiers));P?(this.h(P.contents,f.contents),P.keys.push(...f.keys),P.keys=n.distinct(P.keys)):c.push(R.deepClone(f))}for(const f of s.keys)b.indexOf(f)===-1&&b.push(f)}return new m(l,b,c,i.every(s=>s instanceof m)?void 0:i)}g(r){const l=this.i(r);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const c={};for(const b of n.distinct([...Object.keys(this.contents),...Object.keys(l)])){let i=this.contents[b];const s=l[b];s&&(typeof i=="object"&&typeof s=="object"?(i=R.deepClone(i),this.h(i,s)):i=s),c[b]=i}return new m(c,this.keys,this.overrides)}h(r,l){for(const c of Object.keys(l)){if(c in r&&S.isObject(r[c])&&S.isObject(l[c])){this.h(r[c],l[c]);continue}r[c]=R.deepClone(l[c])}}i(r){let l=null,c=null;const b=i=>{i&&(c?this.h(c,i):c=R.deepClone(i))};for(const i of this.overrides)n.equals(i.identifiers,[r])?l=i.contents:i.identifiers.includes(r)&&b(i.contents);return b(l),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,l){this.j(r,l,!0)}setValue(r,l){this.j(r,l,!1)}removeValue(r){const l=this.keys.indexOf(r);l!==-1&&(this.keys.splice(l,1),(0,N.removeFromValueTree)(this.contents,r),w.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(c=>n.equals(c.identifiers,(0,w.overrideIdentifiersFromKey)(r))),1))}j(r,l,c){(0,N.addToValueTree)(this.contents,r,l,b=>console.error(b)),c=c||this.keys.indexOf(r)===-1,c&&this.keys.push(r),w.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,N.toValuesTree)(this.contents[r],b=>console.error(b))})}}e.ConfigurationModel=m;class a{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,l){if(!S.isUndefinedOrNull(r)){const c=this.g(r);this.parseRaw(c,l)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,l){this.a=r;const{contents:c,keys:b,overrides:i,restricted:s,hasExcludedProperties:f}=this.h(r,l);this.b=new m(c,b,i,f?[r]:void 0),this.c=s||[]}g(r){let l={},c=null,b=[];const i=[],s=[];function f(C){Array.isArray(b)?b.push(C):c!==null&&(b[c]=C)}const P={onObjectBegin:()=>{const C={};f(C),i.push(b),b=C,c=null},onObjectProperty:C=>{c=C},onObjectEnd:()=>{b=i.pop()},onArrayBegin:()=>{const C=[];f(C),i.push(b),b=C,c=null},onArrayEnd:()=>{b=i.pop()},onLiteralValue:f,onError:(C,j,_)=>{s.push({error:C,offset:j,length:_})}};if(r)try{D.visit(r,P),l=b[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return l}h(r,l){const c=h.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),b=this.i(r,c,!0,l);r=b.raw;const i=(0,N.toValuesTree)(r,P=>console.error(`Conflict in settings file ${this.f}: ${P}`)),s=Object.keys(r),f=this.j(r,P=>console.error(`Conflict in settings file ${this.f}: ${P}`));return{contents:i,keys:s,overrides:f,restricted:b.restricted,hasExcludedProperties:b.hasExcludedProperties}}i(r,l,c,b){let i=!1;if(!b?.scopes&&!b?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:i};const s={},f=[];for(const P in r)if(w.OVERRIDE_PROPERTY_REGEX.test(P)&&c){const C=this.i(r[P],l,!1,b);s[P]=C.raw,i=i||C.hasExcludedProperties,f.push(...C.restricted)}else{const C=l[P],j=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&f.push(P),(j===void 0||b.scopes===void 0||b.scopes.includes(j))&&!(b.skipRestricted&&C?.restricted)?s[P]=r[P]:i=!0}return{raw:s,restricted:f,hasExcludedProperties:i}}j(r,l){const c=[];for(const b of Object.keys(r))if(w.OVERRIDE_PROPERTY_REGEX.test(b)){const i={};for(const s in r[b])i[s]=r[b][s];c.push({identifiers:(0,w.overrideIdentifiersFromKey)(b),keys:Object.keys(i),contents:(0,N.toValuesTree)(i,l)})}return c}}e.ConfigurationModelParser=a;class o extends M.Disposable{constructor(r,l,c,b){super(),this.f=r,this.g=l,this.h=b,this.c=this.B(new k.Emitter),this.onDidChange=this.c.event,this.a=new a(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(c.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(k.Event.any(k.Event.filter(this.h.onDidFilesChange,i=>i.contains(this.f)),k.Event.filter(this.h.onDidRunOperation,i=>(i.isOperation(0)||i.isOperation(3)||i.isOperation(1)||i.isOperation(4))&&c.isEqual(i.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new m}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=o;class u{constructor(r,l,c,b,i,s,f,P,C,j,_,K,A){this.a=r,this.b=l,this.c=c,this.overrideIdentifiers=b,this.d=i,this.f=s,this.g=f,this.h=P,this.i=C,this.j=j,this.k=_,this.l=K,this.m=A}get value(){return v(this.c)}n(r,l,c){const b=r.inspect(l,c);return{get value(){return v(b.value)},get override(){return v(b.override)},get merged(){return v(b.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(r,l,c,b,i=new m,s=new m,f=new y.ResourceMap,P=new m,C=new y.ResourceMap){this.c=r,this.d=l,this.f=c,this.g=b,this.h=i,this.i=s,this.j=f,this.l=P,this.m=C,this.a=null,this.b=new y.ResourceMap,this.n=null}getValue(r,l,c){return this.q(r,l,c).getValue(r)}updateValue(r,l,c={}){let b;c.resource?(b=this.m.get(c.resource),b||(b=new m,this.m.set(c.resource,b))):b=this.l,l===void 0?b.removeValue(r):b.setValue(r,l),c.resource||(this.a=null)}inspect(r,l,c){const b=this.q(r,l,c),i=this.u(l.resource,c),s=l.resource?this.m.get(l.resource)||this.l:this.l,f=new Set;for(const P of b.overrides)for(const C of P.identifiers)b.getOverrideValue(r,C)!==void 0&&f.add(C);return new u(r,l,b.getValue(r),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,i||void 0,s)}keys(r){const l=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,l){this.j.set(r,l),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,l){const c=[];if(!l){const{added:b,updated:i,removed:s}=p(this.c,r);l=[...b,...i,...s]}for(const b of l)for(const i of(0,w.overrideIdentifiersFromKey)(b)){const s=this.c.getKeysForOverrideIdentifier(i),f=r.getKeysForOverrideIdentifier(i),P=[...f.filter(C=>s.indexOf(C)===-1),...s.filter(C=>f.indexOf(C)===-1),...s.filter(C=>!R.equals(this.c.override(i).getValue(C),r.override(i).getValue(C)))];c.push([i,P])}return this.updateDefaultConfiguration(r),{keys:l,overrides:c}}compareAndUpdatePolicyConfiguration(r){const{added:l,updated:c,removed:b}=p(this.d,r),i=[...l,...c,...b];return i.length&&this.updatePolicyConfiguration(r),{keys:i,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:l,updated:c,removed:b,overrides:i}=p(this.applicationConfiguration,r),s=[...l,...c,...b];return s.length&&this.updateApplicationConfiguration(r),{keys:s,overrides:i}}compareAndUpdateLocalUserConfiguration(r){const{added:l,updated:c,removed:b,overrides:i}=p(this.localUserConfiguration,r),s=[...l,...c,...b];return s.length&&this.updateLocalUserConfiguration(r),{keys:s,overrides:i}}compareAndUpdateRemoteUserConfiguration(r){const{added:l,updated:c,removed:b,overrides:i}=p(this.remoteUserConfiguration,r),s=[...l,...c,...b];return s.length&&this.updateRemoteUserConfiguration(r),{keys:s,overrides:i}}compareAndUpdateWorkspaceConfiguration(r){const{added:l,updated:c,removed:b,overrides:i}=p(this.workspaceConfiguration,r),s=[...l,...c,...b];return s.length&&this.updateWorkspaceConfiguration(r),{keys:s,overrides:i}}compareAndUpdateFolderConfiguration(r,l){const c=this.p.get(r),{added:b,updated:i,removed:s,overrides:f}=p(c,l),P=[...b,...i,...s];return(P.length||!c)&&this.updateFolderConfiguration(r,l),{keys:P,overrides:f}}compareAndDeleteFolderConfiguration(r){const l=this.p.get(r);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:c,updated:b,removed:i,overrides:s}=p(l,void 0);return{keys:[...c,...b,...i],overrides:s}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,l,c){let b=this.r(l,c);return l.overrideIdentifier&&(b=b.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(b=b.merge(this.d)),b}r({resource:r},l){let c=this.s();if(l&&r){const b=l.getFolder(r);b&&(c=this.t(b.uri)||c);const i=this.m.get(r);i&&(c=c.merge(i))}return c}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let l=this.b.get(r);if(!l){const c=this.s(),b=this.j.get(r);b?(l=c.merge(b),this.b.set(r,l)):l=c}return l}u(r,l){if(l&&r){const c=l.getFolder(r);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,l)=>{const{contents:c,overrides:b,keys:i}=this.j.get(l);return r.push([l,{contents:c,overrides:b,keys:i}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(l=>r.add(l)),this.userConfiguration.keys.forEach(l=>r.add(l)),this.i.keys.forEach(l=>r.add(l)),this.j.forEach(l=>l.keys.forEach(c=>r.add(c))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>r.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>r.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>r.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(c=>r.add(c))),[...r.values()]}w(r){const l=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(c=>l.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(c=>l.add(c)),this.i.getKeysForOverrideIdentifier(r).forEach(c=>l.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(r).forEach(b=>l.add(b))),[...l.values()]}static parse(r){const l=this.x(r.defaults),c=this.x(r.policy),b=this.x(r.application),i=this.x(r.user),s=this.x(r.workspace),f=r.folders.reduce((P,C)=>(P.set(T.URI.revive(C[0]),this.x(C[1])),P),new y.ResourceMap);return new g(l,c,b,i,new m,s,f,new m,new y.ResourceMap)}static x(r){return new m(r.contents,r.keys,r.overrides)}}e.Configuration=g;function E(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const r=new Set,l=new Map;for(const b of d)b.keys.forEach(i=>r.add(i)),b.overrides.forEach(([i,s])=>{const f=(0,y.getOrSet)(l,i,new Set);s.forEach(P=>f.add(P))});const c=[];return l.forEach((b,i)=>c.push([i,[...b.values()]])),{keys:[...r.values()],overrides:c}}e.mergeChanges=E;class L{constructor(r,l,c,b){this.change=r,this.f=l,this.g=c,this.h=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const i of r.keys)this.affectedKeys.add(i);for(const[,i]of r.overrides)for(const s of i)this.affectedKeys.add(s);this.d=this.a;for(const i of this.affectedKeys)this.d+=i+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(r,l){const c=this.a+r,b=this.d.indexOf(c);if(b<0)return!1;const i=b+c.length;if(i>=this.d.length)return!1;const s=this.d.charCodeAt(i);if(s!==this.b&&s!==this.c)return!1;if(l){const f=this.previousConfiguration?this.previousConfiguration.getValue(r,l,this.f?.workspace):void 0,P=this.g.getValue(r,l,this.h);return!R.equals(f,P)}return!0}}e.ConfigurationChangeEvent=L;function p(d,r){const{added:l,removed:c,updated:b}=t(r?.rawConfiguration,d?.rawConfiguration),i=[],s=d?.getAllOverrideIdentifiers()||[],f=r?.getAllOverrideIdentifiers()||[];if(r){const P=f.filter(C=>!s.includes(C));for(const C of P)i.push([C,r.getKeysForOverrideIdentifier(C)])}if(d){const P=s.filter(C=>!f.includes(C));for(const C of P)i.push([C,d.getKeysForOverrideIdentifier(C)])}if(r&&d){for(const P of s)if(f.includes(P)){const C=t({contents:d.getOverrideValue(void 0,P)||{},keys:d.getKeysForOverrideIdentifier(P)},{contents:r.getOverrideValue(void 0,P)||{},keys:r.getKeysForOverrideIdentifier(P)});i.push([P,[...C.added,...C.removed,...C.updated]])}}return{added:l,removed:c,updated:b,overrides:i}}function t(d,r){const l=d?r?d.keys.filter(i=>r.keys.indexOf(i)===-1):[...d.keys]:[],c=r?d?r.keys.filter(i=>d.keys.indexOf(i)===-1):[...r.keys]:[],b=[];if(d&&r){for(const i of r.keys)if(d.keys.indexOf(i)!==-1){const s=(0,N.getConfigurationValue)(r.contents,i),f=(0,N.getConfigurationValue)(d.contents,i);R.equals(s,f)||b.push(i)}}return{added:l,removed:c,updated:b}}}),define(ke[94],Te([1,0,12,3]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var D;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends n.ErrorNoTelemetry{static isNotAvailable(S){return S instanceof M&&S._code===D.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof M&&S._code===D.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof M&&S._code===D.NoResolverFound}static isHandled(S){return S instanceof M&&S.isHandled}constructor(S,T=D.Unknown,N){super(S),this._message=S,this._code=T,this._detail=N,this.isHandled=T===D.NotAvailable&&N===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M;function y(R){const S=R.indexOf("+");return S===-1?R:R.substring(0,S)}e.getRemoteAuthorityPrefix=y}),define(ke[50],Te([1,0,15]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function k(T){return T.scheme===n.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=k;function D(T){if(!T)return;const N=T.indexOf("+");return N<0?T:T.substr(0,N)}e.getRemoteName=D;function M(T){return`/${T.quality??"oss"}-${T.commit??"dev"}`}e.getRemoteServerRootPath=M;function y(T){const{host:N,port:w}=S(T);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:N,port:w}}e.parseAuthorityWithPort=y;function R(T,N){let{host:w,port:h}=S(T);return typeof h>"u"&&(h=N),{host:w,port:h}}e.parseAuthorityWithOptionalPort=R;function S(T){const N=T.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(N)return{host:N[1],port:parseInt(N[2],10)};const w=T.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const h=T.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:T,port:void 0}}}),define(ke[26],Te([1,0,10,3,50]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));var R;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(R=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(m){this.value=m,this.c=m.toLowerCase()}static equals(m,a){if(typeof m>"u"||m===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof m=="string"||typeof a=="string"){const o=typeof m=="string"?m:m.value,u=typeof a=="string"?a:a.value;return n.equalsIgnoreCase(o,u)}return m.c===a.c}static toKey(m){return typeof m=="string"?m.toLowerCase():m.c}}e.ExtensionIdentifier=S;function T(v){return N(v)}e.isApplicationScopedExtension=T;function N(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=N;function w(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function h(v,m){if(m){const a=`onResolveRemoteAuthority:${(0,D.getRemoteName)(m)}`;return!!v.activationEvents?.includes(a)}return!1}e.isResolverExtension=h,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(ke[167],Te([1,0,20,51,2,34]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function y(T){if(n.platform===2&&/^penguin(\.|$)/i.test(T))return"chromebook"}async function R(T,N,w,h,v,m,a,o,u,g){const E=Object.create(null);E["common.machineId"]=a,E.sessionID=(0,M.generateUuid)()+Date.now(),E.commitHash=v,E.version=m,E["common.platformVersion"]=(N||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,n.PlatformToString)(n.platform),E["common.nodePlatform"]=k.platform,E["common.nodeArch"]=h,E["common.product"]=g||"desktop",o&&(E["common.msftInternal"]=o);let L=0;const p=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>L++,enumerable:!0}}),n.isLinuxSnap&&(E["common.snap"]="true");const t=y(w);t&&(E["common.platformDetail"]=t);try{const d=await T.readFile(D.URI.file(u));E["common.source"]=d.value.toString().slice(0,30)}catch{}return E}e.resolveCommonProperties=R;function S(T){const N=k.env.USERDNSDOMAIN;if(!N)return!1;const w=N.toLowerCase();return T.some(h=>w===h)}e.verifyMicrosoftInternalDomain=S}),define(ke[168],Te([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var k;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(k=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ke[52],Te([1,0,22,9,4,41,50,167,168]),function(te,e,n,k,D,M,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class T{constructor(i){this.value=i}}e.TelemetryTrustedValue=T;class N{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(i,s){return Promise.resolve(void 0)}publicLog2(i,s){return this.publicLog(i,s)}publicLogError(i,s){return Promise.resolve(void 0)}publicLogError2(i,s){return this.publicLogError(i,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=N,e.NullTelemetryService=new N;class w{async publicLog(i,s,f){}async publicLogError(i,s,f){}}e.NullEndpointTelemetryService=w,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(b,i){return D.Event.debounce(i.onDidChangeConfiguration,(f,P)=>{const C=f?new Set([...f.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:C}},1e3,!0)(f=>{f.source!==7&&b.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(f.source),configurationKeys:L(f.affectedKeys)})})}e.configurationTelemetry=h;function v(b,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!b.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=v;function m(b,i){return!(i.isBuilt||i.disableTelemetry||b.enableTelemetry&&b.aiConfig?.ariaKey)}e.isLoggingOnly=m;function a(b){const i=b.getValue(S.TELEMETRY_SETTING_ID),s=b.getValue(S.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(b.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=a;function o(b){const i={},s={},f={};E(b,f);for(let P in f){P=P.length>150?P.substr(P.length-149):P;const C=f[P];typeof C=="number"?s[P]=C:typeof C=="boolean"?s[P]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${C.length}`),i[P]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(i[P]=C)}return{properties:i,measurements:s}}e.validateTelemetryData=o;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function g(b){if(!b)return"none";const i=(0,y.getRemoteName)(b);return u.has(i)?i:"other"}e.cleanRemoteAuthority=g;function E(b,i,s=0,f){if(!!b)for(const P of Object.getOwnPropertyNames(b)){const C=b[P],j=f?f+P:P;Array.isArray(C)?i[j]=(0,n.safeStringify)(C):C instanceof Date?i[j]=C.toISOString():(0,k.isObject)(C)?s<2?E(C,i,s+1,j+"."):i[j]=(0,n.safeStringify)(C):i[j]=C}}function L(b){if(!b)return[];const i=[];return p(i,"",b),i}function p(b,i,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(f=>p(b,i?`${i}.${f}`:f,s[f])):b.push(i)}function t(b,i){const s=b.msftInternalDomains||[],f=i.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(s)||f}e.isInternalTelemetry=t;function d(b){return[b.appRoot,b.extensionsPath,b.userHome.fsPath,b.tmpDir.fsPath,b.userDataPath]}e.getPiiPathsFromEnvironment=d;function r(b,i){if(!b||!b.includes("/")&&!b.includes("\\"))return b;let s=b;const f=[];for(const _ of i)for(;;){const K=_.exec(b);if(!K)break;f.push([K.index,_.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let j=0;for(s="";;){const _=C.exec(b);if(!_)break;const K=f.some(([A,$])=>_.index<$&&A<C.lastIndex);!P.test(_[0])&&!K&&(s+=b.substring(j,_.index)+"<REDACTED: user-file-path>",j=C.lastIndex)}return j<b.length&&(s+=b.substr(j)),s}function l(b){if(!b)return b;const i=b.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of s)if(f.regex.test(i))return`<REDACTED: ${f.label}>`;return b}function c(b,i){return(0,n.cloneAndChange)(b,s=>{if(s instanceof T)return s.value;if(typeof s=="string"){let f=s.replaceAll("%20"," ");f=r(f,i);for(const P of i)f=f.replace(P,"");return f=l(f),f}})}e.cleanData=c}),define(ke[169],Te([1,0,10,90,26,20,2,12,51,52]),function(te,e,n,k,D,M,y,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function N(r,l){return r.uuid&&l.uuid?r.uuid===l.uuid:r.id===l.id?!0:(0,n.compareIgnoreCase)(r.id,l.id)===0}e.areSameExtensions=N;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(l){const c=l.manifest?l.manifest.version:l.version,b=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new h(l.identifier,c,b)}static parse(l){const c=w.exec(l);return c&&c[1]&&c[2]?new h({id:c[1]},c[2],c[4]||void 0):null}constructor(l,c,b="undefined"){this.version=c,this.targetPlatform=b,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof h?N(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=h;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const l=v.exec(r);return l&&l[1]?[o(l[1]),l[2]]:[o(r),void 0]}e.getIdAndVersion=m;function a(r,l){return`${r}.${l}`}e.getExtensionId=a;function o(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=o;function u(r,l){return o(a(r,l))}e.getGalleryExtensionId=u;function g(r,l){const c=[],b=i=>{for(const s of c)if(s.some(f=>N(l(f),l(i))))return s;return null};for(const i of r){const s=b(i);s?s.push(i):c.push([i])}return c}e.groupByExtension=g;function E(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function L(r){return{id:new T.TelemetryTrustedValue(r.identifier.id),name:new T.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=L,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function p(r,l){const c=[],b=l.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const i=b.shift();if(i&&c.every(s=>!N(s.identifier,{id:i}))){const s=r.filter(f=>N(f.identifier,{id:i}));s.length===1&&(c.push(s[0]),b.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=p;async function t(r,l){if(!M.isLinux)return!1;let c;try{c=(await r.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await r.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(i){l.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(i))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(r,l){const c=await t(r,l),b=(0,k.getTargetPlatform)(c?"alpine":M.platform,S.arch);return l.debug("ComputeTargetPlatform:",b),b}e.computeTargetPlatform=d}),define(ke[170],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function n(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=n;function k(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=k;function D(y){return Array.from(y.entries()).map(R=>[R[0],n(R[1].map)])}e.serializeEnvironmentVariableCollections=D;function M(y){return new Map(y.map(R=>[R[0],{map:k(R[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(ke[171],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(D){this.b=D,this.a=new Map}dispose(){for(const D of this.a.values())D.dispose()}startBuffering(D,M,y=5){const R=M(S=>{const T=typeof S=="string"?S:S.data;let N=this.a.get(D);if(N){N.data.push(T);return}const w=setTimeout(()=>this.flushBuffer(D),y);N={data:[T],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(D),R.dispose()}},this.a.set(D,N)});return R}stopBuffering(D){this.a.get(D)?.dispose()}flushBuffer(D){const M=this.a.get(D);M&&(this.a.delete(D),this.b(D,M.data.join("")))}}e.TerminalDataBufferer=n}),define(ke[172],Te([1,0,17,84,38,4,9,2,137,69,30]),function(te,e,n,k,D,M,y,R,S,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var w;(function(L){function p(t,d){let r=t.defaults;for(;D.ThemeIcon.isThemeIcon(r);){const l=m.getIcon(r.id);if(!l)return;r=l.defaults}return r}L.getDefinition=p})(w=e.IconContribution||(e.IconContribution={}));var h;(function(L){function p(d){return{weight:d.weight,style:d.style,src:d.src.map(r=>({format:r.format,location:r.location.toString()}))}}L.toJSONObject=p;function t(d){const r=l=>(0,y.isString)(l)?l:void 0;if(d&&Array.isArray(d.src)&&d.src.every(l=>(0,y.isString)(l.format)&&(0,y.isString)(l.location)))return{weight:r(d.weight),style:r(d.style),src:d.src.map(l=>({format:l.format,location:R.URI.parse(l.location)}))}}L.fromJSONObject=t})(h=e.IconFontDefinition||(e.IconFontDefinition={}));class v{constructor(){this.a=new M.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${D.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,t,d,r){const l=this.b[p];if(l){if(d&&!l.description){l.description=d,this.d.properties[p].markdownDescription=`${d} $(${p})`;const i=this.e.enum.indexOf(p);i!==-1&&(this.e.enumDescriptions[i]=d),this.a.fire()}return l}const c={id:p,description:d,defaults:t,deprecationMessage:r};this.b[p]=c;const b={$ref:"#/definitions/icons"};return r&&(b.deprecationMessage=r),d&&(b.markdownDescription=`${d}: $(${p})`),this.d.properties[p]=b,this.e.enum.push(p),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const t=this.e.enum.indexOf(p);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,t){const d=this.f[p];return d||(this.f[p]=t,this.a.fire(),t)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(l,c)=>l.id.localeCompare(c.id),t=l=>{for(;D.ThemeIcon.isThemeIcon(l.defaults);)l=this.b[l.defaults.id];return`codicon codicon-${l?l.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(l=>this.b[l]);for(const l of r.filter(c=>!!c.description).sort(p))d.push(`|<i class="${t(l)}"></i>|${l.id}|${D.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const l of r.filter(c=>!D.ThemeIcon.isThemeIcon(c.defaults)).sort(p))d.push(`|<i class="${t(l)}"></i>|${l.id}|`);return d.join(`
`)}}const m=new v;N.Registry.add(e.Extensions.IconContribution,m);function a(L,p,t,d){return m.registerIcon(L,p,t,d)}e.registerIcon=a;function o(){return m}e.getIconRegistry=o;function u(){const L=(0,k.getCodiconFontCharacters)();for(const p in L){const t="\\"+L[p].toString(16);m.registerIcon(p,{fontCharacter:t})}}u(),e.iconsSchemaId="vscode://schemas/icons";const g=N.Registry.as(T.Extensions.JSONContribution);g.registerSchema(e.iconsSchemaId,m.getIconSchema());const E=new n.RunOnceScheduler(()=>g.notifySchemaChanged(e.iconsSchemaId),200);m.onDidChange(()=>{E.isScheduled()||E.schedule()}),e.widgetClose=a("widget-close",k.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=a("goto-previous-location",k.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=a("goto-next-location",k.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=D.ThemeIcon.modify(k.Codicon.sync,"spin"),e.spinningLoading=D.ThemeIcon.modify(k.Codicon.loading,"spin")}),define(ke[173],Te([1,0,4,41,3,11]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var y;(function(a){a.Http="http",a.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=w;function h(a,o,u,g){if(u===1)return!1;if(u===2&&w(o)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(E?.length===4&&parseInt(E[1])>=18)return!1}return a<1024}e.isPortPrivileged=h;class v{constructor(o,u,g){this.remoteAddress=o,this.localAddress=u,this.b=g,this.a=new n.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=v;let m=class{constructor(o,u){this.i=o,this.j=u,this.a=new n.Emitter,this.onTunnelOpened=this.a.event,this.b=new n.Emitter,this.onTunnelClosed=this.b.event,this.c=new n.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const o=this.j.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.e=o,o?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.f=o.elevation,this.g=o.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const o=[],u=Array.from(this.d.values());for(const g of u){const E=Array.from(g.values());for(const L of E){const p=await L.value;p&&o.push(p)}}return o}async dispose(){for(const o of this.d.values()){for(const{value:u}of o.values())await u.then(g=>g?.dispose());o.clear()}this.d.clear()}setEnvironmentTunnel(o,u,g,E,L){this.o(o,u,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:u,localAddress:g,privacy:E,protocol:L,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,u){(w(o)||N(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const g=this.q(o,u);if(g)return++g.refcount,g.value}openTunnel(o,u,g,E,L,p=!1,t,d){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${g} on local port ${L}.`),!o)return;if(u||(u="localhost"),E||(E=this.k),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(o,u,g,E,L,p,t,d);return r?r.then(l=>{if(!l){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const c=this.m(l);return(l.tunnelRemoteHost!==u||l.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(c),c}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const u=this.d.get(o.tunnelRemoteHost);if(u){const g=u.get(o.tunnelRemotePort);g&&(g.refcount--,await this.n(o.tunnelRemoteHost,o.tunnelRemotePort,g))}}}}async n(o,u,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${u}.`);const E=g.value.then(async L=>{L&&(await L.dispose(!0),this.b.fire({host:L.tunnelRemoteHost,port:L.tunnelRemotePort}))});return this.d.has(o)&&this.d.get(o).delete(u),E}}async closeTunnel(o,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${u} `);const g=this.d.get(o);if(g&&g.has(u)){const E=g.get(u);E.refcount=0,await this.n(o,u,E)}}o(o,u,g){this.d.has(o)||this.d.set(o,new Map),this.d.get(o).set(u,{refcount:1,value:g})}async p(o,u){const g=this.d.get(o);g&&(await g.get(u)||g.delete(u),g.size===0&&this.d.delete(o))}q(o,u){const g=[o];N(o)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):w(o)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const E=g.map(L=>this.d.get(L));for(const L of E){const p=L?.get(u);if(p)return p}}canTunnel(o){return!!T(o)}s(o,u,g,E,L,p,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${g} on local port ${E}.`);const d=g;this.h.add(d);const r=E===void 0?g:E,l={elevationRequired:L?this.isPortPrivileged(r):!1},c={remoteAddress:{host:u,port:g},localAddressPort:E,privacy:p,public:p?p!==R.Private:void 0,protocol:t},b=o.forwardPort(c,l);return b?(this.o(u,g,b),b.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(d)})):this.h.delete(d),b}};m=qe([Ve(0,M.ILogService),Ve(1,k.IConfigurationService)],m),e.AbstractTunnelService=m}),define(ke[174],Te([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,n.createDecorator)("editSessionIdentityService");var k;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(k=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ke[175],Te([1,0,15]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function k(S){return S.scheme!==n.Schemas.file&&S.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=k;function D(S){if(S.folders.length)return S.folders.every(T=>k(T.uri))?S.folders[0].uri:void 0;if(S.configuration&&k(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=D;function M(S){return D(S)?.scheme}e.getVirtualWorkspaceScheme=M;function y(S){return D(S)?.authority}e.getVirtualWorkspaceAuthority=y;function R(S){return D(S)!==void 0}e.isVirtualWorkspace=R}),define(ke[53],Te([1,0,138,19,48,24,2,3,15]),function(te,e,n,k,D,M,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function T(r){const l=r;return typeof l?.id=="string"&&y.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=T;function N(r){return typeof r?.id=="string"&&!T(r)&&!h(r)}e.isEmptyWorkspaceIdentifier=N,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(r,l){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,k.basename)(r)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=r;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=w;function h(r){const l=r;return typeof l?.id=="string"&&y.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=h;function v(r){const l=r;if(l?.uri)return{id:l.id,uri:y.URI.revive(l.uri)};const c=r;if(c?.configPath)return{id:c.id,configPath:y.URI.revive(c.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=v;var m;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function a(r){const l=r;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=a;function o(r){const l=r;return!!(l&&typeof l=="object"&&y.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=o;class u{constructor(l,c,b,i,s){this.h=l,this.j=b,this.k=i,this.l=s,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=c}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class g{constructor(l,c){this.raw=c,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,M.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function E(r){return new g({uri:r,index:0,name:(0,M.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function L(r,l){return M.extUriBiasedIgnorePathCase.isEqualOrParent(r,l.untitledWorkspacesHome)}e.isUntitledWorkspace=L;function p(r){let l;return y.URI.isUri(r)?l=r:l=r.configuration,l?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=p;function t(r,l){return!L(r,l)&&!p(r)}e.isSavedWorkspace=t;function d(r){return(typeof r=="string"?(0,k.extname)(r):(0,M.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=d}),define(ke[54],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(D){this.d=D,this.b=new Map,this.c=1}add(D){const M=this.c++;return this.b.set(M,D),this.e(),M}get(D,M){return this.b.has(D)?this.b.get(D)[M]:void 0}delete(D){this.b.delete(D),this.e()}e(){!n.a||console.log(`${this.d} cache size - ${this.b.size}`)}}n.a=!1,e.Cache=n}),define(ke[36],Te([1,0,15,24,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this.a=new Set(Object.keys(n.Schemas)),this.b=new Map,this.extUri=new k.ExtUri(R=>{const S=this.b.get(R.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(R,S){S===null?this.b.delete(R.scheme):this.b.set(R.scheme,S)}isFreeScheme(R){return!this.b.has(R)&&!this.a.has(R)}getCapabilities(R){return this.b.get(R)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(ke[27],Te([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(ke[176],Te([1,0,11,162,27]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends k.LogService{constructor(R,S){super(R.createLogger(S.logFile,{name:S.logName}))}};M=qe([Ve(0,n.ILoggerService),Ve(1,D.IExtHostInitDataService)],M),e.ExtHostLogService=M}),define(ke[177],Te([1,0,17]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class k{constructor(y,R,S){this.h=new Map,this.a=y,this.b=R,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(T=>(this.f=T,this)),this.g=this.c.onDidChangeStorage(T=>{T.shared===this.b&&T.key===this.a&&(this.f=T.value)}),this.i=new n.RunOnceScheduler(()=>{const T=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of T.values())N.complete()}catch(N){for(const w of T.values())w.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this.d}get(y,R){let S=this.f[y];return typeof S>"u"&&(S=R),S}update(y,R){this.f[y]=R;const S=this.h.get(y);if(S!==void 0)return S.p;const T=new n.DeferredPromise;return this.h.set(y,T),this.i.isScheduled()||this.i.schedule(),T.p}dispose(){this.g.dispose()}}e.ExtensionMemento=k;class D extends k{setKeysForSync(y){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},y)}constructor(y,R){super(y.identifier.value,!0,R),this.j=y}}e.ExtensionGlobalMemento=D}),define(ke[178],Te([1,0,4,2]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(y){this.c=y,this.a=new n.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new n.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(y,R,S,T){const w=this.c.getNotebookDocument(k.URI.revive(y)).acceptModelChanged(R.value,S,T);this.b.fire(w)}$acceptDirtyStateChanged(y,R){this.c.getNotebookDocument(k.URI.revive(y)).acceptDirty(R)}$acceptModelSaved(y){const R=this.c.getNotebookDocument(k.URI.revive(y));this.a.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(ke[18],Te([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class k{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=k});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(ke[179],Te([1,0,26,4]),function(te,e,n,k){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(R,S){D.set(this,void 0),this.b=new k.Emitter,this.onDidChange=this.b.event,this.a=n.ExtensionIdentifier.toKey(R.identifier),Je(this,D,S,"f"),Le(this,D,"f").onDidChangePassword(T=>{T.extensionId===this.a&&this.b.fire({key:T.key})})}get(R){return Le(this,D,"f").get(this.a,R)}store(R,S){return Le(this,D,"f").store(this.a,R,S)}delete(R){return Le(this,D,"f").delete(this.a,R)}}e.ExtensionSecrets=M,D=new WeakMap}),define(ke[70],Te([1,0,3,173,4,18]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var y;(function(S){function T(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:w.protocol}}S.fromApiTunnel=T;function N(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==k.TunnelPrivacyId.ConstantPrivate&&w.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}S.fromServiceTunnel=N})(y=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let R=class{constructor(T){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,N){}async getTunnels(){return[]}async setTunnelFactory(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,N){return{dispose:()=>{}}}async $providePortAttributes(T,N,w,h,v){return[]}async $forwardPort(T,N){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=qe([Ve(0,M.IExtHostRpcService)],R),e.ExtHostTunnelService=R}),define(ke[55],Te([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class k{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=k}),define(ke[180],Te([1,0,23]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(S){let T=this.buffers.indexOf(S);return T<0&&(T=this.buffers.length,this.buffers.push(S)),T}}function D(R,S){if(S.serializeBuffersForPostMessage){const T=new k,N=(v,m)=>{if(m instanceof ArrayBuffer){const a=T.add(m);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(m)){const a=M(m);if(a){const o=T.add(m.buffer);return{$$vscode_array_buffer_reference$$:!0,index:o,view:{type:a,byteLength:m.byteLength,byteOffset:m.byteOffset}}}}return m},w=JSON.stringify(R,N),h=T.buffers.map(v=>{const m=new Uint8Array(v);return n.VSBuffer.wrap(m)});return{message:w,buffers:h}}else return{message:JSON.stringify(R),buffers:[]}}e.serializeWebviewMessage=D;function M(R){switch(R.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(R,S){const T=S.map(h=>{const v=new ArrayBuffer(h.byteLength);return new Uint8Array(v).set(h.buffer),v}),N=S.length?(h,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const m=v,{index:a}=m,o=T[a];if(m.view)switch(m.view.type){case 1:return new Int8Array(o,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return v}:void 0;return{message:JSON.parse(R,N),arrayBuffers:T}}e.deserializeWebviewMessage=y}),define(ke[95],Te([1,0,147,9,2,6,3,30,43,15,39,124,29]),function(te,e,n,k,D,M,y,R,S,T,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var v;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(v=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function a(G){const X=G;return!!X&&typeof X.getSelection=="function"&&!!X.onDidChangeSelection}e.isEditorPaneWithSelection=a;function o(G,X,J){for(const de of J.visibleEditorPanes)if(de.group.id===X&&G.matches(de.input))return de.getViewState()}e.findViewStateForEditor=o;function u(G){if(s(G))return!1;const X=G;return D.URI.isUri(X?.resource)}e.isResourceEditorInput=u;function g(G){if(s(G))return!1;const X=G;return X?.original!==void 0&&X.modified!==void 0}e.isResourceDiffEditorInput=g;function E(G){if(s(G)||g(G))return!1;const X=G;return X?.primary!==void 0&&X.secondary!==void 0}e.isResourceSideBySideEditorInput=E;function L(G){if(s(G))return!1;const X=G;return X?X.resource===void 0||X.resource.scheme===T.Schemas.untitled||X.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=L;const p=/Untitled-\d+/;function t(G){return G.scheme===T.Schemas.untitled&&G.path.length>1&&!p.test(G.path)}e.isUntitledWithAssociatedResource=t;function d(G){if(s(G))return!1;const X=G;return D.URI.isUri(X?.base?.resource)&&D.URI.isUri(X?.input1?.resource)&&D.URI.isUri(X?.input2?.resource)&&D.URI.isUri(X?.result?.resource)}e.isResourceMergeEditorInput=d;var r;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var l;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class c{constructor(){this.a=new Map}registerSource(X,J){let de=this.a.get(X);return de||(de={source:X,label:J},this.a.set(X,de)),de.source}getSourceLabel(X){return this.a.get(X)?.label??X}}e.SaveSourceRegistry=new c;var b;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends M.Disposable{}e.AbstractEditorInput=i;function s(G){return G instanceof i}e.isEditorInput=s;function f(G){const X=G;return D.URI.isUri(X?.preferredResource)}function P(G){const X=G;return s(X?.primary)&&s(X?.secondary)}e.isSideBySideEditorInput=P;function C(G){const X=G;return s(X?.modified)&&s(X?.original)}e.isDiffEditorInput=C;function j(G,X,J,de,ye){return Se(de,[(0,w.toAction)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const Fe={...J,limits:{size:Number.MAX_VALUE}};G.openEditor(X,Fe)}}),(0,w.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:h.default.Warning})}e.createTooLargeFileError=j;function _(G){return s(G?.editor)}e.isEditorInputWithOptions=_;function K(G){const X=G;return _(G)&&X?.group!==void 0}e.isEditorInputWithOptionsAndGroup=K;function A(G){const X=G;return typeof X?.groupId=="number"&&s(X.editor)}e.isEditorIdentifier=A;var $;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})($=e.EditorCloseContext||(e.EditorCloseContext={}));var O;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(O=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var F;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(F=e.SideBySideEditor||(e.SideBySideEditor={}));class H{getOriginalUri(X,J){if(!X)return;if(d(X))return e.EditorResourceAccessor.getOriginalUri(X.result,J);if(J?.supportSideBySide){const{primary:ye,secondary:Fe}=this.a(X);if(ye&&Fe){if(J?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:J.filterByScheme}),secondary:this.getOriginalUri(Fe,{filterByScheme:J.filterByScheme})};if(J?.supportSideBySide===F.ANY)return this.getOriginalUri(ye,{filterByScheme:J.filterByScheme})??this.getOriginalUri(Fe,{filterByScheme:J.filterByScheme});X=J.supportSideBySide===F.PRIMARY?ye:Fe}}if(g(X)||E(X)||d(X))return;const de=f(X)?X.preferredResource:X.resource;return!de||!J||!J.filterByScheme?de:this.b(de,J.filterByScheme)}a(X){return P(X)||E(X)?{primary:X.primary,secondary:X.secondary}:C(X)||g(X)?{primary:X.modified,secondary:X.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(X,J){if(!X)return;if(d(X))return e.EditorResourceAccessor.getCanonicalUri(X.result,J);if(J?.supportSideBySide){const{primary:ye,secondary:Fe}=this.a(X);if(ye&&Fe){if(J?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:J.filterByScheme}),secondary:this.getCanonicalUri(Fe,{filterByScheme:J.filterByScheme})};if(J?.supportSideBySide===F.ANY)return this.getCanonicalUri(ye,{filterByScheme:J.filterByScheme})??this.getCanonicalUri(Fe,{filterByScheme:J.filterByScheme});X=J.supportSideBySide===F.PRIMARY?ye:Fe}}if(g(X)||E(X)||d(X))return;const de=X.resource;return!de||!J||!J.filterByScheme?de:this.b(de,J.filterByScheme)}b(X,J){if(Array.isArray(J)){if(J.some(de=>X.scheme===de))return X}else if(J===X.scheme)return X}}e.EditorResourceAccessor=new H;var V;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(V=e.CloseDirection||(e.CloseDirection={}));class ae{constructor(){this.c=new Map,this.d=new Map}start(X){const J=this.a=X.get(y.IInstantiationService);for(const[de,ye]of this.c)this.e(de,ye,J);this.c.clear()}e(X,J,de){const ye=de.createInstance(J);this.d.set(X,ye)}registerFileEditorFactory(X){if(this.b)throw new Error("Can only register one file editor factory.");this.b=X}getFileEditorFactory(){return(0,k.assertIsDefined)(this.b)}registerEditorSerializer(X,J){if(this.c.has(X)||this.d.has(X))throw new Error(`A editor serializer with type ID '${X}' was already registered.`);return this.a?this.e(X,J,this.a):this.c.set(X,J),(0,M.toDisposable)(()=>{this.c.delete(X),this.d.delete(X)})}getEditorSerializer(X){return this.d.get(typeof X=="string"?X:X.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new ae);async function pe(G,X,J){return!G||!G.length?[]:await Promise.all(G.map(async de=>{const ye=D.URI.revive(de.fileUri);if(!ye){J.info("Cannot resolve the path because it is not valid.",de);return}if(!await X.canHandleResource(ye)){J.info("Cannot resolve the path because it cannot be handled",de);return}let ze=de.exists,Pe=de.type;if(typeof ze!="boolean"||typeof Pe!="number")try{Pe=(await X.stat(ye)).isDirectory?S.FileType.Directory:S.FileType.Unknown,ze=!0}catch(we){J.error(we),ze=!1}if(!ze&&de.openOnlyIfExists){J.info("Cannot resolve the path because it does not exist",de);return}if(Pe===S.FileType.Directory){J.info("Cannot resolve the path because it is a directory",de);return}const Ie={...de.options,pinned:!0};return ze?{resource:ye,options:Ie}:{resource:ye,options:Ie,forceUntitled:!0}}))}e.pathsToEditors=pe;var re;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(re=e.EditorsOrder||(e.EditorsOrder={}));function ce(G){const X=G;if(!X)return!1;const J=X;if(J.modified)return ce(J.modified);const de=X;return!!(de.contributionsState&&de.viewState&&Array.isArray(de.cursorState))}e.isTextEditorViewState=ce;function ue(G){return(0,N.isErrorWithActions)(G)}e.isEditorOpenError=ue;function Se(G,X,J){const de=(0,N.createErrorWithActions)(G,X);return de.forceMessage=J?.forceMessage,de.forceSeverity=J?.forceSeverity,de.allowDialog=J?.allowDialog,de}e.createEditorOpenError=Se}),define(ke[181],Te([1,0,4,148,3,6,28,30,16,63,22,84,172]),function(te,e,n,k,D,M,y,R,S,T,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",w.Codicon.window,(0,k.localize)(0,null));var v;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(v=e.Extensions||(e.Extensions={}));var m;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(m=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function a(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=a;class o extends M.Disposable{constructor(){super(...arguments),this.c=this.B(new n.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new n.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.flatten)([...this.g.values()])}registerViewContainer(l,c,b){const i=this.get(l.id);if(i)return i;const s=l;return s.openCommandActionDescriptor=b?.doNotRegisterOpenCommand?void 0:s.openCommandActionDescriptor??{id:s.id},(0,y.getOrSet)(this.g,c,[]).push(s),b?.isDefault&&this.h.push(s),this.c.fire({viewContainer:s,viewContainerLocation:c}),s}deregisterViewContainer(l){for(const c of this.g.keys()){const b=this.g.get(c),i=b?.indexOf(l);if(i!==-1){b?.splice(i,1),b.length===0&&this.g.delete(c),this.f.fire({viewContainer:l,viewContainerLocation:c});return}}}get(l){return this.all.filter(c=>c.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(b=>b?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(c=>this.getViewContainerLocation(c)===l)}}R.Registry.add(v.ViewContainersRegistry,new o);var u;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(u=e.ViewContentGroups||(e.ViewContentGroups={}));function g(r,l){const c=r.group??u.More,b=l.group??u.More;return c!==b?c.localeCompare(b):(r.order??5)-(l.order??5)}class E extends M.Disposable{constructor(){super(...arguments),this.c=this.B(new n.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new n.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new n.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new n.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new T.SetMap}registerViews(l,c){this.registerViews2([{views:l,viewContainer:c}])}registerViews2(l){l.forEach(({views:c,viewContainer:b})=>this.l(c,b)),this.c.fire(l)}deregisterViews(l,c){const b=this.m(l,c);b.length&&this.f.fire({views:b,viewContainer:c})}moveViews(l,c){for(const b of this.j.keys())if(b!==c){const i=this.m(l,b);i.length&&(this.l(i,c),this.g.fire({views:i,from:b,to:c}))}}getViews(l){return this.j.get(l)||[]}getView(l){for(const c of this.i){const b=(this.j.get(c)||[]).filter(i=>i.id===l)[0];if(b)return b}return null}getViewContainer(l){for(const c of this.i)if((this.j.get(c)||[]).filter(i=>i.id===l)[0])return c;return null}registerViewWelcomeContent(l,c){return this.k.add(l,c),this.h.fire(l),(0,M.toDisposable)(()=>{this.k.delete(l,c),this.h.fire(l)})}registerViewWelcomeContent2(l,c){const b=new Map;for(const[i,s]of c)this.k.add(l,s),b.set(i,(0,M.toDisposable)(()=>{this.k.delete(l,s),this.h.fire(l)}));return this.h.fire(l),b}getViewWelcomeContent(l){const c=[];return this.k.forEach(l,b=>c.push(b)),c.sort(g)}l(l,c){let b=this.j.get(c);b||(b=[],this.j.set(c,b),this.i.push(c));for(const i of l){if(this.getView(i.id)!==null)throw new Error((0,k.localize)(1,null,i.id));b.push(i)}}m(l,c){const b=this.j.get(c);if(!b)return[];const i=[],s=[];for(const f of b)l.includes(f)?i.push(f):s.push(f);return i.length&&(s.length?this.j.set(c,s):(this.j.delete(c),this.i.splice(this.i.indexOf(c),1))),i}}R.Registry.add(v.ViewsRegistry,new E),e.IViewsService=(0,D.createDecorator)("viewsService"),e.IViewDescriptorService=(0,D.createDecorator)("viewDescriptorService");var L;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(L=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(l,c){this.c=!1,this.d=!1,(0,N.mixin)(this,l),this.d=!!c,this.resolve=async b=>{if(c&&!this.c){const i=await c(b);i&&(this.tooltip=this.tooltip??i.tooltip,this.command=this.command??i.command)}b.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class d extends Error{constructor(l){super((0,k.localize)(2,null,l))}}e.NoTreeViewError=d}),define(ke[182],Te([1,0,4,17,149]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new n.Emitter,this.n=new n.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(R){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=R}onEvent(R){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=R}onRequest(R){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.s("response",R)}sendRequest(R,S,T,N){const w={command:R};if(S&&Object.keys(S).length>0&&(w.arguments=S),this.s("request",w),typeof N=="number"){const h=setTimeout(()=>{clearTimeout(h);const v=this.f.get(w.seq);if(v){this.f.delete(w.seq);const m={type:"response",seq:0,request_seq:w.seq,success:!1,command:R,message:(0,D.localize)(0,null,N,R)};v(m)}},N)}return T&&this.f.set(w.seq,T),w.seq}acceptMessage(R){this.j?this.j(R):(this.k.push(R),this.k.length===1&&this.q())}o(R,S){return R.type!=="event"||S.type!=="event"}async q(){let R;for(;this.k.length;){if((!R||this.o(this.k[0],R))&&await(0,k.timeout)(0),R=this.k.shift(),!R)return;switch(R.type){case"event":this.i?.(R);break;case"request":this.g?.(R);break;case"response":{const S=R,T=this.f.get(S.request_seq);T&&(this.f.delete(S.request_seq),T(S));break}}}}s(R,S){S.type=R,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach((S,T)=>R.set(T,S)),await(0,k.timeout)(500),R.forEach((S,T)=>{S({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.f.delete(T)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=M}),define(ke[183],Te([1,0,150,42,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new k.RawContextKey("debugType",void 0,{type:"string",description:n.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new k.RawContextKey("debugConfigurationType",void 0,{type:"string",description:n.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new k.RawContextKey("debugState","inactive",{type:"string",description:n.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new k.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:n.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new k.RawContextKey("hasDebugged",!1,{type:"boolean",description:n.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new k.RawContextKey("inDebugMode",!1,{type:"boolean",description:n.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new k.RawContextKey("inDebugRepl",!1,{type:"boolean",description:n.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new k.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:n.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new k.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:n.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new k.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:n.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new k.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:n.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new k.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:n.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new k.RawContextKey("variablesFocused",!0,{type:"boolean",description:n.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new k.RawContextKey("expressionSelected",!1,{type:"boolean",description:n.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new k.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:n.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new k.RawContextKey("callStackItemType",void 0,{type:"string",description:n.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new k.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:n.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new k.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:n.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new k.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:n.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new k.RawContextKey("watchItemType",void 0,{type:"string",description:n.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new k.RawContextKey("canViewMemory",void 0,{type:"boolean",description:n.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new k.RawContextKey("breakpointItemType",void 0,{type:"string",description:n.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new k.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:n.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new k.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:n.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new k.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:n.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new k.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:n.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new k.RawContextKey("stepBackSupported",!1,{type:"boolean",description:n.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new k.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:n.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new k.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:n.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new k.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:n.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new k.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:n.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new k.RawContextKey("breakpointsExist",!1,{type:"boolean",description:n.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new k.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:n.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new k.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:n.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new k.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:n.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new k.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:n.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new k.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:n.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new k.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:n.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new k.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:n.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new k.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:n.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new k.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:n.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new k.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:n.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new k.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:n.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new k.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:n.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new k.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:n.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new k.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:n.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new k.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:n.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new k.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:n.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new k.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:n.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new k.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:n.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new k.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:n.localize(50,null)});const M=h=>n.localize(51,null,h);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:n.localize(52,null)};var y;(function(h){h[h.Inactive=0]="Inactive",h[h.Initializing=1]="Initializing",h[h.Stopped=2]="Stopped",h[h.Running=3]="Running"})(y=e.State||(e.State={}));function R(h){switch(h){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=R;var S;(function(h){h[h.Valid=0]="Valid",h[h.Unreadable=1]="Unreadable",h[h.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var T;(function(h){h[h.Initial=1]="Initial",h[h.Dynamic=2]="Dynamic"})(T=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var N;(function(h){h.UnverifiedBreakpoints="unverifiedBreakpoints"})(N=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,D.createDecorator)("debugService");var w;(function(h){h[h.CONDITION=0]="CONDITION",h[h.HIT_COUNT=1]="HIT_COUNT",h[h.LOG_MESSAGE=2]="LOG_MESSAGE"})(w=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ke[184],Te([1,0,10,2,19,22,15,44,21,16]),function(te,e,n,k,D,M,y,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const N=/{([^}]+)}/g;function w(i,s,f){return i.replace(N,function(P,C){return s&&C.length>0&&C[0]!=="_"?P:f&&f.hasOwnProperty(C)?f[C]:P})}e.formatPII=w;function h(i){const s={};for(const f of Object.keys(i))f.startsWith("!")||(s[f]=i[f]);return s}e.filterExceptionsFromTelemetry=h;function v(i){return i.configuration.request==="attach"&&!m(i)&&(!i.parentSession||v(i.parentSession))}e.isSessionAttach=v;function m(i){let s=i.configuration.type;if(!!s)return s==="vslsShare"&&(s=i.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(s,"extensionhost")||(0,n.equalsIgnoreCase)(s,"pwa-extensionhost")?i:i.parentSession?m(i.parentSession):void 0}e.getExtensionHostDebugSession=m;function a(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=a;function o(i,s,f){let P,C=0;const j=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let _=null;for(;_=j.exec(i);){const K=_.index+1,A=K+_[0].length;if(K<=s&&A>=f){P=_[0],C=K;break}}if(P){const K=/\w+/g;let A=null;for(;(A=K.exec(P))&&!(A.index+1+C+A[0].length>=f););A&&(P=P.substring(0,K.lastIndex))}return P?{start:C,end:C+P.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=o;async function u(i,s,f,P){if(i.evaluatableExpressionProvider.has(s)){const C=i.evaluatableExpressionProvider.ordered(s),j=(0,T.coalesce)(await Promise.all(C.map(async _=>{try{return await _.provideEvaluatableExpression(s,f,P??S.CancellationToken.None)}catch{return}})));if(j.length>0){let _=j[0].expression;const K=j[0].range;return _||(_=s.getLineContent(f.lineNumber).substring(K.startColumn-1,K.endColumn-1)),{range:K,matchingExpression:_}}}else{const C=s.getLineContent(f.lineNumber),{start:j,end:_}=o(C,f.column,f.column),K=C.substring(j-1,_);return{matchingExpression:K,range:new R.Range(f.lineNumber,j,f.lineNumber,j+K.length)}}return null}e.getEvaluatableExpressionAtPosition=u;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function E(i){return!!(i&&i.match(g))}e.isUri=E;function L(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(E(i.path))return k.URI.parse(i.path);if((0,D.isAbsolute)(i.path))return k.URI.file(i.path)}return i.path}function p(i){if(typeof i.path=="object"){const s=k.URI.revive(i.path);if(s)return s.scheme===y.Schemas.file?s.fsPath:s.toString()}return i.path}function t(i,s){const f=s?L:p,P=(0,M.deepClone)(i);return r(P,(C,j)=>{C&&j&&(j.path=f(j))}),P}e.convertToDAPaths=t;function d(i,s){const f=s?L:p,P=(0,M.deepClone)(i);return r(P,(C,j)=>{!C&&j&&(j.path=f(j))}),P}e.convertToVSCPaths=d;function r(i,s){switch(i.type){case"event":{const f=i;switch(f.event){case"output":s(!1,f.body.source);break;case"loadedSource":s(!1,f.body.source);break;case"breakpoint":s(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=i;switch(f.command){case"setBreakpoints":s(!0,f.arguments.source);break;case"breakpointLocations":s(!0,f.arguments.source);break;case"source":s(!0,f.arguments.source);break;case"gotoTargets":s(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(P=>s(!1,P));break;default:break}break}case"response":{const f=i;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(P=>s(!1,P.source));break;case"loadedSources":f.body.sources.forEach(P=>s(!1,P));break;case"scopes":f.body.scopes.forEach(P=>s(!1,P.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(P=>s(!1,P.source));break;case"setBreakpoints":f.body.breakpoints.forEach(P=>s(!1,P.source));break;case"disassemble":f.body?.instructions.forEach(C=>s(!1,C.location));break;default:break}break}}}function l(i){return i.filter(s=>!s.presentation?.hidden).sort((s,f)=>s.presentation?f.presentation?s.presentation.group?f.presentation.group?s.presentation.group!==f.presentation.group?s.presentation.group.localeCompare(f.presentation.group):c(s.presentation.order,f.presentation.order):-1:f.presentation.group?1:c(s.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.getVisibleAndSorted=l;function c(i,s){return typeof i!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:i-s}async function b(i,s){const f=i.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorLanguageId});if(f!=="none"&&(await s.saveAll(),f==="allEditorsInActiveGroup")){const P=s.activeEditorPane;P&&P.input.resource?.scheme===y.Schemas.untitled&&await s.save({editor:P.input,groupId:P.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=b}),define(ke[71],Te([1,0,23,35,185,65,15,19,20,42]),function(te,e,n,k,D,M,y,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var N;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(N=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var w;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(w=e.NotebookRunState||(e.NotebookRunState={}));var h;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(h=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var v;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(v=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var a;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(a=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var g;(function(F){F.scheme=y.Schemas.vscodeNotebookCell;const H=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${H.join("")}]+`),ae=7;function pe(X,J){const de=J.toString(ae),Fe=`${de.length<H.length?H[de.length-1]:"z"}${de}s${(0,n.encodeBase64)(n.VSBuffer.fromString(X.scheme),!0,!0)}`;return X.with({scheme:F.scheme,fragment:Fe})}F.generate=pe;function re(X){if(X.scheme!==F.scheme)return;const J=X.fragment.indexOf("s");if(J<0)return;const de=parseInt(X.fragment.substring(0,J).replace(V,""),ae),ye=(0,n.decodeBase64)(X.fragment.substring(J+1)).toString();if(!isNaN(de))return{handle:de,notebook:X.with({scheme:ye,fragment:null})}}F.parse=re;function ce(X,J){return X.with({scheme:y.Schemas.vscodeNotebookCellOutput,fragment:`op${J??""},${X.scheme!==y.Schemas.file?X.scheme:""}`})}F.generateCellOutputUri=ce;function ue(X){if(X.scheme!==y.Schemas.vscodeNotebookCellOutput)return;const J=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(X.fragment);if(!J)return;const de=J[1]&&J[1]!==""?J[1]:void 0,ye=J[2];return{outputId:de,notebook:X.with({scheme:ye||y.Schemas.file,fragment:null})}}F.parseCellOutputUri=ue;function Se(X,J,de){return F.generate(X,J).with({scheme:de})}F.generateCellPropertyUri=Se;function G(X,J){if(X.scheme===J)return F.parse(X.with({scheme:F.scheme}))}F.parseCellPropertyUri=G})(g=e.CellUri||(e.CellUri={}));const E=F=>S.isWindows?F.replace(/\//g,"\\"):F;class L{constructor(H=[],V=e.NOTEBOOK_DISPLAY_ORDER){this.e=V,this.d=[...new Set(H)].map(ae=>({pattern:ae,matches:k.parse(E(ae))}))}sort(H){const V=new Map(D.Iterable.map(H,pe=>[pe,E(pe)]));let ae=[];for(const{matches:pe}of this.d)for(const[re,ce]of V)if(pe(ce)){ae.push(re),V.delete(re);break}return V.size&&(ae=ae.concat([...V.keys()].sort((pe,re)=>this.e.indexOf(pe)-this.e.indexOf(re)))),ae}prioritize(H,V){const ae=this.f(H);if(ae===-1){this.d.unshift({pattern:H,matches:k.parse(E(H))});return}const pe=new Set(V.map(ce=>this.f(ce,ae)));pe.delete(-1);const re=Array.from(pe).sort();this.d.splice(ae+1,0,...re.map(ce=>this.d[ce]));for(let ce=re.length-1;ce>=0;ce--)this.d.splice(re[ce],1)}toArray(){return this.d.map(H=>H.pattern)}f(H,V=this.d.length){const ae=E(H);for(let pe=0;pe<V;pe++)if(this.d[pe].matches(ae))return pe;return-1}}e.MimeTypeDisplayOrder=L;function p(F,H,V,ae=(pe,re)=>pe===re){const pe=[];function re(Se,G,X){if(G===0&&X.length===0)return;const J=pe[pe.length-1];J&&J.start+J.deleteCount===Se?(J.deleteCount+=G,J.toInsert.push(...X)):pe.push({start:Se,deleteCount:G,toInsert:X})}let ce=0,ue=0;for(;;){if(ce===F.length){re(ce,0,H.slice(ue));break}if(ue===H.length){re(ce,F.length-ce,[]);break}const Se=F[ce],G=H[ue];if(ae(Se,G)){ce+=1,ue+=1;continue}V(G)?(re(ce,1,[]),ce+=1):(re(ce,0,[G]),ue+=1)}return pe}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new T.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(F){F.default="default",F.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(F){const H=F;return!!((typeof H.include=="string"||k.isRelativePattern(H.include))&&(typeof H.exclude=="string"||k.isRelativePattern(H.exclude)))}e.isDocumentExcludePattern=d;function r(F,H,V){if(Array.isArray(F.viewType)&&F.viewType.indexOf(H)>=0||F.viewType===H)return!0;if(F.filenamePattern){const ae=d(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,pe=d(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(k.match(ae,(0,R.basename)(V.fsPath).toLowerCase()))return!(pe&&k.match(pe,(0,R.basename)(V.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",outputWordWrap:"notebook.output.wordWrap",logging:"notebook.logging"};var l;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(H){return`${c.d}${H}`}static parse(H){if(H.startsWith(c.d))return H.substring(c.d.length)}}c.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=c;function b(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.isTextStreamMime=b;const i=new TextDecoder;function s(F){const H=[];let V=!1;for(const ae of F)(H.length===0||V)&&(H.push(ae),V=!0);return j(H),O(n.VSBuffer.concat(H.map(ae=>n.VSBuffer.wrap(ae))))}e.compressOutputItemStreams=s;const f=`${String.fromCharCode(27)}[A`,P=f.split("").map(F=>F.charCodeAt(0)),C=10;function j(F){F.forEach((H,V)=>{if(V===0||H.length<f.length)return;const ae=F[V-1],pe=H.subarray(0,f.length);if(pe[0]===P[0]&&pe[1]===P[1]&&pe[2]===P[2]){const re=ae.lastIndexOf(C);if(re===-1)return;F[V-1]=ae.subarray(0,re),F[V]=H.subarray(f.length)}})}function _(F){let H=F;do F=H,H=F.replace(/[^\n]\x08/gm,"");while(H.length<F.length);return F}function K(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const H=F.match(/^(.*)\r+/m)[1];let V=F.match(/\r+(.*)$/m)[1];V=V+H.slice(V.length,H.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return F}const A="\b".charCodeAt(0),$="\r".charCodeAt(0);function O(F){return!F.buffer.includes(A)&&!F.buffer.includes($)?F:n.VSBuffer.fromString(K(_(i.decode(F.buffer))))}}),define(ke[186],Te([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var k;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(k=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(ke[45],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(M){M.Delimiter="\0"})(n=e.TestIdPathParts||(e.TestIdPathParts={}));var k;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(k=e.TestPosition||(e.TestPosition={}));class D{static fromExtHostTestItem(y,R,S=y.parent){if(y._isRoot)return new D([R]);const T=[y.id];for(let N=S;N&&N.id!==R;N=N.parent)T.push(N.id);return T.push(R),new D(T.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const R=y.indexOf("\0");return R===-1?y:y.slice(0,R)}static fromString(y){return new D(y.split("\0"))}static join(y,R){return new D([...y.path,R])}static joinToString(y,R){return y.toString()+"\0"+R}static parentId(y){const R=y.lastIndexOf("\0");return R===-1?void 0:y.slice(0,R)}static localId(y){const R=y.lastIndexOf("\0");return R===-1?y:y.slice(R+1)}static compare(y,R){return y===R?0:R.startsWith(y+"\0")?2:y.startsWith(R+"\0")?3:1}constructor(y,R=y.length){if(this.path=y,this.d=R,y.length===0||R<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new D(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let y=1;y<=this.d;y++)yield new D(this.path,y)}*idsToRoot(){for(let y=this.d;y>0;y--)yield new D(this.path,y)}compare(y){if(typeof y=="string")return D.compare(this.toString(),y);for(let R=0;R<y.d&&R<this.d;R++)if(y.path[R]!==this.path[R])return 1;return y.d>this.d?2:y.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let y=1;y<this.d;y++)this.c+="\0",this.c+=this.path[y]}return this.c}}e.TestId=D}),define(ke[56],Te([1,0,2,44,45]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var M;(function(i){i[i.Unset=0]="Unset",i[i.Queued=1]="Queued",i[i.Running=2]="Running",i[i.Passed=3]="Passed",i[i.Failed=4]="Failed",i[i.Skipped=5]="Skipped",i[i.Errored=6]="Errored"})(M=e.TestResultState||(e.TestResultState={}));var y;(function(i){i[i.Run=2]="Run",i[i.Debug=4]="Debug",i[i.Coverage=8]="Coverage",i[i.HasNonDefaultProfile=16]="HasNonDefaultProfile",i[i.HasConfigurable=32]="HasConfigurable",i[i.SupportsContinuousRun=64]="SupportsContinuousRun"})(y=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const R=i=>"runId"in i;e.isStartControllerTests=R;var S;(function(i){i.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),i.deserialize=s=>({range:k.Range.lift(s.range),uri:n.URI.revive(s.uri)})})(S=e.IRichLocation||(e.IRichLocation={}));var T;(function(i){i[i.Error=0]="Error",i[i.Output=1]="Output"})(T=e.TestMessageType||(e.TestMessageType={}));var N;(function(i){i.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&S.serialize(s.location)}),i.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&S.deserialize(s.location)})})(N=e.ITestErrorMessage||(e.ITestErrorMessage={}));const w=(i,s)=>`${s?"s":"e"}${i}`;e.getMarkId=w;var h;(function(i){i.serialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&S.serialize(s.location)}),i.deserialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&S.deserialize(s.location)})})(h=e.ITestOutputMessage||(e.ITestOutputMessage={}));var v;(function(i){i.serialize=s=>s.type===0?N.serialize(s):h.serialize(s),i.deserialize=s=>s.type===0?N.deserialize(s):h.deserialize(s)})(v=e.ITestMessage||(e.ITestMessage={}));var m;(function(i){i.serializeWithoutMessages=s=>({state:s.state,duration:s.duration,messages:[]}),i.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(v.serialize)}),i.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(v.deserialize)})})(m=e.ITestTaskState||(e.ITestTaskState={}));const a="\0",o=(i,s)=>i+a+s;e.namespaceTestTag=o;const u=i=>{const s=i.indexOf(a);return{ctrlId:i.slice(0,s),tagId:i.slice(s+1)}};e.denamespaceTestTag=u;var g;(function(i){i.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),i.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?n.URI.revive(s.uri):void 0,range:s.range?k.Range.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(g=e.ITestItem||(e.ITestItem={}));var E;(function(i){i[i.NotExpandable=0]="NotExpandable",i[i.Expandable=1]="Expandable",i[i.BusyExpanding=2]="BusyExpanding",i[i.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));var L;(function(i){i.serialize=s=>({expand:s.expand,item:g.serialize(s.item)}),i.deserialize=s=>({controllerId:D.TestId.root(s.item.extId),expand:s.expand,item:g.deserialize(s.item)})})(L=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(i){i.serialize=s=>{let f;return s.item&&(f={},s.item.label!==void 0&&(f.label=s.item.label),s.item.tags!==void 0&&(f.tags=s.item.tags),s.item.busy!==void 0&&(f.busy=s.item.busy),s.item.uri!==void 0&&(f.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(f.range=s.item.range?.toJSON()),s.item.description!==void 0&&(f.description=s.item.description),s.item.error!==void 0&&(f.error=s.item.error),s.item.sortText!==void 0&&(f.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:f}},i.deserialize=s=>{let f;return s.item&&(f={},s.item.label!==void 0&&(f.label=s.item.label),s.item.tags!==void 0&&(f.tags=s.item.tags),s.item.busy!==void 0&&(f.busy=s.item.busy),s.item.range!==void 0&&(f.range=s.item.range?k.Range.lift(s.item.range):null),s.item.description!==void 0&&(f.description=s.item.description),s.item.error!==void 0&&(f.error=s.item.error),s.item.sortText!==void 0&&(f.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:f}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(i,s)=>{s.expand!==void 0&&(i.expand=s.expand),s.item!==void 0&&(i.item=i.item?Object.assign(i.item,s.item):s.item)};e.applyTestItemUpdate=t;var d;(function(i){i.serializeWithoutMessages=s=>({...L.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(m.serializeWithoutMessages),retired:s.retired}),i.serialize=s=>({...L.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(m.serialize),retired:s.retired}),i.deserialize=s=>({...L.deserialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(m.deserialize),retired:!0})})(d=e.TestResultItem||(e.TestResultItem={}));var r;(function(i){i[i.Function=0]="Function",i[i.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var l;(function(i){i[i.Add=0]="Add",i[i.Update=1]="Update",i[i.DocumentSynced=2]="DocumentSynced",i[i.Remove=3]="Remove",i[i.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",i[i.Retire=5]="Retire",i[i.AddTag=6]="AddTag",i[i.RemoveTag=7]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var c;(function(i){i.deserialize=s=>s.op===0?{op:s.op,item:L.deserialize(s.item)}:s.op===1?{op:s.op,item:p.deserialize(s.item)}:s.op===2?{op:s.op,uri:n.URI.revive(s.uri),docv:s.docv}:s,i.serialize=s=>s.op===0?{op:s.op,item:L.serialize(s.item)}:s.op===1?{op:s.op,item:p.serialize(s.item)}:s})(c=e.TestsDiffOp||(e.TestsDiffOp={}));class b{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(s){const f=this.o();for(const P of s)switch(P.op){case 0:this.j(L.deserialize(P.item),f);break;case 1:this.k(p.deserialize(P.item),f);break;case 3:this.l(P.itemId,f);break;case 5:this.m(P.itemId);break;case 4:this.updatePendingRoots(P.amount);break;case 6:this.c.set(P.tag.id,P.tag);break;case 7:this.c.delete(P.id);break}f.complete?.()}j(s,f){const P=D.TestId.parentId(s.item.extId)?.toString();let C;if(!P)C=this.p(s),this.f.add(C),this.d.set(s.item.extId,C);else if(this.d.has(P)){const j=this.d.get(P);j.children.add(s.item.extId),C=this.p(s,j),this.d.set(s.item.extId,C)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(s)}`);return}return f.add?.(C),s.expand===2&&this.g++,C}k(s,f){const P=this.d.get(s.extId);if(!!P)return s.expand!==void 0&&(P.expand===2&&this.g--,s.expand===2&&this.g++),(0,e.applyTestItemUpdate)(P,s),f.update?.(P),P}l(s,f){const P=this.d.get(s);if(!P)return;const C=D.TestId.parentId(P.item.extId)?.toString();C?this.d.get(C).children.delete(P.item.extId):this.f.delete(P);const j=[[s]];for(;j.length;)for(const _ of j.pop()){const K=this.d.get(_);K&&(j.push(K.children),this.d.delete(_),f.remove?.(K,K!==P),K.expand===2&&this.g--)}}m(s){}updatePendingRoots(s){this.h+=s}o(){return{}}}e.AbstractIncrementalTestCollection=b}),define(ke[72],Te([1,0,17,4,6,49,56,45]),function(te,e,n,k,D,M,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const T=(g,E)=>g===E,w=Object.entries({range:(g,E)=>g===E?!0:!g||!E?!1:g.equalsRange(E),busy:T,label:T,description:T,error:T,sortText:T,tags:(g,E)=>!(g.length!==E.length||g.some(L=>!E.includes(L)))}),h=(g,E)=>{let L;for(const[p,t]of w)t(g[p],E[p])||(L?L[p]=E[p]:L={[p]:E[p]});return L};class v extends D.Disposable{get root(){return this.m.root}constructor(E){super(),this.m=E,this.f=this.B(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new k.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(E){this.h=E;for(const L of this.tree.values())this.G(L)}get resolveHandler(){return this.h}collectDiff(){const E=this.k;return this.k=[],E}pushDiff(E){switch(E.op){case 2:{for(const L of this.k)if(L.op===2&&L.uri===E.uri){L.docv=E.docv;return}break}case 1:{const L=this.k[this.k.length-1];if(L){if(L.op===1&&L.item.extId===E.item.extId){(0,y.applyTestItemUpdate)(L.item,E.item);return}if(L.op===0&&L.item.item.extId===E.item.extId){(0,y.applyTestItemUpdate)(L.item,E.item);return}}break}}this.k.push(E),this.f.isScheduled()||this.f.schedule()}expand(E,L){const p=this.tree.get(E);if(!!p){if((p.expandLevels===void 0||L>p.expandLevels)&&(p.expandLevels=L),p.expand===1){const t=this.I(p);return t.isOpen()?this.H(p,L-1):t.wait().then(()=>this.H(p,L-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.H(p,L-1)):this.H(p,L-1)}}dispose(){for(const E of this.tree.values())this.m.getApiFor(E.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(E,L){switch(L.op){case 3:this.L(R.TestId.joinToString(E.fullId,L.id));break;case 0:this.u(L.item,E);break;case 5:for(const p of L.ops)this.p(E,p);break;case 1:this.w(L.new,L.old,E.fullId.toString());break;case 2:this.G(E);break;case 4:this.pushDiff({op:1,item:{extId:E.fullId.toString(),item:L.update}});break;case 6:this.s(E.actual.uri);break;default:(0,M.assertNever)(L)}}s(E){E&&this.pushDiff({op:2,uri:E,docv:this.m.getDocumentVersion(E)})}u(E,L){const p=R.TestId.fromExtHostTestItem(E,this.root.id,L?.actual),t=this.m.getApiFor(E);t.parent&&t.parent!==L?.actual&&this.m.getChildren(t.parent).delete(E.id);let d=this.tree.get(p.toString());if(!d){d={fullId:p,actual:E,expandLevels:L?.expandLevels?L.expandLevels-1:void 0,expand:0},E.tags.forEach(this.y,this),this.tree.set(d.fullId.toString(),d),this.C(E,L),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:d.expand,item:this.m.toITestItem(E)}}),this.F(E,d,L);return}if(d.actual===E){this.D(E,d,L);return}if(d.actual.uri?.toString()!==E.uri?.toString())return this.L(p.toString()),this.u(E,L);const r=this.m.getChildren(d.actual),l=d.actual,c=h(this.m.toITestItem(l),this.m.toITestItem(E));this.m.getApiFor(l).listener=void 0,d.actual=E,d.expand=0,c&&(c.hasOwnProperty("tags")&&(this.w(E.tags,l.tags,p.toString()),delete c.tags),this.p(d,{op:4,update:c})),this.F(E,d,L);for(const[b,i]of r)this.m.getChildren(E).get(i.id)||this.L(R.TestId.joinToString(p,i.id));this.s(d.actual.uri)}w(E,L,p){const t=new Set(L.map(d=>d.id));for(const d of E)t.delete(d.id)||this.y(d);this.pushDiff({op:1,item:{extId:p,item:{tags:E.map(d=>(0,y.namespaceTestTag)(this.m.controllerId,d.id))}}}),t.forEach(this.z,this)}y(E){const L=this.j.get(E.id);L?L.refCount++:(this.j.set(E.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,y.namespaceTestTag)(this.m.controllerId,E.id)}}))}z(E){const L=this.j.get(E);L&&!--L.refCount&&(this.j.delete(E),this.pushDiff({op:7,id:(0,y.namespaceTestTag)(this.m.controllerId,E)}))}C(E,L){this.m.getApiFor(E).parent=L&&L.actual!==this.root?L.actual:void 0}D(E,L,p){this.C(E,p);const t=this.m.getApiFor(E);t.parent=p?.actual,t.listener=d=>this.p(L,d),this.G(L)}F(E,L,p){this.D(E,L,p);for(const[t,d]of this.m.getChildren(E))this.u(d,L)}G(E){let L;this.h?E.resolveBarrier?L=E.resolveBarrier.isOpen()?3:2:L=E.actual.canResolveChildren?1:0:L=0,L!==E.expand&&(E.expand=L,this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:L}}),L===1&&E.expandLevels!==void 0&&this.I(E))}H(E,L){if(L<0)return;const p=[];for(const[t,d]of this.m.getChildren(E.actual)){const r=this.expand(R.TestId.joinToString(E.fullId,d.id),L);(0,n.isThenable)(r)&&p.push(r)}if(p.length)return Promise.all(p).then(()=>{})}I(E){if(E.resolveBarrier)return E.resolveBarrier;if(!this.h){const d=new n.Barrier;return d.open(),d}E.expand=2,this.J(E);const L=E.resolveBarrier=new n.Barrier,p=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,d)};let t;try{t=this.h(E.actual===this.root?void 0:E.actual)}catch(d){p(d)}return(0,n.isThenable)(t)?t.catch(p).then(()=>{L.open(),this.G(E)}):(L.open(),this.G(E)),E.resolveBarrier}J(E){this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:E.expand}})}L(E){const L=this.tree.get(E);if(!L)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:E});const p=[L];for(;p.length;){const t=p.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const d of t.actual.tags)this.z(d.id);this.tree.delete(t.fullId.toString());for(const[d,r]of this.m.getChildren(t.actual))p.push(this.tree.get(R.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const E=this.collectDiff();E.length&&this.g.fire(E)}}e.TestItemCollection=v;class m extends Error{constructor(E){super(`Attempted to insert a duplicate test item ID ${E}`)}}e.DuplicateTestItemError=m;class a extends Error{constructor(E){super(`TestItem with ID "${E}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=a;class o extends Error{constructor(E,L,p){super(`TestItem with ID "${E}" is from controller "${L}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=o;const u=(g,E,L)=>{let p=new Map;return{get size(){return p.size},forEach(t,d){for(const r of p.values())t.call(d,r,this)},[Symbol.iterator](){return p.entries()},replace(t){const d=new Map,r=new Set(p.keys()),l={op:5,ops:[]};for(const c of t){if(!(c instanceof L))throw new a(c.id);const b=E(c).controllerId;if(b!==g.controllerId)throw new o(c.id,b,g.controllerId);if(d.has(c.id))throw new m(c.id);d.set(c.id,c),r.delete(c.id),l.ops.push({op:0,item:c})}for(const c of r.keys())l.ops.push({op:3,id:c});g.listener?.(l),p=d},add(t){if(!(t instanceof L))throw new a(t.id);p.set(t.id,t),g.listener?.({op:0,item:t})},delete(t){p.delete(t)&&g.listener?.({op:3,id:t})},get(t){return p.get(t)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=u}),define(ke[96],Te([1,0,72]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const k=new WeakMap,D=(y,R)=>{const S={controllerId:R};return k.set(y,S),S};e.createPrivateApiFor=D;const M=y=>{const R=k.get(y);if(!R)throw new n.InvalidTestItemError(y?.id||"<unknown>");return R};e.getPrivateApiFor=M}),define(ke[73],Te([1,0,15,2]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(R,S){return R.scheme===n.Schemas.http||R.scheme===n.Schemas.https?R:(S&&S.authority&&S.isRemote&&R.scheme===n.Schemas.file&&(R=k.URI.from({scheme:n.Schemas.vscodeRemote,authority:S.authority,path:R.path})),k.URI.from({scheme:n.Schemas.https,authority:`${R.scheme}+${M(R.authority)}.${e.webviewRootResourceAuthority}`,path:R.path,fragment:R.fragment,query:R.query}))}e.asWebviewUri=D;function M(R){return R.replace(/./g,S=>{const T=S.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?S:"-"+T.toString(16).padStart(4,"0")})}function y(R){return R.replace(/-([0-9a-f]{4})/g,(S,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=y}),define(ke[187],Te([1,0,4,6,73]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(R,S,T){this.d=R,this.e=S,this.f=T,this.a=0,this.b=new k.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const N=S.getVisibleTextEditors();for(const w of this.c.values())N.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,S,T,N,w){let h;for(const E of this.e.getVisibleTextEditors(!0))if(E.value===R){h=E;break}if(!h)throw new Error("not a visible editor");const v=this,m=this.a++,a=new n.Emitter,o=new n.Emitter,u=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(E){return(0,D.asWebviewUri)(E,v.f)}get cspSource(){return D.webviewGenericCspSource}set options(E){this.b=E,v.d.$setOptions(m,E)}get options(){return this.b}set html(E){this.a=E,v.d.$setHtml(m,E)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(E){return v.d.$postMessage(m,E)}},g=new class{constructor(){this.editor=R,this.line=S,this.height=T,this.webview=u,this.onDidDispose=o.event}dispose(){v.c.has(m)&&(v.c.delete(m),v.d.$disposeEditorInset(m),o.fire(),o.dispose(),a.dispose())}};return this.d.$createEditorInset(m,h.id,h.value.document.uri,S+1,T,N||{},w.identifier,w.extensionLocation),this.c.set(m,{editor:R,inset:g,onDidReceiveMessage:a}),g}$onDidDispose(R){const S=this.c.get(R);S&&S.inset.dispose()}$onDidReceiveMessage(R,S){this.c.get(R)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=M}),define(ke[188],Te([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,n.createDecorator)("configurationResolverService");var k;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(k=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(y,R){super(R),this.variable=y}}e.VariableError=D}),define(ke[189],Te([1,0,19,51,9,22,20,87,153,188,10]),function(te,e,n,k,D,M,y,R,S,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class w{constructor(v,m,a,o){this.g=new Map,this.a=v,this.b=m,this.d=a,o&&(this.c=o.then(u=>this.h(u)))}h(v){if(y.isWindows){const m=Object.create(null);return Object.keys(v).forEach(a=>{m[a.toLowerCase()]=v[a]}),m}return v}resolveWithEnvironment(v,m,a){return this.j({env:this.h(v),userHome:void 0},m?m.uri:void 0,a)}async resolveAsync(v,m){const a={env:await this.c,userHome:await this.d};return this.j(a,v?v.uri:void 0,m)}async i(v,m,a,o){const u=M.deepClone(m);y.isWindows&&u.windows?Object.keys(u.windows).forEach(E=>u[E]=u.windows[E]):y.isMacintosh&&u.osx?Object.keys(u.osx).forEach(E=>u[E]=u.osx[E]):y.isLinux&&u.linux&&Object.keys(u.linux).forEach(E=>u[E]=u.linux[E]),delete u.windows,delete u.osx,delete u.linux;const g={env:await this.c,userHome:await this.d};return this.j(g,v?v.uri:void 0,u,a,o)}async resolveAnyAsync(v,m,a){return this.i(v,m,a)}async resolveAnyMap(v,m,a){const o=new Map;return{newConfig:await this.i(v,m,a,o),resolvedVariables:o}}resolveWithInteractionReplace(v,m,a,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,m,a,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,m){if(this.g.has(v))throw new Error("Variable "+v+" is contributed twice.");this.g.set(v,m)}async j(v,m,a,o,u){if(D.isString(a))return this.l(v,m,a,o,u);if(Array.isArray(a))return Promise.all(a.map(g=>this.j(v,m,g,o,u)));if(D.isObject(a)){const g=Object.create(null),E=await Promise.all(Object.keys(a).map(async L=>[await this.l(v,m,L,o,u),await this.j(v,m,a[L],o,u)]));for(const[L,p]of E)g[L]=p;return g}return a}l(v,m,a,o,u){return(0,N.replaceAsync)(a,w.VARIABLE_REGEXP,async(g,E)=>{if(E.includes(w.VARIABLE_LHS))return g;let L=await this.n(v,g,E,m,o);return u?.set(E,L),L!==g&&D.isString(L)&&L.match(w.VARIABLE_REGEXP)&&(L=await this.l(v,m,L,o,u)),L})}m(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async n(v,m,a,o,u){let g;const E=a.split(":");E.length>1&&(a=E[0],g=E[1]);const L=d=>{const r=this.a.getFilePath();if(r)return(0,R.normalizeDriveLetter)(r);throw new T.VariableError(d,(0,S.localize)(0,null,m))},p=d=>{const r=L(d);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,R.normalizeDriveLetter)(l)}throw new T.VariableError(d,(0,S.localize)(1,null,m,n.basename(r)))},t=d=>{if(g){const r=this.a.getFolderUri(g);if(r)return r;throw new T.VariableError(d,(0,S.localize)(2,null,m,g))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new T.VariableError(d,(0,S.localize)(3,null,m)):new T.VariableError(d,(0,S.localize)(4,null,m))};switch(a){case"env":if(g){if(v.env){const d=v.env[y.isWindows?g.toLowerCase():g];if(D.isString(d))return d}return""}throw new T.VariableError(T.VariableKind.Env,(0,S.localize)(5,null,m));case"config":if(g){const d=this.a.getConfigurationValue(o,g);if(D.isUndefinedOrNull(d))throw new T.VariableError(T.VariableKind.Config,(0,S.localize)(6,null,m,g));if(D.isObject(d))throw new T.VariableError(T.VariableKind.Config,(0,S.localize)(7,null,m,g));return d}throw new T.VariableError(T.VariableKind.Config,(0,S.localize)(8,null,m));case"command":return this.o(T.VariableKind.Command,m,g,u,"command");case"input":return this.o(T.VariableKind.Input,m,g,u,"input");case"extensionInstallFolder":if(g){const d=await this.a.getExtension(g);if(!d)throw new T.VariableError(T.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,m,g));return this.m(d.extensionLocation)}throw new T.VariableError(T.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,m));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.m(t(T.VariableKind.WorkspaceFolder)));case"cwd":return o||g?(0,R.normalizeDriveLetter)(this.m(t(T.VariableKind.Cwd))):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(n.basename(this.m(t(T.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new T.VariableError(T.VariableKind.UserHome,(0,S.localize)(11,null,m))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new T.VariableError(T.VariableKind.LineNumber,(0,S.localize)(12,null,m))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new T.VariableError(T.VariableKind.SelectedText,(0,S.localize)(13,null,m))}case"file":return L(T.VariableKind.File);case"fileWorkspaceFolder":return p(T.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||g?n.relative(this.m(t(T.VariableKind.RelativeFile)),L(T.VariableKind.RelativeFile)):L(T.VariableKind.RelativeFile);case"relativeFileDirname":{const d=n.dirname(L(T.VariableKind.RelativeFileDirname));if(o||g){const r=n.relative(this.m(t(T.VariableKind.RelativeFileDirname)),d);return r.length===0?".":r}return d}case"fileDirname":return n.dirname(L(T.VariableKind.FileDirname));case"fileExtname":return n.extname(L(T.VariableKind.FileExtname));case"fileBasename":return n.basename(L(T.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=n.basename(L(T.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-n.extname(d).length)}case"fileDirnameBasename":return n.basename(n.dirname(L(T.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||m}case"execInstallFolder":{const d=this.a.getAppRoot();return d||m}case"pathSeparator":return n.sep;default:try{const d=g?`${a}:${g}`:a;return this.o(T.VariableKind.Unknown,m,d,u,void 0)}catch{return m}}}}o(v,m,a,o,u){if(a&&o){const g=u===void 0?o[a]:o[u+":"+a];if(typeof g=="string")return g;throw new T.VariableError(v,(0,S.localize)(14,null,m))}return m}}w.VARIABLE_LHS="${",w.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=w}),define(ke[97],Te([1,0,3,95]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var D;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var M;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var R;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(R=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function T(m){const a=m;return(0,k.isEditorInput)(a?.editor)&&(0,k.isEditorInput)(a?.replacement)}e.isEditorReplacement=T;var N;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var w;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(w=e.OpenEditorContext||(e.OpenEditorContext={}));function h(m){const a=m;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}e.isEditorGroup=h;function v(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=v}),define(ke[190],Te([1,0,3,97]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(M){const y=M;return typeof M=="number"||(0,k.isEditorGroup)(y)}e.isPreferredGroup=D}),define(ke[191],Te([1,0,3,159]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(k.IEnvironmentService)}),define(ke[98],Te([1,0,26,4,19]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(w){this.removedDueToLooping=w}}e.DeltaExtensionsResult=M;class y{static isHostExtension(w,h,v){if(h.getExtensionDescription(w))return!1;const m=v.getExtensionDescription(w);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(w){this.c=new k.Emitter,this.onDidChange=this.c.event,this.d=w,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const w of this.d){if(this.e.has(n.ExtensionIdentifier.toKey(w.identifier))){console.error("Extension `"+w.identifier.value+"` is already registered");continue}if(this.e.set(n.ExtensionIdentifier.toKey(w.identifier),w),this.f.push(w),Array.isArray(w.activationEvents))for(let h of w.activationEvents)h==="onUri"&&(h=`onUri:${n.ExtensionIdentifier.toKey(w.identifier)}`),this.g.has(h)||this.g.set(h,[]),this.g.get(h).push(w)}}set(w){this.d=w,this.h(),this.c.fire(void 0)}deltaExtensions(w,h){this.d=T(this.d,h),this.d=this.d.concat(w);const v=y.j(this.d);return this.d=T(this.d,v.map(m=>m.identifier)),this.h(),this.c.fire(void 0),new M(v)}static j(w){const h=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,g){this.addNode(u),this.addNode(g),this.c.has(u)?this.c.get(u).push(g):this.c.set(u,[g])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,g){const E=h.getArcs(u);for(let L=0;L<E.length;L++)if(!g.has(E[L]))return!1;return!0}getNodes(){return this.e}},v=new Map;for(const u of w){const g=n.ExtensionIdentifier.toKey(u.identifier);if(v.set(g,u),u.extensionDependencies)for(const E of u.extensionDependencies){const L=n.ExtensionIdentifier.toKey(E);h.addArc(g,L)}}const m=new Set;h.getNodes().filter(u=>h.getArcs(u).length===0).forEach(u=>m.add(u));const a=h.getNodes().filter(u=>!m.has(u));let o;do{o=!1;for(let u=0;u<a.length;u++){const g=a[u];h.hasOnlyGoodArcs(g,m)&&(a.splice(u,1),u--,m.add(g),o=!0)}}while(o);return a.map(u=>v.get(u))}containsActivationEvent(w){return this.g.has(w)}containsExtension(w){return this.e.has(n.ExtensionIdentifier.toKey(w))}getExtensionDescriptionsForActivationEvent(w){const h=this.g.get(w);return h?h.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(w){const h=this.e.get(n.ExtensionIdentifier.toKey(w));return h||void 0}getExtensionDescriptionByUUID(w){for(const h of this.f)if(h.uuid===w)return h}getExtensionDescriptionByIdOrUUID(w,h){return this.getExtensionDescription(w)??(h?this.getExtensionDescriptionByUUID(h):void 0)}}e.ExtensionDescriptionRegistry=y;var R;(function(N){N[N.Builtin=0]="Builtin",N[N.User=1]="User",N[N.Dev=2]="Dev"})(R||(R={}));function S(N,w){const h=N.isBuiltin?0:N.isUnderDevelopment?2:1,v=w.isBuiltin?0:w.isUnderDevelopment?2:1;if(h!==v)return h-v;const m=D.posix.basename(N.extensionLocation.path),a=D.posix.basename(w.extensionLocation.path);return m<a?-1:m>a?1:0}function T(N,w){const h=new Set;return w.forEach(v=>h.add(n.ExtensionIdentifier.toKey(v))),N.filter(v=>!h.has(n.ExtensionIdentifier.toKey(v.identifier)))}}),define(ke[74],Te([1,0,23]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var k;(function(T){T[T.Desktop=1]="Desktop",T[T.Web=2]="Web"})(k=e.UIKind||(e.UIKind={}));var D;(function(T){T[T.VersionMismatch=55]="VersionMismatch",T[T.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(T){T[T.Initialized=0]="Initialized",T[T.Ready=1]="Ready",T[T.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function y(T){const N=n.VSBuffer.alloc(1);switch(T){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}e.createMessageOfType=y;function R(T,N){if(T.byteLength!==1)return!1;switch(T.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}e.isMessageOfType=R;var S;(function(T){T.Start="START_NATIVE_LOG",T.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ke[57],Te([1,0,3,4,11,27,74,50,52,22,2,6,143]),function(te,e,n,k,D,M,y,R,S,T,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let v=class extends w.Disposable{constructor(u,g){super(),this.m=u,this.n=g,this.a=this.B(new k.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new k.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=N.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=g.createLogger(this.j,{id:S.extensionTelemetryLogChannelId,name:(0,h.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(g.onDidChangeLogLevel(E=>{(0,D.isLogLevel)(E)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===D.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(u,g,E){const L=this.getTelemetryDetails(),p=new m(g,E,u,this.k,this.i,this.getBuiltInCommonProperties(u),{isUsageEnabled:L.isUsageEnabled,isErrorsEnabled:L.isErrorsEnabled});return this.l.set(u.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(u,g,E){this.f=u,this.g=g,this.c=E??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(u){const g={};switch(g["common.extname"]=`${u.publisher}.${u.name}`,g["common.extversion"]=u.version,g["common.vscodemachineid"]=this.m.telemetryInfo.machineId,g["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,g["common.vscodeversion"]=this.m.version,g["common.isnewappinstall"]=a(this.m.telemetryInfo.firstSessionDate),g["common.product"]=this.m.environment.appHost,this.m.uiKind){case y.UIKind.Web:g["common.uikind"]="web";break;case y.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,R.getRemoteName)((0,S.cleanRemoteAuthority)(this.m.remote.authority)),g}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const g=this.getTelemetryDetails();this.l.forEach(E=>{E.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(u,g){const E=this.l.get(u.value);return!E||E.ignoreUnhandledExtHostErrors?!1:(E.logError(g),!0)}};v=qe([Ve(0,M.IExtHostInitDataService),Ve(1,D.ILoggerService)],v),e.ExtHostTelemetry=v;class m{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,g,E,L,p,t,d){this.g=E,this.h=L,this.i=p,this.j=t,this.a=new k.Emitter,this.ignoreUnhandledExtHostErrors=g?.ignoreUnhandledErrors??!1,this.b=g?.ignoreBuiltInCommonProperties??!1,this.c=g?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(u,g){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:g},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let g=u.properties??u;return g=(0,S.cleanData)(g,[]),this.c&&(g=(0,T.mixin)(g,this.c)),this.b||(g=(0,T.mixin)(g,this.j)),u.properties?u.properties=g:u=g,u}k(u,g){!this.f||(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.f?.sendEventData(u,g),this.h.trace(u,g))}logUsage(u,g){!this.d.isUsageEnabled||this.k(u,g)}logError(u,g){!this.d.isErrorsEnabled||!this.f||(typeof u=="string"?this.k(u,g):this.f.sendErrorData(u,g))}get apiTelemetryLogger(){if(!this.e){const u=this,g={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(g)}return this.e}dispose(){this.f?.flush&&(Promise.resolve(this.f.flush()).then(this.f=void 0),this.e=void 0)}}e.ExtHostTelemetryLogger=m;function a(o){const u=Date.now()-new Date(o).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.isNewAppInstall=a,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(ke[25],Te([1,0,4,2,3,26,169]),function(te,e,n,k,D,M,y){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class S{constructor(b){this.affinity=b,this.kind=1}equals(b){return this.kind===b.kind&&this.affinity===b.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class T{constructor(b){this.affinity=b,this.kind=2}equals(b){return this.kind===b.kind&&this.affinity===b.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=T;class N{constructor(){this.kind=3,this.affinity=0}equals(b){return this.kind===b.kind}asString(){return"Remote"}}e.RemoteRunningLocation=N;class w{constructor(b){this.dependency=b}}e.MissingExtensionDependency=w;var h;(function(c){c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(h=e.ExtensionHostKind||(e.ExtensionHostKind={}));function v(c){if(c===null)return"None";switch(c){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=v;class m{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(b,i){const s=[],f=[],P=[],C=[],j=u(this.c),_=u(b),K=(F,H)=>F.extensionLocation.toString()===H.extensionLocation.toString()||F.isBuiltin===H.isBuiltin||F.isUserBuiltin===H.isUserBuiltin||F.isUnderDevelopment===H.isUnderDevelopment;for(const F of this.c){const H=_.get(M.ExtensionIdentifier.toKey(F.identifier));if(!H){s.push(F.identifier),j.delete(M.ExtensionIdentifier.toKey(F.identifier));continue}if(!K(F,H)){s.push(F.identifier),j.delete(M.ExtensionIdentifier.toKey(F.identifier));continue}}for(const F of b){const H=j.get(M.ExtensionIdentifier.toKey(F.identifier));if(!H){f.push(F);continue}if(!K(H,F)){s.push(H.identifier),j.delete(M.ExtensionIdentifier.toKey(H.identifier));continue}}const A=o(this.d),$=o(i);for(const F of this.d)$.has(M.ExtensionIdentifier.toKey(F))||P.push(F);for(const F of i)A.has(M.ExtensionIdentifier.toKey(F))||C.push(F);const O={toRemove:s,toAdd:f,myToRemove:P,myToAdd:C};return this.delta(O),O}delta(b){const{toRemove:i,toAdd:s,myToRemove:f,myToAdd:P}=b,C=o(i),j=o(f);for(let _=0;_<this.c.length;_++)C.has(M.ExtensionIdentifier.toKey(this.c[_].identifier))&&(this.c.splice(_,1),_--);for(let _=0;_<this.d.length;_++)j.has(M.ExtensionIdentifier.toKey(this.d[_]))&&(this.d.splice(_,1),_--);for(const _ of s)this.c.push(_);for(const _ of P)this.d.push(_)}containsExtension(b){for(const i of this.d)if(M.ExtensionIdentifier.equals(i,b))return!0;return!1}}e.ExtensionHostExtensions=m;class a{constructor(b){if(this[R]="ExtensionIdentifierSet",this.c=new Map,this.d=M.ExtensionIdentifier.toKey,b)for(const i of b)this.add(i)}get size(){return this.c.size}add(b){return this.c.set(this.d(b),b),this}clear(){this.c.clear()}delete(b){return this.c.delete(this.d(b))}has(b){return this.c.has(this.d(b))}forEach(b,i){this.c.forEach(s=>b.call(i,s,s,this))}*entries(){for(const[b,i]of this.c)yield[i,i]}keys(){return this.c.values()}values(){return this.c.values()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=a;function o(c){const b=new Set;for(const i of c)b.add(M.ExtensionIdentifier.toKey(i));return b}e.extensionIdentifiersArrayToSet=o;function u(c){const b=new Map;for(const i of c)b.set(M.ExtensionIdentifier.toKey(i.identifier),i);return b}function g(c,b){return c.enabledApiProposals?c.enabledApiProposals.includes(b):!1}e.isProposedApiEnabled=g;function E(c,b){if(!g(c,b))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${b}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${b}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=E;class L{constructor(b,i,s,f){this.codeLoadingTime=b,this.activateCallTime=i,this.activateResolvedTime=s,this.activationReason=f}}e.ActivationTimes=L;class p{constructor(b,i){this.description=b,this.value=i}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var t;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function d(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function r(c,b){return{identifier:new M.ExtensionIdentifier((0,y.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!b,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,browserNlsBundleUris:c.browserNlsBundleUris}}e.toExtensionDescription=r;class l{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.extensions=[]}activateByEvent(b){return Promise.resolve(void 0)}activationEventIsDone(b){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(b,i){return Promise.resolve(0)}getInspectPorts(b,i){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=l}),define(ke[192],Te([1,0,12,98,26,25,11,17]),function(te,e,n,k,D,M,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(u,g,E,L){this.startup=u,this.codeLoadingTime=g,this.activateCallTime=E,this.activateResolvedTime=L}}S.NONE=new S(!1,-1,-1,-1),e.ExtensionActivationTimes=S;class T{constructor(u){this.a=u,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(u,g){return u===-1||g===-1?-1:g-u}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=T;class N{constructor(u,g,E,L,p,t){this.activationFailed=u,this.activationFailedError=g,this.activationTimes=E,this.module=L,this.exports=p,this.subscriptions=t}}e.ActivatedExtension=N;class w extends N{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=w;class h extends N{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=h;class v extends N{constructor(u){super(!0,u,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(u,g,E,L){this.g=L,this.a=u,this.b=g,this.c=E,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[u,g]of this.d)g.dispose()}isActivated(u){const g=this.d.get(D.ExtensionIdentifier.toKey(u));return Boolean(g&&g.value)}getActivatedExtension(u){const g=this.d.get(D.ExtensionIdentifier.toKey(u));if(!g||!g.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return g.value}async activateByEvent(u,g){if(this.f[u])return;const E=this.a.getExtensionDescriptionsForActivationEvent(u);await this.h(E.map(L=>({id:L.identifier,reason:{startup:g,extensionId:L.identifier,activationEvent:u}}))),this.f[u]=!0}activateById(u,g){const E=this.a.getExtensionDescription(u);if(!E)throw new Error(`Extension '${u}' is not known`);return this.h([{id:E.identifier,reason:g}])}async h(u){const g=u.filter(E=>!this.isActivated(E.id)).map(E=>this.j(E));await Promise.all(g.map(E=>E.wait()))}j(u){if(this.d.has(D.ExtensionIdentifier.toKey(u.id)))return this.d.get(D.ExtensionIdentifier.toKey(u.id));if(this.l(u.id))return this.k(u,null,[],null);const g=this.a.getExtensionDescription(u.id);if(!g){const p=new Error(`Cannot activate unknown extension '${u.id.value}'`),t=this.k(u,null,[],new v(p));return this.c.onExtensionActivationError(u.id,p,new M.MissingExtensionDependency(u.id.value)),t}const E=[],L=typeof g.extensionDependencies>"u"?[]:g.extensionDependencies;for(const p of L){if(this.m(p))continue;const t=this.d.get(D.ExtensionIdentifier.toKey(p));if(t){E.push(t);continue}if(this.l(p)){E.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:u.reason}));continue}const d=this.a.getExtensionDescription(p);if(d){if(!d.main&&!d.browser)continue;E.push(this.j({id:d.identifier,reason:u.reason}));continue}const r=g.displayName||g.identifier.value,l=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${p}'`),c=this.k(u,g.displayName,[],new v(l));return this.c.onExtensionActivationError(g.identifier,l,new M.MissingExtensionDependency(p)),c}return this.k(u,g.displayName,E,null)}k(u,g,E,L){const p=new a(u.id,g,u.reason,E,L,this.c,this.g);return this.d.set(D.ExtensionIdentifier.toKey(u.id),p),p}l(u){return k.ExtensionDescriptionRegistry.isHostExtension(u,this.a,this.b)}m(u){const g=this.b.getExtensionDescription(u);return g?!g.main&&!g.browser:!1}};m=qe([Ve(3,y.ILogService)],m),e.ExtensionsActivator=m;let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(u,g,E,L,p,t,d){this.c=u,this.d=g,this.f=E,this.g=L,this.h=p,this.j=t,this.k=d,this.a=new R.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let u=0;u<this.g.length;u++){const g=this.g[u];if(g.value&&!g.value.activationFailed){this.g.splice(u,1),u--;continue}if(g.value&&g.value.activationFailed){const E=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);E.detail=g.value.activationFailedError,this.h=new v(E),this.j.onExtensionActivationError(this.c,E,null);return}}this.g.length>0&&await Promise.race(this.g.map(u=>u.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(u){const g=new Error;if(u&&u.name&&(g.name=u.name),u&&u.message?g.message=`Activating extension '${this.c.value}' failed: ${u.message}.`:g.message=`Activating extension '${this.c.value}' failed: ${u}.`,u&&u.stack&&(g.stack=u.stack),this.h=new v(g),this.b&&n.isCancellationError(u))return;this.j.onExtensionActivationError(this.c,g,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(u)}}};a=qe([Ve(6,y.ILogService)],a)});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(ke[7],Te([1,0,16,12,86,28,65,10,9,2,34,43,94,71,25]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m){"use strict";var a,o,u,g,E,L,p,t,d,r,l,c,b,i,s,f,P,C,j,_,K,A,$;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function O(z){return Object.assign(z,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct(z,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[ie,...Ee]=arguments;return Reflect.construct(z,Ee,ie.constructor)}}})}var F;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(F=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var H;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(H=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let V=L=class{static from(...U){let ie=U;return new L(function(){if(ie){for(const Ee of ie)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ie=void 0}})}constructor(U){a.set(this,void 0),Je(this,a,U,"f")}dispose(){typeof Le(this,a,"f")=="function"&&(Le(this,a,"f").call(this),Je(this,a,void 0,"f"))}};a=new WeakMap,V=L=qe([O],V),e.Disposable=V;let ae=p=class{static Min(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let Ee=1;Ee<U.length;Ee++){const xe=U[Ee];xe.isBefore(ie)&&(ie=xe)}return ie}static Max(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let Ee=1;Ee<U.length;Ee++){const xe=U[Ee];xe.isAfter(ie)&&(ie=xe)}return ie}static isPosition(U){if(!U)return!1;if(U instanceof p)return!0;const{line:ie,character:Ee}=U;return typeof ie=="number"&&typeof Ee=="number"}static of(U){if(U instanceof p)return U;if(this.isPosition(U))return new p(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,ie){if(U<0)throw(0,k.illegalArgument)("line must be non-negative");if(ie<0)throw(0,k.illegalArgument)("character must be non-negative");this.c=U,this.e=ie}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,ie=0){if(U===null||ie===null)throw(0,k.illegalArgument)();let Ee;return typeof U>"u"?Ee=0:typeof U=="number"?Ee=U:(Ee=typeof U.lineDelta=="number"?U.lineDelta:0,ie=typeof U.characterDelta=="number"?U.characterDelta:0),Ee===0&&ie===0?this:new p(this.line+Ee,this.character+ie)}with(U,ie=this.character){if(U===null||ie===null)throw(0,k.illegalArgument)();let Ee;return typeof U>"u"?Ee=this.line:typeof U=="number"?Ee=U:(Ee=typeof U.line=="number"?U.line:this.line,ie=typeof U.character=="number"?U.character:this.character),Ee===this.line&&ie===this.character?this:new p(Ee,ie)}toJSON(){return{line:this.line,character:this.character}}};ae=p=qe([O],ae),e.Position=ae;let pe=t=class{static isRange(U){return U instanceof t?!0:U?ae.isPosition(U.start)&&ae.isPosition(U.end):!1}static of(U){if(U instanceof t)return U;if(this.isRange(U))return new t(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,ie,Ee,xe){let _e,ot;if(typeof U=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof xe=="number"?(_e=new ae(U,ie),ot=new ae(Ee,xe)):ae.isPosition(U)&&ae.isPosition(ie)&&(_e=ae.of(U),ot=ae.of(ie)),!_e||!ot)throw new Error("Invalid arguments");_e.isBefore(ot)?(this.c=_e,this.e=ot):(this.c=ot,this.e=_e)}contains(U){return t.isRange(U)?this.contains(U.start)&&this.contains(U.end):ae.isPosition(U)?!(ae.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const ie=ae.Max(U.start,this.c),Ee=ae.Min(U.end,this.e);if(!ie.isAfter(Ee))return new t(ie,Ee)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ie=ae.Min(U.start,this.c),Ee=ae.Max(U.end,this.end);return new t(ie,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,ie=this.end){if(U===null||ie===null)throw(0,k.illegalArgument)();let Ee;return U?ae.isPosition(U)?Ee=U:(Ee=U.start||this.start,ie=U.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&ie.isEqual(this.end)?this:new t(Ee,ie)}toJSON(){return[this.start,this.end]}};pe=t=qe([O],pe),e.Range=pe;let re=d=class extends pe{static isSelection(U){return U instanceof d?!0:U?pe.isRange(U)&&ae.isPosition(U.anchor)&&ae.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,ie,Ee,xe){let _e,ot;if(typeof U=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof xe=="number"?(_e=new ae(U,ie),ot=new ae(Ee,xe)):ae.isPosition(U)&&ae.isPosition(ie)&&(_e=ae.of(U),ot=ae.of(ie)),!_e||!ot)throw new Error("Invalid arguments");super(_e,ot),this.f=_e,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};re=d=qe([O],re),e.Selection=re;class ce{constructor(U,ie,Ee){if(typeof U!="string"||U.length===0)throw(0,k.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,k.illegalArgument)("port");if(typeof Ee<"u"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z_\-]+$/.test(Ee)))throw(0,k.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(ie),this.connectionToken=Ee}}e.ResolvedAuthority=ce;class ue extends Error{static NotAvailable(U,ie){return new ue(U,h.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(U){return new ue(U,h.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,ie=h.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(U),this._message=U,this._code=ie,this._detail=Ee,Object.setPrototypeOf(this,ue.prototype)}}e.RemoteAuthorityResolverError=ue;var Se;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(Se=e.EndOfLine||(e.EndOfLine={}));var G;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(G=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let X=r=class{static isTextEdit(U){return U instanceof r?!0:U?pe.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ie){return new r(U,ie)}static insert(U,ie){return r.replace(new pe(U,U),ie)}static delete(U){return r.replace(U,"")}static setEndOfLine(U){const ie=new r(new pe(new ae(0,0),new ae(0,0)),"");return ie.newEol=U,ie}get range(){return this.c}set range(U){if(U&&!pe.isRange(U))throw(0,k.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,k.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,k.illegalArgument)("newEol");this.f=U}constructor(U,ie){this.c=U,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};X=r=qe([O],X),e.TextEdit=X;let J=l=class{static isNotebookCellEdit(U){return U instanceof l?!0:U?jt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,ie){return new l(U,ie)}static insertCells(U,ie){return new l(new jt(U,U),ie)}static deleteCells(U){return new l(U,[])}static updateCellMetadata(U,ie){const Ee=new l(new jt(U,U),[]);return Ee.newCellMetadata=ie,Ee}static updateNotebookMetadata(U){const ie=new l(new jt(0,0),[]);return ie.newNotebookMetadata=U,ie}constructor(U,ie){this.range=U,this.newCells=ie}};J=l=qe([O],J),e.NotebookEdit=J;class de{static isSnippetTextEdit(U){return U instanceof de?!0:U?pe.isRange(U.range)&&ze.isSnippetString(U.snippet):!1}static replace(U,ie){return new de(U,ie)}static insert(U,ie){return de.replace(new pe(U,U),ie)}constructor(U,ie){this.range=U,this.snippet=ie}}e.SnippetTextEdit=de;var ye;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(ye=e.FileEditType||(e.FileEditType={}));let Fe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,ie,Ee,xe){this.c.push({_type:1,from:U,to:ie,options:Ee,metadata:xe})}createFile(U,ie,Ee){this.c.push({_type:1,from:void 0,to:U,options:ie,metadata:Ee})}deleteFile(U,ie,Ee){this.c.push({_type:1,from:U,to:void 0,options:ie,metadata:Ee})}e(U,ie,Ee){this.c.push({_type:3,metadata:Ee,uri:U,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(U,ie,Ee,xe){const _e=ie.start,ot=ie.end;(_e!==ot||Ee.length>0)&&this.c.push({_type:5,uri:U,index:_e,count:ot-_e,cells:Ee,metadata:xe})}g(U,ie,Ee,xe){this.c.push({_type:3,metadata:xe,uri:U,edit:{editType:8,index:ie,metadata:Ee}})}replace(U,ie,Ee,xe){this.c.push({_type:2,uri:U,edit:new X(ie,Ee),metadata:xe})}insert(U,ie,Ee,xe){this.replace(U,new pe(ie,ie),Ee,xe)}delete(U,ie,Ee){this.replace(U,ie,"",Ee)}has(U){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===U.toString())}set(U,ie){if(ie)for(const Ee of ie){if(!Ee)continue;let xe,_e;Array.isArray(Ee)?(xe=Ee[0],_e=Ee[1]):xe=Ee,J.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(U,xe.range.start,xe.newCellMetadata,_e):xe.newNotebookMetadata?this.e(U,xe.newNotebookMetadata,_e):this.f(U,xe.range,xe.newCells,_e):de.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:U,range:xe.range,edit:xe.snippet,metadata:_e}):this.c.push({_type:2,uri:U,edit:xe,metadata:_e})}else{for(let Ee=0;Ee<this.c.length;Ee++){const xe=this.c[Ee];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===U.toString()&&(this.c[Ee]=void 0);break}}(0,n.coalesceInPlace)(this.c)}}get(U){const ie=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===U.toString()&&ie.push(Ee.edit);return ie}entries(){const U=new M.ResourceMap;for(const ie of this.c)if(ie._type===2){let Ee=U.get(ie.uri);Ee||(Ee=[ie.uri,[]],U.set(ie.uri,Ee)),Ee[1].push(ie.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Fe=qe([O],Fe),e.WorkspaceEdit=Fe;let ze=c=class{static isSnippetString(U){return U instanceof c?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=c.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ie=this.e++){if(typeof U=="function"){const Ee=new c;Ee.e=this.e,U(Ee),this.e=Ee.e,U=Ee.value}else U=c.c(U);return this.value+="${",this.value+=ie,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ie=this.e++){const Ee=U.map(xe=>xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(U,ie){if(typeof ie=="function"){const Ee=new c;Ee.e=this.e,ie(Ee),this.e=Ee.e,ie=Ee.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};ze=c=qe([O],ze),e.SnippetString=ze;var Pe;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Pe=e.DiagnosticTag||(e.DiagnosticTag={}));var Ie;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Ie=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let we=b=class{static isLocation(U){return U instanceof b?!0:U?pe.isRange(U.range)&&T.URI.isUri(U.uri):!1}constructor(U,ie){if(this.uri=U,ie)if(pe.isRange(ie))this.range=pe.of(ie);else if(ae.isPosition(ie))this.range=new pe(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};we=b=qe([O],we),e.Location=we;let se=class{static is(U){return U?typeof U.message=="string"&&U.location&&pe.isRange(U.location.range)&&T.URI.isUri(U.location.uri):!1}constructor(U,ie){this.location=U,this.message=ie}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.location.range.isEqual(ie.location.range)&&U.location.uri.toString()===ie.location.uri.toString()}};se=qe([O],se),e.DiagnosticRelatedInformation=se;let le=class{constructor(U,ie,Ee=Ie.Error){if(!pe.isRange(U))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=U,this.message=ie,this.severity=Ee}toJSON(){return{severity:Ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.severity===ie.severity&&U.code===ie.code&&U.severity===ie.severity&&U.source===ie.source&&U.range.isEqual(ie.range)&&(0,n.equals)(U.tags,ie.tags)&&(0,n.equals)(U.relatedInformation,ie.relatedInformation,se.isEqual)}};le=qe([O],le),e.Diagnostic=le;let Z=class{constructor(U,ie){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ie}};Z=qe([O],Z),e.Hover=Z;var I;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let B=class{constructor(U,ie=I.Text){this.range=U,this.kind=ie}toJSON(){return{range:this.range,kind:I[this.kind]}}};B=qe([O],B),e.DocumentHighlight=B;var W;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(W=e.SymbolKind||(e.SymbolKind={}));var q;(function(z){z[z.Deprecated=1]="Deprecated"})(q=e.SymbolTag||(e.SymbolTag={}));let ee=i=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,ie,Ee,xe,_e){this.name=U,this.kind=ie,this.containerName=_e,typeof Ee=="string"&&(this.containerName=Ee),xe instanceof we?this.location=xe:Ee instanceof pe&&(this.location=new we(xe,Ee)),i.validate(this)}toJSON(){return{name:this.name,kind:W[this.kind],location:this.location,containerName:this.containerName}}};ee=i=qe([O],ee),e.SymbolInformation=ee;let fe=s=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(s.validate)}constructor(U,ie,Ee,xe,_e){this.name=U,this.detail=ie,this.kind=Ee,this.range=xe,this.selectionRange=_e,this.children=[],s.validate(this)}};fe=s=qe([O],fe),e.DocumentSymbol=fe;var De;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(De=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let oe=class{constructor(U,ie){this.title=U,this.kind=ie}};oe=qe([O],oe),e.CodeAction=oe;let ve=f=class{constructor(U){this.value=U}append(U){return new f(this.value?this.value+f.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+f.c)}};ve.c=".",ve=f=qe([O],ve),e.CodeActionKind=ve,ve.Empty=new ve(""),ve.QuickFix=ve.Empty.append("quickfix"),ve.Refactor=ve.Empty.append("refactor"),ve.RefactorExtract=ve.Refactor.append("extract"),ve.RefactorInline=ve.Refactor.append("inline"),ve.RefactorMove=ve.Refactor.append("move"),ve.RefactorRewrite=ve.Refactor.append("rewrite"),ve.Source=ve.Empty.append("source"),ve.SourceOrganizeImports=ve.Source.append("organizeImports"),ve.SourceFixAll=ve.Source.append("fixAll");let be=class{constructor(U,ie){if(this.range=U,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};be=qe([O],be),e.SelectionRange=be;class He{constructor(U,ie,Ee,xe,_e,ot){this.kind=U,this.name=ie,this.detail=Ee,this.uri=xe,this.range=_e,this.selectionRange=ot}}e.CallHierarchyItem=He;class je{constructor(U,ie){this.fromRanges=ie,this.from=U}}e.CallHierarchyIncomingCall=je;class it{constructor(U,ie){this.fromRanges=ie,this.to=U}}e.CallHierarchyOutgoingCall=it;var Xe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,ie){this.range=U,this.command=ie}get isResolved(){return!!this.command}};et=qe([O],et),e.CodeLens=et;let nt=P=class{static isMarkdownString(U){return U instanceof P?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,ie=!1){o.set(this,void 0),Je(this,o,new D.MarkdownString(U,{supportThemeIcons:ie}),"f")}get value(){return Le(this,o,"f").value}set value(U){Le(this,o,"f").value=U}get isTrusted(){return Le(this,o,"f").isTrusted}set isTrusted(U){Le(this,o,"f").isTrusted=U}get supportThemeIcons(){return Le(this,o,"f").supportThemeIcons}set supportThemeIcons(U){Le(this,o,"f").supportThemeIcons=U}get supportHtml(){return Le(this,o,"f").supportHtml}set supportHtml(U){Le(this,o,"f").supportHtml=U}get baseUri(){return Le(this,o,"f").baseUri}set baseUri(U){Le(this,o,"f").baseUri=U}appendText(U){return Le(this,o,"f").appendText(U),this}appendMarkdown(U){return Le(this,o,"f").appendMarkdown(U),this}appendCodeblock(U,ie){return Le(this,o,"f").appendCodeblock(ie??"",U),this}};o=new WeakMap,nt=P=qe([O],nt),e.MarkdownString=nt;let Ne=class{constructor(U,ie){this.label=U,this.documentation=ie}};Ne=qe([O],Ne),e.ParameterInformation=Ne;let rt=class{constructor(U,ie){this.label=U,this.documentation=ie,this.parameters=[]}};rt=qe([O],rt),e.SignatureInformation=rt;let Q=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Q=qe([O],Q),e.SignatureHelp=Q;var Y;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Y=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ge;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(ge=e.InlayHintKind||(e.InlayHintKind={}));let We=class{constructor(U){this.value=U}};We=qe([O],We),e.InlayHintLabelPart=We;let $e=class{constructor(U,ie,Ee){this.position=U,this.label=ie,this.kind=Ee}};$e=qe([O],$e),e.InlayHint=$e;var Qe;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var tt;(function(z){z[z.Deprecated=1]="Deprecated"})(tt=e.CompletionItemTag||(e.CompletionItemTag={}));let at=class{constructor(U,ie){this.label=U,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};at=qe([O],at),e.CompletionItem=at;let Et=class{constructor(U=[],ie=!1){this.items=U,this.isIncomplete=ie}};Et=qe([O],Et),e.CompletionList=Et;let Ct=class{constructor(U,ie,Ee){this.insertText=U,this.range=ie,this.command=Ee}};Ct=qe([O],Ct),e.InlineSuggestion=Ct;let It=class{constructor(U){this.commands=void 0,this.items=U}};It=qe([O],It),e.InlineSuggestionList=It;var Dt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Dt=e.ViewColumn||(e.ViewColumn={}));var ut;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ut=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Kt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Kt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Vt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Vt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var kt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(kt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ht;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(ht=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Tt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Tt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function U(ie){switch(ie){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(kt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let $t=class{constructor(U,ie){if(ie&&!T.URI.isUri(ie))throw(0,k.illegalArgument)("target");if(!pe.isRange(U)||U.isEmpty)throw(0,k.illegalArgument)("range");this.range=U,this.target=ie}};$t=qe([O],$t),e.DocumentLink=$t;let At=class{constructor(U,ie,Ee,xe){this.red=U,this.green=ie,this.blue=Ee,this.alpha=xe}};At=qe([O],At),e.Color=At;let Ge=class{constructor(U,ie){if(ie&&!(ie instanceof At))throw(0,k.illegalArgument)("color");if(!pe.isRange(U)||U.isEmpty)throw(0,k.illegalArgument)("range");this.range=U,this.color=ie}};Ge=qe([O],Ge),e.ColorInformation=Ge;let Ft=class{constructor(U){if(!U||typeof U!="string")throw(0,k.illegalArgument)("label");this.label=U}};Ft=qe([O],Ft),e.ColorPresentation=Ft;var xt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(xt=e.ColorFormat||(e.ColorFormat={}));var Nt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Nt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var mt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(mt=e.TerminalExitReason||(e.TerminalExitReason={}));class Ce{constructor(U,ie,Ee){if(this.startIndex=U,this.length=ie,this.tooltip=Ee,typeof U!="number"||U<0)throw(0,k.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,k.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,k.illegalArgument)("tooltip")}}e.TerminalLink=Ce;class Ae{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Ae;class me{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=me;var x;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(x=e.TerminalLocation||(e.TerminalLocation={}));class Re{constructor(U){if(this.options=U,typeof U!="object")throw(0,k.illegalArgument)("options")}}e.TerminalProfile=Re;var Ue;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Ue=e.TaskRevealKind||(e.TaskRevealKind={}));var Ye;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Ye=e.TaskPanelKind||(e.TaskPanelKind={}));let Be=C=class{static from(U){switch(U){case"clean":return C.Clean;case"build":return C.Build;case"rebuild":return C.Rebuild;case"test":return C.Test;default:return}}constructor(U,ie){if(this.label=ie,typeof U!="string"||typeof ie!="string")throw(0,k.illegalArgument)("name");this.c=U}get id(){return this.c}};Be.Clean=new C("clean","Clean"),Be.Build=new C("build","Build"),Be.Rebuild=new C("rebuild","Rebuild"),Be.Test=new C("test","Test"),Be=C=qe([O],Be),e.TaskGroup=Be;function Ze(z){let U="";for(let ie=0;ie<z.length;ie++)U+=z[ie].replace(/,/g,",,")+",";return U}let ct=class{constructor(U,ie,Ee){if(typeof U!="string")throw(0,k.illegalArgument)("process");this.e=[],this.c=U,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=Ee):this.f=ie)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,k.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)U.push(ie);return Ze(U)}};ct=qe([O],ct),e.ProcessExecution=ct;let Pt=class{constructor(U,ie,Ee){if(this.f=[],Array.isArray(ie)){if(!U)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,k.illegalArgument)("command");this.e=U,this.f=ie,this.g=Ee}else{if(typeof U!="string")throw(0,k.illegalArgument)("commandLine");this.c=U,this.g=ie}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,k.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,k.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)U.push(typeof ie=="string"?ie:ie.value);return Ze(U)}};Pt=qe([O],Pt),e.ShellExecution=Pt;var vt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(vt=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class pt{constructor(U){this.c=U}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=pt;let Rt=j=class{constructor(U,ie,Ee,xe,_e,ot){this.j=!1,this.k=this.definition=U;let dt;typeof ie=="string"?(this.m=this.name=ie,this.t=this.source=Ee,this.execution=xe,dt=_e,this.j=!0):ie===wt.Global||ie===wt.Workspace?(this.target=ie,this.m=this.name=Ee,this.t=this.source=xe,this.execution=_e,dt=ot):(this.target=ie,this.m=this.name=Ee,this.t=this.source=xe,this.execution=_e,dt=ot),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ct?this.k={type:j.e,id:this.n.computeId()}:this.n instanceof Pt?this.k={type:j.f,id:this.n.computeId()}:this.n instanceof pt?this.k={type:j.c,id:this.n.computeId()}:this.k={type:j.g,id:(0,N.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,k.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const ie=this.k.type;(j.g===ie||j.e===ie||j.f===ie||j.c===ie)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};Rt.c="customExecution",Rt.e="process",Rt.f="shell",Rt.g="$empty",Rt=j=qe([O],Rt),e.Task=Rt;var bt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(bt=e.ProgressLocation||(e.ProgressLocation={}));var ri;(function(z){function U(ie){const Ee=ie;return(0,S.isNumber)(Ee.value)?Ee.tooltip&&!(0,S.isString)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}z.isViewBadge=U})(ri=e.ViewBadge||(e.ViewBadge={}));let ei=_=class{static isTreeItem(U,ie){const Ee=U;if(Ee.checkboxState!==void 0){(0,m.checkProposedApiEnabled)(ie,"treeItemCheckbox");const xe=(0,S.isNumber)(Ee.checkboxState)?Ee.checkboxState:(0,S.isObject)(Ee.checkboxState)&&(0,S.isNumber)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,_e=!(0,S.isNumber)(Ee.checkboxState)&&(0,S.isObject)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(xe===void 0||xe!==si.Checked&&xe!==si.Unchecked||_e!==void 0&&!(0,S.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(U instanceof _)return!0;if(Ee.label!==void 0&&!(0,S.isString)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,S.isString)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,S.isString)(Ee.iconPath)&&!T.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,S.isString)(Ee.iconPath.id))){const xe=Ee.iconPath;if(!xe||!(0,S.isString)(xe.light)&&!T.URI.isUri(xe.light)&&!(0,S.isString)(xe.dark)&&!T.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,S.isString)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!T.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,S.isString)(Ee.tooltip)&&!(Ee.tooltip instanceof nt)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<St.None&&Ee.collapsibleState>St.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,S.isString)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(U,ie=St.None){this.collapsibleState=ie,T.URI.isUri(U)?this.resourceUri=U:this.label=U}};ei=_=qe([O],ei),e.TreeItem=ei;var St;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(St=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,ie){this.value=U,this.id=ie??(0,N.generateUuid)()}};oi=qe([O],oi),e.DataTransferItem=oi;let _t=class{constructor(U){u.set(this,new Map);for(const[ie,Ee]of U??[]){const xe=Le(this,u,"f").get(ie);xe?xe.push(Ee):Le(this,u,"f").set(ie,[Ee])}}get(U){return Le(this,u,"f").get(U)?.[0]}set(U,ie){Le(this,u,"f").set(U,[ie])}forEach(U,ie){for(const[Ee,xe]of Le(this,u,"f"))for(const _e of xe)U.call(ie,_e,Ee,this)}*[(u=new WeakMap,Symbol.iterator)](){for(const[U,ie]of Le(this,u,"f"))for(const Ee of ie)yield[U,Ee]}};_t=qe([O],_t),e.DataTransfer=_t;let vi=class{constructor(U){this.insertText=U}};vi=qe([O],vi),e.DocumentDropEdit=vi;let Ot=class{constructor(U){this.insertText=U}};Ot=qe([O],Ot),e.DocumentPasteEdit=Ot;let zt=class{constructor(U,ie){this.id=U,this.color=ie}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};zt=qe([O],zt),e.ThemeIcon=zt,zt.File=new zt("file"),zt.Folder=new zt("folder");let bi=class{constructor(U){this.id=U}};bi=qe([O],bi),e.ThemeColor=bi;var ai;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Jt=class{get base(){return this.c}set base(U){this.c=U,this.e=T.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,ie){if(typeof U!="string"&&(!U||!T.URI.isUri(U)&&!T.URI.isUri(U.uri)))throw(0,k.illegalArgument)("base");if(typeof ie!="string")throw(0,k.illegalArgument)("pattern");typeof U=="string"?this.baseUri=T.URI.file(U):T.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Jt=qe([O],Jt),e.RelativePattern=Jt;const lt=new WeakMap;function $i(z,U){lt.set(z,U)}e.setBreakpointId=$i;let Ut=class{constructor(U,ie,Ee,xe){this.enabled=typeof U=="boolean"?U:!0,typeof ie=="string"&&(this.condition=ie),typeof Ee=="string"&&(this.hitCondition=Ee),typeof xe=="string"&&(this.logMessage=xe)}get id(){return this.c||(this.c=lt.get(this)??(0,N.generateUuid)()),this.c}};Ut=qe([O],Ut),e.Breakpoint=Ut;let Xt=class extends Ut{constructor(U,ie,Ee,xe,_e){if(super(ie,Ee,xe,_e),U===null)throw(0,k.illegalArgument)("location");this.location=U}};Xt=qe([O],Xt),e.SourceBreakpoint=Xt;let ci=class extends Ut{constructor(U,ie,Ee,xe,_e){super(ie,Ee,xe,_e),this.functionName=U}};ci=qe([O],ci),e.FunctionBreakpoint=ci;let Ei=class extends Ut{constructor(U,ie,Ee,xe,_e,ot,dt){if(super(xe,_e,ot,dt),!ie)throw(0,k.illegalArgument)("dataId");this.label=U,this.dataId=ie,this.canPersist=Ee}};Ei=qe([O],Ei),e.DataBreakpoint=Ei;let wi=class{constructor(U,ie,Ee){this.command=U,this.args=ie||[],this.options=Ee}};wi=qe([O],wi),e.DebugAdapterExecutable=wi;let ui=class{constructor(U,ie){this.port=U,this.host=ie}};ui=qe([O],ui),e.DebugAdapterServer=ui;let Si=class{constructor(U){this.path=U}};Si=qe([O],Si),e.DebugAdapterNamedPipeServer=Si;let li=class{constructor(U){this.implementation=U}};li=qe([O],li),e.DebugAdapterInlineImplementation=li;let Zt=class{constructor(U,ie){this.range=U,this.expression=ie}};Zt=qe([O],Zt),e.EvaluatableExpression=Zt;var Bi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ti=class{constructor(U,ie){this.range=U,this.text=ie}};ti=qe([O],ti),e.InlineValueText=ti;let ii=class{constructor(U,ie,Ee=!0){this.range=U,this.variableName=ie,this.caseSensitiveLookup=Ee}};ii=qe([O],ii),e.InlineValueVariableLookup=ii;let yi=class{constructor(U,ie){this.range=U,this.expression=ie}};yi=qe([O],yi),e.InlineValueEvaluatableExpression=yi;let Di=class{constructor(U,ie){this.frameId=U,this.stoppedLocation=ie}};Di=qe([O],Di),e.InlineValueContext=Di;var ni;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(ni=e.FileChangeType||(e.FileChangeType={}));let Ii=K=class extends Error{static FileExists(U){return new K(U,w.FileSystemProviderErrorCode.FileExists,K.FileExists)}static FileNotFound(U){return new K(U,w.FileSystemProviderErrorCode.FileNotFound,K.FileNotFound)}static FileNotADirectory(U){return new K(U,w.FileSystemProviderErrorCode.FileNotADirectory,K.FileNotADirectory)}static FileIsADirectory(U){return new K(U,w.FileSystemProviderErrorCode.FileIsADirectory,K.FileIsADirectory)}static NoPermissions(U){return new K(U,w.FileSystemProviderErrorCode.NoPermissions,K.NoPermissions)}static Unavailable(U){return new K(U,w.FileSystemProviderErrorCode.Unavailable,K.Unavailable)}constructor(U,ie=w.FileSystemProviderErrorCode.Unknown,Ee){super(T.URI.isUri(U)?U.toString(!0):U),this.code=Ee?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,ie),Object.setPrototypeOf(this,K.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};Ii=K=qe([O],Ii),e.FileSystemError=Ii;let Ci=class{constructor(U,ie,Ee){this.start=U,this.end=ie,this.kind=Ee}};Ci=qe([O],Ci),e.FoldingRange=Ci;var zi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(U,ie=[]){this.tokenTypes=U,this.tokenModifiers=ie}}e.SemanticTokensLegend=Ri;function Oi(z){return typeof z>"u"||(0,S.isStringArray)(z)}class Me{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let ie=0,Ee=U.tokenTypes.length;ie<Ee;ie++)this.j.set(U.tokenTypes[ie],ie);for(let ie=0,Ee=U.tokenModifiers.length;ie<Ee;ie++)this.k.set(U.tokenModifiers[ie],ie)}}push(U,ie,Ee,xe,_e){if(typeof U=="number"&&typeof ie=="number"&&typeof Ee=="number"&&typeof xe=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(U,ie,Ee,xe,_e);if(pe.isRange(U)&&typeof ie=="string"&&Oi(Ee))return this.m(U,ie,Ee);throw(0,k.illegalArgument)()}m(U,ie,Ee){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ie))throw new Error("`tokenType` is not in the provided legend");const xe=U.start.line,_e=U.start.character,ot=U.end.character-U.start.character,dt=this.j.get(ie);let Mt=0;if(Ee)for(const Ht of Ee){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Ht);Mt|=1<<qt>>>0}this.n(xe,_e,ot,dt,Mt)}n(U,ie,Ee,xe,_e){if(this.f&&(U<this.c||U===this.c&&ie<this.e)){this.f=!1;const Mt=this.g.length/5|0;let Ht=0,qt=0;for(let Gt=0;Gt<Mt;Gt++){let Qt=this.g[5*Gt],Pi=this.g[5*Gt+1];Qt===0?(Qt=Ht,Pi+=qt):Qt+=Ht,this.g[5*Gt]=Qt,this.g[5*Gt+1]=Pi,Ht=Qt,qt=Pi}}let ot=U,dt=ie;this.f&&this.h>0&&(ot-=this.c,ot===0&&(dt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=dt,this.g[this.h++]=Ee,this.g[this.h++]=xe,this.g[this.h++]=_e,this.c=U,this.e=ie}static o(U){const ie=[],Ee=U.length/5|0;for(let dt=0;dt<Ee;dt++)ie[dt]=dt;ie.sort((dt,Mt)=>{const Ht=U[5*dt],qt=U[5*Mt];if(Ht===qt){const Gt=U[5*dt+1],Qt=U[5*Mt+1];return Gt-Qt}return Ht-qt});const xe=new Uint32Array(U.length);let _e=0,ot=0;for(let dt=0;dt<Ee;dt++){const Mt=5*ie[dt],Ht=U[Mt+0],qt=U[Mt+1],Gt=U[Mt+2],Qt=U[Mt+3],Pi=U[Mt+4],sn=Ht-_e,Rn=sn===0?qt-ot:qt,Ai=5*dt;xe[Ai+0]=sn,xe[Ai+1]=Rn,xe[Ai+2]=Gt,xe[Ai+3]=Qt,xe[Ai+4]=Pi,_e=Ht,ot=qt}return xe}build(U){return this.f?new Wt(new Uint32Array(this.g),U):new Wt(Me.o(this.g),U)}}e.SemanticTokensBuilder=Me;class Wt{constructor(U,ie){this.resultId=ie,this.data=U}}e.SemanticTokens=Wt;class Li{constructor(U,ie,Ee){this.start=U,this.deleteCount=ie,this.data=Ee}}e.SemanticTokensEdit=Li;class gt{constructor(U,ie){this.resultId=ie,this.edits=U}}e.SemanticTokensEdits=gt;var Vi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Vi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new zt("arrow-left")},di=qe([O],di),e.QuickInputButtons=di;var Fi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Fi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ji;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(ji=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(U){if(typeof U.badge=="string"){let ie=(0,R.nextCharLength)(U.badge,0);if(ie<U.badge.length&&(ie+=(0,R.nextCharLength)(U.badge,ie)),U.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!zt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,ie,Ee){this.badge=U,this.tooltip=ie,this.color=Ee}}e.FileDecoration=qi;let Ti=class{constructor(U){this.kind=U}};Ti=qe([O],Ti),e.ColorTheme=Ti;var Ki;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ki=e.ColorThemeKind||(e.ColorThemeKind={}));class jt{static isNotebookRange(U){return U instanceof jt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,ie){if(U<0)throw(0,k.illegalArgument)("start must be positive");if(ie<0)throw(0,k.illegalArgument)("end must be positive");U<=ie?(this.c=U,this.e=ie):(this.c=ie,this.e=U)}with(U){let ie=this.c,Ee=this.e;return U.start!==void 0&&(ie=U.start),U.end!==void 0&&(Ee=U.end),ie===this.c&&Ee===this.e?this:new jt(ie,Ee)}}e.NotebookRange=jt;class fi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ie=>fi.isNotebookCellData(ie))}static isNotebookCellData(U){return!0}constructor(U,ie,Ee,xe,_e,ot,dt){this.kind=U,this.value=ie,this.languageId=Ee,this.mime=xe,this.outputs=_e??[],this.metadata=ot,this.executionSummary=dt,fi.validate(this)}}e.NotebookCellData=fi;class xi{constructor(U){this.cells=U}}e.NotebookData=xi;class Bt{static isNotebookCellOutputItem(U){return U instanceof Bt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ie={name:U.name,message:U.message,stack:U.stack};return Bt.json(ie,"application/vnd.code.notebook.error")}static stdout(U){return Bt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Bt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ie="application/octet-stream"){return new Bt(U,ie)}static text(U,ie=y.Mimes.text){const Ee=Le(Bt,g,"f",E).encode(String(U));return new Bt(Ee,ie)}static json(U,ie="text/x-json"){const Ee=JSON.stringify(U,void 0,"	");return Bt.text(Ee,ie)}constructor(U,ie){this.data=U,this.mime=ie;const Ee=(0,y.normalizeMimeType)(ie,!0);if(!Ee)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}g=Bt,E={value:new TextEncoder},e.NotebookCellOutputItem=Bt;class mi{static isNotebookCellOutput(U){return U instanceof mi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,ie=!1){const Ee=new Set,xe=new Set;for(let _e=0;_e<U.length;_e++){const ot=U[_e],dt=(0,y.normalizeMimeType)(ot.mime);if(!Ee.has(dt)||(0,v.isTextStreamMime)(dt)){Ee.add(dt);continue}xe.add(_e),ie&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return xe.size===0?U:U.filter((_e,ot)=>!xe.has(ot))}constructor(U,ie,Ee){this.items=mi.ensureUniqueMimeTypes(U,!0),typeof ie=="string"?(this.id=ie,this.metadata=Ee):(this.id=(0,N.generateUuid)(),this.metadata=ie??Ee)}}e.NotebookCellOutput=mi;var Gi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Gi=e.NotebookCellKind||(e.NotebookCellKind={}));var Xi;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ne;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ne=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var he;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(he=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Oe{constructor(U,ie){this.text=U,this.alignment=ie}}e.NotebookCellStatusBarItem=Oe;var st;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(st=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var yt;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(yt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Lt{constructor(U,ie=[]){this.uri=U,this.provides=(0,n.asArray)(ie)}}e.NotebookRendererScript=Lt;class un{constructor(U){this.label=U}}e.NotebookKernelSourceAction=un;let Qi=class{constructor(U,ie){this.label=U,this.timestamp=ie}};Qi=qe([O],Qi),e.TimelineItem=Qi;var ln;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(ln=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(U,ie){this.ranges=U,this.wordPattern=ie}}e.LinkedEditingRanges=fn;class mn{constructor(U,ie){this.c=U,this.e=ie}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ni=class{constructor(U=void 0,ie=void 0,Ee=void 0){this.include=U,this.exclude=ie,this.profile=Ee}};Ni=qe([O],Ni),e.TestRunRequest=Ni;let Yi=class extends Ni{constructor(U=void 0,ie=void 0,Ee=void 0,xe=!1){super(U,ie,Ee),this.continuous=xe}};Yi=qe([O],Yi),e.TestRunRequest2=Yi;let _i=A=class{static diff(U,ie,Ee){const xe=new A(U);return xe.expectedOutput=ie,xe.actualOutput=Ee,xe}constructor(U){this.message=U}};_i=A=qe([O],_i),e.TestMessage=_i;let Ji=class{constructor(U){this.id=U}};Ji=qe([O],Ji),e.TestTag=Ji;let gi=class{constructor(U,ie){this.covered=U,this.total=ie}};gi=qe([O],gi),e.CoveredCount=gi;let Zi=$=class{static fromDetails(U,ie){const Ee=new gi(0,0),xe=new gi(0,0),_e=new gi(0,0);for(const dt of ie)if("branches"in dt){Ee.total+=1,Ee.covered+=dt.executionCount>0?1:0;for(const Mt of dt.branches)xe.total+=1,xe.covered+=Mt.executionCount>0?1:0}else _e.total+=1,_e.covered+=dt.executionCount>0?1:0;const ot=new $(U,Ee,xe.total>0?xe:void 0,_e.total>0?_e:void 0);return ot.detailedCoverage=ie,ot}constructor(U,ie,Ee,xe){this.uri=U,this.statementCoverage=ie,this.branchCoverage=Ee,this.functionCoverage=xe}};Zi=$=qe([O],Zi),e.FileCoverage=Zi;let en=class{constructor(U,ie,Ee=[]){this.executionCount=U,this.location=ie,this.branches=Ee}};en=qe([O],en),e.StatementCoverage=en;let tn=class{constructor(U,ie){this.executionCount=U,this.location=ie}};tn=qe([O],tn),e.BranchCoverage=tn;let nn=class{constructor(U,ie){this.executionCount=U,this.location=ie}};nn=qe([O],nn),e.FunctionCoverage=nn;var vn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var En;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(En=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class wn{constructor(U,ie,Ee,xe,_e,ot){this.kind=U,this.name=ie,this.detail=Ee,this.uri=xe,this.range=_e,this.selectionRange=ot}}e.TypeHierarchyItem=wn;class Sn{constructor(U){this.uri=U}}e.TextTabInput=Sn;class yn{constructor(U,ie){this.original=U,this.modified=ie}}e.TextDiffTabInput=yn;class Dn{constructor(U,ie,Ee,xe){this.base=U,this.input1=ie,this.input2=Ee,this.result=xe}}e.TextMergeTabInput=Dn;class In{constructor(U,ie){this.uri=U,this.viewType=ie}}e.CustomEditorTabInput=In;class Cn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=Cn;class kn{constructor(U,ie){this.uri=U,this.notebookType=ie}}e.NotebookEditorTabInput=kn;class Tn{constructor(U,ie,Ee){this.original=U,this.modified=ie,this.notebookType=Ee}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(U,ie){this.uri=U,this.inputBoxUri=ie}}e.InteractiveWindowInput=An}),define(ke[99],Te([1,0,49,15,10,258,131,7,16]),function(te,e,n,k,D,M,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const T=new Map;function N(m,a){a?T.set(m,a):T.delete(m)}e.setWordDefinitionFor=N;function w(m){return T.get(m)}class h extends M.MirrorTextModel{constructor(a,o,u,g,E,L,p,t){super(o,u,g,E),this.m=a,this.p=L,this.q=p,this.notebook=t,this.b=!1}dispose(){(0,n.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,S.equals)(this.d,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.c},get fileName(){return a.c.fsPath},get isUntitled(){return a.c.scheme===k.Schemas.untitled},get languageId(){return a.p},get version(){return a.g},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(o){return o?a.s(o):a.getText()},get eol(){return a.f===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return a.d.length},lineAt(o){return a.t(o)},offsetAt(o){return a.u(o)},positionAt(o){return a.v(o)},validateRange(o){return a.w(o)},validatePosition(o){return a.x(o)},getWordRangeAtPosition(o,u){return a.y(o,u)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,n.ok)(!this.b),this.p=a}_acceptIsDirty(a){(0,n.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(a){const o=this.w(a);if(o.isEmpty)return"";if(o.isSingleLine)return this.d[o.start.line].substring(o.start.character,o.end.character);const u=this.f,g=o.start.line,E=o.end.line,L=[];L.push(this.d[g].substring(o.start.character));for(let p=g+1;p<E;p++)L.push(this.d[p]);return L.push(this.d[E].substring(0,o.end.character)),L.join(u)}t(a){let o;if(a instanceof R.Position?o=a.line:typeof a=="number"&&(o=a),typeof o!="number"||o<0||o>=this.d.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new v(o,this.d[o],o===this.d.length-1)}u(a){return a=this.x(a),this.k(),this.h.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.k();const o=this.h.getIndexOf(a),u=this.d[o.index].length;return new R.Position(o.index,Math.min(o.remainder,u))}w(a){if(!(a instanceof R.Range))throw new Error("Invalid argument");const o=this.x(a.start),u=this.x(a.end);return o===a.start&&u===a.end?a:new R.Range(o.line,o.character,u.line,u.character)}x(a){if(!(a instanceof R.Position))throw new Error("Invalid argument");if(this.d.length===0)return a.with(0,0);let{line:o,character:u}=a,g=!1;if(o<0)o=0,u=0,g=!0;else if(o>=this.d.length)o=this.d.length-1,u=this.d[o].length,g=!0;else{const E=this.d[o].length;u<0?(u=0,g=!0):u>E&&(u=E,g=!0)}return g?new R.Position(o,u):a}y(a,o){const u=this.x(a);if(!o)o=w(this.p);else if((0,D.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const g=(0,y.getWordAtText)(u.character+1,(0,y.ensureValidWordDefinition)(o),this.d[u.line],0);if(g)return new R.Range(u.line,g.startColumn-1,u.line,g.endColumn-1)}}e.ExtHostDocumentData=h;class v{constructor(a,o,u){this.a=a,this.b=o,this.c=u}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=v}),define(ke[193],Te([1,0,7,18,4]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(R){this.a=new n.ColorTheme(n.ColorThemeKind.Dark),this.b=new D.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(R){let S;switch(R){case"light":S=n.ColorThemeKind.Light;break;case"hcDark":S=n.ColorThemeKind.HighContrast;break;case"hcLight":S=n.ColorThemeKind.HighContrastLight;break;default:S=n.ColorThemeKind.Dark}this.a=new n.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};M=qe([Ve(0,k.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(ke[8],Te([1,0,16,23,116,194,86,28,112,66,65,22,9,2,44,75,91,96,95,71,45,56,190,7]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o,u,g,E,L,p,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Ce){function Ae(x){const{selectionStartLineNumber:Re,selectionStartColumn:Ue,positionLineNumber:Ye,positionColumn:Be}=x,Ze=new d.Position(Re-1,Ue-1),ct=new d.Position(Ye-1,Be-1);return new d.Selection(Ze,ct)}Ce.to=Ae;function me(x){const{anchor:Re,active:Ue}=x;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Ce.from=me})(r=e.Selection||(e.Selection={}));var l;(function(Ce){function Ae(x){if(!x)return;const{start:Re,end:Ue}=x;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Ce.from=Ae;function me(x){if(!x)return;const{startLineNumber:Re,startColumn:Ue,endLineNumber:Ye,endColumn:Be}=x;return new d.Range(Re-1,Ue-1,Ye-1,Be-1)}Ce.to=me})(l=e.Range||(e.Range={}));var c;(function(Ce){function Ae(me){switch(me){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}Ce.to=Ae})(c=e.TokenType||(e.TokenType={}));var b;(function(Ce){function Ae(x){return new d.Position(x.lineNumber-1,x.column-1)}Ce.to=Ae;function me(x){return{lineNumber:x.line+1,column:x.character+1}}Ce.from=me})(b=e.Position||(e.Position={}));var i;(function(Ce){function Ae(Re,Ue){return(0,n.coalesce)((0,n.asArray)(Re).map(Ye=>me(Ye,Ue)))}Ce.from=Ae;function me(Re,Ue){if(typeof Re=="string")return{$serialized:!0,language:Re};if(Re)return{$serialized:!0,language:Re.language,scheme:x(Re.scheme,Ue),pattern:ge.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType}}function x(Re,Ue){return Ue&&typeof Re=="string"?Ue.transformOutgoingScheme(Re):Re}})(i=e.DocumentSelector||(e.DocumentSelector={}));var s;(function(Ce){function Ae(x){switch(x){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}Ce.from=Ae;function me(x){switch(x){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}Ce.to=me})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(Ce){function Ae(x){let Re;return x.code&&((0,h.isString)(x.code)||(0,h.isNumber)(x.code)?Re=String(x.code):Re={value:String(x.code.value),target:x.code.target}),{...l.from(x.range),message:x.message,source:x.source,code:Re,severity:C.from(x.severity),relatedInformation:x.relatedInformation&&x.relatedInformation.map(P.from),tags:Array.isArray(x.tags)?(0,n.coalesce)(x.tags.map(s.from)):void 0}}Ce.from=Ae;function me(x){const Re=new d.Diagnostic(l.to(x),x.message,C.to(x.severity));return Re.source=x.source,Re.code=(0,h.isString)(x.code)?x.code:x.code?.value,Re.relatedInformation=x.relatedInformation&&x.relatedInformation.map(P.to),Re.tags=x.tags&&(0,n.coalesce)(x.tags.map(s.to)),Re}Ce.to=me})(f=e.Diagnostic||(e.Diagnostic={}));var P;(function(Ce){function Ae(x){return{...l.from(x.location.range),message:x.message,resource:x.location.uri}}Ce.from=Ae;function me(x){return new d.DiagnosticRelatedInformation(new d.Location(x.resource,l.to(x)),x.message)}Ce.to=me})(P=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var C;(function(Ce){function Ae(x){switch(x){case d.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Ce.from=Ae;function me(x){switch(x){case o.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}Ce.to=me})(C=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var j;(function(Ce){function Ae(x){return typeof x=="number"&&x>=d.ViewColumn.One?x-1:x===d.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Ce.from=Ae;function me(x){if(typeof x=="number"&&x>=0)return x+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=me})(j=e.ViewColumn||(e.ViewColumn={}));function _(Ce){return typeof Ce.range<"u"}function K(Ce){return Ce.length===0?!0:!!_(Ce[0])}e.isDecorationOptionsArr=K;var A;(function(Ce){function Ae(Be){return Be.map(Ce.from)}Ce.fromMany=Ae;function me(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function x(Be){let Ze;if(me(Be)){const{language:wt,value:pt}=Be;Ze={value:"```"+wt+`
`+pt+"\n```\n"}}else d.MarkdownString.isMarkdownString(Be)?Ze={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?Ze={value:Be}:Ze={value:""};const ct=Object.create(null);Ze.uris=ct;const Pt=wt=>{try{let pt=v.URI.parse(wt,!0);pt=pt.with({query:Re(pt.query,ct)}),ct[wt]=pt}catch{}return""},vt=new S.marked.Renderer;return vt.link=Pt,vt.image=wt=>typeof wt=="string"?Pt(y.parseHrefAndDimensions(wt).href):"",(0,S.marked)(Ze.value,{renderer:vt}),Ze}Ce.from=x;function Re(Be,Ze){if(!Be)return Be;let ct;try{ct=(0,T.parse)(Be)}catch{}if(!ct)return Be;let Pt=!1;return ct=(0,w.cloneAndChange)(ct,vt=>{if(v.URI.isUri(vt)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[wt]=vt,Pt=!0,wt}else return}),Pt?JSON.stringify(ct):Be}function Ue(Be){const Ze=new d.MarkdownString(Be.value,Be.supportThemeIcons);return Ze.isTrusted=Be.isTrusted,Ze.supportHtml=Be.supportHtml,Ze.baseUri=Be.baseUri?v.URI.from(Be.baseUri):void 0,Ze}Ce.to=Ue;function Ye(Be){if(!!Be)return typeof Be=="string"?Be:Ce.from(Be)}Ce.fromStrict=Ye})(A=e.MarkdownString||(e.MarkdownString={}));function $(Ce){return K(Ce)?Ce.map(Ae=>({range:l.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?A.fromMany(Ae.hoverMessage):Ae.hoverMessage?A.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):Ce.map(Ae=>({range:l.from(Ae)}))}e.fromRangeOrRangeWithMessage=$;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?v.URI.file(Ce):Ce}e.pathOrURIToURI=O;var F;(function(Ce){function Ae(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?O(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Ce.from=Ae})(F=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var H;(function(Ce){function Ae(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?F.from(me.before):void 0,after:me.after?F.from(me.after):void 0}}Ce.from=Ae})(H=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(Ce){function Ae(me){if(typeof me>"u")return me;switch(me){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Ae})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var ae;(function(Ce){function Ae(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?V.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?H.from(me.light):void 0,dark:me.dark?H.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?F.from(me.before):void 0,after:me.after?F.from(me.after):void 0}}Ce.from=Ae})(ae=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var pe;(function(Ce){function Ae(x){return{text:x.newText,eol:x.newEol&&nt.from(x.newEol),range:l.from(x.range)}}Ce.from=Ae;function me(x){const Re=new d.TextEdit(l.to(x.range),x.text);return Re.newEol=typeof x.eol>"u"?void 0:nt.to(x.eol),Re}Ce.to=me})(pe=e.TextEdit||(e.TextEdit={}));var re;(function(Ce){function Ae(x,Re){const Ue={edits:[]};if(x instanceof d.WorkspaceEdit){const Ye=new R.ResourceSet;for(const Be of x._allEntries())Be._type===1&&v.URI.isUri(Be.to)&&Be.from===void 0&&Ye.add(Be.to);for(const Be of x._allEntries())Be._type===1?Ue.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contentsBase64:Be.options?.contents&&(0,k.encodeBase64)(k.VSBuffer.wrap(Be.options.contents))},metadata:Be.metadata}):Be._type===2?Ue.edits.push({resource:Be.uri,textEdit:pe.from(Be.edit),versionId:Ye.has(Be.uri)?void 0:Re?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?Ue.edits.push({resource:Be.uri,textEdit:{range:l.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:Ye.has(Be.uri)?void 0:Re?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?Ue.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&Ue.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(Et.from)}})}return Ue}Ce.from=Ae;function me(x){const Re=new d.WorkspaceEdit;for(const Ue of x.edits)Ue.textEdit?Re.replace(v.URI.revive(Ue.resource),l.to(Ue.textEdit.range),Ue.textEdit.text):Re.renameFile(v.URI.revive(Ue.oldResource),v.URI.revive(Ue.newResource),Ue.options);return Re}Ce.to=me})(re=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ce;(function(Ce){const Ae=Object.create(null);Ae[d.SymbolKind.File]=0,Ae[d.SymbolKind.Module]=1,Ae[d.SymbolKind.Namespace]=2,Ae[d.SymbolKind.Package]=3,Ae[d.SymbolKind.Class]=4,Ae[d.SymbolKind.Method]=5,Ae[d.SymbolKind.Property]=6,Ae[d.SymbolKind.Field]=7,Ae[d.SymbolKind.Constructor]=8,Ae[d.SymbolKind.Enum]=9,Ae[d.SymbolKind.Interface]=10,Ae[d.SymbolKind.Function]=11,Ae[d.SymbolKind.Variable]=12,Ae[d.SymbolKind.Constant]=13,Ae[d.SymbolKind.String]=14,Ae[d.SymbolKind.Number]=15,Ae[d.SymbolKind.Boolean]=16,Ae[d.SymbolKind.Array]=17,Ae[d.SymbolKind.Object]=18,Ae[d.SymbolKind.Key]=19,Ae[d.SymbolKind.Null]=20,Ae[d.SymbolKind.EnumMember]=21,Ae[d.SymbolKind.Struct]=22,Ae[d.SymbolKind.Event]=23,Ae[d.SymbolKind.Operator]=24,Ae[d.SymbolKind.TypeParameter]=25;function me(Re){return typeof Ae[Re]=="number"?Ae[Re]:6}Ce.from=me;function x(Re){for(const Ue in Ae)if(Ae[Ue]===Re)return Number(Ue);return d.SymbolKind.Property}Ce.to=x})(ce=e.SymbolKind||(e.SymbolKind={}));var ue;(function(Ce){function Ae(x){switch(x){case d.SymbolTag.Deprecated:return 1}}Ce.from=Ae;function me(x){switch(x){case 1:return d.SymbolTag.Deprecated}}Ce.to=me})(ue=e.SymbolTag||(e.SymbolTag={}));var Se;(function(Ce){function Ae(x){return{name:x.name,kind:ce.from(x.kind),tags:x.tags&&x.tags.map(ue.from),containerName:x.containerName,location:ye.from(x.location)}}Ce.from=Ae;function me(x){const Re=new d.SymbolInformation(x.name,ce.to(x.kind),x.containerName,ye.to(x.location));return Re.tags=x.tags&&x.tags.map(ue.to),Re}Ce.to=me})(Se=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var G;(function(Ce){function Ae(x){const Re={name:x.name||"!!MISSING: name!!",detail:x.detail,range:l.from(x.range),selectionRange:l.from(x.selectionRange),kind:ce.from(x.kind),tags:x.tags?.map(ue.from)??[]};return x.children&&(Re.children=x.children.map(Ae)),Re}Ce.from=Ae;function me(x){const Re=new d.DocumentSymbol(x.name,x.detail,ce.to(x.kind),l.to(x.range),l.to(x.selectionRange));return(0,n.isNonEmptyArray)(x.tags)&&(Re.tags=x.tags.map(ue.to)),x.children&&(Re.children=x.children.map(me)),Re}Ce.to=me})(G=e.DocumentSymbol||(e.DocumentSymbol={}));var X;(function(Ce){function Ae(x){const Re=new d.CallHierarchyItem(ce.to(x.kind),x.name,x.detail||"",v.URI.revive(x.uri),l.to(x.range),l.to(x.selectionRange));return Re._sessionId=x._sessionId,Re._itemId=x._itemId,Re}Ce.to=Ae;function me(x,Re,Ue){if(Re=Re??x._sessionId,Ue=Ue??x._itemId,Re===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ue,name:x.name,detail:x.detail,kind:ce.from(x.kind),uri:x.uri,range:l.from(x.range),selectionRange:l.from(x.selectionRange),tags:x.tags?.map(ue.from)}}Ce.from=me})(X=e.CallHierarchyItem||(e.CallHierarchyItem={}));var J;(function(Ce){function Ae(me){return new d.CallHierarchyIncomingCall(X.to(me.from),me.fromRanges.map(x=>l.to(x)))}Ce.to=Ae})(J=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var de;(function(Ce){function Ae(me){return new d.CallHierarchyOutgoingCall(X.to(me.to),me.fromRanges.map(x=>l.to(x)))}Ce.to=Ae})(de=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ye;(function(Ce){function Ae(x){return{range:x.range&&l.from(x.range),uri:x.uri}}Ce.from=Ae;function me(x){return new d.Location(v.URI.revive(x.uri),l.to(x.range))}Ce.to=me})(ye=e.location||(e.location={}));var Fe;(function(Ce){function Ae(x){const Re=x,Ue=x;return{originSelectionRange:Re.originSelectionRange?l.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Ue.uri,range:l.from(Re.targetRange?Re.targetRange:Ue.range),targetSelectionRange:Re.targetSelectionRange?l.from(Re.targetSelectionRange):void 0}}Ce.from=Ae;function me(x){return{targetUri:v.URI.revive(x.uri),targetRange:l.to(x.range),targetSelectionRange:x.targetSelectionRange?l.to(x.targetSelectionRange):void 0,originSelectionRange:x.originSelectionRange?l.to(x.originSelectionRange):void 0}}Ce.to=me})(Fe=e.DefinitionLink||(e.DefinitionLink={}));var ze;(function(Ce){function Ae(x){return{range:l.from(x.range),contents:A.fromMany(x.contents)}}Ce.from=Ae;function me(x){return new d.Hover(x.contents.map(A.to),l.to(x.range))}Ce.to=me})(ze=e.Hover||(e.Hover={}));var Pe;(function(Ce){function Ae(x){return{range:l.from(x.range),expression:x.expression}}Ce.from=Ae;function me(x){return new d.EvaluatableExpression(l.to(x.range),x.expression)}Ce.to=me})(Pe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ie;(function(Ce){function Ae(x){if(x instanceof d.InlineValueText)return{type:"text",range:l.from(x.range),text:x.text};if(x instanceof d.InlineValueVariableLookup)return{type:"variable",range:l.from(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};if(x instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(x.range),expression:x.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Ae;function me(x){switch(x.type){case"text":return{range:l.to(x.range),text:x.text};case"variable":return{range:l.to(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};case"expression":return{range:l.to(x.range),expression:x.expression}}}Ce.to=me})(Ie=e.InlineValue||(e.InlineValue={}));var we;(function(Ce){function Ae(x){return{frameId:x.frameId,stoppedLocation:l.from(x.stoppedLocation)}}Ce.from=Ae;function me(x){return new d.InlineValueContext(x.frameId,l.to(x.stoppedLocation))}Ce.to=me})(we=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(Ce){function Ae(x){return{range:l.from(x.range),kind:x.kind}}Ce.from=Ae;function me(x){return new d.DocumentHighlight(l.to(x.range),x.kind)}Ce.to=me})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var le;(function(Ce){function Ae(me){switch(me){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}Ce.to=Ae})(le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(Ce){function Ae(me){return{triggerKind:le.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Ce.to=Ae})(Z=e.CompletionContext||(e.CompletionContext={}));var I;(function(Ce){function Ae(x){switch(x){case d.CompletionItemTag.Deprecated:return 1}}Ce.from=Ae;function me(x){switch(x){case 1:return d.CompletionItemTag.Deprecated}}Ce.to=me})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var B;(function(Ce){const Ae=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function me(Ue){return Ae.get(Ue)??9}Ce.from=me;const x=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Re(Ue){return x.get(Ue)??d.CompletionItemKind.Property}Ce.to=Re})(B=e.CompletionItemKind||(e.CompletionItemKind={}));var W;(function(Ce){function Ae(me,x){const Re=new d.CompletionItem(me.label);return Re.insertText=me.insertText,Re.kind=B.to(me.kind),Re.tags=me.tags?.map(I.to),Re.detail=me.detail,Re.documentation=y.isMarkdownString(me.documentation)?A.to(me.documentation):me.documentation,Re.sortText=me.sortText,Re.filterText=me.filterText,Re.preselect=me.preselect,Re.commitCharacters=me.commitCharacters,m.Range.isIRange(me.range)?Re.range=l.to(me.range):typeof me.range=="object"&&(Re.range={inserting:l.to(me.range.insert),replacing:l.to(me.range.replace)}),Re.keepWhitespace=typeof me.insertTextRules>"u"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Re.insertText=new d.SnippetString(me.insertText):(Re.insertText=me.insertText,Re.textEdit=Re.range instanceof d.Range?new d.TextEdit(Re.range,Re.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Re.additionalTextEdits=me.additionalTextEdits.map(Ue=>pe.to(Ue))),Re.command=x&&me.command?x.fromInternal(me.command):void 0,Re}Ce.to=Ae})(W=e.CompletionItem||(e.CompletionItem={}));var q;(function(Ce){function Ae(x){if(typeof x.label!="string"&&!Array.isArray(x.label))throw new TypeError("Invalid label");return{label:x.label,documentation:A.fromStrict(x.documentation)}}Ce.from=Ae;function me(x){return{label:x.label,documentation:y.isMarkdownString(x.documentation)?A.to(x.documentation):x.documentation}}Ce.to=me})(q=e.ParameterInformation||(e.ParameterInformation={}));var ee;(function(Ce){function Ae(x){return{label:x.label,documentation:A.fromStrict(x.documentation),parameters:Array.isArray(x.parameters)?x.parameters.map(q.from):[],activeParameter:x.activeParameter}}Ce.from=Ae;function me(x){return{label:x.label,documentation:y.isMarkdownString(x.documentation)?A.to(x.documentation):x.documentation,parameters:Array.isArray(x.parameters)?x.parameters.map(q.to):[],activeParameter:x.activeParameter}}Ce.to=me})(ee=e.SignatureInformation||(e.SignatureInformation={}));var fe;(function(Ce){function Ae(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(ee.from):[]}}Ce.from=Ae;function me(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(ee.to):[]}}Ce.to=me})(fe=e.SignatureHelp||(e.SignatureHelp={}));var De;(function(Ce){function Ae(me,x){const Re=new d.InlayHint(b.to(x.position),typeof x.label=="string"?x.label:x.label.map(oe.to.bind(void 0,me)),x.kind&&ve.to(x.kind));return Re.textEdits=x.textEdits&&x.textEdits.map(pe.to),Re.tooltip=y.isMarkdownString(x.tooltip)?A.to(x.tooltip):x.tooltip,Re.paddingLeft=x.paddingLeft,Re.paddingRight=x.paddingRight,Re}Ce.to=Ae})(De=e.InlayHint||(e.InlayHint={}));var oe;(function(Ce){function Ae(me,x){const Re=new d.InlayHintLabelPart(x.label);return Re.tooltip=y.isMarkdownString(x.tooltip)?A.to(x.tooltip):x.tooltip,a.Command.is(x.command)&&(Re.command=me.fromInternal(x.command)),x.location&&(Re.location=ye.to(x.location)),Re}Ce.to=Ae})(oe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ve;(function(Ce){function Ae(x){return x}Ce.from=Ae;function me(x){return x}Ce.to=me})(ve=e.InlayHintKind||(e.InlayHintKind={}));var be;(function(Ce){function Ae(x){return{range:l.from(x.range),url:x.target,tooltip:x.tooltip}}Ce.from=Ae;function me(x){let Re;if(x.url)try{Re=typeof x.url=="string"?v.URI.parse(x.url,!0):v.URI.revive(x.url)}catch{}return new d.DocumentLink(l.to(x.range),Re)}Ce.to=me})(be=e.DocumentLink||(e.DocumentLink={}));var He;(function(Ce){function Ae(x){const Re=new d.ColorPresentation(x.label);return x.textEdit&&(Re.textEdit=pe.to(x.textEdit)),x.additionalTextEdits&&(Re.additionalTextEdits=x.additionalTextEdits.map(Ue=>pe.to(Ue))),Re}Ce.to=Ae;function me(x){return{label:x.label,textEdit:x.textEdit?pe.from(x.textEdit):void 0,additionalTextEdits:x.additionalTextEdits?x.additionalTextEdits.map(Re=>pe.from(Re)):void 0}}Ce.from=me})(He=e.ColorPresentation||(e.ColorPresentation={}));var je;(function(Ce){function Ae(x){return new d.Color(x[0],x[1],x[2],x[3])}Ce.to=Ae;function me(x){return[x.red,x.green,x.blue,x.alpha]}Ce.from=me})(je=e.Color||(e.Color={}));var it;(function(Ce){function Ae(x){return{range:l.from(x.range)}}Ce.from=Ae;function me(x){return new d.SelectionRange(l.to(x.range))}Ce.to=me})(it=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(Ce){function Ae(me){switch(me){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}Ce.to=Ae})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(Ce){function Ae(x){switch(x){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Ae;function me(x){switch(x){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}Ce.to=me})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var nt;(function(Ce){function Ae(x){if(x===d.EndOfLine.CRLF)return 1;if(x===d.EndOfLine.LF)return 0}Ce.from=Ae;function me(x){if(x===1)return d.EndOfLine.CRLF;if(x===0)return d.EndOfLine.LF}Ce.to=me})(nt=e.EndOfLine||(e.EndOfLine={}));var Ne;(function(Ce){function Ae(me){if(typeof me=="object")return me.viewId;switch(me){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Ae})(Ne=e.ProgressLocation||(e.ProgressLocation={}));var rt;(function(Ce){function Ae(x){const Re={start:x.start+1,end:x.end+1};return x.kind&&(Re.kind=Q.from(x.kind)),Re}Ce.from=Ae;function me(x){const Re={start:x.start-1,end:x.end-1};return x.kind&&(Re.kind=Q.to(x.kind)),Re}Ce.to=me})(rt=e.FoldingRange||(e.FoldingRange={}));var Q;(function(Ce){function Ae(x){if(x)switch(x){case d.FoldingRangeKind.Comment:return a.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return a.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return a.FoldingRangeKind.Region}}Ce.from=Ae;function me(x){if(x)switch(x.value){case a.FoldingRangeKind.Comment.value:return d.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports.value:return d.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region.value:return d.FoldingRangeKind.Region}}Ce.to=me})(Q=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Y;(function(Ce){function Ae(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?l.from(me.selection):void 0,override:typeof me.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ce.from=Ae})(Y=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ge;(function(Ce){function Ae(Ue){return Ue instanceof d.RelativePattern?Ue.toJSON():typeof Ue=="string"?Ue:me(Ue)||x(Ue)?new d.RelativePattern(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Ce.from=Ae;function me(Ue){const Ye=Ue;return Ye?v.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function x(Ue){const Ye=Ue;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Re(Ue){return typeof Ue=="string"?Ue:new d.RelativePattern(v.URI.revive(Ue.baseUri),Ue.pattern)}Ce.to=Re})(ge=e.GlobPattern||(e.GlobPattern={}));var We;(function(Ce){function Ae(me){if(me){if(Array.isArray(me))return me.map(Ae);if(typeof me=="string")return me;{const x=me;return{language:x.language,scheme:x.scheme,pattern:ge.from(x.pattern),exclusive:x.exclusive,notebookType:x.notebookType}}}else return}Ce.from=Ae})(We=e.LanguageSelector||(e.LanguageSelector={}));var $e;(function(Ce){function Ae(x){return{start:x.start,end:x.end}}Ce.from=Ae;function me(x){return new d.NotebookRange(x.start,x.end)}Ce.to=me})($e=e.NotebookRange||(e.NotebookRange={}));var Qe;(function(Ce){function Ae(x){return{timing:typeof x.runStartTime=="number"&&typeof x.runEndTime=="number"?{startTime:x.runStartTime,endTime:x.runEndTime}:void 0,executionOrder:x.executionOrder,success:x.lastRunSuccess}}Ce.to=Ae;function me(x){return{lastRunSuccess:x.success,runStartTime:x.timing?.startTime,runEndTime:x.timing?.endTime,executionOrder:x.executionOrder}}Ce.from=me})(Qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ke;(function(Ce){function Ae(me){if(me===E.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;if(me===E.NotebookCellExecutionState.Pending)return;if(me===E.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}Ce.to=Ae})(Ke=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var tt;(function(Ce){function Ae(x){switch(x){case d.NotebookCellKind.Markup:return E.CellKind.Markup;case d.NotebookCellKind.Code:default:return E.CellKind.Code}}Ce.from=Ae;function me(x){switch(x){case E.CellKind.Markup:return d.NotebookCellKind.Markup;case E.CellKind.Code:default:return d.NotebookCellKind.Code}}Ce.to=me})(tt=e.NotebookCellKind||(e.NotebookCellKind={}));var at;(function(Ce){function Ae(x){const Re={metadata:x.metadata??Object.create(null),cells:[]};for(const Ue of x.cells)d.NotebookCellData.validate(Ue),Re.cells.push(Et.from(Ue));return Re}Ce.from=Ae;function me(x){const Re=new d.NotebookData(x.cells.map(Et.to));return(0,h.isEmptyObject)(x.metadata)||(Re.metadata=x.metadata),Re}Ce.to=me})(at=e.NotebookData||(e.NotebookData={}));var Et;(function(Ce){function Ae(x){return{cellKind:tt.from(x.kind),language:x.languageId,mime:x.mime,source:x.value,metadata:x.metadata,internalMetadata:Qe.from(x.executionSummary??{}),outputs:x.outputs?x.outputs.map(It.from):[]}}Ce.from=Ae;function me(x){return new d.NotebookCellData(tt.to(x.cellKind),x.source,x.language,x.mime,x.outputs?x.outputs.map(It.to):void 0,x.metadata,x.internalMetadata?Qe.to(x.internalMetadata):void 0)}Ce.to=me})(Et=e.NotebookCellData||(e.NotebookCellData={}));var Ct;(function(Ce){function Ae(x){return{mime:x.mime,valueBytes:k.VSBuffer.wrap(x.data)}}Ce.from=Ae;function me(x){return new d.NotebookCellOutputItem(x.valueBytes.buffer,x.mime)}Ce.to=me})(Ct=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var It;(function(Ce){function Ae(x){return{outputId:x.id,items:x.items.map(Ct.from),metadata:x.metadata}}Ce.from=Ae;function me(x){const Re=x.items.map(Ct.to);return new d.NotebookCellOutput(Re,x.outputId,x.metadata)}Ce.to=me})(It=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Dt;(function(Ce){function Ae(Re){return x(Re)?{include:(0,h.withNullAsUndefined)(ge.from(Re.include)),exclude:(0,h.withNullAsUndefined)(ge.from(Re.exclude))}:(0,h.withNullAsUndefined)(ge.from(Re))}Ce.from=Ae;function me(Re){return x(Re)?{include:ge.to(Re.include),exclude:ge.to(Re.exclude)}:ge.to(Re)}Ce.to=me;function x(Re){const Ue=Re;return Ue?!(0,h.isUndefinedOrNull)(Ue.include)&&!(0,h.isUndefinedOrNull)(Ue.exclude):!1}})(Dt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ut;(function(Ce){function Ae(me,x,Re){const Ue=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:x.toInternal(Ue,Re),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Ce.from=Ae})(ut=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ft;(function(Ce){function Ae(me,x,Re){const Ue=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:x.toInternal(Ue,Re),label:me.label,description:me.description,detail:me.detail,documentation:me.documentation}}Ce.from=Ae})(ft=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Kt;(function(Ce){function Ae(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}Ce.from=Ae})(Kt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Vt;(function(Ce){function Ae(x){return{uri:x.uri,provides:x.provides}}Ce.from=Ae;function me(x){return new d.NotebookRendererScript(v.URI.revive(x.uri),x.provides)}Ce.to=me})(Vt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var kt;(function(Ce){function Ae(x){return{message:A.fromStrict(x.message)||"",type:0,expected:x.expectedOutput,actual:x.actualOutput,location:x.location&&{range:l.from(x.location.range),uri:x.location.uri}}}Ce.from=Ae;function me(x){const Re=new d.TestMessage(typeof x.message=="string"?x.message:A.to(x.message));return Re.actualOutput=x.actual,Re.expectedOutput=x.expected,Re.location=x.location?ye.to(x.location):void 0,Re}Ce.to=me})(kt=e.TestMessage||(e.TestMessage={}));var ht;(function(Ce){Ce.namespace=p.namespaceTestTag,Ce.denamespace=p.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var Tt;(function(Ce){function Ae(x){const Re=(0,u.getPrivateApiFor)(x).controllerId;return{extId:L.TestId.fromExtHostTestItem(x,Re).toString(),label:x.label,uri:v.URI.revive(x.uri),busy:x.busy,tags:x.tags.map(Ue=>ht.namespace(Re,Ue.id)),range:m.Range.lift(l.from(x.range)),description:x.description||null,sortText:x.sortText||null,error:x.error&&A.fromStrict(x.error)||null}}Ce.from=Ae;function me(x){return{parent:void 0,error:void 0,id:L.TestId.fromString(x.extId).localId,label:x.label,uri:v.URI.revive(x.uri),tags:(x.tags||[]).map(Re=>{const{tagId:Ue}=ht.denamespace(Re);return new d.TestTag(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(x.range||void 0),canResolveChildren:!1,busy:x.busy,description:x.description||void 0,sortText:x.sortText||void 0}}Ce.toPlain=me})(Tt=e.TestItem||(e.TestItem={})),function(Ce){function Ae(x){return{id:x.id}}Ce.from=Ae;function me(x){return new d.TestTag(x.id)}Ce.to=me}(ht=e.TestTag||(e.TestTag={}));var $t;(function(Ce){const Ae=(x,Re)=>{const Ue=[];for(const[Be,Ze]of Re)L.TestId.compare(Ze.item.extId,Be)===2&&(Re.delete(Be),Ue.push(Ze));const Ye={...Tt.toPlain(x.item),parent:void 0,taskStates:x.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(Ze=>Ze.type===0).map(kt.to)})),children:Ue.map(Be=>Ae(Be,Re))};for(const Be of Ye.children)Be.parent=Ye;return Ye};function me(x){const Re=[],Ue=new Map;for(const Ye of x.items){Ue.set(Ye.item.extId,Ye);const Be=L.TestId.root(Ye.item.extId);x.request.targets.some(Ze=>Ze.controllerId===Be&&Ze.testIds.includes(Ye.item.extId))&&Re.push(Ye)}return{completedAt:x.completedAt,results:Re.map(Ye=>Ae(Ye,Ue))}}Ce.to=me})($t=e.TestResults||(e.TestResults={}));var At;(function(Ce){function Ae(Ue){return{covered:Ue.covered,total:Ue.covered}}function me(Ue){return"line"in Ue?b.from(Ue):l.from(Ue)}function x(Ue){return"branches"in Ue?{count:Ue.executionCount,location:me(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&me(Ye.location)})):void 0}:{type:0,count:Ue.executionCount,location:me(Ue.location)}}Ce.fromDetailed=x;function Re(Ue){return{uri:Ue.uri,statement:Ae(Ue.statementCoverage),branch:Ue.branchCoverage&&Ae(Ue.branchCoverage),function:Ue.functionCoverage&&Ae(Ue.functionCoverage),details:Ue.detailedCoverage?.map(x)}}Ce.fromFile=Re})(At=e.TestCoverage||(e.TestCoverage={}));var Ge;(function(Ce){function Ae(me){switch(me){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}Ce.to=Ae})(Ge=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(Ce){function Ae(x){const Re=new d.TypeHierarchyItem(ce.to(x.kind),x.name,x.detail||"",v.URI.revive(x.uri),l.to(x.range),l.to(x.selectionRange));return Re._sessionId=x._sessionId,Re._itemId=x._itemId,Re}Ce.to=Ae;function me(x,Re,Ue){if(Re=Re??x._sessionId,Ue=Ue??x._itemId,Re===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ue,kind:ce.from(x.kind),name:x.name,detail:x.detail??"",uri:x.uri,range:l.from(x.range),selectionRange:l.from(x.selectionRange),tags:x.tags?.map(ue.from)}}Ce.from=me})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var xt;(function(Ce){function Ae(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}Ce.from=Ae})(xt=e.ViewBadge||(e.ViewBadge={}));var Nt;(function(Ce){function Ae(Ue,Ye,Be){const Ze=Ye.fileData;return Ze?new class extends d.DataTransferItem{asFile(){return{name:Ze.name,uri:v.URI.revive(Ze.uri),data:(0,M.once)(()=>Be())}}}("",Ye.id):Ue===N.Mimes.uriList&&Ye.uriListData?new d.DataTransferItem(Re(Ye.uriListData)):new d.DataTransferItem(Ye.asString)}Ce.to=Ae;async function me(Ue,Ye){const Be=await Ye.asString();if(Ue===N.Mimes.uriList)return{id:Ye.id,asString:Be,fileData:void 0,uriListData:x(Be)};const Ze=Ye.asFile();return{id:Ye.id,asString:Be,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}Ce.from=me;function x(Ue){return D.UriList.split(Ue).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return v.URI.parse(Ye)}catch{}return Ye})}function Re(Ue){return D.UriList.create(Ue.map(Ye=>typeof Ye=="string"?Ye:v.URI.revive(Ye)))}})(Nt=e.DataTransferItem||(e.DataTransferItem={}));var mt;(function(Ce){function Ae(x,Re){const Ue=x.items.map(([Ye,Be])=>[Ye,Nt.to(Ye,Be,()=>Re(Be.id))]);return new d.DataTransfer(Ue)}Ce.toDataTransfer=Ae;async function me(x){const Re={items:[]},Ue=[];return x.forEach((Ye,Be)=>{Ue.push((async()=>{Re.items.push([Be,await Nt.from(Be,Ye)])})())}),await Promise.all(Ue),Re}Ce.toDataTransferDTO=me})(mt=e.DataTransfer||(e.DataTransfer={}))}),define(ke[195],Te([1,0,2,12,7,8,161]),function(te,e,n,k,D,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class R{constructor(T,N,w,h={timeout:1500,errors:3}){this.c=T,this.d=N,this.f=w,this.g=h,this.a=new y.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(N,w,h)=>{const m={dispose:this.a.push([N,w,T])};return Array.isArray(h)&&h.push(m),m}}async $participateInSave(T,N){const w=n.URI.revive(T);let h=!1;const v=setTimeout(()=>h=!0,this.g.timeout),m=[];try{for(const a of[...this.a]){if(h)break;const o=this.d.getDocument(w),u=await this.h(a,{document:o,reason:M.TextDocumentSaveReason.to(N)});m.push(u)}}finally{clearTimeout(v)}return m}h([T,N,w],h){const v=this.b.get(T);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(w,T,N,h).then(()=>!0,m=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this.c.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const a=this.b.get(T);this.b.set(T,a?a+1:1),typeof a=="number"&&a>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,N,w,h){const v=[],m=Date.now(),{document:a,reason:o}=h,{version:u}=a,g=Object.freeze({document:a,reason:o,waitUntil(E){if(Object.isFrozen(v))throw(0,k.illegalState)("waitUntil can not be called async");v.push(Promise.resolve(E))}});try{N.apply(w,[g])}catch(E){return Promise.reject(E)}return Object.freeze(v),new Promise((E,L)=>{const p=setTimeout(()=>L(new Error("timeout")),this.g.timeout);return Promise.all(v).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(p),E(t)}).catch(t=>{clearTimeout(p),L(t)})}).then(E=>{const L={edits:[]};for(const p of E)if(Array.isArray(p)&&p.every(t=>t instanceof D.TextEdit))for(const{newText:t,newEol:d,range:r}of p)L.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:r&&M.Range.from(r),text:t,eol:d&&M.EndOfLine.from(d)}});if(L.edits.length!==0)return u===a.version?this.f.$tryApplyWorkspaceEdit(L):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=R}),define(ke[196],Te([1,0,15,2,8,7,71]),function(te,e,n,k,D,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(w,h,v,m){this.start=w,this.deletedCount=h,this.deletedItems=v,this.items=m}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(w,h){return{EOL:h.eol,lines:h.source,languageId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:w}}constructor(w,h,v){this.notebook=w,this.h=h,this.j=v,this.handle=v.handle,this.uri=k.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(D.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(D.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const w=this,h=this.h.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:D.NotebookCellKind.to(this.j.cellKind),document:h.document,get mime(){return w.g},set mime(m){w.g=m},get outputs(){return w.a.slice(0)},get metadata(){return w.b},get executionSummary(){return w.d}};this.f=Object.freeze(v)}return this.f}setOutputs(w){this.a=w.map(D.NotebookCellOutput.to)}setOutputItems(w,h,v){const m=v.map(D.NotebookCellOutputItem.to),a=this.a.find(o=>o.id===w);if(a&&(h||(a.items.length=0),a.items.push(...m),a.items.length>1&&a.items.every(o=>y.isTextStreamMime(o.mime)))){const o=new Map,u=[];a.items.forEach(g=>{let E;o.has(g.mime)?E=o.get(g.mime):(E=[],o.set(g.mime,E),u.push(g.mime)),E.push(g.data)}),a.items.length=0,u.forEach(g=>{const E=y.compressOutputItemStreams(o.get(g));a.items.push({mime:g,data:E.buffer})})}}setMetadata(w){this.b=Object.freeze(w)}setInternalMetadata(w){this.e=w,this.d=Object.freeze(D.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=S;class T{constructor(w,h,v,m,a){this.k=w,this.l=h,this.m=v,this.uri=m,this.handle=T.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const w=this,h={get uri(){return w.uri},get version(){return w.g},get notebookType(){return w.d},get isDirty(){return w.h},get isUntitled(){return w.uri.scheme===n.Schemas.untitled},get isClosed(){return w.j},get metadata(){return w.f},get cellCount(){return w.b.length},cellAt(v){return v=w.n(v),w.b[v].apiCell},getCells(v){return(v?w.p(v):w.b).map(a=>a.apiCell)},save(){return w.q()}};this.e=Object.freeze(h)}return this.e}acceptDocumentPropertiesChanged(w){w.metadata&&(this.f=Object.freeze({...this.f,...w.metadata}))}acceptDirty(w){this.h=w}acceptModelChanged(w,h,v){this.g=w.versionId,this.h=h,this.acceptDocumentPropertiesChanged({metadata:v});const m={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},a=[];for(const u of w.rawEvents)u.kind===y.NotebookCellsChangeType.ModelChange?this.r(u.changes,!1,m.contentChanges):u.kind===y.NotebookCellsChangeType.Move?this.s(u.index,u.length,u.newIdx,m.contentChanges):u.kind===y.NotebookCellsChangeType.Output?(this.t(u.index,u.outputs),a.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===y.NotebookCellsChangeType.OutputItem?(this.u(u.index,u.outputId,u.append,u.outputItems),a.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===y.NotebookCellsChangeType.ChangeCellLanguage?(this.v(u.index,u.language),a.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document})):u.kind===y.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document}):u.kind===y.NotebookCellsChangeType.ChangeCellMime?this.w(u.index,u.mime):u.kind===y.NotebookCellsChangeType.ChangeCellMetadata?(this.x(u.index,u.metadata),a.push({cell:this.b[u.index].apiCell,metadata:this.b[u.index].apiCell.metadata})):u.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(u.index,u.internalMetadata),a.push({cell:this.b[u.index].apiCell,executionSummary:this.b[u.index].apiCell.executionSummary}));const o=new Map;for(let u=0;u<a.length;u++){const g=a[u],E=o.get(g.cell);if(E===void 0){const L=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});o.set(g.cell,L-1)}else m.cellChanges[E]={...m.cellChanges[E],...g}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(w){return w=w|0,w<0?0:w>=this.b.length?this.b.length-1:w}o(w){let h=w.start|0,v=w.end|0;return h<0&&(h=0),v>this.b.length&&(v=this.b.length),w.with({start:h,end:v})}p(w){w=this.o(w);const h=[];for(let v=w.start;v<w.end;v++)h.push(this.b[v]);return h}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(w,h,v){if(this.j)return;const m=[],a=[],o=[];if(w.reverse().forEach(u=>{const E=u[2].map(t=>{const d=new S(this,this.l,t);return h||a.push(S.asModelAddData(this.apiNotebook,t)),d}),L=new R(u[0],u[1],[],E),p=this.b.splice(u[0],u[1],...E);for(const t of p)o.push(t.uri),L.deletedItems.push(t.apiCell);m.push(L)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:o}),v)for(const u of m)v.push(u.asApiEvent())}s(w,h,v,m){const a=this.b.splice(w,h);this.b.splice(v,0,...a);const o=[new R(w,h,a.map(u=>u.apiCell),[]),new R(v,0,[],a)];for(const u of o)m.push(u.asApiEvent())}t(w,h){this.b[w].setOutputs(h)}u(w,h,v,m){this.b[w].setOutputItems(h,v,m)}v(w,h){const v=this.b[w];v.apiCell.document.languageId!==h&&this.m.$acceptModelLanguageChanged(v.uri,h)}w(w,h){const v=this.b[w];v.apiCell.mime=h}x(w,h){this.b[w].setMetadata(h)}y(w,h){this.b[w].setInternalMetadata(h)}getCellFromApiCell(w){return this.b.find(h=>h.apiCell===w)}getCellFromIndex(w){return this.b[w]}getCell(w){return this.b.find(h=>h.handle===w)}getCellIndex(w){return this.b.indexOf(w)}}T.a=0,e.ExtHostNotebookDocument=T}),define(ke[100],Te([1,0,12,8,7]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(R,S,T,N,w,h){this.id=R,this.f=S,this.notebookData=T,this.a=[],this.b=[],this.d=!1,this.a=w,this.b=N,this.c=h}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection(S){this.selections=[S]},get selections(){return R.a},set selections(S){if(!Array.isArray(S)||!S.every(D.NotebookRange.isNotebookRange))throw(0,n.illegalArgument)("selections");R.a=S,R.g(S)},get visibleRanges(){return R.b},revealRange(S,T){R.f.$tryRevealRange(R.id,k.NotebookRange.from(S),T??D.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(k.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}M.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=M}),define(ke[197],Te([1,0,4,11,8]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(R,S){this.c=R,this.d=S,this.a=new n.Emitter,this.b=new n.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(R,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,S);const T=this.d.getEditorById(R);S.visibleRanges&&T._acceptVisibleRanges(S.visibleRanges.ranges.map(D.NotebookRange.to)),S.selections&&T._acceptSelections(S.selections.selections.map(D.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:T.apiEditor,visibleRanges:T.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:T.apiEditor,selections:T.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const S in R)this.d.getEditorById(S)._acceptViewColumn(D.ViewColumn.to(R[S]))}};M=qe([Ve(0,k.ILogService)],M),e.ExtHostNotebookEditors=M}),define(ke[198],Te([1,0,8,165,141,21,64,12]),function(te,e,n,k,D,M,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(h){this.b=0,this.c=new Map,this.a=h}async withProgress(h,v,m){const a=this.b++,{title:o,location:u,cancellable:g}=v,E={label:(0,D.localize)(0,null,h.displayName||h.name),id:h.identifier.value};return this.a.$startProgress(a,{location:n.ProgressLocation.from(u),title:o,source:E,cancellable:g},h.isUnderDevelopment?void 0:h.identifier.value).catch(R.onUnexpectedExternalError),this.d(a,m,!!g)}d(h,v,m){let a;m&&(a=new M.CancellationTokenSource,this.c.set(h,a));const o=g=>{this.a.$progressEnd(g),this.c.delete(g),a?.dispose()};let u;try{u=v(new N(this.a,h),m&&a?a.token:M.CancellationToken.None)}catch(g){throw o(h),g}return u.then(g=>o(h),g=>o(h)),u}$acceptProgressCanceled(h){const v=this.c.get(h);v&&(v.cancel(),this.c.delete(h))}}e.ExtHostProgress=S;function T(w,h){return w.message=h.message,typeof h.increment=="number"&&(typeof w.increment=="number"?w.increment+=h.increment:w.increment=h.increment),w}class N extends k.Progress{constructor(h,v){super(m=>this.throttledReport(m)),this.c=h,this.d=v}throttledReport(h){this.c.$progressReport(this.d,h)}}qe([(0,y.throttle)(100,(w,h)=>T(w,h),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(ke[101],Te([1,0,44,96,45,72,56,8,2]),function(te,e,n,k,D,M,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const T=(E,L,p,t)=>{let d=L;return{enumerable:!0,configurable:!1,get(){return d},set(r){if(!p(d,r)){const l=d;d=r,E.listener?.(t(r,l))}}}},N=(E,L)=>E===L,w={range:(E,L)=>E===L?!0:!E||!L?!1:E.isEqual(L),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(E,L)=>!(E.length!==L.length||E.some(p=>!L.find(t=>p.id===t.id)))},h=E=>L=>({op:4,update:E(L)}),v=(E,L)=>({range:(()=>{let p;const t=h(d=>({range:n.Range.lift(R.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return p},set(d){E.listener?.({op:6}),w.range(p,d)||(p=d,E.listener?.(t(d)))}}})(),label:T(E,L,w.label,h(p=>({label:p}))),description:T(E,void 0,w.description,h(p=>({description:p}))),sortText:T(E,void 0,w.sortText,h(p=>({sortText:p}))),canResolveChildren:T(E,!1,w.canResolveChildren,p=>({op:2,state:p})),busy:T(E,!1,w.busy,h(p=>({busy:p}))),error:T(E,void 0,w.error,h(p=>({error:R.MarkdownString.fromStrict(p)||null}))),tags:T(E,[],w.tags,(p,t)=>({op:1,new:p.map(R.TestTag.from),old:t.map(R.TestTag.from)}))}),m=E=>{const L=D.TestId.fromString(E.extId),p=new o(L.controllerId,L.localId,E.label,S.URI.revive(E.uri)||void 0);return p.range=R.Range.to(E.range||void 0),p.description=E.description||void 0,p.sortText=E.sortText||void 0,p.tags=E.tags.map(t=>R.TestTag.to({id:(0,y.denamespaceTestTag)(t).tagId})),p},a=E=>{let L;for(const p of E.tests){const t=m(p.item);(0,k.getPrivateApiFor)(t).parent=L,L=t}return L};e.toItemFromContext=a;class o{constructor(L,p,t,d){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const r=(0,k.createPrivateApiFor)(this,L);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof u?void 0:r.parent}},children:{value:(0,M.createTestItemChildren)(r,k.getPrivateApiFor,o),enumerable:!0,writable:!1},...v(r,t)})}}e.TestItemImpl=o;class u extends o{constructor(L,p){super(L,L,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=u;class g extends M.TestItemCollection{constructor(L,p,t){super({controllerId:L,getDocumentVersion:d=>d&&t.getDocument(d)?.version,getApiFor:k.getPrivateApiFor,getChildren:d=>d.children,root:new u(L,p),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(ke[102],Te([1,0,49,12,83,8,7]),function(te,e,n,k,D,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class R{constructor(h,v,m){const a=R.c.nextId();h.$registerTextEditorDecorationType(v.identifier,a,M.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:a,dispose(){h.$removeTextEditorDecorationType(a)}})}}R.c=new D.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=R;class S{constructor(h,v){this.g=[],this.h=void 0,this.j=!1,this.c=h,this.d=h.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(h,v){this.k();let m=null;if(h instanceof y.Position)m=new y.Range(h,h);else if(h instanceof y.Range)m=h;else throw new Error("Unrecognized location");this.l(m,v,!1)}insert(h,v){this.k(),this.l(new y.Range(h,h),v,!0)}delete(h){this.k();let v=null;if(h instanceof y.Range)v=h;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(h,v,m){const a=this.c.validateRange(h);this.g.push({range:a,text:v,forceMoveMarkers:m})}setEndOfLine(h){if(this.k(),h!==y.EndOfLine.LF&&h!==y.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this.h=h}}class T{constructor(h,v,m,a){this.c=h,this.d=v,this._accept(m),this.e=a;const o=this;this.value={get tabSize(){return o.f},set tabSize(u){o.m(u)},get indentSize(){return o.g},set indentSize(u){o.o(u)},get insertSpaces(){return o.h},set insertSpaces(u){o.q(u)},get cursorStyle(){return o.j},set cursorStyle(u){o.s(u)},get lineNumbers(){return o.k},set lineNumbers(u){o.t(u)}}}_accept(h){this.f=h.tabSize,this.g=h.indentSize,this.h=h.insertSpaces,this.j=h.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(h.lineNumbers)}l(h){if(h==="auto")return"auto";if(typeof h=="number"){const v=Math.floor(h);return v>0?v:null}if(typeof h=="string"){const v=parseInt(h,10);return isNaN(v)?null:v>0?v:null}return null}m(h){const v=this.l(h);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n(h){if(h==="tabSize")return"tabSize";if(typeof h=="number"){const v=Math.floor(h);return v>0?v:null}if(typeof h=="string"){const v=parseInt(h,10);return isNaN(v)?null:v>0?v:null}return null}o(h){const v=this.n(h);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p(h){return h==="auto"?"auto":h==="false"?!1:Boolean(h)}q(h){const v=this.p(h);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s(h){this.j!==h&&(this.j=h,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:h})))}t(h){this.k!==h&&(this.k=h,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(h)})))}assign(h){const v={};let m=!1;if(typeof h.tabSize<"u"){const a=this.l(h.tabSize);a==="auto"?(m=!0,v.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,m=!0,v.tabSize=a)}if(typeof h.indentSize<"u"){const a=this.n(h.indentSize);a==="tabSize"?(m=!0,v.indentSize=a):typeof a=="number"&&this.g!==a&&(this.g=a,m=!0,v.indentSize=a)}if(typeof h.insertSpaces<"u"){const a=this.p(h.insertSpaces);a==="auto"?(m=!0,v.insertSpaces=a):this.h!==a&&(this.h=a,m=!0,v.insertSpaces=a)}typeof h.cursorStyle<"u"&&this.j!==h.cursorStyle&&(this.j=h.cursorStyle,m=!0,v.cursorStyle=h.cursorStyle),typeof h.lineNumbers<"u"&&this.k!==h.lineNumbers&&(this.k=h.lineNumbers,m=!0,v.lineNumbers=M.TextEditorLineNumbersStyle.from(h.lineNumbers)),m&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u(h,v){v.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${h}' failed:'`),this.e.warn(m)})}}e.ExtHostTextEditorOptions=T;class N{constructor(h,v,m,a,o,u,g,E){this.id=h,this.j=v,this.k=m,this.g=!1,this.h=new Set,this.c=o,this.d=new T(this.j,this.id,u,m),this.e=g,this.f=E;const L=this;this.value=Object.freeze({get document(){return a.value},set document(p){throw(0,k.readonly)("document")},get selection(){return L.c&&L.c[0]},set selection(p){if(!(p instanceof y.Selection))throw(0,k.illegalArgument)("selection");L.c=[p],L.l()},get selections(){return L.c},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof y.Selection)))throw(0,k.illegalArgument)("selections");L.c=p,L.l()},get visibleRanges(){return L.e},set visibleRanges(p){throw(0,k.readonly)("visibleRanges")},get options(){return L.d.value},set options(p){L.g||L.d.assign(p)},get viewColumn(){return L.f},set viewColumn(p){throw(0,k.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(L.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new S(a.value,t);return p(d),L.m(d)},insertSnippet(p,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(L.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=L.c.map(l=>M.Range.from(l));else if(t instanceof y.Position){const{lineNumber:l,column:c}=M.Position.from(t);r=[{startLineNumber:l,startColumn:c,endLineNumber:l,endColumn:c}]}else if(t instanceof y.Range)r=[M.Range.from(t)];else{r=[];for(const l of t)if(l instanceof y.Range)r.push(M.Range.from(l));else{const{lineNumber:c,column:b}=M.Position.from(l);r.push({startLineNumber:c,startColumn:b,endLineNumber:c,endColumn:b})}}return v.$tryInsertSnippet(h,a.value.version,p.value,r,d)},setDecorations(p,t){const d=t.length===0;d&&!L.h.has(p.key)||(d?L.h.delete(p.key):L.h.add(p.key),L.n(()=>{if(M.isDecorationOptionsArr(t))return v.$trySetDecorations(h,p.key,M.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let l=0,c=t.length;l<c;l++){const b=t[l];r[4*l]=b.start.line+1,r[4*l+1]=b.start.character+1,r[4*l+2]=b.end.line+1,r[4*l+3]=b.end.character+1}return v.$trySetDecorationsFast(h,p.key,r)}}))},revealRange(p,t){L.n(()=>v.$tryRevealRange(h,M.Range.from(p),t||y.TextEditorRevealType.Default))},show(p){v.$tryShowEditor(h,M.ViewColumn.from(p))},hide(){v.$tryHideEditor(h)}})}dispose(){(0,n.ok)(!this.g),this.g=!0}_acceptOptions(h){(0,n.ok)(!this.g),this.d._accept(h)}_acceptVisibleRanges(h){(0,n.ok)(!this.g),this.e=h}_acceptViewColumn(h){(0,n.ok)(!this.g),this.f=h}_acceptSelections(h){(0,n.ok)(!this.g),this.c=h}async l(){const h=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,h)),this.value}m(h){const v=h.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const m=v.edits.map(o=>o.range);m.sort((o,u)=>o.end.line===u.end.line?o.end.character===u.end.character?o.start.line===u.start.line?o.start.character-u.start.character:o.start.line-u.start.line:o.end.character-u.end.character:o.end.line-u.end.line);for(let o=0,u=m.length-1;o<u;o++){const g=m[o].end;if(m[o+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=v.edits.map(o=>({range:M.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,a,{setEndOfLine:typeof v.setEndOfLine=="number"?M.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(h){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.ExtHostTextEditor=N}),define(ke[199],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[200],Te([1,0,154,12,29,90,69,30,26,199,164,156]),function(te,e,n,k,D,M,y,R,S,T,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const h=R.Registry.as(y.Extensions.JSONContribution);class v{constructor(p,t,d){this.a=p,this.b=t,this.c=d}d(p,t){this.a({type:p,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(D.default.Error,p)}warn(p){this.d(D.default.Warning,p)}info(p){this.d(D.default.Info,p)}}e.ExtensionMessageCollector=v;class m{static a(p){const t=new Set;for(let d=0,r=p.length;d<r;d++)t.add(S.ExtensionIdentifier.toKey(p[d].description.identifier));return t}static compute(p,t){if(!p||!p.length)return new m(t,[]);if(!t||!t.length)return new m([],p);const d=this.a(p),r=this.a(t),l=t.filter(b=>!d.has(S.ExtensionIdentifier.toKey(b.description.identifier))),c=p.filter(b=>!r.has(S.ExtensionIdentifier.toKey(b.description.identifier)));return new m(l,c)}constructor(p,t){this.added=p,this.removed=t}}e.ExtensionPointUserDelta=m;class a{constructor(p,t){this.name=p,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=m.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,k.onUnexpectedError)(p)}}}e.ExtensionPoint=a;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:Object.values(T.allApiProposals)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"*",description:n.localize(42,null),body:"*"}]}},badges:{type:"array",description:n.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(44,null)},href:{type:"string",description:n.localize(45,null)},description:{type:"string",description:n.localize(46,null)}}}},markdown:{type:"string",description:n.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:n.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:n.localize(51,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(52,null)},{body:["workspace"],description:n.localize(53,null)},{body:["ui","workspace"],description:n.localize(54,null)},{body:["workspace","ui"],description:n.localize(55,null)},{body:[],description:n.localize(56,null)}]},capabilities:{description:n.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(60,null),n.localize(61,null),n.localize(62,null)]},description:{type:"string",markdownDescription:n.localize(63,null)}}},untrustedWorkspaces:{description:n.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(66,null),n.localize(67,null),n.localize(68,null)]},restrictedConfigurations:{description:n.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(70,null)}}}}},sponsor:{description:n.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(73,null),type:"string"},"vscode:uninstall":{description:n.localize(74,null),type:"string"}}},icon:{type:"string",description:n.localize(75,null)},l10n:{type:"string",description:n.localize(76,null)}}};class g{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const t=new a(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,t),p.activationEventsGenerator&&w.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,h.registerSchema(u,e.schema),t}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=g;const E={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(E.ExtensionsRegistry,new g),e.ExtensionsRegistry=R.Registry.as(E.ExtensionsRegistry),h.registerSchema(u,e.schema),h.registerSchema(N.productSchemaId,{properties:{extensionEnabledApiProposals:{description:n.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:Object.values(T.allApiProposals)}}]}}}})}),define(ke[201],Te([1,0,151,9,22,200,42,4]),function(te,e,n,k,D,M,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:n.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:n.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:n.localize(2,null),default:""}}};var T;(function(h){function v(m,a,o){if(!m)return;const u=k.isString(m.type)?m.type:void 0;if(!u||u.length===0){o.error(n.localize(3,null));return}const g=[];if(Array.isArray(m.required))for(const E of m.required)k.isString(E)&&g.push(E);return{extensionId:a.value,taskType:u,required:g,properties:m.properties?D.deepClone(m.properties):{},when:m.when?y.ContextKeyExpr.deserialize(m.when):void 0}}h.from=v})(T||(T={}));const N=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(h,v)=>{for(const m of h)m.type&&v.push(`onTaskType:${m.type}`)},jsonSchema:{description:n.localize(4,null),type:"array",items:S}});class w{constructor(){this.d=new R.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,m)=>{N.setHandler((a,o)=>{this.c=void 0;try{for(const u of o.removed){const g=u.value;for(const E of g)this.a&&E.type&&this.a[E.type]&&delete this.a[E.type]}for(const u of o.added){const g=u.value;for(const E of g){const L=T.from(E,u.description.identifier,u.collector);L&&(this.a[L.taskType]=L)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const m of this.all()){const a={type:"object",additionalProperties:!1};m.required.length>0&&(a.required=m.required.slice(0)),m.properties!==void 0?a.properties=D.deepClone(m.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[m.taskType]},v.push(a)}this.c={oneOf:v}}return this.c}}e.TaskDefinitionRegistry=new w}),define(ke[202],Te([1,0,152,9,24,22,42,201]),function(te,e,n,k,D,M,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new y.RawContextKey("taskRunning",!1,n.localize(0,null)),e.TASKS_CATEGORY={value:n.localize(1,null),original:"Tasks"};var S;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(O){function F(H){if(!H)return O.Strong;switch(H.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=F}(S=e.ShellQuoting||(e.ShellQuoting={}));var T;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(T=e.CommandOptions||(e.CommandOptions={}));var N;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(N=e.RevealKind||(e.RevealKind={})),function(O){function F(H){switch(H.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=F}(N=e.RevealKind||(e.RevealKind={}));var w;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(w=e.RevealProblemKind||(e.RevealProblemKind={})),function(O){function F(H){switch(H.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=F}(w=e.RevealProblemKind||(e.RevealProblemKind={}));var h;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(h=e.PanelKind||(e.PanelKind={})),function(O){function F(H){switch(H.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=F}(h=e.PanelKind||(e.PanelKind={}));var v;(function(O){O.defaults={echo:!0,reveal:N.Always,revealProblems:w.Never,focus:!1,panel:h.Shared,showReuseMessage:!0,clear:!1}})(v=e.PresentationOptions||(e.PresentationOptions={}));var m;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(m=e.RuntimeType||(e.RuntimeType={})),function(O){function F(V){switch(V.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=F;function H(V){switch(V){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=H}(m=e.RuntimeType||(e.RuntimeType={}));var a;(function(O){function F(H){return k.isString(H)?H:H.value}O.value=F})(a=e.CommandString||(e.CommandString={}));var o;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function F(V){return V===O.Clean._id||V===O.Build._id||V===O.Rebuild._id||V===O.Test._id}O.is=F;function H(V){if(V!==void 0)return k.isString(V)?F(V)?{_id:V,isDefault:!1}:void 0:V}O.from=H})(o=e.TaskGroup||(e.TaskGroup={}));var u;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(u=e.TaskScope||(e.TaskScope={}));var g;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function F(H){switch(H){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=F})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var E;(function(O){O.parallel="parallel",O.sequence="sequence"})(E=e.DependsOrder||(e.DependsOrder={}));var L;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(L=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:L.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class t{constructor(F,H,V,ae,pe,re){this._label="",this._id=F,H&&(this._label=H),V&&(this.type=V),this.runOptions=ae,this.configurationProperties=pe,this._source=re}getDefinition(F){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,H=!1){if(F===void 0)return!1;if(k.isString(F))return F===this._label||F===this.configurationProperties.identifier||H&&F===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.CommonTask=t;class d extends t{constructor(F,H,V,ae,pe,re,ce,ue){super(F,V,void 0,ce,ue,H),this.command={},this._source=H,this.hasDefinedMatchers=re,pe&&(this.command=pe)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let H;switch(this.command?this.command.runtime:void 0){case m.Shell:H="shell";break;case m.Process:H="process";break;case m.CustomExecution:H="customExecution";break;case void 0:H="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:H,_key:this._id,id:this._id}}}static is(F){return F instanceof d}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let H=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(H+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:H};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new d(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.CustomTask=d;class r extends t{constructor(F,H,V,ae,pe,re,ce){super(F,V,ae,re,ce,H),this._source=H,this.configures=pe}static is(F){return F instanceof r}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let H=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(H+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:H};return JSON.stringify(V)}}e.ConfiguringTask=r;class l extends t{constructor(F,H,V,ae,pe,re,ce,ue,Se){super(F,V,ae,ue,Se,H),this.defines=pe,this.hasDefinedMatchers=ce,this.command=re,this.icon=Se.icon,this.hide=Se.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof l}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new l(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.ContributedTask=l;class c extends t{constructor(F,H,V,ae,pe,re){super(F,V,ae,pe,re,H),this._source=H}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new c(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.InMemoryTask=c;var b;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(b=e.ExecutionEngine||(e.ExecutionEngine={})),function(O){O._default=O.Terminal}(b=e.ExecutionEngine||(e.ExecutionEngine={}));var i;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(i=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class s{constructor(F){this.c=new Map;for(let H=0;H<F.length;H++)this.c.set(F[H].uri.toString(),H)}compare(F,H){const V=F.getWorkspaceFolder(),ae=H.getWorkspaceFolder();if(V&&ae){let pe=this.c.get(V.uri.toString());pe=pe===void 0?0:pe+1;let re=this.c.get(ae.uri.toString());return re=re===void 0?0:re+1,pe===re?F._label.localeCompare(H._label):pe-re}else return!V&&ae?-1:V&&!ae?1:0}}e.TaskSorter=s;var f;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(f=e.TaskEventKind||(e.TaskEventKind={}));var P;(function(O){O.SingleRun="singleRun",O.Background="background"})(P=e.TaskRunType||(e.TaskRunType={}));var C;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(C=e.TaskRunSource||(e.TaskRunSource={}));var j;(function(O){function F(H,V,ae,pe){if(V){const re={kind:H,taskId:V._id,taskName:V.configurationProperties.name,runType:V.configurationProperties.isBackground?"background":"singleRun",group:V.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:ae,__task:V};return H==="start"?re.resolvedVariables=pe:H==="processStarted"?re.processId=pe:H==="processEnded"&&(re.exitCode=pe),Object.freeze(re)}else return Object.freeze({kind:"changed"})}O.create=F})(j=e.TaskEvent||(e.TaskEvent={}));var _;(function(O){function F(V){const ae=Object.keys(V).sort();let pe="";for(const re of ae){let ce=V[re];ce instanceof Object?ce=F(ce):typeof ce=="string"&&(ce=ce.replace(/,/g,",,")),pe+=re+","+ce+","}return pe}function H(V){const pe={_key:F(V),type:V.taskType};return Object.assign(pe,V),pe}O.create=H})(_=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var K;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(K=e.TaskSettingId||(e.TaskSettingId={}));var A;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(A=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var $;(function(O){function F(H,V){const ae=R.TaskDefinitionRegistry.get(H.type);if(ae===void 0){const ue=M.deepClone(H);return delete ue._key,_.create(ue)}const pe=Object.create(null);pe.type=ae.taskType;const re=new Set;ae.required.forEach(ue=>re.add(ue));const ce=ae.properties;for(const ue of Object.keys(ce)){const Se=H[ue];if(Se!=null)pe[ue]=Se;else if(re.has(ue)){const G=ce[ue];if(G.default!==void 0)pe[ue]=M.deepClone(G.default);else switch(G.type){case"boolean":pe[ue]=!1;break;case"number":case"integer":pe[ue]=0;break;case"string":pe[ue]="";break;default:V.error(n.localize(2,null,JSON.stringify(H,void 0,0),ue));return}}}return _.create(pe)}O.createTaskIdentifier=F})($=e.TaskDefinition||(e.TaskDefinition={}))}),define(ke[203],Te([1,0,12]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class k{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((y,R)=>{this.b=y,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(y){this.f||this.h||(this.f=!0,this.g=y,this.a&&this.b(y))}resolveErr(y){this.f||this.h||(this.h=!0,this.i=y,this.a?this.d(y):(0,n.onUnexpectedError)(y))}then(y,R){return this.j().then(y,R)}catch(y){return this.j().then(void 0,y)}finally(y){return this.j().finally(y)}}e.LazyPromise=k;class D extends k{constructor(){super(),this.h=!0,this.i=new n.CancellationError}}e.CanceledLazyPromise=D}),define(ke[46],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++n.count}}n.count=0,e.ProxyIdentifier=n;const k=[];function D(R){const S=new n(R);return k[S.nid]=S,S}e.createProxyIdentifier=D;function M(R){return k[R].sid}e.getStringIdentifierForProxy=M;class y{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=y}),define(ke[5],Te([1,0,46]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var k;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var M;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var y;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var R;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(R=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var N;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(N=e.CandidatePortSource||(e.CandidatePortSource={}));class w{static mixin(o){return o._id=w.a++,o}}w.a=0,e.IdObject=w;var h;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,n.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,n.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,n.createProxyIdentifier)("ExtHostLocalization")}}),define(ke[76],Te([1,0,3,11,5,18]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(S,T){this.c=T,this.a=new Set,this.b=S.getProxy(D.MainContext.MainThreadTelemetry)}report(S,T,N){const w=this.d(S,T);this.a.has(w)||(this.a.add(w),T.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:S}))}d(S,T){return`${S}-${T.identifier.value}`}};y=qe([Ve(0,M.IExtHostRpcService),Ve(1,k.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(R,S,T){}})}),define(ke[204],Te([1,0,4,5,7,26]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(S){this.b=new Map,this.c=[],this.d=new n.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,T,N,w={}){const h=M.ExtensionIdentifier.toKey(S.identifier),v=this.f.get(h)||[],m=[...N].sort().join(" ");let a=v.find(o=>o.providerId===T&&o.scopes===m);if(a)return a.result;{const o=this.g(S,h,T,N,w);a={providerId:T,scopes:m,result:o},v.push(a),this.f.set(h,v);try{await o}finally{const u=v.findIndex(g=>g.providerId===T&&g.scopes===m);u>-1&&(v.splice(u),this.f.set(h,v))}return o}}async g(S,T,N,w,h={}){await this.a.$ensureProvider(N);const v=S.displayName||S.name;return this.a.$getSession(N,w,T,v,h)}async removeSession(S,T){const N=this.b.get(S);return N?N.provider.removeSession(T):this.a.$removeSession(S,T)}registerAuthenticationProvider(S,T,N,w){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:T,provider:N,options:w??{supportsMultipleAccounts:!1}}),this.c.find(v=>v.id===S)||this.c.push({id:S,label:T});const h=N.onDidChangeSessions(v=>{this.a.$sendDidChangeSessions(S,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this.a.$registerAuthenticationProvider(S,T,w?.supportsMultipleAccounts??!1),new D.Disposable(()=>{h.dispose(),this.b.delete(S);const v=this.c.findIndex(m=>m.id===S);v>-1&&this.c.splice(v),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,T){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,T){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,T){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,T){return this.d.fire({provider:{id:S,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(ke[205],Te([1,0,5,18,8]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(R,S){this.a=R.getProxy(n.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>S.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(R,S,T){const N=D.WorkspaceEdit.from(R,this.b);return this.a.$tryApplyWorkspaceEdit(N,void 0,T?.isRefactoring??!1)}};M=qe([Ve(0,k.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(ke[206],Te([1,0,5]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(M){const y=M.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(R){return y.$writeText(R)}})}}e.ExtHostClipboard=k});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(ke[37],Te([1,0,9,7,8,22,5,16,11,66,44,259,2,6,3,18,101,23,46,39,77,52,57]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o,u,g,E,L,p,t){"use strict";var d,r,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let c=class{constructor(C,j,_){d.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),l.set(this,void 0),Je(this,d,C.getProxy(y.MainContext.MainThreadCommands),"f"),this.d=j,Je(this,l,_,"f"),Je(this,r,C.getProxy(y.MainContext.MainThreadTelemetry),"f"),this.converter=new b(this,K=>{const A=this.c.get(K);return A?.result===s.Void?A:void 0},j),this.f=[{processArgument(K){return(0,T.revive)(K)}},{processArgument(K){return(0,M.cloneAndChange)(K,function(A){if(N.Range.isIRange(A))return D.Range.to(A);if(w.Position.isIPosition(A))return D.Position.to(A);if(N.Range.isIRange(A.range)&&h.URI.isUri(A.uri))return D.location.to(A);if(A instanceof u.VSBuffer)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const j=this.registerCommand(!1,C.id,async(..._)=>{const K=C.args.map(($,O)=>{if(!$.validate(_[O]))throw new Error(`Invalid argument '${$.name}' when running '${C.id}', received: ${_[O]}`);return $.convert(_[O])}),A=await this.executeCommand(C.internalId,...K);return C.result.convert(A,_,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new k.Disposable(()=>{j.dispose(),this.c.delete(C.id)})}registerCommand(C,j,_,K,A,$){if(this.d.trace("ExtHostCommands#registerCommand",j),!j.trim().length)throw new Error("invalid id");if(this.b.has(j))throw new Error(`command '${j}' already exists`);return this.b.set(j,{callback:_,thisArg:K,description:A,extension:$}),C&&Le(this,d,"f").$registerCommand(j),new k.Disposable(()=>{this.b.delete(j)&&C&&Le(this,d,"f").$unregisterCommand(j)})}executeCommand(C,...j){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,j,!0)}async g(C,j,_){if(this.b.has(C))return Le(this,d,"f").$fireCommandActivationEvent(C),this.h(C,j,!1);{let K=!1;const A=(0,M.cloneAndChange)(j,function($){if($ instanceof k.Position)return D.Position.from($);if($ instanceof k.Range)return D.Range.from($);if($ instanceof k.Location)return D.location.from($);if(k.NotebookRange.isNotebookRange($))return D.NotebookRange.from($);if($ instanceof ArrayBuffer)return K=!0,u.VSBuffer.wrap(new Uint8Array($));if($ instanceof Uint8Array)return K=!0,u.VSBuffer.wrap($);if($ instanceof u.VSBuffer)return K=!0,$;if(!Array.isArray($))return $});try{const $=await Le(this,d,"f").$executeCommand(C,K?new g.SerializableObjectWithBuffers(A):A,_);return(0,T.revive)($)}catch($){if($ instanceof Error&&$.message==="$executeCommand:retry")return this.g(C,j,!1);throw $}}}async h(C,j,_){const K=this.b.get(C);if(!K)throw new Error("Unknown command");const{callback:A,thisArg:$,description:O}=K;if(O)for(let H=0;H<O.args.length;H++)try{(0,n.validateConstraint)(j[H],O.args[H].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${O.args[H].name}' - ${O.args[H].description}`)}const F=L.StopWatch.create();try{return await A.apply($,j)}catch(H){if(C===this.converter.delegatingCommandId){const V=this.converter.getActualCommand(...j);V&&(C=V.command)}if(this.d.error(H,C,K.extension?.identifier),!_)throw H;if(K.extension?.identifier){const V=Le(this,l,"f").onExtensionError(K.extension.identifier,H);this.d.trace("forwarded error to extension?",V,K.extension?.identifier)}throw new class extends Error{constructor(){super((0,E.toErrorMessage)(H)),this.id=C,this.source=K.extension?.displayName??K.extension?.name}}}finally{this.j(K,C,F.elapsed())}}j(C,j,_){!C.extension||Le(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new p.TelemetryTrustedValue(j),duration:_})}$executeContributedCommand(C,...j){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const _=this.b.get(C);return _?(j=j.map(K=>this.f.reduce((A,$)=>$.processArgument(A,_.extension?.identifier),K)),this.h(C,j,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),Le(this,d,"f").$getCommands().then(j=>(C&&(j=j.filter(_=>_[0]!=="_")),j))}$getContributedCommandHandlerDescriptions(){const C=Object.create(null);for(const[j,_]of this.b){const{description:K}=_;K&&(C[j]=K)}return Promise.resolve(C)}};d=new WeakMap,r=new WeakMap,l=new WeakMap,c=qe([Ve(0,a.IExtHostRpcService),Ve(1,S.ILogService),Ve(2,t.IExtHostTelemetry)],c),e.ExtHostCommands=c,e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class b{constructor(C,j,_){this.d=C,this.f=j,this.g=_,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,j){if(!C)return;const _={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return _;const K=this.f(C.command);if(K)_.id=K.internalId,_.arguments=K.args.map((A,$)=>A.convert(C.arguments&&C.arguments[$]));else if((0,R.isNonEmptyArray)(C.arguments)){const A=`${C.command}/${++this.c}`;this.b.set(A,C),j.add((0,v.toDisposable)(()=>{this.b.delete(A),this.g.trace("CommandsConverter#DISPOSE",A)})),_.$ident=A,_.id=this.delegatingCommandId,_.arguments=[A],this.g.trace("CommandsConverter#CREATE",C.command,A)}return _}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const j=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],j?j.command:"MISSING"),j?this.d.executeCommand(j.command,...j.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.CommandsConverter=b;class i{constructor(C,j,_,K){this.name=C,this.description=j,this.validate=_,this.convert=K}optional(){return new i(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,j){return new i(C??this.name,j??this.description,this.validate,this.convert)}}i.Uri=new i("uri","Uri of a text document",P=>h.URI.isUri(P),P=>P),i.Position=new i("position","A position in a text document",P=>k.Position.isPosition(P),D.Position.from),i.Range=new i("range","A range in a text document",P=>k.Range.isRange(P),D.Range.from),i.Selection=new i("selection","A selection in a text document",P=>k.Selection.isSelection(P),D.Selection.from),i.Number=new i("number","",P=>typeof P=="number",P=>P),i.String=new i("string","",P=>typeof P=="string",P=>P),i.CallHierarchyItem=new i("item","A call hierarchy item",P=>P instanceof k.CallHierarchyItem,D.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",P=>P instanceof k.TypeHierarchyItem,D.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",P=>P instanceof o.TestItemImpl,D.TestItem.from),e.ApiCommandArgument=i;class s{constructor(C,j){this.description=C,this.convert=j}}s.Void=new s("no result",P=>P),e.ApiCommandResult=s;class f{constructor(C,j,_,K,A){this.id=C,this.internalId=j,this.description=_,this.args=K,this.result=A}}e.ApiCommand=f}),define(ke[207],Te([1,0,2,8,7,75,37,16,88,92,15]),function(te,e,n,k,D,M,y,R,S,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const w=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",v(k.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,o)=>{if((0,R.isFalsyOrEmpty)(a))return;class u extends D.SymbolInformation{static to(E){const L=new u(E.name,k.SymbolKind.to(E.kind),E.containerName||"",new D.Location(o[0],k.Range.to(E.range)));return L.detail=E.detail,L.range=L.location.range,L.selectionRange=k.Range.to(E.selectionRange),L.children=E.children?E.children.map(u.to):[],L}}return a.map(u.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",v(k.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",v(k.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(o=>D.Position.isPosition(o)),a=>a.map(k.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(o=>{let u;for(const g of o.reverse())u=new D.SelectionRange(k.Range.to(g),u);return u}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(k.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(k.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(k.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(k.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:k.Range.to(a.range),placeholder:a.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return k.WorkspaceEdit.to(a)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(k.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new D.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const o=(0,S.decodeSemanticTokensDto)(a);if(o.type==="full")return new D.SemanticTokens(o.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new D.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const o=(0,S.decodeSemanticTokensDto)(a);if(o.type==="full")return new D.SemanticTokens(o.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,o,u)=>{if(!a)return new D.CompletionList([]);const g=a.suggestions.map(E=>k.CompletionItem.to(E,u));return new D.CompletionList(g,a.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return k.SignatureHelp.to(a)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,o,u)=>v(g=>new D.CodeLens(k.Range.to(g.range),g.command&&u.fromInternal(g.command)))(a))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>D.Range.isRange(a),a=>D.Selection.isSelection(a)?k.Selection.from(a):k.Range.from(a)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,o,u)=>v(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(g.command)}else{const E=new D.CodeAction(g.title,g.kind?new D.CodeActionKind(g.kind):void 0);return g.edit&&(E.edit=k.WorkspaceEdit.to(g.edit)),g.command&&(E.command=u.fromInternal(g.command)),E.isPreferred=g.isPreferred,E}})(a))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(o=>new D.ColorInformation(k.Range.to(o.range),k.Color.to(o.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",a=>a instanceof D.Color,k.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:k.Range.from(a.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(k.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(a,o,u)=>a.map(k.InlayHint.to.bind(void 0,u)))),new y.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(a,o)=>{if(a)return a.map(k.FoldingRange.to)})),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",v(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(k.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",a=>n.URI.isUri(a)||typeof a=="string"&&(0,T.matchesSomeScheme)(a,N.Schemas.http,N.Schemas.https),a=>a),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[k.ViewColumn.from(a),void 0]:[k.ViewColumn.from(a.viewColumn),k.TextEditorOpenOptions.from(a)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[k.ViewColumn.from(a),void 0]:[k.ViewColumn.from(a.viewColumn),k.TextEditorOpenOptions.from(a)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[k.ViewColumn.from(a.viewColumn),k.TextEditorOpenOptions.from(a)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(k.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(k.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(k.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void),new y.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[y.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],y.ApiCommandResult.Void),new y.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[y.ApiCommandArgument.String.with("name","The context key name"),new y.ApiCommandArgument("value","The context key value",()=>!0,a=>a)],y.ApiCommandResult.Void)];class h{static register(o){w.forEach(o.registerApiCommand,o)}}e.ExtHostApiCommands=h;function v(a){return o=>{if(Array.isArray(o))return o.map(a)}}function m(a){if(!Array.isArray(a))return;const o=[];for(const u of a)M.isLocationLink(u)?o.push(k.DefinitionLink.to(u)):o.push(k.location.to(u));return o}}),define(ke[208],Te([1,0,17,64,4,6,2,75,26,8,7,5]),function(te,e,n,k,D,M,y,R,S,T,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function h(v,m,a){const o=v.getProxy(w.MainContext.MainThreadComments);class u{constructor(){this.b=new Map,this.c=new Map,m.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===6){const b=this.b.get(c.handle);return b?b.value:c}else if(c&&c.$mid===7){const b=this.b.get(c.commentControlHandle);if(!b)return c;const i=b.getCommentThread(c.commentThreadHandle);return i?i.value:c}else if(c&&(c.$mid===9||c.$mid===8)){const b=this.b.get(c.thread.commentControlHandle);if(!b)return c;const i=b.getCommentThread(c.thread.commentThreadHandle);return i?c.$mid===8?i.value:{thread:i.value,text:c.text}:c}else if(c&&c.$mid===10){const b=this.b.get(c.thread.commentControlHandle);if(!b)return c;const i=b.getCommentThread(c.thread.commentThreadHandle);if(!i)return c;const s=c.commentUniqueId,f=i.getCommentByUniqueId(s);return f||c}else if(c&&c.$mid===11){const b=this.b.get(c.thread.commentControlHandle);if(!b)return c;const i=b.getCommentThread(c.thread.commentThreadHandle);if(!i)return c;const s=c.text,f=c.commentUniqueId,P=i.getCommentByUniqueId(f);return P?(typeof P.body=="string"?P.body=s:P.body=new N.MarkdownString(s),P):c}return c}})}createCommentController(c,b,i){const s=u.a++,f=new E(c,s,b,i);this.b.set(f.handle,f);const P=this.c.get(S.ExtensionIdentifier.toKey(c.identifier))||[];return P.push(f),this.c.set(S.ExtensionIdentifier.toKey(c.identifier),P),f.value}$createCommentThreadTemplate(c,b,i){const s=this.b.get(c);!s||s.$createCommentThreadTemplate(b,i)}async $updateCommentThreadTemplate(c,b,i){const s=this.b.get(c);!s||s.$updateCommentThreadTemplate(b,i)}$deleteCommentThread(c,b){this.b.get(c)?.$deleteCommentThread(b)}$provideCommentingRanges(c,b,i){const s=this.b.get(c);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const f=a.getDocument(y.URI.revive(b));return(0,n.asPromise)(()=>s.commentingRangeProvider.provideCommentingRanges(f,i)).then(P=>P?P.map(C=>T.Range.from(C)):void 0)}$toggleReaction(c,b,i,s,f){const P=this.b.get(c);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const C=P.getCommentThread(b);if(C){const j=C.getCommentByUniqueId(s.uniqueIdInThread);if(P!==void 0&&j&&P.reactionHandler)return P.reactionHandler(j,t(f))}return Promise.resolve(void 0)})}dispose(){}}u.a=0;class g{set threadId(c){this.n=c}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(c){c.isEqual(this.p)||(this.p=c,this.b.range=c,this.c.fire())}get range(){return this.p}set canReply(c){this.d!==c&&(this.d=c,this.b.canReply=c,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(c){this.e=c,this.b.label=c,this.c.fire()}get contextValue(){return this.f}set contextValue(c){this.f=c,this.b.contextValue=c,this.c.fire()}get comments(){return this.q}set comments(c){this.q=c,this.b.comments=c,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(c){this.g=c,this.b.collapsibleState=c,this.c.fire()}get state(){return this.h}set state(c){this.h=c,this.b.state=c,this.c.fire()}get isDisposed(){return this.j}constructor(c,b,i,s,f,P,C,j){this.m=b,this.n=i,this.o=s,this.p=f,this.q=P,this.extensionDescription=C,this.r=j,this.handle=g.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new D.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.MutableDisposable,this.l.value=new M.DisposableStore,this.n===void 0&&(this.n=`${c}.${this.handle}`),o.$createCommentThread(b,this.handle,this.n,this.o,T.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{o.$deleteCommentThread(b,this.handle)}});const _=this;this.value={get uri(){return _.uri},get range(){return _.range},set range(K){_.range=K},get comments(){return _.comments},set comments(K){_.comments=K},get collapsibleState(){return _.collapsibleState},set collapsibleState(K){_.collapsibleState=K},get canReply(){return _.canReply},set canReply(K){_.canReply=K},get contextValue(){return _.contextValue},set contextValue(K){_.contextValue=K},get label(){return _.label},set label(K){_.label=K},get state(){return _.state},set state(K){_.state=K},dispose:()=>{_.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.DisposableStore);const c=i=>Object.prototype.hasOwnProperty.call(this.b,i),b={};c("range")&&(b.range=T.Range.from(this.p)),c("label")&&(b.label=this.label),c("contextValue")&&(b.contextValue=this.contextValue??null),c("comments")&&(b.comments=this.q.map(i=>L(this,i,this.k))),c("collapsibleState")&&(b.collapseState=d(this.g)),c("canReply")&&(b.canReply=this.canReply),c("state")&&(b.state=r(this.h)),c("isTemplate")&&(b.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,b)}getCommentByUniqueId(c){for(const b of this.k){const i=b[0],s=b[1];if(c===s)return i}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(c=>c.dispose())}}g.a=0,qe([(0,k.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(c){this.b=c,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(c){this.c=c,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this.d}set options(c){this.d=c,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(c,b,i,s){this.f=c,this.g=b,this.h=i,this.i=s,this.a=new Map,o.$registerCommentController(this.handle,i,s);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(P){f.options=P},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(P){f.commentingRangeProvider=P},get reactionHandler(){return f.reactionHandler},set reactionHandler(P){f.reactionHandler=P},createCommentThread(P,C,j){return f.createCommentThread(P,C,j).value},dispose:()=>{f.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(c,b,i,s){if(typeof c=="string"){const f=new g(this.id,this.handle,c,b,i,s,this.f,!1);return this.a.set(f.handle,f),f}else{const f=new g(this.id,this.handle,void 0,c,b,i,this.f,!1);return this.a.set(f.handle,f),f}}$createCommentThreadTemplate(c,b){const i=new g(this.id,this.handle,void 0,y.URI.revive(c),T.Range.to(b),[],this.f,!0);return i.collapsibleState=R.CommentThreadCollapsibleState.Expanded,this.a.set(i.handle,i),i}$updateCommentThreadTemplate(c,b){const i=this.a.get(c);i&&(i.range=T.Range.to(b))}$deleteCommentThread(c){this.a.get(c)?.dispose(),this.a.delete(c)}getCommentThread(c){return this.a.get(c)}dispose(){this.a.forEach(c=>{c.dispose()}),this.e.forEach(c=>c.dispose())}}function L(l,c,b){let i=b.get(c);i||(i=++l.commentHandle,b.set(c,i));const s=c.author&&c.author.iconPath?c.author.iconPath.toString():void 0;return{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:i,body:typeof c.body=="string"?c.body:T.MarkdownString.from(c.body),userName:c.author.name,userIconPath:s,label:c.label,commentReactions:c.reactions?c.reactions.map(f=>p(f)):void 0,timestamp:c.timestamp?.toJSON()}}function p(l){return{label:l.label,iconPath:l.iconPath?T.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function t(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?y.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function d(l){if(l!==void 0)switch(l){case N.CommentThreadCollapsibleState.Expanded:return R.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return R.CommentThreadCollapsibleState.Collapsed}return R.CommentThreadCollapsibleState.Collapsed}function r(l){if(l!==void 0)switch(l){case N.CommentThreadState.Unresolved:return R.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return R.CommentThreadState.Resolved}return R.CommentThreadState.Unresolved}return new u}e.createExtHostComments=h}),define(ke[209],Te([1,0,22,5,27,18]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let y=class{constructor(N,w){this.a=N.getProxy(k.MainContext.MainThreadConsole),this.b=w.consoleForward.includeStack,this.c=w.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(N,w){const h=this,v=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){h.e(N,w,v,arguments)}})}e(N,w,h,v){this.a.$logExtensionHostMessage({type:"__$console",severity:w,arguments:S(v,this.b)}),this.c&&this.f(N,h,v)}};y=qe([Ve(0,M.IExtHostRpcService),Ve(1,D.IExtHostInitDataService)],y),e.AbstractExtHostConsoleForwarder=y;const R=1e5;function S(T,N){const w=[];if(T.length)for(let h=0;h<T.length;h++){let v=T[h];if(typeof v>"u")v="undefined";else if(v instanceof Error){const m=v;m.stack?v=m.stack:v=m.toString()}w.push(v)}if(N){const h=new Error().stack;h&&w.push({__$stack:h.split(`
`).slice(3).join(`
`)})}try{const h=(0,n.safeStringify)(w);return h.length>R?"Output omitted for a large object that exceeds the limits":h}catch(h){return`Output omitted for an object that cannot be inspected ('${h.toString()}')`}}}),define(ke[103],Te([1,0,2,5,7,3,18,11,16,10,19,25]),function(te,e,n,k,D,M,y,R,S,T,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let h=class Mi{constructor(m,a){this.h=a,this.f=new Map,this.g=m.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,a){const o=Mi.c++;this.f.set(o,{provider:m,extensionDescription:a}),this.g.$registerDecorationProvider(o,a.identifier.value);const u=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(g=>{if(!g){this.g.$onDidChange(o,null);return}const E=(0,S.asArray)(g);if(E.length<=Mi.d){this.g.$onDidChange(o,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,E.length);const L=E.map(d=>({uri:d,rank:(0,T.count)(d.path,"/")})),p=(0,S.groupBy)(L,(d,r)=>d.rank-r.rank||(0,T.compare)(d.uri.path,r.uri.path)),t=[];e:for(const d of p){let r;for(const l of d){const c=(0,N.dirname)(l.uri.path);if(r!==c&&(r=c,t.push(l.uri)>=Mi.d))break e}}this.g.$onDidChange(o,t)});return new D.Disposable(()=>{u?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(m,a,o){if(!this.f.has(m))return Object.create(null);const u=Object.create(null),{provider:g,extensionDescription:E}=this.f.get(m);return await Promise.all(a.map(async L=>{try{const{uri:p,id:t}=L,d=await Promise.resolve(g.provideFileDecoration(n.URI.revive(p),o));if(!d)return;try{D.FileDecoration.validate(d),d.badge&&typeof d.badge!="string"&&(0,w.checkProposedApiEnabled)(E,"codiconDecoration"),u[t]=[d.propagate,d.tooltip,d.badge,d.color]}catch(r){this.h.warn(`INVALID decoration from extension '${E}': ${r}`)}}catch(p){this.h.error(p)}})),u}};h.c=0,h.d=250,h=qe([Ve(0,y.IExtHostRpcService),Ve(1,R.ILogService)],h),e.ExtHostDecorations=h,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(ke[210],Te([1,0,139,91,2,5,7,8,4,11,28,36]),function(te,e,n,k,D,M,y,R,S,T,N,w){"use strict";var h,v,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class a{constructor(g,E,L,p,t,d,r){this.d=g,this.e=E,this.f=L,this.g=p,h.set(this,void 0),v.set(this,void 0),m.set(this,void 0),this.c=!1,Je(this,m,new N.ResourceMap(l=>t.getComparisonKey(l)),"f"),Je(this,h,d,"f"),Je(this,v,r,"f")}dispose(){this.c||(Le(this,v,"f").fire([...Le(this,m,"f").keys()]),Le(this,h,"f")?.$clear(this.e),Le(this,m,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(g,E){if(!g){this.clear();return}this.h();let L=[];if(D.URI.isUri(g)){if(!E){this.delete(g);return}Le(this,m,"f").set(g,E.slice()),L=[g]}else if(Array.isArray(g)){L=[];let t;g=[...g].sort(a.j);for(const d of g){const[r,l]=d;if((!t||r.toString()!==t.toString())&&(t&&Le(this,m,"f").get(t).length===0&&Le(this,m,"f").delete(t),t=r,L.push(r),Le(this,m,"f").set(r,[])),l)Le(this,m,"f").get(r)?.push(...l);else{const c=Le(this,m,"f").get(r);c&&(c.length=0)}}}if(Le(this,v,"f").fire(L),!Le(this,h,"f"))return;const p=[];for(const t of L){let d=[];const r=Le(this,m,"f").get(t);if(r)if(r.length>this.f){d=[];const l=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const b of r)if(b.severity===l[c]&&d.push({...R.Diagnostic.from(b),modelVersionId:this.g(t)})===this.f)break e;d.push({severity:k.MarkerSeverity.Info,message:(0,n.localize)(0,null,r.length-this.f),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=r.map(l=>({...R.Diagnostic.from(l),modelVersionId:this.g(t)}));p.push([t,d])}Le(this,h,"f").$changeMany(this.e,p)}delete(g){this.h(),Le(this,v,"f").fire([g]),Le(this,m,"f").delete(g),Le(this,h,"f")?.$changeMany(this.e,[[g,void 0]])}clear(){this.h(),Le(this,v,"f").fire([...Le(this,m,"f").keys()]),Le(this,m,"f").clear(),Le(this,h,"f")?.$clear(this.e)}forEach(g,E){this.h();for(const[L,p]of this)g.call(E,L,p,this)}*[(h=new WeakMap,v=new WeakMap,m=new WeakMap,Symbol.iterator)](){this.h();for(const g of Le(this,m,"f").keys())yield[g,this.get(g)]}get(g){this.h();const E=Le(this,m,"f").get(g);return Array.isArray(E)?Object.freeze(E.slice(0)):[]}has(g){return this.h(),Array.isArray(Le(this,m,"f").get(g))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(g,E){return g[0].toString()<E[0].toString()?-1:g[0].toString()>E[0].toString()?1:0}}e.DiagnosticCollection=a;let o=class pi{static _mapper(g){const E=new N.ResourceMap;for(const L of g)E.set(L,L);return{uris:Object.freeze(Array.from(E.values()))}}constructor(g,E,L,p){this.h=E,this.j=L,this.k=p,this.f=new Map,this.g=new S.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,pi._mapper),this.e=g.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(g,E){const{f:L,e:p,g:t,h:d,j:r,k:l}=this,c=new class{$changeMany(s,f){p.$changeMany(s,f),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,s,f.length===0?"CLEARING":f)}$clear(s){p.$clear(s),d.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,s)}dispose(){p.dispose()}};let b;if(!E)E="_generated_diagnostic_collection_name_#"+pi.c++,b=E;else if(!L.has(E))b=E;else{this.h.warn(`DiagnosticCollection with name '${E}' does already exist.`);do b=E+pi.c++;while(L.has(b))}return new class extends a{constructor(){super(E,b,pi.d,s=>l.getDocument(s)?.version,r.extUri,c,t),L.set(b,this)}dispose(){super.dispose(),L.delete(b)}}}getDiagnostics(g){if(g)return this.l(g);{const E=new Map,L=[];for(const p of this.f.values())p.forEach((t,d)=>{let r=E.get(t.toString());typeof r>"u"&&(r=L.length,E.set(t.toString(),r),L.push([t,[]])),L[r][1]=L[r][1].concat(...d)});return L}}l(g){let E=[];for(const L of this.f.values())L.has(g)&&(E=E.concat(L.get(g)));return E}$acceptMarkersChange(g){if(!this.m){const E="_generated_mirror",L=new a(E,E,pi.d,p=>{},this.j.extUri,void 0,this.g);this.f.set(E,L),this.m=L}for(const[E,L]of g)this.m.set(D.URI.revive(E),L.map(R.Diagnostic.to))}};o.c=0,o.d=1e3,o=qe([Ve(1,T.ILogService),Ve(2,w.IExtHostFileSystemInfo)],o),e.ExtHostDiagnostics=o}),define(ke[211],Te([1,0,2,5,25]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class M{constructor(R){this.a=R.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(R,S){return S?.allowUIResources&&(0,D.checkProposedApiEnabled)(R,"showLocal"),this.a.$showOpenDialog(S).then(T=>T?T.map(N=>n.URI.revive(N)):void 0)}showSaveDialog(R){return this.a.$showSaveDialog(R).then(S=>S?n.URI.revive(S):void 0)}}e.ExtHostDialogs=M}),define(ke[212],Te([1,0,12,2,7,5,15,21,10]),function(te,e,n,k,D,M,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(w,h,v){this.d=h,this.e=v,this.b=new Map,this.c=w.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,h){if(Object.keys(y.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const v=T.a++;this.b.set(v,h),this.c.$registerTextContentProvider(v,w);let m;return typeof h.onDidChange=="function"&&(m=h.onDidChange(a=>{if(a.scheme!==w){this.e.warn(`Provider for scheme '${w}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this.d.getDocument(a)&&this.$provideTextDocumentContent(v,a).then(o=>{if(!o&&typeof o!="string")return;const u=this.d.getDocument(a);if(!u)return;const g=(0,S.splitLines)(o);if(!u.equalLines(g))return this.c.$onVirtualDocumentChange(a,o)},n.onUnexpectedError)})),new D.Disposable(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(w,h){const v=this.b.get(w);return v?Promise.resolve(v.provideTextDocumentContent(k.URI.revive(h),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}T.a=0,e.ExtHostDocumentContentProvider=T}),define(ke[213],Te([1,0,4,6,2,5,99,8,9,22,7]),function(te,e,n,k,D,M,y,R,S,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(v,m){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new k.DisposableStore,this.h=new Map,this.f=v.getProxy(M.MainContext.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(a=>{for(const o of a)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const o of a)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const m=this.g.getDocument(v);if(m)return m}getDocument(v){const m=this.getDocumentData(v);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return m.document}ensureDocumentData(v){const m=this.g.getDocument(v);if(m)return Promise.resolve(m);let a=this.h.get(v.toString());return a||(a=this.f.$tryOpenDocument(v).then(o=>{this.h.delete(v.toString());const u=D.URI.revive(o);return(0,S.assertIsDefined)(this.g.getDocument(u))},o=>(this.h.delete(v.toString()),Promise.reject(o))),this.h.set(v.toString(),a)),a}createDocumentData(v){return this.f.$tryCreateDocument(v).then(m=>D.URI.revive(m))}$acceptModelLanguageChanged(v,m){const a=D.URI.revive(v),o=this.g.getDocument(a);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(m),this.a.fire(o.document)}$acceptModelSaved(v){const m=D.URI.revive(v),a=this.g.getDocument(m);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(v,m){const a=D.URI.revive(v),o=this.g.getDocument(a);if(!o)throw new Error("unknown document");o._acceptIsDirty(m),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,m,a){const o=D.URI.revive(v),u=this.g.getDocument(o);if(!u)throw new Error("unknown document");u._acceptIsDirty(a),u.onEvents(m);let g;m.isUndoing?g=N.TextDocumentChangeReason.Undo:m.isRedoing&&(g=N.TextDocumentChangeReason.Redo),this.c.fire((0,T.deepFreeze)({document:u.document,contentChanges:m.changes.map(E=>({range:R.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:g}))}setWordDefinitionFor(v,m){(0,y.setWordDefinitionFor)(v,m)}}e.ExtHostDocuments=w}),define(ke[58],Te([1,0,49,4,6,2,3,5,99,18,102,8,11,28,15,185,85]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class u{constructor(L){this.value=L,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let g=class{constructor(L,p){this.h=L,this.i=p,this.a=null,this.b=new Map,this.c=new v.ResourceMap,this.d=new k.Emitter,this.e=new k.Emitter,this.f=new k.Emitter,this.g=new k.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(L){this.acceptDocumentsAndEditorsDelta(L)}acceptDocumentsAndEditorsDelta(L){const p=[],t=[],d=[];if(L.removedDocuments)for(const r of L.removedDocuments){const l=M.URI.revive(r),c=this.c.get(l);c?.unref()&&(this.c.delete(l),p.push(c.value))}if(L.addedDocuments)for(const r of L.addedDocuments){const l=M.URI.revive(r.uri);let c=this.c.get(l);if(c&&l.scheme!==m.Schemas.vscodeNotebookCell&&l.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);c||(c=new u(new S.ExtHostDocumentData(this.h.getProxy(R.MainContext.MainThreadDocuments),l,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(l,c),t.push(c.value)),c.ref()}if(L.removedEditors)for(const r of L.removedEditors){const l=this.b.get(r);this.b.delete(r),l&&d.push(l)}if(L.addedEditors)for(const r of L.addedEditors){const l=M.URI.revive(r.documentUri);n.ok(this.c.has(l),`document '${l}' does not exist`),n.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const c=this.c.get(l).value,b=new N.ExtHostTextEditor(r.id,this.h.getProxy(R.MainContext.MainThreadTextEditors),this.i,new o.Lazy(()=>c.document),r.selections.map(w.Selection.to),r.options,r.visibleRanges.map(i=>w.Range.to(i)),typeof r.editorPosition=="number"?w.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,b)}L.newActiveEditor!==void 0&&(n.ok(L.newActiveEditor===null||this.b.has(L.newActiveEditor),`active editor '${L.newActiveEditor}' does not exist`),this.a=L.newActiveEditor),(0,D.dispose)(p),(0,D.dispose)(d),L.removedDocuments&&this.e.fire(p),L.addedDocuments&&this.d.fire(t),(L.removedEditors||L.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),L.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(L){return this.c.get(L)?.value}allDocuments(){return a.Iterable.map(this.c.values(),L=>L.value)}getEditor(L){return this.b.get(L)}activeEditor(L){if(!this.a)return;const p=this.b.get(this.a);return L?p:p?.value}allEditors(){return[...this.b.values()]}};g=qe([Ve(0,T.IExtHostRpcService),Ve(1,h.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(ke[59],Te([1,0,8,5,2,4,3,7,18,9,63]),function(te,e,n,k,D,M,y,R,S,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");class w{constructor(o,u,g){this.e=g,this.d=u,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,u={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(u)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.TextTabInput(D.URI.revive(this.b.input.uri));case 2:return new R.TextDiffTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified));case 3:return new R.TextMergeTabInput(D.URI.revive(this.b.input.base),D.URI.revive(this.b.input.input1),D.URI.revive(this.b.input.input2),D.URI.revive(this.b.input.result));case 6:return new R.CustomEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.WebviewEditorTabInput(this.b.input.viewType);case 4:return new R.NotebookEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.NotebookDiffEditorTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.TerminalEditorTabInput;case 9:return new R.InteractiveWindowInput(D.URI.revive(this.b.input.uri),D.URI.revive(this.b.input.inputBoxUri));default:return}}}class h{constructor(o,u){this.c=[],this.d="",this.b=o,this.e=u;for(const g of o.tabs)g.isActive&&(this.d=g.id),this.c.push(new w(g,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,u={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return n.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(g=>g.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(g=>g.apiObject))}};this.a=Object.freeze(u)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const g=new w(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,g),o.tabDto.isActive&&(this.d=g.tabId),g}else if(o.kind===1){const g=this.c.splice(o.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return g.tabId===this.d&&(this.d=""),g}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this.c.splice(o.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,g),g}const u=this.c.find(g=>g.tabId===o.tabDto.id);if(!u)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),u.acceptDtoUpdate(o.tabDto),u}activeTabId(){return this.d}}let v=class{constructor(o){this.b=new M.Emitter,this.c=new M.Emitter,this.e=[],this.a=o.getProxy(k.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,u={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(g=>g.apiObject))},get activeTabGroup(){const g=o.d;return(0,T.assertIsDefined)(o.e.find(L=>L.groupId===g)?.apiObject)},close:async(g,E)=>{const L=Array.isArray(g)?g:[g];return L.length?m(L[0])?this.j(L,E):this.i(L,E):!0}};this.f=Object.freeze(u)}return this.f}$acceptEditorTabModel(o){const u=new Set(this.e.map(r=>r.groupId)),g=new Set(o.map(r=>r.groupId)),E=(0,N.diffSets)(u,g),L=this.e.filter(r=>E.removed.includes(r.groupId)).map(r=>r.apiObject),p=[],t=[];this.e=o.map(r=>{const l=new h(r,()=>this.d);return E.added.includes(l.groupId)?p.push(l.apiObject):t.push(l.apiObject),l});const d=(0,T.assertIsDefined)(o.find(r=>r.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:p,closed:L,changed:t}))}$acceptTabGroupUpdate(o){const u=this.e.find(g=>g.groupId===o.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const u=this.e.find(E=>E.groupId===o.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const g=u.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}g(o){for(const u of this.e)for(const g of u.tabs)if(g.apiObject===o)return g}h(o){return this.e.find(u=>u.apiObject===o)}async i(o,u){const g=[];for(const E of o){const L=this.g(E);if(!L)throw new Error("Tab close: Invalid tab not found!");g.push(L.tabId)}return this.a.$closeTab(g,u)}async j(o,u){const g=[];for(const E of o){const L=this.h(E);if(!L)throw new Error("Group close: Invalid group not found!");g.push(L.groupId)}return this.a.$closeGroup(g,u)}};v=qe([Ve(0,S.IExtHostRpcService)],v),e.ExtHostEditorTabs=v;function m(a){return a.tabs!==void 0}}),define(ke[214],Te([1,0,2,5,6,7,8,260,10,23,25]),function(te,e,n,k,D,M,y,R,S,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this.a=[]}add(m){this.b=void 0,this.a.push(m)}delete(m){const a=this.a.indexOf(m);a>=0&&(this.a.splice(a,1),this.b=void 0)}c(){if(!this.b){const m=this.a.sort(),a=[];let o,u,g=14,E=14;for(const L of m){let p=o?(0,S.commonPrefixLength)(o,L):0;for(p===0?u=1:u=E;p<L.length;p++)p+1===L.length?(g=E,E=9):E+=1,a.push([u,L.toUpperCase().charCodeAt(p),E]),a.push([u,L.toLowerCase().charCodeAt(p),E]),u=E;o=L,E=g}a.push([9,58,10]),a.push([10,47,12]),this.b=new R.StateMachine(a)}}provideDocumentLinks(m){this.c();const a=[],o=R.LinkComputer.computeLinks({getLineContent(u){return m.lineAt(u-1).text},getLineCount(){return m.lineCount}},this.b);for(const u of o){const g=y.DocumentLink.to(u);g.target&&a.push(g)}return a}}class h{constructor(m,a){this.i=a,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=m.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(m,a,o,u={}){if(this.d.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(m,"*",this.b));const g=this.h++;this.b.add(a),this.d.add(a),this.c.set(g,o);let E=2;u.isCaseSensitive&&(E+=1024),u.isReadonly&&(E+=2048),typeof o.copy=="function"&&(E+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,N.checkProposedApiEnabled)(m,"fsChunks"),E+=4),this.a.$registerFileSystemProvider(g,a,E).catch(p=>{console.error(`FAILED to register filesystem provider of ${m.identifier.value}-extension for the scheme ${a}`),console.error(p)});const L=o.onDidChangeFile(p=>{const t=[];for(const d of p){const{uri:r,type:l}=d;if(r.scheme!==a)continue;let c;switch(l){case M.FileChangeType.Changed:c=0;break;case M.FileChangeType.Created:c=1;break;case M.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:c})}this.a.$onFileSystemChange(g,t)});return(0,D.toDisposable)(()=>{L.dispose(),this.b.delete(a),this.d.delete(a),this.c.delete(g),this.a.$unregisterProvider(g)})}static j(m){const{type:a,ctime:o,mtime:u,size:g,permissions:E}=m;return{type:a,ctime:o,mtime:u,size:g,permissions:E}}$stat(m,a){return Promise.resolve(this.k(m).stat(n.URI.revive(a))).then(o=>h.j(o))}$readdir(m,a){return Promise.resolve(this.k(m).readDirectory(n.URI.revive(a)))}$readFile(m,a){return Promise.resolve(this.k(m).readFile(n.URI.revive(a))).then(o=>T.VSBuffer.wrap(o))}$writeFile(m,a,o,u){return Promise.resolve(this.k(m).writeFile(n.URI.revive(a),o.buffer,u))}$delete(m,a,o){return Promise.resolve(this.k(m).delete(n.URI.revive(a),o))}$rename(m,a,o,u){return Promise.resolve(this.k(m).rename(n.URI.revive(a),n.URI.revive(o),u))}$copy(m,a,o,u){const g=this.k(m);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(n.URI.revive(a),n.URI.revive(o),u))}$mkdir(m,a){return Promise.resolve(this.k(m).createDirectory(n.URI.revive(a)))}$watch(m,a,o,u){const g=this.k(m).watch(n.URI.revive(o),u);this.f.set(a,g)}$unwatch(m,a){const o=this.f.get(a);o&&(o.dispose(),this.f.delete(a))}$open(m,a,o){const u=this.k(m);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(n.URI.revive(a),o))}$close(m,a){const o=this.k(m);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(a))}$read(m,a,o,u){const g=this.k(m);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const E=T.VSBuffer.alloc(u);return Promise.resolve(g.read(a,o,E.buffer,0,u)).then(L=>E.slice(0,L))}$write(m,a,o,u){const g=this.k(m);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(a,o,u.buffer,0,u.byteLength))}k(m){const a=this.c.get(m);if(!a){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return a}}e.ExtHostFileSystem=h}),define(ke[60],Te([1,0,5,43,7,23,3,18,36,6]),function(te,e,n,k,D,M,y,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class Yt{constructor(h,v){this.b=new Map,this.a=h.getProxy(n.MainContext.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(a){try{const o=m.b.get(a.scheme);if(!o)return await m.a.$stat(a);await m.a.$ensureActivation(a.scheme);const u=await o.stat(a);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions}}catch(o){Yt.c(o)}},async readDirectory(a){try{const o=m.b.get(a.scheme);return o?(await m.a.$ensureActivation(a.scheme),(await o.readDirectory(a)).slice()):await m.a.$readdir(a)}catch(o){return Yt.c(o)}},async createDirectory(a){try{return await m.a.$mkdir(a)}catch(o){return Yt.c(o)}},async readFile(a){try{const o=m.b.get(a.scheme);return o?(await m.a.$ensureActivation(a.scheme),(await o.readFile(a)).slice()):(await m.a.$readFile(a)).buffer}catch(o){return Yt.c(o)}},async writeFile(a,o){try{return await m.a.$writeFile(a,M.VSBuffer.wrap(o))}catch(u){return Yt.c(u)}},async delete(a,o){try{const u=m.b.get(a.scheme);return u?(await m.a.$ensureActivation(a.scheme),await u.delete(a,{recursive:!1,...o})):await m.a.$delete(a,{recursive:!1,useTrash:!1,...o})}catch(u){return Yt.c(u)}},async rename(a,o,u){try{return await m.a.$rename(a,o,{overwrite:!1,...u})}catch(g){return Yt.c(g)}},async copy(a,o,u){try{return await m.a.$copy(a,o,{overwrite:!1,...u})}catch(g){return Yt.c(g)}},isWritableFileSystem(a){const o=v.getCapabilities(a);if(typeof o=="number")return!(o&2048)}})}static c(h){if(h instanceof D.FileSystemError)throw h;if(!(h instanceof Error))throw new D.FileSystemError(String(h));if(h.name==="ENOPRO"||h.message.includes("ENOPRO"))throw D.FileSystemError.Unavailable(h.message);switch(h.name){case k.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(h.message);case k.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(h.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(h.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(h.message);case k.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(h.message);case k.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(h.message);default:throw new D.FileSystemError(h.message,h.name)}}addFileSystemProvider(h,v){return this.b.set(h,v),(0,T.toDisposable)(()=>this.b.delete(h))}};N=qe([Ve(0,R.IExtHostRpcService),Ve(1,S.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(ke[215],Te([1,0,4,35,2,5,8,7]),function(te,e,n,k,D,M,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(w,h,v,m,a,o,u,g){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter;const E=this.h(w,v,a);this.g=0,o&&(this.g+=1),u&&(this.g+=2),g&&(this.g+=4);const L=(0,k.parse)(a),p=typeof a=="string",t=m(d=>{if(!o)for(const r of d.created){const l=D.URI.revive(r);L(l.fsPath)&&(!p||h.getWorkspaceFolder(l))&&this.a.fire(l)}if(!u)for(const r of d.changed){const l=D.URI.revive(r);L(l.fsPath)&&(!p||h.getWorkspaceFolder(l))&&this.b.fire(l)}if(!g)for(const r of d.deleted){const l=D.URI.revive(r);L(l.fsPath)&&(!p||h.getWorkspaceFolder(l))&&this.c.fire(l)}});this.d=R.Disposable.from(E,this.a,this.b,this.c,t)}h(w,h,v){const m=R.Disposable.from();if(typeof v=="string")return m;const a=w.getProxy(M.MainContext.MainThreadFileSystem);let o=!1;(v.pattern.includes(k.GLOBSTAR)||v.pattern.includes(k.GLOB_SPLIT))&&(o=!0);const u=Math.random();return a.$watch(h.identifier.value,u,v.baseUri,{recursive:o,excludes:[]}),R.Disposable.from({dispose:()=>a.$unwatch(u)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class T{constructor(w,h,v){this.j=w,this.k=h,this.l=v,this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.g=new n.AsyncEmitter,this.h=new n.AsyncEmitter,this.i=new n.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,h,v,m,a,o){return new S(this.j,w,h,this.a.event,y.GlobPattern.from(v),m,a,o)}$onFileEvent(w){this.a.fire(w)}$onDidRunFileOperation(w,h){switch(w){case 2:this.b.fire(Object.freeze({files:h.map(v=>({oldUri:D.URI.revive(v.source),newUri:D.URI.revive(v.target)}))}));break;case 1:this.d.fire(Object.freeze({files:h.map(v=>D.URI.revive(v.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:h.map(v=>D.URI.revive(v.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,h){return(v,m,a)=>{const o=function(g){v.call(m,g)};return o.extension=w,h.event(o,void 0,a)}}async $onWillRunFileOperation(w,h,v,m){switch(w){case 2:return await this.n(this.g,{files:h.map(a=>({oldUri:D.URI.revive(a.source),newUri:D.URI.revive(a.target)}))},v,m);case 1:return await this.n(this.i,{files:h.map(a=>D.URI.revive(a.target))},v,m);case 0:case 3:return await this.n(this.h,{files:h.map(a=>D.URI.revive(a.target))},v,m)}}async n(w,h,v,m){const a=new Set,o=[];if(await w.fireAsync(h,m,async(g,E)=>{const L=Date.now(),p=await Promise.resolve(g);p instanceof R.WorkspaceEdit&&(o.push([E.extension,p]),a.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-L>v&&this.k.warn("SLOW file-participant",E.extension.identifier)}),m.isCancellationRequested||o.length===0)return;const u={edits:[]};for(const[,g]of o){const{edits:E}=y.WorkspaceEdit.from(g,{getTextDocumentVersion:L=>this.l.getDocument(L)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(E)}return{edit:u,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=T}),define(ke[216],Te([1,0,2,37]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(y,R,S,T,N){this.a=R,this.b=S,this.c=T;const w=new k.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new k.ApiCommandArgument("showOptions","Show Options",h=>!0,h=>h),new k.ApiCommandArgument("resource","Interactive resource Uri",h=>!0,h=>h),new k.ApiCommandArgument("controllerId","Notebook controller Id",h=>!0,h=>h),new k.ApiCommandArgument("title","Interactive editor title",h=>!0,h=>h)],new k.ApiCommandResult("Notebook and input URI",h=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",h.notebookEditorId),h.notebookEditorId!==void 0){const v=this.a.getEditorById(h.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:n.URI.revive(h.notebookUri),inputUri:n.URI.revive(h.inputUri),notebookEditor:v.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",h.notebookUri,h.inputUri),{notebookUri:n.URI.revive(h.notebookUri),inputUri:n.URI.revive(h.inputUri)}}));this.c.registerApiCommand(w)}$willAddInteractiveDocument(y,R,S,T){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:S,uri:y,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(n.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=D}),define(ke[217],Te([1,0,6,5]),function(te,e,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(y){this.b=0,this.a=y.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,y),(0,n.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=D}),define(ke[218],Te([1,0,2,22,8,7,75,5,10,44,16,9,261,21,6,88,83,54,77,12,17,25]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o,u,g,E,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class t{constructor(I,B){this.d=I,this.e=B}async provideDocumentSymbols(I,B){const W=this.d.getDocument(I),q=await this.e.provideDocumentSymbols(W,B);if(!(0,N.isFalsyOrEmpty)(q))return q[0]instanceof M.DocumentSymbol?q.map(D.DocumentSymbol.from):t.f(q)}static f(I){I=I.slice(0).sort((q,ee)=>{let fe=q.location.range.start.compareTo(ee.location.range.start);return fe===0&&(fe=ee.location.range.end.compareTo(q.location.range.end)),fe});const B=[],W=[];for(const q of I){const ee={name:q.name||"!!MISSING: name!!",kind:D.SymbolKind.from(q.kind),tags:q.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:D.Range.from(q.location.range),selectionRange:D.Range.from(q.location.range),children:[]};for(;;){if(W.length===0){W.push(ee),B.push(ee);break}const fe=W[W.length-1];if(T.Range.containsRange(fe.range,ee.range)&&!T.Range.equalsRange(fe.range,ee.range)){fe.children?.push(ee),W.push(ee);break}W.pop()}}return B}}class d{constructor(I,B,W){this.g=I,this.h=B,this.j=W,this.e=new u.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(I,B){const W=this.g.getDocument(I),q=await this.j.provideCodeLenses(W,B);if(!q||B.isCancellationRequested)return;const ee=this.e.add(q),fe=new m.DisposableStore;this.f.set(ee,fe);const De={cacheId:ee,lenses:[]};for(let oe=0;oe<q.length;oe++)De.lenses.push({cacheId:[ee,oe],range:D.Range.from(q[oe].range),command:this.h.toInternal(q[oe].command,fe)});return De}async resolveCodeLens(I,B){const W=I.cacheId&&this.e.get(...I.cacheId);if(!W)return;let q;if(typeof this.j.resolveCodeLens!="function"||W.isResolved?q=W:q=await this.j.resolveCodeLens(W,B),q||(q=W),B.isCancellationRequested)return;const ee=I.cacheId&&this.f.get(I.cacheId[0]);if(!!ee)return I.command=this.h.toInternal(q.command??d.d,ee),I}releaseCodeLenses(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}}d.d={command:"missing",title:"!!MISSING: command!!"};function r(Z){return Array.isArray(Z)?Z.map(D.DefinitionLink.from):Z?[D.DefinitionLink.from(Z)]:[]}class l{constructor(I,B){this.d=I,this.e=B}async provideDefinition(I,B,W){const q=this.d.getDocument(I),ee=D.Position.to(B),fe=await this.e.provideDefinition(q,ee,W);return r(fe)}}class c{constructor(I,B){this.d=I,this.e=B}async provideDeclaration(I,B,W){const q=this.d.getDocument(I),ee=D.Position.to(B),fe=await this.e.provideDeclaration(q,ee,W);return r(fe)}}class b{constructor(I,B){this.d=I,this.e=B}async provideImplementation(I,B,W){const q=this.d.getDocument(I),ee=D.Position.to(B),fe=await this.e.provideImplementation(q,ee,W);return r(fe)}}class i{constructor(I,B){this.d=I,this.e=B}async provideTypeDefinition(I,B,W){const q=this.d.getDocument(I),ee=D.Position.to(B),fe=await this.e.provideTypeDefinition(q,ee,W);return r(fe)}}class s{constructor(I,B){this.d=I,this.e=B}async provideHover(I,B,W){const q=this.d.getDocument(I),ee=D.Position.to(B),fe=await this.e.provideHover(q,ee,W);if(!(!fe||(0,N.isFalsyOrEmpty)(fe.contents)))return fe.range||(fe.range=q.getWordRangeAtPosition(ee)),fe.range||(fe.range=new M.Range(ee,ee)),D.Hover.from(fe)}}class f{constructor(I,B){this.d=I,this.e=B}async provideEvaluatableExpression(I,B,W){const q=this.d.getDocument(I),ee=D.Position.to(B),fe=await this.e.provideEvaluatableExpression(q,ee,W);if(fe)return D.EvaluatableExpression.from(fe)}}class P{constructor(I,B){this.d=I,this.e=B}async provideInlineValues(I,B,W,q){const ee=this.d.getDocument(I),fe=await this.e.provideInlineValues(ee,D.Range.to(B),D.InlineValueContext.to(W),q);if(Array.isArray(fe))return fe.map(De=>D.InlineValue.from(De))}}class C{constructor(I,B){this.d=I,this.e=B}async provideDocumentHighlights(I,B,W){const q=this.d.getDocument(I),ee=D.Position.to(B),fe=await this.e.provideDocumentHighlights(q,ee,W);if(Array.isArray(fe))return fe.map(D.DocumentHighlight.from)}}class j{constructor(I,B){this.d=I,this.e=B}async provideLinkedEditingRanges(I,B,W){const q=this.d.getDocument(I),ee=D.Position.to(B),fe=await this.e.provideLinkedEditingRanges(q,ee,W);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,N.coalesce)(fe.ranges.map(D.Range.from)),wordPattern:fe.wordPattern}}}class _{constructor(I,B){this.d=I,this.e=B}async provideReferences(I,B,W,q){const ee=this.d.getDocument(I),fe=D.Position.to(B),De=await this.e.provideReferences(ee,fe,W,q);if(Array.isArray(De))return De.map(D.location.from)}}class K{constructor(I,B,W,q,ee,fe,De){this.g=I,this.h=B,this.j=W,this.k=q,this.l=ee,this.m=fe,this.n=De,this.e=new u.Cache("CodeAction"),this.f=new Map}async provideCodeActions(I,B,W,q){const ee=this.g.getDocument(I),fe=h.Selection.isISelection(B)?D.Selection.to(B):D.Range.to(B),De=[];for(const it of this.j.getDiagnostics(I))if(fe.intersection(it.range)&&De.push(it)>K.d)break;const oe={diagnostics:De,only:W.only?new M.CodeActionKind(W.only):void 0,triggerKind:D.CodeActionTriggerKind.to(W.trigger)},ve=await this.k.provideCodeActions(ee,fe,oe,q);if(!(0,N.isNonEmptyArray)(ve)||q.isCancellationRequested)return;const be=this.e.add(ve),He=new m.DisposableStore;this.f.set(be,He);const je=[];for(let it=0;it<ve.length;it++){const Xe=ve[it];!Xe||(K.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),je.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,He)})):(oe.only&&(Xe.kind?oe.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${oe.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),je.push({cacheId:[be,it],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,He),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(D.Diagnostic.from),edit:Xe.edit&&D.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:be,actions:je}}async resolveCodeAction(I,B){const[W,q]=I,ee=this.e.get(W,q);if(!ee||K.o(ee)||!this.k.resolveCodeAction)return;const fe=await this.k.resolveCodeAction(ee,B)??ee;return fe?.edit?D.WorkspaceEdit.from(fe.edit,void 0):void 0}releaseCodeActions(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}static o(I){return typeof I.command=="string"&&typeof I.title=="string"}}K.d=1e3;class A{constructor(I,B,W,q){this.d=I,this.e=B,this.f=W,this.g=q}async prepareDocumentPaste(I,B,W,q){if(!this.f.prepareDocumentPaste)return;const ee=this.e.getDocument(I),fe=B.map(oe=>D.Range.to(oe)),De=D.DataTransfer.toDataTransfer(W,()=>{throw new E.NotImplementedError});return await this.f.prepareDocumentPaste(ee,fe,De,q),D.DataTransfer.toDataTransferDTO(De)}async providePasteEdits(I,B,W,q,ee){const fe=this.e.getDocument(B),De=W.map(be=>D.Range.to(be)),oe=D.DataTransfer.toDataTransfer(q,async be=>(await this.d.$resolvePasteFileData(this.g,I,be)).buffer),ve=await this.f.provideDocumentPasteEdits(fe,De,oe,ee);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?D.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class ${constructor(I,B){this.d=I,this.e=B}async provideDocumentFormattingEdits(I,B,W){const q=this.d.getDocument(I),ee=await this.e.provideDocumentFormattingEdits(q,B,W);if(Array.isArray(ee))return ee.map(D.TextEdit.from)}}class O{constructor(I,B){this.d=I,this.e=B}async provideDocumentRangeFormattingEdits(I,B,W,q){const ee=this.d.getDocument(I),fe=D.Range.to(B),De=await this.e.provideDocumentRangeFormattingEdits(ee,fe,W,q);if(Array.isArray(De))return De.map(D.TextEdit.from)}}class F{constructor(I,B){this.d=I,this.e=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,B,W,q,ee){const fe=this.d.getDocument(I),De=D.Position.to(B),oe=await this.e.provideOnTypeFormattingEdits(fe,De,W,q,ee);if(Array.isArray(oe))return oe.map(D.TextEdit.from)}}class H{constructor(I,B){this.e=I,this.f=B,this.d=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,B){const W=await this.e.provideWorkspaceSymbols(I,B);if(!(0,N.isNonEmptyArray)(W))return{symbols:[]};const q=this.d.add(W),ee={cacheId:q,symbols:[]};for(let fe=0;fe<W.length;fe++){const De=W[fe];if(!De||!De.name){this.f.warn("INVALID SymbolInformation",De);continue}ee.symbols.push({...D.WorkspaceSymbol.from(De),cacheId:[q,fe]})}return ee}async resolveWorkspaceSymbol(I,B){if(typeof this.e.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const W=this.d.get(...I.cacheId);if(W){const q=await this.e.resolveWorkspaceSymbol(W,B);return q&&(0,k.mixin)(I,D.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(I){this.d.delete(I)}}class V{static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,B,W){this.d=I,this.e=B,this.f=W}async provideRenameEdits(I,B,W,q){const ee=this.d.getDocument(I),fe=D.Position.to(B);try{const De=await this.e.provideRenameEdits(ee,fe,W,q);return De?D.WorkspaceEdit.from(De):void 0}catch(De){const oe=V.g(De);return oe?{rejectReason:oe,edits:void 0}:Promise.reject(De)}}async resolveRenameLocation(I,B,W){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const q=this.d.getDocument(I),ee=D.Position.to(B);try{const fe=await this.e.prepareRename(q,ee,W);let De,oe;if(M.Range.isRange(fe)?(De=fe,oe=q.getText(fe)):(0,w.isObject)(fe)&&(De=fe.range,oe=fe.placeholder),!De||!oe)return;if(De.start.line>ee.line||De.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(De),text:oe}}catch(fe){const De=V.g(fe);return De?{rejectReason:De,range:void 0,text:void 0}:Promise.reject(fe)}}static g(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class ae{constructor(I,B){this.resultId=I,this.tokens=B}}class pe{constructor(I,B){this.f=I,this.g=B,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(I,B,W){const q=this.f.getDocument(I),ee=B!==0?this.d.get(B):null;let fe=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(q,ee.resultId,W):await this.g.provideDocumentSemanticTokens(q,W);return ee&&this.d.delete(B),fe?(fe=pe.h(fe),this.o(pe.n(ee,fe),fe)):null}async releaseDocumentSemanticColoring(I){this.d.delete(I)}static h(I){return pe.j(I)?pe.k(I)?I:new M.SemanticTokens(new Uint32Array(I.data),I.resultId):pe.l(I)?pe.m(I)?I:new M.SemanticTokensEdits(I.edits.map(B=>new M.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),I.resultId):I}static j(I){return I&&!!I.data}static k(I){return I.data instanceof Uint32Array}static l(I){return I&&Array.isArray(I.edits)}static m(I){for(const B of I.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static n(I,B){if(!pe.j(B)||!I||!I.tokens)return B;const W=I.tokens,q=W.length,ee=B.data,fe=ee.length;let De=0;const oe=Math.min(q,fe);for(;De<oe&&W[De]===ee[De];)De++;if(De===q&&De===fe)return new M.SemanticTokensEdits([],B.resultId);let ve=0;const be=oe-De;for(;ve<be&&W[q-ve-1]===ee[fe-ve-1];)ve++;return new M.SemanticTokensEdits([{start:De,deleteCount:q-De-ve,data:ee.subarray(De,fe-ve)}],B.resultId)}o(I,B){if(pe.j(I)){const W=this.e++;return this.d.set(W,new ae(I.resultId,I.data)),(0,a.encodeSemanticTokensDto)({id:W,type:"full",data:I.data})}if(pe.l(I)){const W=this.e++;return pe.j(B)?this.d.set(W,new ae(B.resultId,B.data)):this.d.set(W,new ae(I.resultId)),(0,a.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(I.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class re{constructor(I,B){this.d=I,this.e=B}async provideDocumentRangeSemanticTokens(I,B,W){const q=this.d.getDocument(I),ee=await this.e.provideDocumentRangeSemanticTokens(q,D.Range.to(B),W);return ee?this.f(ee):null}f(I){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}class ce{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,B,W,q,ee){this.f=I,this.g=B,this.h=W,this.j=q,this.k=ee,this.d=new u.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(I,B,W,q){const ee=this.f.getDocument(I),fe=D.Position.to(B),De=ee.getWordRangeAtPosition(fe)||new M.Range(fe,fe),oe=De.with({end:fe}),ve=new g.StopWatch(!0),be=await this.h.provideCompletionItems(ee,fe,q,D.CompletionContext.to(W));if(!be||q.isCancellationRequested)return;const He=Array.isArray(be)?new M.CompletionList(be):be,je=ce.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),it=new m.DisposableStore;this.e.set(je,it);const Xe=[],et={x:je,b:Xe,a:{replace:D.Range.from(De),insert:D.Range.from(oe)},c:He.isIncomplete||void 0,d:ve.elapsed()};for(let nt=0;nt<He.items.length;nt++){const Ne=He.items[nt],rt=this.l(Ne,[je,nt],oe,De);Xe.push(rt)}return et}async resolveCompletionItem(I,B){if(typeof this.h.resolveCompletionItem!="function")return;const W=this.d.get(...I);if(!W)return;const q=await this.h.resolveCompletionItem(W,B);if(!!q)return this.l(q,I)}releaseCompletionItems(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,B,W,q){const ee=this.e.get(B[0]);if(!ee)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(I.command,ee),De={x:B,a:I.label,b:I.kind!==void 0?D.CompletionItemKind.from(I.kind):void 0,m:I.tags&&I.tags.map(D.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:D.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters?.join(""),l:I.additionalTextEdits&&I.additionalTextEdits.map(D.TextEdit.from),n:fe?.$ident,o:fe?.id,p:fe?.$ident?void 0:fe?.arguments};I.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),De.h=I.textEdit.newText):typeof I.insertText=="string"?De.h=I.insertText:I.insertText instanceof M.SnippetString&&(De.h=I.insertText.value,De.i|=4);let oe;return I.textEdit?oe=I.textEdit.range:I.range&&(oe=I.range),M.Range.isRange(oe)?De.j=D.Range.from(oe):oe&&(!W?.isEqual(oe.inserting)||!q?.isEqual(oe.replacing))&&(De.j={insert:D.Range.from(oe.inserting),replace:D.Range.from(oe.replacing)}),De}}class ue{async provideInlineCompletions(I,B,W,q){}disposeCompletions(I){}handleDidShowCompletionItem(I,B){}handlePartialAccept(I,B,W){}}class Se extends ue{constructor(I,B,W,q){super(),this.f=I,this.g=B,this.h=W,this.j=q,this.d=new G,this.e=(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[y.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[y.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(I,B,W,q){const ee=this.g.getDocument(I),fe=D.Position.to(B),De=await this.h.provideInlineCompletionItems(ee,fe,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:D.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[W.triggerKind]},q);if(!De||q.isCancellationRequested)return;const oe=Array.isArray(De)?De:De.items,ve=this.e?Array.isArray(De)?[]:De.commands||[]:[];let be;return{pid:this.d.createReferenceId({dispose(){be?.dispose()},items:oe}),items:oe.map((je,it)=>{let Xe;je.command&&(be||(be=new m.DisposableStore),Xe=this.j.toInternal(je.command,be));const et=je.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:je.filterText,range:je.range?D.Range.from(je.range):void 0,command:Xe,idx:it,completeBracketPairs:this.e?je.completeBracketPairs:!1}}),commands:ve.map(je=>(be||(be=new m.DisposableStore),this.j.toInternal(je,be)))}}disposeCompletions(I){this.d.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,B){const W=this.d.get(I)?.items[B];W&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(W)}handlePartialAccept(I,B,W){const q=this.d.get(I)?.items[B];q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(q,W)}}class G{constructor(){this.d=new Map,this.e=1}createReferenceId(I){const B=this.e++;return this.d.set(B,I),B}disposeReferenceId(I){const B=this.d.get(I);return this.d.delete(I),B}get(I){return this.d.get(I)}}class X{constructor(I,B){this.e=I,this.f=B,this.d=new u.Cache("SignatureHelp")}async provideSignatureHelp(I,B,W,q){const ee=this.e.getDocument(I),fe=D.Position.to(B),De=this.g(W),oe=await this.f.provideSignatureHelp(ee,fe,q,De);if(oe){const ve=this.d.add([oe]);return{...D.SignatureHelp.from(oe),id:ve}}}g(I){let B;if(I.activeSignatureHelp){const W=D.SignatureHelp.to(I.activeSignatureHelp),q=this.d.get(I.activeSignatureHelp.id,0);q?(B=q,B.activeSignature=W.activeSignature,B.activeParameter=W.activeParameter):B=W}return{...I,activeSignatureHelp:B}}releaseSignatureHelp(I){this.d.delete(I)}}class J{constructor(I,B,W,q,ee){this.f=I,this.g=B,this.h=W,this.j=q,this.k=ee,this.d=new u.Cache("InlayHints"),this.e=new Map}async provideInlayHints(I,B,W){const q=this.f.getDocument(I),ee=D.Range.to(B),fe=await this.h.provideInlayHints(q,ee,W);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${B}`);return}if(W.isCancellationRequested)return;const De=this.d.add(fe);this.e.set(De,new m.DisposableStore);const oe={hints:[],cacheId:De};for(let ve=0;ve<fe.length;ve++)this.l(fe[ve],ee)&&oe.hints.push(this.m(fe[ve],[De,ve]));return this.j.trace(`[InlayHints] ${oe.hints.length} inlay hints from '${this.k.identifier.value}' for ${B}`),oe}async resolveInlayHint(I,B){if(typeof this.h.resolveInlayHint!="function")return;const W=this.d.get(...I);if(!W)return;const q=await this.h.resolveInlayHint(W,B);if(!!q&&!!this.l(q))return this.m(q,I)}releaseHints(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,B){return I.label.length===0||Array.isArray(I.label)&&I.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!(B&&!B.contains(I.position))}m(I,B){const W=this.e.get(B[0]);if(!W)throw Error("DisposableStore is missing...");const q={label:"",cacheId:B,tooltip:D.MarkdownString.fromStrict(I.tooltip),position:D.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(D.TextEdit.from),kind:I.kind&&D.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?q.label=I.label:q.label=I.label.map(ee=>{const fe={label:ee.value};return fe.tooltip=D.MarkdownString.fromStrict(ee.tooltip),M.Location.isLocation(ee.location)&&(fe.location=D.location.from(ee.location)),ee.command&&(fe.command=this.g.toInternal(ee.command,W)),fe}),q}}class de{constructor(I,B){this.e=I,this.f=B,this.d=new u.Cache("DocumentLink")}async provideLinks(I,B){const W=this.e.getDocument(I),q=await this.f.provideDocumentLinks(W,B);if(!(!Array.isArray(q)||q.length===0)&&!B.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:q.filter(de.g).map(D.DocumentLink.from)};{const ee=this.d.add(q),fe={links:[],cacheId:ee};for(let De=0;De<q.length;De++){if(!de.g(q[De]))continue;const oe=D.DocumentLink.from(q[De]);oe.cacheId=[ee,De],fe.links.push(oe)}return fe}}}static g(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,B){if(typeof this.f.resolveDocumentLink!="function")return;const W=this.d.get(...I);if(!W)return;const q=await this.f.resolveDocumentLink(W,B);if(!(!q||!de.g(q)))return D.DocumentLink.from(q)}releaseLinks(I){this.d.delete(I)}}class ye{constructor(I,B){this.d=I,this.e=B}async provideColors(I,B){const W=this.d.getDocument(I),q=await this.e.provideDocumentColors(W,B);return Array.isArray(q)?q.map(fe=>({color:D.Color.from(fe.color),range:D.Range.from(fe.range)})):[]}async provideColorPresentations(I,B,W){const q=this.d.getDocument(I),ee=D.Range.to(B.range),fe=D.Color.to(B.color),De=await this.e.provideColorPresentations(fe,{document:q,range:ee},W);if(!!Array.isArray(De))return De.map(D.ColorPresentation.from)}}class Fe{constructor(I,B){this.d=I,this.e=B}async provideFoldingRanges(I,B,W){const q=this.d.getDocument(I),ee=await this.e.provideFoldingRanges(q,B,W);if(!!Array.isArray(ee))return ee.map(D.FoldingRange.from)}}class ze{constructor(I,B,W){this.d=I,this.e=B,this.f=W}async provideSelectionRanges(I,B,W){const q=this.d.getDocument(I),ee=B.map(D.Position.to),fe=await this.e.provideSelectionRanges(q,ee,W);if(!(0,N.isNonEmptyArray)(fe))return[];if(fe.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const De=[];for(let oe=0;oe<ee.length;oe++){const ve=[];De.push(ve);let be=ee[oe],He=fe[oe];for(;;){if(!He.range.contains(be))throw new Error("INVALID selection range, must contain the previous range");if(ve.push(D.SelectionRange.from(He)),!He.parent)break;be=He.range,He=He.parent}}return De}}class Pe{constructor(I,B){this.f=I,this.g=B,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(I,B,W){const q=this.f.getDocument(I),ee=D.Position.to(B),fe=await this.g.prepareCallHierarchy(q,ee,W);if(!fe)return;const De=this.d.nextId();return this.e.set(De,new Map),Array.isArray(fe)?fe.map(oe=>this.h(De,oe)):[this.h(De,fe)]}async provideCallsTo(I,B,W){const q=this.j(I,B);if(!q)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(q,W);if(!!ee)return ee.map(fe=>({from:this.h(I,fe.from),fromRanges:fe.fromRanges.map(De=>D.Range.from(De))}))}async provideCallsFrom(I,B,W){const q=this.j(I,B);if(!q)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(q,W);if(!!ee)return ee.map(fe=>({to:this.h(I,fe.to),fromRanges:fe.fromRanges.map(De=>D.Range.from(De))}))}releaseSession(I){this.e.delete(I)}h(I,B){const W=this.e.get(I),q=D.CallHierarchyItem.from(B,I,W.size.toString(36));return W.set(q._itemId,B),q}j(I,B){return this.e.get(I)?.get(B)}}class Ie{constructor(I,B){this.f=I,this.g=B,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(I,B,W){const q=this.f.getDocument(I),ee=D.Position.to(B),fe=await this.g.prepareTypeHierarchy(q,ee,W);if(!fe)return;const De=this.d.nextId();return this.e.set(De,new Map),Array.isArray(fe)?fe.map(oe=>this.h(De,oe)):[this.h(De,fe)]}async provideSupertypes(I,B,W){const q=this.j(I,B);if(!q)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(q,W);if(!!ee)return ee.map(fe=>this.h(I,fe))}async provideSubtypes(I,B,W){const q=this.j(I,B);if(!q)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(q,W);if(!!ee)return ee.map(fe=>this.h(I,fe))}releaseSession(I){this.e.delete(I)}h(I,B){const W=this.e.get(I),q=D.TypeHierarchyItem.from(B,I,W.size.toString(36));return W.set(q._itemId,B),q}j(I,B){return this.e.get(I)?.get(B)}}class we{constructor(I,B,W,q){this.d=I,this.e=B,this.f=W,this.g=q}async provideDocumentOnDropEdits(I,B,W,q,ee){const fe=this.e.getDocument(B),De=D.Position.to(W),oe=D.DataTransfer.toDataTransfer(q,async be=>(await this.d.$resolveDocumentOnDropFileData(this.g,I,be)).buffer),ve=await this.f.provideDocumentDropEdits(fe,De,oe,ee);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?D.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class se{constructor(I,B){this.adapter=I,this.extension=B}}class le{constructor(I,B,W,q,ee,fe,De,oe){this.g=B,this.h=W,this.j=q,this.k=ee,this.l=fe,this.m=De,this.n=oe,this.f=new Map,this.e=I.getProxy(R.MainContext.MainThreadLanguageFeatures)}o(I){return D.DocumentSelector.from(I,this.g)}p(I){return new M.Disposable(()=>{this.f.delete(I),this.e.$unregister(I)})}q(){return le.d++}async s(I,B,W,q,ee,fe=!1){const De=this.f.get(I);if(!De||!(De.adapter instanceof B))return q;const oe=Date.now();fe||this.l.trace(`[${De.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const ve=W(De.adapter,De.extension);return Promise.resolve(ve).catch(be=>{(0,E.isCancellationError)(be)||(this.l.error(`[${De.extension.identifier.value}] provider FAILED`),this.l.error(be),this.n.onExtensionError(De.extension.identifier,be))}).finally(()=>{fe||this.l.trace(`[${De.extension.identifier.value}] provider DONE after ${Date.now()-oe}ms`)}),v.CancellationToken.isCancellationToken(ee)?(0,L.raceCancellationError)(ve,ee):ve}t(I,B){const W=this.q();return this.f.set(W,new se(I,B)),W}static u(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,B,W,q){const ee=this.t(new t(this.h,W),I),fe=q&&q.label||le.u(I);return this.e.$registerDocumentSymbolProvider(ee,this.o(B),fe),this.p(ee)}$provideDocumentSymbols(I,B,W){return this.s(I,t,q=>q.provideDocumentSymbols(n.URI.revive(B),W),void 0,W)}registerCodeLensProvider(I,B,W){const q=this.q(),ee=typeof W.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(q,new se(new d(this.h,this.j.converter,W),I)),this.e.$registerCodeLensSupport(q,this.o(B),ee);let fe=this.p(q);if(ee!==void 0){const De=W.onDidChangeCodeLenses(oe=>this.e.$emitCodeLensEvent(ee));fe=M.Disposable.from(fe,De)}return fe}$provideCodeLenses(I,B,W){return this.s(I,d,q=>q.provideCodeLenses(n.URI.revive(B),W),void 0,W)}$resolveCodeLens(I,B,W){return this.s(I,d,q=>q.resolveCodeLens(B,W),void 0,void 0)}$releaseCodeLenses(I,B){this.s(I,d,W=>Promise.resolve(W.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(I,B,W){const q=this.t(new l(this.h,W),I);return this.e.$registerDefinitionSupport(q,this.o(B)),this.p(q)}$provideDefinition(I,B,W,q){return this.s(I,l,ee=>ee.provideDefinition(n.URI.revive(B),W,q),[],q)}registerDeclarationProvider(I,B,W){const q=this.t(new c(this.h,W),I);return this.e.$registerDeclarationSupport(q,this.o(B)),this.p(q)}$provideDeclaration(I,B,W,q){return this.s(I,c,ee=>ee.provideDeclaration(n.URI.revive(B),W,q),[],q)}registerImplementationProvider(I,B,W){const q=this.t(new b(this.h,W),I);return this.e.$registerImplementationSupport(q,this.o(B)),this.p(q)}$provideImplementation(I,B,W,q){return this.s(I,b,ee=>ee.provideImplementation(n.URI.revive(B),W,q),[],q)}registerTypeDefinitionProvider(I,B,W){const q=this.t(new i(this.h,W),I);return this.e.$registerTypeDefinitionSupport(q,this.o(B)),this.p(q)}$provideTypeDefinition(I,B,W,q){return this.s(I,i,ee=>ee.provideTypeDefinition(n.URI.revive(B),W,q),[],q)}registerHoverProvider(I,B,W,q){const ee=this.t(new s(this.h,W),I);return this.e.$registerHoverProvider(ee,this.o(B)),this.p(ee)}$provideHover(I,B,W,q){return this.s(I,s,ee=>ee.provideHover(n.URI.revive(B),W,q),void 0,q)}registerEvaluatableExpressionProvider(I,B,W,q){const ee=this.t(new f(this.h,W),I);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(B)),this.p(ee)}$provideEvaluatableExpression(I,B,W,q){return this.s(I,f,ee=>ee.provideEvaluatableExpression(n.URI.revive(B),W,q),void 0,q)}registerInlineValuesProvider(I,B,W,q){const ee=typeof W.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new P(this.h,W),I);this.e.$registerInlineValuesProvider(fe,this.o(B),ee);let De=this.p(fe);if(ee!==void 0){const oe=W.onDidChangeInlineValues(ve=>this.e.$emitInlineValuesEvent(ee));De=M.Disposable.from(De,oe)}return De}$provideInlineValues(I,B,W,q,ee){return this.s(I,P,fe=>fe.provideInlineValues(n.URI.revive(B),W,q,ee),void 0,ee)}registerDocumentHighlightProvider(I,B,W){const q=this.t(new C(this.h,W),I);return this.e.$registerDocumentHighlightProvider(q,this.o(B)),this.p(q)}$provideDocumentHighlights(I,B,W,q){return this.s(I,C,ee=>ee.provideDocumentHighlights(n.URI.revive(B),W,q),void 0,q)}registerLinkedEditingRangeProvider(I,B,W){const q=this.t(new j(this.h,W),I);return this.e.$registerLinkedEditingRangeProvider(q,this.o(B)),this.p(q)}$provideLinkedEditingRanges(I,B,W,q){return this.s(I,j,async ee=>{const fe=await ee.provideLinkedEditingRanges(n.URI.revive(B),W,q);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?le.w(fe.wordPattern):void 0}},void 0,q)}registerReferenceProvider(I,B,W){const q=this.t(new _(this.h,W),I);return this.e.$registerReferenceSupport(q,this.o(B)),this.p(q)}$provideReferences(I,B,W,q,ee){return this.s(I,_,fe=>fe.provideReferences(n.URI.revive(B),W,q,ee),void 0,ee)}registerCodeActionProvider(I,B,W,q){const ee=new m.DisposableStore,fe=this.t(new K(this.h,this.j.converter,this.k,W,this.l,I,this.m),I);return this.e.$registerQuickFixSupport(fe,this.o(B),{providedKinds:q?.providedCodeActionKinds?.map(De=>De.value),documentation:q?.documentation?.map(De=>({kind:De.kind.value,command:this.j.converter.toInternal(De.command,ee)}))},le.u(I),Boolean(W.resolveCodeAction)),ee.add(this.p(fe)),ee}$provideCodeActions(I,B,W,q,ee){return this.s(I,K,fe=>fe.provideCodeActions(n.URI.revive(B),W,q,ee),void 0,ee)}$resolveCodeAction(I,B,W){return this.s(I,K,q=>q.resolveCodeAction(B,W),void 0,void 0)}$releaseCodeActions(I,B){this.s(I,K,W=>Promise.resolve(W.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(I,B,W){const q=this.t(new $(this.h,W),I);return this.e.$registerDocumentFormattingSupport(q,this.o(B),I.identifier,I.displayName||I.name),this.p(q)}$provideDocumentFormattingEdits(I,B,W,q){return this.s(I,$,ee=>ee.provideDocumentFormattingEdits(n.URI.revive(B),W,q),void 0,q)}registerDocumentRangeFormattingEditProvider(I,B,W){const q=this.t(new O(this.h,W),I);return this.e.$registerRangeFormattingSupport(q,this.o(B),I.identifier,I.displayName||I.name),this.p(q)}$provideDocumentRangeFormattingEdits(I,B,W,q,ee){return this.s(I,O,fe=>fe.provideDocumentRangeFormattingEdits(n.URI.revive(B),W,q,ee),void 0,ee)}registerOnTypeFormattingEditProvider(I,B,W,q){const ee=this.t(new F(this.h,W),I);return this.e.$registerOnTypeFormattingSupport(ee,this.o(B),q,I.identifier),this.p(ee)}$provideOnTypeFormattingEdits(I,B,W,q,ee,fe){return this.s(I,F,De=>De.provideOnTypeFormattingEdits(n.URI.revive(B),W,q,ee,fe),void 0,fe)}registerWorkspaceSymbolProvider(I,B){const W=this.t(new H(B,this.l),I);return this.e.$registerNavigateTypeSupport(W,typeof B.resolveWorkspaceSymbol=="function"),this.p(W)}$provideWorkspaceSymbols(I,B,W){return this.s(I,H,q=>q.provideWorkspaceSymbols(B,W),{symbols:[]},W)}$resolveWorkspaceSymbol(I,B,W){return this.s(I,H,q=>q.resolveWorkspaceSymbol(B,W),void 0,void 0)}$releaseWorkspaceSymbols(I,B){this.s(I,H,W=>W.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(I,B,W){const q=this.t(new V(this.h,W,this.l),I);return this.e.$registerRenameSupport(q,this.o(B),V.supportsResolving(W)),this.p(q)}$provideRenameEdits(I,B,W,q,ee){return this.s(I,V,fe=>fe.provideRenameEdits(n.URI.revive(B),W,q,ee),void 0,ee)}$resolveRenameLocation(I,B,W,q){return this.s(I,V,ee=>ee.resolveRenameLocation(n.URI.revive(B),W,q),void 0,q)}registerDocumentSemanticTokensProvider(I,B,W,q){const ee=this.t(new pe(this.h,W),I),fe=typeof W.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(B),q,fe);let De=this.p(ee);if(fe){const oe=W.onDidChangeSemanticTokens(ve=>this.e.$emitDocumentSemanticTokensEvent(fe));De=M.Disposable.from(De,oe)}return De}$provideDocumentSemanticTokens(I,B,W,q){return this.s(I,pe,ee=>ee.provideDocumentSemanticTokens(n.URI.revive(B),W,q),null,q)}$releaseDocumentSemanticTokens(I,B){this.s(I,pe,W=>W.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,B,W,q){const ee=this.t(new re(this.h,W),I);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(B),q),this.p(ee)}$provideDocumentRangeSemanticTokens(I,B,W,q){return this.s(I,re,ee=>ee.provideDocumentRangeSemanticTokens(n.URI.revive(B),W,q),null,q)}registerCompletionItemProvider(I,B,W,q){const ee=this.t(new ce(this.h,this.j.converter,W,this.m,I),I);return this.e.$registerCompletionsProvider(ee,this.o(B),q,ce.supportsResolving(W),`${I.identifier.value}(${q.join("")})`),this.p(ee)}$provideCompletionItems(I,B,W,q,ee){return this.s(I,ce,fe=>fe.provideCompletionItems(n.URI.revive(B),W,q,ee),void 0,ee)}$resolveCompletionItem(I,B,W){return this.s(I,ce,q=>q.resolveCompletionItem(B,W),void 0,W)}$releaseCompletionItems(I,B){this.s(I,ce,W=>W.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(I,B,W){const q=new Se(I,this.h,W,this.j.converter),ee=this.t(q,I);return this.e.$registerInlineCompletionsSupport(ee,this.o(B),q.supportsHandleEvents),this.p(ee)}$provideInlineCompletions(I,B,W,q,ee){return this.s(I,ue,fe=>fe.provideInlineCompletions(n.URI.revive(B),W,q,ee),void 0,ee)}$handleInlineCompletionDidShow(I,B,W){this.s(I,ue,async q=>{q.handleDidShowCompletionItem(B,W)},void 0,void 0)}$handleInlineCompletionPartialAccept(I,B,W,q){this.s(I,ue,async ee=>{ee.handlePartialAccept(B,W,q)},void 0,void 0)}$freeInlineCompletionsList(I,B){this.s(I,ue,async W=>{W.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(I,B,W,q){const ee=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,fe=this.t(new X(this.h,W),I);return this.e.$registerSignatureHelpProvider(fe,this.o(B),ee),this.p(fe)}$provideSignatureHelp(I,B,W,q,ee){return this.s(I,X,fe=>fe.provideSignatureHelp(n.URI.revive(B),W,q,ee),void 0,ee)}$releaseSignatureHelp(I,B){this.s(I,X,W=>W.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(I,B,W){const q=typeof W.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new J(this.h,this.j.converter,W,this.l,I),I);this.e.$registerInlayHintsProvider(ee,this.o(B),typeof W.resolveInlayHint=="function",q,le.u(I));let fe=this.p(ee);if(q!==void 0){const De=W.onDidChangeInlayHints(oe=>this.e.$emitInlayHintsEvent(q));fe=M.Disposable.from(fe,De)}return fe}$provideInlayHints(I,B,W,q){return this.s(I,J,ee=>ee.provideInlayHints(n.URI.revive(B),W,q),void 0,q)}$resolveInlayHint(I,B,W){return this.s(I,J,q=>q.resolveInlayHint(B,W),void 0,W)}$releaseInlayHints(I,B){this.s(I,J,W=>W.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(I,B,W){const q=this.t(new de(this.h,W),I);return this.e.$registerDocumentLinkProvider(q,this.o(B),typeof W.resolveDocumentLink=="function"),this.p(q)}$provideDocumentLinks(I,B,W){return this.s(I,de,q=>q.provideLinks(n.URI.revive(B),W),void 0,W,B.scheme==="output")}$resolveDocumentLink(I,B,W){return this.s(I,de,q=>q.resolveLink(B,W),void 0,void 0,!0)}$releaseDocumentLinks(I,B){this.s(I,de,W=>W.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(I,B,W){const q=this.t(new ye(this.h,W),I);return this.e.$registerDocumentColorProvider(q,this.o(B)),this.p(q)}$provideDocumentColors(I,B,W){return this.s(I,ye,q=>q.provideColors(n.URI.revive(B),W),[],W)}$provideColorPresentations(I,B,W,q){return this.s(I,ye,ee=>ee.provideColorPresentations(n.URI.revive(B),W,q),void 0,q)}registerFoldingRangeProvider(I,B,W){const q=this.q(),ee=typeof W.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(q,new se(new Fe(this.h,W),I)),this.e.$registerFoldingRangeProvider(q,this.o(B),I.identifier,ee);let fe=this.p(q);if(ee!==void 0){const De=W.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));fe=M.Disposable.from(fe,De)}return fe}$provideFoldingRanges(I,B,W,q){return this.s(I,Fe,ee=>ee.provideFoldingRanges(n.URI.revive(B),W,q),void 0,q)}registerSelectionRangeProvider(I,B,W){const q=this.t(new ze(this.h,W,this.l),I);return this.e.$registerSelectionRangeProvider(q,this.o(B)),this.p(q)}$provideSelectionRanges(I,B,W,q){return this.s(I,ze,ee=>ee.provideSelectionRanges(n.URI.revive(B),W,q),[],q)}registerCallHierarchyProvider(I,B,W){const q=this.t(new Pe(this.h,W),I);return this.e.$registerCallHierarchyProvider(q,this.o(B)),this.p(q)}$prepareCallHierarchy(I,B,W,q){return this.s(I,Pe,ee=>Promise.resolve(ee.prepareSession(n.URI.revive(B),W,q)),void 0,q)}$provideCallHierarchyIncomingCalls(I,B,W,q){return this.s(I,Pe,ee=>ee.provideCallsTo(B,W,q),void 0,q)}$provideCallHierarchyOutgoingCalls(I,B,W,q){return this.s(I,Pe,ee=>ee.provideCallsFrom(B,W,q),void 0,q)}$releaseCallHierarchy(I,B){this.s(I,Pe,W=>Promise.resolve(W.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(I,B,W){const q=this.t(new Ie(this.h,W),I);return this.e.$registerTypeHierarchyProvider(q,this.o(B)),this.p(q)}$prepareTypeHierarchy(I,B,W,q){return this.s(I,Ie,ee=>Promise.resolve(ee.prepareSession(n.URI.revive(B),W,q)),void 0,q)}$provideTypeHierarchySupertypes(I,B,W,q){return this.s(I,Ie,ee=>ee.provideSupertypes(B,W,q),void 0,q)}$provideTypeHierarchySubtypes(I,B,W,q){return this.s(I,Ie,ee=>ee.provideSubtypes(B,W,q),void 0,q)}$releaseTypeHierarchy(I,B){this.s(I,Ie,W=>Promise.resolve(W.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(I,B,W){const q=this.q();return this.f.set(q,new se(new we(this.e,this.h,W,q),I)),this.e.$registerDocumentOnDropEditProvider(q,this.o(B)),this.p(q)}$provideDocumentOnDropEdits(I,B,W,q,ee,fe){return this.s(I,we,De=>Promise.resolve(De.provideDocumentOnDropEdits(B,n.URI.revive(W),q,ee,fe)),void 0,void 0)}registerDocumentPasteEditProvider(I,B,W,q){const ee=this.q();return this.f.set(ee,new se(new A(this.e,this.h,W,ee),I)),this.e.$registerPasteEditProvider(ee,this.o(B),!!W.prepareDocumentPaste,q.pasteMimeTypes),this.p(ee)}$prepareDocumentPaste(I,B,W,q,ee){return this.s(I,A,fe=>fe.prepareDocumentPaste(n.URI.revive(B),W,q,ee),void 0,ee)}$providePasteEdits(I,B,W,q,ee,fe){return this.s(I,A,De=>De.providePasteEdits(B,n.URI.revive(W),q,ee,fe),void 0,fe)}static w(I){return{pattern:I.source,flags:(0,S.regExpFlags)(I)}}static y(I){return{decreaseIndentPattern:le.w(I.decreaseIndentPattern),increaseIndentPattern:le.w(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?le.w(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?le.w(I.unIndentedLinePattern):void 0}}static z(I){return{beforeText:le.w(I.beforeText),afterText:I.afterText?le.w(I.afterText):void 0,previousLineText:I.previousLineText?le.w(I.previousLineText):void 0,action:I.action}}static B(I){return I.map(le.z)}setLanguageConfiguration(I,B,W){const{wordPattern:q}=W;if(q&&(0,S.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this.h.setWordDefinitionFor(B,q):this.h.setWordDefinitionFor(B,void 0),W.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),W.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const ee=this.q(),fe={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?le.w(W.wordPattern):void 0,indentationRules:W.indentationRules?le.y(W.indentationRules):void 0,onEnterRules:W.onEnterRules?le.B(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this.e.$setLanguageConfiguration(ee,B,fe),this.p(ee)}$setWordDefinitions(I){for(const B of I)this.h.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}le.d=0,e.ExtHostLanguageFeatures=le}),define(ke[219],Te([1,0,5,8,7,29,17,6]),function(te,e,n,k,D,M,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(N,w,h,v){this.c=w,this.d=h,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=N.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this.b=N}async getLanguages(){return this.b.slice(0)}async changeLanguage(N,w){await this.a.$changeLanguage(N,w);const h=this.c.getDocumentData(N);if(!h)throw new Error(`document '${N.toString()}' NOT found`);return h.document}async tokenAtPosition(N,w){const h=N.version,v=k.Position.from(w),m=await this.a.$tokensAtPosition(N.uri,v),a={type:D.StandardTokenType.Other,range:N.getWordRangeAtPosition(w)??new D.Range(w.line,w.character,w.line,w.character)};if(!m)return a;const o={range:k.Range.to(m.range),type:k.TokenType.to(m.type)};return!o.range.contains(w)||h!==N.version?a:o}createLanguageStatusItem(N,w,h){const v=this.f++,m=this.a,a=this.g,o=`${N.identifier.value}/${w}`;if(a.has(o))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);a.add(o);const u={selector:h,id:w,name:N.displayName??N.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const E=new R.DisposableStore,L=()=>{g?.dispose(),g=(0,y.disposableTimeout)(()=>{E.clear(),this.a.$setLanguageStatus(v,{id:o,name:u.name??N.displayName??N.name,source:N.displayName??N.name,selector:k.DocumentSelector.from(u.selector,this.e),label:u.text,detail:u.detail??"",severity:u.severity===D.LanguageStatusSeverity.Error?M.default.Error:u.severity===D.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:u.command&&this.d.toInternal(u.command,E),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},p={dispose(){E.dispose(),g?.dispose(),m.$removeLanguageStatus(v),a.delete(o)},get id(){return u.id},get name(){return u.name},set name(t){u.name=t,L()},get selector(){return u.selector},set selector(t){u.selector=t,L()},get text(){return u.text},set text(t){u.text=t,L()},get detail(){return u.detail},set detail(t){u.detail=t,L()},get severity(){return u.severity},set severity(t){u.severity=t,L()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(t){u.accessibilityInformation=t,L()},get command(){return u.command},set command(t){u.command=t,L()},get busy(){return u.busy},set busy(t){u.busy=t,L()}};return L(),p}}e.ExtHostLanguages=S}),define(ke[78],Te([1,0,20,10,2,3,11,5,27,18]),function(te,e,n,k,D,M,y,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let N=class{constructor(h,v,m){this.f=m,this.d=new Map,this.a=v.getProxy(R.MainContext.MainThreadLocalization),this.b=h.environment.appLanguage,this.c=this.b===n.LANGUAGE_DEFAULT}getMessage(h,v){const{message:m,args:a,comment:o}=v;if(this.c)return(0,k.format2)(m,a??{});let u=m;o&&o.length>0&&(u+=`/${Array.isArray(o)?o.join(""):o}`);const g=this.d.get(h)?.contents[u];return g||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${u}`),(0,k.format2)(g??m,a??{})}getBundle(h){return this.d.get(h)?.contents}getBundleUri(h){return this.d.get(h)?.uri}async initializeLocalizedMessages(h){if(this.c||!h.l10n&&!h.isBuiltin||this.d.has(h.identifier.value))return;let v;const m=await this.g(h);if(!m){this.f.error(`No bundle location found for extension ${h.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(m),o=JSON.parse(a);v=h.isBuiltin?o.contents?.bundle:o}catch(a){this.f.error(`Failed to load translations for ${h.identifier.value} from ${m}: ${a.message}`);return}v&&this.d.set(h.identifier.value,{contents:v,uri:m})}async g(h){if(h.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(h.identifier.value,this.b);return D.URI.revive(v)}return h.l10n?D.URI.joinPath(h.extensionLocation,h.l10n,`bundle.l10n.${this.b}.json`):void 0}};N=qe([Ve(0,S.IExtHostInitDataService),Ve(1,T.IExtHostRpcService),Ve(2,y.ILogService)],N),e.ExtHostLocalizationService=N,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(ke[220],Te([1,0,11,5,27,18,2,66]),function(te,e,n,k,D,M,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let S=class extends n.AbstractLoggerService{constructor(w,h){super(h.logLevel,h.loggers.map(v=>(0,R.revive)(v))),this.l=w.getProxy(k.MainContext.MainThreadLogger)}$setLogLevel(w,h){h?this.setLogLevel(y.URI.revive(h),w):this.setLogLevel(w)}setVisibility(w,h){super.setVisibility(w,h),this.l.$setVisibility(w,h)}k(w,h,v){return new T(this.l,w,h,v)}};S=qe([Ve(0,M.IExtHostRpcService),Ve(1,D.IExtHostInitDataService)],S),e.ExtHostLoggerService=S;class T extends n.AbstractMessageLogger{constructor(w,h,v,m){super(m?.logLevel==="always"),this.m=w,this.n=h,this.k=!1,this.l=[],this.setLevel(v),this.m.$createLogger(h,m).then(()=>{this.r(this.l),this.k=!0})}g(w,h){const v=[[w,h]];this.k?this.r(v):this.l.push(...v)}r(w){this.m.$log(this.n,w)}}}),define(ke[221],Te([1,0,5,11,25]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(R){return R&&R.title}let y=class{constructor(S,T){this.b=T,this.a=S.getProxy(n.MainContext.MainThreadMessageService)}showMessage(S,T,N,w,h){const v={source:{identifier:S.identifier,label:S.displayName||S.name}};let m;typeof w=="string"||M(w)?m=[w,...h]:(v.modal=w?.modal,v.useCustom=w?.useCustom,v.detail=w?.detail,m=h),v.useCustom&&(0,D.checkProposedApiEnabled)(S,"resolvers");const a=[];for(let o=0;o<m.length;o++){const u=m[o];if(typeof u=="string")a.push({title:u,handle:o,isCloseAffordance:!1});else if(typeof u=="object"){const{title:g,isCloseAffordance:E}=u;a.push({title:g,isCloseAffordance:!!E,handle:o})}else this.b.warn("Invalid message item:",u)}return this.a.$showMessage(T,N,v,a).then(o=>{if(typeof o=="number")return m[o]})}};y=qe([Ve(1,k.ILogService)],y),e.ExtHostMessageService=y}),define(ke[222],Te([1,0,23,4,6,28,10,9,2,54,5,37,8,7,46,196,100]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class u{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,L,p,t){this.q=p,this.r=t,this.f=new Map,this.g=new M.ResourceMap,this.h=new Map,this.j=new k.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new k.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new k.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new T.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=E.getProxy(N.MainContext.MainThreadNotebook),this.c=E.getProxy(N.MainContext.MainThreadNotebookDocuments),this.d=E.getProxy(N.MainContext.MainThreadNotebookEditors),this.i=L.converter,L.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===13){const r=d.notebookEditor?.notebookUri,l=d.cell.handle,b=this.g.get(r)?.getCell(l);if(b)return b.apiCell}if(d&&d.$mid===14){const r=d.uri,l=this.g.get(r);if(l)return l.apiNotebook}return d}}),u.x(L)}getEditorById(E){const L=this.h.get(E);if(!L)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return L}getIdByEditor(E){for(const[L,p]of this.h)if(p.apiEditor===E)return L}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,L){const p=this.g.get(E);if(!p&&!L)throw new Error(`NO notebook document for '${E}'`);return p}static s(E,L){if(!L)return;const p=L.filenamePattern.map(t=>h.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(L.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${L.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:L.displayName,filenamePattern:p,exclusive:L.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,L,p){const t=u.a++,d=typeof p.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(t,p),this.b.$registerNotebookCellStatusBarItemProvider(t,d,L);let r;return d!==void 0&&(r=p.onDidChangeCellStatusBarItems(l=>this.b.$emitCellStatusBarEvent(d))),new v.Disposable(()=>{this.f.delete(t),this.b.$unregisterNotebookCellStatusBarItemProvider(t,d),r?.dispose()})}async createNotebookDocument(E){const L=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&h.NotebookData.from(E.content)});return S.URI.revive(L)}async openNotebookDocument(E){const L=this.g.get(E);if(L)return L.apiNotebook;const p=await this.c.$tryOpenNotebook(E),t=this.g.get(S.URI.revive(p));return(0,R.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(E,L){S.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let p;typeof L=="object"?p={position:h.ViewColumn.from(L.viewColumn),preserveFocus:L.preserveFocus,selections:L.selections&&L.selections.map(h.NotebookRange.from),pinned:typeof L.preview=="boolean"?!L.preview:void 0}:p={preserveFocus:!1};const t=await this.d.$tryShowNotebookDocument(E.uri,E.notebookType,p),d=t&&this.h.get(t)?.apiEditor;if(d)return d;throw t?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,L,p,t){const d=this.f.get(E),r=S.URI.revive(L),l=this.g.get(r);if(!l||!d)return;const c=l.getCellFromIndex(p);if(!c)return;const b=await d.provideCellStatusBarItems(c.apiCell,t);if(!b)return;const i=new D.DisposableStore,s=this.p.add([i]),P=(Array.isArray(b)?b:[b]).map(C=>h.NotebookStatusBarItem.from(C,this.i,i));return{cacheId:s,items:P}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,L,p,t,d){if((0,y.isFalsyOrWhitespace)(L))throw new Error("viewType cannot be empty or just whitespace");const r=this.t++;return this.u.set(r,p),this.b.$registerNotebookSerializer(r,{id:E.identifier,location:E.extensionLocation},L,h.NotebookDocumentContentOptions.from(t),u.s(E,d)),(0,D.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(r)})}async $dataToNotebook(E,L,p){const t=this.u.get(E);if(!t)throw new Error("NO serializer found");const d=await t.deserializeNotebook(L.buffer,p);return new m.SerializableObjectWithBuffers(h.NotebookData.from(d))}async $notebookToData(E,L,p){const t=this.u.get(E);if(!t)throw new Error("NO serializer found");const d=await t.serializeNotebook(h.NotebookData.to(L.value),p);return n.VSBuffer.wrap(d)}w(E,L,p){if(this.h.has(L))throw new Error(`editor with id ALREADY EXSIST: ${L}`);const t=new o.ExtHostNotebookEditor(L,this.d,E,p.visibleRanges.map(h.NotebookRange.to),p.selections.map(h.NotebookRange.to),typeof p.viewColumn=="number"?h.ViewColumn.to(p.viewColumn):void 0);this.h.set(L,t)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const p of E.value.removedDocuments){const t=S.URI.revive(p),d=this.g.get(t);d&&(d.dispose(),this.g.delete(t),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(r=>r.document.uri)}),this.n.fire(d.apiNotebook));for(const r of this.h.values())r.notebookData.uri.toString()===t.toString()&&this.h.delete(r.id)}if(E.value.addedDocuments){const p=[];for(const t of E.value.addedDocuments){const d=S.URI.revive(t.uri);if(this.g.has(d))throw new Error(`adding EXISTING notebook ${d} `);const r=new a.ExtHostNotebookDocument(this.c,this.q,this.r,d,t);p.push(...t.cells.map(l=>a.ExtHostCell.asModelAddData(r.apiNotebook,l))),this.g.get(d)?.dispose(),this.g.set(d,r),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this.m.fire(r.apiNotebook)}}if(E.value.addedEditors)for(const p of E.value.addedEditors){if(this.h.has(p.id))return;const t=S.URI.revive(p.documentUri),d=this.g.get(t);d&&this.w(d,p.id,p)}const L=[];if(E.value.removedEditors)for(const p of E.value.removedEditors){const t=this.h.get(p);t&&(this.h.delete(p),this.k?.id===t.id&&(this.k=void 0),L.push(t))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(t=>this.h.get(t)).filter(t=>!!t);const p=new Set;this.l.forEach(t=>p.add(t.id));for(const t of this.h.values()){const d=p.has(t.id);t._acceptVisibility(d)}this.l=[...this.h.values()].map(t=>t).filter(t=>t.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.h.get(E.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${E.value.newActiveEditor}`),this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(E){const L=w.ApiCommandArgument.String.with("notebookType","A notebook type"),p=new w.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[L,new w.ApiCommandArgument("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>n.VSBuffer.wrap(d))],new w.ApiCommandResult("Notebook Data",d=>h.NotebookData.to(d.value))),t=new w.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[L,new w.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new m.SerializableObjectWithBuffers(h.NotebookData.from(d)))],new w.ApiCommandResult("Bytes",d=>d.buffer));E.registerApiCommand(p),E.registerApiCommand(t)}}u.a=0,e.ExtHostNotebookController=u}),define(ke[223],Te([1,0,16,17,21,4,6,28,2,26,11,54,5,37,8,7,73,186,25,46]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o,u,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let L=class{constructor(c,b,i,s,f){this.k=b,this.l=i,this.m=s,this.n=f,this.b=new R.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new w.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=c.getProxy(h.MainContext.MainThreadNotebookKernels);const P=new v.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.ApiCommandArgument("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const j=this.l.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:j}}else if(C&&"notebookEditor"in C){const j=this.l.getIdByEditor(C.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return C})],v.ApiCommandResult.Void);this.m.registerApiCommand(P)}createNotebookController(c,b,i,s,f,P){for(const ue of this.h.values())if(ue.controller.id===b&&T.ExtensionIdentifier.equals(c.identifier,ue.extensionId))throw new Error(`notebook controller with id '${b}' ALREADY exist`);const C=this.i++,j=this;this.n.trace(`NotebookController[${C}], CREATED by ${c.identifier.value}, ${b}`);const _=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${c.identifier}'`);let K=!1;const A=new y.DisposableStore,$=new M.Emitter,O=new M.Emitter,F={id:r(c.identifier,b),notebookType:i,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:s||c.identifier.value,preloads:P?P.map(m.NotebookRendererScript.from):[]};let H=f??_,V;this.a.$addKernel(C,F).catch(ue=>{console.log(ue),K=!0});let ae=0;const pe=()=>{if(K)return;const ue=++ae;Promise.resolve().then(()=>{ue===ae&&this.a.$updateKernel(C,F)})},re=new R.ResourceMap,ce={get id(){return b},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:$.event,get label(){return F.label},set label(ue){F.label=ue??c.displayName??c.name,pe()},get detail(){return F.detail??""},set detail(ue){F.detail=ue,pe()},get description(){return F.description??""},set description(ue){F.description=ue,pe()},get kind(){return(0,g.checkProposedApiEnabled)(c,"notebookControllerKind"),F.kind??""},set kind(ue){(0,g.checkProposedApiEnabled)(c,"notebookControllerKind"),F.kind=ue,pe()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(ue){F.supportedLanguages=ue,pe()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){F.supportsExecutionOrder=ue,pe()},get rendererScripts(){return F.preloads?F.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(ue){H=ue??_},get interruptHandler(){return V},set interruptHandler(ue){V=ue,F.supportsInterrupt=Boolean(ue),pe()},createNotebookCellExecution(ue){if(K)throw new Error("notebook controller is DISPOSED");if(!re.has(ue.notebook.uri))throw j.n.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return j._createNotebookCellExecution(ue,r(c.identifier,this.id))},dispose:()=>{K||(this.n.trace(`NotebookController[${C}], DISPOSED`),K=!0,this.h.delete(C),A.dispose(),$.dispose(),O.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(ue,Se){Se===a.NotebookControllerAffinity2.Hidden&&(0,g.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),j.a.$updateNotebookPriority(C,ue.uri,Se)},onDidReceiveMessage:O.event,postMessage(ue,Se){return(0,g.checkProposedApiEnabled)(c,"notebookMessaging"),j.a.$postMessage(C,Se&&j.l.getIdByEditor(Se),ue)},asWebviewUri(ue){return(0,g.checkProposedApiEnabled)(c,"notebookMessaging"),(0,o.asWebviewUri)(ue,j.k.remote)}};return this.h.set(C,{extensionId:c.identifier,controller:ce,onDidReceiveMessage:O,onDidChangeSelection:$,associatedNotebooks:re}),ce}getIdByController(c){for(const[b,i]of this.h)if(i.controller===c)return r(i.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,b){const i=this.d++,s=this;this.n.trace(`NotebookControllerDetectionTask[${i}], CREATED by ${c.identifier.value}`),this.a.$addKernelDetectionTask(i,b);const f={dispose:()=>{this.c.delete(i),s.a.$removeKernelDetectionTask(i)}};return this.c.set(i,f),f}registerKernelSourceActionProvider(c,b,i){const s=this.f++,f=typeof i.onDidChangeNotebookKernelSourceActions=="function"?s:void 0,P=this;this.e.set(s,i),this.n.trace(`NotebookKernelSourceActionProvider[${s}], CREATED by ${c.identifier.value}`),this.a.$addKernelSourceActionProvider(s,s,b);let C;return f!==void 0&&(C=i.onDidChangeNotebookKernelSourceActions(j=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.e.delete(s),P.a.$removeKernelSourceActionProvider(s,s),C?.dispose()}}}async $provideKernelSourceActions(c,b){const i=this.e.get(c);if(i){const s=new y.DisposableStore;return this.g.add([s]),(await i.provideNotebookKernelSourceActions(b)??[]).map(P=>m.NotebookKernelSourceAction.from(P,this.m.converter,s))}return[]}$acceptNotebookAssociation(c,b,i){const s=this.h.get(c);if(s){const f=this.l.getNotebookDocument(S.URI.revive(b));i?s.associatedNotebooks.set(f.uri,!0):s.associatedNotebooks.delete(f.uri),this.n.trace(`NotebookController[${c}] ASSOCIATE notebook`,f.uri.toString(),i),s.onDidChangeSelection.fire({selected:i,notebook:f.apiNotebook})}}async $executeCells(c,b,i){const s=this.h.get(c);if(!s)return;const f=this.l.getNotebookDocument(S.URI.revive(b)),P=[];for(const C of i){const j=f.getCell(C);j&&P.push(j.apiCell)}try{this.n.trace(`NotebookController[${c}] EXECUTE cells`,f.uri.toString(),P.length),await s.controller.executeHandler.call(s.controller,P,f.apiNotebook,s.controller)}catch(C){this.n.error(`NotebookController[${c}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(c,b,i){const s=this.h.get(c);if(!s)return;const f=this.l.getNotebookDocument(S.URI.revive(b));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,f.apiNotebook);else for(const P of i){const C=f.getCell(P);C&&this.b.get(C.uri)?.cancel()}}$acceptKernelMessageFromRenderer(c,b,i){const s=this.h.get(c);if(!s)return;const f=this.l.getEditorById(b);s.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:i}))}$cellExecutionChanged(c,b,i){const f=this.l.getNotebookDocument(S.URI.revive(c)).getCell(b);if(f){const P=i?m.NotebookCellExecutionState.to(i):a.NotebookCellExecutionState.Idle;P!==void 0&&this.j.fire({cell:f.apiCell,state:P})}}_createNotebookCellExecution(c,b){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this.l.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!s)throw new Error("invalid cell");if(this.b.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const f=new t(b,s,this.a);this.b.set(s.uri,f);const P=f.onDidChangeState(()=>{f.state===p.Resolved&&(f.dispose(),P.dispose(),this.b.delete(s.uri))});return f.asApiObject()}};L=qe([Ve(4,N.ILogService)],L),e.ExtHostNotebookKernels=L;var p;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(p||(p={}));class t extends y.Disposable{get state(){return this.f}constructor(c,b,i){super(),this.j=b,this.k=i,this.b=t.a++,this.c=new M.Emitter,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new D.CancellationTokenSource),this.h=new d(10,s=>this.m(s)),this.i=b.internalMetadata.executionOrder,this.k.$createExecution(this.b,c,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(c){await this.h.addItem(c)}async m(c){const b=Array.isArray(c)?c:[c];return this.k.$updateExecution(this.b,new E.SerializableObjectWithBuffers(b))}n(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(c){let b=this.j;if(c&&(b=this.j.notebook.getCellFromApiCell(c)),!b)throw new Error("INVALID cell");return b.handle}s(c){return c.map(b=>{const i=a.NotebookCellOutput.ensureUniqueMimeTypes(b.items,!0);return i===b.items?m.NotebookCellOutput.from(b):m.NotebookCellOutput.from({items:i,id:b.id,metadata:b.metadata})})}async t(c,b,i){const s=this.r(b),f=this.s((0,n.asArray)(c));return this.l({editType:u.CellExecutionUpdateType.Output,cellHandle:s,append:i,outputs:f})}async w(c,b,i){return c=a.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(c),!0),this.l({editType:u.CellExecutionUpdateType.OutputItems,items:c.map(m.NotebookCellOutputItem.from),outputId:b.id,append:i})}asApiObject(){const c=this;return Object.freeze({get token(){return c.g.token},get cell(){return c.j.apiCell},get executionOrder(){return c.i},set executionOrder(i){c.i=i,c.m([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:c.i}])},start(i){if(c.f===p.Resolved||c.f===p.Started)throw new Error("Cannot call start again");c.f=p.Started,c.c.fire(),c.m({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:i})},end(i,s){if(c.f===p.Resolved)throw new Error("Cannot call resolve twice");c.f=p.Resolved,c.c.fire(),c.h.flush(),c.k.$completeExecution(c.b,new E.SerializableObjectWithBuffers({runEndTime:s,lastRunSuccess:i}))},clearOutput(i){return c.n(),c.t([],i,!1)},appendOutput(i,s){return c.n(),c.t(i,s,!0)},replaceOutput(i,s){return c.n(),c.t(i,s,!1)},appendOutputItems(i,s){return c.n(),c.w(i,s,!0)},replaceOutputItems(i,s){return c.n(),c.w(i,s,!1)}})}}t.a=0;class d{constructor(c,b){this.d=c,this.e=b,this.a=[],this.b=Date.now()}addItem(c){return this.a.push(c),this.c||(this.c=new k.DeferredPromise,this.b=Date.now(),(0,k.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const c=this.c;this.c=void 0;const b=this.a;return this.a=[],this.e(b).finally(()=>c.complete())}}function r(l,c){return`${l.value}/${c}`}e.createKernelId=r}),define(ke[224],Te([1,0,4,5,100]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(R,S){this.c=S,this.a=new Map,this.b=R.getProxy(k.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,S,T){const N=this.c.getEditorById(R);this.a.get(S)?.fire({editor:N.apiEditor,message:T})}createRendererMessaging(R,S){if(!R.contributes?.notebookRenderer?.some(N=>N.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(N,w,h)=>this.d(S).event(N,w,h),postMessage:(N,w)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(N)&&([N,w]=[w,N]);const h=w&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.b.$postMessage(h?.id,S,N)}}}d(R){let S=this.a.get(R);return S||(S=new n.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(R)}}),this.a.set(R,S),S)}}e.ExtHostNotebookRenderers=M}),define(ke[225],Te([1,0,6,9,2,25,5]),function(te,e,n,k,D,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class R{constructor(T){this.b=new Map,this.a=T.getProxy(y.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(T,N,w){if((0,M.checkProposedApiEnabled)(T,"profileContentHandlers"),this.b.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.b.set(N,w),this.a.$registerProfileContentHandler(N,w.name,w.description,T.identifier.value),(0,n.toDisposable)(()=>{this.b.delete(N),this.a.$unregisterProfileContentHandler(N)})}async $saveProfile(T,N,w,h){const v=this.b.get(T);if(!v)throw new Error(`Unknown handler with id: ${T}`);return v.saveProfile(N,w,h)}async $readProfile(T,N,w){const h=this.b.get(T);if(!h)throw new Error(`Unknown handler with id: ${T}`);return h.readProfile((0,k.isString)(N)?N:D.URI.revive(N),w)}}e.ExtHostProfileContentHandlers=R}),define(ke[226],Te([1,0,2,5,17,8]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class y{constructor(S,T){this.d=T,this.c=new Map,this.b=S.getProxy(k.MainContext.MainThreadQuickDiff)}$provideOriginalResource(S,T,N){const w=n.URI.revive(T),h=this.c.get(S);return h?(0,D.asPromise)(()=>h.provideOriginalResource(w,N)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(S,T,N,w){const h=y.a++;return this.c.set(h,T),this.b.$registerQuickDiffProvider(h,M.DocumentSelector.from(S,this.d),N,w),{dispose:()=>{this.b.$unregisterQuickDiffProvider(h),this.c.delete(h)}}}}y.a=0,e.ExtHostQuickDiff=y}),define(ke[227],Te([1,0,21,4,6,5,2,7,12,16,29,38,25,8]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(a,o,u){const g=a.getProxy(M.MainContext.MainThreadQuickOpen);class E{constructor(i,s){this.e=new Map,this.f=0,this.a=i,this.b=s}showQuickPick(i,s,f,P=n.CancellationToken.None){this.c=void 0;const C=Promise.resolve(s),j=++this.f,_=g.$show(j,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},P),K={},A=_.then(()=>K);return Promise.race([A,C]).then($=>{if($===K)return;const O=(0,h.isProposedApiEnabled)(i,"quickPickItemTooltip");return C.then(F=>{const H=[];for(let V=0;V<F.length;V++){const ae=F[V];typeof ae=="string"?H.push({label:ae,handle:V}):ae.kind===R.QuickPickItemKind.Separator?H.push({type:"separator",label:ae.label}):(ae.tooltip&&!O&&console.warn(`Extension '${i.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${i.identifier.value}`),H.push({label:ae.label,description:ae.description,detail:ae.detail,picked:ae.picked,alwaysShow:ae.alwaysShow,tooltip:O?v.MarkdownString.fromStrict(ae.tooltip):void 0,handle:V}))}return f&&typeof f.onDidSelectItem=="function"&&(this.c=V=>{f.onDidSelectItem(F[V])}),g.$setItems(j,H),_.then(V=>{if(typeof V=="number")return F[V];if(Array.isArray(V))return V.map(ae=>F[ae])})})}).then(void 0,$=>{if(!(0,S.isCancellationError)($))return g.$setError(j,$),Promise.reject($)})}$onItemSelected(i){this.c?.(i)}showInput(i,s=n.CancellationToken.None){return this.d=i?.validateInput,g.$input(i,typeof this.d=="function",s).then(void 0,f=>{if(!(0,S.isCancellationError)(f))return Promise.reject(f)})}async $validateInput(i){if(!this.d)return;const s=await this.d(i);if(!s||typeof s=="string")return s;let f;switch(s.severity){case R.InputBoxValidationSeverity.Info:f=N.default.Info;break;case R.InputBoxValidationSeverity.Warning:f=N.default.Warning;break;case R.InputBoxValidationSeverity.Error:f=N.default.Error;break;default:f=s.message?N.default.Error:N.default.Ignore;break}return{content:s.message,severity:f}}async showWorkspaceFolderPick(i,s=n.CancellationToken.None){const f=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!f)return;const P=await this.a.getWorkspaceFolders2();if(!!P)return P.find(C=>C.uri.toString()===f.uri.toString())}createQuickPick(i){const s=new l(i,()=>this.e.delete(s._id));return this.e.set(s._id,s),s}createInputBox(i){const s=new c(i,()=>this.e.delete(s._id));return this.e.set(s._id,s),s}$onDidChangeValue(i,s){this.e.get(i)?._fireDidChangeValue(s)}$onDidAccept(i){this.e.get(i)?._fireDidAccept()}$onDidChangeActive(i,s){const f=this.e.get(i);f instanceof l&&f._fireDidChangeActive(s)}$onDidChangeSelection(i,s){const f=this.e.get(i);f instanceof l&&f._fireDidChangeSelection(s)}$onDidTriggerButton(i,s){this.e.get(i)?._fireDidTriggerButton(s)}$onDidTriggerItemButton(i,s,f){const P=this.e.get(i);P instanceof l&&P._fireDidTriggerItemButton(s,f)}$onDidHide(i){this.e.get(i)?._fireDidHide()}}class L{constructor(i,s){this.x=i,this.y=s,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new k.Emitter,this.q=new k.Emitter,this.r=new k.Emitter,this.s=new k.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(i){this.b=i,this.z({title:i})}get step(){return this.c}set step(i){this.c=i,this.z({step:i})}get totalSteps(){return this.d}set totalSteps(i){this.d=i,this.z({totalSteps:i})}get enabled(){return this.g}set enabled(i){this.g=i,this.z({enabled:i})}get busy(){return this.j}set busy(i){this.j=i,this.z({busy:i})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(i){this.k=i,this.z({ignoreFocusOut:i})}get value(){return this.l}set value(i){this.l=i,this.z({value:i})}get placeholder(){return this.m}set placeholder(i){this.m=i,this.z({placeholder:i})}get buttons(){return this.n}set buttons(i){this.n=i.slice(),this.o.clear(),i.forEach((s,f)=>{const P=s===R.QuickInputButtons.Back?-1:f;this.o.set(P,s)}),this.z({buttons:i.map((s,f)=>({...r(s),tooltip:s.tooltip,handle:s===R.QuickInputButtons.Back?-1:f}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(i){this.l=i,this.q.fire(i)}_fireDidTriggerButton(i){const s=this.o.get(i);s&&this.r.fire(s)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,D.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),g.$dispose(this._id))}z(i){if(!this.v){for(const s of Object.keys(i)){const f=i[s];this.u[s]=f===void 0?null:f}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){g.$createOrUpdate(this.u),this.u={id:this._id}}}L.a=1;function p(b){if(b instanceof R.ThemeIcon)return{id:b.id};const i=d(b),s=t(b);return{dark:typeof i=="string"?y.URI.file(i):i,light:typeof s=="string"?y.URI.file(s):s}}function t(b){return typeof b=="object"&&"light"in b?b.light:b}function d(b){return typeof b=="object"&&"dark"in b?b.dark:b}function r(b){const i=p(b.iconPath);let s,f;return"id"in i?f=w.ThemeIcon.asClassName(i):s=i,{iconPath:s,iconClass:f}}class l extends L{constructor(i,s){super(i.identifier,s),this.O=i,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new k.Emitter,this.L=[],this.M=new k.Emitter,this.N=new k.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(i){this.B=i.slice(),this.C.clear(),this.D.clear(),i.forEach((P,C)=>{this.C.set(C,P),this.D.set(P,C)});const s=(0,h.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),f=[];for(let P=0;P<i.length;P++){const C=i[P];C.kind===R.QuickPickItemKind.Separator?f.push({type:"separator",label:C.label}):(C.tooltip&&!s&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),f.push({handle:P,label:C.label,description:C.description,detail:C.detail,picked:C.picked,alwaysShow:C.alwaysShow,tooltip:s?v.MarkdownString.fromStrict(C.tooltip):void 0,buttons:C.buttons?.map((j,_)=>({...r(j),tooltip:j.tooltip,handle:_}))}))}this.z({items:f})}get canSelectMany(){return this.E}set canSelectMany(i){this.E=i,this.z({canSelectMany:i})}get matchOnDescription(){return this.F}set matchOnDescription(i){this.F=i,this.z({matchOnDescription:i})}get matchOnDetail(){return this.G}set matchOnDetail(i){this.G=i,this.z({matchOnDetail:i})}get sortByLabel(){return this.H}set sortByLabel(i){this.H=i,this.z({sortByLabel:i})}get keepScrollPosition(){return this.I}set keepScrollPosition(i){this.I=i,this.z({keepScrollPosition:i})}get activeItems(){return this.J}set activeItems(i){this.J=i.filter(s=>this.D.has(s)),this.z({activeItems:this.J.map(s=>this.D.get(s))})}get selectedItems(){return this.L}set selectedItems(i){this.L=i.filter(s=>this.D.has(s)),this.z({selectedItems:this.L.map(s=>this.D.get(s))})}_fireDidChangeActive(i){const s=(0,T.coalesce)(i.map(f=>this.C.get(f)));this.J=s,this.K.fire(s)}_fireDidChangeSelection(i){const s=(0,T.coalesce)(i.map(f=>this.C.get(f)));this.L=s,this.M.fire(s)}_fireDidTriggerItemButton(i,s){const f=this.C.get(i);if(!f||!f.buttons||!f.buttons.length)return;const P=f.buttons[s];P&&this.N.fire({button:P,item:f})}}class c extends L{constructor(i,s){super(i.identifier,s),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(i){this.B=i,this.z({password:i})}get prompt(){return this.C}set prompt(i){this.C=i,this.z({prompt:i})}get valueSelection(){return this.D}set valueSelection(i){this.D=i,this.z({valueSelection:i})}get validationMessage(){return this.E}set validationMessage(i){this.E=i,i?typeof i=="string"?this.z({validationMessage:i,severity:N.default.Error}):this.z({validationMessage:i.message,severity:i.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new E(o,u)}e.createExtHostQuickOpen=m});var Le=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n};define(ke[228],Te([1,0,2,4,64,6,17,5,16,123,11,26,38,8,25]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m){"use strict";var a,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(s){if(s)return typeof s.iconPath=="string"?n.URI.file(s.iconPath):n.URI.isUri(s.iconPath)||h.ThemeIcon.isThemeIcon(s.iconPath)?s.iconPath:void 0}function g(s,f){if(!s.iconPath&&!f.iconPath)return 0;if(s.iconPath){if(!f.iconPath)return 1}else return-1;const P=typeof s.iconPath=="string"?s.iconPath:n.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id,C=typeof f.iconPath=="string"?f.iconPath:n.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,T.comparePaths)(P,C)}function E(s,f){let P=0;if(s.strikeThrough!==f.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==f.faded)return s.faded?1:-1;if(s.tooltip!==f.tooltip)return(s.tooltip||"").localeCompare(f.tooltip||"");if(P=g(s,f),P!==0)return P;if(s.light&&f.light)P=g(s.light,f.light);else{if(s.light)return 1;if(f.light)return-1}if(P!==0)return P;if(s.dark&&f.dark)P=g(s.dark,f.dark);else{if(s.dark)return 1;if(f.dark)return-1}return P}function L(s,f){if(s.command!==f.command)return s.command<f.command?-1:1;if(s.title!==f.title)return s.title<f.title?-1:1;if(s.tooltip!==f.tooltip){if(s.tooltip!==void 0&&f.tooltip!==void 0)return s.tooltip<f.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(s.arguments===f.arguments)return 0;if(s.arguments)if(f.arguments){if(s.arguments.length!==f.arguments.length)return s.arguments.length-f.arguments.length}else return 1;else return-1;for(let P=0;P<s.arguments.length;P++){const C=s.arguments[P],j=f.arguments[P];if(C!==j)return C<j?-1:1}return 0}function p(s,f){let P=(0,T.comparePaths)(s.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(P!==0)return P;if(s.command&&f.command)P=L(s.command,f.command);else{if(s.command)return 1;if(f.command)return-1}if(P!==0)return P;if(s.decorations&&f.decorations)P=E(s.decorations,f.decorations);else{if(s.decorations)return 1;if(f.decorations)return-1}return P}function t(s,f){for(let P=0;P<s.length;P++)if(s[P]!==f[P])return!1;return!0}function d(s,f){return s.command===f.command&&s.title===f.title&&s.tooltip===f.tooltip&&(s.arguments&&f.arguments?t(s.arguments,f.arguments):s.arguments===f.arguments)}function r(s,f){return(0,S.equals)(s,f,d)}class l{get value(){return this.d}set value(f){f=f??"",Le(this,a,"f").$setInputBoxValue(this.l,f),this.m(f)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(f){Le(this,a,"f").$setInputBoxPlaceholder(this.l,f),this.f=f}get validateInput(){return(0,m.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(f){if((0,m.checkProposedApiEnabled)(this.k,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=f,Le(this,a,"f").$setValidationProviderIsEnabled(this.l,!!f)}get enabled(){return this.h}set enabled(f){f=!!f,this.h!==f&&(this.h=f,Le(this,a,"f").$setInputBoxEnablement(this.l,f))}get visible(){return this.j}set visible(f){f=!!f,this.j!==f&&(this.j=f,Le(this,a,"f").$setInputBoxVisibility(this.l,f))}constructor(f,P,C){this.k=f,this.l=C,a.set(this,void 0),this.d="",this.e=new k.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,a,P,"f")}showValidationMessage(f,P){(0,m.checkProposedApiEnabled)(this.k,"scmValidation"),Le(this,a,"f").$showValidationMessage(this.l,f,P)}$onInputBoxValueChange(f){this.m(f)}m(f){this.d=f,this.e.fire(f)}}e.ExtHostSCMInputBox=l,a=new WeakMap;class c{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(f){this.v=f,this.q.$updateGroupLabel(this.t,this.handle,f)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(f){this.p=f,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(f){this.f=[...f],this.k.fire()}constructor(f,P,C,j,_){this.q=f,this.s=P,this.t=C,this.u=j,this.v=_,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new k.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new k.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(f){return this.g.get(f)}$executeResourceCommand(f,P){const C=this.h.get(f);return C?(0,y.asPromise)(()=>this.s.executeCommand(C.command,...C.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this.f].sort(p),C=(0,S.sortedDiff)(this.o,f,p).map(K=>{const A=K.toInsert.map($=>{const O=this.e++;this.g.set(O,$);const F=$.resourceUri;let H;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const J=new M.DisposableStore;H=this.s.converter.toInternal($.command,J),this.j.set(O,J)}else this.h.set(O,$.command);const V=u($.decorations),ae=$.decorations&&u($.decorations.light)||V,pe=$.decorations&&u($.decorations.dark)||V,re=[ae,pe],ce=$.decorations&&$.decorations.tooltip||"",ue=$.decorations&&!!$.decorations.strikeThrough,Se=$.decorations&&!!$.decorations.faded,G=$.contextValue||"";return{rawResource:[O,F,re,ce,ue,Se,G,H],handle:O}});return{start:K.start,deleteCount:K.deleteCount,toInsert:A}}),j=C.map(({start:K,deleteCount:A,toInsert:$})=>[K,A,$.map(O=>O.rawResource)]),_=C.reverse();for(const{start:K,deleteCount:A,toInsert:$}of _){const O=$.map(H=>H.handle),F=this.n.splice(K,A,...O);for(const H of F)this.g.delete(H),this.h.delete(H),this.j.get(H)?.dispose(),this.j.delete(H)}return this.o=f,j}dispose(){this.l=!0,this.m.fire()}}c.d=0;class b{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(f){this.g!==f&&(this.g=f,Le(this,o,"f").$updateSourceControl(this.t,{count:f}))}get quickDiffProvider(){return this.h}set quickDiffProvider(f){this.h=f,f?.label&&(0,m.checkProposedApiEnabled)(this.u,"quickDiffProvider"),Le(this,o,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!f,quickDiffLabel:f?.label})}get commitTemplate(){return this.j}set commitTemplate(f){f!==this.j&&(this.j=f,Le(this,o,"f").$updateSourceControl(this.t,{commitTemplate:f}))}get acceptInputCommand(){return this.l}set acceptInputCommand(f){this.k.value=new M.DisposableStore,this.l=f;const P=this.v.converter.toInternal(f,this.k.value);Le(this,o,"f").$updateSourceControl(this.t,{acceptInputCommand:P})}get actionButton(){return(0,m.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(f){(0,m.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new M.DisposableStore,this.n=f;const P=f!==void 0?{command:this.v.converter.toInternal(f.command,this.m.value),secondaryCommands:f.secondaryCommands?.map(C=>C.map(j=>this.v.converter.toInternal(j,this.m.value))),description:f.description,enabled:f.enabled}:void 0;Le(this,o,"f").$updateSourceControl(this.t,{actionButton:P??null})}get statusBarCommands(){return this.p}set statusBarCommands(f){if(this.p&&f&&r(this.p,f))return;this.o.value=new M.DisposableStore,this.p=f;const P=(f||[]).map(C=>this.v.converter.toInternal(C,this.o.value));Le(this,o,"f").$updateSourceControl(this.t,{statusBarCommands:P})}get selected(){return this.q}constructor(f,P,C,j,_,K){this.u=f,this.v=C,this.w=j,this.x=_,this.y=K,o.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new M.MutableDisposable,this.l=void 0,this.m=new M.MutableDisposable,this.o=new M.MutableDisposable,this.p=void 0,this.q=!1,this.s=new k.Emitter,this.onDidChangeSelection=this.s.event,this.t=b.d++,this.z=new Map,this.A=new Set,Je(this,o,P,"f"),this.f=new l(f,Le(this,o,"f"),this.t),Le(this,o,"f").$registerSourceControl(this.t,j,_,K)}createResourceGroup(f,P){const C=new c(Le(this,o,"f"),this.v,this.t,f,P),j=k.Event.once(C.onDidDispose)(()=>this.z.delete(C));return this.z.set(C,j),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const f=[],P=[];for(const[C,j]of this.z){j.dispose();const _=C.onDidUpdateResourceStates(()=>{this.A.add(C),this.eventuallyUpdateResourceStates()});k.Event.once(C.onDidDispose)(()=>{this.A.delete(C),_.dispose(),this.e.delete(C.handle),Le(this,o,"f").$unregisterGroup(this.t,C.handle)}),f.push([C.handle,C.id,C.label,C.features]);const K=C._takeResourceStateSnapshot();K.length>0&&P.push([C.handle,K]),this.e.set(C.handle,C)}Le(this,o,"f").$registerGroups(this.t,f,P),this.z.clear()}eventuallyUpdateResourceStates(){const f=[];this.A.forEach(P=>{const C=P._takeResourceStateSnapshot();C.length!==0&&f.push([P.handle,C])}),f.length>0&&Le(this,o,"f").$spliceResourceStates(this.t,f),this.A.clear()}getResourceGroup(f){return this.e.get(f)}setSelectionState(f){this.q=f,this.s.fire(f)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(f=>f.dispose()),Le(this,o,"f").$unregisterSourceControl(this.t)}}o=new WeakMap,b.d=0,qe([(0,D.debounce)(100)],b.prototype,"eventuallyAddResourceGroups",null),qe([(0,D.debounce)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let i=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(f,P,C){this.l=P,this.m=C,this.g=new Map,this.h=new Map,this.j=new k.Emitter,this.e=f.getProxy(R.MainContext.MainThreadSCM),this.f=f.getProxy(R.MainContext.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const _=this.g.get(j.sourceControlHandle);if(!_)return j;const K=_.getResourceGroup(j.groupHandle);return K?K.getResourceState(j.handle):j}else if(j&&j.$mid===4){const _=this.g.get(j.sourceControlHandle);return _?_.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const _=this.g.get(j.handle);return _||j}return j}})}createSourceControl(f,P,C,j){this.m.trace("ExtHostSCM#createSourceControl",f.identifier.value,P,C,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const _=on.d++,K=new b(f,this.e,this.l,P,C,j);this.g.set(_,K);const A=this.h.get(w.ExtensionIdentifier.toKey(f.identifier))||[];return A.push(K),this.h.set(w.ExtensionIdentifier.toKey(f.identifier),A),K}getLastInputBox(f){this.m.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const P=this.h.get(w.ExtensionIdentifier.toKey(f.identifier)),C=P&&P[P.length-1];return C&&C.inputBox}$provideOriginalResource(f,P,C){const j=n.URI.revive(P);this.m.trace("ExtHostSCM#$provideOriginalResource",f,j.toString());const _=this.g.get(f);return!_||!_.quickDiffProvider||!_.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>_.quickDiffProvider.provideOriginalResource(j,C)).then(K=>K||null)}$onInputBoxValueChange(f,P){this.m.trace("ExtHostSCM#$onInputBoxValueChange",f);const C=this.g.get(f);return C&&C.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(f,P,C,j){this.m.trace("ExtHostSCM#$executeResourceCommand",f,P,C);const _=this.g.get(f);if(!_)return Promise.resolve(void 0);const K=_.getResourceGroup(P);return K?K.$executeResourceCommand(C,j):Promise.resolve(void 0)}$validateInput(f,P,C){this.m.trace("ExtHostSCM#$validateInput",f);const j=this.g.get(f);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>j.inputBox.validateInput(P,C)).then(_=>{if(!_)return Promise.resolve(void 0);const K=v.MarkdownString.fromStrict(_.message);return K?Promise.resolve([K,_.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this.g.get(f)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=f,Promise.resolve(void 0)}};i.d=0,i=qe([Ve(2,N.ILogService)],i),e.ExtHostSCM=i}),define(ke[79],Te([1,0,5,4,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(R){this.b=new k.Emitter,this.onDidChangePassword=this.b.event,this.a=R.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,S){return this.a.$getPassword(R,S)}store(R,S,T){return this.a.$setPassword(R,S,T)}delete(R,S){return this.a.$deletePassword(R,S)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(ke[229],Te([1,0,7,5,142,6,8,9]),function(te,e,n,k,D,M,y,R){"use strict";var S,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(m,a,o,u,g=n.StatusBarAlignment.Left,E){S.set(this,void 0),T.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new M.DisposableStore,Je(this,S,m,"f"),Je(this,T,a,"f"),this.c=N.a++,this.e=o,this.f=u,this.g=g,this.h=this.u(E)}u(m){if(!!(0,R.isNumber)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!N.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new M.DisposableStore,typeof m=="string"?this.r={fromApi:m,internal:Le(this,T,"f").toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:Le(this,T,"f").toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Le(this,S,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let a;this.m?a=this.m:a=(0,D.localize)(0,null,this.e.displayName||this.e.name);let o=this.n;this.o&&(o=N.b.get(this.o.id));const u=y.MarkdownString.fromStrict(this.l);Le(this,S,"f").$setEntry(this.c,m,a,this.k,u,this.r?.internal,o,this.o,this.g===n.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}S=new WeakMap,T=new WeakMap,N.a=0,N.b=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=N;class w{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,D.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const a={message:m};return this.b.unshift(a),this.c(),new n.Disposable(()=>{const o=this.b.indexOf(a);o>=0&&(this.b.splice(o,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class h{constructor(m,a){this.a=m.getProxy(k.MainContext.MainThreadStatusBar),this.b=a,this.c=new w(this)}createStatusBarEntry(m,a,o,u){return new N(this.a,this.b,m,a,o,u)}setStatusBarMessage(m,a){const o=this.c.setMessage(m);let u;return typeof a=="number"?u=setTimeout(()=>o.dispose(),a):typeof a<"u"&&a.then(()=>o.dispose(),()=>o.dispose()),new n.Disposable(()=>{o.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=h}),define(ke[80],Te([1,0,5,4,3]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(R,S){this.c=S,this.b=new k.Emitter,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,S){this.a.$registerExtensionStorageKeysToSync(R,S)}async initializeExtensionStorage(R,S,T){const N=await this.a.$initializeExtensionStorage(R,S);let w;return N&&(w=this.d(R,S,N)),w||T}setValue(R,S,T){return this.a.$setValue(R,S,T)}$acceptValue(R,S,T){const N=this.d(R,S,T);N&&this.b.fire({shared:R,key:S,value:N})}d(R,S,T){try{return JSON.parse(T)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${R}): ${N}`)}}}e.ExtHostStorage=M,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(ke[81],Te([1,0,3,27,11,60,2]),function(te,e,n,k,D,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let R=class{constructor(T,N,w){this.d=N,this.f=w,this.a=T.workspace??void 0,this.b=T.environment,this.whenReady=this.h().then(h=>this.c=h)}async g(T){return y.URI.joinPath(this.b.workspaceStorageHome,T)}async h(){if(!this.a)return Promise.resolve(void 0);const T=this.a.id,N=await this.g(T);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(y.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:y.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(w){this.d.error("[ExtHostStorage]",w);return}}workspaceValue(T){if(this.c)return y.URI.joinPath(this.c,T.identifier.value)}globalValue(T){return y.URI.joinPath(this.b.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};R=qe([Ve(0,k.IExtHostInitDataService),Ve(1,D.ILogService),Ve(2,M.IExtHostConsumerFileSystem)],R),e.ExtensionStoragePaths=R}),define(ke[61],Te([1,0,4,5,3,2,18,6,7,144,12,170,21,34,171,38,9,17,8]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class E{constructor(i,s,f,P){this.k=i,this._id=s,this.l=f,this.m=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(j=>this.f=j);const C=this;this.value={get name(){return C.m||""},get processId(){return C.b},get creationOptions(){return C.l},get exitStatus(){return C.h},get state(){return C.j},sendText(j,_=!0){C.o(),C.k.$sendText(C._id,j,_)},show(j){C.o(),C.k.$show(C._id,j)},hide(){C.o(),C.k.$hide(C._id)},dispose(){C.a||(C.a=!0,C.k.$dispose(C._id))},get dimensions(){if(!(C.d===void 0||C.g===void 0))return{columns:C.d,rows:C.g}}}}async create(i,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:i.name,shellPath:(0,o.withNullAsUndefined)(i.shellPath),shellArgs:(0,o.withNullAsUndefined)(i.shellArgs),cwd:(0,o.withNullAsUndefined)(i.cwd),env:(0,o.withNullAsUndefined)(i.env),icon:(0,o.withNullAsUndefined)(l(i.iconPath)),color:a.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,o.withNullAsUndefined)(i.message),strictEnv:(0,o.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this.n(i.location,s?.resolvedExtHostIdentifier),isTransient:(0,o.withNullAsUndefined)(i.isTransient)})}async createExtensionTerminal(i,s,f,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:f,color:a.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.n(i,s),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(i,s){return typeof i=="object"?"parentTerminal"in i&&i.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in i?{viewColumn:g.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus}:void 0:i}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(i){this.m=i}setExitStatus(i,s){this.h=Object.freeze({code:i,reason:s})}setDimensions(i,s){return i===this.d&&s===this.g||i===0||s===0?!1:(this.d=i,this.g=s,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(i){this.f?(this.f(i),this.f=void 0):this.b.then(s=>{s!==i&&(this.b=Promise.resolve(i))})}}e.ExtHostTerminal=E;class L{get onProcessReady(){return this.b.event}constructor(i){this.g=i,this.id=0,this.shouldPersist=!1,this.a=new n.Emitter,this.onProcessData=this.a.event,this.b=new n.Emitter,this.d=new n.Emitter,this.onDidChangeProperty=this.d.event,this.f=new n.Emitter,this.onProcessExit=this.f.event}refreshProperty(i){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${i}`)}updateProperty(i,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${i}, value: ${s}`)}async start(){}shutdown(){this.g.close()}input(i){this.g.handleInput?.(i)}resize(i,s){this.g.setDimensions?.({columns:i,rows:s})}async processBinary(i){}acknowledgeDataEvent(i){}async setUnicodeVersion(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this.g.onDidWrite(s=>this.a.fire(s)),this.g.onDidClose?.((s=void 0)=>{this.f.fire(s===void 0?void 0:s)}),this.g.onDidOverrideDimensions?.(s=>{s&&this.d.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this.g.onDidChangeName?.(s=>{this.d.fire({type:"title",value:s})}),this.g.open(i||void 0),i&&this.g.setDimensions?.(i),this.b.fire({pid:-1,cwd:""})}}let p=1,t=class extends R.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(i=>i.value)}get onDidWriteTerminalData(){return this.I.event}constructor(i,s){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new n.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new n.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new n.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new n.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new n.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new n.Emitter,this.onDidChangeShell=this.J.event,this.a=s.getProxy(k.MainContext.MainThreadTerminalService),this.s=new m.TerminalDataBufferer(this.a.$sendProcessData),this.I=new n.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(i),this.B({dispose:()=>{for(const[f,P]of this.g)P.shutdown(!0)}})}getDefaultShell(i){return(i?this.n:this.m)?.path||""}getDefaultShellArgs(i){return(i?this.n:this.m)?.args||[]}createExtensionTerminal(i,s){const f=new E(this.a,(0,v.generateUuid)(),i,i.name),P=new L(i.pty);return f.createExtensionTerminal(i.location,this.L(i,s).resolvedExtHostIdentifier,l(i.iconPath),c(i.color)).then(C=>{const j=this.M(C,P);this.h[C]=j}),this.f.push(f),f.value}L(i,s){if(s=s||{},i.location&&typeof i.location=="object"&&"parentTerminal"in i.location){const f=i.location.parentTerminal;if(f){const P=this.f.find(C=>C.value===f);P&&(s.resolvedExtHostIdentifier=P._id)}}else i.location&&typeof i.location!="object"?s.location=i.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(i,s){if(!this.O(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const P=new L(s),C=this.M(i,P);this.h[i]=C}async $acceptActiveTerminalChanged(i){const s=this.b;if(i===null){this.b=void 0,s!==this.b&&this.F.fire(this.b);return}const f=this.O(i);f&&(this.b=f,s!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(i,s){const f=this.O(i);f&&this.I.fire({terminal:f.value,data:s})}async $acceptTerminalDimensions(i,s,f){const P=this.O(i);P&&P.setDimensions(s,f)&&this.G.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptTerminalMaximumDimensions(i,s,f){this.g.get(i)?.resize(s,f)}async $acceptTerminalTitleChange(i,s){const f=this.O(i);f&&(f.name=s)}async $acceptTerminalClosed(i,s,f){const P=this.Q(this.f,i);if(P!==null){const C=this.f.splice(P,1)[0];C.setExitStatus(s,f),this.C.fire(C.value)}}$acceptTerminalOpened(i,s,f,P){if(s){const _=this.Q(this.f,s);if(_!==null){this.f[_]._id=i,this.D.fire(this.terminals[_]),this.f[_].isOpen=!0;return}}const C={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:M.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},j=new E(this.a,i,C,f);this.f.push(j),this.D.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(i,s){this.O(i)?._setProcessId(s)}async $startExtensionTerminal(i,s){const f=this.O(i);if(!f)return{message:(0,T.localize)(0,null,i)};f.isOpen||await new Promise(C=>{const j=this.onDidOpenTerminal(async _=>{_===f.value&&(j.dispose(),C())})});const P=this.g.get(i);P?P.startSendingEvents(s):this.j[i]={initialDimensions:s}}M(i,s){const f=new R.DisposableStore;f.add(s.onProcessReady(C=>this.a.$sendProcessReady(i,C.pid,C.cwd))),f.add(s.onDidChangeProperty(C=>this.a.$sendProcessProperty(i,C))),this.s.startBuffering(i,s.onProcessData),f.add(s.onProcessExit(C=>this.N(i,C))),this.g.set(i,s);const P=this.j[i];return P&&s instanceof L&&(s.startSendingEvents(P.initialDimensions),delete this.j[i]),f}$acceptProcessAckDataEvent(i,s){this.g.get(i)?.acknowledgeDataEvent(s)}$acceptProcessInput(i,s){this.g.get(i)?.input(s)}$acceptTerminalInteraction(i){const s=this.O(i);s?.setInteractedWith()&&this.H.fire(s.value)}$acceptProcessResize(i,s,f){try{this.g.get(i)?.resize(s,f)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(i,s){this.g.get(i)?.shutdown(s)}$acceptProcessRequestInitialCwd(i){this.g.get(i)?.getInitialCwd().then(s=>this.a.$sendProcessProperty(i,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(i){this.g.get(i)?.getCwd().then(s=>this.a.$sendProcessProperty(i,{type:"cwd",value:s}))}$acceptProcessRequestLatency(i){return Promise.resolve(i)}registerLinkProvider(i){return this.u.add(i),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(i),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(i,s,f){if(this.v.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this.v.set(s,f),this.a.$registerProfileProvider(s,i.identifier.value),new S.Disposable(()=>{this.v.delete(s),this.a.$unregisterProfileProvider(s)})}registerTerminalQuickFixProvider(i,s,f){if(this.w.has(i))throw new Error(`Terminal quick fix provider "${i}" is already registered`);return this.w.set(i,f),this.a.$registerQuickFixProvider(i,s),new S.Disposable(()=>{this.w.delete(i),this.a.$unregisterQuickFixProvider(i)})}async $provideTerminalQuickFixes(i,s){const f=new h.CancellationTokenSource().token;if(f.isCancellationRequested)return;const P=this.w.get(i);if(!P)return;const C=await P.provideTerminalQuickFixes(s,f);if(C!==null)return C}async $createContributedProfileTerminal(i,s){const f=new h.CancellationTokenSource().token;let P=await this.v.get(i)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,s);return}this.createTerminalFromOptions(P.options,s)}}async $provideLinks(i,s){const f=this.O(i);if(!f)return[];this.y.delete(i),this.z.get(i)?.dispose(!0);const C=new h.CancellationTokenSource;this.z.set(i,C);const j=[],_={terminal:f.value,line:s},K=[];for(const O of this.u)K.push(u.Promises.withAsyncBody(async F=>{C.token.onCancellationRequested(()=>F({provider:O,links:[]}));const H=await O.provideTerminalLinks(_,C.token)||[];C.token.isCancellationRequested||F({provider:O,links:H})}));const A=await Promise.all(K);if(C.token.isCancellationRequested)return[];const $=new Map;for(const O of A)O&&O.links.length>0&&j.push(...O.links.map(F=>{const H={id:p++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return $.set(H.id,{provider:O.provider,link:F}),H}));return this.y.set(i,$),j}$activateLink(i,s){const f=this.y.get(i)?.get(s);!f||f.provider.handleTerminalLink(f.link)}N(i,s){this.s.stopBuffering(i),this.g.delete(i),delete this.j[i];const f=this.h[i];f&&(f.dispose(),delete this.h[i]),this.a.$sendProcessExit(i,s)}O(i){return this.P(this.f,i)}P(i,s){const f=this.Q(i,s);return f!==null?i[f]:null}Q(i,s){let f=null;return i.some((P,C)=>P._id===s?(f=C,!0):!1),f}getEnvironmentVariableCollection(i){let s=this.l.get(i.identifier.value);return s||(s=new d,this.S(i.identifier.value,s)),s}R(i,s){const f=(0,w.serializeEnvironmentVariableCollection)(s.map);this.a.$setEnvironmentVariableCollection(i,s.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(i){i.forEach(s=>{const f=s[0],P=new d(s[1]);this.S(f,P)})}$acceptDefaultProfile(i,s){const f=this.m;this.m=i,this.n=s,f?.path!==i.path&&this.J.fire(i.path)}S(i,s){this.l.set(i,s),s.onDidChangeCollection(()=>{this.R(i,s)})}};t=qe([Ve(1,y.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class d{get persistent(){return this.a}set persistent(i){this.a=i,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(i){this.map=new Map,this.a=!0,this.b=new n.Emitter,this.map=new Map(i)}get size(){return this.map.size}replace(i,s){this.d(i,{value:s,type:S.EnvironmentVariableMutatorType.Replace})}append(i,s){this.d(i,{value:s,type:S.EnvironmentVariableMutatorType.Append})}prepend(i,s){this.d(i,{value:s,type:S.EnvironmentVariableMutatorType.Prepend})}d(i,s){const f=this.map.get(i);(!f||f.value!==s.value||f.type!==s.type)&&(this.map.set(i,s),this.b.fire())}get(i){return this.map.get(i)}forEach(i,s){this.map.forEach((f,P)=>i.call(s,P,f,this))}[Symbol.iterator](){return this.map.entries()}delete(i){this.map.delete(i),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let r=class extends t{constructor(i){super(!1,i)}createTerminal(i,s,f){throw new N.NotSupportedError}createTerminalFromOptions(i,s){throw new N.NotSupportedError}};r=qe([Ve(0,y.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function l(b){if(!(!b||typeof b=="string"))return"id"in b?{id:b.id,color:b.color}:b}function c(b){return a.ThemeColor.isThemeColor(b)?b:void 0}});var Le=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n};define(ke[230],Te([1,0,16,17,23,21,4,194,231,6,22,9,34,5,18,101,8,7,45,72,56,25]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o,u,g,E,L,p){"use strict";var t,d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(O,F,H){this.j=H,this.c=new y.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=O.getProxy(v.MainContext.MainThreadTesting),this.h=new _(this.f),this.g=new i(this.f),F.registerArgumentProcessor({processArgument:V=>{if(V?.$mid!==15)return V;const ae=V,pe=ae.tests[ae.tests.length-1].item.extId;return this.d.get(g.TestId.root(pe))?.collection.tree.get(pe)?.actual??(0,a.toItemFromContext)(V)}})}createTestController(O,F,H,V){if(this.d.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const ae=new T.DisposableStore,pe=ae.add(new a.ExtHostTestItemCollection(F,H,this.j));pe.root.label=H;const re=new Map,ce=this.f,ue={items:pe.root.children,get label(){return H},set label(G){H=G,pe.root.label=G,ce.$updateController(F,{label:H})},get refreshHandler(){return V},set refreshHandler(G){V=G,ce.$updateController(F,{canRefresh:!!G})},get id(){return F},createRunProfile:(G,X,J,de,ye,Fe)=>{let ze=(0,S.hash)(G);for(;re.has(ze);)ze++;return Fe!==void 0&&(0,p.checkProposedApiEnabled)(O,"testContinuousRun"),new K(this.f,re,F,ze,G,X,J,de,ye,Fe)},createTestItem(G,X,J){return new a.TestItemImpl(F,G,X,J)},createTestRun:(G,X,J=!0)=>this.g.createTestRun(F,pe,G,X,J),set resolveHandler(G){pe.resolveHandler=G},get resolveHandler(){return pe.resolveHandler},dispose:()=>{ae.dispose()}};ce.$registerTestController(F,H,!!V),ae.add((0,T.toDisposable)(()=>ce.$unregisterTestController(F)));const Se={controller:ue,collection:pe,profiles:re};return this.d.set(F,Se),ae.add((0,T.toDisposable)(()=>this.d.delete(F))),ae.add(pe.onDidGenerateDiff(G=>ce.$publishDiff(F,G.map(L.TestsDiffOp.serialize)))),ue}createTestObserver(){return this.h.checkout()}async runTests(O,F=M.CancellationToken.None){const H=s(O);if(!H)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const V=this.d.get(H.controllerId);if(!V)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(ae=>g.TestId.fromExtHostTestItem(ae,V.collection.root.id).toString())??[V.collection.root.id],profileGroup:A[H.kind],profileId:H.profileId,controllerId:H.controllerId}],exclude:O.exclude?.map(ae=>ae.id)},F)}$syncTests(){for(const{collection:O}of this.d.values())O.flushDiff();return Promise.resolve()}$provideFileCoverage(O,F,H){return(0,n.mapFind)(this.g.trackers,ae=>ae.id===O?ae.getCoverage(F):void 0)?.provideFileCoverage(H)??Promise.resolve([])}$resolveFileCoverage(O,F,H,V){return(0,n.mapFind)(this.g.trackers,pe=>pe.id===O?pe.getCoverage(F):void 0)?.resolveFileCoverage(H,V)??Promise.resolve([])}$configureRunProfile(O,F){this.d.get(O)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(O,F){await this.d.get(O)?.controller.refreshHandler?.(F)}$publishTestResults(O){this.results=Object.freeze(O.map(F=>(0,N.deepFreeze)(o.TestResults.to(F))).concat(this.results).sort((F,H)=>H.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(O,F){const H=this.d.get(g.TestId.fromString(O).controllerId)?.collection;H&&(await H.expand(O,F<0?1/0:F),H.flushDiff())}$acceptDiff(O){this.h.applyDiff(O.map(L.TestsDiffOp.deserialize))}async $runControllerTests(O,F){return Promise.all(O.map(H=>this.k(H,!1,F)))}async $startContinuousRun(O,F){const H=new M.CancellationTokenSource(F),V=await Promise.all(O.map(ae=>this.k(ae,!0,H.token)));return!F.isCancellationRequested&&!V.some(ae=>ae.error)&&await new Promise(ae=>F.onCancellationRequested(ae)),H.dispose(!0),V}async k(O,F,H){const V=this.d.get(O.controllerId);if(!V)return{};const{collection:ae,profiles:pe}=V,re=pe.get(O.profileId);if(!re)return{};const ce=O.testIds.map(X=>ae.tree.get(X)).filter(w.isDefined),ue=O.excludeExtIds.map(X=>V.collection.tree.get(X)).filter(w.isDefined).filter(X=>ce.some(J=>J.fullId.compare(X.fullId)===2));if(!ce.length)return{};const Se=new u.TestRunRequest2(ce.some(X=>X.actual instanceof a.TestItemRootImpl)?void 0:ce.map(X=>X.actual),ue.map(X=>X.actual),re,F),G=(0,L.isStartControllerTests)(O)&&this.g.prepareForMainThreadTestRun(Se,f.fromInternal(O,V.collection),H);try{return await re.runHandler(Se,H),{}}catch(X){return{error:String(X)}}finally{G&&(G.hasRunningTasks&&!H.isCancellationRequested&&await y.Event.toPromise(G.onEnd),G.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.g.cancelAllRuns():this.g.cancelRunById(O)}};r=qe([Ve(0,m.IExtHostRpcService)],r),e.ExtHostTesting=r;const l=1e4;var c;(function($){$[$.Running=0]="Running",$[$.Cancelling=1]="Cancelling",$[$.Ended=2]="Ended"})(c||(c={}));class b extends T.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(O,F,H){super(),this.k=O,this.l=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new y.Emitter),this.onEnd=this.j.event,this.h=this.B(new M.CancellationTokenSource(H));const V=this.B(new k.RunOnceScheduler(()=>this.m(),l));this.B(this.h.token.onCancellationRequested(()=>V.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(O){return this.f.get(O)?.coverage}createRun(O){const F=this.k.id,H=this.k.controllerId,V=(0,h.generateUuid)(),ae=new P(this.l,F,V),pe=Se=>(G,...X)=>{if(ce){console.warn(`Setting the state of test "${G.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(G)||(this.s(G),Se(G,...X))},re=(Se,G)=>{const X=G instanceof Array?G.map(o.TestMessage.from):[o.TestMessage.from(G)];if(Se.uri&&Se.range){const J={range:o.Range.from(Se.range),uri:Se.uri};for(const de of X)de.location=de.location||J}this.l.$appendTestMessagesInRun(F,V,g.TestId.fromExtHostTestItem(Se,H).toString(),X)};let ce=!1;const ue={isPersisted:this.k.isPersisted,token:this.h.token,name:O,get coverageProvider(){return ae.coverageProvider},set coverageProvider(Se){ae.coverageProvider=Se},enqueued:pe(Se=>{this.l.$updateTestStateInRun(F,V,g.TestId.fromExtHostTestItem(Se,H).toString(),1)}),skipped:pe(Se=>{this.l.$updateTestStateInRun(F,V,g.TestId.fromExtHostTestItem(Se,H).toString(),5)}),started:pe(Se=>{this.l.$updateTestStateInRun(F,V,g.TestId.fromExtHostTestItem(Se,H).toString(),2)}),errored:pe((Se,G,X)=>{re(Se,G),this.l.$updateTestStateInRun(F,V,g.TestId.fromExtHostTestItem(Se,H).toString(),6,X)}),failed:pe((Se,G,X)=>{re(Se,G),this.l.$updateTestStateInRun(F,V,g.TestId.fromExtHostTestItem(Se,H).toString(),4,X)}),passed:pe((Se,G)=>{this.l.$updateTestStateInRun(F,V,g.TestId.fromExtHostTestItem(Se,this.k.controllerId).toString(),3,G)}),appendOutput:(Se,G,X)=>{ce||(X&&(this.k.isIncluded(X)?this.s(X):X=void 0),this.l.$appendOutputToRun(F,V,D.VSBuffer.fromString(Se),G&&o.location.from(G),X&&g.TestId.fromExtHostTestItem(X,H).toString()))},end:()=>{ce||(ce=!0,this.l.$finishedTestRunTask(F,V),this.f.delete(V),this.f.size||this.p())}};return this.f.set(V,{run:ue,coverage:ae}),this.l.$startedTestRunTask(F,{id:V,name:O,running:!0}),ue}m(){for(const{run:O}of this.f.values())O.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(O){if(!(O instanceof a.TestItemImpl))throw new E.InvalidTestItemError(O.id);if(this.g.has(g.TestId.fromExtHostTestItem(O,this.k.controllerId).toString()))return;const F=[],H=this.k.colllection.root;for(;;){const V=o.TestItem.from(O);if(F.unshift(V),this.g.has(V.extId)||(this.g.add(V.extId),O===H))break;O=O.parent||H}this.l.$addTestsToRun(this.k.controllerId,this.k.id,F)}}class i{get trackers(){return this.c.values()}constructor(O){this.d=O,this.c=new Map}prepareForMainThreadTestRun(O,F,H){return this.f(O,F,H)}cancelRunById(O){for(const F of this.c.values())if(F.id===O){F.cancel();return}}cancelAllRuns(){for(const O of this.c.values())O.cancel()}createTestRun(O,F,H,V,ae){const pe=this.c.get(H);if(pe)return pe.createRun(V);const re=f.fromPublic(O,F,H,ae),ce=s(H);this.d.$startedExtensionTestRun({controllerId:O,continuous:!!H.continuous,profile:ce&&{group:A[ce.kind],id:ce.profileId},exclude:H.exclude?.map(Se=>g.TestId.fromExtHostTestItem(Se,F.root.id).toString())??[],id:re.id,include:H.include?.map(Se=>g.TestId.fromExtHostTestItem(Se,F.root.id).toString())??[F.root.id],persist:ae});const ue=this.f(H,re);return ue.onEnd(()=>{this.d.$finishedExtensionTestRun(re.id),ue.dispose()}),ue.createRun(V)}f(O,F,H){const V=new b(F,this.d,H);return this.c.set(O,V),V.onEnd(()=>this.c.delete(O)),V}}e.TestRunCoordinator=i;const s=$=>{if(!!$.profile){if(!($.profile instanceof K))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return $.profile}};class f{static fromPublic(O,F,H,V){return new f(O,(0,h.generateUuid)(),H.include?.map(ae=>g.TestId.fromExtHostTestItem(ae,O).toString())??[O],H.exclude?.map(ae=>g.TestId.fromExtHostTestItem(ae,O).toString())??[],V,F)}static fromInternal(O,F){return new f(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,F)}constructor(O,F,H,V,ae,pe){this.controllerId=O,this.id=F,this.isPersisted=ae,this.colllection=pe,this.c=H.map(re=>re+"\0"),this.d=V.map(re=>re+"\0")}isIncluded(O){const F=g.TestId.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const H of this.d)if(F===H||F.startsWith(H))return!1;for(const H of this.c)if(F===H||F.startsWith(H))return!0;return!1}}e.TestRunDto=f;class P{set coverageProvider(O){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!O||(this.c=O,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(O,F,H){this.f=O,this.g=F,this.h=H}async provideFileCoverage(O){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(O))());try{return(await this.d)?.map(o.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(O,F){const H=await this.d;let V=H?.[O];return!this.c||!H||!V?[]:(V.detailedCoverage||(V=H[O]=await this.c.resolveFileCoverage?.(V,F)??V),V.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class C{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(O){this.h=O,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(O){this.c.add(O)}update(O){Object.assign(O.revived,o.TestItem.toPlain(O.item)),this.c.has(O)||this.d.add(O)}remove(O){if(this.c.has(O)){this.c.delete(O);return}this.d.delete(O);const F=g.TestId.parentId(O.item.extId);if(F&&this.g.has(F.toString())){this.g.add(O.item.extId);return}this.f.add(O)}getChangeEvent(){const{c:O,d:F,f:H}=this;return{get added(){return[...O].map(V=>V.revived)},get updated(){return[...F].map(V=>V.revived)},get removed(){return[...H].map(V=>V.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class j extends L.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new y.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(O){return this.d.get(O)}getMirroredTestDataByReference(O){return this.d.get(O.id)}p(O,F){return{...O,revived:o.TestItem.toPlain(O.item),depth:F?F.depth+1:0,children:new Set}}o(){return new C(this.q)}}class _{constructor(O){this.d=O}checkout(){this.c||(this.c=this.f());const O=this.c;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(F=>F.revived)},dispose:(0,R.once)(()=>{--O.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(O){return this.c?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.c?.tests.apply(O)}f(){const O=new j;return this.d.$subscribeToDiffs(),{observers:0,tests:O}}}class K{get label(){return this.d}set label(O){O!==this.d&&(this.d=O,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(O){O!==this.g&&(this.g=O,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:O}))}get isDefault(){return this.f}set isDefault(O){O!==this.f&&(this.f=O,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?o.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this.c}set configureHandler(O){O!==this.c&&(this.c=O,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}constructor(O,F,H,V,ae,pe,re,ce=!1,ue=void 0,Se=!1){this.controllerId=H,this.profileId=V,this.d=ae,this.kind=pe,this.runHandler=re,this.f=ce,this._tag=ue,this.g=Se,t.set(this,void 0),d.set(this,void 0),Je(this,t,O,"f"),Je(this,d,F,"f"),F.set(V,this);const G=A[pe];if(typeof G!="number")throw new Error(`Unknown TestRunProfile.group ${pe}`);Le(this,t,"f").$publishTestRunProfile({profileId:V,controllerId:H,tag:ue?o.TestTag.namespace(this.controllerId,ue.id):null,label:ae,group:G,isDefault:ce,hasConfigurationHandler:!1,supportsContinuousRun:Se})}dispose(){Le(this,d,"f")?.delete(this.profileId)&&(Je(this,d,void 0,"f"),Le(this,t,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=K,t=new WeakMap,d=new WeakMap;const A={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(ke[232],Te([1,0,16,4,5,102,8,7]),function(te,e,n,k,D,M,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(N,w){this.i=w,this.a=new k.Emitter,this.b=new k.Emitter,this.c=new k.Emitter,this.d=new k.Emitter,this.f=new k.Emitter,this.g=new k.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(D.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(h=>this.g.fire(h)),this.i.onDidChangeActiveTextEditor(h=>this.f.fire(h))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const w=this.i.allEditors();return N?w:w.map(h=>h.value)}async showTextDocument(N,w,h){let v;typeof w=="number"?v={position:y.ViewColumn.from(w),preserveFocus:h}:typeof w=="object"?v={position:y.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?y.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:v={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(N.uri,v),a=m&&this.i.getEditor(m);if(a)return a.value;throw m?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,w){return new M.TextEditorDecorationType(this.h,N,w).value}$acceptEditorPropertiesChanged(N,w){const h=this.i.getEditor(N);if(!h)throw new Error("unknown text editor");if(w.options&&h._acceptOptions(w.options),w.selections){const v=w.selections.selections.map(y.Selection.to);h._acceptSelections(v)}if(w.visibleRanges){const v=n.coalesce(w.visibleRanges.map(y.Range.to));h._acceptVisibleRanges(v)}if(w.options&&this.b.fire({textEditor:h.value,options:{...w.options,lineNumbers:y.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const v=R.TextEditorSelectionChangeKind.fromValue(w.selections.source),m=w.selections.selections.map(y.Selection.to);this.a.fire({textEditor:h.value,selections:m,kind:v})}if(w.visibleRanges){const v=n.coalesce(w.visibleRanges.map(y.Range.to));this.c.fire({textEditor:h.value,visibleRanges:v})}}$acceptEditorPositionData(N){for(const w in N){const h=this.i.getEditor(w);if(!h)throw new Error("Unknown text editor");const v=y.ViewColumn.to(N[w]);h.value.viewColumn!==v&&(h._acceptViewColumn(v),this.d.fire({textEditor:h.value,viewColumn:v}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.ExtHostEditors=S}),define(ke[233],Te([1,0,2,3,5,6,7,8,26,9]),function(te,e,n,k,D,M,y,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class N{constructor(v,m){this.b=new Map,this.c=new Map,this.a=v.getProxy(D.MainContext.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(a,o)=>{if(a&&a.$mid===12)if(this.b.get(a.source)&&S.ExtensionIdentifier.equals(o,this.b.get(a.source)?.extension)){const u=a.uri===void 0?void 0:n.URI.revive(a.uri);return this.c.get(a.source)?.get(w(u))?.get(a.handle)}else return;return a}})}async $getTimeline(v,m,a,o){return this.b.get(v)?.provider.provideTimeline(n.URI.revive(m),a,o)}registerTimelineProvider(v,m,a,o){const u=new M.DisposableStore,g=this.d(m.id,o,u).bind(this);let E;m.onDidChange&&(E=m.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:m.id}),this));const L=this.c;return this.f({...m,scheme:v,onDidChange:void 0,async provideTimeline(p,t,d){t?.resetCache&&(u.clear(),L.get(m.id)?.clear());const r=await m.provideTimeline(p,t,d);if(r==null)return;const l=g(p,t);return{...r,source:m.id,items:r.items.map(l)}},dispose(){for(const p of L.values())p.get(m.id)?.clear();E?.dispose(),u.dispose()}},a)}d(v,m,a){return(o,u)=>{let g;if(u?.cacheResults){let E=this.c.get(v);E===void 0&&(E=new Map,this.c.set(v,E));const L=w(o);g=E.get(L),g===void 0&&(g=new Map,E.set(L,g))}return E=>{const{iconPath:L,...p}=E,t=`${v}|${E.id??E.timestamp}`;g?.set(t,E);let d,r,l;E.iconPath&&(L instanceof y.ThemeIcon?l={id:L.id,color:L.color}:n.URI.isUri(L)?(d=L,r=L):{light:d,dark:r}=L);let c;return y.MarkdownString.isMarkdownString(p.tooltip)?c=R.MarkdownString.from(p.tooltip):(0,T.isString)(p.tooltip)?c=p.tooltip:y.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=R.MarkdownString.from(p.detail)):(0,T.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=p.detail),{...p,id:p.id??void 0,handle:t,source:v,command:E.command?m.toInternal(E.command,a):void 0,icon:d,iconDark:r,themeIcon:l,tooltip:c,accessibilityInformation:E.accessibilityInformation}}}}f(v,m){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:m}),(0,M.toDisposable)(()=>{for(const o of this.c.values())o.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.ExtHostTimeline=N;function w(h){return h?.toString()}}),define(ke[234],Te([1,0,6,15,2,5]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(S){this.c=new Map,this.b=S.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,T,N,w){if(this.c.has(T))throw new Error(`Opener with id '${T}' already registered`);const h=w.schemes.find(v=>!y.a.has(v));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this.c.set(T,N),this.b.$registerUriOpener(T,w.schemes,S,w.label),(0,n.toDisposable)(()=>{this.c.delete(T),this.b.$unregisterUriOpener(T)})}async $canOpenUri(S,T,N){const w=this.c.get(S);if(!w)throw new Error(`Unknown opener with id: ${S}`);const h=D.URI.revive(T);return w.canOpenExternalUri(h,N)}async $openUri(S,T,N){const w=this.c.get(S);if(!w)throw new Error(`Unknown opener id: '${S}'`);return w.openExternalUri(D.URI.revive(T.resolvedUri),{sourceUri:D.URI.revive(T.sourceUri)},N)}}y.a=new Set([k.Schemas.http,k.Schemas.https]),e.ExtHostUriOpeners=y}),define(ke[235],Te([1,0,5,2,6,12,26]),function(te,e,n,k,D,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{constructor(T){this.c=new Set,this.d=new Map,this.b=T.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(T,N){if(this.c.has(y.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const w=R.a++;return this.c.add(y.ExtensionIdentifier.toKey(T)),this.d.set(w,N),this.b.$registerUriHandler(w,T),(0,D.toDisposable)(()=>{this.c.delete(y.ExtensionIdentifier.toKey(T)),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(T,N){const w=this.d.get(T);if(!w)return Promise.resolve(void 0);try{w.handleUri(k.URI.revive(N))}catch(h){(0,M.onUnexpectedError)(h)}return Promise.resolve(void 0)}async createAppUri(T){return k.URI.revive(await this.b.$createAppUri(T))}}R.a=0,e.ExtHostUrls=R});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(ke[62],Te([1,0,4,15,22,2,157,180,73,5]),function(te,e,n,k,D,M,y,R,S,T){"use strict";var N,w,h,v,m,a,o,u,g,E,L,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(C,j,_,K,A,$,O){N.set(this,void 0),w.set(this,void 0),h.set(this,void 0),v.set(this,void 0),m.set(this,void 0),a.set(this,void 0),o.set(this,""),u.set(this,void 0),g.set(this,!1),E.set(this,!1),L.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new n.Emitter),this._onDidDispose=Le(this,t,"f").event,Je(this,N,C,"f"),Je(this,w,j,"f"),Je(this,u,_,"f"),Je(this,v,K,"f"),Je(this,m,A,"f"),Je(this,a,$,"f"),Je(this,L,r($),"f"),Je(this,p,l($),"f"),Je(this,h,O,"f")}dispose(){Je(this,g,!0,"f"),Le(this,t,"f").fire(),Le(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(C){return Je(this,E,!0,"f"),(0,S.asWebviewUri)(C,Le(this,v,"f"))}get cspSource(){const C=Le(this,a,"f").extensionLocation;if(C.scheme===k.Schemas.https||C.scheme===k.Schemas.http){let j=C.toString();return j.endsWith("/")||(j+="/"),j+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Le(this,o,"f")}set html(C){this.a(),Le(this,o,"f")!==C&&(Je(this,o,C,"f"),Le(this,p,"f")&&!Le(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(C)&&(Je(this,E,!0,"f"),Le(this,h,"f").report("Webview vscode-resource: uris",Le(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,w,"f").$setHtml(Le(this,N,"f"),this.b(C)))}get options(){return this.a(),Le(this,u,"f")}set options(C){this.a(),D.equals(Le(this,u,"f"),C)||Le(this,w,"f").$setOptions(Le(this,N,"f"),i(Le(this,a,"f"),Le(this,m,"f"),C)),Je(this,u,C,"f")}async postMessage(C){if(Le(this,g,"f"))return!1;const j=(0,R.serializeWebviewMessage)(C,{serializeBuffersForPostMessage:Le(this,L,"f")});return Le(this,w,"f").$postMessage(Le(this,N,"f"),j.message,...j.buffers)}a(){if(Le(this,g,"f"))throw new Error("Webview is disposed")}b(C){if(!Le(this,p,"f"))return C;const j=Le(this,a,"f").extensionLocation?.scheme===k.Schemas.vscodeRemote,_=Le(this,a,"f").extensionLocation.scheme===k.Schemas.vscodeRemote?Le(this,a,"f").extensionLocation.authority:void 0;return C.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(K,A,$,O,F,H)=>{const V=M.URI.from({scheme:O||"file",path:decodeURIComponent(F)}),ae=(0,S.asWebviewUri)(V,{isRemote:j,authority:_}).toString();return`${A}${ae}${H}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(K,A,$,O,F,H)=>{const V=M.URI.from({scheme:O||"file",path:decodeURIComponent(F)}),ae=(0,S.asWebviewUri)(V,{isRemote:j,authority:_}).toString();return`${A}${ae}${H}`})}}e.ExtHostWebview=d,N=new WeakMap,w=new WeakMap,h=new WeakMap,v=new WeakMap,m=new WeakMap,a=new WeakMap,o=new WeakMap,u=new WeakMap,g=new WeakMap,E=new WeakMap,L=new WeakMap,p=new WeakMap,t=new WeakMap;function r(P){try{const C=(0,y.normalizeVersion)((0,y.parseVersion)(P.engines.vscode));return!!C&&C.majorBase>=1&&C.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function l(P){try{const C=(0,y.normalizeVersion)((0,y.parseVersion)(P.engines.vscode));return C?C.majorBase<1||C.majorBase===1&&C.minorBase<60:!1}catch{return!1}}class c{constructor(C,j,_,K,A){this.c=j,this.d=_,this.e=K,this.f=A,this.b=new Map,this.a=C.getProxy(T.MainContext.MainThreadWebviews)}$onMessage(C,j,_){const K=this.g(C);if(K){const{message:A}=(0,R.deserializeWebviewMessage)(j,_.value);K._onMessageEmitter.fire(A)}}$onMissingCsp(C,j){this.e.warn(`${j} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(C,j,_){const K=new d(C,this.a,s(j),this.c,this.d,_,this.f);return this.b.set(C,K),K._onDidDispose(()=>{this.b.delete(C)}),K}deleteWebview(C){this.b.delete(C)}g(C){return this.b.get(C)}}e.ExtHostWebviews=c;function b(P){return{id:P.identifier,location:P.extensionLocation}}e.toExtensionData=b;function i(P,C,j){return{enableCommandUris:j.enableCommandUris,enableScripts:j.enableScripts,enableForms:j.enableForms,portMapping:j.portMapping,localResourceRoots:j.localResourceRoots||f(P,C)}}e.serializeWebviewOptions=i;function s(P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,enableForms:P.enableForms,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots?.map(C=>M.URI.from(C))}}function f(P,C){return[...(C?.getWorkspaceFolders()||[]).map(j=>j.uri),P.extensionLocation]}}),define(ke[236],Te([1,0,21,231,6,15,24,2,8,62,54,5,7]),function(te,e,n,k,D,M,y,R,S,T,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class v{constructor(d,r){this.document=d,this.b=r,this.a=1,this.c=new N.Cache("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,r){await this.f(d).undo(),r||this.disposeBackup()}async redo(d,r){await this.f(d).redo(),r||this.disposeBackup()}disposeEdits(d){for(const r of d)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=p(this.document.uri)+this.a++;return(0,y.joinPath)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const r=this.c.get(d,0);if(!r)throw new Error("No edit found");return r}}class m{constructor(){this.a=new Map}get(d,r){return this.a.get(this.b(d,r))}add(d,r,l){const c=this.b(d,r.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${d} resource:${r.uri}`);const b=new v(r,l);return this.a.set(c,b),b}delete(d,r){const l=this.b(d,r.uri);this.a.delete(l)}b(d,r){return`${d}@@@${r}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class o{constructor(){this.a=new Map}addTextProvider(d,r,l){return this.b(0,d,r,l)}addCustomProvider(d,r,l){return this.b(1,d,r,l)}get(d){return this.a.get(d)}b(d,r,l,c){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:d,extension:l,provider:c}),new h.Disposable(()=>this.a.delete(r))}}class u{constructor(d,r,l,c,b){this.d=r,this.f=l,this.g=c,this.h=b,this.b=new o,this.c=new m,this.a=d.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(d,r,l,c){const b=new D.DisposableStore;return E(l)?(b.add(this.b.addTextProvider(r,d,l)),this.a.$registerTextEditorProvider((0,T.toExtensionData)(d),r,c.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(d))):(b.add(this.b.addCustomProvider(r,d,l)),g(l)&&b.add(l.onDidChangeCustomDocument(i=>{const s=this.i(r,i.document.uri);if(L(i)){const f=s.addEdit(i);this.a.$onDidEdit(i.document.uri,r,f,i.label)}else this.a.$onContentChange(i.document.uri,r)})),this.a.$registerCustomEditorProvider((0,T.toExtensionData)(d),r,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(d))),h.Disposable.from(b,new h.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(d,r,l,c,b){const i=this.b.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(i.type!==1)throw new Error(`Invalid provide type for '${r}'`);const s=R.URI.revive(d),f=await i.provider.openCustomDocument(s,{backupId:l,untitledDocumentData:c?.buffer},b);let P;return g(i.provider)&&this.f&&(P=this.f.workspaceValue(i.extension)??this.f.globalValue(i.extension)),this.c.add(r,f,P),{editable:g(i.provider)}}async $disposeCustomDocument(d,r){const l=this.b.get(r);if(!l)throw new Error(`No provider found for '${r}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${r}'`);const c=R.URI.revive(d),{document:b}=this.i(r,c);this.c.delete(r,b),b.dispose()}async $resolveCustomEditor(d,r,l,c,b,i){const s=this.b.get(l);if(!s)throw new Error(`No provider found for '${l}'`);const f=S.ViewColumn.to(b),P=this.g.createNewWebview(r,c.contentOptions,s.extension),C=this.h.createNewWebviewPanel(r,l,c.title,f,c.options,P,!0),j=R.URI.revive(d);switch(s.type){case 1:{const{document:_}=this.i(l,j);return s.provider.resolveCustomEditor(_,C,i)}case 0:{const _=this.d.getDocument(j);return s.provider.resolveCustomTextEditor(_,C,i)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,r,l){this.i(r,d).disposeEdits(l)}async $onMoveCustomEditor(d,r,l){const c=this.b.get(l);if(!c)throw new Error(`No provider found for '${l}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const b=this.h.getWebviewPanel(d);if(!b)throw new Error("No webview found");const i=R.URI.revive(r),s=this.d.getDocument(i);await c.provider.moveCustomTextEditor(s,b,n.CancellationToken.None)}async $undo(d,r,l,c){return this.i(r,d).undo(l,c)}async $redo(d,r,l,c){return this.i(r,d).redo(l,c)}async $revert(d,r,l){const c=this.i(r,d);await this.j(r).revertCustomDocument(c.document,l),c.disposeBackup()}async $onSave(d,r,l){const c=this.i(r,d);await this.j(r).saveCustomDocument(c.document,l),c.disposeBackup()}async $onSaveAs(d,r,l,c){const b=this.i(r,d);return this.j(r).saveCustomDocumentAs(b.document,R.URI.revive(l),c)}async $backup(d,r,l){const c=this.i(r,d),i=await this.j(r).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},l);return c.updateBackup(i),i.id}i(d,r){const l=this.c.get(d,R.URI.revive(r));if(!l)throw new Error("No custom document found");return l}j(d){const l=this.b.get(d)?.provider;if(!l||!g(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=u;function g(t){return!!t.onDidChangeCustomDocument}function E(t){return typeof t.resolveCustomTextEditor=="function"}function L(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function p(t){const d=t.scheme===M.Schemas.file||t.scheme===M.Schemas.untitled?t.fsPath:t.toString();return(0,k.hash)(d)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(ke[237],Te([1,0,4,6,2,34,8,62,5,7]),function(te,e,n,k,D,M,y,R,S,T){"use strict";var N,w,h,v,m,a,o,u,g,E,L,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends k.Disposable{constructor(b,i,s,f){super(),N.set(this,void 0),w.set(this,void 0),h.set(this,void 0),v.set(this,void 0),m.set(this,void 0),a.set(this,void 0),o.set(this,void 0),u.set(this,void 0),g.set(this,!0),E.set(this,void 0),L.set(this,!1),p.set(this,this.B(new n.Emitter)),this.onDidDispose=Le(this,p,"f").event,t.set(this,this.B(new n.Emitter)),this.onDidChangeViewState=Le(this,t,"f").event,Je(this,N,b,"f"),Je(this,w,i,"f"),Je(this,v,s,"f"),Je(this,h,f.viewType,"f"),Je(this,m,f.panelOptions,"f"),Je(this,u,f.viewColumn,"f"),Je(this,a,f.title,"f"),Je(this,E,f.active,"f")}dispose(){Le(this,L,"f")||(Je(this,L,!0,"f"),Le(this,p,"f").fire(),Le(this,w,"f").$disposeWebview(Le(this,N,"f")),Le(this,v,"f").dispose(),super.dispose())}get webview(){return this.c(),Le(this,v,"f")}get viewType(){return this.c(),Le(this,h,"f")}get title(){return this.c(),Le(this,a,"f")}set title(b){this.c(),Le(this,a,"f")!==b&&(Je(this,a,b,"f"),Le(this,w,"f").$setTitle(Le(this,N,"f"),b))}get iconPath(){return this.c(),Le(this,o,"f")}set iconPath(b){this.c(),Le(this,o,"f")!==b&&(Je(this,o,b,"f"),Le(this,w,"f").$setIconPath(Le(this,N,"f"),D.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return Le(this,m,"f")}get viewColumn(){if(this.c(),!(typeof Le(this,u,"f")=="number"&&Le(this,u,"f")<0))return Le(this,u,"f")}get active(){return this.c(),Le(this,E,"f")}get visible(){return this.c(),Le(this,g,"f")}_updateViewState(b){Le(this,L,"f")||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(Je(this,E,b.active,"f"),Je(this,g,b.visible,"f"),Je(this,u,b.viewColumn,"f"),Le(this,t,"f").fire({webviewPanel:this}))}reveal(b,i){this.c(),Le(this,w,"f").$reveal(Le(this,N,"f"),{viewColumn:typeof b>"u"?void 0:y.ViewColumn.from(b),preserveFocus:!!i})}c(){if(Le(this,L,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,w=new WeakMap,h=new WeakMap,v=new WeakMap,m=new WeakMap,a=new WeakMap,o=new WeakMap,u=new WeakMap,g=new WeakMap,E=new WeakMap,L=new WeakMap,p=new WeakMap,t=new WeakMap;class r{static c(){return(0,M.generateUuid)()}constructor(b,i,s){this.g=i,this.h=s,this.e=new Map,this.f=new Map,this.d=b.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(b,i,s,f,P={}){const C=typeof f=="object"?f.viewColumn:f,j={viewColumn:y.ViewColumn.from(C),preserveFocus:typeof f=="object"&&!!f.preserveFocus},_=(0,R.shouldSerializeBuffersForPostMessage)(b),K=r.c();this.d.$createWebviewPanel((0,R.toExtensionData)(b),K,i,{title:s,panelOptions:l(P),webviewOptions:(0,R.serializeWebviewOptions)(b,this.h,P),serializeBuffersForPostMessage:_},j);const A=this.g.createNewWebview(K,P,b);return this.createNewWebviewPanel(K,i,s,C,P,A,!0)}$onDidChangeWebviewPanelViewStates(b){const i=Object.keys(b);i.sort((s,f)=>{const P=b[s],C=b[f];return P.active?1:C.active?-1:+P.visible-+C.visible});for(const s of i){const f=this.getWebviewPanel(s);if(!f)continue;const P=b[s];f._updateViewState({active:P.active,visible:P.visible,viewColumn:y.ViewColumn.to(P.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.e.delete(b),this.g.deleteWebview(b)}registerWebviewPanelSerializer(b,i,s){if(this.f.has(i))throw new Error(`Serializer for '${i}' already registered`);return this.f.set(i,{serializer:s,extension:b}),this.d.$registerSerializer(i,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(b)}),new T.Disposable(()=>{this.f.delete(i),this.d.$unregisterSerializer(i)})}async $deserializeWebviewPanel(b,i,s,f){const P=this.f.get(i);if(!P)throw new Error(`No serializer found for '${i}'`);const{serializer:C,extension:j}=P,_=this.g.createNewWebview(b,s.webviewOptions,j),K=this.createNewWebviewPanel(b,i,s.title,f,s.panelOptions,_,s.active);await C.deserializeWebviewPanel(K,s.state)}createNewWebviewPanel(b,i,s,f,P,C,j){const _=new d(b,this.d,C,{viewType:i,title:s,viewColumn:f,panelOptions:P,active:j});return this.e.set(b,_),_}getWebviewPanel(b){return this.e.get(b)}}e.ExtHostWebviewPanels=r;function l(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(ke[238],Te([1,0,4,6,62,8,5,7]),function(te,e,n,k,D,M,y,R){"use strict";var S,T,N,w,h,v,m,a,o,u,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class E extends k.Disposable{constructor(t,d,r,l,c,b){super(),S.set(this,void 0),T.set(this,void 0),N.set(this,void 0),w.set(this,void 0),h.set(this,!1),v.set(this,void 0),m.set(this,void 0),a.set(this,void 0),o.set(this,void 0),u.set(this,this.B(new n.Emitter)),this.onDidChangeVisibility=Le(this,u,"f").event,g.set(this,this.B(new n.Emitter)),this.onDidDispose=Le(this,g,"f").event,Je(this,N,r,"f"),Je(this,m,l,"f"),Je(this,S,t,"f"),Je(this,T,d,"f"),Je(this,w,c,"f"),Je(this,v,b,"f")}dispose(){Le(this,h,"f")||(Je(this,h,!0,"f"),Le(this,g,"f").fire(),Le(this,w,"f").dispose(),super.dispose())}get title(){return this.a(),Le(this,m,"f")}set title(t){this.a(),Le(this,m,"f")!==t&&(Je(this,m,t,"f"),Le(this,T,"f").$setWebviewViewTitle(Le(this,S,"f"),t))}get description(){return this.a(),Le(this,a,"f")}set description(t){this.a(),Le(this,a,"f")!==t&&(Je(this,a,t,"f"),Le(this,T,"f").$setWebviewViewDescription(Le(this,S,"f"),t))}get visible(){return Le(this,v,"f")}get webview(){return Le(this,w,"f")}get viewType(){return Le(this,N,"f")}_setVisible(t){t===Le(this,v,"f")||Le(this,h,"f")||(Je(this,v,t,"f"),Le(this,u,"f").fire())}get badge(){return this.a(),Le(this,o,"f")}set badge(t){this.a(),!(t?.value===Le(this,o,"f")?.value&&t?.tooltip===Le(this,o,"f")?.tooltip)&&(Je(this,o,M.ViewBadge.from(t),"f"),Le(this,T,"f").$setWebviewViewBadge(Le(this,S,"f"),t))}show(t){this.a(),Le(this,T,"f").$show(Le(this,S,"f"),!!t)}a(){if(Le(this,h,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,T=new WeakMap,N=new WeakMap,w=new WeakMap,h=new WeakMap,v=new WeakMap,m=new WeakMap,a=new WeakMap,o=new WeakMap,u=new WeakMap,g=new WeakMap;class L{constructor(t,d){this.d=d,this.b=new Map,this.c=new Map,this.a=t.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,d,r,l){if(this.b.has(d))throw new Error(`View provider for '${d}' already registered`);return this.b.set(d,{provider:r,extension:t}),this.a.$registerWebviewViewProvider((0,D.toExtensionData)(t),d,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(t)}),new R.Disposable(()=>{this.b.delete(d),this.a.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(t,d,r,l,c){const b=this.b.get(d);if(!b)throw new Error(`No view provider found for '${d}'`);const{provider:i,extension:s}=b,f=this.d.createNewWebview(t,{},s),P=new E(t,this.a,d,r,f,!0);this.c.set(t,P),await i.resolveWebviewView(P,{state:l},c)}async $onDidChangeWebviewViewVisibility(t,d){this.e(t)._setVisible(d)}async $disposeWebviewView(t){const d=this.e(t);this.c.delete(t),d.dispose(),this.d.deleteWebview(t)}e(t){const d=this.c.get(t);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=L}),define(ke[104],Te([1,0,4,5,2,15,10,3,18]),function(te,e,n,k,D,M,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class an{get state(){return this.d}constructor(w){this.c=new n.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=w.getProxy(k.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(h=>this.$onDidChangeWindowFocus(h))}$onDidChangeWindowFocus(w){w!==this.d.focused&&(this.d={...this.d,focused:w},this.c.fire(this.d))}openUri(w,h){let v;if(typeof w=="string"){v=w;try{w=D.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,y.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,v,h)}async asExternalUri(w,h){if((0,y.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(w,h);return D.URI.from(v)}};T.a={focused:!0},T=qe([Ve(0,S.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,R.createDecorator)("IExtHostWindow")}),define(ke[239],Te([1,0,209,27,18]),function(te,e,n,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends n.AbstractExtHostConsoleForwarder{constructor(R,S){super(R,S)}f(R,S,T){S.apply(console,T)}};M=qe([Ve(0,D.IExtHostRpcService),Ve(1,k.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(ke[240],Te([1,0,17,23,21,12,4,6,127,203,46]),function(te,e,n,k,D,M,y,R,S,T,N){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function h(P,C){try{return JSON.stringify(P,C)}catch{return"null"}}const v="$$ref$$",m={[v]:-1};class a{constructor(C,j){this.jsonString=C,this.referencedBuffers=j}}function o(P,C=null,j=!1){const _=[];return{jsonString:(j?h:JSON.stringify)(P,(A,$)=>{if(typeof $>"u")return m;if(typeof $=="object"){if($ instanceof k.VSBuffer){const O=_.push($)-1;return{[v]:O}}if(C)return C(A,$)}return $}),referencedBuffers:_}}e.stringifyJsonWithBufferRefs=o;function u(P,C,j){return JSON.parse(P,(_,K)=>{if(K){const A=K[v];if(typeof A=="number")return C[A];if(j&&K.$mid===1)return j.transformIncoming(K)}return K})}e.parseJsonAndRestoreBufferRefs=u;function g(P,C){return JSON.stringify(P,C)}function E(P){return P?(C,j)=>j&&j.$mid===1?P.transformOutgoing(j):j:null}var L;(function(P){P[P.LocalSide=0]="LocalSide",P[P.OtherSide=1]="OtherSide"})(L=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(P){P[P.Responsive=0]="Responsive",P[P.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},d=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class l extends R.Disposable{constructor(C,j=null,_=null){super(),this[w]=!0,this.b=this.B(new y.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=j,this.g=_,this.h=E(this.g),this.j=!1,this.k=[],this.l=[];for(let K=0,A=N.ProxyIdentifier.count;K<A;K++)this.k[K]=null,this.l[K]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new n.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(K=>this.G(K))}dispose(){this.j=!0,Object.keys(this.s).forEach(C=>{this.s[C].resolveErr(M.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(C){this.u===0&&(this.v=Date.now()+l.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(C){this.v=Date.now()+l.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(C){this.t!==C&&(this.t=C,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(C){return this.g?(0,S.transformIncomingURIs)(C,this.g):C}getProxy(C){const{nid:j,sid:_}=C;return this.l[j]||(this.l[j]=this.F(j,_)),this.l[j]}F(C,j){const _={get:(K,A)=>(typeof A=="string"&&!K[A]&&A.charCodeAt(0)===36&&(K[A]=(...$)=>this.O(C,A,$)),A===r?j:K[A])};return new Proxy(Object.create(null),_)}set(C,j){return this.k[C.nid]=j,j}assertRegistered(C){for(let j=0,_=C.length;j<_;j++){const K=C[j];if(!this.k[K.nid])throw new Error(`Missing proxy instance ${K.sid}`)}}G(C){if(this.j)return;const j=C.byteLength,_=c.read(C,0),K=_.readUInt8(),A=_.readUInt32();switch(K){case 1:case 2:{let{rpcId:$,method:O,args:F}=i.deserializeRequestJSONArgs(_);this.g&&(F=(0,S.transformIncomingURIs)(F,this.g)),this.H(j,A,$,O,F,K===2);break}case 3:case 4:{let{rpcId:$,method:O,args:F}=i.deserializeRequestMixedArgs(_);this.g&&(F=(0,S.transformIncomingURIs)(F,this.g)),this.H(j,A,$,O,F,K===4);break}case 5:{this.f?.logIncoming(j,A,0,"ack"),this.z(A);break}case 6:{this.I(j,A);break}case 7:{this.J(j,A,void 0);break}case 9:{let $=i.deserializeReplyOKJSON(_);this.g&&($=(0,S.transformIncomingURIs)($,this.g)),this.J(j,A,$);break}case 10:{const $=i.deserializeReplyOKJSONWithBuffers(_,this.g);this.J(j,A,$);break}case 8:{const $=i.deserializeReplyOKVSBuffer(_);this.J(j,A,$);break}case 11:{let $=i.deserializeReplyErrError(_);this.g&&($=(0,S.transformIncomingURIs)($,this.g)),this.L(j,A,$);break}case 12:{this.L(j,A,void 0);break}default:console.error("received unexpected message"),console.error(C)}}H(C,j,_,K,A,$){this.f?.logIncoming(C,j,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)(_)}.${K}(`,A);const O=String(j);let F,H;if($){const ae=new D.CancellationTokenSource;A.push(ae.token),F=this.M(_,K,A),H=()=>ae.cancel()}else F=this.M(_,K,A),H=t;this.p[O]=H;const V=i.serializeAcknowledged(j);this.f?.logOutgoing(V.byteLength,j,1,"ack"),this.c.send(V),F.then(ae=>{delete this.p[O];const pe=i.serializeReplyOK(j,ae,this.h);this.f?.logOutgoing(pe.byteLength,j,1,"reply:",ae),this.c.send(pe)},ae=>{delete this.p[O];const pe=i.serializeReplyErr(j,ae);this.f?.logOutgoing(pe.byteLength,j,1,"replyErr:",ae),this.c.send(pe)})}I(C,j){this.f?.logIncoming(C,j,1,"receiveCancel");const _=String(j);this.p[_]?.()}J(C,j,_){this.f?.logIncoming(C,j,0,"receiveReply:",_);const K=String(j);if(!this.s.hasOwnProperty(K))return;const A=this.s[K];delete this.s[K],A.resolveOk(_)}L(C,j,_){this.f?.logIncoming(C,j,0,"receiveReplyErr:",_);const K=String(j);if(!this.s.hasOwnProperty(K))return;const A=this.s[K];delete this.s[K];let $;_&&(_.$isError?($=new Error,$.name=_.name,$.message=_.message,$.stack=_.stack):$=_),A.resolveErr($)}M(C,j,_){try{return Promise.resolve(this.N(C,j,_))}catch(K){return Promise.reject(K)}}N(C,j,_){const K=this.k[C];if(!K)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(C));const A=K[j];if(typeof A!="function")throw new Error("Unknown method "+j+" on actor "+(0,N.getStringIdentifierForProxy)(C));return A.apply(K,_)}O(C,j,_){if(this.j)return new T.CanceledLazyPromise;let K=null;if(_.length>0&&D.CancellationToken.isCancellationToken(_[_.length-1])&&(K=_.pop()),K&&K.isCancellationRequested)return Promise.reject(M.canceled());const A=i.serializeRequestArguments(_,this.h),$=++this.m,O=String($),F=new T.LazyPromise;K&&K.onCancellationRequested(()=>{const V=i.serializeCancel($);this.f?.logOutgoing(V.byteLength,$,0,"cancel"),this.c.send(i.serializeCancel($))}),this.s[O]=F,this.y($);const H=i.serializeRequest($,C,j,A,!!K);return this.f?.logOutgoing(H.byteLength,$,0,`request: ${(0,N.getStringIdentifierForProxy)(C)}.${j}(`,_),this.c.send(H),F}}w=d,l.a=3*1e3,e.RPCProtocol=l;class c{static alloc(C,j,_){const K=new c(k.VSBuffer.alloc(_+1+4),0);return K.writeUInt8(C),K.writeUInt32(j),K}static read(C,j){return new c(C,j)}get buffer(){return this.a}constructor(C,j){this.a=C,this.b=j}static sizeUInt8(){return 1}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const _=this.a.slice(this.b,this.b+C).toString();return this.b+=C,_}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const _=this.a.slice(this.b,this.b+C).toString();return this.b+=C,_}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+C);return this.b+=C,j}static sizeMixedArray(C){let j=0;j+=1;for(let _=0,K=C.length;_<K;_++){const A=C[_];switch(j+=1,A.type){case 1:j+=this.sizeLongString(A.value);break;case 2:j+=this.sizeVSBuffer(A.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(A.value);for(let $=0;$<A.buffers.length;++$)j+=this.sizeVSBuffer(A.buffers[$]);break;case 4:break}}return j}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let j=0,_=C.length;j<_;j++){const K=C[j];switch(K.type){case 1:this.writeUInt8(1),this.writeLongString(K.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(K.value);break;case 3:this.writeUInt8(3),this.writeUInt32(K.buffers.length),this.writeLongString(K.value);for(let A=0;A<K.buffers.length;++A)this.writeBuffer(K.buffers[A]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const j=new Array(C);for(let _=0;_<C;_++)switch(this.readUInt8()){case 1:j[_]=this.readLongString();break;case 2:j[_]=this.readVSBuffer();break;case 3:{const A=this.readUInt32(),$=this.readLongString(),O=[];for(let F=0;F<A;++F)O.push(this.readVSBuffer());j[_]=new N.SerializableObjectWithBuffers(u($,O,null));break}case 4:j[_]=void 0;break}return j}}c.sizeUInt32=4;var b;(function(P){P[P.Simple=0]="Simple",P[P.Mixed=1]="Mixed"})(b||(b={}));class i{static a(C){for(let j=0,_=C.length;j<_;j++)if(C[j]instanceof k.VSBuffer||C[j]instanceof N.SerializableObjectWithBuffers||typeof C[j]>"u")return!0;return!1}static serializeRequestArguments(C,j){if(this.a(C)){const _=[];for(let K=0,A=C.length;K<A;K++){const $=C[K];if($ instanceof k.VSBuffer)_[K]={type:2,value:$};else if(typeof $>"u")_[K]={type:4};else if($ instanceof N.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:F}=o($.value,j);_[K]={type:3,value:k.VSBuffer.fromString(O),buffers:F}}else _[K]={type:1,value:k.VSBuffer.fromString(g($,j))}}return{type:1,args:_}}return{type:0,args:g(C,j)}}static serializeRequest(C,j,_,K,A){switch(K.type){case 0:return this.b(C,j,_,K.args,A);case 1:return this.c(C,j,_,K.args,A)}}static b(C,j,_,K,A){const $=k.VSBuffer.fromString(_),O=k.VSBuffer.fromString(K);let F=0;F+=c.sizeUInt8(),F+=c.sizeShortString($),F+=c.sizeLongString(O);const H=c.alloc(A?2:1,C,F);return H.writeUInt8(j),H.writeShortString($),H.writeLongString(O),H.buffer}static deserializeRequestJSONArgs(C){const j=C.readUInt8(),_=C.readShortString(),K=C.readLongString();return{rpcId:j,method:_,args:JSON.parse(K)}}static c(C,j,_,K,A){const $=k.VSBuffer.fromString(_);let O=0;O+=c.sizeUInt8(),O+=c.sizeShortString($),O+=c.sizeMixedArray(K);const F=c.alloc(A?4:3,C,O);return F.writeUInt8(j),F.writeShortString($),F.writeMixedArray(K),F.buffer}static deserializeRequestMixedArgs(C){const j=C.readUInt8(),_=C.readShortString(),K=C.readMixedArray(),A=new Array(K.length);for(let $=0,O=K.length;$<O;$++){const F=K[$];typeof F=="string"?A[$]=JSON.parse(F):A[$]=F}return{rpcId:j,method:_,args:A}}static serializeAcknowledged(C){return c.alloc(5,C,0).buffer}static serializeCancel(C){return c.alloc(6,C,0).buffer}static serializeReplyOK(C,j,_){if(typeof j>"u")return this.d(C);if(j instanceof k.VSBuffer)return this.e(C,j);if(j instanceof N.SerializableObjectWithBuffers){const{jsonString:K,referencedBuffers:A}=o(j.value,_,!0);return this.g(C,K,A)}else return this.f(C,h(j,_))}static d(C){return c.alloc(7,C,0).buffer}static e(C,j){let _=0;_+=c.sizeVSBuffer(j);const K=c.alloc(8,C,_);return K.writeVSBuffer(j),K.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,j){const _=k.VSBuffer.fromString(j);let K=0;K+=c.sizeLongString(_);const A=c.alloc(9,C,K);return A.writeLongString(_),A.buffer}static g(C,j,_){const K=k.VSBuffer.fromString(j);let A=0;A+=c.sizeUInt32,A+=c.sizeLongString(K);for(const O of _)A+=c.sizeVSBuffer(O);const $=c.alloc(10,C,A);$.writeUInt32(_.length),$.writeLongString(K);for(const O of _)$.writeBuffer(O);return $.buffer}static deserializeReplyOKJSON(C){const j=C.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(C,j){const _=C.readUInt32(),K=C.readLongString(),A=[];for(let $=0;$<_;++$)A.push(C.readVSBuffer());return new N.SerializableObjectWithBuffers(u(K,A,j))}static serializeReplyErr(C,j){const _=j?h(M.transformErrorForSerialization(j),null):void 0;if(typeof _!="string")return this.h(C);const K=k.VSBuffer.fromString(_);let A=0;A+=c.sizeLongString(K);const $=c.alloc(11,C,A);return $.writeLongString(K),$.buffer}static deserializeReplyErrError(C){const j=C.readLongString();return JSON.parse(j)}static h(C){return c.alloc(12,C,0).buffer}}var s;(function(P){P[P.RequestJSONArgs=1]="RequestJSONArgs",P[P.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",P[P.RequestMixedArgs=3]="RequestMixedArgs",P[P.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",P[P.Acknowledged=5]="Acknowledged",P[P.Cancel=6]="Cancel",P[P.ReplyOKEmpty=7]="ReplyOKEmpty",P[P.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",P[P.ReplyOKJSON=9]="ReplyOKJSON",P[P.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",P[P.ReplyErrError=11]="ReplyErrError",P[P.ReplyErrEmpty=12]="ReplyErrEmpty"})(s||(s={}));var f;(function(P){P[P.String=1]="String",P[P.VSBuffer=2]="VSBuffer",P[P.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",P[P.Undefined=4]="Undefined"})(f||(f={}))}),define(ke[241],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(M){const y=R=>{self.removeEventListener("message",y);const S=R.data;Object.defineProperties(self,{postMessage:{value(T,N){S.postMessage(T,N)}},onmessage:{get(){return S.onmessage},set(T){S.onmessage=T}}}),S.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",y)}.toString();class k extends EventTarget{constructor(M,y,R){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${n})('${y}'))`,T=new Blob([S],{type:"application/javascript"}),N=URL.createObjectURL(T),w=new MessageChannel,h=N,v={type:"_newWorker",id:h,port:w.port2,url:N,options:R};M(v,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{M({type:"_terminateWorker",id:h}),URL.revokeObjectURL(N),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(m){w.port1.onmessage=m}},onmessageerror:{get(){return w.port1.onmessageerror},set(m){w.port1.onmessageerror=m}}}),w.port1.addEventListener("messageerror",m=>{const a=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(a)}),w.port1.addEventListener("message",m=>{const a=new MessageEvent("message",{data:m.data});this.dispatchEvent(a)}),w.port1.start()}}e.NestedWorker=k}),define(ke[242],Te([1,0,4,30,42,3]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)("outputService");var y;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(y=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new n.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new n.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(T){this.a.has(T.id)||(this.a.set(T.id,T),this.b.fire(T.id))}getChannels(){const T=[];return this.a.forEach(N=>T.push(N)),T}getChannel(T){return this.a.get(T)}removeChannel(T){this.a.delete(T),this.c.fire(T)}}k.Registry.add(e.Extensions.OutputChannels,new R),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new D.RawContextKey("activeOutputChannel","")}),define(ke[105],Te([1,0,5,3,18,26,11,242,60,27,36,121,23,9,43,4,6]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class u extends y.AbstractMessageLogger{get disposed(){return this.l}constructor(p,t,d,r,l){super(),this.id=p,this.name=t,this.m=d,this.n=r,this.extension=l,this.k=0,this.l=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.k;this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Clear,p)}replace(p){const t=this.k;this.info(p),this.n.$update(this.id,R.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(p,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof p=="boolean"?p:t))}hide(){this.n.$close(this.id)}g(p,t){this.k+=h.VSBuffer.fromString(t).byteLength,(0,y.log)(this.m,p,t),this.visible&&(this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class g extends u{appendLine(p){this.append(p)}}let E=class{constructor(p,t,d,r,l,c){this.i=t,this.j=d,this.k=r,this.l=l,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(n.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[t,d]of this.g)d.visible=t===this.h}createOutputChannel(p,t,d){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,l=(0,v.isString)(t)?t:void 0;if((0,v.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const b=this.i.environment.extensionLogLevel?.find(([s])=>M.ExtensionIdentifier.equals(d.identifier,s))?.[1];b&&(c=(0,y.parseLogLevel)(b));const i=r?this.o(p,c,d):this.n(p,l,d);return i.then(s=>{this.g.set(s.id,s),s.visible=s.id===this.h}),r?this.r(p,c??this.m.getLevel(),i):this.q(p,i)}async n(p,t,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,l=this.k.extUri.joinPath(r,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),b=await this.a.$register(p,l,t,d.identifier.value);return new u(b,p,c,this.a,d)}async o(p,t,d){const r=await this.p(d),l=this.k.extUri.joinPath(r,`${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=l.toString(),b=this.l.createLogger(l,{id:c,name:p,logLevel:t,extensionId:d.identifier.value});return new g(c,p,b,this.a,d)}p(p){let t=this.d.get(p.identifier.value);if(!t){const d=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(d)}catch(r){if((0,m.toFileSystemProviderErrorCode)(r)!==m.FileSystemProviderErrorCode.FileExists)throw r}return d})())}return t}q(p,t){let d=!1;const r=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return p},append(l){r(),t.then(c=>c.append(l))},appendLine(l){r(),t.then(c=>c.appendLine(l))},clear(){r(),t.then(l=>l.clear())},replace(l){r(),t.then(c=>c.replace(l))},show(l,c){r(),t.then(b=>b.show(l,c))},hide(){r(),t.then(l=>l.hide())},dispose(){d=!0,t.then(l=>l.dispose())}}}r(p,t,d){const r=new o.DisposableStore,l=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},c=r.add(new a.Emitter);function b(i){t=i,c.fire(i)}return d.then(i=>{r.add(i),i.logLevel!==t&&b(i.logLevel),r.add(i.onDidChangeLogLevel(s=>b(s)))}),{...this.q(p,d),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(i,...s){l(),d.then(f=>f.trace(i,...s))},debug(i,...s){l(),d.then(f=>f.debug(i,...s))},info(i,...s){l(),d.then(f=>f.info(i,...s))},warn(i,...s){l(),d.then(f=>f.warn(i,...s))},error(i,...s){l(),d.then(f=>f.error(i,...s))},dispose(){r.dispose()}}}};E=qe([Ve(0,D.IExtHostRpcService),Ve(1,T.IExtHostInitDataService),Ve(2,S.IExtHostConsumerFileSystem),Ve(3,N.IExtHostFileSystemInfo),Ve(4,y.ILoggerService),Ve(5,y.ILogService)],E),e.ExtHostOutputService=E,e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(ke[243],Te([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(ke[244],Te([1,0,40,15,19,20,24,2,3,175,53,191,243]),function(te,e,n,k,D,M,y,R,S,T,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let v=class cn{constructor(a,o,u,g){this.d=a,this.e=o,this.f=u,this.g=g,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??a})()}hasValidBasename(a,o,u){return typeof o=="string"||typeof o>"u"?this.a.then(g=>this.h(a,g,o)):this.h(a,o,u)}h(a,o,u){return a.scheme===k.Schemas.file||a.scheme===k.Schemas.vscodeRemote?(0,n.isValidBasename)(u??(0,y.basename)(a),o===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,o){if(a.remoteAuthority)return k.Schemas.vscodeRemote;const u=(0,T.getVirtualWorkspaceScheme)(o.getWorkspace());if(u)return u;const g=o.getWorkspace().folders[0];if(g)return g.uri.scheme;const E=o.getWorkspace().configuration;return E?E.scheme:k.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===1?D.win32:D.posix)}async fileURI(a){let o="";if(await this.a===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const g=a.indexOf("/",2);g===-1?(o=a.substring(2),a="/"):(o=a.substring(2,g),a=a.substring(g)||"/")}return R.URI.from({scheme:k.Schemas.file,authority:o,path:a,query:"",fragment:""})}};v=qe([Ve(1,h.IRemoteAgentService),Ve(2,w.IWorkbenchEnvironmentService),Ve(3,N.IWorkspaceContextService)],v),e.AbstractPathService=v}),define(ke[106],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(y,R){this.line=y,this.character=R}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,R){return new n(0,0)}with(y){return new n(0,0)}}e.Position=n;class k{constructor(y,R,S,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(y,R),this.end=new n(S,T)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new k(0,0,0,0)}with(y){return new k(0,0,0,0)}}e.Range=k;var D;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ke[47],Te([1,0,16,35,22,40,10,3,19,12,106,17]),function(te,e,n,k,D,M,y,R,S,T,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const h="\u27EA ",v=" characters skipped \u27EB",m=(h.length+v.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var a;(function(ce){ce[ce.file=0]="file",ce[ce.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(ce){ce[ce.File=1]="File",ce[ce.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function u(ce){return!!ce.preview}e.resultIsMatch=u;function g(ce){return!!ce.resource}e.isFileMatch=g;function E(ce){return!!ce.message}e.isProgressMessage=E;var L;(function(ce){ce[ce.Normal=0]="Normal",ce[ce.NewSearchStarted=1]="NewSearchStarted"})(L=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=p;class t{constructor(ue,Se,G){this.ranges=Se;const X=Array.isArray(Se)?Se:[Se];if(G&&G.matchLines===1&&d(X)){ue=(0,y.getNLines)(ue,G.matchLines);let J="",de=0,ye=0;const Fe=Math.floor(G.charsPerLine/5),ze=[];for(const Pe of X){const Ie=Math.max(Pe.startColumn-Fe,0),we=Pe.startColumn+G.charsPerLine;if(Ie>ye+Fe+m){const se=h+(Ie-ye)+v;J+=se+ue.slice(Ie,we),de+=Ie-(ye+se.length)}else J+=ue.slice(ye,we);ze.push(new l(0,Pe.startColumn-de,Pe.endColumn-de)),ye=we}this.preview={text:J,matches:Array.isArray(this.ranges)?ze:ze[0]}}else{const J=Array.isArray(Se)?Se[0].startLineNumber:Se.startLineNumber;this.preview={text:ue,matches:(0,n.mapArrayOrNot)(Se,de=>new r(de.startLineNumber-J,de.startColumn,de.endLineNumber-J,de.endColumn))}}}}e.TextSearchMatch=t;function d(ce){const ue=ce[0].startLineNumber;for(const Se of ce)if(Se.startLineNumber!==ue||Se.endLineNumber!==ue)return!1;return!0}class r{constructor(ue,Se,G,X){this.startLineNumber=ue,this.startColumn=Se,this.endLineNumber=G,this.endColumn=X}}e.SearchRange=r;class l extends r{constructor(ue,Se,G){super(ue,Se,ue,G)}}e.OneLineRange=l;var c;(function(ce){ce.List="list",ce.Tree="tree"})(c=e.ViewMode||(e.ViewMode={}));var b;(function(ce){ce.Default="default",ce.FileNames="fileNames",ce.Type="type",ce.Modified="modified",ce.CountDescending="countDescending",ce.CountAscending="countAscending"})(b=e.SearchSortOrder||(e.SearchSortOrder={}));function i(ce,ue=!0){const Se=ce&&ce.files&&ce.files.exclude,G=ue&&ce&&ce.search&&ce.search.exclude;if(!Se&&!G)return;if(!Se||!G)return Se||G;let X=Object.create(null);return X=D.mixin(X,D.deepClone(Se)),X=D.mixin(X,D.deepClone(G),!0),X}e.getExcludes=i;function s(ce,ue){return ce.excludePattern&&k.match(ce.excludePattern,ue)?!1:ce.includePattern||ce.usingSearchPaths?ce.includePattern&&k.match(ce.includePattern,ue)?!0:ce.usingSearchPaths?!!ce.folderQueries&&ce.folderQueries.some(Se=>{const G=Se.folder.fsPath;if(M.isEqualOrParent(ue,G)){const X=S.relative(G,ue);return!Se.includePattern||!!k.match(Se.includePattern,X)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var f;(function(ce){ce[ce.unknownEncoding=1]="unknownEncoding",ce[ce.regexParseError=2]="regexParseError",ce[ce.globParseError=3]="globParseError",ce[ce.invalidLiteral=4]="invalidLiteral",ce[ce.rgProcessError=5]="rgProcessError",ce[ce.other=6]="other",ce[ce.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(ue,Se){super(ue),this.code=Se}}e.SearchError=P;function C(ce){const ue=ce.message;if((0,T.isCancellationError)(ce))return new P(ue,f.canceled);try{const Se=JSON.parse(ue);return new P(Se.message,Se.code)}catch{return new P(ue,f.other)}}e.deserializeSearchError=C;function j(ce){const ue={message:ce.message,code:ce.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=j;function _(ce){return ce.type==="error"?!0:ce.type==="success"}e.isSerializedSearchComplete=_;function K(ce){return ce.type==="success"}e.isSerializedSearchSuccess=K;function A(ce){return!!ce.path}e.isSerializedFileMatch=A;function $(ce,ue){const Se=ce.searchPath?ce.searchPath:ce.relativePath;return(0,y.fuzzyContains)(Se,ue)}e.isFilePatternMatch=$;class O{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function F(ce,ue){const Se={...ce||{},...ue||{}};return Object.keys(Se).filter(G=>{const X=Se[G];return typeof X=="boolean"&&X})}e.resolvePatternsForProvider=F;class H{constructor(ue,Se){this.c=null,this.a={...ue.excludePattern||{},...Se.excludePattern||{}},this.b=k.parse(this.a);let G=ue.includePattern;Se.includePattern&&(G?G={...G,...Se.includePattern}:G=Se.includePattern),G&&(this.c=k.parse(G))}matchesExcludesSync(ue,Se,G){return!!(this.b&&this.b(ue,Se,G))}includedInQuerySync(ue,Se,G){return!(this.b&&this.b(ue,Se,G)||this.c&&!this.c(ue,Se,G))}includedInQuery(ue,Se,G){const X=this.b(ue,Se,G),J=()=>this.c?!!this.c(ue,Se,G):!0;return(0,w.isThenable)(X)?X.then(de=>de?!1:J()):J()}hasSiblingExcludeClauses(){return V(this.a)}}e.QueryGlobTester=H;function V(ce){for(const ue in ce)if(typeof ce[ue]!="boolean")return!0;return!1}function ae(ce){if(!ce)return;let ue;return Se=>(ue||(ue=(ce()||Promise.resolve([])).then(G=>G?re(G):{})),ue.then(G=>!!G[Se]))}e.hasSiblingPromiseFn=ae;function pe(ce){if(!ce)return;let ue;return Se=>{if(!ue){const G=ce();ue=G?re(G):{}}return!!ue[Se]}}e.hasSiblingFn=pe;function re(ce){const ue={};for(const Se of ce)ue[Se]=!0;return ue}}),define(ke[31],Te([1,0,16,17,21,4,6,48,15,113,24,10,9,2,146,3,11,163,53,36,27,18,8,7,55,47,5]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o,u,g,E,L,p,t,d,r,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function b(K,A,$){return new N.ExtUri(O=>P(O,$)).isEqual(K,A)}function i(K,A,$){return b(K.uri,A.uri,$)?0:(0,w.compare)(K.uri.toString(),A.uri.toString())}function s(K,A,$){return K.index!==A.index?K.index<A.index?-1:1:b(K.uri,A.uri,$)?(0,w.compare)(K.name,A.name):(0,w.compare)(K.uri.toString(),A.uri.toString())}function f(K,A,$,O){const F=K.slice(0).sort((V,ae)=>$(V,ae,O)),H=A.slice(0).sort((V,ae)=>$(V,ae,O));return(0,n.delta)(F,H,(V,ae)=>$(V,ae,O))}function P(K,A){const $=A.getCapabilities(K.scheme);return!($&&$&1024)}class C extends g.Workspace{static toExtHostWorkspace(A,$,O,F){if(!A)return{workspace:null,added:[],removed:[]};const{id:H,name:V,folders:ae,configuration:pe,transient:re,isUntitled:ce}=A,ue=[],Se=$;$?ae.forEach((de,ye)=>{const Fe=v.URI.revive(de.uri),ze=C.o(O||$,Fe,F);ze?(ze.name=de.name,ze.index=de.index,ue.push(ze)):ue.push({uri:Fe,name:de.name,index:ye})}):ue.push(...ae.map(({uri:de,name:ye,index:Fe})=>({uri:v.URI.revive(de),name:ye,index:Fe}))),ue.sort((de,ye)=>de.index<ye.index?-1:1);const G=new C(H,V,ue,!!re,pe?v.URI.revive(pe):null,!!ce,de=>P(de,F)),{added:X,removed:J}=f(Se?Se.workspaceFolders:[],G.workspaceFolders,i,F);return{workspace:G,added:X,removed:J}}static o(A,$,O){for(let F=0;F<A.folders.length;F++){const H=A.workspaceFolders[F];if(b(H.uri,$,O))return H}}constructor(A,$,O,F,H,V,ae){super(A,O.map(pe=>new g.WorkspaceFolder(pe)),F,H,ae),this.t=$,this.u=V,this.q=[],this.s=R.TernarySearchTree.forUris(ae),O.forEach(pe=>{this.q.push(pe),this.s.set(pe.uri,pe)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(A,$){return $&&this.s.get(A)&&(A=(0,N.dirname)(A)),this.s.findSubstr(A)}resolveWorkspaceFolder(A){return this.s.get(A)}}let j=class{constructor(A,$,O,F,H){this.c=new M.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new M.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.AsyncEmitter,this.h=F,this.s=O,this.t=H,this.j=new T.Counter,this.k=new k.Barrier,this.o=A.getProxy(c.MainContext.MainThreadWorkspace),this.q=A.getProxy(c.MainContext.MainThreadMessageService);const V=$.workspace;this.l=V?new C(V.id,V.name,[],!!V.transient,V.configuration?v.URI.revive(V.configuration):null,!!V.isUntitled,ae=>P(ae,O)):void 0}$initializeWorkspace(A,$){this.v=$,this.$acceptWorkspaceData(A),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?v.URI.from({scheme:S.Schemas.untitled,path:(0,N.basename)((0,N.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(A,$,O,...F){const H=[];if(Array.isArray(F)&&F.forEach(ce=>{v.URI.isUri(ce.uri)&&!H.some(ue=>b(ue.uri,ce.uri,this.s))&&H.push({uri:ce.uri,name:ce.name||(0,N.basenameOrAuthority)(ce.uri)})}),this.n||[$,O].some(ce=>typeof ce!="number"||ce<0)||O===0&&H.length===0)return!1;const V=this.x?this.x.workspaceFolders:[];if($+O>V.length)return!1;const ae=V.slice(0);ae.splice($,O,...H.map(ce=>({uri:ce.uri,name:ce.name||(0,N.basenameOrAuthority)(ce.uri),index:void 0})));for(let ce=0;ce<ae.length;ce++){const ue=ae[ce];if(ae.some((Se,G)=>G!==ce&&b(ue.uri,Se.uri,this.s)))return!1}ae.forEach((ce,ue)=>ce.index=ue);const{added:pe,removed:re}=f(V,ae,s,this.s);if(pe.length===0&&re.length===0)return!1;if(this.o){const ce=A.displayName||A.name;this.o.$updateWorkspaceFolders(ce,$,O,H).then(void 0,ue=>{this.n=void 0;const Se={source:{identifier:A.identifier,label:A.displayName||A.name}};this.q.$showMessage(u.Severity.Error,(0,m.localize)(0,null,ce,ue.toString()),Se,[])})}return this.y(ae),!0}getWorkspaceFolder(A,$){if(!!this.x)return this.x.getWorkspaceFolder(A,$)}async getWorkspaceFolder2(A,$){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(A,$)}async resolveWorkspaceFolder(A){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(A)}getPath(){if(!this.x)return;const{folders:A}=this.x;if(A.length!==0)return A[0].uri.fsPath}getRelativePath(A,$){let O,F="";if(typeof A=="string"?(O=v.URI.file(A),F=A):typeof A<"u"&&(O=A,F=A.fsPath),!O)return F;const H=this.getWorkspaceFolder(O,!0);if(!H)return F;typeof $>"u"&&this.x&&($=this.x.folders.length>1);let V=(0,N.relativePath)(H.uri,O);return $&&H.name&&(V=`${H.name}/${V}`),V}y(A){this.x&&(this.n=C.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:A,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(A){const{workspace:$,added:O,removed:F}=C.toExtHostWorkspace(A,this.l,this.n,this.s);this.l=$||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:F}))}findFiles(A,$,O,F,H=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let V;if($===null?V=!1:$&&(typeof $=="string"?V=$:V=$.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:ae,folder:pe}=_(t.GlobPattern.from(A));return this.o.$startFileSearch((0,h.withUndefinedAsNull)(ae),(0,h.withUndefinedAsNull)(pe),(0,h.withUndefinedAsNull)(V),(0,h.withUndefinedAsNull)(O),H).then(re=>Array.isArray(re)?re.map(ce=>v.URI.revive(ce)):[])}async findTextInFiles(A,$,O,F,H=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const V=this.j.getNext(),ae=typeof $.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:pe,folder:re}=_(t.GlobPattern.from($.include)),ce=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,ue={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof $.useParentIgnoreFiles=="boolean"?!$.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:ae,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:pe,excludePattern:ce},Se=!1;if(this.u[V]=G=>{if(Se)return;const X=v.URI.revive(G.resource);G.results.forEach(J=>{(0,l.resultIsMatch)(J)?O({uri:X,preview:{text:J.preview.text,matches:(0,n.mapArrayOrNot)(J.preview.matches,de=>new d.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,n.mapArrayOrNot)(J.ranges,de=>new d.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):O({uri:X,text:J.text,lineNumber:J.lineNumber})})},H.isCancellationRequested)return{};try{const G=await this.o.$startTextSearch(A,(0,h.withUndefinedAsNull)(re),ue,V,H);return delete this.u[V],G||{}}catch(G){throw delete this.u[V],G}}$handleTextSearchResult(A,$){this.u[$]?.(A)}saveAll(A){return this.o.$saveAll(A)}resolveProxy(A){return this.o.$resolveProxy(A)}get trusted(){return this.v}requestWorkspaceTrust(A){return this.o.$requestWorkspaceTrust(A)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(A,$){if(this.w.has(A))throw new Error(`A provider has already been registered for scheme ${A}`);this.w.set(A,$);const O=this.t.transformOutgoingScheme(A),F=this.z++;return this.o.$registerEditSessionIdentityProvider(F,O),(0,y.toDisposable)(()=>{this.w.delete(A),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(A,$){this.h.info("Getting edit session identifier for workspaceFolder",A);const O=await this.resolveWorkspaceFolder(v.URI.revive(A));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const F=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!F),!F)return;const H=await F.provideEditSessionIdentity(O,$);if(this.h.info("Provider returned edit session identifier: ",H),!!H)return H}async $provideEditSessionIdentityMatch(A,$,O,F){this.h.info("Getting edit session identifier for workspaceFolder",A);const H=await this.resolveWorkspaceFolder(v.URI.revive(A));if(!H){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",H);const V=this.w.get(H.uri.scheme);if(this.h.info(`Provider for scheme ${H.uri.scheme} is defined: `,!!V),!V)return;const ae=await V.provideEditSessionIdentityMatch?.($,O,F);if(this.h.info("Provider returned edit session identifier match result: ",ae),!!ae)return ae}getOnWillCreateEditSessionIdentityEvent(A){return($,O,F)=>{const H=function(ae){$.call(O,ae)};return H.extension=A,this.A.event(H,void 0,F)}}async $onWillCreateEditSessionIdentity(A,$,O){const F=await this.resolveWorkspaceFolder(v.URI.revive(A));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:F},$,async(H,V)=>{const ae=Date.now();await Promise.resolve(H),Date.now()-ae>O&&this.h.warn("SLOW edit session create-participant",V.extension.identifier)}),$.isCancellationRequested}};j=qe([Ve(0,p.IExtHostRpcService),Ve(1,L.IExtHostInitDataService),Ve(2,E.IExtHostFileSystemInfo),Ve(3,o.ILogService),Ve(4,r.IURITransformerService)],j),e.ExtHostWorkspace=j,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function _(K){let A,$;return K&&(typeof K=="string"?A=K:(A=K.pattern,$=v.URI.revive(K.baseUri))),{includePattern:A,folder:$}}}),define(ke[32],Te([1,0,22,4,31,5,7,166,93,9,17,3,18,11,2]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(d,r){if(r){const l=r.split(".");let c=d;for(let b=0;c&&b<l.length;b++)c=c[l[b]];return c}}function o(d){return d instanceof m.URI}function u(d){return d&&d.uri instanceof m.URI&&d.languageId&&typeof d.languageId=="string"}function g(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function E(d){return d&&d.uri instanceof m.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function L(d){if(o(d))return{resource:d};if(u(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(g(d))return{overrideIdentifier:d.languageId};if(E(d))return{resource:d.uri};if(d===null)return{resource:null}}let p=class{constructor(r,l,c){this.a=r.getProxy(M.MainContext.MainThreadConfiguration),this.c=l,this.b=c,this.d=new N.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,l){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(r,l))}};p=qe([Ve(0,h.IExtHostRpcService),Ve(1,D.IExtHostWorkspace),Ve(2,v.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(r,l,c,b){this.a=new k.Emitter,this.b=r,this.f=b,this.c=l,this.e=R.Configuration.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,l){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=R.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(l,c))}getConfiguration(r,l,c){const b=L(l)||{},i=this.g(r?a(this.e.getValue(void 0,b,this.c.workspace),r):this.e.getValue(void 0,b,this.c.workspace));r&&this.h(r,b,c?.identifier);function s(P){if(P==null)return null;if(typeof P=="boolean")return P?2:5;switch(P){case y.ConfigurationTarget.Global:return 2;case y.ConfigurationTarget.Workspace:return 5;case y.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(P){return typeof a(i,P)<"u"},get:(P,C)=>{this.h(r?`${r}.${P}`:P,b,c?.identifier);let j=a(i,P);if(typeof j>"u")j=C;else{let _;const K=(A,$)=>{let O;const F=()=>{_=_||(0,n.deepClone)(i),O=O||a(_,$)};return(0,T.isObject)(A)?new Proxy(A,{get:(H,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return F(),()=>O;if(_)return O=O||a(_,$),O[V];const ae=H[V];return typeof V=="string"?K(ae,`${$}.${V}`):ae},set:(H,V,ae)=>(F(),O&&(O[V]=ae),!0),deleteProperty:(H,V)=>(F(),O&&delete O[V],!0),defineProperty:(H,V,ae)=>(F(),O&&Object.defineProperty(O,V,ae),!0)}):A};j=K(j,P)}return j},update:(P,C,j,_)=>{P=r?`${r}.${P}`:P;const K=s(j);return C!==void 0?this.b.$updateConfigurationOption(K,P,C,b,_):this.b.$removeConfigurationOption(K,P,b,_)},inspect:P=>{P=r?`${r}.${P}`:P;const C=this.e.inspect(P,b,this.c.workspace);if(C)return{key:P,defaultValue:(0,n.deepClone)(C.policy?.value??C.default?.value),globalValue:(0,n.deepClone)(C.user?.value??C.application?.value),workspaceValue:(0,n.deepClone)(C.workspace?.value),workspaceFolderValue:(0,n.deepClone)(C.workspaceFolder?.value),defaultLanguageValue:(0,n.deepClone)(C.default?.override),globalLanguageValue:(0,n.deepClone)(C.user?.override??C.application?.override),workspaceLanguageValue:(0,n.deepClone)(C.workspace?.override),workspaceFolderLanguageValue:(0,n.deepClone)(C.workspaceFolder?.override),languageIds:(0,n.deepClone)(C.overrideIdentifiers)}}};return typeof i=="object"&&(0,n.mixin)(f,i,!1),Object.freeze(f)}g(r){const l=c=>(0,T.isObject)(c)?new Proxy(c,{get:(b,i)=>l(b[i]),set:(b,i,s)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(i)}' of object`)},deleteProperty:(b,i)=>{throw new Error(`TypeError: Cannot delete read only property '${String(i)}' of object`)},defineProperty:(b,i)=>{throw new Error(`TypeError: Cannot define property '${String(i)}' for a readonly object`)},setPrototypeOf:b=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return l(r)}h(r,l,c){const b=S.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),i=c?`[${c.value}] `:"";if(b===4){typeof l?.resource>"u"&&this.f.warn(`${i}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(b===3){l?.resource&&this.f.warn(`${i}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,l){const c=new R.ConfigurationChangeEvent(r,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(b,i)=>c.affectsConfiguration(b,L(i))})}k(r){return r.reduce((l,c)=>(l.set(c[0],c[1]),l),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(ke[107],Te([1,0,2,17,4,5,7,31,58,32,21,61,18,27,3,15,20,11,76,202,12]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o,u,g,E,L){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(A){function $(F){if(F!=null)return F}A.from=$;function O(F){if(F!=null)return F}A.to=O})(t||(t={}));var d;(function(A){function $(F){if(F!=null)return F}A.from=$;function O(F){if(F!=null)return F}A.to=O})(d||(d={}));var r;(function(A){function $(F){if(F!=null)return F}A.from=$;function O(F){if(F!=null)return F}A.to=O})(r||(r={}));var l;(function(A){function $(H){if(H){const V=H;return V&&!!V.process}else return!1}A.is=$;function O(H){if(H==null)return;const V={process:H.process,args:H.args};return H.options&&(V.options=r.from(H.options)),V}A.from=O;function F(H){if(H!=null)return new y.ProcessExecution(H.process,H.args,H.options)}A.to=F})(l||(l={}));var c;(function(A){function $(F){if(F!=null)return F}A.from=$;function O(F){if(F!=null)return F}A.to=O})(c||(c={}));var b;(function(A){function $(H){if(H){const V=H;return V&&(!!V.commandLine||!!V.command)}else return!1}A.is=$;function O(H){if(H==null)return;const V={};return H.commandLine!==void 0?V.commandLine=H.commandLine:(V.command=H.command,V.args=H.args),H.options&&(V.options=c.from(H.options)),V}A.from=O;function F(H){if(!(H==null||H.command===void 0&&H.commandLine===void 0))return H.commandLine?new y.ShellExecution(H.commandLine,H.options):new y.ShellExecution(H.command,H.args?H.args:[],H.options)}A.to=F})(b||(b={}));var i;(function(A){function $(H){if(H){const V=H;return V&&V.customExecution==="customExecution"}else return!1}A.is=$;function O(H){return{customExecution:"customExecution"}}A.from=O;function F(H,V){return V.get(H)}A.to=F})(i=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var s;(function(A){function $(O,F){let H;return O.scope!==void 0&&typeof O.scope!="number"?H=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===y.TaskScope.Workspace&&F&&F.workspaceFile?H=F.workspaceFile:H=E.USER_TASKS_GROUP_KEY),{id:O._id,workspaceFolder:H}}A.from=$})(s=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(A){function $(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}A.from=$})(f||(f={}));var P;(function(A){function $(H,V){if(H==null)return[];const ae=[];for(const pe of H){const re=O(pe,V);re&&ae.push(re)}return ae}A.fromMany=$;function O(H,V){if(H==null)return;let ae;H.execution instanceof y.ProcessExecution?ae=l.from(H.execution):H.execution instanceof y.ShellExecution?ae=b.from(H.execution):H.execution&&H.execution instanceof y.CustomExecution&&(ae=i.from(H.execution));const pe=t.from(H.definition);let re;return H.scope?typeof H.scope=="number"?re=H.scope:re=H.scope.uri:re=y.TaskScope.Workspace,!pe||!re?void 0:{_id:H._id,definition:pe,name:H.name,source:{extensionId:V.identifier.value,label:H.source,scope:re},execution:ae,isBackground:H.isBackground,group:f.from(H.group),presentationOptions:d.from(H.presentationOptions),problemMatchers:H.problemMatchers,hasDefinedMatchers:H.hasDefinedMatchers,runOptions:H.runOptions?H.runOptions:{reevaluateOnRerun:!0},detail:H.detail}}A.from=O;async function F(H,V,ae){if(H==null)return;let pe;l.is(H.execution)?pe=l.to(H.execution):b.is(H.execution)?pe=b.to(H.execution):i.is(H.execution)&&(pe=i.to(H._id,ae));const re=t.to(H.definition);let ce;if(H.source&&(H.source.scope!==void 0?typeof H.source.scope=="number"?ce=H.source.scope:ce=await V.resolveWorkspaceFolder(n.URI.revive(H.source.scope)):ce=y.TaskScope.Workspace),!re||!ce)return;const ue=new y.Task(re,ce,H.name,H.source.label,pe,H.problemMatchers);return H.isBackground!==void 0&&(ue.isBackground=H.isBackground),H.group!==void 0&&(ue.group=y.TaskGroup.from(H.group._id),ue.group&&H.group.isDefault&&(ue.group=new y.TaskGroup(ue.group.id,ue.group.label),H.group.isDefault===!0&&(ue.group.isDefault=H.group.isDefault))),H.presentationOptions&&(ue.presentationOptions=d.to(H.presentationOptions)),H._id&&(ue._id=H._id),H.detail&&(ue.detail=H.detail),ue}A.to=F})(P=e.TaskDTO||(e.TaskDTO={}));var C;(function(A){function $(F){return F}A.from=$;function O(F){if(!!F)return Object.assign(Object.create(null),F)}A.to=O})(C||(C={}));class j{constructor($,O,F){this._id=O,this.a=F,p.set(this,void 0),Je(this,p,$,"f")}get task(){return this.a}terminate(){Le(this,p,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}p=new WeakMap;let _=class{constructor($,O,F,H,V,ae,pe,re){this.q=new D.Emitter,this.r=new D.Emitter,this.s=new D.Emitter,this.t=new D.Emitter,this.a=$.getProxy(M.MainContext.MainThreadTask),this.b=F,this.c=H,this.d=V,this.e=ae,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=pe,this.g=re,this.a.$registerSupportedExecutions(!0)}registerTaskProvider($,O,F){if(!F)return new y.Disposable(()=>{});const H=this.w();return this.j.set(H,{type:O,provider:F,extension:$}),this.a.$registerTaskProvider(H,O),new y.Disposable(()=>{this.j.delete(H),this.a.$unregisterTaskProvider(H)})}registerTaskSystem($,O){this.a.$registerTaskSystem($,O)}fetchTasks($){return this.a.$fetchTasks(C.from($)).then(async O=>{const F=[];for(const H of O){const V=await P.to(H,this.b,this.m);V&&F.push(V)}return F})}get taskExecutions(){const $=[];return this.k.forEach(O=>$.push(O)),$}terminateTask($){if(!($ instanceof j))throw new Error("No valid task execution provided");return this.a.$terminateTask($._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask($,O,F){const H=this.m.get($.id);H&&(this.o.set($.id,H),this.e.attachPtyToTerminal(O,await H.callback(F))),this.p=$.id,this.q.fire({execution:await this.y($)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask($){const O=await this.y($);this.l.delete($.id),this.k.delete($.id),this.A($),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess($){const O=await this.y($.id);this.s.fire({execution:O,processId:$.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess($){const O=await this.y($.id);this.t.fire({execution:O,exitCode:$.exitCode})}$provideTasks($,O){const F=this.j.get($);if(!F)return Promise.reject(new Error("no handler found"));const H=[],V=(0,k.asPromise)(()=>F.provider.provideTasks(N.CancellationToken.None)).then(ae=>this.u(O,H,F,ae));return new Promise(ae=>{V.then(pe=>{Promise.all(H).then(()=>{ae(pe)})})})}async $resolveTask($,O){const F=this.j.get($);if(!F)return Promise.reject(new Error("no handler found"));if(O.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${F.type}].`);const H=await P.to(O,this.b,this.m);if(!H)throw new Error("Unexpected: Task cannot be resolved.");const V=await F.provider.resolveTask(H,N.CancellationToken.None);if(!V)return;this.z(V,F);const ae=P.from(V,F.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==H.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return i.is(ae.execution)&&await this.x(ae,V,!0),await this.v(ae)}w(){return this.h++}async x($,O,F){const H=await this.a.$createTaskId($);!F&&!this.m.has(H)&&(this.n.add(H),this.o.set(H,O.execution)),this.m.set(H,O.execution)}async y($,O){if(typeof $=="string"){const V=this.l.get($);if(!V)throw new L.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return V}const F=this.l.get($.id);if(F)return F;const H=new Promise((V,ae)=>{function pe(re,ce,ue){ue?V(new j(re,ce.id,ue)):ae("Unexpected: Task does not exist.")}O?pe(this,$,O):P.to($.task,this.b,this.m).then(re=>pe(this,$,re))});return this.l.set($.id,H),H.then(V=>(this.k.set($.id,V),V),V=>Promise.reject(V))}z($,O){$._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}A($){this.o.get($.id)&&this.o.delete($.id),this.n.has($.id)&&this.p!==$.id&&(this.m.delete($.id),this.n.delete($.id));const F=this.n.values();let H=F.next();for(;!H.done;)!this.o.has(H.value)&&this.p!==H.value&&(this.m.delete(H.value),this.n.delete(H.value)),H=F.next()}};_=qe([Ve(0,h.IExtHostRpcService),Ve(1,v.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,T.IExtHostConfiguration),Ve(5,w.IExtHostTerminalService),Ve(6,u.ILogService),Ve(7,g.IExtHostApiDeprecationService)],_),e.ExtHostTaskBase=_;let K=class extends _{constructor($,O,F,H,V,ae,pe,re){super($,O,F,H,V,ae,pe,re),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask($,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const F=P.from(O,$);if(F===void 0)throw new Error("Task is not valid");if(i.is(F.execution))await this.x(F,O,!1);else throw new L.NotSupportedError;const H=await this.y(await this.a.$getTaskExecution(F),O);return this.a.$executeTask(F).catch(V=>{throw new Error(V)}),H}u($,O,F,H){const V=[];if(H)for(const ae of H){this.z(ae,F),(!ae.definition||!$[ae.definition.type])&&this.f.warn(`The task [${ae.source}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`);const pe=P.from(ae,F.extension);pe&&i.is(pe.execution)?(V.push(pe),O.push(this.x(pe,ae,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:F.extension}}async v($){if(i.is($.execution))return $;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables($,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,O,F){}};K=qe([Ve(0,h.IExtHostRpcService),Ve(1,v.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,T.IExtHostConfiguration),Ve(5,w.IExtHostTerminalService),Ve(6,u.ILogService),Ve(7,g.IExtHostApiDeprecationService)],K),e.WorkerExtHostTask=K,e.IExtHostTask=(0,m.createDecorator)("IExtHostTask")}),define(ke[245],Te([1,0,19,21,39,35,24,77,47]),function(te,e,n,k,D,M,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(h,v,m){this.k=h,this.l=v,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=h.filePattern,this.b=h.includePattern&&M.parse(h.includePattern),this.c=h.maxResults||void 0,this.d=h.exists,this.h=new Set,this.j=h.excludePattern&&M.parse(h.excludePattern)}cancel(){this.g=!0,this.h.forEach(h=>h.cancel()),this.h=new Set}search(h){const v=this.k.folderQueries||[];return new Promise((m,a)=>{const o=u=>{this.f++,h(u)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(u=>{const g=u.toString(),E=n.basename(g);this.j&&this.j(g,E)||this.v(o,{base:u,basename:E})}),Promise.all(v.map(u=>this.p(u,o))).then(u=>{m({limitHit:this.e,stats:u[0]||void 0})},u=>{a(new Error((0,D.toErrorMessage)(u)))})})}async p(h,v){const m=new k.CancellationTokenSource,a=this.q(h),o=this.r(),u=new S.QueryGlobTester(this.k,h),g=!u.hasSiblingExcludeClauses();let E;try{this.h.add(m),E=R.StopWatch.create();const L=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,m.token),p=E.elapsed(),t=R.StopWatch.create();return this.g&&!this.e||(L&&L.forEach(d=>{const r=n.posix.relative(h.folder.path,d.path);if(g){const l=n.basename(d.path);this.v(v,{base:h.folder,relativePath:r,basename:l});return}this.s(o,h.folder,r,v)}),this.g&&!this.e)?null:(this.u(o,u,v),{providerTime:p,postProcessTime:t.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(h){const v=(0,S.resolvePatternsForProvider)(this.k.includePattern,h.includePattern),m=(0,S.resolvePatternsForProvider)(this.k.excludePattern,h.excludePattern);return{folder:h.folder,excludes:m,includes:v,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}s({pathToEntries:h},v,m,a){if(m===this.a){const u=n.basename(this.a);this.v(a,{base:v,relativePath:this.a,basename:u})}function o(u){const g=n.basename(u),E=n.dirname(u);let L=h[E];L||(L=h[E]=[],o(E)),L.push({base:v,relativePath:u,basename:g})}o(m)}u({rootEntries:h,pathToEntries:v},m,a){const o=this,u=this.a;function g(E){const L=(0,S.hasSiblingFn)(()=>E.map(p=>p.basename));for(let p=0,t=E.length;p<t;p++){const d=E[p],{relativePath:r,basename:l}=d;if(m.matchesExcludesSync(r,l,u!==l?L:void 0))continue;const c=v[r];if(c)g(c);else{if(r===u)continue;o.v(a,d)}if(o.e)break}}g(h)}v(h,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||h(v))}}class N{constructor(){this.b=new Map}fileSearch(h,v,m,a){const o=this.c(h.cacheKey),u=new T(h,v,o&&o.token);let g=0;const E=L=>{g+=L.length,m(L.map(p=>this.d(p)))};return this.e(u,N.a,E,a).then(L=>({limitHit:L.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:L.stats}}))}clearCache(h){this.c(h)?.cancel()}c(h){if(!!h)return this.b.has(h)||this.b.set(h,new k.CancellationTokenSource),this.b.get(h)}d(h){return h.relativePath?{resource:y.joinPath(h.base,h.relativePath)}:{resource:h.base}}e(h,v,m,a){a.onCancellationRequested(()=>{h.cancel()});const o=g=>{g&&(u.push(g),v>0&&u.length>=v&&(m(u),u=[]))};let u=[];return h.search(o).then(g=>(u.length&&m(u),g),g=>(u.length&&m(u),Promise.reject(g)))}}N.a=512,e.FileSearchManager=N}),define(ke[246],Te([1,0,16,63,35,87,28,15,19,24,10,9,2,262,155,41,11,53,97,244,47]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o,u,g,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(P,C,j,_,K){this.a=P,this.b=C,this.c=j,this.d=_,this.e=K}text(P,C,j={}){P=this.f(P,j);const _=this.a.getValue(),K=C&&C.some($=>!this.a.getValue({resource:$}).search.useRipgrep);return{...this.h(C?.map(u.toWorkspaceFolder),j),type:2,contentPattern:P,previewOptions:j.previewOptions,maxFileSize:j.maxFileSize,usePCRE2:_.search.usePCRE2||K||!1,beforeContext:j.beforeContext,afterContext:j.afterContext,userDisabledExcludesAndIgnoreFiles:j.disregardExcludeSettings&&j.disregardIgnoreFiles}}f(P,C){const j=this.a.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const _={...P,wordSeparators:j.editor.wordSeparators};return this.j(P,C)&&(_.isCaseSensitive=!0),this.k(P)&&(_.isMultiline=!0),_}file(P,C={}){return{...this.h(P,C),type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey}}g(P,C){return P?(P=Array.isArray(P)?P.map(c):c(P),C?this.parseSearchPaths(P):{pattern:d(...Array.isArray(P)?P:[P])}):{}}h(P=[],C={}){const j=this.g(C.includePattern,C.expandPatterns),_=this.g(C.excludePattern,C.expandPatterns),K=P.length>1,A=(j.searchPaths&&j.searchPaths.length?j.searchPaths.map(F=>this.q(F,C,_)):P.map(F=>this.r(F,C,_,K))).filter(F=>!!F),$={_reason:C._reason,folderQueries:A,usingSearchPaths:!!(j.searchPaths&&j.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:_.pattern,includePattern:j.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const F=n.coalesce(n.flatten(this.c.groups.map(ae=>ae.editors.map(pe=>pe.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const H=F.filter(ae=>(0,L.pathIncludedInQuery)($,ae.fsPath)),V=this.i(H);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...$,...V}}const O=C.extraFileResources&&C.extraFileResources.filter(F=>(0,L.pathIncludedInQuery)($,F.fsPath));return $.extraFileResources=O&&O.length?O:void 0,$}i(P){const C=[],j=new y.ResourceMap,_={};let K=!1;return P.forEach(A=>{if(A.scheme===R.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(A)){const O=this.b.getWorkspaceFolder(A)?.uri??A.with({path:S.dirname(A.fsPath)});let F=j.get(O);F||(K=!0,F={folder:O,includePattern:{}},C.push(F),j.set(O,F));const H=S.relative(O.fsPath,A.fsPath);(0,w.assertIsDefined)(F.includePattern)[H.replace(/\\/g,"/")]=!0}else A.fsPath&&(K=!0,_[A.fsPath]=!0)}),{folderQueries:C,includePattern:_,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(P,C){if(C.isSmartCase){if(P.isRegExp){if(N.containsUppercaseCharacter(P.pattern,!0))return!0}else if(N.containsUppercaseCharacter(P.pattern))return!0}return!!P.isCaseSensitive}k(P){return P.isMultiline||P.isRegExp&&(0,v.isMultilineRegexSource)(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const C=V=>S.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),_=(Array.isArray(P)?P:r(P)).map(V=>{const ae=this.e.resolvedUserHome;return ae?(0,M.untildify)(V,ae.scheme===R.Schemas.file?ae.fsPath:ae.path):V}),K=k.groupBy(_,V=>C(V)?"searchPaths":"exprSegments"),A=(K.exprSegments||[]).map(V=>N.rtrim(V,"/")).map(V=>N.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),l(V))),$={},O=this.m(K.searchPaths||[]);O&&O.length&&($.searchPaths=O);const F=n.flatten(A),H=d(...F);return H&&($.pattern=H),$}l(P,C){return C.disregardExcludeSettings?void 0:(0,L.getExcludes)(P,!C.disregardSearchExcludeSettings)}m(P){if(!P||!P.length)return[];const C=P.flatMap(_=>{let{pathPortion:K,globPortion:A}=t(_);return A&&(A=b(A)),this.n(K).flatMap(O=>this.o(O,A))}),j=new Map;return C.forEach(_=>{const K=_.searchPath.toString(),A=j.get(K);A?_.pattern&&(A.pattern=A.pattern||{},A.pattern[_.pattern]=!0):j.set(K,{searchPath:_.searchPath,pattern:_.pattern?d(_.pattern):void 0})}),Array.from(j.values())}n(P){if(S.isAbsolute(P)){const C=this.b.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==R.Schemas.file?[{searchPath:C[0].uri.with({path:P})}]:[{searchPath:h.URI.file(S.normalize(P))}]}if(this.b.getWorkbenchState()===2){const C=this.b.getWorkspace().folders[0].uri;if(P=c(P),P.startsWith("../")||P===".."){const _=S.posix.resolve(C.path,P);return[{searchPath:C.with({path:_})}]}const j=b(P);return[{searchPath:C,pattern:j}]}else{if(P==="./"||P===".\\")return[];{const C=P.replace(/^\.[\/\\]/,""),_=this.b.getWorkspace().folders.map(K=>{const A=C.match(new RegExp(`^${N.escapeRegExpCharacters(K.name)}(?:/(.*)|$)`));return A?{match:A,folder:K}:null}).filter(w.isDefined);if(_.length)return _.map(K=>{const A=K.match[1];return{searchPath:K.folder.uri,pattern:A&&b(A)}});{const K=P.match(/\.[\/\\](.+)[\/\\]?/),A=K?K[1]:P,$=m.localize(0,null,A);throw new Error($)}}}}o(P,C){const j=P.pattern&&C?`${P.pattern}/${C}`:P.pattern||C,_=[{searchPath:P.searchPath,pattern:j}];return j&&!j.endsWith("**")&&_.push({searchPath:P.searchPath,pattern:j+"/**"}),_}q(P,C,j){const _=this.r((0,u.toWorkspaceFolder)(P.searchPath),C,j,!1);return _?{..._,includePattern:P.pattern}:null}r(P,C,j,_){let K;const A=h.URI.isUri(P)?P:P.uri;if(j.searchPaths){const V=j.searchPaths.filter(ae=>(0,T.isEqual)(ae.searchPath,A))[0];if(V&&!V.pattern)return null;V&&(K=V.pattern)}const $=this.a.getValue({resource:A}),F={...this.l($,C)||{},...K||{}},H=h.URI.isUri(P)?(0,T.basename)(P):P.name;return{folder:A,folderName:_?H:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:$.files&&$.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!$.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!$.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof C.disregardParentIgnoreFiles=="boolean"?C.disregardParentIgnoreFiles:!$.search.useParentIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!$.search.followSymlinks}}};p=qe([Ve(0,a.IConfigurationService),Ve(1,u.IWorkspaceContextService),Ve(2,g.IEditorGroupsService),Ve(3,o.ILogService),Ve(4,E.IPathService)],p),e.QueryBuilder=p;function t(f){const P=f.match(/[\*\{\}\(\)\[\]\?]/);if(P){const C=P.index,j=f.substr(0,C).match(/[/|\\][^/\\]*$/);if(j){let _=f.substr(0,j.index);return _.match(/[/\\]/)||(_+="/"),{pathPortion:_,globPortion:f.substr((j.index||0)+1)}}}return{pathPortion:f}}function d(...f){return f.length?f.reduce((P,C)=>(P[C]=!0,P),Object.create(null)):void 0}function r(f){return D.splitGlobAware(f,",").map(P=>P.trim()).filter(P=>!!P.length)}function l(f){return[`**/${f}/**`,`**/${f}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function c(f){return f.replace(/\\/g,"/")}function b(f){return c(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function i(f){return f.replace(/([?*[\]])/g,"[$1]")}function s(f,P){f=n.distinct(f,_=>_.toString());const C=[],j=P.getWorkspace();return f&&f.forEach(_=>{let K;if(P.getWorkbenchState()===2)K=(0,T.relativePath)(j.folders[0].uri,_),K&&K!=="."&&(K="./"+K);else{const A=P.getWorkspaceFolder(_);if(A){const $=A.name;if(j.folders.filter(F=>F.name===$).length===1){const F=(0,T.relativePath)(A.uri,_);F===""?K=`./${A.name}`:K=`./${A.name}/${F}`}else K=_.fsPath}}K&&C.push(i(K))}),C}e.resolveResourcesForSearchIncludes=s}),define(ke[247],Te([1,0,24,2,21,12,3,246,47,53]),function(te,e,n,k,D,M,y,R,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function w(a,o){const u=o.activationEvents;if(!u)return Promise.resolve(void 0);const g=[],E=[];for(const l of u)if(/^workspaceContains:/.test(l)){const c=l.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||a.forceUsingSearch?E.push(c):g.push(c)}if(g.length===0&&E.length===0)return Promise.resolve(void 0);let L;const p=new Promise((l,c)=>{L=l}),t=l=>L({activationEvent:l}),d=Promise.all(g.map(l=>h(a,l,t))).then(()=>{}),r=v(a,o.identifier,E,t);return Promise.all([d,r]).then(()=>{L(void 0)}),p}e.checkActivateWorkspaceContainsExtension=w;async function h(a,o,u){for(const g of a.folders)if(await a.exists(n.joinPath(k.URI.revive(g),o))){u(`workspaceContains:${o}`);return}}async function v(a,o,u,g){if(u.length===0)return Promise.resolve(void 0);const E=new D.CancellationTokenSource,L=a.checkExists(a.folders,u,E.token),p=setTimeout(async()=>{E.cancel(),a.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},N);let t=!1;try{t=await L}catch(d){M.isCancellationError(d)||M.onUnexpectedError(d)}E.dispose(),clearTimeout(p),t&&g(`workspaceContains:${u.join(",")}`)}function m(a,o,u,g){const E=a.get(y.IInstantiationService),L=a.get(S.ISearchService),t=E.createInstance(R.QueryBuilder).file(o.map(d=>(0,T.toWorkspaceFolder)(k.URI.revive(d))),{_reason:"checkExists",includePattern:u,exists:!0});return L.fileSearch(t,g).then(d=>!!d.limitHit,d=>M.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=m});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,k,D){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,k){if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?k:n==="a"?k.call(te):k?k.value:e.get(te)};define(ke[33],Te([1,0,140,19,82,24,17,6,48,2,11,5,32,192,80,31,25,98,12,26,23,177,7,94,3,27,81,18,68,70,61,4,247,79,179,15,78,77,20]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o,u,g,E,L,p,t,d,r,l,c,b,i,s,f,P,C,j,_,K,A,$,O){"use strict";var F,H,V;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let ae=class Ui extends R.Disposable{constructor(G,X,J,de,ye,Fe,ze,Pe,Ie,we,se){super(),this.a=this.B(new P.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=X,this.g=J,this.f=ze,this.j=de,this.k=ye,this.l=Fe,this.m=Ie,this.p=we,this.s=se,this.t=this.g.getProxy(w.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(w.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(w.MainContext.MainThreadExtensionService),this.w=new y.Barrier,this.y=new y.Barrier,this.z=new y.Barrier,this.C=new y.Barrier,this.F=new u.ExtensionDescriptionRegistry(this.f.allExtensions);const le=(0,o.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new u.ExtensionDescriptionRegistry(ce(this.F,le)),this.G=new m.ExtHostStorage(this.g,this.l),this.H=new j.ExtHostSecretState(this.g),this.I=Pe,this.h=G.createChild(new i.ServiceCollection([m.IExtHostStorage,this.G],[j.IExtHostSecretState,this.H])),this.J=this.B(new v.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(Z,I,B)=>{this.v.$onExtensionActivationError(Z,g.transformErrorForSerialization(I),B)},actualActivateExtension:async(Z,I)=>{if(u.ExtensionDescriptionRegistry.isHostExtension(Z,this.D,this.F))return await this.v.$activateExtension(Z,I),new v.HostExtension;const B=this.D.getExtensionDescription(Z);return this.Y(B,I)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.ob(),this.w.open(),await this.j.waitForInitializeCall(),D.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.lb()}catch(G){g.onUnexpectedError(G)}}async Q(){this.I.onWillDeactivateAll();let G=[];try{G=this.D.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this.X(ye))}catch{}await Promise.all(G)}terminate(G,X=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${G}`),this.l.flush(),this.p.dispose(),this.J.dispose(),g.setUnexpectedErrorHandler(de=>{this.l.error(de)}),this.g.dispose();const J=this.Q();Promise.race([(0,y.timeout)(5e3),J]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${X}`):this.l.info(`Extension host exiting with code ${X}`),this.l.flush(),this.l.dispose(),this.c.exit(X)})}isActivated(G){return this.z.isOpen()?this.J.isActivated(G):!1}async getExtension(G){const X=await this.v.$getExtension(G);let J;if(X?.browserNlsBundleUris){J={};for(const de of Object.keys(X.browserNlsBundleUris))J[de]=T.URI.revive(X.browserNlsBundleUris[de])}return X&&{...X,identifier:new E.ExtensionIdentifier(X.identifier.value),extensionLocation:T.URI.revive(X.extensionLocation),browserNlsBundleUris:J}}R(G,X){return this.J.activateByEvent(G,X)}S(G,X){return this.J.activateById(G,X)}activateByIdWithErrors(G,X){return this.S(G,X).then(()=>{const J=this.J.getActivatedExtension(G);if(J.activationFailed)return Promise.reject(J.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(G=>this.D)}getExtensionExports(G){return this.z.isOpen()?this.J.getActivatedExtension(G).exports:null}async U(G){if(G.scheme!==K.Schemas.file)return G;const X=await this.c.realpath(G.fsPath);return T.URI.file(X)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(G=>new ue(G))),this.L}async W(G){const X=S.TernarySearchTree.forUris(J=>M.extUriBiasedIgnorePathCase.ignorePathCasing(J));return await Promise.all(G.map(async J=>{if(this.pb(J)){const de=await this.U(J.extensionLocation);X.set(de,J)}})),X}X(G){let X=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(G))return X;const J=this.J.getActivatedExtension(G);if(!J)return X;try{typeof J.module.deactivate=="function"&&(X=Promise.resolve(J.module.deactivate()).then(void 0,de=>(this.l.error(de),Promise.resolve(void 0))))}catch(de){this.l.error(`An error occurred when deactivating the extension '${G.value}':`),this.l.error(de)}try{(0,R.dispose)(J.subscriptions)}catch(de){this.l.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this.l.error(de)}return X}async Y(G,X){return this.f.remote.isRemote?this.v.$onWillActivateExtension(G.identifier):await this.v.$onWillActivateExtension(G.identifier),this.ab(G,X).then(J=>{const de=J.activationTimes;return this.v.$onDidActivateExtension(G.identifier,de.codeLoadingTime,de.activateCallTime,de.activateResolvedTime,X),this.Z(G,X,"success",de),J},J=>{throw this.Z(G,X,"failure"),J})}Z(G,X,J,de){const ye=pe(G,X);this.u.$publicLog2("extensionActivationTimes",{...ye,...de||{},outcome:J})}ab(G,X){const J=pe(G,X);this.u.$publicLog2("activatePlugin",J);const de=this.pb(G);if(!de)return Promise.resolve(new v.EmptyExtension(v.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${X.startup}, activationEvent: '${X.activationEvent}'${G.identifier.value!==X.extensionId.value?`, root cause: ${X.extensionId.value}`:""}`),this.l.flush();const ye=new v.ExtensionActivationTimesBuilder(X.startup);return Promise.all([this.qb(G,(0,M.joinPath)(G.extensionLocation,de),ye),this.bb(G)]).then(Fe=>(D.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),Ui.cb(this.l,G.identifier,Fe[0],Fe[1],ye))).then(Fe=>(D.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),Fe))}bb(G){const X=new p.ExtensionGlobalMemento(G,this.G),J=new p.ExtensionMemento(G.identifier.value,!1,this.G),de=new _.ExtensionSecrets(G,this.H),ye=G.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Fe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([X.whenReady,J.whenReady,this.I.whenReady]).then(()=>{const ze=this;let Pe,Ie;const we=(0,o.isProposedApiEnabled)(G,"ipc")?this.f.messagePorts?.get(E.ExtensionIdentifier.toKey(G.identifier)):void 0;return Object.freeze({globalState:X,workspaceState:J,secrets:de,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(se){return k.join(G.extensionLocation.fsPath,se)},get storagePath(){return ze.I.workspaceValue(G)?.fsPath},get globalStoragePath(){return ze.I.globalValue(G).fsPath},get logPath(){return k.join(ze.f.logsLocation.fsPath,G.identifier.value)},get logUri(){return T.URI.joinPath(ze.f.logsLocation,G.identifier.value)},get storageUri(){return ze.I.workspaceValue(G)},get globalStorageUri(){return ze.I.globalValue(G)},get extensionMode(){return ye},get extension(){return Pe===void 0&&(Pe=new re(ze,G.identifier,G,Fe,!1)),Pe},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(G,"extensionRuntime"),ze.extensionRuntime},get environmentVariableCollection(){return ze.p.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!Ie){if(!we)return;const se=P.Event.buffer(P.Event.fromDOMEventEmitter(we,"message",le=>le.data));we.start(),Ie={onDidReceiveMessage:se,postMessage:we.postMessage.bind(we)}}return Ie}})})}static cb(G,X,J,de,ye){return J=J||{activate:void 0,deactivate:void 0},this.db(G,X,J,de,ye).then(Fe=>new v.ActivatedExtension(!1,null,ye.build(),J,Fe,de.subscriptions))}static db(G,X,J,de,ye){if(typeof J.activate=="function")try{ye.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${X.value}`);const Fe=typeof global=="object"?global:self,ze=J.activate.apply(Fe,[de]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve(ze).then(Pe=>(ye.activateResolveStop(),Pe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(J)}eb(G,X){this.S(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:X}).then(void 0,J=>{this.l.error(J)})}fb(G,X=0){const de=Date.now();(0,O.setTimeout0)(()=>{for(let ye=X;ye<G.length;ye+=1){const Fe=G[ye];for(const ze of Fe.activationEvents??[])if(ze==="onStartupFinished")if(Date.now()-de>50){this.fb(G,ye);break}else this.eb(Fe,ze)}})}gb(){this.v.$setPerformanceMarks(D.getMarks()),this.k.getConfigProvider().then(G=>{const X=G.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),J=this.D.getAllExtensionDescriptions();if(X)this.fb(J);else for(const de of J)if(de.activationEvents)for(const ye of de.activationEvents)ye==="onStartupFinished"&&this.eb(de,ye)})}hb(){const G=this.R("*",!0).then(void 0,ye=>{this.l.error(ye)});this.B(this.j.onDidChangeWorkspace(ye=>this.ib(ye.added)));const X=this.j.workspace?this.j.workspace.folders:[],J=this.ib(X),de=Promise.all([G,J]).then(()=>{});return Promise.race([de,(0,y.timeout)(1e4)]).then(()=>{this.gb()}),de}ib(G){return G.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(X=>this.jb(G,X))).then(()=>{})}async jb(G,X){if(this.isActivated(X.identifier))return;const J=!this.f.remote.isRemote&&!!this.f.remote.authority,de={logService:this.l,folders:G.map(Fe=>Fe.uri),forceUsingSearch:J,exists:Fe=>this.c.exists(Fe.fsPath),checkExists:(Fe,ze,Pe)=>this.t.$checkExists(Fe,ze,Pe)},ye=await(0,C.checkActivateWorkspaceContainsExtension)(de,X);if(!!ye)return this.S(X.identifier,{startup:!0,extensionId:X.identifier,activationEvent:ye.activationEvent}).then(void 0,Fe=>this.l.error(Fe))}async $extensionTestsExecute(){await this.C.wait();try{return await this.kb()}catch(G){throw console.error(G),G}}async kb(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:X}=this.f.environment;if(!G||!X)throw new Error(n.localize(0,null));const J=await this.qb(null,X,new v.ExtensionActivationTimesBuilder(!1));if(!J||typeof J.run!="function")throw new Error(n.localize(1,null,X.toString()));return new Promise((de,ye)=>{const Fe=(Ie,we)=>{Ie?ye(Ie):de(typeof we=="number"&&we>0?1:0)},ze=(0,M.originalFSPath)(X),Pe=J.run(ze,Fe);Pe&&Pe.then&&Pe.then(()=>{de(0)}).catch(Ie=>{ye(Ie instanceof Error&&Ie.stack?Ie.stack:String(Ie))})})}lb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.hb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,X){return this.M[G]=X,(0,R.toDisposable)(()=>{delete this.M[G]})}async mb(G){const X=G.indexOf("+");if(X===-1)throw new Error("Not an authority that can be resolved!");const J=G.substr(0,X);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${J}`,!1),{authorityPrefix:J,resolver:this.M[J]}}async $resolveAuthority(G,X){const J=$.StopWatch.create(!1),de=()=>`[resolveAuthority(${(0,d.getRemoteAuthorityPrefix)(G)},${X})][${J.elapsed()}ms] `,ye=we=>this.l.info(`${de()}${we}`),Fe=(we,se=void 0)=>this.l.error(`${de()}${we}`,se);ye("activating resolver...");const{authorityPrefix:ze,resolver:Pe}=await this.mb(G);if(!Pe)return Fe("no resolver"),{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ze}.`,detail:void 0}};const Ie=new y.IntervalTimer;try{ye("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Pe)),Ie.cancelAndSet(()=>ye("waiting..."),1e3),ye("invoking resolve()..."),D.mark(`code/extHost/willResolveAuthority/${ze}`);const we=await Pe.resolve(G,{resolveAttempt:X});D.mark(`code/extHost/didResolveAuthorityOK/${ze}`),Ie.dispose(),ye(`returned ${we.host}:${we.port}`);const se={authority:G,host:we.host,port:we.port,connectionToken:we.connectionToken},le={extensionHostEnv:we.extensionHostEnv,isTrusted:we.isTrusted,authenticationSession:we.authenticationSessionForInitializingExtensions?{id:we.authenticationSessionForInitializingExtensions.id,providerId:we.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:se,options:le,tunnelInformation:{environmentTunnels:we.environmentTunnels,features:we.tunnelFeatures}}}}catch(we){if(D.mark(`code/extHost/didResolveAuthorityError/${ze}`),Ie.dispose(),Fe("returned an error",we),we instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:we._code,message:we._message,detail:we._detail}};throw we}}async $getCanonicalURI(G,X){this.l.info(`$getCanonicalURI invoked for authority (${(0,d.getRemoteAuthorityPrefix)(G)})`);const{resolver:J}=await this.mb(G);if(!J)return null;const de=T.URI.revive(X);if(typeof J.getCanonicalURI>"u")return de;const ye=await(0,y.asPromise)(()=>J.getCanonicalURI(de));return ye||de}static nb(G,X,J){const de=new u.ExtensionDescriptionRegistry(G.getAllExtensionDescriptions());de.deltaExtensions(J.toAdd,J.toRemove);const ye=(0,o.extensionIdentifiersArrayToSet)(X.getAllExtensionDescriptions().map(ze=>ze.identifier));for(const ze of J.myToRemove)ye.delete(E.ExtensionIdentifier.toKey(ze));for(const ze of J.myToAdd)ye.add(E.ExtensionIdentifier.toKey(ze));const Fe=ce(de,ye);return{globalRegistry:de,myExtensions:Fe}}$startExtensionHost(G){G.toAdd.forEach(de=>de.extensionLocation=T.URI.revive(de.extensionLocation));const{globalRegistry:X,myExtensions:J}=Ui.nb(this.F,this.D,G);return this.F.set(X.getAllExtensionDescriptions()),this.D.set(J),this.lb()}$activateByEvent(G,X){return X===1?this.R(G,!1):this.z.wait().then(J=>this.R(G,!1))}async $activate(G,X){return await this.z.wait(),this.D.getExtensionDescription(G)?(await this.S(G,X),!0):!1}async $deltaExtensions(G){G.toAdd.forEach(Fe=>Fe.extensionLocation=T.URI.revive(Fe.extensionLocation));const{globalRegistry:X,myExtensions:J}=Ui.nb(this.F,this.D,G),de=await this.W(J);return(await this.getExtensionPathIndex()).setSearchTree(de),this.F.set(X.getAllExtensionDescriptions()),this.D.set(J),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){const X=L.VSBuffer.alloc(G),J=Math.random()%256;for(let de=0;de<G;de++)X.writeUInt8(J,de);return X}async $updateRemoteConnectionData(G){this.P=G,this.a.fire()}};ae=qe([Ve(0,r.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,b.IExtHostRpcService),Ve(3,a.IExtHostWorkspace),Ve(4,h.IExtHostConfiguration),Ve(5,N.ILogService),Ve(6,l.IExtHostInitDataService),Ve(7,c.IExtensionStoragePaths),Ve(8,s.IExtHostTunnelService),Ve(9,f.IExtHostTerminalService),Ve(10,A.IExtHostLocalizationService)],ae),e.AbstractExtHostExtensionService=ae;function pe(Se,G){return{id:Se.identifier.value,name:Se.name,extensionVersion:Se.version,publisherDisplayName:Se.publisher,activationEvents:Se.activationEvents?Se.activationEvents.join(","):null,isBuiltin:Se.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class re{constructor(G,X,J,de,ye){F.set(this,void 0),H.set(this,void 0),V.set(this,void 0),Je(this,F,G,"f"),Je(this,H,X,"f"),Je(this,V,J.identifier,"f"),this.id=J.identifier.value,this.extensionUri=J.extensionLocation,this.extensionPath=k.normalize((0,M.originalFSPath)(J.extensionLocation)),this.packageJSON=J,this.extensionKind=de,this.isFromDifferentExtensionHost=ye}get isActive(){return Le(this,F,"f").isActivated(Le(this,V,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Le(this,F,"f").getExtensionExports(Le(this,V,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Le(this,F,"f").activateByIdWithErrors(Le(this,V,"f"),{startup:!1,extensionId:Le(this,H,"f"),activationEvent:"api"}),this.exports}}e.Extension=re,F=new WeakMap,H=new WeakMap,V=new WeakMap;function ce(Se,G){return Se.getAllExtensionDescriptions().filter(X=>G.has(E.ExtensionIdentifier.toKey(X.identifier)))}class ue{constructor(G){this.a=G}setSearchTree(G){this.a=G}findSubstr(G){return this.a.findSubstr(G)}forEach(G){return this.a.forEach(G)}}e.ExtensionPaths=ue}),define(ke[248],Te([1,0,82,2,5,32,25,26,18,27,3,33,51,11,10]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(p,t,d,r,l,c,b){this.c=p,this.d=t,this.e=d,this.f=r,this.g=l,this.h=c,this.i=b,this.a=new Map,this.b=[]}async install(){this.j(),n.mark("code/extHost/willWaitForConfig");const p=await this.f.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new u(this.c,t,this.d,p,this.i)),this.register(this.e.createInstance(g,t)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(E,t,this.h.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const t of p.nodeModuleName)this.a.set(t,p);else this.a.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this.b.push(t=>p.alternativeModuleName(t))}};a=qe([Ve(2,N.IInstantiationService),Ve(3,M.IExtHostConfiguration),Ve(4,w.IExtHostExtensionService),Ve(5,T.IExtHostInitDataService),Ve(6,v.ILogService)],a),e.RequireInterceptor=a;let o=class rn{constructor(p){if(p.environment.appRoot&&rn.a.size){const t=(0,m.escapeRegExpCharacters)(this.c(p.environment.appRoot.fsPath)),d="[a-z0-9_.-]",r=`@${d}+\\/${d}+|${d}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${l}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(p){if(!this.b)return;const t=this.b.exec(this.c(p));if(!t)return;const[,d,r,l]=t,c=rn.a.get(r);if(c!==void 0)return console.warn(`${r} as been renamed to ${c}, please update your imports`),d+c+l}c(p){return p.replace(/\\/g,"/")}};o.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=qe([Ve(0,T.IExtHostInitDataService)],o);class u{constructor(p,t,d,r,l){this.c=p,this.d=t,this.e=d,this.f=r,this.g=l,this.nodeModuleName="vscode",this.a=new Map}load(p,t){const d=this.d.findSubstr(t);if(d){let r=this.a.get(R.ExtensionIdentifier.toKey(d.identifier));return r||(r=this.c(d,this.e,this.f),this.a.set(R.ExtensionIdentifier.toKey(d.identifier),r)),r}if(!this.b){let r="";this.d.forEach((l,c)=>r+=`	${c} -> ${l.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this.b=this.c(y.nullExtensionDescription,this.e,this.f)}return this.b}}let g=class{constructor(p,t,d){this.d=p,this.nodeModuleName="keytar",this.a=t.getProxy(D.MainContext.MainThreadTelemetry);const{environment:r}=d,l=t.getProxy(D.MainContext.MainThreadKeytar);if(r.appRoot){let c=r.appRoot.fsPath;h.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.b=new Set,this.b.add(`${c}/node_modules.asar/keytar`),this.b.add(`${c}/node_modules/keytar`)}this.c={getPassword:(c,b)=>l.$getPassword(c,b),setPassword:(c,b,i)=>l.$setPassword(c,b,i),deletePassword:(c,b)=>l.$deletePassword(c,b),findPassword:c=>l.$findPassword(c),findCredentials(c){return l.$findCredentials(c)}}}load(p,t){const d=this.d.findSubstr(t);return this.a.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(p){const t=p.length;if(t<=7||!this.b)return;const d=t-7;if((p.charAt(d)==="/"||p.charAt(d)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.b.has(p)))return"keytar"}};g=qe([Ve(1,S.IExtHostRpcService),Ve(2,T.IExtHostInitDataService)],g);let E=class{constructor(p,t,d){this.e=p,this.f=t,this.nodeModuleName=["open","opn"],this.d=d.getProxy(D.MainContext.MainThreadTelemetry);const r=d.getProxy(D.MainContext.MainThreadWindow);this.c=(l,c)=>{const b=k.URI.parse(l);return c?this.g(l,c):b.scheme==="http"||b.scheme==="https"?r.$openUri(b,l,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?r.$openUri(b,l,{}):this.g(l,c)}}load(p,t,d){const r=this.e.findSubstr(t);return r&&(this.a=r.identifier.value,this.h()),this.b=d(p),this.c}g(p,t){return this.i(),this.b(p,t)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};E=qe([Ve(2,S.IExtHostRpcService)],E)}),define(ke[108],Te([1,0,85,6,19,51,3,58,59,33,7,31,189,32]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,y.createDecorator)("IExtHostVariableResolverProvider");class m extends h.AbstractVariableResolverService{constructor(u,g,E,L,p,t,d){function r(){if(E){const l=E.activeEditor();if(l)return l.document.uri;const c=L.tabGroups.all.find(b=>b.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof N.TextDiffTabInput||c.input instanceof N.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof N.TextTabInput||c.input instanceof N.NotebookEditorTabInput||c.input instanceof N.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:l=>{const c=t.folders.filter(b=>b.name===l);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,c)=>p.getConfiguration(void 0,l).get(c),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=r();if(l)return D.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const l=r();if(l){const c=g.getWorkspaceFolder(l);if(c)return D.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(E){const l=E.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(E){const l=E.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>u.getExtension(l)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(M.env))}}let a=class extends k.Disposable{constructor(u,g,E,L,p){super(),this.b=u,this.c=g,this.g=E,this.h=L,this.i=p,this.a=new n.Lazy(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.i,t,r,this.j())})}getResolver(){return this.a.value}j(){}};a=qe([Ve(0,T.IExtHostExtensionService),Ve(1,w.IExtHostWorkspace),Ve(2,R.IExtHostDocumentsAndEditors),Ve(3,v.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs)],a),e.ExtHostVariableResolverProviderService=a}),define(ke[109],Te([1,0,17,4,9,2,3,5,59,33,18,7,31,182,184,32,108]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,l,c,b,i,s){this.D=l,this.E=c,this.F=b,this.G=i,this.H=s,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new k.Emitter,this.n=new k.Emitter,this.o=new k.Emitter,this.u=new k.Emitter,this.k=r.getProxy(R.MainContext.MainThreadDebugService),this.z=new k.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new E(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(f=>{f.onDidChange(P=>{this.I(f)}),this.I(f)})}asDebugSourceUri(r,l){const c=r;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let b=`debug:${encodeURIComponent(c.path||"")}`,i="?";return l&&(b+=`${i}session=${encodeURIComponent(l.id)}`,i="&"),b+=`${i}ref=${c.sourceReference}`,M.URI.parse(b)}else{if(c.path)return M.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(r){const l=[];for(const c of r.getAllExtensionDescriptions())if(c.contributes){const b=c.contributes.debuggers;if(b&&b.length>0)for(const i of b)(0,m.isDebuggerMainContribution)(i)&&l.push(i.type)}this.k.$registerDebugTypes(l)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const r=[];return this.w.forEach(l=>r.push(l)),r}addBreakpoints(r){this.T();const l=r.filter(i=>{const s=i.id;return this.w.has(s)?!1:(this.w.set(s,i),!0)});this.U(l,[],[]);const c=[],b=new Map;for(const i of l)if(i instanceof w.SourceBreakpoint){let s=b.get(i.location.uri.toString());s||(s={type:"sourceMulti",uri:i.location.uri,lines:[]},b.set(i.location.uri.toString(),s),c.push(s)),s.lines.push({id:i.id,enabled:i.enabled,condition:i.condition,hitCondition:i.hitCondition,logMessage:i.logMessage,line:i.location.range.start.line,character:i.location.range.start.character})}else i instanceof w.FunctionBreakpoint&&c.push({type:"function",id:i.id,enabled:i.enabled,hitCondition:i.hitCondition,logMessage:i.logMessage,condition:i.condition,functionName:i.functionName});return this.k.$registerBreakpoints(c)}removeBreakpoints(r){this.T();const l=r.filter(s=>this.w.delete(s.id));this.U([],l,[]);const c=l.filter(s=>s instanceof w.SourceBreakpoint).map(s=>s.id),b=l.filter(s=>s instanceof w.FunctionBreakpoint).map(s=>s.id),i=l.filter(s=>s instanceof w.DataBreakpoint).map(s=>s.id);return this.k.$unregisterBreakpoints(c,b,i)}startDebugging(r,l,c){return this.k.$startDebugging(r?r.uri:void 0,l,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===w.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,l,c){if(!l)return new w.Disposable(()=>{});const b=this.d++;return this.f.push({type:r,handle:b,provider:l}),this.k.$registerDebugConfigurationProvider(r,c,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,b),new w.Disposable(()=>{this.f=this.f.filter(i=>i.provider!==l),this.k.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(r,l,c){if(!c)return new w.Disposable(()=>{});if(!this.P(r,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.M(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this.g++;return this.h.push({type:l,handle:b,factory:c}),this.k.$registerDebugAdapterDescriptorFactory(l,b),new w.Disposable(()=>{this.h=this.h.filter(i=>i.factory!==c),this.k.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(r,l){if(!l)return new w.Disposable(()=>{});const c=this.i++;return this.j.push({type:r,handle:c,factory:l}),new w.Disposable(()=>{this.j=this.j.filter(b=>b.factory!==l)})}async $runInTerminal(r,l){return Promise.resolve(void 0)}async $substituteVariables(r,l){let c;const b=await this.W(r);return b&&(c={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(c,l)}J(r,l){if(r.type==="implementation")return new p(r.implementation)}K(){}async $startDASession(r,l){const c=this,b=await this.V(l);return this.R(this.M(b.type),b).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const s=this.L(i),f=this.J(s,b);if(!f)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const P=f;return this.A.set(r,P),this.Q(b).then(C=>(C&&this.B.set(r,C),P.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const _=j,K={type:"response",seq:0,command:_.command,request_seq:_.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const A=await this.C.sign(_.arguments.value);K.body={signature:A},P.sendResponse(K)}else throw new Error("no signer")}catch(A){K.success=!1,K.message=A.message,P.sendResponse(K)}}else C&&C.onDidSendMessage&&C.onDidSendMessage(j),j=(0,m.convertToVSCPaths)(j,!0),c.k.$acceptDAMessage(r,j)}),P.onError(j=>{C&&C.onError&&C.onError(j),this.k.$acceptDAError(r,j.name,j.message,j.stack)}),P.onExit(j=>{C&&C.onExit&&C.onExit((0,D.withNullAsUndefined)(j),void 0),this.k.$acceptDAExit(r,(0,D.withNullAsUndefined)(j),void 0)}),C&&C.onWillStartSession&&C.onWillStartSession(),P.startSession()))})}$sendDAMessage(r,l){l=(0,m.convertToDAPaths)(l,!1);const c=this.B.get(r);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(l),this.A.get(r)?.sendMessage(l)}$stopDASession(r){const l=this.B.get(r);this.B.delete(r),l&&l.onWillStopSession&&l.onWillStopSession();const c=this.A.get(r);return this.A.delete(r),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const l=[],c=[],b=[];if(r.added)for(const i of r.added){const s=i.id;if(s&&!this.w.has(s)){let f;if(i.type==="function")f=new w.FunctionBreakpoint(i.functionName,i.enabled,i.condition,i.hitCondition,i.logMessage);else if(i.type==="data")f=new w.DataBreakpoint(i.label,i.dataId,i.canPersist,i.enabled,i.hitCondition,i.condition,i.logMessage);else{const P=M.URI.revive(i.uri);f=new w.SourceBreakpoint(new w.Location(P,new w.Position(i.line,i.character)),i.enabled,i.condition,i.hitCondition,i.logMessage)}(0,w.setBreakpointId)(f,s),this.w.set(s,f),l.push(f)}}if(r.removed)for(const i of r.removed){const s=this.w.get(i);s&&(this.w.delete(i),c.push(s))}if(r.changed){for(const i of r.changed)if(i.id){const s=this.w.get(i.id);if(s){if(s instanceof w.FunctionBreakpoint&&i.type==="function"){const f=s;f.enabled=i.enabled,f.condition=i.condition,f.hitCondition=i.hitCondition,f.logMessage=i.logMessage,f.functionName=i.functionName}else if(s instanceof w.SourceBreakpoint&&i.type==="source"){const f=s;f.enabled=i.enabled,f.condition=i.condition,f.hitCondition=i.hitCondition,f.logMessage=i.logMessage,f.location=new w.Location(M.URI.revive(i.uri),new w.Position(i.line,i.character))}b.push(s)}}}this.U(l,c,b)}$provideDebugConfigurations(r,l,c){return(0,n.asPromise)(async()=>{const b=this.O(r);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const i=await this.W(l);return b.provideDebugConfigurations(i,c)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(r,l,c,b){return(0,n.asPromise)(async()=>{const i=this.O(r);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const s=await this.W(l);return i.resolveDebugConfiguration(s,c,b)})}$resolveDebugConfigurationWithSubstitutedVariables(r,l,c,b){return(0,n.asPromise)(async()=>{const i=this.O(r);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const s=await this.W(l);return i.resolveDebugConfigurationWithSubstitutedVariables(s,c,b)})}async $provideDebugAdapter(r,l){const c=this.N(r);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.V(l);return this.R(c,b).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.L(i)})}async $acceptDebugSessionStarted(r){const l=await this.V(r);this.m.fire(l)}async $acceptDebugSessionTerminated(r){const l=await this.V(r);l&&(this.n.fire(l),this.l.delete(l.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,l){(await this.V(r))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(r,l){const b={session:await this.V(r),event:l.event,body:l.body};this.u.fire(b)}L(r){if(r instanceof w.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof w.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof w.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof w.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}M(r){const l=this.h.filter(c=>c.type===r);if(l.length>0)return l[0].factory}N(r){const l=this.h.filter(c=>c.handle===r);if(l.length>0)return l[0].factory}O(r){const l=this.f.filter(c=>c.handle===r);if(l.length>0)return l[0].provider}P(r,l){if(r.contributes){const c=r.contributes.debuggers;if(c&&c.length>0){for(const b of c)if(b.label&&b.type&&b.type===l)return!0}}return!1}Q(r){const c=r.configuration.type,b=this.j.filter(i=>i.type===c||i.type==="*").map(i=>(0,n.asPromise)(()=>i.factory.createDebugAdapterTracker(r)).then(s=>s,s=>null));return Promise.race([Promise.all(b).then(i=>{const s=i.filter(f=>!!f);if(s.length>0)return new L(s)}),new Promise(i=>setTimeout(()=>i(void 0),1e3))]).catch(i=>{})}async R(r,l){const c=l.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new w.DebugAdapterServer(c));if(r){const i=await this.E.getExtensionRegistry();return(0,n.asPromise)(()=>r.createDebugAdapterDescriptor(l,this.S(l,i))).then(s=>{if(s)return s})}const b=await this.E.getExtensionRegistry();return Promise.resolve(this.S(l,b))}S(r,l){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(r,l,c){(r.length>0||l.length>0||c.length>0)&&this.z.fire(Object.freeze({added:r,removed:l,changed:c}))}async V(r){if(r)if(typeof r=="string"){const l=this.l.get(r);if(l)return l}else{let l=this.l.get(r.id);if(!l){const c=await this.W(r.folderUri),b=r.parent?this.l.get(r.parent):void 0;l=new g(this.k,r.id,r.type,r.name,c,r.configuration,b),this.l.set(l.id,l),this.k.$sessionCached(l.id)}return l}throw new Error("cannot find session")}W(r){if(r){const l=M.URI.revive(r);return this.D.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};u=qe([Ve(0,N.IExtHostRpcService),Ve(1,h.IExtHostWorkspace),Ve(2,T.IExtHostExtensionService),Ve(3,a.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,o.IExtHostVariableResolverProvider)],u),e.ExtHostDebugServiceBase=u;class g{constructor(r,l,c,b,i,s,f){this.d=r,this.f=l,this.g=c,this.h=b,this.i=i,this.j=s,this.k=f}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,l){return this.d.$customDebugAdapterRequest(this.f,r,l)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=g;class E{constructor(r){this.value=Object.freeze({append(l){r.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=E;class L{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(l=>l.onError?l.onError(r):void 0)}onExit(r,l){this.d.forEach(c=>c.onExit?c.onExit(r,l):void 0)}}class p extends v.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let t=class extends u{constructor(r,l,c,b,i,s){super(r,l,c,b,i,s)}};t=qe([Ve(0,N.IExtHostRpcService),Ve(1,h.IExtHostWorkspace),Ve(2,T.IExtHostExtensionService),Ve(3,a.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,o.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(ke[249],Te([1,0,12,82,2,5,240,11,67,68,27,160,18,55,33,57]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class o{static async installEarlyHandler(E){const L=E.get(R.ILogService),t=E.get(h.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(d=>{L.error(d);const r=n.transformErrorForSerialization(d);t.$onUnexpectedError(r)})}static async installFullHandler(E){const L=E.get(R.ILogService),p=E.get(h.IExtHostRpcService),t=E.get(m.IExtHostExtensionService),d=E.get(a.IExtHostTelemetry),r=p.getProxy(M.MainContext.MainThreadExtensionService),l=p.getProxy(M.MainContext.MainThreadErrors),c=await t.getExtensionPathIndex(),b=new WeakMap;Error.prepareStackTrace=(i,s)=>{let f="",P,C;for(const j of s)f+=`
	at ${j.toString()}`,C=j.getFileName(),!P&&C&&(P=c.findSubstr(D.URI.file(C)));return b.set(i,P?.identifier),`${i.name||"Error"}: ${i.message||""}${f}`},n.setUnexpectedErrorHandler(i=>{L.error(i);const s=n.transformErrorForSerialization(i),f=b.get(i);if(!f){l.$onUnexpectedError(s);return}r.$onExtensionRuntimeError(f,s);const P=d.onExtensionError(f,i);L.trace("forwarded error to extension?",P,f)})}}Error.stackTraceLimit=100;class u{constructor(E,L,p,t,d){this.a=p,this.b=new y.RPCProtocol(E,null,t),L=u.e(L,this.b);const r=new T.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());r.set(N.IExtHostInitDataService,{_serviceBrand:void 0,...L,messagePorts:d}),r.set(h.IExtHostRpcService,new h.ExtHostRpcService(this.b)),r.set(v.IURITransformerService,new v.URITransformerService(t)),r.set(m.IHostUtils,p);const l=new w.InstantiationService(r,!0);l.invokeFunction(o.installEarlyHandler),this.d=l.invokeFunction(c=>c.get(R.ILogService)),k.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",L),this.c=l.invokeFunction(c=>c.get(m.IExtHostExtensionService)),this.c.initialize(),l.invokeFunction(o.installFullHandler)}async asBrowserUri(E){const L=this.b.getProxy(M.MainContext.MainThreadExtensionService);return D.URI.revive(await L.$asBrowserUri(E))}terminate(E){this.c.terminate(E)}static e(E,L){E.allExtensions.forEach(t=>{t.extensionLocation=D.URI.revive(L.transformIncomingURIs(t.extensionLocation));const d={};t.browserNlsBundleUris&&(Object.keys(t.browserNlsBundleUris).forEach(r=>d[r]=D.URI.revive(L.transformIncomingURIs(t.browserNlsBundleUris[r]))),t.browserNlsBundleUris=d)}),E.environment.appRoot=D.URI.revive(L.transformIncomingURIs(E.environment.appRoot));const p=E.environment.extensionDevelopmentLocationURI;return p&&(E.environment.extensionDevelopmentLocationURI=p.map(t=>D.URI.revive(L.transformIncomingURIs(t)))),E.environment.extensionTestsLocationURI=D.URI.revive(L.transformIncomingURIs(E.environment.extensionTestsLocationURI)),E.environment.globalStorageHome=D.URI.revive(L.transformIncomingURIs(E.environment.globalStorageHome)),E.environment.workspaceStorageHome=D.URI.revive(L.transformIncomingURIs(E.environment.workspaceStorageHome)),E.environment.extensionTelemetryLogResource=D.URI.revive(L.transformIncomingURIs(E.environment.extensionTelemetryLogResource)),E.nlsBaseUrl=D.URI.revive(L.transformIncomingURIs(E.nlsBaseUrl)),E.logsLocation=D.URI.revive(L.transformIncomingURIs(E.logsLocation)),E.logFile=D.URI.revive(L.transformIncomingURIs(E.logFile)),E.workspace=L.transformIncomingURIs(E.workspace),E}}e.ExtensionHostMain=u}),define(ke[250],Te([1,0,16,17,21,39,15,19,24,2,47]),function(te,e,n,k,D,M,y,R,S,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class w{constructor(g,E,L,p){this.d=g,this.e=E,this.f=L,this.g=p,this.a=null,this.b=!1,this.c=0}search(g,E){const L=this.d.folderQueries||[],p=new D.CancellationTokenSource;return E.onCancellationRequested(()=>p.cancel()),new Promise((t,d)=>{this.a=new v(g);let r=!1;const l=(c,b)=>{if(!r&&!this.b){const i=this.h(c);a(c)&&typeof this.d.maxResults=="number"&&this.c+i>this.d.maxResults&&(this.b=!0,r=!0,p.cancel(),c=this.j(c,this.d.maxResults-this.c));const s=this.h(c);this.c+=s,(s>0||!a(c))&&this.a.add(c,b)}};Promise.all(L.map((c,b)=>this.k(c,i=>l(i,b),p.token))).then(c=>{p.dispose(),this.a.flush();const b=c.some(i=>!!i&&!!i.limitHit);t({limitHit:this.b||b,messages:(0,n.flatten)(c.map(i=>i?.message?Array.isArray(i.message)?i.message:[i.message]:[])),stats:{type:this.g}})},c=>{p.dispose();const b=(0,M.toErrorMessage)(c);d(new Error(b))})})}h(g){return a(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}j(g,E){const L=Array.isArray(g.ranges)?g.ranges:[g.ranges],p=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:L.slice(0,E),preview:{matches:p.slice(0,E),text:g.preview.text},uri:g.uri}}async k(g,E,L){const p=new N.QueryGlobTester(this.d,g),t=[],d={report:c=>{if(!this.l(c))return;const b=g.folder.scheme===y.Schemas.file?(0,N.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(c.uri))):void 0,i=S.relativePath(g.folder,c.uri);if(i){const s=p.includedInQuery(i,R.basename(i),b);(0,k.isThenable)(s)?t.push(s.then(f=>{f&&E(c)})):s&&E(c)}}},r=this.n(g),l=await this.e.provideTextSearchResults(h(this.d.contentPattern),r,d,L);return t.length&&await Promise.all(t),l}l(g){if(a(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(g){const E=(0,N.resolvePatternsForProvider)(this.d.includePattern,g.includePattern),L=(0,N.resolvePatternsForProvider)(this.d.excludePattern,g.excludePattern),p={folder:T.URI.from(g.folder),excludes:L,includes:E,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.f.toCanonicalName(g.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.TextSearchManager=w;function h(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class v{constructor(g){this.e=g,this.b=-1,this.d=null,this.a=new o(512,E=>this.g(E))}add(g,E){this.d&&(this.b!==E||!S.isEqual(this.c,g.uri))&&(this.f(),this.d=null),this.d||(this.b=E,this.d={resource:g.uri,results:[]}),this.d.results.push(m(g))}f(){const g=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,g)}flush(){this.f(),this.a.flush()}g(g){this.e(g)}}e.TextSearchResultsCollector=v;function m(u){return a(u)?{preview:{matches:(0,n.mapArrayOrNot)(u.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:u.preview.text},ranges:(0,n.mapArrayOrNot)(u.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function a(u){return!!u.preview}e.extensionResultIsMatch=a;class o{constructor(g,E){this.g=g,this.h=E,this.c=0,this.d=[],this.e=0}addItem(g,E){!g||this.j(g,E)}addItems(g,E){!g||this.k(g,E)}j(g,E){this.d.push(g),this.e+=E,this.l()}k(g,E){this.d=this.d.concat(g),this.e+=E,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}o.a=4e3,o.b=50,e.BatchedCollector=o}),define(ke[110],Te([1,0,6,5,3,245,18,55,11,2,250]),function(te,e,n,k,D,M,y,R,S,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let w=class{constructor(a,o,u){this.k=a,this.l=o,this.n=u,this.c=this.k.getProxy(k.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.FileSearchManager}o(a){return this.l.transformOutgoingScheme(a)}registerTextSearchProvider(a,o){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const u=this.d++;return this.e.set(u,o),this.c.$registerTextSearchProvider(u,this.o(a)),(0,n.toDisposable)(()=>{this.g.delete(a),this.e.delete(u),this.c.$unregisterProvider(u)})}registerFileSearchProvider(a,o){if(this.i.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.i.add(a);const u=this.d++;return this.h.set(u,o),this.c.$registerFileSearchProvider(u,this.o(a)),(0,n.toDisposable)(()=>{this.i.delete(a),this.h.delete(u),this.c.$unregisterProvider(u)})}$provideFileSearchResults(a,o,u,g){const E=h(u),L=this.h.get(a);if(L)return this.j.fileSearch(E,L,p=>{this.c.$handleFileMatch(a,o,p.map(t=>t.resource))},g);throw new Error("unknown provider: "+a)}$clearCache(a){return this.j.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,o,u,g){const E=this.e.get(a);if(!E||!E.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const L=h(u);return this.q(L,E).search(t=>this.c.$handleTextMatch(a,o,t),g)}$enableExtensionHostSearch(){}q(a,o){return new N.TextSearchManager(a,o,{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}};w=qe([Ve(0,y.IExtHostRpcService),Ve(1,R.IURITransformerService),Ve(2,S.ILogService)],w),e.ExtHostSearch=w;function h(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(v),extraFileResources:m.extraFileResources&&m.extraFileResources.map(a=>T.URI.revive(a))}}e.reviveQuery=h;function v(m){return{...m,folder:T.URI.revive(m.folder)}}}),define(ke[251],Te([1,0,67,105,31,103,32,37,58,61,107,109,110,80,70,76,104,60,36,79,57,59,220,11,176,108,78]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o,u,g,E,L,p,t,d,r,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,n.registerSingleton)(d.ILoggerService,t.ExtHostLoggerService,1),(0,n.registerSingleton)(d.ILogService,r.ExtHostLogService,1),(0,n.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService,1),(0,n.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,0),(0,n.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration,0),(0,n.registerSingleton)(u.IExtHostConsumerFileSystem,u.ExtHostConsumerFileSystem,0),(0,n.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService,0),(0,n.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,n.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,n.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,0),(0,n.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService,1),(0,n.registerSingleton)(h.IExtHostSearch,h.ExtHostSearch,0),(0,n.registerSingleton)(v.IExtHostStorage,v.ExtHostStorage,0),(0,n.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask,0),(0,n.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService,0),(0,n.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService,0),(0,n.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,n.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,0),(0,n.registerSingleton)(E.IExtHostSecretState,E.ExtHostSecretState,0),(0,n.registerSingleton)(L.IExtHostTelemetry,L.ExtHostTelemetry,0),(0,n.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,n.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,0)}),define(ke[252],Te([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class n{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(D){if(D&&this.a.has(D)){const M=this.a.get(D);return this.a.delete(D),M}}addDragOperationTransfer(D,M){this.a.set(D,M)}getRenderedTreeElement(D){if(this.b.has(D))return this.b.get(D)}addRenderedTreeItemElement(D,M){this.b.set(D,M)}removeRenderedTreeItemElement(D){this.b.has(D)&&this.b.delete(D)}}e.TreeviewsService=n}),define(ke[253],Te([1,0,145,7,24,2,4,6,181,17,7,9,16,8,21,252,25]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(L,p){if((0,w.isString)(L))return{label:L};if(L&&typeof L=="object"&&typeof L.label=="string"){let t;return Array.isArray(L.highlights)&&(t=L.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),t=t.length?t:void 0),{label:L.label,highlights:t}}}class g{constructor(p,t,d){this.d=p,this.e=t,this.f=d,this.a=new Map,this.b=new a.TreeviewsService;function r(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>r(l)?this.i(l):Array.isArray(l)&&l.length>0?l.map(c=>r(c)?this.i(c):c):l})}registerTreeDataProvider(p,t,d){const r=this.createTreeView(p,{treeDataProvider:t},d);return{dispose:()=>r.dispose()}}createTreeView(p,t,d){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,b=!!t.dragAndDropController?.handleDrop,i=this.h(p,t,d),s=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:l,hasHandleDrag:c,hasHandleDrop:b});return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,o.checkProposedApiEnabled)(d,"treeItemCheckbox"),i.onDidChangeCheckboxState},get message(){return i.message},set message(f){i.message=f},get title(){return i.title},set title(f){i.title=f},get description(){return i.description},set description(f){i.description=f},get badge(){return i.badge},set badge(f){f!==void 0&&N.ViewBadge.isViewBadge(f)?i.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(i.badge=void 0)},reveal:(f,P)=>i.reveal(f,P),dispose:async()=>{await s,this.a.delete(p),i.dispose()}}}$getChildren(p,t){const d=this.a.get(p);return d?d.getChildren(t):Promise.reject(new S.NoTreeViewError(p))}async $handleDrop(p,t,d,r,l,c,b,i){const s=this.a.get(p);if(!s)return Promise.reject(new S.NoTreeViewError(p));const f=v.DataTransfer.toDataTransfer(d,async P=>(await this.d.$resolveDropFileData(p,t,P)).buffer);return b===p&&i&&await this.g(f,s,i,l,c),s.onDrop(f,r,l)}async g(p,t,d,r,l){const c=this.b.removeDragOperationTransfer(l);if(c)(await c)?.forEach((b,i)=>{b&&p.set(i,b)});else if(l&&t.handleDrag){const b=t.handleDrag(d,p,r);this.b.addDragOperationTransfer(l,b),await b}return p}async $handleDrag(p,t,d,r){const l=this.a.get(p);if(!l)return Promise.reject(new S.NoTreeViewError(p));const c=await this.g(new k.DataTransfer,l,t,r,d);if(!!c)return v.DataTransfer.toDataTransferDTO(c)}async $hasResolve(p){const t=this.a.get(p);if(!t)throw new S.NoTreeViewError(p);return t.hasResolve}$resolve(p,t,d){const r=this.a.get(p);if(!r)throw new S.NoTreeViewError(p);return r.resolveTreeItem(t,d)}$setExpanded(p,t,d){const r=this.a.get(p);if(!r)throw new S.NoTreeViewError(p);r.setExpanded(t,d)}$setSelection(p,t){const d=this.a.get(p);if(!d)throw new S.NoTreeViewError(p);d.setSelection(t)}$setFocus(p,t){const d=this.a.get(p);if(!d)throw new S.NoTreeViewError(p);d.setFocus(t)}$setVisible(p,t){const d=this.a.get(p);if(!d)throw new S.NoTreeViewError(p);d.setVisible(t)}$changeCheckboxState(p,t){const d=this.a.get(p);if(!d)throw new S.NoTreeViewError(p);d.setCheckboxState(t)}h(p,t,d){const r=new E(p,t,this.d,this.e.converter,this.f,d);return this.a.set(p,r),r}i(p){const t=this.a.get(p.$treeViewId);return t&&"$treeItemHandle"in p?t.getExtensionElement(p.$treeItemHandle):t&&"$focusedTreeItem"in p&&p.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=g;class E extends R.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,w.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,t,d,r,l,c){if(super(),this.C=p,this.D=d,this.F=r,this.G=l,this.H=c,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new y.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new y.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new y.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new y.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new y.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new y.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new m.CancellationTokenSource,c.contributes&&c.contributes.views)for(const s in c.contributes.views)for(const f of c.contributes.views[s])f.id===p&&(this.J=f.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(s=>this.w.fire({message:!1,element:s})));let b,i;this.B(y.Event.debounce(this.w.event,(s,f)=>(s||(s={message:!1,elements:[]}),f.element!==!1&&(b||(b=new Promise(P=>i=P),this.y=this.y.then(()=>b)),Array.isArray(f.element)?s.elements.push(...f.element):s.elements.push(f.element)),f.message&&(s.message=!0),s),200,!0)(({message:s,elements:f})=>{f.length&&(this.z=this.z.then(()=>{const P=i;return b=null,this.U(f).then(()=>P())})),s&&this.D.$setMessage(this.C,this.I)}))}async getChildren(p){const t=p?this.getExtensionElement(p):void 0;if(p&&!t)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let d=this.Q(p);return d||(d=await this.R(t)),d?d.map(r=>r.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,t){t=t||{select:!0,focus:!1};const d=(0,w.isUndefinedOrNull)(t.select)?!0:t.select,r=(0,w.isUndefinedOrNull)(t.focus)?!1:t.focus,l=(0,w.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.y.then(()=>this.N(p)).then(c=>this.P(p,c[c.length-1]).then(b=>this.D.$reveal(this.C,{item:b.item,parentChain:c.map(i=>i.item)},{select:d,focus:r,expand:l})),c=>this.G.error(c)):this.D.$reveal(this.C,void 0,{select:d,focus:r,expand:l})}get message(){return this.I}set message(p){this.I=p,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.D.$setTitle(this.C,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.D.$setTitle(this.C,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=v.ViewBadge.from(p),this.D.$setBadge(this.C,p))}setExpanded(p,t){const d=this.getExtensionElement(p);d&&(t?this.r.fire(Object.freeze({element:d})):this.s.fire(Object.freeze({element:d})))}setSelection(p){(0,h.equals)(this.l,p)||(this.l=p,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const t=(await Promise.all(p.map(async d=>{const r=this.getExtensionElement(d.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:d.newState?N.TreeItemCheckboxState.Checked:N.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);t.forEach(d=>{d.treeItem.checkboxState=d.newState?N.TreeItemCheckboxState.Checked:N.TreeItemCheckboxState.Unchecked}),this.v.fire({items:t.map(d=>[d.extensionItem,d.newState])})}async handleDrag(p,t,d){const r=[];for(const l of p){const c=this.getExtensionElement(l);c&&r.push(c)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,d),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,t,d){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,T.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,p,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,t){if(!this.f.resolveTreeItem)return;const d=this.i.get(p);if(d){const r=this.j.get(d);if(r){const l=await this.f.resolveTreeItem(r.extensionItem,d,t)??r.extensionItem;return this.db(l),r.item.tooltip=this.ab(l.tooltip),r.item.command=this.bb(r.disposableStore,l.command),r.item}}}N(p){return this.O(p).then(t=>t?this.N(t).then(d=>this.P(t,d[d.length-1]).then(r=>(d.push(r),d))):Promise.resolve([]))}O(p){const t=this.j.get(p);return t?Promise.resolve(t.parent?this.i.get(t.parent.item.handle):void 0):(0,T.asPromise)(()=>this.f.getParent(p))}P(p,t){const d=this.j.get(p);return d?Promise.resolve(d):(0,T.asPromise)(()=>this.f.getTreeItem(p)).then(r=>this.gb(p,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(r);if(l){const c=this.j.get(l);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(p){if(p){let t;if(typeof p=="string"){const d=this.getExtensionElement(p);t=d?this.j.get(d):void 0}else t=p;return t&&t.children||void 0}return this.h}async R(p){this.nb(p);const t=new m.CancellationTokenSource(this.S.token);try{const d=p?this.j.get(p):void 0,r=await this.f.getChildren(p);if(t.token.isCancellationRequested)return;const l=await Promise.all((0,h.coalesce)(r||[]).map(async c=>{const b=await this.f.getTreeItem(c);return b&&!t.token.isCancellationRequested?this.Z(c,b,d):null}));return t.token.isCancellationRequested?void 0:(0,h.coalesce)(l)}finally{t.dispose()}}U(p){if(p.some(d=>!d))return this.S.dispose(!0),this.S=new m.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const d=this.W(p);if(d.length)return this.X(d)}return Promise.resolve(void 0)}W(p){const t=new Set,d=p.map(l=>this.j.get(l));for(const l of d)if(l&&!t.has(l.item.handle)){let c=l;for(;c&&c.parent&&d.findIndex(b=>c&&c.parent&&b&&b.item.handle===c.parent.item.handle)===-1;){const b=this.i.get(c.parent.item.handle);c=b?this.j.get(b):void 0}c&&!c.parent&&t.add(l.item.handle)}const r=[];return t.forEach(l=>{const c=this.i.get(l);if(c){const b=this.j.get(c);b&&(!b.parent||!t.has(b.parent.item.handle))&&r.push(l)}}),r}X(p){const t={};return Promise.all(p.map(d=>this.Y(d).then(r=>{r&&(t[d]=r.item)}))).then(()=>Object.keys(t).length?this.D.$refresh(this.C,t):void 0)}Y(p){const t=this.getExtensionElement(p);if(t){const d=this.j.get(t);if(d)return this.nb(t),(0,T.asPromise)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const l=this.eb(t,r,d.parent);return this.lb(t,l,d,d.parent),d.dispose(),l}return null})}return Promise.resolve(null)}Z(p,t,d){const r=this.eb(p,t,d);if(t.id&&this.i.has(r.item.handle))throw new Error((0,n.localize)(0,null,t.id));return this.kb(p,r),this.mb(r,d),r}ab(p){return N.MarkdownString.isMarkdownString(p)?v.MarkdownString.from(p):p}bb(p,t){return t?{...this.F.toInternal(t,p),originalId:t.command}:void 0}cb(p){if(!p.checkboxState)return;let t,d;return typeof p.checkboxState=="number"?t=p.checkboxState:(t=p.checkboxState.state,d=p.checkboxState.tooltip),{isChecked:t===N.TreeItemCheckboxState.Checked,tooltip:d}}db(p){if(!N.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,t,d){this.db(t);const r=new R.DisposableStore,l=this.gb(p,t,d),c=this.hb(t);return{item:{handle:l,parentHandle:d?d.item.handle:void 0,label:u(t.label,this.H),description:t.description,resourceUri:t.resourceUri,tooltip:this.ab(t.tooltip),command:this.bb(r,t.command),contextValue:t.contextValue,icon:c,iconDark:this.ib(t)||c,themeIcon:this.fb(t),collapsibleState:(0,w.isUndefinedOrNull)(t.collapsibleState)?N.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.cb(t)},extensionItem:t,parent:d,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(p){return p.iconPath instanceof N.ThemeIcon?p.iconPath:void 0}gb(p,{id:t,label:d,resourceUri:r},l,c){if(t)return`${E.b}/${t}`;const b=u(d,this.H),i=l?l.item.handle:E.a;let s=b?b.label:r?(0,D.basename)(r):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const f=this.j.has(p)?this.j.get(p).item.handle:void 0,P=this.Q(l)||[];let C,j=0;do{if(C=`${i}/${j}:${s}`,c||!this.i.has(C)||f===C)break;j++}while(j<=P.length);return C}hb(p){if(p.iconPath&&!(p.iconPath instanceof N.ThemeIcon))return typeof p.iconPath=="string"||M.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof N.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return M.URI.isUri(p)?p:M.URI.file(p)}kb(p,t){this.i.set(t.item.handle,p),this.j.set(p,t)}lb(p,t,d,r){this.i.delete(t.item.handle),this.j.delete(p),t.item.handle!==d.item.handle&&this.i.delete(d.item.handle),this.kb(p,t);const l=this.Q(r)||[],c=l.filter(b=>b.item.handle===d.item.handle)[0];c&&l.splice(l.indexOf(c),1,t)}mb(p,t){t?(t.children||(t.children=[]),t.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const t=this.j.get(p);if(t){if(t.children)for(const d of t.children){const r=this.i.get(d.item.handle);r&&this.ob(r)}t.children=void 0}}else this.pb()}ob(p){const t=this.j.get(p);if(t){if(t.children)for(const d of t.children){const r=this.i.get(d.item.handle);r&&this.ob(r)}this.j.delete(p),this.i.delete(t.item.handle),t.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}E.a="0",E.b="1"}),define(ke[254],Te([1,0,21,12,4,29,2,130,263,118,128,43,5,74,207,206,37,208,32,210,211,212,195,213,58,33,214,215,218,219,221,105,198,227,228,229,80,61,232,253,8,7,52,235,62,104,31,187,217,50,103,107,109,110,11,55,18,27,222,193,70,76,204,233,81,60,238,236,237,205,36,230,234,79,59,57,223,106,224,15,92,197,178,216,6,25,183,78,174,225,226]),function(te,e,n,k,D,M,y,R,S,T,N,w,h,v,m,a,o,u,g,E,L,p,t,d,r,l,c,b,i,s,f,P,C,j,_,K,A,$,O,F,H,V,ae,pe,re,ce,ue,Se,G,X,J,de,ye,Fe,ze,Pe,Ie,we,se,le,Z,I,B,W,q,ee,fe,De,oe,ve,be,He,je,it,Xe,et,nt,Ne,rt,Q,Y,ge,We,$e,Qe,Ke,tt,at,Et,Ct,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Dt(ut){const ft=ut.get(we.IExtHostInitDataService),Kt=ut.get(be.IExtHostFileSystemInfo),Vt=ut.get(ee.IExtHostConsumerFileSystem),kt=ut.get(l.IExtHostExtensionService),ht=ut.get(ue.IExtHostWorkspace),Tt=ut.get(et.IExtHostTelemetry),$t=ut.get(g.IExtHostConfiguration),At=ut.get(Pe.IURITransformerService),Ge=ut.get(Ie.IExtHostRpcService),Ft=ut.get(A.IExtHostStorage),xt=ut.get(q.IExtensionStoragePaths),Nt=ut.get(ze.ILoggerService),mt=ut.get(ze.ILogService),Ce=ut.get(Z.IExtHostTunnelService),Ae=ut.get(I.IExtHostApiDeprecationService),me=ut.get(ce.IExtHostWindow),x=ut.get(it.IExtHostSecretState),Re=ut.get(Xe.IExtHostEditorTabs);Ge.set(h.ExtHostContext.ExtHostFileSystemInfo,Kt),Ge.set(h.ExtHostContext.ExtHostLogLevelServiceShape,Nt),Ge.set(h.ExtHostContext.ExtHostWorkspace,ht),Ge.set(h.ExtHostContext.ExtHostConfiguration,$t),Ge.set(h.ExtHostContext.ExtHostExtensionService,kt),Ge.set(h.ExtHostContext.ExtHostStorage,Ft),Ge.set(h.ExtHostContext.ExtHostTunnelService,Ce),Ge.set(h.ExtHostContext.ExtHostWindow,me),Ge.set(h.ExtHostContext.ExtHostSecretState,x),Ge.set(h.ExtHostContext.ExtHostTelemetry,Tt),Ge.set(h.ExtHostContext.ExtHostEditorTabs,Re);const Ue=Ge.set(h.ExtHostContext.ExtHostDecorations,ut.get(J.IExtHostDecorations)),Ye=Ge.set(h.ExtHostContext.ExtHostDocumentsAndEditors,ut.get(r.IExtHostDocumentsAndEditors)),Be=Ge.set(h.ExtHostContext.ExtHostCommands,ut.get(o.IExtHostCommands)),Ze=Ge.set(h.ExtHostContext.ExtHostTerminalService,ut.get($.IExtHostTerminalService)),ct=Ge.set(h.ExtHostContext.ExtHostDebugService,ut.get(ye.IExtHostDebugService)),Pt=Ge.set(h.ExtHostContext.ExtHostSearch,ut.get(Fe.IExtHostSearch)),vt=Ge.set(h.ExtHostContext.ExtHostTask,ut.get(de.IExtHostTask)),wt=Ge.set(h.ExtHostContext.ExtHostOutputService,ut.get(P.IExtHostOutputService)),pt=Ge.set(h.ExtHostContext.ExtHostLocalization,ut.get(at.IExtHostLocalizationService)),Rt=Ge.set(h.ExtHostContext.ExtHostUrls,new pe.ExtHostUrls(Ge)),bt=Ge.set(h.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Ge,Ye)),ri=Ge.set(h.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Ge,Ye,mt)),ei=Ge.set(h.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(mt,bt,Ge.getProxy(h.MainContext.MainThreadBulkEdits))),St=Ge.set(h.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(Ge,Be,Ye,bt)),si=Ge.set(h.ExtHostContext.ExtHostNotebookDocuments,new We.ExtHostNotebookDocuments(St)),oi=Ge.set(h.ExtHostContext.ExtHostNotebookEditors,new ge.ExtHostNotebookEditors(mt,St)),_t=Ge.set(h.ExtHostContext.ExtHostNotebookKernels,new nt.ExtHostNotebookKernels(Ge,ft,St,Be,mt)),vi=Ge.set(h.ExtHostContext.ExtHostNotebookRenderers,new rt.ExtHostNotebookRenderers(Ge,St)),Ot=Ge.set(h.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(Ge,Ye)),zt=Ge.set(h.ExtHostContext.ExtHostTreeViews,new F.ExtHostTreeViews(Ge.getProxy(h.MainContext.MainThreadTreeViews),Be,mt)),bi=Ge.set(h.ExtHostContext.ExtHostEditorInsets,new Se.ExtHostEditorInsets(Ge.getProxy(h.MainContext.MainThreadEditorInsets),Ot,ft.remote)),ai=Ge.set(h.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Ge,mt,Kt,Ye)),Jt=Ge.set(h.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(Ge,bt,Be.converter,At)),lt=Ge.set(h.ExtHostContext.ExtHostLanguageFeatures,new i.ExtHostLanguageFeatures(Ge,At,bt,Be,ai,mt,Ae,Tt)),$i=Ge.set(h.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Ge,lt)),Ut=Ge.set(h.ExtHostContext.ExtHostFileSystemEventService,new b.ExtHostFileSystemEventService(Ge,mt,Ye)),Xt=Ge.set(h.ExtHostContext.ExtHostQuickOpen,(0,j.createExtHostQuickOpen)(Ge,ht,Be)),ci=Ge.set(h.ExtHostContext.ExtHostSCM,new _.ExtHostSCM(Ge,Be,mt)),Ei=Ge.set(h.ExtHostContext.ExtHostQuickDiff,new It.ExtHostQuickDiff(Ge,At)),wi=Ge.set(h.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(Ge,Be,bt)),ui=Ge.set(h.ExtHostContext.ExtHostProgress,new C.ExtHostProgress(Ge.getProxy(h.MainContext.MainThreadProgress))),Si=Ge.set(h.ExtHostContext.ExtHosLabelService,new G.ExtHostLabelService(Ge)),li=Ge.set(h.ExtHostContext.ExtHostTheming,new le.ExtHostTheming(Ge)),Zt=Ge.set(h.ExtHostContext.ExtHostAuthentication,new B.ExtHostAuthentication(Ge)),Bi=Ge.set(h.ExtHostContext.ExtHostTimeline,new W.ExtHostTimeline(Ge,Be)),ti=Ge.set(h.ExtHostContext.ExtHostWebviews,new re.ExtHostWebviews(Ge,ft.remote,ht,mt,Ae)),ii=Ge.set(h.ExtHostContext.ExtHostWebviewPanels,new oe.ExtHostWebviewPanels(Ge,ti,ht)),yi=Ge.set(h.ExtHostContext.ExtHostCustomEditors,new De.ExtHostCustomEditors(Ge,bt,xt,ti,ii)),Di=Ge.set(h.ExtHostContext.ExtHostWebviewViews,new fe.ExtHostWebviewViews(Ge,ti)),ni=Ge.set(h.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(Ge,Be,Ye)),Ii=Ge.set(h.ExtHostContext.ExtHostUriOpeners,new je.ExtHostUriOpeners(Ge)),Ci=Ge.set(h.ExtHostContext.ExtHostProfileContentHandlers,new Ct.ExtHostProfileContentHandlers(Ge));Ge.set(h.ExtHostContext.ExtHostInteractive,new $e.ExtHostInteractive(Ge,St,Ye,Be,mt));const zi=Object.values(h.ExtHostContext);Ge.assertRegistered(zi);const Wi=new ve.ExtHostBulkEdits(Ge,Ye),Hi=new a.ExtHostClipboard(Ge),ki=new f.ExtHostMessageService(Ge,mt),Ri=new L.ExtHostDialogs(Ge),Oi=new K.ExtHostStatusBar(Ge,Be.converter);return m.ExtHostApiCommands.register(Be),function(Me,Wt,Li){const gt=function(){let ne=!Me.isUnderDevelopment;function he(){ne||(mt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")he();else{const yt=st;typeof yt.scheme>"u"&&he(),typeof yt.exclusive=="boolean"&&(0,Ke.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return st}}(),Vi={getSession(ne,he,Oe){return Zt.getSession(Me,ne,he,Oe)},async hasSession(ne,he){return(0,Ke.checkProposedApiEnabled)(Me,"authSession"),!!await Zt.getSession(Me,ne,he,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(ne,he,Oe,st){return Zt.registerAuthenticationProvider(ne,he,Oe,st)}},di={registerCommand(ne,he,Oe){return Be.registerCommand(!0,ne,he,Oe,void 0,Me)},registerTextEditorCommand(ne,he,Oe){return Be.registerCommand(!0,ne,(...st)=>{const yt=Ot.getActiveTextEditor();if(!yt){mt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return yt.edit(Lt=>{he.apply(Oe,[yt,Lt,...st])}).then(Lt=>{Lt||mt.warn("Edits from command "+ne+" were not applied.")},Lt=>{mt.warn("An error occurred while running command "+ne,Lt)})},void 0,void 0,Me)},registerDiffInformationCommand:(ne,he,Oe)=>((0,Ke.checkProposedApiEnabled)(Me,"diffCommand"),Be.registerCommand(!0,ne,async(...st)=>{const yt=Ye.activeEditor(!0);if(!yt){mt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Lt=await Ot.getDiffInformation(yt.id);he.apply(Oe,[Lt,...st])},void 0,void 0,Me)),executeCommand(ne,...he){return Be.executeCommand(ne,...he)},getCommands(ne=!1){return Be.getCommands(ne)}},Fi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return Ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ke.checkProposedApiEnabled)(Me,"envShellEvent"),Ze.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ke.checkProposedApiEnabled)(Me,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ke.checkProposedApiEnabled)(Me,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return et.ExtHostTelemetryLogger.validateSender(ne),Tt.instantiateLogger(Me,ne)},openExternal(ne,he){return me.openUri(ne,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===ft.environment.appUriScheme)return Rt.createAppUri(ne);try{return await me.asExternalUri(ne,{allowTunneling:!!ft.remote.authority})}catch(he){if((0,Y.matchesScheme)(ne,Q.Schemas.http)||(0,Y.matchesScheme)(ne,Q.Schemas.https))return ne;throw he}},get remoteName(){return(0,X.getRemoteName)(ft.remote.authority)},get remoteAuthority(){return(0,Ke.checkProposedApiEnabled)(Me,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return mt.onDidChangeLogLevel}};ft.environment.extensionTestsLocationURI||Object.freeze(Fi);const ji={createTestController(ne,he,Oe){return ni.createTestController(Me,ne,he,Oe)},createTestObserver(){return(0,Ke.checkProposedApiEnabled)(Me,"testObserver"),ni.createTestObserver()},runTests(ne){return(0,Ke.checkProposedApiEnabled)(Me,"testObserver"),ni.runTests(ne)},get onDidChangeTestResults(){return(0,Ke.checkProposedApiEnabled)(Me,"testObserver"),ni.onResultsChanged},get testResults(){return(0,Ke.checkProposedApiEnabled)(Me,"testObserver"),ni.results}},hi=ft.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,qi={getExtension(ne,he){(0,Ke.isProposedApiEnabled)(Me,"extensionsAny")||(he=!1);const Oe=Wt.mine.getExtensionDescription(ne);if(Oe)return new l.Extension(kt,Me.identifier,Oe,hi,!1);if(he){const st=Wt.all.getExtensionDescription(ne);if(st)return new l.Extension(kt,Me.identifier,st,hi,!0)}},get all(){const ne=[];for(const he of Wt.mine.getAllExtensionDescriptions())ne.push(new l.Extension(kt,Me.identifier,he,hi,!1));return ne},get allAcrossExtensionHosts(){(0,Ke.checkProposedApiEnabled)(Me,"extensionsAny");const ne=new Ke.ExtensionIdentifierSet(Wt.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),he=[];for(const Oe of Wt.all.getAllExtensionDescriptions()){const st=!ne.has(Oe.identifier);he.push(new l.Extension(kt,Me.identifier,Oe,hi,st))}return he},get onDidChange(){return(0,Ke.isProposedApiEnabled)(Me,"extensionsAny")?D.Event.any(Wt.mine.onDidChange,Wt.all.onDidChange):Wt.mine.onDidChange}},Ti={createDiagnosticCollection(ne){return ai.createDiagnosticCollection(Me.identifier,ne)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ne=>ai.getDiagnostics(ne),getLanguages(){return Jt.getLanguages()},setTextDocumentLanguage(ne,he){return Jt.changeLanguage(ne.uri,he)},match(ne,he){const Oe=bt.getDocumentData(he.uri)?.notebook;return(0,N.score)(H.LanguageSelector.from(ne),he.uri,he.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ne,he,Oe){return lt.registerCodeActionProvider(Me,gt(ne),he,Oe)},registerDocumentPasteEditProvider(ne,he,Oe){return(0,Ke.checkProposedApiEnabled)(Me,"documentPaste"),lt.registerDocumentPasteEditProvider(Me,gt(ne),he,Oe)},registerCodeLensProvider(ne,he){return lt.registerCodeLensProvider(Me,gt(ne),he)},registerDefinitionProvider(ne,he){return lt.registerDefinitionProvider(Me,gt(ne),he)},registerDeclarationProvider(ne,he){return lt.registerDeclarationProvider(Me,gt(ne),he)},registerImplementationProvider(ne,he){return lt.registerImplementationProvider(Me,gt(ne),he)},registerTypeDefinitionProvider(ne,he){return lt.registerTypeDefinitionProvider(Me,gt(ne),he)},registerHoverProvider(ne,he){return lt.registerHoverProvider(Me,gt(ne),he,Me.identifier)},registerEvaluatableExpressionProvider(ne,he){return lt.registerEvaluatableExpressionProvider(Me,gt(ne),he,Me.identifier)},registerInlineValuesProvider(ne,he){return lt.registerInlineValuesProvider(Me,gt(ne),he,Me.identifier)},registerDocumentHighlightProvider(ne,he){return lt.registerDocumentHighlightProvider(Me,gt(ne),he)},registerLinkedEditingRangeProvider(ne,he){return lt.registerLinkedEditingRangeProvider(Me,gt(ne),he)},registerReferenceProvider(ne,he){return lt.registerReferenceProvider(Me,gt(ne),he)},registerRenameProvider(ne,he){return lt.registerRenameProvider(Me,gt(ne),he)},registerDocumentSymbolProvider(ne,he,Oe){return lt.registerDocumentSymbolProvider(Me,gt(ne),he,Oe)},registerWorkspaceSymbolProvider(ne){return lt.registerWorkspaceSymbolProvider(Me,ne)},registerDocumentFormattingEditProvider(ne,he){return lt.registerDocumentFormattingEditProvider(Me,gt(ne),he)},registerDocumentRangeFormattingEditProvider(ne,he){return lt.registerDocumentRangeFormattingEditProvider(Me,gt(ne),he)},registerOnTypeFormattingEditProvider(ne,he,Oe,...st){return lt.registerOnTypeFormattingEditProvider(Me,gt(ne),he,[Oe].concat(st))},registerDocumentSemanticTokensProvider(ne,he,Oe){return lt.registerDocumentSemanticTokensProvider(Me,gt(ne),he,Oe)},registerDocumentRangeSemanticTokensProvider(ne,he,Oe){return lt.registerDocumentRangeSemanticTokensProvider(Me,gt(ne),he,Oe)},registerSignatureHelpProvider(ne,he,Oe,...st){return typeof Oe=="object"?lt.registerSignatureHelpProvider(Me,gt(ne),he,Oe):lt.registerSignatureHelpProvider(Me,gt(ne),he,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(ne,he,...Oe){return lt.registerCompletionItemProvider(Me,gt(ne),he,Oe)},registerInlineCompletionItemProvider(ne,he){return he.handleDidShowCompletionItem&&(0,Ke.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,Ke.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Me,gt(ne),he)},registerDocumentLinkProvider(ne,he){return lt.registerDocumentLinkProvider(Me,gt(ne),he)},registerColorProvider(ne,he){return lt.registerColorProvider(Me,gt(ne),he)},registerFoldingRangeProvider(ne,he){return lt.registerFoldingRangeProvider(Me,gt(ne),he)},registerSelectionRangeProvider(ne,he){return lt.registerSelectionRangeProvider(Me,ne,he)},registerCallHierarchyProvider(ne,he){return lt.registerCallHierarchyProvider(Me,ne,he)},registerTypeHierarchyProvider(ne,he){return lt.registerTypeHierarchyProvider(Me,ne,he)},setLanguageConfiguration:(ne,he)=>lt.setLanguageConfiguration(Me,ne,he),getTokenInformationAtPosition(ne,he){return(0,Ke.checkProposedApiEnabled)(Me,"tokenInformation"),Jt.tokenAtPosition(ne,he)},registerInlayHintsProvider(ne,he){return lt.registerInlayHintsProvider(Me,ne,he)},createLanguageStatusItem(ne,he){return Jt.createLanguageStatusItem(Me,ne,he)},registerDocumentDropEditProvider(ne,he){return lt.registerDocumentOnDropEditProvider(Me,ne,he)}},Ki={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return Ze.activeTerminal},get terminals(){return Ze.terminals},async showTextDocument(ne,he,Oe){const st=await(y.URI.isUri(ne)?Promise.resolve(jt.openTextDocument(ne)):Promise.resolve(ne));return Ot.showTextDocument(st,he,Oe)},createTextEditorDecorationType(ne){return Ot.createTextEditorDecorationType(Me,ne)},onDidChangeActiveTextEditor(ne,he,Oe){return Ot.onDidChangeActiveTextEditor(ne,he,Oe)},onDidChangeVisibleTextEditors(ne,he,Oe){return Ot.onDidChangeVisibleTextEditors(ne,he,Oe)},onDidChangeTextEditorSelection(ne,he,Oe){return Ot.onDidChangeTextEditorSelection(ne,he,Oe)},onDidChangeTextEditorOptions(ne,he,Oe){return Ot.onDidChangeTextEditorOptions(ne,he,Oe)},onDidChangeTextEditorVisibleRanges(ne,he,Oe){return Ot.onDidChangeTextEditorVisibleRanges(ne,he,Oe)},onDidChangeTextEditorViewColumn(ne,he,Oe){return Ot.onDidChangeTextEditorViewColumn(ne,he,Oe)},onDidCloseTerminal(ne,he,Oe){return Ze.onDidCloseTerminal(ne,he,Oe)},onDidOpenTerminal(ne,he,Oe){return Ze.onDidOpenTerminal(ne,he,Oe)},onDidChangeActiveTerminal(ne,he,Oe){return Ze.onDidChangeActiveTerminal(ne,he,Oe)},onDidChangeTerminalDimensions(ne,he,Oe){return(0,Ke.checkProposedApiEnabled)(Me,"terminalDimensions"),Ze.onDidChangeTerminalDimensions(ne,he,Oe)},onDidChangeTerminalState(ne,he,Oe){return Ze.onDidChangeTerminalState(ne,he,Oe)},onDidWriteTerminalData(ne,he,Oe){return(0,Ke.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),Ze.onDidWriteTerminalData(ne,he,Oe)},get state(){return me.state},onDidChangeWindowState(ne,he,Oe){return me.onDidChangeWindowState(ne,he,Oe)},showInformationMessage(ne,...he){return ki.showMessage(Me,M.default.Info,ne,he[0],he.slice(1))},showWarningMessage(ne,...he){return ki.showMessage(Me,M.default.Warning,ne,he[0],he.slice(1))},showErrorMessage(ne,...he){return ki.showMessage(Me,M.default.Error,ne,he[0],he.slice(1))},showQuickPick(ne,he,Oe){return Xt.showQuickPick(Me,ne,he,Oe)},showWorkspaceFolderPick(ne){return Xt.showWorkspaceFolderPick(ne)},showInputBox(ne,he){return Xt.showInput(ne,he)},showOpenDialog(ne){return Ri.showOpenDialog(Me,ne)},showSaveDialog(ne){return Ri.showSaveDialog(ne)},createStatusBarItem(ne,he,Oe){let st,yt,Lt;return typeof ne=="string"?(st=ne,yt=he,Lt=Oe):(yt=ne,Lt=he),Oi.createStatusBarEntry(Me,st,yt,Lt)},setStatusBarMessage(ne,he){return Oi.setStatusBarMessage(ne,he)},withScmProgress(ne){return Ae.report("window.withScmProgress",Me,"Use 'withProgress' instead."),ui.withProgress(Me,{location:V.ProgressLocation.SourceControl},(he,Oe)=>ne({report(st){}}))},withProgress(ne,he){return ui.withProgress(Me,ne,he)},createOutputChannel(ne,he){return wt.createOutputChannel(ne,he,Me)},createWebviewPanel(ne,he,Oe,st){return ii.createWebviewPanel(Me,ne,he,Oe,st)},createWebviewTextEditorInset(ne,he,Oe,st){return(0,Ke.checkProposedApiEnabled)(Me,"editorInsets"),bi.createWebviewEditorInset(ne,he,Oe,st,Me)},createTerminal(ne,he,Oe){return typeof ne=="object"?"pty"in ne?Ze.createExtensionTerminal(ne):Ze.createTerminalFromOptions(ne):Ze.createTerminal(ne,he,Oe)},registerTerminalLinkProvider(ne){return Ze.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,he){return Ze.registerProfileProvider(Me,ne,he)},registerTerminalQuickFixProvider(ne,he){return(0,Ke.checkProposedApiEnabled)(Me,"terminalQuickFixProvider"),Ze.registerTerminalQuickFixProvider(ne,Me.identifier.value,he)},registerTreeDataProvider(ne,he){return zt.registerTreeDataProvider(ne,he,Me)},createTreeView(ne,he){return zt.createTreeView(ne,he,Me)},registerWebviewPanelSerializer:(ne,he)=>ii.registerWebviewPanelSerializer(Me,ne,he),registerCustomEditorProvider:(ne,he,Oe={})=>yi.registerCustomEditorProvider(Me,ne,he,Oe),registerFileDecorationProvider(ne){return Ue.registerFileDecorationProvider(ne,Me)},registerUriHandler(ne){return Rt.registerUriHandler(Me.identifier,ne)},createQuickPick(){return Xt.createQuickPick(Me)},createInputBox(){return Xt.createInputBox(Me)},get activeColorTheme(){return li.activeColorTheme},onDidChangeActiveColorTheme(ne,he,Oe){return li.onDidChangeActiveColorTheme(ne,he,Oe)},registerWebviewViewProvider(ne,he,Oe){return Di.registerWebviewViewProvider(Me,ne,he,Oe?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Oe){return St.onDidChangeActiveNotebookEditor(ne,he,Oe)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,he,Oe){return oi.onDidChangeNotebookEditorSelection(ne,he,Oe)},onDidChangeNotebookEditorVisibleRanges(ne,he,Oe){return oi.onDidChangeNotebookEditorVisibleRanges(ne,he,Oe)},showNotebookDocument(ne,he){return St.showNotebookDocument(ne,he)},registerExternalUriOpener(ne,he,Oe){return(0,Ke.checkProposedApiEnabled)(Me,"externalUriOpener"),Ii.registerExternalUriOpener(Me.identifier,ne,he,Oe)},registerProfileContentHandler(ne,he){return(0,Ke.checkProposedApiEnabled)(Me,"profileContentHandlers"),Ci.registrProfileContentHandler(Me,ne,he)},registerQuickDiffProvider(ne,he,Oe,st){return(0,Ke.checkProposedApiEnabled)(Me,"quickDiffProvider"),Ei.registerQuickDiffProvider(gt(ne),he,Oe,st)},get tabGroups(){return Re.tabGroups}},jt={get rootPath(){return Ae.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(ne){throw k.readonly()},getWorkspaceFolder(ne){return ht.getWorkspaceFolder(ne)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(ne){throw k.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(ne){throw k.readonly()},updateWorkspaceFolders:(ne,he,...Oe)=>ht.updateWorkspaceFolders(Me,ne,he||0,...Oe),onDidChangeWorkspaceFolders:function(ne,he,Oe){return ht.onDidChangeWorkspace(ne,he,Oe)},asRelativePath:(ne,he)=>ht.getRelativePath(ne,he),findFiles:(ne,he,Oe,st)=>ht.findFiles(ne,he,Oe,Me.identifier,st),findTextInFiles:(ne,he,Oe,st)=>{(0,Ke.checkProposedApiEnabled)(Me,"findTextInFiles");let yt,Lt;return typeof he=="object"?(yt=he,Lt=Oe):(yt={},Lt=he,st=Oe),ht.findTextInFiles(ne,yt||{},Lt,Me.identifier,st)},saveAll:ne=>ht.saveAll(ne),applyEdit(ne,he){return Wi.applyWorkspaceEdit(ne,Me,he)},createFileSystemWatcher:(ne,he,Oe,st)=>Ut.createFileSystemWatcher(ht,Me,ne,he,Oe,st),get textDocuments(){return bt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw k.readonly()},openTextDocument(ne){let he;const Oe=ne;if(typeof ne=="string")he=Promise.resolve(y.URI.file(ne));else if(y.URI.isUri(ne))he=Promise.resolve(ne);else if(!Oe||typeof Oe=="object")he=bt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>bt.ensureDocumentData(st).then(yt=>yt.document))},onDidOpenTextDocument:(ne,he,Oe)=>bt.onDidAddDocument(ne,he,Oe),onDidCloseTextDocument:(ne,he,Oe)=>bt.onDidRemoveDocument(ne,he,Oe),onDidChangeTextDocument:(ne,he,Oe)=>bt.onDidChangeDocument(ne,he,Oe),onDidSaveTextDocument:(ne,he,Oe)=>bt.onDidSaveDocument(ne,he,Oe),onWillSaveTextDocument:(ne,he,Oe)=>ei.getOnWillSaveTextDocumentEvent(Me)(ne,he,Oe),get notebookDocuments(){return St.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,he){let Oe;if(y.URI.isUri(ne))Oe=ne,await St.openNotebookDocument(ne);else if(typeof ne=="string")Oe=y.URI.revive(await St.createNotebookDocument({viewType:ne,content:he}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ne,he,Oe){return si.onDidSaveNotebookDocument(ne,he,Oe)},onDidChangeNotebookDocument(ne,he,Oe){return si.onDidChangeNotebookDocument(ne,he,Oe)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(ne,he,Oe,st){return St.registerNotebookSerializer(Me,ne,he,Oe,(0,Ke.isProposedApiEnabled)(Me,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(ne,he,Oe)=>Li.onDidChangeConfiguration(ne,he,Oe),getConfiguration(ne,he){return he=arguments.length===1?void 0:he,Li.getConfiguration(ne,he,Me)},registerTextDocumentContentProvider(ne,he){return ri.registerTextDocumentContentProvider(ne,he)},registerTaskProvider:(ne,he)=>(Ae.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Me,ne,he)),registerFileSystemProvider(ne,he,Oe){return(0,Qe.combinedDisposable)($i.registerFileSystemProvider(Me,ne,he,Oe),Vt.addFileSystemProvider(ne,he))},get fs(){return Vt.value},registerFileSearchProvider:(ne,he)=>((0,Ke.checkProposedApiEnabled)(Me,"fileSearchProvider"),Pt.registerFileSearchProvider(ne,he)),registerTextSearchProvider:(ne,he)=>((0,Ke.checkProposedApiEnabled)(Me,"textSearchProvider"),Pt.registerTextSearchProvider(ne,he)),registerRemoteAuthorityResolver:(ne,he)=>((0,Ke.checkProposedApiEnabled)(Me,"resolvers"),kt.registerRemoteAuthorityResolver(ne,he)),registerResourceLabelFormatter:ne=>((0,Ke.checkProposedApiEnabled)(Me,"resolvers"),Si.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,he,Oe)=>Ut.onDidCreateFile(ne,he,Oe),onDidDeleteFiles:(ne,he,Oe)=>Ut.onDidDeleteFile(ne,he,Oe),onDidRenameFiles:(ne,he,Oe)=>Ut.onDidRenameFile(ne,he,Oe),onWillCreateFiles:(ne,he,Oe)=>Ut.getOnWillCreateFileEvent(Me)(ne,he,Oe),onWillDeleteFiles:(ne,he,Oe)=>Ut.getOnWillDeleteFileEvent(Me)(ne,he,Oe),onWillRenameFiles:(ne,he,Oe)=>Ut.getOnWillRenameFileEvent(Me)(ne,he,Oe),openTunnel:ne=>((0,Ke.checkProposedApiEnabled)(Me,"tunnels"),Ce.openTunnel(Me,ne).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ke.checkProposedApiEnabled)(Me,"tunnels"),Ce.getTunnels()},onDidChangeTunnels:(ne,he,Oe)=>((0,Ke.checkProposedApiEnabled)(Me,"tunnels"),Ce.onDidChangeTunnels(ne,he,Oe)),registerPortAttributesProvider:(ne,he)=>((0,Ke.checkProposedApiEnabled)(Me,"portsAttributes"),Ce.registerPortsAttributesProvider(ne,he)),registerTimelineProvider:(ne,he)=>((0,Ke.checkProposedApiEnabled)(Me,"timeline"),Bi.registerTimelineProvider(ne,he,Me.identifier,Be.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:ne=>((0,Ke.checkProposedApiEnabled)(Me,"workspaceTrust"),ht.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,he,Oe)=>ht.onDidGrantWorkspaceTrust(ne,he,Oe),registerEditSessionIdentityProvider:(ne,he)=>((0,Ke.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(ne,he)),onWillCreateEditSessionIdentity:(ne,he,Oe)=>((0,Ke.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Me)(ne,he,Oe))},fi={get inputBox(){return Ae.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(Me)},createSourceControl(ne,he,Oe){return ci.createSourceControl(Me,ne,he,Oe)}},xi={createCommentController(ne,he){return wi.createCommentController(Me,ne,he)}},Bt={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(ne,he,Oe){return ct.onDidStartDebugSession(ne,he,Oe)},onDidTerminateDebugSession(ne,he,Oe){return ct.onDidTerminateDebugSession(ne,he,Oe)},onDidChangeActiveDebugSession(ne,he,Oe){return ct.onDidChangeActiveDebugSession(ne,he,Oe)},onDidReceiveDebugSessionCustomEvent(ne,he,Oe){return ct.onDidReceiveDebugSessionCustomEvent(ne,he,Oe)},onDidChangeBreakpoints(ne,he,Oe){return ct.onDidChangeBreakpoints(ne,he,Oe)},registerDebugConfigurationProvider(ne,he,Oe){return ct.registerDebugConfigurationProvider(ne,he,Oe||tt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,he){return ct.registerDebugAdapterDescriptorFactory(Me,ne,he)},registerDebugAdapterTrackerFactory(ne,he){return ct.registerDebugAdapterTrackerFactory(ne,he)},startDebugging(ne,he,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?ct.startDebugging(ne,he,{parentSession:Oe}):ct.startDebugging(ne,he,Oe||{})},stopDebugging(ne){return ct.stopDebugging(ne)},addBreakpoints(ne){return ct.addBreakpoints(ne)},removeBreakpoints(ne){return ct.removeBreakpoints(ne)},asDebugSourceUri(ne,he){return ct.asDebugSourceUri(ne,he)}},mi={registerTaskProvider:(ne,he)=>vt.registerTaskProvider(Me,ne,he),fetchTasks:ne=>vt.fetchTasks(ne),executeTask:ne=>vt.executeTask(Me,ne),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(ne,he,Oe)=>vt.onDidStartTask(ne,he,Oe),onDidEndTask:(ne,he,Oe)=>vt.onDidEndTask(ne,he,Oe),onDidStartTaskProcess:(ne,he,Oe)=>vt.onDidStartTaskProcess(ne,he,Oe),onDidEndTaskProcess:(ne,he,Oe)=>vt.onDidEndTaskProcess(ne,he,Oe)},Gi={createNotebookController(ne,he,Oe,st,yt){return _t.createNotebookController(Me,ne,he,Oe,st,(0,Ke.isProposedApiEnabled)(Me,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,he)=>St.registerNotebookCellStatusBarItemProvider(Me,ne,he),createRendererMessaging(ne){return vi.createRendererMessaging(Me,ne)},createNotebookControllerDetectionTask(ne){return(0,Ke.checkProposedApiEnabled)(Me,"notebookKernelSource"),_t.createNotebookControllerDetectionTask(Me,ne)},registerKernelSourceActionProvider(ne,he){return(0,Ke.checkProposedApiEnabled)(Me,"notebookKernelSource"),_t.registerKernelSourceActionProvider(Me,ne,he)},onDidChangeNotebookCellExecutionState(ne,he,Oe){return(0,Ke.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),_t.onDidChangeNotebookCellExecutionState(ne,he,Oe)}},Xi={t(...ne){if(typeof ne[0]=="string"){const he=ne.shift(),Oe=!ne||typeof ne[0]!="object"?ne:ne[0];return pt.getMessage(Me.identifier.value,{message:he,args:Oe})}return pt.getMessage(Me.identifier.value,ne[0])},get bundle(){return pt.getBundle(Me.identifier.value)},get uri(){return pt.getBundleUri(Me.identifier.value)}};return{version:ft.version,authentication:Vi,commands:di,comments:xi,debug:Bt,env:Fi,extensions:qi,l10n:Xi,languages:Ti,notebooks:Gi,scm:fi,tasks:mi,tests:ji,window:Ki,workspace:jt,Breakpoint:V.Breakpoint,TerminalOutputAnchor:V.TerminalOutputAnchor,CallHierarchyIncomingCall:V.CallHierarchyIncomingCall,CallHierarchyItem:V.CallHierarchyItem,CallHierarchyOutgoingCall:V.CallHierarchyOutgoingCall,CancellationError:k.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:h.CandidatePortSource,CodeAction:V.CodeAction,CodeActionKind:V.CodeActionKind,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.CodeLens,Color:V.Color,ColorInformation:V.ColorInformation,ColorPresentation:V.ColorPresentation,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.CompletionItem,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.CompletionList,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.CustomExecution,DebugAdapterExecutable:V.DebugAdapterExecutable,DebugAdapterInlineImplementation:V.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:V.DebugAdapterNamedPipeServer,DebugAdapterServer:V.DebugAdapterServer,DebugConfigurationProviderTriggerKind:tt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.Diagnostic,DiagnosticRelatedInformation:V.DiagnosticRelatedInformation,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.Disposable,DocumentHighlight:V.DocumentHighlight,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.DocumentLink,DocumentSymbol:V.DocumentSymbol,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.EvaluatableExpression,InlineValueText:V.InlineValueText,InlineValueVariableLookup:V.InlineValueVariableLookup,InlineValueEvaluatableExpression:V.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.FileDecoration,FileDecoration2:V.FileDecoration,FileSystemError:V.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:V.FoldingRange,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.FunctionBreakpoint,InlineCompletionItem:V.InlineSuggestion,InlineCompletionList:V.InlineSuggestionList,Hover:V.Hover,IndentAction:T.IndentAction,Location:V.Location,MarkdownString:V.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:V.ParameterInformation,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.Position,ProcessExecution:V.ProcessExecution,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.QuickInputButtons,Range:V.Range,RelativePattern:V.RelativePattern,Selection:V.Selection,SelectionRange:V.SelectionRange,SemanticTokens:V.SemanticTokens,SemanticTokensBuilder:V.SemanticTokensBuilder,SemanticTokensEdit:V.SemanticTokensEdit,SemanticTokensEdits:V.SemanticTokensEdits,SemanticTokensLegend:V.SemanticTokensLegend,ShellExecution:V.ShellExecution,ShellQuoting:V.ShellQuoting,SignatureHelp:V.SignatureHelp,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.SignatureInformation,SnippetString:V.SnippetString,SourceBreakpoint:V.SourceBreakpoint,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.SymbolInformation,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.Task,TaskGroup:V.TaskGroup,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.TerminalLink,TerminalQuickFixCommand:V.TerminalQuickFixCommand,TerminalQuickFixOpener:V.TerminalQuickFixOpener,TerminalLocation:V.TerminalLocation,TerminalProfile:V.TerminalProfile,TerminalExitReason:V.TerminalExitReason,TerminalQuickFixType:V.TerminalQuickFixType,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.TextEdit,SnippetTextEdit:V.SnippetTextEdit,TextEditorCursorStyle:R.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.ThemeColor,ThemeIcon:V.ThemeIcon,TreeItem:V.TreeItem,TreeItem2:V.TreeItem,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.TypeHierarchyItem,UIKind:v.UIKind,Uri:y.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.WorkspaceEdit,DocumentDropEdit:V.DocumentDropEdit,DocumentPasteEdit:V.DocumentPasteEdit,InlayHint:V.InlayHint,InlayHintLabelPart:V.InlayHintLabelPart,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.RemoteAuthorityResolverError,ResolvedAuthority:V.ResolvedAuthority,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.TimelineItem,NotebookRange:V.NotebookRange,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.NotebookCellData,NotebookData:V.NotebookData,NotebookRendererScript:V.NotebookRendererScript,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.NotebookCellOutput,NotebookCellOutputItem:V.NotebookCellOutputItem,NotebookCellStatusBarItem:V.NotebookCellStatusBarItem,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.NotebookEdit,NotebookKernelSourceAction:V.NotebookKernelSourceAction,PortAttributes:V.PortAttributes,LinkedEditingRanges:V.LinkedEditingRanges,TestResultState:V.TestResultState,TestRunRequest:V.TestRunRequest,TestRunRequest2:V.TestRunRequest2,TestMessage:V.TestMessage,TestTag:V.TestTag,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:Ne.TextSearchCompleteMessageType,DataTransfer:V.DataTransfer,DataTransferItem:V.DataTransferItem,CoveredCount:V.CoveredCount,FileCoverage:V.FileCoverage,StatementCoverage:V.StatementCoverage,BranchCoverage:V.BranchCoverage,FunctionCoverage:V.FunctionCoverage,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.TextTabInput,TabInputTextDiff:V.TextDiffTabInput,TabInputTextMerge:V.TextMergeTabInput,TabInputCustom:V.CustomEditorTabInput,TabInputNotebook:V.NotebookEditorTabInput,TabInputNotebookDiff:V.NotebookDiffEditorTabInput,TabInputWebview:V.WebviewEditorTabInput,TabInputTerminal:V.TerminalEditorTabInput,TabInputInteractiveWindow:V.InteractiveWindowInput,TelemetryTrustedValue:ae.TelemetryTrustedValue,LogLevel:ze.LogLevel,EditSessionIdentityMatch:Et.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Dt}),define(ke[255],Te([1,0,254,33,2,248,7,17,239]),function(te,e,n,k,D,M,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class T extends M.RequireInterceptor{j(){}getModule(v,m){for(const a of this.b){const o=a(v);if(o){v=o;break}}if(this.a.has(v))return this.a.get(v).load(v,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends k.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=y.ExtensionRuntime.Webworker}async ob(){this.h.createInstance(S.ExtHostConsoleForwarder);const v=this.h.invokeFunction(n.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(T,v,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.ub()}pb(v){return v.browser}async qb(v,m,a){m=m.with({path:w(m.path,".js")});const o=v?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const u=D.URI.revive(await this.v.$asBrowserUri(m)),g=await fetch(u.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),g.status!==200)throw new Error(g.statusText);const E=await g.text(),L=`${m.toString(!0)}#vscode-extension`,p=`${E}
//# sourceURL=${L}`;let t;try{t=new Function("module","exports","require",p)}catch(c){throw console.error(o?`Loading code for extension ${o} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${m.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}v&&await this.s.initializeLocalizedMessages(v);const d={},r={exports:d},l=c=>{const b=this.r.getModule(c,m);if(b===void 0)throw new Error(`Cannot load module '${c}'`);return b};try{return a.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(r,d,l),r.exports!==d?r.exports:d}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),a.codeLoadingStop()}}async $setRemoteEnvironment(v){}async ub(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+v;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=N;function w(h,v){return h.endsWith(v)?h:h+v}}),define(ke[256],Te([1,0,67,33,81,255]),function(te,e,n,k,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(k.IExtHostExtensionService,M.ExtHostExtensionService,0),(0,n.registerSingleton)(D.IExtensionStoragePaths,D.ExtensionStoragePaths,0)}),define(ke[264],Te([1,0,23,4,74,249,241,19,82,15,2,251,256]),function(te,e,n,k,D,M,y,R,S,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const h=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(t){return/^(file|vscode-remote):/i.test(t)}const m=fetch.bind(self);function a(t){self.fetch=async function(d,r){return d instanceof Request||v(String(d))&&(d=(await t(N.URI.parse(String(d)))).toString(!0)),m(d,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,r,l,c,b){(async()=>(v(r.toString())&&(r=(await t(N.URI.parse(r.toString()))).toString(!0)),super.open(d,r,l??!0,c,b)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(d,r){if(/^file:/i.test(d.toString()))d=T.FileAccess.uriToBrowserUri(N.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const c=`(${function(f){function P(_){return typeof _=="string"||_ instanceof URL?String(_).replace(/^file:\/\//i,"vscode-file://vscode-app"):_}const C=fetch.bind(self);self.fetch=function(_,K){return _ instanceof Request?C(_,K):C(P(_),K)},self.XMLHttpRequest=class extends XMLHttpRequest{open(_,K,A,$,O){return super.open(_,P(K),A??!0,$,O)}};const j=importScripts.bind(self);self.importScripts=(..._)=>{j(..._.map(P))},j(f)}.toString()}('${d}'))`;r=r||{},r.name=r.name||R.basename(d.toString());const b=new Blob([c],{type:"application/javascript"}),i=URL.createObjectURL(b);return new t(i,r)}}else self.Worker=class extends y.NestedWorker{constructor(t,d){super(h,t,{name:R.basename(t.toString()),...d})}};const o=new class{constructor(){this.pid=void 0}exit(t){w()}async exists(t){return!0}async realpath(t){return t}};class u{constructor(){const d=new MessageChannel,r=new k.Emitter;let l=!1;h(d.port2,[d.port2]),d.port1.onmessage=c=>{const{data:b}=c;if(!(b instanceof ArrayBuffer)){console.warn("UNKNOWN data received",b);return}const i=n.VSBuffer.wrap(new Uint8Array(b,0,b.byteLength));if((0,D.isMessageOfType)(i,2)){l=!0,E("received terminate message from renderer");return}r.fire(i)},this.protocol={onMessage:r.event,send:c=>{if(!l){const b=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);d.port1.postMessage(b,[b])}}}}}function g(t){return new Promise(d=>{const r=t.onMessage(l=>{r.dispose();const c=JSON.parse(l.toString());t.send((0,D.createMessageOfType)(0)),d({protocol:t,initData:c})});t.send((0,D.createMessageOfType)(1))})}let E=t=>w();function L(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function p(){S.mark("code/extHost/willConnectToRenderer");const t=new u;return{onmessage(d){!L(d)||g(t.protocol).then(r=>{S.mark("code/extHost/didWaitForInitData");const l=new M.ExtensionHostMain(r.protocol,r.initData,o,null,d.data);a(c=>l.asBrowserUri(c)),E=c=>l.terminate(c)})}}}e.create=p})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/96a795cc0b1cd62f9ff66c347637f917c6dde3da/core/vs/workbench/api/worker/extensionHostWorker.js.map
